/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/base/common/errors","vs/base/common/path","vs/platform/log/common/log","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/network","vs/base/common/resources","vs/base/common/arrays","vs/base/common/types","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/buffer","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/objects","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/uuid","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","child_process","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/map","vs/platform/product/common/product","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","net","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensionHostStarter","vs/platform/extensions/common/extensions","crypto","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/extensions/node/extensionHostStarter","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","util","minimist","assert","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ne=function(J){for(var e=[],R=0,L=J.length;R<L;R++)e[R]=te[J[R]];return e};define(te[99],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function R(L,D){if(!L)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=R}),define(te[65],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const R=Object.prototype.hasOwnProperty;function L(n){const I=[];for(let g in n)R.call(n,g)&&I.push(n[g]);return I}e.values=L;function D(n,I){for(let g in n)if(R.call(n,g)&&I({key:g,value:n[g]},function(){delete n[g]})===!1)return}e.forEach=D;function T(n,I){const g=Object.create(null);for(const E of n){const h=I(E);let p=g[h];p||(p=g[h]=[]),p.push(E)}return g}e.groupBy=T;function k(n){const I=Object.create(null);return n&&n.forEach((g,E)=>{I[E]=g}),I}e.fromMap=k;function C(n,I){const g=[],E=[];for(let h of n)I.has(h)||g.push(h);for(let h of I)n.has(h)||E.push(h);return{removed:g,added:E}}e.diffSets=C;function S(n,I){const g=[],E=[];for(let[h,p]of n)I.has(h)||g.push(p);for(let[h,p]of I)n.has(h)||E.push(p);return{removed:g,added:E}}e.diffMaps=S;class b{constructor(){this.map=new Map}add(I,g){let E=this.map.get(I);E||(E=new Set,this.map.set(I,E)),E.add(g)}delete(I,g){const E=this.map.get(I);!E||(E.delete(g),E.size===0&&this.map.delete(I))}forEach(I,g){const E=this.map.get(I);!E||E.forEach(g)}}e.SetMap=b}),define(te[66],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function R(k){return(C,S,b)=>{let n=null,I=null;if(typeof b.value=="function"?(n="value",I=b.value):typeof b.get=="function"&&(n="get",I=b.get),!I)throw new Error("not supported");b[n]=k(I,S)}}e.createDecorator=R;function L(k,C,S){let b=null,n=null;if(typeof S.value=="function"?(b="value",n=S.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(b="get",n=S.get),!n)throw new Error("not supported");const I=`$memoize$${C}`;S[b]=function(...g){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,g)}),this[I]}}e.memoize=L;function D(k,C,S){return R((b,n)=>{const I=`$debounce$${n}`,g=`$debounce$result$${n}`;return function(...E){this[g]||(this[g]=S?S():void 0),clearTimeout(this[I]),C&&(this[g]=C(this[g],...E),E=[this[g]]),this[I]=setTimeout(()=>{b.apply(this,E),this[g]=S?S():void 0},k)}})}e.debounce=D;function T(k,C,S){return R((b,n)=>{const I=`$throttle$timer$${n}`,g=`$throttle$result$${n}`,E=`$throttle$lastRun$${n}`,h=`$throttle$pending$${n}`;return function(...p){if(this[g]||(this[g]=S?S():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),C&&(this[g]=C(this[g],...p)),this[h])return;const f=this[E]+k;f<=Date.now()?(this[E]=Date.now(),b.apply(this,[this[g]]),this[g]=S?S():void 0):(this[h]=!0,this[I]=setTimeout(()=>{this[h]=!1,this[E]=Date.now(),b.apply(this,[this[g]]),this[g]=S?S():void 0},f-Date.now()))}})}e.throttle=T}),define(te[8],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=R,e.errorHandler=new R;function L(o){e.errorHandler.setUnexpectedErrorHandler(o)}e.setUnexpectedErrorHandler=L;function D(o){S(o)||e.errorHandler.onUnexpectedError(o)}e.onUnexpectedError=D;function T(o){S(o)||e.errorHandler.onUnexpectedExternalError(o)}e.onUnexpectedExternalError=T;function k(o){if(o instanceof Error){let{name:t,message:s}=o;const i=o.stacktrace||o.stack;return{$isError:!0,name:t,message:s,stack:i}}return o}e.transformErrorForSerialization=k;const C="Canceled";function S(o){return o instanceof Error&&o.name===C&&o.message===C}e.isPromiseCanceledError=S;class b extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=b;function n(){const o=new Error(C);return o.name=o.message,o}e.canceled=n;function I(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}e.illegalArgument=I;function g(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}e.illegalState=g;function E(o){return o?new Error(`readonly property '${o} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function h(o){const t=new Error(`${o} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function p(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}e.getErrorMessage=p;class f extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=f;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class v extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=v;function y(o){const t=o;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=y;function c(o,t=Object.create(null)){const s=new Error(o);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=c}),define(te[17],ne([0,1,8]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(z,B=0){return z[z.length-(1+B)]}e.tail=L;function D(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=D;function T(z,B,X=(Z,V)=>Z===V){if(z===B)return!0;if(!z||!B||z.length!==B.length)return!1;for(let Z=0,V=z.length;Z<V;Z++)if(!X(z[Z],B[Z]))return!1;return!0}e.equals=T;function k(z,B,X){let Z=0,V=z.length-1;for(;Z<=V;){const G=(Z+V)/2|0,ie=X(z[G],B);if(ie<0)Z=G+1;else if(ie>0)V=G-1;else return G}return-(Z+1)}e.binarySearch=k;function C(z,B){let X=0,Z=z.length;if(Z===0)return 0;for(;X<Z;){const V=Math.floor((X+Z)/2);B(z[V])?Z=V:X=V+1}return X}e.findFirstInSorted=C;function S(z,B,X){if(z=z|0,z>=B.length)throw new TypeError("invalid index");let Z=B[Math.floor(B.length*Math.random())],V=[],G=[],ie=[];for(let re of B){const ae=X(re,Z);ae<0?V.push(re):ae>0?G.push(re):ie.push(re)}return z<V.length?S(z,V,X):z<V.length+ie.length?ie[0]:S(z-(V.length+ie.length),G,X)}e.quickSelect=S;function b(z,B){const X=[];let Z;for(const V of z.slice(0).sort(B))!Z||B(Z[0],V)!==0?(Z=[V],X.push(Z)):Z.push(V);return X}e.groupBy=b;function n(z,B,X){const Z=[];function V(re,ae,ue){if(ae===0&&ue.length===0)return;const fe=Z[Z.length-1];fe&&fe.start+fe.deleteCount===re?(fe.deleteCount+=ae,fe.toInsert.push(...ue)):Z.push({start:re,deleteCount:ae,toInsert:ue})}let G=0,ie=0;for(;;){if(G===z.length){V(G,0,B.slice(ie));break}if(ie===B.length){V(G,z.length-G,[]);break}const re=z[G],ae=B[ie],ue=X(re,ae);ue===0?(G+=1,ie+=1):ue<0?(V(G,1,[]),G+=1):ue>0&&(V(G,0,[ae]),ie+=1)}return Z}e.sortedDiff=n;function I(z,B,X){const Z=n(z,B,X),V=[],G=[];for(const ie of Z)V.push(...z.slice(ie.start,ie.start+ie.deleteCount)),G.push(...ie.toInsert);return{removed:V,added:G}}e.delta=I;function g(z,B,X){if(X===0)return[];const Z=z.slice(0,X).sort(B);return h(z,B,Z,X,z.length),Z}e.top=g;function E(z,B,X,Z,V){return X===0?Promise.resolve([]):new Promise((G,ie)=>{(async()=>{const re=z.length,ae=z.slice(0,X).sort(B);for(let ue=X,fe=Math.min(X+Z,re);ue<re;ue=fe,fe=Math.min(fe+Z,re)){if(ue>X&&await new Promise(ge=>setTimeout(ge)),V&&V.isCancellationRequested)throw(0,R.canceled)();h(z,B,ae,ue,fe)}return ae})().then(G,ie)})}e.topAsync=E;function h(z,B,X,Z,V){for(const G=X.length;Z<V;Z++){const ie=z[Z];if(B(ie,X[G-1])<0){X.pop();const re=C(X,ae=>B(ie,ae)<0);X.splice(re,0,ie)}}}function p(z){return z.filter(B=>!!B)}e.coalesce=p;function f(z){let B=0;for(let X=0;X<z.length;X++)z[X]&&(z[B]=z[X],B+=1);z.length=B}e.coalesceInPlace=f;function w(z,B,X){z.splice(X,0,z.splice(B,1)[0])}e.move=w;function v(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=v;function y(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=y;function c(z,B){if(!B)return z.filter((Z,V)=>z.indexOf(Z)===V);const X=Object.create(null);return z.filter(Z=>{const V=B(Z);return X[V]?!1:(X[V]=!0,!0)})}e.distinct=c;function o(z){const B=new Set;return z.filter(X=>B.has(X)?!1:(B.add(X),!0))}e.distinctES6=o;function t(z){const B=Object.create(null);return X=>{const Z=z(X);return B[Z]?!1:(B[Z]=!0,!0)}}e.uniqueFilter=t;function s(z,B){const X=i(z,B);if(X!==-1)return z[X]}e.findLast=s;function i(z,B){for(let X=z.length-1;X>=0;X--){const Z=z[X];if(B(Z))return X}return-1}e.lastIndex=i;function r(z,B){return z.length>0?z[0]:B}e.firstOrDefault=r;function a(z,B,X=(Z,V)=>Z===V){let Z=0;for(let V=0,G=Math.min(z.length,B.length);V<G&&X(z[V],B[V]);V++)Z++;return Z}e.commonPrefixLength=a;function l(z){return[].concat(...z)}e.flatten=l;function u(z,B){let X=typeof B=="number"?z:0;typeof B=="number"?X=z:(X=0,B=z);const Z=[];if(X<=B)for(let V=X;V<B;V++)Z.push(V);else for(let V=X;V>B;V--)Z.push(V);return Z}e.range=u;function d(z,B,X){return z.reduce((Z,V)=>(Z[B(V)]=X?X(V):V,Z),Object.create(null))}e.index=d;function m(z,B){return z.push(B),()=>A(z,B)}e.insert=m;function A(z,B){const X=z.indexOf(B);if(X>-1)return z.splice(X,1),B}e.remove=A;function _(z,B,X){const Z=z.slice(0,B),V=z.slice(B);return Z.concat(X,V)}e.arrayInsert=_;function O(z,B){let X;if(typeof B=="number"){let Z=B;X=()=>{const V=Math.sin(Z++)*179426549;return V-Math.floor(V)}}else X=Math.random;for(let Z=z.length-1;Z>0;Z-=1){const V=Math.floor(X()*(Z+1)),G=z[Z];z[Z]=z[V],z[V]=G}}e.shuffle=O;function N(z,B){const X=z.indexOf(B);X>-1&&(z.splice(X,1),z.unshift(B))}e.pushToStart=N;function P(z,B){const X=z.indexOf(B);X>-1&&(z.splice(X,1),z.push(B))}e.pushToEnd=P;function M(z,B){return Array.isArray(z)?z.map(B):B(z)}e.mapArrayOrNot=M;function $(z){return Array.isArray(z)?z:[z]}e.asArray=$;function U(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=U;function H(z,B){for(const X of z){const Z=B(X);if(Z!==void 0)return Z}}e.mapFind=H;function W(z,B,X){const Z=q(z,B),V=z.length,G=X.length;z.length=V+G;for(let ie=V-1;ie>=Z;ie--)z[ie+G]=z[ie];for(let ie=0;ie<G;ie++)z[ie+Z]=X[ie]}e.insertInto=W;function x(z,B,X,Z){const V=q(z,B),G=z.splice(V,X);return W(z,V,Z),G}e.splice=x;function q(z,B){return B<0?Math.max(B+z.length,0):Math.min(B,z.length)}function F(z,B){let X=Number.MAX_SAFE_INTEGER,Z=0;return z.forEach((V,G)=>{const ie=B(V);ie<X&&(X=ie,Z=G)}),Z}e.minIndex=F;function K(z,B){let X=Number.MIN_SAFE_INTEGER,Z=0;return z.forEach((V,G)=>{const ie=B(V);ie>X&&(X=ie,Z=G)}),Z}e.maxIndex=K;class j{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let X=this.firstIdx;for(;X<this.items.length&&B(this.items[X]);)X++;const Z=X===this.firstIdx?null:this.items.slice(this.firstIdx,X);return this.firstIdx=X,Z}takeFromEndWhile(B){let X=this.lastIdx;for(;X>=0&&B(this.items[X]);)X--;const Z=X===this.lastIdx?null:this.items.slice(X+1,this.lastIdx+1);return this.lastIdx=X,Z}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=j}),define(te[67],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(L){const D=this;let T=!1,k;return function(){return T||(T=!0,k=L.apply(D,arguments)),k}}e.once=R}),define(te[55],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(L){function D(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}L.is=D;const T=Object.freeze([]);function k(){return T}L.empty=k;function*C(o){yield o}L.single=C;function S(o){return o||T}L.from=S;function b(o){return!o||o[Symbol.iterator]().next().done===!0}L.isEmpty=b;function n(o){return o[Symbol.iterator]().next().value}L.first=n;function I(o,t){for(const s of o)if(t(s))return!0;return!1}L.some=I;function g(o,t){for(const s of o)if(t(s))return s}L.find=g;function*E(o,t){for(const s of o)t(s)&&(yield s)}L.filter=E;function*h(o,t){let s=0;for(const i of o)yield t(i,s++)}L.map=h;function*p(...o){for(const t of o)for(const s of t)yield s}L.concat=p;function*f(o){for(const t of o)for(const s of t)yield s}L.concatNested=f;function w(o,t,s){let i=s;for(const r of o)i=t(i,r);return i}L.reduce=w;function*v(o,t,s=o.length){for(t<0&&(t+=o.length),s<0?s+=o.length:s>o.length&&(s=o.length);t<s;t++)yield o[t]}L.slice=v;function y(o,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,o];const i=o[Symbol.iterator]();for(let r=0;r<t;r++){const a=i.next();if(a.done)return[s,L.empty()];s.push(a.value)}return[s,{[Symbol.iterator](){return i}}]}L.consume=y;function c(o,t,s=(i,r)=>i===r){const i=o[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const a=i.next(),l=r.next();if(a.done!==l.done)return!1;if(a.done)return!0;if(!s(a.value,l.value))return!1}}L.equals=c})(R=e.Iterable||(e.Iterable={}))}),define(te[36],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(R=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function k(t,s=!1){let i=0,r=t.length,a="",l=0,u=16,d=0;function m($){let U=0,H=0;for(;U<$;){const W=t.charCodeAt(i);if(W>=48&&W<=57)H=H*16+W-48;else if(W>=65&&W<=70)H=H*16+W-65+10;else if(W>=97&&W<=102)H=H*16+W-97+10;else break;i++,U++}return U<$&&(H=-1),H}function A($){i=$,a="",l=0,u=16,d=0}function _(){const $=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&b(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&b(t.charCodeAt(i)))for(i++;i<t.length&&b(t.charCodeAt(i));)i++;else return d=3,t.substring($,i);let U=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&b(t.charCodeAt(i))){for(i++;i<t.length&&b(t.charCodeAt(i));)i++;U=i}else d=3;return t.substring($,U)}function O(){let $="",U=i;for(;;){if(i>=r){$+=t.substring(U,i),d=2;break}const H=t.charCodeAt(i);if(H===34){$+=t.substring(U,i),i++;break}if(H===92){if($+=t.substring(U,i),i++,i>=r){d=2;break}switch(t.charCodeAt(i++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const x=m(4);x>=0?$+=String.fromCharCode(x):d=4;break;default:d=5}U=i;continue}if(H>=0&&H<=31)if(S(H)){$+=t.substring(U,i),d=2;break}else d=6;i++}return $}function N(){if(a="",d=0,l=i,i>=r)return l=r,u=17;let $=t.charCodeAt(i);if(C($)){do i++,a+=String.fromCharCode($),$=t.charCodeAt(i);while(C($));return u=15}if(S($))return i++,a+=String.fromCharCode($),$===13&&t.charCodeAt(i)===10&&(i++,a+=`
`),u=14;switch($){case 123:return i++,u=1;case 125:return i++,u=2;case 91:return i++,u=3;case 93:return i++,u=4;case 58:return i++,u=6;case 44:return i++,u=5;case 34:return i++,a=O(),u=10;case 47:const U=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<r&&!S(t.charCodeAt(i));)i++;return a=t.substring(U,i),u=12}if(t.charCodeAt(i+1)===42){i+=2;const H=r-1;let W=!1;for(;i<H;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,W=!0;break}i++}return W||(i++,d=1),a=t.substring(U,i),u=13}return a+=String.fromCharCode($),i++,u=16;case 45:if(a+=String.fromCharCode($),i++,i===r||!b(t.charCodeAt(i)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=_(),u=11;default:for(;i<r&&P($);)i++,$=t.charCodeAt(i);if(l!==i){switch(a=t.substring(l,i),a){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return a+=String.fromCharCode($),i++,u=16}}function P($){if(C($)||S($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let $;do $=N();while($>=12&&$<=15);return $}return{setPosition:A,getPosition:()=>i,scan:s?M:N,getToken:()=>u,getTokenValue:()=>a,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>d}}e.createScanner=k;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function I(t,s){const i=[],r=new Object;let a;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function d(m,A,_,O){l.value=m,l.offset=A,l.length=_,l.type=O,l.colonOffset=void 0,a=l}try{y(t,{onObjectBegin:(m,A)=>{if(s<=m)throw r;a=void 0,u=s>m,i.push("")},onObjectProperty:(m,A,_)=>{if(s<A||(d(m,A,_,"property"),i[i.length-1]=m,s<=A+_))throw r},onObjectEnd:(m,A)=>{if(s<=m)throw r;a=void 0,i.pop()},onArrayBegin:(m,A)=>{if(s<=m)throw r;a=void 0,i.push(0)},onArrayEnd:(m,A)=>{if(s<=m)throw r;a=void 0,i.pop()},onLiteralValue:(m,A,_)=>{if(s<A||(d(m,A,_,o(m)),s<=A+_))throw r},onSeparator:(m,A,_)=>{if(s<=A)throw r;if(m===":"&&a&&a.type==="property")a.colonOffset=A,u=!1,a=void 0;else if(m===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(u=!0,i[i.length-1]=""),a=void 0}}})}catch(m){if(m!==r)throw m}return{path:i,previousNode:a,isAtPropertyKey:u,matches:m=>{let A=0;for(let _=0;A<m.length&&_<i.length;_++)if(m[A]===i[_]||m[A]==="*")A++;else if(m[A]!=="**")return!1;return A===m.length}}}e.getLocation=I;function g(t,s=[],i=T.DEFAULT){let r=null,a=[];const l=[];function u(m){Array.isArray(a)?a.push(m):r!==null&&(a[r]=m)}return y(t,{onObjectBegin:()=>{const m={};u(m),l.push(a),a=m,r=null},onObjectProperty:m=>{r=m},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const m=[];u(m),l.push(a),a=m,r=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:u,onError:(m,A,_)=>{s.push({error:m,offset:A,length:_})}},i),a[0]}e.parse=g;function E(t,s=[],i=T.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(m){r.type==="property"&&(r.length=m-r.offset,r=r.parent)}function l(m){return r.children.push(m),m}y(t,{onObjectBegin:m=>{r=l({type:"object",offset:m,length:-1,parent:r,children:[]})},onObjectProperty:(m,A,_)=>{r=l({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:m,offset:A,length:_,parent:r})},onObjectEnd:(m,A)=>{r.length=m+A-r.offset,r=r.parent,a(m+A)},onArrayBegin:(m,A)=>{r=l({type:"array",offset:m,length:-1,parent:r,children:[]})},onArrayEnd:(m,A)=>{r.length=m+A-r.offset,r=r.parent,a(m+A)},onLiteralValue:(m,A,_)=>{l({type:o(m),offset:A,length:_,parent:r,value:m}),a(A+_)},onSeparator:(m,A,_)=>{r.type==="property"&&(m===":"?r.colonOffset=A:m===","&&a(A))},onError:(m,A,_)=>{s.push({error:m,offset:A,length:_})}},i);const d=r.children[0];return d&&delete d.parent,d}e.parseTree=E;function h(t,s){if(!t)return;let i=t;for(let r of s)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let a=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===r){i=l.children[1],a=!0;break}if(!a)return}else{const a=r;if(i.type!=="array"||a<0||!Array.isArray(i.children)||a>=i.children.length)return;i=i.children[a]}return i}e.findNodeAtLocation=h;function p(t){if(!t.parent||!t.parent.children)return[];const s=p(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;s.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&s.push(i)}return s}e.getNodePath=p;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":const s=Object.create(null);for(let i of t.children){const r=i.children[1];r&&(s[i.children[0].value]=f(r))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=f;function w(t,s,i=!1){return s>=t.offset&&s<t.offset+t.length||i&&s===t.offset+t.length}e.contains=w;function v(t,s,i=!1){if(w(t,s,i)){const r=t.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=s;a++){const l=v(r[a],s,i);if(l)return l}return t}}e.findNodeAtOffset=v;function y(t,s,i=T.DEFAULT){const r=k(t,!1);function a(B){return B?()=>B(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(B){return B?X=>B(X,r.getTokenOffset(),r.getTokenLength()):()=>!0}const u=a(s.onObjectBegin),d=l(s.onObjectProperty),m=a(s.onObjectEnd),A=a(s.onArrayBegin),_=a(s.onArrayEnd),O=l(s.onLiteralValue),N=l(s.onSeparator),P=a(s.onComment),M=l(s.onError),$=i&&i.disallowComments,U=i&&i.allowTrailingComma;function H(){for(;;){const B=r.scan();switch(r.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:$||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(B){case 12:case 13:$?W(10):P();break;case 16:W(1);break;case 15:case 14:break;default:return B}}}function W(B,X=[],Z=[]){if(M(B),X.length+Z.length>0){let V=r.getToken();for(;V!==17;){if(X.indexOf(V)!==-1){H();break}else if(Z.indexOf(V)!==-1)break;V=H()}}}function x(B){const X=r.getTokenValue();return B?O(X):d(X),H(),!0}function q(){switch(r.getToken()){case 11:let B=0;try{B=JSON.parse(r.getTokenValue()),typeof B!="number"&&(W(2),B=0)}catch(X){W(2)}O(B);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return H(),!0}function F(){return r.getToken()!==10?(W(3,[],[2,5]),!1):(x(!1),r.getToken()===6?(N(":"),H(),z()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function K(){u(),H();let B=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(B||W(4,[],[]),N(","),H(),r.getToken()===2&&U)break}else B&&W(6,[],[]);F()||W(4,[],[2,5]),B=!0}return m(),r.getToken()!==2?W(7,[2],[]):H(),!0}function j(){A(),H();let B=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(B||W(4,[],[]),N(","),H(),r.getToken()===4&&U)break}else B&&W(6,[],[]);z()||W(4,[],[4,5]),B=!0}return _(),r.getToken()!==4?W(8,[4],[]):H(),!0}function z(){switch(r.getToken()){case 3:return j();case 1:return K();case 10:return x(!0);default:return q()}}return H(),r.getToken()===17?i.allowEmptyContent?!0:(W(4,[],[]),!1):z()?(r.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=y;function c(t,s){let i=k(t),r=[],a,l=0,u;do switch(u=i.getPosition(),a=i.scan(),a){case 12:case 13:case 17:l!==u&&r.push(t.substring(l,u)),s!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,s)),l=i.getPosition();break}while(a!==17);return r.join("")}e.stripComments=c;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=o}),define(te[48],ne([0,1,36]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(S,b,n){let I,g,E,h,p;if(b){for(h=b.offset,p=h+b.length,E=h;E>0&&!C(S,E-1);)E--;let l=p;for(;l<S.length&&!C(S,l);)l++;g=S.substring(E,l),I=T(g,n)}else g=S,I=0,E=0,h=0,p=S.length;const f=k(n,S);let w=!1,v=0,y;n.insertSpaces?y=D(" ",n.tabSize||4):y="	";const c=(0,R.createScanner)(g,!1);let o=!1;function t(){return f+D(y,I+v)}function s(){let l=c.scan();for(w=!1;l===15||l===14;)w=w||l===14,l=c.scan();return o=l===16||c.getTokenError()!==0,l}const i=[];function r(l,u,d){!o&&u<p&&d>h&&S.substring(u,d)!==l&&i.push({offset:u,length:d-u,content:l})}let a=s();if(a!==17){const l=c.getTokenOffset()+E,u=D(y,I);r(u,E,l)}for(;a!==17;){let l=c.getTokenOffset()+c.getTokenLength()+E,u=s(),d="";for(;!w&&(u===12||u===13);){const A=c.getTokenOffset()+E;r(" ",l,A),l=c.getTokenOffset()+c.getTokenLength()+E,d=u===12?t():"",u=s()}if(u===2)a!==1&&(v--,d=t());else if(u===4)a!==3&&(v--,d=t());else{switch(a){case 3:case 1:v++,d=t();break;case 5:case 12:d=t();break;case 13:w?d=t():d=" ";break;case 6:d=" ";break;case 10:if(u===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?d=" ":u!==5&&u!==17&&(o=!0);break;case 16:o=!0;break}w&&(u===12||u===13)&&(d=t())}const m=c.getTokenOffset()+E;r(d,l,m),a=u}return i}e.format=L;function D(S,b){let n="";for(let I=0;I<b;I++)n+=S;return n}function T(S,b){let n=0,I=0;const g=b.tabSize||4;for(;n<S.length;){const E=S.charAt(n);if(E===" ")I++;else if(E==="	")I+=g;else break;n++}return Math.floor(I/g)}function k(S,b){for(let n=0;n<b.length;n++){const I=b.charAt(n);if(I==="\r")return n+1<b.length&&b.charAt(n+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=k;function C(S,b){return`\r
`.indexOf(S.charAt(b))!==-1}e.isEOL=C}),define(te[44],ne([0,1,36,48]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(b,n,I){return T(b,n,void 0,I)}e.removeProperty=D;function T(b,n,I,g,E){const h=n.slice(),p=[],f=(0,R.parseTree)(b,p);let w,v;for(;h.length>0&&(v=h.pop(),w=(0,R.findNodeAtLocation)(f,h),w===void 0&&I!==void 0);)typeof v=="string"?I={[v]:I}:I=[I];if(w)if(w.type==="object"&&typeof v=="string"&&Array.isArray(w.children)){const y=(0,R.findNodeAtLocation)(w,[v]);if(y!==void 0)if(I===void 0){if(!y.parent)throw new Error("Malformed AST");const c=w.children.indexOf(y.parent);let o,t=y.parent.offset+y.parent.length;if(c>0){const s=w.children[c-1];o=s.offset+s.length}else o=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return k(b,{offset:o,length:t-o,content:""},g)}else return k(b,{offset:y.offset,length:y.length,content:JSON.stringify(I)},g);else{if(I===void 0)return[];const c=`${JSON.stringify(v)}: ${JSON.stringify(I)}`,o=E?E(w.children.map(s=>s.children[0].value)):w.children.length;let t;if(o>0){const s=w.children[o-1];t={offset:s.offset+s.length,length:0,content:","+c}}else w.children.length===0?t={offset:w.offset+1,length:0,content:c}:t={offset:w.offset+1,length:0,content:c+","};return k(b,t,g)}}else if(w.type==="array"&&typeof v=="number"&&Array.isArray(w.children))if(I!==void 0){const y=`${JSON.stringify(I)}`;let c;if(w.children.length===0||v===0)c={offset:w.offset+1,length:0,content:w.children.length===0?y:y+","};else{const o=v===-1||v>w.children.length?w.children.length:v,t=w.children[o-1];c={offset:t.offset+t.length,length:0,content:","+y}}return k(b,c,g)}else{const y=v,c=w.children[y];let o;if(w.children.length===1)o={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===y){const t=w.children[y-1],s=t.offset+t.length,i=w.offset+w.length;o={offset:s,length:i-2-s,content:""}}else o={offset:c.offset,length:w.children[y+1].offset-c.offset,content:""};return k(b,o,g)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${w.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return k(b,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(I)},g)}}e.setProperty=T;function k(b,n,I){let g=C(b,n),E=n.offset,h=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;E>0&&!(0,L.isEOL)(g,E-1);)E--;for(;h<g.length&&!(0,L.isEOL)(g,h);)h++}const p=(0,L.format)(g,{offset:E,length:h-E},I);for(let w=p.length-1;w>=0;w--){const v=p[w];g=C(g,v),E=Math.min(E,v.offset),h=Math.max(h,v.offset+v.length),h+=v.content.length-v.length}const f=b.length-(g.length-h)-E;return[{offset:E,length:f,content:g.substring(E,h)}]}e.withFormatting=k;function C(b,n){return b.substring(0,n.offset)+n.content+b.substring(n.offset+n.length)}e.applyEdit=C;function S(b,n){let I=n.slice(0).sort((E,h)=>{const p=E.offset-h.offset;return p===0?E.length-h.length:p}),g=b.length;for(let E=I.length-1;E>=0;E--){let h=I[E];if(h.offset+h.length<=g)b=C(b,h);else throw new Error("Overlapping edit");g=h.offset}return b}e.applyEdits=S}),define(te[2],ne([0,1,67,55]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let T=null;function k(r){T=r}if(e.setDisposableTracker=k,D){const r="__is_disposable_tracked__";k(new class{trackDisposable(a){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[r]||console.log(l)},3e3)}setParent(a,l){if(a&&a!==v.None)try{a[r]=!0}catch{}}markAsDisposed(a){if(a&&a!==v.None)try{a[r]=!0}catch{}}markAsSingleton(a){}})}function C(r){return T?.trackDisposable(r),r}function S(r){T?.markAsDisposed(r)}function b(r,a){T?.setParent(r,a)}function n(r,a){if(!!T)for(const l of r)T.setParent(l,a)}function I(r){return T?.markAsSingleton(r),r}e.markAsSingleton=I;class g extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=g;function E(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=E;function h(r){if(L.Iterable.is(r)){let a=[];for(const l of r)if(l)try{l.dispose()}catch(u){a.push(u)}if(a.length===1)throw a[0];if(a.length>1)throw new g(a);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=h;function p(...r){const a=f(()=>h(r));return n(r,a),a}e.combinedDisposable=p;function f(r){const a=C({dispose:(0,R.once)(()=>{S(a),r()})});return a}e.toDisposable=f;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return b(a,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new w,C(this),b(this._store,this)}dispose(){S(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class y{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&b(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&b(a,null),a}}e.MutableDisposable=y;class c{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class o{constructor(){this.references=new Map}acquire(a,...l){let u=this.references.get(a);u||(u={counter:0,object:this.createReferencedObject(a,...l)},this.references.set(a,u));const{object:d}=u,m=(0,R.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(a,u.object),this.references.delete(a))});return u.counter++,{object:d,dispose:m}}}e.ReferenceCollection=o;class t{constructor(a){this.referenceCollection=a}async acquire(a,...l){const u=this.referenceCollection.acquire(a,...l);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(d){throw u.dispose(),d}}}e.AsyncReferenceCollection=t;class s{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=s;function i(r){const a=new w;try{r(a)}finally{a.dispose()}}e.disposeOnReturn=i}),define(te[100],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(T){this.element=T,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class L{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let T=this._first;for(;T!==R.Undefined;){const k=T.next;T.prev=R.Undefined,T.next=R.Undefined,T=k}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,k){const C=new R(T);if(this._first===R.Undefined)this._first=C,this._last=C;else if(k){const b=this._last;this._last=C,C.prev=b,b.next=C}else{const b=this._first;this._first=C,C.next=b,b.prev=C}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(C))}}shift(){if(this._first!==R.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==R.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==R.Undefined&&T.next!==R.Undefined){const k=T.prev;k.next=T.next,T.next.prev=k}else T.prev===R.Undefined&&T.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):T.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):T.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==R.Undefined;)yield T.element,T=T.next}}e.LinkedList=L}),function(){function J(D){const T=[];typeof D=="number"&&T.push("code/timeOrigin",D);function k(S){T.push(S,Date.now())}function C(){const S=[];for(let b=0;b<T.length;b+=2)S.push({name:T[b],startTime:T[b+1]});return S}return{mark:k,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const k of performance.getEntriesByType("mark"))T.push({name:k.name,startTime:Math.round(D+k.startTime)});return T}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function R(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=R(L))}(),define(te[4],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const R="en";let L=!1,D=!1,T=!1,k=!1,C=!1,S=!1,b=!1,n,I=R,g,E;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const p=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=p&&h?.sandboxed,typeof navigator=="object"&&!p)E=navigator.userAgent,L=E.indexOf("Windows")>=0,D=E.indexOf("Macintosh")>=0,b=(E.indexOf("Macintosh")>=0||E.indexOf("iPad")>=0||E.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=E.indexOf("Linux")>=0,S=!0,n=navigator.language,I=n;else if(typeof h=="object"){L=h.platform==="win32",D=h.platform==="darwin",T=h.platform==="linux",k=T&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,n=R,I=R;const i=h.env.VSCODE_NLS_CONFIG;if(i)try{const r=JSON.parse(i),a=r.availableLanguages["*"];n=r.locale,I=a||R,g=r._translationsConfigFile}catch(r){}C=!0}else console.error("Unable to resolve platform.");var f;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function w(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let v=0;D?v=1:L?v=3:T&&(v=2),e.isWindows=L,e.isMacintosh=D,e.isLinux=T,e.isLinuxSnap=k,e.isNative=C,e.isWeb=S,e.isIOS=b,e.platform=v,e.userAgent=E,e.language=I;var y;(function(i){function r(){return e.language}i.value=r;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=a;function l(){return e.language==="en"}i.isDefault=l})(y=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeSetImmediateId)for(let d=0,m=a.length;d<m;d++){const A=a[d];if(A.id===u.data.vscodeSetImmediateId){a.splice(d,1),A.callback();return}}});let l=0;return u=>{const d=++l;a.push({id:d,callback:u}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const r=Promise.resolve();return a=>r.then(a)}();var c;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||b?2:L?1:3;let o=!0,t=!1;function s(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,o=new Uint16Array(i.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=s}),define(te[31],ne([0,1,4]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.process!="undefined"){const D=R.globals.vscode.process;L={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(T){return(0,R.setImmediate)(T)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:L={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,R.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(te[9],ne([0,1,31]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,D=97,T=90,k=122,C=46,S=47,b=92,n=58,I=63;class g extends Error{constructor(c,o,t){let s;typeof o=="string"&&o.indexOf("not ")===0?(s="must not be",o=o.replace(/^not /,"")):s="must be";const i=c.indexOf(".")!==-1?"property":"argument";let r=`The "${c}" ${i} ${s} of type ${o}`;r+=`. Received type ${typeof t}`;super(r);this.code="ERR_INVALID_ARG_TYPE"}}function E(y,c){if(typeof y!="string")throw new g(c,"string",y)}function h(y){return y===S||y===b}function p(y){return y===S}function f(y){return y>=L&&y<=T||y>=D&&y<=k}function w(y,c,o,t){let s="",i=0,r=-1,a=0,l=0;for(let u=0;u<=y.length;++u){if(u<y.length)l=y.charCodeAt(u);else{if(t(l))break;l=S}if(t(l)){if(!(r===u-1||a===1))if(a===2){if(s.length<2||i!==2||s.charCodeAt(s.length-1)!==C||s.charCodeAt(s.length-2)!==C){if(s.length>2){const d=s.lastIndexOf(o);d===-1?(s="",i=0):(s=s.slice(0,d),i=s.length-1-s.lastIndexOf(o)),r=u,a=0;continue}else if(s.length!==0){s="",i=0,r=u,a=0;continue}}c&&(s+=s.length>0?`${o}..`:"..",i=2)}else s.length>0?s+=`${o}${y.slice(r+1,u)}`:s=y.slice(r+1,u),i=u-r-1;r=u,a=0}else l===C&&a!==-1?++a:a=-1}return s}function v(y,c){if(c===null||typeof c!="object")throw new g("pathObject","Object",c);const o=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return o?o===c.root?`${o}${t}`:`${o}${y}${t}`:t}e.win32={resolve(...y){let c="",o="",t=!1;for(let s=y.length-1;s>=-1;s--){let i;if(s>=0){if(i=y[s],E(i,"path"),i.length===0)continue}else c.length===0?i=R.cwd():(i=R.env[`=${c}`]||R.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==c.toLowerCase()&&i.charCodeAt(2)===b)&&(i=`${c}\\`));const r=i.length;let a=0,l="",u=!1;const d=i.charCodeAt(0);if(r===1)h(d)&&(a=1,u=!0);else if(h(d))if(u=!0,h(i.charCodeAt(1))){let m=2,A=m;for(;m<r&&!h(i.charCodeAt(m));)m++;if(m<r&&m!==A){const _=i.slice(A,m);for(A=m;m<r&&h(i.charCodeAt(m));)m++;if(m<r&&m!==A){for(A=m;m<r&&!h(i.charCodeAt(m));)m++;(m===r||m!==A)&&(l=`\\\\${_}\\${i.slice(A,m)}`,a=m)}}}else a=1;else f(d)&&i.charCodeAt(1)===n&&(l=i.slice(0,2),a=2,r>2&&h(i.charCodeAt(2))&&(u=!0,a=3));if(l.length>0)if(c.length>0){if(l.toLowerCase()!==c.toLowerCase())continue}else c=l;if(t){if(c.length>0)break}else if(o=`${i.slice(a)}\\${o}`,t=u,u&&c.length>0)break}return o=w(o,!t,"\\",h),t?`${c}\\${o}`:`${c}${o}`||"."},normalize(y){E(y,"path");const c=y.length;if(c===0)return".";let o=0,t,s=!1;const i=y.charCodeAt(0);if(c===1)return p(i)?"\\":y;if(h(i))if(s=!0,h(y.charCodeAt(1))){let a=2,l=a;for(;a<c&&!h(y.charCodeAt(a));)a++;if(a<c&&a!==l){const u=y.slice(l,a);for(l=a;a<c&&h(y.charCodeAt(a));)a++;if(a<c&&a!==l){for(l=a;a<c&&!h(y.charCodeAt(a));)a++;if(a===c)return`\\\\${u}\\${y.slice(l)}\\`;a!==l&&(t=`\\\\${u}\\${y.slice(l,a)}`,o=a)}}}else o=1;else f(i)&&y.charCodeAt(1)===n&&(t=y.slice(0,2),o=2,c>2&&h(y.charCodeAt(2))&&(s=!0,o=3));let r=o<c?w(y.slice(o),!s,"\\",h):"";return r.length===0&&!s&&(r="."),r.length>0&&h(y.charCodeAt(c-1))&&(r+="\\"),t===void 0?s?`\\${r}`:r:s?`${t}\\${r}`:`${t}${r}`},isAbsolute(y){E(y,"path");const c=y.length;if(c===0)return!1;const o=y.charCodeAt(0);return h(o)||c>2&&f(o)&&y.charCodeAt(1)===n&&h(y.charCodeAt(2))},join(...y){if(y.length===0)return".";let c,o;for(let i=0;i<y.length;++i){const r=y[i];E(r,"path"),r.length>0&&(c===void 0?c=o=r:c+=`\\${r}`)}if(c===void 0)return".";let t=!0,s=0;if(typeof o=="string"&&h(o.charCodeAt(0))){++s;const i=o.length;i>1&&h(o.charCodeAt(1))&&(++s,i>2&&(h(o.charCodeAt(2))?++s:t=!1))}if(t){for(;s<c.length&&h(c.charCodeAt(s));)s++;s>=2&&(c=`\\${c.slice(s)}`)}return e.win32.normalize(c)},relative(y,c){if(E(y,"from"),E(c,"to"),y===c)return"";const o=e.win32.resolve(y),t=e.win32.resolve(c);if(o===t||(y=o.toLowerCase(),c=t.toLowerCase(),y===c))return"";let s=0;for(;s<y.length&&y.charCodeAt(s)===b;)s++;let i=y.length;for(;i-1>s&&y.charCodeAt(i-1)===b;)i--;const r=i-s;let a=0;for(;a<c.length&&c.charCodeAt(a)===b;)a++;let l=c.length;for(;l-1>a&&c.charCodeAt(l-1)===b;)l--;const u=l-a,d=r<u?r:u;let m=-1,A=0;for(;A<d;A++){const O=y.charCodeAt(s+A);if(O!==c.charCodeAt(a+A))break;O===b&&(m=A)}if(A!==d){if(m===-1)return t}else{if(u>d){if(c.charCodeAt(a+A)===b)return t.slice(a+A+1);if(A===2)return t.slice(a+A)}r>d&&(y.charCodeAt(s+A)===b?m=A:A===2&&(m=3)),m===-1&&(m=0)}let _="";for(A=s+m+1;A<=i;++A)(A===i||y.charCodeAt(A)===b)&&(_+=_.length===0?"..":"\\..");return a+=m,_.length>0?`${_}${t.slice(a,l)}`:(t.charCodeAt(a)===b&&++a,t.slice(a,l))},toNamespacedPath(y){if(typeof y!="string")return y;if(y.length===0)return"";const c=e.win32.resolve(y);if(c.length<=2)return y;if(c.charCodeAt(0)===b){if(c.charCodeAt(1)===b){const o=c.charCodeAt(2);if(o!==I&&o!==C)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(f(c.charCodeAt(0))&&c.charCodeAt(1)===n&&c.charCodeAt(2)===b)return`\\\\?\\${c}`;return y},dirname(y){E(y,"path");const c=y.length;if(c===0)return".";let o=-1,t=0;const s=y.charCodeAt(0);if(c===1)return h(s)?y:".";if(h(s)){if(o=t=1,h(y.charCodeAt(1))){let a=2,l=a;for(;a<c&&!h(y.charCodeAt(a));)a++;if(a<c&&a!==l){for(l=a;a<c&&h(y.charCodeAt(a));)a++;if(a<c&&a!==l){for(l=a;a<c&&!h(y.charCodeAt(a));)a++;if(a===c)return y;a!==l&&(o=t=a+1)}}}}else f(s)&&y.charCodeAt(1)===n&&(o=c>2&&h(y.charCodeAt(2))?3:2,t=o);let i=-1,r=!0;for(let a=c-1;a>=t;--a)if(h(y.charCodeAt(a))){if(!r){i=a;break}}else r=!1;if(i===-1){if(o===-1)return".";i=o}return y.slice(0,i)},basename(y,c){c!==void 0&&E(c,"ext"),E(y,"path");let o=0,t=-1,s=!0,i;if(y.length>=2&&f(y.charCodeAt(0))&&y.charCodeAt(1)===n&&(o=2),c!==void 0&&c.length>0&&c.length<=y.length){if(c===y)return"";let r=c.length-1,a=-1;for(i=y.length-1;i>=o;--i){const l=y.charCodeAt(i);if(h(l)){if(!s){o=i+1;break}}else a===-1&&(s=!1,a=i+1),r>=0&&(l===c.charCodeAt(r)?--r==-1&&(t=i):(r=-1,t=a))}return o===t?t=a:t===-1&&(t=y.length),y.slice(o,t)}for(i=y.length-1;i>=o;--i)if(h(y.charCodeAt(i))){if(!s){o=i+1;break}}else t===-1&&(s=!1,t=i+1);return t===-1?"":y.slice(o,t)},extname(y){E(y,"path");let c=0,o=-1,t=0,s=-1,i=!0,r=0;y.length>=2&&y.charCodeAt(1)===n&&f(y.charCodeAt(0))&&(c=t=2);for(let a=y.length-1;a>=c;--a){const l=y.charCodeAt(a);if(h(l)){if(!i){t=a+1;break}continue}s===-1&&(i=!1,s=a+1),l===C?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===t+1?"":y.slice(o,s)},format:v.bind(null,"\\"),parse(y){E(y,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return c;const o=y.length;let t=0,s=y.charCodeAt(0);if(o===1)return h(s)?(c.root=c.dir=y,c):(c.base=c.name=y,c);if(h(s)){if(t=1,h(y.charCodeAt(1))){let m=2,A=m;for(;m<o&&!h(y.charCodeAt(m));)m++;if(m<o&&m!==A){for(A=m;m<o&&h(y.charCodeAt(m));)m++;if(m<o&&m!==A){for(A=m;m<o&&!h(y.charCodeAt(m));)m++;m===o?t=m:m!==A&&(t=m+1)}}}}else if(f(s)&&y.charCodeAt(1)===n){if(o<=2)return c.root=c.dir=y,c;if(t=2,h(y.charCodeAt(2))){if(o===3)return c.root=c.dir=y,c;t=3}}t>0&&(c.root=y.slice(0,t));let i=-1,r=t,a=-1,l=!0,u=y.length-1,d=0;for(;u>=t;--u){if(s=y.charCodeAt(u),h(s)){if(!l){r=u+1;break}continue}a===-1&&(l=!1,a=u+1),s===C?i===-1?i=u:d!==1&&(d=1):i!==-1&&(d=-1)}return a!==-1&&(i===-1||d===0||d===1&&i===a-1&&i===r+1?c.base=c.name=y.slice(r,a):(c.name=y.slice(r,i),c.base=y.slice(r,a),c.ext=y.slice(i,a))),r>0&&r!==t?c.dir=y.slice(0,r-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...y){let c="",o=!1;for(let t=y.length-1;t>=-1&&!o;t--){const s=t>=0?y[t]:R.cwd();E(s,"path"),s.length!==0&&(c=`${s}/${c}`,o=s.charCodeAt(0)===S)}return c=w(c,!o,"/",p),o?`/${c}`:c.length>0?c:"."},normalize(y){if(E(y,"path"),y.length===0)return".";const c=y.charCodeAt(0)===S,o=y.charCodeAt(y.length-1)===S;return y=w(y,!c,"/",p),y.length===0?c?"/":o?"./":".":(o&&(y+="/"),c?`/${y}`:y)},isAbsolute(y){return E(y,"path"),y.length>0&&y.charCodeAt(0)===S},join(...y){if(y.length===0)return".";let c;for(let o=0;o<y.length;++o){const t=y[o];E(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(y,c){if(E(y,"from"),E(c,"to"),y===c||(y=e.posix.resolve(y),c=e.posix.resolve(c),y===c))return"";const o=1,t=y.length,s=t-o,i=1,r=c.length-i,a=s<r?s:r;let l=-1,u=0;for(;u<a;u++){const m=y.charCodeAt(o+u);if(m!==c.charCodeAt(i+u))break;m===S&&(l=u)}if(u===a)if(r>a){if(c.charCodeAt(i+u)===S)return c.slice(i+u+1);if(u===0)return c.slice(i+u)}else s>a&&(y.charCodeAt(o+u)===S?l=u:u===0&&(l=0));let d="";for(u=o+l+1;u<=t;++u)(u===t||y.charCodeAt(u)===S)&&(d+=d.length===0?"..":"/..");return`${d}${c.slice(i+l)}`},toNamespacedPath(y){return y},dirname(y){if(E(y,"path"),y.length===0)return".";const c=y.charCodeAt(0)===S;let o=-1,t=!0;for(let s=y.length-1;s>=1;--s)if(y.charCodeAt(s)===S){if(!t){o=s;break}}else t=!1;return o===-1?c?"/":".":c&&o===1?"//":y.slice(0,o)},basename(y,c){c!==void 0&&E(c,"ext"),E(y,"path");let o=0,t=-1,s=!0,i;if(c!==void 0&&c.length>0&&c.length<=y.length){if(c===y)return"";let r=c.length-1,a=-1;for(i=y.length-1;i>=0;--i){const l=y.charCodeAt(i);if(l===S){if(!s){o=i+1;break}}else a===-1&&(s=!1,a=i+1),r>=0&&(l===c.charCodeAt(r)?--r==-1&&(t=i):(r=-1,t=a))}return o===t?t=a:t===-1&&(t=y.length),y.slice(o,t)}for(i=y.length-1;i>=0;--i)if(y.charCodeAt(i)===S){if(!s){o=i+1;break}}else t===-1&&(s=!1,t=i+1);return t===-1?"":y.slice(o,t)},extname(y){E(y,"path");let c=-1,o=0,t=-1,s=!0,i=0;for(let r=y.length-1;r>=0;--r){const a=y.charCodeAt(r);if(a===S){if(!s){o=r+1;break}continue}t===-1&&(s=!1,t=r+1),a===C?c===-1?c=r:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||t===-1||i===0||i===1&&c===t-1&&c===o+1?"":y.slice(c,t)},format:v.bind(null,"/"),parse(y){E(y,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return c;const o=y.charCodeAt(0)===S;let t;o?(c.root="/",t=1):t=0;let s=-1,i=0,r=-1,a=!0,l=y.length-1,u=0;for(;l>=t;--l){const d=y.charCodeAt(l);if(d===S){if(!a){i=l+1;break}continue}r===-1&&(a=!1,r=l+1),d===C?s===-1?s=l:u!==1&&(u=1):s!==-1&&(u=-1)}if(r!==-1){const d=i===0&&o?1:i;s===-1||u===0||u===1&&s===r-1&&s===i+1?c.base=c.name=y.slice(d,r):(c.name=y.slice(d,s),c.base=y.slice(d,r),c.ext=y.slice(s,r))}return i>0?c.dir=y.slice(0,i-1):o&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=R.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=R.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=R.platform==="win32"?e.win32.join:e.posix.join,e.resolve=R.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=R.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=R.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=R.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=R.platform==="win32"?e.win32.extname:e.posix.extname,e.format=R.platform==="win32"?e.win32.format:e.posix.format,e.parse=R.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=R.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=R.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=R.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[101],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var L;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(T,...k){const C=k.reduce((n,I)=>(n[I]=!0,n),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(n=>!C[n]).forEach(n=>{for(let I=0;I<S.length;I++)if(n.search(S[I])!==-1){delete T[n];break}})}e.sanitizeProcessEnvironment=D}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var L in R)(typeof exports=="object"?exports:J)[L]=R[L]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function R(L){if(e[L])return e[L].exports;var D=e[L]={i:L,l:!1,exports:{}};return J[L].call(D.exports,D,D.exports,R),D.l=!0,D.exports}return R.m=J,R.c=e,R.d=function(L,D,T){R.o(L,D)||Object.defineProperty(L,D,{enumerable:!0,get:T})},R.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},R.t=function(L,D){if(1&D&&(L=R(L)),8&D||4&D&&typeof L=="object"&&L&&L.__esModule)return L;var T=Object.create(null);if(R.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:L}),2&D&&typeof L!="string")for(var k in L)R.d(T,k,function(C){return L[C]}.bind(null,k));return T},R.n=function(L){var D=L&&L.__esModule?function(){return L.default}:function(){return L};return R.d(D,"a",D),D},R.o=function(L,D){return Object.prototype.hasOwnProperty.call(L,D)},R.p="",R(R.s=0)}([function(J,e,R){(function(L){var D;e=J.exports=Z,D=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],S=e.src=[],b=0,n=b++;S[n]="0|[1-9]\\d*";var I=b++;S[I]="[0-9]+";var g=b++;S[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=b++;S[E]="("+S[n]+")\\.("+S[n]+")\\.("+S[n]+")";var h=b++;S[h]="("+S[I]+")\\.("+S[I]+")\\.("+S[I]+")";var p=b++;S[p]="(?:"+S[n]+"|"+S[g]+")";var f=b++;S[f]="(?:"+S[I]+"|"+S[g]+")";var w=b++;S[w]="(?:-("+S[p]+"(?:\\."+S[p]+")*))";var v=b++;S[v]="(?:-?("+S[f]+"(?:\\."+S[f]+")*))";var y=b++;S[y]="[0-9A-Za-z-]+";var c=b++;S[c]="(?:\\+("+S[y]+"(?:\\."+S[y]+")*))";var o=b++,t="v?"+S[E]+S[w]+"?"+S[c]+"?";S[o]="^"+t+"$";var s="[v=\\s]*"+S[h]+S[v]+"?"+S[c]+"?",i=b++;S[i]="^"+s+"$";var r=b++;S[r]="((?:<|>)?=?)";var a=b++;S[a]=S[I]+"|x|X|\\*";var l=b++;S[l]=S[n]+"|x|X|\\*";var u=b++;S[u]="[v=\\s]*("+S[l]+")(?:\\.("+S[l]+")(?:\\.("+S[l]+")(?:"+S[w]+")?"+S[c]+"?)?)?";var d=b++;S[d]="[v=\\s]*("+S[a]+")(?:\\.("+S[a]+")(?:\\.("+S[a]+")(?:"+S[v]+")?"+S[c]+"?)?)?";var m=b++;S[m]="^"+S[r]+"\\s*"+S[u]+"$";var A=b++;S[A]="^"+S[r]+"\\s*"+S[d]+"$";var _=b++;S[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=b++;S[O]="(?:~>?)";var N=b++;S[N]="(\\s*)"+S[O]+"\\s+",C[N]=new RegExp(S[N],"g");var P=b++;S[P]="^"+S[O]+S[u]+"$";var M=b++;S[M]="^"+S[O]+S[d]+"$";var $=b++;S[$]="(?:\\^)";var U=b++;S[U]="(\\s*)"+S[$]+"\\s+",C[U]=new RegExp(S[U],"g");var H=b++;S[H]="^"+S[$]+S[u]+"$";var W=b++;S[W]="^"+S[$]+S[d]+"$";var x=b++;S[x]="^"+S[r]+"\\s*("+s+")$|^$";var q=b++;S[q]="^"+S[r]+"\\s*("+t+")$|^$";var F=b++;S[F]="(\\s*)"+S[r]+"\\s*("+s+"|"+S[u]+")",C[F]=new RegExp(S[F],"g");var K=b++;S[K]="^\\s*("+S[u]+")\\s+-\\s+("+S[u]+")\\s*$";var j=b++;S[j]="^\\s*("+S[d]+")\\s+-\\s+("+S[d]+")\\s*$";var z=b++;S[z]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)D(B,S[B]),C[B]||(C[B]=new RegExp(S[B]));function X(ee,oe){if(ee instanceof Z)return ee;if(typeof ee!="string"||ee.length>T||!(oe?C[i]:C[o]).test(ee))return null;try{return new Z(ee,oe)}catch(ce){return null}}function Z(ee,oe){if(ee instanceof Z){if(ee.loose===oe)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof Z))return new Z(ee,oe);D("SemVer",ee,oe),this.loose=oe;var ce=ee.trim().match(oe?C[i]:C[o]);if(!ce)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Se=+ye;if(Se>=0&&Se<k)return Se}return ye}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=X,e.valid=function(ee,oe){var ce=X(ee,oe);return ce?ce.version:null},e.clean=function(ee,oe){var ce=X(ee.trim().replace(/^[=v]+/,""),oe);return ce?ce.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ee){return D("SemVer.compare",this.version,this.loose,ee),ee instanceof Z||(ee=new Z(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},Z.prototype.compareMain=function(ee){return ee instanceof Z||(ee=new Z(ee,this.loose)),G(this.major,ee.major)||G(this.minor,ee.minor)||G(this.patch,ee.patch)},Z.prototype.comparePre=function(ee){if(ee instanceof Z||(ee=new Z(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var oe=0;do{var ce=this.prerelease[oe],ye=ee.prerelease[oe];if(D("prerelease compare",oe,ce,ye),ce===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(ce===void 0)return-1;if(ce!==ye)return G(ce,ye)}while(++oe)},Z.prototype.inc=function(ee,oe){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",oe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",oe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",oe),this.inc("pre",oe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",oe),this.inc("pre",oe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}oe&&(this.prerelease[0]===oe?isNaN(this.prerelease[1])&&(this.prerelease=[oe,0]):this.prerelease=[oe,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,oe,ce,ye){typeof ce=="string"&&(ye=ce,ce=void 0);try{return new Z(ee,ce).inc(oe,ye).version}catch(Se){return null}},e.diff=function(ee,oe){if(ue(ee,oe))return null;var ce=X(ee),ye=X(oe);if(ce.prerelease.length||ye.prerelease.length){for(var Se in ce)if((Se==="major"||Se==="minor"||Se==="patch")&&ce[Se]!==ye[Se])return"pre"+Se;return"prerelease"}for(var Se in ce)if((Se==="major"||Se==="minor"||Se==="patch")&&ce[Se]!==ye[Se])return Se},e.compareIdentifiers=G;var V=/^[0-9]+$/;function G(ee,oe){var ce=V.test(ee),ye=V.test(oe);return ce&&ye&&(ee=+ee,oe=+oe),ce&&!ye?-1:ye&&!ce?1:ee<oe?-1:ee>oe?1:0}function ie(ee,oe,ce){return new Z(ee,ce).compare(new Z(oe,ce))}function re(ee,oe,ce){return ie(ee,oe,ce)>0}function ae(ee,oe,ce){return ie(ee,oe,ce)<0}function ue(ee,oe,ce){return ie(ee,oe,ce)===0}function fe(ee,oe,ce){return ie(ee,oe,ce)!==0}function ge(ee,oe,ce){return ie(ee,oe,ce)>=0}function Ie(ee,oe,ce){return ie(ee,oe,ce)<=0}function Pe(ee,oe,ce,ye){var Se;switch(oe){case"===":typeof ee=="object"&&(ee=ee.version),typeof ce=="object"&&(ce=ce.version),Se=ee===ce;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ce=="object"&&(ce=ce.version),Se=ee!==ce;break;case"":case"=":case"==":Se=ue(ee,ce,ye);break;case"!=":Se=fe(ee,ce,ye);break;case">":Se=re(ee,ce,ye);break;case">=":Se=ge(ee,ce,ye);break;case"<":Se=ae(ee,ce,ye);break;case"<=":Se=Ie(ee,ce,ye);break;default:throw new TypeError("Invalid operator: "+oe)}return Se}function Ee(ee,oe){if(ee instanceof Ee){if(ee.loose===oe)return ee;ee=ee.value}if(!(this instanceof Ee))return new Ee(ee,oe);D("comparator",ee,oe),this.loose=oe,this.parse(ee),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ee,oe){return G(oe,ee)},e.major=function(ee,oe){return new Z(ee,oe).major},e.minor=function(ee,oe){return new Z(ee,oe).minor},e.patch=function(ee,oe){return new Z(ee,oe).patch},e.compare=ie,e.compareLoose=function(ee,oe){return ie(ee,oe,!0)},e.rcompare=function(ee,oe,ce){return ie(oe,ee,ce)},e.sort=function(ee,oe){return ee.sort(function(ce,ye){return e.compare(ce,ye,oe)})},e.rsort=function(ee,oe){return ee.sort(function(ce,ye){return e.rcompare(ce,ye,oe)})},e.gt=re,e.lt=ae,e.eq=ue,e.neq=fe,e.gte=ge,e.lte=Ie,e.cmp=Pe,e.Comparator=Ee;var _e={};function De(ee,oe){if(ee instanceof De)return ee.loose===oe?ee:new De(ee.raw,oe);if(ee instanceof Ee)return new De(ee.value,oe);if(!(this instanceof De))return new De(ee,oe);if(this.loose=oe,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function ke(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Fe(ee,oe,ce,ye,Se,Oe,Te,Ue,Ae,Y,se,le,de){return((oe=ke(ce)?"":ke(ye)?">="+ce+".0.0":ke(Se)?">="+ce+"."+ye+".0":">="+oe)+" "+(Ue=ke(Ae)?"":ke(Y)?"<"+(+Ae+1)+".0.0":ke(se)?"<"+Ae+"."+(+Y+1)+".0":le?"<="+Ae+"."+Y+"."+se+"-"+le:"<="+Ue)).trim()}function Ne(ee,oe){for(var ce=0;ce<ee.length;ce++)if(!ee[ce].test(oe))return!1;if(oe.prerelease.length){for(ce=0;ce<ee.length;ce++)if(D(ee[ce].semver),ee[ce].semver!==_e&&ee[ce].semver.prerelease.length>0){var ye=ee[ce].semver;if(ye.major===oe.major&&ye.minor===oe.minor&&ye.patch===oe.patch)return!0}return!1}return!0}function ze(ee,oe,ce){try{oe=new De(oe,ce)}catch(ye){return!1}return oe.test(ee)}function xe(ee,oe,ce,ye){var Se,Oe,Te,Ue,Ae;switch(ee=new Z(ee,ye),oe=new De(oe,ye),ce){case">":Se=re,Oe=Ie,Te=ae,Ue=">",Ae=">=";break;case"<":Se=ae,Oe=ge,Te=re,Ue="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(ee,oe,ye))return!1;for(var Y=0;Y<oe.set.length;++Y){var se=oe.set[Y],le=null,de=null;if(se.forEach(function(me){me.semver===_e&&(me=new Ee(">=0.0.0")),le=le||me,de=de||me,Se(me.semver,le.semver,ye)?le=me:Te(me.semver,de.semver,ye)&&(de=me)}),le.operator===Ue||le.operator===Ae||(!de.operator||de.operator===Ue)&&Oe(ee,de.semver)||de.operator===Ae&&Te(ee,de.semver))return!1}return!0}Ee.prototype.parse=function(ee){var oe=this.loose?C[x]:C[q],ce=ee.match(oe);if(!ce)throw new TypeError("Invalid comparator: "+ee);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new Z(ce[2],this.loose):this.semver=_e},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(ee){return D("Comparator.test",ee,this.loose),this.semver===_e||(typeof ee=="string"&&(ee=new Z(ee,this.loose)),Pe(ee,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(ee,oe){if(!(ee instanceof Ee))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new De(ee.value,oe),ze(this.value,ce,oe);if(ee.operator==="")return ce=new De(this.value,oe),ze(ee.semver,ce,oe);var ye=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),Oe=this.semver.version===ee.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Ue=Pe(this.semver,"<",ee.semver,oe)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),Ae=Pe(this.semver,">",ee.semver,oe)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return ye||Se||Oe&&Te||Ue||Ae},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(ee){var oe=this.loose;ee=ee.trim(),D("range",ee,oe);var ce=oe?C[j]:C[K];ee=ee.replace(ce,Fe),D("hyphen replace",ee),ee=ee.replace(C[F],"$1$2$3"),D("comparator trim",ee,C[F]),ee=(ee=(ee=ee.replace(C[N],"$1~")).replace(C[U],"$1^")).split(/\s+/).join(" ");var ye=oe?C[x]:C[q],Se=ee.split(" ").map(function(Oe){return function(Te,Ue){return D("comp",Te),Te=function(Ae,Y){return Ae.trim().split(/\s+/).map(function(se){return function(le,de){D("caret",le,de);var me=de?C[W]:C[H];return le.replace(me,function(be,pe,we,Ce,Re){var Le;return D("caret",le,be,pe,we,Ce,Re),ke(pe)?Le="":ke(we)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":ke(Ce)?Le=pe==="0"?">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+".0 <"+(+pe+1)+".0.0":Re?(D("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Le=pe==="0"?we==="0"?">="+pe+"."+we+"."+Ce+Re+" <"+pe+"."+we+"."+(+Ce+1):">="+pe+"."+we+"."+Ce+Re+" <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+"."+Ce+Re+" <"+(+pe+1)+".0.0"):(D("no pr"),Le=pe==="0"?we==="0"?">="+pe+"."+we+"."+Ce+" <"+pe+"."+we+"."+(+Ce+1):">="+pe+"."+we+"."+Ce+" <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+"."+Ce+" <"+(+pe+1)+".0.0"),D("caret return",Le),Le})}(se,Y)}).join(" ")}(Te,Ue),D("caret",Te),Te=function(Ae,Y){return Ae.trim().split(/\s+/).map(function(se){return function(le,de){var me=de?C[M]:C[P];return le.replace(me,function(be,pe,we,Ce,Re){var Le;return D("tilde",le,be,pe,we,Ce,Re),ke(pe)?Le="":ke(we)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":ke(Ce)?Le=">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0":Re?(D("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Le=">="+pe+"."+we+"."+Ce+Re+" <"+pe+"."+(+we+1)+".0"):Le=">="+pe+"."+we+"."+Ce+" <"+pe+"."+(+we+1)+".0",D("tilde return",Le),Le})}(se,Y)}).join(" ")}(Te,Ue),D("tildes",Te),Te=function(Ae,Y){return D("replaceXRanges",Ae,Y),Ae.split(/\s+/).map(function(se){return function(le,de){le=le.trim();var me=de?C[A]:C[m];return le.replace(me,function(be,pe,we,Ce,Re,Le){D("xRange",le,be,pe,we,Ce,Re,Le);var it=ke(we),Ge=it||ke(Ce),je=Ge||ke(Re);return pe==="="&&je&&(pe=""),it?be=pe===">"||pe==="<"?"<0.0.0":"*":pe&&je?(Ge&&(Ce=0),je&&(Re=0),pe===">"?(pe=">=",Ge?(we=+we+1,Ce=0,Re=0):je&&(Ce=+Ce+1,Re=0)):pe==="<="&&(pe="<",Ge?we=+we+1:Ce=+Ce+1),be=pe+we+"."+Ce+"."+Re):Ge?be=">="+we+".0.0 <"+(+we+1)+".0.0":je&&(be=">="+we+"."+Ce+".0 <"+we+"."+(+Ce+1)+".0"),D("xRange return",be),be})}(se,Y)}).join(" ")}(Te,Ue),D("xrange",Te),Te=function(Ae,Y){return D("replaceStars",Ae,Y),Ae.trim().replace(C[z],"")}(Te,Ue),D("stars",Te),Te}(Oe,oe)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(Oe){return!!Oe.match(ye)})),Se=Se.map(function(Oe){return new Ee(Oe,oe)})},De.prototype.intersects=function(ee,oe){if(!(ee instanceof De))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(ye){return ee.set.some(function(Se){return Se.every(function(Oe){return ye.intersects(Oe,oe)})})})})},e.toComparators=function(ee,oe){return new De(ee,oe).set.map(function(ce){return ce.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},De.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new Z(ee,this.loose));for(var oe=0;oe<this.set.length;oe++)if(Ne(this.set[oe],ee))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(ee,oe,ce){var ye=null,Se=null;try{var Oe=new De(oe,ce)}catch(Te){return null}return ee.forEach(function(Te){Oe.test(Te)&&(ye&&Se.compare(Te)!==-1||(Se=new Z(ye=Te,ce)))}),ye},e.minSatisfying=function(ee,oe,ce){var ye=null,Se=null;try{var Oe=new De(oe,ce)}catch(Te){return null}return ee.forEach(function(Te){Oe.test(Te)&&(ye&&Se.compare(Te)!==1||(Se=new Z(ye=Te,ce)))}),ye},e.validRange=function(ee,oe){try{return new De(ee,oe).range||"*"}catch(ce){return null}},e.ltr=function(ee,oe,ce){return xe(ee,oe,"<",ce)},e.gtr=function(ee,oe,ce){return xe(ee,oe,">",ce)},e.outside=xe,e.prerelease=function(ee,oe){var ce=X(ee,oe);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(ee,oe,ce){return ee=new De(ee,ce),oe=new De(oe,ce),ee.intersects(oe)},e.coerce=function(ee){if(ee instanceof Z)return ee;if(typeof ee!="string")return null;var oe=ee.match(C[_]);return oe==null?null:X((oe[1]||"0")+"."+(oe[2]||"0")+"."+(oe[3]||"0"))}}).call(this,R(1))},function(J,e){var R,L,D=J.exports={};function T(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function C(f){if(R===setTimeout)return setTimeout(f,0);if((R===T||!R)&&setTimeout)return R=setTimeout,setTimeout(f,0);try{return R(f,0)}catch(w){try{return R.call(null,f,0)}catch(v){return R.call(this,f,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:T}catch(f){R=T}try{L=typeof clearTimeout=="function"?clearTimeout:k}catch(f){L=k}})();var S,b=[],n=!1,I=-1;function g(){n&&S&&(n=!1,S.length?b=S.concat(b):I=-1,b.length&&E())}function E(){if(!n){var f=C(g);n=!0;for(var w=b.length;w;){for(S=b,b=[];++I<w;)S&&S[I].run();I=-1,w=b.length}S=null,n=!1,function(v){if(L===clearTimeout)return clearTimeout(v);if((L===k||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(v);try{L(v)}catch(y){try{return L.call(null,v)}catch(c){return L.call(this,v)}}}(f)}}function h(f,w){this.fun=f,this.array=w}function p(){}D.nextTick=function(f){var w=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)w[v-1]=arguments[v];b.push(new h(f,w)),b.length!==1||n||C(E)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=p,D.addListener=p,D.once=p,D.off=p,D.removeListener=p,D.removeAllListeners=p,D.emit=p,D.prependListener=p,D.prependOnceListener=p,D.listeners=function(f){return[]},D.binding=function(f){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(f){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(te[102],ne([0,1,4]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=R.globals.performance&&typeof R.globals.performance.now=="function";class D{constructor(k){this._highResolution=L&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new D(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}e.StopWatch=D}),define(te[3],ne([0,1,8,67,2,100,102]),function(J,e,R,L,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(c){c.None=()=>D.Disposable.None;function o(U){return(H,W=null,x)=>{let q=!1,F;return F=U(K=>{if(!q)return F?F.dispose():q=!0,H.call(W,K)},null,x),q&&F.dispose(),F}}c.once=o;function t(U,H){return u((W,x=null,q)=>U(F=>W.call(x,H(F)),null,q))}c.map=t;function s(U,H){return u((W,x=null,q)=>U(F=>{H(F),W.call(x,F)},null,q))}c.forEach=s;function i(U,H){return u((W,x=null,q)=>U(F=>H(F)&&W.call(x,F),null,q))}c.filter=i;function r(U){return U}c.signal=r;function a(...U){return(H,W=null,x)=>(0,D.combinedDisposable)(...U.map(q=>q(F=>H.call(W,F),null,x)))}c.any=a;function l(U,H,W){let x=W;return t(U,q=>(x=H(x,q),x))}c.reduce=l;function u(U){let H;const W=new g({onFirstListenerAdd(){H=U(W.fire,W)},onLastListenerRemove(){H.dispose()}});return W.event}function d(U,H,W=100,x=!1,q){let F,K,j,z=0;const B=new g({leakWarningThreshold:q,onFirstListenerAdd(){F=U(X=>{z++,K=H(K,X),x&&!j&&(B.fire(K),K=void 0),clearTimeout(j),j=setTimeout(()=>{const Z=K;K=void 0,j=void 0,(!x||z>1)&&B.fire(Z),z=0},W)})},onLastListenerRemove(){F.dispose()}});return B.event}c.debounce=d;function m(U,H=(W,x)=>W===x){let W=!0,x;return i(U,q=>{const F=W||!H(q,x);return W=!1,x=q,F})}c.latch=m;function A(U,H){return[c.filter(U,H),c.filter(U,W=>!H(W))]}c.split=A;function _(U,H=!1,W=[]){let x=W.slice(),q=U(j=>{x?x.push(j):K.fire(j)});const F=()=>{x&&x.forEach(j=>K.fire(j)),x=null},K=new g({onFirstListenerAdd(){q||(q=U(j=>K.fire(j)))},onFirstListenerDidAdd(){x&&(H?setTimeout(F):F())},onLastListenerRemove(){q&&q.dispose(),q=null}});return K.event}c.buffer=_;class O{constructor(H){this.event=H}map(H){return new O(t(this.event,H))}forEach(H){return new O(s(this.event,H))}filter(H){return new O(i(this.event,H))}reduce(H,W){return new O(l(this.event,H,W))}latch(){return new O(m(this.event))}debounce(H,W=100,x=!1,q){return new O(d(this.event,H,W,x,q))}on(H,W,x){return this.event(H,W,x)}once(H,W,x){return o(this.event)(H,W,x)}}function N(U){return new O(U)}c.chain=N;function P(U,H,W=x=>x){const x=(...j)=>K.fire(W(...j)),q=()=>U.on(H,x),F=()=>U.removeListener(H,x),K=new g({onFirstListenerAdd:q,onLastListenerRemove:F});return K.event}c.fromNodeEventEmitter=P;function M(U,H,W=x=>x){const x=(...j)=>K.fire(W(...j)),q=()=>U.addEventListener(H,x),F=()=>U.removeEventListener(H,x),K=new g({onFirstListenerAdd:q,onLastListenerRemove:F});return K.event}c.fromDOMEventEmitter=M;function $(U){return new Promise(H=>o(U)(H))}c.toPromise=$})(C=e.Event||(e.Event={}));class S{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${S._idPool++}`}start(o){this._stopWatch=new k.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let b=-1;function n(c){const o=b;return b=c,{dispose(){b=o}}}e.setGlobalLeakWarningThreshold=n;class I{constructor(o,t=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let t=b;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||o<t)return;this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(s)||0;if(this._stacks.set(s,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let r,a=0;for(const[l,u]of this._stacks)(!r||a<u)&&(r=l,a=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${a}):`),console.warn(r)}return()=>{const r=this._stacks.get(s)||0;this._stacks.set(s,r-1)}}}class g{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=b>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(o,t,s)=>{this._listeners||(this._listeners=new T.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(t?[o,t]:o);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,t);const a=this._leakageMon?.check(this._listeners.size),l=(0,D.toDisposable)(()=>{a&&a(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof D.DisposableStore?s.add(l):Array.isArray(s)&&s.push(l),l}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,s]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,s):t[0].call(t[1],s)}catch(i){(0,R.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=g;class E extends g{async fireAsync(o,t,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,o]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[i,r]=this._asyncDeliveryQueue.shift(),a=[],l={...r,waitUntil:u=>{if(Object.isFrozen(a))throw new Error("waitUntil can NOT be called asynchronous");s&&(u=s(u,typeof i=="function"?i:i[0])),a.push(u)}};try{typeof i=="function"?i.call(void 0,l):i[0].call(i[1],l)}catch(u){(0,R.onUnexpectedError)(u);continue}Object.freeze(a),await Promise.allSettled(a).then(u=>{for(const d of u)d.status==="rejected"&&(0,R.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=E;class h extends g{constructor(o){super(o);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=h;class p extends h{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=p;class f extends g{constructor(o){super(o);this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=f;class w{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const t={event:o,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const s=()=>{this.hasListeners&&this.unhook(t);const i=this.events.indexOf(t);this.events.splice(i,1)};return(0,D.toDisposable)((0,L.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(t=>this.emitter.fire(t))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=w;class v{constructor(){this.buffers=[]}wrapEvent(o){return(t,s,i)=>o(r=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>t.call(s,r)):t.call(s,r)},void 0,i)}bufferEvents(o){const t=[];this.buffers.push(t);const s=o();return this.buffers.pop(),t.forEach(i=>i()),s}}e.EventBufferer=v;class y{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=D.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=y}),define(te[27],ne([0,1,3]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(C,S){const b=setTimeout(C.bind(S),0);return{dispose(){clearTimeout(b)}}});var D;(function(C){function S(b){return b===C.None||b===C.Cancelled||b instanceof T?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}C.isCancellationToken=S,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(D=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=D.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=k}),define(te[49],ne([0,1,3]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new R.Emitter}add(I){const g=this._icons.get(I.id);g?I.description?g.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new L;e.iconRegistry=D;function T(n,I){return new C(n,I)}e.registerCodicon=T;function k(n){return n?n.replace(/\$\((.*?)\)/g,(I,g)=>` ${g} `).trim():""}e.getCodiconAriaLabel=k;class C{constructor(I,g,E){this.id=I,this.definition=g,this.description=E,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function S(n,I){const g=["codicon","codicon-"+n];return I&&g.push("codicon-modifier-"+I),g}e.getClassNamesArray=S;var b;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function g(p){if(p instanceof C)return["codicon","codicon-"+p.id];const f=I.exec(p.id);if(!f)return g(C.error);let[,w,v]=f;const y=["codicon","codicon-"+w];return v&&y.push("codicon-modifier-"+v.substr(1)),y}n.asClassNameArray=g;function E(p){return g(p).join(" ")}n.asClassName=E;function h(p){return"."+g(p).join(".")}n.asCSSSelector=h})(b=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",{fontCharacter:"\\eb0f"}),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(te[50],ne([0,1,8,2]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(y){const c=y;return c?[c.on,c.pause,c.resume,c.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=D;function T(y){const c=y;return c?D(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=T;function k(y,c){return new C(y,c)}e.newWriteableStream=k;class C{constructor(c,o){this.reducer=c,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(o=>o(c))}emitError(c){this.listeners.error.length===0?(0,R.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(o=>o(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,o){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(c,o){if(this.state.destroyed)return;let t;switch(c){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(o);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(y,c){const o=[];let t;for(;(t=y.read())!==null;)o.push(t);return c(o)}e.consumeReadable=S;function b(y,c,o){const t=[];let s;for(;(s=y.read())!==null&&t.length<o;)t.push(s);return s===null&&t.length>0?c(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const i=s;return s=void 0,i}return y.read()}}}e.peekReadable=b;function n(y,c){return new Promise((o,t)=>{const s=[];I(y,{onData:i=>{c&&s.push(i)},onError:i=>{c?t(i):o(void 0)},onEnd:()=>{o(c?c(s):void 0)}})})}e.consumeStream=n;function I(y,c){y.on("error",o=>c.onError(o)),y.on("end",()=>c.onEnd()),y.on("data",o=>c.onData(o))}e.listenStream=I;function g(y,c){return new Promise((o,t)=>{const s=new L.DisposableStore,i=[],r=u=>{if(i.push(u),i.length>c)return s.dispose(),y.pause(),o({stream:y,buffer:i,ended:!1})},a=u=>t(u),l=()=>o({stream:y,buffer:i,ended:!0});s.add((0,L.toDisposable)(()=>y.removeListener("error",a))),y.on("error",a),s.add((0,L.toDisposable)(()=>y.removeListener("end",l))),y.on("end",l),s.add((0,L.toDisposable)(()=>y.removeListener("data",r))),y.on("data",r)})}e.peekStream=g;function E(y,c){const o=k(c);return o.end(y),o}e.toStream=E;function h(){const y=k(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=h;function p(y){let c=!1;return{read:()=>c?null:(c=!0,y)}}e.toReadable=p;function f(y,c,o){const t=k(o);return I(y,{onData:s=>t.write(c.data(s)),onError:s=>t.error(c.error?c.error(s):s),onEnd:()=>t.end()}),t}e.transform=f;function w(y,c,o){let t=!1;return{read:()=>{const s=c.read();return t?s:(t=!0,s!==null?o([y,s]):y)}}}e.prefixedReadable=w;function v(y,c,o){let t=!1;const s=k(o);return I(c,{onData:i=>t?s.write(i):(t=!0,s.write(o([y,i]))),onError:i=>s.error(i),onEnd:()=>{t||(t=!0,s.write(y)),s.end()}}),s}e.prefixedStream=v}),define(te[22],ne([0,1,50]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let D,T;class k{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return L?new k(Buffer.allocUnsafe(r)):new k(new Uint8Array(r))}static wrap(r){return L&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new k(r)}static fromString(r,a){return!(a?.dontUseNodeBuffer||!1)&&L?new k(Buffer.from(r)):(D||(D=new TextEncoder),new k(D.encode(r)))}static concat(r,a){if(typeof a=="undefined"){a=0;for(let d=0,m=r.length;d<m;d++)a+=r[d].byteLength}const l=k.alloc(a);let u=0;for(let d=0,m=r.length;d<m;d++){const A=r[d];l.set(A,u),u+=A.byteLength}return l}toString(){return L?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(r,a){return new k(this.buffer.subarray(r,a))}set(r,a){r instanceof k?this.buffer.set(r.buffer,a):this.buffer.set(r,a)}readUInt32BE(r){return b(this.buffer,r)}writeUInt32BE(r,a){n(this.buffer,r,a)}readUInt32LE(r){return I(this.buffer,r)}writeUInt32LE(r,a){g(this.buffer,r,a)}readUInt8(r){return E(this.buffer,r)}writeUInt8(r,a){h(this.buffer,r,a)}}e.VSBuffer=k;function C(i,r){return i[r+0]<<0>>>0|i[r+1]<<8>>>0}e.readUInt16LE=C;function S(i,r,a){i[a+0]=r&255,r=r>>>8,i[a+1]=r&255}e.writeUInt16LE=S;function b(i,r){return i[r]*2**24+i[r+1]*2**16+i[r+2]*2**8+i[r+3]}e.readUInt32BE=b;function n(i,r,a){i[a+3]=r,r=r>>>8,i[a+2]=r,r=r>>>8,i[a+1]=r,r=r>>>8,i[a]=r}e.writeUInt32BE=n;function I(i,r){return i[r+0]<<0>>>0|i[r+1]<<8>>>0|i[r+2]<<16>>>0|i[r+3]<<24>>>0}e.readUInt32LE=I;function g(i,r,a){i[a+0]=r&255,r=r>>>8,i[a+1]=r&255,r=r>>>8,i[a+2]=r&255,r=r>>>8,i[a+3]=r&255}e.writeUInt32LE=g;function E(i,r){return i[r]}e.readUInt8=E;function h(i,r,a){i[a]=r}e.writeUInt8=h;function p(i){return R.consumeReadable(i,r=>k.concat(r))}e.readableToBuffer=p;function f(i){return R.toReadable(i)}e.bufferToReadable=f;function w(i){return R.consumeStream(i,r=>k.concat(r))}e.streamToBuffer=w;async function v(i){return i.ended?k.concat(i.buffer):k.concat([...i.buffer,await w(i.stream)])}e.bufferedStreamToBuffer=v;function y(i){return R.toStream(i,r=>k.concat(r))}e.bufferToStream=y;function c(i){return R.transform(i,{data:r=>typeof r=="string"?k.fromString(r):k.wrap(r)},r=>k.concat(r))}e.streamToBufferReadableStream=c;function o(i){return R.newWriteableStream(r=>k.concat(r),i)}e.newWriteableBufferStream=o;function t(i,r){return R.prefixedReadable(i,r,a=>k.concat(a))}e.prefixedBufferReadable=t;function s(i,r){return R.prefixedStream(i,r,a=>k.concat(a))}e.prefixedBufferStream=s}),define(te[25],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=R;const L=/{(\d+)}/g;function D(Y,...se){return se.length===0?Y:Y.replace(L,function(le,de){const me=parseInt(de,10);return isNaN(me)||me<0||me>=se.length?le:se[me]})}e.format=D;const T=/{([^}]+)}/g;function k(Y,se){return Y.replace(T,(le,de)=>se[de]??le)}e.format2=k;function C(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=C;function S(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function b(Y,se){let le=0;const de=se.charCodeAt(0);for(let me=Y.length-1;me>=0;me--)Y.charCodeAt(me)===de&&le++;return le}e.count=b;function n(Y,se,le="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${le}`}e.truncate=n;function I(Y,se=" "){const le=g(Y,se);return E(le,se)}e.trim=I;function g(Y,se){if(!Y||!se)return Y;const le=se.length;if(le===0||Y.length===0)return Y;let de=0;for(;Y.indexOf(se,de)===de;)de=de+le;return Y.substring(de)}e.ltrim=g;function E(Y,se){if(!Y||!se)return Y;const le=se.length,de=Y.length;if(le===0||de===0)return Y;let me=de,be=-1;for(;be=Y.lastIndexOf(se,me-1),!(be===-1||be+le!==me);){if(be===0)return"";me=be}return Y.substring(0,me)}e.rtrim=E;function h(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function p(Y){return Y.replace(/\*/g,"")}e.stripWildcards=p;function f(Y,se,le={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=S(Y)),le.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let de="";return le.global&&(de+="g"),le.matchCase||(de+="i"),le.multiline&&(de+="m"),le.unicode&&(de+="u"),new RegExp(Y,de)}e.createRegExp=f;function w(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function v(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=v;function y(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=y;function c(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=c;function o(Y){for(let se=0,le=Y.length;se<le;se++){const de=Y.charCodeAt(se);if(de!==32&&de!==9)return se}return-1}e.firstNonWhitespaceIndex=o;function t(Y,se=0,le=Y.length){for(let de=se;de<le;de++){const me=Y.charCodeAt(de);if(me!==32&&me!==9)return Y.substring(se,de)}return Y.substring(se,le)}e.getLeadingWhitespace=t;function s(Y,se=Y.length-1){for(let le=se;le>=0;le--){const de=Y.charCodeAt(le);if(de!==32&&de!==9)return le}return-1}e.lastNonWhitespaceIndex=s;function i(Y,se){return Y<se?-1:Y>se?1:0}e.compare=i;function r(Y,se,le=0,de=Y.length,me=0,be=se.length){for(;le<de&&me<be;le++,me++){let Ce=Y.charCodeAt(le),Re=se.charCodeAt(me);if(Ce<Re)return-1;if(Ce>Re)return 1}const pe=de-le,we=be-me;return pe<we?-1:pe>we?1:0}e.compareSubstring=r;function a(Y,se){return l(Y,se,0,Y.length,0,se.length)}e.compareIgnoreCase=a;function l(Y,se,le=0,de=Y.length,me=0,be=se.length){for(;le<de&&me<be;le++,me++){let Ce=Y.charCodeAt(le),Re=se.charCodeAt(me);if(Ce===Re)continue;const Le=Ce-Re;if(!(Le===32&&d(Re))&&!(Le===-32&&d(Ce)))return u(Ce)&&u(Re)?Le:r(Y.toLowerCase(),se.toLowerCase(),le,de,me,be)}const pe=de-le,we=be-me;return pe<we?-1:pe>we?1:0}e.compareSubstringIgnoreCase=l;function u(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=u;function d(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=d;function m(Y){return u(Y)||d(Y)}function A(Y,se){return Y.length===se.length&&_(Y,se)}e.equalsIgnoreCase=A;function _(Y,se,le=Y.length){for(let de=0;de<le;de++){const me=Y.charCodeAt(de),be=se.charCodeAt(de);if(me!==be){if(m(me)&&m(be)){const pe=Math.abs(me-be);if(pe!==0&&pe!==32)return!1}else if(String.fromCharCode(me).toLowerCase()!==String.fromCharCode(be).toLowerCase())return!1}}return!0}function O(Y,se){const le=se.length;return se.length>Y.length?!1:_(Y,se,le)}e.startsWithIgnoreCase=O;function N(Y,se){let le,de=Math.min(Y.length,se.length);for(le=0;le<de;le++)if(Y.charCodeAt(le)!==se.charCodeAt(le))return le;return de}e.commonPrefixLength=N;function P(Y,se){let le,de=Math.min(Y.length,se.length);const me=Y.length-1,be=se.length-1;for(le=0;le<de;le++)if(Y.charCodeAt(me-le)!==se.charCodeAt(be-le))return le;return de}e.commonSuffixLength=P;function M(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=M;function $(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=$;function U(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.computeCodePoint=U;function H(Y,se,le){const de=Y.charCodeAt(le);if(M(de)&&le+1<se){const me=Y.charCodeAt(le+1);if($(me))return U(de,me)}return de}e.getNextCodePoint=H;function W(Y,se){const le=Y.charCodeAt(se-1);if($(le)&&se>1){const de=Y.charCodeAt(se-2);if(M(de))return U(de,le)}return le}function x(Y,se){const le=ce.getInstance(),de=se,me=Y.length,be=H(Y,me,se);se+=be>=65536?2:1;let pe=le.getGraphemeBreakType(be);for(;se<me;){const we=H(Y,me,se),Ce=le.getGraphemeBreakType(we);if(ee(pe,Ce))break;se+=we>=65536?2:1,pe=Ce}return se-de}e.nextCharLength=x;function q(Y,se){const le=ce.getInstance(),de=se,me=W(Y,se);se-=me>=65536?2:1;let be=le.getGraphemeBreakType(me);for(;se>0;){const pe=W(Y,se),we=le.getGraphemeBreakType(pe);if(ee(we,be))break;se-=pe>=65536?2:1,be=we}return de-se}e.prevCharLength=q;function F(Y,se){const le=ce.getInstance(),de=Y.length,me=se,be=H(Y,de,se),pe=le.getGraphemeBreakType(be);se+=be>=65536?2:1;let we=pe;for(;se<de;){const Re=H(Y,de,se),Le=le.getGraphemeBreakType(Re);if(ee(we,Le))break;se+=Re>=65536?2:1,we=Le}const Ce=se;for(se=me,we=pe;se>0;){const Re=W(Y,se),Le=le.getGraphemeBreakType(Re);if(ee(Le,we))break;se-=Re>=65536?2:1,we=Le}return[se,Ce]}function K(Y,se){return se>0&&$(Y.charCodeAt(se))?F(Y,se-1):F(Y,se)}e.getCharContainingOffset=K;const j=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function z(Y){return j.test(Y)}e.containsRTL=z;const B=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function X(Y){return B.test(Y)}e.containsEmoji=X;const Z=/^[\t\n\r\x20-\x7E]*$/;function V(Y){return Z.test(Y)}e.isBasicASCII=V,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function G(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=G;function ie(Y){for(let se=0,le=Y.length;se<le;se++)if(re(Y.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=ie;function re(Y){return Y=+Y,Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=re;function ae(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129003||Y>=129280&&Y<=129535||Y>=129648&&Y<=129750}e.isEmojiImprecise=ae;function ue(Y,se){if(Y.length<se)return Y;const le=/\b/g;let de=0;for(;le.test(Y)&&!(Y.length-le.lastIndex<se);)de=le.lastIndex,le.lastIndex+=1;return Y.substring(de).replace(/^\s/,"")}e.lcut=ue;const fe=/\x1B\x5B[12]?K/g,ge=/\x1b\[\d+m/g,Ie=/\x1b\[0?m/g;function Pe(Y){return Y&&(Y=Y.replace(fe,""),Y=Y.replace(ge,""),Y=Y.replace(Ie,"")),Y}e.removeAnsiEscapeCodes=Pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function _e(Y){return Ee(Y)?Y.substr(1):Y}e.stripUTF8BOM=_e;function De(Y,se){if(!Y||!se||Y.length<se.length)return!1;const le=se.length,de=Y.toLowerCase();let me=0,be=-1;for(;me<le;){const pe=de.indexOf(se[me],be+1);if(pe<0)return!1;be=pe,me++}return!0}e.fuzzyContains=De;function ke(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=ke;function Fe(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Fe;function Ne(Y,se=1){if(se===0)return"";let le=-1;do le=Y.indexOf(`
`,le+1),se--;while(se>0&&le>=0);return le===-1?Y:(Y[le-1]==="\r"&&le--,Y.substr(0,le))}e.getNLines=Ne;function ze(Y){const se=90-65+1;return Y=Y%(2*se),Y<se?String.fromCharCode(97+Y):String.fromCharCode(65+Y-se)}e.singleLetterHash=ze;function xe(Y){return ce.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=xe;function ee(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}e.breakBetweenGraphemeBreakType=ee;var oe;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(oe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ce{constructor(){this._data=ye()}static getInstance(){return ce._INSTANCE||(ce._INSTANCE=new ce),ce._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const le=this._data,de=le.length/3;let me=1;for(;me<=de;)if(se<le[3*me])me=2*me;else if(se>le[3*me+1])me=2*me+1;else return le[3*me+2];return 0}}ce._INSTANCE=null;function ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(Y,se){if(Y===0)return 0;const le=Oe(Y,se);if(le!==void 0)return le;const de=W(se,Y);return Y-=Te(de),Y}e.getLeftDeleteOffset=Se;function Oe(Y,se){let le=W(se,Y);for(Y-=Te(le);Ue(le)||le===65039||le===8419;){if(Y===0)return;le=W(se,Y),Y-=Te(le)}if(!!ae(le)){if(Y>=0){const de=W(se,Y);de===8205&&(Y-=Te(de))}return Y}}function Te(Y){return Y>=65536?2:1}function Ue(Y){return 127995<=Y&&Y<=127999}var Ae;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Ae||(Ae={}))}),define(te[18],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function R(d){return Array.isArray(d)}e.isArray=R;function L(d){return typeof d=="string"}e.isString=L;function D(d){return Array.isArray(d)&&d.every(m=>L(m))}e.isStringArray=D;function T(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=T;function k(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=k;function C(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=C;function S(d){return d===!0||d===!1}e.isBoolean=S;function b(d){return typeof d=="undefined"}e.isUndefined=b;function n(d){return!I(d)}e.isDefined=n;function I(d){return b(d)||d===null}e.isUndefinedOrNull=I;function g(d,m){if(!d)throw new Error(m?`Unexpected type, expected '${m}'`:"Unexpected type")}e.assertType=g;function E(d){if(I(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=E;function h(...d){const m=[];for(let A=0;A<d.length;A++){const _=d[A];if(I(_))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);m.push(_)}return m}e.assertAllDefined=h;const p=Object.prototype.hasOwnProperty;function f(d){if(!T(d))return!1;for(let m in d)if(p.call(d,m))return!1;return!0}e.isEmptyObject=f;function w(d){return typeof d=="function"}e.isFunction=w;function v(...d){return d.length>0&&d.every(w)}e.areFunctions=v;function y(d,m){const A=Math.min(d.length,m.length);for(let _=0;_<A;_++)c(d[_],m[_])}e.validateConstraints=y;function c(d,m){if(L(m)){if(typeof d!==m)throw new Error(`argument does not match constraint: typeof ${m}`)}else if(w(m)){try{if(d instanceof m)return}catch{}if(!I(d)&&d.constructor===m||m.length===1&&m.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function o(d){let m=[],A=Object.getPrototypeOf(d);for(;Object.prototype!==A;)m=m.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return m}e.getAllPropertyNames=o;function t(d){const m=[];for(const A of o(d))typeof d[A]=="function"&&m.push(A);return m}e.getAllMethodNames=t;function s(d,m){const A=O=>function(){const N=Array.prototype.slice.call(arguments,0);return m(O,N)};let _={};for(const O of d)_[O]=A(O);return _}e.createProxyObject=s;function i(d){return d===null?void 0:d}e.withNullAsUndefined=i;function r(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=r;function a(d){return class{constructor(){return new Proxy({},{get(m,A){if(m[A])return m[A];throw new Error(`Not Implemented: ${d}->${String(A)}`)}})}}}e.NotImplementedProxy=a;function l(d,m="Unreachable"){throw new Error(m)}e.assertNever=l;function u(d){return!!d&&typeof d.then=="function"&&typeof d.catch=="function"}e.isPromise=u}),define(te[40],ne([0,1,9,4,25,18]),function(J,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(i){return i===47||i===92}e.isPathSeparator=k;function C(i){return i.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=C;function S(i){return i.indexOf("/")===-1&&(i=C(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=S;function b(i,r=R.posix.sep){if(!i)return"";const a=i.length,l=i.charCodeAt(0);if(k(l)){if(k(i.charCodeAt(1))&&!k(i.charCodeAt(2))){let d=3;const m=d;for(;d<a&&!k(i.charCodeAt(d));d++);if(m!==d&&!k(i.charCodeAt(d+1))){for(d+=1;d<a;d++)if(k(i.charCodeAt(d)))return i.slice(0,d+1).replace(/[\\/]/g,r)}}return r}else if(w(l)&&i.charCodeAt(1)===58)return k(i.charCodeAt(2))?i.slice(0,2)+r:i.slice(0,2);let u=i.indexOf("://");if(u!==-1){for(u+=3;u<a;u++)if(k(i.charCodeAt(u)))return i.slice(0,u+1)}return""}e.getRoot=b;function n(i){if(!L.isWindows||!i||i.length<5)return!1;let r=i.charCodeAt(0);if(r!==92||(r=i.charCodeAt(1),r!==92))return!1;let a=2;const l=a;for(;a<i.length&&(r=i.charCodeAt(a),r!==92);a++);return!(l===a||(r=i.charCodeAt(a+1),isNaN(r)||r===92))}e.isUNC=n;const I=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(i,r=L.isWindows){const a=r?I:g;return!(!i||i.length===0||/^\s+$/.test(i)||(a.lastIndex=0,a.test(i))||r&&E.test(i)||i==="."||i===".."||r&&i[i.length-1]==="."||r&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=h;function p(i,r,a){const l=i===r;return!a||l?l:!i||!r?!1:(0,D.equalsIgnoreCase)(i,r)}e.isEqual=p;function f(i,r,a,l=R.sep){if(i===r)return!0;if(!i||!r||r.length>i.length)return!1;if(a){if(!(0,D.startsWithIgnoreCase)(i,r))return!1;if(r.length===i.length)return!0;let d=r.length;return r.charAt(r.length-1)===l&&d--,i.charAt(d)===l}return r.charAt(r.length-1)!==l&&(r+=l),i.indexOf(r)===0}e.isEqualOrParent=f;function w(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=w;function v(i,r){return L.isWindows&&i.endsWith(":")&&(i+=R.sep),(0,R.isAbsolute)(i)||(i=(0,R.join)(r,i)),i=(0,R.normalize)(i),L.isWindows?(i=(0,D.rtrim)(i,R.sep),i.endsWith(":")&&(i+=R.sep)):(i=(0,D.rtrim)(i,R.sep),i||(i=R.sep)),i}e.sanitizeFilePath=v;function y(i){const r=(0,R.normalize)(i);return L.isWindows?i.length>3?!1:c(r)&&(i.length===2||r.charCodeAt(2)===92):r===R.posix.sep}e.isRootOrDriveLetter=y;function c(i){return L.isWindows?w(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function o(i){return c(i)?i[0]:void 0}e.getDriveLetter=o;function t(i,r,a){return r.length>i.length?-1:i===r?0:(a&&(i=i.toLowerCase(),r=r.toLowerCase()),i.indexOf(r))}e.indexOfPath=t;function s(i){const r=i.split(":");let a,l,u;if(r.forEach(d=>{const m=Number(d);(0,T.isNumber)(m)?l===void 0?l=m:u===void 0&&(u=m):a=a?[a,d].join(":"):d}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:l!==void 0?l:void 0,column:u!==void 0?u:l!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(te[26],ne([0,1,18]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const f=Array.isArray(p)?[]:{};return Object.keys(p).forEach(w=>{p[w]&&typeof p[w]=="object"?f[w]=L(p[w]):f[w]=p[w]}),f}e.deepClone=L;function D(p){if(!p||typeof p!="object")return p;const f=[p];for(;f.length>0;){const w=f.shift();Object.freeze(w);for(const v in w)if(T.call(w,v)){const y=w[v];typeof y=="object"&&!Object.isFrozen(y)&&f.push(y)}}return p}e.deepFreeze=D;const T=Object.prototype.hasOwnProperty;function k(p,f){return C(p,f,new Set)}e.cloneAndChange=k;function C(p,f,w){if((0,R.isUndefinedOrNull)(p))return p;const v=f(p);if(typeof v!="undefined")return v;if((0,R.isArray)(p)){const y=[];for(const c of p)y.push(C(c,f,w));return y}if((0,R.isObject)(p)){if(w.has(p))throw new Error("Cannot clone recursive data-structure");w.add(p);const y={};for(let c in p)T.call(p,c)&&(y[c]=C(p[c],f,w));return w.delete(p),y}return p}function S(p,f,w=!0){return(0,R.isObject)(p)?((0,R.isObject)(f)&&Object.keys(f).forEach(v=>{v in p?w&&((0,R.isObject)(p[v])&&(0,R.isObject)(f[v])?S(p[v],f[v],w):p[v]=f[v]):p[v]=f[v]}),p):f}e.mixin=S;function b(p,f){if(p===f)return!0;if(p==null||f===null||f===void 0||typeof p!=typeof f||typeof p!="object"||Array.isArray(p)!==Array.isArray(f))return!1;let w,v;if(Array.isArray(p)){if(p.length!==f.length)return!1;for(w=0;w<p.length;w++)if(!b(p[w],f[w]))return!1}else{const y=[];for(v in p)y.push(v);y.sort();const c=[];for(v in f)c.push(v);if(c.sort(),!b(y,c))return!1;for(w=0;w<y.length;w++)if(!b(p[y[w]],f[y[w]]))return!1}return!0}e.equals=b;function n(p){const f=new Set;return JSON.stringify(p,(w,v)=>{if((0,R.isObject)(v)||Array.isArray(v)){if(f.has(v))return"[Circular]";f.add(v)}return v})}e.safeStringify=n;function I(p,f,w){const v=f(p);return typeof v=="undefined"?w:v}e.getOrDefault=I;function g(p,f){const w=Object.create(null);return!p||!f||Object.keys(f).forEach(y=>{const c=p[y],o=f[y];b(c,o)||(w[y]=o)}),w}e.distinct=g;function E(p,f){const w=f.toLowerCase(),v=Object.keys(p).find(y=>y.toLowerCase()===w);return v?p[v]:p[f]}e.getCaseInsensitive=E;function h(p,f){const w=Object.create(null);for(const v of Object.keys(p))f(v,p[v])&&(w[v]=p[v]);return w}e.filter=h}),define(te[7],ne([0,1,9,4]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,T=/^\//,k=/^\/\//;function C(i,r){if(!i.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!D.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!T.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(i,r){return!i&&!r?"file":i}function b(i,r){switch(i){case"https":case"http":case"file":r?r[0]!==I&&(r=I+r):r=I;break}return r}const n="",I="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(r,a,l,u,d,m=!1){typeof r=="object"?(this.scheme=r.scheme||n,this.authority=r.authority||n,this.path=r.path||n,this.query=r.query||n,this.fragment=r.fragment||n):(this.scheme=S(r,m),this.authority=a||n,this.path=b(this.scheme,l||n),this.query=u||n,this.fragment=d||n,C(this,m))}static isUri(r){return r instanceof E?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return y(this,!1)}with(r){if(!r)return this;let{scheme:a,authority:l,path:u,query:d,fragment:m}=r;return a===void 0?a=this.scheme:a===null&&(a=n),l===void 0?l=this.authority:l===null&&(l=n),u===void 0?u=this.path:u===null&&(u=n),d===void 0?d=this.query:d===null&&(d=n),m===void 0?m=this.fragment:m===null&&(m=n),a===this.scheme&&l===this.authority&&u===this.path&&d===this.query&&m===this.fragment?this:new p(a,l,u,d,m)}static parse(r,a=!1){const l=g.exec(r);return l?new p(l[2]||n,s(l[4]||n),s(l[5]||n),s(l[7]||n),s(l[9]||n),a):new p(n,n,n,n,n)}static file(r){let a=n;if(L.isWindows&&(r=r.replace(/\\/g,I)),r[0]===I&&r[1]===I){const l=r.indexOf(I,2);l===-1?(a=r.substring(2),r=I):(a=r.substring(2,l),r=r.substring(l)||I)}return new p("file",a,r,n,n)}static from(r){const a=new p(r.scheme,r.authority,r.path,r.query,r.fragment);return C(a,!0),a}static joinPath(r,...a){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return L.isWindows&&r.scheme==="file"?l=E.file(R.win32.join(y(r,!0),...a)).path:l=R.posix.join(r.path,...a),r.with({path:l})}toString(r=!1){return c(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof E)return r;{const a=new p(r);return a._formatted=r.external,a._fsPath=r._sep===h?r.fsPath:null,a}}else return r}}e.URI=E;const h=L.isWindows?1:void 0;class p extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(r=!1){return r?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=h),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(i,r){let a,l=-1;for(let u=0;u<i.length;u++){const d=i.charCodeAt(u);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||r&&d===47)l!==-1&&(a+=encodeURIComponent(i.substring(l,u)),l=-1),a!==void 0&&(a+=i.charAt(u));else{a===void 0&&(a=i.substr(0,u));const m=f[d];m!==void 0?(l!==-1&&(a+=encodeURIComponent(i.substring(l,u)),l=-1),a+=m):l===-1&&(l=u)}}return l!==-1&&(a+=encodeURIComponent(i.substring(l))),a!==void 0?a:i}function v(i){let r;for(let a=0;a<i.length;a++){const l=i.charCodeAt(a);l===35||l===63?(r===void 0&&(r=i.substr(0,a)),r+=f[l]):r!==void 0&&(r+=i[a])}return r!==void 0?r:i}function y(i,r){let a;return i.authority&&i.path.length>1&&i.scheme==="file"?a=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?r?a=i.path.substr(1):a=i.path[1].toLowerCase()+i.path.substr(2):a=i.path,L.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=y;function c(i,r){const a=r?v:w;let l="",{scheme:u,authority:d,path:m,query:A,fragment:_}=i;if(u&&(l+=u,l+=":"),(d||u==="file")&&(l+=I,l+=I),d){let O=d.indexOf("@");if(O!==-1){const N=d.substr(0,O);d=d.substr(O+1),O=N.indexOf(":"),O===-1?l+=a(N,!1):(l+=a(N.substr(0,O),!1),l+=":",l+=a(N.substr(O+1),!1)),l+="@"}d=d.toLowerCase(),O=d.indexOf(":"),O===-1?l+=a(d,!1):(l+=a(d.substr(0,O),!1),l+=d.substr(O))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const O=m.charCodeAt(1);O>=65&&O<=90&&(m=`/${String.fromCharCode(O+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const O=m.charCodeAt(0);O>=65&&O<=90&&(m=`${String.fromCharCode(O+32)}:${m.substr(2)}`)}l+=a(m,!0)}return A&&(l+="?",l+=a(A,!1)),_&&(l+="#",l+=r?_:w(_,!1)),l}function o(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+o(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(t)?i.replace(t,r=>o(r)):i}}),define(te[103],ne([0,1,7]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(b){const n=b;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=L;function D(b){const n=[];let I;try{const g=JSON.parse(b.arguments),E=g[g.length-1];E&&E.__$stack&&(g.pop(),I=E.__$stack),n.push(...g)}catch(g){n.push("Unable to log remote console arguments",b.arguments)}return{args:n,stack:I}}e.parse=D;function T(b){if(typeof b!="string")return T(D(b).stack);const n=b;if(n){const I=k(n),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(g&&g.length===4)return{uri:R.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=T;function k(b){if(!b)return b;const n=b.indexOf(`
`);return n===-1?b:b.substring(0,n)}function C(b,n){const{args:I,stack:g}=D(b),E=typeof I[0]=="string"&&I.length===1;let h=k(g);h&&(h=`(${h.trim()})`);let p=[];if(typeof I[0]=="string"?h&&E?p=[`%c[${n}] %c${I[0]} %c${h}`,S("blue"),S(""),S("grey")]:p=[`%c[${n}] %c${I[0]}`,S("blue"),S(""),...I.slice(1)]:p=[`%c[${n}]%`,S("blue"),...I],h&&!E&&p.push(h),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,p)}e.log=C;function S(b){return`color: ${b}`}});var yt=this&&this.__classPrivateFieldSet||function(J,e,R,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(J,R):D?D.value=R:e.set(J,R),R},Be=this&&this.__classPrivateFieldGet||function(J,e,R,L){if(R==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return R==="m"?L:R==="a"?L.call(J):L?L.value:e.get(J)};define(te[41],ne([0,1,17,25,7]),function(J,e,R,L,D){"use strict";var T,k,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(s,i,r){let a=s.get(i);return a===void 0&&(a=r,s.set(i,a)),a}e.getOrSet=S;function b(s){const i=[];return s.forEach((r,a)=>{i.push(`${a} => ${r}`)}),`Map(${s.size}) {${i.join(", ")}}`}e.mapToString=b;function n(s){const i=[];return s.forEach(r=>{i.push(r)}),`Set(${s.size}) {${i.join(", ")}}`}e.setToString=n;class I{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return r-a}value(){return this._value[this._pos]}}e.StringIterator=I;class g{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,L.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=g;class E{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,L.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var h;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(h||(h={}));class p{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,L.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class f{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class w{constructor(i){this._iter=i}static forUris(i=()=>!1){return new w(new p(i))}static forPaths(){return new w(new E)}static forStrings(){return new w(new I)}static forConfigKeys(){return new w(new g)}clear(){this._root=void 0}set(i,r){const a=this._iter.reset(i);let l;for(this._root||(this._root=new f,this._root.segment=a.value()),l=this._root;;){const d=a.cmp(l.segment);if(d>0)l.left||(l.left=new f,l.left.segment=a.value()),l=l.left;else if(d<0)l.right||(l.right=new f,l.right.segment=a.value()),l=l.right;else if(a.hasNext())a.next(),l.mid||(l.mid=new f,l.mid.segment=a.value()),l=l.mid;else break}const u=l.value;return l.value=r,l.key=i,u}fill(i,r){const a=r.slice(0);(0,R.shuffle)(a);for(let l of a)this.set(l,i)}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let a=this._root;for(;a;){const l=r.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else break}return a}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const a=this._iter.reset(i),l=[];let u=this._root;for(;u;){const d=a.cmp(u.segment);if(d>0)l.push([1,u]),u=u.left;else if(d<0)l.push([-1,u]),u=u.right;else if(a.hasNext())a.next(),l.push([0,u]),u=u.mid;else{for(r?(u.left=void 0,u.mid=void 0,u.right=void 0):u.value=void 0;l.length>0&&u.isEmpty();){let[m,A]=l.pop();switch(m){case 1:A.left=void 0;break;case 0:A.mid=void 0;break;case-1:A.right=void 0;break}u=A}break}}}findSubstr(i){const r=this._iter.reset(i);let a=this._root,l;for(;a;){const u=r.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(r.hasNext())r.next(),l=a.value||l,a=a.mid;else break}return a&&a.value||l}findSuperstr(i){const r=this._iter.reset(i);let a=this._root;for(;a;){const l=r.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[r,a]of this)i(a,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){if(!i)return;const r=[i];for(;r.length>0;){const a=r.pop();a&&(a.value&&(yield[a.key,a.value]),a.left&&r.push(a.left),a.mid&&r.push(a.mid),a.right&&r.push(a.right))}}}e.TernarySearchTree=w;class v{constructor(i,r){this[T]="ResourceMap",i instanceof v?(this.map=new Map(i.map),this.toKey=r??v.defaultToKey):(this.map=new Map,this.toKey=i??v.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),r),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(let[a,l]of this.map)i(l,D.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield D.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[D.URI.parse(i[0]),i[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[D.URI.parse(i[0]),i[1]]}}e.ResourceMap=v,v.defaultToKey=s=>s.toString();var y;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(y=e.Touch||(e.Touch={}));class c{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const a=this._map.get(i);if(!!a)return r!==0&&this.touch(a,r),a.value}set(i,r,a=0){let l=this._map.get(i);if(l)l.value=r,a!==0&&this.touch(l,a);else{switch(l={key:i,value:r,next:void 0,previous:void 0},a){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(i,l),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const a=this._state;let l=this._head;for(;l;){if(r?i.bind(r)(l.value,l.key,this):i(l.value,l.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const i=this,r=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const u={value:a.key,done:!1};return a=a.next,u}else return{value:void 0,done:!0}}};return l}values(){const i=this,r=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const u={value:a.value,done:!1};return a=a.next,u}else return{value:void 0,done:!0}}};return l}entries(){const i=this,r=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const u={value:[a.key,a.value],done:!1};return a=a.next,u}else return{value:void 0,done:!0}}};return l}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,a=this.size;for(;r&&a>i;)this._map.delete(r.key),r=r.next,a--;this._head=r,this._size=a,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,a=i.previous;if(!r||!a)throw new Error("Invalid list");r.previous=a,a.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const a=i.next,l=i.previous;i===this._tail?(l.next=void 0,this._tail=l):(a.previous=l,l.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const a=i.next,l=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=l,l.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,a)=>{i.push([a,r])}),i}fromJSON(i){this.clear();for(const[r,a]of i)this.set(r,a)}}e.LinkedMap=c;class o extends c{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class t{constructor(i){C.set(this,void 0),yt(this,C,i,"f")}get size(){return Be(this,C,"f").size}forEach(i,r){Be(this,C,"f").forEach(i,r)}get(i){return Be(this,C,"f").get(i)}has(i){return Be(this,C,"f").has(i)}entries(){return Be(this,C,"f").entries()}keys(){return Be(this,C,"f").keys()}values(){return Be(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Be(this,C,"f").entries()}}e.ReadonlyMapView=t}),define(te[104],ne([0,1,22,25,7]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(n){return JSON.stringify(n,S)}e.stringify=T;function k(n){let I=JSON.parse(n);return I=b(I),I}e.parse=k;var C;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function S(n,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function b(n,I=0){if(!n||I>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return D.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof R.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let g=0;g<n.length;++g)n[g]=b(n[g],I+1);else for(const g in n)Object.hasOwnProperty.call(n,g)&&(n[g]=b(n[g],I+1))}return n}e.revive=b}),define(te[15],ne([0,1,4,7]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,b,n){this._hosts[S]=b,this._ports[S]=n}setConnectionToken(S,b){this._connectionTokens[S]=b}rewrite(S){if(this._delegate)return this._delegate(S);const b=S.authority;let n=this._hosts[b];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const I=this._ports[b],g=this._connectionTokens[b];let E=`path=${encodeURIComponent(S.path)}`;return typeof g=="string"&&(E+=`&tkn=${encodeURIComponent(g)}`),L.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${n}:${I}`,path:"/vscode-remote-resource",query:E})}}e.RemoteAuthorities=new T;class k{asBrowserUri(S,b){const n=this.toUri(S,b);return n.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===D.file&&(R.isNative||typeof R.globals.importScripts=="function"&&R.globals.origin===`${D.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?n.with({scheme:D.vscodeFileResource,authority:n.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(S,b){const n=this.toUri(S,b);return n.scheme===D.vscodeFileResource?n.with({scheme:D.file,authority:n.authority!==k.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(S,b){return L.URI.isUri(S)?S:L.URI.parse(b.toUrl(S))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(te[68],ne([0,1,41]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new R.LRUCache(1e4);function D(b){return S(b,"NFC",L)}e.normalizeNFC=D;const T=new R.LRUCache(1e4);function k(b){return S(b,"NFD",T)}e.normalizeNFD=k;const C=/[^\u0000-\u0080]/;function S(b,n,I){if(!b)return b;const g=I.get(b);if(g)return g;let E;return C.test(b)?E=b.normalize(n):E=b,I.set(b,E),E}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(n){return k(n).replace(b,"")}}()}),define(te[16],ne([0,1,40,15,9,4,25,7]),function(J,e,R,L,D,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(E){return(0,C.uriToFsPath)(E,!0)}e.originalFSPath=S;class b{constructor(h){this._ignorePathCasing=h}compare(h,p,f=!1){return h===p?0:(0,k.compare)(this.getComparisonKey(h,f),this.getComparisonKey(p,f))}isEqual(h,p,f=!1){return h===p?!0:!h||!p?!1:this.getComparisonKey(h,f)===this.getComparisonKey(p,f)}getComparisonKey(h,p=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,p,f=!1){if(h.scheme===p.scheme){if(h.scheme===L.Schemas.file)return R.isEqualOrParent(S(h),S(p),this._ignorePathCasing(h))&&h.query===p.query&&(f||h.fragment===p.fragment);if((0,e.isEqualAuthority)(h.authority,p.authority))return R.isEqualOrParent(h.path,p.path,this._ignorePathCasing(h),"/")&&h.query===p.query&&(f||h.fragment===p.fragment)}return!1}joinPath(h,...p){return C.URI.joinPath(h,...p)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let p;return h.scheme===L.Schemas.file?p=C.URI.file(D.dirname(S(h))).path:(p=D.posix.dirname(h.path),h.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),p="/")),h.with({path:p})}normalizePath(h){if(!h.path.length)return h;let p;return h.scheme===L.Schemas.file?p=C.URI.file(D.normalize(S(h))).path:p=D.posix.normalize(h.path),h.with({path:p})}relativePath(h,p){if(h.scheme!==p.scheme||!(0,e.isEqualAuthority)(h.authority,p.authority))return;if(h.scheme===L.Schemas.file){const v=D.relative(S(h),S(p));return T.isWindows?R.toSlashes(v):v}let f=h.path||"/",w=p.path||"/";if(this._ignorePathCasing(h)){let v=0;for(const y=Math.min(f.length,w.length);v<y&&!(f.charCodeAt(v)!==w.charCodeAt(v)&&f.charAt(v).toLowerCase()!==w.charAt(v).toLowerCase());v++);f=w.substr(0,v)+f.substr(v)}return D.posix.relative(f,w)}resolvePath(h,p){if(h.scheme===L.Schemas.file){const f=C.URI.file(D.resolve(S(h),p));return h.with({authority:f.authority,path:f.path})}return p=R.toPosixPath(p),h.with({path:D.posix.resolve(h.path,p)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,p){return h===p||(0,k.equalsIgnoreCase)(h,p)}hasTrailingPathSeparator(h,p=D.sep){if(h.scheme===L.Schemas.file){const f=S(h);return f.length>R.getRoot(f).length&&f[f.length-1]===p}else{const f=h.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,p=D.sep){return(0,e.hasTrailingPathSeparator)(h,p)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,p=D.sep){let f=!1;if(h.scheme===L.Schemas.file){const w=S(h);f=w!==void 0&&w.length===R.getRoot(w).length&&w[w.length-1]===p}else{p="/";const w=h.path;f=w.length===1&&w.charCodeAt(w.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(h,p)?h.with({path:h.path+"/"}):h}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(E=>E.scheme===L.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new b(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(E,h){const p=[];for(let f=0;f<E.length;f++){const w=h(E[f]);E.some((v,y)=>y===f?!1:(0,e.isEqualOrParent)(w,h(v)))||p.push(E[f])}return p}e.distinctParents=n;var I;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function h(p){const f=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(y=>{const[c,o]=y.split(":");c&&o&&f.set(c,o)});const v=p.path.substring(0,p.path.indexOf(";"));return v&&f.set(E.META_DATA_MIME,v),f}E.parseMetaData=h})(I=e.DataUri||(e.DataUri={}));function g(E,h,p){if(h){let f=E.path;return f&&f[0]!==D.posix.sep&&(f=D.posix.sep+f),E.with({scheme:p,authority:h,path:f})}return E.with({scheme:p})}e.toLocalResource=g}),define(te[6],ne([0,1,27,8,3,2,16]),function(J,e,R,L,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(W){return!!W&&typeof W.then=="function"}e.isThenable=C;function S(W){const x=new R.CancellationTokenSource,q=W(x.token),F=new Promise((K,j)=>{const z=x.token.onCancellationRequested(()=>{z.dispose(),x.dispose(),j((0,L.canceled)())});Promise.resolve(q).then(B=>{z.dispose(),x.dispose(),K(B)},B=>{z.dispose(),x.dispose(),j(B)})});return new class{cancel(){x.cancel()}then(K,j){return F.then(K,j)}catch(K){return this.then(void 0,K)}finally(K){return F.finally(K)}}}e.createCancelablePromise=S;function b(W,x,q){return Promise.race([W,new Promise(F=>x.onCancellationRequested(()=>F(q)))])}e.raceCancellation=b;async function n(W){let x=-1;const q=W.map((K,j)=>K.then(z=>(x=j,z))),F=await Promise.race(q);return W.forEach((K,j)=>{j!==x&&K.cancel()}),F}e.raceCancellablePromises=n;function I(W,x,q){let F;const K=setTimeout(()=>{F?.(void 0),q?.()},x);return Promise.race([W.finally(()=>clearTimeout(K)),new Promise(j=>F=j)])}e.raceTimeout=I;function g(W){return new Promise((x,q)=>{const F=W();C(F)?F.then(x,q):x(F)})}e.asPromise=g;class E{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(x){if(this.activePromise){if(this.queuedPromiseFactory=x,!this.queuedPromise){const q=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(q,q).then(F)})}return new Promise((q,F)=>{this.queuedPromise.then(q,F)})}return this.activePromise=x(),new Promise((q,F)=>{this.activePromise.then(K=>{this.activePromise=null,q(K)},K=>{this.activePromise=null,F(K)})})}}e.Throttler=E;class h{constructor(){this.current=Promise.resolve(null)}queue(x){return this.current=this.current.then(()=>x(),()=>x())}}e.Sequencer=h;class p{constructor(){this.promiseMap=new Map}queue(x,q){const K=(this.promiseMap.get(x)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get(x)===K&&this.promiseMap.delete(x)});return this.promiseMap.set(x,K),K}}e.SequencerByKey=p;class f{constructor(x){this.defaultDelay=x,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(x,q=this.defaultDelay){return this.task=x,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,K)=>{this.doResolve=F,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=f;class w{constructor(x){this.delayer=new f(x),this.throttler=new E}trigger(x,q){return this.delayer.trigger(()=>this.throttler.queue(x),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class v{constructor(){this._isOpen=!1,this._promise=new Promise((x,q)=>{this._completePromise=x})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=v;class y extends v{constructor(x){super();this._timeout=setTimeout(()=>this.open(),x)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=y;function c(W,x){return x?new Promise((q,F)=>{const K=setTimeout(()=>{j.dispose(),q()},W),j=x.onCancellationRequested(()=>{clearTimeout(K),j.dispose(),F((0,L.canceled)())})}):S(q=>c(W,q))}e.timeout=c;function o(W,x=0){const q=setTimeout(W,x);return(0,T.toDisposable)(()=>clearTimeout(q))}e.disposableTimeout=o;function t(W){const x=[];let q=0;const F=W.length;function K(){return q<F?W[q++]():null}function j(z){z!=null&&x.push(z);const B=K();return B?B.then(j):Promise.resolve(x)}return Promise.resolve(null).then(j)}e.sequence=t;function s(W,x=F=>!!F,q=null){let F=0;const K=W.length,j=()=>{if(F>=K)return Promise.resolve(q);const z=W[F++];return Promise.resolve(z()).then(X=>x(X)?Promise.resolve(X):j())};return j()}e.first=s;function i(W,x=F=>!!F,q=null){if(W.length===0)return Promise.resolve(q);let F=W.length;const K=()=>{F=-1;for(const j of W)j.cancel?.()};return new Promise((j,z)=>{for(const B of W)B.then(X=>{--F>=0&&x(X)?(K(),j(X)):F===0&&j(q)}).catch(X=>{--F>=0&&(K(),z(X))})})}e.firstParallel=i;class r{constructor(x){this._size=0,this.maxDegreeOfParalellism=x,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(x){return this._size++,new Promise((q,F)=>{this.outstandingPromises.push({factory:x,c:q,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const x=this.outstandingPromises.shift();this.runningPromises++;const q=x.factory();q.then(x.c,x.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class a extends r{constructor(){super(1)}}e.Queue=a;class l{constructor(){this.queues=new Map}queueFor(x,q=k.extUri){const F=q.getComparisonKey(x);let K=this.queues.get(F);return K||(K=new a,D.Event.once(K.onFinished)(()=>{K?.dispose(),this.queues.delete(F)}),this.queues.set(F,K)),K}dispose(){this.queues.forEach(x=>x.dispose()),this.queues.clear()}}e.ResourceQueue=l;class u{constructor(x,q){this._token=-1,typeof x=="function"&&typeof q=="number"&&this.setIfNotSet(x,q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(x,q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,x()},q)}setIfNotSet(x,q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,x()},q))}}e.TimeoutTimer=u;class d{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(x,q){this.cancel(),this._token=setInterval(()=>{x()},q)}}e.IntervalTimer=d;class m{constructor(x,q){this.timeoutToken=-1,this.runner=x,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(x=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,x)}get delay(){return this.timeout}set delay(x){this.timeout=x}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=m;class A{constructor(x,q){q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.runner=x,this.timeout=q,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(x=this.timeout){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(x/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class _ extends m{constructor(x,q){super(x,q);this.units=[]}work(x){this.units.push(x),this.isScheduled()||this.schedule()}doRun(){const x=this.units;this.units=[],this.runner&&this.runner(x)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_;class O extends T.Disposable{constructor(x,q,F,K){super();this.maxWorkChunkSize=x,this.maxPendingWork=q,this.throttleDelay=F,this.handler=K,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(x){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+x.length>this.maxPendingWork)return!1}else if(this.pending+x.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...x),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new m(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{const x=setTimeout(()=>{const F=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0,clearTimeout(x))}}}:e.runWhenIdle=(W,x)=>{const q=requestIdleCallback(W,typeof x=="number"?{timeout:x}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(q))}}}}();class N{constructor(x){this._didRun=!1,this._executor=()=>{try{this._value=x()}catch(q){this._error=q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=N;async function P(W,x,q){let F;for(let K=0;K<q;K++)try{return await W()}catch(j){F=j,await c(x)}throw F}e.retry=P;class M{hasPending(x){return this._pending?typeof x=="number"?this._pending.taskId===x:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(x,q,F){return this._pending={taskId:x,cancel:()=>F?.(),promise:q},q.then(()=>this.donePending(x),()=>this.donePending(x)),q}donePending(x){this._pending&&x===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const x=this._next;this._next=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}setNext(x){if(this._next)this._next.run=x;else{let q,F;const K=new Promise((j,z)=>{q=j,F=z});this._next={run:x,promise:K,promiseResolve:q,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=M;class ${constructor(x){this.interval=x,this.lastIncrementTime=0,this.value=0}increment(){const x=Date.now();return x-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=x,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((x,q)=>{this.completeCallback=x,this.errorCallback=q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(x){return new Promise(q=>{this.completeCallback(x),this.resolved=!0,q()})}error(x){return new Promise(q=>{this.errorCallback(x),this.rejected=!0,q()})}cancel(){new Promise(x=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,x()})}}e.DeferredPromise=U;var H;(function(W){async function x(q){let F;const K=await Promise.all(q.map(j=>j.then(z=>z,z=>{F||(F=z)})));if(typeof F!="undefined")throw F;return K}W.settled=x})(H=e.Promises||(e.Promises={}))}),define(te[69],ne([0,1,6,40,41,9,25]),function(J,e,R,L,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const S="**",b="/",n="[/\\\\]",I="[^/\\\\]",g=/\//g;function E(F){switch(F){case 0:return"";case 1:return`${I}*?`;default:return`(?:${n}|${I}+${n}|${n}${I}+)*?`}}function h(F,K){if(!F)return[];const j=[];let z=!1,B=!1,X="";for(const Z of F){switch(Z){case K:if(!z&&!B){j.push(X),X="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":B=!0;break;case"]":B=!1;break}X+=Z}return X&&j.push(X),j}e.splitGlobAware=h;function p(F){if(!F)return"";let K="";const j=h(F,b);if(j.every(z=>z===S))K=".*";else{let z=!1;j.forEach((B,X)=>{if(B===S){z||(K+=E(2),z=!0);return}let Z=!1,V="",G=!1,ie="";for(const re of B){if(re!=="}"&&Z){V+=re;continue}if(G&&(re!=="]"||!ie)){let ae;re==="-"?ae=re:(re==="^"||re==="!")&&!ie?ae="^":re===b?ae="":ae=k.escapeRegExpCharacters(re),ie+=ae;continue}switch(re){case"{":Z=!0;continue;case"[":G=!0;continue;case"}":K+=`(?:${h(V,",").map(fe=>p(fe)).join("|")})`,Z=!1,V="";break;case"]":K+="["+ie+"]",G=!1,ie="";break;case"?":K+=I;continue;case"*":K+=E(1);continue;default:K+=k.escapeRegExpCharacters(re)}}X<j.length-1&&(j[X+1]!==S||X+2<j.length)&&(K+=n),z=!1})}return K}const f=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,y=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new D.LRUCache(1e4),s=function(){return!1},i=function(){return null};function r(F,K){if(!F)return i;let j;typeof F!="string"?j=F.pattern:j=F,j=j.trim();const z=`${j}_${!!K.trimForExclusions}`;let B=t.get(z);if(B)return a(B,F);let X;if(f.test(j)){const Z=j.substr(4);B=function(V,G){return typeof V=="string"&&V.endsWith(Z)?j:null}}else(X=w.exec(l(j,K)))?B=u(X[1],j):(K.trimForExclusions?y:v).test(j)?B=d(j,K):(X=c.exec(l(j,K)))?B=m(X[1].substr(1),j,!0):(X=o.exec(l(j,K)))?B=m(X[1],j,!1):B=A(j);return t.set(z,B),a(B,F)}function a(F,K){return typeof K=="string"?F:function(j,z){return L.isEqualOrParent(j,K.base)?F(T.relative(K.base,j),z):null}}function l(F,K){return K.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function u(F,K){const j=`/${F}`,z=`\\${F}`,B=function(Z,V){return typeof Z!="string"?null:V?V===F?K:null:Z===F||Z.endsWith(j)||Z.endsWith(z)?K:null},X=[F];return B.basenames=X,B.patterns=[K],B.allBasenames=X,B}function d(F,K){const j=q(F.slice(1,-1).split(",").map(V=>r(V,K)).filter(V=>V!==i),F),z=j.length;if(!z)return i;if(z===1)return j[0];const B=function(V,G){for(let ie=0,re=j.length;ie<re;ie++)if(j[ie](V,G))return F;return null},X=j.find(V=>!!V.allBasenames);X&&(B.allBasenames=X.allBasenames);const Z=j.reduce((V,G)=>G.allPaths?V.concat(G.allPaths):V,[]);return Z.length&&(B.allPaths=Z),B}function m(F,K,j){const z=T.sep===T.posix.sep,B=z?F:F.replace(g,T.sep),X=T.sep+B,Z=T.posix.sep+F,V=j?function(G,ie){return typeof G=="string"&&(G===B||G.endsWith(X)||!z&&(G===F||G.endsWith(Z)))?K:null}:function(G,ie){return typeof G=="string"&&(G===B||!z&&G===F)?K:null};return V.allPaths=[(j?"*/":"./")+F],V}function A(F){try{const K=new RegExp(`^${p(F)}$`);return function(j){return K.lastIndex=0,typeof j=="string"&&K.test(j)?F:null}}catch(K){return i}}function _(F,K,j){return!F||typeof K!="string"?!1:O(F)(K,void 0,j)}e.match=_;function O(F,K={}){if(!F)return s;if(typeof F=="string"||$(F)){const j=r(F,K);if(j===i)return s;const z=function(B,X){return!!j(B,X)};return j.allBasenames&&(z.allBasenames=j.allBasenames),j.allPaths&&(z.allPaths=j.allPaths),z}return W(F,K)}e.parse=O;function N(F){if(!F)return;let K;return j=>(K||(K=(F()||Promise.resolve([])).then(z=>z?M(z):{})),K.then(z=>!!z[j]))}e.hasSiblingPromiseFn=N;function P(F){if(!F)return;let K;return j=>{if(!K){const z=F();K=z?M(z):{}}return!!K[j]}}e.hasSiblingFn=P;function M(F){const K={};for(const j of F)K[j]=!0;return K}function $(F){const K=F;return K&&typeof K.base=="string"&&typeof K.pattern=="string"}e.isRelativePattern=$;function U(F){return F.allBasenames||[]}e.getBasenameTerms=U;function H(F){return F.allPaths||[]}e.getPathTerms=H;function W(F,K){const j=q(Object.getOwnPropertyNames(F).map(V=>x(V,F[V],K)).filter(V=>V!==i)),z=j.length;if(!z)return i;if(!j.some(V=>!!V.requiresSiblings)){if(z===1)return j[0];const V=function(re,ae){for(let ue=0,fe=j.length;ue<fe;ue++){const ge=j[ue](re,ae);if(ge)return ge}return null},G=j.find(re=>!!re.allBasenames);G&&(V.allBasenames=G.allBasenames);const ie=j.reduce((re,ae)=>ae.allPaths?re.concat(ae.allPaths):re,[]);return ie.length&&(V.allPaths=ie),V}const B=function(V,G,ie){let re;for(let ae=0,ue=j.length;ae<ue;ae++){const fe=j[ae];fe.requiresSiblings&&ie&&(G||(G=T.basename(V)),re||(re=G.substr(0,G.length-T.extname(V).length)));const ge=fe(V,G,re,ie);if(ge)return ge}return null},X=j.find(V=>!!V.allBasenames);X&&(B.allBasenames=X.allBasenames);const Z=j.reduce((V,G)=>G.allPaths?V.concat(G.allPaths):V,[]);return Z.length&&(B.allPaths=Z),B}function x(F,K,j){if(K===!1)return i;const z=r(F,j);if(z===i)return i;if(typeof K=="boolean")return z;if(K){const B=K.when;if(typeof B=="string"){const X=(Z,V,G,ie)=>{if(!ie||!z(Z,V))return null;const re=B.replace("$(basename)",G),ae=ie(re);return(0,R.isThenable)(ae)?ae.then(ue=>ue?F:null):ae?F:null};return X.requiresSiblings=!0,X}}return z}function q(F,K){const j=F.filter(V=>!!V.basenames);if(j.length<2)return F;const z=j.reduce((V,G)=>{const ie=G.basenames;return ie?V.concat(ie):V},[]);let B;if(K){B=[];for(let V=0,G=z.length;V<G;V++)B.push(K)}else B=j.reduce((V,G)=>{const ie=G.patterns;return ie?V.concat(ie):V},[]);const X=function(V,G){if(typeof V!="string")return null;if(!G){let re;for(re=V.length;re>0;re--){const ae=V.charCodeAt(re-1);if(ae===47||ae===92)break}G=V.substr(re)}const ie=z.indexOf(G);return ie!==-1?B[ie]:null};X.basenames=z,X.patterns=B,X.allBasenames=z;const Z=F.filter(V=>!V.basenames);return Z.push(X),Z}}),define(te[105],ne([0,1,69,15,9,16,25]),function(J,e,R,L,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown",r.latex="text/latex"})(C=e.Mimes||(e.Mimes={}));let S=[],b=[],n=[];function I(r,a=!1){const l=g(r);S.push(l),l.userConfigured?n.push(l):b.push(l),a&&!l.userConfigured&&S.forEach(u=>{u.mime===l.mime||u.userConfigured||(l.extension&&u.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&u.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&u.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&u.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=I;function g(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?(0,R.parse)(r.filepattern.toLowerCase()):void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(D.posix.sep)>=0:!1}}function E(r){r?(S=S.filter(a=>!a.userConfigured),n=[]):(S=[],b=[],n=[])}e.clearTextMimes=E;function h(r,a){let l;if(r)switch(r.scheme){case L.Schemas.file:l=r.fsPath;break;case L.Schemas.data:l=T.DataUri.parseMetaData(r).get(T.DataUri.META_DATA_LABEL);break;default:l=r.path}if(!l)return[C.unknown];l=l.toLowerCase();const u=(0,D.basename)(l),d=p(l,u,n);if(d)return[d,C.text];const m=p(l,u,b);if(m)return[m,C.text];if(a){const A=f(a);if(A)return[A,C.text]}return[C.unknown]}e.guessMimeTypes=h;function p(r,a,l){let u=null,d=null,m=null;for(let A=l.length-1;A>=0;A--){const _=l[A];if(a===_.filenameLowercase){u=_;break}if(_.filepattern&&(!d||_.filepattern.length>d.filepattern.length)){const O=_.filepatternOnPath?r:a;_.filepatternLowercase?.(O)&&(d=_)}_.extension&&(!m||_.extension.length>m.extension.length)&&a.endsWith(_.extensionLowercase)&&(m=_)}return u?u.mime:d?d.mime:m?m.mime:null}function f(r){if((0,k.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let a=S.length-1;a>=0;a--){const l=S[a];if(!l.firstline)continue;const u=r.match(l.firstline);if(u&&u.length>0)return l.mime}return null}function w(r){return r?typeof r=="string"?r===C.binary||r===C.text||r===C.unknown:r.length===1&&w(r[0]):!0}e.isUnspecific=w;const v={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},y={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(r){const a=(0,D.extname)(r),l=v[a.toLowerCase()];return l!==void 0?l:o(r)}e.getMediaOrTextMime=c;function o(r){const a=(0,D.extname)(r);return y[a.toLowerCase()]}e.getMediaMime=o;function t(r){for(const a in y)if(y[a]===r)return a}e.getExtensionForMimeType=t;const s=/^(.+)\/(.+?)(;.+)?$/;function i(r,a){const l=s.exec(r);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:a?void 0:r}e.normalizeMimeType=i}),define(te[106],ne([0,1,7]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class D{constructor(I){this._uriTransformer=I}transformIncoming(I){const g=this._uriTransformer.transformIncoming(I);return g===I?I:L(R.URI.from(g))}transformOutgoing(I){const g=this._uriTransformer.transformOutgoing(I);return g===I?I:L(R.URI.from(g))}transformOutgoingURI(I){const g=this._uriTransformer.transformOutgoing(I);return g===I?I:R.URI.from(g)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function T(n,I,g){if(!n||g>200)return null;if(typeof n=="object"){if(n instanceof R.URI)return I.transformOutgoing(n);for(let E in n)if(Object.hasOwnProperty.call(n,E)){const h=T(n[E],I,g+1);h!==null&&(n[E]=h)}}return null}function k(n,I){const g=T(n,I,0);return g===null?n:g}e.transformOutgoingURIs=k;function C(n,I,g,E){if(!n||E>200)return null;if(typeof n=="object"){if(n.$mid===1)return g?R.URI.revive(I.transformIncoming(n)):I.transformIncoming(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const p=C(n[h],I,g,E+1);p!==null&&(n[h]=p)}}return null}function S(n,I){const g=C(n,I,!1,0);return g===null?n:g}e.transformIncomingURIs=S;function b(n,I){const g=C(n,I,!0,0);return g===null?n:g}e.transformAndReviveIncomingURIs=b}),define(te[30],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(S){return R.test(S)}e.isUUID=L;const D=new Uint8Array(16),T=[];for(let S=0;S<256;S++)T.push(S.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(S){for(let b=0;b<S.length;b++)S[b]=Math.floor(Math.random()*256);return S};function C(){k(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let S=0,b="";return b+=T[D[S++]],b+=T[D[S++]],b+=T[D[S++]],b+=T[D[S++]],b+="-",b+=T[D[S++]],b+=T[D[S++]],b+="-",b+=T[D[S++]],b+=T[D[S++]],b+="-",b+=T[D[S++]],b+=T[D[S++]],b+="-",b+=T[D[S++]],b+=T[D[S++]],b+=T[D[S++]],b+=T[D[S++]],b+=T[D[S++]],b+=T[D[S++]],b}e.generateUuid=C}),define(te[70],ne([0,1,107]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(T="utf8"){this.stringDecoder=new R.StringDecoder(T),this.remaining=null}write(T){const k=[],C=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(C.length<1)return k;let S=0,b,n=S;for(;n<C.length;)if(b=C.charCodeAt(n),b===13||b===10){if(k.push(C.substring(S,n)),n++,n<C.length){const I=b;b=C.charCodeAt(n),(I===13&&b===10||I===10&&b===13)&&n++}S=n}else n++;return this.remaining=S<C.length?C.substr(S):null,k}end(){return this.remaining}}e.LineDecoder=L}),define(te[108],ne([0,1,32]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(C){const S=C.replace(/\-/g,":").toLowerCase();return!L.has(S)}function T(){return new Promise(async(C,S)=>{const b=setTimeout(()=>S("Unable to retrieve mac address (timeout after 10s)"),1e4);try{C(await k())}catch(n){S(n)}finally{clearTimeout(b)}})}e.getMac=T;function k(){return new Promise((C,S)=>{try{const b=(0,R.networkInterfaces)();for(let n in b){const I=b[n];if(I){for(const{mac:g}of I)if(D(g))return C(g)}}S("Unable to retrieve mac address (unexpected format)")}catch(b){S(b)}})}}),define(te[109],ne([0,1,32,8,41,30,108]),function(J,e,R,L,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,I=0;const g=(0,R.networkInterfaces)();for(let E in g){const h=g[E];if(h)for(const{mac:p,internal:f}of h)f||(I+=1,this._isVirtualMachineMacAddress(p.toUpperCase())&&(n+=1))}this._value=I>0?n/I:0}return this._value}};let C;async function S(){return C||(C=(async()=>await b()||T.generateUuid())()),C}e.getMachineId=S;async function b(){try{const n=await new Promise((g,E)=>{J(["crypto"],g,E)}),I=await(0,k.getMac)();return n.createHash("sha256").update(I,"utf8").digest("hex")}catch(n){L.onUnexpectedError(n);return}}}),define(te[19],ne([0,1,51,32,236,6,40,68,9,4,16,7,30]),function(J,e,R,L,D,T,k,C,S,b,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function h(U,H=E.UNLINK){if((0,k.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return H===E.UNLINK?f(U):p(U)}async function p(U){try{const H=(0,S.join)((0,L.tmpdir)(),(0,g.generateUuid)());try{await e.Promises.rename(U,H)}catch(W){return f(U)}f(H).catch(W=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function f(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function w(U){if((0,k.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");R.rmdirSync(U,{recursive:!0})}e.rimrafSync=w;async function v(U,H){return o(await(H?y(U):(0,D.promisify)(R.readdir)(U)))}async function y(U){try{return await(0,D.promisify)(R.readdir)(U,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const H=[],W=await v(U);for(const x of W){let q=!1,F=!1,K=!1;try{const j=await e.Promises.lstat((0,S.join)(U,x));q=j.isFile(),F=j.isDirectory(),K=j.isSymbolicLink()}catch(j){console.warn("[node.js fs] unexpected error from lstat after readdir: ",j)}H.push({name:x,isFile:()=>q,isDirectory:()=>F,isSymbolicLink:()=>K})}return H}function c(U){return o(R.readdirSync(U))}e.readdirSync=c;function o(U){return U.map(H=>typeof H=="string"?b.isMacintosh?(0,C.normalizeNFC)(H):H:(H.name=b.isMacintosh?(0,C.normalizeNFC)(H.name):H.name,H))}async function t(U){const H=await v(U),W=[];for(const x of H)await i.existsDirectory((0,S.join)(U,x))&&W.push(x);return W}function s(U,H=1e3){return new Promise(W=>{let x=!1;const q=setInterval(()=>{x||(x=!0,R.access(U,F=>{x=!1,F&&(clearInterval(q),W(void 0))}))},H)})}e.whenDeleted=s;var i;(function(U){async function H(q){let F;try{if(F=await e.Promises.lstat(q),!F.isSymbolicLink())return{stat:F}}catch(K){}try{return{stat:await e.Promises.stat(q),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(b.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(j){if(j.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw j}throw K}}U.stat=H;async function W(q){try{const{stat:F,symbolicLink:K}=await U.stat(q);return F.isFile()&&K?.dangling!==!0}catch(F){}return!1}U.existsFile=W;async function x(q){try{const{stat:F,symbolicLink:K}=await U.stat(q);return F.isDirectory()&&K?.dangling!==!0}catch(F){}return!1}U.existsDirectory=x})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new T.ResourceQueue;function a(U,H,W){return r.queueFor(I.URI.file(U),n.extUriBiasedIgnorePathCase).queue(()=>{const x=m(W);return new Promise((q,F)=>u(U,H,x,K=>K?F(K):q()))})}let l=!0;function u(U,H,W,x){if(!l)return R.writeFile(U,H,{mode:W.mode,flag:W.flag},x);R.open(U,W.flag,W.mode,(q,F)=>{if(q)return x(q);R.writeFile(F,H,K=>{if(K)return R.close(F,()=>x(K));R.fdatasync(F,j=>(j&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",j),l=!1),R.close(F,z=>x(z))))})})}function d(U,H,W){const x=m(W);if(!l)return R.writeFileSync(U,H,{mode:x.mode,flag:x.flag});const q=R.openSync(U,x.flag,x.mode);try{R.writeFileSync(q,H);try{R.fdatasyncSync(q)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),l=!1}}finally{R.closeSync(q)}}e.writeFileSync=d;function m(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function A(U,H){if(U===H)return;async function W(x){try{const q=await e.Promises.lstat(x);if(q.isDirectory()||q.isSymbolicLink())return;await e.Promises.utimes(x,q.atime,new Date)}catch(q){}}try{await e.Promises.rename(U,H),await W(H)}catch(x){if(U.toLowerCase()!==H.toLowerCase()&&x.code==="EXDEV"||U.endsWith("."))await _(U,H,{preserveSymlinks:!1}),await h(U,E.MOVE),await W(H);else throw x}}async function _(U,H,W){return N(U,H,{root:{source:U,target:H},options:W,handledSourcePaths:new Set})}const O=511;async function N(U,H,W){if(W.handledSourcePaths.has(U))return;W.handledSourcePaths.add(U);const{stat:x,symbolicLink:q}=await i.stat(U);if(q){if(W.options.preserveSymlinks)try{return await $(U,H,W)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(q.dangling)return}return x.isDirectory()?P(U,H,x.mode&O,W):M(U,H,x.mode&O)}async function P(U,H,W,x){await e.Promises.mkdir(H,{recursive:!0,mode:W});const q=await v(U);for(const F of q)await N((0,S.join)(U,F),(0,S.join)(H,F),x)}async function M(U,H,W){await e.Promises.copyFile(U,H),await e.Promises.chmod(H,W)}async function $(U,H,W){let x=await e.Promises.readlink(U);(0,k.isEqualOrParent)(x,W.root.source,!b.isLinux)&&(x=(0,S.join)(W.root.target,x.substr(W.root.source.length+1))),await e.Promises.symlink(x,H)}e.Promises=new class{get access(){return(0,D.promisify)(R.access)}get stat(){return(0,D.promisify)(R.stat)}get lstat(){return(0,D.promisify)(R.lstat)}get utimes(){return(0,D.promisify)(R.utimes)}get read(){return(0,D.promisify)(R.read)}get readFile(){return(0,D.promisify)(R.readFile)}get write(){return(0,D.promisify)(R.write)}get appendFile(){return(0,D.promisify)(R.appendFile)}get fdatasync(){return(0,D.promisify)(R.fdatasync)}get truncate(){return(0,D.promisify)(R.truncate)}get rename(){return(0,D.promisify)(R.rename)}get copyFile(){return(0,D.promisify)(R.copyFile)}get open(){return(0,D.promisify)(R.open)}get close(){return(0,D.promisify)(R.close)}get symlink(){return(0,D.promisify)(R.symlink)}get readlink(){return(0,D.promisify)(R.readlink)}get chmod(){return(0,D.promisify)(R.chmod)}get mkdir(){return(0,D.promisify)(R.mkdir)}get unlink(){return(0,D.promisify)(R.unlink)}get rmdir(){return(0,D.promisify)(R.rmdir)}get realpath(){return(0,D.promisify)(R.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return t}get writeFile(){return a}get rm(){return h}get move(){return A}get copy(){return _}}}),define(te[110],ne([0,1,51,9,25,19]),function(J,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(n){const I=(0,L.dirname)(n);if(n===I)return n;const g=((0,L.basename)(n)||n).toLowerCase();try{const h=(0,T.readdirSync)(I).filter(p=>p.toLowerCase()===g);if(h.length===1){const p=k(I);if(p)return(0,L.join)(p,h[0])}else if(h.length>1){const p=h.indexOf(g);if(p>=0){const f=k(I);if(f)return(0,L.join)(f,h[p])}}}catch(E){}return null}e.realcaseSync=k;async function C(n){try{return await T.Promises.realpath(n)}catch(I){const g=b(n);return await T.Promises.access(g,R.constants.R_OK),g}}e.realpath=C;function S(n){try{return R.realpathSync(n)}catch(I){const g=b(n);return R.accessSync(g,R.constants.R_OK),g}}e.realpathSync=S;function b(n){return(0,D.rtrim)((0,L.normalize)(n),L.sep)}}),define(te[111],ne([0,1,56]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(C,S,b,n=1){let I=!1;return new Promise(g=>{const E=setTimeout(()=>{if(!I)return I=!0,g(0)},b);D(C,S,n,h=>{if(!I)return I=!0,clearTimeout(E),g(h)})})}e.findFreePort=L;function D(C,S,b,n){if(S===0)return n(0);const I=new R.Socket;I.once("connect",()=>(k(I),D(C+b,S-1,b,n))),I.once("data",()=>{}),I.once("error",g=>(k(I),g.code!=="ECONNREFUSED"?D(C+b,S-1,b,n):n(C))),I.connect(C,"127.0.0.1")}function T(C,S,b){let n=!1,I,g=1;const E=R.createServer({pauseOnConnect:!0});function h(p,f){n||(n=!0,E.removeAllListeners(),E.close(),I&&clearTimeout(I),f(p))}return new Promise(p=>{I=setTimeout(()=>{h(0,p)},b),E.on("listening",()=>{h(C,p)}),E.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&g<S?(C++,g++,E.listen(C,"127.0.0.1")):h(0,p)}),E.on("close",()=>{h(0,p)}),E.listen(C,"127.0.0.1")})}e.findFreePortFaster=T;function k(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(S){console.error(S)}}}),define(te[71],ne([0,1,32,9,19]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,k=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var S;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(S||(S={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class I{constructor(o,t,s){this.exePath=o,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:c=!1}={}){return c?b===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:c=!1,findPreview:o=!1}={}){const t=g({useAlternateBitness:c});if(!t)return null;const s=L.join(t,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(s))return null;let i=-1,r=null;for(const u of await D.Promises.readdir(s)){let d=-1;if(o){const A=u.indexOf("-");if(A<0)continue;const _=u.substring(0,A);if(!T.test(_)||u.substring(A+1)!=="preview")continue;d=parseInt(_,10)}else{if(!T.test(u))continue;d=parseInt(u,10)}if(d<=i)continue;const m=L.join(s,u,"pwsh.exe");!await D.SymlinkSupport.existsFile(m)||(r=m,i=d)}if(!r)return null;const a=t.includes("x86")?" (x86)":"",l=o?" Preview":"";return new I(r,`PowerShell${l}${a}`,!0)}async function h({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const o=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=c?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const i of await D.Promises.readdir(o))if(t.test(i)){const r=L.join(o,i,"pwsh.exe");return new I(r,s)}return null}function p(){const c=L.join(R.homedir(),".dotnet","tools","pwsh.exe");return new I(c,".NET Core PowerShell Global Tool")}function f(){const c=L.join(process.env.windir,b===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(c,"Windows PowerShell",!0)}async function*w(){let c=await E();c&&(yield c),c=await E({useAlternateBitness:!0}),c&&(yield c),c=await h(),c&&(yield c),c=p(),c&&(yield c),c=await E({findPreview:!0}),c&&(yield c),c=await h({findPreview:!0}),c&&(yield c),c=await E({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=f(),c&&(yield c)}async function*v(){for await(const c of w())await c.exists()&&(yield c)}e.enumeratePowerShellInstallations=v;async function y(){for await(const c of v())return c;return null}e.getFirstAvailablePowerShellInstallation=y}),define(te[112],ne([0,1,37,15]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(k){return new Promise((C,S)=>{let b;const n=new Map;function I(E,h,p,f,w){const v=n.get(h);if(E===k||v){const y={name:g(p),cmd:p,pid:E,ppid:h,load:f,mem:w};n.set(E,y),E===k&&(b=y),v&&(v.children||(v.children=[]),v.children.push(y),v.children.length>1&&(v.children=v.children.sort((c,o)=>c.pid-o.pid)))}}function g(E){const h=/--disable-blink-features=Auxclick/,p=/\\watcher\\win32\\CodeHelper\.exe/,f=/--crashes-directory/,w=/\\pipe\\winpty-control/,v=/conhost\.exe/,y=/--type=([a-zA-Z-]+)/;if(p.exec(E))return"watcherService ";if(f.exec(E))return"electron-crash-reporter";if(w.exec(E))return"winpty-process";if(v.exec(E))return"console-window-host (Windows internal process)";let c=y.exec(E);if(c&&c.length===2)return c[1]==="renderer"?h.exec(E)?"shared-process":"window":c[1];const o=/[a-zA-Z-]+\.js/g;let t="";do c=o.exec(E),c&&(t+=c+" ");while(c);return t&&E.indexOf("node ")<0&&E.indexOf("node.exe")<0?`electron_node ${t}`:E}if(process.platform==="win32"){const E=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,p)=>{J(["windows-process-tree"],h,p)}).then(h=>{h.getProcessList(k,p=>{h.getProcessCpuUsage(p,f=>{const w=new Map;f.forEach(v=>{const y=E(v.commandLine||"");w.set(v.pid,{name:g(y),cmd:y,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),b=w.get(k),b?(w.forEach(v=>{const y=w.get(v.ppid);y&&(y.children||(y.children=[]),y.children.push(v))}),w.forEach(v=>{v.children&&(v.children=v.children.sort((y,c)=>y.pid-c.pid))}),C(b)):S(new Error(`Root process ${k} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let E=function(){let h=[b];const p=[];for(;h.length;){const w=h.shift();w&&(p.push(w.pid),w.children&&(h=h.concat(w.children)))}let f=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);f+=" "+p.join(" "),(0,R.exec)(f,{},(w,v,y)=>{if(w||y)S(w||new Error(y.toString()));else{const c=v.toString().split(`
`);for(let o=0;o<p.length;o++){const t=n.get(p[o]);t.load=parseFloat(c[o])}if(!b){S(new Error(`Root process ${k} not found`));return}C(b)}})};(0,R.exec)("which ps",{},(h,p,f)=>{if(h||f)if(process.platform!=="linux")S(h||new Error(f.toString()));else{const w=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,R.exec)(w,{},(v,y,c)=>{v||c?S(v||new Error(c.toString())):(T(y,I),E())})}else{const w=p.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${w} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,c,o)=>{y||o&&!o.includes("screen size is bogus")?S(y||new Error(o.toString())):(T(c,I),process.platform==="linux"?E():b?C(b):S(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=D;function T(k,C){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=k.toString().split(`
`);for(const n of b){const I=S.exec(n.trim());I&&I.length===6&&C(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(te[113],ne([0,1,51,27,40,2,68,9,4,19]),function(J,e,R,L,D,T,k,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function n(h,p,f){return g({path:h,isDirectory:!1},p,f)}e.watchFile=n;function I(h,p,f){return g({path:h,isDirectory:!0},p,f)}e.watchFolder=I,e.CHANGE_BUFFER_DELAY=100;function g(h,p,f){if(S.isMacintosh&&(0,D.isEqualOrParent)(h.path,"/Volumes/"))return f(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const w=(0,C.basename)(h.path),v=new Map;let y=!1,c=[(0,T.toDisposable)(()=>{v.forEach(o=>(0,T.dispose)(o)),v.clear()})];try{const o=(0,R.watch)(h.path);c.push((0,T.toDisposable)(()=>{o.removeAllListeners(),o.close()}));const t=new Set;h.isDirectory&&b.Promises.readdir(h.path).then(s=>s.forEach(i=>t.add(i))),o.on("error",(s,i)=>{y||f(`Failed to watch ${h.path} for changes using fs.watch() (${s}, ${i})`)}),o.on("change",(s,i)=>{if(y)return;let r="";if(i&&(r=i.toString(),S.isMacintosh&&(r=(0,k.normalizeNFC)(r))),!r||s!=="change"&&s!=="rename")return;const a=h.isDirectory?(0,C.join)(h.path,r):h.path;if(h.isDirectory)if(s==="rename"){const l=v.get(a);l&&(0,T.dispose)(l);const u=setTimeout(async()=>{v.delete(a);const d=await b.Promises.exists(a);if(y)return;let m;d?t.has(r)?m="changed":(m="added",t.add(r)):(t.delete(r),m="deleted"),p(m,a)},e.CHANGE_BUFFER_DELAY);v.set(a,(0,T.toDisposable)(()=>clearTimeout(u)))}else{let l;t.has(r)?l="changed":(l="added",t.add(r)),p(l,a)}else if(s==="rename"||r!==w){const l=setTimeout(async()=>{const u=await b.Promises.exists(a);y||(u?(p("changed",a),c=[g(h,p,f)]):p("deleted",a))},e.CHANGE_BUFFER_DELAY);(0,T.dispose)(c),c=[(0,T.toDisposable)(()=>clearTimeout(l))]}else p("changed",a)})}catch(o){b.Promises.exists(h.path).then(t=>{t&&!y&&f(`Failed to watch ${h.path} for changes using fs.watch() (${o.toString()})`)})}return(0,T.toDisposable)(()=>{y=!0,c=(0,T.dispose)(c)})}async function E(h,p,f,w=512){const v=await b.Promises.open(h,"r"),y=Buffer.allocUnsafe(w),c=new L.CancellationTokenSource(f);let o,t=!1;const s=n(h,async i=>{if(i==="changed"){if(t)return;t=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:r}=await b.Promises.read(v,y,0,w,null);if(!r||c.token.isCancellationRequested)break;p(y.slice(0,r))}}catch(r){o=new Error(r),c.dispose(!0)}finally{t=!1}}},i=>{o=new Error(i),c.dispose(!0)});return new Promise((i,r)=>{c.token.onCancellationRequested(async()=>{s.dispose(),await b.Promises.close(v),o?r(o):i()})})}e.watchFileContents=E});var he=this&&this.__decorate||function(J,e,R,L){var D=arguments.length,T=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,R):L,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(J,e,R,L);else for(var C=J.length-1;C>=0;C--)(k=J[C])&&(T=(D<3?k(T):D>3?k(e,R,T):k(e,R))||T);return D>3&&T&&Object.defineProperty(e,R,T),T};define(te[33],ne([0,1,17,6,22,27,66,8,3,2,104,25,18]),function(J,e,R,L,D,T,k,C,S,b,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function h(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function f(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(w||(w={}));class v{constructor(F){this.buffer=F,this.pos=0}read(F){const K=this.buffer.slice(this.pos,this.pos+F);return this.pos+=K.byteLength,K}}class y{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var c;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(c||(c={}));function o(q){const F=D.VSBuffer.alloc(4);return F.writeUInt32BE(q,0),F}function t(q){return q.read(4).readUInt32BE(0)}function s(q){const F=D.VSBuffer.alloc(1);return F.writeUInt8(q,0),F}const i={Undefined:s(c.Undefined),String:s(c.String),Buffer:s(c.Buffer),VSBuffer:s(c.VSBuffer),Array:s(c.Array),Object:s(c.Object)},r=typeof Buffer!="undefined";function a(q,F){if(typeof F=="undefined")q.write(i.Undefined);else if(typeof F=="string"){const K=D.VSBuffer.fromString(F);q.write(i.String),q.write(o(K.byteLength)),q.write(K)}else if(r&&Buffer.isBuffer(F)){const K=D.VSBuffer.wrap(F);q.write(i.Buffer),q.write(o(K.byteLength)),q.write(K)}else if(F instanceof D.VSBuffer)q.write(i.VSBuffer),q.write(o(F.byteLength)),q.write(F);else if(Array.isArray(F)){q.write(i.Array),q.write(o(F.length));for(const K of F)a(q,K)}else{const K=D.VSBuffer.fromString(JSON.stringify(F));q.write(i.Object),q.write(o(K.byteLength)),q.write(K)}}function l(q){switch(q.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return q.read(t(q)).toString();case c.Buffer:return q.read(t(q)).buffer;case c.VSBuffer:return q.read(t(q));case c.Array:{const K=t(q),j=[];for(let z=0;z<K;z++)j.push(l(q));return j}case c.Object:return JSON.parse(q.read(t(q)).toString())}}class u{constructor(F,K,j=null,z=1e3){this.protocol=F,this.ctx=K,this.logger=j,this.timeoutDelay=z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(F,K){this.channels.set(F,K),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const K=this.send([F.type]);this.logger&&this.logger.logOutgoing(K,0,1,f(F.type));return}case 201:case 202:case 204:case 203:{const K=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(K,F.id,1,f(F.type),F.data);return}}}send(F,K=void 0){const j=new y;return a(j,F),a(j,K),this.sendBuffer(j.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(K){return 0}}onRawMessage(F){const K=new v(F),j=l(K),z=l(K),B=j[0];switch(B){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,j[1],1,`${h(B)}: ${j[2]}.${j[3]}`,z),this.onPromise({type:B,id:j[1],channelName:j[2],name:j[3],arg:z});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,j[1],1,`${h(B)}: ${j[2]}.${j[3]}`,z),this.onEventListen({type:B,id:j[1],channelName:j[2],name:j[3],arg:z});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,j[1],1,`${h(B)}`),this.disposeActiveRequest({type:B,id:j[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,j[1],1,`${h(B)}`),this.disposeActiveRequest({type:B,id:j[1]})}}onPromise(F){const K=this.channels.get(F.channelName);if(!K){this.collectPendingRequest(F);return}const j=new T.CancellationTokenSource;let z;try{z=K.call(this.ctx,F.name,F.arg,j.token)}catch(Z){z=Promise.reject(Z)}const B=F.id;z.then(Z=>{this.sendResponse({id:B,data:Z,type:201}),this.activeRequests.delete(F.id)},Z=>{Z instanceof Error?this.sendResponse({id:B,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:B,data:Z,type:203}),this.activeRequests.delete(F.id)});const X=(0,b.toDisposable)(()=>j.cancel());this.activeRequests.set(F.id,X)}onEventListen(F){const K=this.channels.get(F.channelName);if(!K){this.collectPendingRequest(F);return}const j=F.id,B=K.listen(this.ctx,F.name,F.arg)(X=>this.sendResponse({id:j,data:X,type:204}));this.activeRequests.set(F.id,B)}disposeActiveRequest(F){const K=this.activeRequests.get(F.id);K&&(K.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let K=this.pendingRequests.get(F.channelName);K||(K=[],this.pendingRequests.set(F.channelName,K));const j=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:F,timeoutTimer:j})}flushPendingRequests(F){const K=this.pendingRequests.get(F);if(K){for(const j of K)switch(clearTimeout(j.timeoutTimer),j.request.type){case 100:this.onPromise(j.request);break;case 102:this.onEventListen(j.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var d;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class m{constructor(F,K=null){this.protocol=F,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(j=>this.onBuffer(j)),this.logger=K}getChannel(F){const K=this;return{call(j,z,B){return K.isDisposed?Promise.reject(C.canceled()):K.requestPromise(F,j,z,B)},listen(j,z){return K.isDisposed?Promise.reject(C.canceled()):K.requestEvent(F,j,z)}}}requestPromise(F,K,j,z=T.CancellationToken.None){const B=this.lastRequestId++,Z={id:B,type:100,channelName:F,name:K,arg:j};if(z.isCancellationRequested)return Promise.reject(C.canceled());let V;return new Promise((ie,re)=>{if(z.isCancellationRequested)return re(C.canceled());const ae=()=>{const Ie=Pe=>{switch(Pe.type){case 201:this.handlers.delete(B),ie(Pe.data);break;case 202:this.handlers.delete(B);const Ee=new Error(Pe.data.message);Ee.stack=Pe.data.stack,Ee.name=Pe.data.name,re(Ee);break;case 203:this.handlers.delete(B),re(Pe.data);break}};this.handlers.set(B,Ie),this.sendRequest(Z)};let ue=null;this.state===w.Idle?ae():(ue=(0,L.createCancelablePromise)(Ie=>this.whenInitialized()),ue.then(()=>{ue=null,ae()}));const fe=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:B,type:101}),re(C.canceled())},ge=z.onCancellationRequested(fe);V=(0,b.combinedDisposable)((0,b.toDisposable)(fe),ge),this.activeRequests.add(V)}).finally(()=>{this.activeRequests.delete(V)})}requestEvent(F,K,j){const z=this.lastRequestId++,X={id:z,type:102,channelName:F,name:K,arg:j};let Z=null;const V=new S.Emitter({onFirstListenerAdd:()=>{Z=(0,L.createCancelablePromise)(ie=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(V),this.sendRequest(X)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(V),this.sendRequest({id:z,type:103}))}}),G=ie=>V.fire(ie.data);return this.handlers.set(z,G),V.event}sendRequest(F){switch(F.type){case 100:case 102:{const K=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(K,F.id,0,`${h(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const K=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(K,F.id,0,h(F.type));return}}}send(F,K=void 0){const j=new y;return a(j,F),a(j,K),this.sendBuffer(j.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(K){return 0}}onBuffer(F){const K=new v(F),j=l(K),z=l(K),B=j[0];switch(B){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,f(B)),this.onResponse({type:j[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,j[1],0,f(B),z),this.onResponse({type:j[0],id:j[1],data:z})}}onResponse(F){if(F.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const K=this.handlers.get(F.id);K&&K(F)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}he([k.memoize],m.prototype,"onDidInitializePromise",null),e.ChannelClient=m;class A{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:K,onDidClientDisconnect:j})=>{S.Event.once(K.onMessage)(B=>{const X=new v(B),Z=l(X),V=new u(K,Z),G=new m(K);this.channels.forEach((re,ae)=>V.registerChannel(ae,re));const ie={channelServer:V,channelClient:G,ctx:Z};this._connections.add(ie),this._onDidAddConnection.fire(ie),j(()=>{V.dispose(),G.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)})})})}get connections(){const F=[];return this._connections.forEach(K=>F.push(K)),F}getChannel(F,K){const j=this;return{call(z,B,X){let Z;if((0,g.isFunction)(K)){let G=(0,R.getRandomElement)(j.connections.filter(K));Z=G?Promise.resolve(G):S.Event.toPromise(S.Event.filter(j.onDidAddConnection,K))}else Z=K.routeCall(j,z,B);const V=Z.then(G=>G.channelClient.getChannel(F));return O(V).call(z,B,X)},listen(z,B){if((0,g.isFunction)(K))return j.getMulticastEvent(F,K,z,B);const X=K.routeEvent(j,z,B).then(Z=>Z.channelClient.getChannel(F));return O(X).listen(z,B)}}}getMulticastEvent(F,K,j,z){const B=this;let X=new b.DisposableStore;const Z=new S.Emitter({onFirstListenerAdd:()=>{X=new b.DisposableStore;const V=new S.EventMultiplexer,G=new Map,ie=ae=>{const fe=ae.channelClient.getChannel(F).listen(j,z),ge=V.add(fe);G.set(ae,ge)},re=ae=>{const ue=G.get(ae);!ue||(ue.dispose(),G.delete(ae))};B.connections.filter(K).forEach(ie),S.Event.filter(B.onDidAddConnection,K)(ie,void 0,X),B.onDidRemoveConnection(re,void 0,X),V.event(Z.fire,Z,X),X.add(V)},onLastListenerRemove:()=>{X.dispose()}});return Z.event}registerChannel(F,K){this.channels.set(F,K),this._connections.forEach(j=>{j.channelServer.registerChannel(F,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class _{constructor(F,K,j=null){const z=new y;a(z,K),F.send(z.buffer),this.channelClient=new m(F,j),this.channelServer=new u(F,K,j)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,K){this.channelServer.registerChannel(F,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function O(q){return{call(F,K,j){return q.then(z=>z.call(F,K,j))},listen(F,K){const j=new S.Relay;return q.then(z=>j.input=z.listen(F,K)),j.event}}}e.getDelayedChannel=O;function N(q){let F=!1;return{call(K,j,z){return F?q.call(K,j,z):(0,L.timeout)(0).then(()=>F=!0).then(()=>q.call(K,j,z))},listen(K,j){if(F)return q.listen(K,j);const z=new S.Relay;return(0,L.timeout)(0).then(()=>F=!0).then(()=>z.input=q.listen(K,j)),z.event}}}e.getNextTickChannel=N;class P{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const K of F.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await S.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=P;var M;(function(q){function F(B,X){const Z=B,V=X&&X.disableMarshalling,G=new Map;for(const ie in Z)j(ie)&&G.set(ie,S.Event.buffer(Z[ie],!0));return new class{listen(ie,re,ae){const ue=G.get(re);if(ue)return ue;if(z(re)){const fe=Z[re];if(typeof fe=="function")return fe.call(Z,ae)}throw new Error(`Event not found: ${re}`)}call(ie,re,ae){const ue=Z[re];if(typeof ue=="function"){if(!V&&Array.isArray(ae))for(let fe=0;fe<ae.length;fe++)ae[fe]=(0,n.revive)(ae[fe]);return ue.apply(Z,ae)}throw new Error(`Method not found: ${re}`)}}}q.fromService=F;function K(B,X){const Z=X&&X.disableMarshalling;return new Proxy({},{get(V,G){if(typeof G=="string")return X?.properties?.has(G)?X.properties.get(G):z(G)?function(ie){return B.listen(G,ie)}:j(G)?B.listen(G):async function(...ie){let re;X&&!(0,g.isUndefinedOrNull)(X.context)?re=[X.context,...ie]:re=ie;const ae=await B.call(G,re);return Z?ae:(0,n.revive)(ae)};throw new Error(`Property not found: ${String(G)}`)}})}q.toService=K;function j(B){return B[0]==="o"&&B[1]==="n"&&I.isUpperAsciiLetter(B.charCodeAt(2))}function z(B){return/^onDynamic/.test(B)&&I.isUpperAsciiLetter(B.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let F=q.toString();if(F!=="[object Object]")return F}return q}function H(q){return Array.isArray(q)?q.map(U):U(q)}function W(q,F,K,j,z,B,X){X=H(X);const Z=$[z],V=Z[j%Z.length];let G=[`%c[${q}]%c[${String(F).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(j).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(B)?(G=G.concat(X),G.push(")")):G.push(X),console.log.apply(console,G)}e.logWithColors=W;class x{constructor(F,K){this._outgoingPrefix=F,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,K,j,z,B){this._totalOutgoing+=F,W(this._outgoingPrefix,this._totalOutgoing,F,K,j,z,B)}logIncoming(F,K,j,z,B){this._totalIncoming+=F,W(this._incomingPrefix,this._totalIncoming,F,K,j,z,B)}}e.IPCLogger=x}),define(te[114],ne([0,1,22,3,33]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(S){this.port=S,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",b=>R.VSBuffer.wrap(b.data)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class k extends D.IPCClient{constructor(S,b){const n=new T(S);super(n,b);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=k}),define(te[72],ne([0,1,22,3,2,4,31,33]),function(J,e,R,L,D,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var S;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function n(){return b||(b=R.VSBuffer.alloc(0)),b}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,a){if(r===0)return n();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const m=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=r),m}if(this._chunks[0].byteLength>r){const m=this._chunks[0].slice(0,r);return a&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),m}let l=R.VSBuffer.alloc(r),u=0,d=0;for(;r>0;){const m=this._chunks[d];if(m.byteLength>r){const A=m.slice(0,r);l.set(A,u),u+=r,a&&(this._chunks[d]=m.slice(r),this._totalLength-=r),r-=r}else l.set(m,u),u+=m.byteLength,a?(this._chunks.shift(),this._totalLength-=m.byteLength):d++,r-=m.byteLength}return l}}e.ChunkStream=I;var g;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(g||(g={}));var E;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(r,a,l,u){this.type=r,this.id=a,this.ack=l,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends D.Disposable{constructor(r){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const l=this._state.messageType,u=this._state.id,d=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(l,u,d,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(r){this._isDisposed=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(r){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=R.VSBuffer.alloc(13);a.writeUInt8(r.type,0),a.writeUInt32BE(r.id,1),a.writeUInt32BE(r.ack,5),a.writeUInt32BE(r.data.byteLength,9),this._writeSoon(a,r.data)}_bufferAdd(r,a){const l=this._totalLength===0;return this._data.push(r,a),this._totalLength+=r.byteLength+a.byteLength,l}_bufferTake(){const r=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,a){this._bufferAdd(r,a)&&T.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class w extends D.Disposable{constructor(r){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new h(1,0,0,r))}}e.Protocol=w;class v extends C.IPCClient{constructor(r,a,l=null){super(r,a,l);this.protocol=r}static fromSocket(r,a){return new v(new w(r),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=v;class y{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,k.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=y;class c{constructor(r){this.data=r,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],a=0,l=this._first;for(;l;)r[a++]=l.data,l=l.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const a=new c(r);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class t{constructor(){this.lastRuns=[];const r=Date.now();for(let a=0;a<t._HISTORY_LENGTH;a++)this.lastRuns[a]=r-1e3*a;setInterval(()=>{for(let a=t._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const r=Date.now(),a=(1+t._HISTORY_LENGTH)*1e3;let l=0;for(let u=0;u<t._HISTORY_LENGTH;u++)r-this.lastRuns[u]<=a&&l++;return 1-l/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(r,a=null,l=t.getInstance()){this._onControlMessage=new y,this.onControlMessage=this._onControlMessage.event,this._onMessage=new y,this.onMessage=this._onMessage.event,this._onDidDispose=new y,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new y,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new y,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=r,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new h(5,0,0,n());this._socketWriter.write(r),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const r=Date.now()-this._socketWriter.lastWriteTime;if(r>=5e3){const a=new h(4,0,0,n());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-r+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const r=Date.now()-this._socketReader.lastReadTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-r,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,a){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=r,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const r=this._outgoingUnackMsg.toArray();for(let a=0,l=r.length;a<l;a++)this._socketWriter.write(r[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(r.type===1){if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new h(6,0,0,n())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data)}else if(r.type===2)this._onControlMessage.fire(r.data);else if(r.type===5)this._onDidDispose.fire();else if(r.type===6){const a=this._outgoingUnackMsg.toArray();for(let l=0,u=a.length;l<u;l++)this._socketWriter.write(a[l]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new h(1,a,this._incomingAckId,r);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(r){const a=new h(2,0,0,r);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),a=Date.now()-r.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new h(3,0,this._incomingAckId,n());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(te[115],ne([0,1,116,3,33,114]),function(J,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class k extends D.IPCServer{static getOnDidClientConnect(){const S=L.Event.fromNodeEventEmitter(R.ipcRenderer,"vscode:createMessageChannel",(b,n)=>n);return L.Event.map(S,b=>{const{port1:n,port2:I}=new MessageChannel,E={protocol:new T.Protocol(n),onDidClientDisconnect:L.Event.fromDOMEventEmitter(n,"close")};return R.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[I]),E})}constructor(){super(k.getOnDidClientConnect())}}e.Server=k}),define(te[117],ne([0,1,22,8]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function D(C,S){C.proxyAuthorization&&(C.headers={...C.headers||{},"Proxy-Authorization":C.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((n,I)=>{b.open(C.type||"GET",C.url||"",!0,C.user,C.password),T(b,C),b.responseType="arraybuffer",b.onerror=g=>I(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=g=>{n({res:{statusCode:b.status,headers:k(b)},stream:(0,R.bufferToStream)(R.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=g=>I(new Error(`XHR timeout: ${C.timeout}ms`)),C.timeout&&(b.timeout=C.timeout),b.send(C.data),S.onCancellationRequested(()=>{b.abort(),I((0,L.canceled)())})})}e.request=D;function T(C,S){if(S.headers){e:for(let b in S.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}C.setRequestHeader(b,S.headers[b])}}}function k(C){const S=Object.create(null);for(const b of C.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const n=b.indexOf(":");S[b.substr(0,n).trim().toLowerCase()]=b.substr(n+1).trim()}return S}}),define(te[73],ne([0,1,6,3,2,18]),function(J,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function C(I){const g=I;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=C;var S;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(S||(S={}));class b extends D.Disposable{constructor(g,E=Object.create(null)){super();this.database=g,this.options=E,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=S.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((E,h)=>this.accept(h,E)),g.deleted?.forEach(E=>this.accept(E,void 0))}accept(g,E){if(this.state===S.Closed)return;let h=!1;(0,T.isUndefinedOrNull)(E)?h=this.cache.delete(g):this.cache.get(g)!==E&&(this.cache.set(g,E),h=!0),h&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===S.None&&(this.state=S.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,E){const h=this.cache.get(g);return(0,T.isUndefinedOrNull)(h)?E:h}getBoolean(g,E){const h=this.get(g);return(0,T.isUndefinedOrNull)(h)?E:h==="true"}getNumber(g,E){const h=this.get(g);return(0,T.isUndefinedOrNull)(h)?E:parseInt(h,10)}async set(g,E){if(this.state===S.Closed)return;if((0,T.isUndefinedOrNull)(E))return this.delete(g);const h=String(E);if(this.cache.get(g)!==h)return this.cache.set(g,h),this.pendingInserts.set(g,h),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async delete(g){if(!(this.state===S.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=S.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class n{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((E,h)=>this.items.set(h,E)),g.delete&&g.delete.forEach(E=>this.items.delete(E))}async close(){}}e.InMemoryStorageDatabase=n}),define(te[118],ne([11,12]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[57],ne([0,1,118]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,D=L*60,T=D*24,k=T*7,C=T*30,S=T*365;function b(I,g){typeof I!="number"&&(I=I.getTime());const E=Math.round((new Date().getTime()-I)/1e3);if(E<-30)return(0,R.localize)(0,null,b(new Date().getTime()+E*1e3,!1));if(E<30)return(0,R.localize)(1,null);let h;return E<L?(h=E,g?h===1?(0,R.localize)(2,null,h):(0,R.localize)(3,null,h):h===1?(0,R.localize)(4,null,h):(0,R.localize)(5,null,h)):E<D?(h=Math.floor(E/L),g?h===1?(0,R.localize)(6,null,h):(0,R.localize)(7,null,h):h===1?(0,R.localize)(8,null,h):(0,R.localize)(9,null,h)):E<T?(h=Math.floor(E/D),g?h===1?(0,R.localize)(10,null,h):(0,R.localize)(11,null,h):h===1?(0,R.localize)(12,null,h):(0,R.localize)(13,null,h)):E<k?(h=Math.floor(E/T),g?h===1?(0,R.localize)(14,null,h):(0,R.localize)(15,null,h):h===1?(0,R.localize)(16,null,h):(0,R.localize)(17,null,h)):E<C?(h=Math.floor(E/k),g?h===1?(0,R.localize)(18,null,h):(0,R.localize)(19,null,h):h===1?(0,R.localize)(20,null,h):(0,R.localize)(21,null,h)):E<S?(h=Math.floor(E/C),g?h===1?(0,R.localize)(22,null,h):(0,R.localize)(23,null,h):h===1?(0,R.localize)(24,null,h):(0,R.localize)(25,null,h)):(h=Math.floor(E/S),g?h===1?(0,R.localize)(26,null,h):(0,R.localize)(27,null,h):h===1?(0,R.localize)(28,null,h):(0,R.localize)(29,null,h))}e.fromNow=b;function n(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(te[119],ne([11,12]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[38],ne([0,1,17,18,119]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(b,n){return n&&(b.stack||b.stacktrace)?D.localize(0,null,C(b),k(b.stack)||k(b.stacktrace)):C(b)}function k(b){return Array.isArray(b)?b.join(`
`):b}function C(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?D.localize(1,null,b.message):b.message||D.localize(2,null)}function S(b=null,n=!1){if(!b)return D.localize(3,null);if(Array.isArray(b)){const I=R.coalesce(b),g=S(I[0],n);return I.length>1?D.localize(4,null,g,I.length):g}if(L.isString(b))return b;if(b.detail){const I=b.detail;if(I.error)return T(I.error,n);if(I.exception)return T(I.exception,n)}return b.stack?T(b,n):b.message?b.message:D.localize(5,null)}e.toErrorMessage=S}),define(te[120],ne([11,12]),function(J,e){return J.create("vs/base/node/processes",e)}),define(te[74],ne([0,1,37,40,15,26,9,4,31,101,18,70,19,120]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return b.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return b.TerminateResponseCode}});function h(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function p(o,t){if(C.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};t&&(s.cwd=t);const i=R.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],s);return new Promise(r=>{i.once("error",a=>{r({success:!1,error:a})}),i.once("exit",(a,l)=>{r(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?h(s.status):1})}else if(C.isLinux||C.isMacintosh)try{const s=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(i=>{R.execFile(s,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,a,l)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function f(o=S.env){return o.comspec||"cmd.exe"}e.getWindowsShell=f;class w{constructor(t,s,i,r){if(s!==void 0&&i!==void 0&&r!==void 0)this.cmd=t,this.args=s,this.shell=i,this.options=r;else{const a=t;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(S.env).forEach(l=>{a[l]=S.env[l]}),Object.keys(this.options.env).forEach(l=>{a[l]=this.options.env[l]}),this.options.env=a}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const s=t.lastIndexOf(k.sep);return s!==-1&&(t=t.substring(s+1)),w.WellKnowCommands[t]?t:"other"}start(t){return C.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(S.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(s=>{let i,r;const a=new Promise((l,u)=>{i=l,r=u});if(s){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=R.exec(l,this.options,(u,d,m)=>{this.childProcess=null;const A=u;A&&A.killed?r({killed:this.terminateRequested,stdout:d.toString(),stderr:m.toString()}):this.handleExec(i,t,u,d,m)})}else{let l=null;const u=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,i,t,r);const m={terminated:this.terminateRequested};n.isNumber(d)&&(m.cmdCode=d),i(m)};if(this.shell&&C.isWindows){const d=T.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let m=!1,A=!1;const _=[];let O=this.ensureQuotes(this.cmd);_.push(O.value),m=O.quoted,this.args&&this.args.forEach(P=>{O=this.ensureQuotes(P),_.push(O.value),A=A&&O.quoted});const N=["/s","/c"];m?A?N.push('"'+_.join(" ")+'"'):_.length>1?N.push('"'+_[0]+'" '+_.slice(1).join(" ")):N.push('"'+_[0]+'"'):N.push(_.join(" ")),l=R.spawn(f(),N,d)}else this.cmd&&(l=R.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(n.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",d=>{this.childProcess=null,r({terminated:this.terminateRequested,error:d})}),l.pid&&(this.childProcess.on("close",u),this.handleSpawn(l,i,t,r,!0)))}return a})}handleClose(t,s,i,r){}ensureQuotes(t){return w.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,p(t,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!C.isWindows)return t(!1);const s=R.spawn(f(),["/s","/c"]);s.on("error",i=>t(!0)),s.on("exit",i=>t(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class v extends w{constructor(t,s,i,r){super(t,s,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,s,i,r,a){[r,a].forEach((l,u)=>{const d=new I.LineDecoder;d.write(l).forEach(_=>{s({line:_,source:u===0?0:1})});const A=d.end();A&&s({line:A,source:u===0?0:1})}),t({terminated:this.terminateRequested,error:i})}handleSpawn(t,s,i,r,a){const l=new I.LineDecoder,u=new I.LineDecoder;t.stdout.on("data",d=>{l.write(d).forEach(A=>i({line:A,source:0}))}),t.stderr.on("data",d=>{u.write(d).forEach(A=>i({line:A,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=u}handleClose(t,s,i,r){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&i({line:a,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&i({line:l,source:1})}}e.LineProcess=v;function y(o){let t=[],s=!1;const i=function(r){if(s){t.push(r);return}(!o.send(r,l=>{if(l&&console.error(l),s=!1,t.length>0){const u=t.slice(0);t=[],u.forEach(d=>i(d))}})||C.isWindows)&&(s=!0)};return{send:i}}e.createQueuedSender=y;var c;(function(o){async function t(s,i,r){if(k.isAbsolute(s))return s;if(i===void 0&&(i=S.cwd()),k.dirname(s)!=="."||(r===void 0&&n.isString(S.env.PATH)&&(r=S.env.PATH.split(k.delimiter)),r===void 0||r.length===0))return k.join(i,s);async function l(u){if(await g.Promises.exists(u)){let d;try{d=await g.Promises.stat(u)}catch(m){m.message.startsWith("EACCES")&&(d=await g.Promises.lstat(u))}return d?!d.isDirectory():!1}return!1}for(let u of r){let d;if(k.isAbsolute(u)?d=k.join(u,s):d=k.join(i,u,s),await l(d))return d;let m=d+".com";if(await l(m)||(m=d+".exe",await l(m)))return m}return k.join(i,s)}o.findExecutable=t})(c=e.win32||(e.win32={}))}),define(te[121],ne([0,1,32,4,71,74]),function(J,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(E,h){return E===1?L.isWindows?I():T.getWindowsShell(h):b(E,h)}e.getSystemShell=k;function C(E,h){return E===1?L.isWindows?g(h):T.getWindowsShell(h):b(E,h)}e.getSystemShellSync=C;let S=null;function b(E,h){if(L.isLinux&&E===2||L.isMacintosh&&E===3)return"/bin/bash";if(!S){let p;if(L.isWindows)p="/bin/bash";else{if(p=h.SHELL,!p)try{p=(0,R.userInfo)().shell}catch(f){}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}S=p}return S}let n=null;async function I(){return n||(n=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),n}function g(E){if(n)return n;const h=L.isWindows&&parseFloat((0,R.release)())>=10,p=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${E.windir}\\${p?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?f:T.getWindowsShell(E)}}),define(te[52],ne([0,1,37,6,22,27,103,8,3,2,26,4,74,33]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends E.ChannelServer{constructor(w){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch(y){}},onMessage:S.Event.fromNodeEventEmitter(process,"message",v=>D.VSBuffer.wrap(Buffer.from(v,"base64")))},w);process.once("disconnect",()=>this.dispose())}}e.Server=h;class p{constructor(w,v){this.modulePath=w,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new S.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new L.Delayer(y),this.child=null,this._client=null}getChannel(w){const v=this;return{call(y,c,o){return v.requestPromise(w,y,c,o)},listen(y,c){return v.requestEvent(w,y,c)}}}requestPromise(w,v,y,c=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(C.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(w),t=(0,L.createCancelablePromise)(r=>o.call(v,y,r)),s=c.onCancellationRequested(()=>t.cancel()),i=(0,b.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{s.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(w,v,y){if(!this.disposeDelayer)return S.Event.None;this.disposeDelayer.cancel();let c;const o=new S.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(w).listen(v,y)(o.fire,o),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const w=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,n.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),I.isMacintosh&&v.env&&delete v.env.DYLD_LIBRARY_PATH,this.child=(0,R.fork)(this.modulePath,w,v);const y=new S.Emitter;S.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,k.isRemoteConsoleLog)(a)){(0,k.log)(a,`IPC Library: ${this.options.serverName}`);return}y.fire(D.VSBuffer.wrap(Buffer.from(a,"base64")))});const o=this.options.useQueue?(0,g.createQueuedSender)(this.child):this.child,t=a=>this.child&&this.child.connected&&o.send(a.buffer.toString("base64")),s=y.event,i={send:t,onMessage:s};this._client=new E.ChannelClient(i);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,l)=>{process.removeListener("exit",r),this.activeRequests.forEach(u=>(0,b.dispose)(u)),this.activeRequests.clear(),a!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:l})})}return this._client}getCachedChannel(w){let v=this.channels.get(w);return v||(v=this.client.getChannel(w),this.channels.set(w,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=p}),define(te[122],ne([11,12]),function(J,e){return J.create("vs/base/node/zip",e)}),define(te[123],ne([11,12]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[124],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(te[125],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(te[126],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(te[127],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[128],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[129],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[130],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[131],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[132],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[133],ne([11,12]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[134],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[135],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(te[136],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[137],ne([11,12]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[138],ne([11,12]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[139],ne([11,12]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[140],ne([11,12]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[141],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[142],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[143],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[144],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[145],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[146],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[75],ne([0,1,57,66,15,9,31,16,7]),function(J,e,R,L,D,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(p,f,w){this._args=p,this.paths=f,this.productService=w}get appRoot(){return(0,T.dirname)(D.FileAccess.asFileUri("",J).fsPath)}get userHome(){return S.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return S.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,C.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const p=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",p)}return this.args.logsPath}get userDataSyncLogResource(){return S.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(S.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return S.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return S.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=k.env.VSCODE_PORTABLE;return p?S.URI.file((0,T.join)(p,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,C.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,T.resolve)(p):(0,T.normalize)((0,T.join)(D.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const p=this.args["extensions-download-dir"];return p?(0,T.resolve)(p):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,T.resolve)(p);const f=k.env.VSCODE_EXTENSIONS;if(f)return f;const w=k.env.VSCODE_PORTABLE;return w?(0,T.join)(w,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(f=>/^[^:/?#]+?:\/\//.test(f)?S.URI.parse(f):S.URI.file((0,T.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?S.URI.parse(p):S.URI.file((0,T.normalize)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,C.joinPath)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return S.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],b.prototype,"appRoot",null),he([L.memoize],b.prototype,"userHome",null),he([L.memoize],b.prototype,"userDataPath",null),he([L.memoize],b.prototype,"appSettingsHome",null),he([L.memoize],b.prototype,"tmpDir",null),he([L.memoize],b.prototype,"userRoamingDataHome",null),he([L.memoize],b.prototype,"settingsResource",null),he([L.memoize],b.prototype,"userDataSyncHome",null),he([L.memoize],b.prototype,"userDataSyncLogResource",null),he([L.memoize],b.prototype,"sync",null),he([L.memoize],b.prototype,"machineSettingsResource",null),he([L.memoize],b.prototype,"globalStorageHome",null),he([L.memoize],b.prototype,"workspaceStorageHome",null),he([L.memoize],b.prototype,"keybindingsResource",null),he([L.memoize],b.prototype,"keyboardLayoutResource",null),he([L.memoize],b.prototype,"argvResource",null),he([L.memoize],b.prototype,"snippetsHome",null),he([L.memoize],b.prototype,"isExtensionDevelopment",null),he([L.memoize],b.prototype,"untitledWorkspacesHome",null),he([L.memoize],b.prototype,"installSourcePath",null),he([L.memoize],b.prototype,"builtinExtensionsPath",null),he([L.memoize],b.prototype,"extensionsPath",null),he([L.memoize],b.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],b.prototype,"extensionDevelopmentKind",null),he([L.memoize],b.prototype,"extensionTestsLocationURI",null),he([L.memoize],b.prototype,"debugExtensionHost",null),he([L.memoize],b.prototype,"serviceMachineIdResource",null),he([L.memoize],b.prototype,"telemetryLogResource",null),he([L.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function n(h,p){return E(h["inspect-extensions"],h["inspect-brk-extensions"],5870,p,h.debugId)}e.parseExtensionHostPort=n;function I(h,p){return E(h["inspect-search"],h["inspect-brk-search"],5876,p)}e.parseSearchPort=I;function g(h,p){return E(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,p)}e.parsePtyHostPort=g;function E(h,p,f,w,v){const c=Number(p||h)||(w?null:f),o=c?Boolean(!!p):!1;return{port:c,break:o,debugId:v}}}),define(te[147],ne([0,1,237,4,124]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{}};function C(h,p,f=k){const w={},v=[],y=[];for(let s in p){const i=p[s];i.alias&&(w[s]=i.alias),i.type==="string"||i.type==="string[]"?(v.push(s),i.deprecates&&v.push(i.deprecates)):i.type==="boolean"&&(y.push(s),i.deprecates&&y.push(i.deprecates))}const c=R(h,{string:v,boolean:y,alias:w}),o={},t=c;o._=c._.map(s=>String(s)).filter(s=>s.length>0),delete t._;for(let s in p){const i=p[s];i.alias&&delete t[i.alias];let r=t[s];i.deprecates&&t.hasOwnProperty(i.deprecates)&&(r||(r=t[i.deprecates]),delete t[i.deprecates]),typeof r!="undefined"&&(i.type==="string[]"?r&&!Array.isArray(r)&&(r=[r]):i.type==="string"&&Array.isArray(r)&&(r=r.pop(),f.onMultipleValues(s,r)),o[s]=r),delete t[s]}for(let s in t)f.onUnknownOption(s);return o}e.parseArgs=C;function S(h,p){let f="";return p.args&&(Array.isArray(p.args)?f=` <${p.args.join("> <")}>`:f=` <${p.args}>`),p.alias?`-${p.alias} --${h}${f}`:`--${h}${f}`}function b(h,p){let f=0,w=[];for(const o in h){const t=h[o],s=S(o,t);f=Math.max(f,s.length),w.push([s,t.description])}let v=f+2+1;if(p-v<25)return w.reduce((o,t)=>o.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let y=p-v-1,c=[];for(const o of w){let t=o[0],s=I(o[1],y),i=n(v-t.length-2);c.push("  "+t+i+s[0]);for(let r=1;r<s.length;r++)c.push(n(v)+s[r])}return c}e.formatOptions=b;function n(h){return" ".repeat(h)}function I(h,p){let f=[];for(;h.length;){let w=h.length<p?h.length:h.lastIndexOf(" ",p),v=h.slice(0,w).trim();h=h.slice(w),f.push(v)}return f}function g(h,p,f,w,v=!0){const y=process.stdout.isTTY&&process.stdout.columns||80;let c=[`${h} ${f}`];c.push(""),c.push(`${(0,D.localize)(32,null)}: ${p} [${(0,D.localize)(33,null)}][${(0,D.localize)(34,null)}...]`),c.push(""),v&&(L.isWindows?c.push((0,D.localize)(35,null,p)):c.push((0,D.localize)(36,null,p)),c.push(""));const o={};for(const t in w){const s=w[t];if(s.description&&s.cat){let i=o[s.cat];i||(o[s.cat]=i={}),i[t]=s}}for(let t in o){const s=t;let i=o[s];i&&(c.push(T[s]),c.push(...b(i,y)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=g;function E(h,p){return`${h||(0,D.localize)(37,null)}
${p||(0,D.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=E}),function(){"use strict";function J(e,R,L,D){function T(C){const S=k(C),b=[S];return e.isAbsolute(S)||b.unshift(D),e.resolve(...b)}function k(C){const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,L);const n=C["user-data-dir"];if(n)return n;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(I,"AppData","Roaming")}break;case"darwin":b=e.join(R.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,L)}return{getUserDataPath:T}}if(typeof define=="function")define(te[148],ne([0,149,32,15,16,31]),function(e,R,L,D,T,k){const C=T.dirname(D.FileAccess.asFileUri("",e)),S=e.__$__nodeRequire(T.joinPath(C,"package.json").fsPath);return J(R,L,S.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),R=require("path"),L=require("os");module.exports=J(R,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[150],ne([0,1,32,75,148]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends L.AbstractNativeEnvironmentService{constructor(C,S){super(C,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,D.getUserDataPath)(C)},S)}}e.NativeEnvironmentService=T}),define(te[151],ne([0,1,7]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,k=/([^@:.]+\.[^@:.]+)(:\d+)?$/,C=/^\s*url\s*=\s*(.+\S)\s*$/mg,S=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(f){const w=f.match(k);return w?w[1]:null}function n(f){if(f.indexOf("://")===-1){const w=f.match(L);return w?b(w[2]):null}try{const w=R.URI.parse(f);if(w.authority)return b(w.authority)}catch(w){}return null}function I(f,w){const v=new Set;let y;for(;y=C.exec(f);){const o=n(y[1]);o&&v.add(o)}const c=new Set(w);return Array.from(v).map(o=>c.has(o)?o:o.replace(S,"a"))}e.getDomainsOfRemotes=I;function g(f){const w=f.match(T);return w?w[2]:null}function E(f,w,v){return f&&w?(v&&w.endsWith(".git")&&(w=w.substr(0,w.length-4)),w.indexOf("/")===0?`${f}${w}`:`${f}/${w}`):null}function h(f,w){if(f.indexOf("://")===-1){const v=f.match(D);if(v)return E(v[2],v[3],w)}try{const v=R.URI.parse(f);if(v.authority)return E(g(v.authority),v.path,w)}catch(v){}return null}function p(f,w=!1){const v=[];let y;for(;y=C.exec(f);){const c=h(y[1],w);c&&v.push(c)}return v}e.getRemotes=p}),define(te[152],ne([0,1,26]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function D(T,k){const C=S=>{if(typeof S!="string")return;const b=L.exec(S);if(!b)return;const n=k[b[1]]??S;return typeof n=="string"?n:typeof n.message=="string"?n.message:S};return(0,R.cloneAndChange)(T,C)}e.localizeManifest=D}),define(te[153],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,k,C,S){return this.channel.call("promptImportantExtensionsInstallNotification",[T,k,C,S])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class L{constructor(T){this.service=T}listen(T,k){throw new Error(`Event not found: ${k}`)}call(T,k,C){switch(k){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(C[0],C[1],C[2],C[3])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(te[76],ne([0,1,133]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function T(g){return g=g.trim(),g==="*"||L.test(g)}e.isValidVersionStr=T;function k(g){if(!T(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=g.match(L);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=k;function C(g){if(!g)return null;let E=g.majorBase,h=g.majorMustEqual,p=g.minorBase,f=g.minorMustEqual,w=g.patchBase,v=g.patchMustEqual;g.hasCaret&&(E===0||(f=!1),v=!1);let y=0;if(g.preRelease){const c=D.exec(g.preRelease);if(c){const[,o,t,s]=c;y=Date.UTC(Number(o),Number(t)-1,Number(s))}}return{majorBase:E,majorMustEqual:h,minorBase:p,minorMustEqual:f,patchBase:w,patchMustEqual:v,isMinimum:g.hasGreaterEquals,notBefore:y}}e.normalizeVersion=C;function S(g,E,h){let p;typeof g=="string"?p=C(k(g)):p=g;let f;E instanceof Date?f=E.getTime():typeof E=="string"&&(f=new Date(E).getTime());let w;if(typeof h=="string"?w=C(k(h)):w=h,!p||!w)return!1;let v=p.majorBase,y=p.minorBase,c=p.patchBase,o=w.majorBase,t=w.minorBase,s=w.patchBase,i=w.notBefore,r=w.majorMustEqual,a=w.minorMustEqual,l=w.patchMustEqual;return w.isMinimum?v>o?!0:v<o?!1:y>t?!0:y<t||f&&f<i?!1:c>=s:(v===1&&o===0&&(!r||!a||!l)&&(o=1,t=0,s=0,r=!0,a=!1,l=!1),v<o?!1:v>o?!r:y<t?!1:y>t?!a:c<s?!1:c>s?!l:!(f&&f<i))}e.isValidVersion=S;function b(g,E,h,p){return h.isBuiltin||typeof h.main=="undefined"?!0:I(g,E,h.engines.vscode,p)}e.isValidExtensionVersion=b;function n(g,E,h){return g==="*"||I(E,h,g)}e.isEngineValid=n;function I(g,E,h,p=[]){let f=C(k(h));if(!f)return p.push(R.localize(0,null,h)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return p.push(R.localize(1,null,h)),!1}else if(!f.majorMustEqual)return p.push(R.localize(2,null,h)),!1;return S(g,E,f)?!0:(p.push(R.localize(3,null,g,h)),!1)}}),define(te[154],ne([0,1,2,15,33,52]),function(J,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends R.Disposable{constructor(S,b,n,I){super();this.requests=S,this.onDidFilesChange=b,this.onLogMessage=n,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new T.Client(L.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=D.ProxyChannel.toService((0,D.getNextTickChannel)(S.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b))),this.watch(this.requests)}setVerboseLogging(S){this.verboseLogging=S,this.isDisposed||this.service?.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${S}`})}watch(S){this.requests=S,this.service?.watch(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(te[155],ne([0,1,2,15,33,52]),function(J,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends R.Disposable{constructor(S,b,n,I,g={}){super();this.folders=S,this.onDidFilesChange=b,this.onLogMessage=n,this.verboseLogging=I,this.watcherOptions=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new T.Client(L.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=D.ProxyChannel.toService((0,D.getNextTickChannel)(S.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(b=>!this.isDisposed&&this.onDidFilesChange(b))),this._register(this.service.onDidLogMessage(b=>this.onLogMessage(b))),this.service.watch(this.folders)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${S}`})}setVerboseLogging(S){this.verboseLogging=S,this.service&&this.service.setVerboseLogging(S)}watch(S){this.folders=S,this.service&&this.service.watch(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(te[156],ne([0,1,37,69,15,70]),function(J,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class k{constructor(S,b,n,I,g){this.watchedFolder=S,this.eventCallback=n,this.logCallback=I,this.verboseLogging=g,this.restartCounter=0,Array.isArray(b)?this.ignored=b.map(E=>(0,L.parse)(E)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${S}, excludes: ${b.join(",")}`),this.startWatcher()}startWatcher(){const S=[this.watchedFolder];this.verboseLogging&&S.push("-verbose"),this.handle=(0,R.spawn)(D.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",J).fsPath,S);const b=new T.LineDecoder;this.handle.stdout.on("data",n=>{const I=[];for(const g of b.write(n)){const E=g.split("|");if(E.length===2){const h=Number(E[0]),p=E[1];if(h>=0&&h<3){if(this.ignored&&this.ignored.some(f=>f(p))){this.verboseLogging&&this.log(p);continue}I.push({type:k.changeTypeMap[h],path:p})}else this.log(E[1])}}I.length>0&&this.eventCallback(I)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,I)=>this.onExit(n,I))}onError(S){this.error("process error: "+S.toString())}onExit(S,b){this.handle&&(this.error(`terminated unexpectedly (code: ${S}, signal: ${b})`),this.restartCounter<=k.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(S){this.logCallback({type:"error",message:`[File Watcher (C#)] ${S}`})}log(S){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${S}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=k,k.MAX_RESTARTS=5,k.changeTypeMap=[0,1,2]}),define(te[157],ne([0,1,9,25,156]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class T{constructor(C,S,b,n){this.onDidFilesChange=S,this.onLogMessage=b,this.verboseLogging=n,this.service=void 0,this.folder=C[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(R.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,R.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new D.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,C=>this.onFileEvents(C),C=>this.onLogMessage(C),this.verboseLogging)}setVerboseLogging(C){this.verboseLogging=C,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(C){this.isDisposed||C.length>0&&this.onDidFilesChange(C)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=T}),define(te[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(D,T=[],k=!1){this.ctor=D,this.staticArguments=T,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=R}),define(te[77],ne([0,1,53]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function D(k,C,S){C instanceof R.SyncDescriptor||(C=new R.SyncDescriptor(C,[],S)),L.push([k,C])}e.registerSingleton=D;function T(){return L}e.getSingletonServiceDescriptors=T}),define(te[158],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=R;class L{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let k of this._nodes.values())k.outgoing.size===0&&T.push(k);return T}insertEdge(T,k){const C=this.lookupOrInsertNode(T),S=this.lookupOrInsertNode(k);C.outgoing.set(this._hashFn(k),S),S.incoming.set(this._hashFn(T),C)}removeNode(T){const k=this._hashFn(T);this._nodes.delete(k);for(let C of this._nodes.values())C.outgoing.delete(k),C.incoming.delete(k)}lookupOrInsertNode(T){const k=this._hashFn(T);let C=this._nodes.get(k);return C||(C=new R(T),this._nodes.set(k,C)),C}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[k,C]of this._nodes)T.push(`${k}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,k]of this._nodes){const C=new Set([T]),S=this._findCycle(k,C);if(S)return S}}_findCycle(T,k){for(let[C,S]of T.outgoing){if(k.has(C))return[...k,C].join(" -> ");k.add(C);const b=this._findCycle(S,k);if(b)return b;k.delete(C)}}}e.Graph=L}),define(te[5],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function S(b){return b[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=S})(R=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function L(C,S,b,n){S[R.DI_TARGET]===S?S[R.DI_DEPENDENCIES].push({id:C,index:b,optional:n}):(S[R.DI_DEPENDENCIES]=[{id:C,index:b,optional:n}],S[R.DI_TARGET]=S)}function D(C){if(R.serviceIds.has(C))return R.serviceIds.get(C);const S=function(b,n,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(S,b,I,!1)};return S.toString=()=>C,R.serviceIds.set(C,S),S}e.createDecorator=D;function T(C){return C}e.refineServiceDecorator=T;function k(C){return function(S,b,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(C,S,n,!0)}}e.optional=k}),define(te[159],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(te[160],ne([0,1,4,25,5]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=R.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",R.isMacintosh),k.set("isLinux",R.isLinux),k.set("isWindows",R.isWindows),k.set("isWeb",R.isWeb),k.set("isMacNative",R.isMacintosh&&!R.isWeb),k.set("isEdge",T.indexOf("Edg/")>=0),k.set("isFirefox",T.indexOf("Firefox")>=0),k.set("isChrome",T.indexOf("Chrome")>=0),k.set("isSafari",T.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var S;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return g.INSTANCE}static true(){return E.INSTANCE}static has(P){return h.create(P)}static equals(P,M){return p.create(P,M)}static notEquals(P,M){return v.create(P,M)}static regex(P,M){return i.create(P,M)}static in(P,M){return f.create(P,M)}static not(P){return y.create(P)}static and(...P){return l.create(P,null)}static or(...P){return u.create(P,null,!0)}static greater(P,M){return c.create(P,M)}static less(P,M){return t.create(P,M)}static deserialize(P,M=!1){if(!!P)return this._deserializeOrExpression(P,M)}static _deserializeOrExpression(P,M){let $=P.split("||");return u.create($.map(U=>this._deserializeAndExpression(U,M)),null,!0)}static _deserializeAndExpression(P,M){let $=P.split("&&");return l.create($.map(U=>this._deserializeOne(U,M)),null)}static _deserializeOne(P,M){if(P=P.trim(),P.indexOf("!=")>=0){let $=P.split("!=");return v.create($[0].trim(),this._deserializeValue($[1],M))}if(P.indexOf("==")>=0){let $=P.split("==");return p.create($[0].trim(),this._deserializeValue($[1],M))}if(P.indexOf("=~")>=0){let $=P.split("=~");return i.create($[0].trim(),this._deserializeRegexValue($[1],M))}if(P.indexOf(" in ")>=0){let $=P.split(" in ");return f.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(P)){const $=P.split(">=");return o.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(P)){const $=P.split(">");return c.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(P)){const $=P.split("<=");return s.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(P)){const $=P.split("<");return t.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(P)?y.create(P.substr(1).trim()):h.create(P)}static _deserializeValue(P,M){if(P=P.trim(),P==="true")return!0;if(P==="false")return!1;let $=/^'([^']*)'$/.exec(P);return $?$[1].trim():P}static _deserializeRegexValue(P,M){if((0,L.isFalsyOrWhitespace)(P)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let $=P.indexOf("/"),U=P.lastIndexOf("/");if($===U||$<0){if(M)throw new Error(`bad regexp-value '${P}', missing /-enclosure`);return console.warn(`bad regexp-value '${P}', missing /-enclosure`),null}let H=P.slice($+1,U),W=P[U+1]==="i"?"i":"";try{return new RegExp(H,W)}catch(x){if(M)throw new Error(`bad regexp-value '${P}', parse error: ${x}`);return console.warn(`bad regexp-value '${P}', parse error: ${x}`),null}}}e.ContextKeyExpr=b;function n(N,P){const M=N?N.substituteConstants():void 0,$=P?P.substituteConstants():void 0;return!M&&!$?!0:!M||!$?!1:M.equals($)}e.expressionsAreEqualWithConstantSubstitution=n;function I(N,P){return N.cmp(P)}class g{constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=g,g.INSTANCE=new g;class E{constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return g.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class h{constructor(P,M){this.key=P,this.negated=M,this.type=2}static create(P,M=null){const $=k.get(P);return typeof $=="boolean"?$?E.INSTANCE:g.INSTANCE:new h(P,M)}cmp(P){return P.type!==this.type?this.type-P.type:m(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=k.get(this.key);return typeof P=="boolean"?P?E.INSTANCE:g.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class p{constructor(P,M,$){this.key=P,this.value=M,this.negated=$,this.type=4}static create(P,M,$=null){if(typeof M=="boolean")return M?h.create(P,$):y.create(P,$);const U=k.get(P);return typeof U=="boolean"?M===(U?"true":"false")?E.INSTANCE:g.INSTANCE:new p(P,M,$)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=k.get(this.key);if(typeof P=="boolean"){const M=P?"true":"false";return this.value===M?E.INSTANCE:g.INSTANCE}return this}evaluate(P){return P.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(P){return P.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=p;class f{constructor(P,M){this.key=P,this.valueKey=M,this.type=10,this.negated=null}static create(P,M){return new f(P,M)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.valueKey,P.key,P.valueKey)}equals(P){return P.type===this.type?this.key===P.key&&this.valueKey===P.valueKey:!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.valueKey),$=P.getValue(this.key);return Array.isArray(M)?M.indexOf($)>=0:typeof $=="string"&&typeof M=="object"&&M!==null?C.call(M,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(P){return P.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this)),this.negated}}e.ContextKeyInExpr=f;class w{constructor(P){this._actual=P,this.type=11}static create(P){return new w(P)}cmp(P){return P.type!==this.type?this.type-P.type:this._actual.cmp(P._actual)}equals(P){return P.type===this.type?this._actual.equals(P._actual):!1}substituteConstants(){return this}evaluate(P){return!this._actual.evaluate(P)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(P){return new w(this._actual.map(P))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class v{constructor(P,M,$){this.key=P,this.value=M,this.negated=$,this.type=5}static create(P,M,$=null){if(typeof M=="boolean")return M?y.create(P,$):h.create(P,$);const U=k.get(P);return typeof U=="boolean"?M===(U?"true":"false")?g.INSTANCE:E.INSTANCE:new v(P,M,$)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=k.get(this.key);if(typeof P=="boolean"){const M=P?"true":"false";return this.value===M?g.INSTANCE:E.INSTANCE}return this}evaluate(P){return P.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(P){return P.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=v;class y{constructor(P,M){this.key=P,this.negated=M,this.type=3}static create(P,M=null){const $=k.get(P);return typeof $=="boolean"?$?g.INSTANCE:E.INSTANCE:new y(P,M)}cmp(P){return P.type!==this.type?this.type-P.type:m(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=k.get(this.key);return typeof P=="boolean"?P?g.INSTANCE:E.INSTANCE:this}evaluate(P){return!P.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(P){return P.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=y;class c{constructor(P,M,$){this.key=P,this.value=M,this.negated=$,this.type=12}static create(P,M,$=null){return new c(P,M,$)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return parseFloat(P.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class o{constructor(P,M,$){this.key=P,this.value=M,this.negated=$,this.type=13}static create(P,M,$=null){return new o(P,M,$)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return parseFloat(P.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=o;class t{constructor(P,M,$){this.key=P,this.value=M,this.negated=$,this.type=14}static create(P,M,$=null){return new t(P,M,$)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return parseFloat(P.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class s{constructor(P,M,$){this.key=P,this.value=M,this.negated=$,this.type=15}static create(P,M,$=null){return new s(P,M,$)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return parseFloat(P.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=s;class i{constructor(P,M){this.key=P,this.regexp=M,this.type=7,this.negated=null}static create(P,M){return new i(P,M)}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.key<P.key)return-1;if(this.key>P.key)return 1;const M=this.regexp?this.regexp.source:"",$=P.regexp?P.regexp.source:"";return M<$?-1:M>$?1:0}equals(P){if(P.type===this.type){const M=this.regexp?this.regexp.source:"",$=P.regexp?P.regexp.source:"";return this.key===P.key&&M===$}return!1}substituteConstants(){return this}evaluate(P){let M=P.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const P=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${P}`}keys(){return[this.key]}map(P){return P.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class r{constructor(P){this._actual=P,this.type=8}static create(P){return new r(P)}cmp(P){return P.type!==this.type?this.type-P.type:this._actual.cmp(P._actual)}equals(P){return P.type===this.type?this._actual.equals(P._actual):!1}substituteConstants(){return this}evaluate(P){return!this._actual.evaluate(P)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(P){return new r(this._actual.map(P))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;function a(N){let P=null;for(let M=0,$=N.length;M<$;M++){const U=N[M].substituteConstants();if(N[M]!==U&&P===null){P=[];for(let H=0;H<M;H++)P[H]=N[H]}P!==null&&(P[M]=U)}return P===null?N:P}class l{constructor(P,M){this.expr=P,this.negated=M,this.type=6}static create(P,M){return l._normalizeArr(P,M)}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,$=this.expr.length;M<$;M++){const U=I(this.expr[M],P.expr[M]);if(U!==0)return U}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=a(this.expr);return P===this.expr?this:l.create(P,this.negated)}evaluate(P){for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].evaluate(P))return!1;return!0}static _normalizeArr(P,M){const $=[];let U=!1;for(const H of P)if(!!H){if(H.type===1){U=!0;continue}if(H.type===0)return g.INSTANCE;if(H.type===6){$.push(...H.expr);continue}$.push(H)}if($.length===0&&U)return E.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(I);for(let H=1;H<$.length;H++)$[H-1].equals($[H])&&($.splice(H,1),H--);if($.length===1)return $[0];for(;$.length>1;){const H=$[$.length-1];if(H.type!==9)break;$.pop();const W=$.pop(),x=$.length===0,q=u.create(H.expr.map(F=>l.create([F,W],null)),null,x);q&&($.push(q),$.sort(I))}return $.length===1?$[0]:new l($,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(let M of this.expr)P.push(...M.keys());return P}map(P){return new l(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.negated){const P=[];for(let M of this.expr)P.push(M.negate());this.negated=u.create(P,this,!0)}return this.negated}}class u{constructor(P,M){this.expr=P,this.negated=M,this.type=9}static create(P,M,$){return u._normalizeArr(P,M,$)}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,$=this.expr.length;M<$;M++){const U=I(this.expr[M],P.expr[M]);if(U!==0)return U}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=a(this.expr);return P===this.expr?this:u.create(P,this.negated,!1)}evaluate(P){for(let M=0,$=this.expr.length;M<$;M++)if(this.expr[M].evaluate(P))return!0;return!1}static _normalizeArr(P,M,$){let U=[],H=!1;if(P){for(let W=0,x=P.length;W<x;W++){const q=P[W];if(!!q){if(q.type===0){H=!0;continue}if(q.type===1)return E.INSTANCE;if(q.type===9){U=U.concat(q.expr);continue}U.push(q)}}if(U.length===0&&H)return g.INSTANCE;U.sort(I)}if(U.length!==0){if(U.length===1)return U[0];for(let W=1;W<U.length;W++)U[W-1].equals(U[W])&&(U.splice(W,1),W--);if(U.length===1)return U[0];if($){for(let W=0;W<U.length;W++)for(let x=W+1;x<U.length;x++)_(U[W],U[x])&&(U.splice(x,1),x--);if(U.length===1)return U[0]}return new u(U,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(let M of this.expr)P.push(...M.keys());return P}map(P){return new u(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.negated){let P=[];for(let M of this.expr)P.push(M.negate());for(;P.length>1;){const M=P.shift(),$=P.shift(),U=[];for(const W of O(M))for(const x of O($))U.push(l.create([W,x],null));const H=P.length===0;P.unshift(u.create(U,null,H))}this.negated=P[0]}return this.negated}}class d extends h{constructor(P,M,$){super(P,null);this._defaultValue=M,typeof $=="object"?d._info.push({...$,key:P}):$!==!0&&d._info.push({key:P,description:$,type:M!=null?typeof M:void 0})}static all(){return d._info.values()}bindTo(P){return P.createKey(this.key,this._defaultValue)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return p.create(this.key,P)}notEqualsTo(P){return v.create(this.key,P)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(N,P){return N<P?-1:N>P?1:0}function A(N,P,M,$){return N<M?-1:N>M?1:P<$?-1:P>$?1:0}function _(N,P){if(P.type===6&&N.type!==9&&N.type!==6){for(const U of P.expr)if(N.equals(U))return!0}const M=N.negate(),$=O(M).concat(O(P));$.sort(I);for(let U=0;U<$.length;U++){const W=$[U].negate();for(let x=U+1;x<$.length;x++){const q=$[x];if(W.equals(q))return!0}}return!1}e.implies=_;function O(N){return N.type===9?N.expr:[N]}}),define(te[78],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function L(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=L}),define(te[79],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(te[13],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(te[28],ne([0,1,15,128,5]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var T;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(T=e.TargetPlatform||(e.TargetPlatform={}));function k(v){switch(v){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function C(v){switch(v){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function S(v,y){switch(v){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function b(v,y){return y==="web"&&!v.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function n(v,y,c){return b(y,c)?!1:v==="undefined"||v==="universal"?!0:v==="unknown"?!1:v===c?!0:I(c).includes(v)}e.isTargetPlatformCompatible=n;function I(v){switch(v){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function g(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=g;var E;(function(v){v[v.NoneOrRelevance=0]="NoneOrRelevance",v[v.LastUpdatedDate=1]="LastUpdatedDate",v[v.Title=2]="Title",v[v.PublisherName=3]="PublisherName",v[v.InstallCount=4]="InstallCount",v[v.PublishedDate=10]="PublishedDate",v[v.AverageRating=6]="AverageRating",v[v.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var h;(function(v){v[v.Default=0]="Default",v[v.Ascending=1]="Ascending",v[v.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var p;(function(v){v.Install="install",v.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var f;(function(v){v[v.None=0]="None",v[v.Install=1]="Install",v[v.Update=2]="Update"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class w extends Error{constructor(y,c){super(y);this.code=c,this.name=c}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")});var Q=this&&this.__param||function(J,e){return function(R,L){e(R,L,J)}};define(te[161],ne([0,1,2,28]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let D=class extends R.Disposable{constructor(k){super();this.extensionManagementService=k,this._register(k),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};D=he([Q(0,L.IExtensionManagementService)],D),e.DeprecatedExtensionsCleaner=D}),define(te[162],ne([0,1,3,2,26,7,106,28]),function(J,e,R,L,D,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function S(p,f){return T.URI.revive(f?f.transformIncoming(p):p)}function b(p,f){return f?f.transformOutgoingURI(p):p}function n(p,f){f=f||k.DefaultURITransformer;const w=p.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...p,manifest:void 0},f),manifest:w}}function I(p,f){return f?(0,D.cloneAndChange)(p,w=>w instanceof T.URI?f.transformOutgoingURI(w):void 0):p}class g{constructor(f,w){this.service=f,this.getUriTransformer=w,this.onInstallExtension=R.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(f.onDidUninstallExtension,!0)}listen(f,w){const v=this.getUriTransformer(f);switch(w){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,y=>y.map(c=>({...c,local:c.local?I(c.local,v):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(f,w,v){const y=this.getUriTransformer(f);switch(w){case"zip":return this.service.zip(n(v[0],y)).then(c=>b(c,y));case"unzip":return this.service.unzip(S(v[0],y));case"install":return this.service.install(S(v[0],y),v[1]);case"getManifest":return this.service.getManifest(S(v[0],y));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(v[0]);case"installFromGallery":return this.service.installFromGallery(v[0],v[1]);case"uninstall":return this.service.uninstall(n(v[0],y),v[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(n(v[0],y));case"getInstalled":return this.service.getInstalled(v[0]).then(c=>c.map(o=>I(o,y)));case"updateMetadata":return this.service.updateMetadata(n(v[0],y),v[1]).then(c=>I(c,y));case"updateExtensionScope":return this.service.updateExtensionScope(n(v[0],y),v[1]).then(c=>I(c,y));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=g;class E extends L.Disposable{constructor(f){super();this.channel=f,this._onInstallExtension=this._register(new R.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new R.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new R.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new R.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(w=>this._onInstallExtension.fire({identifier:w.identifier,source:this.isUriComponents(w.source)?T.URI.revive(w.source):w.source}))),this._register(this.channel.listen("onDidInstallExtensions")(w=>this._onDidInstallExtensions.fire(w.map(v=>({...v,local:v.local?n(v.local,null):v.local,source:this.isUriComponents(v.source)?T.URI.revive(v.source):v.source}))))),this._register(this.channel.listen("onUninstallExtension")(w=>this._onUninstallExtension.fire(w))),this._register(this.channel.listen("onDidUninstallExtension")(w=>this._onDidUninstallExtension.fire(w)))}isUriComponents(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(f){const w=await this.getTargetPlatform();return f.allTargetPlatforms.some(v=>(0,C.isTargetPlatformCompatible)(v,f.allTargetPlatforms,w))}zip(f){return Promise.resolve(this.channel.call("zip",[f]).then(w=>T.URI.revive(w)))}unzip(f){return Promise.resolve(this.channel.call("unzip",[f]))}install(f,w){return Promise.resolve(this.channel.call("install",[f,w])).then(v=>n(v,null))}getManifest(f){return Promise.resolve(this.channel.call("getManifest",[f]))}installFromGallery(f,w){return Promise.resolve(this.channel.call("installFromGallery",[f,w])).then(v=>n(v,null))}uninstall(f,w){return Promise.resolve(this.channel.call("uninstall",[f,w]))}reinstallFromGallery(f){return Promise.resolve(this.channel.call("reinstallFromGallery",[f]))}getInstalled(f=null){return Promise.resolve(this.channel.call("getInstalled",[f])).then(w=>w.map(v=>n(v,null)))}updateMetadata(f,w){return Promise.resolve(this.channel.call("updateMetadata",[f,w])).then(v=>n(v,null))}updateExtensionScope(f,w){return Promise.resolve(this.channel.call("updateExtensionScope",[f,w])).then(v=>n(v,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=E;class h{constructor(f){this.service=f}listen(f,w){throw new Error("Invalid listen")}call(f,w,v){switch(w){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(v[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[80],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function D(k){switch(k){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var T;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[81],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,R.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[82],ne([0,1,25,5]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=D;function T(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class C{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,g){if(typeof I=="undefined"||I===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof I=="string"||typeof g=="string"){let E=typeof I=="string"?I:I.value,h=typeof g=="string"?g:g.value;return R.equalsIgnoreCase(E,h)}return I._lower===g._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=C;function S(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function b(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=b,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[34],ne([0,1,25,82]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(h,p){return h.uuid&&p.uuid?h.uuid===p.uuid:h.id===p.id?!0:(0,R.compareIgnoreCase)(h.id,p.id)===0}e.areSameExtensions=D;class T{constructor(p,f){this.version=f,this.id=p.id,this.uuid=p.uuid}key(){return`${this.id}-${this.version}`}equals(p){return p instanceof T?D(this,p)&&this.version===p.version:!1}}e.ExtensionIdentifierWithVersion=T;function k(h,p){return`${h}.${p}`}e.getExtensionId=k;function C(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function S(h,p){return C(k(h,p))}e.getGalleryExtensionId=S;function b(h,p){const f=[],w=v=>{for(const y of f)if(y.some(c=>D(p(c),p(v))))return y;return null};for(const v of h){const y=w(v);y?y.push(v):f.push([v])}return f}e.groupByExtension=b;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function I(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function g(h){const p=new Set;for(const f of h)f.malicious&&p.add(f.id.id);return p}e.getMaliciousExtensionsSet=g;function E(h,p){const f=[],w=p.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const v=w.shift();if(v&&f.every(y=>!D(y.identifier,{id:v}))){const y=h.filter(c=>D(c.identifier,{id:v}));y.length===1&&(f.push(y[0]),w.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return f}e.getExtensionDependencies=E}),define(te[163],ne([0,1,2,9,19,82]),function(J,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends R.Disposable{constructor(S,b){super();this.environmentService=S,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this._register(b.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtensions(S){S.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(S){S.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(te[14],ne([0,1,41,9,25,18,7,135,5]),function(J,e,R,L,D,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function b(U){return U.create===!0}e.isFileOpenForWriteOptions=b;var n;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var I;(function(U){U[U.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var g;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=E;function h(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=h;function p(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function f(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=f;var w;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(H,W){super(H);this.code=W}}e.FileSystemProviderError=v;function y(U,H){const W=new v(U.toString(),H);return o(W,H),W}e.createFileSystemProviderError=y;function c(U){return U||y((0,C.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=c;function o(U,H){return U.name=H?`${H} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=o;function t(U){if(!U)return w.Unknown;if(U instanceof v)return U.code;const H=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!H)return w.Unknown;switch(H[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function s(U){if(U instanceof d)return U.fileOperationResult;switch(t(U)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var i;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(H,W,x){this.resource=H,this.operation=W,this.target=x}isOperation(H){return this.operation===H}}e.FileOperationEvent=r;var a;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class l{constructor(H,W){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const x of H)switch(x.type){case 1:this.added||(this.added=R.TernarySearchTree.forUris(()=>W)),this.added.set(x.resource,x);break;case 0:this.updated||(this.updated=R.TernarySearchTree.forUris(()=>W)),this.updated.set(x.resource,x);break;case 2:this.deleted||(this.deleted=R.TernarySearchTree.forUris(()=>W)),this.deleted.set(x.resource,x);break}}contains(H,...W){return this.doContains(H,{includeChildren:!1},...W)}affects(H,...W){return this.doContains(H,{includeChildren:!0},...W)}doContains(H,W,...x){if(!H)return!1;const q=x.length>0;return!!((!q||x.includes(1))&&(this.added?.get(H)||W.includeChildren&&this.added?.findSuperstr(H))||(!q||x.includes(0))&&(this.updated?.get(H)||W.includeChildren&&this.updated?.findSuperstr(H))||(!q||x.includes(2))&&(this.deleted?.findSubstr(H)||W.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function u(U,H,W){return!U||!H||U===H||H.length>U.length?!1:(H.charAt(H.length-1)!==L.sep&&(H+=L.sep),W?(0,D.startsWithIgnoreCase)(U,H):U.indexOf(H)===0)}e.isParent=u;class d extends Error{constructor(H,W,x){super(H);this.fileOperationResult=W,this.options=x}}e.FileOperationError=d;class m extends d{constructor(H,W,x){super(H,2,x);this.stat=W}}e.NotModifiedSinceFileOperationError=m;var A;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=O;async function N(U,H){if(!H.canHandleResource(k.URI.from({scheme:U.scheme})))return new Promise(W=>{const x=H.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===U.scheme&&q.added&&(x.dispose(),W())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class P{static formatSize(H){return(0,T.isNumber)(H)||(H=0),H<P.KB?(0,C.localize)(1,null,H.toFixed(0)):H<P.MB?(0,C.localize)(2,null,(H/P.KB).toFixed(2)):H<P.GB?(0,C.localize)(3,null,(H/P.MB).toFixed(2)):H<P.TB?(0,C.localize)(4,null,(H/P.GB).toFixed(2)):(0,C.localize)(5,null,(H/P.TB).toFixed(2))}}e.ByteSize=P,P.KB=1024,P.MB=P.KB*P.KB,P.GB=P.MB*P.KB,P.TB=P.GB*P.KB;var M;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(M=e.Arch||(e.Arch={}));function $(U){return{maxFileSize:U===0?300*P.MB:16*P.GB,maxHeapSize:U===0?700*P.MB:2*700*P.MB}}e.getPlatformLimits=$}),define(te[164],ne([0,1,83,50,14]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(C){this.fileService=C}checksum(C){return new Promise(async(S,b)=>{const n=(0,R.createHash)("md5"),I=(await this.fileService.readFileStream(C)).value;(0,L.listenStream)(I,{onData:g=>n.update(g.buffer),onError:g=>b(g),onEnd:()=>S(n.digest("base64").replace(/=+$/,""))})})}};T=he([Q(0,D.IFileService)],T),e.ChecksumService=T}),define(te[165],ne([0,1,238,125,147,14]),function(J,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(g,E){const h={onUnknownOption:f=>{console.warn((0,L.localize)(0,null,f))},onMultipleValues:(f,w)=>{console.warn((0,L.localize)(1,null,f,w))}},p=(0,D.parseArgs)(g,D.OPTIONS,E?h:void 0);return p.goto&&p._.forEach(f=>R(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,L.localize)(2,null))),p["max-memory"]&&R(parseInt(p["max-memory"])>=T.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${T.MIN_MAX_MEMORY_SIZE_MB} MB.`),p}function C(g){const E=g.findIndex(h=>!/^-/.test(h));if(E>-1)return[...g.slice(0,E),...g.slice(E+1)]}function S(g){let[,...E]=g;process.env.VSCODE_DEV&&(E=C(E)||[]);const h=!I(process.env);return k(E,h)}e.parseMainProcessArgv=S;function b(g){const[,,...E]=g;return k(E,!0)}e.parseCLIProcessArgv=b;function n(g,...E){const h=g.indexOf("--");return h===-1?g.push(...E):g.splice(h,0,...E),g}e.addArg=n;function I(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(te[166],ne([0,1,149,37,126,27,38,8,4,30,121,165]),function(J,e,R,L,D,T,k,C,S,b,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const g=1e4;let E;async function h(f,w,v){return w["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(v)&&!w["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(v)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=new Promise(async(y,c)=>{const o=new T.CancellationTokenSource,t=setTimeout(()=>{o.dispose(!0),c((0,D.localize)(0,null))},g);try{y(await p(f,o.token))}catch(s){!(0,C.isPromiseCanceledError)(s)&&!o.token.isCancellationRequested&&c((0,D.localize)(1,null,(0,k.toErrorMessage)(s))),y({})}finally{clearTimeout(t),o.dispose()}})),E)}e.resolveShellEnv=h;async function p(f,w){return new Promise(async(v,y)=>{const c=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",c);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",o);const t=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(t+"(.*)"+t),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};f.trace("getUnixShellEnvironment#env",i);const r=await(0,n.getSystemShell)(S.OS,i);if(f.trace("getUnixShellEnvironment#shell",r),w.isCancellationRequested)return y(C.canceled);const a=(0,R.basename)(r);let l,u;/^pwsh(-preview)?$/.test(a)?(l=`& '${process.execPath}' -p '''${t}'' + JSON.stringify(process.env) + ''${t}'''`,u=["-Login","-Command"]):(l=`'${process.execPath}' -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,u=["-ilc"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),l);const d=(0,L.spawn)(r,[...u,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});w.onCancellationRequested(()=>(d.kill(),y(C.canceled))),d.on("error",_=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(_)),y(_)});const m=[];d.stdout.on("data",_=>m.push(_));const A=[];d.stderr.on("data",_=>A.push(_)),d.on("close",(_,O)=>{const N=Buffer.concat(m).toString("utf8");f.trace("getUnixShellEnvironment#raw",N);const P=Buffer.concat(A).toString("utf8");if(P.trim()&&f.trace("getUnixShellEnvironment#stderr",P),_||O)return y(new Error((0,D.localize)(2,null,_,O)));const M=s.exec(N),$=M?M[1]:"{}";try{const U=JSON.parse($);c?U.ELECTRON_RUN_AS_NODE=c:delete U.ELECTRON_RUN_AS_NODE,o?U.ELECTRON_NO_ATTACH_CONSOLE=o:delete U.ELECTRON_NO_ATTACH_CONSOLE,delete U.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",U),v(U)}catch(U){f.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(U)),y(U)}})})}}),define(te[84],ne([0,1,4,7,14]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function T(S){return S.map(b=>({type:b.type,resource:L.URI.file(b.path)}))}e.toFileChanges=T;function k(S){const b=new C;for(const n of S)b.processEvent(n);return b.normalize()}e.normalizeFileChanges=k;class C{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(b){return R.isLinux?b.path:b.path.toLowerCase()}processEvent(b){const n=this.mapPathToChange.get(this.toKey(b));let I=!1;if(n){const g=n.type,E=b.type;n.path!==b.path&&(E===1||E===0)?(n.type=2,I=!0):g===1&&E===2?(this.mapPathToChange.delete(this.toKey(b)),this.normalized.delete(n)):g===2&&E===1?n.type=0:g===1&&E===0||(n.type=E)}else I=!0;I&&(this.normalized.add(b),this.mapPathToChange.set(this.toKey(b),b))}normalize(){const b=[],n=[];return Array.from(this.normalized).filter(I=>I.type!==2?(b.push(I),!1):!0).sort((I,g)=>I.path.length-g.path.length).filter(I=>n.some(g=>(0,D.isParent)(I.path,g,!R.isLinux))?!1:(n.push(I.path),!0)).concat(b)}}}),define(te[167],ne([0,1,6,2,9,110,19,113,84]),function(J,e,R,L,D,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b extends L.Disposable{constructor(I,g,E,h){super();this.path=I,this.onDidFilesChange=g,this.onLogMessage=E,this.verboseLogging=h,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(C.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:g}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let E=this.path;if(g)try{E=await(0,T.realpath)(E)}catch(h){if(this.onError(h),g.dangling)return}I.isDirectory()?this._register((0,C.watchFolder)(E,(h,p)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,D.join)(this.path,(0,D.basename)(p))})},h=>this.onError(h))):this._register((0,C.watchFile)(E,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const E=(0,S.normalizeFileChanges)(g);if(this.verboseLogging)for(const h of E)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);E.length>0&&this.onDidFilesChange(E)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=b}),define(te[85],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...D){this._entries=new Map;for(let[T,k]of D)this.set(T,k)}set(D,T){const k=this._entries.get(D);return this._entries.set(D,T),k}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=R}),define(te[168],ne([0,1,6,8,53,158,5,85]),function(J,e,R,L,D,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class b extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class n{constructor(h=new C.ServiceCollection,p=!1,f){this._activeInstantiations=new Set,this._services=h,this._strict=p,this._parent=f,this._services.set(k.IInstantiationService,this)}createChild(h){return new n(h,this._strict,this)}invokeFunction(h,...p){let f=g.traceInvocation(h),w=!1;try{return h({get:(y,c)=>{if(w)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(y,f);if(!o&&c!==k.optional)throw new Error(`[invokeFunction] unknown service '${y}'`);return o}},...p)}finally{w=!0,f.stop()}}createInstance(h,...p){let f,w;return h instanceof D.SyncDescriptor?(f=g.traceCreation(h.ctor),w=this._createInstance(h.ctor,h.staticArguments.concat(p),f)):(f=g.traceCreation(h),w=this._createInstance(h,p,f)),f.stop(),w}_createInstance(h,p=[],f){let w=k._util.getServiceDependencies(h).sort((c,o)=>c.index-o.index),v=[];for(const c of w){let o=this._getOrCreateServiceInstance(c.id,f);if(!o&&this._strict&&!c.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${c.id}.`);v.push(o)}let y=w.length>0?w[0].index:p.length;if(p.length!==y){console.warn(`[createInstance] First service dependency of ${h.name} at position ${y+1} conflicts with ${p.length} static arguments`);let c=y-p.length;c>0?p=p.concat(new Array(c)):p=p.slice(0,y)}return new h(...[...p,...v])}_setServiceInstance(h,p){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,p);else if(this._parent)this._parent._setServiceInstance(h,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let p=this._services.get(h);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):p}_getOrCreateServiceInstance(h,p){let f=this._getServiceInstanceOrDescriptor(h);return f instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,f,p.branch(h,!0)):(p.branch(h,!1),f)}_safeCreateAndCacheServiceInstance(h,p,f){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,p,f)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,p,f){const w=new T.Graph(c=>c.id.toString());let v=0;const y=[{id:h,desc:p,_trace:f}];for(;y.length;){const c=y.pop();if(w.lookupOrInsertNode(c),v++>1e3)throw new b(w);for(let o of k._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(o.id);if(!t&&!o.optional&&console.warn(`[createInstance] ${h} depends on ${o.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const s={id:o.id,desc:t,_trace:c._trace.branch(o.id,!0)};w.insertEdge(c,s),y.push(s)}}}for(;;){const c=w.roots();if(c.length===0){if(!w.isEmpty())throw new b(w);break}for(const{data:o}of c){if(this._getServiceInstanceOrDescriptor(o.id)instanceof D.SyncDescriptor){const s=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,s)}w.removeNode(o)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,p,f=[],w,v){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(p,f,w,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,p,f,w,v);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(h,p=[],f,w){if(f){const v=new R.IdleValue(()=>this._createInstance(h,p,w));return new Proxy(Object.create(null),{get(y,c){if(c in y)return y[c];let o=v.value,t=o[c];return typeof t!="function"||(t=t.bind(o),y[c]=t),t},set(y,c,o){return v.value[c]=o,!0}})}else return this._createInstance(h,p,w)}}e.InstantiationService=n;var I;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(I||(I={}));class g{constructor(h,p){this.type=h,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return S?new g(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(h){return S?new g(0,h.name):g._None}branch(h,p){let f=new g(2,h.toString());return this._dep.push([h,p,f]),f}stop(){let h=Date.now()-this._start;g._totals+=h;let p=!1;function f(v,y){let c=[],o=new Array(v+1).join("	");for(const[t,s,i]of y._dep)if(s&&i){p=!0,c.push(`${o}CREATES -> ${t}`);let r=f(v+1,i);r&&c.push(r)}else c.push(`${o}uses -> ${t}`);return c.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(h>2||p)&&console.log(w.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(te[169],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class R{constructor(D,T){this.server=D,this.router=T}getChannel(D){return this.server.getChannel(D,this.router)}registerChannel(D,T){this.server.registerChannel(D,T)}}e.MessagePortMainProcessService=R}),define(te[170],ne([0,1,33,53,77,5]),function(J,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class k{constructor(E,h,p){const f=p.getChannel(E);return C(h)?new h.channelClientCtor(f):R.ProxyChannel.toService(f,h?.proxyOptions)}}function C(g){return!!g?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let S=class extends k{constructor(E,h,p){super(E,h,p)}};S=he([Q(2,e.IMainProcessService)],S);function b(g,E,h){(0,D.registerSingleton)(g,new L.SyncDescriptor(S,[E,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let n=class extends k{constructor(E,h,p){super(E,h,p)}};n=he([Q(2,e.ISharedProcessService)],n);function I(g,E,h){(0,D.registerSingleton)(g,new L.SyncDescriptor(n,[E,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=I}),define(te[58],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,R.createDecorator)("localizationsService");function L(D){if(typeof D.languageId!="string"||!Array.isArray(D.translations)||D.translations.length===0)return!1;for(const T of D.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(D.languageName&&typeof D.languageName!="string"||D.localizedLanguageName&&typeof D.localizedLanguageName!="string")}e.isValidLocalization=L}),define(te[171],ne([0,1,2,58]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends R.Disposable{constructor(k){super();this.localizationsService=k,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};D=he([Q(0,L.ILocalizationsService)],D),e.LocalizationsUpdater=D}),define(te[10],ne([0,1,38,3,2,4,5]),function(J,e,R,L,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function C(){return new Date().toISOString()}var S;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class b extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class n extends b{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(S.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(S.Error,this.format(i))}else this.log(S.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let i=0;i<t.length;i++){let r=t[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}s+=(i>0?" ":"")+r}return s}}e.AbstractMessageLogger=n;class I extends b{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...s){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...s):console.log(`[main ${C()}]`,t,...s))}debug(t,...s){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...s):console.log(`[main ${C()}]`,t,...s))}info(t,...s){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...s):console.log(`[main ${C()}]`,t,...s))}warn(t,...s){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...s):console.warn(`[main ${C()}]`,t,...s))}error(t,...s){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...s):console.error(`[main ${C()}]`,t,...s))}critical(t,...s){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...s):console.error(`[main ${C()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class g extends b{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=g;class E extends b{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,R.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=E;class h extends b{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const i of this.logServices)i.trace(t,...s)}debug(t,...s){for(const i of this.logServices)i.debug(t,...s)}info(t,...s){for(const i of this.logServices)i.info(t,...s)}warn(t,...s){for(const i of this.logServices)i.warn(t,...s)}error(t,...s){for(const i of this.logServices)i.error(t,...s)}critical(t,...s){for(const i of this.logServices)i.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=h;class p extends D.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=p;class f extends D.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(i))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,s){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,s?.always?S.Trace:this.logLevel,s),this.loggers.set(t.toString(),i),s?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=f;class w{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=w;function v(o){if(o.verbose)return S.Trace;if(typeof o.logLevel=="string"){const t=y(o.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=v;function y(o){switch(o){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=y;function c(o){switch(o){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=c}),define(te[172],ne([0,1,6,8,2,9,19,13,10]),function(J,e,R,L,D,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends D.Disposable{constructor(I,g){super();this.environmentService=I,this.logService=g,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const I=(0,T.basename)(this.environmentService.logsPath),g=(0,T.dirname)(this.environmentService.logsPath),p=(await k.Promises.readdir(g)).filter(w=>/^\d{8}T\d{6}$/.test(w)).sort().filter(w=>w!==I),f=p.slice(0,Math.max(0,p.length-9));f.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(w=>k.Promises.rm((0,T.join)(g,w)))))}catch(I){(0,L.onUnexpectedError)(I)}}};b=he([Q(0,C.IEnvironmentService),Q(1,S.ILogService)],b),e.LogsDataCleaner=b}),define(te[173],ne([0,1,6,8,2,9,19,13,10]),function(J,e,R,L,D,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let b=class mt extends D.Disposable{constructor(I,g,E){super();this.backupWorkspacesPath=I,this.environmentService=g,this.logService=E,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const I=await k.Promises.readFile(this.backupWorkspacesPath,"utf8"),E=JSON.parse(I).emptyWorkspaceInfos.map(p=>p.backupFolder),h=await k.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async p=>{p.length!==mt.NON_EMPTY_WORKSPACE_ID_LENGTH&&E.indexOf(p)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${p}.`),await k.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,p)))}))}catch(I){(0,L.onUnexpectedError)(I)}}};b.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,b=he([Q(1,C.INativeEnvironmentService),Q(2,S.ILogService)],b),e.StorageDataCleaner=b}),define(te[174],ne([0,1,6,8,2,4,16,59,7,30,19,13,28,34,14,10]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const f=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let w=class extends D.Disposable{constructor(y,c,o,t){super();this.fileService=c,this.extensionGalleryService=o,this.logService=t,this.extensionsDownloadDir=S.URI.file(y.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(y,c){await this.cleanUpPromise;const o=this.getName(y),t=(0,k.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(t)){const s=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(y,s,c);try{await this.rename(s,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(s)}catch(r){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",y.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,s.path),i}}return t}async delete(y){await this.cleanUpPromise,await this.fileService.del(y)}async rename(y,c,o){try{await n.Promises.rename(y.fsPath,c.fsPath)}catch(t){if(T.isWindows&&t&&t.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${y} to ${c} with 'EPERM' error. Trying again...`),this.rename(y,c,o);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const y=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(y.children){const c=[],o=[];for(const i of y.children){const r=this.parse(i.name);r&&o.push([r,i])}const t=(0,E.groupByExtension)(o,([i])=>i),s=[];for(const i of t)i.sort((r,a)=>C.rcompare(r[0].version,a[0].version)),c.push(...i.slice(1).map(r=>r[1].resource)),s.push(i[0][1]);s.sort((i,r)=>i.mtime-r.mtime),c.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(i=>i.resource)),await R.Promises.settled(c.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(y){this.logService.error(y)}}getName(y){return this.cache?`${new E.ExtensionIdentifierWithVersion(y.identifier,y.version).key().toLowerCase()}${y.properties.targetPlatform!=="undefined"?`-${y.properties.targetPlatform}`:""}`:(0,b.generateUuid)()}parse(y){const c=f.exec(y);return c&&c[1]&&c[2]?new E.ExtensionIdentifierWithVersion({id:c[1]},c[2]):null}};w=he([Q(0,I.INativeEnvironmentService),Q(1,h.IFileService),Q(2,g.IExtensionGalleryService),Q(3,p.ILogService)],w),e.ExtensionsDownloader=w}),define(te[175],ne([0,1,37,6,38,3,2,15,9,19,13,10]),function(J,e,R,L,D,T,k,C,S,b,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends k.Disposable{constructor(h,p){super();this.environmentService=h,this.logService=p,this.processesLimiter=new L.Limiter(5)}async postUninstall(h){const p=this.parseScript(h,"uninstall");return p&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(p.script,"uninstall",p.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),f=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${f}`)))),b.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,f=>this.logService.error("Error while removing extension storage path",f))}parseScript(h,p){const f=`vscode:${p}`;if(h.location.scheme===C.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[f]=="string"){const w=h.manifest.scripts[f].split(" ");return w.length<2||w[0]!=="node"||!w[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${f} should be a node script`),null):{script:(0,S.join)(h.location.fsPath,w[1]),args:w.slice(2)||[]}}return null}runLifecycleHook(h,p,f,w,v){return new Promise((y,c)=>{const o=this.start(h,p,f,v);let t;const s=i=>{t&&(clearTimeout(t),t=null),i?c(i):y(void 0)};o.on("error",i=>{s((0,D.toErrorMessage)(i)||"Unknown")}),o.on("exit",(i,r)=>{s(i?`post-${p} process exited with code ${i}`:void 0)}),w&&(t=setTimeout(()=>{t=null,o.kill(),c("timed out")},5e3))})}start(h,p,f,w){const v={silent:!0,execArgv:void 0},y=(0,R.fork)(h,[`--type=extension-post-${p}`,...f],v);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const c=T.Event.fromNodeEventEmitter(y.stdout,"data"),o=T.Event.fromNodeEventEmitter(y.stderr,"data");c(i=>this.logService.info(w.identifier.id,w.manifest.version,`post-${p}`,i)),o(i=>this.logService.error(w.identifier.id,w.manifest.version,`post-${p}`,i));const t=T.Event.any(T.Event.map(c,i=>({data:`%c${i}`,format:[""]})),T.Event.map(o,i=>({data:`%c${i}`,format:["color: red"]})));return T.Event.debounce(t,(i,r)=>i?{data:i.data+r.data,format:[...i.format,...r.format]}:{data:r.data,format:r.format},100)(i=>{console.group(w.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),y}getExtensionStoragePath(h){return(0,S.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};g=he([Q(0,n.IEnvironmentService),Q(1,I.ILogService)],g),e.ExtensionsLifecycle=g}),define(te[176],ne([0,1,3,2,16,7,13,34,14,10]),function(J,e,R,L,D,T,k,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends L.Disposable{constructor(g,E,h,p){super();this.extensionsManagementService=g,this.logService=p,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(v=>{this.installedExtensions=v.map(y=>y.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(v=>this.onInstallExtension(v))),this._register(g.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(g.onDidUninstallExtension(v=>this.onDidUninstallExtension(v)));const f=T.URI.file(h.extensionsPath),w=new D.ExtUri(v=>!E.hasCapability(v,1024));this._register(E.watch(f)),this._register(R.Event.filter(E.onDidChangeFilesRaw,v=>v.changes.some(y=>this.doesChangeAffects(y,f,w)))(()=>this.onDidChange()))}doesChangeAffects(g,E,h){return h.isEqual(h.dirname(g.resource),E)?h.isEqual(g.resource,h.joinPath(E,".obsolete"))?!0:!(g.type!==1&&g.type!==2||h.basename(g.resource).startsWith(".")):!1}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const E of g)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(E=>!(0,C.areSameExtensions)(E,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,C.areSameExtensions)(E,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(1),E=g.filter(p=>[...this.installingExtensions,...this.installedExtensions].some(f=>(0,C.areSameExtensions)(f,p.identifier))?!1:p.installedTimestamp&&p.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",p.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",p.identifier.id),!1)),h=this.installedExtensions.filter(p=>this.installingExtensions.some(f=>(0,C.areSameExtensions)(f,p))?!1:g.every(f=>!(0,C.areSameExtensions)(f.identifier,p))?(this.logService.info("Detected extension removed from another source",p.id),!0):!1);this.installedExtensions=g.map(p=>p.identifier),(E.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:h})}}};n=he([Q(1,S.IFileService),Q(2,k.INativeEnvironmentService),Q(3,b.ILogService)],n),e.ExtensionsWatcher=n}),define(te[177],ne([0,1,8,2,81,3,37,15,107,4,10,77]),function(J,e,R,L,D,T,k,C,S,b,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let g=class extends L.Disposable{constructor(p,f){super();this.id=p,this._logService=f,this._onStdout=this._register(new T.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new T.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new T.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onExit=this._register(new T.Emitter),this.onExit=this._onExit.event,this._process=null}register(p){this._register(p)}start(p){this._process=(0,k.fork)(C.FileAccess.asFileUri("bootstrap-fork",J).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],p);const f=this._process.pid;this._logService.info(`Starting extension host with pid ${f}.`);const w=new S.StringDecoder("utf-8");this._process.stdout?.on("data",y=>{const c=typeof y=="string"?y:w.write(y);this._onStdout.fire(c)});const v=new S.StringDecoder("utf-8");return this._process.stderr?.on("data",y=>{const c=typeof y=="string"?y:v.write(y);this._onStderr.fire(c)}),this._process.on("message",y=>{this._onMessage.fire(y)}),this._process.on("error",y=>{this._onError.fire({error:(0,R.transformErrorForSerialization)(y)})}),this._process.on("exit",(y,c)=>{this._onExit.fire({pid:f,code:y,signal:c})}),{pid:f}}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):b.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}};g=he([Q(1,n.ILogService)],g);let E=class vt{constructor(p){this._logService=p,this._extHosts=new Map}dispose(){}_getExtHost(p){const f=this._extHosts.get(p);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout(p){return this._getExtHost(p).onStdout}onDynamicStderr(p){return this._getExtHost(p).onStderr}onDynamicMessage(p){return this._getExtHost(p).onMessage}onDynamicError(p){return this._getExtHost(p).onError}onDynamicExit(p){return this._getExtHost(p).onExit}async createExtensionHost(){const p=String(++vt._lastId),f=new g(p,this._logService);return this._extHosts.set(p,f),f.onExit(({pid:w,code:v,signal:y})=>{this._logService.info(`Extension host with pid ${w} exited with code: ${v}, signal: ${y}.`),setTimeout(()=>{f.dispose(),this._extHosts.delete(p)})}),{id:p}}async start(p,f){return this._getExtHost(p).start(f)}async enableInspectPort(p){const f=this._extHosts.get(p);return f?f.enableInspectPort():!1}async kill(p){const f=this._extHosts.get(p);!f||f.kill()}};E._lastId=0,E=he([Q(0,n.ILogService)],E),e.ExtensionHostStarter=E,(0,I.registerSingleton)(D.IExtensionHostStarter,E,!0)}),define(te[178],ne([0,1,83,17,6,2,15,9,19,13,28,34,58,10]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends T.Disposable{constructor(w,v,y){super();this.extensionManagementService=w,this.logService=y,this.cache=this._register(new p(v,y)),this.extensionManagementService.registerParticipant({postInstall:async c=>this.postInstallExtension(c),postUninstall:async c=>this.postUninstallExtension(c)})}async getLanguageIds(){const w=await this.cache.getLanguagePacks(),v=["en",...Object.keys(w)];return(0,L.distinct)(v)}async postInstallExtension(w){w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",w.identifier.id),await this.update())}async postUninstallExtension(w){const v=await this.cache.getLanguagePacks();Object.keys(v).some(y=>v[y]&&v[y].extensions.some(c=>(0,I.areSameExtensions)(c.extensionIdentifier,w.identifier)))&&(this.logService.info("Removing language packs from the extension",w.identifier.id),await this.update())}async update(){const[w,v]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),y=await this.cache.update(v);return!(0,L.equals)(Object.keys(w),Object.keys(y))}};h=he([Q(0,n.IExtensionManagementService),Q(1,b.INativeEnvironmentService),Q(2,E.ILogService)],h),e.LocalizationsService=h;let p=class extends T.Disposable{constructor(w,v){super();this.logService=v,this.languagePacks={},this.languagePacksFilePath=(0,C.join)(w.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(w){return this.withLanguagePacks(v=>{Object.keys(v).forEach(y=>delete v[y]),this.createLanguagePacksFromExtensions(v,...w)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(w,...v){for(const y of v)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(w,y);Object.keys(w).forEach(y=>this.updateHash(w[y]))}createLanguagePacksFromExtension(w,v){const y=v.identifier,c=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const o of c)if(v.location.scheme===k.Schemas.file&&(0,g.isValidLocalization)(o)){let t=w[o.languageId];t||(t={hash:"",extensions:[],translations:{}},w[o.languageId]=t);let s=t.extensions.filter(i=>(0,I.areSameExtensions)(i.extensionIdentifier,y))[0];s?s.version=v.manifest.version:t.extensions.push({extensionIdentifier:y,version:v.manifest.version});for(const i of o.translations)t.translations[i.id]=(0,C.join)(v.location.fsPath,i.path)}}updateHash(w){if(w){const v=(0,R.createHash)("md5");for(const y of w.extensions)v.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);w.hash=v.digest("hex")}}withLanguagePacks(w=()=>null){return this.languagePacksFileLimiter.queue(()=>{let v=null;return S.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch(c){return{}}}).then(y=>(v=w(y),y)).then(y=>{for(const o of Object.keys(y))y[o]||delete y[o];this.languagePacks=y,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),S.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>v,y=>this.logService.error(y))})}};p=he([Q(0,b.INativeEnvironmentService),Q(1,E.ILogService)],p)}),define(te[86],ne([0,1,3,7,10]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(g){this.service=g,this.onDidChangeLogLevel=R.Event.buffer(g.onDidChangeLogLevel,!0)}listen(g,E){switch(E){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${E}`)}async call(g,E,h){switch(E){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${E}`)}}e.LogLevelChannel=T;class k{constructor(g){this.channel=g}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(g){k.setLevel(this.channel,g)}static setLevel(g,E){return g.call("setLevel",E)}}e.LogLevelChannelClient=k;class C{constructor(g){this.loggerService=g,this.loggers=new Map}listen(g,E){throw new Error(`Event not found: ${E}`)}async call(g,E,h){switch(E){case"createLogger":this.createLogger(L.URI.revive(h[0]),h[1]);return;case"log":return this.log(L.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${E}`)}createLogger(g,E){this.loggers.set(g.toString(),this.loggerService.createLogger(g,E))}consoleLog(g,E){let h=console.log;switch(g){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...E)}log(g,E){const h=this.loggers.get(g.toString());if(!h)throw new Error("Create the logger before logging");for(const[p,f]of E)switch(p){case D.LogLevel.Trace:h.trace(f);break;case D.LogLevel.Debug:h.debug(f);break;case D.LogLevel.Info:h.info(f);break;case D.LogLevel.Warning:h.warn(f);break;case D.LogLevel.Error:h.error(f);break;case D.LogLevel.Critical:h.critical(f);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=C;class S extends D.AbstractLoggerService{constructor(g,E,h){super(g,E);this.channel=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(g,E)=>{this.channel.call("consoleLog",[g,E])}})}doCreateLogger(g,E,h){return new b(this.channel,g,E,h)}}e.LoggerChannelClient=S;class b extends D.AbstractMessageLogger{constructor(g,E,h,p){super(p?.always);this.channel=g,this.file=E,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[E,p]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(g,E){const h=[[g,E]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(g){this.channel.call("log",[this.file,g])}}class n extends D.LogService{constructor(g,E){super(E);this.parent=g,this._register(g.onDidChangeLogLevel(h=>E.setLevel(h)))}setLevel(g){super.setLevel(g),this.parent.setLevel(g)}}e.FollowerLogService=n}),define(te[60],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(te[42],ne([0,1,15,4,31,16]),function(J,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const C=L.globals.vscode.context.configuration();if(C)k=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const C=(0,T.dirname)(R.FileAccess.asFileUri("",J));k=J.__$__nodeRequire((0,T.joinPath)(C,"product.json").fsPath);const S=J.__$__nodeRequire((0,T.joinPath)(C,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:S.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(te[87],ne([0,1,22,8,136,14,42]),function(J,e,R,L,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function C(I,g,E,h,p,f){let w;try{await S(I,g,E,h,p,f)}catch(v){w=v}finally{w&&p.errorTransformer&&(w=p.errorTransformer(w)),typeof w!="undefined"&&E.error(w),E.end()}}e.readFileIntoStream=C;async function S(I,g,E,h,p,f){b(f);const w=await I.open(g,{create:!1});try{b(f);let v=0,y=0,c=p&&typeof p.length=="number"?p.length:void 0,o=R.VSBuffer.alloc(Math.min(p.bufferSize,typeof c=="number"?c:p.bufferSize)),t=p&&typeof p.position=="number"?p.position:0,s=0;do y=await I.read(w,t,o.buffer,s,o.byteLength-s),t+=y,s+=y,v+=y,typeof c=="number"&&(c-=y),s===o.byteLength&&(await E.write(h(o)),o=R.VSBuffer.alloc(Math.min(p.bufferSize,typeof c=="number"?c:p.bufferSize)),s=0);while(y>0&&(typeof c!="number"||c>0)&&b(f)&&n(v,p));if(s>0){let i=s;typeof c=="number"&&(i=Math.min(s,c)),E.write(h(o.slice(0,i)))}}catch(v){throw(0,T.ensureFileSystemProviderError)(v)}finally{await I.close(w)}}function b(I){if(I.isCancellationRequested)throw(0,L.canceled)();return!0}function n(I,g){if(g?.limits){if(typeof g.limits.memory=="number"&&I>g.limits.memory)throw(0,T.createFileSystemProviderError)((0,D.localize)(0,null,k.default.nameShort),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&I>g.limits.size)throw(0,T.createFileSystemProviderError)((0,D.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[179],ne([0,1,17,6,22,27,3,55,2,41,15,180,16,50,134,14,87,10]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class He extends S.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new k.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(He.FILE_EVENTS_THROTTLING.maxChangesChunkSize,He.FILE_EVENTS_THROTTLING.maxChangesBufferSize,He.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new p.FileChangesEvent(o,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(He.FILE_EVENTS_THROTTLING.maxChangesChunkSize,He.FILE_EVENTS_THROTTLING.maxChangesBufferSize,He.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new p.FileChangesEvent(o,!0)))),this.watchedResources=b.TernarySearchTree.forUris(o=>{const t=this.getProvider(o.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(c,o){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${c}`),this.provider.set(c,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:o});const t=new S.DisposableStore;return t.add(o.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(o)))),t.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:c}))),typeof o.onDidErrorOccur=="function"&&t.add(o.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:o}),this.provider.delete(c),(0,S.dispose)(t)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(t){o.push(t)}}),!this.provider.has(c)&&await L.Promises.settled(o)}canHandleResource(c){return this.provider.has(c.scheme)}hasCapability(c,o){const t=this.provider.get(c.scheme);return!!(t&&t.capabilities&o)}listCapabilities(){return C.Iterable.map(this.provider,([c,o])=>({scheme:c,capabilities:o.capabilities}))}async withProvider(c){if(!(0,g.isAbsolutePath)(c))throw new p.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const o=this.provider.get(c.scheme);if(!o){const t=new Error;throw t.name="ENOPRO",t.message=(0,h.localize)(1,null,c.toString()),t}return o}async withReadProvider(c){const o=await this.withProvider(c);if((0,p.hasOpenReadWriteCloseCapability)(o)||(0,p.hasReadWriteCapability)(o)||(0,p.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const o=await this.withProvider(c);if((0,p.hasOpenReadWriteCloseCapability)(o)||(0,p.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,o){try{return await this.doResolveFile(c,o)}catch(t){throw(0,p.toFileSystemProviderErrorCode)(t)===p.FileSystemProviderErrorCode.FileNotFound?new p.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,p.ensureFileSystemProviderError)(t)}}async doResolveFile(c,o){const t=await this.withProvider(c),s=this.isPathCaseSensitive(t),i=o?.resolveTo,r=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,l=await t.stat(c);let u;return this.toFileStat(t,c,l,void 0,!!a,(d,m)=>{if(!u&&(u=b.TernarySearchTree.forUris(()=>!s),u.set(c,!0),i))for(const A of i)u.set(A,!0);return u.get(d.resource)||u.findSuperstr(d.resource.with({query:null,fragment:null}))?!0:d.isDirectory&&r?m===1:!1})}async toFileStat(c,o,t,s,i,r){const{providerExtUri:a}=this.getExtUri(c),l={resource:o,name:a.basename(o),isFile:(t.type&p.FileType.File)!=0,isDirectory:(t.type&p.FileType.Directory)!=0,isSymbolicLink:(t.type&p.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&p.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,p.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&r(l,s)){try{const u=await c.readdir(o),d=await L.Promises.settled(u.map(async([m,A])=>{try{const _=a.joinPath(o,m),O=i?await c.stat(_):{type:A};return await this.toFileStat(c,_,O,u.length,i,r)}catch(_){return this.logService.trace(_),null}}));l.children=(0,R.coalesce)(d)}catch(u){this.logService.trace(u),l.children=[]}return l}return l}async resolveAll(c){return L.Promises.settled(c.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(c){const o=await this.withProvider(c);try{return!!await o.stat(c)}catch(t){return!1}}async canCreateFile(c,o){try{await this.doValidateCreateFile(c,o)}catch(t){return t}return!0}async doValidateCreateFile(c,o){if(!o?.overwrite&&await this.exists(c))throw new p.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,o)}async createFile(c,o=D.VSBuffer.fromString(""),t){await this.doValidateCreateFile(c,t);const s=await this.writeFile(c,o);return this._onDidRunOperation.fire(new p.FileOperationEvent(c,0,s)),s}async writeFile(c,o,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:i}=this.getExtUri(s);try{await this.validateWriteFile(s,c,t)||await this.mkdirp(s,i.dirname(c));let a;if((0,p.hasReadWriteCapability)(s)&&!(o instanceof D.VSBuffer))if((0,E.isReadableStream)(o)){const l=await(0,E.peekStream)(o,3);l.ended?a=D.VSBuffer.concat(l.buffer):a=l}else a=(0,E.peekReadable)(o,l=>D.VSBuffer.concat(l),3);else a=o;!(0,p.hasOpenReadWriteCloseCapability)(s)||(0,p.hasReadWriteCapability)(s)&&a instanceof D.VSBuffer?await this.doWriteUnbuffered(s,c,t,a):await this.doWriteBuffered(s,c,t,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a)}catch(r){throw new p.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,p.ensureFileSystemProviderError)(r).toString()),(0,p.toFileOperationResult)(r),t)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,o,t){if(!!t?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(o)));let i;try{i=await c.stat(o)}catch(r){return}if((i.type&p.FileType.Directory)!=0)throw new p.FileOperationError((0,h.localize)(6,null,this.resourceForError(o)),0,t);if(this.throwIfFileIsReadonly(o,i),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==p.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==(0,p.etag)({mtime:t.mtime,size:i.size}))throw new p.FileOperationError((0,h.localize)(7,null),3,t);return i}async readFile(c,o){const t=await this.withReadProvider(c);return o?.atomic?this.doReadFileAtomic(t,c,o):this.doReadFile(t,c,o)}async doReadFileAtomic(c,o,t){return new Promise((s,i)=>{this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(c,o,t);s(r)}catch(r){i(r)}})})}async doReadFile(c,o,t){const s=await this.doReadFileStream(c,o,{...t,preferUnbuffered:!0});return{...s,value:await(0,D.streamToBuffer)(s.value)}}async readFileStream(c,o){const t=await this.withReadProvider(c);return this.doReadFileStream(t,c,o)}async doReadFileStream(c,o,t){const s=new T.CancellationTokenSource,i=this.validateReadFile(o,t).then(a=>a,a=>{throw s.cancel(),a});let r;try{return typeof t?.etag=="string"&&t.etag!==p.ETAG_DISABLED&&await i,!((0,p.hasOpenReadWriteCloseCapability)(c)||(0,p.hasFileReadStreamCapability)(c))||(0,p.hasReadWriteCapability)(c)&&t?.preferUnbuffered?r=this.readFileUnbuffered(c,o,t):(0,p.hasFileReadStreamCapability)(c)?r=this.readFileStreamed(c,o,s.token,t):r=this.readFileBuffered(c,o,s.token,t),{...await i,value:r}}catch(a){r&&await(0,E.consumeStream)(r);const l=(0,h.localize)(8,null,this.resourceForError(o),(0,p.ensureFileSystemProviderError)(a).toString());throw a instanceof p.NotModifiedSinceFileOperationError?new p.NotModifiedSinceFileOperationError(l,a.stat,t):new p.FileOperationError(l,(0,p.toFileOperationResult)(a),t)}}readFileStreamed(c,o,t,s=Object.create(null)){const i=c.readFileStream(o,s,t);return(0,E.transform)(i,{data:r=>r instanceof D.VSBuffer?r:D.VSBuffer.wrap(r),error:r=>new p.FileOperationError((0,h.localize)(9,null,this.resourceForError(o),(0,p.ensureFileSystemProviderError)(r).toString()),(0,p.toFileOperationResult)(r),s)},r=>D.VSBuffer.concat(r))}readFileBuffered(c,o,t,s=Object.create(null)){const i=(0,D.newWriteableBufferStream)();return(0,f.readFileIntoStream)(c,o,i,r=>r,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new p.FileOperationError((0,h.localize)(10,null,this.resourceForError(o),(0,p.ensureFileSystemProviderError)(r).toString()),(0,p.toFileOperationResult)(r),s)},t),i}readFileUnbuffered(c,o,t){const s=(0,E.newWriteableStream)(i=>D.VSBuffer.concat(i));return(async()=>{try{let i=await c.readFile(o);typeof t?.position=="number"&&(i=i.slice(t.position)),typeof t?.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(o,i.byteLength,t),s.end(D.VSBuffer.wrap(i))}catch(i){s.error(i),s.end()}})(),s}async validateReadFile(c,o){const t=await this.resolve(c,{resolveMetadata:!0});if(t.isDirectory)throw new p.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,o);if(typeof o?.etag=="string"&&o.etag!==p.ETAG_DISABLED&&o.etag===t.etag)throw new p.NotModifiedSinceFileOperationError((0,h.localize)(12,null),t,o);return this.validateReadFileLimits(c,t.size,o),t}validateReadFileLimits(c,o,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&o>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&o>t.limits.size&&(s=7),typeof s=="number")throw new p.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),s)}}async canMove(c,o,t){return this.doCanMoveCopy(c,o,"move",t)}async canCopy(c,o,t){return this.doCanMoveCopy(c,o,"copy",t)}async doCanMoveCopy(c,o,t,s){if(c.toString()!==o.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(i,c,r,o,t,s)}catch(i){return i}return!0}async move(c,o,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(s,c,i,o,"move",!!t),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(c,r==="move"?2:3,a)),a}async copy(c,o,t){const s=await this.withReadProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(s,c,i,o,"copy",!!t),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(c,r==="copy"?3:2,a)),a}async doMoveCopy(c,o,t,s,i,r){if(o.toString()===s.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(c,o,t,s,i,r);if(a&&!l&&r&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),i==="copy"){if(c===t&&(0,p.hasFileFolderCopyCapability)(c))await c.copy(o,s,{overwrite:r});else{const u=await this.resolve(o);u.isDirectory?await this.doCopyFolder(c,u,t,s):await this.doCopyFile(c,o,t,s)}return i}else return c===t?(await c.rename(o,s,{overwrite:r}),i):(await this.doMoveCopy(c,o,t,s,"copy",r),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(c,o,t,s){if((0,p.hasOpenReadWriteCloseCapability)(c)&&(0,p.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(c,o,t,s);if((0,p.hasOpenReadWriteCloseCapability)(c)&&(0,p.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(c,o,t,s);if((0,p.hasReadWriteCapability)(c)&&(0,p.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(c,o,t,s);if((0,p.hasReadWriteCapability)(c)&&(0,p.hasReadWriteCapability)(t))return this.doPipeUnbuffered(c,o,t,s)}async doCopyFolder(c,o,t,s){await t.mkdir(s),Array.isArray(o.children)&&await L.Promises.settled(o.children.map(async i=>{const r=this.getExtUri(t).providerExtUri.joinPath(s,i.name);return i.isDirectory?this.doCopyFolder(c,await this.resolve(i.resource),t,r):this.doCopyFile(c,i.resource,t,r)}))}async doValidateMoveCopy(c,o,t,s,i,r){let a=!1;if(c===t){const{providerExtUri:u,isPathCaseSensitive:d}=this.getExtUri(c);if(d||(a=u.isEqual(o,s)),a&&i==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(o),this.resourceForError(s)));if(!a&&u.isEqualOrParent(s,o))throw new Error((0,h.localize)(15,null,this.resourceForError(o),this.resourceForError(s)))}const l=await this.exists(s);if(l&&!a){if(!r)throw new p.FileOperationError((0,h.localize)(16,null,this.resourceForError(o),this.resourceForError(s)),4);if(c===t){const{providerExtUri:u}=this.getExtUri(c);if(u.isEqualOrParent(o,s))throw new Error((0,h.localize)(17,null,this.resourceForError(o),this.resourceForError(s)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}getExtUri(c){const o=this.isPathCaseSensitive(c);return{providerExtUri:o?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(o,c);const t=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(c,0,t)),t}async mkdirp(c,o){const t=[],{providerExtUri:s}=this.getExtUri(c);for(;!s.isEqual(o,s.dirname(o));)try{if(((await c.stat(o)).type&p.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(o)));break}catch(i){if((0,p.toFileSystemProviderErrorCode)(i)!==p.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(s.basename(o)),o=s.dirname(o)}for(let i=t.length-1;i>=0;i--){o=s.joinPath(o,t[i]);try{await c.mkdir(o)}catch(r){if((0,p.toFileSystemProviderErrorCode)(r)!==p.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(c,o){try{await this.doValidateDelete(c,o)}catch(t){return t}return!0}async doValidateDelete(c,o){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!o?.useTrash&&!(t.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let i;try{i=await t.stat(c)}catch(a){}if(i)this.throwIfFileIsReadonly(c,i);else throw new p.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!o?.recursive){const a=await this.resolve(c);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return t}async del(c,o){const t=await this.doValidateDelete(c,o),s=!!o?.useTrash,i=!!o?.recursive;await t.delete(c,{recursive:i,useTrash:s}),this._onDidRunOperation.fire(new p.FileOperationEvent(c,1))}onDidChangeFile(c,o){this._onDidChangeFilesRaw.fire({changes:c});let t,s;{for(const i of c)this.watchedResources.has(i.resource)?(t||(t=[]),t.push(i)):(s||(s=[]),s.push(i));t&&this._onDidFilesChange.fire(new p.FileChangesEvent(t,!o))}if(s){const i=o?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(s)&&He.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(c,o={recursive:!1,excludes:[]}){const t=new S.DisposableStore;{let s=!1,i=()=>{s=!0};t.add((0,S.toDisposable)(()=>i())),this.doWatch(c,o).then(r=>{s?(0,S.dispose)(r):i=()=>(0,S.dispose)(r)},r=>this.logService.error(r))}return o.recursive||(this.watchedResources.set(c,(this.watchedResources.get(c)??0)+1),t.add((0,S.toDisposable)(()=>{const s=this.watchedResources.get(c);typeof s=="number"&&(s<=1?this.watchedResources.delete(c):this.watchedResources.set(c,s-1))}))),t}async doWatch(c,o){const t=await this.withProvider(c),s=this.toWatchKey(t,c,o),i=this.activeWatchers.get(s)||{count:0,disposable:t.watch(c,o)};return this.activeWatchers.has(s)||this.activeWatchers.set(s,i),i.count+=1,(0,S.toDisposable)(()=>{i.count--,i.count===0&&((0,S.dispose)(i.disposable),this.activeWatchers.delete(s))})}toWatchKey(c,o,t){const{providerExtUri:s}=this.getExtUri(c);return[s.getComparisonKey(o),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,S.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,o,t,s){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(async()=>{const i=await c.open(o,{create:!0,unlock:t?.unlock??!1});try{(0,E.isReadableStream)(s)||(0,E.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(c,i,s):await this.doWriteReadableBufferedQueued(c,i,s)}catch(r){throw(0,p.ensureFileSystemProviderError)(r)}finally{await c.close(i)}})}async doWriteStreamBufferedQueued(c,o,t){let s=0,i;if((0,E.isReadableBufferedStream)(t)){if(t.buffer.length>0){const r=D.VSBuffer.concat(t.buffer);await this.doWriteBuffer(c,o,r,r.byteLength,s,0),s+=r.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(r,a)=>{(0,E.listenStream)(i,{onData:async l=>{i.pause();try{await this.doWriteBuffer(c,o,l,l.byteLength,s,0)}catch(u){return a(u)}s+=l.byteLength,setTimeout(()=>i.resume())},onError:l=>a(l),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(c,o,t){let s=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(c,o,i,i.byteLength,s,0),s+=i.byteLength}async doWriteBuffer(c,o,t,s,i,r){let a=0;for(;a<s;)a+=await c.write(o,i+a,t.buffer,r+a,s-a)}async doWriteUnbuffered(c,o,t,s){return this.writeQueue.queueFor(o,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,o,t,s))}async doWriteUnbufferedQueued(c,o,t,s){let i;s instanceof D.VSBuffer?i=s:(0,E.isReadableStream)(s)?i=await(0,D.streamToBuffer)(s):(0,E.isReadableBufferedStream)(s)?i=await(0,D.bufferedStreamToBuffer)(s):i=(0,D.readableToBuffer)(s),await c.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(c,o,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,o,t,s))}async doPipeBufferedQueued(c,o,t,s){let i,r;try{i=await c.open(o,{create:!1}),r=await t.open(s,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,u=0,d=0;do d=await c.read(i,l,a.buffer,u,a.byteLength-u),await this.doWriteBuffer(t,r,a,d,l,u),l+=d,u+=d,u===a.byteLength&&(u=0);while(d>0)}catch(a){throw(0,p.ensureFileSystemProviderError)(a)}finally{await L.Promises.settled([typeof i=="number"?c.close(i):Promise.resolve(),typeof r=="number"?t.close(r):Promise.resolve()])}}async doPipeUnbuffered(c,o,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,o,t,s))}async doPipeUnbufferedQueued(c,o,t,s){return t.writeFile(s,await c.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,o,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,o,t,s))}async doPipeUnbufferedToBufferedQueued(c,o,t,s){const i=await t.open(s,{create:!0,unlock:!1});try{const r=await c.readFile(o);await this.doWriteBuffer(t,i,D.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,p.ensureFileSystemProviderError)(r)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(c,o,t,s){const i=await(0,D.streamToBuffer)(this.readFileBuffered(c,o,T.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,i)}throwIfFileSystemIsReadonly(c,o){if(c.capabilities&2048)throw new p.FileOperationError((0,h.localize)(22,null,this.resourceForError(o)),6);return c}throwIfFileIsReadonly(c,o){if((o.permissions??0)&p.FilePermission.Readonly)throw new p.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===n.Schemas.file?c.fsPath:c.toString(!0)}};v.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},v=he([Q(0,w.ILogService)],v),e.FileService=v}),define(te[181],ne([0,1,17,6,22,3,40,2,9,4,16,50,19,137,14,87,167,154,155,84,157,10,42]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p,f,w,v,y,c,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class s extends C.Disposable{constructor(r,a){super();this.logService=r,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new T.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:l}=await g.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,l),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await g.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),l=[];return await Promise.all(a.map(async u=>{try{let d;u.isSymbolicLink()?d=(await this.stat((0,n.joinPath)(r,u.name))).type:d=this.toType(u),l.push([u.name,d])}catch(d){this.logService.trace(d)}})),l}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let l;return a?.dangling?l=h.FileType.Unknown:r.isFile()?l=h.FileType.File:r.isDirectory()?l=h.FileType.Directory:l=h.FileType.Unknown,a&&(l|=h.FileType.SymbolicLink),l}async readFile(r){try{const a=this.toFilePath(r);return await g.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,l){const u=(0,I.newWriteableStream)(d=>D.VSBuffer.concat(d.map(m=>D.VSBuffer.wrap(m))).buffer);return(0,p.readFileIntoStream)(this,r,u,d=>d.buffer,{...a,bufferSize:this.BUFFER_SIZE},l),u}async writeFile(r,a,l){let u;try{const d=this.toFilePath(r);if(!l.create||!l.overwrite){if(await g.Promises.exists(d)){if(!l.overwrite)throw(0,h.createFileSystemProviderError)((0,E.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,h.createFileSystemProviderError)((0,E.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(r,{create:!0,unlock:l.unlock}),await this.write(u,0,a,0,a.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(r,d)}finally{typeof u=="number"&&await this.close(u)}}async open(r,a){try{const l=this.toFilePath(r);if((0,h.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:m}=await g.SymlinkSupport.stat(l);m.mode&128||await g.Promises.chmod(l,m.mode|128)}catch(m){this.logService.trace(m)}let u;if((0,h.isFileOpenForWriteOptions)(a)){if(b.isWindows)try{await g.Promises.truncate(l,0),u="r+"}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}u||(u="w")}else u="r";const d=await g.Promises.open(l,u);return this.mapHandleToPos.set(d,0),(0,h.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(d,r),d}catch(l){throw(0,h.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(r,l):this.toFileSystemProviderError(l)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await g.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await g.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,l,u,d){const m=this.normalizePos(r,a);let A=null;try{const _=await g.Promises.read(r,l,u,d,m);return typeof _=="number"?A=_:A=_.bytesRead,A}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(r,m,A)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,l){const u=this.mapHandleToPos.get(r);typeof u=="number"&&(typeof a=="number"||(typeof l=="number"?this.mapHandleToPos.set(r,u+l):this.mapHandleToPos.delete(r)))}async write(r,a,l,u,d){return(0,L.retry)(()=>this.doWrite(r,a,l,u,d),100,3)}async doWrite(r,a,l,u,d){const m=this.normalizePos(r,a);let A=null;try{const _=await g.Promises.write(r,l,u,d,m);return typeof _=="number"?A=_:A=_.bytesWritten,A}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),_)}finally{this.updatePos(r,m,A)}}async mkdir(r){try{await g.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const l=this.toFilePath(r);await this.doDelete(l,a)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(r,a){a.recursive?await g.Promises.rm(r,g.RimRafMode.MOVE):await g.Promises.unlink(r)}async rename(r,a,l){const u=this.toFilePath(r),d=this.toFilePath(a);if(u!==d)try{await this.validateTargetDeleted(r,a,"move",l.overwrite),await g.Promises.move(u,d)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,E.localize)(2,null,(0,S.basename)(u),(0,S.basename)((0,S.dirname)(d)),m.toString()))),this.toFileSystemProviderError(m)}}async copy(r,a,l){const u=this.toFilePath(r),d=this.toFilePath(a);if(u!==d)try{await this.validateTargetDeleted(r,a,"copy",l.overwrite),await g.Promises.copy(u,d,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,E.localize)(3,null,(0,S.basename)(u),(0,S.basename)((0,S.dirname)(d)),m.toString()))),this.toFileSystemProviderError(m)}}async validateTargetDeleted(r,a,l,u){const d=this.toFilePath(r),m=this.toFilePath(a);let A=!1;if(!!(this.capabilities&1024)||(A=(0,k.isEqual)(d,m,!0)),A&&l==="copy")throw(0,h.createFileSystemProviderError)((0,E.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!A&&await g.Promises.exists(m)){if(!u)throw(0,h.createFileSystemProviderError)((0,E.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(r,a){return a.recursive?this.watchRecursive(r,a):this.watchNonRecursive(r)}watchRecursive(r,a){const l={path:this.toFilePath(r),excludes:a.excludes},u=(0,R.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,C.toDisposable)(()=>{u(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof w.FileWatcher)this.recursiveWatcher.watch(this.recursiveFoldersToWatch);else if((0,C.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,a;if(this.options?.watcher?.usePolling)r=v.FileWatcher,a=this.options?.watcher;else{let l;this.options?.enableLegacyRecursiveWatcher?l=!0:l=t.default.quality==="stable"&&b.isLinux,l&&this.recursiveFoldersToWatch.length===1?b.isWindows?r=c.FileWatcher:r=v.FileWatcher:r=w.FileWatcher}this.recursiveWatcher=new r(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,y.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===o.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===o.LogLevel.Trace)}))}}watchNonRecursive(r){const a=new f.FileWatcher(this.toFilePath(r),u=>this._onDidChangeFile.fire((0,y.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===o.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===o.LogLevel.Trace)});return(0,C.combinedDisposable)(a,l)}toFilePath(r){return(0,S.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof h.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=h.FileSystemProviderErrorCode.NoPermissions;break;default:a=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(r,a)}async toFileSystemProviderWriteError(r,a){let l=this.toFileSystemProviderError(a);if(r&&l.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await g.SymlinkSupport.stat(this.toFilePath(r));u.mode&128||(l=(0,h.createFileSystemProviderError)(a,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return l}dispose(){super.dispose(),(0,C.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,C.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=s}),define(te[29],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService")}),define(te[182],ne([0,1,6,8,2,9,19,10,29]),function(J,e,R,L,D,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends D.Disposable{constructor(I,g,E){super();this.productService=g,this.logService=E,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,I&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(I)},30*1e3)).schedule()}async cleanUpCodeCaches(I){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),E=(0,T.dirname)(I),h=(0,T.basename)(I),p=await k.Promises.readdir(E);await Promise.all(p.map(async f=>{if(f===h)return;const w=(0,T.join)(E,f),v=await k.Promises.stat(w);if(v.isDirectory()&&g-v.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${f}.`),k.Promises.rm(w)}))}catch(g){(0,L.onUnexpectedError)(g)}}};b=he([Q(1,S.IProductService),Q(2,C.ILogService)],b),e.CodeCacheCleaner=b}),define(te[183],ne([0,1,6,8,2,9,19,13,10,29]),function(J,e,R,L,D,T,k,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends D.Disposable{constructor(g,E,h){super();this.environmentService=g,this.logService=E,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),E=JSON.parse(await k.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let v of Object.keys(E)){const y=E[v];g[`${y.hash}.${v}`]=!0}const h=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await k.Promises.exists(h))return;const f=await k.Promises.readdir(h);for(const v of f){if(g[v]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${v}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${v}`),await k.Promises.rm((0,T.join)(h,v))}const w=Date.now();for(const v of Object.keys(g)){const y=(0,T.join)(h,v),c=await k.Promises.readdir(y);for(const o of c){if(o==="tcf.json")continue;const t=(0,T.join)(y,o),s=await k.Promises.stat(t);s.isDirectory()&&w-s.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(v,o)}`),await k.Promises.rm(t))}}}catch(g){(0,L.onUnexpectedError)(g)}}};n=he([Q(0,C.INativeEnvironmentService),Q(1,S.ILogService),Q(2,b.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(te[35],ne([0,1,99,18]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(k,C){R.ok(L.isString(k)),R.ok(L.isObject(C)),R.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,C)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new D}),define(te[88],ne([0,1,3,35]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class T{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,b){this.schemasById[D(S)]=b,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new T;L.Registry.add(e.Extensions.JSONContribution,k)}),define(te[39],ne([0,1,17,3,18,123,88,35]),function(J,e,R,L,D,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const n=C.Registry.as(k.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(y,c=!0){this.registerConfigurations([y],c)}registerConfigurations(y,c=!0){const o=this.doRegisterConfigurations(y,c);n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(y){const c=this.doDeregisterConfigurations(y);n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}updateConfigurations({add:y,remove:c}){const o=[];o.push(...this.doDeregisterConfigurations(c)),o.push(...this.doRegisterConfigurations(y,!1)),n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,R.distinct)(o))}registerDefaultConfigurations(y){const c=[],o=[];for(const t of y)for(const s in t)if(c.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]={...this.defaultValues[s]||{},...t[s]};const i={type:"object",default:this.defaultValues[s],description:T.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};o.push(E(s)),this.configurationProperties[s]=i,this.defaultLanguageConfigurationOverridesNode.properties[s]=i}else{this.defaultValues[s]=t[s];const i=this.configurationProperties[s];i&&(this.updatePropertyDefaultValue(s,i),this.updateSchema(s,i))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(y){const c=[];for(const o of y)for(const t in o)if(c.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...y){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(y){for(const c of y)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(y,c){const o=[];return y.forEach(t=>{o.push(...this.validateAndRegisterProperties(t,c,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),o}doDeregisterConfigurations(y){const c=[],o=t=>{if(t.properties)for(const s in t.properties)c.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,t.properties[s]);t.allOf&&t.allOf.forEach(s=>o(s))};for(const t of y){o(t);const s=this.configurationContributors.indexOf(t);s!==-1&&this.configurationContributors.splice(s,1)}return c}validateAndRegisterProperties(y,c=!0,o,t=3){t=D.isUndefinedOrNull(y.scope)?t:y.scope;let s=[],i=y.properties;if(i)for(let a in i){if(c&&f(a)){delete i[a];continue}const l=i[a];if(this.updatePropertyDefaultValue(a,l),e.OVERRIDE_PROPERTY_PATTERN.test(a)?l.scope=void 0:(l.scope=D.isUndefinedOrNull(l.scope)?t:l.scope,l.restricted=D.isUndefinedOrNull(l.restricted)?!!o?.restrictedConfigurations?.includes(a):l.restricted),i[a].hasOwnProperty("included")&&!i[a].included){this.excludedConfigurationProperties[a]=i[a],delete i[a];continue}else this.configurationProperties[a]=i[a];!i[a].deprecationMessage&&i[a].markdownDeprecationMessage&&(i[a].deprecationMessage=i[a].markdownDeprecationMessage),s.push(a)}let r=y.allOf;if(r)for(let a of r)s.push(...this.validateAndRegisterProperties(a,c,o,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(y){const c=o=>{let t=o.properties;if(t)for(const i in t)this.updateSchema(i,t[i]);let s=o.allOf;s&&s.forEach(c)};c(y)}updateSchema(y,c){switch(e.allSettings.properties[y]=c,c.scope){case 1:e.applicationSettings.properties[y]=c;break;case 2:e.machineSettings.properties[y]=c;break;case 6:e.machineOverridableSettings.properties[y]=c;break;case 3:e.windowSettings.properties[y]=c;break;case 4:e.resourceSettings.properties[y]=c;break;case 5:e.resourceSettings.properties[y]=c,this.resourceLanguageSettingsSchema.properties[y]=c;break}}removeFromSchema(y,c){switch(delete e.allSettings.properties[y],c.scope){case 1:delete e.applicationSettings.properties[y];break;case 2:delete e.machineSettings.properties[y];break;case 6:delete e.machineOverridableSettings.properties[y];break;case 3:delete e.windowSettings.properties[y];break;case 4:case 5:delete e.resourceSettings.properties[y];break}}updateOverridePropertyPatternKey(){for(const y of this.overrideIdentifiers.values()){const c=`[${y}]`,o={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,o),e.allSettings.properties[c]=o,e.applicationSettings.properties[c]=o,e.machineSettings.properties[c]=o,e.machineOverridableSettings.properties[c]=o,e.windowSettings.properties[c]=o,e.resourceSettings.properties[c]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(y,c){let o=this.defaultValues[y];D.isUndefined(o)&&(o=c.default),D.isUndefined(o)&&(o=h(c.type)),c.default=o}}const g="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(g);function E(v){return v.substring(1,v.length-1)}e.overrideIdentifierFromKey=E;function h(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const p=new I;C.Registry.add(e.Extensions.Configuration,p);function f(v){return v.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(v)?T.localize(5,null,v):p.getConfigurationProperties()[v]!==void 0?T.localize(6,null,v):null:T.localize(4,null)}e.validateProperty=f;function w(){const v=[],y=p.getConfigurationProperties();for(const c of Object.keys(y))v.push([c,y[c].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=w}),define(te[20],ne([0,1,26,18,7,39,5,35]),function(J,e,R,L,D,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function S(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof D.URI)}e.isConfigurationOverrides=S;var b;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function I(s,i){const r=i?s?i.keys.filter(_=>s.keys.indexOf(_)===-1):[...i.keys]:[],a=s?i?s.keys.filter(_=>i.keys.indexOf(_)===-1):[...s.keys]:[],l=[];if(i&&s){for(const _ of s.keys)if(i.keys.indexOf(_)!==-1){const O=w(s.contents,_),N=w(i.contents,_);R.equals(O,N)||l.push(_)}}const u=[],d=_=>{const O={};for(const N of _)for(const P of N.identifiers)O[o(P)]=N;return O},m=i?d(i.overrides):{},A=s?d(s.overrides):{};if(Object.keys(m).length)for(const _ of r){const O=m[_];O&&u.push([(0,T.overrideIdentifierFromKey)(_),O.keys])}if(Object.keys(A).length)for(const _ of a){const O=A[_];O&&u.push([(0,T.overrideIdentifierFromKey)(_),O.keys])}if(Object.keys(m).length&&Object.keys(A).length)for(const _ of l){const O=A[_],N=m[_];if(O&&N){const P=I({contents:O.contents,keys:O.keys,overrides:[]},{contents:N.contents,keys:N.keys,overrides:[]});u.push([(0,T.overrideIdentifierFromKey)(_),[...P.added,...P.removed,...P.updated]])}}return{added:r,removed:a,updated:l,overrides:u}}e.compare=I;function g(s,i){const r=[];for(const a of Object.keys(s))if(T.OVERRIDE_PROPERTY_PATTERN.test(a)){const l={};for(const u in s[a])l[u]=s[a][u];r.push({identifiers:[(0,T.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(l),contents:E(l,i)})}return r}e.toOverrides=g;function E(s,i){const r=Object.create(null);for(let a in s)h(r,a,s[a],i);return r}e.toValuesTree=E;function h(s,i,r,a){const l=i.split("."),u=l.pop();let d=s;for(let m=0;m<l.length;m++){let A=l[m],_=d[A];switch(typeof _){case"undefined":_=d[A]=Object.create(null);break;case"object":break;default:a(`Ignoring ${i} as ${l.slice(0,m+1).join(".")} is ${JSON.stringify(_)}`);return}d=_}if(typeof d=="object"&&d!==null)try{d[u]=r}catch(m){a(`Ignoring ${i} as ${l.join(".")} is ${JSON.stringify(d)}`)}else a(`Ignoring ${i} as ${l.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=h;function p(s,i){const r=i.split(".");f(s,r)}e.removeFromValueTree=p;function f(s,i){const r=i.shift();if(i.length===0){delete s[r];return}if(Object.keys(s).indexOf(r)!==-1){const a=s[r];typeof a=="object"&&!Array.isArray(a)&&(f(a,i),Object.keys(a).length===0&&delete s[r])}}function w(s,i,r){function a(d,m){let A=d;for(const _ of m){if(typeof A!="object"||A===null)return;A=A[_]}return A}const l=i.split("."),u=a(s,l);return typeof u=="undefined"?r:u}e.getConfigurationValue=w;function v(s,i,r){Object.keys(i).forEach(a=>{a!=="__proto__"&&(a in s?L.isObject(s[a])&&L.isObject(i[a])?v(s[a],i[a],r):r&&(s[a]=i[a]):s[a]=i[a])})}e.merge=v;function y(){const s=C.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=y;function c(){const s=Object.create(null),i=C.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let r in i){let a=i[r].default;h(s,r,a,l=>console.error(`Conflict in default settings: ${l}`))}return s}e.getDefaultValues=c;function o(s){return`[${s}]`}e.keyFromOverrideIdentifier=o;function t(s,i,r){const a=s.inspect(i),l=s.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:a.defaultValue}e.getMigratedSettingValue=t}),define(te[89],ne([0,1,17,3,36,2,41,26,18,7,20,39,35]),function(J,e,R,L,D,T,k,C,S,b,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class E{constructor(t={},s=[],i=[]){this._contents=t,this._keys=s,this._overrides=i,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const i=this.getContentsForOverrideIdentifer(s);return i?t?(0,n.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){let s=this.overrideConfigurations.get(t);return s||(s=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,s)),s}merge(...t){const s=C.deepClone(this.contents),i=C.deepClone(this.overrides),r=[...this.keys];for(const a of t){this.mergeContents(s,a.contents);for(const l of a.overrides){const[u]=i.filter(d=>R.equals(d.identifiers,l.identifiers));u?this.mergeContents(u.contents,l.contents):i.push(C.deepClone(l))}for(const l of a.keys)r.indexOf(l)===-1&&r.push(l)}return new E(s,r,i)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let i={};for(const r of R.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r],l=s[r];l&&(typeof a=="object"&&typeof l=="object"?(a=C.deepClone(a),this.mergeContents(a,l)):a=l),i[r]=a}return new E(i,this.keys,this.overrides)}mergeContents(t,s){for(const i of Object.keys(s)){if(i in t&&S.isObject(t[i])&&S.isObject(s[i])){this.mergeContents(t[i],s[i]);continue}t[i]=C.deepClone(s[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?C.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,n.addToValueTree)(this.contents,t,s,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let i=0;i<s;i++)t.indexOf(this.keys[i])===0&&(s=i);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=E;class h extends E{constructor(){const t=(0,n.getDefaultValues)(),s=(0,n.getConfigurationKeys)(),i=[];for(const r of Object.keys(t))I.OVERRIDE_PROPERTY_PATTERN.test(r)&&i.push({identifiers:[(0,I.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,n.toValuesTree)(t[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,s,i)}}e.DefaultConfigurationModel=h;class p{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!S.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:i,keys:r,overrides:a,restricted:l}=this.doParseRaw(t,s);this._configurationModel=new E(i,r,a),this._restrictedConfigurations=l||[]}doParseContent(t){let s={},i=null,r=[],a=[],l=[];function u(m){Array.isArray(r)?r.push(m):i!==null&&(r[i]=m)}let d={onObjectBegin:()=>{let m={};u(m),a.push(r),r=m,i=null},onObjectProperty:m=>{i=m},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let m=[];u(m),a.push(r),r=m,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:u,onError:(m,A,_)=>{l.push({error:m,offset:A,length:_})}};if(t)try{D.visit(t,d),s=r[0]||{}}catch(m){console.error(`Error while parsing settings file ${this._name}: ${m}`),this._parseErrors=[m]}return s}doParseRaw(t,s){const i=g.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,i,!0,s);t=r.raw;const a=(0,n.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),l=Object.keys(t),u=(0,n.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:a,keys:l,overrides:u,restricted:r.restricted}}filter(t,s,i,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:t,restricted:[]};const a={},l=[];for(let u in t)if(I.OVERRIDE_PROPERTY_PATTERN.test(u)&&i){const d=this.filter(t[u],s,!1,r);a[u]=d.raw,l.push(...d.restricted)}else{const d=s[u],m=d?typeof d.scope!="undefined"?d.scope:3:void 0;d?.restricted&&l.push(u),(m===void 0||r.scopes===void 0||r.scopes.includes(m))&&(r.skipRestricted&&d?.restricted||(a[u]=t[u]))}return{raw:a,restricted:l}}}e.ConfigurationModelParser=p;class f extends T.Disposable{constructor(t,s,i,r){super();this.userSettingsResource=t,this.scopes=s,this.fileService=r,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=f;class w{constructor(t,s,i=new E,r=new E,a=new k.ResourceMap,l=new E,u=new k.ResourceMap,d=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=i,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=l,this._memoryConfigurationByResource=u,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,s,i){return this.getConsolidateConfigurationModel(s,i).getValue(t)}updateValue(t,s,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new E,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,s===void 0?r.removeValue(t):r.setValue(t,s),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,i){const r=this.getConsolidateConfigurationModel(s,i),a=this.getFolderConfigurationModelForResource(s.resource,i),l=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,u=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),d=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),m=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),A=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),_=i?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=a?s.overrideIdentifier?a.freeze().override(s.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,N=s.overrideIdentifier?l.override(s.overrideIdentifier).getValue(t):l.getValue(t),P=r.getValue(t),M=R.distinct(R.flatten(r.overrides.map($=>$.identifiers))).filter($=>r.getOverrideValue(t,$)!==void 0);return{defaultValue:u,userValue:d,userLocalValue:m,userRemoteValue:A,workspaceValue:_,workspaceFolderValue:O,memoryValue:N,value:P,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:m!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:_!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:a?.freeze().getValue(t),override:s.overrideIdentifier?a?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:N!==void 0?{value:l.getValue(t),override:s.overrideIdentifier?l.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:M.length?M:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const i=s.filter(r=>I.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,I.overrideIdentifierFromKey)(r),l=this._defaultConfiguration.getKeysForOverrideIdentifier(a),u=t.getKeysForOverrideIdentifier(a),d=[...u.filter(m=>l.indexOf(m)===-1),...l.filter(m=>u.indexOf(m)===-1),...l.filter(m=>!C.equals(this._defaultConfiguration.override(a).getValue(m),t.override(a).getValue(m)))];return[a,d]});return this.updateDefaultConfiguration(t),{keys:s,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:i,removed:r,overrides:a}=(0,n.compare)(this.localUserConfiguration,t),l=[...s,...i,...r];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:i,removed:r,overrides:a}=(0,n.compare)(this.remoteUserConfiguration,t);let l=[...s,...i,...r];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:i,removed:r,overrides:a}=(0,n.compare)(this.workspaceConfiguration,t);let l=[...s,...i,...r];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:a}}compareAndUpdateFolderConfiguration(t,s){const i=this.folderConfigurations.get(t),{added:r,updated:a,removed:l,overrides:u}=(0,n.compare)(i,s);let d=[...r,...a,...l];return(d.length||!i)&&this.updateFolderConfiguration(t,s),{keys:d,overrides:u}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:r,removed:a,overrides:l}=(0,n.compare)(s,void 0);return{keys:[...i,...r,...a],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let i=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},s){let i=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const r=s.getFolder(t);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const a=this._memoryConfigurationByResource.get(t);a&&(i=i.merge(a))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(s=i.merge(r),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=i}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const i=s.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:i,overrides:r,keys:a}=this._folderConfigurations.get(s);return t.push([s,{contents:i,overrides:r,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((l,u)=>(l.set(b.URI.revive(u[0]),this.parseConfigurationModel(u[1])),l),new k.ResourceMap);return new w(s,i,new E,r,a,new E,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new E(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function v(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>t.add(a)),r.overrides.forEach(([a,l])=>{const u=(0,k.getOrSet)(s,a,new Set);l.forEach(d=>u.add(d))});const i=[];return s.forEach((r,a)=>i.push([a,[...r.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=v;class y{constructor(t,s,i,r){this.change=t,this.previous=s,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(u=>a.add(u)),t.overrides.forEach(([,u])=>u.forEach(d=>a.add(d))),this.affectedKeys=[...a.values()];const l=new E;this.affectedKeys.forEach(u=>l.setValue(u,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!C.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let i=(0,n.toValuesTree)({[s]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(t=t[r],!t)return!1;i=i[r]}return!0}}e.ConfigurationChangeEvent=y;class c extends y{constructor(t,s,i,r){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=i,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=c}),define(te[184],ne([0,1,6,3,2,16,20,89,39,35]),function(J,e,R,L,D,T,k,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends D.Disposable{constructor(g,E){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new C.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,E)),this.configuration=new C.Configuration(new C.DefaultConfigurationModel,new C.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new C.Configuration(new C.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,E){const h=typeof g=="string"?g:void 0,p=(0,k.isConfigurationOverrides)(g)?g:(0,k.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(h,p,void 0)}updateValue(g,E,h,p){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const E=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(h,E,1)}onDidDefaultConfigurationChange(g){const E=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new C.DefaultConfigurationModel,g);this.trigger(h,E,6)}trigger(g,E,h){const p=new C.ConfigurationChangeEvent(g,{data:E},this.configuration);p.source=h,p.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(p)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(te[185],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var L;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(k,C=L.Unknown,S){super(k);this._message=k,this._code=C,this._detail=S,this.isHandled=C===L.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===L.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===L.NoResolverFound}static isHandled(k){return k instanceof D&&k.isHandled}}e.RemoteAuthorityResolverError=D}),define(te[186],ne([0,1,6,22,27,8,3,2,30,72,185]),function(J,e,R,L,D,T,k,C,S,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var g;(function(j){j[j.Management=1]="Management",j[j.ExtensionHost=2]="ExtensionHost",j[j.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function E(j){switch(j){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(j){const z=new D.CancellationTokenSource;return setTimeout(()=>z.cancel(),j),z.token}function p(j,z){if(j.isCancellationRequested||z.isCancellationRequested)return D.CancellationToken.Cancelled;const B=new D.CancellationTokenSource;return j.onCancellationRequested(()=>B.cancel()),z.onCancellationRequested(()=>B.cancel()),B.token}class f{constructor(z){this._state="pending",this._disposables=new C.DisposableStore,this.promise=new Promise((B,X)=>{this._resolvePromise=B,this._rejectPromise=X}),z.isCancellationRequested?this._timeout():this._disposables.add(z.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(z){this._state==="pending"?this._disposables.add(z):z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const z=new Error("Time limit reached");return z.code="ETIMEDOUT",z.syscall="connect",z}resolve(z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(z))}reject(z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(z))}}function w(j,z){const B=new f(z);return B.registerDisposable(j.onControlMessage(X=>{const Z=JSON.parse(X.toString()),V=W(Z);V?B.reject(V):B.resolve(Z)})),B.promise}function v(j,z,B,X,Z,V){const G=new f(V);return z.connect(B,X,Z,(ie,re)=>{G.didTimeout?(ie&&j.error(ie),re?.dispose()):ie||!re?G.reject(ie):G.resolve(re)}),G.promise}function y(j,z){const B=new f(z);return j.then(X=>{B.didTimeout||B.resolve(X)},X=>{B.didTimeout||B.reject(X)}),B.promise}async function c(j,z,B,X){const Z=F(j,z);j.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let V;try{V=await v(j.logService,j.socketFactory,j.host,j.port,`reconnectionToken=${j.reconnectionToken}&reconnection=${j.reconnectionProtocol?"true":"false"}`,X)}catch(ae){throw j.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),j.logService.error(ae),ae}j.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let G,ie;j.reconnectionProtocol?(j.reconnectionProtocol.beginAcceptReconnection(V,null),G=j.reconnectionProtocol,ie=!1):(G=new b.PersistentProtocol(V,null),ie=!0),j.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const re={type:"auth",auth:j.connectionToken||"00000000000000000000"};G.sendControl(L.VSBuffer.fromString(JSON.stringify(re)));try{const ae=await w(G,p(X,h(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}j.logService.trace(`${Z} 4/6. received SignRequest control message.`);const ue=await y(j.signService.sign(ae.data),X),fe={type:"connectionType",commit:j.commit,signedData:ue,desiredConnectionType:z};return B&&(fe.args=B),j.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(L.VSBuffer.fromString(JSON.stringify(fe))),{protocol:G,ownsProtocol:ie}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(j.logService.error(`${Z} the handshake timed out. Error:`),j.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(j.logService.error(`${Z} received error control message when negotiating connection. Error:`),j.logService.error(ae)),ie&&H(G),ae}}async function o(j,z,B,X){const Z=Date.now(),V=F(j,z),{protocol:G,ownsProtocol:ie}=await c(j,z,B,X),re=new f(X);return re.registerDisposable(G.onControlMessage(ae=>{const ue=JSON.parse(ae.toString()),fe=W(ue);fe?(j.logService.error(`${V} received error control message when negotiating connection. Error:`),j.logService.error(fe),ie&&H(G),re.reject(fe)):(j.reconnectionProtocol&&j.reconnectionProtocol.endAcceptReconnection(),j.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${K(Z)}!`),re.resolve({protocol:G,firstMessage:ue}))})),re.promise}async function t(j,z){const{protocol:B}=await o(j,1,void 0,z);return{protocol:B}}async function s(j,z,B){const{protocol:X,firstMessage:Z}=await o(j,2,z,B),V=Z&&Z.debugPort;return{protocol:X,debugPort:V}}async function i(j,z,B){const X=Date.now(),Z=F(j,3),{protocol:V}=await c(j,3,z,B);return j.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${K(X)}!`),V}async function r(j,z,B){const{host:X,port:Z,connectionToken:V}=await j.addressProvider.getAddress();return{commit:j.commit,host:X,port:Z,connectionToken:V,reconnectionToken:z,reconnectionProtocol:B,socketFactory:j.socketFactory,signService:j.signService,logService:j.logService}}async function a(j,z,B){try{const X=(0,S.generateUuid)(),Z=await r(j,X,null),{protocol:V}=await t(Z,D.CancellationToken.None);return new $(j,z,B,X,V)}catch(X){throw j.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),j.logService.error(X),M.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(X)),X}}e.connectRemoteAgentManagement=a;async function l(j,z){try{const B=(0,S.generateUuid)(),X=await r(j,B,null),{protocol:Z,debugPort:V}=await s(X,z,D.CancellationToken.None);return new U(j,z,B,Z,V)}catch(B){throw j.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),j.logService.error(B),M.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentExtensionHost=l;async function u(j,z,B){const X=await r(j,(0,S.generateUuid)(),null);return await i(X,{host:z,port:B},D.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function d(j){return(0,R.createCancelablePromise)(z=>new Promise((B,X)=>{const Z=setTimeout(B,j*1e3);z.onCancellationRequested(()=>{clearTimeout(Z),B()})}))}var m;(function(j){j[j.ConnectionLost=0]="ConnectionLost",j[j.ReconnectionWait=1]="ReconnectionWait",j[j.ReconnectionRunning=2]="ReconnectionRunning",j[j.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",j[j.ConnectionGain=4]="ConnectionGain"})(m=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(z,B){this.reconnectionToken=z,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=A;class _{constructor(z,B,X,Z){this.reconnectionToken=z,this.millisSinceLastIncomingData=B,this.durationSeconds=X,this.cancellableTimer=Z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class O{constructor(z,B,X){this.reconnectionToken=z,this.millisSinceLastIncomingData=B,this.attempt=X,this.type=2}}e.ReconnectionRunningEvent=O;class N{constructor(z,B,X){this.reconnectionToken=z,this.millisSinceLastIncomingData=B,this.attempt=X,this.type=4}}e.ConnectionGainEvent=N;class P{constructor(z,B,X,Z){this.reconnectionToken=z,this.millisSinceLastIncomingData=B,this.attempt=X,this.handled=Z,this.type=3}}e.ReconnectionPermanentFailureEvent=P;class M extends C.Disposable{constructor(z,B,X,Z){super();this._connectionType=z,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=B,this.reconnectionToken=X,this.protocol=Z,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(Z.onSocketClose(V=>{const G=q(this._connectionType,this.reconnectionToken,!0);V?V.type===0?(this._options.logService.info(`${G} received socket close event (hadError: ${V.hadError}).`),V.error&&this._options.logService.error(V.error)):(this._options.logService.info(`${G} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this._options.logService.error(V.event)):this._options.logService.info(`${G} received socket close event.`),this._beginReconnecting()})),this._register(Z.onSocketTimeout(()=>{const V=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${V} received socket timeout event.`),this._beginReconnecting()})),M._instances.push(this),M._permanentFailure&&this._gotoPermanentFailure(M._permanentFailureMillisSinceLastIncomingData,M._permanentFailureAttempt,M._permanentFailureHandled)}static triggerPermanentFailure(z,B,X){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=z,this._permanentFailureAttempt=B,this._permanentFailureHandled=X,this._instances.forEach(Z=>Z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(M._permanentFailure)return;const z=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30];let X=-1;do{X++;const Z=X<B.length?B[X]:B[B.length-1];try{if(Z>0){const G=d(Z);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,G)),this._options.logService.info(`${z} waiting for ${Z} seconds before reconnecting...`);try{await G}catch{}}if(M._permanentFailure){this._options.logService.error(`${z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X+1)),this._options.logService.info(`${z} resolving connection...`);const V=await r(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${z} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,h(I)),this._options.logService.info(`${z} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}if(X>360){this._options.logService.error(`${z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,T.isPromiseCanceledError)(V)){this._options.logService.info(`${z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,n.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}}while(!M._permanentFailure)}_gotoPermanentFailure(z,B,X){this._onDidStateChange.fire(new P(this.reconnectionToken,z,B,X)),H(this.protocol)}}M._permanentFailure=!1,M._permanentFailureMillisSinceLastIncomingData=0,M._permanentFailureAttempt=0,M._permanentFailureHandled=!1,M._instances=[];class $ extends M{constructor(z,B,X,Z,V){super(1,z,Z,V);this.client=this._register(new b.Client(V,{remoteAuthority:B,clientId:X},z.ipcLogger))}async _reconnect(z,B){await t(z,B)}}e.ManagementPersistentConnection=$;class U extends M{constructor(z,B,X,Z,V){super(2,z,X,Z);this._startArguments=B,this.debugPort=V}async _reconnect(z,B){await s(z,this._startArguments,B)}}e.ExtensionHostPersistentConnection=U;function H(j){try{j.acceptDisconnect();const z=j.getSocket();j.dispose(),z.dispose()}catch(z){(0,T.onUnexpectedError)(z)}}function W(j){if(j&&j.type==="error"){const z=new Error(`Connection error: ${j.reason}`);return z.code="VSCODE_CONNECTION_ERROR",z}return null}function x(j,z){for(;j.length<z;)j+=" ";return j}function q(j,z,B){return`[remote-connection][${x(E(j),13)}][${z.substr(0,5)}\u2026][${B?"reconnect":"initial"}]`}function F(j,z){return`${q(z,j.reconnectionToken,!!j.reconnectionProtocol)}[${j.host}:${j.port}]`}function K(j){return`${Date.now()-j} ms`}}),define(te[187],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[61],ne([0,1,3,4,5,10]),function(J,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService");var k;(function(h){h.Http="http",h.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(C=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function n(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=n,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=I;function g(h,p){return p?p!==1&&h<1024:!L.isWindows&&h<1024}e.isPortPrivileged=g;let E=class{constructor(p){this.logService=p,this._onTunnelOpened=new R.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new R.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new R.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p,f){return this._tunnelProvider=p,p?(this._canElevate=f.elevation,this._privacyOptions=f.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return new Promise(async p=>{const f=[],w=Array.from(this._tunnels.values());for(let v of w){const y=Array.from(v.values());for(let c of y){const o=await c.value;o&&f.push(o)}}p(f)})}async dispose(){for(const p of this._tunnels.values()){for(const{value:f}of p.values())await f.then(w=>w?.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,f,w,v,y=!1,c=C.Private,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${w} on local port ${v}.`),!p)return;f||(f="localhost");const t=this.retainOrCreateTunnel(p,f,w,v,y,c,o);return t?t.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(f,w);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(s);return(s.tunnelRemoteHost!==f||s.tunnelRemotePort!==w)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const f=this._tunnels.get(p.tunnelRemoteHost);if(f){const w=f.get(p.tunnelRemotePort);w&&(w.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,w))}}}}async tryDisposeTunnel(p,f,w){if(w.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${f}.`);const v=w.value.then(async y=>{y&&(await y.dispose(!0),this._onTunnelClosed.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(f),v}}async closeTunnel(p,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${f} `);const w=this._tunnels.get(p);if(w&&w.has(f)){const v=w.get(f);v.refcount=0,await this.tryDisposeTunnel(p,f,v)}}addTunnelToMap(p,f,w){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(f,{refcount:1,value:w})}async removeEmptyTunnelFromMap(p,f){const w=this._tunnels.get(p);w&&(await w.get(f)||w.delete(f),w.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,f){let w=[p];n(p)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):I(p)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const v=w.map(y=>this._tunnels.get(y));for(const y of v){const c=y?.get(f);if(c)return c}}canTunnel(p){return!!b(p)}createWithProvider(p,f,w,v,y,c,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${w} on local port ${v}.`);const s={elevationRequired:y?g(v===void 0?w:v):!1},i={remoteAddress:{host:f,port:w},localAddressPort:v,privacy:c,public:c!==C.Private,protocol:o},r=p.forwardPort(i,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(f,w,r),r}};E=he([Q(0,T.ILogService)],E),e.AbstractTunnelService=E}),define(te[188],ne([0,1,10,61,2,8,6]),function(J,e,R,L,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class C extends D.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new k.DeferredPromise),this._addressPromise.p)}setAddress(n){this._address=n,this._addressPromise&&(this._addressPromise.complete(n),this._addressPromise=null)}setTunnel(n){this._register(n)}}let S=class pt extends D.Disposable{constructor(n,I){super();this._tunnelService=n,this._logService=I,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(n=>n.dispose())}async createTunnel(){return{id:String(++pt._lastId)}}async startTunnel(n,I,g,E,h){const p=new C,f=await Promise.resolve(this._tunnelService.openTunnel(p,I,g,E,h));if(!f)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${I}:${g} (remote).`),p.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(n))throw this._disposedTunnels.delete(n),p.dispose(),await f.dispose(),(0,T.canceled)();return p.setTunnel(f),this._tunnels.set(n,p),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${n}: ${f.localAddress} (local) to ${I}:${g} (remote).`),{tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress}}async setAddress(n,I){const g=this._tunnels.get(n);!g||g.setAddress(I)}async destroyTunnel(n){const I=this._tunnels.get(n);if(I){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${n}.`),this._tunnels.delete(n),await I.dispose();return}this._disposedTunnels.add(n)}};S._lastId=0,S=he([Q(0,L.ITunnelService),Q(1,R.ILogService)],S),e.SharedProcessTunnelService=S}),define(te[189],ne([0,1,117,20,10]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(C,S){this.configurationService=C,this.logService=S}request(C,S){return this.logService.trace("RequestService#request",C.url),C.proxyAuthorization||(C.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,R.request)(C,S)}async resolveProxy(C){}};T=he([Q(0,L.IConfigurationService),Q(1,D.ILogService)],T),e.RequestService=T}),define(te[43],ne([0,1,22,138,39,5,35]),function(J,e,R,L,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function C(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=C;function S(h){return h.res.statusCode===204}async function b(h){if(!C(h))throw new Error("Server returned "+h.res.statusCode);return S(h)?null:(await(0,R.streamToBuffer)(h.stream)).toString()}e.asText=b;async function n(h){if(!C(h))throw new Error("Server returned "+h.res.statusCode);if(S(h))return null;const f=(await(0,R.streamToBuffer)(h.stream)).toString();try{return JSON.parse(f)}catch(w){throw w.message+=`:
`+f,w}}e.asJson=n;function I(h){E(h)}e.updateProxyConfigurationsScope=I;let g;function E(h){const p=k.Registry.as(D.Extensions.Configuration),f=g;g={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},p.updateConfigurations({add:[g],remove:f?[f]:[]})}E(2)}),define(te[190],ne([0,1,27,15,14,43]),function(J,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(S,b){this.requestService=S,this.fileService=b}async download(S,b,n=R.CancellationToken.None){if(S.scheme===L.Schemas.file||S.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(S,b);return}const I={type:"GET",url:S.toString()},g=await this.requestService.request(I,n);if(g.res.statusCode===200)await this.fileService.writeFile(b,g.stream);else{const E=await(0,T.asText)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${E}`)}}};k=he([Q(0,T.IRequestService),Q(1,D.IFileService)],k),e.DownloadService=k}),define(te[191],ne([0,1,17,27,65,2,16,151,14,10,29,43]),function(J,e,R,L,D,T,k,C,S,b,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let g=class extends T.Disposable{constructor(h,p,f,w){super();this.fileService=h,this.productService=p,this.requestService=f,this.logService=w,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,D.forEach)(this.productService.configBasedExtensionTips,({value:v})=>this.allConfigBasedTips.set(v.configPath,v))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const p=[];for(const[f,w]of this.allConfigBasedTips)if(!(w.configScheme&&w.configScheme!==h.scheme))try{const v=await this.fileService.readFile((0,k.joinPath)(h,f)),y=new Map;(0,D.forEach)(w.recommendations,({key:o,value:t})=>{if((0,R.isNonEmptyArray)(t.remotes))for(const s of t.remotes)y.set(s,{extensionId:o,extensionName:t.name,configName:w.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else p.push({extensionId:o,extensionName:t.name,configName:w.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const c=(0,C.getDomainsOfRemotes)(v.value.toString(),[...y.keys()]);for(const o of c){const t=y.get(o);t&&p.push(t)}}catch(v){}return p}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},L.CancellationToken.None);if(h.res.statusCode!==200)return[];const p=await(0,I.asJson)(h);return p?p.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};g=he([Q(0,S.IFileService),Q(1,n.IProductService),Q(2,I.IRequestService),Q(3,b.ILogService)],g),e.ExtensionTipsService=g}),define(te[45],ne([0,1,22,30]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(T,k,C){let S=C&&C.get("storage.serviceMachineId",0)||null;if(S)return S;try{const n=(await k.readFile(T.serviceMachineIdResource)).value.toString();S=(0,L.isUUID)(n)?n:null}catch(b){S=null}if(!S){S=(0,L.generateUuid)();try{await k.writeFile(T.serviceMachineIdResource,R.VSBuffer.fromString(S))}catch(b){}}return C&&C.store("storage.serviceMachineId",S,0,1),S}e.getServiceMachineId=D}),define(te[90],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[192],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R{vsda(){return new Promise((D,T)=>J(["vsda"],D,T))}async sign(D){try{const T=await this.vsda(),k=new T.signer;if(k)return k.sign(D)}catch(T){}return D}}e.SignService=R}),define(te[23],ne([0,1,6,3,2,18,73,5]),function(J,e,R,L,D,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const S="__$__targetStorageMarker";e.IStorageService=(0,C.createDecorator)("storageService");var b;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(p){p[p.GLOBAL=0]="GLOBAL",p[p.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var I;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class g extends D.Disposable{constructor(f={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super();this.options=f,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,w){w===S?(f===0?this._globalKeyTargets=void 0:f===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:f})):this._onDidChangeValue.fire({scope:f,key:w,target:this.getKeyTargets(f)[w]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,w,v){return this.getStorage(w)?.get(f,v)}getBoolean(f,w,v){return this.getStorage(w)?.getBoolean(f,v)}getNumber(f,w,v){return this.getStorage(w)?.getNumber(f,v)}store(f,w,v,y){if((0,T.isUndefinedOrNull)(w)){this.remove(f,v);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,v,y),this.getStorage(v)?.set(f,w)})}remove(f,w){this.withPausedEmitters(()=>{this.updateKeyTarget(f,w,void 0),this.getStorage(w)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,w){const v=[],y=this.getKeyTargets(f);for(const c of Object.keys(y))y[c]===w&&v.push(c);return v}updateKeyTarget(f,w,v){const y=this.getKeyTargets(w);typeof v=="number"?y[f]!==v&&(y[f]=v,this.getStorage(w)?.set(S,JSON.stringify(y))):typeof y[f]=="number"&&(delete y[f],this.getStorage(w)?.set(S,JSON.stringify(y)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(f){return f===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(f){const w=this.get(S,f);if(w)try{return JSON.parse(w)}catch(v){}return Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=b.NONE){this._onWillSaveState.fire({reason:f}),await R.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const f=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return h(f,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;class E extends g{constructor(){super();this.globalStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.globalStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f)))}getStorage(f){return f===0?this.globalStorage:this.workspaceStorage}getLogDetails(f){return f===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(f){}}e.InMemoryStorageService=E;async function h(p,f,w,v){const y=a=>{try{return JSON.parse(a)}catch(l){return a}},c=new Map,o=new Map;p.forEach((a,l)=>{c.set(l,a),o.set(l,y(a))});const t=new Map,s=new Map;f.forEach((a,l)=>{t.set(l,a),s.set(l,y(a))}),console.group(`Storage: Global (path: ${w})`);let i=[];c.forEach((a,l)=>{i.push({key:l,value:a})}),console.table(i),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${v})`);let r=[];t.forEach((a,l)=>{r.push({key:l,value:a})}),console.table(r),console.groupEnd(),console.log(s)}e.logStorage=h}),define(te[193],ne([0,1,3,2,18,28,34,23]),function(J,e,R,L,D,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let S=class extends L.Disposable{constructor(I){super();this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(I)),this._register(this.storageManger.onDidChange(g=>this._onDidChangeEnablement.fire({extensions:g,source:"storage"})))}async enableExtension(I,g){return this._removeFromDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:g}),!0):!1}async disableExtension(I,g){return this._addToDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:g}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(I){let g=this.getDisabledExtensions();return g.every(E=>!(0,k.areSameExtensions)(E,I))?(g.push(I),this._setDisabledExtensions(g),!0):!1}_removeFromDisabledExtensions(I){let g=this.getDisabledExtensions();for(let E=0;E<g.length;E++){const h=g[E];if((0,k.areSameExtensions)(h,I))return g.splice(E,1),this._setDisabledExtensions(g),!0}return!1}_setDisabledExtensions(I){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,I)}_getExtensions(I){return this.storageManger.get(I,0)}_setExtensions(I,g){this.storageManger.set(I,g,0)}};S=he([Q(0,C.IStorageService)],S),e.GlobalExtensionEnablementService=S;class b extends L.Disposable{constructor(I){super();this.storageService=I,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(I.onDidChangeValue(g=>this.onDidStorageChange(g)))}get(I,g){let E;return g===0?((0,D.isUndefinedOrNull)(this.storage[I])&&(this.storage[I]=this._get(I,g)),E=this.storage[I]):E=this._get(I,g),JSON.parse(E)}set(I,g,E){let h=JSON.stringify(g.map(({id:f,uuid:w})=>({id:f,uuid:w})));this._get(I,E)!==h&&(E===0&&(g.length?this.storage[I]=h:delete this.storage[I]),this._set(I,g.length?h:void 0,E))}onDidStorageChange(I){if(I.scope===0&&!(0,D.isUndefinedOrNull)(this.storage[I.key])&&this._get(I.key,I.scope)!==this.storage[I.key]){const E=this.get(I.key,I.scope);delete this.storage[I.key];const h=this.get(I.key,I.scope),p=E.filter(w=>!h.some(v=>(0,k.areSameExtensions)(w,v))),f=h.filter(w=>!E.some(v=>(0,k.areSameExtensions)(v,w)));(p.length||f.length)&&this._onDidChange.fire([...p,...f])}}_get(I,g){return this.storageService.get(I,g,"[]")}_set(I,g,E){g?this.storageService.store(I,g,E,1):this.storageService.remove(I,E)}}e.StorageManager=b}),define(te[194],ne([0,1,3,2]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class D extends L.Disposable{constructor(b,n){super();this.channel=b,this.workspace=n}async getItems(){const b={workspace:this.workspace},n=await this.channel.call("getItems",b);return new Map(n)}updateItems(b){const n={workspace:this.workspace};return b.insert&&(n.insert=Array.from(b.insert.entries())),b.delete&&(n.delete=Array.from(b.delete.values())),this.channel.call("updateItems",n)}}class T extends D{constructor(b){super(b,void 0);this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(b=>this.onDidChangeGlobalStorage(b)))}onDidChangeGlobalStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}async close(){this.dispose()}}class k extends D{constructor(b,n){super(b,n);this.onDidChangeItemsExternal=R.Event.None}async close(){const b={workspace:this.workspace};return this.channel.call("close",b)}}class C extends L.Disposable{constructor(b,n){super();this.channel=b,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new k(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=C}),define(te[195],ne([0,1,6,2,180,16,73,23,194]),function(J,e,R,L,D,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends C.AbstractStorageService{constructor(I,g,E){super();this.mainProcessService=g,this.environmentService=E,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new L.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(I)}createGlobalStorage(){const I=new S.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),g=new k.Storage(I.globalStorage);return this._register(g.onDidChangeStorage(E=>this.emitDidChangeValue(0,E))),g}createWorkspaceStorage(I){const g=new S.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),I);if(g.workspaceStorage){const E=new k.Storage(g.workspaceStorage);return this.workspaceStorageDisposable.value=E.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)),this.workspaceStorageId=I?.id,E}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,D.mark)("code/willInitStorage");try{await R.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,D.mark)("code/didInitStorage")}}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(C.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(I){const g=this.workspaceStorage,E=g?.items??new Map;g&&(await g.close(),g.dispose()),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init();for(const[h,p]of E)this.workspaceStorage.set(h,p)}}e.NativeStorageService=b}),define(te[196],ne([0,1,4,31,7,30]),function(J,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(b){if(R.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function C(b,n,I,g,E,h,p,f,w,v){const y=Object.create(null);y["common.machineId"]=p,y.sessionID=(0,T.generateUuid)()+Date.now(),y.commitHash=E,y.version=h,y["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=(0,R.PlatformToString)(R.platform),y["common.nodePlatform"]=L.platform,y["common.nodeArch"]=g,y["common.product"]=v||"desktop";const c=S(f||[]);c&&(y["common.msftInternal"]=c);let o=0;const t=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),R.isLinuxSnap&&(y["common.snap"]="true");const s=k(I);s&&(y["common.platformDetail"]=s);try{const i=await b.readFile(D.URI.file(w));y["common.source"]=i.value.toString().slice(0,30)}catch(i){}return y}e.resolveCommonProperties=C;function S(b){const n=L.env.USERDNSDOMAIN;if(!n)return!1;const I=n.toLowerCase();return b.some(g=>I===g)}e.verifyMicrosoftInternalDomain=S}),define(te[21],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[197],ne([0,1,32,55,36,15,9,4,7,109,19,112,78,14,29,21]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function f(o,t){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,r=new Map,a=2e4;function l(m,A,_,O){const N=A.substring(m.length+1);return new Promise(async P=>{let M;try{M=await n.Promises.readdir(A,{withFileTypes:!0})}catch(H){P();return}if(O.count>=a){O.count+=M.length,O.maxReached=!0,P();return}let $=M.length;if($===0){P();return}let U=M;O.count+M.length>a&&(O.maxReached=!0,$=a-O.count,U=M.slice(0,$)),O.count+=M.length;for(const H of U)if(H.isDirectory()){if(_.includes(H.name)||await l(m,(0,k.join)(A,H.name),_,O),--$==0){P();return}}else{const W=H.name.lastIndexOf(".");if(W>=0){const x=H.name.substring(W+1);x&&i.set(x,(i.get(x)??0)+1)}for(const x of s)x.relativePathPattern?.test(N)!==!1&&x.filePattern.test(H.name)&&r.set(x.tag,(r.get(x.tag)??0)+1);if(--$==0){P();return}}})}const u={count:0,maxReached:!1};await l(o,o,t,u);const d=await y(o);return{configFiles:w(r),fileTypes:w(i),fileCount:u.count,maxFilesReached:u.maxReached,launchConfigFiles:d}}e.collectWorkspaceStats=f;function w(o){return[...L.Iterable.map(o.entries(),([t,s])=>({name:t,count:s}))].sort((t,s)=>s.count-t.count)}function v(){const o={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/E.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/E.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.virtualMachineHint.value()*100)}%`},t=R.cpus();return t&&t.length>0&&(o.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),o}e.getMachineInfo=v;async function y(o){try{const t=new Map,s=(0,k.join)(o,".vscode","launch.json"),i=await n.Promises.readFile(s),r=[],a=(0,D.parse)(i.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,D.getNodeType)(a)==="object"&&a.configurations)for(const l of a.configurations){const u=l.type;u&&(t.has(u)?t.set(u,t.get(u)+1):t.set(u,1))}return w(t)}catch(t){return[]}}e.collectLaunchConfigs=y;let c=class{constructor(t,s){this.telemetryService=t,this.productService=s}formatMachineInfo(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}formatEnvironment(t){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const i=R.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(R.totalmem()/E.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/E.ByteSize.GB).toFixed(2)}GB free)`),C.isWindows||s.push(`Load (avg):       ${R.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(b.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,I.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async i=>{let[r,a]=i,l=this.formatProcessList(t,r);return s.forEach(u=>{if((0,g.isRemoteDiagnosticError)(u))l+=`
${u.errorMessage}`,a+=`
${u.errorMessage}`;else if(l+=`

Remote: ${u.hostName}`,u.processes&&(l+=`
${this.formatProcessList(t,u.processes)}`),u.workspaceMetadata){a+=`
|  Remote: ${u.hostName}`;for(const d of Object.keys(u.workspaceMetadata)){const m=u.workspaceMetadata[d];let A=`${m.fileCount} files`;m.maxFilesReached&&(A=`more than ${A}`),a+=`|    Folder (${d}): ${A}`,a+=this.formatWorkspaceStats(m)}}}),{processInfo:l,workspaceInfo:a}})}async getSystemInfo(t,s){const{memory:i,vmHint:r,os:a,cpus:l}=v(),u={os:a,memory:i,cpus:l,vmHint:r,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return C.isWindows||(u.load=`${R.loadavg().map(d=>Math.round(d)).join(", ")}`),C.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(t,s){const i=[];return(0,I.listProcesses)(t.mainPID).then(async r=>(i.push(""),i.push(this.formatEnvironment(t)),i.push(""),i.push(this.formatProcessList(t,r)),t.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(t))),s.forEach(a=>{if((0,g.isRemoteDiagnosticError)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.formatMachineInfo(a.machineInfo)),a.processes&&i.push(this.formatProcessList(t,a.processes)),a.workspaceMetadata)for(const l of Object.keys(a.workspaceMetadata)){const u=a.workspaceMetadata[l];let d=`${u.fileCount} files`;u.maxFilesReached&&(d=`more than ${d}`),i.push(`Folder (${l}): ${d}`),i.push(this.formatWorkspaceStats(u))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(t){const s=[],i=60;let r=0;const a=(m,A)=>{const _=` ${m}(${A})`;r+_.length>i?(s.push(l),l="|                 ",r=l.length):r+=_.length,l+=_};let l="|      File types:";const u=10;let d=t.fileTypes.length>u?u:t.fileTypes.length;for(let m=0;m<d;m++){const A=t.fileTypes[m];a(A.name,A.count)}if(s.push(l),t.configFiles.length>=0&&(l="|      Conf files:",r=0,t.configFiles.forEach(m=>{a(m.name,m.count)}),s.push(l)),t.launchConfigFiles.length>0){let m="|      Launch Configs:";t.launchConfigFiles.forEach(A=>{m+=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`}),s.push(m)}return s.join(`
`)}expandGPUFeatures(t){const s=Math.max(...Object.keys(t).map(i=>i.length));return Object.keys(t).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${t[i]}`).join(`
                  `)}formatWorkspaceMetadata(t){const s=[],i=[];return t.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(a=>{const l=S.URI.revive(a);if(l.scheme===T.Schemas.file){const u=l.fsPath;i.push(f(u,["node_modules",".git"]).then(d=>{let m=`${d.fileCount} files`;d.maxFilesReached&&(m=`more than ${m}`),s.push(`|    Folder (${(0,k.basename)(u)}): ${m}`),s.push(this.formatWorkspaceStats(d))}).catch(d=>{s.push(`|      Error: Unable to collect workspace stats for folder ${u} (${d.toString()})`)}))}else s.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(t,s){const i=new Map;t.windows.forEach(a=>i.set(a.pid,a.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(t.mainPID,i,r,s,0),r.join(`
`)}formatProcessItem(t,s,i,r,a){const l=a===0;let u;l?u=r.pid===t?`${this.productService.applicationName} main`:"remote agent":(u=`${"  ".repeat(a)} ${r.name}`,r.name==="window"&&(u=`${u} (${s.get(r.pid)})`));const d=process.platform==="win32"?r.mem:R.totalmem()*(r.mem/100);i.push(`${r.load.toFixed(0).padStart(5," ")}	${(d/E.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(r.children)&&r.children.forEach(m=>this.formatProcessItem(t,s,i,m,a+1))}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const i=S.URI.revive(s);if(i.scheme!==T.Schemas.file)continue;const r=i.fsPath;try{const a=await f(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),a.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),a.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),a.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};c=he([Q(0,p.ITelemetryService),Q(1,h.IProductService)],c),e.DiagnosticsService=c}),define(te[198],ne([0,1,17,6,27,8,3,2,4,7,127,28,34,10,42,21]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let f=class extends C.Disposable{constructor(o,t,s){super();this.galleryService=o,this.telemetryService=t,this.logService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,C.toDisposable)(()=>{this.installingExtensions.forEach(i=>i.cancel()),this.uninstallingExtensions.forEach(i=>i.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(o){const t=await this.getTargetPlatform();return o.allTargetPlatforms.some(s=>(0,I.isTargetPlatformCompatible)(s,o.allTargetPlatforms,t))}async installFromGallery(o,t={}){if(!this.galleryService.isEnabled())throw new Error(n.localize(0,null));if(!await this.canInstall(o)){const i=await this.getTargetPlatform(),r=new I.ExtensionManagementError(n.localize(1,null,o.identifier.id,h.default.nameLong,(0,I.TargetPlatformToString)(i)),e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",o.identifier.id,r.message),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(o),void 0,r),r}try{o=await this.checkAndGetCompatibleVersion(o,!t.installGivenVersion)}catch(i){throw this.logService.error((0,T.getErrorMessage)(i)),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(o),void 0,i),i}const s=await this.galleryService.getManifest(o,D.CancellationToken.None);if(s===null){const i=new I.ExtensionManagementError(`Missing manifest for extension ${o.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",o.identifier.id,i.message),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(o),void 0,i),i}if(s.version!==o.version){const i=new I.ExtensionManagementError(`Cannot install '${o.identifier.id}' extension because of version mismatch in Marketplace`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error(i.message),v(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(o),void 0,i),i}return this.installExtension(s,o,t)}async uninstall(o,t={}){return this.logService.trace("ExtensionManagementService#uninstall",o.identifier.id),this.unininstallExtension(o,t)}async reinstallFromGallery(o){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",o.identifier.id),!this.galleryService.isEnabled())throw new Error(n.localize(2,null));const t=await this.findGalleryExtension(o);if(!t)throw new Error(n.localize(3,null));await this.createUninstallExtensionTask(o,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsReport(){const o=new Date().getTime();return(!this.reportedExtensions||o-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=o),this.reportedExtensions}registerParticipant(o){this.participants.push(o)}async installExtension(o,t,s){if(!b.URI.isUri(t)){let u=this.installingExtensions.get(new g.ExtensionIdentifierWithVersion(t.identifier,t.version).key());if(u)return this.logService.info("Extensions is already requested to install",t.identifier.id),u.waitUntilTaskIsFinished();s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const i=[],r=[],a=this.createInstallExtensionTask(o,t,s);b.URI.isUri(t)||this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(a.identifier,o.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:t}),this.logService.info("Installing extension:",a.identifier.id),i.push({task:a,manifest:o});let l=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const d=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,o,!!s.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:m,manifest:A}of d)if(l=l||!!A.extensionDependencies?.some(_=>(0,g.areSameExtensions)({id:_},a.identifier)),this.installingExtensions.has(new g.ExtensionIdentifierWithVersion(m.identifier,m.version).key()))this.logService.info("Extension is already requested to install",m.identifier.id);else{const _=this.createInstallExtensionTask(A,m,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(_.identifier,A.version).key(),_),this._onInstallExtension.fire({identifier:_.identifier,source:m}),this.logService.info("Installing extension:",_.identifier.id),i.push({task:_,manifest:A})}}catch(d){if(b.URI.isUri(a.source))(0,R.isNonEmptyArray)(o.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,d.message),(0,R.isNonEmptyArray)(o.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,d.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(d),d}const u=i.reduce((d,{task:m,manifest:A})=>(d.set(m.identifier.id.toLowerCase(),{task:m,manifest:A}),d),new Map);for(;u.size;){let d;const m=[...u.values()].filter(({manifest:A})=>!A.extensionDependencies?.some(_=>u.has(_.toLowerCase())));m.length?d=u.size===1?m:m.filter(({task:A})=>!(A===a&&!l)):(this.logService.info("Found extensions with circular dependencies",m.map(({task:A})=>A.identifier.id)),d=[...u.values()]),await this.joinAllSettled(d.map(async({task:A})=>{const _=new Date().getTime();try{const O=await A.run();if(await this.joinAllSettled(this.participants.map(N=>N.postInstall(O,A.source,s,D.CancellationToken.None))),!b.URI.isUri(A.source)&&(v(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-_,void 0),S.isWeb&&A.operation===1))try{await this.galleryService.reportStatistic(O.manifest.publisher,O.manifest.name,O.manifest.version,"install")}catch(N){}r.push({local:O,identifier:A.identifier,operation:A.operation,source:A.source})}catch(O){throw b.URI.isUri(A.source)||v(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-_,O),this.logService.error("Error while installing the extension:",A.identifier.id),this.logService.error(O),O}finally{u.delete(A.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:d})=>this.logService.info("Extension installed successfully:",d.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:d})=>(0,g.areSameExtensions)(d,a.identifier))[0].local}catch(u){if(i.forEach(({task:d})=>d.cancel()),r.length)try{const d=await Promise.allSettled(r.map(({local:m})=>this.createUninstallExtensionTask(m,{versionOnly:!0}).run()));for(let m=0;m<d.length;m++){const A=d[m],{identifier:_}=r[m];A.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",_.id):this.logService.warn("Rollback: Error while uninstalling extension",_.id,(0,T.getErrorMessage)(A.reason))}}catch(d){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(d),r.map(({identifier:m})=>m.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,T.getErrorMessage)(u)),this._onDidInstallExtensions.fire(i.map(({task:d})=>({identifier:d.identifier,operation:1,source:d.source}))),u instanceof Error&&(u.name=u&&u.code?u.code:e.ERROR_UNKNOWN),u}finally{for(const{task:u,manifest:d}of i)if(!b.URI.isUri(u.source)){const m=new g.ExtensionIdentifierWithVersion(u.identifier,d.version).key();this.installingExtensions.delete(m)||this.logService.warn("Installation task is not found in the cache",m)}}}async joinAllSettled(o){const t=[],s=[],i=await Promise.allSettled(o);for(const r of i)r.status==="fulfilled"?t.push(r.value):s.push(r.reason);if(s.length)throw w(s);return t}async getAllDepsAndPackExtensionsToInstall(o,t,s){if(!this.galleryService.isEnabled())return[];let i=await this.getInstalled();const r=[o,...i.map(u=>u.identifier)],a=[],l=async(u,d)=>{const m=d.extensionDependencies||[],A=[...m];if(d.extensionPack){const _=s?i.find(O=>(0,g.areSameExtensions)(O.identifier,u)):void 0;for(const O of d.extensionPack)_&&_.manifest.extensionPack&&_.manifest.extensionPack.some(N=>(0,g.areSameExtensions)({id:N},{id:O}))||A.every(N=>!(0,g.areSameExtensions)({id:N},{id:O}))&&A.push(O)}if(A.length){const _=[...r,...a.map(N=>N.gallery.identifier)],O=A.filter(N=>_.every(P=>!(0,g.areSameExtensions)(P,{id:N})));if(O.length){const N=await this.galleryService.query({names:O,pageSize:A.length},D.CancellationToken.None);for(const P of N.firstPage){if(_.find(H=>(0,g.areSameExtensions)(H,P.identifier)))continue;if(!m.some(H=>(0,g.areSameExtensions)({id:H},P.identifier))&&!await this.canInstall(P)){this.logService.info("Skipping the packed extension as it cannot be installed",P.identifier.id);continue}const $=await this.checkAndGetCompatibleVersion(P,!0),U=await this.galleryService.getManifest($,D.CancellationToken.None);if(U===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${$.identifier.id}`,e.INSTALL_ERROR_VALIDATING);a.push({gallery:$,manifest:U}),await l($.identifier,U)}}}};return await l(o,t),i=await this.getInstalled(),a.filter(u=>!i.some(d=>(0,g.areSameExtensions)(d.identifier,u.gallery.identifier)))}async checkAndGetCompatibleVersion(o,t){if(await this.isMalicious(o))throw new I.ExtensionManagementError(n.localize(4,null,o.identifier.id),I.INSTALL_ERROR_MALICIOUS);const s=await this.getCompatibleVersion(o,t);if(!s)throw new I.ExtensionManagementError(n.localize(5,null,o.identifier.id,h.default.version),I.INSTALL_ERROR_INCOMPATIBLE);return s}async getCompatibleVersion(o,t){const s=await this.getTargetPlatform();let i=null;return await this.galleryService.isExtensionCompatible(o,s)&&(i=o),!i&&t&&(i=await this.galleryService.getCompatibleExtension(o,s)),i}async isMalicious(o){const t=await this.getExtensionsReport();return(0,g.getMaliciousExtensionsSet)(t).has(o.identifier.id)}async unininstallExtension(o,t){const s=this.uninstallingExtensions.get(o.identifier.id.toLowerCase());if(s)return this.logService.info("Extensions is already requested to uninstall",o.identifier.id),s.waitUntilTaskIsFinished();const i=(u,d)=>{const m=this.createUninstallExtensionTask(u,d);return this.uninstallingExtensions.set(m.extension.identifier.id.toLowerCase(),m),this.logService.info("Uninstalling extension:",u.identifier.id),this._onUninstallExtension.fire(u.identifier),m},r=(u,d)=>{d?this.logService.error("Failed to uninstall extension:",u.identifier.id,d.message):this.logService.info("Successfully uninstalled extension:",u.identifier.id),v(this.telemetryService,"extensionGallery:uninstall",(0,g.getLocalExtensionTelemetryData)(u),void 0,d),this._onDidUninstallExtension.fire({identifier:u.identifier,error:d?.code})},a=[],l=[];try{a.push(i(o,{}));const u=await this.getInstalled(1);if(t.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",o.identifier.id);else{const d=this.getAllPackExtensionsToUninstall(o,u);for(const m of d)this.uninstallingExtensions.has(m.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",m.identifier.id):a.push(i(m,{}))}t.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",o.identifier.id):this.checkForDependents(a.map(d=>d.extension),u,o),await this.joinAllSettled(a.map(async d=>{try{if(await d.run(),await this.joinAllSettled(this.participants.map(m=>m.postUninstall(d.extension,t,D.CancellationToken.None))),d.extension.identifier.uuid)try{await this.galleryService.reportStatistic(d.extension.manifest.publisher,d.extension.manifest.name,d.extension.manifest.version,"uninstall")}catch(m){}r(d.extension)}catch(m){const A=m instanceof I.ExtensionManagementError?m:new I.ExtensionManagementError((0,T.getErrorMessage)(m),e.ERROR_UNKNOWN);throw r(d.extension,A),A}finally{l.push(d)}}))}catch(u){const d=u instanceof I.ExtensionManagementError?u:new I.ExtensionManagementError((0,T.getErrorMessage)(u),e.ERROR_UNKNOWN);for(const m of a){try{m.cancel()}catch(A){}l.includes(m)||r(m.extension,d)}throw d}finally{for(const u of a)this.uninstallingExtensions.delete(u.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",u.extension.identifier.id)}}checkForDependents(o,t,s){for(const i of o){const r=this.getDependents(i,t);if(r.length){const a=r.filter(l=>!o.some(u=>(0,g.areSameExtensions)(u.identifier,l.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(i,a,s))}}}getDependentsErrorMessage(o,t,s){return s===o?t.length===1?n.localize(6,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?n.localize(7,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):n.localize(8,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):t.length===1?n.localize(9,null,s.manifest.displayName||s.manifest.name,o.manifest.displayName||o.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?n.localize(10,null,s.manifest.displayName||s.manifest.name,o.manifest.displayName||o.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):n.localize(11,null,s.manifest.displayName||s.manifest.name,o.manifest.displayName||o.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}getAllPackExtensionsToUninstall(o,t,s=[]){if(s.indexOf(o)!==-1)return[];s.push(o);const i=o.manifest.extensionPack?o.manifest.extensionPack:[];if(i.length){const r=t.filter(l=>!l.isBuiltin&&i.some(u=>(0,g.areSameExtensions)({id:u},l.identifier))),a=[];for(const l of r)a.push(...this.getAllPackExtensionsToUninstall(l,t,s));return[...r,...a]}return[]}getDependents(o,t){return t.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(i=>(0,g.areSameExtensions)({id:i},o.identifier)))}async findGalleryExtension(o){if(o.identifier.uuid){const t=await this.findGalleryExtensionById(o.identifier.uuid);return t||this.findGalleryExtensionByName(o.identifier.id)}return this.findGalleryExtensionByName(o.identifier.id)}async findGalleryExtensionById(o){return(await this.galleryService.query({ids:[o],pageSize:1},D.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(o){return(await this.galleryService.query({names:[o],pageSize:1},D.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const o=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${o.length} reported extensions from service`),o}catch(o){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};f=he([Q(0,I.IExtensionGalleryService),Q(1,p.ITelemetryService),Q(2,E.ILogService)],f),e.AbstractExtensionManagementService=f;function w(c){const o=Array.isArray(c)?c:[c];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((t,s)=>new Error(`${t.message}${t.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=w;function v(c,o,t,s,i){const r=i?i instanceof I.ExtensionManagementError?i.code:e.ERROR_UNKNOWN:void 0;c.publicLogError(o,{...t,success:!i,duration:s,errorcode:r})}e.reportTelemetry=v;class y{constructor(){this.barrier=new L.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(o=>this.doRun(o))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(o=>new Promise((t,s)=>{const i=o.onCancellationRequested(()=>{i.dispose(),s((0,T.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=y}),define(te[199],ne([0,1,17,6,65,3,9,4,31,7,129,13,28,191,80,14,10,60,29,43,23,21]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p,f,w,v,y,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let i=class extends E.ExtensionTipsService{constructor(a,l,u,d,m,A,_,O,N,P){super(_,O,N,P);this.environmentService=a,this.telemetryService=l,this.extensionManagementService=u,this.storageService=d,this.nativeHostService=m,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,D.forEach)(O.exeBasedExtensionTips,({key:M,value:$})=>{const U=[],H=[],W=[];(0,D.forEach)($.recommendations,({key:x,value:q})=>{q.important?$.important?U.push({extensionId:x,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):H.push({extensionId:x,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):W.push({extensionId:x,extensionName:q.name,isExtensionPack:!!q.isExtensionPack})}),U.length&&this.highImportanceExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:U}),H.length&&this.mediumImportanceExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:H}),W.length&&this.allOtherExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:W})}),(0,L.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...a,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(a,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,u)}groupImportantTipsByExe(a,l){const u=new Map;a.forEach(O=>u.set(O.extensionId.toLowerCase(),O));const{installed:d,uninstalled:m}=this.groupByInstalled([...u.keys()],l);for(const O of d){const N=u.get(O);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:N.exeName})}for(const O of m){const N=u.get(O);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:N.exeName})}const A=this.getPromptedExecutableTips(),_=new Map;for(const O of m){const N=u.get(O);if(N&&(!A[N.exeName]||!A[N.exeName].includes(N.extensionId))){let P=_.get(N.exeName);P||(P=[],_.set(N.exeName,P)),P.push(N)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[a,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(a);break;case"incompatibleWindow":const d=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const m=this._register((0,L.disposableTimeout)(()=>{m.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const a=this.getLastPromptedMediumExeTime(),l=Date.now()-a,u=7*24*60*60*1e3;if(l<u){const A=this._register((0,L.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},u-l));return}const[d,m]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(m).then(A=>{switch(A){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(m[0].exeName,m);const _=this._register((0,L.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const O=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const N=this._register((0,L.disposableTimeout)(()=>{N.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(a){const l=a.map(({extensionId:d})=>d.toLowerCase()),u=(0,n.localize)(0,null,a[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,u,`@exe:"${a[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let a=this.storageService.getNumber(s,0);return a||(a=Date.now(),this.updateLastPromptedMediumExeTime(a)),a}updateLastPromptedMediumExeTime(a){this.storageService.store(s,a,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(a,l){const u=this.getPromptedExecutableTips();u[a]=l.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(t,JSON.stringify(u),0,0)}groupByInstalled(a,l){const u=[],d=[],m=l.reduce((A,_)=>(A.add(_.identifier.id.toLowerCase()),A),new Set);return a.forEach(A=>{m.has(A.toLowerCase())?u.push(A):d.push(A)}),{installed:u,uninstalled:d}}async getValidExecutableBasedExtensionTips(a){const l=[],u=new Map;for(const d of a.keys()){const m=a.get(d);if(!m||!(0,R.isNonEmptyArray)(m.recommendations))continue;const A=[];C.isWindows?m.windowsPath&&A.push(m.windowsPath.replace("%USERPROFILE%",S.env.USERPROFILE).replace("%ProgramFiles(x86)%",S.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",S.env.ProgramFiles).replace("%APPDATA%",S.env.APPDATA).replace("%WINDIR%",S.env.WINDIR)):(A.push((0,k.join)("/usr/local/bin",d)),A.push((0,k.join)("/usr/bin",d)),A.push((0,k.join)(this.environmentService.userHome.fsPath,d)));for(const _ of A){let O=u.get(_);if(O===void 0&&(O=await this.fileService.exists(b.URI.file(_)),u.set(_,O)),O)for(const{extensionId:N,extensionName:P,isExtensionPack:M}of m.recommendations)l.push({extensionId:N,extensionName:P,isExtensionPack:M,exeName:d,exeFriendlyName:m.exeFriendlyName,windowsPath:m.windowsPath})}}return l}};i=he([Q(0,I.INativeEnvironmentService),Q(1,o.ITelemetryService),Q(2,g.IExtensionManagementService),Q(3,c.IStorageService),Q(4,w.INativeHostService),Q(5,h.IExtensionRecommendationNotificationService),Q(6,p.IFileService),Q(7,v.IProductService),Q(8,y.IRequestService),Q(9,f.ILogService)],i),e.ExtensionTipsService=i}),define(te[91],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(T){this.appenders=T}listen(T,k){throw new Error(`Event not found: ${k}`)}call(T,k,{eventName:C,data:S}){return this.appenders.forEach(b=>b.log(C,S)),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class L{constructor(T){this.channel=T}log(T,k){return this.channel.call("log",{eventName:T,data:k}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(te[46],ne([0,1,26,18,20,21]),function(J,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(w,v){return Promise.resolve(void 0)}publicLog2(w,v){return this.publicLog(w,v)}publicLogError(w,v){return Promise.resolve(void 0)}publicLogError2(w,v){return this.publicLogError(w,v)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class C{async publicLog(w,v,y){}async publicLogError(w,v,y){}}e.NullEndpointTelemetryService=C,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(f,w){return w.onDidChangeConfiguration(v=>{v.source!==6&&f.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(v.source),configurationKeys:h(v.sourceConfig)})})}e.configurationTelemetry=S;function b(f,w){return!(w.disableTelemetry||!f.enableTelemetry)}e.supportsTelemetry=b;function n(f){const w=f.getValue(T.TELEMETRY_SETTING_ID),v=f.getValue("telemetry.enableCrashReporter");if(f.getValue(T.TELEMETRY_OLD_SETTING_ID)===!1||v===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=n;function I(f){const w=Object.create(null),v=Object.create(null),y=Object.create(null);E(f,y);for(let c in y){c=c.length>150?c.substr(c.length-149):c;const o=y[c];typeof o=="number"?v[c]=o:typeof o=="boolean"?v[c]=o?1:0:typeof o=="string"?w[c]=o.substring(0,1023):typeof o!="undefined"&&o!==null&&(w[c]=o)}return{properties:w,measurements:v}}e.validateTelemetryData=I;function g(f){if(!f)return"none";let w="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(y=>{f.indexOf(`${y}+`)===0&&(w=y)}),w}e.cleanRemoteAuthority=g;function E(f,w,v=0,y){if(!!f)for(let c of Object.getOwnPropertyNames(f)){const o=f[c],t=y?y+c:c;Array.isArray(o)?w[t]=(0,R.safeStringify)(o):o instanceof Date?w[t]=o.toISOString():(0,L.isObject)(o)?v<2?E(o,w,v+1,t+"."):w[t]=(0,R.safeStringify)(o):w[t]=o}}function h(f){if(!f)return[];const w=[];return p(w,"",f),w}function p(f,w,v){v&&typeof v=="object"&&!Array.isArray(v)?Object.keys(v).forEach(y=>p(f,w?`${w}.${y}`:y,v[y])):f.push(w)}}),define(te[200],ne([0,1,17,27,8,26,4,31,7,20,13,28,34,76,14,10,29,43,45,23,21,46]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p,f,w,v,y,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=k.isWeb?"web":(0,I.getTargetPlatform)(k.platform,C.arch);var s;(function(V){V[V.None=0]="None",V[V.IncludeVersions=1]="IncludeVersions",V[V.IncludeFiles=2]="IncludeFiles",V[V.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",V[V.IncludeSharedAccounts=8]="IncludeSharedAccounts",V[V.IncludeVersionProperties=16]="IncludeVersionProperties",V[V.ExcludeNonValidated=32]="ExcludeNonValidated",V[V.IncludeInstallationTargets=64]="IncludeInstallationTargets",V[V.IncludeAssetUri=128]="IncludeAssetUri",V[V.IncludeStatistics=256]="IncludeStatistics",V[V.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",V[V.Unpublished=4096]="Unpublished"})(s||(s={}));function i(...V){return String(V.reduce((G,ie)=>G|ie,0))}var r;(function(V){V[V.Tag=1]="Tag",V[V.ExtensionId=4]="ExtensionId",V[V.Category=5]="Category",V[V.ExtensionName=7]="ExtensionName",V[V.Target=8]="Target",V[V.Featured=9]="Featured",V[V.SearchText=10]="SearchText",V[V.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class m{constructor(G=d){this.state=G}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(G,ie=this.state.pageSize){return new m({...this.state,pageNumber:G,pageSize:ie})}withFilter(G,...ie){const re=[...this.state.criteria,...ie.length?ie.map(ae=>({filterType:G,value:ae})):[{filterType:G}]];return new m({...this.state,criteria:re})}withSortBy(G){return new m({...this.state,sortBy:G})}withSortOrder(G){return new m({...this.state,sortOrder:G})}withFlags(...G){return new m({...this.state,flags:G.reduce((ie,re)=>ie|re,0)})}withAssetTypes(...G){return new m({...this.state,assetTypes:G})}get raw(){const{criteria:G,pageNumber:ie,pageSize:re,sortBy:ae,sortOrder:ue,flags:fe,assetTypes:ge}=this.state;return{filters:[{criteria:G,pageNumber:ie,pageSize:re,sortBy:ae,sortOrder:ue}],assetTypes:ge,flags:fe}}get searchText(){const G=this.state.criteria.filter(ie=>ie.filterType===r.SearchText)[0];return G&&G.value?G.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(G=>String(G.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(V,G){const ie=(V||[]).filter(re=>re.statisticName===G)[0];return ie?ie.value:0}function _(V){const G="Microsoft.VisualStudio.Code.Translation.";return V.files.filter(re=>re.assetType.indexOf(G)===0).reduce((re,ae)=>{const ue=M(V,ae.assetType);return ue&&re.push([ae.assetType.substring(G.length),ue]),re},[])}function O(V){if(V.properties){const G=V.properties.filter(ae=>ae.key===a.Repository),ie=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),re=G.filter(ae=>ie.test(ae.value))[0];return re?{uri:re.value,fallbackUri:re.value}:null}return M(V,a.Repository)}function N(V){return{uri:`${V.fallbackAssetUri}/${a.VSIX}?redirect=true${V.targetPlatform?`&targetPlatform=${V.targetPlatform}`:""}`,fallbackUri:`${V.fallbackAssetUri}/${a.VSIX}${V.targetPlatform?`?targetPlatform=${V.targetPlatform}`:""}`}}function P(V){const G=M(V,a.Icon);if(G)return G;const ie=I.DefaultIconPath;return{uri:ie,fallbackUri:ie}}function M(V,G){return V.files.filter(re=>re.assetType===G)[0]?{uri:`${V.assetUri}/${G}`,fallbackUri:`${V.fallbackAssetUri}/${G}`}:null}function $(V,G){const ie=V.properties?V.properties.filter(ae=>ae.key===G):[],re=ie.length>0&&ie[0].value;return re?re.split(",").map(ae=>(0,g.adoptToGalleryExtensionId)(ae)):[]}function U(V){const G=V.properties?V.properties.filter(ie=>ie.key===l.Engine):[];return G.length>0&&G[0].value||""}function H(V){const G=V.properties?V.properties.filter(re=>re.key===l.LocalizedLanguages):[],ie=G.length>0&&G[0].value||"";return ie?ie.split(","):[]}function W(V){return V.indexOf("preview")!==-1}function x(V){return V.targetPlatform?(0,I.toTargetPlatform)(V.targetPlatform):"undefined"}function q(V){const G=(0,R.distinct)(V.versions.map(x)),ie=!!V.tags?.includes(I.WEB_EXTENSION_TAG),re=G.indexOf("web");return ie?re===-1&&G.push("web"):re!==-1&&G.splice(re,1),G}function F(V,G){const ie=(0,I.getFallbackTargetPlarforms)(G);for(let re=0;re<V.length;re++){const ae=V[re];if(ae.version===V[re-1]?.version){let ue=re;const fe=x(ae);if(fe===G)for(;ue>0&&V[ue-1].version===ae.version;)ue--;else if(ie.includes(fe))for(;ue>0&&V[ue-1].version===ae.version&&x(V[ue-1])!==G;)ue--;ue!==re&&(V.splice(re,1),V.splice(ue,0,ae))}}return V}e.sortExtensionVersions=F;function K(V,G,ie,re,ae){const ue=q(V);let fe=V.versions[0];return fe=V.versions.find(ge=>ge.version===fe.version&&(0,I.isTargetPlatformCompatible)(x(ge),ue,ae))||fe,j(V,fe,ue,G,ie,re)}function j(V,G,ie,re,ae,ue){const fe={manifest:M(G,a.Manifest),readme:M(G,a.Details),changelog:M(G,a.Changelog),license:M(G,a.License),repository:O(G),download:N(G),icon:P(G),coreTranslations:_(G)};return{identifier:{id:(0,g.getGalleryExtensionId)(V.publisher.publisherName,V.extensionName),uuid:V.extensionId},name:V.extensionName,version:G.version,displayName:V.displayName,publisherId:V.publisher.publisherId,publisher:V.publisher.publisherName,publisherDisplayName:V.publisher.displayName,description:V.shortDescription||"",installCount:A(V.statistics,"install"),rating:A(V.statistics,"averagerating"),ratingCount:A(V.statistics,"ratingcount"),categories:V.categories||[],tags:V.tags||[],releaseDate:Date.parse(V.releaseDate),lastUpdated:Date.parse(V.lastUpdated),allTargetPlatforms:ie,assets:fe,properties:{dependencies:$(G,l.Dependency),extensionPack:$(G,l.ExtensionPack),engine:U(G),localizedLanguages:H(G),targetPlatform:x(G)},preview:W(V.flags),telemetryData:{index:(ae.pageNumber-1)*ae.pageSize+re,querySource:ue}}}let z=class{constructor(G,ie,re,ae,ue,fe,ge,Ie){this.requestService=ie,this.logService=re,this.environmentService=ae,this.telemetryService=ue,this.fileService=fe,this.productService=ge,this.configurationService=Ie;const Pe=ge.extensionsGallery;this.extensionsGalleryUrl=Pe&&Pe.serviceUrl,this.extensionsControlUrl=Pe&&Pe.controlUrl,this.commonHeadersPromise=Z(ge.version,ge,this.environmentService,this.configurationService,this.fileService,G)}api(G=""){return`${this.extensionsGalleryUrl}${G}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(G,ie){const re=[];let ae=new m().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,G.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...G.map(({id:fe})=>fe.toLowerCase()));G.every(fe=>!fe.version)&&(ae=ae.withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly));const{galleryExtensions:ue}=await this.queryGallery(ae,t,L.CancellationToken.None);for(let fe=0;fe<ue.length;fe++){const ge=ue[fe];if(!ge.versions.length)continue;const Ie=(0,g.getGalleryExtensionId)(ge.publisher.publisherName,ge.extensionName),Pe=G.find(Ee=>(0,g.areSameExtensions)(Ee,{id:Ie}))?.version;if(Pe){const Ee=ge.versions.find(_e=>_e.version===Pe);Ee&&re.push(j(ge,Ee,q(ge),fe,ae))}else re.push(K(ge,fe,ae,void 0,t))}return re}async getCompatibleExtension(G,ie){const re=(0,I.isIExtensionIdentifier)(G)?null:G;if(re){if((0,I.isNotWebExtensionInWebTargetPlatform)(re.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(re,ie))return re}const{id:ae,uuid:ue}=re?re.identifier:G;let fe=new m().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");ue?fe=fe.withFilter(r.ExtensionId,ue):fe=fe.withFilter(r.ExtensionName,ae);const{galleryExtensions:ge}=await this.queryGallery(fe,ie,L.CancellationToken.None),[Ie]=ge;if(!Ie||!Ie.versions.length)return null;const Pe=q(Ie);if((0,I.isNotWebExtensionInWebTargetPlatform)(Pe,ie))return null;for(let Ee of Ie.versions){if(!U(Ee)){const _e=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:l.Engine,value:_e}]}}if(await this.isRawExtensionVersionCompatible(Ee,Pe,ie))return j(Ie,Ee,Pe,0,fe)}return null}async isExtensionCompatible(G,ie){if(!(0,I.isTargetPlatformCompatible)(G.properties.targetPlatform,G.allTargetPlatforms,ie))return!1;let re=G.properties.engine;if(!re){const ae=await this.getManifest(G,L.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");re=ae.engines.vscode}return(0,E.isEngineValid)(re,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(G,ie,re){if(!(0,I.isTargetPlatformCompatible)(x(G),ie,re))return!1;const ae=await this.getEngine(G);return(0,E.isEngineValid)(ae,this.productService.version,this.productService.date)}async query(G,ie){const re=L.CancellationToken.isCancellationToken(G)?{}:G,ae=L.CancellationToken.isCancellationToken(G)?G:ie;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ue=re.text||"";const fe=(0,T.getOrDefault)(re,De=>De.pageSize,50);let ge=new m().withFlags(s.IncludeLatestVersionOnly,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,fe).withFilter(r.Target,"Microsoft.VisualStudio.Code");ue?(ue=ue.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(De,ke,Fe)=>(ge=ge.withFilter(r.Category,Fe||ke),"")),ue=ue.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(De,ke,Fe)=>(ge=ge.withFilter(r.Tag,Fe||ke),"")),ue=ue.replace(/\bfeatured(\s+|\b|$)/g,()=>(ge=ge.withFilter(r.Featured),"")),ue=ue.trim(),ue&&(ue=ue.length<200?ue:ue.substring(0,200),ge=ge.withFilter(r.SearchText,ue)),ge=ge.withSortBy(0)):re.ids?ge=ge.withFilter(r.ExtensionId,...re.ids):re.names?ge=ge.withFilter(r.ExtensionName,...re.names):ge=ge.withSortBy(4),typeof re.sortBy=="number"&&(ge=ge.withSortBy(re.sortBy)),typeof re.sortOrder=="number"&&(ge=ge.withSortOrder(re.sortOrder));const{galleryExtensions:Ie,total:Pe}=await this.queryGallery(ge,t,ae),Ee=Ie.map((De,ke)=>K(De,ke,ge,re.source,t)),_e=async(De,ke)=>{if(ke.isCancellationRequested)throw(0,D.canceled)();const Fe=ge.withPage(De+1),{galleryExtensions:Ne}=await this.queryGallery(Fe,t,ke);return Ne.map((ze,xe)=>K(ze,xe,Fe,re.source,t))};return{firstPage:Ee,total:Pe,pageSize:ge.pageSize,getPage:_e}}async queryGallery(G,ie,re){if(!this.isEnabled())throw new Error("No extension gallery service configured.");G=G.withFlags(G.flags,s.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,i(s.Unpublished));const ae=await this.commonHeadersPromise,ue=JSON.stringify(G.raw),fe={...ae,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ue.length)},ge=new Date().getTime();let Ie,Pe,Ee=0;try{if(Ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ue,headers:fe},re),Ie.res.statusCode&&Ie.res.statusCode>=400&&Ie.res.statusCode<500)return{galleryExtensions:[],total:Ee};const _e=await(0,w.asJson)(Ie);if(_e){const De=_e.results[0],ke=De.extensions;ke.forEach(Ne=>F(Ne.versions,ie));const Fe=De.resultMetadata&&De.resultMetadata.filter(Ne=>Ne.metadataType==="ResultCount")[0];return Ee=Fe&&Fe.metadataItems.filter(Ne=>Ne.name==="TotalCount")[0].count||0,{galleryExtensions:ke,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(_e){throw Pe=_e,_e}finally{this.telemetryService.publicLog2("galleryService:query",{...G.telemetryData,requestBodySize:String(ue.length),duration:new Date().getTime()-ge,success:!!Ie&&(0,w.isSuccess)(Ie),responseBodySize:Ie?.res.headers["Content-Length"],statusCode:Ie?String(Ie.res.statusCode):void 0,errorCode:Pe?(0,D.isPromiseCanceledError)(Pe)?"canceled":(0,D.getErrorMessage)(Pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(G,ie,re,ae){if(!this.isEnabled())return;const ue=k.isWeb?this.api(`/itemName/${G}.${ie}/version/${re}/statType/${ae==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${G}/extensions/${ie}/${re}/stats?statType=${ae}`),fe=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ie={...await this.commonHeadersPromise,Accept:fe};try{await this.requestService.request({type:"POST",url:ue,headers:Ie},L.CancellationToken.None)}catch(Pe){}}async download(G,ie,re){this.logService.trace("ExtensionGalleryService#download",G.identifier.id);const ae=(0,g.getGalleryExtensionTelemetryData)(G),ue=new Date().getTime(),fe=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ae,duration:Ee}),ge=re===1?"install":re===2?"update":"",Ie=ge?{uri:`${G.assets.download.uri}${S.URI.parse(G.assets.download.uri).query?"&":"?"}${ge}=true`,fallbackUri:`${G.assets.download.fallbackUri}${S.URI.parse(G.assets.download.fallbackUri).query?"&":"?"}${ge}=true`}:G.assets.download,Pe=await this.getAsset(Ie);await this.fileService.writeFile(ie,Pe.stream),fe(new Date().getTime()-ue)}async getReadme(G,ie){if(G.assets.readme){const re=await this.getAsset(G.assets.readme,{},ie);return await(0,w.asText)(re)||""}return""}async getManifest(G,ie){if(G.assets.manifest){const re=await this.getAsset(G.assets.manifest,{},ie),ae=await(0,w.asText)(re);return ae?JSON.parse(ae):null}return null}async getManifestFromRawExtensionVersion(G,ie){const re=M(G,a.Manifest);if(!re)throw new Error("Manifest was not found");const ae={"Accept-Encoding":"gzip"},ue=await this.getAsset(re,{headers:ae});return await(0,w.asJson)(ue)}async getCoreTranslation(G,ie){const re=G.assets.coreTranslations.filter(ae=>ae[0]===ie.toUpperCase())[0];if(re){const ae=await this.getAsset(re[1]),ue=await(0,w.asText)(ae);return ue?JSON.parse(ue):null}return null}async getChangelog(G,ie){if(G.assets.changelog){const re=await this.getAsset(G.assets.changelog,{},ie);return await(0,w.asText)(re)||""}return""}async getAllCompatibleVersions(G,ie){let re=new m().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");G.identifier.uuid?re=re.withFilter(r.ExtensionId,G.identifier.uuid):re=re.withFilter(r.ExtensionName,G.identifier.id);const{galleryExtensions:ae}=await this.queryGallery(re,ie,L.CancellationToken.None);if(!ae.length)return[];const ue=q(ae[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(ue,ie))return[];const fe=[];for(const ge of ae[0].versions)try{fe[fe.length-1]?.version!==ge.version&&await this.isRawExtensionVersionCompatible(ge,ue,ie)&&fe.push({version:ge.version,date:ge.lastUpdated})}catch(Ie){}return fe}async getAsset(G,ie={},re=L.CancellationToken.None){const ae=await this.commonHeadersPromise,ue={type:"GET"},fe={...ae,...ie.headers||{}};ie={...ie,...ue,headers:fe};const ge=G.uri,Ie=G.fallbackUri,Pe={...ie,url:ge};try{const Ee=await this.requestService.request(Pe,re);if(Ee.res.statusCode===200)return Ee;const _e=await(0,w.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${_e}`)}catch(Ee){if((0,D.isPromiseCanceledError)(Ee))throw Ee;const _e=(0,D.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ge,message:_e});const De={...ie,url:Ie};return this.requestService.request(De,re)}}async getEngine(G){let ie=U(G);if(!ie){const re=await this.getManifestFromRawExtensionVersion(G,L.CancellationToken.None);if(!re)throw new Error("Manifest was not found");ie=re.engines.vscode}return ie}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const G=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(G.res.statusCode!==200)throw new Error("Could not get extensions report.");const ie=await(0,w.asJson)(G),re=new Map;if(ie)for(const ae of ie.malicious){const ue=re.get(ae)||{id:{id:ae},malicious:!0,slow:!1};ue.malicious=!0,re.set(ae,ue)}return[...re.values()]}};z=he([Q(1,w.IRequestService),Q(2,p.ILogService),Q(3,n.IEnvironmentService),Q(4,c.ITelemetryService),Q(5,h.IFileService),Q(6,f.IProductService),Q(7,b.IConfigurationService)],z);let B=class extends z{constructor(G,ie,re,ae,ue,fe,ge,Ie){super(G,ie,re,ae,ue,fe,ge,Ie)}};B=he([Q(0,y.IStorageService),Q(1,w.IRequestService),Q(2,p.ILogService),Q(3,n.IEnvironmentService),Q(4,c.ITelemetryService),Q(5,h.IFileService),Q(6,f.IProductService),Q(7,b.IConfigurationService)],B),e.ExtensionGalleryService=B;let X=class extends z{constructor(G,ie,re,ae,ue,fe,ge){super(void 0,G,ie,re,ae,ue,fe,ge)}};X=he([Q(0,w.IRequestService),Q(1,p.ILogService),Q(2,n.IEnvironmentService),Q(3,c.ITelemetryService),Q(4,h.IFileService),Q(5,f.IProductService),Q(6,b.IConfigurationService)],X),e.ExtensionGalleryServiceWithNoStorageService=X;async function Z(V,G,ie,re,ae,ue){const fe={"X-Market-Client-Id":`VSCode ${V}`,"User-Agent":`VSCode ${V}`},ge=await(0,v.getServiceMachineId)(ie,ae,ue);return(0,o.supportsTelemetry)(G,ie)&&(0,o.getTelemetryLevel)(re)===3&&(fe["X-Market-User-Id"]=ge),fe}e.resolveMarketplaceHeaders=Z}),define(te[92],ne([0,1,2,13,10,46]),function(J,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let k=class extends R.Disposable{constructor(S,b,n=""){super();this.prefix=n;const I=S.getLogger(b.telemetryLogResource);I?this.logger=this._register(I):(this.logger=this._register(S.createLogger(b.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(S,b){this.logger.trace(`${this.prefix}telemetry/${S}`,(0,T.validateTelemetryData)(b))}};k=he([Q(0,D.ILoggerService),Q(1,L.IEnvironmentService)],k),e.TelemetryLogAppender=k}),define(te[93],ne([0,1,2,26,4,25,139,20,39,42,35,21,46]),function(J,e,R,L,D,T,k,C,S,b,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(f,w){this._configurationService=w,this._experimentProperties={},this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=f.appenders,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let v of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(v),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(v=>{const y=/^[a-f0-9]+$/i.test(v["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!y})})}setExperimentProperty(f,w){this._experimentProperties[f]=w}_updateTelemetryLevel(){this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const f=await this._commonProperties;let w=f.sessionID,v=f["common.instanceId"],y=f["common.machineId"],c=f["common.firstSessionDate"],o=f["common.msftInternal"];return{sessionId:w,instanceId:v,machineId:y,firstSessionDate:c,msftInternal:o}}dispose(){this._disposables.dispose()}_log(f,w,v,y){return this.telemetryLevel<w?Promise.resolve(void 0):this._commonProperties.then(c=>{v=(0,L.mixin)(v,c),v=(0,L.mixin)(v,this._experimentProperties),v=(0,L.cloneAndChange)(v,o=>{if(typeof o=="string")return this._cleanupInfo(o,y)}),this._appenders.forEach(o=>o.log(f,v))},c=>{console.error(c)})}publicLog(f,w,v){return this._log(f,3,w,v)}publicLog2(f,w,v){return this.publicLog(f,w,v)}publicLogError(f,w){return this.sendErrorTelemetry?this._log(f,2,w,!0):Promise.resolve(void 0)}publicLogError2(f,w){return this.publicLogError(f,w)}_anonymizeFilePaths(f){let w=f;const v=[];for(let t of this._cleanupPatterns)for(;;){const s=t.exec(f);if(!s)break;v.push([s.index,t.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(w="";;){const t=c.exec(f);if(!t)break;!y.test(t[0])&&v.every(([s,i])=>t.index<s||t.index>=i)&&(w+=f.substring(o,t.index)+"<REDACTED: user-file-path>",o=c.lastIndex)}return o<f.length&&(w+=f.substr(o)),w}_removePropertiesWithPossibleUserInfo(f){if(!f)return f;const w=f.toLowerCase(),v=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(w)?"<REDACTED: secret>":v.test(w)?"<REDACTED: email>":f}_cleanupInfo(f,w){let v=f;w&&(v=this._anonymizeFilePaths(v));for(let y of this._cleanupPatterns)v=v.replace(y,"");return v=this._removePropertiesWithPossibleUserInfo(v),v}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=he([Q(1,C.IConfigurationService)],E),e.TelemetryService=E;function h(){const p=(0,k.localize)(0,null,b.default.nameLong),f=b.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=D.isWeb?"":(0,k.localize)(3,null),v=(0,k.localize)(4,null),y=(0,k.localize)(5,null),c=(0,k.localize)(6,null),o=(0,k.localize)(7,null),t=`
|       | ${v} | ${y} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,k.localize)(8,null);return`
${p} ${f} ${w}

&nbsp;

${o}
${t}

&nbsp;

${s}
`}n.Registry.as(S.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),n.Registry.as(S.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,k.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,k.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[201],ne([0,1,8,26,46]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(C){const S=await new Promise((n,I)=>{J(["applicationinsights"],n,I)});let b;return S.defaultClient?(b=new S.TelemetryClient(C),b.channel.setUseDiskRetryCaching(!0)):(S.setup(C).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),b=S.defaultClient),C.indexOf("AIF-")===0&&(b.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),b}class k{constructor(S,b,n){this._eventPrefix=S,this._defaultData=b,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(S){if(!!this._aiClient){if(typeof this._aiClient!="string"){S(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient)),this._asyncAIClient.then(b=>{S(b)},b=>{(0,R.onUnexpectedError)(b),console.error(b)})}}log(S,b){!this._aiClient||(b=(0,L.mixin)(b,this._defaultData),b=(0,D.validateTelemetryData)(b),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+S,properties:b.properties,measurements:b.measurements})))}flush(){return this._aiClient?new Promise(S=>{this._withAIClient(b=>{b.flush({callback:()=>{this._aiClient=void 0,S(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(te[202],ne([0,1,15,52,20,13,10,21,91,92,93]),function(J,e,R,L,D,T,k,C,S,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let I=class{constructor(E,h,p,f){this.configurationService=E,this.telemetryService=h,this.loggerService=p,this.environmentService=f,this.customTelemetryServices=new Map}async getCustomTelemetryService(E){if(!this.customTelemetryServices.has(E.id)){const{machineId:h,sessionId:p}=await this.telemetryService.getTelemetryInfo(),f=Object.create(null);f["common.vscodemachineid"]=h,f["common.vscodesessionid"]=p;const w=[E.id,JSON.stringify(f),E.aiKey],y=new L.Client(R.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:w,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new S.TelemetryAppenderClient(y),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${E.id}] `)];this.customTelemetryServices.set(E.id,new n.TelemetryService({appenders:c,sendErrorTelemetry:E.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(E.id)}async publicLog(E,h,p){await(await this.getCustomTelemetryService(E)).publicLog(h,p)}async publicLogError(E,h,p){await(await this.getCustomTelemetryService(E)).publicLogError(h,p)}};I=he([Q(0,D.IConfigurationService),Q(1,C.ITelemetryService),Q(2,k.ILoggerService),Q(3,T.IEnvironmentService)],I),e.CustomEndpointTelemetryService=I}),define(te[203],ne([0,1,6,27,3,2,10]),function(J,e,R,L,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let C=class extends T.Disposable{constructor(b,n){super();this._logService=n,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((n,I)=>{const g=++this._lastRequestId;this._pendingRequests.set(g,n),this._onCreateRequest.fire({requestId:g,...b});const E=new L.CancellationTokenSource;(0,R.timeout)(this._timeout,E.token).then(()=>I(`Request ${g} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(g,[(0,T.toDisposable)(()=>E.cancel())])})}acceptReply(b,n){const I=this._pendingRequests.get(b);I?(this._pendingRequests.delete(b),(0,T.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),I(n)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};C=he([Q(1,k.ILogService)],C),e.RequestStore=C}),define(te[94],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var k;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(k=e.TitleEventSource||(e.TitleEventSource={}));var C;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(C=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,R.createDecorator)("ptyService");var S;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions"})(S=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var n;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(n=e.TerminalLocation||(e.TerminalLocation={}));var I;(function(f){f.TerminalView="view",f.Editor="editor"})(I=e.TerminalLocationString||(e.TerminalLocationString={}));var g;(function(f){f.CwdDetection="cwdDetection"})(g=e.ProcessCapability||(e.ProcessCapability={}));var E;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(E=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var p;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(p=e.ProfileSource||(e.ProfileSource={}))}),define(te[204],ne([0,1,5]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,R.createDecorator)("localPtyService")}),define(te[205],ne([0,1,32,26,9,4,31,18,19]),function(J,e,R,L,D,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const I=/(\d+)\.(\d+)\.(\d+)/g.exec(R.release());let g=0;return I&&I.length===4&&(g=parseInt(I[3])),g}e.getWindowsBuildNumber=b;async function n(I,g,E,h=k.env,p=S.Promises.exists){if(D.isAbsolute(I))return await p(I)?I:void 0;if(g===void 0&&(g=k.cwd()),D.dirname(I)!=="."){const y=D.join(g,I);return await p(y)?y:void 0}const w=(0,L.getCaseInsensitive)(h,"PATH");if(E===void 0&&(0,C.isString)(w)&&(E=w.split(D.delimiter)),E===void 0||E.length===0){const y=D.join(g,I);return await p(y)?y:void 0}for(let y of E){let c;if(D.isAbsolute(y)?c=D.join(y,I):c=D.join(g,y,I),await p(c))return c;if(T.isWindows){let o=c+".com";if(await p(o)||(o=c+".exe",await p(o)))return o}}const v=D.join(g,I);return await p(v)?v:void 0}e.findExecutable=n}),define(te[206],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var R;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(R=e.ColorScheme||(e.ColorScheme={}))}),define(te[95],ne([0,1,49,3,2,5,35,206]),function(J,e,R,L,D,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var S;(function(f){function w(v){return v&&typeof v=="object"&&typeof v.id=="string"}f.isThemeColor=w})(S=e.ThemeColor||(e.ThemeColor={}));function b(f){return{id:f}}e.themeColorFromId=b;var n;(function(f){function w(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||S.isThemeColor(s.color))}f.isThemeIcon=w;const v=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function y(s){const i=v.exec(s);if(!i)return;let[,r]=i;return{id:r}}f.fromString=y;function c(s,i){let r=s.id;const a=r.lastIndexOf("~");return a!==-1&&(r=r.substring(0,a)),i&&(r=`${r}~${i}`),{id:r}}f.modify=c;function o(s,i){return s.id===i.id&&s.color?.id===i.color?.id}f.isEqual=o;function t(s,i){return{id:s.id,color:i?b(i):void 0}}f.asThemeIcon=t,f.asClassNameArray=R.CSSIcon.asClassNameArray,f.asClassName=R.CSSIcon.asClassName,f.asCSSSelector=R.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function I(f){switch(f){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,D.toDisposable)(()=>{const v=this.themingParticipants.indexOf(w);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let E=new g;k.Registry.add(e.Extensions.ThemingContribution,E);function h(f){return E.onColorThemeChange(f)}e.registerThemingParticipant=h;class p extends D.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,v){let y=this.theme.getColor(w);return y&&v&&(y=v(y,this.theme)),y?y.toString():null}}e.Themable=p}),define(te[207],ne([0,1,49,95]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function D(C,S){const b=C.map(n=>({name:n.profileName,description:T(n)}));return S&&b.push(...S.map(n=>({name:n.title,description:k(n)}))),{values:b.map(n=>n.name),markdownDescriptions:b.map(n=>n.description)}}e.createProfileSchemaEnums=D;function T(C){let S=`$(${L.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:R.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?S+=`
- args: "${C.args}"`:S+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(S+=`
- overrideName: ${C.overrideName}`),C.color&&(S+=`
- color: ${C.color}`),C.env&&(S+=`
- env: ${JSON.stringify(C.env)}`),S}function k(C){return`$(${L.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:R.Codicon.terminal.id}) ${C.title}
- extensionIdenfifier: ${C.extensionIdentifier}`}}),define(te[208],ne([0,1,49,140,39,35,207]),function(J,e,R,L,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const C={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(R.iconRegistry.all,f=>f.id),markdownEnumDescriptions:Array.from(R.iconRegistry.all,f=>`$(${f.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},S={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...C}},b=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),I=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),g={id:"terminal",order:100,title:(0,L.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(19,null)}},{type:"string",markdownDescription:(0,L.localize)(20,null)}],default:[],markdownDeprecationMessage:I},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(22,null),enum:["PowerShell","Git Bash"]},...C}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(23,null),type:"string"},id:{description:(0,L.localize)(24,null),type:"string"},title:{description:(0,L.localize)(25,null),type:"string"},...C}},{type:"null"},S]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(27,null),type:"string"},id:{description:(0,L.localize)(28,null),type:"string"},title:{description:(0,L.localize)(29,null),type:"string"},...C}},{type:"null"},S]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(31,null),type:"string"},id:{description:(0,L.localize)(32,null),type:"string"},title:{description:(0,L.localize)(33,null),type:"string"},...C}},{type:"null"},S]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,L.localize)(36,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(37,null),type:"boolean",default:!0}}};function E(){T.Registry.as(D.Extensions.Configuration).registerConfiguration(g),p()}e.registerTerminalPlatformConfiguration=E;let h;function p(f,w){const v=T.Registry.as(D.Extensions.Configuration);let y;f&&(y=(0,k.createProfileSchemaEnums)(f?.profiles,w));const c=h;h={id:"terminal",order:100,title:(0,L.localize)(38,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(39,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?y?.values:void 0,markdownEnumDescriptions:f?.os===3?y?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(40,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?y?.values:void 0,markdownEnumDescriptions:f?.os===2?y?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(41,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?y?.values:void 0,markdownEnumDescriptions:f?.os===1?y?.markdownDescriptions:void 0}}},v.updateConfigurations({add:[h],remove:c?[c]:[]})}e.registerTerminalDefaultProfileConfiguration=p}),define(te[209],ne([0,1,37,49,9,4,19,71,205,95]),function(J,e,R,L,D,T,k,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function I(t,s,i,r,a=process.env,l,u,d,m){return l=l||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},T.isWindows?g(i,l,a,u,r.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:r.getValue("terminal.integrated.profiles.windows"),typeof s=="string"?s:r.getValue("terminal.integrated.defaultProfile.windows"),m,d):y(l,u,i,t&&typeof t=="object"?{...t}:r.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof s=="string"?s:r.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),m,d,a)}e.detectAvailableProfiles=I;async function g(t,s,i,r,a,l,u,d,m){const A=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${process.env.windir}\\${A?"Sysnative":"System32"}`;let O=!1;(0,S.getWindowsBuildNumber)()>=16299&&(O=!0),await p(d);const N=new Map;t&&(N.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Windows PowerShell",{path:`${_}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),N.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),N.set("Command Prompt",{path:`${_}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0})),c(l,N);const P=await E(N.entries(),u,s,i,r,m);if(t||!t&&a)try{const M=await w(`${_}\\${O?"wsl":"bash"}.exe`,u);for(const $ of M)(!l||!($.profileName in l))&&P.push($)}catch(M){r?.info("WSL is not installed, so could not detect WSL profiles")}return P}async function E(t,s,i,r=process.env,a,l){const u=[];for(const[d,m]of t){if(m===null)continue;let A,_,O;if("source"in m){const M=n?.get(m.source);if(!M)continue;A=M.paths,_=m.args||M.args,m.icon?O=h(m.icon):M.icon&&(O=M.icon)}else A=Array.isArray(m.path)?m.path:[m.path],_=T.isWindows||Array.isArray(m.args)?m.args:void 0,O=h(m.icon)||void 0;const N=await l?.(A)||A.slice(),P=await o(d,s,N,i,r,_,m.env,m.overrideName,m.isAutoDetected,a);P?(P.isAutoDetected=m.isAutoDetected,P.icon=O,P.color=m.color,u.push(P)):a?.trace("profile not validated",d,A)}return u}function h(t){return typeof t=="string"?{id:t}:t}async function p(t){n&&!t||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:t||await f(),icon:b.ThemeIcon.asThemeIcon(L.Codicon.terminalPowershell)}))}async function f(){const t=[];for await(const s of(0,C.enumeratePowerShellInstallations)())t.push(s.exePath);return t}async function w(t,s){const i=[],r=await new Promise((u,d)=>{R.exec("wsl.exe -l -q",{encoding:"utf16le"},(m,A)=>{if(m)return d("Problem occurred when getting wsl distros");u(A)})});if(!r)return[];const a=new RegExp(/[\r?\n]/),l=r.split(a).filter(u=>u.trim().length>0&&u!=="");for(const u of l){if(u===""||u.startsWith("docker-desktop"))continue;const d=`${u} (WSL)`,m={profileName:d,path:t,args:["-d",`${u}`],isDefault:d===s,icon:v(u)};i.push(m)}return i}function v(t){return t.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(L.Codicon.terminalUbuntu):t.includes("Debian")?b.ThemeIcon.asThemeIcon(L.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(L.Codicon.terminalLinux)}async function y(t,s,i,r,a,l,u,d){const m=new Map;if(i){const A=(await t.readFile("/etc/shells")).toString(),_=l||A.split(`
`).filter(N=>N.trim().indexOf("#")!==0&&N.trim().length>0),O=new Map;for(const N of _){let P=(0,D.basename)(N),M=O.get(P)||0;M++,M>1&&(P=`${P} (${M})`),O.set(P,M),m.set(P,{path:N,isAutoDetected:!0})}}return c(r,m),await E(m.entries(),a,t,d,s,u)}function c(t,s){if(!!t)for(const[i,r]of Object.entries(t))r===null||!("path"in r)&&!("source"in r)?s.delete(i):s.set(i,r)}async function o(t,s,i,r,a,l,u,d,m,A){if(i.length===0)return Promise.resolve(void 0);const _=i.shift();if(_==="")return o(t,s,i,r,a,l,u,d,m);const O={profileName:t,path:_,args:l,env:u,overrideName:d,isAutoDetected:m,isDefault:t===s};if((0,D.basename)(_)===_){const P=a.PATH?a.PATH.split(D.delimiter):void 0;return await(0,S.findExecutable)(_,void 0,P,void 0,r.existsFile)?O:o(t,s,i,r,a,l)}return await r.existsFile((0,D.normalize)(_))?O:o(t,s,i,r,a,l,u,d,m)}}),define(te[210],ne([0,1,3,2,15,4,33,52,20,13,75,166,10,86,21,203,94,208,209]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p,f,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var y;(function(t){t[t.MaxRestarts=5]="MaxRestarts"})(y||(y={}));let c=0,o=class extends L.Disposable{constructor(s,i,r,a,l){super();this._reconnectConstants=s,this._configurationService=i,this._environmentService=r,this._logService=a,this._telemetryService=l,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new R.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new R.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new R.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new R.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new R.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new R.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new R.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new R.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new R.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new R.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new R.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new R.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new R.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new R.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new R.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new R.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,this._onDidChangeProperty=this._register(new R.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,(0,w.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new p.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,I.resolveShellEnv)(this._logService,{_:[]},process.env)}catch(s){return this._logService.error("ptyHost was unable to resolve shell environment",s),{}}}_startPtyHost(){const s={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},i=(0,n.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);i&&(i.break&&i.port?s.debugBrk=i.port:!i.break&&i.port&&(s.debug=i.port));const r=new C.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,s);this._onPtyHostStart.fire(),k.ProxyChannel.toService(r.getChannel(f.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(r.onDidProcessExit(d=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(d.code),this._isDisposed||(this._restartCount<=y.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}, giving up`))}));const l=r.getChannel(f.TerminalIpcChannels.Log);E.LogLevelChannelClient.setLevel(l,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{E.LogLevelChannelClient.setLevel(l,this._logService.getLevel())}));const u=k.ProxyChannel.toService(r.getChannel(f.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(d=>this._onProcessData.fire(d))),this._register(u.onProcessExit(d=>this._onProcessExit.fire(d))),this._register(u.onProcessReady(d=>this._onProcessReady.fire(d))),this._register(u.onProcessTitleChanged(d=>this._onProcessTitleChanged.fire(d))),this._register(u.onProcessShellTypeChanged(d=>this._onProcessShellTypeChanged.fire(d))),this._register(u.onProcessOverrideDimensions(d=>this._onProcessOverrideDimensions.fire(d))),this._register(u.onProcessResolvedShellLaunchConfig(d=>this._onProcessResolvedShellLaunchConfig.fire(d))),this._register(u.onProcessDidChangeHasChildProcesses(d=>this._onProcessDidChangeHasChildProcesses.fire(d))),this._register(u.onDidChangeProperty(d=>this._onDidChangeProperty.fire(d))),this._register(u.onProcessReplay(d=>this._onProcessReplay.fire(d))),this._register(u.onProcessOrphanQuestion(d=>this._onProcessOrphanQuestion.fire(d))),this._register(u.onDidRequestDetach(d=>this._onDidRequestDetach.fire(d))),[r,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(s,i,r,a,l,u,d,m,A,_,O){const N=setTimeout(()=>this._handleUnresponsiveCreateProcess(),f.HeartbeatConstants.CreateProcessTimeout),P=await this._proxy.createProcess(s,i,r,a,l,u,d,m,A,_,O);return clearTimeout(N),c=Math.max(c,P),P}updateTitle(s,i,r){return this._proxy.updateTitle(s,i,r)}updateIcon(s,i,r){return this._proxy.updateIcon(s,i,r)}attachToProcess(s){return this._proxy.attachToProcess(s)}detachFromProcess(s){return this._proxy.detachFromProcess(s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(s){return this._proxy.start(s)}shutdown(s,i){return this._proxy.shutdown(s,i)}input(s,i){return this._proxy.input(s,i)}processBinary(s,i){return this._proxy.processBinary(s,i)}resize(s,i,r){return this._proxy.resize(s,i,r)}acknowledgeDataEvent(s,i){return this._proxy.acknowledgeDataEvent(s,i)}setUnicodeVersion(s,i){return this._proxy.setUnicodeVersion(s,i)}getInitialCwd(s){return this._proxy.getInitialCwd(s)}getCwd(s){return this._proxy.getCwd(s)}getLatency(s){return this._proxy.getLatency(s)}orphanQuestionReply(s){return this._proxy.orphanQuestionReply(s)}getDefaultSystemShell(s){return this._proxy.getDefaultSystemShell(s)}async getProfiles(s,i,r,a=!1){const l=await this._shellEnv;return(0,v.detectAvailableProfiles)(i,r,a,this._configurationService,l,void 0,this._logService,this._resolveVariables.bind(this,s))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(s){return this._proxy.getWslPath(s)}setTerminalLayoutInfo(s){return this._proxy.setTerminalLayoutInfo(s)}async getTerminalLayoutInfo(s){return await this._proxy.getTerminalLayoutInfo(s)}async requestDetachInstance(s,i){return this._proxy.requestDetachInstance(s,i)}async acceptDetachInstanceReply(s,i){return this._proxy.acceptDetachInstanceReply(s,i)}async serializeTerminalState(s){return this._proxy.serializeTerminalState(s)}async reviveTerminalProcesses(s){return this._proxy.reviveTerminalProcesses(s)}async refreshProperty(s,i){return this._proxy.refreshProperty(s,i)}async updateProperty(s,i,r){return this._proxy.updateProperty(s,i,r)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier+f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${f.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(s,i){return this._resolveVariablesRequestStore.createRequest({workspaceId:s,originalText:i})}async acceptPtyHostResolvedVariables(s,i){this._resolveVariablesRequestStore.acceptReply(s,i)}};o=he([Q(1,S.IConfigurationService),Q(2,b.IEnvironmentService),Q(3,g.ILogService),Q(4,h.ITelemetryService)],o),e.PtyHostService=o}),define(te[54],ne([0,1,44]),function(J,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(k,C,S,b){const n=(0,R.setProperty)(k,C,S,b)[0];return n&&(k=k.substring(0,n.offset)+n.content+k.substring(n.offset+n.length)),k}e.edit=L;function D(k,C,S){let b=S;for(;b>=0;){if(k.charAt(b)===C.charAt(C.length-1)&&C.length===1)return b+1;if(b--,C.length===2&&b>=0&&k.charAt(b)===C.charAt(0))return b+2}return 0}e.getLineStartOffset=D;function T(k,C,S){let b=S;for(;b>=0;)if(k.charAt(b)===C.charAt(C.length-1)&&C.length===1||(b++,C.length===2&&b>=0&&k.charAt(b)===C.charAt(1)))return b;return k.length-1}e.getLineEndOffset=T}),define(te[211],ne([0,1,26,59]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(I,g,E,h,p){const f=[],w=[],v=[];if(!g){const _=I.filter(({identifier:O})=>p.every(N=>N.toLowerCase()!==O.id.toLowerCase()));return{local:{added:f,removed:w,updated:v},remote:_.length>0?{added:_,updated:[],removed:[],all:_}:null}}I=I.map(b),g=g.map(b),E=E?E.map(b):null;const y=new Map,c=_=>{_.uuid&&y.set(_.id.toLowerCase(),_.uuid)};I.forEach(({identifier:_})=>c(_)),g.forEach(({identifier:_})=>c(_)),E&&E.forEach(({identifier:_})=>c(_));const o=_=>{const O=_.identifier.uuid||y.get(_.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${_.identifier.id.toLowerCase()}`},t=(_,O)=>(_.set(o(O),O),_),s=I.reduce(t,new Map),i=g.reduce(t,new Map),r=g.reduce((_,O)=>{const N=o(O);O=(0,R.deepClone)(O);const P=s.get(N);return P&&(P.installed&&(O.installed=!0),O.version||(O.version=P.version)),t(_,O)},new Map),a=E?E.reduce(t,new Map):null,l=h.reduce(t,new Map),u=p.reduce((_,O)=>{const N=y.get(O.toLowerCase());return _.add(N?`uuid:${N}`:`id:${O.toLowerCase()}`)},new Set),d=T(s,i,u);if(d.added.size>0||d.removed.size>0||d.updated.size>0){const _=T(a,s,u),O=T(a,i,u),N=(P,M)=>{const $=s.get(P);if($){const U=i.get(P);return{...M?U:$,version:(U.version&&L.gt(U.version,$.version),$.version),state:k($,U,a?.get(P))}}};for(const P of O.removed.values()){const M=s.get(P);M&&w.push(M.identifier)}for(const P of O.added.values())if(_.added.has(P)){if(d.updated.has(P)){const M=N(P,!0);M&&(v.push(n(M,P)),r.set(P,M))}}else{const M=i.get(P);M.installed&&f.push(n(M,P))}for(const P of O.updated.values()){const M=N(P,!0);M&&(v.push(n(M,P)),r.set(P,M))}for(const P of _.added.values())O.added.has(P)||r.set(P,s.get(P));for(const P of _.updated.values())if(!O.removed.has(P)&&!O.updated.has(P)){const M=N(P,!1);M&&(r.get(P)?.installed&&(M.installed=!0),r.set(P,M))}for(const P of _.removed.values())!l.has(P)&&!O.updated.has(P)&&a?.get(P)?.installed&&r.delete(P)}const m=[],A=T(i,r,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(A.added.size>0||A.updated.size>0||A.removed.size>0)&&r.forEach((_,O)=>m.push(n(_,O))),{local:{added:f,removed:w,updated:v},remote:m.length?{added:[...A.added].map(_=>r.get(_)),updated:[...A.updated].map(_=>r.get(_)),removed:[...A.removed].map(_=>i.get(_)),all:m}:null}}e.merge=D;function T(I,g,E,{checkInstalledProperty:h,checkVersionProperty:p}={checkInstalledProperty:!1,checkVersionProperty:!1}){const f=I?[...I.keys()].filter(o=>!E.has(o)):[],w=[...g.keys()].filter(o=>!E.has(o)),v=w.filter(o=>f.indexOf(o)===-1).reduce((o,t)=>(o.add(t),o),new Set),y=f.filter(o=>w.indexOf(o)===-1).reduce((o,t)=>(o.add(t),o),new Set),c=new Set;for(const o of f){if(y.has(o))continue;const t=I.get(o),s=g.get(o);(!s||t.disabled!==s.disabled||!S(t.state,s.state)||p&&t.version!==s.version||h&&t.installed!==s.installed)&&c.add(o)}return{added:v,removed:y,updated:c}}function k(I,g,E){const h=I.state,p=g.state,f=E?.state;if(!g.version||h&&L.gt(I.version,g.version))return h;if(p&&L.gt(g.version,I.version)||!h)return p;if(!p)return h;const w=(0,R.deepClone)(h),v=f?C(f,p):{added:Object.keys(p).reduce((c,o)=>(c.add(o),c),new Set),removed:new Set,updated:new Set},y=f?C(f,h):{added:Object.keys(h).reduce((c,o)=>(c.add(o),c),new Set),removed:new Set,updated:new Set};for(const c of[...v.added.values(),...v.updated.values()])w[c]=p[c];for(const c of v.removed.values())y.updated.has(c)||delete w[c];return w}function C(I,g){const E=Object.keys(I),h=Object.keys(g),p=h.filter(v=>E.indexOf(v)===-1).reduce((v,y)=>(v.add(y),v),new Set),f=E.filter(v=>h.indexOf(v)===-1).reduce((v,y)=>(v.add(y),v),new Set),w=new Set;for(const v of E){if(f.has(v))continue;const y=I[v],c=g[v];(0,R.equals)(y,c)||w.add(v)}return{added:p,removed:f,updated:w}}function S(I={},g={}){const{added:E,removed:h,updated:p}=C(I,g);return E.size===0&&h.size===0&&p.size===0}function b(I){return{...I,disabled:!!I.disabled,installed:!!I.installed}}function n(I,g){const E={identifier:{id:I.identifier.id,uuid:g.startsWith("uuid:")?g.substring("uuid:".length):void 0}};return I.version&&(E.version=I.version),I.disabled&&(E.disabled=!0),I.installed&&(E.installed=!0),I.state&&(E.state=I.state),E}}),define(te[96],ne([0,1,17,3,2,34,5,29,23]),function(J,e,R,L,D,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,k.createDecorator)("IExtensionsStorageSyncService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class nt extends D.Disposable{constructor(g,E){super();this.storageService=g,this.productService=E,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(g){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(g.id)}@${g.version}`}static fromKey(g){const E=b.exec(g);if(E&&E[1])return{id:E[1],version:E[2]}}initialize(){const g=this.storageService.keys(0,1);for(const E of g){const h=nt.fromKey(E);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(g){if(g.scope!==0)return;if(this.extensionsWithKeysForSync.has(g.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const E=nt.fromKey(g.key);if(E){this.extensionsWithKeysForSync.add(E.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(g,E){this.storageService.store(nt.toKey(g),JSON.stringify(E),0,1)}getKeysForSync(g){const E=this.productService.extensionSyncedKeys?.[g.id.toLowerCase()],h=this.storageService.get(nt.toKey(g),0),p=h?JSON.parse(h):void 0;return p&&E?(0,R.distinct)([...p,...E]):p||E}};n=he([Q(0,S.IStorageService),Q(1,C.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(te[97],ne([0,1,17,20,5]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(C){this.configurationService=C}hasToNeverSyncExtension(C){return this.getConfiguredIgnoredExtensions().includes(C.toLowerCase())}hasToAlwaysSyncExtension(C){return this.getConfiguredIgnoredExtensions().includes(`-${C.toLowerCase()}`)}updateIgnoredExtensions(C,S){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return b=b.filter(n=>n!==C&&n!==`-${C}`),S&&b.push(C.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}updateSynchronizedExtensions(C,S){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return b=b.filter(n=>n!==C&&n!==`-${C}`),S&&b.push(`-${C.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}getIgnoredExtensions(C){const S=C.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(g=>g.toLowerCase()),n=[],I=[];if(Array.isArray(b))for(const g of b)g.startsWith("-")?I.push(g.substring(1)):n.push(g);return(0,R.distinct)([...S,...n].filter(g=>I.indexOf(g)===-1))}getConfiguredIgnoredExtensions(){let C=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return C!==void 0||(C=this.configurationService.inspect("sync.ignoredExtensions").userValue,C!==void 0)?C:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};T=he([Q(0,L.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(te[212],ne([0,1,17,36,26,160,54]),function(J,e,R,L,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function C(c){return(0,L.parse)(c)||[]}e.parseKeybindings=C;async function S(c,o,t,s,i){const r=C(c),a=C(o),l=t?C(t):null,u=[...r,...a,...l||[]].map(H=>H.key),d=await i.resolveUserBindings(u);let m=n(r,a,l,d);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const A=g(r),_=g(a),O=l?g(l):null,N=h(A,_,d),P=O?h(O,A,d):{added:[...A.keys()].reduce((H,W)=>(H.add(W),H),new Set),removed:new Set,updated:new Set},M=O?h(O,_,d):{added:[..._.keys()].reduce((H,W)=>(H.add(W),H),new Set),removed:new Set,updated:new Set},$=b(N,P,M);let U=c;for(const H of $.removed.values())$.conflicts.has(H)||(U=v(U,H,s));for(const H of $.added.values()){if($.conflicts.has(H))continue;const W=_.get(H);if(W.some(x=>x.command!==`-${H}`&&m.conflicts.has(d[x.key]))){$.conflicts.add(H);continue}U=w(U,W,s)}for(const H of $.updated.values()){if($.conflicts.has(H))continue;const W=_.get(H);if(W.some(x=>x.command!==`-${H}`&&m.conflicts.has(d[x.key]))){$.conflicts.add(H);continue}U=y(U,H,W,s)}return{mergeContent:U,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=S;function b(c,o,t){const s=new Set,i=new Set,r=new Set,a=new Set;for(const l of o.removed.values())t.updated.has(l)&&a.add(l);for(const l of t.removed.values())a.has(l)||(o.updated.has(l)?a.add(l):i.add(l));for(const l of o.added.values())a.has(l)||t.added.has(l)&&c.updated.has(l)&&a.add(l);for(const l of t.added.values())a.has(l)||(o.added.has(l)?c.updated.has(l)&&a.add(l):s.add(l));for(const l of o.updated.values())a.has(l)||t.updated.has(l)&&c.updated.has(l)&&a.add(l);for(const l of t.updated.values())a.has(l)||(o.updated.has(l)?c.updated.has(l)&&a.add(l):r.add(l));return{added:s,removed:i,updated:r,conflicts:a}}function n(c,o,t,s){const i=new Set,r=I(c,s),a=I(o,s),l=t?I(t,s):null,u=E(r,a);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const d=l?E(l,r):{added:[...r.keys()].reduce((P,M)=>(P.add(M),P),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const m=l?E(l,a):{added:[...a.keys()].reduce((P,M)=>(P.add(M),P),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:A,removed:_,updated:O,conflicts:N}=b(u,d,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:_,updated:O,conflicts:N}}function I(c,o){const t=new Map;for(const s of c){const i=o[s.key];let r=t.get(i);r||(r=[],t.set(i,r)),r.push(s)}return t}function g(c){const o=new Map;for(const t of c){const s=t.command[0]==="-"?t.command.substring(1):t.command;let i=o.get(s);i||(i=[],o.set(s,i)),i.push(t)}return o}function E(c,o){const t=[...c.keys()],s=[...o.keys()],i=s.filter(l=>t.indexOf(l)===-1).reduce((l,u)=>(l.add(u),l),new Set),r=t.filter(l=>s.indexOf(l)===-1).reduce((l,u)=>(l.add(u),l),new Set),a=new Set;for(const l of t){if(r.has(l))continue;const u=c.get(l).map(m=>({...m,key:l})),d=o.get(l).map(m=>({...m,key:l}));(0,R.equals)(u,d,(m,A)=>f(m,A))||a.add(l)}return{added:i,removed:r,updated:a}}function h(c,o,t){const s=[...c.keys()],i=[...o.keys()],r=i.filter(u=>s.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),a=s.filter(u=>i.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),l=new Set;for(const u of s){if(a.has(u))continue;const d=c.get(u).map(A=>({...A,key:t[A.key]})),m=o.get(u).map(A=>({...A,key:t[A.key]}));p(d,m)||l.add(u)}return{added:r,removed:a,updated:l}}function p(c,o){return!(!(0,R.equals)(c.filter(({command:t})=>t[0]!=="-"),o.filter(({command:t})=>t[0]!=="-"),(t,s)=>f(t,s))||!(0,R.equals)(c.filter(({command:t})=>t[0]==="-"),o.filter(({command:t})=>t[0]==="-"),(t,s)=>f(t,s)))}function f(c,o){if(c.command!==o.command||c.key!==o.key)return!1;const t=T.ContextKeyExpr.deserialize(c.when),s=T.ContextKeyExpr.deserialize(o.when);return!(t&&!s||!t&&s||t&&s&&!t.equals(s)||!D.equals(c.args,o.args))}function w(c,o,t){for(const s of o)c=k.edit(c,[-1],s,t);return c}function v(c,o,t){const s=C(c);for(let i=s.length-1;i>=0;i--)(s[i].command===o||s[i].command===`-${o}`)&&(c=k.edit(c,[i],void 0,t));return c}function y(c,o,t,s){const i=C(c),r=i.findIndex(a=>a.command===o||a.command===`-${o}`);for(let a=i.length-1;a>=0;a--)(i[a].command===o||i[a].command===`-${o}`)&&(c=k.edit(c,[a],void 0,s));for(let a=t.length-1;a>=0;a--)c=k.edit(c,[r],t[a],s);return c}}),define(te[213],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(T,k,C){const S={},b={},n=new Set;if(!k)return{local:{added:S,updated:b,removed:[...n.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const I=L(T,k);if(I.added.size===0&&I.removed.size===0&&I.updated.size===0)return{local:{added:S,updated:b,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=L(C,T),E=L(C,k),h={},p={},f=new Set,w=new Set;for(const v of g.removed.values())E.updated.has(v)?S[v]=k[v]:f.add(v);for(const v of E.removed.values())w.has(v)||(g.updated.has(v)?w.add(v):n.add(v));for(const v of g.updated.values())w.has(v)||(E.updated.has(v)?I.updated.has(v)&&w.add(v):p[v]=T[v]);for(const v of E.updated.values())w.has(v)||(g.updated.has(v)?I.updated.has(v)&&w.add(v):T[v]!==void 0&&(b[v]=k[v]));for(const v of g.added.values())w.has(v)||(E.added.has(v)?I.updated.has(v)&&w.add(v):h[v]=T[v]);for(const v of E.added.values())w.has(v)||(g.added.has(v)?I.updated.has(v)&&w.add(v):S[v]=k[v]);return{local:{added:S,removed:[...n.values()],updated:b},remote:{added:h,removed:[...f.values()],updated:p},conflicts:[...w.values()]}}e.merge=R;function L(T,k){const C=T?Object.keys(T):[],S=k?Object.keys(k):[],b=S.filter(g=>C.indexOf(g)===-1).reduce((g,E)=>(g.add(E),g),new Set),n=C.filter(g=>S.indexOf(g)===-1).reduce((g,E)=>(g.add(E),g),new Set),I=new Set;for(const g of C){if(n.has(g))continue;const E=T[g],h=k[g];E!==h&&I.add(g)}return{added:b,removed:n,updated:I}}function D(T,k){const{added:C,removed:S,updated:b}=L(T,k);return C.size===0&&S.size===0&&b.size===0}e.areSame=D}),define(te[24],ne([0,1,17,16,18,145,39,28,5,88,35]),function(J,e,R,L,D,T,k,C,S,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function I(){const l=n.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(l).filter(u=>!!l[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function g(){const l=n.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(l).filter(A=>!!l[A].ignoreSync),d=Object.keys(l).filter(A=>l[A].scope===2||l[A].scope===6),m=I();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...d,...m])}e.getDefaultIgnoredSettings=g,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function E(){const l="vscode://schemas/ignoredSettings",u=n.Registry.as(k.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:C.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:l,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const d=n.Registry.as(b.Extensions.JSONContribution),m=()=>{const A=I(),_=g().filter(M=>M!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(k.allSettings.properties).filter(M=>_.indexOf(M)===-1),N=_.filter(M=>A.indexOf(M)===-1),P={items:{type:"string",enum:[...O,...N.map(M=>`-${M}`)]}};d.registerSchema(l,P)};return u.onDidUpdateConfiguration(()=>m())}e.registerConfiguration=E;function h(l){return l&&(0,D.isObject)(l)&&(0,D.isString)(l.id)&&(0,D.isArray)(l.scopes)}e.isAuthenticationProvider=h;var p;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Extensions="extensions",l.GlobalState="globalState"})(p=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function f(l,u,d){return d.joinPath(u.userDataSyncHome,l,`lastSync${l}.json`)}e.getLastSyncResourceUri=f,e.IUserDataSyncStoreManagementService=(0,S.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,S.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,S.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function w(l){const u={};return u[e.HEADER_EXECUTION_ID]=l,u}e.createSyncHeaders=w;var v;(function(l){l.Unauthorized="Unauthorized",l.Conflict="Conflict",l.Gone="Gone",l.PreconditionFailed="PreconditionFailed",l.TooLarge="TooLarge",l.UpgradeRequired="UpgradeRequired",l.PreconditionRequired="PreconditionRequired",l.TooManyRequests="RemoteTooManyRequests",l.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",l.RequestFailed="RequestFailed",l.RequestCanceled="RequestCanceled",l.RequestTimeout="RequestTimeout",l.RequestProtocolNotSupported="RequestProtocolNotSupported",l.RequestPathNotEscaped="RequestPathNotEscaped",l.RequestHeadersNotObject="RequestHeadersNotObject",l.NoRef="NoRef",l.EmptyResponse="EmptyResponse",l.TurnedOff="TurnedOff",l.SessionExpired="SessionExpired",l.ServiceChanged="ServiceChanged",l.DefaultServiceChanged="DefaultServiceChanged",l.LocalTooManyRequests="LocalTooManyRequests",l.LocalPreconditionFailed="LocalPreconditionFailed",l.LocalInvalidContent="LocalInvalidContent",l.LocalError="LocalError",l.IncompatibleLocalContent="IncompatibleLocalContent",l.IncompatibleRemoteContent="IncompatibleRemoteContent",l.UnresolvedConflicts="UnresolvedConflicts",l.Unknown="Unknown"})(v=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class y extends Error{constructor(u,d,m,A){super(u);this.code=d,this.resource=m,this.operationId=A,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=y;class c extends y{constructor(u,d,m,A,_){super(u,m,void 0,_);this.url=d,this.serverCode=A}}e.UserDataSyncStoreError=c;class o extends y{constructor(u,d){super(u,d)}}e.UserDataAutoSyncError=o,function(l){function u(d){if(d instanceof l)return d;const m=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(d.name);if(m&&m[1]){const A=m[2]==="unknown"?void 0:m[2],_=m[3]==="unknown"?void 0:m[3];return new l(d.message,m[1],A,_)}return new l(d.message,"Unknown")}l.toUserDataSyncError=u}(y=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(l){l.Uninitialized="uninitialized",l.Idle="idle",l.Syncing="syncing",l.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var s;(function(l){l[l.None=0]="None",l[l.Added=1]="Added",l[l.Modified=2]="Modified",l[l.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var i;(function(l){l.Preview="preview",l.Conflict="conflict",l.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(l){return`sync.enable.${l}`}e.getEnablementKey=r,e.IUserDataSyncResourceEnablementService=(0,S.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,S.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,S.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,S.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,S.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,S.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function a(l,u){if(l.scheme!==e.USER_DATA_SYNC_SCHEME)return l=l.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(d=>(0,L.isEqualOrParent)(l,(0,L.joinPath)(u.userDataSyncHome,d,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=a}),define(te[47],ne([0,1,17,6,22,27,3,36,2,16,25,18,7,141,20,13,14,45,23,21,24]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p,f,w,v,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function o(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=o;let t=class extends S.Disposable{constructor(l,u,d,m,A,_,O,N,P,M){super();this.resource=l,this.fileService=u,this.environmentService=d,this.userDataSyncStoreService=A,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=O,this.telemetryService=N,this.logService=P,this.configurationService=M,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new L.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,n.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?b.extUri:b.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(d.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,c.PREVIEW_DIR_NAME),this.lastSyncResource=(0,c.getLastSyncResourceUri)(l,d,this.extUri),this.currentMachineIdPromise=(0,w.getServiceMachineId)(d,u,m)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?(await this.doGenerateSyncResourcePreview(l,l,!0,this.getUserDataSyncConfiguration(),T.CancellationToken.None)).resourcePreviews.some(({remoteChange:d})=>d!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){if(this._status!==l){const u=this._status;l==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&l==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=l,this._onDidChangStatus.fire(l)}}async sync(l,u={}){await this._sync(l,!0,this.getUserDataSyncConfiguration(),u)}async preview(l,u,d={}){return this._sync(l,!1,u,d)}async apply(l,u={}){try{this.syncHeaders={...u};const d=await this.doApply(l);return this.setStatus(d),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,u,d,m){try{if(this.syncHeaders={...m},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let A="idle";try{const _=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(l,_);return A=await this.performSync(O,_,u,d),A==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):A==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(A)}}finally{this.syncHeaders={}}}async replace(l){const u=await this.resolveContent(l);if(!u)return!1;const d=this.parseSyncData(u);if(!d)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const m=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,m),_=await this.isRemoteDataFromCurrentMachine(A),O=await this.generateSyncPreview({ref:A.ref,syncData:d},m,_,this.getUserDataSyncConfiguration(),T.CancellationToken.None),N=[];for(const P of O){const M=await this.getAcceptResult(P,P.remoteResource,void 0,T.CancellationToken.None),{remoteChange:$}=await this.getAcceptResult(P,P.previewResource,P.remoteContent,T.CancellationToken.None);N.push([P,{...M,remoteChange:$!==0?$:2}])}await this.applyResult(A,m,N,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(l){const u=await this.currentMachineIdPromise;return!!l.syncData?.machineId&&l.syncData.machineId===u}async getLatestRemoteUserData(l,u){if(u){const d=l&&l.latest?l.latest[this.resource]:void 0;if(u.ref===d||d===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(l,u,d,m){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new c.UserDataSyncError((0,E.localize)(0,null,this.resource,this.version,l.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(l,u,d,m)}catch(A){if(A instanceof c.UserDataSyncError)switch(A.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,u,d,m);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(l,u,d,m)}throw A}}async doSync(l,u,d,m){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,L.createCancelablePromise)(_=>this.doGenerateSyncResourcePreview(l,u,d,m,_)));const A=await this.syncPreviewPromise;return this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:_})=>_==="conflict")?"hasConflicts":d?await this.doApply(!1):"syncing"}catch(A){throw this.syncPreviewPromise=null,A}}async merge(l){return await this.updateSyncResourcePreview(l,async u=>{const d=await this.getMergeResult(u,T.CancellationToken.None);await this.fileService.writeFile(u.previewResource,D.VSBuffer.fromString(d?.content||""));const m=d&&!d.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,T.CancellationToken.None):void 0;return u.acceptResult=m,u.mergeState=d.hasConflicts?"conflict":m?"accepted":"preview",u.localChange=m?m.localChange:d.localChange,u.remoteChange=m?m.remoteChange:d.remoteChange,u}),this.syncPreviewPromise}async accept(l,u){return await this.updateSyncResourcePreview(l,async d=>{const m=await this.getAcceptResult(d,l,u,T.CancellationToken.None);return d.acceptResult=m,d.mergeState="accepted",d.localChange=m.localChange,d.remoteChange=m.remoteChange,d}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async u=>{const d=await this.getMergeResult(u,T.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,D.VSBuffer.fromString(d.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=d.localChange,u.remoteChange=d.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(l,u){if(!this.syncPreviewPromise)return;let d=await this.syncPreviewPromise;const m=d.resourcePreviews.findIndex(({localResource:A,remoteResource:_,previewResource:O})=>this.extUri.isEqual(A,l)||this.extUri.isEqual(_,l)||this.extUri.isEqual(O,l));m!==-1&&(this.syncPreviewPromise=(0,L.createCancelablePromise)(async A=>{const _=[...d.resourcePreviews];return _[m]=await u(_[m]),{...d,resourcePreviews:_}}),d=await this.syncPreviewPromise,this.updateConflicts(d.resourcePreviews),d.resourcePreviews.some(({mergeState:A})=>A==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:d})=>d==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:d})=>d!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(d=>[d,d.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(l){}}updateConflicts(l){const u=l.filter(({mergeState:d})=>d==="conflict");(0,R.equals)(this._conflicts,u,(d,m)=>this.extUri.isEqual(d.previewResource,m.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:d})=>({created:u,uri:this.toRemoteBackupResource(d)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:d})=>({created:u,uri:this.toLocalBackupResource(d)}))}toRemoteBackupResource(l){return g.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return g.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const u=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(u))){const{content:d}=await this.getUserData(u);if(d)return this.parseSyncData(d)?.machineId}}async resolveContent(l){const u=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(u))){const{content:d}=await this.getUserData(u);return d}return this.extUri.isEqual(l,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(l){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const d of u.resourcePreviews){if(this.extUri.isEqual(d.acceptedResource,l))return d.acceptResult?d.acceptResult.content:null;if(this.extUri.isEqual(d.remoteResource,l))return d.remoteContent;if(this.extUri.isEqual(d.localResource,l))return d.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(l){}}async doGenerateSyncResourcePreview(l,u,d,m,A){const _=await this.isRemoteDataFromCurrentMachine(l),O=await this.generateSyncPreview(l,u,_,m,A),N=[];for(const P of O){const M=P.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(P.localChange===0&&P.remoteChange===0)N.push({...P,acceptedResource:M,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const $=d?await this.getMergeResult(P,A):void 0;if(A.isCancellationRequested)break;await this.fileService.writeFile(P.previewResource,D.VSBuffer.fromString($?.content||""));const U=$&&!$.hasConflicts?await this.getAcceptResult(P,P.previewResource,void 0,A):void 0;N.push({...P,acceptResult:U,mergeState:$?.hasConflicts?"conflict":U?"accepted":"preview",localChange:U?U.localChange:$?$.localChange:P.localChange,remoteChange:U?U.remoteChange:$?$.remoteChange:P.remoteChange})}}return{remoteUserData:l,lastSyncUserData:u,resourcePreviews:N,isLastSyncFromCurrentMachine:_}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(l.value.toString()),d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&d&&u.version!==d,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${d}.`),await this.resetLocal(),null;const m=u;if(m.content===null)return{ref:u.ref,syncData:null};const A=JSON.parse(m.content);if(o(A))return{...u,syncData:A,content:void 0}}catch(l){l instanceof f.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),m={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:d,...u};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(m)))}async getRemoteUserData(l){const{ref:u,content:d}=await this.getUserData(l);let m=null;return d!==null&&(m=this.parseSyncData(d)),{ref:u,syncData:m}}parseSyncData(l){try{const u=JSON.parse(l);if(o(u))return u}catch(u){this.logService.error(u)}throw new c.UserDataSyncError((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(l){if((0,I.isString)(l)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:u}}else{const u=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(l,u){const d=await this.currentMachineIdPromise,m={version:this.version,machineId:d,content:l};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(m),u,this.syncHeaders),{ref:u,syncData:m}}async backupLocal(l){const u={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=he([Q(1,f.IFileService),Q(2,p.IEnvironmentService),Q(3,v.IStorageService),Q(4,c.IUserDataSyncStoreService),Q(5,c.IUserDataSyncBackupStoreService),Q(6,c.IUserDataSyncResourceEnablementService),Q(7,y.ITelemetryService),Q(8,c.IUserDataSyncLogService),Q(9,h.IConfigurationService)],t),e.AbstractSynchroniser=t;let s=class extends t{constructor(l,u,d,m,A,_,O,N,P,M,$){super(u,d,m,A,_,O,N,P,M,$);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(U=>this.onFileChanges(U)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(l){return null}}async updateLocalFileContent(l,u,d){try{u?await this.fileService.writeFile(this.file,D.VSBuffer.fromString(l),d?void 0:u):await this.fileService.createFile(this.file,D.VSBuffer.fromString(l),{overwrite:d})}catch(m){throw m instanceof f.FileOperationError&&m.fileOperationResult===1||m instanceof f.FileOperationError&&m.fileOperationResult===3?new c.UserDataSyncError(m.message,"LocalPreconditionFailed"):m}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};s=he([Q(2,f.IFileService),Q(3,p.IEnvironmentService),Q(4,v.IStorageService),Q(5,c.IUserDataSyncStoreService),Q(6,c.IUserDataSyncBackupStoreService),Q(7,c.IUserDataSyncResourceEnablementService),Q(8,y.ITelemetryService),Q(9,c.IUserDataSyncLogService),Q(10,h.IConfigurationService)],s),e.AbstractFileSynchroniser=s;let i=class extends s{constructor(l,u,d,m,A,_,O,N,P,M,$,U){super(l,u,d,m,A,_,O,N,P,M,U);this.userDataSyncUtilService=$,this._formattingOptions=void 0}hasErrors(l){const u=[];return(0,C.parse)(l,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};i=he([Q(2,f.IFileService),Q(3,p.IEnvironmentService),Q(4,v.IStorageService),Q(5,c.IUserDataSyncStoreService),Q(6,c.IUserDataSyncBackupStoreService),Q(7,c.IUserDataSyncResourceEnablementService),Q(8,y.ITelemetryService),Q(9,c.IUserDataSyncLogService),Q(10,c.IUserDataSyncUtilService),Q(11,h.IConfigurationService)],i),e.AbstractJsonFileSynchroniser=i;let r=class{constructor(l,u,d,m){this.resource=l,this.environmentService=u,this.logService=d,this.fileService=m,this.extUri=this.fileService.hasCapability(u.userDataSyncHome,1024)?b.extUri:b.extUriIgnorePathCase,this.lastSyncResource=(0,c.getLastSyncResourceUri)(this.resource,u,b.extUri)}async initialize({ref:l,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const d=this.parseSyncData(u);if(!d)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:l,syncData:d})}catch(A){this.logService.error(A)}}parseSyncData(l){try{const u=JSON.parse(l);if(o(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,u={}){const d={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(d)))}};r=he([Q(1,p.IEnvironmentService),Q(2,c.IUserDataSyncLogService),Q(3,f.IFileService)],r),e.AbstractInitializer=r}),define(te[214],ne([0,1,6,27,8,3,44,48,25,7,20,13,28,34,14,23,21,47,211,96,97,24]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p,f,w,v,y,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function t(l,u){const d=JSON.parse(l.content);if(l.version===1||l.version===2){const m=(await u.getInstalled(0)).filter(A=>A.isBuiltin);for(const A of d)l.version===1&&(A.enabled===!1&&(A.disabled=!0),delete A.enabled),l.version===2&&m.every(_=>!(0,E.areSameExtensions)(_.identifier,A.identifier))&&(A.installed=!0)}return d}function s(l,u,d){const m=d.get((0,E.getExtensionId)(l,u),0)||"{}";return JSON.parse(m)}e.getExtensionStorageState=s;function i(l,u,d,m){m.store((0,E.getExtensionId)(l,u),JSON.stringify(d),0,1)}e.storeExtensionStorageState=i;let r=class ht extends w.AbstractSynchroniser{constructor(u,d,m,A,_,O,N,P,M,$,U,H,W,x){super("extensions",d,u,m,A,_,H,W,M,U);this.storageService=m,this.extensionManagementService=O,this.extensionEnablementService=N,this.ignoredExtensionsManagementService=P,this.extensionGalleryService=$,this.extensionsStorageSyncService=x,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.debounce(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,q=>q.some(({local:F})=>!!F)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,q=>!q.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(u,d){const m=u.syncData?await t(u.syncData,this.extensionManagementService):null,A=d?.skippedExtensions||[],_=d?.syncData?await t(d.syncData,this.extensionManagementService):null,O=await this.extensionManagementService.getInstalled(void 0,!0),N=this.getLocalExtensions(O),P=this.ignoredExtensionsManagementService.getIgnoredExtensions(O);m?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:M,remote:$}=(0,v.merge)(N,m,_,A,P),U={local:M,remote:$,content:this.getPreviewContent(N,M.added,M.updated,M.removed),localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:$!==null?2:0};return[{skippedExtensions:A,localResource:this.localResource,localContent:this.format(N),localExtensions:N,remoteResource:this.remoteResource,remoteContent:m?this.format(m):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(u,d,m,A){const _=[...d,...m],O=new Set,N=P=>{O.add(P.id.toLowerCase()),P.uuid&&O.add(P.uuid)};_.forEach(({identifier:P})=>N(P)),A.forEach(N);for(const P of u)O.has(P.identifier.id.toLowerCase())||P.identifier.uuid&&O.has(P.identifier.uuid)||_.push(P);return this.format(_)}async getMergeResult(u,d){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,d,m,A){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(d,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(u){const d=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),A=(0,v.merge)(u.localExtensions,null,null,u.skippedExtensions,m),{local:_,remote:O}=A;return{content:u.localContent,local:_,remote:O,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:O!==null?2:0}}async acceptRemote(u){const d=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),A=u.remoteContent?JSON.parse(u.remoteContent):null;if(A!==null){const _=(0,v.merge)(u.localExtensions,A,u.localExtensions,[],m),{local:O,remote:N}=_;return{content:u.remoteContent,local:O,remote:N,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:N!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,d,m,A){let{skippedExtensions:_,localExtensions:O}=m[0][0],{local:N,remote:P,localChange:M,remoteChange:$}=m[0][1];if(M===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),M!==0&&(await this.backupLocal(JSON.stringify(O)),_=await this.updateLocalExtensions(N.added,N.removed,N.updated,_)),P){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const U=JSON.stringify(P.all);u=await this.updateRemoteUserData(U,A?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${P.added.length?` Added: ${JSON.stringify(P.added.map(H=>H.identifier.id))}.`:""}${P.updated.length?` Updated: ${JSON.stringify(P.updated.map(H=>H.identifier.id))}.`:""}${P.removed.length?` Removed: ${JSON.stringify(P.removed.map(H=>H.identifier.id))}.`:""}`)}d?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(u,{skippedExtensions:_}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${_.length?` Skipped: ${JSON.stringify(_.map(U=>U.identifier.id))}.`:""}`))}async getAssociatedResources({uri:u}){return[{resource:this.extUri.joinPath(u,"extensions.json"),comparableResource:ht.EXTENSIONS_DATA_URI}]}async resolveContent(u){if(this.extUri.isEqual(u,ht.EXTENSIONS_DATA_URI)){const m=await this.extensionManagementService.getInstalled(),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(m),_=this.getLocalExtensions(m).filter(O=>!A.some(N=>(0,E.areSameExtensions)({id:N},O.identifier)));return this.format(_)}if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u))return this.resolvePreviewContent(u);let d=await super.resolveContent(u);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(u)),d){const m=this.parseSyncData(d);if(m)switch(this.extUri.basename(u)){case"extensions.json":return this.format(this.parseExtensions(m))}}return null}format(u){u.sort((A,_)=>!A.identifier.uuid&&_.identifier.uuid?-1:A.identifier.uuid&&!_.identifier.uuid?1:(0,S.compare)(A.identifier.id,_.identifier.id));const d=JSON.stringify(u),m=(0,C.format)(d,void 0,{});return(0,k.applyEdits)(d,m)}async hasLocalData(){try{const u=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(u).some(m=>m.installed||m.disabled))return!0}catch(u){}return!1}async updateLocalExtensions(u,d,m,A){const _=[],O=[],N=await this.extensionManagementService.getInstalled();if(d.length){const M=N.filter(({identifier:$,isBuiltin:U})=>!U&&d.some(H=>(0,E.areSameExtensions)($,H)));await R.Promises.settled(M.map(async $=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,$.identifier.id),await this.extensionManagementService.uninstall($,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,$.identifier.id),_.push($.identifier)}))}(u.length||m.length)&&await R.Promises.settled([...u,...m].map(async M=>{const $=N.find(H=>(0,E.areSameExtensions)(H.identifier,M.identifier));if($&&$.isBuiltin){M.state&&$.manifest.version===M.version&&this.updateExtensionState(M.state,$.manifest.publisher,$.manifest.name,$.manifest.version),M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id)),_.push(M.identifier);return}const U=(await this.extensionGalleryService.getExtensions([M.identifier],L.CancellationToken.None))[0];if(M.state&&($?$.manifest.version===M.version:!!U)){const H=$?$.manifest.publisher:U.publisher,W=$?$.manifest.name:U.name;this.updateExtensionState(M.state,H,W,$?.manifest.version)}if(U)try{M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id,U.version),await this.extensionEnablementService.disableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id,U.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id,U.version),await this.extensionEnablementService.enableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id,U.version)),$||(await this.extensionManagementService.canInstall(U)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,M.identifier.id,U.version),await this.extensionManagementService.installFromGallery(U,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,M.identifier.id,U.version),_.push(U.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),O.push(M)))}catch(H){O.push(M),H instanceof g.ExtensionManagementError&&H.code===g.INSTALL_ERROR_INCOMPATIBLE?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,U.displayName||U.identifier.id):(this.logService.error(H),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,U.displayName||U.identifier.id))}else O.push(M),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,M.identifier.id)}));const P=[];for(const M of A)_.some($=>(0,E.areSameExtensions)($,M.identifier))||P.push(M);for(const M of O)P.some($=>(0,E.areSameExtensions)($.identifier,M.identifier))||P.push(M);return P}updateExtensionState(u,d,m,A){const _=s(d,m,this.storageService),O=A?this.extensionsStorageSyncService.getKeysForSync({id:(0,E.getGalleryExtensionId)(d,m),version:A}):void 0;O?O.forEach(N=>{_[N]=u[N]}):Object.keys(u).forEach(N=>_[N]=u[N]),i(d,m,_,this.storageService)}parseExtensions(u){return JSON.parse(u.content)}getLocalExtensions(u){const d=this.extensionEnablementService.getDisabledExtensions();return u.map(({identifier:m,isBuiltin:A,manifest:_})=>{const O={identifier:m,version:_.version};d.some(N=>(0,E.areSameExtensions)(N,m))&&(O.disabled=!0),A||(O.installed=!0);try{const N=this.extensionsStorageSyncService.getKeysForSync({id:m.id,version:_.version});if(N){const P=s(_.publisher,_.name,this.storageService);O.state=Object.keys(P).reduce((M,$)=>(N.includes($)&&(M[$]=P[$]),M),{})}}catch(N){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(N))}return O})}};r.EXTENSIONS_DATA_URI=b.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),r=he([Q(0,I.IEnvironmentService),Q(1,h.IFileService),Q(2,p.IStorageService),Q(3,o.IUserDataSyncStoreService),Q(4,o.IUserDataSyncBackupStoreService),Q(5,g.IExtensionManagementService),Q(6,g.IGlobalExtensionEnablementService),Q(7,c.IIgnoredExtensionsManagementService),Q(8,o.IUserDataSyncLogService),Q(9,g.IExtensionGalleryService),Q(10,n.IConfigurationService),Q(11,o.IUserDataSyncResourceEnablementService),Q(12,f.ITelemetryService),Q(13,y.IExtensionsStorageSyncService)],r),e.ExtensionsSynchroniser=r;let a=class extends w.AbstractInitializer{constructor(u,d,m,A,_){super("extensions",A,_,m);this.extensionManagementService=u,this.ignoredExtensionsManagementService=d}async parseExtensions(u){return u.syncData?await t(u.syncData,this.extensionManagementService):null}generatePreview(u,d){const m=[],A=[],_=[];for(const O of u){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(O.identifier.id))continue;const N=d.find(P=>(0,E.areSameExtensions)(P.identifier,O.identifier));N?(m.push(N),O.disabled&&_.push(O.identifier)):O.installed&&(A.push(O.identifier),O.disabled&&_.push(O.identifier))}return{installedExtensions:m,newExtensions:A,disabledExtensions:_,remoteExtensions:u}}};a=he([Q(0,g.IExtensionManagementService),Q(1,c.IIgnoredExtensionsManagementService),Q(2,h.IFileService),Q(3,I.IEnvironmentService),Q(4,o.IUserDataSyncLogService)],a),e.AbstractExtensionsInitializer=a}),define(te[215],ne([0,1,26,24]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(C,S,b,n,I){if(!S)return{remote:Object.keys(C).length>0?C:null,local:{added:{},removed:[],updated:{}}};const g=T(C,S);if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const E=b?T(b,S):{added:Object.keys(S).reduce((v,y)=>(v.add(y),v),new Set),removed:new Set,updated:new Set},h=b?T(b,C):{added:Object.keys(C).reduce((v,y)=>(v.add(y),v),new Set),removed:new Set,updated:new Set},p={added:{},removed:[],updated:{}},f=R.deepClone(S),w=!b;for(const v of h.added.values())v!==L.SYNC_SERVICE_URL_TYPE&&w&&E.added.has(v)||(f[v]=C[v]);for(const v of h.updated.values())f[v]=C[v];for(const v of h.removed.values())n.unregistered.includes(v)||delete f[v];for(const v of E.added.values()){const y=S[v];if(n.machine.includes(v)){I.info(`GlobalState: Skipped adding ${v} in local storage because it is declared as machine scoped.`);continue}if(b&&h.added.has(v))continue;const c=C[v];c&&c.value===y.value||v===L.SYNC_SERVICE_URL_TYPE&&w&&h.added.has(v)||(c?p.updated[v]=y:p.added[v]=y)}for(const v of E.updated.values()){const y=S[v];if(n.machine.includes(v)){I.info(`GlobalState: Skipped updating ${v} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(v)||h.removed.has(v))continue;const c=C[v];c&&c.value===y.value||(p.updated[v]=y)}for(const v of E.removed.values()){if(n.machine.includes(v)){I.trace(`GlobalState: Skipped removing ${v} in local storage because it is declared as machine scoped.`);continue}h.updated.has(v)||h.removed.has(v)||p.removed.push(v)}return{local:p,remote:k(f,S)?null:f}}e.merge=D;function T(C,S){const b=Object.keys(C),n=Object.keys(S),I=n.filter(h=>b.indexOf(h)===-1).reduce((h,p)=>(h.add(p),h),new Set),g=b.filter(h=>n.indexOf(h)===-1).reduce((h,p)=>(h.add(p),h),new Set),E=new Set;for(const h of b){if(g.has(h))continue;const p=C[h],f=S[h];R.equals(p,f)||E.add(h)}return{added:I,removed:g,updated:E}}function k(C,S){const{added:b,removed:n,updated:I}=T(C,S);return b.size===0&&n.size===0&&I.size===0}}),define(te[216],ne([0,1,22,3,36,44,48,4,7,30,20,13,14,10,45,23,21,47,54,215,24]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p,f,w,v,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const o="globalState.argv.",t=["locale"];function s(u){const d=u.storage?Object.keys(u.storage).sort():[],m={};d.forEach(O=>m[O]=u.storage[O]),u.storage=m;const A=JSON.stringify(u),_=(0,k.format)(A,void 0,{});return(0,T.applyEdits)(A,_)}const i=1;let r=class ft extends w.AbstractSynchroniser{constructor(d,m,A,_,O,N,P,M,$){super("globalState",d,O,$,m,A,N,P,_,M);this.storageService=$,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(d.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(d.onDidFilesChange,U=>U.contains(this.environmentService.argvResource)),L.Event.filter($.onDidChangeValue,U=>U.scope===0&&U.target!==void 0?U.target===0:$.keys(0,0).includes(U.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(d,m,A){const _=d.syncData?JSON.parse(d.syncData.content):null;m=m===null&&A?d:m;const O=m&&m.syncData?JSON.parse(m.syncData.content):null,N=await this.getLocalGlobalState();_?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const P=this.getStorageKeys(O),{local:M,remote:$}=(0,y.merge)(N.storage,_?_.storage:null,O?O.storage:null,P,this.logService),U={content:null,local:M,remote:$,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:$!==null?2:0};return[{localResource:this.localResource,localContent:s(N),localUserData:N,remoteResource:this.remoteResource,remoteContent:_?s(_):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource,storageKeys:P}]}async getMergeResult(d,m){return{...d.previewResult,hasConflicts:!1}}async getAcceptResult(d,m,A,_){if(this.extUri.isEqual(m,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(m,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(m,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${m.toString()}`)}async acceptLocal(d){return{content:d.localContent,local:{added:{},removed:[],updated:{}},remote:d.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(d){if(d.remoteContent!==null){const m=JSON.parse(d.remoteContent),{local:A,remote:_}=(0,y.merge)(d.localUserData.storage,m.storage,null,d.storageKeys,this.logService);return{content:d.remoteContent,local:A,remote:_,localChange:Object.keys(A.added).length>0||Object.keys(A.updated).length>0||A.removed.length>0?2:0,remoteChange:_!==null?2:0}}else return{content:d.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(d,m,A,_){let{localUserData:O}=A[0][0],{local:N,remote:P,localChange:M,remoteChange:$}=A[0][1];if(M===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),M!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(O)),await this.writeLocalGlobalState(N),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),$!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:P});d=await this.updateRemoteUserData(U,_?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}m?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"globalState.json"),comparableResource:ft.GLOBAL_STATE_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,ft.GLOBAL_STATE_DATA_URI)){const A=await this.getLocalGlobalState();return s(A)}if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let m=await super.resolveContent(d);if(m)return m;if(m=await super.resolveContent(this.extUri.dirname(d)),m){const A=this.parseSyncData(m);if(A)switch(this.extUri.basename(d)){case"globalState.json":return s(JSON.parse(A.content))}}return null}async hasLocalData(){try{const{storage:d}=await this.getLocalGlobalState();if(Object.keys(d).length>1||d[`${o}.locale`]?.value!=="en")return!0}catch(d){}return!1}async getLocalGlobalState(){const d={},m=await this.getLocalArgvContent(),A=(0,D.parse)(m);for(const _ of t)A[_]!==void 0&&(d[`${o}${_}`]={version:1,value:A[_]});for(const _ of this.storageService.keys(0,0)){const O=this.storageService.get(_,0);O&&(d[_]={version:1,value:O})}return{storage:d}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(d){}return"{}"}async writeLocalGlobalState({added:d,removed:m,updated:A}){const _={},O={},N=(M,$)=>{for(const U of M){if(U.startsWith(o)){_[U.substring(o.length)]=$?$[U].value:void 0;continue}if($){const H=$[U];H.value!==String(this.storageService.get(U,0))&&(O[U]=H.value)}else this.storageService.get(U,0)!==void 0&&(O[U]=void 0)}};if(N(Object.keys(d),d),N(Object.keys(A),A),N(m),Object.keys(_).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(_),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(O).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const M of Object.keys(O))this.storageService.store(M,O[M],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(O))}}async updateArgv(d){const m=await this.getLocalArgvContent();let A=m;for(const _ of Object.keys(d))A=(0,v.edit)(A,[_],d[_],{});m!==A&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(A)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(d){const m=this.storageService.keys(0,0),A=this.storageService.keys(0,1),_=[...m,...A],O=d?.storage?Object.keys(d.storage).filter(N=>!N.startsWith(o)&&!_.includes(N)&&this.storageService.get(N,0)!==void 0):[];if(!C.isWeb){const N=[...c.ALL_SYNC_RESOURCES.map(P=>(0,c.getEnablementKey)(P)),c.SYNC_SERVICE_URL_TYPE];O.push(...N),A.push(...N)}return{user:m,machine:A,unregistered:O}}};r.GLOBAL_STATE_DATA_URI=S.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),r=he([Q(0,g.IFileService),Q(1,c.IUserDataSyncStoreService),Q(2,c.IUserDataSyncBackupStoreService),Q(3,c.IUserDataSyncLogService),Q(4,I.IEnvironmentService),Q(5,c.IUserDataSyncResourceEnablementService),Q(6,f.ITelemetryService),Q(7,n.IConfigurationService),Q(8,p.IStorageService)],r),e.GlobalStateSynchroniser=r;let a=class extends w.AbstractInitializer{constructor(d,m,A,_){super("globalState",A,_,m);this.storageService=d}async doInitialize(d){const m=d.syncData?JSON.parse(d.syncData.content):null;if(!m){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const A={},_={};for(const O of Object.keys(m.storage))O.startsWith(o)?A[O.substring(o.length)]=m.storage[O].value:this.storageService.get(O,0)===void 0&&(_[O]=m.storage[O].value);if(Object.keys(A).length){let O="{}";try{O=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(N){}for(const N of Object.keys(A))O=(0,v.edit)(O,[N],A[N],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(O))}if(Object.keys(_).length)for(const O of Object.keys(_))this.storageService.store(O,_[O],0,0)}};a=he([Q(0,p.IStorageService),Q(1,g.IFileService),Q(2,I.IEnvironmentService),Q(3,c.IUserDataSyncLogService)],a),e.GlobalStateInitializer=a;let l=class{constructor(d,m,A,_,O){this.userDataSyncStoreClient=d,this.storageService=m,this.environmentService=A,this.fileService=_,this.logService=O}getSyncStoreType(d){return this.parseGlobalState(d)?.storage[c.SYNC_SERVICE_URL_TYPE]?.value}async sync(d){const m=(0,c.createSyncHeaders)((0,b.generateUuid)());try{return await this.doSync(d,m)}catch(A){if(A instanceof c.UserDataSyncError)switch(A.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(d,m)}throw A}}async doSync(d,m){const A=await this.userDataSyncStoreClient.read("globalState",null,m),_=this.parseGlobalState(A)||{storage:{}};_.storage[c.SYNC_SERVICE_URL_TYPE]={value:d,version:i};const O=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),N={version:i,machineId:O,content:s(_)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(N),A.ref,m)}parseGlobalState({content:d}){if(!d)return null;const m=JSON.parse(d);if((0,w.isSyncData)(m))return m?JSON.parse(m.content):null;throw new Error("Invalid remote data")}};l=he([Q(1,p.IStorageService),Q(2,I.IEnvironmentService),Q(3,g.IFileService),Q(4,E.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(te[217],ne([0,1,17,22,3,36,4,18,142,20,13,14,23,21,47,212,24]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(c,o,t){try{const s=JSON.parse(c);if(!o)return(0,C.isUndefined)(s.all)?null:s.all;switch(k.OS){case 2:return(0,C.isUndefined)(s.mac)?null:s.mac;case 3:return(0,C.isUndefined)(s.linux)?null:s.linux;case 1:return(0,C.isUndefined)(s.windows)?null:s.windows}}catch(s){return t.error(s),null}}e.getKeybindingsContentFromSyncContent=w;let v=class extends h.AbstractJsonFileSynchroniser{constructor(o,t,s,i,r,a,l,u,d,m){super(l.keybindingsResource,"keybindings",a,l,u,o,t,r,m,s,d,i);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(i.onDidChangeConfiguration,A=>A.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,t,s,i){const r=o.syncData?w(o.syncData.content,i.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&s?o:t;const a=t?this.getKeybindingsContentFromLastSyncUserData(t):null,l=await this.getLocalFileContent(),u=await this.getFormattingOptions();let d=null,m=!1,A=!1,_=!1;if(r){let N=l?l.value.toString():"[]";if(N=N||"[]",this.hasErrors(N))throw new f.UserDataSyncError((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==N||a!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const P=await(0,p.merge)(N,r,a,u,this.userDataSyncUtilService);P.hasChanges&&(d=P.mergeContent,_=P.hasConflicts,m=_||P.mergeContent!==N,A=_||P.mergeContent!==r)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),d=l.value.toString(),A=!0);const O={content:d,localChange:m?l?2:1:0,remoteChange:A?2:0,hasConflicts:_};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:O.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:O.remoteChange,previewResource:this.previewResource,previewResult:O,acceptedResource:this.acceptedResource}]}async getMergeResult(o,t){return o.previewResult}async getAcceptResult(o,t,s,i){if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,s,i){const{fileContent:r}=s[0][0];let{content:a,localChange:l,remoteChange:u}=s[0][1];if(l===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a)))throw new f.UserDataSyncError((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),r&&await this.backupLocal(this.toSyncContent(r.value.toString())),await this.updateLocalFileContent(a||"[]",r,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const d=this.toSyncContent(a||"[]",o.syncData?.content);o=await this.updateRemoteUserData(d,i?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(d){}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=(0,T.parse)(o.value.toString());if((0,R.isNonEmptyArray)(t))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:o}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(o,"keybindings.json"),comparableResource:t}]}async resolveContent(o){if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o))return this.resolvePreviewContent(o);let t=await super.resolveContent(o);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(o)),t){const s=this.parseSyncData(t);if(s)switch(this.extUri.basename(o)){case"keybindings.json":return w(s.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(o.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(o,t){let s={};try{s=JSON.parse(t||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=o,k.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};v=he([Q(0,f.IUserDataSyncStoreService),Q(1,f.IUserDataSyncBackupStoreService),Q(2,f.IUserDataSyncLogService),Q(3,b.IConfigurationService),Q(4,f.IUserDataSyncResourceEnablementService),Q(5,I.IFileService),Q(6,n.IEnvironmentService),Q(7,g.IStorageService),Q(8,f.IUserDataSyncUtilService),Q(9,E.ITelemetryService)],v),e.KeybindingsSynchroniser=v;let y=class extends h.AbstractInitializer{constructor(o,t,s){super("keybindings",t,s,o)}async doInitialize(o){const t=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,L.VSBuffer.fromString(t)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,T.parse)(o.value.toString());return!(0,R.isNonEmptyArray)(t)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return w(o,!0,this.logService)}catch(t){return this.logService.error(t),null}}};y=he([Q(0,I.IFileService),Q(1,n.IEnvironmentService),Q(2,f.IUserDataSyncLogService)],y),e.KeybindingsInitializer=y}),define(te[218],ne([0,1,17,36,44,48,26,54,24]),function(J,e,R,L,D,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function b(l,u,d){let m=[];d?m=I(d):m=n(u);const A=[],_=[...(0,S.getDisallowedIgnoredSettings)()];if(Array.isArray(m))for(const O of m)O.startsWith("-")?_.push(O.substring(1)):A.push(O);return(0,R.distinct)([...l,...A].filter(O=>_.indexOf(O)===-1))}e.getIgnoredSettings=b;function n(l){let u=l.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=l.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:l.getValue("settingsSync.ignoredSettings")||[]}function I(l){const u=(0,L.parse)(l);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function g(l,u,d,m){if(d.length){const A=a(u),_=(0,L.parse)(u),O=(0,L.parse)(l),N=[];for(const P of d){const M=_[P],$=O[P];M===void 0?l=C.edit(l,[P],void 0,m):$!==void 0?l=C.edit(l,[P],M,m):N.push(o(P,A))}N.sort((P,M)=>P.startOffset-M.startOffset),N.forEach(P=>l=w(P.setting.key,u,l,m))}return l}e.updateIgnoredSettings=g;function E(l,u,d,m,A,_){const O=g(l,u,m,_),N=d!==O,P=d!==u;if(!N&&!P)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!P)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(P&&!N)return{conflictsSettings:[],localContent:g(u,l,m,_),remoteContent:null,hasConflicts:!1};if(d===null&&p(l)){const G=h(l,u,m)?null:g(u,l,m,_);return{conflictsSettings:[],localContent:G,remoteContent:null,hasConflicts:!1}}let M=l,$=u;const U=(0,L.parse)(l),H=(0,L.parse)(u),W=d?(0,L.parse)(d):null,x=m.reduce((G,ie)=>(G.add(ie),G),new Set),q=f(U,H,x),F=f(W,U,x),K=f(W,H,x),j=new Map,z=new Set,B=G=>{z.add(G);const ie=A.filter(({key:re})=>re===G)[0];ie?(M=C.edit(M,[G],ie.value,_),$=C.edit($,[G],ie.value,_)):j.set(G,{key:G,localValue:U[G],remoteValue:H[G]})};for(const G of F.removed.values())K.updated.has(G)?B(G):$=C.edit($,[G],void 0,_);for(const G of K.removed.values())z.has(G)||(F.updated.has(G)?B(G):M=C.edit(M,[G],void 0,_));for(const G of F.updated.values())z.has(G)||(K.updated.has(G)?q.updated.has(G)&&B(G):$=C.edit($,[G],U[G],_));for(const G of K.updated.values())z.has(G)||(F.updated.has(G)?q.updated.has(G)&&B(G):M=C.edit(M,[G],H[G],_));for(const G of F.added.values())z.has(G)||(K.added.has(G)?q.updated.has(G)&&B(G):$=w(G,M,$,_));for(const G of K.added.values())z.has(G)||(F.added.has(G)?q.updated.has(G)&&B(G):M=w(G,$,M,_));const X=j.size>0||!h(M,$,m),Z=X||!h(M,l,[]),V=X||!h($,u,[]);return{localContent:Z?M:null,remoteContent:V?$:null,conflictsSettings:[...j.values()],hasConflicts:X}}e.merge=E;function h(l,u,d){if(l===u)return!0;const m=(0,L.parse)(l),A=(0,L.parse)(u),_=d.reduce((P,M)=>(P.add(M),P),new Set),O=a(l).filter(P=>!(P.setting&&_.has(P.setting.key))),N=a(u).filter(P=>!(P.setting&&_.has(P.setting.key)));if(O.length!==N.length)return!1;for(let P=0;P<O.length;P++){const M=O[P],$=N[P];if(M.setting&&$.setting){if(M.setting.key!==$.setting.key||!k.equals(m[M.setting.key],A[M.setting.key]))return!1}else if(!M.setting&&!$.setting){if(M.value!==$.value)return!1}else return!1}return!0}e.areSame=h;function p(l){return l?a(l).length===0:!0}e.isEmpty=p;function f(l,u,d){const m=l?Object.keys(l).filter(P=>!d.has(P)):[],A=Object.keys(u).filter(P=>!d.has(P)),_=A.filter(P=>m.indexOf(P)===-1).reduce((P,M)=>(P.add(M),P),new Set),O=m.filter(P=>A.indexOf(P)===-1).reduce((P,M)=>(P.add(M),P),new Set),N=new Set;if(l)for(const P of m){if(O.has(P))continue;const M=l[P],$=u[P];k.equals(M,$)||N.add(P)}return{added:_,removed:O,updated:N}}function w(l,u,d,m){const A=(0,L.parse)(u),_=a(u),O=a(d),N=v(l,_,O);return y(d,l,A[l],N,O,m)}e.addSetting=w;function v(l,u,d){const m=u.findIndex(_=>_.setting?.key===l),A=u[m-1];if(A){if(A.setting){const O=o(A.setting.key,d);if(O)return{index:d.indexOf(O),insertAfter:!0}}else{const O=t(m,u);if(O){const N=o(O.setting.key,d);if(N){const P=s(d.indexOf(N),d),M=i(u,O,u[m]);if(P){const $=i(d,N,P),U=r(M,$);return U?{index:d.indexOf(U),insertAfter:!0}:{index:d.indexOf(P),insertAfter:!1}}else{const $=i(d,N,d[d.length-1]),U=r(M,$);return U?{index:d.indexOf(U),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const _=u[m+1];if(_)if(_.setting){const O=o(_.setting.key,d);if(O)return{index:d.indexOf(O),insertAfter:!1}}else{const O=s(m,u);if(O){const N=o(O.setting.key,d);if(N){const P=t(d.indexOf(N),d),M=i(u,u[m],O);if(P){const $=i(d,P,N),U=r(M.reverse(),$.reverse());return U?{index:d.indexOf(U),insertAfter:!1}:{index:d.indexOf(P),insertAfter:!0}}else{const $=i(d,d[0],N),U=r(M.reverse(),$.reverse());return U?{index:d.indexOf(U),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function y(l,u,d,m,A,_){let O;return m.index===-1?O=(0,D.setProperty)(l,[u],d,_):O=c(l,u,d,m,A,_).map(N=>(0,D.withFormatting)(l,N,_)[0]),(0,D.applyEdits)(l,O)}function c(l,u,d,m,A,_){const O=`${JSON.stringify(u)}: ${JSON.stringify(d)}`,N=(0,T.getEOL)(_,l),P=A[m.index];if(m.insertAfter){const M=[];if(P.setting)M.push({offset:P.endOffset,length:0,content:","+O});else{const $=s(m.index,A),U=t(m.index,A),H=U?.setting?.commaOffset;U&&H===void 0&&M.push({offset:U.endOffset,length:0,content:","});const W=H!==void 0&&H>P.endOffset;M.push({offset:W?H+1:P.endOffset,length:0,content:$?N+O+",":N+O})}return M}else{if(P.setting)return[{offset:P.startOffset,length:0,content:O+","}];const M=(A[m.index-1]&&!A[m.index-1].setting?N:"")+O+(s(m.index,A)?",":"")+N;return[{offset:P.startOffset,length:0,content:M}]}}function o(l,u){return u.filter(d=>d.setting?.key===l)[0]}function t(l,u){for(let d=l-1;d>=0;d--)if(u[d].setting)return u[d]}function s(l,u){for(let d=l+1;d<u.length;d++)if(u[d].setting)return u[d]}function i(l,u,d){const m=l.indexOf(u),A=l.indexOf(d);return l.filter((_,O)=>m<O&&O<A)}function r(l,u){if(l.length&&u.length){let d=0;for(;d<u.length&&d<l.length;d++)if(l[d].value!==u[d].value)return u[d-1];return u[d-1]}}function a(l){const u=[];let d=-1,m,A;const _={onObjectBegin:O=>{d++},onObjectProperty:(O,N,P)=>{d===0&&(m=N,A=O)},onObjectEnd:(O,N)=>{d--,d===0&&u.push({startOffset:m,endOffset:O+N,value:l.substring(m,O+N),setting:{key:A,commaOffset:void 0}})},onArrayBegin:(O,N)=>{d++},onArrayEnd:(O,N)=>{d--,d===0&&u.push({startOffset:m,endOffset:O+N,value:l.substring(m,O+N),setting:{key:A,commaOffset:void 0}})},onLiteralValue:(O,N,P)=>{d===0&&u.push({startOffset:m,endOffset:N+P,value:l.substring(m,N+P),setting:{key:A,commaOffset:void 0}})},onSeparator:(O,N,P)=>{if(d===0&&O===","){let M=u.length-1;for(;M>=0&&!u[M].setting;M--);const $=u[M];$&&u.splice(M,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:N}})}},onComment:(O,N)=>{d===0&&u.push({startOffset:O,endOffset:O+N,value:l.substring(O,O+N)})}};return(0,L.visit)(l,_),u}}),define(te[219],ne([0,1,22,3,44,143,20,89,13,28,14,23,21,47,54,218,24]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function w(t){return t&&t.settings&&typeof t.settings=="string"&&Object.keys(t).length===1}function v(t){const s=JSON.parse(t);return w(s)?s:{settings:t}}e.parseSettingsSyncContent=v;let y=class extends E.AbstractJsonFileSynchroniser{constructor(s,i,r,a,l,u,d,m,A,_,O){super(i.settingsResource,"settings",s,i,r,a,l,A,_,u,d,m);this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(s){const i=await this.getLastSyncUserData(),r=await this.getLatestRemoteUserData(s,i),a=this.getSettingsSyncContent(r),l=new C.ConfigurationModelParser(f.USER_DATA_SYNC_CONFIGURATION_SCOPE);return a?.settings&&l.parse(a.settings),l.configurationModel.getValue(f.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(s,i,r){const a=await this.getLocalFileContent(),l=await this.getFormattingOptions(),u=this.getSettingsSyncContent(s);i=i===null&&r?s:i;const d=i?this.getSettingsSyncContent(i):null,m=await this.getIgnoredSettings();let A=null,_=!1,O=!1,N=!1;if(u){let M=a?a.value.toString().trim():"{}";M=M||"{}",this.validateContent(M),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const $=(0,p.merge)(M,u.settings,d?d.settings:null,m,[],l);A=$.localContent||$.remoteContent,_=$.localContent!==null,O=$.remoteContent!==null,N=$.hasConflicts}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),A=a.value.toString(),O=!0);const P={content:A,localChange:_?2:0,remoteChange:O?2:0,hasConflicts:N};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:P.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:P.remoteChange,previewResource:this.previewResource,previewResult:P,acceptedResource:this.acceptedResource}]}async getMergeResult(s,i){const r=await this.getFormattingOptions(),a=await this.getIgnoredSettings();return{...s.previewResult,content:s.previewResult.content?(0,p.updateIgnoredSettings)(s.previewResult.content,"{}",a,r):null}}async getAcceptResult(s,i,r,a){const l=await this.getFormattingOptions(),u=await this.getIgnoredSettings();if(this.extUri.isEqual(i,this.localResource))return{content:s.fileContent?(0,p.updateIgnoredSettings)(s.fileContent.value.toString(),"{}",u,l):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:s.remoteContent!==null?(0,p.updateIgnoredSettings)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",u,l):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return r===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:r!==null?(0,p.updateIgnoredSettings)(r,s.fileContent?s.fileContent.value.toString():"{}",u,l):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(s,i,r,a){const{fileContent:l}=r[0][0];let{content:u,localChange:d,remoteChange:m}=r[0][1];if(d===0&&m===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),u=u?u.trim():"{}",u=u||"{}",this.validateContent(u),d!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),l&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(l.value.toString()))),await this.updateLocalFileContent(u,l,a),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),m!==0){const A=await this.getFormattingOptions(),_=this.getSettingsSyncContent(s),O=await this.getIgnoredSettings(u);u=(0,p.updateIgnoredSettings)(u,_?_.settings:"{}",O,A),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),s=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(u)),a?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(A){}i?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(s),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const i=await this.getFormattingOptions(),r=(0,h.edit)(s.value.toString(),[f.CONFIGURATION_SYNC_STORE_KEY],void 0,i);return!(0,p.isEmpty)(r)}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const i=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"settings.json"),comparableResource:i}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let i=await super.resolveContent(s);if(i)return i;if(i=await super.resolveContent(this.extUri.dirname(s)),i){const r=this.parseSyncData(i);if(r){const a=this.parseSettingsSyncContent(r.content);if(a)switch(this.extUri.basename(s)){case"settings.json":return a.settings}}}return null}async resolvePreviewContent(s){let i=await super.resolvePreviewContent(s);if(i){const r=await this.getFormattingOptions(),a=await this.getIgnoredSettings();i=(0,p.updateIgnoredSettings)(i,"{}",a,r)}return i}getSettingsSyncContent(s){return s.syncData?this.parseSettingsSyncContent(s.syncData.content):null}parseSettingsSyncContent(s){try{return v(s)}catch(i){this.logService.error(i)}return null}toSettingsSyncContent(s){return{settings:s}}async getIgnoredSettings(s){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const r=L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,a=>a.some(({local:l})=>!!l)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,a=>!a.error))(()=>{r.dispose(),this._defaultIgnoredSettings=void 0})}const i=await this._defaultIgnoredSettings;return(0,p.getIgnoredSettings)(i,this.configurationService,s)}validateContent(s){if(this.hasErrors(s))throw new f.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const s=await this.getLocalFileContent();if(!s)return;const i=JSON.parse(s.value.toString());if(!o(i))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const r=this.parseSettingsSyncContent(i.content);if(!r||!r.settings)return;let a=r.settings;const l=await this.getFormattingOptions();for(const u in i)if(["version","content","machineId"].indexOf(u)===-1&&i[u]!==void 0){const d=(0,D.setProperty)(a,[u],i[u],l);d.length&&(a=(0,D.applyEdits)(a,d))}await this.fileService.writeFile(this.file,R.VSBuffer.fromString(a))}catch(s){}}};y=he([Q(0,n.IFileService),Q(1,S.IEnvironmentService),Q(2,I.IStorageService),Q(3,f.IUserDataSyncStoreService),Q(4,f.IUserDataSyncBackupStoreService),Q(5,f.IUserDataSyncLogService),Q(6,f.IUserDataSyncUtilService),Q(7,k.IConfigurationService),Q(8,f.IUserDataSyncResourceEnablementService),Q(9,g.ITelemetryService),Q(10,b.IExtensionManagementService)],y),e.SettingsSynchroniser=y;let c=class extends E.AbstractInitializer{constructor(s,i,r){super("settings",i,r,s)}async doInitialize(s){const i=s.syncData?this.parseSettingsSyncContent(s.syncData.content):null;if(!i){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,R.VSBuffer.fromString(i.settings)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.environmentService.settingsResource);return(0,p.isEmpty)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}parseSettingsSyncContent(s){try{return v(s)}catch(i){this.logService.error(i)}return null}};c=he([Q(0,n.IFileService),Q(1,S.IEnvironmentService),Q(2,f.IUserDataSyncLogService)],c),e.SettingsInitializer=c;function o(t){return!!(t&&t.version!==void 0&&typeof t.version=="number"&&t.content!==void 0&&typeof t.content=="string"&&t.machineId!==void 0&&typeof t.machineId=="string")}}),define(te[220],ne([0,1,22,3,26,20,13,14,23,21,47,213,24]),function(J,e,R,L,D,T,k,C,S,b,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let E=class extends n.AbstractSynchroniser{constructor(f,w,v,y,c,o,t,s,i){super("snippets",w,f,v,y,c,s,i,o,t);this.version=1,this.snippetsFolder=f.snippetsHome,this._register(this.fileService.watch(f.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(L.Event.filter(this.fileService.onDidFilesChange,r=>r.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(f,w,v){const y=await this.getSnippetsFileContents(),c=this.toSnippetsContents(y),o=f.syncData?this.parseSnippets(f.syncData):null;w=w===null&&v?f:w;const t=w&&w.syncData?this.parseSnippets(w.syncData):null;o?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,I.merge)(c,o,t);return this.getResourcePreviews(s,y,o||{})}async getMergeResult(f,w){return f.previewResult}async getAcceptResult(f,w,v,y){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:f.fileContent?f.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:f.remoteContent,localChange:f.remoteContent!==null?f.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return v===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:v,localChange:v===null?f.fileContent!==null?3:0:2,remoteChange:v===null?f.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(f,w,v,y){const c=v.map(([o,t])=>({...o,acceptResult:t}));c.every(({localChange:o,remoteChange:t})=>o===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),c.some(({localChange:o})=>o!==0)&&(await this.updateLocalBackup(c),await this.updateLocalSnippets(c,y)),c.some(({remoteChange:o})=>o!==0)&&(f=await this.updateRemoteSnippets(c,f,y)),w?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(f),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:o}of c)try{await this.fileService.del(o)}catch(t){}}getResourcePreviews(f,w,v){const y=new Map;for(const c of Object.keys(f.local.added)){const o={content:f.local.added[c],hasConflicts:!1,localChange:1,remoteChange:0};y.set(c,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(f.local.updated)){const o={content:f.local.updated[c],hasConflicts:!1,localChange:2,remoteChange:0};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[c],localContent:w[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of f.local.removed){const o={content:null,hasConflicts:!1,localChange:3,remoteChange:0};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[c],localContent:w[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(f.remote.added)){const o={content:f.remote.added[c],hasConflicts:!1,localChange:0,remoteChange:1};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[c],localContent:w[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(f.remote.updated)){const o={content:f.remote.updated[c],hasConflicts:!1,localChange:0,remoteChange:2};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[c],localContent:w[c].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of f.remote.removed){const o={content:null,hasConflicts:!1,localChange:0,remoteChange:3};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[c],previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of f.conflicts){const o={content:w[c]?w[c].value.toString():null,hasConflicts:!0,localChange:w[c]?2:1,remoteChange:v[c]?2:1};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[c]||null,localContent:w[c]?w[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const c of Object.keys(w))if(!y.has(c)){const o={content:w[c]?w[c].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};y.set(c,{localResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[c]||null,localContent:w[c]?w[c].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:v[c]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,c),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...y.values()]}async getAssociatedResources({uri:f}){let w=await super.resolveContent(f);if(w){const v=this.parseSyncData(w);if(v){const y=this.parseSnippets(v),c=[];for(const o of Object.keys(y)){const t=this.extUri.joinPath(f,o),s=this.extUri.joinPath(this.snippetsFolder,o),i=await this.fileService.exists(s);c.push({resource:t,comparableResource:i?s:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})})}return c}}return[]}async resolveContent(f){if(this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(f);let w=await super.resolveContent(f);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(f)),w){const v=this.parseSyncData(w);if(v)return this.parseSnippets(v)[this.extUri.basename(f)]||null}return null}async hasLocalData(){try{const f=await this.getSnippetsFileContents();if(Object.keys(f).length)return!0}catch(f){}return!1}async updateLocalBackup(f){const w={};for(const v of f)v.fileContent&&(w[this.extUri.basename(v.localResource)]=v.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(f,w){for(const{fileContent:v,acceptResult:y,localResource:c,remoteResource:o,localChange:t}of f)if(t!==0){const s=o?this.extUri.basename(o):this.extUri.basename(c),i=this.extUri.joinPath(this.snippetsFolder,s);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(i)),await this.fileService.del(i),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(i))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(i)),await this.fileService.createFile(i,R.VSBuffer.fromString(y.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(i))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(i)),await this.fileService.writeFile(i,R.VSBuffer.fromString(y.content),w?void 0:v),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(i)))}}async updateRemoteSnippets(f,w,v){const y=w.syncData?this.parseSnippets(w.syncData):{},c=(0,D.deepClone)(y);for(const{acceptResult:o,localResource:t,remoteResource:s,remoteChange:i}of f)if(i!==0){const r=t?this.extUri.basename(t):this.extUri.basename(s);i===3?delete c[r]:c[r]=o.content}return(0,I.areSame)(y,c)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(c),v?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(f){return JSON.parse(f.content)}toSnippetsContents(f){const w={};for(const v of Object.keys(f))w[v]=f[v].value.toString();return w}async getSnippetsFileContents(){const f={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(v){if(v instanceof C.FileOperationError&&v.fileOperationResult===1)return f;throw v}for(const v of w.children||[]){const y=v.resource,c=this.extUri.extname(y);if(c===".json"||c===".code-snippets"){const o=this.extUri.relativePath(this.snippetsFolder,y),t=await this.fileService.readFile(y);f[o]=t}}return f}};E=he([Q(0,k.IEnvironmentService),Q(1,C.IFileService),Q(2,S.IStorageService),Q(3,g.IUserDataSyncStoreService),Q(4,g.IUserDataSyncBackupStoreService),Q(5,g.IUserDataSyncLogService),Q(6,T.IConfigurationService),Q(7,g.IUserDataSyncResourceEnablementService),Q(8,b.ITelemetryService)],E),e.SnippetsSynchroniser=E;let h=class extends n.AbstractInitializer{constructor(f,w,v){super("snippets",w,v,f)}async doInitialize(f){const w=f.syncData?JSON.parse(f.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const y of Object.keys(w)){const c=w[y];if(c){const o=this.extUri.joinPath(this.environmentService.snippetsHome,y);await this.fileService.createFile(o,R.VSBuffer.fromString(c)),this.logService.info("Created snippet",this.extUri.basename(o))}}await this.updateLastSyncUserData(f)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(f){return f.fileOperationResult===1}}};h=he([Q(0,C.IFileService),Q(1,k.IEnvironmentService),Q(2,g.IUserDataSyncLogService)],h),e.SnippetsInitializer=h}),define(te[62],ne([0,1,3,2,5,24]),function(J,e,R,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let k=class extends L.Disposable{constructor(S){super();this.userDataSyncStoreService=S,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(S.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(S.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(S){(S&&this._account?S.token!==this._account.token||S.authenticationProviderId!==this._account.authenticationProviderId:S!==this._account)&&(this._account=S,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(S))}};k=he([Q(0,T.IUserDataSyncStoreService)],k),e.UserDataSyncAccountService=k}),define(te[221],ne([0,1,6,22,57,2,16,20,13,14,24]),function(J,e,R,L,D,T,k,C,S,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let I=class extends T.Disposable{constructor(E,h,p,f){super();this.environmentService=E,this.fileService=h,this.configurationService=p,this.logService=f,n.ALL_SYNC_RESOURCES.forEach(w=>this.cleanUpBackup(w))}async getAllRefs(E){const h=(0,k.joinPath)(this.environmentService.userDataSyncHome,E),p=await this.fileService.resolve(h);return p.children?p.children.filter(w=>w.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(w.name)).sort().reverse().map(w=>({ref:w.name,created:this.getCreationTime(w)})):[]}async resolveContent(E,h){if(!h){const p=await this.getAllRefs(E);p.length&&(h=p[p.length-1].ref)}if(h){const p=(0,k.joinPath)(this.environmentService.userDataSyncHome,E,h);return(await this.fileService.readFile(p)).value.toString()}return null}async backup(E,h){const p=(0,k.joinPath)(this.environmentService.userDataSyncHome,E),f=(0,k.joinPath)(p,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(f,L.VSBuffer.fromString(h))}catch(w){this.logService.error(w)}try{this.cleanUpBackup(E)}catch(w){}}async cleanUpBackup(E){const h=(0,k.joinPath)(this.environmentService.userDataSyncHome,E);try{try{if(!await this.fileService.exists(h))return}catch(f){return}const p=await this.fileService.resolve(h);if(p.children){const f=p.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),w=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let v=f.filter(c=>Date.now()-this.getCreationTime(c)>w);const y=f.length-v.length;y<10&&(v=v.slice(10-y)),await R.Promises.settled(v.map(async c=>{this.logService.info("Deleting from backup",c.resource.path),await this.fileService.del(c.resource)}))}}catch(p){this.logService.error(p)}}getCreationTime(E){return E.ctime||new Date(parseInt(E.name.substring(0,4)),parseInt(E.name.substring(4,6))-1,parseInt(E.name.substring(6,8)),parseInt(E.name.substring(9,11)),parseInt(E.name.substring(11,13)),parseInt(E.name.substring(13,15))).getTime()}};I=he([Q(0,S.IEnvironmentService),Q(1,b.IFileService),Q(2,C.IConfigurationService),Q(3,n.IUserDataSyncLogService)],I),e.UserDataSyncBackupStoreService=I}),define(te[222],ne([0,1,2,7]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(g){this.service=g}listen(g,E){switch(E){case"onError":return this.service.onError}throw new Error(`Event not found: ${E}`)}call(g,E,h){switch(E){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class T{constructor(g){this.service=g}listen(g,E){throw new Error(`Event not found: ${E}`)}call(g,E,h){switch(E){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(L.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class k{constructor(g){this.channel=g}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.channel.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.channel.call("resolveFormattingOptions",[g])}}e.UserDataSyncUtilServiceClient=k;class C{constructor(g){this.service=g}listen(g,E){switch(E){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${E}`)}async call(g,E,h){switch(E){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=C;class S{constructor(g){this.service=g}listen(g,E){switch(E){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${E}`)}call(g,E,h){switch(E){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=S;class b{constructor(g){this.service=g}listen(g,E){switch(E){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${E}`)}call(g,E,h){switch(E){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class n extends R.Disposable{constructor(g){super();this.channel=g,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.channel.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(g)}revive(g){return{url:L.URI.revive(g.url),type:g.type,defaultUrl:L.URI.revive(g.defaultUrl),insidersUrl:L.URI.revive(g.insidersUrl),stableUrl:L.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(te[223],ne([0,1,13,10]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends L.AbstractLogger{constructor(k,C){super();this.logger=this._register(k.createLogger(C.userDataSyncLogResource,{name:"settingssync"}))}trace(k,...C){this.logger.trace(k,...C)}debug(k,...C){this.logger.debug(k,...C)}info(k,...C){this.logger.info(k,...C)}warn(k,...C){this.logger.warn(k,...C)}error(k,...C){this.logger.error(k,...C)}critical(k,...C){this.logger.critical(k,...C)}flush(){this.logger.flush()}};D=he([Q(0,L.ILoggerService),Q(1,R.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(te[63],ne([0,1,3,2,4,25,146,13,14,5,29,45,23,24]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let p=class Ze extends L.Disposable{constructor(w,v,y,c,o,t){super();this.storageService=y,this.userDataSyncStoreService=c,this.logService=o,this.productService=t,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,I.getServiceMachineId)(w,v,y)}async getMachines(w){const v=await this.currentMachineIdPromise;return(await this.readMachinesData(w)).machines.map(c=>({...c,isCurrent:c.id===v}))}async addCurrentMachine(w){const v=await this.currentMachineIdPromise,y=await this.readMachinesData(w);y.machines.some(({id:c})=>c===v)||(y.machines.push({id:v,name:this.computeCurrentMachineName(y.machines)}),await this.writeMachinesData(y))}async removeCurrentMachine(w){const v=await this.currentMachineIdPromise,y=await this.readMachinesData(w),c=y.machines.filter(({id:o})=>o!==v);c.length!==y.machines.length&&(y.machines=c,await this.writeMachinesData(y))}async renameMachine(w,v,y){const c=await this.currentMachineIdPromise,o=await this.readMachinesData(y),t=o.machines.find(({id:s})=>s===w);t&&(t.name=v,await this.writeMachinesData(o),o.machines.some(({id:s})=>s===c)&&this.storageService.store(h,v,0,1))}async setEnablement(w,v){const y=await this.readMachinesData(),c=y.machines.find(({id:o})=>o===w);c&&(c.disabled=v?void 0:!0,await this.writeMachinesData(y))}computeCurrentMachineName(w){const v=this.storageService.get(h,0);if(v)return v;const y=`${this.productService.nameLong} (${(0,D.PlatformToString)(D.isWeb?0:D.platform)})`,c=new RegExp(`${(0,T.escapeRegExpCharacters)(y)}\\s#(\\d+)`);let o=0;for(const t of w){const s=c.exec(t.name),i=s?parseInt(s[1]):0;o=i>o?i:o}return`${y} #${o+1}`}async readMachinesData(w){this.userData=await this.readUserData(w);const v=this.parse(this.userData);if(v.version!==Ze.VERSION)throw new Error((0,k.localize)(0,null,this.productService.nameLong));return v}async writeMachinesData(w){const v=JSON.stringify(w),y=await this.userDataSyncStoreService.write(Ze.RESOURCE,v,this.userData?.ref||null);this.userData={ref:y,content:v},this._onDidChange.fire()}async readUserData(w){if(this.userData){const v=w&&w.latest?w.latest[Ze.RESOURCE]:void 0;if(this.userData.ref===v)return this.userData;if(v===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ze.RESOURCE,this.userData)}parse(w){if(w.content!==null)try{return JSON.parse(w.content)}catch(v){this.logService.error(v)}return{version:Ze.VERSION,machines:[]}}};p.VERSION=1,p.RESOURCE="machines",p=he([Q(0,C.IEnvironmentService),Q(1,S.IFileService),Q(2,g.IStorageService),Q(3,E.IUserDataSyncStoreService),Q(4,E.IUserDataSyncLogService),Q(5,n.IProductService)],p),e.UserDataSyncMachinesService=p}),define(te[98],ne([0,1,6,57,38,8,3,2,4,16,7,144,13,29,23,21,24,62,63]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p,f,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const y="sync.enable",c="sync.disableMachineEventually",o="sync.sessionId",t="sync.storeUrl",s="sync.productQuality";let i=class extends C.Disposable{constructor(u,d,m){super();this.storageService=u,this.environmentService=d,this.userDataSyncStoreManagementService=m,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(u.onDidChangeValue(A=>this.onDidStorageChange(A)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(y,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||this.storageService.store(y,u,0,1)}onDidStorageChange(u){if(u.scope===0&&y===u.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};i=he([Q(0,h.IStorageService),Q(1,g.IEnvironmentService),Q(2,f.IUserDataSyncStoreManagementService)],i),e.UserDataAutoSyncEnablementService=i;let r=class extends C.Disposable{constructor(u,d,m,A,_,O,N,P,M,$,U){super();this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=m,this.userDataSyncResourceEnablementService=A,this.userDataSyncService=_,this.logService=O,this.userDataSyncAccountService=N,this.telemetryService=P,this.userDataSyncMachinesService=M,this.storageService=$,this.autoSync=this._register(new C.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=U,this.syncTriggerDelayer=this._register(new R.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=u.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(d.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,d.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(N.onDidChangeAccount(()=>this.updateAutoSync())),this._register(m.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(_.onDidChangeLocal,(H,W)=>H?[...H,W]:[W],1e3)(H=>this.triggerSync(H,!1,!1))),this._register(k.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,H])=>H)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const u=this.storageService.get(t,0);return u?n.URI.parse(u):void 0}set syncUrl(u){u?this.storageService.store(t,u.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(s,0)}set productQuality(u){u?this.storageService.store(s,u,0,1):this.storageService.remove(s,0)}updateAutoSync(){const{enabled:u,message:d}=this.isAutoSyncEnabled();u?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(m=>this.onDidFinishSync(m))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(d&&this.logService.info(d),this.autoSync.clear()):d&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(d))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(u,d,m){try{this.userDataSyncAccountService.account&&!m&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(o,0),u?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(A){if(d)this.logService.error(A),this.updateEnablement(!1);else throw A}}updateEnablement(u){this.userDataAutoSyncEnablementService.isEnabled()!==u&&(this.telemetryService.publicLog2(y,{enabled:u}),this.userDataAutoSyncEnablementService.setEnablement(u),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(u){if(!u){this.successiveFailures=0;return}const d=f.UserDataSyncError.toUserDataSyncError(u);d instanceof f.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:d.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),d.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):d.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):d.code==="LocalTooManyRequests"||d.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):d.code==="UpgradeRequired"||d.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):d.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with newer version than of client. Requires client upgrade.`)):d.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with older version than of client. Requires server reset.`)):d.code==="ServiceChanged"||d.code==="DefaultServiceChanged"?S.isWeb&&d.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(d),this.successiveFailures++),this._onError.fire(d)}async disableMachineEventually(){this.storageService.store(c,!0,0,1),await(0,R.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(c,0,!1)}stopDisableMachineEventually(){this.storageService.remove(c,0)}async triggerSync(u,d,m){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(d&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...u),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",m)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=he([Q(0,E.IProductService),Q(1,f.IUserDataSyncStoreManagementService),Q(2,f.IUserDataSyncStoreService),Q(3,f.IUserDataSyncResourceEnablementService),Q(4,f.IUserDataSyncService),Q(5,f.IUserDataSyncLogService),Q(6,w.IUserDataSyncAccountService),Q(7,p.ITelemetryService),Q(8,v.IUserDataSyncMachinesService),Q(9,h.IStorageService),Q(10,f.IUserDataAutoSyncEnablementService)],r),e.UserDataAutoSyncService=r;class a extends C.Disposable{constructor(u,d,m,A,_,O,N,P){super();this.lastSyncUrl=u,this.interval=d,this.userDataSyncStoreManagementService=m,this.userDataSyncStoreService=A,this.userDataSyncService=_,this.userDataSyncMachinesService=O,this.logService=N,this.storageService=P,this.intervalHandler=this._register(new C.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,C.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(u,d){const m=(0,R.createCancelablePromise)(async A=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(_){if((0,T.isPromiseCanceledError)(_))return}return this.doSync(u,d,A)});return this.syncPromise=m,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const u=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),d=this.userDataSyncStoreManagementService.userDataSyncStore;return!!d&&!!u&&(!(0,b.isEqual)(d.defaultUrl,u.defaultUrl)||!(0,b.isEqual)(d.insidersUrl,u.insidersUrl)||!(0,b.isEqual)(d.stableUrl,u.stableUrl))}async doSync(u,d,m){this.logService.info(`Auto Sync: Triggered by ${u}`),this._onDidStartSync.fire();let A;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,d),m.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new f.UserDataAutoSyncError((0,I.localize)(0,null),"DefaultServiceChanged"):new f.UserDataAutoSyncError((0,I.localize)(1,null),"ServiceChanged"):new f.UserDataAutoSyncError((0,I.localize)(2,null),"TurnedOff");const _=this.storageService.get(o,0);if(_&&this.manifest&&_!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new f.UserDataAutoSyncError((0,I.localize)(3,null),"DefaultServiceChanged"):new f.UserDataAutoSyncError((0,I.localize)(4,null),"ServiceChanged"):new f.UserDataAutoSyncError((0,I.localize)(5,null),"SessionExpired");const O=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(m.isCancellationRequested)return;const N=O.find(P=>P.isCurrent);if(N?.disabled)throw new f.UserDataAutoSyncError((0,I.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(P){throw new f.UserDataAutoSyncError((0,D.toErrorMessage)(P),P instanceof f.UserDataSyncError?P.code:"Unknown")}if(this.manifest&&this.manifest.session!==_&&this.storageService.store(o,this.manifest.session,0,1),m.isCancellationRequested)return;N||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(_){this.logService.error(_),A=_}this._onDidFinishSync.fire(A)}register(u){return super._register(u)}}a.INTERVAL_SYNCING="Interval"}),define(te[224],ne([0,1,3,2,4,23,21,24]),function(J,e,R,L,D,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let S=class extends L.Disposable{constructor(n,I){super();this.storageService=n,this.telemetryService=I,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(g=>this.onDidStorageChange(g)))}isResourceEnabled(n){return this.storageService.getBoolean((0,C.getEnablementKey)(n),0,!0)}setResourceEnablement(n,I){if(this.isResourceEnabled(n)!==I){const g=(0,C.getEnablementKey)(n);this.telemetryService.publicLog2(g,{enabled:I}),this.storeResourceEnablement(g,I)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,I){this.storageService.store(n,I,0,D.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const I=C.ALL_SYNC_RESOURCES.filter(g=>(0,C.getEnablementKey)(g)===n.key)[0];if(I){this._onDidChangeResourceEnablement.fire([I,this.isResourceEnabled(I)]);return}}}};S=he([Q(0,T.IStorageService),Q(1,k.ITelemetryService)],S),e.UserDataSyncResourceEnablementService=S}),define(te[225],ne([0,1,17,6,38,8,3,2,16,30,20,5,23,21,214,216,217,219,220,24]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p,f,w,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const c="sync.lastSyncTime";let o=class extends C.Disposable{constructor(r,a,l,u,d,m,A){super();this.userDataSyncStoreService=r,this.userDataSyncStoreManagementService=a,this.instantiationService=l,this.configurationService=u,this.logService=d,this.telemetryService=m,this.storageService=A,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(w.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(f.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(v.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(p.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(h.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(k.Event.any(...this.synchronisers.map(_=>k.Event.map(_.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(k.Event.any(...this.synchronisers.map(_=>k.Event.map(_.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(c,0,void 0),this.onDidChangeLocal=k.Event.any(...this.synchronisers.map(_=>k.Event.map(_.onDidChangeLocal,()=>_.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(r,a){await this.checkEnablement();const l=(0,b.generateUuid)();try{const A=(0,y.createSyncHeaders)(l);a&&(A["Cache-Control"]="no-cache"),r=await this.userDataSyncStoreService.manifest(r,A)}catch(A){const _=y.UserDataSyncError.toUserDataSyncError(A);throw this.reportUserDataSyncError(_,l),_}let u=!1;const d=this;let m;return{manifest:r,run(){if(u)throw new Error("Can run a task only once");return m=(0,L.createCancelablePromise)(A=>d.sync(r,l,A)),m.finally(()=>m=void 0)},async stop(){if(m&&m.cancel(),d.status!=="idle")return d.stop()}}}async createManualSyncTask(){await this.checkEnablement();const r=(0,b.generateUuid)(),a=(0,y.createSyncHeaders)(r);let l;try{l=await this.userDataSyncStoreService.manifest(null,a)}catch(u){const d=y.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(d,r),d}return new t(r,l,a,this.synchronisers,this.configurationService,this.logService)}async sync(r,a,l){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),l.isCancellationRequested)return;const u=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const d=(0,y.createSyncHeaders)(a);for(const m of this.synchronisers){if(l.isCancellationRequested)return;try{await m.sync(r,d)}catch(A){let _=!1;if(A instanceof y.UserDataSyncError)switch(A.code){case"TooLarge":A=new y.UserDataSyncError(A.message,A.code,m.resource),_=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":_=!0;break}const O=y.UserDataSyncError.toUserDataSyncError(A);if(this.reportUserDataSyncError(O,a),_)throw O;this.logService.error(A),this.logService.error(`${m.resource}: ${(0,D.toErrorMessage)(A)}`),this._syncErrors.push([m.resource,O])}}this.logService.info(`Sync done. Took ${new Date().getTime()-u}ms`),this.updateLastSyncTime()}catch(d){const m=y.UserDataSyncError.toUserDataSyncError(d);throw this.reportUserDataSyncError(m,a),m}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const r of this.synchronisers)try{r.status!=="idle"&&await r.stop()}catch(a){this.logService.error(a)}}async replace(r){await this.checkEnablement();for(const a of this.synchronisers)if(await a.replace(r))return}async accept(r,a,l,u){await this.checkEnablement();const d=this.getSynchroniser(r);await d.accept(a,l),u&&await d.apply(!1,(0,y.createSyncHeaders)((0,b.generateUuid)()))}async resolveContent(r){for(const a of this.synchronisers){const l=await a.resolveContent(r);if(l)return l}return null}getRemoteSyncResourceHandles(r){return this.getSynchroniser(r).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(r){return this.getSynchroniser(r).getLocalSyncResourceHandles()}getAssociatedResources(r,a){return this.getSynchroniser(r).getAssociatedResources(a)}getMachineId(r,a){return this.getSynchroniser(r).getMachineId(a)}async hasLocalData(){const r=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const a of r)if(await a.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(r){this.logService.error(r)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(c,0);for(const r of this.synchronisers)try{await r.resetLocal()}catch(a){this.logService.error(`${r.resource}: ${(0,D.toErrorMessage)(a)}`),this.logService.error(a)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const r of this.synchronisers)if(await r.hasPreviouslySynced())return!0;return!1}setStatus(r){const a=this._status;this._status!==r&&(this._status=r,this._onDidChangeStatus.fire(r),a==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const r=this.computeStatus();this.setStatus(r)}updateConflicts(){const r=this.computeConflicts();(0,R.equals)(this._conflicts,r,([a,l],[u,d])=>a===a&&(0,R.equals)(l,d,(m,A)=>(0,S.isEqual)(m.previewResource,A.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(r))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(r=>r.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(r=>r.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(c,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(r,a){this.telemetryService.publicLog2("sync/error",{code:r.code,serverCode:r instanceof y.UserDataSyncStoreError?String(r.serverCode):void 0,url:r instanceof y.UserDataSyncStoreError?r.url:void 0,resource:r.resource,executionId:a,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(r=>r.status==="hasConflicts").map(r=>[r.resource,r.conflicts.map(s)])}getSynchroniser(r){return this.synchronisers.find(a=>a.resource===r)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=he([Q(0,y.IUserDataSyncStoreService),Q(1,y.IUserDataSyncStoreManagementService),Q(2,I.IInstantiationService),Q(3,n.IConfigurationService),Q(4,y.IUserDataSyncLogService),Q(5,E.ITelemetryService),Q(6,g.IStorageService)],o),e.UserDataSyncService=o;class t extends C.Disposable{constructor(r,a,l,u,d,m){super();this.id=r,this.manifest=a,this.syncHeaders=l,this.synchronisers=u,this.configurationService=d,this.logService=m,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new k.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(r=>r.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(r=>r.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,L.createCancelablePromise)(r=>this.getPreviews(r))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(r){throw this.logService.error(r),r}}async accept(r,a){try{return await this.performAction(r,l=>l.accept(r,a))}catch(l){throw this.logService.error(l),l}}async merge(r){try{return r?await this.performAction(r,a=>a.merge(r)):await this.mergeAll()}catch(a){throw this.logService.error(a),a}}async discard(r){try{return await this.performAction(r,a=>a.discard(r))}catch(a){throw this.logService.error(a),a}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const r=[];for(const[,a]of this.previews)for(const l of a.resourcePreviews)l.mergeState==="conflict"&&r.push(l.previewResource);for(const a of r)await this.discard(a);return this.previews}catch(r){throw this.logService.error(r),r}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const r=[];for(const[a,l]of this.previews){this.synchronizingResources.push([a,l.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(m=>m.resource===a);for(const m of l.resourcePreviews)(m.localChange!==0||m.remoteChange!==0)&&m.mergeState==="preview"&&await u.merge(m.previewResource);const d=await u.apply(!1,this.syncHeaders);d&&r.push(this.toSyncResourcePreview(u.resource,d)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=r,this.previews}catch(r){throw this.logService.error(r),r}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[r,a]of this.previews){this.synchronizingResources.push([r,a.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(u=>u.resource===r);for(const u of a.resourcePreviews)await l.accept(u.remoteResource);await l.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(r){throw this.logService.error(r),r}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[r,a]of this.previews){this.synchronizingResources.push([r,a.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(u=>u.resource===r);for(const u of a.resourcePreviews)await l.accept(u.localResource);await l.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(r){throw this.logService.error(r),r}}async stop(){for(const r of this.synchronisers)try{await r.stop()}catch(a){(0,T.isPromiseCanceledError)(a)||this.logService.error(a)}this.reset()}async performAction(r,a){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const l=this.previews.findIndex(([,P])=>P.resourcePreviews.some(({localResource:M,previewResource:$,remoteResource:U})=>(0,S.isEqual)(r,M)||(0,S.isEqual)(r,$)||(0,S.isEqual)(r,U)));if(l===-1)return this.previews;const[u,d]=this.previews[l],m=d.resourcePreviews.find(({localResource:P,remoteResource:M,previewResource:$})=>(0,S.isEqual)(P,r)||(0,S.isEqual)(M,r)||(0,S.isEqual)($,r));if(!m)return this.previews;let A=this.synchronizingResources.find(P=>P[0]===u);A||(A=[u,[]],this.synchronizingResources.push(A)),A[1].some(P=>(0,S.isEqual)(P,m.localResource))||(A[1].push(m.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const _=this.synchronisers.find(P=>P.resource===this.previews[l][0]),O=await a(_);O?this.previews.splice(l,1,this.toSyncResourcePreview(_.resource,O)):this.previews.splice(l,1);const N=this.synchronizingResources.findIndex(P=>P[0]===u);return this.synchronizingResources[N][1].splice(A[1].findIndex(P=>(0,S.isEqual)(P,m.localResource)),1),A[1].length||(this.synchronizingResources.splice(N,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const r=[];for(const[a,l]of this.previews){this.synchronizingResources.push([a,l.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(m=>m.resource===a);let d=l;for(const m of l.resourcePreviews)(m.localChange!==0||m.remoteChange!==0)&&m.mergeState==="preview"&&(d=await u.merge(m.previewResource));d&&r.push(this.toSyncResourcePreview(u.resource,d)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=r,this.previews}async getPreviews(r){const a=[],l=await this.getUserDataSyncConfiguration();for(const u of this.synchronisers){if(r.isCancellationRequested)return[];const d=await u.preview(this.manifest,l,this.syncHeaders);d&&a.push(this.toSyncResourcePreview(u.resource,d))}return a}async getUserDataSyncConfiguration(){const r=this.configurationService.getValue(y.USER_DATA_SYNC_CONFIGURATION_SCOPE),a=await this.synchronisers.find(l=>l instanceof w.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...r,...a}}toSyncResourcePreview(r,a){return[r,{isLastSyncFromCurrentMachine:a.isLastSyncFromCurrentMachine,resourcePreviews:a.resourcePreviews.map(s)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function s(i){return{localResource:i.localResource,previewResource:i.previewResource,remoteResource:i.remoteResource,acceptedResource:i.acceptedResource,localChange:i.localChange,remoteChange:i.remoteChange,mergeState:i.mergeState}}}),define(te[226],ne([0,1,3,2,18,7,24]),function(J,e,R,L,D,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class C{constructor(I,g){this.service=I,this.logService=g,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(I,g){switch(g){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${g}`)}async call(I,g,E){try{return await this._call(I,g,E)}catch(h){throw this.logService.error(h),h}}async _call(I,g,E){switch(g){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(E[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(E[0],T.URI.revive(E[1]),E[2],E[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(E[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(E[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(E[0]);case"getAssociatedResources":return this.service.getAssociatedResources(E[0],{created:E[1].created,uri:T.URI.revive(E[1].uri)});case"getMachineId":return this.service.getMachineId(E[0],{created:E[1].created,uri:T.URI.revive(E[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(g.startsWith("manualSync/")){const h=g.substring("manualSync/".length),p=E[0],f=this.getManualSyncTask(p);switch(E=E.slice(1),h){case"preview":return f.preview();case"accept":return f.accept(T.URI.revive(E[0]),E[1]);case"merge":return f.merge(T.URI.revive(E[0]));case"discard":return f.discard(T.URI.revive(E[0]));case"discardConflicts":return f.discardConflicts();case"apply":return f.apply();case"pull":return f.pull();case"push":return f.push();case"stop":return f.stop();case"_getStatus":return f.status;case"dispose":return this.disposeManualSyncTask(f)}}throw new Error("Invalid call")}getManualSyncTask(I){const g=this.manualSyncTasks.get(this.createKey(I));if(!g)throw new Error(`Manual sync taks not found: ${I}`);return g.manualSyncTask}async createManualSyncTask(){const I=new L.DisposableStore,g=I.add(await this.service.createManualSyncTask());return I.add(g.onSynchronizeResources(E=>this.onManualSynchronizeResources.fire({manualSyncTaskId:g.id,data:E}))),this.manualSyncTasks.set(this.createKey(g.id),{manualSyncTask:g,disposables:I}),{id:g.id,manifest:g.manifest,status:g.status}}disposeManualSyncTask(I){I.dispose();const g=this.createKey(I.id);this.manualSyncTasks.get(g)?.disposables.dispose(),this.manualSyncTasks.delete(g)}createKey(I){return`manualSyncTask-${I}`}}e.UserDataSyncChannel=C;class S extends L.Disposable{constructor(I){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(g,E,h){return I.call(g,E,h).then(null,p=>{throw k.UserDataSyncError.toUserDataSyncError(p)})},listen(g,E){return I.listen(g,E)}},this.channel.call("_getInitialData").then(([g,E,h])=>{this.updateStatus(g),this.updateConflicts(E),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(p=>this.updateStatus(p))),this._register(this.channel.listen("onDidChangeLastSyncTime")(p=>this.updateLastSyncTime(p)))}),this._register(this.channel.listen("onDidChangeConflicts")(g=>this.updateConflicts(g))),this._register(this.channel.listen("onSyncErrors")(g=>this._onSyncErrors.fire(g.map(([E,h])=>[E,k.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:I,manifest:g,status:E}=await this.channel.call("createManualSyncTask"),h=this,p=new b(I,g,E,{async call(f,w,v){return h.channel.call(`manualSync/${f}`,[I,...(0,D.isArray)(w)?w:[w]],v)},listen(f,w){return R.Event.map(R.Event.filter(h.channel.listen(`manualSync/${f}`,w),v=>!p.isDiposed()&&v.manualSyncTaskId===I),v=>v.data)}});return p}replace(I){return this.channel.call("replace",[I])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(I,g,E,h){return this.channel.call("accept",[I,g,E,h])}resolveContent(I){return this.channel.call("resolveContent",[I])}async getLocalSyncResourceHandles(I){return(await this.channel.call("getLocalSyncResourceHandles",[I])).map(({created:E,uri:h})=>({created:E,uri:T.URI.revive(h)}))}async getRemoteSyncResourceHandles(I){return(await this.channel.call("getRemoteSyncResourceHandles",[I])).map(({created:E,uri:h})=>({created:E,uri:T.URI.revive(h)}))}async getAssociatedResources(I,g){return(await this.channel.call("getAssociatedResources",[I,g])).map(({resource:h,comparableResource:p})=>({resource:T.URI.revive(h),comparableResource:T.URI.revive(p)}))}async getMachineId(I,g){return this.channel.call("getMachineId",[I,g])}async updateStatus(I){this._status=I,this._onDidChangeStatus.fire(I)}async updateConflicts(I){this._conflicts=I.map(([g,E])=>[g,E.map(h=>({...h,localResource:T.URI.revive(h.localResource),remoteResource:T.URI.revive(h.remoteResource),previewResource:T.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(I){this._lastSyncTime!==I&&(this._lastSyncTime=I,this._onDidChangeLastSyncTime.fire(I))}}e.UserDataSyncChannelClient=S;class b extends L.Disposable{constructor(I,g,E,h){super();this.id=I,this.manifest=g,this._disposed=!1,this._status=E;const p=this;this.channel={async call(f,w,v){try{const y=await h.call(f,w,v);return p.isDiposed()||(p._status=await h.call("_getStatus")),y}catch(y){throw k.UserDataSyncError.toUserDataSyncError(y)}},listen(f,w){return h.listen(f,w)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const I=await this.channel.call("preview");return this.deserializePreviews(I)}async accept(I,g){const E=await this.channel.call("accept",[I,g]);return this.deserializePreviews(E)}async merge(I){const g=await this.channel.call("merge",[I]);return this.deserializePreviews(g)}async discard(I){const g=await this.channel.call("discard",[I]);return this.deserializePreviews(g)}async discardConflicts(){const I=await this.channel.call("discardConflicts");return this.deserializePreviews(I)}async apply(){const I=await this.channel.call("apply");return this.deserializePreviews(I)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(I){return I.map(([g,E])=>[g,{isLastSyncFromCurrentMachine:E.isLastSyncFromCurrentMachine,resourcePreviews:E.resourcePreviews.map(h=>({...h,localResource:T.URI.revive(h.localResource),remoteResource:T.URI.revive(h.remoteResource),previewResource:T.URI.revive(h.previewResource),acceptedResource:T.URI.revive(h.acceptedResource)}))}])}}}),define(te[227],ne([0,1,6,27,8,3,2,105,4,16,18,7,30,20,13,14,29,43,45,23,24]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p,f,w,v,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const o="sync.previous.store",t="sync.donot-make-requests-until",s="sync.user-session-id",i="sync.machine-session-id",r=100,a=1e3*60*5;let l=class extends k.Disposable{constructor(O,N,P){super();this.productService=O,this.configurationService=N,this.storageService=P,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(P.onDidChangeValue,M=>M.key===c.SYNC_SERVICE_URL_TYPE&&M.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,O,0,S.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(c.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,N){O=S.isWeb&&O?.web?{...O,...O.web}:O;const P={...O||{},...N||{}};if(P&&(0,n.isString)(P.url)&&(0,n.isObject)(P.authenticationProviders)&&Object.keys(P.authenticationProviders).every(M=>(0,n.isArray)(P.authenticationProviders[M].scopes))){const M=P,$=!!M.canSwitch&&!N?.url,U=M.url===M.insidersUrl?"insiders":"stable",H=($?this.userDataSyncStoreType:void 0)||U,W=N?.url||(H==="insiders"?M.insidersUrl:H==="stable"?M.stableUrl:M.url);return{url:I.URI.parse(W),type:H,defaultType:U,defaultUrl:I.URI.parse(M.url),stableUrl:I.URI.parse(M.stableUrl),insidersUrl:I.URI.parse(M.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(M.authenticationProviders).reduce((x,q)=>(x.push({id:q,scopes:M.authenticationProviders[q].scopes}),x),[])}}}};l=he([Q(0,f.IProductService),Q(1,E.IConfigurationService),Q(2,y.IStorageService)],l),e.AbstractUserDataSyncStoreManagementService=l;let u=class extends l{constructor(O,N,P){super(O,N,P);const M=this.storageService.get(o,0);M&&(this.previousConfigurationSyncStore=JSON.parse(M));const $=this.productService[c.CONFIGURATION_SYNC_STORE_KEY];$?this.storageService.store(o,JSON.stringify($),0,1):this.storageService.remove(o,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=he([Q(0,f.IProductService),Q(1,E.IConfigurationService),Q(2,y.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let d=class extends k.Disposable{constructor(O,N,P,M,$,U,H){super();this.requestService=P,this.logService=M,this.storageService=H,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,v.getServiceMachineId)($,U,H).then(W=>{const x={"X-Client-Name":`${N.applicationName}${S.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(x["X-Client-Commit"]=N.commit),x}),this.session=new A(r,a,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,k.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,N){this.authToken={token:O,type:N}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,b.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(t,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(N=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O),P={},M=await this.request(N.toString(),{type:"GET",headers:P},[],L.CancellationToken.None);return(await(0,w.asJson)(M)||[]).map(({url:U,created:H})=>({ref:(0,b.relativePath)(N,N.with({path:U})),created:H*1e3}))}async resolveContent(O,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const P=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O,N).toString(),M={};M["Cache-Control"]="no-cache";const $=await this.request(P,{type:"GET",headers:M},[],L.CancellationToken.None);return await(0,w.asText)($)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),P={};await this.request(N,{type:"DELETE",headers:P},[],L.CancellationToken.None)}async read(O,N,P={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();P={...P},P["Cache-Control"]="no-cache",N&&(P["If-None-Match"]=N.ref);const $=await this.request(M,{type:"GET",headers:P},[304],L.CancellationToken.None);let U=null;if($.res.statusCode===304&&(U=N),U===null){const H=$.res.headers.etag;if(!H)throw new c.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);const W=await(0,w.asText)($);if(!W&&$.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",M,"EmptyResponse",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);U={ref:H,content:W}}return U}async write(O,N,P,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();M={...M},M["Content-Type"]=C.Mimes.text,P&&(M["If-Match"]=P);const U=await this.request($,{type:"POST",data:N,headers:M},[],L.CancellationToken.None),H=U.res.headers.etag;if(!H)throw new c.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",U.res.statusCode,U.res.headers[c.HEADER_OPERATION_ID]);return H}async manifest(O,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const P=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",O&&(N["If-None-Match"]=O.ref);const M=await this.request(P,{type:"GET",headers:N},[304],L.CancellationToken.None);let $=null;if(M.res.statusCode===304&&($=O),!$){const H=M.res.headers.etag;if(!H)throw new c.UserDataSyncStoreError("Server did not return the ref",P,"NoRef",M.res.statusCode,M.res.headers[c.HEADER_OPERATION_ID]);const W=await(0,w.asText)(M);if(!W&&M.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",P,"EmptyResponse",M.res.statusCode,M.res.headers[c.HEADER_OPERATION_ID]);W&&($={...JSON.parse(W),ref:H})}const U=this.storageService.get(s,0);return U&&$&&U!==$.session&&this.clearSession(),$===null&&U&&this.clearSession(),$&&this.storageService.store(s,$.session,0,1),$}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":C.Mimes.text};await this.request(O,{type:"DELETE",headers:N},[],L.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(s,0),this.storageService.remove(i,0)}async request(O,N,P,M){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const $=await this.commonHeadersPromise;N.headers={...N.headers||{},...$,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:O,type:N.type,headers:{...N.headers,authorization:void 0}});let U;try{U=await this.session.request(O,N,M)}catch(q){if(!(q instanceof c.UserDataSyncStoreError)){let F="RequestFailed";const K=(0,D.getErrorMessage)(q).toLowerCase();K.includes("xhr timeout")?F="RequestTimeout":K.includes("protocol")&&K.includes("not supported")?F="RequestProtocolNotSupported":K.includes("request path contains unescaped characters")?F="RequestPathNotEscaped":K.includes("headers must be an object")?F="RequestHeadersNotObject":(0,D.isPromiseCanceledError)(q)&&(F="RequestCanceled"),q=new c.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,F,void 0,void 0)}throw this.logService.info("Request failed",O),q}const H=U.res.headers[c.HEADER_OPERATION_ID],W={url:O,status:U.res.statusCode,"execution-id":N.headers[c.HEADER_EXECUTION_ID],"operation-id":H},x=(0,w.isSuccess)(U)||U.res.statusCode&&P.indexOf(U.res.statusCode)!==-1;if(x?this.logService.trace("Request succeeded",W):this.logService.info("Request failed",W),U.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new c.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",U.res.statusCode,H);if(this._onTokenSucceed.fire(),U.res.statusCode===409)throw new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",U.res.statusCode,H);if(U.res.statusCode===410)throw new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",U.res.statusCode,H);if(U.res.statusCode===412)throw new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",U.res.statusCode,H);if(U.res.statusCode===413)throw new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",U.res.statusCode,H);if(U.res.statusCode===426)throw new c.UserDataSyncStoreError(`${N.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",U.res.statusCode,H);if(U.res.statusCode===429){const q=U.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",U.res.statusCode,H)):new c.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",U.res.statusCode,H)}if(!x)throw new c.UserDataSyncStoreError("Server returned "+U.res.statusCode,O,"Unknown",U.res.statusCode,H);return U}addSessionHeaders(O){let N=this.storageService.get(i,0);N===void 0&&(N=(0,g.generateUuid)(),this.storageService.store(i,N,0,1)),O["X-Machine-Session-Id"]=N;const P=this.storageService.get(s,0);P!==void 0&&(O["X-User-Session-Id"]=P)}};d=he([Q(1,f.IProductService),Q(2,w.IRequestService),Q(3,c.IUserDataSyncLogService),Q(4,h.IEnvironmentService),Q(5,p.IFileService),Q(6,y.IStorageService)],d),e.UserDataSyncStoreClient=d;let m=class extends d{constructor(O,N,P,M,$,U,H){super(O.userDataSyncStore?.url,N,P,M,$,U,H);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};m=he([Q(0,c.IUserDataSyncStoreManagementService),Q(1,f.IProductService),Q(2,w.IRequestService),Q(3,c.IUserDataSyncLogService),Q(4,h.IEnvironmentService),Q(5,p.IFileService),Q(6,y.IStorageService)],m),e.UserDataSyncStoreService=m;class A{constructor(O,N,P,M){this.limit=O,this.interval=N,this.requestService=P,this.logService=M,this.requests=[],this.startTime=void 0}request(O,N,P){if(this.isExpired()&&this.reset(),N.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(N,P)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(te[228],ne([0,1,3,60,29,23,21,98,24,62,63]),function(J,e,R,L,D,T,k,C,S,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let I=class extends C.UserDataAutoSyncService{constructor(E,h,p,f,w,v,y,c,o,t,s,i){super(E,h,p,f,w,y,c,o,t,s,i);this._register(R.Event.debounce(R.Event.any(R.Event.map(v.onDidFocusWindow,()=>"windowFocus"),R.Event.map(v.onDidOpenWindow,()=>"windowOpen")),(r,a)=>r?[...r,a]:[a],1e3)(r=>this.triggerSync(r,!0,!1)))}};I=he([Q(0,D.IProductService),Q(1,S.IUserDataSyncStoreManagementService),Q(2,S.IUserDataSyncStoreService),Q(3,S.IUserDataSyncResourceEnablementService),Q(4,S.IUserDataSyncService),Q(5,L.INativeHostService),Q(6,S.IUserDataSyncLogService),Q(7,b.IUserDataSyncAccountService),Q(8,k.ITelemetryService),Q(9,n.IUserDataSyncMachinesService),Q(10,T.IStorageService),Q(11,S.IUserDataAutoSyncEnablementService)],I),e.UserDataAutoSyncService=I}),define(te[229],ne([0,1,6,3,2]),function(J,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends D.Disposable{constructor({onDidOpenWindow:C,onDidFocusWindow:S,getActiveWindowId:b}){super();this.disposables=this._register(new D.DisposableStore),L.Event.latch(L.Event.any(C,S))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>b()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(C){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=C}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(te[64],ne([0,1,51,6,9,18,19,122,239,240]),function(J,e,R,L,D,T,k,C,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,s){let i=s.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=s}}e.ExtractError=n;function I(o){const t=o.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,i)=>s+i,t&61440)}function g(o){if(o instanceof n)return o;let t;return/end of central directory record signature not found/.test(o.message)&&(t="CorruptZip"),new n(t,o)}function E(o,t,s,i,r,a){const l=D.dirname(t),u=D.join(i,l);if(!u.startsWith(i))return Promise.reject(new Error(C.localize(0,null,t)));const d=D.join(i,t);let m;return a.onCancellationRequested(()=>{m&&m.destroy()}),Promise.resolve(k.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((A,_)=>{if(!a.isCancellationRequested)try{m=(0,R.createWriteStream)(d,{mode:s}),m.once("close",()=>A()),m.once("error",_),o.once("error",_),o.pipe(m)}catch(O){_(O)}}))}function h(o,t,s,i){let r=(0,L.createCancelablePromise)(()=>Promise.resolve()),a=0;return i.onCancellationRequested(()=>{r.cancel(),o.close()}),new Promise((l,u)=>{const d=new L.Sequencer,m=A=>{A.isCancellationRequested||(a++,o.readEntry())};o.once("error",u),o.once("close",()=>r.then(()=>{i.isCancellationRequested||o.entryCount===a?l():u(new n("Incomplete",new Error(C.localize(1,null,a,o.entryCount))))},u)),o.readEntry(),o.on("entry",A=>{if(i.isCancellationRequested)return;if(!s.sourcePathRegex.test(A.fileName)){m(i);return}const _=A.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(_)){const P=D.join(t,_);r=(0,L.createCancelablePromise)(M=>k.Promises.mkdir(P,{recursive:!0}).then(()=>m(M)).then(void 0,u));return}const O=f(o,A),N=I(A);r=(0,L.createCancelablePromise)(P=>d.queue(()=>O.then(M=>E(M,_,N,t,s,P).then(()=>m(P)))).then(null,u))})})}function p(o,t=!1){return new Promise((s,i)=>{(0,S.open)(o,t?{lazyEntries:!0}:void 0,(r,a)=>{r?i(g(r)):s((0,T.assertIsDefined)(a))})})}function f(o,t){return new Promise((s,i)=>{o.openReadStream(t,(r,a)=>{r?i(g(r)):s((0,T.assertIsDefined)(a))})})}function w(o,t){return new Promise((s,i)=>{const r=new b.ZipFile;t.forEach(l=>{l.contents?r.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&r.addFile(l.localPath,l.path)}),r.end();const a=(0,R.createWriteStream)(o);r.outputStream.pipe(a),r.outputStream.once("error",i),a.once("error",i),a.once("finish",()=>s(o))})}e.zip=w;function v(o,t,s={},i){const r=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let a=p(o,!0);return s.overwrite&&(a=a.then(l=>k.Promises.rm(t).then(()=>l))),a.then(l=>h(l,t,{sourcePathRegex:r},i))}e.extract=v;function y(o,t){return p(o).then(s=>new Promise((i,r)=>{s.on("entry",a=>{a.fileName===t&&f(s,a).then(l=>i(l),l=>r(l))}),s.once("close",()=>r(new Error(C.localize(2,null,t))))}))}function c(o,t){return y(o,t).then(s=>new Promise((i,r)=>{const a=[];s.once("error",r),s.on("data",l=>a.push(l)),s.on("end",()=>i(Buffer.concat(a)))}))}e.buffer=c}),define(te[230],ne([0,1,64,131]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(T){return(0,R.buffer)(T,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch(C){throw new Error((0,L.localize)(0,null))}})}e.getManifest=D}),define(te[231],ne([0,1,17,6,8,2,15,9,4,16,59,7,30,19,64,132,13,28,34,152,14,10,29]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p,f,w,v,y,c,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const s="scanningSystem",i="scanningUser",r="extracting",a="deleting",l="renaming";let u=class extends T.Disposable{constructor(m,A,_,O,N){super();this.beforeRemovingExtension=m,this.fileService=A,this.logService=_,this.environmentService=O,this.productService=N,this._devSystemExtensionsPath=null,this.systemExtensionsPath=O.builtinExtensionsPath,this.extensionsPath=O.extensionsPath,this.uninstalledPath=C.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(m){const A=[];(m===null||m===0)&&A.push(this.scanSystemExtensions().then(null,_=>Promise.reject(new w.ExtensionManagementError(this.joinErrors(_).message,s)))),(m===null||m===1)&&A.push(this.scanUserExtensions(!0).then(null,_=>Promise.reject(new w.ExtensionManagementError(this.joinErrors(_).message,i))));try{const _=await Promise.all(A);return(0,R.flatten)(_)}catch(_){throw this.joinErrors(_)}}async scanUserExtensions(m){this.logService.trace("Started scanning user extensions");let[A,_]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return _=_.filter(O=>!A[new v.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),m&&(_=(0,v.groupByExtension)(_,N=>N.identifier).map(N=>N.sort((P,M)=>n.rcompare(P.manifest.version,M.manifest.version))[0])),this.logService.trace("Scanned user extensions:",_.length),_}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(m,A,_,O){const N=m.key(),P=C.join(this.extensionsPath,`.${(0,g.generateUuid)()}`),M=C.join(this.extensionsPath,N);try{await E.Promises.rm(M)}catch(U){try{await E.Promises.rm(M)}catch(H){}throw new w.ExtensionManagementError((0,p.localize)(0,null,M,m.id),a)}await this.extractAtLocation(m,A,P,O);let $=await this.scanExtension(I.URI.file(P),1);if(!$)throw new Error((0,p.localize)(1,null,P));await this.storeMetadata($,{..._,installedTimestamp:Date.now()});try{await this.rename(m,P,M,Date.now()+2*60*1e3),this.logService.info("Renamed to",M)}catch(U){try{await E.Promises.rm(P)}catch(H){}if(U.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",m.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(U)}. Deleted from extracted location`,P),U}try{$=await this.scanExtension(I.URI.file(M),1)}catch(U){}if($)return $;throw new Error((0,p.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(m,A){return this.setMetadata(m,A),await this.storeMetadata(m,{...A,installedTimestamp:m.installedTimestamp}),m}async storeMetadata(m,A){A.isMachineScoped=A.isMachineScoped||void 0,A.isBuiltin=A.isBuiltin||void 0,A.installedTimestamp=A.installedTimestamp||void 0;const _=C.join(m.location.fsPath,"package.json"),O=await E.Promises.readFile(_,"utf8"),{manifest:N}=await this.parseManifest(O);return N.__metadata=A,await E.Promises.writeFile(_,JSON.stringify(N,null,"	")),m}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...m){const A=m.map(_=>new v.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version));await this.withUninstalledExtensions(_=>{A.forEach(O=>_[O.key()]=!0)})}async setInstalled(m){await this.withUninstalledExtensions(O=>delete O[m.key()]);const _=(await this.scanExtensions(1)).find(O=>new v.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).equals(m))||null;return _?(await this.storeMetadata(_,{installedTimestamp:Date.now()}),this.scanExtension(_.location,1)):null}async withUninstalledExtensions(m){return this.uninstalledFileLimiter.queue(async()=>{let A;try{A=await E.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let _={};if(A)try{_=JSON.parse(A)}catch(O){}return m&&(m(_),Object.keys(_).length?await E.Promises.writeFile(this.uninstalledPath,JSON.stringify(_)):await E.Promises.rm(this.uninstalledPath)),_})}async removeExtension(m,A){this.logService.trace(`Deleting ${A} extension from disk`,m.identifier.id,m.location.fsPath),await E.Promises.rm(m.location.fsPath),this.logService.info("Deleted from disk",m.identifier.id,m.location.fsPath)}async removeUninstalledExtension(m){await this.removeExtension(m,"uninstalled"),await this.withUninstalledExtensions(A=>delete A[new v.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).key()])}async extractAtLocation(m,A,_,O){this.logService.trace(`Started extracting the extension from ${A} to ${_}`);try{await E.Promises.rm(_)}catch(N){throw new w.ExtensionManagementError(this.joinErrors(N).message,a)}try{await(0,h.extract)(A,_,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${_}:`,m.id)}catch(N){try{await E.Promises.rm(_)}catch(P){}throw new w.ExtensionManagementError(N.message,N instanceof h.ExtractError&&N.type?N.type:r)}}async rename(m,A,_,O){try{await E.Promises.rename(A,_)}catch(N){if(S.isWindows&&N&&N.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${A} to ${_} with 'EPERM' error. Trying again...`,m.id),this.rename(m,A,_,O);throw new w.ExtensionManagementError(N.message||(0,p.localize)(3,null,A,_),N.code||l)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const m=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return m;const A=this.scanDevSystemExtensions(),[_,O]=await Promise.all([m,A]);return[..._,...O]}async scanExtensionsInDir(m,A){const _=new L.Limiter(10),O=await this.fileService.resolve(I.URI.file(m));return O.children?(await Promise.all(O.children.filter(P=>P.isDirectory).map(P=>_.queue(async()=>A===1&&(0,b.basename)(P.resource).indexOf(".")===0?null:this.scanExtension(P.resource,A))))).filter(P=>P&&P.identifier):[]}async scanExtension(m,A){try{const _=await this.fileService.resolve(m);if(_.children){const{manifest:O,metadata:N}=await this.readManifest(m.fsPath),P=_.children.find(({name:H})=>/^readme(\.txt|\.md|)$/i.test(H))?.resource,M=_.children.find(({name:H})=>/^changelog(\.txt|\.md|)$/i.test(H))?.resource,$={id:(0,v.getGalleryExtensionId)(O.publisher,O.name)},U={type:A,identifier:$,manifest:O,location:m,readmeUrl:P,changelogUrl:M,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:A===0};return N&&(this.setMetadata(U,N),U.installedTimestamp=N.installedTimestamp),U}}catch(_){A!==0&&this.logService.trace(_)}return null}async scanDefaultSystemExtensions(){const m=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",m.length),m}async scanDevSystemExtensions(){const m=this.getDevSystemExtensionsList();if(m.length){const A=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",A.length),A.filter(_=>m.some(O=>(0,v.areSameExtensions)(_.identifier,{id:O})))}else return[]}setMetadata(m,A){m.publisherDisplayName=A.publisherDisplayName||null,m.publisherId=A.publisherId||null,m.identifier.uuid=A.id,m.isMachineScoped=!!A.isMachineScoped,m.isBuiltin=m.type===0||!!A.isBuiltin}async removeUninstalledExtensions(){const m=await this.getUninstalledExtensions(),A=await this.scanAllUserExtensions(),_=new Set;for(const P of A)m[new v.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()]||_.add(P.identifier.id.toLowerCase());const O=(0,v.groupByExtension)(A,P=>P.identifier);await L.Promises.settled(O.map(async P=>{const M=P.sort(($,U)=>n.rcompare($.manifest.version,U.manifest.version))[0];_.has(M.identifier.id.toLowerCase())||await this.beforeRemovingExtension(M)}));const N=A.filter(P=>m[new v.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()]);await L.Promises.settled(N.map(P=>this.removeUninstalledExtension(P)))}async removeOutdatedExtensions(){const m=await this.scanAllUserExtensions(),A=[],_=(0,v.groupByExtension)(m,O=>O.identifier);A.push(...(0,R.flatten)(_.map(O=>O.sort((N,P)=>n.rcompare(N.manifest.version,P.manifest.version)).slice(1)))),await L.Promises.settled(A.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(m=>m.name)}joinErrors(m){const A=Array.isArray(m)?m:[m];return A.length===1?A[0]instanceof Error?A[0]:new Error(A[0]):A.reduce((_,O)=>new Error(`${_.message}${_.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=C.normalize(C.join(k.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(m){const A=[E.Promises.readFile(C.join(m,"package.json"),"utf8").then(P=>this.parseManifest(P)),E.Promises.readFile(C.join(m,"package.nls.json"),"utf8").then(void 0,P=>P.code!=="ENOENT"?Promise.reject(P):"{}").then(P=>JSON.parse(P))],[{manifest:_,metadata:O},N]=await Promise.all(A);return{manifest:(0,y.localizeManifest)(_,N),metadata:O}}parseManifest(m){return new Promise((A,_)=>{try{const O=JSON.parse(m),N=O.__metadata||null;A({manifest:O,metadata:N})}catch(O){_(new Error((0,p.localize)(4,null)))}})}};u=he([Q(1,c.IFileService),Q(2,o.ILogService),Q(3,f.INativeEnvironmentService),Q(4,t.IProductService)],u),e.ExtensionsScanner=u}),define(te[232],ne([0,1,38,8,15,9,4,31,16,59,7,30,19,64,130,79,13,198,28,34,174,175,230,163,231,176,76,14,5,10,42,21]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p,f,w,v,y,c,o,t,s,i,r,a,l,u,d,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const _="unsetUninstalled",O="downloading";let N=class extends w.AbstractExtensionManagementService{constructor(W,x,q,F,K,j,z){super(W,x,q);this.environmentService=F,this.downloadService=K,this.fileService=z;const B=this._register(j.createInstance(o.ExtensionsLifecycle));this.extensionsScanner=this._register(j.createInstance(i.ExtensionsScanner,Z=>B.postUninstall(Z))),this.manifestCache=this._register(new s.ExtensionsManifestCache(F,this)),this.extensionsDownloader=this._register(j.createInstance(c.ExtensionsDownloader));const X=this._register(new r.ExtensionsWatcher(this,z,F,q));this._register(X.onDidChangeExtensionsByAnotherSource(({added:Z,removed:V})=>{Z.length&&this._onDidInstallExtensions.fire(Z.map(G=>({identifier:G.identifier,operation:0,local:G}))),V.forEach(G=>this._onDidUninstallExtension.fire({identifier:G}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const W=await this.isAlpineLinux(),x=(0,v.getTargetPlatform)(W?"alpine":k.platform,C.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",x),x})()),this._targetPlatformPromise}async isAlpineLinux(){if(!k.isLinux)return!1;let W;try{W=(await this.fileService.readFile(n.URI.file("/etc/os-release"))).value.toString()}catch(x){try{W=(await this.fileService.readFile(n.URI.file("/usr/lib/os-release"))).value.toString()}catch(q){this.logService.debug("Error while getting the os-release file.",(0,L.getErrorMessage)(q))}}return!!W&&(W.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(W){this.logService.trace("ExtensionManagementService#zip",W.identifier.id);const x=await this.collectFiles(W),q=await(0,E.zip)((0,S.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)()).fsPath,x);return n.URI.file(q)}async unzip(W){return this.logService.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const x=await this.downloadVsix(W),q=T.resolve(x.fsPath);return(0,t.getManifest)(q)}getInstalled(W=null){return this.extensionsScanner.scanExtensions(W)}async install(W,x={}){this.logService.trace("ExtensionManagementService#install",W.toString());const q=await this.downloadVsix(W),F=await(0,t.getManifest)(T.resolve(q.fsPath));if(F.engines&&F.engines.vscode&&!(0,a.isEngineValid)(F.engines.vscode,m.default.version,m.default.date))throw new Error(h.localize(0,null,(0,y.getGalleryExtensionId)(F.publisher,F.name),m.default.version));return this.installExtension(F,q,x)}async updateMetadata(W,x){return this.logService.trace("ExtensionManagementService#updateMetadata",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},...x}),this.manifestCache.invalidate(),W}async updateExtensionScope(W,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},isMachineScoped:x}),this.manifestCache.invalidate(),W}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(W){if(W.scheme===D.Schemas.file)return W;const x=(0,S.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)());return await this.downloadService.download(W,x),x}createInstallExtensionTask(W,x,q){return n.URI.isUri(x)?new $(W,x,q,this.galleryService,this.extensionsScanner,this.logService):new M(x,q,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(W,x){return new U(W,x,this.extensionsScanner)}async collectFiles(W){const x=async F=>{let K=await g.Promises.readdir(F);K=K.map(B=>T.join(F,B));const j=await Promise.all(K.map(B=>g.Promises.stat(B)));let z=Promise.resolve([]);return j.forEach((B,X)=>{const Z=K[X];B.isFile()&&(z=z.then(V=>[...V,Z])),B.isDirectory()&&(z=z.then(V=>x(Z).then(G=>[...V,...G])))}),z};return(await x(W.location.fsPath)).map(F=>({path:`extension/${T.relative(W.location.fsPath,F)}`,localPath:F}))}};N=he([Q(0,v.IExtensionGalleryService),Q(1,A.ITelemetryService),Q(2,d.ILogService),Q(3,f.INativeEnvironmentService),Q(4,p.IDownloadService),Q(5,u.IInstantiationService),Q(6,l.IFileService)],N),e.ExtensionManagementService=N;class P extends w.AbstractExtensionTask{constructor(W,x,q,F){super();this.identifier=W,this.source=x,this.extensionsScanner=q,this.logService=F,this._operation=1}get operation(){return this._operation}async installExtension(W,x){try{const q=await this.unsetUninstalledAndGetLocal(W.identifierWithVersion);if(q)return W.metadata?this.extensionsScanner.saveMetadataForLocalExtension(q,W.metadata):q}catch(q){throw k.isMacintosh?new v.ExtensionManagementError(h.localize(1,null),_):new v.ExtensionManagementError(h.localize(2,null),_)}return this.extract(W,x)}async unsetUninstalledAndGetLocal(W){if(!await this.isUninstalled(W))return null;this.logService.trace("Removing the extension from uninstalled list:",W.id);const q=await this.extensionsScanner.setInstalled(W);return this.logService.info("Removed the extension from uninstalled list:",W.id),q}async isUninstalled(W){return!!(await this.extensionsScanner.getUninstalledExtensions())[W.key()]}async extract({zipPath:W,identifierWithVersion:x,metadata:q},F){let K=await this.extensionsScanner.extractUserExtension(x,W,q,F);return this.logService.info("Extracting completed.",x.id),K}}class M extends P{constructor(W,x,q,F,K){super(W.identifier,W,F,K);this.gallery=W,this.options=x,this.extensionsDownloader=q}async doRun(W){const q=(await this.extensionsScanner.scanExtensions(null)).find(K=>(0,y.areSameExtensions)(K.identifier,this.gallery.identifier));q&&(this._operation=2);const F=await this.downloadInstallableExtension(this.gallery,this._operation);F.metadata.isMachineScoped=this.options.isMachineScoped||q?.isMachineScoped,F.metadata.isBuiltin=this.options.isBuiltin||q?.isBuiltin;try{const K=await this.installExtension(F,W);return q&&b.neq(q.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(q),K}catch(K){throw await this.deleteDownloadedVSIX(F.zipPath),K}}async deleteDownloadedVSIX(W){try{await this.extensionsDownloader.delete(n.URI.file(W))}catch(x){this.logService.warn("Error while deleting the downloaded vsix",W.toString(),(0,L.getErrorMessage)(x))}}async downloadInstallableExtension(W,x){const q={id:W.identifier.uuid,publisherId:W.publisherId,publisherDisplayName:W.publisherDisplayName};let F;try{this.logService.trace("Started downloading extension:",W.identifier.id),F=(await this.extensionsDownloader.downloadExtension(W,x)).fsPath,this.logService.info("Downloaded extension:",W.identifier.id,F)}catch(K){throw new v.ExtensionManagementError((0,w.joinErrors)(K).message,O)}try{const K=await(0,t.getManifest)(F);return{zipPath:F,identifierWithVersion:new y.ExtensionIdentifierWithVersion(W.identifier,K.version),metadata:q}}catch(K){throw await this.deleteDownloadedVSIX(F),new v.ExtensionManagementError((0,w.joinErrors)(K).message,w.INSTALL_ERROR_VALIDATING)}}}class $ extends P{constructor(W,x,q,F,K,j){super({id:(0,y.getGalleryExtensionId)(W.publisher,W.name)},x,K,j);this.manifest=W,this.location=x,this.options=q,this.galleryService=F}async doRun(W){const x=new y.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),F=(await this.extensionsScanner.scanExtensions(1)).find(j=>(0,y.areSameExtensions)(this.identifier,j.identifier)),K=await this.getMetadata(this.identifier.id,W);if(K.isMachineScoped=this.options.isMachineScoped||F?.isMachineScoped,K.isBuiltin=this.options.isBuiltin||F?.isBuiltin,F)if(this._operation=2,x.equals(new y.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version)))try{await this.extensionsScanner.removeExtension(F,"existing")}catch(j){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else b.gt(F.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(F);else{const j=await this.unsetUninstalledAndGetLocal(x);if(j)try{await this.extensionsScanner.removeExtension(j,"existing")}catch(z){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:T.resolve(this.location.fsPath),identifierWithVersion:x,metadata:K},W)}async getMetadata(W,x){try{const q=(await this.galleryService.query({names:[W],pageSize:1},x)).firstPage[0];if(q)return{id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId}}catch(q){}return{}}}class U extends w.AbstractExtensionTask{constructor(W,x,q){super();this.extension=W,this.options=x,this.extensionsScanner=q}async doRun(W){const x=[],q=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const F=new y.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);x.push(...q.filter(K=>F.equals(new y.ExtensionIdentifierWithVersion(K.identifier,K.manifest.version))))}else x.push(...q.filter(F=>(0,y.areSameExtensions)(F.identifier,this.extension.identifier)));if(!x.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const F of x)try{W.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(F)}catch(K){throw new Error(h.localize(6,null,(0,R.toErrorMessage)(K)))}}}}),define(te[233],ne([0,1,83,56,32,22,8,3,2,9,4,30,33,72,241]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{constructor(u){this.socket=u,this._errorListener=d=>{if(d){if(d.code==="EPIPE")return;(0,k.onUnexpectedError)(d)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const d=m=>u(T.VSBuffer.wrap(m));return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(u){const d=m=>{u({type:0,hadError:m,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(u){return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(u){if(!this.socket.destroyed)try{this.socket.write(u.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,k.onUnexpectedError)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,k.onUnexpectedError)(d)}}end(){this.socket.end()}drain(){return new Promise((u,d)=>{if(this.socket.bufferSize===0){u();return}const m=()=>{this.socket.off("close",m),this.socket.off("end",m),this.socket.off("error",m),this.socket.off("timeout",m),this.socket.off("drain",m),u()};this.socket.on("close",m),this.socket.on("end",m),this.socket.on("error",m),this.socket.on("timeout",m),this.socket.on("drain",m)})}}e.NodeSocket=p;var f;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var w;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(w||(w={}));class v extends S.Disposable{constructor(u,d,m,A){super();this._onDidZlibFlush=this._register(new C.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new C.Emitter),this._onClose=this._register(new C.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=d,this._recordInflateBytes=A,d?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",_=>{console.error(_),(0,k.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibInflate.on("data",_=>{this._pendingInflateData.push(_)}),m&&(this._zlibInflate.write(m.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",_=>{console.error(_),(0,k.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibDeflate.on("data",_=>{this._pendingDeflateData.push(_)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new E.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):T.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._totalOutgoingDataBytes+=u.byteLength,this._zlibDeflate?(this._zlibDeflate.write(u.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let d=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,d=d.slice(0,d.length-4),this._isEnded||this._write(T.VSBuffer.wrap(d),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(u,!1)}_write(u,d){let m=2;u.byteLength<126?m+=0:u.byteLength<2**16?m+=2:m+=8;const A=T.VSBuffer.alloc(m);if(d?A.writeUInt8(194,0):A.writeUInt8(130,0),u.byteLength<126)A.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){A.writeUInt8(126,1);let _=1;A.writeUInt8(u.byteLength>>>8&255,++_),A.writeUInt8(u.byteLength>>>0&255,++_)}else{A.writeUInt8(127,1);let _=1;A.writeUInt8(0,++_),A.writeUInt8(0,++_),A.writeUInt8(0,++_),A.writeUInt8(0,++_),A.writeUInt8(u.byteLength>>>24&255,++_),A.writeUInt8(u.byteLength>>>16&255,++_),A.writeUInt8(u.byteLength>>>8&255,++_),A.writeUInt8(u.byteLength>>>0&255,++_)}this._totalOutgoingWireBytes+=A.byteLength+u.byteLength,this.socket.write(T.VSBuffer.concat([A,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._totalIncomingWireBytes+=u.byteLength,this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const d=this._incomingData.peek(this._state.readLen),m=d.readUInt8(0),A=(m&128)>>>7,_=(m&64)>>>6,O=d.readUInt8(1),N=(O&128)>>>7,P=O&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(P===126?2:0)+(P===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(_)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0}else if(this._state.state===2){const d=this._incomingData.read(this._state.readLen),m=d.readUInt8(1),A=(m&128)>>>7;let _=m&127,O=1;_===126?_=d.readUInt8(++O)*2**8+d.readUInt8(++O):_===127&&(_=d.readUInt8(++O)*0+d.readUInt8(++O)*0+d.readUInt8(++O)*0+d.readUInt8(++O)*0+d.readUInt8(++O)*2**24+d.readUInt8(++O)*2**16+d.readUInt8(++O)*2**8+d.readUInt8(++O));let N=0;A&&(N=d.readUInt8(++O)*2**24+d.readUInt8(++O)*2**16+d.readUInt8(++O)*2**8+d.readUInt8(++O)),this._state.state=3,this._state.readLen=_,this._state.mask=N}else if(this._state.state===3){const d=this._incomingData.read(this._state.readLen);y(d,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(d.buffer)),this._zlibInflate.write(d.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const m=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=m.length,this._onData.fire(T.VSBuffer.wrap(m))})):(this._totalIncomingDataBytes+=d.byteLength,this._onData.fire(d))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await C.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=v;function y(l,u){if(u===0)return;let d=l.byteLength>>>2;for(let P=0;P<d;P++){const M=l.readUInt32BE(P*4);l.writeUInt32BE(M^u,P*4)}let m=d*4,A=l.byteLength-m;const _=u>>>24&255,O=u>>>16&255,N=u>>>8&255;A>=1&&l.writeUInt8(l.readUInt8(m)^_,m),A>=2&&l.writeUInt8(l.readUInt8(m+1)^O,m+1),A>=3&&l.writeUInt8(l.readUInt8(m+2)^N,m+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function o(){const l=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):u=(0,b.join)((0,D.tmpdir)(),`vscode-ipc-${l}.sock`),s(u),u}e.createRandomIPCHandle=o;function t(l,u,d){const m=(0,R.createHash)("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${m}-${d}-${u}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-${m.substr(0,8)}-${d}-${u}.sock`):A=(0,b.join)(l,`${d}-${u}.sock`),s(A),A}e.createStaticIPCHandle=t;function s(l){const u=c[n.platform];typeof u=="number"&&l.length>=u&&console.warn(`WARNING: IPC handle "${l}" is longer than ${u} chars, try a shorter --user-data-dir`)}class i extends g.IPCServer{constructor(u){super(i.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const d=C.Event.fromNodeEventEmitter(u,"connection");return C.Event.map(d,m=>({protocol:new E.Protocol(new p(m)),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(m,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function r(l){return new Promise((u,d)=>{const m=(0,L.createServer)();m.on("error",d),m.listen(l,()=>{m.removeListener("error",d),u(new i(m))})})}e.serve=r;function a(l,u){return new Promise((d,m)=>{const A=(0,L.createConnection)(l,()=>{A.removeListener("error",m),d(E.Client.fromSocket(new p(A),u))});A.once("error",m)})}e.connect=a}),define(te[234],ne([0,1,56,233]),function(J,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,T,k,C){const S=n=>C(n,void 0),b=R.createConnection({host:D,port:T},()=>{b.removeListener("error",S);const n=Buffer.alloc(16);for(let h=0;h<16;h++)n[h]=Math.round(Math.random()*256);const I=n.toString("base64");let g=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${T}/?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];b.write(g.join(`\r
`)+`\r
\r
`);const E=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",E),C(void 0,new L.NodeSocket(b)))};b.on("data",E)});b.once("error",S)}}}),define(te[235],ne([0,1,56,111,234,6,2,20,10,29,186,61,90]),function(J,e,R,L,D,T,k,C,S,b,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function E(w,v,y,c,o){return new h(w,v,y,c,o).waitForReady()}class h extends k.Disposable{constructor(v,y,c,o,t){super();this.defaultTunnelHost=y,this.suggestedLocalPort=t,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=v,this._server=R.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=o,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(y=>{y()})}async waitForReady(){let v=await(0,L.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),y=null;return this._server.listen(v,this.defaultTunnelHost),await this._barrier.wait(),y=this._server.address(),y||(v=0,this._server.listen(v,this.defaultTunnelHost),await this._barrier.wait(),y=this._server.address()),this.tunnelLocalPort=y.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${y.port}`,this}async _onConnection(v){v.pause();const y=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,n.connectRemoteAgentTunnel)(this._options,y,this.tunnelRemotePort),o=c.getSocket().socket,t=c.readEntireBuffer();c.dispose(),t.byteLength>0&&v.write(t.buffer),v.on("end",()=>{this._socketsDispose.delete(v.localAddress),o.end()}),v.on("close",()=>o.end()),v.on("error",()=>{this._socketsDispose.delete(v.localAddress),o.destroy()}),o.on("end",()=>v.end()),o.on("close",()=>v.end()),o.on("error",()=>{v.destroy()}),v.pipe(o),o.pipe(v),this._socketsDispose.set(v.localAddress,()=>{v.end(),o.end()})}}let p=class extends I.AbstractTunnelService{constructor(v,y,c,o,t){super(y);this.socketFactory=v,this.signService=c,this.productService=o,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(v,y,c,o,t,s,i){const r=this.getTunnelFromMap(y,c);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,y,c,o,t,s,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${y}:${c} on local port ${o}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:v,signService:this.signService,logService:this.logService,ipcLogger:null},l=E(a,this.defaultTunnelHost,y,c,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(y,c,l),l}}};p=he([Q(1,S.ILogService),Q(2,g.ISignService),Q(3,b.IProductService),Q(4,C.IConfigurationService)],p),e.BaseTunnelService=p;let f=class extends p{constructor(v,y,c,o){super(D.nodeSocketFactory,v,y,c,o)}};f=he([Q(0,S.ILogService),Q(1,g.ISignService),Q(2,b.IProductService),Q(3,C.IConfigurationService)],f),e.TunnelService=f}),define(te[242],ne([0,1,116,51,243,32,38,8,2,15,16,7,33,115,182,161,183,171,172,173,159,164,20,184,78,197,79,190,13,150,193,200,28,162,199,232,80,153,14,179,181,53,5,168,85,169,170,58,178,10,86,60,42,29,189,43,23,195,196,21,91,92,93,46,201,202,94,204,210,96,97,98,24,62,221,222,223,63,224,225,226,227,228,229,81,177,90,192,61,235,187,188]),function(J,e,R,L,D,T,k,C,S,b,n,I,g,E,h,p,f,w,v,y,c,o,t,s,i,r,a,l,u,d,m,A,_,O,N,P,M,$,U,H,W,x,q,F,K,j,z,B,X,Z,V,G,ie,re,ae,ue,fe,ge,Ie,Pe,Ee,_e,De,ke,Fe,Ne,ze,xe,ee,oe,ce,ye,Se,Oe,Te,Ue,Ae,Y,se,le,de,me,be,pe,we,Ce,Re,Le,it,Ge,je,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class wt extends S.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new E.Server),(0,D.gracefulify)(L),this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve)}async open(){const ve=await this.initServices();(0,Se.registerConfiguration)(),ve.invokeFunction(Me=>{const qe=Me.get(Z.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler(qe)}),this._register((0,S.combinedDisposable)(ve.createInstance(h.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(f.LanguagePackCachedDataCleaner),ve.createInstance(y.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(v.LogsDataCleaner),ve.createInstance(w.LocalizationsUpdater),ve.createInstance(p.DeprecatedExtensionsCleaner)))}async initServices(){const ve=new K.ServiceCollection,Me={_serviceBrand:void 0,...ie.default};ve.set(re.IProductService,Me);const qe=new g.StaticRouter(We=>We==="main"),Je=new j.MessagePortMainProcessService(this.server,qe);ve.set(z.IMainProcessService,Je);const $e=new d.NativeEnvironmentService(this.configuration.args,Me);ve.set(u.INativeEnvironmentService,$e);const rt=new V.LogLevelChannelClient(this.server.getChannel("logLevel",qe)),Xe=new V.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,Je.getChannel("logger"));ve.set(Z.ILoggerService,Xe);const at=this._register(new Z.MultiplexLogService([this._register(new Z.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger((0,n.joinPath)(I.URI.file($e.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ke=this._register(new V.FollowerLogService(rt,at));ve.set(Z.ILogService,Ke);const Qe=this._register(new H.FileService(Ke));ve.set(U.IFileService,Qe);const ot=this._register(new W.DiskFileSystemProvider(Ke));Qe.registerProvider(b.Schemas.file,ot);const Ve=this._register(new s.ConfigurationService($e.settingsResource,Qe));ve.set(t.IConfigurationService,Ve),await Ve.initialize();const et=new ge.NativeStorageService(void 0,Je,$e);ve.set(fe.IStorageService,et),await et.initialize(),this._register((0,S.toDisposable)(()=>et.flush())),ve.set(ue.IRequestService,new x.SyncDescriptor(ae.RequestService)),ve.set(c.IChecksumService,new x.SyncDescriptor(o.ChecksumService));const st=g.ProxyChannel.toService(Je.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(G.INativeHostService,st),ve.set(a.IDownloadService,new x.SyncDescriptor(l.DownloadService));const ct=this._register(new pe.ActiveWindowManager(st)),lt=new g.StaticRouter(We=>ct.getActiveClientId().then(ut=>We===ut));ve.set(M.IExtensionRecommendationNotificationService,new $.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",lt)));let Ye;const tt=[];if((0,ke.supportsTelemetry)(Me,$e)){const We=new _e.TelemetryLogAppender(Xe,$e);tt.push(We);const{appRoot:ut,extensionsPath:It,installSourcePath:Ct}=$e;if(Me.aiConfig&&Me.aiConfig.asimovKey){const gt=new Fe.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey);this._register((0,S.toDisposable)(()=>gt.flush())),tt.push(gt)}Ye=new De.TelemetryService({appenders:tt,commonProperties:(0,Ie.resolveCommonProperties)(Qe,(0,T.release)(),(0,T.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,Me.msftInternalDomains,Ct),sendErrorTelemetry:!0,piiPaths:[ut,It]},Ve)}else{Ye=ke.NullTelemetryService;const We=ke.NullAppender;tt.push(We)}this.server.registerChannel("telemetryAppender",new Ee.TelemetryAppenderChannel(tt)),ve.set(Pe.ITelemetryService,Ye);const bt=new Ne.CustomEndpointTelemetryService(Ve,Ye,Xe,$e);return ve.set(Pe.ICustomEndpointTelemetryService,bt),ve.set(_.IExtensionManagementService,new x.SyncDescriptor(P.ExtensionManagementService)),ve.set(_.IExtensionGalleryService,new x.SyncDescriptor(A.ExtensionGalleryService)),ve.set(_.IExtensionTipsService,new x.SyncDescriptor(N.ExtensionTipsService)),ve.set(B.ILocalizationsService,new x.SyncDescriptor(X.LocalizationsService)),ve.set(i.IDiagnosticsService,new x.SyncDescriptor(r.DiagnosticsService)),ve.set(Oe.IUserDataSyncAccountService,new x.SyncDescriptor(Oe.UserDataSyncAccountService)),ve.set(Se.IUserDataSyncLogService,new x.SyncDescriptor(Ae.UserDataSyncLogService)),ve.set(Se.IUserDataSyncUtilService,new Ue.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),ve.set(_.IGlobalExtensionEnablementService,new x.SyncDescriptor(m.GlobalExtensionEnablementService)),ve.set(ce.IIgnoredExtensionsManagementService,new x.SyncDescriptor(ce.IgnoredExtensionsManagementService)),ve.set(oe.IExtensionsStorageSyncService,new x.SyncDescriptor(oe.ExtensionsStorageSyncService)),ve.set(Se.IUserDataSyncStoreManagementService,new x.SyncDescriptor(me.UserDataSyncStoreManagementService)),ve.set(Se.IUserDataSyncStoreService,new x.SyncDescriptor(me.UserDataSyncStoreService)),ve.set(Y.IUserDataSyncMachinesService,new x.SyncDescriptor(Y.UserDataSyncMachinesService)),ve.set(Se.IUserDataSyncBackupStoreService,new x.SyncDescriptor(Te.UserDataSyncBackupStoreService)),ve.set(Se.IUserDataAutoSyncEnablementService,new x.SyncDescriptor(ye.UserDataAutoSyncEnablementService)),ve.set(Se.IUserDataSyncResourceEnablementService,new x.SyncDescriptor(se.UserDataSyncResourceEnablementService)),ve.set(Se.IUserDataSyncService,new x.SyncDescriptor(le.UserDataSyncService)),ve.set(xe.ILocalPtyService,this._register(new ee.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ve.getValue("terminal.integrated.persistentSessionScrollback")??100},Ve,$e,Ke,Ye))),ve.set(we.IExtensionHostStarter,this._register(new Ce.ExtensionHostStarter(Ke))),ve.set(Re.ISignService,new x.SyncDescriptor(Le.SignService)),ve.set(it.ITunnelService,new x.SyncDescriptor(Ge.TunnelService)),ve.set(je.ISharedProcessTunnelService,new x.SyncDescriptor(St.SharedProcessTunnelService)),new F.InstantiationService(ve)}initChannels(ve){const Me=new O.ExtensionManagementChannel(ve.get(_.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const qe=g.ProxyChannel.fromService(ve.get(B.ILocalizationsService));this.server.registerChannel("localizations",qe);const Je=g.ProxyChannel.fromService(ve.get(i.IDiagnosticsService));this.server.registerChannel("diagnostics",Je);const $e=new O.ExtensionTipsChannel(ve.get(_.IExtensionTipsService));this.server.registerChannel("extensionTipsService",$e);const rt=g.ProxyChannel.fromService(ve.get(c.IChecksumService));this.server.registerChannel("checksum",rt);const Xe=new Ue.UserDataSyncMachinesServiceChannel(ve.get(Y.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Xe);const at=g.ProxyChannel.fromService(ve.get(Pe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const Ke=new Ue.UserDataSyncAccountServiceChannel(ve.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ke);const Qe=new Ue.UserDataSyncStoreManagementServiceChannel(ve.get(Se.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Qe);const ot=new de.UserDataSyncChannel(ve.get(Se.IUserDataSyncService),ve.get(Z.ILogService));this.server.registerChannel("userDataSync",ot);const Ve=this._register(ve.get(q.IInstantiationService).createInstance(be.UserDataAutoSyncService)),et=new Ue.UserDataAutoSyncChannel(Ve);this.server.registerChannel("userDataAutoSync",et);const st=ve.get(xe.ILocalPtyService),ct=g.ProxyChannel.fromService(st);this.server.registerChannel(ze.TerminalIpcChannels.LocalPty,ct);const lt=g.ProxyChannel.fromService(ve.get(we.IExtensionHostStarter));this.server.registerChannel(we.ipcExtensionHostStarterChannelName,lt);const Ye=g.ProxyChannel.fromService(ve.get(je.ISharedProcessTunnelService));this.server.registerChannel(je.ipcSharedProcessTunnelChannelName,Ye)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Me=>{(0,C.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,C.setUnexpectedErrorHandler)(Me=>{const qe=(0,k.toErrorMessage)(Me,!0);!qe||ve.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function Et(dt){const ve=new wt(dt);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Et})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
