/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/extpath","fs","vs/base/common/process","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/product/common/product","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/base/common/errorMessage","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/linkedList","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],x=function(V){for(var e=[],p=0,L=V.length;p<L;p++)e[p]=Z[V[p]];return e};define(Z[103],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=p}),define(Z[47],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(E){return(n,f,w)=>{let i=null,I=null;if(typeof w.value=="function"?(i="value",I=w.value):typeof w.get=="function"&&(i="get",I=w.get),!I)throw new Error("not supported");w[i]=E(I,f)}}e.createDecorator=p;function L(E,n,f){let w=null,i=null;if(typeof f.value=="function"?(w="value",i=f.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(w="get",i=f.get),!i)throw new Error("not supported");const I=`$memoize$${n}`;f[w]=function(...P){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,P)}),this[I]}}e.memoize=L;function k(E,n,f){return p((w,i)=>{const I=`$debounce$${i}`,P=`$debounce$result$${i}`;return function(...y){this[P]||(this[P]=f?f():void 0),clearTimeout(this[I]),n&&(this[P]=n(this[P],...y),y=[this[P]]),this[I]=setTimeout(()=>{w.apply(this,y),this[P]=f?f():void 0},E)}})}e.debounce=k;function M(E,n,f){return p((w,i)=>{const I=`$throttle$timer$${i}`,P=`$throttle$result$${i}`,y=`$throttle$lastRun$${i}`,d=`$throttle$pending$${i}`;return function(...g){if(this[P]||(this[P]=f?f():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),n&&(this[P]=n(this[P],...g)),this[d])return;const b=this[y]+E;b<=Date.now()?(this[y]=Date.now(),w.apply(this,[this[P]]),this[P]=f?f():void 0):(this[d]=!0,this[I]=setTimeout(()=>{this[d]=!1,this[y]=Date.now(),w.apply(this,[this[P]]),this[P]=f?f():void 0},b-Date.now()))}})}e.throttle=M}),define(Z[17],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(l=>{l(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function L(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=L;function k(u){f(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=k;function M(u){f(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=M;function E(u){if(u instanceof Error){let{name:t,message:l}=u;const r=u.stacktrace||u.stack;return{$isError:!0,name:t,message:l,stack:r}}return u}e.transformErrorForSerialization=E;const n="Canceled";function f(u){return u instanceof Error&&u.name===n&&u.message===n}e.isPromiseCanceledError=f;class w extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=w;function i(){const u=new Error(n);return u.name=u.message,u}e.canceled=i;function I(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=I;function P(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=P;function y(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function d(u){const t=new Error(`${u} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function g(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=g;class b extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=b;class v extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=v;class c extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=c;function h(u){const t=u;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=h;function a(u,t=Object.create(null)){const l=new Error(u);return t.actions&&(l.actions=t.actions),l}e.createErrorWithActions=a}),define(Z[30],x([0,1,17]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(A,F=0){return A[A.length-(1+F)]}e.tail=L;function k(A){if(A.length===0)throw new Error("Invalid tail call");return[A.slice(0,A.length-1),A[A.length-1]]}e.tail2=k;function M(A,F,B=(Y,C)=>Y===C){if(A===F)return!0;if(!A||!F||A.length!==F.length)return!1;for(let Y=0,C=A.length;Y<C;Y++)if(!B(A[Y],F[Y]))return!1;return!0}e.equals=M;function E(A,F,B){let Y=0,C=A.length-1;for(;Y<=C;){const N=(Y+C)/2|0,Q=B(A[N],F);if(Q<0)Y=N+1;else if(Q>0)C=N-1;else return N}return-(Y+1)}e.binarySearch=E;function n(A,F){let B=0,Y=A.length;if(Y===0)return 0;for(;B<Y;){const C=Math.floor((B+Y)/2);F(A[C])?Y=C:B=C+1}return B}e.findFirstInSorted=n;function f(A,F,B){if(A=A|0,A>=F.length)throw new TypeError("invalid index");let Y=F[Math.floor(F.length*Math.random())],C=[],N=[],Q=[];for(let J of F){const re=B(J,Y);re<0?C.push(J):re>0?N.push(J):Q.push(J)}return A<C.length?f(A,C,B):A<C.length+Q.length?Q[0]:f(A-(C.length+Q.length),N,B)}e.quickSelect=f;function w(A,F){const B=[];let Y;for(const C of A.slice(0).sort(F))!Y||F(Y[0],C)!==0?(Y=[C],B.push(Y)):Y.push(C);return B}e.groupBy=w;function i(A,F,B){const Y=[];function C(J,re,le){if(re===0&&le.length===0)return;const ee=Y[Y.length-1];ee&&ee.start+ee.deleteCount===J?(ee.deleteCount+=re,ee.toInsert.push(...le)):Y.push({start:J,deleteCount:re,toInsert:le})}let N=0,Q=0;for(;;){if(N===A.length){C(N,0,F.slice(Q));break}if(Q===F.length){C(N,A.length-N,[]);break}const J=A[N],re=F[Q],le=B(J,re);le===0?(N+=1,Q+=1):le<0?(C(N,1,[]),N+=1):le>0&&(C(N,0,[re]),Q+=1)}return Y}e.sortedDiff=i;function I(A,F,B){const Y=i(A,F,B),C=[],N=[];for(const Q of Y)C.push(...A.slice(Q.start,Q.start+Q.deleteCount)),N.push(...Q.toInsert);return{removed:C,added:N}}e.delta=I;function P(A,F,B){if(B===0)return[];const Y=A.slice(0,B).sort(F);return d(A,F,Y,B,A.length),Y}e.top=P;function y(A,F,B,Y,C){return B===0?Promise.resolve([]):new Promise((N,Q)=>{(async()=>{const J=A.length,re=A.slice(0,B).sort(F);for(let le=B,ee=Math.min(B+Y,J);le<J;le=ee,ee=Math.min(ee+Y,J)){if(le>B&&await new Promise(ae=>setTimeout(ae)),C&&C.isCancellationRequested)throw(0,p.canceled)();d(A,F,re,le,ee)}return re})().then(N,Q)})}e.topAsync=y;function d(A,F,B,Y,C){for(const N=B.length;Y<C;Y++){const Q=A[Y];if(F(Q,B[N-1])<0){B.pop();const J=n(B,re=>F(Q,re)<0);B.splice(J,0,Q)}}}function g(A){return A.filter(F=>!!F)}e.coalesce=g;function b(A){let F=0;for(let B=0;B<A.length;B++)A[B]&&(A[F]=A[B],F+=1);A.length=F}e.coalesceInPlace=b;function v(A,F,B){A.splice(B,0,A.splice(F,1)[0])}e.move=v;function c(A){return!Array.isArray(A)||A.length===0}e.isFalsyOrEmpty=c;function h(A){return Array.isArray(A)&&A.length>0}e.isNonEmptyArray=h;function a(A,F){if(!F)return A.filter((Y,C)=>A.indexOf(Y)===C);const B=Object.create(null);return A.filter(Y=>{const C=F(Y);return B[C]?!1:(B[C]=!0,!0)})}e.distinct=a;function u(A){const F=new Set;return A.filter(B=>F.has(B)?!1:(F.add(B),!0))}e.distinctES6=u;function t(A){const F=Object.create(null);return B=>{const Y=A(B);return F[Y]?!1:(F[Y]=!0,!0)}}e.uniqueFilter=t;function l(A,F){const B=r(A,F);if(B!==-1)return A[B]}e.findLast=l;function r(A,F){for(let B=A.length-1;B>=0;B--){const Y=A[B];if(F(Y))return B}return-1}e.lastIndex=r;function s(A,F){return A.length>0?A[0]:F}e.firstOrDefault=s;function o(A,F,B=(Y,C)=>Y===C){let Y=0;for(let C=0,N=Math.min(A.length,F.length);C<N&&B(A[C],F[C]);C++)Y++;return Y}e.commonPrefixLength=o;function m(A){return[].concat(...A)}e.flatten=m;function S(A,F){let B=typeof F=="number"?A:0;typeof F=="number"?B=A:(B=0,F=A);const Y=[];if(B<=F)for(let C=B;C<F;C++)Y.push(C);else for(let C=B;C>F;C--)Y.push(C);return Y}e.range=S;function D(A,F,B){return A.reduce((Y,C)=>(Y[F(C)]=B?B(C):C,Y),Object.create(null))}e.index=D;function R(A,F){return A.push(F),()=>T(A,F)}e.insert=R;function T(A,F){const B=A.indexOf(F);if(B>-1)return A.splice(B,1),F}e.remove=T;function _(A,F,B){const Y=A.slice(0,F),C=A.slice(F);return Y.concat(B,C)}e.arrayInsert=_;function G(A,F){let B;if(typeof F=="number"){let Y=F;B=()=>{const C=Math.sin(Y++)*179426549;return C-Math.floor(C)}}else B=Math.random;for(let Y=A.length-1;Y>0;Y-=1){const C=Math.floor(B()*(Y+1)),N=A[Y];A[Y]=A[C],A[C]=N}}e.shuffle=G;function ne(A,F){const B=A.indexOf(F);B>-1&&(A.splice(B,1),A.unshift(F))}e.pushToStart=ne;function se(A,F){const B=A.indexOf(F);B>-1&&(A.splice(B,1),A.push(F))}e.pushToEnd=se;function K(A,F){return Array.isArray(A)?A.map(F):F(A)}e.mapArrayOrNot=K;function te(A){return Array.isArray(A)?A:[A]}e.asArray=te;function W(A){return A[Math.floor(Math.random()*A.length)]}e.getRandomElement=W;function j(A,F){for(const B of A){const Y=F(B);if(Y!==void 0)return Y}}e.mapFind=j;function H(A,F,B){const Y=q(A,F),C=A.length,N=B.length;A.length=C+N;for(let Q=C-1;Q>=Y;Q--)A[Q+N]=A[Q];for(let Q=0;Q<N;Q++)A[Q+Y]=B[Q]}e.insertInto=H;function z(A,F,B,Y){const C=q(A,F),N=A.splice(C,B);return H(A,C,Y),N}e.splice=z;function q(A,F){return F<0?Math.max(F+A.length,0):Math.min(F,A.length)}function O(A,F){let B=Number.MAX_SAFE_INTEGER,Y=0;return A.forEach((C,N)=>{const Q=F(C);Q<B&&(B=Q,Y=N)}),Y}e.minIndex=O;function $(A,F){let B=Number.MIN_SAFE_INTEGER,Y=0;return A.forEach((C,N)=>{const Q=F(C);Q>B&&(B=Q,Y=N)}),Y}e.maxIndex=$;class U{constructor(F){this.items=F,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(F){let B=this.firstIdx;for(;B<this.items.length&&F(this.items[B]);)B++;const Y=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,Y}takeFromEndWhile(F){let B=this.lastIdx;for(;B>=0&&F(this.items[B]);)B--;const Y=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,Y}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=U}),define(Z[43],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(L){const k=this;let M=!1,E;return function(){return M||(M=!0,E=L.apply(k,arguments)),E}}e.once=p}),define(Z[65],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(L){function k(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}L.is=k;const M=Object.freeze([]);function E(){return M}L.empty=E;function*n(u){yield u}L.single=n;function f(u){return u||M}L.from=f;function w(u){return!u||u[Symbol.iterator]().next().done===!0}L.isEmpty=w;function i(u){return u[Symbol.iterator]().next().value}L.first=i;function I(u,t){for(const l of u)if(t(l))return!0;return!1}L.some=I;function P(u,t){for(const l of u)if(t(l))return l}L.find=P;function*y(u,t){for(const l of u)t(l)&&(yield l)}L.filter=y;function*d(u,t){let l=0;for(const r of u)yield t(r,l++)}L.map=d;function*g(...u){for(const t of u)for(const l of t)yield l}L.concat=g;function*b(u){for(const t of u)for(const l of t)yield l}L.concatNested=b;function v(u,t,l){let r=l;for(const s of u)r=t(r,s);return r}L.reduce=v;function*c(u,t,l=u.length){for(t<0&&(t+=u.length),l<0?l+=u.length:l>u.length&&(l=u.length);t<l;t++)yield u[t]}L.slice=c;function h(u,t=Number.POSITIVE_INFINITY){const l=[];if(t===0)return[l,u];const r=u[Symbol.iterator]();for(let s=0;s<t;s++){const o=r.next();if(o.done)return[l,L.empty()];l.push(o.value)}return[l,{[Symbol.iterator](){return r}}]}L.consume=h;function a(u,t,l=(r,s)=>r===s){const r=u[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const o=r.next(),m=s.next();if(o.done!==m.done)return!1;if(o.done)return!0;if(!l(o.value,m.value))return!1}}L.equals=a})(p=e.Iterable||(e.Iterable={}))}),define(Z[40],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function E(t,l=!1){let r=0,s=t.length,o="",m=0,S=16,D=0;function R(te){let W=0,j=0;for(;W<te;){const H=t.charCodeAt(r);if(H>=48&&H<=57)j=j*16+H-48;else if(H>=65&&H<=70)j=j*16+H-65+10;else if(H>=97&&H<=102)j=j*16+H-97+10;else break;r++,W++}return W<te&&(j=-1),j}function T(te){r=te,o="",m=0,S=16,D=0}function _(){const te=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&w(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&w(t.charCodeAt(r)))for(r++;r<t.length&&w(t.charCodeAt(r));)r++;else return D=3,t.substring(te,r);let W=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&w(t.charCodeAt(r))){for(r++;r<t.length&&w(t.charCodeAt(r));)r++;W=r}else D=3;return t.substring(te,W)}function G(){let te="",W=r;for(;;){if(r>=s){te+=t.substring(W,r),D=2;break}const j=t.charCodeAt(r);if(j===34){te+=t.substring(W,r),r++;break}if(j===92){if(te+=t.substring(W,r),r++,r>=s){D=2;break}switch(t.charCodeAt(r++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:const z=R(4);z>=0?te+=String.fromCharCode(z):D=4;break;default:D=5}W=r;continue}if(j>=0&&j<=31)if(f(j)){te+=t.substring(W,r),D=2;break}else D=6;r++}return te}function ne(){if(o="",D=0,m=r,r>=s)return m=s,S=17;let te=t.charCodeAt(r);if(n(te)){do r++,o+=String.fromCharCode(te),te=t.charCodeAt(r);while(n(te));return S=15}if(f(te))return r++,o+=String.fromCharCode(te),te===13&&t.charCodeAt(r)===10&&(r++,o+=`
`),S=14;switch(te){case 123:return r++,S=1;case 125:return r++,S=2;case 91:return r++,S=3;case 93:return r++,S=4;case 58:return r++,S=6;case 44:return r++,S=5;case 34:return r++,o=G(),S=10;case 47:const W=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<s&&!f(t.charCodeAt(r));)r++;return o=t.substring(W,r),S=12}if(t.charCodeAt(r+1)===42){r+=2;const j=s-1;let H=!1;for(;r<j;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,D=1),o=t.substring(W,r),S=13}return o+=String.fromCharCode(te),r++,S=16;case 45:if(o+=String.fromCharCode(te),r++,r===s||!w(t.charCodeAt(r)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),S=11;default:for(;r<s&&se(te);)r++,te=t.charCodeAt(r);if(m!==r){switch(o=t.substring(m,r),o){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return o+=String.fromCharCode(te),r++,S=16}}function se(te){if(n(te)||f(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let te;do te=ne();while(te>=12&&te<=15);return te}return{setPosition:T,getPosition:()=>r,scan:l?K:ne,getToken:()=>S,getTokenValue:()=>o,getTokenOffset:()=>m,getTokenLength:()=>r-m,getTokenError:()=>D}}e.createScanner=E;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,l){const r=[],s=new Object;let o;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function D(R,T,_,G){m.value=R,m.offset=T,m.length=_,m.type=G,m.colonOffset=void 0,o=m}try{h(t,{onObjectBegin:(R,T)=>{if(l<=R)throw s;o=void 0,S=l>R,r.push("")},onObjectProperty:(R,T,_)=>{if(l<T||(D(R,T,_,"property"),r[r.length-1]=R,l<=T+_))throw s},onObjectEnd:(R,T)=>{if(l<=R)throw s;o=void 0,r.pop()},onArrayBegin:(R,T)=>{if(l<=R)throw s;o=void 0,r.push(0)},onArrayEnd:(R,T)=>{if(l<=R)throw s;o=void 0,r.pop()},onLiteralValue:(R,T,_)=>{if(l<T||(D(R,T,_,u(R)),l<=T+_))throw s},onSeparator:(R,T,_)=>{if(l<=T)throw s;if(R===":"&&o&&o.type==="property")o.colonOffset=T,S=!1,o=void 0;else if(R===","){const G=r[r.length-1];typeof G=="number"?r[r.length-1]=G+1:(S=!0,r[r.length-1]=""),o=void 0}}})}catch(R){if(R!==s)throw R}return{path:r,previousNode:o,isAtPropertyKey:S,matches:R=>{let T=0;for(let _=0;T<R.length&&_<r.length;_++)if(R[T]===r[_]||R[T]==="*")T++;else if(R[T]!=="**")return!1;return T===R.length}}}e.getLocation=I;function P(t,l=[],r=M.DEFAULT){let s=null,o=[];const m=[];function S(R){Array.isArray(o)?o.push(R):s!==null&&(o[s]=R)}return h(t,{onObjectBegin:()=>{const R={};S(R),m.push(o),o=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{o=m.pop()},onArrayBegin:()=>{const R=[];S(R),m.push(o),o=R,s=null},onArrayEnd:()=>{o=m.pop()},onLiteralValue:S,onError:(R,T,_)=>{l.push({error:R,offset:T,length:_})}},r),o[0]}e.parse=P;function y(t,l=[],r=M.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(R){s.type==="property"&&(s.length=R-s.offset,s=s.parent)}function m(R){return s.children.push(R),R}h(t,{onObjectBegin:R=>{s=m({type:"object",offset:R,length:-1,parent:s,children:[]})},onObjectProperty:(R,T,_)=>{s=m({type:"property",offset:T,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:R,offset:T,length:_,parent:s})},onObjectEnd:(R,T)=>{s.length=R+T-s.offset,s=s.parent,o(R+T)},onArrayBegin:(R,T)=>{s=m({type:"array",offset:R,length:-1,parent:s,children:[]})},onArrayEnd:(R,T)=>{s.length=R+T-s.offset,s=s.parent,o(R+T)},onLiteralValue:(R,T,_)=>{m({type:u(R),offset:T,length:_,parent:s,value:R}),o(T+_)},onSeparator:(R,T,_)=>{s.type==="property"&&(R===":"?s.colonOffset=T:R===","&&o(T))},onError:(R,T,_)=>{l.push({error:R,offset:T,length:_})}},r);const D=s.children[0];return D&&delete D.parent,D}e.parseTree=y;function d(t,l){if(!t)return;let r=t;for(let s of l)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const m of r.children)if(Array.isArray(m.children)&&m.children[0].value===s){r=m.children[1],o=!0;break}if(!o)return}else{const o=s;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}e.findNodeAtLocation=d;function g(t){if(!t.parent||!t.parent.children)return[];const l=g(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;l.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&l.push(r)}return l}e.getNodePath=g;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":const l=Object.create(null);for(let r of t.children){const s=r.children[1];s&&(l[r.children[0].value]=b(s))}return l;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=b;function v(t,l,r=!1){return l>=t.offset&&l<t.offset+t.length||r&&l===t.offset+t.length}e.contains=v;function c(t,l,r=!1){if(v(t,l,r)){const s=t.children;if(Array.isArray(s))for(let o=0;o<s.length&&s[o].offset<=l;o++){const m=c(s[o],l,r);if(m)return m}return t}}e.findNodeAtOffset=c;function h(t,l,r=M.DEFAULT){const s=E(t,!1);function o(F){return F?()=>F(s.getTokenOffset(),s.getTokenLength()):()=>!0}function m(F){return F?B=>F(B,s.getTokenOffset(),s.getTokenLength()):()=>!0}const S=o(l.onObjectBegin),D=m(l.onObjectProperty),R=o(l.onObjectEnd),T=o(l.onArrayBegin),_=o(l.onArrayEnd),G=m(l.onLiteralValue),ne=m(l.onSeparator),se=o(l.onComment),K=m(l.onError),te=r&&r.disallowComments,W=r&&r.allowTrailingComma;function j(){for(;;){const F=s.scan();switch(s.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:te||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(F){case 12:case 13:te?H(10):se();break;case 16:H(1);break;case 15:case 14:break;default:return F}}}function H(F,B=[],Y=[]){if(K(F),B.length+Y.length>0){let C=s.getToken();for(;C!==17;){if(B.indexOf(C)!==-1){j();break}else if(Y.indexOf(C)!==-1)break;C=j()}}}function z(F){const B=s.getTokenValue();return F?G(B):D(B),j(),!0}function q(){switch(s.getToken()){case 11:let F=0;try{F=JSON.parse(s.getTokenValue()),typeof F!="number"&&(H(2),F=0)}catch(B){H(2)}G(F);break;case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return j(),!0}function O(){return s.getToken()!==10?(H(3,[],[2,5]),!1):(z(!1),s.getToken()===6?(ne(":"),j(),A()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function $(){S(),j();let F=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(F||H(4,[],[]),ne(","),j(),s.getToken()===2&&W)break}else F&&H(6,[],[]);O()||H(4,[],[2,5]),F=!0}return R(),s.getToken()!==2?H(7,[2],[]):j(),!0}function U(){T(),j();let F=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(F||H(4,[],[]),ne(","),j(),s.getToken()===4&&W)break}else F&&H(6,[],[]);A()||H(4,[],[4,5]),F=!0}return _(),s.getToken()!==4?H(8,[4],[]):j(),!0}function A(){switch(s.getToken()){case 3:return U();case 1:return $();case 10:return z(!0);default:return q()}}return j(),s.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):A()?(s.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=h;function a(t,l){let r=E(t),s=[],o,m=0,S;do switch(S=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:m!==S&&s.push(t.substring(m,S)),l!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,l)),m=r.getPosition();break}while(o!==17);return s.join("")}e.stripComments=a;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(Z[104],x([0,1,40]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(f,w,i){let I,P,y,d,g;if(w){for(d=w.offset,g=d+w.length,y=d;y>0&&!n(f,y-1);)y--;let m=g;for(;m<f.length&&!n(f,m);)m++;P=f.substring(y,m),I=M(P,i)}else P=f,I=0,y=0,d=0,g=f.length;const b=E(i,f);let v=!1,c=0,h;i.insertSpaces?h=k(" ",i.tabSize||4):h="	";const a=(0,p.createScanner)(P,!1);let u=!1;function t(){return b+k(h,I+c)}function l(){let m=a.scan();for(v=!1;m===15||m===14;)v=v||m===14,m=a.scan();return u=m===16||a.getTokenError()!==0,m}const r=[];function s(m,S,D){!u&&S<g&&D>d&&f.substring(S,D)!==m&&r.push({offset:S,length:D-S,content:m})}let o=l();if(o!==17){const m=a.getTokenOffset()+y,S=k(h,I);s(S,y,m)}for(;o!==17;){let m=a.getTokenOffset()+a.getTokenLength()+y,S=l(),D="";for(;!v&&(S===12||S===13);){const T=a.getTokenOffset()+y;s(" ",m,T),m=a.getTokenOffset()+a.getTokenLength()+y,D=S===12?t():"",S=l()}if(S===2)o!==1&&(c--,D=t());else if(S===4)o!==3&&(c--,D=t());else{switch(o){case 3:case 1:c++,D=t();break;case 5:case 12:D=t();break;case 13:v?D=t():D=" ";break;case 6:D=" ";break;case 10:if(S===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?D=" ":S!==5&&S!==17&&(u=!0);break;case 16:u=!0;break}v&&(S===12||S===13)&&(D=t())}const R=a.getTokenOffset()+y;s(D,m,R),o=S}return r}e.format=L;function k(f,w){let i="";for(let I=0;I<w;I++)i+=f;return i}function M(f,w){let i=0,I=0;const P=w.tabSize||4;for(;i<f.length;){const y=f.charAt(i);if(y===" ")I++;else if(y==="	")I+=P;else break;i++}return Math.floor(I/P)}function E(f,w){for(let i=0;i<w.length;i++){const I=w.charAt(i);if(I==="\r")return i+1<w.length&&w.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=E;function n(f,w){return`\r
`.indexOf(f.charAt(w))!==-1}e.isEOL=n}),define(Z[77],x([0,1,40,104]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(w,i,I){return M(w,i,void 0,I)}e.removeProperty=k;function M(w,i,I,P,y){const d=i.slice(),g=[],b=(0,p.parseTree)(w,g);let v,c;for(;d.length>0&&(c=d.pop(),v=(0,p.findNodeAtLocation)(b,d),v===void 0&&I!==void 0);)typeof c=="string"?I={[c]:I}:I=[I];if(v)if(v.type==="object"&&typeof c=="string"&&Array.isArray(v.children)){const h=(0,p.findNodeAtLocation)(v,[c]);if(h!==void 0)if(I===void 0){if(!h.parent)throw new Error("Malformed AST");const a=v.children.indexOf(h.parent);let u,t=h.parent.offset+h.parent.length;if(a>0){const l=v.children[a-1];u=l.offset+l.length}else u=v.offset+1,v.children.length>1&&(t=v.children[1].offset);return E(w,{offset:u,length:t-u,content:""},P)}else return E(w,{offset:h.offset,length:h.length,content:JSON.stringify(I)},P);else{if(I===void 0)return[];const a=`${JSON.stringify(c)}: ${JSON.stringify(I)}`,u=y?y(v.children.map(l=>l.children[0].value)):v.children.length;let t;if(u>0){const l=v.children[u-1];t={offset:l.offset+l.length,length:0,content:","+a}}else v.children.length===0?t={offset:v.offset+1,length:0,content:a}:t={offset:v.offset+1,length:0,content:a+","};return E(w,t,P)}}else if(v.type==="array"&&typeof c=="number"&&Array.isArray(v.children))if(I!==void 0){const h=`${JSON.stringify(I)}`;let a;if(v.children.length===0||c===0)a={offset:v.offset+1,length:0,content:v.children.length===0?h:h+","};else{const u=c===-1||c>v.children.length?v.children.length:c,t=v.children[u-1];a={offset:t.offset+t.length,length:0,content:","+h}}return E(w,a,P)}else{const h=c,a=v.children[h];let u;if(v.children.length===1)u={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===h){const t=v.children[h-1],l=t.offset+t.length,r=v.offset+v.length;u={offset:l,length:r-2-l,content:""}}else u={offset:a.offset,length:v.children[h+1].offset-a.offset,content:""};return E(w,u,P)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${v.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return E(w,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(I)},P)}}e.setProperty=M;function E(w,i,I){let P=n(w,i),y=i.offset,d=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;y>0&&!(0,L.isEOL)(P,y-1);)y--;for(;d<P.length&&!(0,L.isEOL)(P,d);)d++}const g=(0,L.format)(P,{offset:y,length:d-y},I);for(let v=g.length-1;v>=0;v--){const c=g[v];P=n(P,c),y=Math.min(y,c.offset),d=Math.max(d,c.offset+c.length),d+=c.content.length-c.length}const b=w.length-(P.length-d)-y;return[{offset:y,length:b,content:P.substring(y,d)}]}e.withFormatting=E;function n(w,i){return w.substring(0,i.offset)+i.content+w.substring(i.offset+i.length)}e.applyEdit=n;function f(w,i){let I=i.slice(0).sort((y,d)=>{const g=y.offset-d.offset;return g===0?y.length-d.length:g}),P=w.length;for(let y=I.length-1;y>=0;y--){let d=I[y];if(d.offset+d.length<=P)w=n(w,d);else throw new Error("Overlapping edit");P=d.offset}return w}e.applyEdits=f}),define(Z[57],x([0,1,17]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var L;(function(c){c[c.DependsOnKbLayout=-1]="DependsOnKbLayout",c[c.Unknown=0]="Unknown",c[c.Backspace=1]="Backspace",c[c.Tab=2]="Tab",c[c.Enter=3]="Enter",c[c.Shift=4]="Shift",c[c.Ctrl=5]="Ctrl",c[c.Alt=6]="Alt",c[c.PauseBreak=7]="PauseBreak",c[c.CapsLock=8]="CapsLock",c[c.Escape=9]="Escape",c[c.Space=10]="Space",c[c.PageUp=11]="PageUp",c[c.PageDown=12]="PageDown",c[c.End=13]="End",c[c.Home=14]="Home",c[c.LeftArrow=15]="LeftArrow",c[c.UpArrow=16]="UpArrow",c[c.RightArrow=17]="RightArrow",c[c.DownArrow=18]="DownArrow",c[c.Insert=19]="Insert",c[c.Delete=20]="Delete",c[c.KEY_0=21]="KEY_0",c[c.KEY_1=22]="KEY_1",c[c.KEY_2=23]="KEY_2",c[c.KEY_3=24]="KEY_3",c[c.KEY_4=25]="KEY_4",c[c.KEY_5=26]="KEY_5",c[c.KEY_6=27]="KEY_6",c[c.KEY_7=28]="KEY_7",c[c.KEY_8=29]="KEY_8",c[c.KEY_9=30]="KEY_9",c[c.KEY_A=31]="KEY_A",c[c.KEY_B=32]="KEY_B",c[c.KEY_C=33]="KEY_C",c[c.KEY_D=34]="KEY_D",c[c.KEY_E=35]="KEY_E",c[c.KEY_F=36]="KEY_F",c[c.KEY_G=37]="KEY_G",c[c.KEY_H=38]="KEY_H",c[c.KEY_I=39]="KEY_I",c[c.KEY_J=40]="KEY_J",c[c.KEY_K=41]="KEY_K",c[c.KEY_L=42]="KEY_L",c[c.KEY_M=43]="KEY_M",c[c.KEY_N=44]="KEY_N",c[c.KEY_O=45]="KEY_O",c[c.KEY_P=46]="KEY_P",c[c.KEY_Q=47]="KEY_Q",c[c.KEY_R=48]="KEY_R",c[c.KEY_S=49]="KEY_S",c[c.KEY_T=50]="KEY_T",c[c.KEY_U=51]="KEY_U",c[c.KEY_V=52]="KEY_V",c[c.KEY_W=53]="KEY_W",c[c.KEY_X=54]="KEY_X",c[c.KEY_Y=55]="KEY_Y",c[c.KEY_Z=56]="KEY_Z",c[c.Meta=57]="Meta",c[c.ContextMenu=58]="ContextMenu",c[c.F1=59]="F1",c[c.F2=60]="F2",c[c.F3=61]="F3",c[c.F4=62]="F4",c[c.F5=63]="F5",c[c.F6=64]="F6",c[c.F7=65]="F7",c[c.F8=66]="F8",c[c.F9=67]="F9",c[c.F10=68]="F10",c[c.F11=69]="F11",c[c.F12=70]="F12",c[c.F13=71]="F13",c[c.F14=72]="F14",c[c.F15=73]="F15",c[c.F16=74]="F16",c[c.F17=75]="F17",c[c.F18=76]="F18",c[c.F19=77]="F19",c[c.NumLock=78]="NumLock",c[c.ScrollLock=79]="ScrollLock",c[c.US_SEMICOLON=80]="US_SEMICOLON",c[c.US_EQUAL=81]="US_EQUAL",c[c.US_COMMA=82]="US_COMMA",c[c.US_MINUS=83]="US_MINUS",c[c.US_DOT=84]="US_DOT",c[c.US_SLASH=85]="US_SLASH",c[c.US_BACKTICK=86]="US_BACKTICK",c[c.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",c[c.US_BACKSLASH=88]="US_BACKSLASH",c[c.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",c[c.US_QUOTE=90]="US_QUOTE",c[c.OEM_8=91]="OEM_8",c[c.OEM_102=92]="OEM_102",c[c.NUMPAD_0=93]="NUMPAD_0",c[c.NUMPAD_1=94]="NUMPAD_1",c[c.NUMPAD_2=95]="NUMPAD_2",c[c.NUMPAD_3=96]="NUMPAD_3",c[c.NUMPAD_4=97]="NUMPAD_4",c[c.NUMPAD_5=98]="NUMPAD_5",c[c.NUMPAD_6=99]="NUMPAD_6",c[c.NUMPAD_7=100]="NUMPAD_7",c[c.NUMPAD_8=101]="NUMPAD_8",c[c.NUMPAD_9=102]="NUMPAD_9",c[c.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",c[c.NUMPAD_ADD=104]="NUMPAD_ADD",c[c.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",c[c.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",c[c.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",c[c.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",c[c.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",c[c.ABNT_C1=110]="ABNT_C1",c[c.ABNT_C2=111]="ABNT_C2",c[c.MAX_VALUE=112]="MAX_VALUE"})(L=e.KeyCode||(e.KeyCode={}));class k{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,a){this._keyCodeToStr[h]=a,this._strToKeyCode[a.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const M=new k,E=new k,n=new k;(function(){function c(h,a,u=a,t=u){M.define(h,a),E.define(h,u),n.define(h,t)}c(0,"unknown"),c(1,"Backspace"),c(2,"Tab"),c(3,"Enter"),c(4,"Shift"),c(5,"Ctrl"),c(6,"Alt"),c(7,"PauseBreak"),c(8,"CapsLock"),c(9,"Escape"),c(10,"Space"),c(11,"PageUp"),c(12,"PageDown"),c(13,"End"),c(14,"Home"),c(15,"LeftArrow","Left"),c(16,"UpArrow","Up"),c(17,"RightArrow","Right"),c(18,"DownArrow","Down"),c(19,"Insert"),c(20,"Delete"),c(21,"0"),c(22,"1"),c(23,"2"),c(24,"3"),c(25,"4"),c(26,"5"),c(27,"6"),c(28,"7"),c(29,"8"),c(30,"9"),c(31,"A"),c(32,"B"),c(33,"C"),c(34,"D"),c(35,"E"),c(36,"F"),c(37,"G"),c(38,"H"),c(39,"I"),c(40,"J"),c(41,"K"),c(42,"L"),c(43,"M"),c(44,"N"),c(45,"O"),c(46,"P"),c(47,"Q"),c(48,"R"),c(49,"S"),c(50,"T"),c(51,"U"),c(52,"V"),c(53,"W"),c(54,"X"),c(55,"Y"),c(56,"Z"),c(57,"Meta"),c(58,"ContextMenu"),c(59,"F1"),c(60,"F2"),c(61,"F3"),c(62,"F4"),c(63,"F5"),c(64,"F6"),c(65,"F7"),c(66,"F8"),c(67,"F9"),c(68,"F10"),c(69,"F11"),c(70,"F12"),c(71,"F13"),c(72,"F14"),c(73,"F15"),c(74,"F16"),c(75,"F17"),c(76,"F18"),c(77,"F19"),c(78,"NumLock"),c(79,"ScrollLock"),c(80,";",";","OEM_1"),c(81,"=","=","OEM_PLUS"),c(82,",",",","OEM_COMMA"),c(83,"-","-","OEM_MINUS"),c(84,".",".","OEM_PERIOD"),c(85,"/","/","OEM_2"),c(86,"`","`","OEM_3"),c(110,"ABNT_C1"),c(111,"ABNT_C2"),c(87,"[","[","OEM_4"),c(88,"\\","\\","OEM_5"),c(89,"]","]","OEM_6"),c(90,"'","'","OEM_7"),c(91,"OEM_8"),c(92,"OEM_102"),c(93,"NumPad0"),c(94,"NumPad1"),c(95,"NumPad2"),c(96,"NumPad3"),c(97,"NumPad4"),c(98,"NumPad5"),c(99,"NumPad6"),c(100,"NumPad7"),c(101,"NumPad8"),c(102,"NumPad9"),c(103,"NumPad_Multiply"),c(104,"NumPad_Add"),c(105,"NumPad_Separator"),c(106,"NumPad_Subtract"),c(107,"NumPad_Decimal"),c(108,"NumPad_Divide")})();var f;(function(c){function h(r){return M.keyCodeToStr(r)}c.toString=h;function a(r){return M.strToKeyCode(r)}c.fromString=a;function u(r){return E.keyCodeToStr(r)}c.toUserSettingsUS=u;function t(r){return n.keyCodeToStr(r)}c.toUserSettingsGeneral=t;function l(r){return E.strToKeyCode(r)||n.strToKeyCode(r)}c.fromUserSettings=l})(f=e.KeyCodeUtils||(e.KeyCodeUtils={}));var w;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl",c[c.KeyCode=255]="KeyCode"})(w||(w={}));var i;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl"})(i=e.KeyMod||(e.KeyMod={}));function I(c,h){const a=(h&65535)<<16>>>0;return(c|a)>>>0}e.KeyChord=I;function P(c,h){if(c===0)return null;const a=(c&65535)>>>0,u=(c&4294901760)>>>16;return u!==0?new g([y(a,h),y(u,h)]):new g([y(a,h)])}e.createKeybinding=P;function y(c,h){const a=!!(c&2048),u=!!(c&256),t=h===2?u:a,l=!!(c&1024),r=!!(c&512),s=h===2?a:u,o=c&255;return new d(t,l,r,s,o)}e.createSimpleKeybinding=y;class d{constructor(h,a,u,t,l){this.ctrlKey=h,this.shiftKey=a,this.altKey=u,this.metaKey=t,this.keyCode=l}equals(h){return this.ctrlKey===h.ctrlKey&&this.shiftKey===h.shiftKey&&this.altKey===h.altKey&&this.metaKey===h.metaKey&&this.keyCode===h.keyCode}getHashCode(){const h=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",u=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${h}${a}${u}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class g{constructor(h){if(h.length===0)throw(0,p.illegalArgument)("parts");this.parts=h}getHashCode(){let h="";for(let a=0,u=this.parts.length;a<u;a++)a!==0&&(h+=";"),h+=this.parts[a].getHashCode();return h}equals(h){if(h===null||this.parts.length!==h.parts.length)return!1;for(let a=0;a<this.parts.length;a++)if(!this.parts[a].equals(h.parts[a]))return!1;return!0}}e.ChordKeybinding=g;class b{constructor(h,a,u,t,l,r){this.ctrlKey=h,this.shiftKey=a,this.altKey=u,this.metaKey=t,this.keyLabel=l,this.keyAriaLabel=r}}e.ResolvedKeybindingPart=b;class v{}e.ResolvedKeybinding=v}),define(Z[2],x([0,1,43,65]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let M=null;function E(s){M=s}if(e.setDisposableTracker=E,k){const s="__is_disposable_tracked__";E(new class{trackDisposable(o){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[s]||console.log(m)},3e3)}setParent(o,m){if(o&&o!==c.None)try{o[s]=!0}catch{}}markAsDisposed(o){if(o&&o!==c.None)try{o[s]=!0}catch{}}markAsSingleton(o){}})}function n(s){return M?.trackDisposable(s),s}function f(s){M?.markAsDisposed(s)}function w(s,o){M?.setParent(s,o)}function i(s,o){if(!!M)for(const m of s)M.setParent(m,o)}function I(s){return M?.markAsSingleton(s),s}e.markAsSingleton=I;class P extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=P;function y(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=y;function d(s){if(L.Iterable.is(s)){let o=[];for(const m of s)if(m)try{m.dispose()}catch(S){o.push(S)}if(o.length===1)throw o[0];if(o.length>1)throw new P(o);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=d;function g(...s){const o=b(()=>d(s));return i(s,o),o}e.combinedDisposable=g;function b(s){const o=n({dispose:(0,p.once)(()=>{f(o),s()})});return o}e.toDisposable=b;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,n(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return w(o,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class c{constructor(){this._store=new v,n(this),w(this._store,this)}dispose(){f(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=c,c.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,n(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&w(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&w(o,null),o}}e.MutableDisposable=h;class a{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class u{constructor(){this.references=new Map}acquire(o,...m){let S=this.references.get(o);S||(S={counter:0,object:this.createReferencedObject(o,...m)},this.references.set(o,S));const{object:D}=S,R=(0,p.once)(()=>{--S.counter==0&&(this.destroyReferencedObject(o,S.object),this.references.delete(o))});return S.counter++,{object:D,dispose:R}}}e.ReferenceCollection=u;class t{constructor(o){this.referenceCollection=o}async acquire(o,...m){const S=this.referenceCollection.acquire(o,...m);try{return{object:await S.object,dispose:()=>S.dispose()}}catch(D){throw S.dispose(),D}}}e.AsyncReferenceCollection=t;class l{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=l;function r(s){const o=new v;try{s(o)}finally{o.dispose()}}e.disposeOnReturn=r}),define(Z[105],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(M){this.element=M,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class L{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let M=this._first;for(;M!==p.Undefined;){const E=M.next;M.prev=p.Undefined,M.next=p.Undefined,M=E}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,E){const n=new p(M);if(this._first===p.Undefined)this._first=n,this._last=n;else if(E){const w=this._last;this._last=n,n.prev=w,w.next=n}else{const w=this._first;this._first=n,n.next=w,w.prev=n}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(n))}}shift(){if(this._first!==p.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==p.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==p.Undefined&&M.next!==p.Undefined){const E=M.prev;E.next=M.next,M.next.prev=E}else M.prev===p.Undefined&&M.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):M.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):M.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==p.Undefined;)yield M.element,M=M.next}}e.LinkedList=L}),function(){function V(k){const M=[];typeof k=="number"&&M.push("code/timeOrigin",k);function E(f){M.push(f,Date.now())}function n(){const f=[];for(let w=0;w<M.length;w+=2)f.push({name:M[w],startTime:M[w+1]});return f}return{mark:E,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const E of performance.getEntriesByType("mark"))M.push({name:E.name,startTime:Math.round(k+E.startTime)});return M}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function p(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=p(L))}(),define(Z[3],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const p="en";let L=!1,k=!1,M=!1,E=!1,n=!1,f=!1,w=!1,i,I=p,P,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const g=typeof d?.versions?.electron=="string"&&d.type==="renderer";if(e.isElectronSandboxed=g&&d?.sandboxed,typeof navigator=="object"&&!g)y=navigator.userAgent,L=y.indexOf("Windows")>=0,k=y.indexOf("Macintosh")>=0,w=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=y.indexOf("Linux")>=0,f=!0,i=navigator.language,I=i;else if(typeof d=="object"){L=d.platform==="win32",k=d.platform==="darwin",M=d.platform==="linux",E=M&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,i=p,I=p;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const s=JSON.parse(r),o=s.availableLanguages["*"];i=s.locale,I=o||p,P=s._translationsConfigFile}catch(s){}n=!0}else console.error("Unable to resolve platform.");var b;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function v(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=v;let c=0;k?c=1:L?c=3:M&&(c=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=M,e.isLinuxSnap=E,e.isNative=n,e.isWeb=f,e.isIOS=w,e.platform=c,e.userAgent=y,e.language=I;var h;(function(r){function s(){return e.language}r.value=s;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=o;function m(){return e.language==="en"}r.isDefault=m})(h=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=P,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let D=0,R=o.length;D<R;D++){const T=o[D];if(T.id===S.data.vscodeSetImmediateId){o.splice(D,1),T.callback();return}}});let m=0;return S=>{const D=++m;o.push({id:D,callback:S}),e.globals.postMessage({vscodeSetImmediateId:D},"*")}}if(typeof d?.nextTick=="function")return d.nextTick.bind(d);const s=Promise.resolve();return o=>s.then(o)}();var a;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||w?2:L?1:3;let u=!0,t=!1;function l(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,u=new Uint16Array(r.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=l}),define(Z[33],x([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const k=p.globals.vscode.process;L={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()},nextTick(M){return(0,p.setImmediate)(M)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},nextTick(k){return(0,p.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(Z[8],x([0,1,33]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,M=90,E=122,n=46,f=47,w=92,i=58,I=63;class P extends Error{constructor(a,u,t){let l;typeof u=="string"&&u.indexOf("not ")===0?(l="must not be",u=u.replace(/^not /,"")):l="must be";const r=a.indexOf(".")!==-1?"property":"argument";let s=`The "${a}" ${r} ${l} of type ${u}`;s+=`. Received type ${typeof t}`;super(s);this.code="ERR_INVALID_ARG_TYPE"}}function y(h,a){if(typeof h!="string")throw new P(a,"string",h)}function d(h){return h===f||h===w}function g(h){return h===f}function b(h){return h>=L&&h<=M||h>=k&&h<=E}function v(h,a,u,t){let l="",r=0,s=-1,o=0,m=0;for(let S=0;S<=h.length;++S){if(S<h.length)m=h.charCodeAt(S);else{if(t(m))break;m=f}if(t(m)){if(!(s===S-1||o===1))if(o===2){if(l.length<2||r!==2||l.charCodeAt(l.length-1)!==n||l.charCodeAt(l.length-2)!==n){if(l.length>2){const D=l.lastIndexOf(u);D===-1?(l="",r=0):(l=l.slice(0,D),r=l.length-1-l.lastIndexOf(u)),s=S,o=0;continue}else if(l.length!==0){l="",r=0,s=S,o=0;continue}}a&&(l+=l.length>0?`${u}..`:"..",r=2)}else l.length>0?l+=`${u}${h.slice(s+1,S)}`:l=h.slice(s+1,S),r=S-s-1;s=S,o=0}else m===n&&o!==-1?++o:o=-1}return l}function c(h,a){if(a===null||typeof a!="object")throw new P("pathObject","Object",a);const u=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return u?u===a.root?`${u}${t}`:`${u}${h}${t}`:t}e.win32={resolve(...h){let a="",u="",t=!1;for(let l=h.length-1;l>=-1;l--){let r;if(l>=0){if(r=h[l],y(r,"path"),r.length===0)continue}else a.length===0?r=p.cwd():(r=p.env[`=${a}`]||p.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===w)&&(r=`${a}\\`));const s=r.length;let o=0,m="",S=!1;const D=r.charCodeAt(0);if(s===1)d(D)&&(o=1,S=!0);else if(d(D))if(S=!0,d(r.charCodeAt(1))){let R=2,T=R;for(;R<s&&!d(r.charCodeAt(R));)R++;if(R<s&&R!==T){const _=r.slice(T,R);for(T=R;R<s&&d(r.charCodeAt(R));)R++;if(R<s&&R!==T){for(T=R;R<s&&!d(r.charCodeAt(R));)R++;(R===s||R!==T)&&(m=`\\\\${_}\\${r.slice(T,R)}`,o=R)}}}else o=1;else b(D)&&r.charCodeAt(1)===i&&(m=r.slice(0,2),o=2,s>2&&d(r.charCodeAt(2))&&(S=!0,o=3));if(m.length>0)if(a.length>0){if(m.toLowerCase()!==a.toLowerCase())continue}else a=m;if(t){if(a.length>0)break}else if(u=`${r.slice(o)}\\${u}`,t=S,S&&a.length>0)break}return u=v(u,!t,"\\",d),t?`${a}\\${u}`:`${a}${u}`||"."},normalize(h){y(h,"path");const a=h.length;if(a===0)return".";let u=0,t,l=!1;const r=h.charCodeAt(0);if(a===1)return g(r)?"\\":h;if(d(r))if(l=!0,d(h.charCodeAt(1))){let o=2,m=o;for(;o<a&&!d(h.charCodeAt(o));)o++;if(o<a&&o!==m){const S=h.slice(m,o);for(m=o;o<a&&d(h.charCodeAt(o));)o++;if(o<a&&o!==m){for(m=o;o<a&&!d(h.charCodeAt(o));)o++;if(o===a)return`\\\\${S}\\${h.slice(m)}\\`;o!==m&&(t=`\\\\${S}\\${h.slice(m,o)}`,u=o)}}}else u=1;else b(r)&&h.charCodeAt(1)===i&&(t=h.slice(0,2),u=2,a>2&&d(h.charCodeAt(2))&&(l=!0,u=3));let s=u<a?v(h.slice(u),!l,"\\",d):"";return s.length===0&&!l&&(s="."),s.length>0&&d(h.charCodeAt(a-1))&&(s+="\\"),t===void 0?l?`\\${s}`:s:l?`${t}\\${s}`:`${t}${s}`},isAbsolute(h){y(h,"path");const a=h.length;if(a===0)return!1;const u=h.charCodeAt(0);return d(u)||a>2&&b(u)&&h.charCodeAt(1)===i&&d(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let a,u;for(let r=0;r<h.length;++r){const s=h[r];y(s,"path"),s.length>0&&(a===void 0?a=u=s:a+=`\\${s}`)}if(a===void 0)return".";let t=!0,l=0;if(typeof u=="string"&&d(u.charCodeAt(0))){++l;const r=u.length;r>1&&d(u.charCodeAt(1))&&(++l,r>2&&(d(u.charCodeAt(2))?++l:t=!1))}if(t){for(;l<a.length&&d(a.charCodeAt(l));)l++;l>=2&&(a=`\\${a.slice(l)}`)}return e.win32.normalize(a)},relative(h,a){if(y(h,"from"),y(a,"to"),h===a)return"";const u=e.win32.resolve(h),t=e.win32.resolve(a);if(u===t||(h=u.toLowerCase(),a=t.toLowerCase(),h===a))return"";let l=0;for(;l<h.length&&h.charCodeAt(l)===w;)l++;let r=h.length;for(;r-1>l&&h.charCodeAt(r-1)===w;)r--;const s=r-l;let o=0;for(;o<a.length&&a.charCodeAt(o)===w;)o++;let m=a.length;for(;m-1>o&&a.charCodeAt(m-1)===w;)m--;const S=m-o,D=s<S?s:S;let R=-1,T=0;for(;T<D;T++){const G=h.charCodeAt(l+T);if(G!==a.charCodeAt(o+T))break;G===w&&(R=T)}if(T!==D){if(R===-1)return t}else{if(S>D){if(a.charCodeAt(o+T)===w)return t.slice(o+T+1);if(T===2)return t.slice(o+T)}s>D&&(h.charCodeAt(l+T)===w?R=T:T===2&&(R=3)),R===-1&&(R=0)}let _="";for(T=l+R+1;T<=r;++T)(T===r||h.charCodeAt(T)===w)&&(_+=_.length===0?"..":"\\..");return o+=R,_.length>0?`${_}${t.slice(o,m)}`:(t.charCodeAt(o)===w&&++o,t.slice(o,m))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const a=e.win32.resolve(h);if(a.length<=2)return h;if(a.charCodeAt(0)===w){if(a.charCodeAt(1)===w){const u=a.charCodeAt(2);if(u!==I&&u!==n)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(b(a.charCodeAt(0))&&a.charCodeAt(1)===i&&a.charCodeAt(2)===w)return`\\\\?\\${a}`;return h},dirname(h){y(h,"path");const a=h.length;if(a===0)return".";let u=-1,t=0;const l=h.charCodeAt(0);if(a===1)return d(l)?h:".";if(d(l)){if(u=t=1,d(h.charCodeAt(1))){let o=2,m=o;for(;o<a&&!d(h.charCodeAt(o));)o++;if(o<a&&o!==m){for(m=o;o<a&&d(h.charCodeAt(o));)o++;if(o<a&&o!==m){for(m=o;o<a&&!d(h.charCodeAt(o));)o++;if(o===a)return h;o!==m&&(u=t=o+1)}}}}else b(l)&&h.charCodeAt(1)===i&&(u=a>2&&d(h.charCodeAt(2))?3:2,t=u);let r=-1,s=!0;for(let o=a-1;o>=t;--o)if(d(h.charCodeAt(o))){if(!s){r=o;break}}else s=!1;if(r===-1){if(u===-1)return".";r=u}return h.slice(0,r)},basename(h,a){a!==void 0&&y(a,"ext"),y(h,"path");let u=0,t=-1,l=!0,r;if(h.length>=2&&b(h.charCodeAt(0))&&h.charCodeAt(1)===i&&(u=2),a!==void 0&&a.length>0&&a.length<=h.length){if(a===h)return"";let s=a.length-1,o=-1;for(r=h.length-1;r>=u;--r){const m=h.charCodeAt(r);if(d(m)){if(!l){u=r+1;break}}else o===-1&&(l=!1,o=r+1),s>=0&&(m===a.charCodeAt(s)?--s==-1&&(t=r):(s=-1,t=o))}return u===t?t=o:t===-1&&(t=h.length),h.slice(u,t)}for(r=h.length-1;r>=u;--r)if(d(h.charCodeAt(r))){if(!l){u=r+1;break}}else t===-1&&(l=!1,t=r+1);return t===-1?"":h.slice(u,t)},extname(h){y(h,"path");let a=0,u=-1,t=0,l=-1,r=!0,s=0;h.length>=2&&h.charCodeAt(1)===i&&b(h.charCodeAt(0))&&(a=t=2);for(let o=h.length-1;o>=a;--o){const m=h.charCodeAt(o);if(d(m)){if(!r){t=o+1;break}continue}l===-1&&(r=!1,l=o+1),m===n?u===-1?u=o:s!==1&&(s=1):u!==-1&&(s=-1)}return u===-1||l===-1||s===0||s===1&&u===l-1&&u===t+1?"":h.slice(u,l)},format:c.bind(null,"\\"),parse(h){y(h,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return a;const u=h.length;let t=0,l=h.charCodeAt(0);if(u===1)return d(l)?(a.root=a.dir=h,a):(a.base=a.name=h,a);if(d(l)){if(t=1,d(h.charCodeAt(1))){let R=2,T=R;for(;R<u&&!d(h.charCodeAt(R));)R++;if(R<u&&R!==T){for(T=R;R<u&&d(h.charCodeAt(R));)R++;if(R<u&&R!==T){for(T=R;R<u&&!d(h.charCodeAt(R));)R++;R===u?t=R:R!==T&&(t=R+1)}}}}else if(b(l)&&h.charCodeAt(1)===i){if(u<=2)return a.root=a.dir=h,a;if(t=2,d(h.charCodeAt(2))){if(u===3)return a.root=a.dir=h,a;t=3}}t>0&&(a.root=h.slice(0,t));let r=-1,s=t,o=-1,m=!0,S=h.length-1,D=0;for(;S>=t;--S){if(l=h.charCodeAt(S),d(l)){if(!m){s=S+1;break}continue}o===-1&&(m=!1,o=S+1),l===n?r===-1?r=S:D!==1&&(D=1):r!==-1&&(D=-1)}return o!==-1&&(r===-1||D===0||D===1&&r===o-1&&r===s+1?a.base=a.name=h.slice(s,o):(a.name=h.slice(s,r),a.base=h.slice(s,o),a.ext=h.slice(r,o))),s>0&&s!==t?a.dir=h.slice(0,s-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let a="",u=!1;for(let t=h.length-1;t>=-1&&!u;t--){const l=t>=0?h[t]:p.cwd();y(l,"path"),l.length!==0&&(a=`${l}/${a}`,u=l.charCodeAt(0)===f)}return a=v(a,!u,"/",g),u?`/${a}`:a.length>0?a:"."},normalize(h){if(y(h,"path"),h.length===0)return".";const a=h.charCodeAt(0)===f,u=h.charCodeAt(h.length-1)===f;return h=v(h,!a,"/",g),h.length===0?a?"/":u?"./":".":(u&&(h+="/"),a?`/${h}`:h)},isAbsolute(h){return y(h,"path"),h.length>0&&h.charCodeAt(0)===f},join(...h){if(h.length===0)return".";let a;for(let u=0;u<h.length;++u){const t=h[u];y(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(h,a){if(y(h,"from"),y(a,"to"),h===a||(h=e.posix.resolve(h),a=e.posix.resolve(a),h===a))return"";const u=1,t=h.length,l=t-u,r=1,s=a.length-r,o=l<s?l:s;let m=-1,S=0;for(;S<o;S++){const R=h.charCodeAt(u+S);if(R!==a.charCodeAt(r+S))break;R===f&&(m=S)}if(S===o)if(s>o){if(a.charCodeAt(r+S)===f)return a.slice(r+S+1);if(S===0)return a.slice(r+S)}else l>o&&(h.charCodeAt(u+S)===f?m=S:S===0&&(m=0));let D="";for(S=u+m+1;S<=t;++S)(S===t||h.charCodeAt(S)===f)&&(D+=D.length===0?"..":"/..");return`${D}${a.slice(r+m)}`},toNamespacedPath(h){return h},dirname(h){if(y(h,"path"),h.length===0)return".";const a=h.charCodeAt(0)===f;let u=-1,t=!0;for(let l=h.length-1;l>=1;--l)if(h.charCodeAt(l)===f){if(!t){u=l;break}}else t=!1;return u===-1?a?"/":".":a&&u===1?"//":h.slice(0,u)},basename(h,a){a!==void 0&&y(a,"ext"),y(h,"path");let u=0,t=-1,l=!0,r;if(a!==void 0&&a.length>0&&a.length<=h.length){if(a===h)return"";let s=a.length-1,o=-1;for(r=h.length-1;r>=0;--r){const m=h.charCodeAt(r);if(m===f){if(!l){u=r+1;break}}else o===-1&&(l=!1,o=r+1),s>=0&&(m===a.charCodeAt(s)?--s==-1&&(t=r):(s=-1,t=o))}return u===t?t=o:t===-1&&(t=h.length),h.slice(u,t)}for(r=h.length-1;r>=0;--r)if(h.charCodeAt(r)===f){if(!l){u=r+1;break}}else t===-1&&(l=!1,t=r+1);return t===-1?"":h.slice(u,t)},extname(h){y(h,"path");let a=-1,u=0,t=-1,l=!0,r=0;for(let s=h.length-1;s>=0;--s){const o=h.charCodeAt(s);if(o===f){if(!l){u=s+1;break}continue}t===-1&&(l=!1,t=s+1),o===n?a===-1?a=s:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||t===-1||r===0||r===1&&a===t-1&&a===u+1?"":h.slice(a,t)},format:c.bind(null,"/"),parse(h){y(h,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return a;const u=h.charCodeAt(0)===f;let t;u?(a.root="/",t=1):t=0;let l=-1,r=0,s=-1,o=!0,m=h.length-1,S=0;for(;m>=t;--m){const D=h.charCodeAt(m);if(D===f){if(!o){r=m+1;break}continue}s===-1&&(o=!1,s=m+1),D===n?l===-1?l=m:S!==1&&(S=1):l!==-1&&(S=-1)}if(s!==-1){const D=r===0&&u?1:r;l===-1||S===0||S===1&&l===s-1&&l===r+1?a.base=a.name=h.slice(D,s):(a.name=h.slice(D,l),a.base=h.slice(D,s),a.ext=h.slice(l,s))}return r>0?a.dir=h.slice(0,r-1):u&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[78],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(M){M[M.stdout=0]="stdout",M[M.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var L;(function(M){M[M.Success=0]="Success",M[M.Unknown=1]="Unknown",M[M.AccessDenied=2]="AccessDenied",M[M.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(M,...E){const n=E.reduce((i,I)=>(i[I]=!0,i),{}),f=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(M).filter(i=>!n[i]).forEach(i=>{for(let I=0;I<f.length;I++)if(i.search(f[I])!==-1){delete M[i];break}})}e.sanitizeProcessEnvironment=k}),define(Z[79],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var p;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(p=e.ScanCode||(e.ScanCode={}));const L=[],k=Object.create(null),M=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>M[n]||0,toEnum:n=>k[n]||0,toString:n=>L[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class E{constructor(f,w,i,I,P){this.ctrlKey=f,this.shiftKey=w,this.altKey=i,this.metaKey=I,this.scanCode=P}equals(f){return this.ctrlKey===f.ctrlKey&&this.shiftKey===f.shiftKey&&this.altKey===f.altKey&&this.metaKey===f.metaKey&&this.scanCode===f.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=E,function(){function n(f,w){L[f]=w,k[w]=f,M[w.toLowerCase()]=f}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let f=0;f<=193;f++)e.IMMUTABLE_CODE_TO_KEY_CODE[f]=-1;for(let f=0;f<=112;f++)e.IMMUTABLE_KEY_CODE_TO_CODE[f]=-1;function n(f,w){e.IMMUTABLE_CODE_TO_KEY_CODE[f]=w,w!==0&&w!==3&&w!==5&&w!==4&&w!==6&&w!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[w]=f)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(Z[106],x([0,1,57,79]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class k{static _readModifiers(E){E=E.toLowerCase().trim();let n=!1,f=!1,w=!1,i=!1,I;do I=!1,/^ctrl(\+|\-)/.test(E)&&(n=!0,E=E.substr("ctrl-".length),I=!0),/^shift(\+|\-)/.test(E)&&(f=!0,E=E.substr("shift-".length),I=!0),/^alt(\+|\-)/.test(E)&&(w=!0,E=E.substr("alt-".length),I=!0),/^meta(\+|\-)/.test(E)&&(i=!0,E=E.substr("meta-".length),I=!0),/^win(\+|\-)/.test(E)&&(i=!0,E=E.substr("win-".length),I=!0),/^cmd(\+|\-)/.test(E)&&(i=!0,E=E.substr("cmd-".length),I=!0);while(I);let P;const y=E.indexOf(" ");return y>0?(P=E.substring(0,y),E=E.substring(y)):(P=E,E=""),{remains:E,ctrl:n,shift:f,alt:w,meta:i,key:P}}static parseSimpleKeybinding(E){const n=this._readModifiers(E),f=p.KeyCodeUtils.fromUserSettings(n.key);return[new p.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,f),n.remains]}static parseKeybinding(E,n){if(!E)return null;const f=[];let w;do[w,E]=this.parseSimpleKeybinding(E),f.push(w);while(E.length>0);return new p.ChordKeybinding(f)}static parseSimpleUserBinding(E){const n=this._readModifiers(E),f=n.key.match(/^\[([^\]]+)\]$/);if(f){const i=f[1],I=L.ScanCodeUtils.lowerCaseToEnum(i);return[new L.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,I),n.remains]}const w=p.KeyCodeUtils.fromUserSettings(n.key);return[new p.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,w),n.remains]}static parseUserBinding(E){if(!E)return[];const n=[];let f;for(;E.length>0;)[f,E]=this.parseSimpleUserBinding(E),n.push(f);return n}}e.KeybindingParser=k}),define(Z[107],x([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=p.globals.performance&&typeof p.globals.performance.now=="function";class k{constructor(E){this._highResolution=L&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new k(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=k}),define(Z[4],x([0,1,17,43,2,105,107]),function(V,e,p,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(a){a.None=()=>k.Disposable.None;function u(W){return(j,H=null,z)=>{let q=!1,O;return O=W($=>{if(!q)return O?O.dispose():q=!0,j.call(H,$)},null,z),q&&O.dispose(),O}}a.once=u;function t(W,j){return S((H,z=null,q)=>W(O=>H.call(z,j(O)),null,q))}a.map=t;function l(W,j){return S((H,z=null,q)=>W(O=>{j(O),H.call(z,O)},null,q))}a.forEach=l;function r(W,j){return S((H,z=null,q)=>W(O=>j(O)&&H.call(z,O),null,q))}a.filter=r;function s(W){return W}a.signal=s;function o(...W){return(j,H=null,z)=>(0,k.combinedDisposable)(...W.map(q=>q(O=>j.call(H,O),null,z)))}a.any=o;function m(W,j,H){let z=H;return t(W,q=>(z=j(z,q),z))}a.reduce=m;function S(W){let j;const H=new P({onFirstListenerAdd(){j=W(H.fire,H)},onLastListenerRemove(){j.dispose()}});return H.event}function D(W,j,H=100,z=!1,q){let O,$,U,A=0;const F=new P({leakWarningThreshold:q,onFirstListenerAdd(){O=W(B=>{A++,$=j($,B),z&&!U&&(F.fire($),$=void 0),clearTimeout(U),U=setTimeout(()=>{const Y=$;$=void 0,U=void 0,(!z||A>1)&&F.fire(Y),A=0},H)})},onLastListenerRemove(){O.dispose()}});return F.event}a.debounce=D;function R(W,j=(H,z)=>H===z){let H=!0,z;return r(W,q=>{const O=H||!j(q,z);return H=!1,z=q,O})}a.latch=R;function T(W,j){return[a.filter(W,j),a.filter(W,H=>!j(H))]}a.split=T;function _(W,j=!1,H=[]){let z=H.slice(),q=W(U=>{z?z.push(U):$.fire(U)});const O=()=>{z&&z.forEach(U=>$.fire(U)),z=null},$=new P({onFirstListenerAdd(){q||(q=W(U=>$.fire(U)))},onFirstListenerDidAdd(){z&&(j?setTimeout(O):O())},onLastListenerRemove(){q&&q.dispose(),q=null}});return $.event}a.buffer=_;class G{constructor(j){this.event=j}map(j){return new G(t(this.event,j))}forEach(j){return new G(l(this.event,j))}filter(j){return new G(r(this.event,j))}reduce(j,H){return new G(m(this.event,j,H))}latch(){return new G(R(this.event))}debounce(j,H=100,z=!1,q){return new G(D(this.event,j,H,z,q))}on(j,H,z){return this.event(j,H,z)}once(j,H,z){return u(this.event)(j,H,z)}}function ne(W){return new G(W)}a.chain=ne;function se(W,j,H=z=>z){const z=(...U)=>$.fire(H(...U)),q=()=>W.on(j,z),O=()=>W.removeListener(j,z),$=new P({onFirstListenerAdd:q,onLastListenerRemove:O});return $.event}a.fromNodeEventEmitter=se;function K(W,j,H=z=>z){const z=(...U)=>$.fire(H(...U)),q=()=>W.addEventListener(j,z),O=()=>W.removeEventListener(j,z),$=new P({onFirstListenerAdd:q,onLastListenerRemove:O});return $.event}a.fromDOMEventEmitter=K;function te(W){return new Promise(j=>u(W)(j))}a.toPromise=te})(n=e.Event||(e.Event={}));class f{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${f._idPool++}`}start(u){this._stopWatch=new E.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let w=-1;function i(a){const u=w;return w=a,{dispose(){w=u}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(u,t=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let t=w;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||u<t)return;this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(l)||0;if(this._stacks.set(l,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let s,o=0;for(const[m,S]of this._stacks)(!s||o<S)&&(s=m,o=S);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${o}):`),console.warn(s)}return()=>{const s=this._stacks.get(l)||0;this._stacks.set(l,s-1)}}}class P{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=w>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(u,t,l)=>{this._listeners||(this._listeners=new M.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(t?[u,t]:u);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,t);const o=this._leakageMon?.check(this._listeners.size),m=(0,k.toDisposable)(()=>{o&&o(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return l instanceof k.DisposableStore?l.add(m):Array.isArray(l)&&l.push(m),m}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new M.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,l]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,l):t[0].call(t[1],l)}catch(r){(0,p.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=P;class y extends P{async fireAsync(u,t,l){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,u]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[r,s]=this._asyncDeliveryQueue.shift(),o=[],m={...s,waitUntil:S=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");l&&(S=l(S,typeof r=="function"?r:r[0])),o.push(S)}};try{typeof r=="function"?r.call(void 0,m):r[0].call(r[1],m)}catch(S){(0,p.onUnexpectedError)(S);continue}Object.freeze(o),await Promise.allSettled(o).then(S=>{for(const D of S)D.status==="rejected"&&(0,p.onUnexpectedError)(D.reason)})}}}}e.AsyncEmitter=y;class d extends P{constructor(u){super(u);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=d;class g extends d{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=g;class b extends P{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=b;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new P({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const t={event:u,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const l=()=>{this.hasListeners&&this.unhook(t);const r=this.events.indexOf(t);this.events.splice(r,1)};return(0,k.toDisposable)((0,L.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(t=>this.emitter.fire(t))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=v;class c{constructor(){this.buffers=[]}wrapEvent(u){return(t,l,r)=>u(s=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>t.call(l,s)):t.call(l,s)},void 0,r)}bufferEvents(u){const t=[];this.buffers.push(t);const l=u();return this.buffers.pop(),t.forEach(r=>r()),l}}e.EventBufferer=c;class h{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=k.Disposable.None,this.emitter=new P({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=h}),define(Z[23],x([0,1,4]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(n,f){const w=setTimeout(n.bind(f),0);return{dispose(){clearTimeout(w)}}});var k;(function(n){function f(w){return w===n.None||w===n.Cancelled||w instanceof M?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}n.isCancellationToken=f,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=k.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=E}),define(Z[108],x([0,1,4]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(I){const P=this._icons.get(I.id);P?I.description?P.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function M(i,I){return new n(i,I)}e.registerCodicon=M;function E(i){return i?i.replace(/\$\((.*?)\)/g,(I,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=E;class n{constructor(I,P,y){this.id=I,this.definition=P,this.description=y,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function f(i,I){const P=["codicon","codicon-"+i];return I&&P.push("codicon-modifier-"+I),P}e.getClassNamesArray=f;var w;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function P(g){if(g instanceof n)return["codicon","codicon-"+g.id];const b=I.exec(g.id);if(!b)return P(n.error);let[,v,c]=b;const h=["codicon","codicon-"+v];return c&&h.push("codicon-modifier-"+c.substr(1)),h}i.asClassNameArray=P;function y(g){return P(g).join(" ")}i.asClassName=y;function d(g){return"."+P(g).join(".")}i.asCSSSelector=d})(w=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",{fontCharacter:"\\eb0f"}),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(Z[66],x([0,1,17,2]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(h){const a=h;return a?[a.on,a.pause,a.resume,a.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=k;function M(h){const a=h;return a?k(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=M;function E(h,a){return new n(h,a)}e.newWriteableStream=E;class n{constructor(a,u){this.reducer=a,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(u=>u(a))}emitError(a){this.listeners.error.length===0?(0,p.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(u=>u(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,u){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(a,u){if(this.state.destroyed)return;let t;switch(a){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const l=t.indexOf(u);l>=0&&t.splice(l,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(h,a){const u=[];let t;for(;(t=h.read())!==null;)u.push(t);return a(u)}e.consumeReadable=f;function w(h,a,u){const t=[];let l;for(;(l=h.read())!==null&&t.length<u;)t.push(l);return l===null&&t.length>0?a(t):{read:()=>{if(t.length>0)return t.shift();if(typeof l!="undefined"){const r=l;return l=void 0,r}return h.read()}}}e.peekReadable=w;function i(h,a){return new Promise((u,t)=>{const l=[];I(h,{onData:r=>{a&&l.push(r)},onError:r=>{a?t(r):u(void 0)},onEnd:()=>{u(a?a(l):void 0)}})})}e.consumeStream=i;function I(h,a){h.on("error",u=>a.onError(u)),h.on("end",()=>a.onEnd()),h.on("data",u=>a.onData(u))}e.listenStream=I;function P(h,a){return new Promise((u,t)=>{const l=new L.DisposableStore,r=[],s=S=>{if(r.push(S),r.length>a)return l.dispose(),h.pause(),u({stream:h,buffer:r,ended:!1})},o=S=>t(S),m=()=>u({stream:h,buffer:r,ended:!0});l.add((0,L.toDisposable)(()=>h.removeListener("error",o))),h.on("error",o),l.add((0,L.toDisposable)(()=>h.removeListener("end",m))),h.on("end",m),l.add((0,L.toDisposable)(()=>h.removeListener("data",s))),h.on("data",s)})}e.peekStream=P;function y(h,a){const u=E(a);return u.end(h),u}e.toStream=y;function d(){const h=E(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=d;function g(h){let a=!1;return{read:()=>a?null:(a=!0,h)}}e.toReadable=g;function b(h,a,u){const t=E(u);return I(h,{onData:l=>t.write(a.data(l)),onError:l=>t.error(a.error?a.error(l):l),onEnd:()=>t.end()}),t}e.transform=b;function v(h,a,u){let t=!1;return{read:()=>{const l=a.read();return t?l:(t=!0,l!==null?u([h,l]):h)}}}e.prefixedReadable=v;function c(h,a,u){let t=!1;const l=E(u);return I(a,{onData:r=>t?l.write(r):(t=!0,l.write(u([h,r]))),onError:r=>l.error(r),onEnd:()=>{t||(t=!0,l.write(h)),l.end()}}),l}e.prefixedStream=c}),define(Z[18],x([0,1,66]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let k,M;class E{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return L?new E(Buffer.allocUnsafe(s)):new E(new Uint8Array(s))}static wrap(s){return L&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new E(s)}static fromString(s,o){return!(o?.dontUseNodeBuffer||!1)&&L?new E(Buffer.from(s)):(k||(k=new TextEncoder),new E(k.encode(s)))}static concat(s,o){if(typeof o=="undefined"){o=0;for(let D=0,R=s.length;D<R;D++)o+=s[D].byteLength}const m=E.alloc(o);let S=0;for(let D=0,R=s.length;D<R;D++){const T=s[D];m.set(T,S),S+=T.byteLength}return m}toString(){return L?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(s,o){return new E(this.buffer.subarray(s,o))}set(s,o){s instanceof E?this.buffer.set(s.buffer,o):this.buffer.set(s,o)}readUInt32BE(s){return w(this.buffer,s)}writeUInt32BE(s,o){i(this.buffer,s,o)}readUInt32LE(s){return I(this.buffer,s)}writeUInt32LE(s,o){P(this.buffer,s,o)}readUInt8(s){return y(this.buffer,s)}writeUInt8(s,o){d(this.buffer,s,o)}}e.VSBuffer=E;function n(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0}e.readUInt16LE=n;function f(r,s,o){r[o+0]=s&255,s=s>>>8,r[o+1]=s&255}e.writeUInt16LE=f;function w(r,s){return r[s]*2**24+r[s+1]*2**16+r[s+2]*2**8+r[s+3]}e.readUInt32BE=w;function i(r,s,o){r[o+3]=s,s=s>>>8,r[o+2]=s,s=s>>>8,r[o+1]=s,s=s>>>8,r[o]=s}e.writeUInt32BE=i;function I(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0|r[s+2]<<16>>>0|r[s+3]<<24>>>0}e.readUInt32LE=I;function P(r,s,o){r[o+0]=s&255,s=s>>>8,r[o+1]=s&255,s=s>>>8,r[o+2]=s&255,s=s>>>8,r[o+3]=s&255}e.writeUInt32LE=P;function y(r,s){return r[s]}e.readUInt8=y;function d(r,s,o){r[o]=s}e.writeUInt8=d;function g(r){return p.consumeReadable(r,s=>E.concat(s))}e.readableToBuffer=g;function b(r){return p.toReadable(r)}e.bufferToReadable=b;function v(r){return p.consumeStream(r,s=>E.concat(s))}e.streamToBuffer=v;async function c(r){return r.ended?E.concat(r.buffer):E.concat([...r.buffer,await v(r.stream)])}e.bufferedStreamToBuffer=c;function h(r){return p.toStream(r,s=>E.concat(s))}e.bufferToStream=h;function a(r){return p.transform(r,{data:s=>typeof s=="string"?E.fromString(s):E.wrap(s)},s=>E.concat(s))}e.streamToBufferReadableStream=a;function u(r){return p.newWriteableStream(s=>E.concat(s),r)}e.newWriteableBufferStream=u;function t(r,s){return p.prefixedReadable(r,s,o=>E.concat(o))}e.prefixedBufferReadable=t;function l(r,s){return p.prefixedStream(r,s,o=>E.concat(o))}e.prefixedBufferStream=l}),define(Z[25],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function p(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=p;const L=/{(\d+)}/g;function k(X,...oe){return oe.length===0?X:X.replace(L,function(ce,me){const be=parseInt(me,10);return isNaN(be)||be<0||be>=oe.length?ce:oe[be]})}e.format=k;const M=/{([^}]+)}/g;function E(X,oe){return X.replace(M,(ce,me)=>oe[me]??ce)}e.format2=E;function n(X){return X.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=n;function f(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function w(X,oe){let ce=0;const me=oe.charCodeAt(0);for(let be=X.length-1;be>=0;be--)X.charCodeAt(be)===me&&ce++;return ce}e.count=w;function i(X,oe,ce="\u2026"){return X.length<=oe?X:`${X.substr(0,oe)}${ce}`}e.truncate=i;function I(X,oe=" "){const ce=P(X,oe);return y(ce,oe)}e.trim=I;function P(X,oe){if(!X||!oe)return X;const ce=oe.length;if(ce===0||X.length===0)return X;let me=0;for(;X.indexOf(oe,me)===me;)me=me+ce;return X.substring(me)}e.ltrim=P;function y(X,oe){if(!X||!oe)return X;const ce=oe.length,me=X.length;if(ce===0||me===0)return X;let be=me,ke=-1;for(;ke=X.lastIndexOf(oe,be-1),!(ke===-1||ke+ce!==be);){if(ke===0)return"";be=ke}return X.substring(0,be)}e.rtrim=y;function d(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function g(X){return X.replace(/\*/g,"")}e.stripWildcards=g;function b(X,oe,ce={}){if(!X)throw new Error("Cannot create regex from empty string");oe||(X=f(X)),ce.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let me="";return ce.global&&(me+="g"),ce.matchCase||(me+="i"),ce.multiline&&(me+="m"),ce.unicode&&(me+="u"),new RegExp(X,me)}e.createRegExp=b;function v(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function c(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function h(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=h;function a(X){return X.split(/\r\n|\r|\n/)}e.splitLines=a;function u(X){for(let oe=0,ce=X.length;oe<ce;oe++){const me=X.charCodeAt(oe);if(me!==32&&me!==9)return oe}return-1}e.firstNonWhitespaceIndex=u;function t(X,oe=0,ce=X.length){for(let me=oe;me<ce;me++){const be=X.charCodeAt(me);if(be!==32&&be!==9)return X.substring(oe,me)}return X.substring(oe,ce)}e.getLeadingWhitespace=t;function l(X,oe=X.length-1){for(let ce=oe;ce>=0;ce--){const me=X.charCodeAt(ce);if(me!==32&&me!==9)return ce}return-1}e.lastNonWhitespaceIndex=l;function r(X,oe){return X<oe?-1:X>oe?1:0}e.compare=r;function s(X,oe,ce=0,me=X.length,be=0,ke=oe.length){for(;ce<me&&be<ke;ce++,be++){let ze=X.charCodeAt(ce),Ue=oe.charCodeAt(be);if(ze<Ue)return-1;if(ze>Ue)return 1}const Fe=me-ce,_e=ke-be;return Fe<_e?-1:Fe>_e?1:0}e.compareSubstring=s;function o(X,oe){return m(X,oe,0,X.length,0,oe.length)}e.compareIgnoreCase=o;function m(X,oe,ce=0,me=X.length,be=0,ke=oe.length){for(;ce<me&&be<ke;ce++,be++){let ze=X.charCodeAt(ce),Ue=oe.charCodeAt(be);if(ze===Ue)continue;const qe=ze-Ue;if(!(qe===32&&D(Ue))&&!(qe===-32&&D(ze)))return S(ze)&&S(Ue)?qe:s(X.toLowerCase(),oe.toLowerCase(),ce,me,be,ke)}const Fe=me-ce,_e=ke-be;return Fe<_e?-1:Fe>_e?1:0}e.compareSubstringIgnoreCase=m;function S(X){return X>=97&&X<=122}e.isLowerAsciiLetter=S;function D(X){return X>=65&&X<=90}e.isUpperAsciiLetter=D;function R(X){return S(X)||D(X)}function T(X,oe){return X.length===oe.length&&_(X,oe)}e.equalsIgnoreCase=T;function _(X,oe,ce=X.length){for(let me=0;me<ce;me++){const be=X.charCodeAt(me),ke=oe.charCodeAt(me);if(be!==ke){if(R(be)&&R(ke)){const Fe=Math.abs(be-ke);if(Fe!==0&&Fe!==32)return!1}else if(String.fromCharCode(be).toLowerCase()!==String.fromCharCode(ke).toLowerCase())return!1}}return!0}function G(X,oe){const ce=oe.length;return oe.length>X.length?!1:_(X,oe,ce)}e.startsWithIgnoreCase=G;function ne(X,oe){let ce,me=Math.min(X.length,oe.length);for(ce=0;ce<me;ce++)if(X.charCodeAt(ce)!==oe.charCodeAt(ce))return ce;return me}e.commonPrefixLength=ne;function se(X,oe){let ce,me=Math.min(X.length,oe.length);const be=X.length-1,ke=oe.length-1;for(ce=0;ce<me;ce++)if(X.charCodeAt(be-ce)!==oe.charCodeAt(ke-ce))return ce;return me}e.commonSuffixLength=se;function K(X){return 55296<=X&&X<=56319}e.isHighSurrogate=K;function te(X){return 56320<=X&&X<=57343}e.isLowSurrogate=te;function W(X,oe){return(X-55296<<10)+(oe-56320)+65536}e.computeCodePoint=W;function j(X,oe,ce){const me=X.charCodeAt(ce);if(K(me)&&ce+1<oe){const be=X.charCodeAt(ce+1);if(te(be))return W(me,be)}return me}e.getNextCodePoint=j;function H(X,oe){const ce=X.charCodeAt(oe-1);if(te(ce)&&oe>1){const me=X.charCodeAt(oe-2);if(K(me))return W(me,ce)}return ce}function z(X,oe){const ce=Be.getInstance(),me=oe,be=X.length,ke=j(X,be,oe);oe+=ke>=65536?2:1;let Fe=ce.getGraphemeBreakType(ke);for(;oe<be;){const _e=j(X,be,oe),ze=ce.getGraphemeBreakType(_e);if(Ne(Fe,ze))break;oe+=_e>=65536?2:1,Fe=ze}return oe-me}e.nextCharLength=z;function q(X,oe){const ce=Be.getInstance(),me=oe,be=H(X,oe);oe-=be>=65536?2:1;let ke=ce.getGraphemeBreakType(be);for(;oe>0;){const Fe=H(X,oe),_e=ce.getGraphemeBreakType(Fe);if(Ne(_e,ke))break;oe-=Fe>=65536?2:1,ke=_e}return me-oe}e.prevCharLength=q;function O(X,oe){const ce=Be.getInstance(),me=X.length,be=oe,ke=j(X,me,oe),Fe=ce.getGraphemeBreakType(ke);oe+=ke>=65536?2:1;let _e=Fe;for(;oe<me;){const Ue=j(X,me,oe),qe=ce.getGraphemeBreakType(Ue);if(Ne(_e,qe))break;oe+=Ue>=65536?2:1,_e=qe}const ze=oe;for(oe=be,_e=Fe;oe>0;){const Ue=H(X,oe),qe=ce.getGraphemeBreakType(Ue);if(Ne(qe,_e))break;oe-=Ue>=65536?2:1,_e=qe}return[oe,ze]}function $(X,oe){return oe>0&&te(X.charCodeAt(oe))?O(X,oe-1):O(X,oe)}e.getCharContainingOffset=$;const U=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function A(X){return U.test(X)}e.containsRTL=A;const F=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function B(X){return F.test(X)}e.containsEmoji=B;const Y=/^[\t\n\r\x20-\x7E]*$/;function C(X){return Y.test(X)}e.isBasicASCII=C,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function N(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=N;function Q(X){for(let oe=0,ce=X.length;oe<ce;oe++)if(J(X.charCodeAt(oe)))return!0;return!1}e.containsFullWidthCharacter=Q;function J(X){return X=+X,X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=J;function re(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129003||X>=129280&&X<=129535||X>=129648&&X<=129750}e.isEmojiImprecise=re;function le(X,oe){if(X.length<oe)return X;const ce=/\b/g;let me=0;for(;ce.test(X)&&!(X.length-ce.lastIndex<oe);)me=ce.lastIndex,ce.lastIndex+=1;return X.substring(me).replace(/^\s/,"")}e.lcut=le;const ee=/\x1B\x5B[12]?K/g,ae=/\x1b\[\d+m/g,ue=/\x1b\[0?m/g;function de(X){return X&&(X=X.replace(ee,""),X=X.replace(ae,""),X=X.replace(ue,"")),X}e.removeAnsiEscapeCodes=de,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function pe(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=pe;function Ie(X){return pe(X)?X.substr(1):X}e.stripUTF8BOM=Ie;function we(X,oe){if(!X||!oe||X.length<oe.length)return!1;const ce=oe.length,me=X.toLowerCase();let be=0,ke=-1;for(;be<ce;){const Fe=me.indexOf(oe[be],ke+1);if(Fe<0)return!1;ke=Fe,be++}return!0}e.fuzzyContains=we;function ge(X,oe=!1){return X?(oe&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=ge;function Ee(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=Ee;function Me(X,oe=1){if(oe===0)return"";let ce=-1;do ce=X.indexOf(`
`,ce+1),oe--;while(oe>0&&ce>=0);return ce===-1?X:(X[ce-1]==="\r"&&ce--,X.substr(0,ce))}e.getNLines=Me;function Te(X){const oe=90-65+1;return X=X%(2*oe),X<oe?String.fromCharCode(97+X):String.fromCharCode(65+X-oe)}e.singleLetterHash=Te;function We(X){return Be.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=We;function Ne(X,oe){return X===0?oe!==5&&oe!==7:X===2&&oe===3?!1:X===4||X===2||X===3||oe===4||oe===2||oe===3?!0:!(X===8&&(oe===8||oe===9||oe===11||oe===12)||(X===11||X===9)&&(oe===9||oe===10)||(X===12||X===10)&&oe===10||oe===5||oe===13||oe===7||X===1||X===13&&oe===14||X===6&&oe===6)}e.breakBetweenGraphemeBreakType=Ne;var Xe;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(Xe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=ut()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const ce=this._data,me=ce.length/3;let be=1;for(;be<=me;)if(oe<ce[3*be])be=2*be;else if(oe>ce[3*be+1])be=2*be+1;else return ce[3*be+2];return 0}}Be._INSTANCE=null;function ut(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function st(X,oe){if(X===0)return 0;const ce=xe(X,oe);if(ce!==void 0)return ce;const me=H(oe,X);return X-=Ge(me),X}e.getLeftDeleteOffset=st;function xe(X,oe){let ce=H(oe,X);for(X-=Ge(ce);ht(ce)||ce===65039||ce===8419;){if(X===0)return;ce=H(oe,X),X-=Ge(ce)}if(!!re(ce)){if(X>=0){const me=H(oe,X);me===8205&&(X-=Ge(me))}return X}}function Ge(X){return X>=65536?2:1}function ht(X){return 127995<=X&&X<=127999}var ot;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(ot||(ot={}))}),define(Z[80],x([0,1,25]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(v){return k(v,0)}e.hash=L;function k(v,c){switch(typeof v){case"object":return v===null?M(349,c):Array.isArray(v)?f(v,c):w(v,c);case"string":return n(v,c);case"boolean":return E(v,c);case"number":return M(v,c);case"undefined":return M(937,c);default:return M(617,c)}}e.doHash=k;function M(v,c){return(c<<5)-c+v|0}e.numberHash=M;function E(v,c){return M(v?433:863,c)}function n(v,c){c=M(149417,c);for(let h=0,a=v.length;h<a;h++)c=M(v.charCodeAt(h),c);return c}e.stringHash=n;function f(v,c){return c=M(104579,c),v.reduce((h,a)=>k(a,h),c)}function w(v,c){return c=M(181387,c),Object.keys(v).sort().reduce((h,a)=>(h=n(a,h),k(v[a],h)),c)}class i{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=k(c,this._value),this._value}}e.Hasher=i;var I;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function P(v,c,h=32){const a=h-c,u=~((1<<a)-1);return(v<<c|(u&v)>>>a)>>>0}function y(v,c=0,h=v.byteLength,a=0){for(let u=0;u<h;u++)v[c+u]=a}function d(v,c,h="0"){for(;v.length<c;)v=h+v;return v}function g(v,c=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((v>>>0).toString(16),c/4)}e.toHexString=g;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const h=c.length;if(h===0)return;const a=this._buff;let u=this._buffLen,t=this._leftoverHighSurrogate,l,r;for(t!==0?(l=t,r=-1,t=0):(l=c.charCodeAt(0),r=0);;){let s=l;if(p.isHighSurrogate(l))if(r+1<h){const o=c.charCodeAt(r+1);p.isLowSurrogate(o)?(r++,s=p.computeCodePoint(l,o)):s=65533}else{t=l;break}else p.isLowSurrogate(l)&&(s=65533);if(u=this._push(a,u,s),r++,r<h)l=c.charCodeAt(r);else break}this._buffLen=u,this._leftoverHighSurrogate=t}_push(c,h,a){return a<128?c[h++]=a:a<2048?(c[h++]=192|(a&1984)>>>6,c[h++]=128|(a&63)>>>0):a<65536?(c[h++]=224|(a&61440)>>>12,c[h++]=128|(a&4032)>>>6,c[h++]=128|(a&63)>>>0):(c[h++]=240|(a&1835008)>>>18,c[h++]=128|(a&258048)>>>12,c[h++]=128|(a&4032)>>>6,c[h++]=128|(a&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=b._bigBlock32,h=this._buffDV;for(let S=0;S<64;S+=4)c.setUint32(S,h.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)c.setUint32(S,P(c.getUint32(S-12,!1)^c.getUint32(S-32,!1)^c.getUint32(S-56,!1)^c.getUint32(S-64,!1),1),!1);let a=this._h0,u=this._h1,t=this._h2,l=this._h3,r=this._h4,s,o,m;for(let S=0;S<80;S++)S<20?(s=u&t|~u&l,o=1518500249):S<40?(s=u^t^l,o=1859775393):S<60?(s=u&t|u&l|t&l,o=2400959708):(s=u^t^l,o=3395469782),m=P(a,5)+s+r+o+c.getUint32(S*4,!1)&4294967295,r=l,l=t,t=P(u,30),u=a,a=m;this._h0=this._h0+a&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[13],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(D){return Array.isArray(D)}e.isArray=p;function L(D){return typeof D=="string"}e.isString=L;function k(D){return Array.isArray(D)&&D.every(R=>L(R))}e.isStringArray=k;function M(D){return typeof D=="object"&&D!==null&&!Array.isArray(D)&&!(D instanceof RegExp)&&!(D instanceof Date)}e.isObject=M;function E(D){return typeof D=="number"&&!isNaN(D)}e.isNumber=E;function n(D){return!!D&&typeof D[Symbol.iterator]=="function"}e.isIterable=n;function f(D){return D===!0||D===!1}e.isBoolean=f;function w(D){return typeof D=="undefined"}e.isUndefined=w;function i(D){return!I(D)}e.isDefined=i;function I(D){return w(D)||D===null}e.isUndefinedOrNull=I;function P(D,R){if(!D)throw new Error(R?`Unexpected type, expected '${R}'`:"Unexpected type")}e.assertType=P;function y(D){if(I(D))throw new Error("Assertion Failed: argument is undefined or null");return D}e.assertIsDefined=y;function d(...D){const R=[];for(let T=0;T<D.length;T++){const _=D[T];if(I(_))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);R.push(_)}return R}e.assertAllDefined=d;const g=Object.prototype.hasOwnProperty;function b(D){if(!M(D))return!1;for(let R in D)if(g.call(D,R))return!1;return!0}e.isEmptyObject=b;function v(D){return typeof D=="function"}e.isFunction=v;function c(...D){return D.length>0&&D.every(v)}e.areFunctions=c;function h(D,R){const T=Math.min(D.length,R.length);for(let _=0;_<T;_++)a(D[_],R[_])}e.validateConstraints=h;function a(D,R){if(L(R)){if(typeof D!==R)throw new Error(`argument does not match constraint: typeof ${R}`)}else if(v(R)){try{if(D instanceof R)return}catch{}if(!I(D)&&D.constructor===R||R.length===1&&R.call(void 0,D)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function u(D){let R=[],T=Object.getPrototypeOf(D);for(;Object.prototype!==T;)R=R.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return R}e.getAllPropertyNames=u;function t(D){const R=[];for(const T of u(D))typeof D[T]=="function"&&R.push(T);return R}e.getAllMethodNames=t;function l(D,R){const T=G=>function(){const ne=Array.prototype.slice.call(arguments,0);return R(G,ne)};let _={};for(const G of D)_[G]=T(G);return _}e.createProxyObject=l;function r(D){return D===null?void 0:D}e.withNullAsUndefined=r;function s(D){return typeof D=="undefined"?null:D}e.withUndefinedAsNull=s;function o(D){return class{constructor(){return new Proxy({},{get(R,T){if(R[T])return R[T];throw new Error(`Not Implemented: ${D}->${String(T)}`)}})}}}e.NotImplementedProxy=o;function m(D,R="Unreachable"){throw new Error(R)}e.assertNever=m;function S(D){return!!D&&typeof D.then=="function"&&typeof D.catch=="function"}e.isPromise=S}),define(Z[31],x([0,1,8,3,25,13]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function E(r){return r===47||r===92}e.isPathSeparator=E;function n(r){return r.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=n;function f(r){return r.indexOf("/")===-1&&(r=n(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=f;function w(r,s=p.posix.sep){if(!r)return"";const o=r.length,m=r.charCodeAt(0);if(E(m)){if(E(r.charCodeAt(1))&&!E(r.charCodeAt(2))){let D=3;const R=D;for(;D<o&&!E(r.charCodeAt(D));D++);if(R!==D&&!E(r.charCodeAt(D+1))){for(D+=1;D<o;D++)if(E(r.charCodeAt(D)))return r.slice(0,D+1).replace(/[\\/]/g,s)}}return s}else if(v(m)&&r.charCodeAt(1)===58)return E(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let S=r.indexOf("://");if(S!==-1){for(S+=3;S<o;S++)if(E(r.charCodeAt(S)))return r.slice(0,S+1)}return""}e.getRoot=w;function i(r){if(!L.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let o=2;const m=o;for(;o<r.length&&(s=r.charCodeAt(o),s!==92);o++);return!(m===o||(s=r.charCodeAt(o+1),isNaN(s)||s===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,P=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,s=L.isWindows){const o=s?I:P;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||s&&y.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function g(r,s,o){const m=r===s;return!o||m?m:!r||!s?!1:(0,k.equalsIgnoreCase)(r,s)}e.isEqual=g;function b(r,s,o,m=p.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(o){if(!(0,k.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let D=s.length;return s.charAt(s.length-1)===m&&D--,r.charAt(D)===m}return s.charAt(s.length-1)!==m&&(s+=m),r.indexOf(s)===0}e.isEqualOrParent=b;function v(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=v;function c(r,s){return L.isWindows&&r.endsWith(":")&&(r+=p.sep),(0,p.isAbsolute)(r)||(r=(0,p.join)(s,r)),r=(0,p.normalize)(r),L.isWindows?(r=(0,k.rtrim)(r,p.sep),r.endsWith(":")&&(r+=p.sep)):(r=(0,k.rtrim)(r,p.sep),r||(r=p.sep)),r}e.sanitizeFilePath=c;function h(r){const s=(0,p.normalize)(r);return L.isWindows?r.length>3?!1:a(s)&&(r.length===2||s.charCodeAt(2)===92):s===p.posix.sep}e.isRootOrDriveLetter=h;function a(r){return L.isWindows?v(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function u(r){return a(r)?r[0]:void 0}e.getDriveLetter=u;function t(r,s,o){return s.length>r.length?-1:r===s?0:(o&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=t;function l(r){const s=r.split(":");let o,m,S;if(s.forEach(D=>{const R=Number(D);(0,M.isNumber)(R)?m===void 0?m=R:S===void 0&&(S=R):o=o?[o,D].join(":"):D}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:m!==void 0?m:void 0,column:S!==void 0?S:m!==void 0?1:void 0}}e.parseLineAndColumnAware=l}),define(Z[44],x([0,1,13]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const b=Array.isArray(g)?[]:{};return Object.keys(g).forEach(v=>{g[v]&&typeof g[v]=="object"?b[v]=L(g[v]):b[v]=g[v]}),b}e.deepClone=L;function k(g){if(!g||typeof g!="object")return g;const b=[g];for(;b.length>0;){const v=b.shift();Object.freeze(v);for(const c in v)if(M.call(v,c)){const h=v[c];typeof h=="object"&&!Object.isFrozen(h)&&b.push(h)}}return g}e.deepFreeze=k;const M=Object.prototype.hasOwnProperty;function E(g,b){return n(g,b,new Set)}e.cloneAndChange=E;function n(g,b,v){if((0,p.isUndefinedOrNull)(g))return g;const c=b(g);if(typeof c!="undefined")return c;if((0,p.isArray)(g)){const h=[];for(const a of g)h.push(n(a,b,v));return h}if((0,p.isObject)(g)){if(v.has(g))throw new Error("Cannot clone recursive data-structure");v.add(g);const h={};for(let a in g)M.call(g,a)&&(h[a]=n(g[a],b,v));return v.delete(g),h}return g}function f(g,b,v=!0){return(0,p.isObject)(g)?((0,p.isObject)(b)&&Object.keys(b).forEach(c=>{c in g?v&&((0,p.isObject)(g[c])&&(0,p.isObject)(b[c])?f(g[c],b[c],v):g[c]=b[c]):g[c]=b[c]}),g):b}e.mixin=f;function w(g,b){if(g===b)return!0;if(g==null||b===null||b===void 0||typeof g!=typeof b||typeof g!="object"||Array.isArray(g)!==Array.isArray(b))return!1;let v,c;if(Array.isArray(g)){if(g.length!==b.length)return!1;for(v=0;v<g.length;v++)if(!w(g[v],b[v]))return!1}else{const h=[];for(c in g)h.push(c);h.sort();const a=[];for(c in b)a.push(c);if(a.sort(),!w(h,a))return!1;for(v=0;v<h.length;v++)if(!w(g[h[v]],b[h[v]]))return!1}return!0}e.equals=w;function i(g){const b=new Set;return JSON.stringify(g,(v,c)=>{if((0,p.isObject)(c)||Array.isArray(c)){if(b.has(c))return"[Circular]";b.add(c)}return c})}e.safeStringify=i;function I(g,b,v){const c=b(g);return typeof c=="undefined"?v:c}e.getOrDefault=I;function P(g,b){const v=Object.create(null);return!g||!b||Object.keys(b).forEach(h=>{const a=g[h],u=b[h];w(a,u)||(v[h]=u)}),v}e.distinct=P;function y(g,b){const v=b.toLowerCase(),c=Object.keys(g).find(h=>h.toLowerCase()===v);return c?g[c]:g[b]}e.getCaseInsensitive=y;function d(g,b){const v=Object.create(null);for(const c of Object.keys(g))b(c,g[c])&&(v[c]=g[c]);return v}e.filter=d}),define(Z[7],x([0,1,8,3]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,M=/^\//,E=/^\/\//;function n(r,s){if(!r.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!M.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(r,s){return!r&&!s?"file":r}function w(r,s){switch(r){case"https":case"http":case"file":s?s[0]!==I&&(s=I+s):s=I;break}return s}const i="",I="/",P=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(s,o,m,S,D,R=!1){typeof s=="object"?(this.scheme=s.scheme||i,this.authority=s.authority||i,this.path=s.path||i,this.query=s.query||i,this.fragment=s.fragment||i):(this.scheme=f(s,R),this.authority=o||i,this.path=w(this.scheme,m||i),this.query=S||i,this.fragment=D||i,n(this,R))}static isUri(s){return s instanceof y?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return h(this,!1)}with(s){if(!s)return this;let{scheme:o,authority:m,path:S,query:D,fragment:R}=s;return o===void 0?o=this.scheme:o===null&&(o=i),m===void 0?m=this.authority:m===null&&(m=i),S===void 0?S=this.path:S===null&&(S=i),D===void 0?D=this.query:D===null&&(D=i),R===void 0?R=this.fragment:R===null&&(R=i),o===this.scheme&&m===this.authority&&S===this.path&&D===this.query&&R===this.fragment?this:new g(o,m,S,D,R)}static parse(s,o=!1){const m=P.exec(s);return m?new g(m[2]||i,l(m[4]||i),l(m[5]||i),l(m[7]||i),l(m[9]||i),o):new g(i,i,i,i,i)}static file(s){let o=i;if(L.isWindows&&(s=s.replace(/\\/g,I)),s[0]===I&&s[1]===I){const m=s.indexOf(I,2);m===-1?(o=s.substring(2),s=I):(o=s.substring(2,m),s=s.substring(m)||I)}return new g("file",o,s,i,i)}static from(s){const o=new g(s.scheme,s.authority,s.path,s.query,s.fragment);return n(o,!0),o}static joinPath(s,...o){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return L.isWindows&&s.scheme==="file"?m=y.file(p.win32.join(h(s,!0),...o)).path:m=p.posix.join(s.path,...o),s.with({path:m})}toString(s=!1){return a(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof y)return s;{const o=new g(s);return o._formatted=s.external,o._fsPath=s._sep===d?s.fsPath:null,o}}else return s}}e.URI=y;const d=L.isWindows?1:void 0;class g extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(s=!1){return s?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=d),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(r,s){let o,m=-1;for(let S=0;S<r.length;S++){const D=r.charCodeAt(S);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||s&&D===47)m!==-1&&(o+=encodeURIComponent(r.substring(m,S)),m=-1),o!==void 0&&(o+=r.charAt(S));else{o===void 0&&(o=r.substr(0,S));const R=b[D];R!==void 0?(m!==-1&&(o+=encodeURIComponent(r.substring(m,S)),m=-1),o+=R):m===-1&&(m=S)}}return m!==-1&&(o+=encodeURIComponent(r.substring(m))),o!==void 0?o:r}function c(r){let s;for(let o=0;o<r.length;o++){const m=r.charCodeAt(o);m===35||m===63?(s===void 0&&(s=r.substr(0,o)),s+=b[m]):s!==void 0&&(s+=r[o])}return s!==void 0?s:r}function h(r,s){let o;return r.authority&&r.path.length>1&&r.scheme==="file"?o=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?s?o=r.path.substr(1):o=r.path[1].toLowerCase()+r.path.substr(2):o=r.path,L.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=h;function a(r,s){const o=s?c:v;let m="",{scheme:S,authority:D,path:R,query:T,fragment:_}=r;if(S&&(m+=S,m+=":"),(D||S==="file")&&(m+=I,m+=I),D){let G=D.indexOf("@");if(G!==-1){const ne=D.substr(0,G);D=D.substr(G+1),G=ne.indexOf(":"),G===-1?m+=o(ne,!1):(m+=o(ne.substr(0,G),!1),m+=":",m+=o(ne.substr(G+1),!1)),m+="@"}D=D.toLowerCase(),G=D.indexOf(":"),G===-1?m+=o(D,!1):(m+=o(D.substr(0,G),!1),m+=D.substr(G))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const G=R.charCodeAt(1);G>=65&&G<=90&&(R=`/${String.fromCharCode(G+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const G=R.charCodeAt(0);G>=65&&G<=90&&(R=`${String.fromCharCode(G+32)}:${R.substr(2)}`)}m+=o(R,!0)}return T&&(m+="?",m+=o(T,!1)),_&&(m+="#",m+=s?_:v(_,!1)),m}function u(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+u(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(r){return r.match(t)?r.replace(t,s=>u(s)):r}}),define(Z[109],x([0,1,7]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(w){const i=w;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function k(w){const i=[];let I;try{const P=JSON.parse(w.arguments),y=P[P.length-1];y&&y.__$stack&&(P.pop(),I=y.__$stack),i.push(...P)}catch(P){i.push("Unable to log remote console arguments",w.arguments)}return{args:i,stack:I}}e.parse=k;function M(w){if(typeof w!="string")return M(k(w).stack);const i=w;if(i){const I=E(i),P=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(P&&P.length===4)return{uri:p.URI.file(P[1]),line:Number(P[2]),column:Number(P[3])}}}e.getFirstFrame=M;function E(w){if(!w)return w;const i=w.indexOf(`
`);return i===-1?w:w.substring(0,i)}function n(w,i){const{args:I,stack:P}=k(w),y=typeof I[0]=="string"&&I.length===1;let d=E(P);d&&(d=`(${d.trim()})`);let g=[];if(typeof I[0]=="string"?d&&y?g=[`%c[${i}] %c${I[0]} %c${d}`,f("blue"),f(""),f("grey")]:g=[`%c[${i}] %c${I[0]}`,f("blue"),f(""),...I.slice(1)]:g=[`%c[${i}]%`,f("blue"),...I],d&&!y&&g.push(d),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,g)}e.log=n;function f(w){return`color: ${w}`}});var Et=this&&this.__classPrivateFieldSet||function(V,e,p,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?V!==e||!k:!e.has(V))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(V,p):k?k.value=p:e.set(V,p),p},Ve=this&&this.__classPrivateFieldGet||function(V,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?V!==e||!L:!e.has(V))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(V):L?L.value:e.get(V)};define(Z[37],x([0,1,30,25,7]),function(V,e,p,L,k){"use strict";var M,E,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function f(l,r,s){let o=l.get(r);return o===void 0&&(o=s,l.set(r,o)),o}e.getOrSet=f;function w(l){const r=[];return l.forEach((s,o)=>{r.push(`${o} => ${s}`)}),`Map(${l.size}) {${r.join(", ")}}`}e.mapToString=w;function i(l){const r=[];return l.forEach(s=>{r.push(s)}),`Set(${l.size}) {${r.join(", ")}}`}e.setToString=i;class I{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=I;class P{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class y{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var d;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(d||(d={}));class g{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class b{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class v{constructor(r){this._iter=r}static forUris(r=()=>!1){return new v(new g(r))}static forPaths(){return new v(new y)}static forStrings(){return new v(new I)}static forConfigKeys(){return new v(new P)}clear(){this._root=void 0}set(r,s){const o=this._iter.reset(r);let m;for(this._root||(this._root=new b,this._root.segment=o.value()),m=this._root;;){const D=o.cmp(m.segment);if(D>0)m.left||(m.left=new b,m.left.segment=o.value()),m=m.left;else if(D<0)m.right||(m.right=new b,m.right.segment=o.value()),m=m.right;else if(o.hasNext())o.next(),m.mid||(m.mid=new b,m.mid.segment=o.value()),m=m.mid;else break}const S=m.value;return m.value=s,m.key=r,S}fill(r,s){const o=s.slice(0);(0,p.shuffle)(o);for(let m of o)this.set(m,r)}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let o=this._root;for(;o;){const m=s.cmp(o.segment);if(m>0)o=o.left;else if(m<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const o=this._iter.reset(r),m=[];let S=this._root;for(;S;){const D=o.cmp(S.segment);if(D>0)m.push([1,S]),S=S.left;else if(D<0)m.push([-1,S]),S=S.right;else if(o.hasNext())o.next(),m.push([0,S]),S=S.mid;else{for(s?(S.left=void 0,S.mid=void 0,S.right=void 0):S.value=void 0;m.length>0&&S.isEmpty();){let[R,T]=m.pop();switch(R){case 1:T.left=void 0;break;case 0:T.mid=void 0;break;case-1:T.right=void 0;break}S=T}break}}}findSubstr(r){const s=this._iter.reset(r);let o=this._root,m;for(;o;){const S=s.cmp(o.segment);if(S>0)o=o.left;else if(S<0)o=o.right;else if(s.hasNext())s.next(),m=o.value||m,o=o.mid;else break}return o&&o.value||m}findSuperstr(r){const s=this._iter.reset(r);let o=this._root;for(;o;){const m=s.cmp(o.segment);if(m>0)o=o.left;else if(m<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(r){for(const[s,o]of this)r(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const o=s.pop();o&&(o.value&&(yield[o.key,o.value]),o.left&&s.push(o.left),o.mid&&s.push(o.mid),o.right&&s.push(o.right))}}}e.TernarySearchTree=v;class c{constructor(r,s){this[M]="ResourceMap",r instanceof c?(this.map=new Map(r.map),this.toKey=s??c.defaultToKey):(this.map=new Map,this.toKey=r??c.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[o,m]of this.map)r(m,k.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield k.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[k.URI.parse(r[0]),r[1]]}*[(M=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[k.URI.parse(r[0]),r[1]]}}e.ResourceMap=c,c.defaultToKey=l=>l.toString();var h;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class a{constructor(){this[E]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const o=this._map.get(r);if(!!o)return s!==0&&this.touch(o,s),o.value}set(r,s,o=0){let m=this._map.get(r);if(m)m.value=s,o!==0&&this.touch(m,o);else{switch(m={key:r,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(m);break;case 1:this.addItemFirst(m);break;case 2:this.addItemLast(m);break;default:this.addItemLast(m);break}this._map.set(r,m),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const o=this._state;let m=this._head;for(;m;){if(s?r.bind(s)(m.value,m.key,this):r(m.value,m.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const r=this,s=this._state;let o=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const S={value:o.key,done:!1};return o=o.next,S}else return{value:void 0,done:!0}}};return m}values(){const r=this,s=this._state;let o=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const S={value:o.value,done:!1};return o=o.next,S}else return{value:void 0,done:!0}}};return m}entries(){const r=this,s=this._state;let o=this._head;const m={[Symbol.iterator](){return m},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const S={value:[o.key,o.value],done:!1};return o=o.next,S}else return{value:void 0,done:!0}}};return m}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>r;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,o=r.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const o=r.next,m=r.previous;r===this._tail?(m.next=void 0,this._tail=m):(o.previous=m,m.next=o),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const o=r.next,m=r.previous;r===this._head?(o.previous=void 0,this._head=o):(o.previous=m,m.next=o),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,o)=>{r.push([o,s])}),r}fromJSON(r){this.clear();for(const[s,o]of r)this.set(s,o)}}e.LinkedMap=a;class u extends a{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u;class t{constructor(r){n.set(this,void 0),Et(this,n,r,"f")}get size(){return Ve(this,n,"f").size}forEach(r,s){Ve(this,n,"f").forEach(r,s)}get(r){return Ve(this,n,"f").get(r)}has(r){return Ve(this,n,"f").has(r)}entries(){return Ve(this,n,"f").entries()}keys(){return Ve(this,n,"f").keys()}values(){return Ve(this,n,"f").values()}[(n=new WeakMap,Symbol.iterator)](){return Ve(this,n,"f").entries()}}e.ReadonlyMapView=t}),define(Z[110],x([0,1,18,25,7]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function M(i){return JSON.stringify(i,f)}e.stringify=M;function E(i){let I=JSON.parse(i);return I=w(I),I}e.parse=E;var n;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(n=e.MarshalledId||(e.MarshalledId={}));function f(i,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function w(i,I=0){if(!i||I>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return k.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof p.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let P=0;P<i.length;++P)i[P]=w(i[P],I+1);else for(const P in i)Object.hasOwnProperty.call(i,P)&&(i[P]=w(i[P],I+1))}return i}e.revive=w}),define(Z[10],x([0,1,3,7]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractive="vscode-interactive",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,w,i){this._hosts[f]=w,this._ports[f]=i}setConnectionToken(f,w){this._connectionTokens[f]=w}rewrite(f){if(this._delegate)return this._delegate(f);const w=f.authority;let i=this._hosts[w];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[w],P=this._connectionTokens[w];let y=`path=${encodeURIComponent(f.path)}`;return typeof P=="string"&&(y+=`&tkn=${encodeURIComponent(P)}`),L.URI.from({scheme:p.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new M;class E{asBrowserUri(f,w){const i=this.toUri(f,w);return i.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===k.file&&(p.isNative||typeof p.globals.importScripts=="function"&&p.globals.origin===`${k.vscodeFileResource}://${E.FALLBACK_AUTHORITY}`)?i.with({scheme:k.vscodeFileResource,authority:i.authority||E.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(f,w){const i=this.toUri(f,w);return i.scheme===k.vscodeFileResource?i.with({scheme:k.file,authority:i.authority!==E.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(f,w){return L.URI.isUri(f)?f:L.URI.parse(w.toUrl(f))}}E.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new E}),define(Z[67],x([0,1,37]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new p.LRUCache(1e4);function k(w){return f(w,"NFC",L)}e.normalizeNFC=k;const M=new p.LRUCache(1e4);function E(w){return f(w,"NFD",M)}e.normalizeNFD=E;const n=/[^\u0000-\u0080]/;function f(w,i,I){if(!w)return w;const P=I.get(w);if(P)return P;let y;return n.test(w)?y=w.normalize(i):y=w,I.set(w,y),y}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(i){return E(i).replace(w,"")}}()}),define(Z[15],x([0,1,31,10,8,3,25,7]),function(V,e,p,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(y){return(0,n.uriToFsPath)(y,!0)}e.originalFSPath=f;class w{constructor(d){this._ignorePathCasing=d}compare(d,g,b=!1){return d===g?0:(0,E.compare)(this.getComparisonKey(d,b),this.getComparisonKey(g,b))}isEqual(d,g,b=!1){return d===g?!0:!d||!g?!1:this.getComparisonKey(d,b)===this.getComparisonKey(g,b)}getComparisonKey(d,g=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,g,b=!1){if(d.scheme===g.scheme){if(d.scheme===L.Schemas.file)return p.isEqualOrParent(f(d),f(g),this._ignorePathCasing(d))&&d.query===g.query&&(b||d.fragment===g.fragment);if((0,e.isEqualAuthority)(d.authority,g.authority))return p.isEqualOrParent(d.path,g.path,this._ignorePathCasing(d),"/")&&d.query===g.query&&(b||d.fragment===g.fragment)}return!1}joinPath(d,...g){return n.URI.joinPath(d,...g)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let g;return d.scheme===L.Schemas.file?g=n.URI.file(k.dirname(f(d))).path:(g=k.posix.dirname(d.path),d.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),g="/")),d.with({path:g})}normalizePath(d){if(!d.path.length)return d;let g;return d.scheme===L.Schemas.file?g=n.URI.file(k.normalize(f(d))).path:g=k.posix.normalize(d.path),d.with({path:g})}relativePath(d,g){if(d.scheme!==g.scheme||!(0,e.isEqualAuthority)(d.authority,g.authority))return;if(d.scheme===L.Schemas.file){const c=k.relative(f(d),f(g));return M.isWindows?p.toSlashes(c):c}let b=d.path||"/",v=g.path||"/";if(this._ignorePathCasing(d)){let c=0;for(const h=Math.min(b.length,v.length);c<h&&!(b.charCodeAt(c)!==v.charCodeAt(c)&&b.charAt(c).toLowerCase()!==v.charAt(c).toLowerCase());c++);b=v.substr(0,c)+b.substr(c)}return k.posix.relative(b,v)}resolvePath(d,g){if(d.scheme===L.Schemas.file){const b=n.URI.file(k.resolve(f(d),g));return d.with({authority:b.authority,path:b.path})}return g=p.toPosixPath(g),d.with({path:k.posix.resolve(d.path,g)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,g){return d===g||(0,E.equalsIgnoreCase)(d,g)}hasTrailingPathSeparator(d,g=k.sep){if(d.scheme===L.Schemas.file){const b=f(d);return b.length>p.getRoot(b).length&&b[b.length-1]===g}else{const b=d.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,g=k.sep){return(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,g=k.sep){let b=!1;if(d.scheme===L.Schemas.file){const v=f(d);b=v!==void 0&&v.length===p.getRoot(v).length&&v[v.length-1]===g}else{g="/";const v=d.path;b=v.length===1&&v.charCodeAt(v.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path+"/"}):d}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(y=>y.scheme===L.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new w(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(y,d){const g=[];for(let b=0;b<y.length;b++){const v=d(y[b]);y.some((c,h)=>h===b?!1:(0,e.isEqualOrParent)(v,d(c)))||g.push(y[b])}return g}e.distinctParents=i;var I;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function d(g){const b=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(h=>{const[a,u]=h.split(":");a&&u&&b.set(a,u)});const c=g.path.substring(0,g.path.indexOf(";"));return c&&b.set(y.META_DATA_MIME,c),b}y.parseMetaData=d})(I=e.DataUri||(e.DataUri={}));function P(y,d,g){if(d){let b=y.path;return b&&b[0]!==k.posix.sep&&(b=k.posix.sep+b),y.with({scheme:g,authority:d,path:b})}return y.with({scheme:g})}e.toLocalResource=P}),define(Z[9],x([0,1,23,17,4,2,15]),function(V,e,p,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function n(H){return!!H&&typeof H.then=="function"}e.isThenable=n;function f(H){const z=new p.CancellationTokenSource,q=H(z.token),O=new Promise(($,U)=>{const A=z.token.onCancellationRequested(()=>{A.dispose(),z.dispose(),U((0,L.canceled)())});Promise.resolve(q).then(F=>{A.dispose(),z.dispose(),$(F)},F=>{A.dispose(),z.dispose(),U(F)})});return new class{cancel(){z.cancel()}then($,U){return O.then($,U)}catch($){return this.then(void 0,$)}finally($){return O.finally($)}}}e.createCancelablePromise=f;function w(H,z,q){return Promise.race([H,new Promise(O=>z.onCancellationRequested(()=>O(q)))])}e.raceCancellation=w;async function i(H){let z=-1;const q=H.map(($,U)=>$.then(A=>(z=U,A))),O=await Promise.race(q);return H.forEach(($,U)=>{U!==z&&$.cancel()}),O}e.raceCancellablePromises=i;function I(H,z,q){let O;const $=setTimeout(()=>{O?.(void 0),q?.()},z);return Promise.race([H.finally(()=>clearTimeout($)),new Promise(U=>O=U)])}e.raceTimeout=I;function P(H){return new Promise((z,q)=>{const O=H();n(O)?O.then(z,q):z(O)})}e.asPromise=P;class y{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(z){if(this.activePromise){if(this.queuedPromiseFactory=z,!this.queuedPromise){const q=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(q,q).then(O)})}return new Promise((q,O)=>{this.queuedPromise.then(q,O)})}return this.activePromise=z(),new Promise((q,O)=>{this.activePromise.then($=>{this.activePromise=null,q($)},$=>{this.activePromise=null,O($)})})}}e.Throttler=y;class d{constructor(){this.current=Promise.resolve(null)}queue(z){return this.current=this.current.then(()=>z(),()=>z())}}e.Sequencer=d;class g{constructor(){this.promiseMap=new Map}queue(z,q){const $=(this.promiseMap.get(z)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get(z)===$&&this.promiseMap.delete(z)});return this.promiseMap.set(z,$),$}}e.SequencerByKey=g;class b{constructor(z){this.defaultDelay=z,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(z,q=this.defaultDelay){return this.task=z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,$)=>{this.doResolve=O,this.doReject=$}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class v{constructor(z){this.delayer=new b(z),this.throttler=new y}trigger(z,q){return this.delayer.trigger(()=>this.throttler.queue(z),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class c{constructor(){this._isOpen=!1,this._promise=new Promise((z,q)=>{this._completePromise=z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class h extends c{constructor(z){super();this._timeout=setTimeout(()=>this.open(),z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function a(H,z){return z?new Promise((q,O)=>{const $=setTimeout(()=>{U.dispose(),q()},H),U=z.onCancellationRequested(()=>{clearTimeout($),U.dispose(),O((0,L.canceled)())})}):f(q=>a(H,q))}e.timeout=a;function u(H,z=0){const q=setTimeout(H,z);return(0,M.toDisposable)(()=>clearTimeout(q))}e.disposableTimeout=u;function t(H){const z=[];let q=0;const O=H.length;function $(){return q<O?H[q++]():null}function U(A){A!=null&&z.push(A);const F=$();return F?F.then(U):Promise.resolve(z)}return Promise.resolve(null).then(U)}e.sequence=t;function l(H,z=O=>!!O,q=null){let O=0;const $=H.length,U=()=>{if(O>=$)return Promise.resolve(q);const A=H[O++];return Promise.resolve(A()).then(B=>z(B)?Promise.resolve(B):U())};return U()}e.first=l;function r(H,z=O=>!!O,q=null){if(H.length===0)return Promise.resolve(q);let O=H.length;const $=()=>{O=-1;for(const U of H)U.cancel?.()};return new Promise((U,A)=>{for(const F of H)F.then(B=>{--O>=0&&z(B)?($(),U(B)):O===0&&U(q)}).catch(B=>{--O>=0&&($(),A(B))})})}e.firstParallel=r;class s{constructor(z){this._size=0,this.maxDegreeOfParalellism=z,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(z){return this._size++,new Promise((q,O)=>{this.outstandingPromises.push({factory:z,c:q,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const z=this.outstandingPromises.shift();this.runningPromises++;const q=z.factory();q.then(z.c,z.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class o extends s{constructor(){super(1)}}e.Queue=o;class m{constructor(){this.queues=new Map}queueFor(z,q=E.extUri){const O=q.getComparisonKey(z);let $=this.queues.get(O);return $||($=new o,k.Event.once($.onFinished)(()=>{$?.dispose(),this.queues.delete(O)}),this.queues.set(O,$)),$}dispose(){this.queues.forEach(z=>z.dispose()),this.queues.clear()}}e.ResourceQueue=m;class S{constructor(z,q){this._token=-1,typeof z=="function"&&typeof q=="number"&&this.setIfNotSet(z,q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(z,q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,z()},q)}setIfNotSet(z,q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,z()},q))}}e.TimeoutTimer=S;class D{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(z,q){this.cancel(),this._token=setInterval(()=>{z()},q)}}e.IntervalTimer=D;class R{constructor(z,q){this.timeoutToken=-1,this.runner=z,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,z)}get delay(){return this.timeout}set delay(z){this.timeout=z}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class T{constructor(z,q){q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.runner=z,this.timeout=q,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(z=this.timeout){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(z/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=T;class _ extends R{constructor(z,q){super(z,q);this.units=[]}work(z){this.units.push(z),this.isScheduled()||this.schedule()}doRun(){const z=this.units;this.units=[],this.runner&&this.runner(z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_;class G extends M.Disposable{constructor(z,q,O,$){super();this.maxWorkChunkSize=z,this.maxPendingWork=q,this.throttleDelay=O,this.handler=$,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(z){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+z.length>this.maxPendingWork)return!1}else if(this.pending+z.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...z),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=G,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{const z=setTimeout(()=>{const O=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0,clearTimeout(z))}}}:e.runWhenIdle=(H,z)=>{const q=requestIdleCallback(H,typeof z=="number"?{timeout:z}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(q))}}}}();class ne{constructor(z){this._didRun=!1,this._executor=()=>{try{this._value=z()}catch(q){this._error=q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ne;async function se(H,z,q){let O;for(let $=0;$<q;$++)try{return await H()}catch(U){O=U,await a(z)}throw O}e.retry=se;class K{hasPending(z){return this._pending?typeof z=="number"?this._pending.taskId===z:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(z,q,O){return this._pending={taskId:z,cancel:()=>O?.(),promise:q},q.then(()=>this.donePending(z),()=>this.donePending(z)),q}donePending(z){this._pending&&z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const z=this._next;this._next=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}setNext(z){if(this._next)this._next.run=z;else{let q,O;const $=new Promise((U,A)=>{q=U,O=A});this._next={run:z,promise:$,promiseResolve:q,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=K;class te{constructor(z){this.interval=z,this.lastIncrementTime=0,this.value=0}increment(){const z=Date.now();return z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=z,this.value=0),this.value++,this.value}}e.IntervalCounter=te;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((z,q)=>{this.completeCallback=z,this.errorCallback=q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(z){return new Promise(q=>{this.completeCallback(z),this.resolved=!0,q()})}error(z){return new Promise(q=>{this.errorCallback(z),this.rejected=!0,q()})}cancel(){new Promise(z=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,z()})}}e.DeferredPromise=W;var j;(function(H){async function z(q){let O;const $=await Promise.all(q.map(U=>U.then(A=>A,A=>{O||(O=A)})));if(typeof O!="undefined")throw O;return $}H.settled=z})(j=e.Promises||(e.Promises={}))}),define(Z[111],x([0,1,9,31,37,8,25]),function(V,e,p,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const f="**",w="/",i="[/\\\\]",I="[^/\\\\]",P=/\//g;function y(O){switch(O){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function d(O,$){if(!O)return[];const U=[];let A=!1,F=!1,B="";for(const Y of O){switch(Y){case $:if(!A&&!F){U.push(B),B="";continue}break;case"{":A=!0;break;case"}":A=!1;break;case"[":F=!0;break;case"]":F=!1;break}B+=Y}return B&&U.push(B),U}e.splitGlobAware=d;function g(O){if(!O)return"";let $="";const U=d(O,w);if(U.every(A=>A===f))$=".*";else{let A=!1;U.forEach((F,B)=>{if(F===f){A||($+=y(2),A=!0);return}let Y=!1,C="",N=!1,Q="";for(const J of F){if(J!=="}"&&Y){C+=J;continue}if(N&&(J!=="]"||!Q)){let re;J==="-"?re=J:(J==="^"||J==="!")&&!Q?re="^":J===w?re="":re=E.escapeRegExpCharacters(J),Q+=re;continue}switch(J){case"{":Y=!0;continue;case"[":N=!0;continue;case"}":$+=`(?:${d(C,",").map(ee=>g(ee)).join("|")})`,Y=!1,C="";break;case"]":$+="["+Q+"]",N=!1,Q="";break;case"?":$+=I;continue;case"*":$+=y(1);continue;default:$+=E.escapeRegExpCharacters(J)}}B<U.length-1&&(U[B+1]!==f||B+2<U.length)&&($+=i),A=!1})}return $}const b=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.LRUCache(1e4),l=function(){return!1},r=function(){return null};function s(O,$){if(!O)return r;let U;typeof O!="string"?U=O.pattern:U=O,U=U.trim();const A=`${U}_${!!$.trimForExclusions}`;let F=t.get(A);if(F)return o(F,O);let B;if(b.test(U)){const Y=U.substr(4);F=function(C,N){return typeof C=="string"&&C.endsWith(Y)?U:null}}else(B=v.exec(m(U,$)))?F=S(B[1],U):($.trimForExclusions?h:c).test(U)?F=D(U,$):(B=a.exec(m(U,$)))?F=R(B[1].substr(1),U,!0):(B=u.exec(m(U,$)))?F=R(B[1],U,!1):F=T(U);return t.set(A,F),o(F,O)}function o(O,$){return typeof $=="string"?O:function(U,A){return L.isEqualOrParent(U,$.base)?O(M.relative($.base,U),A):null}}function m(O,$){return $.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function S(O,$){const U=`/${O}`,A=`\\${O}`,F=function(Y,C){return typeof Y!="string"?null:C?C===O?$:null:Y===O||Y.endsWith(U)||Y.endsWith(A)?$:null},B=[O];return F.basenames=B,F.patterns=[$],F.allBasenames=B,F}function D(O,$){const U=q(O.slice(1,-1).split(",").map(C=>s(C,$)).filter(C=>C!==r),O),A=U.length;if(!A)return r;if(A===1)return U[0];const F=function(C,N){for(let Q=0,J=U.length;Q<J;Q++)if(U[Q](C,N))return O;return null},B=U.find(C=>!!C.allBasenames);B&&(F.allBasenames=B.allBasenames);const Y=U.reduce((C,N)=>N.allPaths?C.concat(N.allPaths):C,[]);return Y.length&&(F.allPaths=Y),F}function R(O,$,U){const A=M.sep===M.posix.sep,F=A?O:O.replace(P,M.sep),B=M.sep+F,Y=M.posix.sep+O,C=U?function(N,Q){return typeof N=="string"&&(N===F||N.endsWith(B)||!A&&(N===O||N.endsWith(Y)))?$:null}:function(N,Q){return typeof N=="string"&&(N===F||!A&&N===O)?$:null};return C.allPaths=[(U?"*/":"./")+O],C}function T(O){try{const $=new RegExp(`^${g(O)}$`);return function(U){return $.lastIndex=0,typeof U=="string"&&$.test(U)?O:null}}catch($){return r}}function _(O,$,U){return!O||typeof $!="string"?!1:G(O)($,void 0,U)}e.match=_;function G(O,$={}){if(!O)return l;if(typeof O=="string"||te(O)){const U=s(O,$);if(U===r)return l;const A=function(F,B){return!!U(F,B)};return U.allBasenames&&(A.allBasenames=U.allBasenames),U.allPaths&&(A.allPaths=U.allPaths),A}return H(O,$)}e.parse=G;function ne(O){if(!O)return;let $;return U=>($||($=(O()||Promise.resolve([])).then(A=>A?K(A):{})),$.then(A=>!!A[U]))}e.hasSiblingPromiseFn=ne;function se(O){if(!O)return;let $;return U=>{if(!$){const A=O();$=A?K(A):{}}return!!$[U]}}e.hasSiblingFn=se;function K(O){const $={};for(const U of O)$[U]=!0;return $}function te(O){const $=O;return $&&typeof $.base=="string"&&typeof $.pattern=="string"}e.isRelativePattern=te;function W(O){return O.allBasenames||[]}e.getBasenameTerms=W;function j(O){return O.allPaths||[]}e.getPathTerms=j;function H(O,$){const U=q(Object.getOwnPropertyNames(O).map(C=>z(C,O[C],$)).filter(C=>C!==r)),A=U.length;if(!A)return r;if(!U.some(C=>!!C.requiresSiblings)){if(A===1)return U[0];const C=function(J,re){for(let le=0,ee=U.length;le<ee;le++){const ae=U[le](J,re);if(ae)return ae}return null},N=U.find(J=>!!J.allBasenames);N&&(C.allBasenames=N.allBasenames);const Q=U.reduce((J,re)=>re.allPaths?J.concat(re.allPaths):J,[]);return Q.length&&(C.allPaths=Q),C}const F=function(C,N,Q){let J;for(let re=0,le=U.length;re<le;re++){const ee=U[re];ee.requiresSiblings&&Q&&(N||(N=M.basename(C)),J||(J=N.substr(0,N.length-M.extname(C).length)));const ae=ee(C,N,J,Q);if(ae)return ae}return null},B=U.find(C=>!!C.allBasenames);B&&(F.allBasenames=B.allBasenames);const Y=U.reduce((C,N)=>N.allPaths?C.concat(N.allPaths):C,[]);return Y.length&&(F.allPaths=Y),F}function z(O,$,U){if($===!1)return r;const A=s(O,U);if(A===r)return r;if(typeof $=="boolean")return A;if($){const F=$.when;if(typeof F=="string"){const B=(Y,C,N,Q)=>{if(!Q||!A(Y,C))return null;const J=F.replace("$(basename)",N),re=Q(J);return(0,p.isThenable)(re)?re.then(le=>le?O:null):re?O:null};return B.requiresSiblings=!0,B}}return A}function q(O,$){const U=O.filter(C=>!!C.basenames);if(U.length<2)return O;const A=U.reduce((C,N)=>{const Q=N.basenames;return Q?C.concat(Q):C},[]);let F;if($){F=[];for(let C=0,N=A.length;C<N;C++)F.push($)}else F=U.reduce((C,N)=>{const Q=N.patterns;return Q?C.concat(Q):C},[]);const B=function(C,N){if(typeof C!="string")return null;if(!N){let J;for(J=C.length;J>0;J--){const re=C.charCodeAt(J-1);if(re===47||re===92)break}N=C.substr(J)}const Q=A.indexOf(N);return Q!==-1?F[Q]:null};B.basenames=A,B.patterns=F,B.allBasenames=A;const Y=O.filter(C=>!C.basenames);return Y.push(B),Y}}),define(Z[34],x([0,1,31,10,8,3,15,25,7]),function(V,e,p,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function w(s,o,m){if(typeof s=="string"&&(s=f.URI.file(s)),m){const D=m.getWorkspaceFolder(s);if(D){const R=m.getWorkspace().folders.length>1;let T;if((0,E.isEqual)(D.uri,s)?T="":T=(0,E.relativePath)(D.uri,s),R){const _=D.name?D.name:(0,E.basename)(D.uri);T=T?_+" \u2022 "+T:_}return T}}if(s.scheme!==L.Schemas.file&&s.scheme!==L.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(s.fsPath))return(0,k.normalize)(I(s.fsPath));let S=(0,k.normalize)(s.fsPath);return!M.isWindows&&o?.userHome&&(S=y(S,o.userHome.fsPath)),S}e.getPathLabel=w;function i(s){if(!s)return;typeof s=="string"&&(s=f.URI.file(s));const o=(0,E.basename)(s)||(s.scheme===L.Schemas.file?s.fsPath:s.path);return M.isWindows&&(0,p.isRootOrDriveLetter)(o)?I(o):o}e.getBaseLabel=i;function I(s){return(0,p.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=I;let P=Object.create(null);function y(s,o){if(M.isWindows||!s||!o)return s;let m=P.original===o?P.normalized:void 0;return m||(m=`${(0,n.rtrim)(o,k.posix.sep)}${k.posix.sep}`,P={original:o,normalized:m}),(M.isLinux?s.startsWith(m):(0,n.startsWithIgnoreCase)(s,m))&&(s=`~/${s.substr(m.length)}`),s}e.tildify=y;function d(s,o){return s.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=d;const g="\u2026",b="\\\\",v="~";function c(s,o=k.sep){const m=new Array(s.length);let S=!1;for(let D=0;D<s.length;D++){let R=s[D];if(R===""){m[D]=`.${o}`;continue}if(!R){m[D]=R;continue}S=!0;let T="";R.indexOf(b)===0?(T=R.substr(0,R.indexOf(b)+b.length),R=R.substr(R.indexOf(b)+b.length)):R.indexOf(o)===0?(T=R.substr(0,R.indexOf(o)+o.length),R=R.substr(R.indexOf(o)+o.length)):R.indexOf(v)===0&&(T=R.substr(0,R.indexOf(v)+v.length),R=R.substr(R.indexOf(v)+v.length));const _=R.split(o);for(let G=1;S&&G<=_.length;G++)for(let ne=_.length-G;S&&ne>=0;ne--){S=!1;let se=_.slice(ne,ne+G).join(o);for(let K=0;!S&&K<s.length;K++)if(K!==D&&s[K]&&s[K].indexOf(se)>-1){const te=ne+G===_.length,W=ne>0&&s[K].indexOf(o)>-1?o+se:se,j=s[K].endsWith(W);S=!te||j}if(!S){let K="";(_[0].endsWith(":")||T!=="")&&(ne===1&&(ne=0,G++,se=_[0]+o+se),ne>0&&(K=_[0]+o),K=T+K),ne>0&&(K=K+g+o),K=K+se,ne+G<_.length&&(K=K+o+g),m[D]=K}}S&&(m[D]=R)}return m}e.shorten=c;var h;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function a(s,o=Object.create(null)){const m=[];let S=!1,D="";for(const R of s)if(R==="$"||S&&R==="{")D&&m.push({value:D,type:h.TEXT}),D="",S=!0;else if(R==="}"&&S){const T=o[D];if(typeof T=="string")T.length&&m.push({value:T,type:h.VARIABLE});else if(T){const _=m[m.length-1];(!_||_.type!==h.SEPARATOR)&&m.push({value:T.label,type:h.SEPARATOR})}D="",S=!1}else D+=R;return D&&!S&&m.push({value:D,type:h.TEXT}),m.filter((R,T)=>{if(R.type===h.SEPARATOR){const _=m[T-1],G=m[T+1];return[_,G].every(ne=>ne&&(ne.type===h.VARIABLE||ne.type===h.TEXT)&&ne.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=a;function u(s,o){return M.isMacintosh||o?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):s.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function t(s,o){return M.isMacintosh||o?s.replace(/\(&&\w\)|&&/g,""):M.isWindows?s.replace(/&&|&/g,m=>m==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function l(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=l;function r(s){const o=s.indexOf("/")!==-1?k.posix:k.win32,m=o.basename(s),S=o.dirname(s);return m.length?{name:m,parentPath:S}:{name:S,parentPath:""}}e.splitName=r}),define(Z[28],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(f){return p.test(f)}e.isUUID=L;const k=new Uint8Array(16),M=[];for(let f=0;f<256;f++)M.push(f.toString(16).padStart(2,"0"));let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(f){for(let w=0;w<f.length;w++)f[w]=Math.floor(Math.random()*256);return f};function n(){E(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let f=0,w="";return w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+="-",w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w+=M[k[f++]],w}e.generateUuid=n}),define(Z[112],x([0,1,58,32,43]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(E,n){if(await new Promise((i,I)=>{const P=L.createReadStream(E),y=p.createHash("sha1");P.pipe(y);const d=(0,k.once)((g,b)=>{P.removeAllListeners(),y.removeAllListeners(),g?I(g):i(b)});P.once("error",d),P.once("end",d),y.once("error",d),y.once("data",g=>d(void 0,g.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=M}),define(Z[81],x([0,1,240]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(M="utf8"){this.stringDecoder=new p.StringDecoder(M),this.remaining=null}write(M){const E=[],n=this.remaining?this.remaining+this.stringDecoder.write(M):this.stringDecoder.write(M);if(n.length<1)return E;let f=0,w,i=f;for(;i<n.length;)if(w=n.charCodeAt(i),w===13||w===10){if(E.push(n.substring(f,i)),i++,i<n.length){const I=w;w=n.charCodeAt(i),(I===13&&w===10||I===10&&w===13)&&i++}f=i}else i++;return this.remaining=f<n.length?n.substr(f):null,E}end(){return this.remaining}}e.LineDecoder=L}),define(Z[113],x([0,1,26]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(n){const f=n.replace(/\-/g,":").toLowerCase();return!L.has(f)}function M(){return new Promise(async(n,f)=>{const w=setTimeout(()=>f("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await E())}catch(i){f(i)}finally{clearTimeout(w)}})}e.getMac=M;function E(){return new Promise((n,f)=>{try{const w=(0,p.networkInterfaces)();for(let i in w){const I=w[i];if(I){for(const{mac:P}of I)if(k(P))return n(P)}}f("Unable to retrieve mac address (unexpected format)")}catch(w){f(w)}})}}),define(Z[68],x([0,1,26,17,37,28,113]),function(V,e,p,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,I=0;const P=(0,p.networkInterfaces)();for(let y in P){const d=P[y];if(d)for(const{mac:g,internal:b}of d)b||(I+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(i+=1))}this._value=I>0?i/I:0}return this._value}};let n;async function f(){return n||(n=(async()=>await w()||M.generateUuid())()),n}e.getMachineId=f;async function w(){try{const i=await new Promise((P,y)=>{V(["crypto"],P,y)}),I=await(0,E.getMac)();return i.createHash("sha256").update(I,"utf8").digest("hex")}catch(i){L.onUnexpectedError(i);return}}}),define(Z[19],x([0,1,32,26,114,9,31,67,8,3,15,7,28]),function(V,e,p,L,k,M,E,n,f,w,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function d(W,j=y.UNLINK){if((0,E.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return j===y.UNLINK?b(W):g(W)}async function g(W){try{const j=(0,f.join)((0,L.tmpdir)(),(0,P.generateUuid)());try{await e.Promises.rename(W,j)}catch(H){return b(W)}b(j).catch(H=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function b(W){return e.Promises.rmdir(W,{recursive:!0,maxRetries:3})}function v(W){if((0,E.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(W,{recursive:!0})}e.rimrafSync=v;async function c(W,j){return u(await(j?h(W):(0,k.promisify)(p.readdir)(W)))}async function h(W){try{return await(0,k.promisify)(p.readdir)(W,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const j=[],H=await c(W);for(const z of H){let q=!1,O=!1,$=!1;try{const U=await e.Promises.lstat((0,f.join)(W,z));q=U.isFile(),O=U.isDirectory(),$=U.isSymbolicLink()}catch(U){console.warn("[node.js fs] unexpected error from lstat after readdir: ",U)}j.push({name:z,isFile:()=>q,isDirectory:()=>O,isSymbolicLink:()=>$})}return j}function a(W){return u(p.readdirSync(W))}e.readdirSync=a;function u(W){return W.map(j=>typeof j=="string"?w.isMacintosh?(0,n.normalizeNFC)(j):j:(j.name=w.isMacintosh?(0,n.normalizeNFC)(j.name):j.name,j))}async function t(W){const j=await c(W),H=[];for(const z of j)await r.existsDirectory((0,f.join)(W,z))&&H.push(z);return H}function l(W,j=1e3){return new Promise(H=>{let z=!1;const q=setInterval(()=>{z||(z=!0,p.access(W,O=>{z=!1,O&&(clearInterval(q),H(void 0))}))},j)})}e.whenDeleted=l;var r;(function(W){async function j(q){let O;try{if(O=await e.Promises.lstat(q),!O.isSymbolicLink())return{stat:O}}catch($){}try{return{stat:await e.Promises.stat(q),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch($){if($.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(w.isWindows&&$.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(U){if(U.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw U}throw $}}W.stat=j;async function H(q){try{const{stat:O,symbolicLink:$}=await W.stat(q);return O.isFile()&&$?.dangling!==!0}catch(O){}return!1}W.existsFile=H;async function z(q){try{const{stat:O,symbolicLink:$}=await W.stat(q);return O.isDirectory()&&$?.dangling!==!0}catch(O){}return!1}W.existsDirectory=z})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new M.ResourceQueue;function o(W,j,H){return s.queueFor(I.URI.file(W),i.extUriBiasedIgnorePathCase).queue(()=>{const z=R(H);return new Promise((q,O)=>S(W,j,z,$=>$?O($):q()))})}let m=!0;function S(W,j,H,z){if(!m)return p.writeFile(W,j,{mode:H.mode,flag:H.flag},z);p.open(W,H.flag,H.mode,(q,O)=>{if(q)return z(q);p.writeFile(O,j,$=>{if($)return p.close(O,()=>z($));p.fdatasync(O,U=>(U&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",U),m=!1),p.close(O,A=>z(A))))})})}function D(W,j,H){const z=R(H);if(!m)return p.writeFileSync(W,j,{mode:z.mode,flag:z.flag});const q=p.openSync(W,z.flag,z.mode);try{p.writeFileSync(q,j);try{p.fdatasyncSync(q)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),m=!1}}finally{p.closeSync(q)}}e.writeFileSync=D;function R(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function T(W,j){if(W===j)return;async function H(z){try{const q=await e.Promises.lstat(z);if(q.isDirectory()||q.isSymbolicLink())return;await e.Promises.utimes(z,q.atime,new Date)}catch(q){}}try{await e.Promises.rename(W,j),await H(j)}catch(z){if(W.toLowerCase()!==j.toLowerCase()&&z.code==="EXDEV"||W.endsWith("."))await _(W,j,{preserveSymlinks:!1}),await d(W,y.MOVE),await H(j);else throw z}}async function _(W,j,H){return ne(W,j,{root:{source:W,target:j},options:H,handledSourcePaths:new Set})}const G=511;async function ne(W,j,H){if(H.handledSourcePaths.has(W))return;H.handledSourcePaths.add(W);const{stat:z,symbolicLink:q}=await r.stat(W);if(q){if(H.options.preserveSymlinks)try{return await te(W,j,H)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(q.dangling)return}return z.isDirectory()?se(W,j,z.mode&G,H):K(W,j,z.mode&G)}async function se(W,j,H,z){await e.Promises.mkdir(j,{recursive:!0,mode:H});const q=await c(W);for(const O of q)await ne((0,f.join)(W,O),(0,f.join)(j,O),z)}async function K(W,j,H){await e.Promises.copyFile(W,j),await e.Promises.chmod(j,H)}async function te(W,j,H){let z=await e.Promises.readlink(W);(0,E.isEqualOrParent)(z,H.root.source,!w.isLinux)&&(z=(0,f.join)(H.root.target,z.substr(H.root.source.length+1))),await e.Promises.symlink(z,j)}e.Promises=new class{get access(){return(0,k.promisify)(p.access)}get stat(){return(0,k.promisify)(p.stat)}get lstat(){return(0,k.promisify)(p.lstat)}get utimes(){return(0,k.promisify)(p.utimes)}get read(){return(0,k.promisify)(p.read)}get readFile(){return(0,k.promisify)(p.readFile)}get write(){return(0,k.promisify)(p.write)}get appendFile(){return(0,k.promisify)(p.appendFile)}get fdatasync(){return(0,k.promisify)(p.fdatasync)}get truncate(){return(0,k.promisify)(p.truncate)}get rename(){return(0,k.promisify)(p.rename)}get copyFile(){return(0,k.promisify)(p.copyFile)}get open(){return(0,k.promisify)(p.open)}get close(){return(0,k.promisify)(p.close)}get symlink(){return(0,k.promisify)(p.symlink)}get readlink(){return(0,k.promisify)(p.readlink)}get chmod(){return(0,k.promisify)(p.chmod)}get mkdir(){return(0,k.promisify)(p.mkdir)}get unlink(){return(0,k.promisify)(p.unlink)}get rmdir(){return(0,k.promisify)(p.rmdir)}get realpath(){return(0,k.promisify)(p.realpath)}async exists(W){try{return await e.Promises.access(W),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return t}get writeFile(){return o}get rm(){return d}get move(){return T}get copy(){return _}}}),define(Z[82],x([0,1,32,8,25,19]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function E(i){const I=(0,L.dirname)(i);if(i===I)return i;const P=((0,L.basename)(i)||i).toLowerCase();try{const d=(0,M.readdirSync)(I).filter(g=>g.toLowerCase()===P);if(d.length===1){const g=E(I);if(g)return(0,L.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(P);if(g>=0){const b=E(I);if(b)return(0,L.join)(b,d[g])}}}catch(y){}return null}e.realcaseSync=E;async function n(i){try{return await M.Promises.realpath(i)}catch(I){const P=w(i);return await M.Promises.access(P,p.constants.R_OK),P}}e.realpath=n;function f(i){try{return p.realpathSync(i)}catch(I){const P=w(i);return p.accessSync(P,p.constants.R_OK),P}}e.realpathSync=f;function w(i){return(0,k.rtrim)((0,L.normalize)(i),L.sep)}}),define(Z[115],x([0,1,59]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(n,f,w,i=1){let I=!1;return new Promise(P=>{const y=setTimeout(()=>{if(!I)return I=!0,P(0)},w);k(n,f,i,d=>{if(!I)return I=!0,clearTimeout(y),P(d)})})}e.findFreePort=L;function k(n,f,w,i){if(f===0)return i(0);const I=new p.Socket;I.once("connect",()=>(E(I),k(n+w,f-1,w,i))),I.once("data",()=>{}),I.once("error",P=>(E(I),P.code!=="ECONNREFUSED"?k(n+w,f-1,w,i):i(n))),I.connect(n,"127.0.0.1")}function M(n,f,w){let i=!1,I,P=1;const y=p.createServer({pauseOnConnect:!0});function d(g,b){i||(i=!0,y.removeAllListeners(),y.close(),I&&clearTimeout(I),b(g))}return new Promise(g=>{I=setTimeout(()=>{d(0,g)},w),y.on("listening",()=>{d(n,g)}),y.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&P<f?(n++,P++,y.listen(n,"127.0.0.1")):d(0,g)}),y.on("close",()=>{d(0,g)}),y.listen(n,"127.0.0.1")})}e.findFreePortFaster=M;function E(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(f){console.error(f)}}}),define(Z[116],x([0,1,26,8,19]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,E=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var f;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(f||(f={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class I{constructor(u,t,l){this.exePath=u,this.displayName=t,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function P({useAlternateBitness:a=!1}={}){return a?w===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:a=!1,findPreview:u=!1}={}){const t=P({useAlternateBitness:a});if(!t)return null;const l=L.join(t,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(l))return null;let r=-1,s=null;for(const S of await k.Promises.readdir(l)){let D=-1;if(u){const T=S.indexOf("-");if(T<0)continue;const _=S.substring(0,T);if(!M.test(_)||S.substring(T+1)!=="preview")continue;D=parseInt(_,10)}else{if(!M.test(S))continue;D=parseInt(S,10)}if(D<=r)continue;const R=L.join(l,S,"pwsh.exe");!await k.SymlinkSupport.existsFile(R)||(s=R,r=D)}if(!s)return null;const o=t.includes("x86")?" (x86)":"",m=u?" Preview":"";return new I(s,`PowerShell${m}${o}`,!0)}async function d({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const u=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:t,pwshMsixName:l}=a?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:E,pwshMsixName:"PowerShell (Store)"};for(const r of await k.Promises.readdir(u))if(t.test(r)){const s=L.join(u,r,"pwsh.exe");return new I(s,l)}return null}function g(){const a=L.join(p.homedir(),".dotnet","tools","pwsh.exe");return new I(a,".NET Core PowerShell Global Tool")}function b(){const a=L.join(process.env.windir,w===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(a,"Windows PowerShell",!0)}async function*v(){let a=await y();a&&(yield a),a=await y({useAlternateBitness:!0}),a&&(yield a),a=await d(),a&&(yield a),a=g(),a&&(yield a),a=await y({findPreview:!0}),a&&(yield a),a=await d({findPreview:!0}),a&&(yield a),a=await y({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=b(),a&&(yield a)}async function*c(){for await(const a of v())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=c;async function h(){for await(const a of c())return a;return null}e.getFirstAvailablePowerShellInstallation=h}),define(Z[83],x([0,1,41,10]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(E){return new Promise((n,f)=>{let w;const i=new Map;function I(y,d,g,b,v){const c=i.get(d);if(y===E||c){const h={name:P(g),cmd:g,pid:y,ppid:d,load:b,mem:v};i.set(y,h),y===E&&(w=h),c&&(c.children||(c.children=[]),c.children.push(h),c.children.length>1&&(c.children=c.children.sort((a,u)=>a.pid-u.pid)))}}function P(y){const d=/--disable-blink-features=Auxclick/,g=/\\watcher\\win32\\CodeHelper\.exe/,b=/--crashes-directory/,v=/\\pipe\\winpty-control/,c=/conhost\.exe/,h=/--type=([a-zA-Z-]+)/;if(g.exec(y))return"watcherService ";if(b.exec(y))return"electron-crash-reporter";if(v.exec(y))return"winpty-process";if(c.exec(y))return"console-window-host (Windows internal process)";let a=h.exec(y);if(a&&a.length===2)return a[1]==="renderer"?d.exec(y)?"shared-process":"window":a[1];const u=/[a-zA-Z-]+\.js/g;let t="";do a=u.exec(y),a&&(t+=a+" ");while(a);return t&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${t}`:y}if(process.platform==="win32"){const y=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,g)=>{V(["windows-process-tree"],d,g)}).then(d=>{d.getProcessList(E,g=>{d.getProcessCpuUsage(g,b=>{const v=new Map;b.forEach(c=>{const h=y(c.commandLine||"");v.set(c.pid,{name:P(h),cmd:h,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),w=v.get(E),w?(v.forEach(c=>{const h=v.get(c.ppid);h&&(h.children||(h.children=[]),h.children.push(c))}),v.forEach(c=>{c.children&&(c.children=c.children.sort((h,a)=>h.pid-a.pid))}),n(w)):f(new Error(`Root process ${E} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let y=function(){let d=[w];const g=[];for(;d.length;){const v=d.shift();v&&(g.push(v.pid),v.children&&(d=d.concat(v.children)))}let b=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",V).fsPath);b+=" "+g.join(" "),(0,p.exec)(b,{},(v,c,h)=>{if(v||h)f(v||new Error(h.toString()));else{const a=c.toString().split(`
`);for(let u=0;u<g.length;u++){const t=i.get(g[u]);t.load=parseFloat(a[u])}if(!w){f(new Error(`Root process ${E} not found`));return}n(w)}})};(0,p.exec)("which ps",{},(d,g,b)=>{if(d||b)if(process.platform!=="linux")f(d||new Error(b.toString()));else{const v=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",V).fsPath);(0,p.exec)(v,{},(c,h,a)=>{c||a?f(c||new Error(a.toString())):(M(h,I),y())})}else{const v=g.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${v} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,a,u)=>{h||u&&!u.includes("screen size is bogus")?f(h||new Error(u.toString())):(M(a,I),process.platform==="linux"?y():w?n(w):f(new Error(`Root process ${E} not found`)))})}})}})}e.listProcesses=k;function M(E,n){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=E.toString().split(`
`);for(const i of w){const I=f.exec(i.trim());I&&I.length===6&&n(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(Z[117],x([0,1,32,23,31,2,67,8,3,19]),function(V,e,p,L,k,M,E,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function i(d,g,b){return P({path:d,isDirectory:!1},g,b)}e.watchFile=i;function I(d,g,b){return P({path:d,isDirectory:!0},g,b)}e.watchFolder=I,e.CHANGE_BUFFER_DELAY=100;function P(d,g,b){if(f.isMacintosh&&(0,k.isEqualOrParent)(d.path,"/Volumes/"))return b(`Refusing to watch ${d.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const v=(0,n.basename)(d.path),c=new Map;let h=!1,a=[(0,M.toDisposable)(()=>{c.forEach(u=>(0,M.dispose)(u)),c.clear()})];try{const u=(0,p.watch)(d.path);a.push((0,M.toDisposable)(()=>{u.removeAllListeners(),u.close()}));const t=new Set;d.isDirectory&&w.Promises.readdir(d.path).then(l=>l.forEach(r=>t.add(r))),u.on("error",(l,r)=>{h||b(`Failed to watch ${d.path} for changes using fs.watch() (${l}, ${r})`)}),u.on("change",(l,r)=>{if(h)return;let s="";if(r&&(s=r.toString(),f.isMacintosh&&(s=(0,E.normalizeNFC)(s))),!s||l!=="change"&&l!=="rename")return;const o=d.isDirectory?(0,n.join)(d.path,s):d.path;if(d.isDirectory)if(l==="rename"){const m=c.get(o);m&&(0,M.dispose)(m);const S=setTimeout(async()=>{c.delete(o);const D=await w.Promises.exists(o);if(h)return;let R;D?t.has(s)?R="changed":(R="added",t.add(s)):(t.delete(s),R="deleted"),g(R,o)},e.CHANGE_BUFFER_DELAY);c.set(o,(0,M.toDisposable)(()=>clearTimeout(S)))}else{let m;t.has(s)?m="changed":(m="added",t.add(s)),g(m,o)}else if(l==="rename"||s!==v){const m=setTimeout(async()=>{const S=await w.Promises.exists(o);h||(S?(g("changed",o),a=[P(d,g,b)]):g("deleted",o))},e.CHANGE_BUFFER_DELAY);(0,M.dispose)(a),a=[(0,M.toDisposable)(()=>clearTimeout(m))]}else g("changed",o)})}catch(u){w.Promises.exists(d.path).then(t=>{t&&!h&&b(`Failed to watch ${d.path} for changes using fs.watch() (${u.toString()})`)})}return(0,M.toDisposable)(()=>{h=!0,a=(0,M.dispose)(a)})}async function y(d,g,b,v=512){const c=await w.Promises.open(d,"r"),h=Buffer.allocUnsafe(v),a=new L.CancellationTokenSource(b);let u,t=!1;const l=i(d,async r=>{if(r==="changed"){if(t)return;t=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:s}=await w.Promises.read(c,h,0,v,null);if(!s||a.token.isCancellationRequested)break;g(h.slice(0,s))}}catch(s){u=new Error(s),a.dispose(!0)}finally{t=!1}}},r=>{u=new Error(r),a.dispose(!0)});return new Promise((r,s)=>{a.token.onCancellationRequested(async()=>{l.dispose(),await w.Promises.close(c),u?s(u):r()})})}e.watchFileContents=y}),define(Z[118],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[119],x([0,1,14,13,118]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){p.ipcMain.on(k.CONTEXT_MENU_CHANNEL,(n,f,w,i,I)=>{const P=E(n,i,w);P.popup({window:(0,L.withNullAsUndefined)(p.BrowserWindow.fromWebContents(n.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{P&&n.sender.send(k.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=M;function E(n,f,w){const i=new p.Menu;return w.forEach(I=>{let P;I.type==="separator"?P=new p.MenuItem({type:I.type}):Array.isArray(I.submenu)?P=new p.MenuItem({submenu:E(n,f,I.submenu),label:I.label}):P=new p.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(y,d,g)=>n.sender.send(f,I.id,g)}),i.append(P)}),i}});var he=this&&this.__decorate||function(V,e,p,L){var k=arguments.length,M=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,p):L,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(V,e,p,L);else for(var n=V.length-1;n>=0;n--)(E=V[n])&&(M=(k<3?E(M):k>3?E(e,p,M):E(e,p))||M);return k>3&&M&&Object.defineProperty(e,p,M),M};define(Z[35],x([0,1,30,9,18,23,47,17,4,2,110,25,13]),function(V,e,p,L,k,M,E,n,f,w,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function d(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function b(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(v||(v={}));class c{constructor(O){this.buffer=O,this.pos=0}read(O){const $=this.buffer.slice(this.pos,this.pos+O);return this.pos+=$.byteLength,$}}class h{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var a;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(a||(a={}));function u(q){const O=k.VSBuffer.alloc(4);return O.writeUInt32BE(q,0),O}function t(q){return q.read(4).readUInt32BE(0)}function l(q){const O=k.VSBuffer.alloc(1);return O.writeUInt8(q,0),O}const r={Undefined:l(a.Undefined),String:l(a.String),Buffer:l(a.Buffer),VSBuffer:l(a.VSBuffer),Array:l(a.Array),Object:l(a.Object)},s=typeof Buffer!="undefined";function o(q,O){if(typeof O=="undefined")q.write(r.Undefined);else if(typeof O=="string"){const $=k.VSBuffer.fromString(O);q.write(r.String),q.write(u($.byteLength)),q.write($)}else if(s&&Buffer.isBuffer(O)){const $=k.VSBuffer.wrap(O);q.write(r.Buffer),q.write(u($.byteLength)),q.write($)}else if(O instanceof k.VSBuffer)q.write(r.VSBuffer),q.write(u(O.byteLength)),q.write(O);else if(Array.isArray(O)){q.write(r.Array),q.write(u(O.length));for(const $ of O)o(q,$)}else{const $=k.VSBuffer.fromString(JSON.stringify(O));q.write(r.Object),q.write(u($.byteLength)),q.write($)}}function m(q){switch(q.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return q.read(t(q)).toString();case a.Buffer:return q.read(t(q)).buffer;case a.VSBuffer:return q.read(t(q));case a.Array:{const $=t(q),U=[];for(let A=0;A<$;A++)U.push(m(q));return U}case a.Object:return JSON.parse(q.read(t(q)).toString())}}class S{constructor(O,$,U=null,A=1e3){this.protocol=O,this.ctx=$,this.logger=U,this.timeoutDelay=A,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(F=>this.onRawMessage(F)),this.sendResponse({type:200})}registerChannel(O,$){this.channels.set(O,$),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const $=this.send([O.type]);this.logger&&this.logger.logOutgoing($,0,1,b(O.type));return}case 201:case 202:case 204:case 203:{const $=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing($,O.id,1,b(O.type),O.data);return}}}send(O,$=void 0){const U=new h;return o(U,O),o(U,$),this.sendBuffer(U.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch($){return 0}}onRawMessage(O){const $=new c(O),U=m($),A=m($),F=U[0];switch(F){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,U[1],1,`${d(F)}: ${U[2]}.${U[3]}`,A),this.onPromise({type:F,id:U[1],channelName:U[2],name:U[3],arg:A});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,U[1],1,`${d(F)}: ${U[2]}.${U[3]}`,A),this.onEventListen({type:F,id:U[1],channelName:U[2],name:U[3],arg:A});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,U[1],1,`${d(F)}`),this.disposeActiveRequest({type:F,id:U[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,U[1],1,`${d(F)}`),this.disposeActiveRequest({type:F,id:U[1]})}}onPromise(O){const $=this.channels.get(O.channelName);if(!$){this.collectPendingRequest(O);return}const U=new M.CancellationTokenSource;let A;try{A=$.call(this.ctx,O.name,O.arg,U.token)}catch(Y){A=Promise.reject(Y)}const F=O.id;A.then(Y=>{this.sendResponse({id:F,data:Y,type:201}),this.activeRequests.delete(O.id)},Y=>{Y instanceof Error?this.sendResponse({id:F,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:F,data:Y,type:203}),this.activeRequests.delete(O.id)});const B=(0,w.toDisposable)(()=>U.cancel());this.activeRequests.set(O.id,B)}onEventListen(O){const $=this.channels.get(O.channelName);if(!$){this.collectPendingRequest(O);return}const U=O.id,F=$.listen(this.ctx,O.name,O.arg)(B=>this.sendResponse({id:U,data:B,type:204}));this.activeRequests.set(O.id,F)}disposeActiveRequest(O){const $=this.activeRequests.get(O.id);$&&($.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let $=this.pendingRequests.get(O.channelName);$||($=[],this.pendingRequests.set(O.channelName,$));const U=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);$.push({request:O,timeoutTimer:U})}flushPendingRequests(O){const $=this.pendingRequests.get(O);if($){for(const U of $)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=S;var D;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(O,$=null){this.protocol=O,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=$}getChannel(O){const $=this;return{call(U,A,F){return $.isDisposed?Promise.reject(n.canceled()):$.requestPromise(O,U,A,F)},listen(U,A){return $.isDisposed?Promise.reject(n.canceled()):$.requestEvent(O,U,A)}}}requestPromise(O,$,U,A=M.CancellationToken.None){const F=this.lastRequestId++,Y={id:F,type:100,channelName:O,name:$,arg:U};if(A.isCancellationRequested)return Promise.reject(n.canceled());let C;return new Promise((Q,J)=>{if(A.isCancellationRequested)return J(n.canceled());const re=()=>{const ue=de=>{switch(de.type){case 201:this.handlers.delete(F),Q(de.data);break;case 202:this.handlers.delete(F);const pe=new Error(de.data.message);pe.stack=de.data.stack,pe.name=de.data.name,J(pe);break;case 203:this.handlers.delete(F),J(de.data);break}};this.handlers.set(F,ue),this.sendRequest(Y)};let le=null;this.state===v.Idle?re():(le=(0,L.createCancelablePromise)(ue=>this.whenInitialized()),le.then(()=>{le=null,re()}));const ee=()=>{le?(le.cancel(),le=null):this.sendRequest({id:F,type:101}),J(n.canceled())},ae=A.onCancellationRequested(ee);C=(0,w.combinedDisposable)((0,w.toDisposable)(ee),ae),this.activeRequests.add(C)}).finally(()=>{this.activeRequests.delete(C)})}requestEvent(O,$,U){const A=this.lastRequestId++,B={id:A,type:102,channelName:O,name:$,arg:U};let Y=null;const C=new f.Emitter({onFirstListenerAdd:()=>{Y=(0,L.createCancelablePromise)(Q=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(C),this.sendRequest(B)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(C),this.sendRequest({id:A,type:103}))}}),N=Q=>C.fire(Q.data);return this.handlers.set(A,N),C.event}sendRequest(O){switch(O.type){case 100:case 102:{const $=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing($,O.id,0,`${d(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const $=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing($,O.id,0,d(O.type));return}}}send(O,$=void 0){const U=new h;return o(U,O),o(U,$),this.sendBuffer(U.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch($){return 0}}onBuffer(O){const $=new c(O),U=m($),A=m($),F=U[0];switch(F){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,b(F)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,U[1],0,b(F),A),this.onResponse({type:U[0],id:U[1],data:A})}}onResponse(O){if(O.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const $=this.handlers.get(O.id);$&&$(O)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}he([E.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class T{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:$,onDidClientDisconnect:U})=>{f.Event.once($.onMessage)(F=>{const B=new c(F),Y=m(B),C=new S($,Y),N=new R($);this.channels.forEach((J,re)=>C.registerChannel(re,J));const Q={channelServer:C,channelClient:N,ctx:Y};this._connections.add(Q),this._onDidAddConnection.fire(Q),U(()=>{C.dispose(),N.dispose(),this._connections.delete(Q),this._onDidRemoveConnection.fire(Q)})})})}get connections(){const O=[];return this._connections.forEach($=>O.push($)),O}getChannel(O,$){const U=this;return{call(A,F,B){let Y;if((0,P.isFunction)($)){let N=(0,p.getRandomElement)(U.connections.filter($));Y=N?Promise.resolve(N):f.Event.toPromise(f.Event.filter(U.onDidAddConnection,$))}else Y=$.routeCall(U,A,F);const C=Y.then(N=>N.channelClient.getChannel(O));return G(C).call(A,F,B)},listen(A,F){if((0,P.isFunction)($))return U.getMulticastEvent(O,$,A,F);const B=$.routeEvent(U,A,F).then(Y=>Y.channelClient.getChannel(O));return G(B).listen(A,F)}}}getMulticastEvent(O,$,U,A){const F=this;let B=new w.DisposableStore;const Y=new f.Emitter({onFirstListenerAdd:()=>{B=new w.DisposableStore;const C=new f.EventMultiplexer,N=new Map,Q=re=>{const ee=re.channelClient.getChannel(O).listen(U,A),ae=C.add(ee);N.set(re,ae)},J=re=>{const le=N.get(re);!le||(le.dispose(),N.delete(re))};F.connections.filter($).forEach(Q),f.Event.filter(F.onDidAddConnection,$)(Q,void 0,B),F.onDidRemoveConnection(J,void 0,B),C.event(Y.fire,Y,B),B.add(C)},onLastListenerRemove:()=>{B.dispose()}});return Y.event}registerChannel(O,$){this.channels.set(O,$),this._connections.forEach(U=>{U.channelServer.registerChannel(O,$)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class _{constructor(O,$,U=null){const A=new h;o(A,$),O.send(A.buffer),this.channelClient=new R(O,U),this.channelServer=new S(O,$,U)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,$){this.channelServer.registerChannel(O,$)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function G(q){return{call(O,$,U){return q.then(A=>A.call(O,$,U))},listen(O,$){const U=new f.Relay;return q.then(A=>U.input=A.listen(O,$)),U.event}}}e.getDelayedChannel=G;function ne(q){let O=!1;return{call($,U,A){return O?q.call($,U,A):(0,L.timeout)(0).then(()=>O=!0).then(()=>q.call($,U,A))},listen($,U){if(O)return q.listen($,U);const A=new f.Relay;return(0,L.timeout)(0).then(()=>O=!0).then(()=>A.input=q.listen($,U)),A.event}}}e.getNextTickChannel=ne;class se{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const $ of O.connections)if(await Promise.resolve(this.fn($.ctx)))return Promise.resolve($);return await f.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=se;var K;(function(q){function O(F,B){const Y=F,C=B&&B.disableMarshalling,N=new Map;for(const Q in Y)U(Q)&&N.set(Q,f.Event.buffer(Y[Q],!0));return new class{listen(Q,J,re){const le=N.get(J);if(le)return le;if(A(J)){const ee=Y[J];if(typeof ee=="function")return ee.call(Y,re)}throw new Error(`Event not found: ${J}`)}call(Q,J,re){const le=Y[J];if(typeof le=="function"){if(!C&&Array.isArray(re))for(let ee=0;ee<re.length;ee++)re[ee]=(0,i.revive)(re[ee]);return le.apply(Y,re)}throw new Error(`Method not found: ${J}`)}}}q.fromService=O;function $(F,B){const Y=B&&B.disableMarshalling;return new Proxy({},{get(C,N){if(typeof N=="string")return B?.properties?.has(N)?B.properties.get(N):A(N)?function(Q){return F.listen(N,Q)}:U(N)?F.listen(N):async function(...Q){let J;B&&!(0,P.isUndefinedOrNull)(B.context)?J=[B.context,...Q]:J=Q;const re=await F.call(N,J);return Y?re:(0,i.revive)(re)};throw new Error(`Property not found: ${String(N)}`)}})}q.toService=$;function U(F){return F[0]==="o"&&F[1]==="n"&&I.isUpperAsciiLetter(F.charCodeAt(2))}function A(F){return/^onDynamic/.test(F)&&I.isUpperAsciiLetter(F.charCodeAt(9))}})(K=e.ProxyChannel||(e.ProxyChannel={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let O=q.toString();if(O!=="[object Object]")return O}return q}function j(q){return Array.isArray(q)?q.map(W):W(q)}function H(q,O,$,U,A,F,B){B=j(B);const Y=te[A],C=Y[U%Y.length];let N=[`%c[${q}]%c[${String(O).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${F}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(F)?(N=N.concat(B),N.push(")")):N.push(B),console.log.apply(console,N)}e.logWithColors=H;class z{constructor(O,$){this._outgoingPrefix=O,this._incomingPrefix=$,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,$,U,A,F){this._totalOutgoing+=O,H(this._outgoingPrefix,this._totalOutgoing,O,$,U,A,F)}logIncoming(O,$,U,A,F){this._totalIncoming+=O,H(this._incomingPrefix,this._totalIncoming,O,$,U,A,F)}}e.IPCLogger=z}),define(Z[120],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class p{constructor(k,M){this.sender=k,this.onMessage=M}send(k){try{this.sender.send("vscode:message",k.buffer)}catch(M){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=p}),define(Z[121],x([0,1,18,4,35]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(f){this.port=f,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",w=>p.VSBuffer.wrap(w.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=M;class E extends k.IPCClient{constructor(f,w){const i=new M(f);super(i,w);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=E}),define(Z[84],x([0,1,18,4,2,3,33,35]),function(V,e,p,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var f;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function i(){return w||(w=p.VSBuffer.alloc(0)),w}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,o){if(s===0)return i();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const R=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=s),R}if(this._chunks[0].byteLength>s){const R=this._chunks[0].slice(0,s);return o&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),R}let m=p.VSBuffer.alloc(s),S=0,D=0;for(;s>0;){const R=this._chunks[D];if(R.byteLength>s){const T=R.slice(0,s);m.set(T,S),S+=s,o&&(this._chunks[D]=R.slice(s),this._totalLength-=s),s-=s}else m.set(R,S),S+=R.byteLength,o?(this._chunks.shift(),this._totalLength-=R.byteLength):D++,s-=R.byteLength}return m}}e.ChunkStream=I;var P;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(P||(P={}));var y;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(y=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(s,o,m,S){this.type=s,this.id=o,this.ack=m,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends k.Disposable{constructor(s){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5);else{const m=this._state.messageType,S=this._state.id,D=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(m,S,D,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class b{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=p.VSBuffer.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this._writeSoon(o,s.data)}_bufferAdd(s,o){const m=this._totalLength===0;return this._data.push(s,o),this._totalLength+=s.byteLength+o.byteLength,m}_bufferTake(){const s=p.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,o){this._bufferAdd(s,o)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class v extends k.Disposable{constructor(s){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new b(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new d(1,0,0,s))}}e.Protocol=v;class c extends n.IPCClient{constructor(s,o,m=null){super(s,o,m);this.protocol=s}static fromSocket(s,o){return new c(new v(s),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=c;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,E.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class a{constructor(s){this.data=s,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],o=0,m=this._first;for(;m;)s[o++]=m.data,m=m.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const o=new a(s);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class t{constructor(){this.lastRuns=[];const s=Date.now();for(let o=0;o<t._HISTORY_LENGTH;o++)this.lastRuns[o]=s-1e3*o;setInterval(()=>{for(let o=t._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const s=Date.now(),o=(1+t._HISTORY_LENGTH)*1e3;let m=0;for(let S=0;S<t._HISTORY_LENGTH;S++)s-this.lastRuns[S]<=o&&m++;return 1-m/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class l{constructor(s,o=null,m=t.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=m,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(S=>this._receiveMessage(S))),this._socketDisposables.push(this._socket.onClose(S=>this._onSocketClose.fire(S))),o&&this._socketReader.acceptChunk(o),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new d(5,0,0,i());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const o=new d(4,0,0,i());this._socketWriter.write(o),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,o){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(m=>this._receiveMessage(m))),this._socketDisposables.push(this._socket.onClose(m=>this._onSocketClose.fire(m))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let o=0,m=s.length;o<m;o++)this._socketWriter.write(s[o]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new d(6,0,0,i())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const o=this._outgoingUnackMsg.toArray();for(let m=0,S=o.length;m<S;m++)this._socketWriter.write(o[m]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const m=new d(1,o,this._incomingAckId,s);this._outgoingUnackMsg.push(m),this._isReconnecting||(this._socketWriter.write(m),this._recvAckCheck())}sendControl(s){const o=new d(2,0,0,s);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),o=Date.now()-s.writtenTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-o,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new d(3,0,this._incomingAckId,i());this._socketWriter.write(s)}}e.PersistentProtocol=l}),define(Z[122],x([0,1,14,18,4,2,35,120]),function(V,e,p,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(i,I){const P=k.Event.fromNodeEventEmitter(p.ipcMain,I,(d,g)=>({event:d,message:g})),y=k.Event.filter(P,({event:d})=>d.sender.id===i);return k.Event.map(y,({message:d})=>d&&L.VSBuffer.wrap(d))}class w extends E.IPCServer{constructor(){super(w.getOnDidClientConnect())}static getOnDidClientConnect(){const I=k.Event.fromNodeEventEmitter(p.ipcMain,"vscode:hello",({sender:P})=>P);return k.Event.map(I,P=>{const y=P.id,d=w.Clients.get(y);d&&d.dispose();const g=new k.Emitter;w.Clients.set(y,(0,M.toDisposable)(()=>g.fire()));const b=f(y,"vscode:message"),v=k.Event.any(k.Event.signal(f(y,"vscode:disconnect")),g.event);return{protocol:new n.Protocol(P,b),onDidClientDisconnect:v}})}}e.Server=w,w.Clients=new Map}),define(Z[85],x([0,1,14,4,28,121]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class E extends M.Client{constructor(w,i){super({addEventListener:(I,P)=>w.addListener(I,P),removeEventListener:(I,P)=>w.removeListener(I,P),postMessage:I=>w.postMessage(I),start:()=>w.start(),close:()=>w.close()},i)}}e.Client=E;async function n(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,k.generateUuid)();f.webContents.send("vscode:createMessageChannel",w);const i=L.Event.fromNodeEventEmitter(p.ipcMain,"vscode:createMessageChannelResult",(P,y)=>({nonce:y,port:P.ports[0]})),{port:I}=await L.Event.toPromise(L.Event.once(L.Event.filter(i,P=>P.nonce===w)));return I}e.connect=n}),define(Z[86],x([0,1,9,4,2,13]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var E;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(E=e.StorageHint||(e.StorageHint={}));function n(I){const P=I;return P?.changed instanceof Map||P?.deleted instanceof Set}e.isStorageItemsChangeEvent=n;var f;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(f||(f={}));class w extends k.Disposable{constructor(P,y=Object.create(null)){super();this.database=P,this.options=y,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=new p.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(P=>this.onDidChangeItemsExternal(P)))}onDidChangeItemsExternal(P){P.changed?.forEach((y,d)=>this.accept(d,y)),P.deleted?.forEach(y=>this.accept(y,void 0))}accept(P,y){if(this.state===f.Closed)return;let d=!1;(0,M.isUndefinedOrNull)(y)?d=this.cache.delete(P):this.cache.get(P)!==y&&(this.cache.set(P,y),d=!0),d&&this._onDidChangeStorage.fire(P)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(P,y){const d=this.cache.get(P);return(0,M.isUndefinedOrNull)(d)?y:d}getBoolean(P,y){const d=this.get(P);return(0,M.isUndefinedOrNull)(d)?y:d==="true"}getNumber(P,y){const d=this.get(P);return(0,M.isUndefinedOrNull)(d)?y:parseInt(d,10)}async set(P,y){if(this.state===f.Closed)return;if((0,M.isUndefinedOrNull)(y))return this.delete(P);const d=String(y);if(this.cache.get(P)!==d)return this.cache.set(P,d),this.pendingInserts.set(P,d),this.pendingDeletes.delete(P),this._onDidChangeStorage.fire(P),this.flushDelayer.trigger(()=>this.flushPending())}async delete(P){if(!(this.state===f.Closed||!this.cache.delete(P)))return this.pendingDeletes.has(P)||this.pendingDeletes.add(P),this.pendingInserts.delete(P),this._onDidChangeStorage.fire(P),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(P){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const P={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(P).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(P=>this.whenFlushedCallbacks.push(P))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(P){P.insert&&P.insert.forEach((y,d)=>this.items.set(d,y)),P.delete&&P.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=i}),define(Z[123],x([0,1,9,4,37,8,19]),function(V,e,p,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(i,I=Object.create(null)){this.path=i,this.options=I,this.name=(0,M.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return L.Event.None}async getItems(){const i=await this.whenConnected,I=new Map;return(await this.all(i,"SELECT * FROM ItemTable")).forEach(y=>I.set(y.key,y.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(i){const I=await this.whenConnected;return this.doUpdateItems(I,i)}doUpdateItems(i,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?(0,k.mapToString)(I.insert):"0"}), delete(${I.delete?(0,k.setToString)(I.delete):"0"})`),this.transaction(i,()=>{const P=I.insert,y=I.delete;if(P&&P.size>0){const d=[];d.push([]);let g=0;P.forEach((b,v)=>{let c=d[g];c.length>n.MAX_HOST_PARAMETERS&&(g++,c=[],d.push(c)),c.push(v,b)}),d.forEach(b=>{this.prepare(i,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,v=>v.run(b),()=>{const v=[];let c=0;return P.forEach((h,a)=>{v.push(a),c+=h.length}),`Keys: ${v.join(", ")} Length: ${c}`})})}if(y&&y.size){const d=[];d.push([]);let g=0;y.forEach(b=>{let v=d[g];v.length>n.MAX_HOST_PARAMETERS&&(g++,v=[],d.push(v)),v.push(b)}),d.forEach(b=>{this.prepare(i,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,v=>v.run(b),()=>{const v=[];return y.forEach(c=>{v.push(c)}),`Keys: ${v.join(", ")}`})})}})}async close(i){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,i)}doClose(i,I){return new Promise((P,y)=>{i.db.close(d=>(d&&this.handleSQLiteError(i,`[storage ${this.name}] close(): ${d}`),this.path===n.IN_MEMORY_PATH?P():!i.isErroneous&&!i.isInMemory?this.backup().then(P,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),P())):typeof I=="function"?E.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const b=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:I()}).then(()=>b(),v=>(b(),Promise.reject(v)))})).then(P,y):y(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const i=this.toBackupPath(this.path);return E.Promises.copy(this.path,i,{preserveSymlinks:!1})}toBackupPath(i){return`${i}.backup`}async checkIntegrity(i){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${i})`);const I=await this.whenConnected,P=await this.get(I,i?"PRAGMA integrity_check":"PRAGMA quick_check"),y=i?P.integrity_check:P.quick_check;return I.isErroneous?`${y} (last error: ${I.lastError})`:I.isInMemory?`${y} (in-memory!)`:y}async connect(i,I=!0){this.logger.trace(`[storage ${this.name}] open(${i}, retryOnBusy: ${I})`);try{return await this.doConnect(i)}catch(P){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${P}`),P.code==="SQLITE_BUSY"&&I)return await(0,p.timeout)(n.BUSY_OPEN_TIMEOUT),this.connect(i,!1);try{await E.Promises.unlink(i);try{await E.Promises.rename(this.toBackupPath(i),i)}catch(y){}return await this.doConnect(i)}catch(y){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${y}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(i,I){i.isErroneous=!0,i.lastError=I,this.logger.error(I)}doConnect(i){return new Promise((I,P)=>{new Promise((y,d)=>{V(["@vscode/sqlite3"],y,d)}).then(y=>{const d={db:new(this.logger.isTracing?y.verbose().Database:y.Database)(i,g=>g?d.db?d.db.close(()=>P(g)):P(g):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(d),b=>d.db.close(()=>P(b)))),isInMemory:i===n.IN_MEMORY_PATH};d.db.on("error",g=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&d.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},P)})}exec(i,I){return new Promise((P,y)=>{i.db.exec(I,d=>d?(this.handleSQLiteError(i,`[storage ${this.name}] exec(): ${d}`),y(d)):P())})}get(i,I){return new Promise((P,y)=>{i.db.get(I,(d,g)=>d?(this.handleSQLiteError(i,`[storage ${this.name}] get(): ${d}`),y(d)):P(g))})}all(i,I){return new Promise((P,y)=>{i.db.all(I,(d,g)=>d?(this.handleSQLiteError(i,`[storage ${this.name}] all(): ${d}`),y(d)):P(g))})}transaction(i,I){return new Promise((P,y)=>{i.db.serialize(()=>{i.db.run("BEGIN TRANSACTION"),I(),i.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(i,`[storage ${this.name}] transaction(): ${d}`),y(d)):P())})})}prepare(i,I,P,y){const d=i.db.prepare(I),g=b=>{this.handleSQLiteError(i,`[storage ${this.name}] prepare(): ${b} (${I}). Details: ${y()}`)};d.on("error",g),P(d),d.finalize(b=>{b&&g(b),d.removeListener("error",g)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class f{constructor(i){i&&typeof i.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=i.logTrace),i&&typeof i.logError=="function"&&(this.logError=i.logError)}get isTracing(){return!!this.logTrace}trace(i){this.logTrace&&this.logTrace(i)}error(i){this.logError&&this.logError(i)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[124],x([12,11]),function(V,e){return V.create("vs/base/common/date",e)}),define(Z[125],x([0,1,124]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,M=k*24,E=M*7,n=M*30,f=M*365;function w(I,P){typeof I!="number"&&(I=I.getTime());const y=Math.round((new Date().getTime()-I)/1e3);if(y<-30)return(0,p.localize)(0,null,w(new Date().getTime()+y*1e3,!1));if(y<30)return(0,p.localize)(1,null);let d;return y<L?(d=y,P?d===1?(0,p.localize)(2,null,d):(0,p.localize)(3,null,d):d===1?(0,p.localize)(4,null,d):(0,p.localize)(5,null,d)):y<k?(d=Math.floor(y/L),P?d===1?(0,p.localize)(6,null,d):(0,p.localize)(7,null,d):d===1?(0,p.localize)(8,null,d):(0,p.localize)(9,null,d)):y<M?(d=Math.floor(y/k),P?d===1?(0,p.localize)(10,null,d):(0,p.localize)(11,null,d):d===1?(0,p.localize)(12,null,d):(0,p.localize)(13,null,d)):y<E?(d=Math.floor(y/M),P?d===1?(0,p.localize)(14,null,d):(0,p.localize)(15,null,d):d===1?(0,p.localize)(16,null,d):(0,p.localize)(17,null,d)):y<n?(d=Math.floor(y/E),P?d===1?(0,p.localize)(18,null,d):(0,p.localize)(19,null,d):d===1?(0,p.localize)(20,null,d):(0,p.localize)(21,null,d)):y<f?(d=Math.floor(y/n),P?d===1?(0,p.localize)(22,null,d):(0,p.localize)(23,null,d):d===1?(0,p.localize)(24,null,d):(0,p.localize)(25,null,d)):(d=Math.floor(y/f),P?d===1?(0,p.localize)(26,null,d):(0,p.localize)(27,null,d):d===1?(0,p.localize)(28,null,d):(0,p.localize)(29,null,d))}e.fromNow=w;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(Z[126],x([12,11]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(Z[60],x([0,1,30,13,126]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function M(w,i){return i&&(w.stack||w.stacktrace)?k.localize(0,null,n(w),E(w.stack)||E(w.stacktrace)):n(w)}function E(w){return Array.isArray(w)?w.join(`
`):w}function n(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?k.localize(1,null,w.message):w.message||k.localize(2,null)}function f(w=null,i=!1){if(!w)return k.localize(3,null);if(Array.isArray(w)){const I=p.coalesce(w),P=f(I[0],i);return I.length>1?k.localize(4,null,P,I.length):P}if(L.isString(w))return w;if(w.detail){const I=w.detail;if(I.error)return M(I.error,i);if(I.exception)return M(I.exception,i)}return w.stack?M(w,i):w.message?w.message:k.localize(5,null)}e.toErrorMessage=f}),define(Z[127],x([12,11]),function(V,e){return V.create("vs/base/common/keybindingLabels",e)}),define(Z[128],x([0,1,127]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(E,n,f=n){this.modifierLabels=[null],this.modifierLabels[2]=E,this.modifierLabels[1]=n,this.modifierLabels[3]=f}toLabel(E,n,f){if(n.length===0)return null;const w=[];for(let i=0,I=n.length;i<I;i++){const P=n[i],y=f(P);if(y===null)return null;w[i]=k(P,y,this.modifierLabels[E])}return w.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:p.localize(0,null),shiftKey:p.localize(1,null),altKey:p.localize(2,null),metaKey:p.localize(3,null),separator:"+"},{ctrlKey:p.localize(4,null),shiftKey:p.localize(5,null),altKey:p.localize(6,null),metaKey:p.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:p.localize(8,null),shiftKey:p.localize(9,null),altKey:p.localize(10,null),metaKey:p.localize(11,null),separator:"+"},{ctrlKey:p.localize(12,null),shiftKey:p.localize(13,null),altKey:p.localize(14,null),metaKey:p.localize(15,null),separator:"+"},{ctrlKey:p.localize(16,null),shiftKey:p.localize(17,null),altKey:p.localize(18,null),metaKey:p.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function k(M,E,n){if(E===null)return"";const f=[];return M.ctrlKey&&f.push(n.ctrlKey),M.shiftKey&&f.push(n.shiftKey),M.altKey&&f.push(n.altKey),M.metaKey&&f.push(n.metaKey),E!==""&&f.push(E),f.join(n.separator)}}),define(Z[129],x([12,11]),function(V,e){return V.create("vs/base/node/processes",e)}),define(Z[69],x([0,1,41,31,10,44,8,3,33,78,13,81,19,129]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return w.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return w.TerminateResponseCode}});function d(u){switch(u){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(u,t){if(n.isWindows)try{const l={stdio:["pipe","pipe","ignore"]};t&&(l.cwd=t);const r=p.execFile("taskkill",["/T","/F","/PID",u.pid.toString()],l);return new Promise(s=>{r.once("error",o=>{s({success:!1,error:o})}),r.once("exit",(o,m)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(l){return Promise.resolve({success:!1,error:l,code:l.status?d(l.status):1})}else if(n.isLinux||n.isMacintosh)try{const l=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",V).fsPath;return new Promise(r=>{p.execFile(l,[u.pid.toString()],{encoding:"utf8",shell:!0},(s,o,m)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(l){return Promise.resolve({success:!1,error:l})}else u.kill("SIGKILL");return Promise.resolve({success:!0})}function b(u=f.env){return u.comspec||"cmd.exe"}e.getWindowsShell=b;class v{constructor(t,l,r,s){if(l!==void 0&&r!==void 0&&s!==void 0)this.cmd=t,this.args=l,this.shell=r,this.options=s;else{const o=t;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(f.env).forEach(m=>{o[m]=f.env[m]}),Object.keys(this.options.env).forEach(m=>{o[m]=this.options.env[m]}),this.options.env=o}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const l=t.lastIndexOf(E.sep);return l!==-1&&(t=t.substring(l+1)),v.WellKnowCommands[t]?t:"other"}start(t){return n.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(f.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(l=>{let r,s;const o=new Promise((m,S)=>{r=m,s=S});if(l){let m=this.cmd;this.args&&(m=m+" "+this.args.join(" ")),this.childProcess=p.exec(m,this.options,(S,D,R)=>{this.childProcess=null;const T=S;T&&T.killed?s({killed:this.terminateRequested,stdout:D.toString(),stderr:R.toString()}):this.handleExec(r,t,S,D,R)})}else{let m=null;const S=D=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(D,r,t,s);const R={terminated:this.terminateRequested};i.isNumber(D)&&(R.cmdCode=D),r(R)};if(this.shell&&n.isWindows){const D=M.deepClone(this.options);D.windowsVerbatimArguments=!0,D.detached=!1;let R=!1,T=!1;const _=[];let G=this.ensureQuotes(this.cmd);_.push(G.value),R=G.quoted,this.args&&this.args.forEach(se=>{G=this.ensureQuotes(se),_.push(G.value),T=T&&G.quoted});const ne=["/s","/c"];R?T?ne.push('"'+_.join(" ")+'"'):_.length>1?ne.push('"'+_[0]+'" '+_.slice(1).join(" ")):ne.push('"'+_[0]+'"'):ne.push(_.join(" ")),m=p.spawn(b(),ne,D)}else this.cmd&&(m=p.spawn(this.cmd,this.args,this.options));m&&(this.childProcess=m,this.childProcessPromise=Promise.resolve(m),this.pidResolve&&(this.pidResolve(i.isNumber(m.pid)?m.pid:-1),this.pidResolve=void 0),m.on("error",D=>{this.childProcess=null,s({terminated:this.terminateRequested,error:D})}),m.pid&&(this.childProcess.on("close",S),this.handleSpawn(m,r,t,s,!0)))}return o})}handleClose(t,l,r,s){}ensureQuotes(t){return v.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,g(t,this.options.cwd).then(l=>(l.success&&(this.childProcess=null),l))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!n.isWindows)return t(!1);const l=p.spawn(b(),["/s","/c"]);l.on("error",r=>t(!0)),l.on("exit",r=>t(!1))})}}e.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class c extends v{constructor(t,l,r,s){super(t,l,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,l,r,s,o){[s,o].forEach((m,S)=>{const D=new I.LineDecoder;D.write(m).forEach(_=>{l({line:_,source:S===0?0:1})});const T=D.end();T&&l({line:T,source:S===0?0:1})}),t({terminated:this.terminateRequested,error:r})}handleSpawn(t,l,r,s,o){const m=new I.LineDecoder,S=new I.LineDecoder;t.stdout.on("data",D=>{m.write(D).forEach(T=>r({line:T,source:0}))}),t.stderr.on("data",D=>{S.write(D).forEach(T=>r({line:T,source:1}))}),this.stdoutLineDecoder=m,this.stderrLineDecoder=S}handleClose(t,l,r,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&r({line:o,source:0});const m=this.stderrLineDecoder?this.stderrLineDecoder.end():null;m&&r({line:m,source:1})}}e.LineProcess=c;function h(u){let t=[],l=!1;const r=function(s){if(l){t.push(s);return}(!u.send(s,m=>{if(m&&console.error(m),l=!1,t.length>0){const S=t.slice(0);t=[],S.forEach(D=>r(D))}})||n.isWindows)&&(l=!0)};return{send:r}}e.createQueuedSender=h;var a;(function(u){async function t(l,r,s){if(E.isAbsolute(l))return l;if(r===void 0&&(r=f.cwd()),E.dirname(l)!=="."||(s===void 0&&i.isString(f.env.PATH)&&(s=f.env.PATH.split(E.delimiter)),s===void 0||s.length===0))return E.join(r,l);async function m(S){if(await P.Promises.exists(S)){let D;try{D=await P.Promises.stat(S)}catch(R){R.message.startsWith("EACCES")&&(D=await P.Promises.lstat(S))}return D?!D.isDirectory():!1}return!1}for(let S of s){let D;if(E.isAbsolute(S)?D=E.join(S,l):D=E.join(r,S,l),await m(D))return D;let R=D+".com";if(await m(R)||(R=D+".exe",await m(R)))return R}return E.join(r,l)}u.findExecutable=t})(a=e.win32||(e.win32={}))}),define(Z[130],x([0,1,26,3,116,69]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function E(y,d){return y===1?L.isWindows?I():M.getWindowsShell(d):w(y,d)}e.getSystemShell=E;function n(y,d){return y===1?L.isWindows?P(d):M.getWindowsShell(d):w(y,d)}e.getSystemShellSync=n;let f=null;function w(y,d){if(L.isLinux&&y===2||L.isMacintosh&&y===3)return"/bin/bash";if(!f){let g;if(L.isWindows)g="/bin/bash";else{if(g=d.SHELL,!g)try{g=(0,p.userInfo)().shell}catch(b){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}f=g}return f}let i=null;async function I(){return i||(i=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),i}function P(y){if(i)return i;const d=L.isWindows&&parseFloat((0,p.release)())>=10,g=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${y.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?b:M.getWindowsShell(y)}}),define(Z[87],x([0,1,41,9,18,23,109,17,4,2,44,3,69,35]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends y.ChannelServer{constructor(v){super({send:c=>{try{process.send&&process.send(c.buffer.toString("base64"))}catch(h){}},onMessage:f.Event.fromNodeEventEmitter(process,"message",c=>k.VSBuffer.wrap(Buffer.from(c,"base64")))},v);process.once("disconnect",()=>this.dispose())}}e.Server=d;class g{constructor(v,c){this.modulePath=v,this.options=c,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=c&&c.timeout?c.timeout:6e4;this.disposeDelayer=new L.Delayer(h),this.child=null,this._client=null}getChannel(v){const c=this;return{call(h,a,u){return c.requestPromise(v,h,a,u)},listen(h,a){return c.requestEvent(v,h,a)}}}requestPromise(v,c,h,a=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(n.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(v),t=(0,L.createCancelablePromise)(s=>u.call(c,h,s)),l=a.onCancellationRequested(()=>t.cancel()),r=(0,w.toDisposable)(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{l.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(v,c,h){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let a;const u=new f.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(v).listen(c,h)(u.fire,u),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],c=Object.create(null);c.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(c.env={...c.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(c.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),I.isMacintosh&&c.env&&delete c.env.DYLD_LIBRARY_PATH,this.child=(0,p.fork)(this.modulePath,v,c);const h=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,E.isRemoteConsoleLog)(o)){(0,E.log)(o,`IPC Library: ${this.options.serverName}`);return}h.fire(k.VSBuffer.wrap(Buffer.from(o,"base64")))});const u=this.options.useQueue?(0,P.createQueuedSender)(this.child):this.child,t=o=>this.child&&this.child.connected&&u.send(o.buffer.toString("base64")),l=h.event,r={send:t,onMessage:l};this._client=new y.ChannelClient(r);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,m)=>{process.removeListener("exit",s),this.activeRequests.forEach(S=>(0,w.dispose)(S)),this.activeRequests.clear(),o!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+m),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:m})})}return this._client}getCachedChannel(v){let c=this.channels.get(v);return c||(c=this.client.getChannel(v),this.channels.set(v,c)),c}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(Z[131],x([12,11]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(Z[132],x([12,11]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[133],x([12,11]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[134],x([12,11]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(Z[135],x([12,11]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(Z[136],x([12,11]),function(V,e){return V.create("vs/platform/environment/node/shellEnv",e)}),define(Z[137],x([12,11]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[138],x([12,11]),function(V,e){return V.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[139],x([12,11]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[140],x([12,11]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(Z[141],x([12,11]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(Z[142],x([12,11]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(Z[143],x([12,11]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[144],x([12,11]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[145],x([12,11]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[146],x([12,11]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[147],x([12,11]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(Z[148],x([12,11]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[149],x([12,11]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[150],x([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/window",e)}),define(Z[151],x([12,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[152],x([12,11]),function(V,e){return V.create("vs/platform/workspaces/common/workspaces",e)}),define(Z[153],x([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[154],x([12,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[155],x([0,1,4,2]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new p.Emitter,this._onReloadEmitter=new p.Emitter,this._onTerminateEmitter=new p.Emitter,this._onAttachEmitter=new p.Emitter}call(n,f,w){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(n,f,w){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class M extends L.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,f,w){this.channel.call("attach",[n,f,w])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,f){this.channel.call("terminate",[n,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,f,w){return this.channel.call("openExtensionDevelopmentHostWindow",[n,f||{},w])}}e.ExtensionHostDebugChannelClient=M}),define(Z[156],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class p{constructor(E){this.driver=E}listen(E,n){throw new Error(`No event found: ${n}`)}call(E,n,f){switch(n){case"click":return this.driver.click(f[0],f[1],f[2]);case"doubleClick":return this.driver.doubleClick(f);case"setValue":return this.driver.setValue(f[0],f[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(f);case"getElements":return this.driver.getElements(f[0],f[1]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=p;class L{constructor(E){this.channel=E}click(E,n,f){return this.channel.call("click",[E,n,f])}doubleClick(E){return this.channel.call("doubleClick",E)}setValue(E,n){return this.channel.call("setValue",[E,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(E){return this.channel.call("isActiveElement",E)}getElements(E,n){return this.channel.call("getElements",[E,n])}getElementXY(E,n,f){return this.channel.call("getElementXY",[E,n,f])}typeInEditor(E,n){return this.channel.call("typeInEditor",[E,n])}getTerminalBuffer(E){return this.channel.call("getTerminalBuffer",E)}writeInTerminal(E,n){return this.channel.call("writeInTerminal",[E,n])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=L;class k{constructor(E){this.channel=E}registerWindowDriver(E){return this.channel.call("registerWindowDriver",E)}reloadWindowDriver(E){return this.channel.call("reloadWindowDriver",E)}}e.WindowDriverRegistryChannelClient=k}),define(Z[157],x([0,1,125,47,10,8,33,15,7]),function(V,e,p,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(g,b,v){this._args=g,this.paths=b,this.productService=v}get appRoot(){return(0,M.dirname)(k.FileAccess.asFileUri("",V).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,n.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,n.joinPath)(f.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return f.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return f.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=E.env.VSCODE_PORTABLE;return g?f.URI.file((0,M.join)(g,"argv.json")):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,n.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,M.resolve)(g):(0,M.normalize)((0,M.join)(k.FileAccess.asFileUri("",V).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,M.resolve)(g):(0,M.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,M.resolve)(g);const b=E.env.VSCODE_EXTENSIONS;if(b)return b;const v=E.env.VSCODE_PORTABLE;return v?(0,M.join)(v,"extensions"):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(b=>/^[^:/?#]+?:\/\//.test(b)?f.URI.parse(b):f.URI.file((0,M.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?f.URI.parse(g):f.URI.file((0,M.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!E.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,n.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return f.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],w.prototype,"appRoot",null),he([L.memoize],w.prototype,"userHome",null),he([L.memoize],w.prototype,"userDataPath",null),he([L.memoize],w.prototype,"appSettingsHome",null),he([L.memoize],w.prototype,"tmpDir",null),he([L.memoize],w.prototype,"userRoamingDataHome",null),he([L.memoize],w.prototype,"settingsResource",null),he([L.memoize],w.prototype,"userDataSyncHome",null),he([L.memoize],w.prototype,"userDataSyncLogResource",null),he([L.memoize],w.prototype,"sync",null),he([L.memoize],w.prototype,"machineSettingsResource",null),he([L.memoize],w.prototype,"globalStorageHome",null),he([L.memoize],w.prototype,"workspaceStorageHome",null),he([L.memoize],w.prototype,"keybindingsResource",null),he([L.memoize],w.prototype,"keyboardLayoutResource",null),he([L.memoize],w.prototype,"argvResource",null),he([L.memoize],w.prototype,"snippetsHome",null),he([L.memoize],w.prototype,"isExtensionDevelopment",null),he([L.memoize],w.prototype,"untitledWorkspacesHome",null),he([L.memoize],w.prototype,"installSourcePath",null),he([L.memoize],w.prototype,"builtinExtensionsPath",null),he([L.memoize],w.prototype,"extensionsPath",null),he([L.memoize],w.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],w.prototype,"extensionDevelopmentKind",null),he([L.memoize],w.prototype,"extensionTestsLocationURI",null),he([L.memoize],w.prototype,"debugExtensionHost",null),he([L.memoize],w.prototype,"serviceMachineIdResource",null),he([L.memoize],w.prototype,"telemetryLogResource",null),he([L.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function i(d,g){return y(d["inspect-extensions"],d["inspect-brk-extensions"],5870,g,d.debugId)}e.parseExtensionHostPort=i;function I(d,g){return y(d["inspect-search"],d["inspect-brk-search"],5876,g)}e.parseSearchPort=I;function P(d,g){return y(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,g)}e.parsePtyHostPort=P;function y(d,g,b,v,c){const a=Number(g||d)||(v?null:b),u=a?Boolean(!!g):!1;return{port:a,break:u,debugId:c}}}),define(Z[88],x([0,1,241,3,134]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,k.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},category:{type:"string",cat:"e",description:(0,k.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,k.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,k.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,k.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,k.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,k.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const E={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(d,g,b=E){const v={},c=[],h=[];for(let l in g){const r=g[l];r.alias&&(v[l]=r.alias),r.type==="string"||r.type==="string[]"?(c.push(l),r.deprecates&&c.push(r.deprecates)):r.type==="boolean"&&(h.push(l),r.deprecates&&h.push(r.deprecates))}const a=p(d,{string:c,boolean:h,alias:v}),u={},t=a;u._=a._.map(l=>String(l)).filter(l=>l.length>0),delete t._;for(let l in g){const r=g[l];r.alias&&delete t[r.alias];let s=t[l];r.deprecates&&t.hasOwnProperty(r.deprecates)&&(s||(s=t[r.deprecates]),delete t[r.deprecates]),typeof s!="undefined"&&(r.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):r.type==="string"&&Array.isArray(s)&&(s=s.pop(),b.onMultipleValues(l,s)),u[l]=s),delete t[l]}for(let l in t)b.onUnknownOption(l);return u}e.parseArgs=n;function f(d,g){let b="";return g.args&&(Array.isArray(g.args)?b=` <${g.args.join("> <")}>`:b=` <${g.args}>`),g.alias?`-${g.alias} --${d}${b}`:`--${d}${b}`}function w(d,g){let b=0,v=[];for(const u in d){const t=d[u],l=f(u,t);b=Math.max(b,l.length),v.push([l,t.description])}let c=b+2+1;if(g-c<25)return v.reduce((u,t)=>u.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let h=g-c-1,a=[];for(const u of v){let t=u[0],l=I(u[1],h),r=i(c-t.length-2);a.push("  "+t+r+l[0]);for(let s=1;s<l.length;s++)a.push(i(c)+l[s])}return a}e.formatOptions=w;function i(d){return" ".repeat(d)}function I(d,g){let b=[];for(;d.length;){let v=d.length<g?d.length:d.lastIndexOf(" ",g),c=d.slice(0,v).trim();d=d.slice(v),b.push(c)}return b}function P(d,g,b,v,c=!0){const h=process.stdout.isTTY&&process.stdout.columns||80;let a=[`${d} ${b}`];a.push(""),a.push(`${(0,k.localize)(32,null)}: ${g} [${(0,k.localize)(33,null)}][${(0,k.localize)(34,null)}...]`),a.push(""),c&&(L.isWindows?a.push((0,k.localize)(35,null,g)):a.push((0,k.localize)(36,null,g)),a.push(""));const u={};for(const t in v){const l=v[t];if(l.description&&l.cat){let r=u[l.cat];r||(u[l.cat]=r={}),r[t]=l}}for(let t in u){const l=t;let r=u[l];r&&(a.push(M[l]),a.push(...w(r,h)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=P;function y(d,g){return`${d||(0,k.localize)(37,null)}
${g||(0,k.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=y}),define(Z[158],x([0,1,59,155,88]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends L.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,f,w){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(w[0],w[1],w[2]):super.call(n,f,w)}async openExtensionDevelopmentHostWindow(n,f,w){const i=(0,k.parseArgs)(n,k.OPTIONS);i.debugRenderer=w;const I=i.extensionDevelopmentPath;if(!I)return{success:!1};let P;const y=Object.keys(f);for(let h of y){let a=f[h];a===null||(P||(P=Object.create(null)),P[h]=a)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(I,{context:5,cli:i,userEnv:P});if(!w)return{success:!0};const g=d.win;if(!g)return{success:!0};const b=g.webContents.debugger;let v=b.isAttached()?1/0:0;const c=(0,p.createServer)(h=>{v++==0&&b.attach();let a=!1;const u=r=>{a||h.write(JSON.stringify(r)+"\0")},t=(r,s,o,m)=>u({method:s,params:o,sessionId:m});g.on("close",()=>{b.removeListener("message",t),h.end(),a=!0}),b.addListener("message",t);let l=Buffer.alloc(0);h.on("data",r=>{l=Buffer.concat([l,r]);for(let s=l.indexOf(0);s!==-1;s=l.indexOf(0)){let o;try{const m=l.slice(0,s).toString("utf8");l=l.slice(s+1),o=JSON.parse(m)}catch(m){console.error("error reading cdp line",m)}b.sendCommand(o.method,o.params,o.sessionId).then(m=>u({id:o.id,sessionId:o.sessionId,result:m})).catch(m=>u({id:o.id,sessionId:o.sessionId,error:{code:0,message:m.message}}))}}),h.on("error",r=>{console.error("error on cdp pipe:",r)}),h.on("close",()=>{a=!0,--v==0&&b.detach()})});return await new Promise(h=>c.listen(0,h)),g.on("close",()=>c.close()),{rendererDebugPort:c.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),function(){"use strict";function V(e,p,L,k){function M(n){const f=E(n),w=[f];return e.isAbsolute(f)||w.unshift(k),e.resolve(...w)}function E(n){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,L);const i=n["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(I,"AppData","Roaming")}break;case"darwin":w=e.join(p.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,L)}return{getUserDataPath:M}}if(typeof define=="function")define(Z[159],x([0,160,26,10,15,33]),function(e,p,L,k,M,E){const n=M.dirname(k.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(M.joinPath(n,"package.json").fsPath);return V(p,L,f.name,E.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),L=require("os");module.exports=V(p,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[161],x([0,1,26,157,159]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends L.AbstractNativeEnvironmentService{constructor(n,f){super(n,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,k.getUserDataPath)(n)},f)}}e.NativeEnvironmentService=M}),define(Z[162],x([0,1,32,26,8]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function M(E){const n=(0,k.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return p.writeFileSync(n,""),E&&console.log(`Marker file for --wait created: ${n}`),n}catch(f){E&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=M}),define(Z[163],x([0,1,138]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function M(P){return P=P.trim(),P==="*"||L.test(P)}e.isValidVersionStr=M;function E(P){if(!M(P))return null;if(P=P.trim(),P==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=P.match(L);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=E;function n(P){if(!P)return null;let y=P.majorBase,d=P.majorMustEqual,g=P.minorBase,b=P.minorMustEqual,v=P.patchBase,c=P.patchMustEqual;P.hasCaret&&(y===0||(b=!1),c=!1);let h=0;if(P.preRelease){const a=k.exec(P.preRelease);if(a){const[,u,t,l]=a;h=Date.UTC(Number(u),Number(t)-1,Number(l))}}return{majorBase:y,majorMustEqual:d,minorBase:g,minorMustEqual:b,patchBase:v,patchMustEqual:c,isMinimum:P.hasGreaterEquals,notBefore:h}}e.normalizeVersion=n;function f(P,y,d){let g;typeof P=="string"?g=n(E(P)):g=P;let b;y instanceof Date?b=y.getTime():typeof y=="string"&&(b=new Date(y).getTime());let v;if(typeof d=="string"?v=n(E(d)):v=d,!g||!v)return!1;let c=g.majorBase,h=g.minorBase,a=g.patchBase,u=v.majorBase,t=v.minorBase,l=v.patchBase,r=v.notBefore,s=v.majorMustEqual,o=v.minorMustEqual,m=v.patchMustEqual;return v.isMinimum?c>u?!0:c<u?!1:h>t?!0:h<t||b&&b<r?!1:a>=l:(c===1&&u===0&&(!s||!o||!m)&&(u=1,t=0,l=0,s=!0,o=!1,m=!1),c<u?!1:c>u?!s:h<t?!1:h>t?!o:a<l?!1:a>l?!m:!(b&&b<r))}e.isValidVersion=f;function w(P,y,d,g){return d.isBuiltin||typeof d.main=="undefined"?!0:I(P,y,d.engines.vscode,g)}e.isValidExtensionVersion=w;function i(P,y,d){return P==="*"||I(y,d,P)}e.isEngineValid=i;function I(P,y,d,g=[]){let b=n(E(d));if(!b)return g.push(p.localize(0,null,d)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return g.push(p.localize(1,null,d)),!1}else if(!b.majorMustEqual)return g.push(p.localize(2,null,d)),!1;return f(P,y,b)?!0:(g.push(p.localize(3,null,P,d)),!1)}}),define(Z[164],x([0,1,2,10,35,87]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends p.Disposable{constructor(f,w,i,I){super();this.requests=f,this.onDidFilesChange=w,this.onLogMessage=i,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new M.Client(L.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.watch(this.requests)}setVerboseLogging(f){this.verboseLogging=f,this.isDisposed||this.service?.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}watch(f){this.requests=f,this.service?.watch(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(Z[165],x([0,1,2,10,35,87]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends p.Disposable{constructor(f,w,i,I,P={}){super();this.folders=f,this.onDidFilesChange=w,this.onLogMessage=i,this.verboseLogging=I,this.watcherOptions=P,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new M.Client(L.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.service.watch(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}watch(f){this.folders=f,this.service&&this.service.watch(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(Z[166],x([0,1,41,111,10,81]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class E{constructor(f,w,i,I,P){this.watchedFolder=f,this.eventCallback=i,this.logCallback=I,this.verboseLogging=P,this.restartCounter=0,Array.isArray(w)?this.ignored=w.map(y=>(0,L.parse)(y)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}, excludes: ${w.join(",")}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=(0,p.spawn)(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",V).fsPath,f);const w=new M.LineDecoder;this.handle.stdout.on("data",i=>{const I=[];for(const P of w.write(i)){const y=P.split("|");if(y.length===2){const d=Number(y[0]),g=y[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(b=>b(g))){this.verboseLogging&&this.log(g);continue}I.push({type:E.changeTypeMap[d],path:g})}else this.log(y[1])}}I.length>0&&this.eventCallback(I)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,I)=>this.onExit(i,I))}onError(f){this.error("process error: "+f.toString())}onExit(f,w){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${w})`),this.restartCounter<=E.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=E,E.MAX_RESTARTS=5,E.changeTypeMap=[0,1,2]}),define(Z[167],x([0,1,8,25,166]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M{constructor(n,f,w,i){this.onDidFilesChange=f,this.onLogMessage=w,this.verboseLogging=i,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(p.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,p.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new k.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=M}),define(Z[70],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(k,M=[],E=!1){this.ctor=k,this.staticArguments=M,this.supportsDelayedInstantiation=E}}e.SyncDescriptor=p}),define(Z[168],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=p;class L{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(let E of this._nodes.values())E.outgoing.size===0&&M.push(E);return M}insertEdge(M,E){const n=this.lookupOrInsertNode(M),f=this.lookupOrInsertNode(E);n.outgoing.set(this._hashFn(E),f),f.incoming.set(this._hashFn(M),n)}removeNode(M){const E=this._hashFn(M);this._nodes.delete(E);for(let n of this._nodes.values())n.outgoing.delete(E),n.incoming.delete(E)}lookupOrInsertNode(M){const E=this._hashFn(M);let n=this._nodes.get(E);return n||(n=new p(M),this._nodes.set(E,n)),n}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){let M=[];for(let[E,n]of this._nodes)M.push(`${E}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(let[M,E]of this._nodes){const n=new Set([M]),f=this._findCycle(E,n);if(f)return f}}_findCycle(M,E){for(let[n,f]of M.outgoing){if(E.has(n))return[...E,n].join(" -> ");E.add(n);const w=this._findCycle(f,E);if(w)return w;E.delete(n)}}}e.Graph=L}),define(Z[5],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function f(w){return w[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=f})(p=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(n,f,w,i){f[p.DI_TARGET]===f?f[p.DI_DEPENDENCIES].push({id:n,index:w,optional:i}):(f[p.DI_DEPENDENCIES]=[{id:n,index:w,optional:i}],f[p.DI_TARGET]=f)}function k(n){if(p.serviceIds.has(n))return p.serviceIds.get(n);const f=function(w,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(f,w,I,!1)};return f.toString=()=>n,p.serviceIds.set(n,f),f}e.createDecorator=k;function M(n){return n}e.refineServiceDecorator=M;function E(n){return function(f,w,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(n,f,i,!0)}}e.optional=E}),define(Z[71],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function L(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[89],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,p.createDecorator)("encryptionMainService");class L{constructor(M){this.machineId=M}encryption(){return new Promise((M,E)=>V(["vscode-encrypt"],M,E))}async encrypt(M){try{return(await this.encryption()).encrypt(this.machineId,M)}catch(E){return M}}async decrypt(M){try{return(await this.encryption()).decrypt(this.machineId,M)}catch(E){return M}}}e.EncryptionMainService=L}),define(Z[48],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[169],x([0,1,10,137,5]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var M;(function(c){c.WIN32_X64="win32-x64",c.WIN32_IA32="win32-ia32",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(M=e.TargetPlatform||(e.TargetPlatform={}));function E(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=E;function n(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=n;function f(c,h){switch(c){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=f;function w(c,h){return h==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function i(c,h,a){return w(h,a)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===a?!0:I(a).includes(c)}e.isTargetPlatformCompatible=i;function I(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function P(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=P;var y;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var d;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(d=e.SortOrder||(e.SortOrder={}));var g;(function(c){c.Install="install",c.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var b;(function(c){c[c.None=0]="None",c[c.Install=1]="Install",c[c.Update=2]="Update"})(b=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class v extends Error{constructor(h,a){super(h);this.code=a,this.name=a}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=p.FileAccess.asBrowserUri("./media/defaultIcon.png",V).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")}),define(Z[170],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,p.createDecorator)("extensionUrlTrustService")}),define(Z[171],x([0,1,25,5]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=k;function M(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class n{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,P){if(typeof I=="undefined"||I===null)return typeof P=="undefined"||P===null;if(typeof P=="undefined"||P===null)return!1;if(typeof I=="string"||typeof P=="string"){let y=typeof I=="string"?I:I.value,d=typeof P=="string"?P:P.value;return p.equalsIgnoreCase(y,d)}return I._lower===P._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=n;function f(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function w(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[172],x([0,1,25,171]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(d,g){return d.uuid&&g.uuid?d.uuid===g.uuid:d.id===g.id?!0:(0,p.compareIgnoreCase)(d.id,g.id)===0}e.areSameExtensions=k;class M{constructor(g,b){this.version=b,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof M?k(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=M;function E(d,g){return`${d}.${g}`}e.getExtensionId=E;function n(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function f(d,g){return n(E(d,g))}e.getGalleryExtensionId=f;function w(d,g){const b=[],v=c=>{for(const h of b)if(h.some(a=>k(g(a),g(c))))return h;return null};for(const c of d){const h=v(c);h?h.push(c):b.push([c])}return b}e.groupByExtension=w;function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function P(d){const g=new Set;for(const b of d)b.malicious&&g.add(b.id.id);return g}e.getMaliciousExtensionsSet=P;function y(d,g){const b=[],v=g.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const c=v.shift();if(c&&b.every(h=>!k(h.identifier,{id:c}))){const h=d.filter(a=>k(a.identifier,{id:c}));h.length===1&&(b.push(h[0]),v.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=y}),define(Z[90],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(Z[173],x([0,1,41,10,8,3,78,19,69,139,90]),function(V,e,p,L,k,M,E,n,f,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=w.localize(0,null);class P{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends P{openTerminal(a,u){return this.spawnTerminal(p,a,f.getWindowsShell(),u)}spawnTerminal(a,u,t,l){const r=u.windowsExec||y.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const s=k.basename(r).toLowerCase();if(s==="cmder"||s==="cmder.exe")return a.spawn(r,l?[l]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return r.indexOf(" ")>=0&&o.push('""'),o.push(r),(s==="wt"||s==="wt.exe")&&o.push("-d ."),new Promise((m,S)=>{const D=b(process),R=a.spawn(t,o,{cwd:l,env:D});R.on("error",S),R.on("exit",()=>m())})}runInTerminal(a,u,t,l,r){const s="windowsExec"in r&&r.windowsExec?r.windowsExec:y.getDefaultTerminalWindows();return new Promise((o,m)=>{const S=`"${u} - ${I}"`,D=`""${t.join('" "')}" & pause"`,R=["/c","start",S,"/wait",s,"/c",D],T=Object.assign({},b(process),l);Object.keys(T).filter(ne=>T[ne]===null).forEach(ne=>delete T[ne]);const _={cwd:u,env:T,windowsVerbatimArguments:!0};p.spawn(y.CMD,R,_).on("error",ne=>{m(v(ne))}),o(void 0)})}static getDefaultTerminalWindows(){if(!y._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return y._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=y,y.CMD="cmd.exe";class d extends P{openTerminal(a,u){return this.spawnTerminal(p,a,u)}runInTerminal(a,u,t,l,r){const s=r.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((o,m)=>{if(s===i.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const S=s===i.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`,V).fsPath,"-t",a||I,"-w",u];for(let G of t)R.push("-a"),R.push(G);if(l){const G=Object.assign({},b(process),l);for(let ne in G){const se=G[ne];se===null?(R.push("-u"),R.push(ne)):(R.push("-e"),R.push(`${ne}=${se}`))}}let T="";const _=p.spawn(d.OSASCRIPT,R);_.on("error",G=>{m(v(G))}),_.stderr.on("data",G=>{T+=G.toString()}),_.on("exit",G=>{if(G===0)o(void 0);else if(T){const ne=T.split(`
`,1);m(new Error(ne[0]))}else m(new Error(w.localize(1,null,S,G)))})}else m(new Error(w.localize(2,null,s)))})}spawnTerminal(a,u,t){const l=u.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((r,s)=>{const o=["-a",l];t&&o.push(t);const m=b(process),S=a.spawn("/usr/bin/open",o,{cwd:t,env:m});S.on("error",s),S.on("exit",()=>r())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class g extends P{openTerminal(a,u){return this.spawnTerminal(p,a,u)}runInTerminal(a,u,t,l,r){const s=r.linuxExec?Promise.resolve(r.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((o,m)=>{let S=[];s.then(D=>{D.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const R=`${c(t)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;S.push(`''${R}''`);const T=Object.assign({},b(process),l);Object.keys(T).filter(se=>T[se]===null).forEach(se=>delete T[se]);const _={cwd:u,env:T};let G="";const ne=p.spawn(D,S,_);ne.on("error",se=>{m(v(se))}),ne.stderr.on("data",se=>{G+=se.toString()}),ne.on("exit",se=>{if(se===0)o(void 0);else if(G){const K=G.split(`
`,1);m(new Error(K[0]))}else m(new Error(w.localize(4,null,D,se)))})})})}static async getDefaultTerminalLinuxReady(){return g._DEFAULT_TERMINAL_LINUX_READY||(g._DEFAULT_TERMINAL_LINUX_READY=new Promise(async a=>{M.isLinux?await n.Promises.exists("/etc/debian_version")?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm"):a("xterm")})),g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,u,t){const l=u.linuxExec?Promise.resolve(u.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((r,s)=>{l.then(o=>{const m=b(process),S=a.spawn(o,[],{cwd:t,env:m});S.on("error",s),S.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=w.localize(3,null);function b(h){const a={...h.env};return(0,E.sanitizeProcessEnvironment)(a),a}function v(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(w.localize(5,null,h.path)):h}function c(h){let a="";for(let u of h)u.indexOf(" ")>=0?a+='"'+u+'"':a+=u,a+=" ";return a}}),define(Z[20],x([0,1,37,8,25,13,7,141,5]),function(V,e,p,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function w(W){return W.create===!0}e.isFileOpenForWriteOptions=w;var i;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(W){W[W.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var P;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock"})(P=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=y;function d(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=d;function g(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function b(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=b;var v;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(j,H){super(j);this.code=H}}e.FileSystemProviderError=c;function h(W,j){const H=new c(W.toString(),j);return u(H,j),H}e.createFileSystemProviderError=h;function a(W){return W||h((0,n.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=a;function u(W,j){return W.name=j?`${j} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=u;function t(W){if(!W)return v.Unknown;if(W instanceof c)return W.code;const j=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!j)return v.Unknown;switch(j[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=t;function l(W){if(W instanceof D)return W.fileOperationResult;switch(t(W)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var r;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class s{constructor(j,H,z){this.resource=j,this.operation=H,this.target=z}isOperation(j){return this.operation===j}}e.FileOperationEvent=s;var o;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class m{constructor(j,H){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const z of j)switch(z.type){case 1:this.added||(this.added=p.TernarySearchTree.forUris(()=>H)),this.added.set(z.resource,z);break;case 0:this.updated||(this.updated=p.TernarySearchTree.forUris(()=>H)),this.updated.set(z.resource,z);break;case 2:this.deleted||(this.deleted=p.TernarySearchTree.forUris(()=>H)),this.deleted.set(z.resource,z);break}}contains(j,...H){return this.doContains(j,{includeChildren:!1},...H)}affects(j,...H){return this.doContains(j,{includeChildren:!0},...H)}doContains(j,H,...z){if(!j)return!1;const q=z.length>0;return!!((!q||z.includes(1))&&(this.added?.get(j)||H.includeChildren&&this.added?.findSuperstr(j))||(!q||z.includes(0))&&(this.updated?.get(j)||H.includeChildren&&this.updated?.findSuperstr(j))||(!q||z.includes(2))&&(this.deleted?.findSubstr(j)||H.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=m;function S(W,j,H){return!W||!j||W===j||j.length>W.length?!1:(j.charAt(j.length-1)!==L.sep&&(j+=L.sep),H?(0,k.startsWithIgnoreCase)(W,j):W.indexOf(j)===0)}e.isParent=S;class D extends Error{constructor(j,H,z){super(j);this.fileOperationResult=H,this.options=z}}e.FileOperationError=D;class R extends D{constructor(j,H,z){super(j,2,z);this.stat=H}}e.NotModifiedSinceFileOperationError=R;var T;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function G(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=G;async function ne(W,j){if(!j.canHandleResource(E.URI.from({scheme:W.scheme})))return new Promise(H=>{const z=j.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===W.scheme&&q.added&&(z.dispose(),H())})})}e.whenProviderRegistered=ne,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class se{static formatSize(j){return(0,M.isNumber)(j)||(j=0),j<se.KB?(0,n.localize)(1,null,j.toFixed(0)):j<se.MB?(0,n.localize)(2,null,(j/se.KB).toFixed(2)):j<se.GB?(0,n.localize)(3,null,(j/se.MB).toFixed(2)):j<se.TB?(0,n.localize)(4,null,(j/se.GB).toFixed(2)):(0,n.localize)(5,null,(j/se.TB).toFixed(2))}}e.ByteSize=se,se.KB=1024,se.MB=se.KB*se.KB,se.GB=se.MB*se.KB,se.TB=se.GB*se.KB;var K;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(K=e.Arch||(e.Arch={}));function te(W){return{maxFileSize:W===0?300*se.MB:16*se.GB,maxHeapSize:W===0?700*se.MB:2*700*se.MB}}e.getPlatformLimits=te}),define(Z[54],x([0,1,242,135,88,20]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function E(P,y){const d={onUnknownOption:b=>{console.warn((0,L.localize)(0,null,b))},onMultipleValues:(b,v)=>{console.warn((0,L.localize)(1,null,b,v))}},g=(0,k.parseArgs)(P,k.OPTIONS,y?d:void 0);return g.goto&&g._.forEach(b=>p(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,L.localize)(2,null))),g["max-memory"]&&p(parseInt(g["max-memory"])>=M.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${M.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function n(P){const y=P.findIndex(d=>!/^-/.test(d));if(y>-1)return[...P.slice(0,y),...P.slice(y+1)]}function f(P){let[,...y]=P;process.env.VSCODE_DEV&&(y=n(y)||[]);const d=!I(process.env);return E(y,d)}e.parseMainProcessArgv=f;function w(P){const[,,...y]=P;return E(y,!0)}e.parseCLIProcessArgv=w;function i(P,...y){const d=P.indexOf("--");return d===-1?P.push(...y):P.splice(d,0,...y),P}e.addArg=i;function I(P){return P.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(Z[91],x([0,1,160,41,136,23,60,17,3,28,130,54]),function(V,e,p,L,k,M,E,n,f,w,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const P=1e4;let y;async function d(b,v,c){return v["force-disable-user-env"]?(b.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(b.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(c)&&!v["force-user-env"]?(b.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(c)?b.trace("resolveShellEnv(): running (--force-user-env)"):b.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=new Promise(async(h,a)=>{const u=new M.CancellationTokenSource,t=setTimeout(()=>{u.dispose(!0),a((0,k.localize)(0,null))},P);try{h(await g(b,u.token))}catch(l){!(0,n.isPromiseCanceledError)(l)&&!u.token.isCancellationRequested&&a((0,k.localize)(1,null,(0,E.toErrorMessage)(l))),h({})}finally{clearTimeout(t),u.dispose()}})),y)}e.resolveShellEnv=d;async function g(b,v){return new Promise(async(c,h)=>{const a=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",a);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",u);const t=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),l=new RegExp(t+"(.*)"+t),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};b.trace("getUnixShellEnvironment#env",r);const s=await(0,i.getSystemShell)(f.OS,r);if(b.trace("getUnixShellEnvironment#shell",s),v.isCancellationRequested)return h(n.canceled);const o=(0,p.basename)(s);let m,S;/^pwsh(-preview)?$/.test(o)?(m=`& '${process.execPath}' -p '''${t}'' + JSON.stringify(process.env) + ''${t}'''`,S=["-Login","-Command"]):(m=`'${process.execPath}' -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,S=["-ilc"]),b.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),m);const D=(0,L.spawn)(s,[...S,m],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});v.onCancellationRequested(()=>(D.kill(),h(n.canceled))),D.on("error",_=>{b.error("getUnixShellEnvironment#errorChildProcess",(0,E.toErrorMessage)(_)),h(_)});const R=[];D.stdout.on("data",_=>R.push(_));const T=[];D.stderr.on("data",_=>T.push(_)),D.on("close",(_,G)=>{const ne=Buffer.concat(R).toString("utf8");b.trace("getUnixShellEnvironment#raw",ne);const se=Buffer.concat(T).toString("utf8");if(se.trim()&&b.trace("getUnixShellEnvironment#stderr",se),_||G)return h(new Error((0,k.localize)(2,null,_,G)));const K=l.exec(ne),te=K?K[1]:"{}";try{const W=JSON.parse(te);a?W.ELECTRON_RUN_AS_NODE=a:delete W.ELECTRON_RUN_AS_NODE,u?W.ELECTRON_NO_ATTACH_CONSOLE=u:delete W.ELECTRON_NO_ATTACH_CONSOLE,delete W.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",W),c(W)}catch(W){b.error("getUnixShellEnvironment#errorCaught",(0,E.toErrorMessage)(W)),h(W)}})})}}),define(Z[92],x([0,1,3,7,20]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function M(f){return f.map(w=>({type:w.type,resource:L.URI.file(w.path)}))}e.toFileChanges=M;function E(f){const w=new n;for(const i of f)w.processEvent(i);return w.normalize()}e.normalizeFileChanges=E;class n{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(w){return p.isLinux?w.path:w.path.toLowerCase()}processEvent(w){const i=this.mapPathToChange.get(this.toKey(w));let I=!1;if(i){const P=i.type,y=w.type;i.path!==w.path&&(y===1||y===0)?(i.type=2,I=!0):P===1&&y===2?(this.mapPathToChange.delete(this.toKey(w)),this.normalized.delete(i)):P===2&&y===1?i.type=0:P===1&&y===0||(i.type=y)}else I=!0;I&&(this.normalized.add(w),this.mapPathToChange.set(this.toKey(w),w))}normalize(){const w=[],i=[];return Array.from(this.normalized).filter(I=>I.type!==2?(w.push(I),!1):!0).sort((I,P)=>I.path.length-P.path.length).filter(I=>i.some(P=>(0,k.isParent)(I.path,P,!p.isLinux))?!1:(i.push(I.path),!0)).concat(w)}}}),define(Z[174],x([0,1,9,2,8,82,19,117,92]),function(V,e,p,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends L.Disposable{constructor(I,P,y,d){super();this.path=I,this.onDidFilesChange=P,this.onLogMessage=y,this.verboseLogging=d,this.fileChangesDelayer=this._register(new p.ThrottledDelayer(n.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:P}=await E.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let y=this.path;if(P)try{y=await(0,M.realpath)(y)}catch(d){if(this.onError(d),P.dangling)return}I.isDirectory()?this._register((0,n.watchFolder)(y,(d,g)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,k.join)(this.path,(0,k.basename)(g))})},d=>this.onError(d))):this._register((0,n.watchFile)(y,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const P=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=(0,f.normalizeFileChanges)(P);if(this.verboseLogging)for(const d of y)this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);y.length>0&&this.onDidFilesChange(y)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(Z[72],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...k){this._entries=new Map;for(let[M,E]of k)this.set(M,E)}set(k,M){const E=this._entries.get(k);return this._entries.set(k,M),E}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=p}),define(Z[175],x([0,1,9,17,70,168,5,72]),function(V,e,p,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class w extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class i{constructor(d=new n.ServiceCollection,g=!1,b){this._activeInstantiations=new Set,this._services=d,this._strict=g,this._parent=b,this._services.set(E.IInstantiationService,this)}createChild(d){return new i(d,this._strict,this)}invokeFunction(d,...g){let b=P.traceInvocation(d),v=!1;try{return d({get:(h,a)=>{if(v)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(h,b);if(!u&&a!==E.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return u}},...g)}finally{v=!0,b.stop()}}createInstance(d,...g){let b,v;return d instanceof k.SyncDescriptor?(b=P.traceCreation(d.ctor),v=this._createInstance(d.ctor,d.staticArguments.concat(g),b)):(b=P.traceCreation(d),v=this._createInstance(d,g,b)),b.stop(),v}_createInstance(d,g=[],b){let v=E._util.getServiceDependencies(d).sort((a,u)=>a.index-u.index),c=[];for(const a of v){let u=this._getOrCreateServiceInstance(a.id,b);if(!u&&this._strict&&!a.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${a.id}.`);c.push(u)}let h=v.length>0?v[0].index:g.length;if(g.length!==h){console.warn(`[createInstance] First service dependency of ${d.name} at position ${h+1} conflicts with ${g.length} static arguments`);let a=h-g.length;a>0?g=g.concat(new Array(a)):g=g.slice(0,h)}return new d(...[...g,...c])}_setServiceInstance(d,g){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,g);else if(this._parent)this._parent._setServiceInstance(d,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let g=this._services.get(d);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):g}_getOrCreateServiceInstance(d,g){let b=this._getServiceInstanceOrDescriptor(d);return b instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,b,g.branch(d,!0)):(g.branch(d,!1),b)}_safeCreateAndCacheServiceInstance(d,g,b){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,g,b)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,g,b){const v=new M.Graph(a=>a.id.toString());let c=0;const h=[{id:d,desc:g,_trace:b}];for(;h.length;){const a=h.pop();if(v.lookupOrInsertNode(a),c++>1e3)throw new w(v);for(let u of E._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(u.id);if(!t&&!u.optional&&console.warn(`[createInstance] ${d} depends on ${u.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const l={id:u.id,desc:t,_trace:a._trace.branch(u.id,!0)};v.insertEdge(a,l),h.push(l)}}}for(;;){const a=v.roots();if(a.length===0){if(!v.isEmpty())throw new w(v);break}for(const{data:u}of a){if(this._getServiceInstanceOrDescriptor(u.id)instanceof k.SyncDescriptor){const l=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,l)}v.removeNode(u)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,g,b=[],v,c){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(g,b,v,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,g,b,v,c);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(d,g=[],b,v){if(b){const c=new p.IdleValue(()=>this._createInstance(d,g,v));return new Proxy(Object.create(null),{get(h,a){if(a in h)return h[a];let u=c.value,t=u[a];return typeof t!="function"||(t=t.bind(u),h[a]=t),t},set(h,a,u){return c.value[a]=u,!0}})}else return this._createInstance(d,g,v)}}e.InstantiationService=i;var I;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(I||(I={}));class P{constructor(d,g){this.type=d,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return f?new P(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):P._None}static traceCreation(d){return f?new P(0,d.name):P._None}branch(d,g){let b=new P(2,d.toString());return this._dep.push([d,g,b]),b}stop(){let d=Date.now()-this._start;P._totals+=d;let g=!1;function b(c,h){let a=[],u=new Array(c+1).join("	");for(const[t,l,r]of h._dep)if(l&&r){g=!0,a.push(`${u}CREATES -> ${t}`);let s=b(c+1,r);s&&a.push(s)}else a.push(`${u}uses -> ${t}`);return a.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${P._totals.toFixed(2)}ms)`];(d>2||g)&&console.log(v.join(`
`))}}P._None=new class extends P{constructor(){super(-1,null)}stop(){}branch(){return this}},P._totals=0}),define(Z[176],x([0,1,17,128,57]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class M extends k.ResolvedKeybinding{constructor(n,f){super();if(f.length===0)throw(0,p.illegalArgument)("parts");this._os=n,this._parts=f}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new k.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=M}),define(Z[177],x([0,1,57,176]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends L.BaseResolvedKeybinding{constructor(E,n){super(n,E.parts)}_keyCodeToUILabel(E){if(this._os===2)switch(E){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return p.KeyCodeUtils.toString(E)}_getLabel(E){return E.isDuplicateModifierCase()?"":this._keyCodeToUILabel(E.keyCode)}_getAriaLabel(E){return E.isDuplicateModifierCase()?"":p.KeyCodeUtils.toString(E.keyCode)}_keyCodeToElectronAccelerator(E){if(E>=93&&E<=108)return null;switch(E){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return p.KeyCodeUtils.toString(E)}_getElectronAccelerator(E){return E.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(E.keyCode)}_getUserSettingsLabel(E){if(E.isDuplicateModifierCase())return"";const n=p.KeyCodeUtils.toUserSettingsUS(E.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(E){return k.getDispatchStr(E)}static getDispatchStr(E){if(E.isModifierKey())return null;let n="";return E.ctrlKey&&(n+="ctrl+"),E.shiftKey&&(n+="shift+"),E.altKey&&(n+="alt+"),E.metaKey&&(n+="meta+"),n+=p.KeyCodeUtils.toString(E.keyCode),n}_getSingleModifierDispatchPart(E){return E.keyCode===5&&!E.shiftKey&&!E.altKey&&!E.metaKey?"ctrl":E.keyCode===4&&!E.ctrlKey&&!E.altKey&&!E.metaKey?"shift":E.keyCode===6&&!E.ctrlKey&&!E.shiftKey&&!E.metaKey?"alt":E.keyCode===57&&!E.ctrlKey&&!E.shiftKey&&!E.altKey?"meta":null}}e.USLayoutResolvedKeybinding=k}),define(Z[178],x([0,1,9]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(k,M){if(k.length===0)return Promise.resolve(!1);const E=[];let n=!1;for(let f of k){if(f===!0)return Promise.resolve(!0);(0,p.isThenable)(f)&&E.push(f.then(w=>{w&&(n=!0)},w=>{M(w),n=!0}))}return p.Promises.settled(E).then(()=>n)}e.handleVetos=L}),define(Z[6],x([0,1,60,4,2,3,5]),function(V,e,p,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function n(){return new Date().toISOString()}var f;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;class w extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class i extends w{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...l){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([t,...l]))}debug(t,...l){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([t,...l]))}info(t,...l){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([t,...l]))}warn(t,...l){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([t,...l]))}error(t,...l){if(this.checkLogLevel(f.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(f.Error,this.format(r))}else this.log(f.Error,this.format([t,...l]))}critical(t,...l){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([t,...l]))}flush(){}format(t){let l="";for(let r=0;r<t.length;r++){let s=t[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch(o){}l+=(r>0?" ":"")+s}return l}}e.AbstractMessageLogger=i;class I extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!M.isWindows}trace(t,...l){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...l):console.log(`[main ${n()}]`,t,...l))}debug(t,...l){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...l):console.log(`[main ${n()}]`,t,...l))}info(t,...l){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...l):console.log(`[main ${n()}]`,t,...l))}warn(t,...l){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,t,...l):console.warn(`[main ${n()}]`,t,...l))}error(t,...l){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,t,...l):console.error(`[main ${n()}]`,t,...l))}critical(t,...l){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,t,...l):console.error(`[main ${n()}]`,t,...l))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class P extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...l){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",t,...l)}debug(t,...l){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...l)}info(t,...l){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",t,...l)}warn(t,...l){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",t,...l)}error(t,...l){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",t,...l)}critical(t,...l){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...l)}dispose(){}flush(){}}e.ConsoleLogger=P;class y extends w{constructor(t,l=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(l)}trace(t,...l){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(t),...l])}debug(t,...l){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(t),...l])}info(t,...l){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(t),...l])}warn(t,...l){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(t),...l])}error(t,...l){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(t),...l])}critical(t,...l){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(t),...l])}extractMessage(t){return typeof t=="string"?t:(0,p.toErrorMessage)(t,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class d extends w{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const l of this.logServices)l.setLevel(t);super.setLevel(t)}trace(t,...l){for(const r of this.logServices)r.trace(t,...l)}debug(t,...l){for(const r of this.logServices)r.debug(t,...l)}info(t,...l){for(const r of this.logServices)r.info(t,...l)}warn(t,...l){for(const r of this.logServices)r.warn(t,...l)}error(t,...l){for(const r of this.logServices)r.error(t,...l)}critical(t,...l){for(const r of this.logServices)r.critical(t,...l)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class g extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...l){this.logger.trace(t,...l)}debug(t,...l){this.logger.debug(t,...l)}info(t,...l){this.logger.info(t,...l)}warn(t,...l){this.logger.warn(t,...l)}error(t,...l){this.logger.error(t,...l)}critical(t,...l){this.logger.critical(t,...l)}flush(){this.logger.flush()}}e.LogService=g;class b extends k.Disposable{constructor(t,l){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(l(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,l){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,l?.always?f.Trace:this.logLevel,l),this.loggers.set(t.toString(),r),l?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class v{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return f.Info}trace(t,...l){}debug(t,...l){}info(t,...l){}warn(t,...l){}error(t,...l){}critical(t,...l){}dispose(){}flush(){}}e.NullLogService=v;function c(u){if(u.verbose)return f.Trace;if(typeof u.logLevel=="string"){const t=h(u.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function h(u){switch(u){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=h;function a(u){switch(u){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=a});var ie=this&&this.__param||function(V,e){return function(p,L){e(p,L,V)}};define(Z[179],x([0,1,9,18,40,77,48,20,5,6]),function(V,e,p,L,k,M,E,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var i;(function(P){P.ERROR_INVALID_FILE="ERROR_INVALID_FILE",P.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(i=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,f.createDecorator)(e.UserConfigurationFileServiceId);let I=class{constructor(y,d,g){this.environmentService=y,this.fileService=d,this.logService=g,this.queue=new p.Queue}async updateSettings(y,d){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,y,d))}async doWrite(y,d,g){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,y.toString(),d);const{value:b,mtime:v,etag:c}=await this.fileService.readFile(y,{atomic:!0});let h=b.toString();const a=[];if((0,k.parse)(h,a,{allowTrailingComma:!0,allowEmptyContent:!0}),a.length)throw new Error("ERROR_INVALID_FILE");const u=this.getEdits(d,h,g)[0];if(u){h=h.substring(0,u.offset)+u.content+h.substring(u.offset+u.length);try{await this.fileService.writeFile(y,L.VSBuffer.fromString(h),{etag:c,mtime:v})}catch(t){if(t.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:y,path:d},g,b){return d.length?(0,M.setProperty)(g,d,y,b):[{content:JSON.stringify(y,null,b.insertSpaces&&b.tabSize?" ".repeat(b.tabSize):"	"),length:g.length,offset:0}]}};I=he([ie(0,E.IEnvironmentService),ie(1,n.IFileService),ie(2,w.ILogService)],I),e.UserConfigurationFileService=I}),define(Z[93],x([0,1,6]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(M,E){switch(E){case p.LogLevel.Trace:return M.trace;case p.LogLevel.Debug:return M.debug;case p.LogLevel.Info:return M.info;case p.LogLevel.Warning:return M.warn;case p.LogLevel.Error:return M.error;case p.LogLevel.Critical:return M.critical;default:throw new Error("Invalid log level")}}class k extends p.AbstractLogger{constructor(E=p.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(E),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(E){this._logger=E;for(const{level:n,args:f}of this.buffer)L(E,n).apply(E,f);this.buffer=[]}_log(E,...n){this._logger?L(this._logger,E).apply(this._logger,n):this.getLevel()<=E&&this.buffer.push({level:E,args:n})}trace(E,...n){this._log(p.LogLevel.Trace,E,...n)}debug(E,...n){this._log(p.LogLevel.Debug,E,...n)}info(E,...n){this._log(p.LogLevel.Info,E,...n)}warn(E,...n){this._log(p.LogLevel.Warning,E,...n)}error(E,...n){this._log(p.LogLevel.Error,E,...n)}critical(E,...n){this._log(p.LogLevel.Critical,E,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=k}),define(Z[180],x([0,1,9,18,15,20,5,93,6]),function(V,e,p,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const w=5*M.ByteSize.MB;let i=class extends f.AbstractLogger{constructor(y,d,g,b,v){super();this.name=y,this.resource=d,this.donotUseFormatters=b,this.fileService=v,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new p.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const y=arguments[0];if(y instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=y.stack,this._log(f.LogLevel.Error,this.format(d))}else this._log(f.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,this.format(arguments))}flush(){}log(y,d){this._log(y,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(y){if(y.fileOperationResult!==3)throw y}}_log(y,d){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>w&&(await this.fileService.writeFile(this.getBackupResource(),L.VSBuffer.fromString(g)),g=""),this.donotUseFormatters?g+=d:g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(y)}] ${d}
`,await this.fileService.writeFile(this.resource,L.VSBuffer.fromString(g))})}getCurrentTimestamp(){const y=b=>b<10?`0${b}`:b,d=b=>b<10?`00${b}`:b<100?`0${b}`:b,g=new Date;return`${g.getFullYear()}-${y(g.getMonth()+1)}-${y(g.getDate())} ${y(g.getHours())}:${y(g.getMinutes())}:${y(g.getSeconds())}.${d(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(y){return""}}stringifyLogLevel(y){switch(y){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}format(y){let d="";for(let g=0;g<y.length;g++){let b=y[g];if(typeof b=="object")try{b=JSON.stringify(b)}catch(v){}d+=(g>0?" ":"")+b}return d}};i=he([ie(4,M.IFileService)],i),e.FileLogger=i;let I=class extends f.AbstractLoggerService{constructor(y,d,g){super(y.getLevel(),y.onDidChangeLogLevel);this.instantiationService=d,this.fileService=g}doCreateLogger(y,d,g){const b=new n.BufferLogService(d);return(0,M.whenProviderRegistered)(y,this.fileService).then(()=>b.logger=this.instantiationService.createInstance(i,(0,k.basename)(y),y,b.getLevel(),!!g?.donotUseFormatters)),b}};I=he([ie(0,f.ILogService),ie(1,E.IInstantiationService),ie(2,M.IFileService)],I),e.FileLoggerService=I}),define(Z[181],x([0,1,4,7,6]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(P){this.service=P,this.onDidChangeLogLevel=p.Event.buffer(P.onDidChangeLogLevel,!0)}listen(P,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(P,y,d){switch(y){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=M;class E{constructor(P){this.channel=P}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(P){E.setLevel(this.channel,P)}static setLevel(P,y){return P.call("setLevel",y)}}e.LogLevelChannelClient=E;class n{constructor(P){this.loggerService=P,this.loggers=new Map}listen(P,y){throw new Error(`Event not found: ${y}`)}async call(P,y,d){switch(y){case"createLogger":this.createLogger(L.URI.revive(d[0]),d[1]);return;case"log":return this.log(L.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${y}`)}createLogger(P,y){this.loggers.set(P.toString(),this.loggerService.createLogger(P,y))}consoleLog(P,y){let d=console.log;switch(P){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...y)}log(P,y){const d=this.loggers.get(P.toString());if(!d)throw new Error("Create the logger before logging");for(const[g,b]of y)switch(g){case k.LogLevel.Trace:d.trace(b);break;case k.LogLevel.Debug:d.debug(b);break;case k.LogLevel.Info:d.info(b);break;case k.LogLevel.Warning:d.warn(b);break;case k.LogLevel.Error:d.error(b);break;case k.LogLevel.Critical:d.critical(b);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class f extends k.AbstractLoggerService{constructor(P,y,d){super(P,y);this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(P,y)=>{this.channel.call("consoleLog",[P,y])}})}doCreateLogger(P,y,d){return new w(this.channel,P,y,d)}}e.LoggerChannelClient=f;class w extends k.AbstractMessageLogger{constructor(P,y,d,g){super(g?.always);this.channel=P,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[y,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(P,y){const d=[[P,y]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(P){this.channel.call("log",[this.file,P])}}class i extends k.LogService{constructor(P,y){super(y);this.parent=P,this._register(P.onDidChangeLogLevel(d=>y.setLevel(d)))}setLevel(P){super.setLevel(P),this.parent.setLevel(P)}}e.FollowerLogService=i}),define(Z[94],x([0,1,20,6]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(f,w,i,I){try{const P=await new Promise((y,d)=>{V(["spdlog"],y,d)});return P.setFlushOn(L.LogLevel.Trace),P.createAsyncRotatingLogger(f,w,i,I)}catch(P){console.error(P)}return null}function M(f,w,i,I){const P=V.__$__nodeRequire("spdlog");return P.setFlushOn(L.LogLevel.Trace),P.createRotatingLogger(f,w,i,I)}e.createRotatingLogger=M;function E(f,w,i){switch(w){case L.LogLevel.Trace:f.trace(i);break;case L.LogLevel.Debug:f.debug(i);break;case L.LogLevel.Info:f.info(i);break;case L.LogLevel.Warning:f.warn(i);break;case L.LogLevel.Error:f.error(i);break;case L.LogLevel.Critical:f.critical(i);break;default:throw new Error("Invalid log level")}}class n extends L.AbstractMessageLogger{constructor(w,i,I,P){super();this.name=w,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(P),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}_createSpdLogLogger(){const w=this.rotating?6:1,i=30/w*p.ByteSize.MB;return k(this.name,this.filepath,i,w).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:P,message:y}of this.buffer)E(this._logger,P,y);this.buffer=[]}})}log(w,i){this._logger?E(this._logger,w,i):this.getLevel()<=w&&this.buffer.push({level:w,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(Z[182],x([0,1,10,15,28,20,180,6,94]),function(V,e,p,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let w=class extends n.AbstractLoggerService{constructor(I,P){super(I.getLevel(),I.onDidChangeLogLevel);this.fileService=P}doCreateLogger(I,P,y){if(I.scheme===p.Schemas.file){const d=new f.SpdLogLogger(y?.name||(0,k.generateUuid)(),I.fsPath,!y?.donotRotate,P);return y?.donotUseFormatters&&d.clearFormatters(),d}else return new E.FileLogger(y?.name??(0,L.basename)(I),I,P,!!y?.donotUseFormatters,this.fileService)}};w=he([ie(0,n.ILogService),ie(1,M.IFileService)],w),e.LoggerService=w}),define(Z[183],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function p(E){return E.submenu!==void 0}e.isMenubarMenuItemSubmenu=p;function L(E){return E.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function k(E){return E.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function M(E){return!p(E)&&!L(E)&&!k(E)}e.isMenubarMenuItemAction=M}),define(Z[45],x([0,1,10,3,33,15]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let E;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const n=L.globals.vscode.context.configuration();if(n)E=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof V?.__$__nodeRequire=="function"){const n=(0,M.dirname)(p.FileAccess.asFileUri("",V));E=V.__$__nodeRequire((0,M.joinPath)(n,"product.json").fsPath);const f=V.__$__nodeRequire((0,M.joinPath)(n,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(E,{nameShort:`${E.nameShort} Dev`,nameLong:`${E.nameLong} Dev`,dataFolderName:`${E.dataFolderName}-dev`}),Object.assign(E,{version:f.version})}else E={},Object.keys(E).length===0&&Object.assign(E,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=E}),define(Z[95],x([0,1,18,17,142,20,45]),function(V,e,p,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(I,P,y,d,g,b){let v;try{await f(I,P,y,d,g,b)}catch(c){v=c}finally{v&&g.errorTransformer&&(v=g.errorTransformer(v)),typeof v!="undefined"&&y.error(v),y.end()}}e.readFileIntoStream=n;async function f(I,P,y,d,g,b){w(b);const v=await I.open(P,{create:!1});try{w(b);let c=0,h=0,a=g&&typeof g.length=="number"?g.length:void 0,u=p.VSBuffer.alloc(Math.min(g.bufferSize,typeof a=="number"?a:g.bufferSize)),t=g&&typeof g.position=="number"?g.position:0,l=0;do h=await I.read(v,t,u.buffer,l,u.byteLength-l),t+=h,l+=h,c+=h,typeof a=="number"&&(a-=h),l===u.byteLength&&(await y.write(d(u)),u=p.VSBuffer.alloc(Math.min(g.bufferSize,typeof a=="number"?a:g.bufferSize)),l=0);while(h>0&&(typeof a!="number"||a>0)&&w(b)&&i(c,g));if(l>0){let r=l;typeof a=="number"&&(r=Math.min(l,a)),y.write(d(u.slice(0,r)))}}catch(c){throw(0,M.ensureFileSystemProviderError)(c)}finally{await I.close(v)}}function w(I){if(I.isCancellationRequested)throw(0,L.canceled)();return!0}function i(I,P){if(P?.limits){if(typeof P.limits.memory=="number"&&I>P.limits.memory)throw(0,M.createFileSystemProviderError)((0,k.localize)(0,null,E.default.nameShort),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&I>P.limits.size)throw(0,M.createFileSystemProviderError)((0,k.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[184],x([0,1,30,9,18,23,4,65,2,37,10,73,15,66,140,20,95,6]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d,g,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class Ke extends f.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new E.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new E.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new E.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new E.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new E.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new E.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new g.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new g.FileChangesEvent(u,!0)))),this.watchedResources=w.TernarySearchTree.forUris(u=>{const t=this.getProvider(u.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(a,u){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:u});const t=new f.DisposableStore;return t.add(u.onDidChangeFile(l=>this.onDidChangeFile(l,this.isPathCaseSensitive(u)))),t.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:a}))),typeof u.onDidErrorOccur=="function"&&t.add(u.onDidErrorOccur(l=>this._onError.fire(new Error(l)))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:u}),this.provider.delete(a),(0,f.dispose)(t)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(t){u.push(t)}}),!this.provider.has(a)&&await L.Promises.settled(u)}canHandleResource(a){return this.provider.has(a.scheme)}hasCapability(a,u){const t=this.provider.get(a.scheme);return!!(t&&t.capabilities&u)}listCapabilities(){return n.Iterable.map(this.provider,([a,u])=>({scheme:a,capabilities:u.capabilities}))}async withProvider(a){if(!(0,P.isAbsolutePath)(a))throw new g.FileOperationError((0,d.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const u=this.provider.get(a.scheme);if(!u){const t=new Error;throw t.name="ENOPRO",t.message=(0,d.localize)(1,null,a.toString()),t}return u}async withReadProvider(a){const u=await this.withProvider(a);if((0,g.hasOpenReadWriteCloseCapability)(u)||(0,g.hasReadWriteCapability)(u)||(0,g.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const u=await this.withProvider(a);if((0,g.hasOpenReadWriteCloseCapability)(u)||(0,g.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,u){try{return await this.doResolveFile(a,u)}catch(t){throw(0,g.toFileSystemProviderErrorCode)(t)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,d.localize)(2,null,this.resourceForError(a)),1):(0,g.ensureFileSystemProviderError)(t)}}async doResolveFile(a,u){const t=await this.withProvider(a),l=this.isPathCaseSensitive(t),r=u?.resolveTo,s=u?.resolveSingleChildDescendants,o=u?.resolveMetadata,m=await t.stat(a);let S;return this.toFileStat(t,a,m,void 0,!!o,(D,R)=>{if(!S&&(S=w.TernarySearchTree.forUris(()=>!l),S.set(a,!0),r))for(const T of r)S.set(T,!0);return S.get(D.resource)||S.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&s?R===1:!1})}async toFileStat(a,u,t,l,r,s){const{providerExtUri:o}=this.getExtUri(a),m={resource:u,name:o.basename(u),isFile:(t.type&g.FileType.File)!=0,isDirectory:(t.type&g.FileType.Directory)!=0,isSymbolicLink:(t.type&g.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&g.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,g.etag)({mtime:t.mtime,size:t.size})};if(m.isDirectory&&s(m,l)){try{const S=await a.readdir(u),D=await L.Promises.settled(S.map(async([R,T])=>{try{const _=o.joinPath(u,R),G=r?await a.stat(_):{type:T};return await this.toFileStat(a,_,G,S.length,r,s)}catch(_){return this.logService.trace(_),null}}));m.children=(0,p.coalesce)(D)}catch(S){this.logService.trace(S),m.children=[]}return m}return m}async resolveAll(a){return L.Promises.settled(a.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(a){const u=await this.withProvider(a);try{return!!await u.stat(a)}catch(t){return!1}}async canCreateFile(a,u){try{await this.doValidateCreateFile(a,u)}catch(t){return t}return!0}async doValidateCreateFile(a,u){if(!u?.overwrite&&await this.exists(a))throw new g.FileOperationError((0,d.localize)(3,null,this.resourceForError(a)),3,u)}async createFile(a,u=k.VSBuffer.fromString(""),t){await this.doValidateCreateFile(a,t);const l=await this.writeFile(a,u);return this._onDidRunOperation.fire(new g.FileOperationEvent(a,0,l)),l}async writeFile(a,u,t){const l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:r}=this.getExtUri(l);try{await this.validateWriteFile(l,a,t)||await this.mkdirp(l,r.dirname(a));let o;if((0,g.hasReadWriteCapability)(l)&&!(u instanceof k.VSBuffer))if((0,y.isReadableStream)(u)){const m=await(0,y.peekStream)(u,3);m.ended?o=k.VSBuffer.concat(m.buffer):o=m}else o=(0,y.peekReadable)(u,m=>k.VSBuffer.concat(m),3);else o=u;!(0,g.hasOpenReadWriteCloseCapability)(l)||(0,g.hasReadWriteCapability)(l)&&o instanceof k.VSBuffer?await this.doWriteUnbuffered(l,a,t,o):await this.doWriteBuffered(l,a,t,o instanceof k.VSBuffer?(0,k.bufferToReadable)(o):o)}catch(s){throw new g.FileOperationError((0,d.localize)(4,null,this.resourceForError(a),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),t)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,u,t){if(!!t?.unlock&&!(a.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(u)));let r;try{r=await a.stat(u)}catch(s){return}if((r.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,d.localize)(6,null,this.resourceForError(u)),0,t);if(this.throwIfFileIsReadonly(u,r),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==g.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,g.etag)({mtime:t.mtime,size:r.size}))throw new g.FileOperationError((0,d.localize)(7,null),3,t);return r}async readFile(a,u){const t=await this.withReadProvider(a);return u?.atomic?this.doReadFileAtomic(t,a,u):this.doReadFile(t,a,u)}async doReadFileAtomic(a,u,t){return new Promise((l,r)=>{this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(a,u,t);l(s)}catch(s){r(s)}})})}async doReadFile(a,u,t){const l=await this.doReadFileStream(a,u,{...t,preferUnbuffered:!0});return{...l,value:await(0,k.streamToBuffer)(l.value)}}async readFileStream(a,u){const t=await this.withReadProvider(a);return this.doReadFileStream(t,a,u)}async doReadFileStream(a,u,t){const l=new M.CancellationTokenSource,r=this.validateReadFile(u,t).then(o=>o,o=>{throw l.cancel(),o});let s;try{return typeof t?.etag=="string"&&t.etag!==g.ETAG_DISABLED&&await r,!((0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasFileReadStreamCapability)(a))||(0,g.hasReadWriteCapability)(a)&&t?.preferUnbuffered?s=this.readFileUnbuffered(a,u,t):(0,g.hasFileReadStreamCapability)(a)?s=this.readFileStreamed(a,u,l.token,t):s=this.readFileBuffered(a,u,l.token,t),{...await r,value:s}}catch(o){s&&await(0,y.consumeStream)(s);const m=(0,d.localize)(8,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(o).toString());throw o instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(m,o.stat,t):new g.FileOperationError(m,(0,g.toFileOperationResult)(o),t)}}readFileStreamed(a,u,t,l=Object.create(null)){const r=a.readFileStream(u,l,t);return(0,y.transform)(r,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new g.FileOperationError((0,d.localize)(9,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),l)},s=>k.VSBuffer.concat(s))}readFileBuffered(a,u,t,l=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,b.readFileIntoStream)(a,u,r,s=>s,{...l,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new g.FileOperationError((0,d.localize)(10,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(s).toString()),(0,g.toFileOperationResult)(s),l)},t),r}readFileUnbuffered(a,u,t){const l=(0,y.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r=await a.readFile(u);typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(u,r.byteLength,t),l.end(k.VSBuffer.wrap(r))}catch(r){l.error(r),l.end()}})(),l}async validateReadFile(a,u){const t=await this.resolve(a,{resolveMetadata:!0});if(t.isDirectory)throw new g.FileOperationError((0,d.localize)(11,null,this.resourceForError(a)),0,u);if(typeof u?.etag=="string"&&u.etag!==g.ETAG_DISABLED&&u.etag===t.etag)throw new g.NotModifiedSinceFileOperationError((0,d.localize)(12,null),t,u);return this.validateReadFileLimits(a,t.size,u),t}validateReadFileLimits(a,u,t){if(t?.limits){let l;if(typeof t.limits.memory=="number"&&u>t.limits.memory&&(l=9),typeof t.limits.size=="number"&&u>t.limits.size&&(l=7),typeof l=="number")throw new g.FileOperationError((0,d.localize)(13,null,this.resourceForError(a)),l)}}async canMove(a,u,t){return this.doCanMoveCopy(a,u,"move",t)}async canCopy(a,u,t){return this.doCanMoveCopy(a,u,"copy",t)}async doCanMoveCopy(a,u,t,l){if(a.toString()!==u.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(r,a,s,u,t,l)}catch(r){return r}return!0}async move(a,u,t){const l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),s=await this.doMoveCopy(l,a,r,u,"move",!!t),o=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,s==="move"?2:3,o)),o}async copy(a,u,t){const l=await this.withReadProvider(a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),s=await this.doMoveCopy(l,a,r,u,"copy",!!t),o=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,s==="copy"?3:2,o)),o}async doMoveCopy(a,u,t,l,r,s){if(u.toString()===l.toString())return r;const{exists:o,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(a,u,t,l,r,s);if(o&&!m&&s&&await this.del(l,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(l)),r==="copy"){if(a===t&&(0,g.hasFileFolderCopyCapability)(a))await a.copy(u,l,{overwrite:s});else{const S=await this.resolve(u);S.isDirectory?await this.doCopyFolder(a,S,t,l):await this.doCopyFile(a,u,t,l)}return r}else return a===t?(await a.rename(u,l,{overwrite:s}),r):(await this.doMoveCopy(a,u,t,l,"copy",s),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(a,u,t,l){if((0,g.hasOpenReadWriteCloseCapability)(a)&&(0,g.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(a,u,t,l);if((0,g.hasOpenReadWriteCloseCapability)(a)&&(0,g.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(a,u,t,l);if((0,g.hasReadWriteCapability)(a)&&(0,g.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(a,u,t,l);if((0,g.hasReadWriteCapability)(a)&&(0,g.hasReadWriteCapability)(t))return this.doPipeUnbuffered(a,u,t,l)}async doCopyFolder(a,u,t,l){await t.mkdir(l),Array.isArray(u.children)&&await L.Promises.settled(u.children.map(async r=>{const s=this.getExtUri(t).providerExtUri.joinPath(l,r.name);return r.isDirectory?this.doCopyFolder(a,await this.resolve(r.resource),t,s):this.doCopyFile(a,r.resource,t,s)}))}async doValidateMoveCopy(a,u,t,l,r,s){let o=!1;if(a===t){const{providerExtUri:S,isPathCaseSensitive:D}=this.getExtUri(a);if(D||(o=S.isEqual(u,l)),o&&r==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(u),this.resourceForError(l)));if(!o&&S.isEqualOrParent(l,u))throw new Error((0,d.localize)(15,null,this.resourceForError(u),this.resourceForError(l)))}const m=await this.exists(l);if(m&&!o){if(!s)throw new g.FileOperationError((0,d.localize)(16,null,this.resourceForError(u),this.resourceForError(l)),4);if(a===t){const{providerExtUri:S}=this.getExtUri(a);if(S.isEqualOrParent(u,l))throw new Error((0,d.localize)(17,null,this.resourceForError(u),this.resourceForError(l)))}}return{exists:m,isSameResourceWithDifferentPathCase:o}}getExtUri(a){const u=this.isPathCaseSensitive(a);return{providerExtUri:u?P.extUri:P.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(u,a);const t=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,0,t)),t}async mkdirp(a,u){const t=[],{providerExtUri:l}=this.getExtUri(a);for(;!l.isEqual(u,l.dirname(u));)try{if(((await a.stat(u)).type&g.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(u)));break}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(l.basename(u)),u=l.dirname(u)}for(let r=t.length-1;r>=0;r--){u=l.joinPath(u,t[r]);try{await a.mkdir(u)}catch(s){if((0,g.toFileSystemProviderErrorCode)(s)!==g.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(a,u){try{await this.doValidateDelete(a,u)}catch(t){return t}return!0}async doValidateDelete(a,u){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!u?.useTrash&&!(t.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(a)));let r;try{r=await t.stat(a)}catch(o){}if(r)this.throwIfFileIsReadonly(a,r);else throw new g.FileOperationError((0,d.localize)(20,null,this.resourceForError(a)),1);if(!!!u?.recursive){const o=await this.resolve(a);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(a)))}return t}async del(a,u){const t=await this.doValidateDelete(a,u),l=!!u?.useTrash,r=!!u?.recursive;await t.delete(a,{recursive:r,useTrash:l}),this._onDidRunOperation.fire(new g.FileOperationEvent(a,1))}onDidChangeFile(a,u){this._onDidChangeFilesRaw.fire({changes:a});let t,l;{for(const r of a)this.watchedResources.has(r.resource)?(t||(t=[]),t.push(r)):(l||(l=[]),l.push(r));t&&this._onDidFilesChange.fire(new g.FileChangesEvent(t,!u))}if(l){const r=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(l)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${l[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,u={recursive:!1,excludes:[]}){const t=new f.DisposableStore;{let l=!1,r=()=>{l=!0};t.add((0,f.toDisposable)(()=>r())),this.doWatch(a,u).then(s=>{l?(0,f.dispose)(s):r=()=>(0,f.dispose)(s)},s=>this.logService.error(s))}return u.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),t.add((0,f.toDisposable)(()=>{const l=this.watchedResources.get(a);typeof l=="number"&&(l<=1?this.watchedResources.delete(a):this.watchedResources.set(a,l-1))}))),t}async doWatch(a,u){const t=await this.withProvider(a),l=this.toWatchKey(t,a,u),r=this.activeWatchers.get(l)||{count:0,disposable:t.watch(a,u)};return this.activeWatchers.has(l)||this.activeWatchers.set(l,r),r.count+=1,(0,f.toDisposable)(()=>{r.count--,r.count===0&&((0,f.dispose)(r.disposable),this.activeWatchers.delete(l))})}toWatchKey(a,u,t){const{providerExtUri:l}=this.getExtUri(a);return[l.getComparisonKey(u),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,f.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,u,t,l){return this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(async()=>{const r=await a.open(u,{create:!0,unlock:t?.unlock??!1});try{(0,y.isReadableStream)(l)||(0,y.isReadableBufferedStream)(l)?await this.doWriteStreamBufferedQueued(a,r,l):await this.doWriteReadableBufferedQueued(a,r,l)}catch(s){throw(0,g.ensureFileSystemProviderError)(s)}finally{await a.close(r)}})}async doWriteStreamBufferedQueued(a,u,t){let l=0,r;if((0,y.isReadableBufferedStream)(t)){if(t.buffer.length>0){const s=k.VSBuffer.concat(t.buffer);await this.doWriteBuffer(a,u,s,s.byteLength,l,0),l+=s.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise(async(s,o)=>{(0,y.listenStream)(r,{onData:async m=>{r.pause();try{await this.doWriteBuffer(a,u,m,m.byteLength,l,0)}catch(S){return o(S)}l+=m.byteLength,setTimeout(()=>r.resume())},onError:m=>o(m),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(a,u,t){let l=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(a,u,r,r.byteLength,l,0),l+=r.byteLength}async doWriteBuffer(a,u,t,l,r,s){let o=0;for(;o<l;)o+=await a.write(u,r+o,t.buffer,s+o,l-o)}async doWriteUnbuffered(a,u,t,l){return this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,u,t,l))}async doWriteUnbufferedQueued(a,u,t,l){let r;l instanceof k.VSBuffer?r=l:(0,y.isReadableStream)(l)?r=await(0,k.streamToBuffer)(l):(0,y.isReadableBufferedStream)(l)?r=await(0,k.bufferedStreamToBuffer)(l):r=(0,k.readableToBuffer)(l),await a.writeFile(u,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(a,u,t,l){return this.writeQueue.queueFor(l,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,u,t,l))}async doPipeBufferedQueued(a,u,t,l){let r,s;try{r=await a.open(u,{create:!1}),s=await t.open(l,{create:!0,unlock:!1});const o=k.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,S=0,D=0;do D=await a.read(r,m,o.buffer,S,o.byteLength-S),await this.doWriteBuffer(t,s,o,D,m,S),m+=D,S+=D,S===o.byteLength&&(S=0);while(D>0)}catch(o){throw(0,g.ensureFileSystemProviderError)(o)}finally{await L.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof s=="number"?t.close(s):Promise.resolve()])}}async doPipeUnbuffered(a,u,t,l){return this.writeQueue.queueFor(l,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,u,t,l))}async doPipeUnbufferedQueued(a,u,t,l){return t.writeFile(l,await a.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,u,t,l){return this.writeQueue.queueFor(l,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,u,t,l))}async doPipeUnbufferedToBufferedQueued(a,u,t,l){const r=await t.open(l,{create:!0,unlock:!1});try{const s=await a.readFile(u);await this.doWriteBuffer(t,r,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,g.ensureFileSystemProviderError)(s)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(a,u,t,l){const r=await(0,k.streamToBuffer)(this.readFileBuffered(a,u,M.CancellationToken.None));await this.doWriteUnbuffered(t,l,void 0,r)}throwIfFileSystemIsReadonly(a,u){if(a.capabilities&2048)throw new g.FileOperationError((0,d.localize)(22,null,this.resourceForError(u)),6);return a}throwIfFileIsReadonly(a,u){if((u.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,d.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===i.Schemas.file?a.fsPath:a.toString(!0)}};c.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},c=he([ie(0,v.ILogService)],c),e.FileService=c}),define(Z[185],x([0,1,30,9,18,4,31,2,8,3,15,66,19,143,20,95,174,164,165,92,167,6,45]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d,g,b,v,c,h,a,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class l extends n.Disposable{constructor(s,o){super();this.logService=s,this.options=o,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=M.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:o,symbolicLink:m}=await P.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(o,m),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(s){try{const o=await P.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),m=[];return await Promise.all(o.map(async S=>{try{let D;S.isSymbolicLink()?D=(await this.stat((0,i.joinPath)(s,S.name))).type:D=this.toType(S),m.push([S.name,D])}catch(D){this.logService.trace(D)}})),m}catch(o){throw this.toFileSystemProviderError(o)}}toType(s,o){let m;return o?.dangling?m=d.FileType.Unknown:s.isFile()?m=d.FileType.File:s.isDirectory()?m=d.FileType.Directory:m=d.FileType.Unknown,o&&(m|=d.FileType.SymbolicLink),m}async readFile(s){try{const o=this.toFilePath(s);return await P.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(s,o,m){const S=(0,I.newWriteableStream)(D=>k.VSBuffer.concat(D.map(R=>k.VSBuffer.wrap(R))).buffer);return(0,g.readFileIntoStream)(this,s,S,D=>D.buffer,{...o,bufferSize:this.BUFFER_SIZE},m),S}async writeFile(s,o,m){let S;try{const D=this.toFilePath(s);if(!m.create||!m.overwrite){if(await P.Promises.exists(D)){if(!m.overwrite)throw(0,d.createFileSystemProviderError)((0,y.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!m.create)throw(0,d.createFileSystemProviderError)((0,y.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(s,{create:!0,unlock:m.unlock}),await this.write(S,0,o,0,o.byteLength)}catch(D){throw await this.toFileSystemProviderWriteError(s,D)}finally{typeof S=="number"&&await this.close(S)}}async open(s,o){try{const m=this.toFilePath(s);if((0,d.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:R}=await P.SymlinkSupport.stat(m);R.mode&128||await P.Promises.chmod(m,R.mode|128)}catch(R){this.logService.trace(R)}let S;if((0,d.isFileOpenForWriteOptions)(o)){if(w.isWindows)try{await P.Promises.truncate(m,0),S="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}S||(S="w")}else S="r";const D=await P.Promises.open(m,S);return this.mapHandleToPos.set(D,0),(0,d.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(D,s),D}catch(m){throw(0,d.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(s,m):this.toFileSystemProviderError(m)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await P.Promises.fdatasync(s)}catch(o){this.canFlush=!1,this.logService.error(o)}return await P.Promises.close(s)}catch(o){throw this.toFileSystemProviderError(o)}}async read(s,o,m,S,D){const R=this.normalizePos(s,o);let T=null;try{const _=await P.Promises.read(s,m,S,D,R);return typeof _=="number"?T=_:T=_.bytesRead,T}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(s,R,T)}}normalizePos(s,o){return o===this.mapHandleToPos.get(s)?null:o}updatePos(s,o,m){const S=this.mapHandleToPos.get(s);typeof S=="number"&&(typeof o=="number"||(typeof m=="number"?this.mapHandleToPos.set(s,S+m):this.mapHandleToPos.delete(s)))}async write(s,o,m,S,D){return(0,L.retry)(()=>this.doWrite(s,o,m,S,D),100,3)}async doWrite(s,o,m,S,D){const R=this.normalizePos(s,o);let T=null;try{const _=await P.Promises.write(s,m,S,D,R);return typeof _=="number"?T=_:T=_.bytesWritten,T}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),_)}finally{this.updatePos(s,R,T)}}async mkdir(s){try{await P.Promises.mkdir(this.toFilePath(s))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(s,o){try{const m=this.toFilePath(s);await this.doDelete(m,o)}catch(m){throw this.toFileSystemProviderError(m)}}async doDelete(s,o){o.recursive?await P.Promises.rm(s,P.RimRafMode.MOVE):await P.Promises.unlink(s)}async rename(s,o,m){const S=this.toFilePath(s),D=this.toFilePath(o);if(S!==D)try{await this.validateTargetDeleted(s,o,"move",m.overwrite),await P.Promises.move(S,D)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,y.localize)(2,null,(0,f.basename)(S),(0,f.basename)((0,f.dirname)(D)),R.toString()))),this.toFileSystemProviderError(R)}}async copy(s,o,m){const S=this.toFilePath(s),D=this.toFilePath(o);if(S!==D)try{await this.validateTargetDeleted(s,o,"copy",m.overwrite),await P.Promises.copy(S,D,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,y.localize)(3,null,(0,f.basename)(S),(0,f.basename)((0,f.dirname)(D)),R.toString()))),this.toFileSystemProviderError(R)}}async validateTargetDeleted(s,o,m,S){const D=this.toFilePath(s),R=this.toFilePath(o);let T=!1;if(!!(this.capabilities&1024)||(T=(0,E.isEqual)(D,R,!0)),T&&m==="copy")throw(0,d.createFileSystemProviderError)((0,y.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!T&&await P.Promises.exists(R)){if(!S)throw(0,d.createFileSystemProviderError)((0,y.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(s,o){return o.recursive?this.watchRecursive(s,o):this.watchNonRecursive(s)}watchRecursive(s,o){const m={path:this.toFilePath(s),excludes:o.excludes},S=(0,p.insert)(this.recursiveFoldersToWatch,m);return this.refreshRecursiveWatchers(),(0,n.toDisposable)(()=>{S(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof v.FileWatcher)this.recursiveWatcher.watch(this.recursiveFoldersToWatch);else if((0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let s,o;if(this.options?.watcher?.usePolling)s=c.FileWatcher,o=this.options?.watcher;else{let m;this.options?.enableLegacyRecursiveWatcher?m=!0:m=t.default.quality==="stable"&&w.isLinux,m&&this.recursiveFoldersToWatch.length===1?w.isWindows?s=a.FileWatcher:s=c.FileWatcher:s=v.FileWatcher}this.recursiveWatcher=new s(this.recursiveFoldersToWatch,m=>this._onDidChangeFile.fire((0,h.toFileChanges)(m)),m=>{m.type==="error"&&this._onDidWatchErrorOccur.fire(m.message),this.logService[m.type](m.message)},this.logService.getLevel()===u.LogLevel.Trace,o),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)}))}}watchNonRecursive(s){const o=new b.FileWatcher(this.toFilePath(s),S=>this._onDidChangeFile.fire((0,h.toFileChanges)(S)),S=>{S.type==="error"&&this._onDidWatchErrorOccur.fire(S.message),this.logService[S.type](S.message)},this.logService.getLevel()===u.LogLevel.Trace),m=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)});return(0,n.combinedDisposable)(o,m)}toFilePath(s){return(0,f.normalize)(s.fsPath)}toFileSystemProviderError(s){if(s instanceof d.FileSystemProviderError)return s;let o;switch(s.code){case"ENOENT":o=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=d.FileSystemProviderErrorCode.NoPermissions;break;default:o=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(s,o)}async toFileSystemProviderWriteError(s,o){let m=this.toFileSystemProviderError(o);if(s&&m.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:S}=await P.SymlinkSupport.stat(this.toFilePath(s));S.mode&128||(m=(0,d.createFileSystemProviderError)(o,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(S){this.logService.trace(S)}return m}dispose(){super.dispose(),(0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,n.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=l}),define(Z[21],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService")}),define(Z[186],x([0,1,58,6,21]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(n,f){this.productService=n,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(f);if(!w)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,i,I]=w;let P=this.trustedExtensionUrlPublicKeys.get(n);if(!P){if(P=this.productService.trustedExtensionUrlPublicKeys[n],!P||P.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...P])}const y=Buffer.from(decodeURIComponent(I),"base64");if(y.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const d=y.slice(0,6),g=y.readUIntBE(0,6),b=Date.now()-g;if(b<0||b>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const v=y.slice(6),c=p.createVerify("SHA256");c.write(d),c.write(Buffer.from(i)),c.end();for(let h=0;h<P.length;h++){let a=P[h];if(a!==null){if(typeof a=="string")try{a=p.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),P[h]=a}catch(u){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${h+1} for ${n}:`,u),P[h]=null;continue}if(c.verify(a,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};M=he([ie(0,k.IProductService),ie(1,L.ILogService)],M),e.ExtensionUrlTrustService=M}),define(Z[55],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,p.createDecorator)("protocolMainService")}),define(Z[187],x([0,1,14,2,37,10,3,15,7,28,48,6]),function(V,e,p,L,k,M,E,n,f,w,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let P=class extends L.Disposable{constructor(d,g){super();this.logService=g,this.validRoots=k.TernarySearchTree.forUris(()=>!E.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(f.URI.file(d.appRoot)),this.addValidFileRoot(f.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=p.session;d.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(g,b)=>this.handleResourceRequest(g,b)),d.protocol.interceptFileProtocol(M.Schemas.file,(g,b)=>this.handleFileRequest(g,b)),this._register((0,L.toDisposable)(()=>{d.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?L.Disposable.None:(this.validRoots.set(d,!0),(0,L.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,g){const b=f.URI.parse(d.url);return this.logService.error(`Refused to load resource ${b.fsPath} from ${M.Schemas.file}: protocol (original URL: ${d.url})`),g({error:-3})}handleResourceRequest(d,g){const b=f.URI.parse(d.url),v=M.FileAccess.asFileUri(b);return this.validRoots.findSubstr(v)?g({path:v.fsPath}):this.validExtensions.has((0,n.extname)(v))?g({path:v.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${v.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),g({error:-3}))}createIPCObjectUrl(){let d;const g=f.URI.from({scheme:"vscode",path:(0,w.generateUuid)()}),b=g.toString(),v=async()=>d;return p.ipcMain.handle(b,v),this.logService.trace(`IPC Object URL: Registered new channel ${b}.`),{resource:g,update:c=>d=c,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${b}.`),p.ipcMain.removeHandler(b)}}}};P=he([ie(0,i.INativeEnvironmentService),ie(1,I.ILogService)],P),e.ProtocolMainService=P}),define(Z[38],x([0,1,103,13]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(E,n){p.ok(L.isString(E)),p.ok(L.isObject(n)),p.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,n)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}e.Registry=new k}),define(Z[188],x([0,1,4,38]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class M{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,w){this.schemasById[k(f)]=w,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new M;L.Registry.add(e.Extensions.JSONContribution,E)}),define(Z[49],x([0,1,30,4,13,132,188,38]),function(V,e,p,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var f;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(f=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var w;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=n.Registry.as(E.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(h,a=!0){this.registerConfigurations([h],a)}registerConfigurations(h,a=!0){const u=this.doRegisterConfigurations(h,a);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(h){const a=this.doDeregisterConfigurations(h);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}updateConfigurations({add:h,remove:a}){const u=[];u.push(...this.doDeregisterConfigurations(a)),u.push(...this.doRegisterConfigurations(h,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,p.distinct)(u))}registerDefaultConfigurations(h){const a=[],u=[];for(const t of h)for(const l in t)if(a.push(l),e.OVERRIDE_PROPERTY_PATTERN.test(l)){this.defaultValues[l]={...this.defaultValues[l]||{},...t[l]};const r={type:"object",default:this.defaultValues[l],description:M.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId};u.push(y(l)),this.configurationProperties[l]=r,this.defaultLanguageConfigurationOverridesNode.properties[l]=r}else{this.defaultValues[l]=t[l];const r=this.configurationProperties[l];r&&(this.updatePropertyDefaultValue(l,r),this.updateSchema(l,r))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(h){const a=[];for(const u of h)for(const t in u)if(a.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const l=this.configurationProperties[t];l&&(this.updatePropertyDefaultValue(t,l),this.updateSchema(t,l))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){for(const a of h)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(h,a){const u=[];return h.forEach(t=>{u.push(...this.validateAndRegisterProperties(t,a,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),u}doDeregisterConfigurations(h){const a=[],u=t=>{if(t.properties)for(const l in t.properties)a.push(l),delete this.configurationProperties[l],this.removeFromSchema(l,t.properties[l]);t.allOf&&t.allOf.forEach(l=>u(l))};for(const t of h){u(t);const l=this.configurationContributors.indexOf(t);l!==-1&&this.configurationContributors.splice(l,1)}return a}validateAndRegisterProperties(h,a=!0,u,t=3){t=k.isUndefinedOrNull(h.scope)?t:h.scope;let l=[],r=h.properties;if(r)for(let o in r){if(a&&b(o)){delete r[o];continue}const m=r[o];if(this.updatePropertyDefaultValue(o,m),e.OVERRIDE_PROPERTY_PATTERN.test(o)?m.scope=void 0:(m.scope=k.isUndefinedOrNull(m.scope)?t:m.scope,m.restricted=k.isUndefinedOrNull(m.restricted)?!!u?.restrictedConfigurations?.includes(o):m.restricted),r[o].hasOwnProperty("included")&&!r[o].included){this.excludedConfigurationProperties[o]=r[o],delete r[o];continue}else this.configurationProperties[o]=r[o];!r[o].deprecationMessage&&r[o].markdownDeprecationMessage&&(r[o].deprecationMessage=r[o].markdownDeprecationMessage),l.push(o)}let s=h.allOf;if(s)for(let o of s)l.push(...this.validateAndRegisterProperties(o,a,u,t));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(h){const a=u=>{let t=u.properties;if(t)for(const r in t)this.updateSchema(r,t[r]);let l=u.allOf;l&&l.forEach(a)};a(h)}updateSchema(h,a){switch(e.allSettings.properties[h]=a,a.scope){case 1:e.applicationSettings.properties[h]=a;break;case 2:e.machineSettings.properties[h]=a;break;case 6:e.machineOverridableSettings.properties[h]=a;break;case 3:e.windowSettings.properties[h]=a;break;case 4:e.resourceSettings.properties[h]=a;break;case 5:e.resourceSettings.properties[h]=a,this.resourceLanguageSettingsSchema.properties[h]=a;break}}removeFromSchema(h,a){switch(delete e.allSettings.properties[h],a.scope){case 1:delete e.applicationSettings.properties[h];break;case 2:delete e.machineSettings.properties[h];break;case 6:delete e.machineOverridableSettings.properties[h];break;case 3:delete e.windowSettings.properties[h];break;case 4:case 5:delete e.resourceSettings.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const a=`[${h}]`,u={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,u),e.allSettings.properties[a]=u,e.applicationSettings.properties[a]=u,e.machineSettings.properties[a]=u,e.machineOverridableSettings.properties[a]=u,e.windowSettings.properties[a]=u,e.resourceSettings.properties[a]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,a){let u=this.defaultValues[h];k.isUndefined(u)&&(u=a.default),k.isUndefined(u)&&(u=d(a.type)),a.default=u}}const P="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(P);function y(c){return c.substring(1,c.length-1)}e.overrideIdentifierFromKey=y;function d(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new I;n.Registry.add(e.Extensions.Configuration,g);function b(c){return c.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(c)?M.localize(5,null,c):g.getConfigurationProperties()[c]!==void 0?M.localize(6,null,c):null:M.localize(4,null)}e.validateProperty=b;function v(){const c=[],h=g.getConfigurationProperties();for(const a of Object.keys(h))c.push([a,h[a].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=v}),define(Z[16],x([0,1,44,13,7,49,5,38]),function(V,e,p,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,E.createDecorator)("configurationService");function f(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof k.URI)}e.isConfigurationOverrides=f;var w;(function(l){l[l.USER=1]="USER",l[l.USER_LOCAL=2]="USER_LOCAL",l[l.USER_REMOTE=3]="USER_REMOTE",l[l.WORKSPACE=4]="WORKSPACE",l[l.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",l[l.DEFAULT=6]="DEFAULT",l[l.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(l){switch(l){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(l,r){const s=r?l?r.keys.filter(_=>l.keys.indexOf(_)===-1):[...r.keys]:[],o=l?r?l.keys.filter(_=>r.keys.indexOf(_)===-1):[...l.keys]:[],m=[];if(r&&l){for(const _ of l.keys)if(r.keys.indexOf(_)!==-1){const G=v(l.contents,_),ne=v(r.contents,_);p.equals(G,ne)||m.push(_)}}const S=[],D=_=>{const G={};for(const ne of _)for(const se of ne.identifiers)G[u(se)]=ne;return G},R=r?D(r.overrides):{},T=l?D(l.overrides):{};if(Object.keys(R).length)for(const _ of s){const G=R[_];G&&S.push([(0,M.overrideIdentifierFromKey)(_),G.keys])}if(Object.keys(T).length)for(const _ of o){const G=T[_];G&&S.push([(0,M.overrideIdentifierFromKey)(_),G.keys])}if(Object.keys(R).length&&Object.keys(T).length)for(const _ of m){const G=T[_],ne=R[_];if(G&&ne){const se=I({contents:G.contents,keys:G.keys,overrides:[]},{contents:ne.contents,keys:ne.keys,overrides:[]});S.push([(0,M.overrideIdentifierFromKey)(_),[...se.added,...se.removed,...se.updated]])}}return{added:s,removed:o,updated:m,overrides:S}}e.compare=I;function P(l,r){const s=[];for(const o of Object.keys(l))if(M.OVERRIDE_PROPERTY_PATTERN.test(o)){const m={};for(const S in l[o])m[S]=l[o][S];s.push({identifiers:[(0,M.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(m),contents:y(m,r)})}return s}e.toOverrides=P;function y(l,r){const s=Object.create(null);for(let o in l)d(s,o,l[o],r);return s}e.toValuesTree=y;function d(l,r,s,o){const m=r.split("."),S=m.pop();let D=l;for(let R=0;R<m.length;R++){let T=m[R],_=D[T];switch(typeof _){case"undefined":_=D[T]=Object.create(null);break;case"object":break;default:o(`Ignoring ${r} as ${m.slice(0,R+1).join(".")} is ${JSON.stringify(_)}`);return}D=_}if(typeof D=="object"&&D!==null)try{D[S]=s}catch(R){o(`Ignoring ${r} as ${m.join(".")} is ${JSON.stringify(D)}`)}else o(`Ignoring ${r} as ${m.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=d;function g(l,r){const s=r.split(".");b(l,s)}e.removeFromValueTree=g;function b(l,r){const s=r.shift();if(r.length===0){delete l[s];return}if(Object.keys(l).indexOf(s)!==-1){const o=l[s];typeof o=="object"&&!Array.isArray(o)&&(b(o,r),Object.keys(o).length===0&&delete l[s])}}function v(l,r,s){function o(D,R){let T=D;for(const _ of R){if(typeof T!="object"||T===null)return;T=T[_]}return T}const m=r.split("."),S=o(l,m);return typeof S=="undefined"?s:S}e.getConfigurationValue=v;function c(l,r,s){Object.keys(r).forEach(o=>{o!=="__proto__"&&(o in l?L.isObject(l[o])&&L.isObject(r[o])?c(l[o],r[o],s):s&&(l[o]=r[o]):l[o]=r[o])})}e.merge=c;function h(){const l=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();return Object.keys(l)}e.getConfigurationKeys=h;function a(){const l=Object.create(null),r=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();for(let s in r){let o=r[s].default;d(l,s,o,m=>console.error(`Conflict in default settings: ${m}`))}return l}e.getDefaultValues=a;function u(l){return`[${l}]`}e.keyFromOverrideIdentifier=u;function t(l,r,s){const o=l.inspect(r),m=l.inspect(s);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:o.defaultValue}e.getMigratedSettingValue=t}),define(Z[189],x([0,1,30,4,40,2,37,44,13,7,16,49,38]),function(V,e,p,L,k,M,E,n,f,w,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(t={},l=[],r=[]){this._contents=t,this._keys=l,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,l){const r=this.getContentsForOverrideIdentifer(l);return r?t?(0,i.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const l of this.overrides)if(l.identifiers.indexOf(t)!==-1)return l.keys;return[]}override(t){let l=this.overrideConfigurations.get(t);return l||(l=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,l)),l}merge(...t){const l=n.deepClone(this.contents),r=n.deepClone(this.overrides),s=[...this.keys];for(const o of t){this.mergeContents(l,o.contents);for(const m of o.overrides){const[S]=r.filter(D=>p.equals(D.identifiers,m.identifiers));S?this.mergeContents(S.contents,m.contents):r.push(n.deepClone(m))}for(const m of o.keys)s.indexOf(m)===-1&&s.push(m)}return new y(l,s,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(t){const l=this.getContentsForOverrideIdentifer(t);if(!l||typeof l!="object"||!Object.keys(l).length)return this;let r={};for(const s of p.distinct([...Object.keys(this.contents),...Object.keys(l)])){let o=this.contents[s],m=l[s];m&&(typeof o=="object"&&typeof m=="object"?(o=n.deepClone(o),this.mergeContents(o,m)):o=m),r[s]=o}return new y(r,this.keys,this.overrides)}mergeContents(t,l){for(const r of Object.keys(l)){if(r in t&&f.isObject(t[r])&&f.isObject(l[r])){this.mergeContents(t[r],l[r]);continue}t[r]=n.deepClone(l[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?n.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const l of this.overrides)if(l.identifiers.indexOf(t)!==-1)return l.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,l){this.addKey(t),(0,i.addToValueTree)(this.contents,t,l,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let l=this.keys.length;for(let r=0;r<l;r++)t.indexOf(this.keys[r])===0&&(l=r);this.keys.splice(l,1,t)}removeKey(t){let l=this.keys.indexOf(t);return l!==-1?(this.keys.splice(l,1),!0):!1}}e.ConfigurationModel=y;class d extends y{constructor(){const t=(0,i.getDefaultValues)(),l=(0,i.getConfigurationKeys)(),r=[];for(const s of Object.keys(t))I.OVERRIDE_PROPERTY_PATTERN.test(s)&&r.push({identifiers:[(0,I.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,i.toValuesTree)(t[s],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,l,r)}}e.DefaultConfigurationModel=d;class g{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,l){if(!f.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,l)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,l){this._raw=t;const{contents:r,keys:s,overrides:o,restricted:m}=this.doParseRaw(t,l);this._configurationModel=new y(r,s,o),this._restrictedConfigurations=m||[]}doParseContent(t){let l={},r=null,s=[],o=[],m=[];function S(R){Array.isArray(s)?s.push(R):r!==null&&(s[r]=R)}let D={onObjectBegin:()=>{let R={};S(R),o.push(s),s=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{let R=[];S(R),o.push(s),s=R,r=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:S,onError:(R,T,_)=>{m.push({error:R,offset:T,length:_})}};if(t)try{k.visit(t,D),l=s[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return l}doParseRaw(t,l){const r=P.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,r,!0,l);t=s.raw;const o=(0,i.toValuesTree)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),m=Object.keys(t),S=(0,i.toOverrides)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:o,keys:m,overrides:S,restricted:s.restricted}}filter(t,l,r,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:t,restricted:[]};const o={},m=[];for(let S in t)if(I.OVERRIDE_PROPERTY_PATTERN.test(S)&&r){const D=this.filter(t[S],l,!1,s);o[S]=D.raw,m.push(...D.restricted)}else{const D=l[S],R=D?typeof D.scope!="undefined"?D.scope:3:void 0;D?.restricted&&m.push(S),(R===void 0||s.scopes===void 0||s.scopes.includes(R))&&(s.skipRestricted&&D?.restricted||(o[S]=t[S]))}return{raw:o,restricted:m}}}e.ConfigurationModelParser=g;class b extends M.Disposable{constructor(t,l,r,s){super();this.userSettingsResource=t,this.scopes=l,this.fileService=s,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class v{constructor(t,l,r=new y,s=new y,o=new E.ResourceMap,m=new y,S=new E.ResourceMap,D=!0){this._defaultConfiguration=t,this._localUserConfiguration=l,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=o,this._memoryConfiguration=m,this._memoryConfigurationByResource=S,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new E.ResourceMap,this._userConfiguration=null}getValue(t,l,r){return this.getConsolidateConfigurationModel(l,r).getValue(t)}updateValue(t,l,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new y,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,l===void 0?s.removeValue(t):s.setValue(t,l),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,l,r){const s=this.getConsolidateConfigurationModel(l,r),o=this.getFolderConfigurationModelForResource(l.resource,r),m=l.resource?this._memoryConfigurationByResource.get(l.resource)||this._memoryConfiguration:this._memoryConfiguration,S=l.overrideIdentifier?this._defaultConfiguration.freeze().override(l.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),D=l.overrideIdentifier?this.userConfiguration.freeze().override(l.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),R=l.overrideIdentifier?this.localUserConfiguration.freeze().override(l.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),T=l.overrideIdentifier?this.remoteUserConfiguration.freeze().override(l.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),_=r?l.overrideIdentifier?this._workspaceConfiguration.freeze().override(l.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,G=o?l.overrideIdentifier?o.freeze().override(l.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,ne=l.overrideIdentifier?m.override(l.overrideIdentifier).getValue(t):m.getValue(t),se=s.getValue(t),K=p.distinct(p.flatten(s.overrides.map(te=>te.identifiers))).filter(te=>s.getOverrideValue(t,te)!==void 0);return{defaultValue:S,userValue:D,userLocalValue:R,userRemoteValue:T,workspaceValue:_,workspaceFolderValue:G,memoryValue:ne,value:se,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:l.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,l.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:l.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,l.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:l.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,l.overrideIdentifier):void 0}:void 0,userRemote:T!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:l.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,l.overrideIdentifier):void 0}:void 0,workspace:_!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:l.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,l.overrideIdentifier):void 0}:void 0,workspaceFolder:G!==void 0?{value:o?.freeze().getValue(t),override:l.overrideIdentifier?o?.freeze().getOverrideValue(t,l.overrideIdentifier):void 0}:void 0,memory:ne!==void 0?{value:m.getValue(t),override:l.overrideIdentifier?m.getOverrideValue(t,l.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(t){const l=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:l?l.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,l){this._folderConfigurations.set(t,l),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,l){const r=l.filter(s=>I.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const o=(0,I.overrideIdentifierFromKey)(s),m=this._defaultConfiguration.getKeysForOverrideIdentifier(o),S=t.getKeysForOverrideIdentifier(o),D=[...S.filter(R=>m.indexOf(R)===-1),...m.filter(R=>S.indexOf(R)===-1),...m.filter(R=>!n.equals(this._defaultConfiguration.override(o).getValue(R),t.override(o).getValue(R)))];return[o,D]});return this.updateDefaultConfiguration(t),{keys:l,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:l,updated:r,removed:s,overrides:o}=(0,i.compare)(this.localUserConfiguration,t),m=[...l,...r,...s];return m.length&&this.updateLocalUserConfiguration(t),{keys:m,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:l,updated:r,removed:s,overrides:o}=(0,i.compare)(this.remoteUserConfiguration,t);let m=[...l,...r,...s];return m.length&&this.updateRemoteUserConfiguration(t),{keys:m,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:l,updated:r,removed:s,overrides:o}=(0,i.compare)(this.workspaceConfiguration,t);let m=[...l,...r,...s];return m.length&&this.updateWorkspaceConfiguration(t),{keys:m,overrides:o}}compareAndUpdateFolderConfiguration(t,l){const r=this.folderConfigurations.get(t),{added:s,updated:o,removed:m,overrides:S}=(0,i.compare)(r,l);let D=[...s,...o,...m];return(D.length||!r)&&this.updateFolderConfiguration(t,l),{keys:D,overrides:S}}compareAndDeleteFolderConfiguration(t){const l=this.folderConfigurations.get(t);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:s,removed:o,overrides:m}=(0,i.compare)(l,void 0);return{keys:[...r,...s,...o],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,l){let r=this.getConsolidatedConfigurationModelForResource(t,l);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},l){let r=this.getWorkspaceConsolidatedConfiguration();if(l&&t){const s=l.getFolder(t);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const o=this._memoryConfigurationByResource.get(t);o&&(r=r.merge(o))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let l=this._foldersConsolidatedConfigurations.get(t);if(!l){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(l=r.merge(s),this._freeze&&(l=l.freeze()),this._foldersConsolidatedConfigurations.set(t,l)):l=r}return l}getFolderConfigurationModelForResource(t,l){if(l&&t){const r=l.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,l)=>{const{contents:r,overrides:s,keys:o}=this._folderConfigurations.get(l);return t.push([l,{contents:r,overrides:s,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(l=>t.add(l)),this.userConfiguration.freeze().keys.forEach(l=>t.add(l)),this._workspaceConfiguration.freeze().keys.forEach(l=>t.add(l)),this._folderConfigurations.forEach(l=>l.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const l=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>l.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>l.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>l.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(s=>l.add(s))),[...l.values()]}static parse(t){const l=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((m,S)=>(m.set(w.URI.revive(S[0]),this.parseConfigurationModel(S[1])),m),new E.ResourceMap);return new v(l,r,new y,s,o,new y,new E.ResourceMap,!1)}static parseConfigurationModel(t){return new y(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=v;function c(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const t=new Set,l=new Map;for(const s of u)s.keys.forEach(o=>t.add(o)),s.overrides.forEach(([o,m])=>{const S=(0,E.getOrSet)(l,o,new Set);m.forEach(D=>S.add(D))});const r=[];return l.forEach((s,o)=>r.push([o,[...s.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=c;class h{constructor(t,l,r,s){this.change=t,this.previous=l,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(S=>o.add(S)),t.overrides.forEach(([,S])=>S.forEach(D=>o.add(D))),this.affectedKeys=[...o.values()];const m=new y;this.affectedKeys.forEach(S=>m.setValue(S,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,l){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(l){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,l,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(t,l,this.currentWorkspace);return!n.equals(r,s)}return!0}return!1}doesAffectedKeysTreeContains(t,l){let r=(0,i.toValuesTree)({[l]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(t=t[s],!t)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=h;class a extends h{constructor(t,l,r,s){super({keys:t.allKeys(),overrides:[]},void 0,t,l);this.source=r,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=a}),define(Z[190],x([0,1,9,4,2,15,16,189,49,38]),function(V,e,p,L,k,M,E,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends k.Disposable{constructor(P,y){super();this.settingsResource=P,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new n.UserSettings(this.settingsResource,void 0,M.extUriBiasedIgnorePathCase,y)),this.configuration=new n.Configuration(new n.DefaultConfigurationModel,new n.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(w.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const P=await this.userConfiguration.loadConfiguration();this.configuration=new n.Configuration(new n.DefaultConfigurationModel,P)}getConfigurationData(){return this.configuration.toData()}getValue(P,y){const d=typeof P=="string"?P:void 0,g=(0,E.isConfigurationOverrides)(P)?P:(0,E.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(d,g,void 0)}updateValue(P,y,d,g){return Promise.reject(new Error("not supported"))}inspect(P){return this.configuration.inspect(P,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const P=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(P)}onDidChangeUserConfiguration(P){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(P);this.trigger(d,y,1)}onDidDefaultConfigurationChange(P){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new n.DefaultConfigurationModel,P);this.trigger(d,y,6)}trigger(P,y,d){const g=new n.ConfigurationChangeEvent(P,{data:y},this.configuration);g.source=d,g.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(P){switch(P){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(Z[191],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var L;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(E,n=L.Unknown,f){super(E);this._message=E,this._code=n,this._detail=f,this.isHandled=n===L.NotAvailable&&f===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(E){return E instanceof k&&E._code===L.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof k&&E._code===L.NoResolverFound}static isHandled(E){return E instanceof k&&E.isHandled}}e.RemoteAuthorityResolverError=k}),define(Z[192],x([0,1,9,18,23,17,4,2,28,84,191]),function(V,e,p,L,k,M,E,n,f,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var P;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(P=e.ConnectionType||(e.ConnectionType={}));function y(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(U){const A=new k.CancellationTokenSource;return setTimeout(()=>A.cancel(),U),A.token}function g(U,A){if(U.isCancellationRequested||A.isCancellationRequested)return k.CancellationToken.Cancelled;const F=new k.CancellationTokenSource;return U.onCancellationRequested(()=>F.cancel()),A.onCancellationRequested(()=>F.cancel()),F.token}class b{constructor(A){this._state="pending",this._disposables=new n.DisposableStore,this.promise=new Promise((F,B)=>{this._resolvePromise=F,this._rejectPromise=B}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function v(U,A){const F=new b(A);return F.registerDisposable(U.onControlMessage(B=>{const Y=JSON.parse(B.toString()),C=H(Y);C?F.reject(C):F.resolve(Y)})),F.promise}function c(U,A,F,B,Y,C){const N=new b(C);return A.connect(F,B,Y,(Q,J)=>{N.didTimeout?(Q&&U.error(Q),J?.dispose()):Q||!J?N.reject(Q):N.resolve(J)}),N.promise}function h(U,A){const F=new b(A);return U.then(B=>{F.didTimeout||F.resolve(B)},B=>{F.didTimeout||F.reject(B)}),F.promise}async function a(U,A,F,B){const Y=O(U,A);U.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let C;try{C=await c(U.logService,U.socketFactory,U.host,U.port,`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,B)}catch(re){throw U.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),U.logService.error(re),re}U.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let N,Q;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(C,null),N=U.reconnectionProtocol,Q=!1):(N=new w.PersistentProtocol(C,null),Q=!0),U.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const J={type:"auth",auth:U.connectionToken||"00000000000000000000"};N.sendControl(L.VSBuffer.fromString(JSON.stringify(J)));try{const re=await v(N,g(B,d(1e4)));if(re.type!=="sign"||typeof re.data!="string"){const ae=new Error("Unexpected handshake message");throw ae.code="VSCODE_CONNECTION_ERROR",ae}U.logService.trace(`${Y} 4/6. received SignRequest control message.`);const le=await h(U.signService.sign(re.data),B),ee={type:"connectionType",commit:U.commit,signedData:le,desiredConnectionType:A};return F&&(ee.args=F),U.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),N.sendControl(L.VSBuffer.fromString(JSON.stringify(ee))),{protocol:N,ownsProtocol:Q}}catch(re){throw re&&re.code==="ETIMEDOUT"&&(U.logService.error(`${Y} the handshake timed out. Error:`),U.logService.error(re)),re&&re.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${Y} received error control message when negotiating connection. Error:`),U.logService.error(re)),Q&&j(N),re}}async function u(U,A,F,B){const Y=Date.now(),C=O(U,A),{protocol:N,ownsProtocol:Q}=await a(U,A,F,B),J=new b(B);return J.registerDisposable(N.onControlMessage(re=>{const le=JSON.parse(re.toString()),ee=H(le);ee?(U.logService.error(`${C} received error control message when negotiating connection. Error:`),U.logService.error(ee),Q&&j(N),J.reject(ee)):(U.reconnectionProtocol&&U.reconnectionProtocol.endAcceptReconnection(),U.logService.trace(`${C} 6/6. handshake finished, connection is up and running after ${$(Y)}!`),J.resolve({protocol:N,firstMessage:le}))})),J.promise}async function t(U,A){const{protocol:F}=await u(U,1,void 0,A);return{protocol:F}}async function l(U,A,F){const{protocol:B,firstMessage:Y}=await u(U,2,A,F),C=Y&&Y.debugPort;return{protocol:B,debugPort:C}}async function r(U,A,F){const B=Date.now(),Y=O(U,3),{protocol:C}=await a(U,3,A,F);return U.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${$(B)}!`),C}async function s(U,A,F){const{host:B,port:Y,connectionToken:C}=await U.addressProvider.getAddress();return{commit:U.commit,host:B,port:Y,connectionToken:C,reconnectionToken:A,reconnectionProtocol:F,socketFactory:U.socketFactory,signService:U.signService,logService:U.logService}}async function o(U,A,F){try{const B=(0,f.generateUuid)(),Y=await s(U,B,null),{protocol:C}=await t(Y,k.CancellationToken.None);return new te(U,A,F,B,C)}catch(B){throw U.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),U.logService.error(B),K.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentManagement=o;async function m(U,A){try{const F=(0,f.generateUuid)(),B=await s(U,F,null),{protocol:Y,debugPort:C}=await l(B,A,k.CancellationToken.None);return new W(U,A,F,Y,C)}catch(F){throw U.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),U.logService.error(F),K.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(F)),F}}e.connectRemoteAgentExtensionHost=m;async function S(U,A,F){const B=await s(U,(0,f.generateUuid)(),null);return await r(B,{host:A,port:F},k.CancellationToken.None)}e.connectRemoteAgentTunnel=S;function D(U){return(0,p.createCancelablePromise)(A=>new Promise((F,B)=>{const Y=setTimeout(F,U*1e3);A.onCancellationRequested(()=>{clearTimeout(Y),F()})}))}var R;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class T{constructor(A,F){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.type=0}}e.ConnectionLostEvent=T;class _{constructor(A,F,B,Y){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.durationSeconds=B,this.cancellableTimer=Y,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class G{constructor(A,F,B){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=B,this.type=2}}e.ReconnectionRunningEvent=G;class ne{constructor(A,F,B){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=B,this.type=4}}e.ConnectionGainEvent=ne;class se{constructor(A,F,B,Y){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=B,this.handled=Y,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class K extends n.Disposable{constructor(A,F,B,Y){super();this._connectionType=A,this._onDidStateChange=this._register(new E.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=F,this.reconnectionToken=B,this.protocol=Y,this._isReconnecting=!1,this._onDidStateChange.fire(new ne(this.reconnectionToken,0,0)),this._register(Y.onSocketClose(C=>{const N=q(this._connectionType,this.reconnectionToken,!0);C?C.type===0?(this._options.logService.info(`${N} received socket close event (hadError: ${C.hadError}).`),C.error&&this._options.logService.error(C.error)):(this._options.logService.info(`${N} received socket close event (wasClean: ${C.wasClean}, code: ${C.code}, reason: ${C.reason}).`),C.event&&this._options.logService.error(C.event)):this._options.logService.info(`${N} received socket close event.`),this._beginReconnecting()})),this._register(Y.onSocketTimeout(()=>{const C=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${C} received socket timeout event.`),this._beginReconnecting()})),K._instances.push(this),K._permanentFailure&&this._gotoPermanentFailure(K._permanentFailureMillisSinceLastIncomingData,K._permanentFailureAttempt,K._permanentFailureHandled)}static triggerPermanentFailure(A,F,B){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=F,this._permanentFailureHandled=B,this._instances.forEach(Y=>Y._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(K._permanentFailure)return;const A=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const Y=B<F.length?F[B]:F[F.length-1];try{if(Y>0){const N=D(Y);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,N)),this._options.logService.info(`${A} waiting for ${Y} seconds before reconnecting...`);try{await N}catch{}}if(K._permanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this._options.logService.info(`${A} resolving connection...`);const C=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${C.host}:${C.port}...`),await this._reconnect(C,d(I)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(C){if(C.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(C),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(C),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(i.RemoteAuthorityResolverError.isTemporarilyNotAvailable(C)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(C);continue}if((C.code==="ETIMEDOUT"||C.code==="ENETUNREACH"||C.code==="ECONNREFUSED"||C.code==="ECONNRESET")&&C.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(C);continue}if((0,M.isPromiseCanceledError)(C)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(C);continue}if(C instanceof i.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(C),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,i.RemoteAuthorityResolverError.isHandled(C));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(C),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!K._permanentFailure)}_gotoPermanentFailure(A,F,B){this._onDidStateChange.fire(new se(this.reconnectionToken,A,F,B)),j(this.protocol)}}K._permanentFailure=!1,K._permanentFailureMillisSinceLastIncomingData=0,K._permanentFailureAttempt=0,K._permanentFailureHandled=!1,K._instances=[];class te extends K{constructor(A,F,B,Y,C){super(1,A,Y,C);this.client=this._register(new w.Client(C,{remoteAuthority:F,clientId:B},A.ipcLogger))}async _reconnect(A,F){await t(A,F)}}e.ManagementPersistentConnection=te;class W extends K{constructor(A,F,B,Y,C){super(2,A,B,Y);this._startArguments=F,this.debugPort=C}async _reconnect(A,F){await l(A,this._startArguments,F)}}e.ExtensionHostPersistentConnection=W;function j(U){try{U.acceptDisconnect();const A=U.getSocket();U.dispose(),A.dispose()}catch(A){(0,M.onUnexpectedError)(A)}}function H(U){if(U&&U.type==="error"){const A=new Error(`Connection error: ${U.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function z(U,A){for(;U.length<A;)U+=" ";return U}function q(U,A,F){return`[remote-connection][${z(y(U),13)}][${A.substr(0,5)}\u2026][${F?"reconnect":"initial"}]`}function O(U,A){return`${q(A,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.host}:${U.port}]`}function $(U){return`${Date.now()-U} ms`}}),define(Z[74],x([0,1,10]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(w){return w.scheme===p.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=L;function k(w){if(!w)return;const i=w.indexOf("+");return i<0?w:w.substr(0,i)}e.getRemoteName=k;function M(w){return w.scheme!==p.Schemas.file&&w.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=M;function E(w){if(w.folders.length)return w.folders.every(i=>M(i.uri))?w.folders[0].uri:void 0;if(w.configuration&&M(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=E;function n(w){return E(w)?.scheme}e.getVirtualWorkspaceScheme=n;function f(w){return E(w)!==void 0}e.isVirtualWorkspace=f}),define(Z[96],x([0,1,4,3,5,6]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var E;(function(d){d.Http="http",d.Https="https"})(E=e.TunnelProtocol||(e.TunnelProtocol={}));var n;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(n=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var f;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(f=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=I;function P(d,g){return g?g!==1&&d<1024:!L.isWindows&&d<1024}e.isPortPrivileged=P;let y=class{constructor(g){this.logService=g,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g,b){return this._tunnelProvider=g,g?(this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return new Promise(async g=>{const b=[],v=Array.from(this._tunnels.values());for(let c of v){const h=Array.from(c.values());for(let a of h){const u=await a.value;u&&b.push(u)}}g(b)})}async dispose(){for(const g of this._tunnels.values()){for(const{value:b}of g.values())await b.then(v=>v?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,b,v,c,h=!1,a=n.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${b}:${v} on local port ${c}.`),!g)return;b||(b="localhost");const t=this.retainOrCreateTunnel(g,b,v,c,h,a,u);return t?t.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(b,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(l);return(l.tunnelRemoteHost!==b||l.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const b=this._tunnels.get(g.tunnelRemoteHost);if(b){const v=b.get(g.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,v))}}}}async tryDisposeTunnel(g,b,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${b}.`);const c=v.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(b),c}}async closeTunnel(g,b){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${b} `);const v=this._tunnels.get(g);if(v&&v.has(b)){const c=v.get(b);c.refcount=0,await this.tryDisposeTunnel(g,b,c)}}addTunnelToMap(g,b,v){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(b,{refcount:1,value:v})}async removeEmptyTunnelFromMap(g,b){const v=this._tunnels.get(g);v&&(await v.get(b)||v.delete(b),v.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,b){let v=[g];i(g)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):I(g)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const c=v.map(h=>this._tunnels.get(h));for(const h of c){const a=h?.get(b);if(a)return a}}canTunnel(g){return!!w(g)}createWithProvider(g,b,v,c,h,a,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${b}:${v} on local port ${c}.`);const l={elevationRequired:h?P(c===void 0?v:c):!1},r={remoteAddress:{host:b,port:v},localAddressPort:c,privacy:a,public:a!==n.Private,protocol:u},s=g.forwardPort(r,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),s&&this.addTunnelToMap(b,v,s),s}};y=he([ie(0,M.ILogService)],y),e.AbstractTunnelService=y}),define(Z[50],x([0,1,18,147,49,5,38]),function(V,e,p,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function n(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=n;function f(d){return d.res.statusCode===204}async function w(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);return f(d)?null:(await(0,p.streamToBuffer)(d.stream)).toString()}e.asText=w;async function i(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);if(f(d))return null;const b=(await(0,p.streamToBuffer)(d.stream)).toString();try{return JSON.parse(b)}catch(v){throw v.message+=`:
`+b,v}}e.asJson=i;function I(d){y(d)}e.updateProxyConfigurationsScope=I;let P;function y(d){const g=E.Registry.as(k.Extensions.Configuration),b=P;P={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[P],remove:b?[b]:[]})}y(2)}),define(Z[193],x([0,1,194,13]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(E,n){return E.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:E.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function M(E,n,f={}){const w=(0,p.parse)(E),i=f.proxyUrl||k(w,n);if(!i)return null;const I=(0,p.parse)(i);if(!/^https?:$/.test(I.protocol||""))return null;const P={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,L.isBoolean)(f.strictSSL)?f.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((y,d)=>{V(["http-proxy-agent"],y,d)}))(P):new(await new Promise((y,d)=>{V(["https-proxy-agent"],y,d)}))(P)}e.getProxyAgent=M}),define(Z[195],x([0,1,18,28]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(M,E,n){let f=n&&n.get("storage.serviceMachineId",0)||null;if(f)return f;try{const i=(await E.readFile(M.serviceMachineIdResource)).value.toString();f=(0,L.isUUID)(i)?i:null}catch(w){f=null}if(!f){f=(0,L.generateUuid)();try{await E.writeFile(M.serviceMachineIdResource,p.VSBuffer.fromString(f))}catch(w){}}return n&&n.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=k}),define(Z[75],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,p.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[196],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{vsda(){return new Promise((k,M)=>V(["vsda"],k,M))}async sign(k){try{const M=await this.vsda(),E=new M.signer;if(E)return E.sign(k)}catch(M){}return k}}e.SignService=p}),define(Z[39],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,p.createDecorator)("stateMainService")}),define(Z[22],x([0,1,14,9,4,2,3,33,13,5,178,6,39]),function(V,e,p,L,k,M,E,n,f,w,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,w.createDecorator)("lifecycleMainService");var y;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen"})(y=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let d=class lt extends M.Disposable{constructor(b,v){super();this.logService=b,this.stateMainService=v,this._onBeforeShutdown=this._register(new k.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new k.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new k.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new k.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new k.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(lt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(lt.QUIT_AND_RESTART_KEY)}registerListeners(){const b=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),E.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};p.app.addListener("before-quit",b);const v=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!E.isMacintosh)&&p.app.quit()};p.app.addListener("window-all-closed",v),p.app.once("will-quit",c=>{this.logService.trace("Lifecycle#app.on(will-quit)"),c.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),p.app.removeListener("before-quit",b),p.app.removeListener("window-all-closed",v),p.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const b=[];return this._onWillShutdown.fire({join(v){b.push(v)}}),this.pendingWillShutdownPromise=(async()=>{try{await L.Promises.settled(b)}catch(v){this.logService.error(v)}try{await this.stateMainService.close()}catch(v){this.logService.error(v)}})(),this.pendingWillShutdownPromise}set phase(b){if(b<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===b)return;this.logService.trace(`lifecycle (main): phase changed (value: ${b})`),this._phase=b;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}async when(b){if(b<=this._phase)return;let v=this.phaseWhen.get(b);v||(v=new L.Barrier,this.phaseWhen.set(b,v)),await v.wait()}registerWindow(b){const v=new M.DisposableStore;this.windowCounter++,v.add(b.onWillLoad(h=>this._onWillLoadWindow.fire({window:b,workspace:h.workspace,reason:h.reason})));const c=(0,f.assertIsDefined)(b.win);c.on("close",h=>{const a=b.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${b.id}`),h.preventDefault(),this.unload(b,1).then(u=>{if(u){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(b),b.close()})}),c.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${b.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!E.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(b,v){await this.unload(b,3)||b.reload(v)}async unload(b,v){if(!b.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${b.id}`);const c=this._quitRequested?2:v;let h=await this.onBeforeUnloadWindowInRenderer(b,c);return h?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${b.id})`),this.handleWindowUnloadVeto(h)):(h=await this.onBeforeUnloadWindowInMain(b,c),h?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${b.id})`),this.handleWindowUnloadVeto(h)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${b.id})`),await this.onWillUnloadWindowInRenderer(b,c),!1))}handleWindowUnloadVeto(b){return b?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(b){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(b),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(b,v){return new Promise(c=>{const h=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${h}`,u=`vscode:cancel${h}`;p.ipcMain.once(a,()=>{c(!1)}),p.ipcMain.once(u,()=>{c(!0)}),b.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:u,reason:v})})}onBeforeUnloadWindowInMain(b,v){const c=[];return this._onBeforeUnloadWindow.fire({reason:v,window:b,veto(h){c.push(h)}}),(0,i.handleVetos)(c,h=>this.logService.error(h))}onWillUnloadWindowInRenderer(b,v){return new Promise(c=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;p.ipcMain.once(a,()=>c()),b.send("vscode:onWillUnload",{replyChannel:a,reason:v})})}quit(b){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${b}`),b&&this.stateMainService.setItem(lt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.logService.trace("Lifecycle#quit() - calling app.quit()"),p.app.quit()}),this.pendingQuitPromise)}async relaunch(b){this.logService.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if(b?.addArgs&&v.push(...b.addArgs),b?.removeArgs)for(const a of b.removeArgs){const u=v.indexOf(a);u>=0&&v.splice(u,1)}const c=()=>{try{if(E.isWindows){const a=(0,n.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),p.app.relaunch({args:v})};p.app.once("quit",c),await this.quit(!0)&&p.app.removeListener("quit",c)}async kill(b){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const v of p.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let c;v.webContents&&!v.webContents.isDestroyed()?c=new Promise(h=>v.once("closed",h)):c=Promise.resolve(),v.destroy(),await c}})()]),p.app.exit(b)}};d.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",d=he([ie(0,I.ILogService),ie(1,P.IStateMainService)],d),e.LifecycleMainService=d}),define(Z[197],x([0,1,4,2,5,22]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,k.createDecorator)("keyboardLayoutMainService");let E=class extends L.Disposable{constructor(w){super();this._onDidChangeKeyboardLayout=this._register(new p.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,w.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const w=await new Promise((i,I)=>{V(["native-keymap"],i,I)});this._keyboardLayoutData=n(w),w.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(w),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};E=he([ie(0,M.ILifecycleMainService)],E),e.KeyboardLayoutMainService=E;function n(f){const w=f.getKeyMap(),i=f.getCurrentKeyboardLayout();return{keyboardMapping:w,keyboardLayoutInfo:i}}}),define(Z[97],x([0,1,9,4,2,13,86,5]),function(V,e,p,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,n.createDecorator)("storageService");var w;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var I;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class P extends k.Disposable{constructor(b={flushInterval:P.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new p.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,p.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,v){v===f?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:v,target:this.getKeyTargets(b)[v]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,v,c){return this.getStorage(v)?.get(b,c)}getBoolean(b,v,c){return this.getStorage(v)?.getBoolean(b,c)}getNumber(b,v,c){return this.getStorage(v)?.getNumber(b,c)}store(b,v,c,h){if((0,M.isUndefinedOrNull)(v)){this.remove(b,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(b,c,h),this.getStorage(c)?.set(b,v)})}remove(b,v){this.withPausedEmitters(()=>{this.updateKeyTarget(b,v,void 0),this.getStorage(v)?.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,v){const c=[],h=this.getKeyTargets(b);for(const a of Object.keys(h))h[a]===v&&c.push(a);return c}updateKeyTarget(b,v,c){const h=this.getKeyTargets(v);typeof c=="number"?h[b]!==c&&(h[b]=c,this.getStorage(v)?.set(f,JSON.stringify(h))):typeof h[b]=="number"&&(delete h[b],this.getStorage(v)?.set(f,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const v=this.get(f,b);if(v)try{return JSON.parse(v)}catch(c){}return Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=w.NONE){this._onWillSaveState.fire({reason:b}),await p.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const b=this.getStorage(0)?.items??new Map,v=this.getStorage(1)?.items??new Map;return d(b,v,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=P,P.DEFAULT_FLUSH_INTERVAL=60*1e3;class y extends P{constructor(){super();this.globalStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}e.InMemoryStorageService=y;async function d(g,b,v,c){const h=o=>{try{return JSON.parse(o)}catch(m){return o}},a=new Map,u=new Map;g.forEach((o,m)=>{a.set(m,o),u.set(m,h(o))});const t=new Map,l=new Map;b.forEach((o,m)=>{t.set(m,o),l.set(m,h(o))}),console.group(`Storage: Global (path: ${v})`);let r=[];a.forEach((o,m)=>{r.push({key:m,value:o})}),console.table(r),console.groupEnd(),console.log(u),console.group(`Storage: Workspace (path: ${c})`);let s=[];t.forEach((o,m)=>{s.push({key:m,value:o})}),console.table(s),console.groupEnd(),console.log(l)}e.logStorage=d}),define(Z[198],x([0,1,3,33,7,28]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function E(w){if(p.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function n(w,i,I,P,y,d,g,b,v,c){const h=Object.create(null);h["common.machineId"]=g,h.sessionID=(0,M.generateUuid)()+Date.now(),h.commitHash=y,h.version=d,h["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,p.PlatformToString)(p.platform),h["common.nodePlatform"]=L.platform,h["common.nodeArch"]=P,h["common.product"]=c||"desktop";const a=f(b||[]);a&&(h["common.msftInternal"]=a);let u=0;const t=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),p.isLinuxSnap&&(h["common.snap"]="true");const l=E(I);l&&(h["common.platformDetail"]=l);try{const r=await w.readFile(k.URI.file(v));h["common.source"]=r.value.toString().slice(0,30)}catch(r){}return h}e.resolveCommonProperties=n;function f(w){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const I=i.toLowerCase();return w.some(P=>I===P)}e.verifyMicrosoftInternalDomain=f}),define(Z[29],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[199],x([0,1,26,65,40,10,8,3,7,68,19,83,71,20,21,29]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function b(u,t){const l=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,s=new Map,o=2e4;function m(R,T,_,G){const ne=T.substring(R.length+1);return new Promise(async se=>{let K;try{K=await i.Promises.readdir(T,{withFileTypes:!0})}catch(j){se();return}if(G.count>=o){G.count+=K.length,G.maxReached=!0,se();return}let te=K.length;if(te===0){se();return}let W=K;G.count+K.length>o&&(G.maxReached=!0,te=o-G.count,W=K.slice(0,te)),G.count+=K.length;for(const j of W)if(j.isDirectory()){if(_.includes(j.name)||await m(R,(0,E.join)(T,j.name),_,G),--te==0){se();return}}else{const H=j.name.lastIndexOf(".");if(H>=0){const z=j.name.substring(H+1);z&&r.set(z,(r.get(z)??0)+1)}for(const z of l)z.relativePathPattern?.test(ne)!==!1&&z.filePattern.test(j.name)&&s.set(z.tag,(s.get(z.tag)??0)+1);if(--te==0){se();return}}})}const S={count:0,maxReached:!1};await m(u,u,t,S);const D=await h(u);return{configFiles:v(s),fileTypes:v(r),fileCount:S.count,maxFilesReached:S.maxReached,launchConfigFiles:D}}e.collectWorkspaceStats=b;function v(u){return[...L.Iterable.map(u.entries(),([t,l])=>({name:t,count:l}))].sort((t,l)=>l.count-t.count)}function c(){const u={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},t=p.cpus();return t&&t.length>0&&(u.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),u}e.getMachineInfo=c;async function h(u){try{const t=new Map,l=(0,E.join)(u,".vscode","launch.json"),r=await i.Promises.readFile(l),s=[],o=(0,k.parse)(r.toString(),s);if(s.length)return console.log(`Unable to parse ${l}`),[];if((0,k.getNodeType)(o)==="object"&&o.configurations)for(const m of o.configurations){const S=m.type;S&&(t.has(S)?t.set(S,t.get(S)+1):t.set(S,1))}return v(t)}catch(t){return[]}}e.collectLaunchConfigs=h;let a=class{constructor(t,l){this.telemetryService=t,this.productService=l}formatMachineInfo(t){const l=[];return l.push(`OS Version:       ${t.os}`),l.push(`CPUs:             ${t.cpus}`),l.push(`Memory (System):  ${t.memory}`),l.push(`VM:               ${t.vmHint}`),l.join(`
`)}formatEnvironment(t){const l=[];l.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),l.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const r=p.cpus();return r&&r.length>0&&l.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),l.push(`Memory (System):  ${(p.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`),n.isWindows||l.push(`Load (avg):       ${p.loadavg().map(s=>Math.round(s)).join(", ")}`),l.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),l.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),l.push(`Process Argv:     ${t.mainArguments.join(" ")}`),l.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),l.join(`
`)}async getPerformanceInfo(t,l){return Promise.all([(0,I.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async r=>{let[s,o]=r,m=this.formatProcessList(t,s);return l.forEach(S=>{if((0,P.isRemoteDiagnosticError)(S))m+=`
${S.errorMessage}`,o+=`
${S.errorMessage}`;else if(m+=`

Remote: ${S.hostName}`,S.processes&&(m+=`
${this.formatProcessList(t,S.processes)}`),S.workspaceMetadata){o+=`
|  Remote: ${S.hostName}`;for(const D of Object.keys(S.workspaceMetadata)){const R=S.workspaceMetadata[D];let T=`${R.fileCount} files`;R.maxFilesReached&&(T=`more than ${T}`),o+=`|    Folder (${D}): ${T}`,o+=this.formatWorkspaceStats(R)}}}),{processInfo:m,workspaceInfo:o}})}async getSystemInfo(t,l){const{memory:r,vmHint:s,os:o,cpus:m}=c(),S={os:o,memory:r,cpus:m,vmHint:s,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:l};return n.isWindows||(S.load=`${p.loadavg().map(D=>Math.round(D)).join(", ")}`),n.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(t,l){const r=[];return(0,I.listProcesses)(t.mainPID).then(async s=>(r.push(""),r.push(this.formatEnvironment(t)),r.push(""),r.push(this.formatProcessList(t,s)),t.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(t))),l.forEach(o=>{if((0,P.isRemoteDiagnosticError)(o))r.push(`
${o.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${o.hostName}`),r.push(this.formatMachineInfo(o.machineInfo)),o.processes&&r.push(this.formatProcessList(t,o.processes)),o.workspaceMetadata)for(const m of Object.keys(o.workspaceMetadata)){const S=o.workspaceMetadata[m];let D=`${S.fileCount} files`;S.maxFilesReached&&(D=`more than ${D}`),r.push(`Folder (${m}): ${D}`),r.push(this.formatWorkspaceStats(S))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(t){const l=[],r=60;let s=0;const o=(R,T)=>{const _=` ${R}(${T})`;s+_.length>r?(l.push(m),m="|                 ",s=m.length):s+=_.length,m+=_};let m="|      File types:";const S=10;let D=t.fileTypes.length>S?S:t.fileTypes.length;for(let R=0;R<D;R++){const T=t.fileTypes[R];o(T.name,T.count)}if(l.push(m),t.configFiles.length>=0&&(m="|      Conf files:",s=0,t.configFiles.forEach(R=>{o(R.name,R.count)}),l.push(m)),t.launchConfigFiles.length>0){let R="|      Launch Configs:";t.launchConfigFiles.forEach(T=>{R+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),l.push(R)}return l.join(`
`)}expandGPUFeatures(t){const l=Math.max(...Object.keys(t).map(r=>r.length));return Object.keys(t).map(r=>`${r}:  ${" ".repeat(l-r.length)}  ${t[r]}`).join(`
                  `)}formatWorkspaceMetadata(t){const l=[],r=[];return t.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(l.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const m=f.URI.revive(o);if(m.scheme===M.Schemas.file){const S=m.fsPath;r.push(b(S,["node_modules",".git"]).then(D=>{let R=`${D.fileCount} files`;D.maxFilesReached&&(R=`more than ${R}`),l.push(`|    Folder (${(0,E.basename)(S)}): ${R}`),l.push(this.formatWorkspaceStats(D))}).catch(D=>{l.push(`|      Error: Unable to collect workspace stats for folder ${S} (${D.toString()})`)}))}else l.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(s=>l.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(t,l){const r=new Map;t.windows.forEach(o=>r.set(o.pid,o.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),l&&this.formatProcessItem(t.mainPID,r,s,l,0),s.join(`
`)}formatProcessItem(t,l,r,s,o){const m=o===0;let S;m?S=s.pid===t?`${this.productService.applicationName} main`:"remote agent":(S=`${"  ".repeat(o)} ${s.name}`,s.name==="window"&&(S=`${S} (${l.get(s.pid)})`));const D=process.platform==="win32"?s.mem:p.totalmem()*(s.mem/100);r.push(`${s.load.toFixed(0).padStart(5," ")}	${(D/y.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(s.children)&&s.children.forEach(R=>this.formatProcessItem(t,l,r,R,o+1))}async reportWorkspaceStats(t){for(const{uri:l}of t.folders){const r=f.URI.revive(l);if(r.scheme!==M.Schemas.file)continue;const s=r.fsPath;try{const o=await b(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),o.fileTypes.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:m.name,count:m.count})}),o.launchConfigFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:m.name,count:m.count})}),o.configFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};a=he([ie(0,g.ITelemetryService),ie(1,d.IProductService)],a),e.DiagnosticsService=a}),define(Z[200],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(M){this.appenders=M}listen(M,E){throw new Error(`Event not found: ${E}`)}call(M,E,{eventName:n,data:f}){return this.appenders.forEach(w=>w.log(n,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class L{constructor(M){this.channel=M}log(M,E){return this.channel.call("log",{eventName:M,data:E}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[61],x([0,1,44,13,16,29]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class E{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,c){return Promise.resolve(void 0)}publicLog2(v,c){return this.publicLog(v,c)}publicLogError(v,c){return Promise.resolve(void 0)}publicLogError2(v,c){return this.publicLogError(v,c)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=E,e.NullTelemetryService=new E;class n{async publicLog(v,c,h){}async publicLogError(v,c,h){}}e.NullEndpointTelemetryService=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(b,v){return v.onDidChangeConfiguration(c=>{c.source!==6&&b.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(c.source),configurationKeys:d(c.sourceConfig)})})}e.configurationTelemetry=f;function w(b,v){return!(v.disableTelemetry||!b.enableTelemetry)}e.supportsTelemetry=w;function i(b){const v=b.getValue(M.TELEMETRY_SETTING_ID),c=b.getValue("telemetry.enableCrashReporter");if(b.getValue(M.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=i;function I(b){const v=Object.create(null),c=Object.create(null),h=Object.create(null);y(b,h);for(let a in h){a=a.length>150?a.substr(a.length-149):a;const u=h[a];typeof u=="number"?c[a]=u:typeof u=="boolean"?c[a]=u?1:0:typeof u=="string"?v[a]=u.substring(0,1023):typeof u!="undefined"&&u!==null&&(v[a]=u)}return{properties:v,measurements:c}}e.validateTelemetryData=I;function P(b){if(!b)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(h=>{b.indexOf(`${h}+`)===0&&(v=h)}),v}e.cleanRemoteAuthority=P;function y(b,v,c=0,h){if(!!b)for(let a of Object.getOwnPropertyNames(b)){const u=b[a],t=h?h+a:a;Array.isArray(u)?v[t]=(0,p.safeStringify)(u):u instanceof Date?v[t]=u.toISOString():(0,L.isObject)(u)?c<2?y(u,v,c+1,t+"."):v[t]=(0,p.safeStringify)(u):v[t]=u}}function d(b){if(!b)return[];const v=[];return g(v,"",b),v}function g(b,v,c){c&&typeof c=="object"&&!Array.isArray(c)?Object.keys(c).forEach(h=>g(b,v?`${v}.${h}`:h,c[h])):b.push(v)}}),define(Z[201],x([0,1,30,23,17,44,3,33,7,16,48,169,172,163,20,6,21,50,195,97,29,61]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d,g,b,v,c,h,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=E.isWeb?"web":(0,I.getTargetPlatform)(E.platform,n.arch);var l;(function(C){C[C.None=0]="None",C[C.IncludeVersions=1]="IncludeVersions",C[C.IncludeFiles=2]="IncludeFiles",C[C.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",C[C.IncludeSharedAccounts=8]="IncludeSharedAccounts",C[C.IncludeVersionProperties=16]="IncludeVersionProperties",C[C.ExcludeNonValidated=32]="ExcludeNonValidated",C[C.IncludeInstallationTargets=64]="IncludeInstallationTargets",C[C.IncludeAssetUri=128]="IncludeAssetUri",C[C.IncludeStatistics=256]="IncludeStatistics",C[C.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",C[C.Unpublished=4096]="Unpublished"})(l||(l={}));function r(...C){return String(C.reduce((N,Q)=>N|Q,0))}var s;(function(C){C[C.Tag=1]="Tag",C[C.ExtensionId=4]="ExtensionId",C[C.Category=5]="Category",C[C.ExtensionName=7]="ExtensionName",C[C.Target=8]="Target",C[C.Featured=9]="Featured",C[C.SearchText=10]="SearchText",C[C.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},D={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:l.None,criteria:[],assetTypes:[]};class R{constructor(N=D){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,Q=this.state.pageSize){return new R({...this.state,pageNumber:N,pageSize:Q})}withFilter(N,...Q){const J=[...this.state.criteria,...Q.length?Q.map(re=>({filterType:N,value:re})):[{filterType:N}]];return new R({...this.state,criteria:J})}withSortBy(N){return new R({...this.state,sortBy:N})}withSortOrder(N){return new R({...this.state,sortOrder:N})}withFlags(...N){return new R({...this.state,flags:N.reduce((Q,J)=>Q|J,0)})}withAssetTypes(...N){return new R({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:Q,pageSize:J,sortBy:re,sortOrder:le,flags:ee,assetTypes:ae}=this.state;return{filters:[{criteria:N,pageNumber:Q,pageSize:J,sortBy:re,sortOrder:le}],assetTypes:ae,flags:ee}}get searchText(){const N=this.state.criteria.filter(Q=>Q.filterType===s.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function T(C,N){const Q=(C||[]).filter(J=>J.statisticName===N)[0];return Q?Q.value:0}function _(C){const N="Microsoft.VisualStudio.Code.Translation.";return C.files.filter(J=>J.assetType.indexOf(N)===0).reduce((J,re)=>{const le=K(C,re.assetType);return le&&J.push([re.assetType.substring(N.length),le]),J},[])}function G(C){if(C.properties){const N=C.properties.filter(re=>re.key===o.Repository),Q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),J=N.filter(re=>Q.test(re.value))[0];return J?{uri:J.value,fallbackUri:J.value}:null}return K(C,o.Repository)}function ne(C){return{uri:`${C.fallbackAssetUri}/${o.VSIX}?redirect=true${C.targetPlatform?`&targetPlatform=${C.targetPlatform}`:""}`,fallbackUri:`${C.fallbackAssetUri}/${o.VSIX}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`}}function se(C){const N=K(C,o.Icon);if(N)return N;const Q=I.DefaultIconPath;return{uri:Q,fallbackUri:Q}}function K(C,N){return C.files.filter(J=>J.assetType===N)[0]?{uri:`${C.assetUri}/${N}`,fallbackUri:`${C.fallbackAssetUri}/${N}`}:null}function te(C,N){const Q=C.properties?C.properties.filter(re=>re.key===N):[],J=Q.length>0&&Q[0].value;return J?J.split(",").map(re=>(0,P.adoptToGalleryExtensionId)(re)):[]}function W(C){const N=C.properties?C.properties.filter(Q=>Q.key===m.Engine):[];return N.length>0&&N[0].value||""}function j(C){const N=C.properties?C.properties.filter(J=>J.key===m.LocalizedLanguages):[],Q=N.length>0&&N[0].value||"";return Q?Q.split(","):[]}function H(C){return C.indexOf("preview")!==-1}function z(C){return C.targetPlatform?(0,I.toTargetPlatform)(C.targetPlatform):"undefined"}function q(C){const N=(0,p.distinct)(C.versions.map(z)),Q=!!C.tags?.includes(I.WEB_EXTENSION_TAG),J=N.indexOf("web");return Q?J===-1&&N.push("web"):J!==-1&&N.splice(J,1),N}function O(C,N){const Q=(0,I.getFallbackTargetPlarforms)(N);for(let J=0;J<C.length;J++){const re=C[J];if(re.version===C[J-1]?.version){let le=J;const ee=z(re);if(ee===N)for(;le>0&&C[le-1].version===re.version;)le--;else if(Q.includes(ee))for(;le>0&&C[le-1].version===re.version&&z(C[le-1])!==N;)le--;le!==J&&(C.splice(J,1),C.splice(le,0,re))}}return C}e.sortExtensionVersions=O;function $(C,N,Q,J,re){const le=q(C);let ee=C.versions[0];return ee=C.versions.find(ae=>ae.version===ee.version&&(0,I.isTargetPlatformCompatible)(z(ae),le,re))||ee,U(C,ee,le,N,Q,J)}function U(C,N,Q,J,re,le){const ee={manifest:K(N,o.Manifest),readme:K(N,o.Details),changelog:K(N,o.Changelog),license:K(N,o.License),repository:G(N),download:ne(N),icon:se(N),coreTranslations:_(N)};return{identifier:{id:(0,P.getGalleryExtensionId)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},name:C.extensionName,version:N.version,displayName:C.displayName,publisherId:C.publisher.publisherId,publisher:C.publisher.publisherName,publisherDisplayName:C.publisher.displayName,description:C.shortDescription||"",installCount:T(C.statistics,"install"),rating:T(C.statistics,"averagerating"),ratingCount:T(C.statistics,"ratingcount"),categories:C.categories||[],tags:C.tags||[],releaseDate:Date.parse(C.releaseDate),lastUpdated:Date.parse(C.lastUpdated),allTargetPlatforms:Q,assets:ee,properties:{dependencies:te(N,m.Dependency),extensionPack:te(N,m.ExtensionPack),engine:W(N),localizedLanguages:j(N),targetPlatform:z(N)},preview:H(C.flags),telemetryData:{index:(re.pageNumber-1)*re.pageSize+J,querySource:le}}}let A=class{constructor(N,Q,J,re,le,ee,ae,ue){this.requestService=Q,this.logService=J,this.environmentService=re,this.telemetryService=le,this.fileService=ee,this.productService=ae,this.configurationService=ue;const de=ae.extensionsGallery;this.extensionsGalleryUrl=de&&de.serviceUrl,this.extensionsControlUrl=de&&de.controlUrl,this.commonHeadersPromise=Y(ae.version,ae,this.environmentService,this.configurationService,this.fileService,N)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,Q){const J=[];let re=new R().withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,N.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...N.map(({id:ee})=>ee.toLowerCase()));N.every(ee=>!ee.version)&&(re=re.withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties,l.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(re,t,L.CancellationToken.None);for(let ee=0;ee<le.length;ee++){const ae=le[ee];if(!ae.versions.length)continue;const ue=(0,P.getGalleryExtensionId)(ae.publisher.publisherName,ae.extensionName),de=N.find(pe=>(0,P.areSameExtensions)(pe,{id:ue}))?.version;if(de){const pe=ae.versions.find(Ie=>Ie.version===de);pe&&J.push(U(ae,pe,q(ae),ee,re))}else J.push($(ae,ee,re,void 0,t))}return J}async getCompatibleExtension(N,Q){const J=(0,I.isIExtensionIdentifier)(N)?null:N;if(J){if((0,I.isNotWebExtensionInWebTargetPlatform)(J.allTargetPlatforms,Q))return null;if(await this.isExtensionCompatible(J,Q))return J}const{id:re,uuid:le}=J?J.identifier:N;let ee=new R().withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");le?ee=ee.withFilter(s.ExtensionId,le):ee=ee.withFilter(s.ExtensionName,re);const{galleryExtensions:ae}=await this.queryGallery(ee,Q,L.CancellationToken.None),[ue]=ae;if(!ue||!ue.versions.length)return null;const de=q(ue);if((0,I.isNotWebExtensionInWebTargetPlatform)(de,Q))return null;for(let pe of ue.versions){if(!W(pe)){const Ie=await this.getEngine(pe);pe={...pe,properties:[...pe.properties||[],{key:m.Engine,value:Ie}]}}if(await this.isRawExtensionVersionCompatible(pe,de,Q))return U(ue,pe,de,0,ee)}return null}async isExtensionCompatible(N,Q){if(!(0,I.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,Q))return!1;let J=N.properties.engine;if(!J){const re=await this.getManifest(N,L.CancellationToken.None);if(!re)throw new Error("Manifest was not found");J=re.engines.vscode}return(0,y.isEngineValid)(J,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(N,Q,J){if(!(0,I.isTargetPlatformCompatible)(z(N),Q,J))return!1;const re=await this.getEngine(N);return(0,y.isEngineValid)(re,this.productService.version,this.productService.date)}async query(N,Q){const J=L.CancellationToken.isCancellationToken(N)?{}:N,re=L.CancellationToken.isCancellationToken(N)?N:Q;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let le=J.text||"";const ee=(0,M.getOrDefault)(J,we=>we.pageSize,50);let ae=new R().withFlags(l.IncludeLatestVersionOnly,l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,ee).withFilter(s.Target,"Microsoft.VisualStudio.Code");le?(le=le.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,ge,Ee)=>(ae=ae.withFilter(s.Category,Ee||ge),"")),le=le.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,ge,Ee)=>(ae=ae.withFilter(s.Tag,Ee||ge),"")),le=le.replace(/\bfeatured(\s+|\b|$)/g,()=>(ae=ae.withFilter(s.Featured),"")),le=le.trim(),le&&(le=le.length<200?le:le.substring(0,200),ae=ae.withFilter(s.SearchText,le)),ae=ae.withSortBy(0)):J.ids?ae=ae.withFilter(s.ExtensionId,...J.ids):J.names?ae=ae.withFilter(s.ExtensionName,...J.names):ae=ae.withSortBy(4),typeof J.sortBy=="number"&&(ae=ae.withSortBy(J.sortBy)),typeof J.sortOrder=="number"&&(ae=ae.withSortOrder(J.sortOrder));const{galleryExtensions:ue,total:de}=await this.queryGallery(ae,t,re),pe=ue.map((we,ge)=>$(we,ge,ae,J.source,t)),Ie=async(we,ge)=>{if(ge.isCancellationRequested)throw(0,k.canceled)();const Ee=ae.withPage(we+1),{galleryExtensions:Me}=await this.queryGallery(Ee,t,ge);return Me.map((Te,We)=>$(Te,We,Ee,J.source,t))};return{firstPage:pe,total:de,pageSize:ae.pageSize,getPage:Ie}}async queryGallery(N,Q,J){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,l.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,r(l.Unpublished));const re=await this.commonHeadersPromise,le=JSON.stringify(N.raw),ee={...re,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},ae=new Date().getTime();let ue,de,pe=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:ee},J),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:pe};const Ie=await(0,v.asJson)(ue);if(Ie){const we=Ie.results[0],ge=we.extensions;ge.forEach(Me=>O(Me.versions,Q));const Ee=we.resultMetadata&&we.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return pe=Ee&&Ee.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:pe}}return{galleryExtensions:[],total:pe}}catch(Ie){throw de=Ie,Ie}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-ae,success:!!ue&&(0,v.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:de?(0,k.isPromiseCanceledError)(de)?"canceled":(0,k.getErrorMessage)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(pe)})}}async reportStatistic(N,Q,J,re){if(!this.isEnabled())return;const le=E.isWeb?this.api(`/itemName/${N}.${Q}/version/${J}/statType/${re==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${Q}/${J}/stats?statType=${re}`),ee=E.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.commonHeadersPromise,Accept:ee};try{await this.requestService.request({type:"POST",url:le,headers:ue},L.CancellationToken.None)}catch(de){}}async download(N,Q,J){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const re=(0,P.getGalleryExtensionTelemetryData)(N),le=new Date().getTime(),ee=pe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...re,duration:pe}),ae=J===1?"install":J===2?"update":"",ue=ae?{uri:`${N.assets.download.uri}${f.URI.parse(N.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${N.assets.download.fallbackUri}${f.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:N.assets.download,de=await this.getAsset(ue);await this.fileService.writeFile(Q,de.stream),ee(new Date().getTime()-le)}async getReadme(N,Q){if(N.assets.readme){const J=await this.getAsset(N.assets.readme,{},Q);return await(0,v.asText)(J)||""}return""}async getManifest(N,Q){if(N.assets.manifest){const J=await this.getAsset(N.assets.manifest,{},Q),re=await(0,v.asText)(J);return re?JSON.parse(re):null}return null}async getManifestFromRawExtensionVersion(N,Q){const J=K(N,o.Manifest);if(!J)throw new Error("Manifest was not found");const re={"Accept-Encoding":"gzip"},le=await this.getAsset(J,{headers:re});return await(0,v.asJson)(le)}async getCoreTranslation(N,Q){const J=N.assets.coreTranslations.filter(re=>re[0]===Q.toUpperCase())[0];if(J){const re=await this.getAsset(J[1]),le=await(0,v.asText)(re);return le?JSON.parse(le):null}return null}async getChangelog(N,Q){if(N.assets.changelog){const J=await this.getAsset(N.assets.changelog,{},Q);return await(0,v.asText)(J)||""}return""}async getAllCompatibleVersions(N,Q){let J=new R().withFlags(l.IncludeVersions,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?J=J.withFilter(s.ExtensionId,N.identifier.uuid):J=J.withFilter(s.ExtensionName,N.identifier.id);const{galleryExtensions:re}=await this.queryGallery(J,Q,L.CancellationToken.None);if(!re.length)return[];const le=q(re[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(le,Q))return[];const ee=[];for(const ae of re[0].versions)try{ee[ee.length-1]?.version!==ae.version&&await this.isRawExtensionVersionCompatible(ae,le,Q)&&ee.push({version:ae.version,date:ae.lastUpdated})}catch(ue){}return ee}async getAsset(N,Q={},J=L.CancellationToken.None){const re=await this.commonHeadersPromise,le={type:"GET"},ee={...re,...Q.headers||{}};Q={...Q,...le,headers:ee};const ae=N.uri,ue=N.fallbackUri,de={...Q,url:ae};try{const pe=await this.requestService.request(de,J);if(pe.res.statusCode===200)return pe;const Ie=await(0,v.asText)(pe);throw new Error(`Expected 200, got back ${pe.res.statusCode} instead.

${Ie}`)}catch(pe){if((0,k.isPromiseCanceledError)(pe))throw pe;const Ie=(0,k.getErrorMessage)(pe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ae,message:Ie});const we={...Q,url:ue};return this.requestService.request(we,J)}}async getEngine(N){let Q=W(N);if(!Q){const J=await this.getManifestFromRawExtensionVersion(N,L.CancellationToken.None);if(!J)throw new Error("Manifest was not found");Q=J.engines.vscode}return Q}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const Q=await(0,v.asJson)(N),J=new Map;if(Q)for(const re of Q.malicious){const le=J.get(re)||{id:{id:re},malicious:!0,slow:!1};le.malicious=!0,J.set(re,le)}return[...J.values()]}};A=he([ie(1,v.IRequestService),ie(2,g.ILogService),ie(3,i.IEnvironmentService),ie(4,a.ITelemetryService),ie(5,d.IFileService),ie(6,b.IProductService),ie(7,w.IConfigurationService)],A);let F=class extends A{constructor(N,Q,J,re,le,ee,ae,ue){super(N,Q,J,re,le,ee,ae,ue)}};F=he([ie(0,h.IStorageService),ie(1,v.IRequestService),ie(2,g.ILogService),ie(3,i.IEnvironmentService),ie(4,a.ITelemetryService),ie(5,d.IFileService),ie(6,b.IProductService),ie(7,w.IConfigurationService)],F),e.ExtensionGalleryService=F;let B=class extends A{constructor(N,Q,J,re,le,ee,ae){super(void 0,N,Q,J,re,le,ee,ae)}};B=he([ie(0,v.IRequestService),ie(1,g.ILogService),ie(2,i.IEnvironmentService),ie(3,a.ITelemetryService),ie(4,d.IFileService),ie(5,b.IProductService),ie(6,w.IConfigurationService)],B),e.ExtensionGalleryServiceWithNoStorageService=B;async function Y(C,N,Q,J,re,le){const ee={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C}`},ae=await(0,c.getServiceMachineId)(Q,re,le);return(0,u.supportsTelemetry)(N,Q)&&(0,u.getTelemetryLevel)(J)===3&&(ee["X-Market-User-Id"]=ae),ee}e.resolveMarketplaceHeaders=Y}),define(Z[202],x([0,1,2,44,3,25,148,16,49,45,38,29,61]),function(V,e,p,L,k,M,E,n,f,w,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(b,v){this._configurationService=v,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appenders=b.appenders,this._commonProperties=b.commonProperties||Promise.resolve({}),this._piiPaths=b.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!b.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(c=>{const h=/^[a-f0-9]+$/i.test(c["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!h})})}setExperimentProperty(b,v){this._experimentProperties[b]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,P.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const b=await this._commonProperties;let v=b.sessionID,c=b["common.instanceId"],h=b["common.machineId"],a=b["common.firstSessionDate"],u=b["common.msftInternal"];return{sessionId:v,instanceId:c,machineId:h,firstSessionDate:a,msftInternal:u}}dispose(){this._disposables.dispose()}_log(b,v,c,h){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(a=>{c=(0,L.mixin)(c,a),c=(0,L.mixin)(c,this._experimentProperties),c=(0,L.cloneAndChange)(c,u=>{if(typeof u=="string")return this._cleanupInfo(u,h)}),this._appenders.forEach(u=>u.log(b,c))},a=>{console.error(a)})}publicLog(b,v,c){return this._log(b,3,v,c)}publicLog2(b,v,c){return this.publicLog(b,v,c)}publicLogError(b,v){return this.sendErrorTelemetry?this._log(b,2,v,!0):Promise.resolve(void 0)}publicLogError2(b,v){return this.publicLogError(b,v)}_anonymizeFilePaths(b){let v=b;const c=[];for(let t of this._cleanupPatterns)for(;;){const l=t.exec(b);if(!l)break;c.push([l.index,t.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(v="";;){const t=a.exec(b);if(!t)break;!h.test(t[0])&&c.every(([l,r])=>t.index<l||t.index>=r)&&(v+=b.substring(u,t.index)+"<REDACTED: user-file-path>",u=a.lastIndex)}return u<b.length&&(v+=b.substr(u)),v}_removePropertiesWithPossibleUserInfo(b){if(!b)return b;const v=b.toLowerCase(),c=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(v)?"<REDACTED: secret>":c.test(v)?"<REDACTED: email>":b}_cleanupInfo(b,v){let c=b;v&&(c=this._anonymizeFilePaths(c));for(let h of this._cleanupPatterns)c=c.replace(h,"");return c=this._removePropertiesWithPossibleUserInfo(c),c}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=he([ie(1,n.IConfigurationService)],y),e.TelemetryService=y;function d(){const g=(0,E.localize)(0,null,w.default.nameLong),b=w.default.privacyStatementUrl?(0,E.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,E.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=k.isWeb?"":(0,E.localize)(3,null),c=(0,E.localize)(4,null),h=(0,E.localize)(5,null),a=(0,E.localize)(6,null),u=(0,E.localize)(7,null),t=`
|       | ${c} | ${h} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,l=(0,E.localize)(8,null);return`
${g} ${b} ${v}

&nbsp;

${u}
${t}

&nbsp;

${l}
`}i.Registry.as(f.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,E.localize)(10,null),(0,E.localize)(11,null),(0,E.localize)(12,null),(0,E.localize)(13,null)],markdownDescription:d(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),i.Registry.as(f.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,E.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,E.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,E.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,E.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[203],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(Z[204],x([0,1,108,4,2,5,38,203]),function(V,e,p,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var f;(function(b){function v(c){return c&&typeof c=="object"&&typeof c.id=="string"}b.isThemeColor=v})(f=e.ThemeColor||(e.ThemeColor={}));function w(b){return{id:b}}e.themeColorFromId=w;var i;(function(b){function v(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color=="undefined"||f.isThemeColor(l.color))}b.isThemeIcon=v;const c=new RegExp(`^\\$\\((${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?)\\)$`);function h(l){const r=c.exec(l);if(!r)return;let[,s]=r;return{id:s}}b.fromString=h;function a(l,r){let s=l.id;const o=s.lastIndexOf("~");return o!==-1&&(s=s.substring(0,o)),r&&(s=`${s}~${r}`),{id:s}}b.modify=a;function u(l,r){return l.id===r.id&&l.color?.id===r.color?.id}b.isEqual=u;function t(l,r){return{id:l.id,color:r?w(r):void 0}}b.asThemeIcon=t,b.asClassNameArray=p.CSSIcon.asClassNameArray,b.asClassName=p.CSSIcon.asClassName,b.asCSSSelector=p.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=p.Codicon.file,e.FolderThemeIcon=p.Codicon.folder;function I(b){switch(b){case n.ColorScheme.DARK:return"vs-dark";case n.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class P{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,k.toDisposable)(()=>{const c=this.themingParticipants.indexOf(v);this.themingParticipants.splice(c,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new P;E.Registry.add(e.Extensions.ThemingContribution,y);function d(b){return y.onColorThemeChange(b)}e.registerThemingParticipant=d;class g extends k.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(c=>this.onThemeChange(c)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,c){let h=this.theme.getColor(v);return h&&c&&(h=c(h,this.theme)),h?h.toString():null}}e.Themable=g}),define(Z[62],x([0,1,14,3,5,39]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const E="#FFFFFF",n="#1E1E1E",f="#000000",w="theme",i="themeBackground",I="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let P=class{constructor(d){this.stateMainService=d}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme)return f;let d=this.stateMainService.getItem(i,null);if(!d){let g;(L.isWindows||L.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(w,"vs-dark").split(" ")[0],d=g==="hc-black"?f:g==="vs"?E:n}return L.isMacintosh&&d.toUpperCase()===n&&(d="#171717"),d}saveWindowSplash(d,g){this.stateMainService.setItems([{key:w,data:g.baseTheme},{key:i,data:g.colorInfo.background},{key:I,data:g}]),typeof d=="number"&&this.updateBackgroundColor(d,g)}updateBackgroundColor(d,g){for(const b of p.BrowserWindow.getAllWindows())if(b.id===d){b.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(I)}};P=he([ie(0,M.IStateMainService)],P),e.ThemeMainService=P}),define(Z[42],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(L=e.StateType||(e.StateType={}));var k;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,E)=>({type:"idle",updateType:M,error:E}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,p.createDecorator)("updateService")}),define(Z[205],x([0,1,3,149,49,38]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:p.isWindows&&!p.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[206],x([0,1,4,42]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(n){this.service=n}listen(n,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(n,f,w){switch(f){case"checkForUpdates":return this.service.checkForUpdates(w);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=k;class M{constructor(n){this.channel=n,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=M}),define(Z[98],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,p.createDecorator)("urlService")}),define(Z[207],x([0,1,7]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(n){this.handler=n}listen(n,f){throw new Error(`Event not found: ${f}`)}call(n,f,w){switch(f){case"handleURL":return this.handler.handleURL(p.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=L;class k{constructor(n){this.channel=n}handleURL(n,f){return this.channel.call("handleURL",[n.toJSON(),f])}}e.URLHandlerChannelClient=k;class M{constructor(n){this.next=n}async routeCall(n,f,w,i){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(w){const I=p.URI.revive(w);if(I&&I.query){const P=/\bwindowId=(\d+)/.exec(I.query);if(P){const y=P[1],d=new RegExp(`window:${y}`),g=n.connections.find(b=>d.test(b.ctx));if(g)return g}}}return this.next.routeCall(n,f,w,i)}routeEvent(n,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=M}),define(Z[208],x([0,1,9,2,7,21]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class E extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(w,i){const I=[...this.handlers.values()];return(0,p.first)(I.map(P=>()=>P.handleURL(w,i)),void 0,!1).then(P=>P||!1)}registerHandler(w){return this.handlers.add(w),(0,L.toDisposable)(()=>this.handlers.delete(w))}}e.AbstractURLService=E;let n=class extends E{constructor(w){super();this.productService=w}create(w){let{authority:i,path:I,query:P,fragment:y}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return i&&I&&I.indexOf("/")!==0&&(I=`/${I}`),k.URI.from({scheme:this.productService.urlProtocol,authority:i,path:I,query:P,fragment:y})}};n=he([ie(0,M.IProductService)],n),e.NativeURLService=n}),define(Z[209],x([0,1,14,9,4,2,3,7]),function(V,e,p,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(i){try{return n.URI.parse(i)}catch(I){return null}}class w{constructor(I,P,y,d,g){if(this.urlService=P,this.uris=[],this.retryCount=0,this.flushDisposable=M.Disposable.None,this.disposables=new M.DisposableStore,this.uris=I,E.isWindows){const c=d.isBuilt?[]:[`"${d.appRoot}"`];c.push("--open-url","--"),p.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,c)}const b=k.Event.map(k.Event.fromNodeEventEmitter(p.app,"open-url",(c,h)=>({event:c,url:h})),({event:c,url:h})=>(c.preventDefault(),h));this.disposables.add(b(c=>{const h=f(c);!h||this.urlService.open(h,{originalUrl:c})})),y.getWindows().filter(c=>c.isReady).length>0?this.flush():k.Event.once(y.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const P of this.uris)await this.urlService.open(P.uri,{originalUrl:P.url})||I.push(P);I.length!==0&&(this.uris=I,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=w}),define(Z[210],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,p.createDecorator)("webviewManagerService")}),define(Z[211],x([0,1,14,2,10,7]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class E extends L.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);p.protocol.registerFileProtocol(k.Schemas.vscodeWebview,f)}handleWebviewRequest(f,w){try{const i=M.URI.parse(f.url),I=E.validWebviewFilePaths.get(i.path);if(typeof I=="string"){const P=`vs/workbench/contrib/webview/browser/pre/${I}`,y=k.FileAccess.asFileUri(P,V);return w(decodeURIComponent(y.fsPath))}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=E,E.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Z[63],x([0,1,3]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(w){return!!w.workspaceUri}e.isWorkspaceToOpen=L;function k(w){return!!w.folderUri}e.isFolderToOpen=k;function M(w){return!!w.fileUri}e.isFileToOpen=M;function E(w){const i=n(w),I=w.getValue("window.menuBarVisibility");return I==="default"||i==="native"&&I==="compact"||p.isMacintosh&&p.isNative?"classic":I}e.getMenuBarVisibility=E;function n(w){if(p.isWeb)return"custom";const i=w.getValue("window");if(i){if(p.isMacintosh&&i.nativeTabs===!0||p.isMacintosh&&i.nativeFullScreen===!1)return"native";const y=i.titleBarStyle;if(y==="native"||y==="custom")return y}return p.isLinux?"native":"custom"}e.getTitleBarStyle=n;function f(w=0){return Math.pow(1.2,w)}e.zoomLevelToZoomFactor=f}),define(Z[36],x([0,1,5]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var L;(function(w){w[w.INITIAL=1]="INITIAL",w[w.LOAD=2]="LOAD",w[w.RELOAD=3]="RELOAD"})(L=e.LoadReason||(e.LoadReason={}));var k;(function(w){w[w.CLOSE=1]="CLOSE",w[w.QUIT=2]="QUIT",w[w.RELOAD=3]="RELOAD",w[w.LOAD=4]="LOAD"})(k=e.UnloadReason||(e.UnloadReason={}));var M;(function(w){w[w.CLI=0]="CLI",w[w.DOCK=1]="DOCK",w[w.MENU=2]="MENU",w[w.DIALOG=3]="DIALOG",w[w.DESKTOP=4]="DESKTOP",w[w.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}));const E=function(w=1){return{width:1024,height:768,mode:w}};e.defaultWindowState=E;var n;(function(w){w[w.Maximized=0]="Maximized",w[w.Normal=1]="Normal",w[w.Minimized=2]="Minimized",w[w.Fullscreen=3]="Fullscreen"})(n=e.WindowMode||(e.WindowMode={}));var f;(function(w){w[w.UNRESPONSIVE=1]="UNRESPONSIVE",w[w.CRASHED=2]="CRASHED",w[w.LOAD=3]="LOAD"})(f=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,p.createDecorator)("windowsMainService")}),define(Z[212],x([0,1,14,4,2,211,36]),function(V,e,p,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let n=class extends k.Disposable{constructor(w){super();this.windowsMainService=w,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,i){let I;if(typeof w.windowId=="number"){const{windowId:P}=w,y=this.windowsMainService.getWindowById(P);if(!y?.win)throw new Error(`Invalid windowId: ${P}`);I=y.win.webContents}else{const{webContentsId:P}=w;if(I=p.webContents.fromId(P),!I)throw new Error(`Invalid webContentsId: ${P}`)}I.isDestroyed()||I.setIgnoreMenuShortcuts(i)}async findInFrame(w,i,I,P){const y=this.getFrameByName(w,i),d=y;if(typeof d.findInFrame=="function"){d.findInFrame(I,{findNext:P.findNext,forward:P.forward});const g=(b,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),y.removeListener("found-in-frame",g))};y.on("found-in-frame",g)}}async stopFindInFrame(w,i,I){const y=this.getFrameByName(w,i);typeof y.stopFindInFrame=="function"&&y.stopFindInFrame(I.keepSelection?"keepSelection":"clearSelection")}getFrameByName(w,i){const I=this.windowsMainService.getWindowById(w.windowId);if(!I?.win)throw new Error(`Invalid windowId: ${w}`);const P=I.win.webContents.mainFrame.framesInSubtree.find(y=>y.name===i);if(!P)throw new Error(`Unknown frame: ${i}`);return P}};n=he([ie(0,E.IWindowsMainService)],n),e.WebviewMainService=n}),define(Z[213],x([0,1,9,4,2]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends k.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:f,getActiveWindowId:w}){super();this.disposables=this._register(new k.DisposableStore),L.Event.latch(L.Event.any(n,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,p.createCancelablePromise)(()=>w()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=M}),define(Z[214],x([0,1,37,15,7,5]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,M.createDecorator)("contextService");var E;(function(P){P[P.EMPTY=1]="EMPTY",P[P.FOLDER=2]="FOLDER",P[P.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function n(P){const y=P;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.isWorkspace=n;function f(P){const y=P;return!!(y&&typeof y=="object"&&k.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.isWorkspaceFolder=f;class w{constructor(y,d,g,b,v){this._id=y,this._transient=g,this._configuration=b,this._ignorePathCasing=v,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(y){this._id=y.id,this._configuration=y.configuration,this._transient=y.transient,this._ignorePathCasing=y._ignorePathCasing,this.folders=y.folders}get folders(){return this._folders}set folders(y){this._folders=y,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(y){this._configuration=y}getFolder(y){return y&&this._foldersMap.findSubstr(y.with({scheme:y.scheme,authority:y.authority,path:y.path}))||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing);for(const y of this.folders)this._foldersMap.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class i{constructor(y,d){this.raw=d,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,L.joinPath)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(P){return new i({uri:P,index:0,name:(0,L.basenameOrAuthority)(P)},{uri:P.toString()})}e.toWorkspaceFolder=I}),define(Z[27],x([0,1,31,40,77,34,10,8,3,15,7,152,5,74,214]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(W){return(typeof W=="string"?(0,n.extname)(W):(0,w.extname)(W))===g}e.hasWorkspaceFileExtension=b,e.IWorkspacesService=(0,P.createDecorator)("workspacesService");function v(W){return W.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function c(W){return W.hasOwnProperty("folderUri")}e.isRecentFolder=c;function h(W){return W.hasOwnProperty("fileUri")}e.isRecentFile=h;function a(W){const j=W;return typeof j?.id=="string"&&i.URI.isUri(j.uri)}e.isSingleFolderWorkspaceIdentifier=a;function u(W){if(W.configuration)return{id:W.id,configPath:W.configuration};if(W.folders.length===1)return{id:W.id,uri:W.folders[0].uri}}e.toWorkspaceIdentifier=u;function t(W){const j=W;return typeof j?.id=="string"&&i.URI.isUri(j.configPath)}e.isWorkspaceIdentifier=t;function l(W){const j=W;if(j?.uri)return{id:j.id,uri:i.URI.revive(j.uri)};const H=W;if(H?.configPath)return{id:H.id,configPath:i.URI.revive(H.configPath)};if(W?.id)return{id:W.id}}e.reviveIdentifier=l;function r(W,j){return w.extUriBiasedIgnorePathCase.isEqualOrParent(W,j.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function s(W){return o(W)||m(W)}e.isStoredWorkspaceFolder=s;function o(W){const j=W;return typeof j?.path=="string"&&(!j.name||typeof j.name=="string")}e.isRawFileWorkspaceFolder=o;function m(W){const j=W;return typeof j?.uri=="string"&&(!j.name||typeof j.name=="string")}e.isRawUriWorkspaceFolder=m;function S(W,j,H,z,q=!f.isWindows,O){if(W.scheme!==z.scheme)return{name:H,uri:W.toString(!0)};let $=j?void 0:O.relativePath(z,W);if($!==void 0)$.length===0?$=".":f.isWindows&&W.scheme===E.Schemas.file&&!q&&($=$.replace(/\//g,"\\"));else if(W.scheme===E.Schemas.file)$=W.fsPath,f.isWindows&&($=(0,M.normalizeDriveLetter)($),q&&($=(0,p.toSlashes)($)));else{if(!O.isEqualAuthority(W.authority,z.authority))return{name:H,uri:W.toString(!0)};$=W.path}return{name:H,path:$}}e.getStoredWorkspaceFolder=S;function D(W,j,H){let z=[],q=new Set;const O=H.dirname(j);for(let $ of W){let U;if(o($))$.path&&(U=H.resolvePath(O,$.path));else if(m($))try{U=i.URI.parse($.uri),U.path[0]!=="/"&&(U=U.with({path:"/"+U.path}))}catch(A){console.warn(A)}if(U){let A=H.getComparisonKey(U);if(!q.has(A)){q.add(A);const F=$.name||H.basenameOrAuthority(U);z.push(new d.WorkspaceFolder({uri:U,name:F,index:z.length},$))}}}return z}e.toWorkspaceFolders=D;function R(W,j,H,z,q){let O=T(j,W);const $=q.dirname(j),U=q.dirname(z),A=[],F=_(O.folders);for(const N of O.folders){const Q=o(N)?q.resolvePath($,N.path):i.URI.parse(N.uri);let J;H?J=!1:J=!o(N)||(0,n.isAbsolute)(N.path),A.push(S(Q,J,N.name,U,F,q))}const B={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},Y=k.setProperty(W,["folders"],A,B);let C=k.applyEdits(W,Y);return O.remoteAuthority===(0,y.getRemoteAuthority)(z)&&(C=k.applyEdits(C,k.removeProperty(C,["remoteAuthority"],B))),C}e.rewriteWorkspaceFileForNewLocation=R;function T(W,j){let H=L.parse(j);if(H&&Array.isArray(H.folders))H.folders=H.folders.filter(z=>s(z));else throw new Error(`${W} looks like an invalid workspace file.`);return H}function _(W){return f.isWindows?W.some(j=>o(j)&&j.path.indexOf("/")>=0):!0}e.useSlashForPath=_;function G(W){return W.workspace&&typeof W.workspace=="object"&&typeof W.workspace.id=="string"&&typeof W.workspace.configPath=="string"}function ne(W){return typeof W.folderUri=="string"}function se(W){return typeof W.fileUri=="string"}function K(W,j){const H={workspaces:[],files:[]};if(W){const z=function(O,$){for(let U=0;U<O.length;U++)try{$(O[U],U)}catch(A){j.warn(`Error restoring recent entry ${JSON.stringify(O[U])}: ${A.toString()}. Skip entry.`)}},q=W;if(Array.isArray(q.entries))z(q.entries,O=>{const $=O.label,U=O.remoteAuthority;G(O)?H.workspaces.push({label:$,remoteAuthority:U,workspace:{id:O.workspace.id,configPath:i.URI.parse(O.workspace.configPath)}}):ne(O)?H.workspaces.push({label:$,remoteAuthority:U,folderUri:i.URI.parse(O.folderUri)}):se(O)&&H.files.push({label:$,remoteAuthority:U,fileUri:i.URI.parse(O.fileUri)})});else{const O=W;Array.isArray(O.workspaces3)&&z(O.workspaces3,($,U)=>{const A=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[U]||void 0;typeof $=="object"&&typeof $.id=="string"&&typeof $.configURIPath=="string"?H.workspaces.push({label:A,workspace:{id:$.id,configPath:i.URI.parse($.configURIPath)}}):typeof $=="string"&&H.workspaces.push({label:A,folderUri:i.URI.parse($)})}),Array.isArray(O.files2)&&z(O.files2,($,U)=>{const A=Array.isArray(O.fileLabels)&&O.fileLabels[U]||void 0;typeof $=="string"&&H.files.push({label:A,fileUri:i.URI.parse($)})})}}return H}e.restoreRecentlyOpened=K;function te(W){const j={entries:[]};for(const H of W.workspaces)c(H)?j.entries.push({folderUri:H.folderUri.toString(),label:H.label,remoteAuthority:H.remoteAuthority}):j.entries.push({workspace:{id:H.workspace.id,configPath:H.workspace.configPath.toString()},label:H.label,remoteAuthority:H.remoteAuthority});for(const H of W.files)j.entries.push({fileUri:H.fileUri.toString(),label:H.label,remoteAuthority:H.remoteAuthority});return j}e.toStoreData=te}),define(Z[51],x([0,1,5,27]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,p.createDecorator)("backupMainService");function k(M){const E=M;return E&&(0,L.isWorkspaceIdentifier)(E.workspace)}e.isWorkspaceBackupInfo=k}),define(Z[52],x([0,1,14,9,80,34,2,67,8,3,13,19,133,5,6,39,27]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let v=class mt{constructor(h,a){this.stateMainService=h,this.logService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(h,a){return this.doPick({...h,pickFolders:!0,pickFiles:!0,title:(0,P.localize)(0,null)},a)}pickFolder(h,a){return this.doPick({...h,pickFolders:!0,title:(0,P.localize)(1,null)},a)}pickFile(h,a){return this.doPick({...h,pickFiles:!0,title:(0,P.localize)(2,null)},a)}pickWorkspace(h,a){const u=(0,P.localize)(3,null),t=(0,M.mnemonicButtonLabel)((0,P.localize)(4,null)),l=b.WORKSPACE_FILTER;return this.doPick({...h,pickFiles:!0,title:u,filters:l,buttonLabel:t},a)}async doPick(h,a){const u={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters};u.defaultPath=h.defaultPath||this.stateMainService.getItem(mt.workingDirPickerStorageKey),(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(u.properties=void 0,h.pickFiles&&h.pickFolders&&(u.properties=["multiSelections","openDirectory","openFile","createDirectory"])),u.properties||(u.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&u.properties.push("treatPackageAsDirectory");const t=a||p.BrowserWindow.getFocusedWindow(),l=await this.showOpenDialog(u,(0,i.withNullAsUndefined)(t));if(l&&l.filePaths&&l.filePaths.length>0)return this.stateMainService.setItem(mt.workingDirPickerStorageKey,(0,f.dirname)(l.filePaths[0])),l.filePaths}getWindowDialogQueue(h){if(h){let a=this.windowDialogQueues.get(h.id);return a||(a=new L.Queue,this.windowDialogQueues.set(h.id,a)),a}else return this.noWindowDialogueQueue}showMessageBox(h,a){return this.getWindowDialogQueue(a).queue(async()=>a?p.dialog.showMessageBox(a,h):p.dialog.showMessageBox(h))}async showSaveDialog(h,a){const u=this.acquireFileDialogLock(h,a);if(!u)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(a).queue(async()=>{let t;return a?t=await p.dialog.showSaveDialog(a,h):t=await p.dialog.showSaveDialog(h),t.filePath=this.normalizePath(t.filePath),t})}finally{(0,E.dispose)(u)}}normalizePath(h){return h&&w.isMacintosh&&(h=(0,n.normalizeNFC)(h)),h}normalizePaths(h){return h.map(a=>this.normalizePath(a))}async showOpenDialog(h,a){h.defaultPath&&(await I.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const u=this.acquireFileDialogLock(h,a);if(!u)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(a).queue(async()=>{let t;return a?t=await p.dialog.showOpenDialog(a,h):t=await p.dialog.showOpenDialog(h),t.filePaths=this.normalizePaths(t.filePaths),t})}finally{(0,E.dispose)(u)}}acquireFileDialogLock(h,a){if(!a)return E.Disposable.None;let u=this.windowFileDialogLocks.get(a.id);u||(u=new Set,this.windowFileDialogLocks.set(a.id,u));const t=(0,k.hash)(h);if(!u.has(t))return u.add(t),(0,E.toDisposable)(()=>{u?.delete(t),u?.size===0&&this.windowFileDialogLocks.delete(a.id)})}};v.workingDirPickerStorageKey="pickerWorkingDir",v=he([ie(0,g.IStateMainService),ie(1,d.ILogService)],v),e.DialogMainService=v}),define(Z[215],x([0,1,4,2,27]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends L.Disposable{constructor(n,f){super();this.logService=n,this.storageMainService=f,this._onDidChangeGlobalStorage=this._register(new p.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(p.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,f)=>(n?n.push(f):n=[f],n),M.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const f=new Map,w=new Set;return n.forEach(i=>{const I=this.storageMainService.globalStorage.get(i.key);typeof I=="string"?f.set(i.key,I):w.add(i.key)}),{changed:Array.from(f.entries()),deleted:Array.from(w.values())}}listen(n,f){switch(f){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${f}`)}async call(n,f,w){const i=(0,k.reviveIdentifier)(w.workspace),I=await this.withStorageInitialized(i);switch(f){case"getItems":return Array.from(I.items.entries());case"updateItems":{const P=w;if(P.insert)for(const[y,d]of P.insert)I.set(y,d);P.delete&&P.delete.forEach(y=>I.delete(y));break}case"close":{if(i)return I.close();break}default:throw new Error(`Call not found: ${f}`)}}async withStorageInitialized(n){const f=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await f.init()}catch(w){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${w}`)}return f}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[216],x([0,1,4,2,8,28,19,86,123,6,97,29,27]),function(V,e,p,L,k,M,E,n,f,w,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class y extends L.Disposable{constructor(v){super();this.logService=v,this._onDidChangeStorage=this._register(new p.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new p.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const v=await this.doCreate();this.storage.dispose(),this.storage=v,this._register(v.onDidChangeStorage(h=>this._onDidChangeStorage.fire({key:h}))),await this.doInit(v);const c=v.getBoolean(i.IS_NEW_KEY);c===void 0?v.set(i.IS_NEW_KEY,!0):c&&v.set(i.IS_NEW_KEY,!1)}catch(v){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${v}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===w.LogLevel.Trace?v=>this.logService.trace(v):void 0,logError:v=>this.logService.error(v)}}doInit(v){return v.init()}get items(){return this.storage.items}get(v,c){return this.storage.get(v,c)}set(v,c){return this.storage.set(v,c)}delete(v){return this.storage.delete(v)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class d extends y{constructor(v,c,h){super(c);this.options=v,this.environmentService=h}async doCreate(){let v;return this.options.useInMemoryStorage?v=f.SQLiteStorageDatabase.IN_MEMORY_PATH:v=(0,k.join)(this.environmentService.globalStorageHome.fsPath,d.STORAGE_NAME),new n.Storage(new f.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}))}async doInit(v){await super.doInit(v),this.updateTelemetryState(v)}updateTelemetryState(v){v.get(I.instanceStorageKey,void 0)===void 0&&v.set(I.instanceStorageKey,(0,M.generateUuid)()),v.get(I.firstSessionDateStorageKey,void 0)===void 0&&v.set(I.firstSessionDateStorageKey,new Date().toUTCString());const a=v.get(I.currentSessionDateStorageKey,void 0),u=new Date().toUTCString();v.set(I.lastSessionDateStorageKey,typeof a=="undefined"?null:a),v.set(I.currentSessionDateStorageKey,u)}}e.GlobalStorageMain=d,d.STORAGE_NAME="state.vscdb";class g extends y{constructor(v,c,h,a){super(h);this.workspace=v,this.options=c,this.environmentService=a}async doCreate(){const{storageFilePath:v,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new f.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}),{hint:c?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const v=(0,k.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=(0,k.join)(v,g.WORKSPACE_STORAGE_NAME);return await E.Promises.exists(v)?{storageFilePath:c,wasCreated:!1}:(await E.Promises.mkdir(v,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(v),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(v){let c;if((0,P.isSingleFolderWorkspaceIdentifier)(this.workspace)?c={folder:this.workspace.uri.toString()}:(0,P.isWorkspaceIdentifier)(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const h=(0,k.join)(v,g.WORKSPACE_META_NAME);await E.Promises.exists(h)||await E.Promises.writeFile(h,JSON.stringify(c,void 0,2))}catch(h){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${h}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(Z[99],x([0,1,43,2,48,5,22,6,216]),function(V,e,p,L,k,M,E,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let w=class extends L.Disposable{constructor(I,P,y){super();this.logService=I,this.environmentService=P,this.lifecycleMainService=y,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async I=>{I.workspace&&this.workspaceStorage(I.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(I=>{I.join(this.globalStorage.close());for(const[,P]of this.mapWorkspaceToStorage)I.join(P.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const I=new f.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,p.once)(I.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),I}createWorkspaceStorage(I){return new f.WorkspaceStorageMain(I,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(I){let P=this.mapWorkspaceToStorage.get(I.id);return P||(this.logService.trace(`StorageMainService: creating workspace storage (${I.id})`),P=this.createWorkspaceStorage(I),this.mapWorkspaceToStorage.set(I.id,P),(0,p.once)(P.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${I.id})`),this.mapWorkspaceToStorage.delete(I.id)})),P}};w=he([ie(0,n.ILogService),ie(1,k.IEnvironmentService),ie(2,E.ILifecycleMainService)],w),e.StorageMainService=w}),define(Z[100],x([0,1,15,7,27]),function(V,e,p,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function M(f,w,i){for(const P of f){const y=P.openedWorkspace;if((0,k.isWorkspaceIdentifier)(y)){const d=i(y);if(d){if(d.folders.some(g=>p.extUriBiasedIgnorePathCase.isEqualOrParent(w,g.uri)))return P}else if(p.extUriBiasedIgnorePathCase.isEqualOrParent(w,y.configPath))return P}}const I=f.filter(P=>(0,k.isSingleFolderWorkspaceIdentifier)(P.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqualOrParent(w,P.openedWorkspace.uri));if(I.length)return I.sort((P,y)=>-(P.openedWorkspace.uri.path.length-y.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function E(f,w){for(const i of f)if((0,k.isWorkspaceIdentifier)(i.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,w)||(0,k.isSingleFolderWorkspaceIdentifier)(i.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.uri,w))return i}e.findWindowOnWorkspaceOrFolder=E;function n(f,w){const i=I=>w.some(P=>p.extUriBiasedIgnorePathCase.isEqual(L.URI.file(P),L.URI.file(I)));for(const I of f)if(I.config?.extensionDevelopmentPath?.some(P=>i(P)))return I}e.findWindowOnExtensionDevelopmentPath=n}),define(Z[217],x([0,1,14,2,3,15,7,16,22,6,39,36,27]),function(V,e,p,L,k,M,E,n,f,w,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=class wt extends L.Disposable{constructor(h,a,u,t,l){super();this.windowsMainService=h,this.stateMainService=a,this.lifecycleMainService=u,this.logService=t,this.configurationService=l,this._state=d(this.stateMainService.getItem(wt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){p.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!h.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(l=>!l.isExtensionDevelopmentHost)),t&&(h.lastActiveWindow=this.toWindowState(t))}const a=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);a&&(h.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(h.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const u=b(h);this.stateMainService.setItem(wt.windowsStateStorageKey,u),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",u)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(u=>{const t=(0,P.isWorkspaceIdentifier)(h.openedWorkspace)&&u.workspace?.id===h.openedWorkspace.id,l=(0,P.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&u.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(u.folderUri,h.openedWorkspace.uri);(t||l)&&(u.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(h){return{workspace:(0,P.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,P.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const a=this.doGetNewWindowState(h),u=this.configurationService.getValue("window");let t;return a.hasDefaultState?t=!!(u?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(u.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||u?.restoreFullscreen),t&&k.isMacintosh&&this.windowsMainService.getWindows().some(l=>l.isFullScreen)&&(t=!1)),a.mode===3&&!t&&(a.mode=1),a}doGetNewWindowState(h){const a=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const o=h.workspace;if((0,P.isWorkspaceIdentifier)(o)){const S=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===o.id).map(D=>D.uiState);if(S.length)return S[0]}if((0,P.isSingleFolderWorkspaceIdentifier)(o)){const S=this.state.openedWindows.filter(D=>D.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(D.folderUri,o.uri)).map(D=>D.uiState);if(S.length)return S[0]}else if(h.backupPath){const S=this.state.openedWindows.filter(D=>D.backupPath===h.backupPath).map(D=>D.uiState);if(S.length)return S[0]}const m=this.lastClosedState||this.state.lastActiveWindow;if(!a&&m)return m.uiState}let u;const t=p.screen.getAllDisplays();if(t.length===1)u=t[0];else{if(k.isMacintosh){const o=p.screen.getCursorScreenPoint();u=p.screen.getDisplayNearestPoint(o)}!u&&a&&(u=p.screen.getDisplayMatching(a.getBounds())),u||(u=p.screen.getPrimaryDisplay()||t[0])}let l=(0,I.defaultWindowState)();l.x=Math.round(u.bounds.x+u.bounds.width/2-l.width/2),l.y=Math.round(u.bounds.y+u.bounds.height/2-l.height/2);const r=this.configurationService.getValue("window");let s=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")l.mode=0,s=!1;else if(r.newWindowDimensions==="fullscreen")l.mode=3,s=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&a){const o=a.serializeWindowState();o.mode===3?l.mode=3:l=o,s=l.mode!==3&&r.newWindowDimensions==="offset"}}return s&&(l=this.ensureNoOverlap(l)),l.hasDefaultState=!0,l}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const a=this.windowsMainService.getWindows().map(u=>u.getBounds());for(;a.some(u=>u.x===h.x||u.y===h.y);)h.x+=30,h.y+=30;return h}};y.windowsStateStorageKey="windowsState",y=he([ie(0,I.IWindowsMainService),ie(1,i.IStateMainService),ie(2,f.ILifecycleMainService),ie(3,w.ILogService),ie(4,n.IConfigurationService)],y),e.WindowsStateHandler=y;function d(c){const h={openedWindows:[]},a=c||{openedWindows:[]};return a.lastActiveWindow&&(h.lastActiveWindow=g(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=g(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(h.openedWindows=a.openedWindows.map(u=>g(u))),h}e.restoreWindowsState=d;function g(c){const h={uiState:c.uiState};return c.backupPath&&(h.backupPath=c.backupPath),c.remoteAuthority&&(h.remoteAuthority=c.remoteAuthority),c.folder&&(h.folderUri=E.URI.parse(c.folder)),c.workspaceIdentifier&&(h.workspace={id:c.workspaceIdentifier.id,configPath:E.URI.parse(c.workspaceIdentifier.configURIPath)}),h}function b(c){return{lastActiveWindow:c.lastActiveWindow&&v(c.lastActiveWindow),lastPluginDevelopmentHostWindow:c.lastPluginDevelopmentHostWindow&&v(c.lastPluginDevelopmentHostWindow),openedWindows:c.openedWindows.map(h=>v(h))}}e.getWindowsStateStoreData=b;function v(c){return{workspaceIdentifier:c.workspace&&{id:c.workspace.id,configURIPath:c.workspace.configPath.toString()},folder:c.folderUri&&c.folderUri.toString(),backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.uiState}}}),define(Z[101],x([0,1,58,32,10,3,15]),function(V,e,p,L,k,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function n(w){function i(){let I=w.scheme===k.Schemas.file?(0,E.originalFSPath)(w):w.toString();return M.isLinux||(I=I.toLowerCase()),(0,p.createHash)("md5").update(I).digest("hex")}return{id:i(),configPath:w}}e.getWorkspaceIdentifier=n;function f(w,i){function I(){if(w.scheme!==k.Schemas.file)return(0,p.createHash)("md5").update(w.toString()).digest("hex");if(!i)try{i=(0,L.statSync)(w.fsPath)}catch(d){return}let y;return M.isLinux?y=i.ino:M.isMacintosh?y=i.birthtime.getTime():M.isWindows&&(typeof i.birthtimeMs=="number"?y=Math.floor(i.birthtimeMs):y=i.birthtime.getTime()),(0,p.createHash)("md5").update(w.fsPath).update(y?String(y):"").digest("hex")}const P=I();if(typeof P=="string")return{id:P,uri:w}}e.getSingleFolderWorkspaceIdentifier=f}),define(Z[56],x([0,1,58,59,26,18,17,4,2,8,3,28,35,84,218]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(S){this.socket=S,this._errorListener=D=>{if(D){if(D.code==="EPIPE")return;(0,E.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(S){const D=R=>S(M.VSBuffer.wrap(R));return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(S){const D=R=>{S({type:0,hadError:R,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(S){return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(S){if(!this.socket.destroyed)try{this.socket.write(S.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,E.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,E.onUnexpectedError)(D)}}end(){this.socket.end()}drain(){return new Promise((S,D)=>{if(this.socket.bufferSize===0){S();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),S()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=g;var b;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(b||(b={}));var v;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(v||(v={}));class c extends f.Disposable{constructor(S,D,R,T){super();this._onDidZlibFlush=this._register(new n.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new n.Emitter),this._onClose=this._register(new n.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=S,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=D,this._recordInflateBytes=T,D?(this._zlibInflate=d.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",_=>{console.error(_),(0,E.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibInflate.on("data",_=>{this._pendingInflateData.push(_)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",_=>{console.error(_),(0,E.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibDeflate.on("data",_=>{this._pendingDeflateData.push(_)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new y.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):M.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(S){return this._onData.event(S)}onClose(S){return this._onClose.event(S)}onEnd(S){return this.socket.onEnd(S)}write(S){this._totalOutgoingDataBytes+=S.byteLength,this._zlibDeflate?(this._zlibDeflate.write(S.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let D=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,D=D.slice(0,D.length-4),this._isEnded||this._write(M.VSBuffer.wrap(D),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(S,!1)}_write(S,D){let R=2;S.byteLength<126?R+=0:S.byteLength<2**16?R+=2:R+=8;const T=M.VSBuffer.alloc(R);if(D?T.writeUInt8(194,0):T.writeUInt8(130,0),S.byteLength<126)T.writeUInt8(S.byteLength,1);else if(S.byteLength<2**16){T.writeUInt8(126,1);let _=1;T.writeUInt8(S.byteLength>>>8&255,++_),T.writeUInt8(S.byteLength>>>0&255,++_)}else{T.writeUInt8(127,1);let _=1;T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(0,++_),T.writeUInt8(S.byteLength>>>24&255,++_),T.writeUInt8(S.byteLength>>>16&255,++_),T.writeUInt8(S.byteLength>>>8&255,++_),T.writeUInt8(S.byteLength>>>0&255,++_)}this._totalOutgoingWireBytes+=T.byteLength+S.byteLength,this.socket.write(M.VSBuffer.concat([T,S]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(S){if(S.byteLength!==0){for(this._totalIncomingWireBytes+=S.byteLength,this._incomingData.acceptChunk(S);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const D=this._incomingData.peek(this._state.readLen),R=D.readUInt8(0),T=(R&128)>>>7,_=(R&64)>>>6,G=D.readUInt8(1),ne=(G&128)>>>7,se=G&127;this._state.state=2,this._state.readLen=2+(ne?4:0)+(se===126?2:0)+(se===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(_)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0}else if(this._state.state===2){const D=this._incomingData.read(this._state.readLen),R=D.readUInt8(1),T=(R&128)>>>7;let _=R&127,G=1;_===126?_=D.readUInt8(++G)*2**8+D.readUInt8(++G):_===127&&(_=D.readUInt8(++G)*0+D.readUInt8(++G)*0+D.readUInt8(++G)*0+D.readUInt8(++G)*0+D.readUInt8(++G)*2**24+D.readUInt8(++G)*2**16+D.readUInt8(++G)*2**8+D.readUInt8(++G));let ne=0;T&&(ne=D.readUInt8(++G)*2**24+D.readUInt8(++G)*2**16+D.readUInt8(++G)*2**8+D.readUInt8(++G)),this._state.state=3,this._state.readLen=_,this._state.mask=ne}else if(this._state.state===3){const D=this._incomingData.read(this._state.readLen);h(D,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(D.buffer)),this._zlibInflate.write(D.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(M.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=D.byteLength,this._onData.fire(D))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await n.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=c;function h(m,S){if(S===0)return;let D=m.byteLength>>>2;for(let se=0;se<D;se++){const K=m.readUInt32BE(se*4);m.writeUInt32BE(K^S,se*4)}let R=D*4,T=m.byteLength-R;const _=S>>>24&255,G=S>>>16&255,ne=S>>>8&255;T>=1&&m.writeUInt8(m.readUInt8(R)^_,R),T>=2&&m.writeUInt8(m.readUInt8(R+1)^G,R+1),T>=3&&m.writeUInt8(m.readUInt8(R+2)^ne,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function u(){const m=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let S;return e.XDG_RUNTIME_DIR?S=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):S=(0,w.join)((0,k.tmpdir)(),`vscode-ipc-${m}.sock`),l(S),S}e.createRandomIPCHandle=u;function t(m,S,D){const R=(0,p.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${D}-${S}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${D}-${S}.sock`):T=(0,w.join)(m,`${D}-${S}.sock`),l(T),T}e.createStaticIPCHandle=t;function l(m){const S=a[i.platform];typeof S=="number"&&m.length>=S&&console.warn(`WARNING: IPC handle "${m}" is longer than ${S} chars, try a shorter --user-data-dir`)}class r extends P.IPCServer{constructor(S){super(r.toClientConnectionEvent(S));this.server=S}static toClientConnectionEvent(S){const D=n.Event.fromNodeEventEmitter(S,"connection");return n.Event.map(D,R=>({protocol:new y.Protocol(new g(R)),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function s(m){return new Promise((S,D)=>{const R=(0,L.createServer)();R.on("error",D),R.listen(m,()=>{R.removeListener("error",D),S(new r(R))})})}e.serve=s;function o(m,S){return new Promise((D,R)=>{const T=(0,L.createConnection)(m,()=>{T.removeListener("error",R),D(y.Client.fromSocket(new g(T),S))});T.once("error",R)})}e.connect=o}),define(Z[219],x([0,1,56]),function(V,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(f){this.driver=f}listen(f,w){throw new Error("No event found")}call(f,w,i){switch(w){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(i);case"getLocalizedStrings":return this.driver.getLocalizedStrings(i)}throw new Error(`Call not found: ${w}`)}}e.DriverChannel=L;class k{constructor(f){this.channel=f}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(f){return this.channel.call("capturePage",f)}reloadWindow(f){return this.channel.call("reloadWindow",f)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(f,w){return this.channel.call("dispatchKeybinding",[f,w])}click(f,w,i,I){return this.channel.call("click",[f,w,i,I])}doubleClick(f,w){return this.channel.call("doubleClick",[f,w])}setValue(f,w,i){return this.channel.call("setValue",[f,w,i])}getTitle(f){return this.channel.call("getTitle",[f])}isActiveElement(f,w){return this.channel.call("isActiveElement",[f,w])}getElements(f,w,i){return this.channel.call("getElements",[f,w,i])}getElementXY(f,w,i,I){return this.channel.call("getElementXY",[f,w,i,I])}typeInEditor(f,w,i){return this.channel.call("typeInEditor",[f,w,i])}getTerminalBuffer(f,w){return this.channel.call("getTerminalBuffer",[f,w])}writeInTerminal(f,w,i){return this.channel.call("writeInTerminal",[f,w,i])}getLocaleInfo(f){return this.channel.call("getLocaleInfo",f)}getLocalizedStrings(f){return this.channel.call("getLocalizedStrings",f)}}e.DriverChannelClient=k;class M{constructor(f){this.registry=f}listen(f,w){throw new Error(`Event not found: ${w}`)}call(f,w,i){switch(w){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${w}`)}}e.WindowDriverRegistryChannel=M;async function E(n){const f=await(0,p.connect)(n,"driverClient"),w=f.getChannel("driver"),i=new k(w);return{client:f,driver:i}}e.connect=E}),define(Z[220],x([0,1,9,4,106,57,2,3,79,35,56,156,219,177,22,36]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function b(h){return h<21}let v=class{constructor(a,u,t,l){this.windowServer=a,this.options=u,this.windowsMainService=t,this.lifecycleMainService=l,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(a){return this.registeredWindowIds.add(a),this.reloadingWindowIds.delete(a),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(a){this.reloadingWindowIds.add(a)}async getWindowIds(){return this.windowsMainService.getWindows().map(a=>a.id).filter(a=>this.registeredWindowIds.has(a)&&!this.reloadingWindowIds.has(a))}async capturePage(a){await this.whenUnfrozen(a);const u=this.windowsMainService.getWindowById(a);if(!u?.win)throw new Error("Invalid window");return(await u.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(a){await this.whenUnfrozen(a);const u=this.windowsMainService.getWindowById(a);if(!u)throw new Error("Invalid window");this.reloadingWindowIds.add(a),this.lifecycleMainService.reload(u)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(a,u){await this.whenUnfrozen(a);const t=k.KeybindingParser.parseUserBinding(u);for(let l of t)await this._dispatchKeybinding(a,l)}async _dispatchKeybinding(a,u){if(u instanceof f.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const t=this.windowsMainService.getWindowById(a);if(!t?.win)throw new Error("Invalid window");const l=t.win.webContents,r=new M.SimpleKeybinding(!1,!1,!1,!1,u.keyCode),o=new y.USLayoutResolvedKeybinding(r.toChord(),n.OS).getElectronAccelerator(),m=[];u.ctrlKey&&m.push("ctrl"),u.metaKey&&m.push("meta"),u.shiftKey&&m.push("shift"),u.altKey&&m.push("alt"),l.sendInputEvent({type:"keyDown",keyCode:o,modifiers:m}),b(u.keyCode)||l.sendInputEvent({type:"char",keyCode:o,modifiers:m}),l.sendInputEvent({type:"keyUp",keyCode:o,modifiers:m}),await(0,p.timeout)(100)}async click(a,u,t,l){await(await this.getWindowDriver(a)).click(u,t,l)}async doubleClick(a,u){await(await this.getWindowDriver(a)).doubleClick(u)}async setValue(a,u,t){await(await this.getWindowDriver(a)).setValue(u,t)}async getTitle(a){return await(await this.getWindowDriver(a)).getTitle()}async isActiveElement(a,u){return await(await this.getWindowDriver(a)).isActiveElement(u)}async getElements(a,u,t){return await(await this.getWindowDriver(a)).getElements(u,t)}async getElementXY(a,u,t,l){return await(await this.getWindowDriver(a)).getElementXY(u,t,l)}async typeInEditor(a,u,t){await(await this.getWindowDriver(a)).typeInEditor(u,t)}async getTerminalBuffer(a,u){return await(await this.getWindowDriver(a)).getTerminalBuffer(u)}async writeInTerminal(a,u,t){await(await this.getWindowDriver(a)).writeInTerminal(u,t)}async getLocaleInfo(a){return await(await this.getWindowDriver(a)).getLocaleInfo()}async getLocalizedStrings(a){return await(await this.getWindowDriver(a)).getLocalizedStrings()}async getWindowDriver(a){await this.whenUnfrozen(a);const u=`window:${a}`,t=new w.StaticRouter(r=>r===u),l=this.windowServer.getChannel("windowDriver",t);return new I.WindowDriverChannelClient(l)}async whenUnfrozen(a){for(;this.reloadingWindowIds.has(a);)await L.Event.toPromise(this.onDidReloadingChange.event)}};v=he([ie(2,g.IWindowsMainService),ie(3,d.ILifecycleMainService)],v),e.Driver=v;async function c(h,a,u,t){const l=u.driverVerbose,r=t.createInstance(v,h,{verbose:l}),s=new P.WindowDriverRegistryChannel(r);h.registerChannel("windowDriverRegistry",s);const o=await(0,i.serve)(a),m=new P.DriverChannel(r);return o.registerChannel("driver",m),(0,E.combinedDisposable)(o,h)}e.serve=c}),define(Z[24],x([0,1,47,8,56,48,161,5]),function(V,e,p,L,k,M,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,n.refineServiceDecorator)(M.IEnvironmentService);class f extends E.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,L.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}he([p.memoize],f.prototype,"cachedLanguagesPath",null),he([p.memoize],f.prototype,"backupHome",null),he([p.memoize],f.prototype,"backupWorkspacesPath",null),he([p.memoize],f.prototype,"mainIPCHandle",null),he([p.memoize],f.prototype,"mainLockfile",null),he([p.memoize],f.prototype,"sandbox",null),he([p.memoize],f.prototype,"driverVerbose",null),he([p.memoize],f.prototype,"disableUpdates",null),he([p.memoize],f.prototype,"disableKeytar",null),he([p.memoize],f.prototype,"codeCachePath",null),he([p.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(Z[221],x([0,1,58,32,31,10,8,3,15,7,19,51,16,24,20,6,27]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{constructor(h,a,u){this.configurationService=a,this.logService=u,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,l)=>(0,k.isEqual)(t,l,!n.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await i.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let a=[];try{Array.isArray(h.rootURIWorkspaces)&&(a=h.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:w.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(a);let u=[];try{Array.isArray(h.folderURIWorkspaces)&&(u=h.folderURIWorkspaces.map(t=>w.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(u),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,a){this.workspaces.some(t=>h.workspace.id===t.workspace.id)||(this.workspaces.push(h),this.saveSync());const u=this.getBackupPath(h.workspace.id);return a&&this.moveBackupFolderSync(u,a),u}moveBackupFolderSync(h,a){if(L.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),L.existsSync(a))try{L.renameSync(a,h)}catch(u){this.logService.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}unregisterWorkspaceBackupSync(h){const a=h.id,u=this.workspaces.findIndex(t=>t.workspace.id===a);u!==-1&&(this.workspaces.splice(u,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(a=>this.backupUriComparer.isEqual(h,a))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const a=this.folders.findIndex(u=>this.backupUriComparer.isEqual(h,u));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(h,a){const u=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,u))||(this.emptyWindows.push({backupFolder:u,remoteAuthority:a}),this.saveSync()),this.getBackupPath(u)}unregisterEmptyWindowBackupSync(h){const a=this.emptyWindows.findIndex(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,h));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(h){return(0,E.join)(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const a=new Set,u=[];for(let t of h){const l=t.workspace;if(!(0,b.isWorkspaceIdentifier)(l))return[];if(!a.has(l.id)){a.add(l.id);const r=this.getBackupPath(l.id);await this.doHasBackups(r)?l.configPath.scheme!==M.Schemas.file||await i.Promises.exists(l.configPath.fsPath)?u.push(t):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return u}async validateFolders(h){if(!Array.isArray(h))return[];const a=[],u=new Set;for(let t of h){const l=this.backupUriComparer.getComparisonKey(t);if(!u.has(l)){u.add(l);const r=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(r)?t.scheme!==M.Schemas.file||await i.Promises.exists(t.fsPath)?a.push(t):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return a}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const a=[],u=new Set;for(let t of h){const l=t.backupFolder;if(typeof l!="string")return[];if(!u.has(l)){u.add(l);const r=this.getBackupPath(l);await this.doHasBackups(r)?a.push(t):await this.deleteStaleBackup(r)}}return a}async deleteStaleBackup(h){try{await i.Promises.exists(h)&&await i.Promises.rm(h,i.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(h){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a));)a=this.getRandomEmptyWindowId();const u=this.getBackupPath(a);try{await i.Promises.rename(h,u)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(h){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a));)a=this.getRandomEmptyWindowId();const u=this.getBackupPath(a);try{L.renameSync(h,u)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const h=[];for(const a of this.workspaces)await this.hasBackups(a)&&h.push(a.workspace);for(const a of this.folders)await this.hasBackups(a)&&h.push(a);return h}hasBackups(h){let a;return w.URI.isUri(h)?a=this.getBackupPath(this.getFolderHash(h)):(0,I.isWorkspaceBackupInfo)(h)?a=this.getBackupPath(h.workspace.id):a=h.backupFolder,this.doHasBackups(a)}async doHasBackups(h){try{const a=await i.Promises.readdir(h);for(const u of a)try{if((await i.Promises.readdir((0,E.join)(h,u))).length>0)return!0}catch(t){}}catch(a){}return!1}saveSync(){try{(0,i.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await i.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderURIWorkspaces:this.folders.map(h=>h.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){let a;return h.scheme===M.Schemas.file?a=n.isLinux?h.fsPath:h.fsPath.toLowerCase():a=h.toString().toLowerCase(),(0,p.createHash)("md5").update(a).digest("hex")}};v=he([ie(0,y.IEnvironmentMainService),ie(1,P.IConfigurationService),ie(2,g.ILogService)],v),e.BackupMainService=v}),define(Z[222],x([0,1,59,56]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,M,E,n){const f=i=>n(i,void 0),w=p.createConnection({host:k,port:M},()=>{w.removeListener("error",f);const i=Buffer.alloc(16);for(let d=0;d<16;d++)i[d]=Math.round(Math.random()*256);const I=i.toString("base64");let P=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${M}/?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];w.write(P.join(`\r
`)+`\r
\r
`);const y=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",y),n(void 0,new L.NodeSocket(w)))};w.on("data",y)});w.once("error",f)}}}),define(Z[223],x([0,1,59,115,222,9,2,16,6,21,192,96,75]),function(V,e,p,L,k,M,E,n,f,w,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function y(v,c,h,a,u){return new d(v,c,h,a,u).waitForReady()}class d extends E.Disposable{constructor(c,h,a,u,t){super();this.defaultTunnelHost=h,this.suggestedLocalPort=t,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=p.createServer(),this._barrier=new M.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=l=>this._onConnection(l),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=u,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let c=await(0,L.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(c){c.pause();const h=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,i.connectRemoteAgentTunnel)(this._options,h,this.tunnelRemotePort),u=a.getSocket().socket,t=a.readEntireBuffer();a.dispose(),t.byteLength>0&&c.write(t.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),u.end()}),c.on("close",()=>u.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),u.destroy()}),u.on("end",()=>c.end()),u.on("close",()=>c.end()),u.on("error",()=>{c.destroy()}),c.pipe(u),u.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),u.end()})}}let g=class extends I.AbstractTunnelService{constructor(c,h,a,u,t){super(h);this.socketFactory=c,this.signService=a,this.productService=u,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,h,a,u,t,l,r){const s=this.getTunnelFromMap(h,a);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,a,u,t,l,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${a} on local port ${u}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},m=y(o,this.defaultTunnelHost,h,a,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,a,m),m}}};g=he([ie(1,f.ILogService),ie(2,P.ISignService),ie(3,w.IProductService),ie(4,n.IConfigurationService)],g),e.BaseTunnelService=g;let b=class extends g{constructor(c,h,a,u){super(k.nodeSocketFactory,c,h,a,u)}};b=he([ie(0,f.ILogService),ie(1,P.ISignService),ie(2,w.IProductService),ie(3,n.IConfigurationService)],b),e.TunnelService=b}),define(Z[224],x([0,1,194,18,17,2,13,16,48,91,6,193,218]),function(V,e,p,L,k,M,E,n,f,w,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let y=class extends M.Disposable{constructor(g,b,v){super();this.environmentService=b,this.logService=v,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,b){this.logService.trace("RequestService#request",g.url);const{proxyUrl:v,strictSSL:c}=this;let h;try{h=await(0,w.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(t){this.logService.error("RequestService#request resolving shell environment failed",t)}const a={...process.env,...h},u=g.agent?g.agent:await(0,I.getProxyAgent)(g.url||"",a,{proxyUrl:v,strictSSL:c});return g.agent=u,g.strictSSL=c,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,b)}async getNodeRequest(g){return((0,p.parse)(g.url).protocol==="https:"?await new Promise((c,h)=>{V(["https"],c,h)}):await new Promise((c,h)=>{V(["http"],c,h)})).request}_request(g,b){return new Promise(async(v,c)=>{let h;const a=(0,p.parse)(g.url),u=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),t={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,E.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(t.auth=g.user+":"+g.password),h=u(t,l=>{const r=(0,E.isNumber)(g.followRedirects)?g.followRedirects:3;if(l.statusCode&&l.statusCode>=300&&l.statusCode<400&&r>0&&l.headers.location)this._request({...g,url:l.headers.location,followRedirects:r-1},b).then(v,c);else{let s=l;l.headers["content-encoding"]==="gzip"&&(s=l.pipe((0,P.createGunzip)())),v({res:l,stream:(0,L.streamToBufferReadableStream)(s)})}}),h.on("error",c),g.timeout&&h.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&h.write(g.data),h.end(),b.onCancellationRequested(()=>{h.abort(),c((0,k.canceled)())})})}async resolveProxy(g){}};y=he([ie(0,n.IConfigurationService),ie(1,f.INativeEnvironmentService),ie(2,i.ILogService)],y),e.RequestService=y}),define(Z[225],x([0,1,14,224]),function(V,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(E){return p.net.request}class M extends L.RequestService{request(n,f){return super.request({...n||{},getRawRequest:k},f)}}e.RequestMainService=M}),define(Z[226],x([0,1,14,9,4,2,10,13,85,24,22,6,45,55,62]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends M.Disposable{constructor(v,c,h,a,u,t,l){super();this.machineId=v,this.userEnv=c,this.environmentMainService=h,this.lifecycleMainService=a,this.logService=u,this.themeMainService=t,this.protocolMainService=l,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new k.Emitter),this.onDidError=k.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),p.ipcMain.on("vscode:createSharedProcessMessageChannel",async(v,c)=>this.onWindowConnection(v,c))}async onWindowConnection(v,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const h=await this.connect();if(v.sender.isDestroyed())return h.close();v.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[h])}onWillShutdown(){const v=this.window;!v||(!v.isDestroyed()&&!v.webContents.isDestroyed()&&v.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(v.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{v.close()}catch(c){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(v=>p.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),v()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(v=>p.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),v()}))})()),this._whenIpcReady}createWindow(){const v=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new p.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${v.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),v.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:P.default}),this.window.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",V).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=v=>{this.logService.trace("SharedProcess#close prevented"),v.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(v,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(v,c,h)=>this._onDidError.fire({type:3,details:{reason:h,exitCode:c}})))}async connect(){await this.whenIpcReady;const v=(0,n.assertIsDefined)(this.window);return(0,f.connect)(v)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};g=he([ie(2,w.IEnvironmentMainService),ie(3,i.ILifecycleMainService),ie(4,I.ILogService),ie(5,d.IThemeMainService),ie(6,y.IProtocolMainService)],g),e.SharedProcess=g}),define(Z[227],x([0,1,9,18,8,13,7,24,20,6]),function(V,e,p,L,k,M,E,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class i{constructor(y,d,g){this.storagePath=y,this.logService=d,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new p.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,d){const g=this.storage[y];return(0,M.isUndefinedOrNull)(g)?d:g}setItem(y,d){this.setItems([{key:y,data:d}])}setItems(y){let d=!1;for(const{key:g,data:b}of y)this.storage[g]!==b&&((0,M.isUndefinedOrNull)(b)?(0,M.isUndefined)(this.storage[g])||(this.storage[g]=void 0,d=!0):(this.storage[g]=b,d=!0));d&&this.save()}removeItem(y){(0,M.isUndefined)(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(y){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),y)}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(y)),this.lastSavedStorageContents=y}catch(d){this.logService.error(d)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=i;let I=class St{constructor(y,d,g){this.fileStorage=new i(E.URI.file((0,k.join)(y.userDataPath,St.STATE_FILE)),d,g)}async init(){return this.fileStorage.init()}getItem(y,d){return this.fileStorage.getItem(y,d)}setItem(y,d){this.fileStorage.setItem(y,d)}setItems(y){this.fileStorage.setItems(y)}removeItem(y){this.fileStorage.removeItem(y)}close(){return this.fileStorage.close()}};I.STATE_FILE="storage.json",I=he([ie(0,n.IEnvironmentMainService),ie(1,w.ILogService),ie(2,f.IFileService)],I),e.StateMainService=I}),define(Z[76],x([0,1,9,23,4,16,24,22,6,21,50,42]),function(V,e,p,L,k,M,E,n,f,w,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function P(d,g,b){return`${b.updateUrl}/api/update/${d}/${g}/${b.commit}`}e.createUpdateURL=P;let y=class{constructor(g,b,v,c,h,a){this.lifecycleMainService=g,this.configurationService=b,this.environmentMainService=v,this.requestService=c,this.logService=h,this.productService=a,this._state=I.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=this.getUpdateMode(),b=this.getProductQuality(g);if(!b){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(b),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(I.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getUpdateMode(){return(0,M.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,p.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},L.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};y=he([ie(0,n.ILifecycleMainService),ie(1,M.IConfigurationService),ie(2,E.IEnvironmentMainService),ie(3,i.IRequestService),ie(4,f.ILogService),ie(5,w.IProductService)],y),e.AbstractUpdateService=y}),define(Z[228],x([0,1,14,47,4,2,16,24,22,6,21,50,29,42,76]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends d.AbstractUpdateService{constructor(v,c,h,a,u,t,l){super(v,c,a,u,t,l);this.telemetryService=h,this.disposables=new M.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(p.autoUpdater,"error",(v,c)=>c)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(p.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(p.autoUpdater,"update-available",(v,c,h)=>({url:c,version:h,productVersion:h}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(p.autoUpdater,"update-downloaded",(v,c,h,a)=>({releaseNotes:c,version:h,productVersion:h,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const h=(this.state.type==="checking for updates"?this.state.explicit:!0)?v:void 0;this.setState(y.State.Idle(1,h))}buildUpdateFeedUrl(v){let c;this.productService.darwinUniversalAssetId?c=this.productService.darwinUniversalAssetId:c=process.arch==="x64"?"darwin":"darwin-arm64";const h=(0,d.createUpdateURL)(c,v,this.productService);try{p.autoUpdater.setFeedURL({url:h})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return h}doCheckForUpdates(v){this.setState(y.State.CheckingForUpdates(v)),p.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(y.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(y.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(y.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),p.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([L.memoize],g.prototype,"onRawError",null),he([L.memoize],g.prototype,"onRawUpdateNotAvailable",null),he([L.memoize],g.prototype,"onRawUpdateAvailable",null),he([L.memoize],g.prototype,"onRawUpdateDownloaded",null),g=he([ie(0,f.ILifecycleMainService),ie(1,E.IConfigurationService),ie(2,P.ITelemetryService),ie(3,n.IEnvironmentMainService),ie(4,I.IRequestService),ie(5,w.ILogService),ie(6,i.IProductService)],g),e.DarwinUpdateService=g}),define(Z[229],x([0,1,41,32,9,4,8,24,22,6,29,42]),function(V,e,p,L,k,M,E,n,f,w,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let P=class{constructor(g,b,v){if(this.lifecycleMainService=g,this.logService=v,this._state=I.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event,b.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(I.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,c=>this.logService.error(c))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,k.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};P=he([ie(0,f.ILifecycleMainService),ie(1,n.IEnvironmentMainService),ie(2,w.ILogService)],P);let y=class extends P{constructor(g,b,v,c,h,a){super(v,c,h);this.snap=g,this.snapRevision=b,this.telemetryService=a;const u=(0,L.watch)(E.dirname(this.snap)),t=M.Event.fromNodeEventEmitter(u,"change",(o,m)=>m),l=M.Event.filter(t,o=>o==="current"),s=M.Event.debounce(l,(o,m)=>m,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{s.dispose(),u.close()})}doCheckForUpdates(){this.setState(I.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(I.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,p.spawn)("sleep 3 && "+E.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((v,c)=>(0,L.realpath)(`${E.dirname(this.snap)}/current`,(h,a)=>h?c(h):v(a))),b=E.basename(g);return this.snapRevision!==b}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};y=he([ie(2,f.ILifecycleMainService),ie(3,n.IEnvironmentMainService),ie(4,w.ILogService),ie(5,i.ITelemetryService)],y),e.SnapUpdateService=y}),define(Z[46],x([0,1,14,32,4,40,34,2,10,8,3,15,13,19,154,51,52,24,5,6,21,100,27,101]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d,g,b,v,c,h,a,u,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,c.createDecorator)("workspacesManagementMainService");let r=class extends n.Disposable{constructor(o,m,S,D,R){super();this.environmentMainService=o,this.logService=m,this.backupMainService=S,this.dialogMainService=D,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new k.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new k.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(o){return this.doResolveLocalWorkspace(o,m=>(0,L.readFileSync)(m,"utf8"))}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,m=>y.Promises.readFile(m,"utf8"))}doResolveLocalWorkspace(o,m){if(!!this.isWorkspacePath(o)&&o.scheme===f.Schemas.file)try{const S=m(o.fsPath);return S instanceof Promise?S.then(D=>this.doResolveWorkspace(o,D),D=>{}):this.doResolveWorkspace(o,S)}catch{return}}isWorkspacePath(o){return(0,t.isUntitledWorkspace)(o,this.environmentMainService)||(0,t.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,m){try{const S=this.doParseStoredWorkspace(o,m),D=(0,l.getWorkspaceIdentifier)(o);return{id:D.id,configPath:D.configPath,folders:(0,t.toWorkspaceFolders)(S.folders,D.configPath,I.extUriBiasedIgnorePathCase),remoteAuthority:S.remoteAuthority,transient:S.transient}}catch(S){this.logService.warn(S.toString())}}doParseStoredWorkspace(o,m){const S=(0,M.parse)(m);if(S&&Array.isArray(S.folders))S.folders=S.folders.filter(D=>(0,t.isStoredWorkspaceFolder)(D));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return S}async createUntitledWorkspace(o,m){const{workspace:S,storedWorkspace:D}=this.newUntitledWorkspace(o,m),R=S.configPath.fsPath;return await y.Promises.mkdir((0,w.dirname)(R),{recursive:!0}),await y.Promises.writeFile(R,JSON.stringify(D,null,"	")),S}createUntitledWorkspaceSync(o,m){const{workspace:S,storedWorkspace:D}=this.newUntitledWorkspace(o,m),R=S.configPath.fsPath;return(0,L.mkdirSync)((0,w.dirname)(R),{recursive:!0}),(0,y.writeFileSync)(R,JSON.stringify(D,null,"	")),S}newUntitledWorkspace(o=[],m){const S=(Date.now()+Math.round(Math.random()*1e3)).toString(),D=(0,I.joinPath)(this.untitledWorkspacesHome,S),R=(0,I.joinPath)(D,t.UNTITLED_WORKSPACE_NAME),T=[];for(const _ of o)T.push((0,t.getStoredWorkspaceFolder)(_.uri,!0,_.name,D,!i.isWindows,I.extUriBiasedIgnorePathCase));return{workspace:(0,l.getWorkspaceIdentifier)(R),storedWorkspace:{folders:T,remoteAuthority:m}}}async getWorkspaceIdentifier(o){return(0,l.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,t.isUntitledWorkspace)(o.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(o){!this.isUntitledWorkspace(o)||(this.doDeleteUntitledWorkspaceSync(o),this._onDidDeleteUntitledWorkspace.fire(o))}async deleteUntitledWorkspace(o){this.deleteUntitledWorkspaceSync(o)}doDeleteUntitledWorkspaceSync(o){const m=(0,I.originalFSPath)(o.configPath);try{(0,y.rimrafSync)((0,w.dirname)(m));const S=(0,w.join)(this.environmentMainService.workspaceStorageHome.fsPath,o.id);(0,L.existsSync)(S)&&(0,y.writeFileSync)((0,w.join)(S,"obsolete"),"")}catch(S){this.logService.warn(`Unable to delete untitled workspace ${m} (${S}).`)}}getUntitledWorkspacesSync(){const o=[];try{const m=(0,y.readdirSync)(this.untitledWorkspacesHome.fsPath).map(S=>(0,I.joinPath)(this.untitledWorkspacesHome,S,t.UNTITLED_WORKSPACE_NAME));for(const S of m){const D=(0,l.getWorkspaceIdentifier)(S),R=this.resolveLocalWorkspaceSync(S);R?o.push({workspace:D,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(D)}}catch(m){m.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${m}).`)}return o}async enterWorkspace(o,m,S){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,m,S))return;const R=this.doEnterWorkspace(o,(0,l.getWorkspaceIdentifier)(S));if(!!R)return this._onDidEnterWorkspace.fire({window:o,workspace:R.workspace}),R}async isValidTargetWorkspacePath(o,m,S){if(!S)return!0;if((0,t.isWorkspaceIdentifier)(o.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,S))return!1;if((0,u.findWindowOnWorkspaceOrFolder)(m,S)){const D={title:this.productService.nameLong,type:"info",buttons:[(0,E.mnemonicButtonLabel)((0,d.localize)(0,null))],message:(0,d.localize)(1,null,(0,I.basename)(S)),detail:(0,d.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(D,(0,P.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(o,m){if(!o.config)return;o.focus();let S;return o.config.extensionDevelopmentPath||(S=this.backupMainService.registerWorkspaceBackupSync({workspace:m,remoteAuthority:o.remoteAuthority},o.config.backupPath)),(0,t.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&this.deleteUntitledWorkspaceSync(o.openedWorkspace),o.config.workspace=m,o.config.backupPath=S,{workspace:m,backupPath:S}}};r=he([ie(0,v.IEnvironmentMainService),ie(1,h.ILogService),ie(2,g.IBackupMainService),ie(3,b.IDialogMainService),ie(4,a.IProductService)],r),e.WorkspacesManagementMainService=r}),define(Z[102],x([0,1,14,30,23,3,13,7,19,16,54,5,6,98,36,27,46]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,I.createDecorator)(e.ID);let v=class{constructor(h,a,u,t,l){this.logService=h,this.windowsMainService=a,this.urlService=u,this.workspacesManagementMainService=t,this.configurationService=l}async start(h,a){this.logService.trace("Received data from other instance: ",h,a),M.isMacintosh&&p.app.focus({steal:!0});const u=this.parseOpenUrl(h);if(u.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:l,url:r}of u)this.urlService.open(l,{originalUrl:r})})}else return this.startOpenWindow(h,a)}parseOpenUrl(h){return h["open-url"]&&h._urls&&h._urls.length>0?(0,L.coalesce)(h._urls.map(a=>{try{return{uri:n.URI.parse(a),url:a}}catch(u){return null}})):[]}async startOpenWindow(h,a){const u=(0,i.isLaunchedFromCli)(a)?0:4;let t=[];const l=h.wait&&h.waitMarkerFilePath?n.URI.file(h.waitMarkerFilePath):void 0,r=h.remote||void 0,s={context:u,cli:h,userEnv:a,waitMarkerFileURI:l,remoteAuthority:r};if(h.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(h.extensionDevelopmentPath,s);else if(!h._.length&&!h["folder-uri"]&&!h["file-uri"]){let o=!1;if(h["new-window"]||h["unity-launch"])o=!0;else if(h["reuse-window"])o=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":o=!0;break;case"off":o=!1;break;default:o=!M.isMacintosh}if(o)t=this.windowsMainService.open({...s,forceNewWindow:!0,forceEmpty:!0});else{const m=this.windowsMainService.getLastActiveWindow();m?(this.windowsMainService.openExistingWindow(m,s),t=[m]):t=this.windowsMainService.open({...s,forceEmpty:!0})}}else t=this.windowsMainService.open({...s,forceNewWindow:h["new-window"],preferNewWindow:!h["reuse-window"]&&!h.wait,forceReuseWindow:h["reuse-window"],diffMode:h.diff,addMode:h.add,noRecentEntry:!!h["skip-add-to-recently-opened"],gotoLineMode:h.goto});if(l&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,(0,f.whenDeleted)(l.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const h=[];return p.BrowserWindow.getAllWindows().forEach(a=>{const u=this.windowsMainService.getWindowById(a.id);u?h.push(this.codeWindowToInfo(u)):h.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!p.app.accessibilitySupportEnabled,gpuFeatureStatus:p.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(h){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(t=>new Promise(l=>{const r=t.remoteAuthority;if(r){const s=`vscode:getDiagnosticInfoResponse${t.id}`,o={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:s,args:o}),p.ipcMain.once(s,(m,S)=>{S||l({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),l(S)}),setTimeout(()=>{l({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else l(void 0)})))).filter(t=>!!t)}getFolderURIs(h){const a=[],u=h.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(u))a.push(u.uri);else if((0,g.isWorkspaceIdentifier)(u)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);t&&t.folders.forEach(r=>{a.push(r.uri)})}return a}codeWindowToInfo(h){const a=this.getFolderURIs(h),u=(0,E.assertIsDefined)(h.win);return this.browserWindowToInfo(u,a,h.remoteAuthority)}browserWindowToInfo(h,a=[],u){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:a,remoteAuthority:u}}};v=he([ie(0,P.ILogService),ie(1,d.IWindowsMainService),ie(2,y.IURLService),ie(3,b.IWorkspacesManagementMainService),ie(4,w.IConfigurationService)],v),e.LaunchMainService=v}),define(Z[53],x([0,1,41,14,26,114,47,4,34,2,10,8,3,7,82,68,19,146,52,24,5,22,6,21,29,62,36,27,46]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d,g,b,v,c,h,a,u,t,l,r,s,o,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let D=class ct extends w.Disposable{constructor(T,_,G,ne,se,K,te,W,j,H){super();this.sharedProcess=T,this.windowsMainService=_,this.dialogMainService=G,this.lifecycleMainService=ne,this.environmentMainService=se,this.telemetryService=K,this.logService=te,this.productService=W,this.themeMainService=j,this.workspacesManagementMainService=H,this.onDidOpenWindow=n.Event.map(this.windowsMainService.onDidOpenWindow,z=>z.id),this.onDidMaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(z,q)=>q.id),z=>!!this.windowsMainService.getWindowById(z)),this.onDidUnmaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(z,q)=>q.id),z=>!!this.windowsMainService.getWindowById(z)),this.onDidBlurWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(z,q)=>q.id),z=>!!this.windowsMainService.getWindowById(z)),this.onDidFocusWindow=n.Event.any(n.Event.map(n.Event.filter(n.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),z=>!!z),z=>z.id),n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(z,q)=>q.id),z=>!!this.windowsMainService.getWindowById(z))),this.onDidResumeOS=n.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new n.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=n.Event.debounce(n.Event.any(n.Event.filter(n.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(z,q,O)=>O),z=>!(Array.isArray(z)&&z.length===1&&z[0]==="workArea")),n.Event.fromNodeEventEmitter(L.screen,"display-added"),n.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(_=>({id:_.id,workspace:_.openedWorkspace,title:_.win?.getTitle()??"",filename:_.getRepresentedFilename(),dirty:_.isDocumentEdited()}))}async getWindowCount(T){return this.windowsMainService.getWindowCount()}async getActiveWindowId(T){const _=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(_)return _.id}openWindow(T,_,G){return Array.isArray(_)?this.doOpenWindow(T,_,G):this.doOpenEmptyWindow(T,_)}async doOpenWindow(T,_,G=Object.create(null)){_.length>0&&this.windowsMainService.open({context:5,contextWindowId:T,urisToOpen:_,cli:this.environmentMainService.args,forceNewWindow:G.forceNewWindow,forceReuseWindow:G.forceReuseWindow,preferNewWindow:G.preferNewWindow,diffMode:G.diffMode,addMode:G.addMode,gotoLineMode:G.gotoLineMode,noRecentEntry:G.noRecentEntry,waitMarkerFileURI:G.waitMarkerFileURI,remoteAuthority:G.remoteAuthority||void 0})}async doOpenEmptyWindow(T,_){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:T},_)}async toggleFullScreen(T){const _=this.windowById(T);_&&_.toggleFullScreen()}async handleTitleDoubleClick(T){const _=this.windowById(T);_&&_.handleTitleDoubleClick()}async isMaximized(T){const _=this.windowById(T);return _?.win?_.win.isMaximized():!1}async maximizeWindow(T){const _=this.windowById(T);_?.win&&_.win.maximize()}async unmaximizeWindow(T){const _=this.windowById(T);_?.win&&_.win.unmaximize()}async minimizeWindow(T){const _=this.windowById(T);_?.win&&_.win.minimize()}async focusWindow(T,_){_&&typeof _.windowId=="number"&&(T=_.windowId);const G=this.windowById(T);G&&G.focus({force:_?.force??!1})}async setMinimumSize(T,_,G){const ne=this.windowById(T);if(ne?.win){const[se,K]=ne.win.getSize(),[te,W]=ne.win.getMinimumSize(),[j,H]=[_??te,G??W],[z,q]=[Math.max(se,j),Math.max(K,H)];(te!==j||W!==H)&&ne.win.setMinimumSize(j,H),(se!==z||K!==q)&&ne.win.setSize(z,q)}}async saveWindowSplash(T,_){this.themeMainService.saveWindowSplash(T,_)}async installShellCommand(T){const{source:_,target:G}=await this.getShellCommandLink();try{const{symbolicLink:ne}=await b.SymlinkSupport.stat(_);if(ne&&!ne.dangling){const se=await(0,d.realpath)(_);if(G===se)return}await b.Promises.unlink(_)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await b.Promises.symlink(G,_)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:se}=await this.showMessageBox(T,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const K=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${G}' '${_}'\\" with administrator privileges"`;await(0,M.promisify)(p.exec)(K)}catch(K){throw new Error((0,v.localize)(3,null,_))}}}async uninstallShellCommand(T){const{source:_}=await this.getShellCommandLink();try{await b.Promises.unlink(_)}catch(G){switch(G.code){case"EACCES":const{response:ne}=await this.showMessageBox(T,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ne===0)try{const se=`osascript -e "do shell script \\"rm '${_}'\\" with administrator privileges"`;await(0,M.promisify)(p.exec)(se)}catch(se){throw new Error((0,v.localize)(7,null,_))}break;case"ENOENT":break;default:throw G}}}async getShellCommandLink(){const T=(0,I.resolve)(this.environmentMainService.appRoot,"bin","code"),_=`/usr/local/bin/${this.productService.applicationName}`;if(!await b.Promises.exists(T))throw new Error((0,v.localize)(8,null,T));return{source:_,target:T}}async showMessageBox(T,_){return this.dialogMainService.showMessageBox(_,this.toBrowserWindow(T))}async showSaveDialog(T,_){return this.dialogMainService.showSaveDialog(_,this.toBrowserWindow(T))}async showOpenDialog(T,_){return this.dialogMainService.showOpenDialog(_,this.toBrowserWindow(T))}toBrowserWindow(T){const _=this.windowById(T);if(_?.win)return _.win}async pickFileFolderAndOpen(T,_){const G=await this.dialogMainService.pickFileFolder(_);G&&(this.sendPickerTelemetry(G,_.telemetryEventName||"openFileFolder",_.telemetryExtraData),this.doOpenPicked(await Promise.all(G.map(async ne=>await b.SymlinkSupport.existsDirectory(ne)?{folderUri:y.URI.file(ne)}:{fileUri:y.URI.file(ne)})),_,T))}async pickFolderAndOpen(T,_){const G=await this.dialogMainService.pickFolder(_);G&&(this.sendPickerTelemetry(G,_.telemetryEventName||"openFolder",_.telemetryExtraData),this.doOpenPicked(G.map(ne=>({folderUri:y.URI.file(ne)})),_,T))}async pickFileAndOpen(T,_){const G=await this.dialogMainService.pickFile(_);G&&(this.sendPickerTelemetry(G,_.telemetryEventName||"openFile",_.telemetryExtraData),this.doOpenPicked(G.map(ne=>({fileUri:y.URI.file(ne)})),_,T))}async pickWorkspaceAndOpen(T,_){const G=await this.dialogMainService.pickWorkspace(_);G&&(this.sendPickerTelemetry(G,_.telemetryEventName||"openWorkspace",_.telemetryExtraData),this.doOpenPicked(G.map(ne=>({workspaceUri:y.URI.file(ne)})),_,T))}doOpenPicked(T,_,G){this.windowsMainService.open({context:3,contextWindowId:G,cli:this.environmentMainService.args,urisToOpen:T,forceNewWindow:_.forceNewWindow})}sendPickerTelemetry(T,_,G){const ne=T?T.length:0;this.telemetryService.publicLog(_,{...G,outcome:ne?"success":"canceled",numberOfPaths:ne})}async showItemInFolder(T,_){L.shell.showItemInFolder(_)}async setRepresentedFilename(T,_){const G=this.windowById(T);G&&G.setRepresentedFilename(_)}async setDocumentEdited(T,_){const G=this.windowById(T);G&&G.setDocumentEdited(_)}async openExternal(T,_){return P.isLinuxSnap?this.safeSnapOpenExternal(_):L.shell.openExternal(_),!0}safeSnapOpenExternal(T){const _=process.env.GDK_PIXBUF_MODULE_FILE,G=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(T),process.env.GDK_PIXBUF_MODULE_FILE=_,process.env.GDK_PIXBUF_MODULEDIR=G}moveItemToTrash(T,_){return L.shell.trashItem(_)}async isAdmin(){let T;return P.isWindows?T=(await new Promise((_,G)=>{V(["native-is-elevated"],_,G)}))():T=process.getuid()===0,T}async writeElevated(T,_,G,ne){const se=await new Promise((K,te)=>{V(["sudo-prompt"],K,te)});return new Promise((K,te)=>{const W=[`"${this.cliPath}"`];ne?.unlock&&W.push("--file-chmod"),W.push("--file-write",`"${_.fsPath}"`,`"${G.fsPath}"`);const j={name:this.productService.nameLong.replace("-",""),icns:P.isMacintosh&&this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};se.exec(W.join(" "),j,(H,z,q)=>{z&&this.logService.trace(`[sudo-prompt] received stdout: ${z}`),q&&this.logService.trace(`[sudo-prompt] received stderr: ${q}`),H?te(H):K(void 0)})})}get cliPath(){return P.isWindows?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):P.isLinux?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,I.join)(this.environmentMainService.appRoot,"bin","code"):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}async killProcess(T,_,G){process.kill(_,G)}async readClipboardText(T,_){return L.clipboard.readText(_)}async writeClipboardText(T,_,G){return L.clipboard.writeText(_,G)}async readClipboardFindText(T){return L.clipboard.readFindText()}async writeClipboardFindText(T,_){return L.clipboard.writeFindText(_)}async writeClipboardBuffer(T,_,G,ne){return L.clipboard.writeBuffer(_,Buffer.from(G),ne)}async readClipboardBuffer(T,_){return L.clipboard.readBuffer(_)}async hasClipboard(T,_,G){return L.clipboard.has(_,G)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(T,_){const G=this.windowById(T);G&&G.updateTouchBar(_)}async notifyReady(T){const _=this.windowById(T);_&&_.setReady()}async relaunch(T,_){return this.lifecycleMainService.relaunch(_)}async reload(T,_){const G=this.windowById(T);if(G){if((0,m.isWorkspaceIdentifier)(G.openedWorkspace)){const ne=G.openedWorkspace.configPath;if(ne.scheme===i.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ne))?.transient)return this.openWindow(G.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(G,_?.disableExtensions!==void 0?{_:[],"disable-extensions":_.disableExtensions}:void 0)}}async closeWindow(T){this.closeWindowById(T,T)}async closeWindowById(T,_){const G=this.windowById(_);if(G?.win)return G.win.close()}async quit(T){const _=this.windowsMainService.getLastActiveWindow();_?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&_.win?_.win.close():this.lifecycleMainService.quit()}async exit(T,_){await this.lifecycleMainService.kill(_)}async resolveProxy(T,_){const ne=this.windowById(T)?.win?.webContents?.session;if(ne)return ne.resolveProxy(_)}async openDevTools(T,_){const G=this.windowById(T);G?.win&&G.win.webContents.openDevTools(_)}async toggleDevTools(T){const _=this.windowById(T);_?.win&&_.win.webContents.toggleDevTools()}async sendInputEvent(T,_){const G=this.windowById(T);G?.win&&(_.type==="mouseDown"||_.type==="mouseUp")&&G.win.webContents.sendInputEvent(_)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(T,_,G,ne){if(!P.isWindows)return;const se=await new Promise((K,te)=>{V(["vscode-windows-registry"],K,te)});try{return se.GetStringRegKey(_,G,ne)}catch{return}}async getPassword(T,_,G){const ne=await this.withKeytar(),se=await ne.getPassword(_,G);if(se)try{let{content:K,hasNextChunk:te}=JSON.parse(se);if(!K||!te)return se;let W=1;for(;te;){const j=await ne.getPassword(_,`${G}-${W}`),H=JSON.parse(j);K+=H.content,te=H.hasNextChunk,W++}return K}catch{return se}return se}async setPassword(T,_,G,ne){const se=await this.withKeytar(),K=3,te=async(W,j,H)=>{let z=0,q;for(;z<K;)try{await se.setPassword(W,j,H);return}catch(O){q=O,this.logService.warn("Error attempting to set a password: ",O),z++,await new Promise($=>setTimeout($,200))}throw q};if(P.isWindows&&ne.length>ct.MAX_PASSWORD_LENGTH){let W=0,j=0,H=!0;for(;H;){const z=ne.substring(W,W+ct.PASSWORD_CHUNK_SIZE);W+=ct.PASSWORD_CHUNK_SIZE,H=ne.length-W>0;const q={content:z,hasNextChunk:H};await te(_,j?`${G}-${j}`:G,JSON.stringify(q)),j++}}else await te(_,G,ne);this._onDidChangePassword.fire({service:_,account:G})}async deletePassword(T,_,G){const se=await(await this.withKeytar()).deletePassword(_,G);return se&&this._onDidChangePassword.fire({service:_,account:G}),se}async findPassword(T,_){return(await this.withKeytar()).findPassword(_)}async findCredentials(T,_){return(await this.withKeytar()).findCredentials(_)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((T,_)=>{V(["keytar"],T,_)})}windowById(T){if(typeof T=="number")return this.windowsMainService.getWindowById(T)}};D.MAX_PASSWORD_LENGTH=2500,D.PASSWORD_CHUNK_SIZE=D.MAX_PASSWORD_LENGTH-100,he([E.memoize],D.prototype,"cliPath",null),D=he([ie(1,o.IWindowsMainService),ie(2,c.IDialogMainService),ie(3,u.ILifecycleMainService),ie(4,h.IEnvironmentMainService),ie(5,r.ITelemetryService),ie(6,t.ILogService),ie(7,l.IProductService),ie(8,s.IThemeMainService),ie(9,S.IWorkspacesManagementMainService)],D),e.NativeHostMainService=D}),define(Z[230],x([0,1,14,23,4,80,2,28,89,6,53,21,36]),function(V,e,p,L,k,M,E,n,f,w,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let d=class extends E.Disposable{constructor(b,v,c,h,a){super();this.logService=b,this.windowsMainService=v,this.nativeHostMainService=c,this.encryptionMainService=h,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=k.Event.fromNodeEventEmitter(p.app,"login",(v,c,h,a,u)=>({event:v,webContents:c,req:h,authInfo:a,callback:u}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:v,req:c,callback:h}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&c.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(a?.username,a?.password)}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(b);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){this.logService.trace("auth#doResolveProxyCredentials - enter",b);const v=String((0,M.hash)({scheme:b.scheme,host:b.host,port:b.port}));let c,h;try{const l=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v);if(l){const r=JSON.parse(await this.encryptionMainService.decrypt(l));c=r.username,h=r.password}}catch(l){this.logService.error(l)}if(this.state!==y.StoredCredentialsUsed&&typeof c=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:c,password:h};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const u={authInfo:b,username:this.sessionCredentials?.username??c,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,n.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,u),this.state=y.LoginDialogShown;const t=await new Promise(l=>{const r=async(s,o,m)=>{if(o===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",r),m){const S={username:m.username,password:m.password};try{if(m.remember){const D=await this.encryptionMainService.encrypt(JSON.stringify(S));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v,D)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v)}catch(D){this.logService.error(D)}l({username:S.username,password:S.password})}else l(void 0)};a.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=t,t}};d=he([ie(0,w.ILogService),ie(1,P.IWindowsMainService),ie(2,i.INativeHostMainService),ie(3,f.IEncryptionMainService),ie(4,I.IProductService)],d),e.ProxyAuthHandler=d}),define(Z[231],x([0,1,14,26,34,2,10,3,83,144,71,52,24,5,102,6,53,45,21,55,63]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d,g,b,v,c,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,y.createDecorator)("issueMainService");let u=class bt{constructor(l,r,s,o,m,S,D,R,T){this.userEnv=l,this.environmentMainService=r,this.launchMainService=s,this.logService=o,this.diagnosticsService=m,this.dialogMainService=S,this.nativeHostMainService=D,this.protocolMainService=R,this.productService=T,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:issueSystemInfoRequest",async l=>{const[r,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),o=await this.diagnosticsService.getSystemInfo(r,s);this.safeSend(l,"vscode:issueSystemInfoResponse",o)}),p.ipcMain.on("vscode:listProcesses",async l=>{const r=[];try{const s=await this.launchMainService.getMainProcessId();r.push({name:(0,w.localize)(0,null),rootProcess:await(0,f.listProcesses)(s)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(m=>{(0,i.isRemoteDiagnosticError)(m)?r.push({name:m.hostName,rootProcess:m}):m.processes&&r.push({name:m.hostName,rootProcess:m.processes})})}catch(s){this.logService.error(`Listing processes failed: ${s}`)}this.safeSend(l,"vscode:listProcessesResponse",r)}),p.ipcMain.on("vscode:issueReporterClipboard",async l=>{const r={title:this.productService.nameLong,message:(0,w.localize)(1,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(2,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const s=await this.dialogMainService.showMessageBox(r,this.issueReporterWindow);this.safeSend(l,"vscode:issueReporterClipboardResponse",s.response===0)}}),p.ipcMain.on("vscode:issuePerformanceInfoRequest",async l=>{const r=await this.getPerformanceInfo();this.safeSend(l,"vscode:issuePerformanceInfoResponse",r)}),p.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const l={title:this.productService.nameLong,message:(0,w.localize)(4,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,w.localize)(5,null)),(0,k.mnemonicButtonLabel)((0,w.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(l,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),p.ipcMain.on("vscode:workbenchCommand",(l,r)=>{const{id:s,from:o,args:m}=r;let S;switch(o){case"issueReporter":S=this.issueReporterParentWindow;break;case"processExplorer":S=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${o}`)}S&&S.webContents.send("vscode:runAction",{id:s,from:o,args:m})}),p.ipcMain.on("vscode:openExternal",(l,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),p.ipcMain.on("vscode:closeIssueReporter",l=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),p.ipcMain.on("vscode:closeProcessExplorer",l=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),p.ipcMain.on("vscode:windowsInfoRequest",async l=>{const r=await this.launchMainService.getMainProcessInfo();this.safeSend(l,"vscode:windowsInfoResponse",r.windows)})}safeSend(l,r,...s){l.sender.isDestroyed()||l.sender.send(r,...s)}async openReporter(l){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=p.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new M.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(o,s,{backgroundColor:l.styles.backgroundColor,title:(0,w.localize)(7,null),zoomLevel:l.zoomLevel,alwaysOnTop:!1}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:l,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:v.default}),this.issueReporterWindow.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",V).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(l){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=p.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new M.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(o,s,{backgroundColor:l.styles.backgroundColor,title:(0,w.localize)(8,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:l,product:v.default}),this.processExplorerWindow.loadURL(E.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",V).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(l,r,s){const o=new p.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:s.title,backgroundColor:s.backgroundColor||bt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:E.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,a.zoomLevelToZoomFactor)(s.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:s.alwaysOnTop});return o.setMenuBarVisibility(!1),o}async getSystemStatus(){const[l,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(l,r)}getWindowPosition(l,r,s){let o;const m=p.screen.getAllDisplays();if(m.length===1)o=m[0];else{if(n.isMacintosh){const R=p.screen.getCursorScreenPoint();o=p.screen.getDisplayNearestPoint(R)}!o&&l&&(o=p.screen.getDisplayMatching(l.getBounds())),o||(o=p.screen.getPrimaryDisplay()||m[0])}const S={width:r,height:s},D=o.bounds;return S.x=D.x+D.width/2-S.width/2,S.y=D.y+D.height/2-S.height/2,D.width>0&&D.height>0&&(S.x<D.x&&(S.x=D.x),S.y<D.y&&(S.y=D.y),S.x>D.x+D.width&&(S.x=D.x),S.y>D.y+D.height&&(S.y=D.y),S.width>D.width&&(S.width=D.width),S.height>D.height&&(S.height=D.height)),S}async getPerformanceInfo(){try{const[l,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(l,r)}catch(l){throw this.logService.warn("issueService#getPerformanceInfo ",l.message),l}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=he([ie(1,P.IEnvironmentMainService),ie(2,d.ILaunchMainService),ie(3,g.ILogService),ie(4,i.IDiagnosticsService),ie(5,I.IDialogMainService),ie(6,b.INativeHostMainService),ie(7,h.IProtocolMainService),ie(8,c.IProductService)],u),e.IssueMainService=u}),define(Z[232],x([0,1,23,16,24,22,6,53,21,50,29,42,76]),function(V,e,p,L,k,M,E,n,f,w,i,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let y=class extends P.AbstractUpdateService{constructor(g,b,v,c,h,a,u,t){super(g,b,c,h,a,t);this.telemetryService=v,this.nativeHostMainService=u}buildUpdateFeedUrl(g){return(0,P.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(I.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},p.CancellationToken.None).then(w.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(I.State.Idle(1))):this.setState(I.State.AvailableForDownload(b))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const v=g?b.message||b:void 0;this.setState(I.State.Idle(1,v))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(I.State.Idle(1))}};y=he([ie(0,M.ILifecycleMainService),ie(1,L.IConfigurationService),ie(2,i.ITelemetryService),ie(3,k.IEnvironmentMainService),ie(4,w.IRequestService),ie(5,E.ILogService),ie(6,n.INativeHostMainService),ie(7,f.IProductService)],y),e.LinuxUpdateService=y}),define(Z[233],x([0,1,41,32,26,9,23,47,8,7,112,19,16,24,20,22,6,53,21,50,29,42,76]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d,g,b,v,c,h,a,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(m,S=1e3){for(;!m();)await(0,M.timeout)(S)}let r;function s(){return typeof r=="undefined"&&(r=L.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),r}let o=class extends t.AbstractUpdateService{constructor(S,D,R,T,_,G,ne,se,K){super(S,D,T,_,G,K);this.telemetryService=R,this.fileService=ne,this.nativeHostMainService=se}get cachePath(){const S=f.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return I.Promises.mkdir(S,{recursive:!0}).then(()=>S)}initialize(){super.initialize(),s()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(S){let D="win32";return process.arch!=="ia32"&&(D+=`-${process.arch}`),s()===1?D+="-archive":this.productService.target==="user"&&(D+="-user"),(0,t.createUpdateURL)(D,S,this.productService)}doCheckForUpdates(S){!this.url||(this.setState(u.State.CheckingForUpdates(S)),this.requestService.request({url:this.url},E.CancellationToken.None).then(h.asJson).then(D=>{const R=s();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S}),this.setState(u.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(u.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(u.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(T=>I.Promises.exists(T).then(_=>{if(_)return Promise.resolve(T);const G=D.url,ne=D.hash,se=`${T}.tmp`;return this.requestService.request({url:G},E.CancellationToken.None).then(K=>this.fileService.writeFile(w.URI.file(se),K.stream)).then(ne?()=>(0,i.checksum)(se,D.hash):()=>{}).then(()=>I.Promises.rename(se,T)).then(()=>T)})).then(T=>{const _=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},_&&D.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(u.State.Downloaded(D)):this.setState(u.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!S});const R=S?D.message||D:void 0;this.setState(u.State.Idle(s(),R))}))}async doDownloadUpdate(S){S.update.url&&this.nativeHostMainService.openExternal(void 0,S.update.url),this.setState(u.State.Idle(s()))}async getUpdatePackagePath(S){const D=await this.cachePath;return f.join(D,`CodeSetup-${this.productService.quality}-${S}.exe`)}async cleanup(S=null){const D=S?G=>!new RegExp(`${this.productService.quality}-${S}\\.exe$`).test(G):()=>!0,R=await this.cachePath,_=(await I.Promises.readdir(R)).filter(D).map(async G=>{try{await I.Promises.unlink(f.join(R,G))}catch(ne){}});await Promise.all(_)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const S=this.state.update;this.setState(u.State.Updating(S));const D=await this.cachePath;this.availableUpdate.updateFilePath=f.join(D,`CodeSetup-${this.productService.quality}-${S.version}.flag`),await I.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,p.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(u.State.Idle(s()))});const T=`${this.productService.win32MutexName}-ready`,_=await new Promise((G,ne)=>{V(["windows-mutex"],G,ne)});l(()=>_.isActive(T)).then(()=>this.setState(u.State.Ready(S)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):(0,p.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return s()}};he([n.memoize],o.prototype,"cachePath",null),o=he([ie(0,g.ILifecycleMainService),ie(1,P.IConfigurationService),ie(2,a.ITelemetryService),ie(3,y.IEnvironmentMainService),ie(4,h.IRequestService),ie(5,b.ILogService),ie(6,d.IFileService),ie(7,v.INativeHostMainService),ie(8,c.IProductService)],o),e.Win32UpdateService=o}),define(Z[234],x([0,1,14,9,23,4,34,2,10,8,73,3,7,150,51,16,52,24,54,201,20,22,6,21,55,99,29,204,62,63,36,27,46]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d,g,b,v,c,h,a,u,t,l,r,s,o,m,S,D,R,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var G;(function(se){se[se.NONE=0]="NONE",se[se.LOADING=1]="LOADING",se[se.NAVIGATING=2]="NAVIGATING",se[se.READY=3]="READY"})(G||(G={}));let ne=class extends n.Disposable{constructor(K,te,W,j,H,z,q,O,$,U,A,F,B,Y){super();this.logService=te,this.environmentMainService=W,this.fileService=j,this.configurationService=z,this.themeMainService=q,this.workspacesManagementMainService=O,this.backupMainService=$,this.telemetryService=U,this.dialogMainService=A,this.lifecycleMainService=F,this.productService=B,this.protocolMainService=Y,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[C,N]=this.restoreWindowState(K.state);this.windowState=C,this.logService.trace("window#ctor: using window state",C);const Q=this.windowState.mode===0||this.windowState.mode===3,J=this.configurationService.getValue("window"),re={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!Q,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,D.zoomLevelToZoomFactor)(J?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};I.isLinux?re.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):I.isWindows&&!this.environmentMainService.isBuilt&&(re.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),I.isMacintosh&&!this.useNativeFullScreen()&&(re.fullscreenable=!1),I.isMacintosh&&(re.acceptFirstMouse=!0,J?.clickThroughInactive===!1&&(re.acceptFirstMouse=!1));const le=I.isMacintosh&&J?.nativeTabs===!0;le&&(re.tabbingIdentifier=this.productService.nameShort);const ee=(0,D.getTitleBarStyle)(this.configurationService)==="custom";if(ee&&(re.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,I.isMacintosh||(re.frame=!1)),(0,i.mark)("code/willCreateCodeBrowserWindow"),this._win=new p.BrowserWindow(re),(0,i.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),I.isMacintosh&&ee&&this._win.setSheetOffset(22),I.isMacintosh&&N&&(!le||p.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ae=>typeof ae=="number")){const ae=this.windowState;this._win.setBounds({width:ae.width,height:ae.height,x:ae.x,y:ae.y})}Q&&((0,i.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,i.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,h.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:C=>H.globalStorage.get(C),store:(C,N)=>H.globalStorage.set(C,N)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(K){I.isMacintosh?this._win.setRepresentedFilename(K):this.representedFilename=K}getRepresentedFilename(){return I.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(K){I.isMacintosh&&this._win.setDocumentEdited(K),this.documentEdited=K}isDocumentEdited(){return I.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(K){I.isMacintosh&&K?.force&&p.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(K=>{if(this.isReady)return K(this);this.whenReadyCallbacks.push(K)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(K=>{function te(){W.dispose(),j.dispose(),K()}const W=this.onDidClose(()=>te()),j=this.onWillLoad(()=>te())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(H,z)=>this.onWindowError(2,z)),this._win.webContents.on("did-fail-load",(H,z,q)=>this.onWindowError(3,{reason:q,exitCode:z})),this._win.webContents.on("will-prevent-unload",H=>{H.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const K=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),te=H=>{for(let z=H;z;z=z.parent)if(z.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},W=H=>H.resourceType==="xhr"||te(H.frame);this._win.webContents.session.webRequest.onBeforeRequest((H,z)=>{const q=P.URI.parse(H.url);return q.path.endsWith(".svg")&&!K.has(q.scheme)?z({cancel:!W(H)}):z({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((H,z)=>{const q=H.responseHeaders,O=q["content-type"]||q["Content-Type"];if(O&&Array.isArray(O)){const $=P.URI.parse(H.url);if($.path.endsWith(".svg")&&K.has($.scheme))return q["Content-Type"]=["image/svg+xml"],z({cancel:!1,responseHeaders:q});if(!$.path.includes(f.Schemas.vscodeRemoteResource)&&O.some(U=>U.toLowerCase().includes("image/svg")))return z({cancel:!W(H)})}return z({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",H=>{this.currentConfig&&(this.currentConfig.maximized=!0),p.app.emit("browser-window-maximize",H,this._win)}),this._win.on("unmaximize",H=>{this.currentConfig&&(this.currentConfig.maximized=!1),p.app.emit("browser-window-unmaximize",H,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(H=>this.onDidDeleteUntitledWorkspace(H)));const j=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:j},async(H,z)=>{const q=await this.marketplaceHeadersPromise;z({cancel:!1,requestHeaders:Object.assign(H.requestHeaders,q)})})}async onWindowError(K,te){switch(K){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${te?.reason||"<unknown>"}, code: ${te?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${te?.reason||"<unknown>"}, code: ${te?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:K,reason:te?.reason,code:te?.exitCode}),K){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(K===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const W=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,y.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,y.localize)(1,null)),(0,E.mnemonicButtonLabel)((0,y.localize)(2,null))],message:(0,y.localize)(3,null),detail:(0,y.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;W.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):W.response===2&&this.destroyWindow()}else if(K===2){let W;te?W=(0,y.localize)(6,null,te.reason,te.exitCode??"<unknown>"):W=(0,y.localize)(5,null);const j=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,y.localize)(7,null)),(0,E.mnemonicButtonLabel)((0,y.localize)(8,null))],message:W,detail:(0,y.localize)(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;j.response===0?this.reload():j.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(K){this.openedWorkspace?.id===K.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const K=this.getMenuBarVisibility();K!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=K,this.setMenuBarVisibility(K));let te=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;te?.endsWith("/")&&(te=te.substr(0,te.length-1));const W=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((te||"").indexOf("@")===-1&&(te!==this.currentHttpProxy||W!==this.currentNoProxy)){this.currentHttpProxy=te,this.currentNoProxy=W;const j=te||"",H=W?`${W},<local>`:"<local>";this.logService.trace(`Setting proxy to '${j}', bypassing '${H}'`),this._win.webContents.session.setProxy({proxyRules:j,proxyBypassRules:H,pacScript:""})}}addTabbedWindow(K){I.isMacintosh&&K.win&&this._win.addTabbedWindow(K.win)}load(K,te=Object.create(null)){this.isDocumentEdited()&&(!te.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),te.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(K,te),this.readyState===0?this.currentConfig=K:(this.pendingLoadConfig=K,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",V).toString(!0));const W=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:K.workspace,reason:te.isReload?3:W?2:1})}updateConfiguration(K,te){const W=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(W){const j=(0,c.isLaunchedFromCli)(W)&&!(0,c.isLaunchedFromCli)(K.userEnv),H=this.isExtensionDevelopmentHost;(j||H)&&(K.userEnv={...W,...K.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(K.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),te.disableExtensions!==void 0&&(K["disable-extensions"]=te.disableExtensions),K.fullscreen=this.isFullScreen,K.maximized=this._win.isMaximized(),K.partsSplash=this.themeMainService.getWindowSplash(),(0,i.mark)("code/willOpenNewWindow"),K.perfMarks=(0,i.getMarks)(),this.configObjectUrl.update(K)}async reload(K){const te=Object.assign({},this.currentConfig);te.workspace=await this.validateWorkspaceBeforeReload(te),delete te.filesToOpenOrCreate,delete te.filesToDiff,delete te.filesToWait,this.isExtensionDevelopmentHost&&K&&(te.verbose=K.verbose,te.debugId=K.debugId,te["inspect-extensions"]=K["inspect-extensions"],te["inspect-brk-extensions"]=K["inspect-brk-extensions"],te["extensions-dir"]=K["extensions-dir"]),te.isInitialStartup=!1,this.load(te,{isReload:!0,disableExtensions:K?.["disable-extensions"]})}async validateWorkspaceBeforeReload(K){if((0,T.isWorkspaceIdentifier)(K.workspace)){const te=K.workspace.configPath;if(te.scheme===f.Schemas.file&&!await this.fileService.exists(te))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(K.workspace)){const te=K.workspace.uri;if(te.scheme===f.Schemas.file&&!await this.fileService.exists(te))return}return K.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let W;try{W=p.screen.getDisplayMatching(this.getBounds())}catch(z){}const j=(0,R.defaultWindowState)();return{mode:3,display:W?W.id:void 0,width:this.windowState.width||j.width,height:this.windowState.height||j.height,x:this.windowState.x||0,y:this.windowState.y||0}}const K=Object.create(null);let te;if(!I.isMacintosh&&this._win.isMaximized()?te=0:te=1,te===0?K.mode=0:K.mode=1,te===1||te===0){let W;te===1?W=this.getBounds():W=this._win.getNormalBounds(),K.x=W.x,K.y=W.y,K.width=W.width,K.height=W.height}return K}restoreWindowState(K){(0,i.mark)("code/willRestoreCodeWindowState");let te=!1;if(K)try{const W=p.screen.getAllDisplays();te=W.length>1,K=this.validateWindowState(K,W)}catch(W){this.logService.warn(`Unexpected error validating window state: ${W}
${W.stack}`)}return(0,i.mark)("code/didRestoreCodeWindowState"),[K||(0,R.defaultWindowState)(),te]}validateWindowState(K,te){if(this.logService.trace(`window#validateWindowState: validating window state on ${te.length} display(s)`,K),typeof K.x!="number"||typeof K.y!="number"||typeof K.width!="number"||typeof K.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(K.width<=0||K.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(te.length===1){const H=this.getWorkingArea(te[0]);if(H){let z=function(){!K||typeof K.x!="number"||typeof K.y!="number"||!H||(K.x<H.x&&(K.x=H.x),K.y<H.y&&(K.y=H.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",H),z(),K.width>H.width&&(K.width=H.width),K.height>H.height&&(K.height=H.height),K.x>H.x+H.width-128&&(K.x=H.x+H.width-K.width),K.y>H.y+H.height-128&&(K.y=H.y+H.height-K.height),z()}return K}if(K.display&&K.mode===3){const H=te.find(z=>z.id===K.display);if(H&&typeof H.bounds?.x=="number"&&typeof H.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const z=(0,R.defaultWindowState)(3);return z.x=H.bounds.x,z.y=H.bounds.y,z}}let W,j;try{W=p.screen.getDisplayMatching({x:K.x,y:K.y,width:K.width,height:K.height}),j=this.getWorkingArea(W)}catch(H){}if(W&&j&&K.x+K.width>j.x&&K.y+K.height>j.y&&K.x<j.x+j.width&&K.y<j.y+j.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",j),K}getWorkingArea(K){if(K.workArea.width>0&&K.workArea.height>0)return K.workArea;if(K.bounds.width>0&&K.bounds.height>0)return K.bounds}getBounds(){const[K,te]=this._win.getPosition(),[W,j]=this._win.getSize();return{x:K,y:te,width:W,height:j}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(K){this.useNativeFullScreen()?this.setNativeFullScreen(K):this.setSimpleFullScreen(K),this.sendWhenReady(K?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(K){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(K)}setSimpleFullScreen(K){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(K),this._win.webContents.focus()}useNativeFullScreen(){const K=this.configurationService.getValue("window");return!K||typeof K.nativeFullScreen!="boolean"||K.nativeTabs?!0:K.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let K=(0,D.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(K)<0&&(K="classic"),K}setMenuBarVisibility(K,te=!0){I.isMacintosh||(K==="toggle"&&te&&this.send("vscode:showInfoMessage",(0,y.localize)(10,null)),K==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(K)}):this.doSetMenuBarVisibility(K))}doSetMenuBarVisibility(K){const te=this.isFullScreen;switch(K){case"classic":this._win.setMenuBarVisibility(!te),this._win.autoHideMenuBar=te;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(I.isMacintosh)switch(p.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(K,te,...W){this.isReady?this.send(K,...W):this.ready().then(()=>{te.isCancellationRequested||this.send(K,...W)})}send(K,...te){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${K} for window that is destroyed`);return}this._win.webContents.send(K,...te)}}updateTouchBar(K){!I.isMacintosh||this.touchBarGroups.forEach((te,W)=>{const j=K[W];te.segments=this.createTouchBarGroupSegments(j)})}createTouchBar(){if(!!I.isMacintosh){for(let K=0;K<10;K++){const te=this.createTouchBarGroup();this.touchBarGroups.push(te)}this._win.setTouchBar(new p.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(K=[]){const te=this.createTouchBarGroupSegments(K),W=new p.TouchBar.TouchBarSegmentedControl({segments:te,mode:"buttons",segmentStyle:"automatic",change:j=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:W.segments[j].id,from:"touchbar"})}});return W}createTouchBarGroupSegments(K=[]){return K.map(W=>{let j;W.icon&&!m.ThemeIcon.isThemeIcon(W.icon)&&W.icon?.dark?.scheme===f.Schemas.file&&(j=p.nativeImage.createFromPath(P.URI.revive(W.icon.dark).fsPath),j.isEmpty()&&(j=void 0));let H;return typeof W.title=="string"?H=W.title:H=W.title.value,{id:W.id,label:j?void 0:H,icon:j}})}dispose(){super.dispose(),this._win=null}};ne=he([ie(1,t.ILogService),ie(2,v.IEnvironmentMainService),ie(3,a.IFileService),ie(4,s.IStorageMainService),ie(5,g.IConfigurationService),ie(6,S.IThemeMainService),ie(7,_.IWorkspacesManagementMainService),ie(8,d.IBackupMainService),ie(9,o.ITelemetryService),ie(10,b.IDialogMainService),ie(11,u.ILifecycleMainService),ie(12,l.IProductService),ie(13,r.IProtocolMainService)],ne),e.CodeWindow=ne}),define(Z[64],x([0,1,14,30,9,4,34,2,10,3,15,7,19,153,5,22,6,39,27,46]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d,g,b,v,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let a=class He extends n.Disposable{constructor(m,S,D,R){super();this.stateMainService=m,this.logService=S,this.workspacesManagementMainService=D,this.lifecycleMainService=R,this._onDidChangeRecentlyOpened=this._register(new M.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(m=>this.addRecentlyOpened([{workspace:m.workspace}])))}handleWindowsJumpList(){!w.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(m){const S=[],D=[];for(let R of m)if((0,c.isRecentWorkspace)(R))!this.workspacesManagementMainService.isUntitledWorkspace(R.workspace)&&l(S,R.workspace)===-1&&S.push(R);else if((0,c.isRecentFolder)(R))r(S,R.folderUri)===-1&&S.push(R);else{const T=s(D,R.fileUri)>=0,_=R.fileUri.scheme===f.Schemas.file&&He.COMMON_FILES_FILTER.indexOf((0,i.basename)(R.fileUri))>=0;!T&&!_&&(D.push(R),w.isWindows&&R.fileUri.scheme===f.Schemas.file&&p.app.addRecentDocument(R.fileUri.fsPath))}this.addEntriesFromStorage(S,D),S.length>He.MAX_TOTAL_RECENT_ENTRIES&&(S.length=He.MAX_TOTAL_RECENT_ENTRIES),D.length>He.MAX_TOTAL_RECENT_ENTRIES&&(D.length=He.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:S,files:D}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(m){const S=_=>{const G=t(_);for(const ne of m)if(i.extUriBiasedIgnorePathCase.isEqual(ne,G))return!1;return!0},D=this.getRecentlyOpened(),R=D.workspaces.filter(S),T=D.files.filter(S);(R.length!==D.workspaces.length||T.length!==D.files.length)&&(this.saveRecentlyOpened({files:T,workspaces:R}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!w.isMacintosh)return;p.app.clearRecentDocuments();const m=this.getRecentlyOpened(),S=[];let D=0;for(let T=0;T<m.workspaces.length&&D<He.MAX_MACOS_DOCK_RECENT_WORKSPACES;T++){const _=t(m.workspaces[T]);if(_.scheme===f.Schemas.file){const G=(0,i.originalFSPath)(_);await P.Promises.exists(G)&&(S.push(G),D++)}}const R=[];for(let T=0;T<m.files.length&&D<He.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;T++){const _=t(m.files[T]);if(_.scheme===f.Schemas.file){const G=(0,i.originalFSPath)(_);if(He.COMMON_FILES_FILTER.includes((0,i.basename)(_))||S.includes(G))continue;await P.Promises.exists(G)&&(R.push(G),D++)}}R.reverse().forEach(T=>p.app.addRecentDocument(T)),S.reverse().forEach(T=>p.app.addRecentDocument(T))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),p.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(m){const S=[],D=[],R=m?.config?.workspace;(0,c.isWorkspaceIdentifier)(R)&&!this.workspacesManagementMainService.isUntitledWorkspace(R)?S.push({workspace:R}):(0,c.isSingleFolderWorkspaceIdentifier)(R)&&S.push({folderUri:R.uri});const T=m?.config?.filesToOpenOrCreate;if(T)for(let _ of T){const G=_.fileUri;G&&s(D,G)===-1&&D.push({fileUri:G})}return this.addEntriesFromStorage(S,D),{workspaces:S,files:D}}addEntriesFromStorage(m,S){let D=this.getRecentlyOpenedFromStorage();for(let R of D.workspaces){let T=(0,c.isRecentFolder)(R)?r(m,R.folderUri):l(m,R.workspace);T>=0?m[T].label=m[T].label||R.label:m.push(R)}for(let R of D.files){let T=s(S,R.fileUri);T>=0?S[T].label=S[T].label||R.label:S.push(R)}}getRecentlyOpenedFromStorage(){const m=this.stateMainService.getItem(He.recentlyOpenedStorageKey);return(0,c.restoreRecentlyOpened)(m,this.logService)}saveRecentlyOpened(m){const S=(0,c.toStoreData)(m);this.stateMainService.setItem(He.recentlyOpenedStorageKey,S)}updateWindowsJumpList(){if(!w.isWindows)return;const m=[];if(m.push({type:"tasks",items:[{type:"task",title:(0,y.localize)(0,null),description:(0,y.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let S=[];for(let T of p.app.getJumpListSettings().removedItems){const _=T.args;if(_){const G=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(_);G&&S.push(I.URI.parse(G[2]))}}this.removeRecentlyOpened(S);let D=!1;const R=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(T=>{const _=(0,c.isRecentWorkspace)(T)?T.workspace:T.folderUri,{title:G,description:ne}=this.getWindowsJumpListLabel(_,T.label);let se;return I.URI.isUri(_)?se=`--folder-uri "${_.toString()}"`:(D=!0,se=`--file-uri "${_.configPath.toString()}"`),{type:"task",title:G.substr(0,255),description:ne.substr(0,255),program:process.execPath,args:se,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&m.push({type:"custom",name:D?(0,y.localize)(2,null):(0,y.localize)(3,null),items:R})}m.push({type:"recent"});try{p.app.setJumpList(m)}catch(S){this.logService.warn("updateWindowsJumpList#setJumpList",S)}}getWindowsJumpListLabel(m,S){if(S)return{title:(0,E.splitName)(S).name,description:S};if(I.URI.isUri(m))return{title:(0,i.basename)(m),description:u(m)};if(this.workspacesManagementMainService.isUntitledWorkspace(m))return{title:(0,y.localize)(4,null),description:""};let D=(0,i.basename)(m.configPath);return D.endsWith(c.WORKSPACE_EXTENSION)&&(D=D.substr(0,D.length-c.WORKSPACE_EXTENSION.length-1)),{title:(0,y.localize)(5,null,D),description:u(m.configPath)}}};a.MAX_TOTAL_RECENT_ENTRIES=100,a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a.recentlyOpenedStorageKey="openedPathsList",a=he([ie(0,v.IStateMainService),ie(1,b.ILogService),ie(2,h.IWorkspacesManagementMainService),ie(3,g.ILifecycleMainService)],a),e.WorkspacesHistoryMainService=a;function u(o){return o.scheme==="file"?(0,E.normalizeDriveLetter)(o.fsPath):o.toString()}function t(o){return(0,c.isRecentFolder)(o)?o.folderUri:(0,c.isRecentFile)(o)?o.fileUri:o.workspace.configPath}function l(o,m){return o.findIndex(S=>(0,c.isRecentWorkspace)(S)&&S.workspace.id===m.id)}function r(o,m){return o.findIndex(S=>(0,c.isRecentFolder)(S)&&i.extUriBiasedIgnorePathCase.isEqual(S.folderUri,m))}function s(o,m){return o.findIndex(S=>i.extUriBiasedIgnorePathCase.isEqual(S.fileUri,m))}}),define(Z[235],x([0,1,14,9,23,34,3,7,145,16,24,22,6,183,53,21,39,29,42,63,36,64]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d,g,b,v,c,h,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let l=class pt{constructor(o,m,S,D,R,T,_,G,ne,se,K){this.updateService=o,this.configurationService=m,this.windowsMainService=S,this.environmentMainService=D,this.telemetryService=R,this.workspacesHistoryMainService=T,this.stateMainService=_,this.lifecycleMainService=G,this.logService=ne,this.nativeHostMainService=se,this.productService=K,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(E.isMacintosh||(0,h.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateMainService.getItem(pt.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,_,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:_?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,_,G)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:_?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,_,G)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,_,G)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(G),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const m=this.productService.requestFeatureUrl;m&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(m,"openUserVoiceUrl"));const S=this.productService.reportIssueUrl;S&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(S,"openReportIssues"));const D=this.productService.licenseUrl;D&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(E.language){const T=D.indexOf("?")>0?"&":"?";this.openUrl(`${D}${T}lang=${E.language}`,"openLicenseUrl")}else this.openUrl(D,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&D&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!E.isMacintosh)return!1;let o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,m){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateMainService.setItem(pt.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!E.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!E.isMacintosh||(this.noActiveWindow=!p.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=p.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){p.Menu.setApplicationMenu(E.isMacintosh?new p.Menu:null);return}const m=new p.Menu;let S;if(E.isMacintosh){const R=new p.Menu;S=new p.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),m.append(S)}if(E.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new p.Menu;R.append(new p.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),p.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:R});this.setMenuById(R,"File"),m.append(T)}if(this.shouldDrawMenu("Edit")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),m.append(T)}if(this.shouldDrawMenu("Selection")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),m.append(T)}if(this.shouldDrawMenu("View")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:R});this.setMenuById(R,"View"),m.append(T)}if(this.shouldDrawMenu("Go")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),m.append(T)}if(this.shouldDrawMenu("Run")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),m.append(T)}if(this.shouldDrawMenu("Terminal")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),m.append(T)}let D;if(this.shouldDrawMenu("Window")){const R=new p.Menu;D=new p.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(D&&m.append(D),this.shouldDrawMenu("Help")){const R=new p.Menu,T=new p.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),m.append(T)}m.items&&m.items.length>0?p.Menu.setApplicationMenu(m):p.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const m=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),S=this.getUpdateMenuItems();let D;if(this.shouldDrawMenu("Preferences")){const te=new p.Menu;this.setMenuById(te,"Preferences"),D=new p.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:te})}const R=new p.Menu,T=new p.MenuItem({label:f.localize(12,null),role:"services",submenu:R}),_=new p.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),G=new p.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ne=new p.MenuItem({label:f.localize(15,null),role:"unhide"}),se=new p.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:()=>{const te=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!p.BrowserWindow.getFocusedWindow()||te?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),K=[m];K.push(...S),D&&K.push(r(),D),K.push(r(),T,r(),_,G,ne,r(),se),K.forEach(te=>o.append(te))}shouldDrawMenu(o){if(!E.isMacintosh&&(0,h.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(E.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(E.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,m){m.forEach(S=>{if((0,y.isMenubarMenuItemSeparator)(S))o.append(r());else if((0,y.isMenubarMenuItemSubmenu)(S)){const D=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(S.label),submenu:D});this.setMenu(D,S.submenu.items),o.append(R)}else(0,y.isMenubarMenuItemRecentAction)(S)?o.append(this.createOpenRecentMenuItem(S)):(0,y.isMenubarMenuItemAction)(S)&&(S.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),E.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[S.id]?o.append(new p.MenuItem(this.likeAction(S.id,{label:this.mnemonicLabel(S.label),click:this.fallbackMenuHandlers[S.id]}))):o.append(this.createMenuItem(S.label,S.id,!1,S.checked)):o.append(this.createMenuItem(S.label,S.id,S.enabled!==!1,!!S.checked)):o.append(this.createMenuItem(S.label,S.id,S.enabled!==!1,!!S.checked)))})}setMenuById(o,m){this.menubarMenus&&this.menubarMenus[m]&&this.setMenu(o,this.menubarMenus[m].items)}insertCheckForUpdatesItems(o){const m=this.getUpdateMenuItems();m.length&&(m.forEach(S=>o.append(S)),o.append(r()))}createOpenRecentMenuItem(o){const m=n.URI.revive(o.uri),S=o.id,D=S==="openRecentFile"?{fileUri:m}:S==="openRecentWorkspace"?{workspaceUri:m}:{folderUri:m};return new p.MenuItem(this.likeAction(S,{label:o.label,click:(R,T,_)=>{const G=this.isOptionClick(_);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[D],forceNewWindow:G,gotoLineMode:!1,remoteAuthority:o.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([m])}},!1))}isOptionClick(o){return!!(o&&(!E.isMacintosh&&(o.ctrlKey||o.shiftKey)||E.isMacintosh&&(o.metaKey||o.altKey)))}createRoleMenuItem(o,m,S){const D={label:this.mnemonicLabel(o),role:S,enabled:!0};return new p.MenuItem(this.withKeybinding(m,D))}setMacWindowMenu(o){const m=new p.MenuItem({label:f.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),S=new p.MenuItem({label:f.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),D=new p.MenuItem({label:f.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(f.localize(20,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(r()),T.push(this.createMenuItem(f.localize(21,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(f.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(f.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(f.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[m,S,r(),R,...T,r(),D].forEach(_=>o.append(_))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new p.MenuItem({label:f.localize(27,null),enabled:!1})];case"available for download":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new p.MenuItem({label:f.localize(29,null),enabled:!1})];case"downloaded":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new p.MenuItem({label:f.localize(31,null),enabled:!1})];case"ready":return[new p.MenuItem({label:this.mnemonicLabel(f.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,m,S,D){const R=this.mnemonicLabel(o),T=typeof m=="function"?m:(K,te,W)=>{const j=K?K.userSettingsLabel:null;let H=m;Array.isArray(m)&&(H=this.isOptionClick(W)?m[1]:m[0]),j&&W.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:j}):this.runActionInRenderer({type:"commandId",commandId:H})},_=typeof S=="boolean"?S:this.windowsMainService.getWindowCount()>0,G=typeof D=="boolean"?D:!1,ne={label:R,click:T,enabled:_};G&&(ne.type="checkbox",ne.checked=G);let se;return typeof m=="string"?se=m:Array.isArray(m)&&(se=m[0]),E.isMacintosh&&(se==="editor.action.clipboardCutAction"?ne.role="cut":se==="editor.action.clipboardCopyAction"?ne.role="copy":se==="editor.action.clipboardPasteAction"&&(ne.role="paste"),se==="undo"?ne.click=this.makeContextAwareClickHandler(T,{inDevTools:K=>K.undo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?ne.click=this.makeContextAwareClickHandler(T,{inDevTools:K=>K.redo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(ne.click=this.makeContextAwareClickHandler(T,{inDevTools:K=>K.selectAll(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("selectAll:")}))),new p.MenuItem(this.withKeybinding(se,ne))}makeContextAwareClickHandler(o,m){return(S,D,R)=>{const T=p.BrowserWindow.getFocusedWindow();if(!T)return m.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return m.inDevTools(T.webContents.devToolsWebContents);o(S,D||T,R)}}runActionInRenderer(o){let m=p.BrowserWindow.getFocusedWindow();if(!m){const D=this.windowsMainService.getLastActiveWindow();D?.isMinimized()&&(m=D.win)}const S=m?this.windowsMainService.getWindowById(m.id):void 0;if(S){if(this.logService.trace("menubar#runActionInRenderer",o),E.isMacintosh&&!this.environmentMainService.isBuilt&&!S.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const D={id:o.commandId,from:"menu"};S.sendWhenReady("vscode:runAction",k.CancellationToken.None,D)}else{const D={userSettingsLabel:o.userSettingsLabel};S.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,D)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,m){const S=typeof o=="string"?this.keybindings[o]:void 0;if(S?.label){if(S.isNative!==!1)m.accelerator=S.label,m.userSettingsLabel=S.userSettingsLabel;else if(typeof m.label=="string"){const D=m.label.indexOf("[");D>=0?m.label=`${m.label.substr(0,D)} [${S.label}]`:m.label=`${m.label} [${S.label}]`}}else m.accelerator=void 0;return m}likeAction(o,m,S=!m.accelerator){S&&(m=this.withKeybinding(o,m));const D=m.click;return m.click=(R,T,_)=>{this.reportMenuActionTelemetry(o),D&&D(R,T,_)},m}openUrl(o,m){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(m)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:t})}mnemonicLabel(o){return(0,M.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};l.lastKnownMenubarStorageKey="lastKnownMenubarData",l=he([ie(0,c.IUpdateService),ie(1,w.IConfigurationService),ie(2,a.IWindowsMainService),ie(3,i.IEnvironmentMainService),ie(4,v.ITelemetryService),ie(5,u.IWorkspacesHistoryMainService),ie(6,b.IStateMainService),ie(7,I.ILifecycleMainService),ie(8,P.ILogService),ie(9,d.INativeHostMainService),ie(10,g.IProductService)],l),e.Menubar=l;function r(){return new p.MenuItem({type:"separator"})}}),define(Z[236],x([0,1,5,22,6,235]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,p.createDecorator)("menubarMainService");let E=class{constructor(f,w,i){this.instantiationService=f,this.lifecycleMainService=w,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(M.Menubar)}async updateMenubar(f,w){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(w,f)}};E=he([ie(0,p.IInstantiationService),ie(1,L.ILifecycleMainService),ie(2,k.ILogService)],E),e.MenubarMainService=E}),define(Z[237],x([0,1,14,32,26,30,23,4,31,43,34,2,10,8,73,3,33,15,13,7,151,51,16,52,24,20,5,22,6,45,21,55,74,39,63,234,100,217,27,101,64,46]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d,g,b,v,c,h,a,u,t,l,r,s,o,m,S,D,R,T,_,G,ne,se,K,te,W,j,H,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function q(U){return(0,W.isWorkspaceIdentifier)(U?.workspace)}function O(U){return(0,W.isSingleFolderWorkspaceIdentifier)(U?.workspace)}let $=class Ze extends I.Disposable{constructor(A,F,B,Y,C,N,Q,J,re,le,ee,ae,ue,de,pe){super();this.machineId=A,this.initialUserEnv=F,this.logService=B,this.stateMainService=Y,this.environmentMainService=C,this.lifecycleMainService=N,this.backupMainService=Q,this.configurationService=J,this.workspacesHistoryMainService=re,this.workspacesManagementMainService=le,this.instantiationService=ee,this.dialogMainService=ae,this.fileService=ue,this.productService=de,this.protocolMainService=pe,this._onDidOpenWindow=this._register(new n.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new n.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new n.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new n.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new te.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const F=new I.DisposableStore;if(F.add(n.Event.any(A.onDidClose,A.onDidDestroy)(()=>F.dispose())),A.config.extensionDevelopmentPath)for(const B of A.config.extensionDevelopmentPath)F.add(this.protocolMainService.addValidFileRoot(h.URI.file(B)));A.config.extensionTestsPath&&F.add(this.protocolMainService.addValidFileRoot(h.URI.file(A.config.extensionTestsPath)))}}))}openEmptyWindow(A,F){let B=this.environmentMainService.args;const Y=F?.remoteAuthority||void 0,C=!0,N=F?.forceReuseWindow,Q=!N;return this.open({...A,cli:B,forceEmpty:C,forceNewWindow:Q,forceReuseWindow:N,remoteAuthority:Y})}openExistingWindow(A,F){A.focus(),this.handleWaitMarkerFile(F,[A])}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const F=[],B=[],Y=[],C=[],N=[];let Q,J=0;const re=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",re);for(const ue of re)O(ue)?A.addMode?F.push(ue):B.push(ue):q(ue)?Y.push(ue):ue.fileUri?(Q||(Q={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ue.remoteAuthority}),Q.filesToOpenOrCreate.push(ue)):ue.backupPath?N.push({backupFolder:(0,y.basename)(ue.backupPath),remoteAuthority:ue.remoteAuthority}):J++;A.diffMode&&Q&&Q.filesToOpenOrCreate.length>=2&&(Q.filesToDiff=Q.filesToOpenOrCreate.slice(0,2),Q.filesToOpenOrCreate=[]),Q&&A.waitMarkerFileURI&&(Q.filesToWait={paths:[...Q.filesToDiff,...Q.filesToOpenOrCreate],waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(C.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),Y.push(...C),N.push(...this.backupMainService.getEmptyWindowBackupPaths())):N.length=0;const{windows:le,filesOpenedInWindow:ee}=this.doOpen(A,Y,B,N,J,Q,F);if(this.logService.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${Y.length}, foldersToOpen: ${B.length}, emptyToRestore: ${N.length}, emptyToOpen: ${J})`),le.length>1)if(ee)ee.focus();else{const ue=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let de=!0,pe=!0;if(ue){const Ie=le.filter(we=>this.windowsStateHandler.state.lastActiveWindow&&we.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ie.length&&(Ie[0].focus(),de=!1,pe=!1)}if(de)for(let Ie=le.length-1;Ie>=0;Ie--){const we=le[Ie];if(!(we.openedWorkspace&&C.some(ge=>we.openedWorkspace&&ge.workspace.id===we.openedWorkspace.id)||we.backupPath&&N.some(ge=>we.backupPath&&ge.backupFolder===(0,y.basename)(we.backupPath)))){we.focus(),pe=!1;break}}pe&&le[le.length-1].focus()}const ae=Q&&Q.filesToDiff.length>0;if(!le.some(ue=>ue.isExtensionDevelopmentHost)&&!ae&&!A.noRecentEntry){const ue=[];for(const de of re)q(de)&&!de.transient?ue.push({label:de.label,workspace:de.workspace,remoteAuthority:de.remoteAuthority}):O(de)?ue.push({label:de.label,folderUri:de.workspace.uri,remoteAuthority:de.remoteAuthority}):de.fileUri&&ue.push({label:de.label,fileUri:de.fileUri,remoteAuthority:de.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ue)}return this.handleWaitMarkerFile(A,le),le}handleWaitMarkerFile(A,F){const B=A.waitMarkerFileURI;A.context===0&&B&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.fileService.del(B)}catch(Y){}})()}doOpen(A,F,B,Y,C,N,Q){const J=[];let re;function le(we,ge){J.push(we),ge&&(re=we,N=void 0)}let{openFolderInNewWindow:ee,openFilesInNewWindow:ae}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&Q.length>0){const we=Q[0].remoteAuthority,ge=this.getLastActiveWindowForAuthority(we);ge&&le(this.doAddFoldersToExistingWindow(ge,Q.map(Ee=>Ee.workspace.uri)))}const ue=B.length+F.length+Y.length;if(N&&ue===0){const we=N.filesToOpenOrCreate[0]||N.filesToDiff[0],ge=this.getWindows().filter(Me=>N&&Me.remoteAuthority===N.remoteAuthority);let Ee;we?.fileUri&&!ae&&((A.context===4||A.context===0||A.context===1)&&(Ee=(0,K.findWindowOnFile)(ge,we.fileUri,Me=>Me.configPath.scheme===P.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Me.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(ge))),Ee?(0,W.isWorkspaceIdentifier)(Ee.openedWorkspace)?F.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,W.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?B.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):le(this.doOpenFilesInExistingWindow(A,Ee,N),!0):le(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const de=(0,M.distinct)(F,we=>we.workspace.id);if(de.length>0){const we=(0,M.coalesce)(de.map(ge=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.configPath)));if(we.length>0){const ge=we[0],Ee=N?.remoteAuthority===ge.remoteAuthority?N:void 0;le(this.doOpenFilesInExistingWindow(A,ge,Ee),!!Ee),ee=!0}de.forEach(ge=>{if(we.some(Te=>Te.openedWorkspace&&Te.openedWorkspace.id===ge.workspace.id))return;const Ee=ge.remoteAuthority,Me=N?.remoteAuthority===Ee?N:void 0;le(this.doOpenFolderOrWorkspace(A,ge,ee,Me),!!Me),ee=!0})}const pe=(0,M.distinct)(B,we=>v.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(pe.length>0){const we=(0,M.coalesce)(pe.map(ge=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.uri)));if(we.length>0){const ge=we[0],Ee=N?.remoteAuthority===ge.remoteAuthority?N:void 0;le(this.doOpenFilesInExistingWindow(A,ge,Ee),!!Ee),ee=!0}pe.forEach(ge=>{if(we.some(Te=>(0,W.isSingleFolderWorkspaceIdentifier)(Te.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(Te.openedWorkspace.uri,ge.workspace.uri)))return;const Ee=ge.remoteAuthority,Me=N?.remoteAuthority===Ee?N:void 0;le(this.doOpenFolderOrWorkspace(A,ge,ee,Me),!!Me),ee=!0})}const Ie=(0,M.distinct)(Y,we=>we.backupFolder);if(Ie.length>0&&Ie.forEach(we=>{const ge=we.remoteAuthority,Ee=N?.remoteAuthority===ge?N:void 0;le(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:Ee,remoteAuthority:ge,forceNewWindow:!0,forceNewTabbedWindow:A.forceNewTabbedWindow,emptyWindowBackupInfo:we}),!!Ee),ee=!0}),J.length===0||N){N&&!C&&C++;const we=N?N.remoteAuthority:A.remoteAuthority;for(let ge=0;ge<C;ge++)le(this.doOpenEmpty(A,ee,we,N),!!N),ee=!0}return{windows:(0,M.distinct)(J),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(A,F,B){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),F.focus();const Y={filesToOpenOrCreate:B?.filesToOpenOrCreate,filesToDiff:B?.filesToDiff,filesToWait:B?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",E.CancellationToken.None,Y),F}doAddFoldersToExistingWindow(A,F){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),A.focus();const B={foldersToAdd:F};return A.sendWhenReady("vscode:addFolders",E.CancellationToken.None,B),A}doOpenEmpty(A,F,B,Y,C){return!F&&!C&&typeof A.contextWindowId=="number"&&(C=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:B,forceNewWindow:F,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:Y,windowToUse:C})}doOpenFolderOrWorkspace(A,F,B,Y,C){return!B&&!C&&typeof A.contextWindowId=="number"&&(C=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:F.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:B,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:Y,windowToUse:C})}getPathsToOpen(A){let F,B=!1,Y=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(F=this.doExtractPathsFromAPI(A),B=!0):A.forceEmpty?F=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(F=this.doExtractPathsFromCLI(A.cli),F.length===0&&F.push(Object.create(null)),B=!0):(F=this.doGetPathsFromLastSession(),F.length===0&&F.push(Object.create(null)),Y=!0),!A.addMode&&B){const C=F.filter(N=>O(N));if(C.length>1){const N=C[0].remoteAuthority;if(C.every(Q=>Q.remoteAuthority===N)){const Q=this.workspacesManagementMainService.createUntitledWorkspaceSync(C.map(J=>({uri:J.workspace.uri})));F.push({workspace:Q,remoteAuthority:N}),F=F.filter(J=>!O(J))}}}return A.initialStartup&&!Y&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&F.unshift(...this.doGetPathsFromLastSession().filter(C=>q(C)||O(C)||C.backupPath)),F}doExtractPathsFromAPI(A){const F=[],B={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const Y of(0,M.coalesce)(A.urisToOpen||[])){const C=this.resolveOpenable(Y,B);if(C)C.label=Y.label,F.push(C);else{const N=this.resourceFromOpenable(Y),Q={title:this.productService.nameLong,type:"info",buttons:[(0,i.mnemonicButtonLabel)((0,a.localize)(0,null))],defaultId:0,message:N.scheme===P.Schemas.file?(0,a.localize)(1,null):(0,a.localize)(2,null),detail:N.scheme===P.Schemas.file?(0,a.localize)(3,null,(0,i.getPathLabel)(N.fsPath,this.environmentMainService)):(0,a.localize)(4,null,N.toString()),noLink:!0};this.dialogMainService.showMessageBox(Q,(0,c.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return F}doExtractPathsFromCLI(A){const F=[],B={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:!1},Y=A["folder-uri"];if(Y)for(const Q of Y){const J=this.cliArgToUri(Q);if(J){const re=this.resolveOpenable({folderUri:J},B);re&&F.push(re)}}const C=A["file-uri"];if(C)for(const Q of C){const J=this.cliArgToUri(Q);if(J){const re=this.resolveOpenable((0,W.hasWorkspaceFileExtension)(Q)?{workspaceUri:J}:{fileUri:J},B);re&&F.push(re)}}const N=A._;for(const Q of N){const J=B.remoteAuthority?this.doResolvePathRemote(Q,B):this.doResolveFilePath(Q,B);J&&F.push(J)}return F}cliArgToUri(A){try{const F=h.URI.parse(A);if(!F.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return F}catch(F){this.logService.error(`Invalid URI input string: ${A}, ${F.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":const F=[];A!=="one"&&F.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&F.push(this.windowsStateHandler.state.lastActiveWindow);const B=[];for(const Y of F)if(Y.workspace){const C=this.resolveOpenable({workspaceUri:Y.workspace.configPath},{remoteAuthority:Y.remoteAuthority,rejectTransientWorkspaces:!0});q(C)&&B.push(C)}else if(Y.folderUri){const C=this.resolveOpenable({folderUri:Y.folderUri},{remoteAuthority:Y.remoteAuthority});O(C)&&B.push(C)}else A!=="folders"&&Y.backupPath&&B.push({backupPath:Y.backupPath,remoteAuthority:Y.remoteAuthority});return B}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,F=Object.create(null)){let B=this.resourceFromOpenable(A);return B.scheme===P.Schemas.file?((0,ne.isFileToOpen)(A)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(B.fsPath,F)):this.doResolveRemoteOpenable(A,F)}doResolveRemoteOpenable(A,F){let B=this.resourceFromOpenable(A);const Y=(0,_.getRemoteAuthority)(B)||F.remoteAuthority;if(B=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(B)),(0,ne.isFileToOpen)(A)){if(F.gotoLineMode){const{path:C,line:N,column:Q}=(0,f.parseLineAndColumnAware)(B.path);return{fileUri:B.with({path:C}),selection:N?{startLineNumber:N,startColumn:Q||1}:void 0,remoteAuthority:Y}}return{fileUri:B,remoteAuthority:Y}}else if((0,ne.isWorkspaceToOpen)(A))return{workspace:(0,j.getWorkspaceIdentifier)(B),remoteAuthority:Y};return{workspace:(0,j.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:Y}}resourceFromOpenable(A){return(0,ne.isWorkspaceToOpen)(A)?A.workspaceUri:(0,ne.isFolderToOpen)(A)?A.folderUri:A.fileUri}doResolveFilePath(A,F){let B,Y;F.gotoLineMode&&({path:A,line:B,column:Y}=(0,f.parseLineAndColumnAware)(A)),A=(0,f.sanitizeFilePath)((0,y.normalize)(A),(0,b.cwd)());try{const C=(0,L.statSync)(A);if(C.isFile()){if(!F.forceOpenWorkspaceAsFile){const N=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(A));if(N)return N.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:N.id,configPath:N.configPath},remoteAuthority:N.remoteAuthority,exists:!0,transient:N.transient}}return{fileUri:h.URI.file(A),selection:B?{startLineNumber:B,startColumn:Y||1}:void 0,exists:!0}}else if(C.isDirectory())return{workspace:(0,j.getSingleFolderWorkspaceIdentifier)(h.URI.file(A),C),exists:!0}}catch(C){const N=h.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([N]),F.ignoreFileNotFound)return{fileUri:N,exists:!1}}}doResolvePathRemote(A,F){const B=A.charCodeAt(0),Y=F.remoteAuthority;let C,N;F.gotoLineMode&&({path:A,line:C,column:N}=(0,f.parseLineAndColumnAware)(A)),B!==47&&((0,f.isWindowsDriveLetter)(B)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,f.toSlashes)(A)),A=`/${A}`);const Q=h.URI.from({scheme:P.Schemas.vscodeRemote,authority:Y,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,W.hasWorkspaceFileExtension)(A))return F.forceOpenWorkspaceAsFile?{fileUri:Q,selection:C?{startLineNumber:C,startColumn:N||1}:void 0,remoteAuthority:F.remoteAuthority}:{workspace:(0,j.getWorkspaceIdentifier)(Q),remoteAuthority:Y};if(F.gotoLineMode||y.posix.basename(A).indexOf(".")!==-1)return{fileUri:Q,selection:C?{startLineNumber:C,startColumn:N||1}:void 0,remoteAuthority:Y}}return{workspace:(0,j.getSingleFolderWorkspaceIdentifier)(Q),remoteAuthority:Y}}shouldOpenNewWindow(A){const F=this.configurationService.getValue("window"),B=F?.openFoldersInNewWindow||"default",Y=F?.openFilesInNewWindow||"off";let C=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(B==="on"||B==="off")&&(C=B==="on");let N=!1;return A.forceNewWindow||A.forceReuseWindow?N=!!A.forceNewWindow&&!A.forceReuseWindow:(g.isMacintosh?A.context===1&&(N=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!A.cli.extensionDevelopmentPath&&(Y==="on"||Y==="off")&&(N=Y==="on")),{openFolderInNewWindow:!!C,openFilesInNewWindow:N}}openExtensionDevelopmentHostWindow(A,F){const B=(0,K.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(B)return this.lifecycleMainService.reload(B,F.cli),B.focus(),[B];let Y=F.cli["folder-uri"]||[],C=F.cli["file-uri"]||[],N=F.cli._;if(!N.length&&!Y.length&&!C.length&&!F.cli.extensionTestsPath){const le=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ee=le&&(le.workspace||le.folderUri);ee&&(h.URI.isUri(ee)?ee.scheme===P.Schemas.file?N=[ee.fsPath]:Y=[ee.toString()]:ee.configPath.scheme===P.Schemas.file?N=[(0,v.originalFSPath)(ee.configPath)]:C=[ee.configPath.toString()])}let Q=F.remoteAuthority;for(const le of A)if(le.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ee=h.URI.parse(le),ae=(0,_.getRemoteAuthority)(ee);ae&&(Q?ae!==Q&&this.logService.error("more than one extension development path authority"):Q=ae)}N=N.filter(le=>{const ee=h.URI.file(le);return(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ee)?!1:(0,_.getRemoteAuthority)(ee)===Q}),Y=Y.filter(le=>{const ee=this.cliArgToUri(le);return ee&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ee)?!1:ee?(0,_.getRemoteAuthority)(ee)===Q:!1}),C=C.filter(le=>{const ee=this.cliArgToUri(le);return ee&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ee)?!1:ee?(0,_.getRemoteAuthority)(ee)===Q:!1}),F.cli._=N,F.cli["folder-uri"]=Y,F.cli["file-uri"]=C;const J=!N.length&&!Y.length&&!C.length,re={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:J,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:Q};return this.open(re)}openInBrowserWindow(A){const F=this.configurationService.getValue("window"),B={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,y.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:D.default,isInitialStartup:A.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof F?.zoomLevel=="number"?F.zoomLevel:void 0,enableLegacyRecursiveWatcher:this.configurationService.getValue("files.legacyWatcher"),autoDetectHighContrast:F?.autoDetectHighContrast??!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}};let Y;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&(Y=A.windowToUse||this.getLastActiveWindow(),Y&&Y.focus()),Y){const C=Y.config;!B.extensionDevelopmentPath&&C&&!!C.extensionDevelopmentPath&&(B.extensionDevelopmentPath=C.extensionDevelopmentPath,B.verbose=C.verbose,B["inspect-brk-extensions"]=C["inspect-brk-extensions"],B.debugId=C.debugId,B["inspect-extensions"]=C["inspect-extensions"],B["extensions-dir"]=C["extensions-dir"])}else{const C=this.windowsStateHandler.getNewWindowState(B);(0,d.mark)("code/willCreateCodeWindow");const N=Y=this.instantiationService.createInstance(se.CodeWindow,{state:C,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});if((0,d.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow){const J=this.getLastActiveWindow();J&&J.addTabbedWindow(N)}Ze.WINDOWS.push(N),this._onDidOpenWindow.fire(N),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(N.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(N)),(0,w.once)(N.onDidClose)(()=>this.onWindowClosed(N)),(0,w.once)(N.onDidDestroy)(()=>this._onDidDestroyWindow.fire(N));const Q=(0,c.assertIsDefined)(N.win?.webContents);Q.removeAllListeners("devtools-reload-page"),Q.on("devtools-reload-page",()=>this.lifecycleMainService.reload(N)),this.lifecycleMainService.registerWindow(N)}return B.windowId=Y.id,Y.isReady?this.lifecycleMainService.unload(Y,4).then(C=>{C||this.doOpenInBrowserWindow(Y,B,A)}):this.doOpenInBrowserWindow(Y,B,A),Y}doOpenInBrowserWindow(A,F,B){if(!F.extensionDevelopmentPath)if((0,W.isWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:F.workspace,remoteAuthority:F.remoteAuthority});else if((0,W.isSingleFolderWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerFolderBackupSync(F.workspace.uri);else{const Y=B.emptyWindowBackupInfo&&B.emptyWindowBackupInfo.backupFolder;F.backupPath=this.backupMainService.registerEmptyWindowBackupSync(Y,F.remoteAuthority)}A.load(F)}onWindowClosed(A){const F=Ze.WINDOWS.indexOf(A);Ze.WINDOWS.splice(F,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=p.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(F=>F.remoteAuthority===A))}doGetLastActiveWindow(A){const F=Math.max.apply(Math,A.map(B=>B.lastFocusTime));return A.find(B=>B.lastFocusTime===F)}sendToFocused(A,...F){const B=this.getFocusedWindow()||this.getLastActiveWindow();B&&B.sendWhenReady(A,E.CancellationToken.None,...F)}sendToAll(A,F,B){for(const Y of this.getWindows())B&&B.indexOf(Y.id)>=0||Y.sendWhenReady(A,E.CancellationToken.None,F)}getWindows(){return Ze.WINDOWS}getWindowCount(){return Ze.WINDOWS.length}getWindowById(A){const F=this.getWindows().filter(B=>B.id===A);return(0,M.firstOrDefault)(F)}getWindowByWebContents(A){const F=p.BrowserWindow.fromWebContents(A);if(!!F)return this.getWindowById(F.id)}};$.WINDOWS=[],$=he([ie(2,S.ILogService),ie(3,G.IStateMainService),ie(4,r.IEnvironmentMainService),ie(5,m.ILifecycleMainService),ie(6,u.IBackupMainService),ie(7,t.IConfigurationService),ie(8,H.IWorkspacesHistoryMainService),ie(9,z.IWorkspacesManagementMainService),ie(10,o.IInstantiationService),ie(11,l.IDialogMainService),ie(12,s.IFileService),ie(13,R.IProductService),ie(14,T.IProtocolMainService)],$),e.WindowsMainService=$}),define(Z[238],x([0,1,51,36,64,46]),function(V,e,p,L,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let E=class{constructor(f,w,i,I){this.workspacesManagementMainService=f,this.windowsMainService=w,this.workspacesHistoryMainService=i,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,w){const i=this.windowsMainService.getWindowById(f);if(i)return this.workspacesManagementMainService.enterWorkspace(i,this.windowsMainService.getWindows(),w)}createUntitledWorkspace(f,w,i){return this.workspacesManagementMainService.createUntitledWorkspace(w,i)}deleteUntitledWorkspace(f,w){return this.workspacesManagementMainService.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(f,w){return this.workspacesManagementMainService.getWorkspaceIdentifier(w)}async getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}async addRecentlyOpened(f,w){return this.workspacesHistoryMainService.addRecentlyOpened(w)}async removeRecentlyOpened(f,w){return this.workspacesHistoryMainService.removeRecentlyOpened(w)}async clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};E=he([ie(0,M.IWorkspacesManagementMainService),ie(1,L.IWindowsMainService),ie(2,k.IWorkspacesHistoryMainService),ie(3,p.IBackupMainService)],E),e.WorkspacesMainService=E}),define(Z[239],x([0,1,14,32,26,18,60,17,31,43,40,34,2,10,8,3,15,13,7,28,68,119,35,122,85,230,131,51,221,16,179,158,71,52,220,89,24,54,91,170,186,90,173,20,70,5,72,231,197,102,22,6,181,236,53,21,74,226,75,39,215,99,198,29,200,202,61,42,206,228,232,229,233,98,207,208,209,210,212,36,237,213,27,64,238,46]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d,g,b,v,c,h,a,u,t,l,r,s,o,m,S,D,R,T,_,G,ne,se,K,te,W,j,H,z,q,O,$,U,A,F,B,Y,C,N,Q,J,re,le,ee,ae,ue,de,pe,Ie,we,ge,Ee,Me,Te,We,Ne,Xe,Be,ut,st,xe,Ge,ht,ot,X,oe,ce,me,be,ke,Fe,_e,ze){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ue=class extends P.Disposable{constructor(fe,ye,Se,ve,Pe,Le,De,Re,Ae,je){super();this.mainProcessNodeIpcServer=fe,this.userEnv=ye,this.mainInstantiationService=Se,this.logService=ve,this.environmentMainService=Pe,this.lifecycleMainService=Le,this.configurationService=De,this.stateMainService=Re,this.fileService=Ae,this.productService=je,this.configureSession(),this.registerListeners()}configureSession(){const fe=ve=>ve?.startsWith(`${y.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);p.session.defaultSession.setPermissionRequestHandler((ve,Pe,Le,De)=>fe(De.requestingUrl)?Le(ye.has(Pe)):Le(!1)),p.session.defaultSession.setPermissionCheckHandler((ve,Pe,Le,De)=>fe(De.requestingUrl)?ye.has(Pe):!1);const Se=p.session.defaultSession;typeof Se.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Se.setCodeCachePath((0,d.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,n.setUnexpectedErrorHandler)(Se=>this.onUnexpectedError(Se)),process.on("uncaughtException",Se=>(0,n.onUnexpectedError)(Se)),process.on("unhandledRejection",Se=>(0,n.onUnexpectedError)(Se)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,u.registerContextMenuListener)(),p.app.on("accessibility-support-changed",(Se,ve)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ve)}),p.app.on("activate",(Se,ve)=>{this.logService.trace("app#activate"),ve||this.windowsMainService?.openEmptyWindow({context:1})}),p.app.on("web-contents-created",(Se,ve)=>{ve.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),ve.setWindowOpenHandler(({url:Pe})=>(this.nativeHostMainService?.openExternal(void 0,Pe),{action:"deny"}))});let fe=[],ye;p.app.on("open-file",(Se,ve)=>{this.logService.trace("app#open-file: ",ve),Se.preventDefault(),fe.push(this.getWindowOpenableFromPathSync(ve)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:fe,gotoLineMode:!1,preferNewWindow:!0}),fe=[],ye=void 0},100)}),p.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),p.ipcMain.handle("vscode:fetchShellEnv",Se=>{const ve=this.windowsMainService?.getWindowByWebContents(Se.sender);let Pe,Le;return ve?.config?(Pe=ve.config,Le={...process.env,...ve.config.userEnv}):(Pe=this.environmentMainService.args,Le=process.env),this.resolveShellEnvironment(Pe,Le)}),p.ipcMain.handle("vscode:writeNlsFile",(Se,ve,Pe)=>{const Le=this.validateNlsPath([ve]);if(!Le||typeof Pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Le,M.VSBuffer.fromString(Pe))}),p.ipcMain.handle("vscode:readNlsFile",async(Se,...ve)=>{const Pe=this.validateNlsPath(ve);if(!Pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Pe)).value.toString()}),p.ipcMain.on("vscode:toggleDevTools",Se=>Se.sender.toggleDevTools()),p.ipcMain.on("vscode:openDevTools",Se=>Se.sender.openDevTools()),p.ipcMain.on("vscode:reloadWindow",Se=>Se.sender.reload())}validateNlsPath(fe){let ye;for(const Se of fe)typeof Se=="string"&&(typeof ye!="string"?ye=Se:ye=(0,d.join)(ye,Se));if(!(typeof ye!="string"||!(0,d.isAbsolute)(ye)||!(0,f.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!g.isLinux)))return c.URI.file(ye)}onUnexpectedError(fe){if(fe){const ye={message:`[uncaught exception in main]: ${fe.message}`,stack:fe.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${fe}`),fe.stack&&this.logService.error(fe.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const fe=this.productService.win32AppUserModelId;g.isWindows&&fe&&p.app.setAppUserModelId(fe);try{g.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!p.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&p.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ae){this.logService.error(Ae)}const ye=new l.Server;this.logService.trace("Resolving machine identifier...");const Se=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Se}`);const{sharedProcess:ve,sharedProcessReady:Pe,sharedProcessClient:Le}=this.setupSharedProcess(Se),De=await this.initServices(Se,ve,Pe);if(this.environmentMainService.driverHandle){const Ae=await(0,ne.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,De);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Ae)}this._register(De.createInstance(s.ProxyAuthHandler)),De.invokeFunction(Ae=>this.initChannels(Ae,ye,Le));const Re=De.invokeFunction(Ae=>this.openFirstWindow(Ae,ye));De.invokeFunction(Ae=>this.afterWindowOpen(Ae,ve)),this.environmentMainService.args.trace&&De.invokeFunction(Ae=>this.stopTracingEventually(Ae,Re))}async resolveMachineId(){let fe=this.stateMainService.getItem(ge.machineIdKey);return(!fe||g.isMacintosh&&fe==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(fe=await(0,a.getMachineId)(),this.stateMainService.setItem(ge.machineIdKey,fe)),fe}setupSharedProcess(fe){const ye=this._register(this.mainInstantiationService.createInstance(ae.SharedProcess,fe,this.userEnv)),Se=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Pe=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new r.Client(Pe,"main")})(),ve=(async()=>(await ye.whenReady(),Se))();return{sharedProcess:ye,sharedProcessReady:ve,sharedProcessClient:Se}}async initServices(fe,ye,Se){const ve=new A.ServiceCollection;switch(process.platform){case"win32":ve.set(We.IUpdateService,new $.SyncDescriptor(st.Win32UpdateService));break;case"linux":g.isLinuxSnap?ve.set(We.IUpdateService,new $.SyncDescriptor(ut.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ve.set(We.IUpdateService,new $.SyncDescriptor(Be.LinuxUpdateService));break;case"darwin":ve.set(We.IUpdateService,new $.SyncDescriptor(Xe.DarwinUpdateService));break}ve.set(ce.IWindowsMainService,new $.SyncDescriptor(me.WindowsMainService,[fe,this.userEnv])),ve.set(G.IDialogMainService,new $.SyncDescriptor(G.DialogMainService)),ve.set(Y.ILaunchMainService,new $.SyncDescriptor(Y.LaunchMainService)),ve.set(_.IDiagnosticsService,t.ProxyChannel.toService((0,t.getDelayedChannel)(Se.then(Le=>Le.getChannel("diagnostics"))))),ve.set(F.IIssueMainService,new $.SyncDescriptor(F.IssueMainService,[this.userEnv])),ve.set(se.IEncryptionMainService,new $.SyncDescriptor(se.EncryptionMainService,[fe])),ve.set(B.IKeyboardLayoutMainService,new $.SyncDescriptor(B.KeyboardLayoutMainService)),ve.set(re.INativeHostMainService,new $.SyncDescriptor(re.NativeHostMainService,[ye])),ve.set(X.IWebviewManagerService,new $.SyncDescriptor(oe.WebviewMainService)),ve.set(ke.IWorkspacesService,new $.SyncDescriptor(_e.WorkspacesMainService)),ve.set(ze.IWorkspacesManagementMainService,new $.SyncDescriptor(ze.WorkspacesManagementMainService)),ve.set(Fe.IWorkspacesHistoryMainService,new $.SyncDescriptor(Fe.WorkspacesHistoryMainService)),ve.set(J.IMenubarMainService,new $.SyncDescriptor(J.MenubarMainService)),ve.set(j.IExtensionUrlTrustService,new $.SyncDescriptor(H.ExtensionUrlTrustService)),ve.set(Ie.IStorageMainService,new $.SyncDescriptor(Ie.StorageMainService)),g.isWindows?ve.set(z.IExternalTerminalMainService,new $.SyncDescriptor(q.WindowsExternalTerminalService)):g.isMacintosh?ve.set(z.IExternalTerminalMainService,new $.SyncDescriptor(q.MacExternalTerminalService)):g.isLinux&&ve.set(z.IExternalTerminalMainService,new $.SyncDescriptor(q.LinuxExternalTerminalService));const Pe=new S.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ve.set(m.IBackupMainService,Pe),ve.set(xe.IURLService,new $.SyncDescriptor(ht.NativeURLService)),(0,Te.supportsTelemetry)(this.productService,this.environmentMainService)){const Le=(0,t.getDelayedChannel)(Se.then(Ye=>Ye.getChannel("telemetryAppender"))),De=new Ee.TelemetryAppenderClient(Le),Re=(0,we.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,fe,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ae=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],je={appenders:[De],commonProperties:Re,piiPaths:Ae,sendErrorTelemetry:!0};ve.set(ge.ITelemetryService,new $.SyncDescriptor(Me.TelemetryService,[je]))}else ve.set(ge.ITelemetryService,Te.NullTelemetryService);return await Pe.initialize(),this.mainInstantiationService.createChild(ve)}initChannels(fe,ye,Se){const ve=t.ProxyChannel.fromService(fe.get(Y.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ve),ye.registerChannel(R.UserConfigurationFileServiceId,t.ProxyChannel.fromService(new R.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const Pe=new Ne.UpdateChannel(fe.get(We.IUpdateService));ye.registerChannel("update",Pe);const Le=t.ProxyChannel.fromService(fe.get(F.IIssueMainService));ye.registerChannel("issue",Le);const De=t.ProxyChannel.fromService(fe.get(se.IEncryptionMainService));ye.registerChannel("encryption",De);const Re=t.ProxyChannel.fromService(fe.get(ue.ISignService));ye.registerChannel("sign",Re);const Ae=t.ProxyChannel.fromService(fe.get(B.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",Ae),this.nativeHostMainService=fe.get(re.INativeHostMainService);const je=t.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",je),Se.then($e=>$e.registerChannel("nativeHost",je));const Ye=t.ProxyChannel.fromService(fe.get(ke.IWorkspacesService));ye.registerChannel("workspaces",Ye);const et=t.ProxyChannel.fromService(fe.get(J.IMenubarMainService));ye.registerChannel("menubar",et);const tt=t.ProxyChannel.fromService(fe.get(xe.IURLService));ye.registerChannel("url",tt);const dt=t.ProxyChannel.fromService(fe.get(j.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",dt);const Ce=t.ProxyChannel.fromService(fe.get(X.IWebviewManagerService));ye.registerChannel("webview",Ce);const it=this._register(new pe.StorageDatabaseChannel(this.logService,fe.get(Ie.IStorageMainService)));ye.registerChannel("storage",it),Se.then($e=>$e.registerChannel("storage",it));const nt=t.ProxyChannel.fromService(fe.get(z.IExternalTerminalMainService));ye.registerChannel("externalTerminal",nt);const Qe=new Q.LogLevelChannel(fe.get(N.ILogService));ye.registerChannel("logLevel",Qe),Se.then($e=>$e.registerChannel("logLevel",Qe));const rt=new Q.LoggerChannel(fe.get(N.ILoggerService));ye.registerChannel("logger",rt),Se.then($e=>$e.registerChannel("logger",rt));const at=new T.ElectronExtensionHostDebugBroadcastChannel(fe.get(ce.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",at)}openFirstWindow(fe,ye){const Se=this.windowsMainService=fe.get(ce.IWindowsMainService),ve=fe.get(xe.IURLService),Pe=fe.get(re.INativeHostMainService);this.lifecycleMainService.phase=2;const Le=[],De=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Oe=>{try{return{uri:c.URI.parse(Oe),url:Oe}}catch{return}}).filter(Oe=>{if(!Oe||this.shouldBlockURI(Oe.uri))return!1;const Je=this.getWindowOpenableFromProtocolLink(Oe.uri);return Je?(Le.push(Je),!1):!0}),Re=this,Ae=this.environmentMainService,je=this.productService;ve.registerHandler({async handleURL(Oe,Je){if(Oe.scheme===je.urlProtocol&&Oe.path==="workspace"&&(Oe=Oe.with({authority:"file",path:c.URI.parse(Oe.query).path,query:""})),Re.shouldBlockURI(Oe))return!0;const yt=Re.getWindowOpenableFromProtocolLink(Oe);if(yt){const[gt]=Se.open({context:5,cli:{...Ae.args},urisToOpen:[yt],gotoLineMode:!0});return gt.focus(),!0}if(g.isMacintosh&&Se.getWindowCount()===0){const[gt]=Se.open({context:5,cli:{...Ae.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ee.getRemoteAuthority)(Oe)});return await gt.ready(),ve.open(Oe,Je)}return!1}});const Ye=this._register(new be.ActiveWindowManager({onDidOpenWindow:Pe.onDidOpenWindow,onDidFocusWindow:Pe.onDidFocusWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),et=new t.StaticRouter(Oe=>Ye.getActiveClientId().then(Je=>Oe===Je)),tt=new Ge.URLHandlerRouter(et),dt=ye.getChannel("urlHandler",tt);ve.registerHandler(new Ge.URLHandlerChannelClient(dt)),this._register(new ot.ElectronURLListener(De,ve,Se,this.environmentMainService,this.productService));const Ce=this.environmentMainService.args,it=global.macOpenFiles,nt=(0,te.isLaunchedFromCli)(process.env)?0:4,Qe=Ce._.length,rt=!!Ce["folder-uri"],at=!!Ce["file-uri"],$e=Ce["skip-add-to-recently-opened"]===!0,ft=Ce.wait&&Ce.waitMarkerFilePath?c.URI.file(Ce.waitMarkerFilePath):void 0,vt=Ce.remote||void 0;return Le.length>0?Se.open({context:nt,cli:Ce,urisToOpen:Le,gotoLineMode:!0,initialStartup:!0}):Ce["new-window"]&&!Qe&&!rt&&!at?Se.open({context:nt,cli:Ce,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:$e,waitMarkerFileURI:ft,initialStartup:!0,remoteAuthority:vt}):it.length&&!Qe&&!rt&&!at?Se.open({context:1,cli:Ce,urisToOpen:it.map(Oe=>this.getWindowOpenableFromPathSync(Oe)),noRecentEntry:$e,waitMarkerFileURI:ft,initialStartup:!0}):Se.open({context:nt,cli:Ce,forceNewWindow:Ce["new-window"]||!Qe&&Ce["unity-launch"],diffMode:Ce.diff,noRecentEntry:$e,waitMarkerFileURI:ft,gotoLineMode:Ce.goto,initialStartup:!0,remoteAuthority:vt})}shouldBlockURI(fe){return!!(fe.authority===y.Schemas.file&&g.isWindows&&p.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,I.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,I.getPathLabel)(fe.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(fe){if(!!fe.path){if(fe.authority===y.Schemas.file){const ye=c.URI.file(fe.fsPath);return(0,ke.hasWorkspaceFileExtension)(ye)?{workspaceUri:ye}:{fileUri:ye}}else if(fe.authority===y.Schemas.vscodeRemote){const ye=fe.path.indexOf(d.posix.sep,1);if(ye!==-1){const Se=fe.path.substring(1,ye),ve=fe.path.substring(ye),Pe=c.URI.from({scheme:y.Schemas.vscodeRemote,authority:Se,path:ve,query:fe.query,fragment:fe.fragment});return(0,ke.hasWorkspaceFileExtension)(ve)?{workspaceUri:Pe}:/:[\d]+$/.test(ve)?{fileUri:Pe}:{folderUri:Pe}}}}}getWindowOpenableFromPathSync(fe){try{if((0,L.statSync)(fe).isDirectory())return{folderUri:c.URI.file(fe)};if((0,ke.hasWorkspaceFileExtension)(fe))return{workspaceUri:c.URI.file(fe)}}catch(ye){}return{fileUri:c.URI.file(fe)}}async afterWindowOpen(fe,ye){this.lifecycleMainService.phase=3;let Se=!1;(0,w.once)(this.lifecycleMainService.onWillShutdown)(()=>Se=!0);const ve=fe.get(ge.ITelemetryService);this._register(ye.onDidError(({type:De,details:Re})=>{let Ae;switch(De){case 1:Ae="SharedProcess: detected unresponsive window";break;case 2:Ae=`SharedProcess: crashed (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break;case 3:Ae=`SharedProcess: failed to load (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break}(0,n.onUnexpectedError)(new Error(Ae)),ve.publicLog2("sharedprocesserror",{type:De,reason:Re?.reason,code:Re?.exitCode,visible:ye.isVisible(),shuttingdown:Se})}));const Pe=this.productService.win32MutexName;if(g.isWindows&&Pe)try{const De=V.__$__nodeRequire("windows-mutex").Mutex,Re=new De(Pe);(0,w.once)(this.lifecycleMainService.onWillShutdown)(()=>Re.release())}catch(De){this.logService.error(De)}p.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(De,Re)=>{Re({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})});const Le=fe.get(We.IUpdateService);(Le instanceof st.Win32UpdateService||Le instanceof Be.LinuxUpdateService||Le instanceof Xe.DarwinUpdateService)&&Le.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env);try{const Re=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,i.stripComments)(Re))["enable-crash-reporter"]===void 0){const Ye=(0,Te.getTelemetryLevel)(this.configurationService)>=1,et=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ye},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,h.generateUuid)()}"`,"}"],tt=Re.substring(0,Re.length-2).concat(`,
`,et.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(tt))}}catch(De){this.logService.error(De)}}async resolveShellEnvironment(fe,ye){try{return await(0,W.resolveShellEnv)(this.logService,fe,ye)}catch(Se){this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",(0,E.toErrorMessage)(Se))}return{}}stopTracingEventually(fe,ye){this.logService.info("Tracing: waiting for windows to get ready...");const Se=fe.get(G.IDialogMainService);let ve=!1;const Pe=async De=>{if(ve)return;ve=!0;const Re=await p.contentTracing.stopRecording((0,b.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);De?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Re}`):Se.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,Re),buttons:[(0,I.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,v.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))},Le=setTimeout(()=>Pe(!0),3e4);Promise.all(ye.map(De=>De.ready())).then(()=>{clearTimeout(Le),Pe(!1)})}};Ue=he([ie(2,U.IInstantiationService),ie(3,N.ILogService),ie(4,K.IEnvironmentMainService),ie(5,C.ILifecycleMainService),ie(6,D.IConfigurationService),ie(7,de.IStateMainService),ie(8,O.IFileService),ie(9,le.IProductService)],Ue),e.CodeApplication=Ue}),define(Z[243],x([0,1,14,32,30,9,60,17,31,43,34,10,8,73,3,33,25,19,35,56,239,11,16,190,199,24,54,162,20,184,185,70,175,72,22,93,6,182,94,45,21,55,187,96,223,50,225,75,196,39,227,61,62,205]),function(V,e,p,L,k,M,E,n,f,w,i,I,P,y,d,g,b,v,c,h,a,u,t,l,r,s,o,m,S,D,R,T,_,G,ne,se,K,te,W,j,H,z,q,O,$,U,A,F,B,Y,C,N,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class J{main(){try{this.startup()}catch(ee){console.error(ee.message),p.app.exit(1)}}async startup(){(0,n.setUnexpectedErrorHandler)(ge=>console.error(ge));const[ee,ae,ue,de,pe,Ie,we]=this.createServices();try{try{await this.initServices(ue,de,pe)}catch(ge){throw this.handleStartupDataDirError(ue,we.nameLong,ge),ge}await ee.invokeFunction(async ge=>{const Ee=ge.get(K.ILogService),Me=ge.get(ne.ILifecycleMainService),Te=ge.get(S.IFileService),We=await this.claimInstance(Ee,ue,Me,ee,we,!0);return v.Promises.writeFile(ue.mainLockfile,String(process.pid)).catch(Ne=>{Ee.warn(`Error writing main lockfile: ${Ne.stack}`)}),Ie.logger=new W.SpdLogLogger("main",(0,P.join)(ue.logsPath,"main.log"),!0,Ie.getLevel()),(0,w.once)(Me.onWillShutdown)(Ne=>{Te.dispose(),de.dispose(),Ne.join(v.Promises.unlink(ue.mainLockfile).catch(()=>{}))}),ee.createInstance(a.CodeApplication,We,ae).startup()})}catch(ge){ee.invokeFunction(this.quit,ge)}}createServices(){const ee=new G.ServiceCollection,ae={_serviceBrand:void 0,...j.default};ee.set(H.IProductService,ae);const ue=new s.EnvironmentMainService(this.resolveArgs(),ae),de=this.patchEnvironment(ue);ee.set(s.IEnvironmentMainService,ue);const pe=new se.BufferLogService,Ie=new K.MultiplexLogService([new K.ConsoleMainLogger((0,K.getLogLevel)(ue)),pe]);process.once("exit",()=>Ie.dispose()),ee.set(K.ILogService,Ie);const we=new D.FileService(Ie);ee.set(S.IFileService,we);const ge=new R.DiskFileSystemProvider(Ie);we.registerProvider(I.Schemas.file,ge),ee.set(K.ILoggerService,new te.LoggerService(Ie,we));const Ee=new l.ConfigurationService(ue.settingsResource,we);ee.set(t.IConfigurationService,Ee),ee.set(ne.ILifecycleMainService,new T.SyncDescriptor(ne.LifecycleMainService));const Me=new C.StateMainService(ue,Ie,we);return ee.set(Y.IStateMainService,Me),ee.set(U.IRequestService,new T.SyncDescriptor(A.RequestMainService)),ee.set(Q.IThemeMainService,new T.SyncDescriptor(Q.ThemeMainService)),ee.set(F.ISignService,new T.SyncDescriptor(B.SignService)),ee.set(O.ITunnelService,new T.SyncDescriptor($.TunnelService)),ee.set(z.IProtocolMainService,new T.SyncDescriptor(q.ProtocolMainService)),[new _.InstantiationService(ee,!0),de,ue,Ee,Me,pe,ae]}patchEnvironment(ee){const ae={VSCODE_IPC_HOOK:ee.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const de=process.env[ue];typeof de=="string"&&(ae[ue]=de)}),Object.assign(process.env,ae),ae}initServices(ee,ae,ue){return M.Promises.settled([Promise.all([ee.extensionsPath,ee.codeCachePath,ee.logsPath,ee.globalStorageHome.fsPath,ee.workspaceStorageHome.fsPath,ee.backupHome].map(de=>de?v.Promises.mkdir(de,{recursive:!0}):void 0)),ae.initialize(),ue.init()])}async claimInstance(ee,ae,ue,de,pe,Ie){let we;try{(0,y.mark)("code/willStartMainServer"),we=await(0,h.serve)(ae.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,w.once)(ue.onWillShutdown)(()=>we.dispose())}catch(ge){if(ge.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ae,pe.nameLong,ge),ge;let Ee;try{Ee=await(0,h.connect)(ae.mainIPCHandle,"main")}catch(We){if(!Ie||d.isWindows||We.code!=="ECONNREFUSED")throw We.code==="EPERM"&&this.showStartupWarningDialog((0,u.localize)(0,null,pe.nameShort),(0,u.localize)(1,null),pe.nameLong),We;try{(0,L.unlinkSync)(ae.mainIPCHandle)}catch(Ne){throw ee.warn("Could not delete obsolete instance handle",Ne),Ne}return this.claimInstance(ee,ae,ue,de,pe,!1)}if(ae.extensionTestsLocationURI&&!ae.debugExtensionHost.break){const We="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ee.error(We),Ee.dispose(),new Error(We)}let Me;!ae.args.wait&&!ae.args.status&&(Me=setTimeout(()=>{this.showStartupWarningDialog((0,u.localize)(2,null,pe.nameShort),(0,u.localize)(3,null),pe.nameLong)},1e4));const Te=c.ProxyChannel.toService(Ee.getChannel("launch"),{disableMarshalling:!0});if(ae.args.status)return de.invokeFunction(async()=>{const We=new r.DiagnosticsService(N.NullTelemetryService,pe),Ne=await Te.getMainProcessInfo(),Xe=await Te.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await We.getDiagnostics(Ne,Xe);throw console.log(Be),new n.ExpectedError});throw d.isWindows&&await this.windowsAllowSetForegroundWindow(Te,ee),ee.trace("Sending env to running instance..."),await Te.start(ae.args,process.env),Ee.dispose(),Me&&clearTimeout(Me),new n.ExpectedError("Sent env to running instance. Terminating...")}if(ae.args.status)throw ee.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new n.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),we}handleStartupDataDirError(ee,ae,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const de=(0,k.coalesce)([ee.userDataPath,ee.extensionsPath,h.XDG_RUNTIME_DIR]).map(pe=>(0,i.getPathLabel)(pe,ee));this.showStartupWarningDialog((0,u.localize)(4,null),(0,u.localize)(5,null,(0,E.toErrorMessage)(ue),de.join(`
`)),ae)}}showStartupWarningDialog(ee,ae,ue){p.dialog.showMessageBoxSync({title:ue,type:"warning",buttons:[(0,i.mnemonicButtonLabel)((0,u.localize)(6,null))],message:ee,detail:ae,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ee,ae){if(d.isWindows){const ue=await ee.getMainProcessId();ae.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((de,pe)=>{V(["windows-foreground-love"],de,pe)})).allowSetForegroundWindow(ue)}catch(de){ae.error(de)}}}quit(ee,ae){const ue=ee.get(K.ILogService),de=ee.get(ne.ILifecycleMainService);let pe=0;ae&&(ae.isExpected?ae.message&&ue.trace(ae.message):(pe=1,ae.stack?ue.error(ae.stack):ue.error(`Startup error: ${ae.toString()}`))),de.kill(pe)}resolveArgs(){const ee=this.validatePaths((0,o.parseMainProcessArgv)(process.argv));if(ee.wait&&!ee.waitMarkerFilePath){const ae=(0,m.createWaitMarkerFile)(ee.verbose);ae&&((0,o.addArg)(process.argv,"--waitMarkerFilePath",ae),ee.waitMarkerFilePath=ae)}return ee}validatePaths(ee){if(ee["open-url"]&&(ee._urls=ee._,ee._=[]),!ee.remote){const ae=this.doValidatePaths(ee._,ee.goto);ee._=ae}return ee}doValidatePaths(ee,ae){const ue=(0,g.cwd)(),de=ee.map(we=>{let ge=String(we),Ee;ae&&(Ee=(0,f.parseLineAndColumnAware)(ge),ge=Ee.path),ge&&(ge=this.preparePath(ue,ge));const Me=(0,f.sanitizeFilePath)(ge,ue),Te=(0,P.basename)(Me);return Te&&!(0,f.isValidBasename)(Te)?null:ae&&Ee?(Ee.path=Me,this.toPath(Ee)):Me}),pe=d.isWindows||d.isMacintosh,Ie=(0,k.distinct)(de,we=>we&&pe?we.toLowerCase():we||"");return(0,k.coalesce)(Ie)}preparePath(ee,ae){return d.isWindows&&(ae=(0,b.rtrim)(ae,'"')),ae=(0,b.trim)((0,b.trim)(ae," "),"	"),d.isWindows&&(ae=(0,P.resolve)(ee,ae),ae=(0,b.rtrim)(ae,".")),ae}toPath(ee){const ae=[ee.path];return typeof ee.line=="number"&&ae.push(String(ee.line)),typeof ee.column=="number"&&ae.push(String(ee.column)),ae.join(":")}}new J().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/code/electron-main/main.js.map
