/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/platform","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/async","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/severity","fs","vs/editor/common/core/position","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/skipList","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],me=function(Y){for(var e=[],f=0,F=Y.length;f<F;f++)e[f]=fe[Y[f]];return e};define(fe[57],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function f(F,C){if(!F)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=f}),define(fe[58],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const f=Object.prototype.hasOwnProperty;function F(n){const k=[];for(let a in n)f.call(n,a)&&k.push(n[a]);return k}e.values=F;function C(n,k){for(let a in n)if(f.call(n,a)&&k({key:a,value:n[a]},function(){delete n[a]})===!1)return}e.forEach=C;function y(n,k){const a=Object.create(null);for(const m of n){const d=k(m);let v=a[d];v||(v=a[d]=[]),v.push(m)}return a}e.groupBy=y;function A(n){const k=Object.create(null);return n&&n.forEach((a,m)=>{k[m]=a}),k}e.fromMap=A;function _(n,k){const a=[],m=[];for(let d of n)k.has(d)||a.push(d);for(let d of k)n.has(d)||m.push(d);return{removed:a,added:m}}e.diffSets=_;function S(n,k){const a=[],m=[];for(let[d,v]of n)k.has(d)||a.push(v);for(let[d,v]of k)n.has(d)||m.push(v);return{removed:a,added:m}}e.diffMaps=S;class P{constructor(){this.map=new Map}add(k,a){let m=this.map.get(k);m||(m=new Set,this.map.set(k,m)),m.add(a)}delete(k,a){const m=this.map.get(k);!m||(m.delete(a),m.size===0&&this.map.delete(k))}forEach(k,a){const m=this.map.get(k);!m||m.forEach(a)}}e.SetMap=P}),define(fe[59],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function f(A){return(_,S,P)=>{let n=null,k=null;if(typeof P.value=="function"?(n="value",k=P.value):typeof P.get=="function"&&(n="get",k=P.get),!k)throw new Error("not supported");P[n]=A(k,S)}}e.createDecorator=f;function F(A,_,S){let P=null,n=null;if(typeof S.value=="function"?(P="value",n=S.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(P="get",n=S.get),!n)throw new Error("not supported");const k=`$memoize$${_}`;S[P]=function(...a){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,a)}),this[k]}}e.memoize=F;function C(A,_,S){return f((P,n)=>{const k=`$debounce$${n}`,a=`$debounce$result$${n}`;return function(...m){this[a]||(this[a]=S?S():void 0),clearTimeout(this[k]),_&&(this[a]=_(this[a],...m),m=[this[a]]),this[k]=setTimeout(()=>{P.apply(this,m),this[a]=S?S():void 0},A)}})}e.debounce=C;function y(A,_,S){return f((P,n)=>{const k=`$throttle$timer$${n}`,a=`$throttle$result$${n}`,m=`$throttle$lastRun$${n}`,d=`$throttle$pending$${n}`;return function(...v){if(this[a]||(this[a]=S?S():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),_&&(this[a]=_(this[a],...v)),this[d])return;const D=this[m]+A;D<=Date.now()?(this[m]=Date.now(),P.apply(this,[this[a]]),this[a]=S?S():void 0):(this[d]=!0,this[k]=setTimeout(()=>{this[d]=!1,this[m]=Date.now(),P.apply(this,[this[a]]),this[a]=S?S():void 0},D-Date.now()))}})}e.throttle=y}),define(fe[18],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class f{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(u=>{u(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=f,e.errorHandler=new f;function F(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=F;function C(g){S(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=C;function y(g){S(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=y;function A(g){if(g instanceof Error){let{name:t,message:u}=g;const r=g.stacktrace||g.stack;return{$isError:!0,name:t,message:u,stack:r}}return g}e.transformErrorForSerialization=A;const _="Canceled";function S(g){return g instanceof Error&&g.name===_&&g.message===_}e.isPromiseCanceledError=S;class P extends Error{constructor(){super(_);this.name=this.message}}e.CancellationError=P;function n(){const g=new Error(_);return g.name=g.message,g}e.canceled=n;function k(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=k;function a(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=a;function m(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function d(g){const t=new Error(`${g} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function v(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=v;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class I extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=I;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function l(g){const t=g;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=l;function o(g,t=Object.create(null)){const u=new Error(g);return t.actions&&(u.actions=t.actions),u}e.createErrorWithActions=o}),define(fe[16],me([0,1,18]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function F(K,X=0){return K[K.length-(1+X)]}e.tail=F;function C(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}e.tail2=C;function y(K,X,de=(be,Se)=>be===Se){if(K===X)return!0;if(!K||!X||K.length!==X.length)return!1;for(let be=0,Se=K.length;be<Se;be++)if(!de(K[be],X[be]))return!1;return!0}e.equals=y;function A(K,X,de){let be=0,Se=K.length-1;for(;be<=Se;){const Ie=(be+Se)/2|0,Oe=de(K[Ie],X);if(Oe<0)be=Ie+1;else if(Oe>0)Se=Ie-1;else return Ie}return-(be+1)}e.binarySearch=A;function _(K,X){let de=0,be=K.length;if(be===0)return 0;for(;de<be;){const Se=Math.floor((de+be)/2);X(K[Se])?be=Se:de=Se+1}return de}e.findFirstInSorted=_;function S(K,X,de){if(K=K|0,K>=X.length)throw new TypeError("invalid index");let be=X[Math.floor(X.length*Math.random())],Se=[],Ie=[],Oe=[];for(let xe of X){const ze=de(xe,be);ze<0?Se.push(xe):ze>0?Ie.push(xe):Oe.push(xe)}return K<Se.length?S(K,Se,de):K<Se.length+Oe.length?Oe[0]:S(K-(Se.length+Oe.length),Ie,de)}e.quickSelect=S;function P(K,X){const de=[];let be;for(const Se of K.slice(0).sort(X))!be||X(be[0],Se)!==0?(be=[Se],de.push(be)):be.push(Se);return de}e.groupBy=P;function n(K,X,de){const be=[];function Se(xe,ze,j){if(ze===0&&j.length===0)return;const ee=be[be.length-1];ee&&ee.start+ee.deleteCount===xe?(ee.deleteCount+=ze,ee.toInsert.push(...j)):be.push({start:xe,deleteCount:ze,toInsert:j})}let Ie=0,Oe=0;for(;;){if(Ie===K.length){Se(Ie,0,X.slice(Oe));break}if(Oe===X.length){Se(Ie,K.length-Ie,[]);break}const xe=K[Ie],ze=X[Oe],j=de(xe,ze);j===0?(Ie+=1,Oe+=1):j<0?(Se(Ie,1,[]),Ie+=1):j>0&&(Se(Ie,0,[ze]),Oe+=1)}return be}e.sortedDiff=n;function k(K,X,de){const be=n(K,X,de),Se=[],Ie=[];for(const Oe of be)Se.push(...K.slice(Oe.start,Oe.start+Oe.deleteCount)),Ie.push(...Oe.toInsert);return{removed:Se,added:Ie}}e.delta=k;function a(K,X,de){if(de===0)return[];const be=K.slice(0,de).sort(X);return d(K,X,be,de,K.length),be}e.top=a;function m(K,X,de,be,Se){return de===0?Promise.resolve([]):new Promise((Ie,Oe)=>{(async()=>{const xe=K.length,ze=K.slice(0,de).sort(X);for(let j=de,ee=Math.min(de+be,xe);j<xe;j=ee,ee=Math.min(ee+be,xe)){if(j>de&&await new Promise(re=>setTimeout(re)),Se&&Se.isCancellationRequested)throw(0,f.canceled)();d(K,X,ze,j,ee)}return ze})().then(Ie,Oe)})}e.topAsync=m;function d(K,X,de,be,Se){for(const Ie=de.length;be<Se;be++){const Oe=K[be];if(X(Oe,de[Ie-1])<0){de.pop();const xe=_(de,ze=>X(Oe,ze)<0);de.splice(xe,0,Oe)}}}function v(K){return K.filter(X=>!!X)}e.coalesce=v;function D(K){let X=0;for(let de=0;de<K.length;de++)K[de]&&(K[X]=K[de],X+=1);K.length=X}e.coalesceInPlace=D;function I(K,X,de){K.splice(de,0,K.splice(X,1)[0])}e.move=I;function b(K){return!Array.isArray(K)||K.length===0}e.isFalsyOrEmpty=b;function l(K){return Array.isArray(K)&&K.length>0}e.isNonEmptyArray=l;function o(K,X){if(!X)return K.filter((be,Se)=>K.indexOf(be)===Se);const de=Object.create(null);return K.filter(be=>{const Se=X(be);return de[Se]?!1:(de[Se]=!0,!0)})}e.distinct=o;function g(K){const X=new Set;return K.filter(de=>X.has(de)?!1:(X.add(de),!0))}e.distinctES6=g;function t(K){const X=Object.create(null);return de=>{const be=K(de);return X[be]?!1:(X[be]=!0,!0)}}e.uniqueFilter=t;function u(K,X){const de=r(K,X);if(de!==-1)return K[de]}e.findLast=u;function r(K,X){for(let de=K.length-1;de>=0;de--){const be=K[de];if(X(be))return de}return-1}e.lastIndex=r;function i(K,X){return K.length>0?K[0]:X}e.firstOrDefault=i;function s(K,X,de=(be,Se)=>be===Se){let be=0;for(let Se=0,Ie=Math.min(K.length,X.length);Se<Ie&&de(K[Se],X[Se]);Se++)be++;return be}e.commonPrefixLength=s;function c(K){return[].concat(...K)}e.flatten=c;function h(K,X){let de=typeof X=="number"?K:0;typeof X=="number"?de=K:(de=0,X=K);const be=[];if(de<=X)for(let Se=de;Se<X;Se++)be.push(Se);else for(let Se=de;Se>X;Se--)be.push(Se);return be}e.range=h;function w(K,X,de){return K.reduce((be,Se)=>(be[X(Se)]=de?de(Se):Se,be),Object.create(null))}e.index=w;function E(K,X){return K.push(X),()=>p(K,X)}e.insert=E;function p(K,X){const de=K.indexOf(X);if(de>-1)return K.splice(de,1),X}e.remove=p;function T(K,X,de){const be=K.slice(0,X),Se=K.slice(X);return be.concat(de,Se)}e.arrayInsert=T;function L(K,X){let de;if(typeof X=="number"){let be=X;de=()=>{const Se=Math.sin(be++)*179426549;return Se-Math.floor(Se)}}else de=Math.random;for(let be=K.length-1;be>0;be-=1){const Se=Math.floor(de()*(be+1)),Ie=K[be];K[be]=K[Se],K[Se]=Ie}}e.shuffle=L;function M(K,X){const de=K.indexOf(X);de>-1&&(K.splice(de,1),K.unshift(X))}e.pushToStart=M;function R(K,X){const de=K.indexOf(X);de>-1&&(K.splice(de,1),K.push(X))}e.pushToEnd=R;function $(K,X){return Array.isArray(K)?K.map(X):X(K)}e.mapArrayOrNot=$;function z(K){return Array.isArray(K)?K:[K]}e.asArray=z;function O(K){return K[Math.floor(Math.random()*K.length)]}e.getRandomElement=O;function V(K,X){for(const de of K){const be=X(de);if(be!==void 0)return be}}e.mapFind=V;function N(K,X,de){const be=x(K,X),Se=K.length,Ie=de.length;K.length=Se+Ie;for(let Oe=Se-1;Oe>=be;Oe--)K[Oe+Ie]=K[Oe];for(let Oe=0;Oe<Ie;Oe++)K[Oe+be]=de[Oe]}e.insertInto=N;function U(K,X,de,be){const Se=x(K,X),Ie=K.splice(Se,de);return N(K,Se,be),Ie}e.splice=U;function x(K,X){return X<0?Math.max(X+K.length,0):Math.min(X,K.length)}function B(K,X){let de=Number.MAX_SAFE_INTEGER,be=0;return K.forEach((Se,Ie)=>{const Oe=X(Se);Oe<de&&(de=Oe,be=Ie)}),be}e.minIndex=B;function H(K,X){let de=Number.MIN_SAFE_INTEGER,be=0;return K.forEach((Se,Ie)=>{const Oe=X(Se);Oe>de&&(de=Oe,be=Ie)}),be}e.maxIndex=H;class G{constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let de=this.firstIdx;for(;de<this.items.length&&X(this.items[de]);)de++;const be=de===this.firstIdx?null:this.items.slice(this.firstIdx,de);return this.firstIdx=de,be}takeFromEndWhile(X){let de=this.lastIdx;for(;de>=0&&X(this.items[de]);)de--;const be=de===this.lastIdx?null:this.items.slice(de+1,this.lastIdx+1);return this.lastIdx=de,be}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=G}),define(fe[75],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function f(F){const C=this;let y=!1,A;return function(){return y||(y=!0,A=F.apply(C,arguments)),A}}e.once=f}),define(fe[76],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class f{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=f,e.defaultGenerator=new f("id#")}),define(fe[94],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var f;(function(F){function C(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}F.is=C;const y=Object.freeze([]);function A(){return y}F.empty=A;function*_(g){yield g}F.single=_;function S(g){return g||y}F.from=S;function P(g){return!g||g[Symbol.iterator]().next().done===!0}F.isEmpty=P;function n(g){return g[Symbol.iterator]().next().value}F.first=n;function k(g,t){for(const u of g)if(t(u))return!0;return!1}F.some=k;function a(g,t){for(const u of g)if(t(u))return u}F.find=a;function*m(g,t){for(const u of g)t(u)&&(yield u)}F.filter=m;function*d(g,t){let u=0;for(const r of g)yield t(r,u++)}F.map=d;function*v(...g){for(const t of g)for(const u of t)yield u}F.concat=v;function*D(g){for(const t of g)for(const u of t)yield u}F.concatNested=D;function I(g,t,u){let r=u;for(const i of g)r=t(r,i);return r}F.reduce=I;function*b(g,t,u=g.length){for(t<0&&(t+=g.length),u<0?u+=g.length:u>g.length&&(u=g.length);t<u;t++)yield g[t]}F.slice=b;function l(g,t=Number.POSITIVE_INFINITY){const u=[];if(t===0)return[u,g];const r=g[Symbol.iterator]();for(let i=0;i<t;i++){const s=r.next();if(s.done)return[u,F.empty()];u.push(s.value)}return[u,{[Symbol.iterator](){return r}}]}F.consume=l;function o(g,t,u=(r,i)=>r===i){const r=g[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const s=r.next(),c=i.next();if(s.done!==c.done)return!1;if(s.done)return!0;if(!u(s.value,c.value))return!1}}F.equals=o})(f=e.Iterable||(e.Iterable={}))}),define(fe[60],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var f;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(f=e.ScanError||(e.ScanError={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function A(t,u=!1){let r=0,i=t.length,s="",c=0,h=16,w=0;function E(z){let O=0,V=0;for(;O<z;){const N=t.charCodeAt(r);if(N>=48&&N<=57)V=V*16+N-48;else if(N>=65&&N<=70)V=V*16+N-65+10;else if(N>=97&&N<=102)V=V*16+N-97+10;else break;r++,O++}return O<z&&(V=-1),V}function p(z){r=z,s="",c=0,h=16,w=0}function T(){const z=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&P(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&P(t.charCodeAt(r)))for(r++;r<t.length&&P(t.charCodeAt(r));)r++;else return w=3,t.substring(z,r);let O=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&P(t.charCodeAt(r))){for(r++;r<t.length&&P(t.charCodeAt(r));)r++;O=r}else w=3;return t.substring(z,O)}function L(){let z="",O=r;for(;;){if(r>=i){z+=t.substring(O,r),w=2;break}const V=t.charCodeAt(r);if(V===34){z+=t.substring(O,r),r++;break}if(V===92){if(z+=t.substring(O,r),r++,r>=i){w=2;break}switch(t.charCodeAt(r++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const U=E(4);U>=0?z+=String.fromCharCode(U):w=4;break;default:w=5}O=r;continue}if(V>=0&&V<=31)if(S(V)){z+=t.substring(O,r),w=2;break}else w=6;r++}return z}function M(){if(s="",w=0,c=r,r>=i)return c=i,h=17;let z=t.charCodeAt(r);if(_(z)){do r++,s+=String.fromCharCode(z),z=t.charCodeAt(r);while(_(z));return h=15}if(S(z))return r++,s+=String.fromCharCode(z),z===13&&t.charCodeAt(r)===10&&(r++,s+=`
`),h=14;switch(z){case 123:return r++,h=1;case 125:return r++,h=2;case 91:return r++,h=3;case 93:return r++,h=4;case 58:return r++,h=6;case 44:return r++,h=5;case 34:return r++,s=L(),h=10;case 47:const O=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!S(t.charCodeAt(r));)r++;return s=t.substring(O,r),h=12}if(t.charCodeAt(r+1)===42){r+=2;const V=i-1;let N=!1;for(;r<V;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,N=!0;break}r++}return N||(r++,w=1),s=t.substring(O,r),h=13}return s+=String.fromCharCode(z),r++,h=16;case 45:if(s+=String.fromCharCode(z),r++,r===i||!P(t.charCodeAt(r)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=T(),h=11;default:for(;r<i&&R(z);)r++,z=t.charCodeAt(r);if(c!==r){switch(s=t.substring(c,r),s){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return s+=String.fromCharCode(z),r++,h=16}}function R(z){if(_(z)||S(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function $(){let z;do z=M();while(z>=12&&z<=15);return z}return{setPosition:p,getPosition:()=>r,scan:u?$:M,getToken:()=>h,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>r-c,getTokenError:()=>w}}e.createScanner=A;function _(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function P(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function k(t,u){const r=[],i=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function w(E,p,T,L){c.value=E,c.offset=p,c.length=T,c.type=L,c.colonOffset=void 0,s=c}try{l(t,{onObjectBegin:(E,p)=>{if(u<=E)throw i;s=void 0,h=u>E,r.push("")},onObjectProperty:(E,p,T)=>{if(u<p||(w(E,p,T,"property"),r[r.length-1]=E,u<=p+T))throw i},onObjectEnd:(E,p)=>{if(u<=E)throw i;s=void 0,r.pop()},onArrayBegin:(E,p)=>{if(u<=E)throw i;s=void 0,r.push(0)},onArrayEnd:(E,p)=>{if(u<=E)throw i;s=void 0,r.pop()},onLiteralValue:(E,p,T)=>{if(u<p||(w(E,p,T,g(E)),u<=p+T))throw i},onSeparator:(E,p,T)=>{if(u<=p)throw i;if(E===":"&&s&&s.type==="property")s.colonOffset=p,h=!1,s=void 0;else if(E===","){const L=r[r.length-1];typeof L=="number"?r[r.length-1]=L+1:(h=!0,r[r.length-1]=""),s=void 0}}})}catch(E){if(E!==i)throw E}return{path:r,previousNode:s,isAtPropertyKey:h,matches:E=>{let p=0;for(let T=0;p<E.length&&T<r.length;T++)if(E[p]===r[T]||E[p]==="*")p++;else if(E[p]!=="**")return!1;return p===E.length}}}e.getLocation=k;function a(t,u=[],r=y.DEFAULT){let i=null,s=[];const c=[];function h(E){Array.isArray(s)?s.push(E):i!==null&&(s[i]=E)}return l(t,{onObjectBegin:()=>{const E={};h(E),c.push(s),s=E,i=null},onObjectProperty:E=>{i=E},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const E=[];h(E),c.push(s),s=E,i=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:h,onError:(E,p,T)=>{u.push({error:E,offset:p,length:T})}},r),s[0]}e.parse=a;function m(t,u=[],r=y.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(E){i.type==="property"&&(i.length=E-i.offset,i=i.parent)}function c(E){return i.children.push(E),E}l(t,{onObjectBegin:E=>{i=c({type:"object",offset:E,length:-1,parent:i,children:[]})},onObjectProperty:(E,p,T)=>{i=c({type:"property",offset:p,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:E,offset:p,length:T,parent:i})},onObjectEnd:(E,p)=>{i.length=E+p-i.offset,i=i.parent,s(E+p)},onArrayBegin:(E,p)=>{i=c({type:"array",offset:E,length:-1,parent:i,children:[]})},onArrayEnd:(E,p)=>{i.length=E+p-i.offset,i=i.parent,s(E+p)},onLiteralValue:(E,p,T)=>{c({type:g(E),offset:p,length:T,parent:i,value:E}),s(p+T)},onSeparator:(E,p,T)=>{i.type==="property"&&(E===":"?i.colonOffset=p:E===","&&s(p))},onError:(E,p,T)=>{u.push({error:E,offset:p,length:T})}},r);const w=i.children[0];return w&&delete w.parent,w}e.parseTree=m;function d(t,u){if(!t)return;let r=t;for(let i of u)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const c of r.children)if(Array.isArray(c.children)&&c.children[0].value===i){r=c.children[1],s=!0;break}if(!s)return}else{const s=i;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}e.findNodeAtLocation=d;function v(t){if(!t.parent||!t.parent.children)return[];const u=v(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;u.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&u.push(r)}return u}e.getNodePath=v;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const u=Object.create(null);for(let r of t.children){const i=r.children[1];i&&(u[r.children[0].value]=D(i))}return u;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function I(t,u,r=!1){return u>=t.offset&&u<t.offset+t.length||r&&u===t.offset+t.length}e.contains=I;function b(t,u,r=!1){if(I(t,u,r)){const i=t.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=u;s++){const c=b(i[s],u,r);if(c)return c}return t}}e.findNodeAtOffset=b;function l(t,u,r=y.DEFAULT){const i=A(t,!1);function s(X){return X?()=>X(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(X){return X?de=>X(de,i.getTokenOffset(),i.getTokenLength()):()=>!0}const h=s(u.onObjectBegin),w=c(u.onObjectProperty),E=s(u.onObjectEnd),p=s(u.onArrayBegin),T=s(u.onArrayEnd),L=c(u.onLiteralValue),M=c(u.onSeparator),R=s(u.onComment),$=c(u.onError),z=r&&r.disallowComments,O=r&&r.allowTrailingComma;function V(){for(;;){const X=i.scan();switch(i.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:z||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(X){case 12:case 13:z?N(10):R();break;case 16:N(1);break;case 15:case 14:break;default:return X}}}function N(X,de=[],be=[]){if($(X),de.length+be.length>0){let Se=i.getToken();for(;Se!==17;){if(de.indexOf(Se)!==-1){V();break}else if(be.indexOf(Se)!==-1)break;Se=V()}}}function U(X){const de=i.getTokenValue();return X?L(de):w(de),V(),!0}function x(){switch(i.getToken()){case 11:let X=0;try{X=JSON.parse(i.getTokenValue()),typeof X!="number"&&(N(2),X=0)}catch(de){N(2)}L(X);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return V(),!0}function B(){return i.getToken()!==10?(N(3,[],[2,5]),!1):(U(!1),i.getToken()===6?(M(":"),V(),K()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function H(){h(),V();let X=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(X||N(4,[],[]),M(","),V(),i.getToken()===2&&O)break}else X&&N(6,[],[]);B()||N(4,[],[2,5]),X=!0}return E(),i.getToken()!==2?N(7,[2],[]):V(),!0}function G(){p(),V();let X=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(X||N(4,[],[]),M(","),V(),i.getToken()===4&&O)break}else X&&N(6,[],[]);K()||N(4,[],[4,5]),X=!0}return T(),i.getToken()!==4?N(8,[4],[]):V(),!0}function K(){switch(i.getToken()){case 3:return G();case 1:return H();case 10:return U(!0);default:return x()}}return V(),i.getToken()===17?r.allowEmptyContent?!0:(N(4,[],[]),!1):K()?(i.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=l;function o(t,u){let r=A(t),i=[],s,c=0,h;do switch(h=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:c!==h&&i.push(t.substring(c,h)),u!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,u)),c=r.getPosition();break}while(s!==17);return i.join("")}e.stripComments=o;function g(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(fe[139],me([0,1,60]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function F(S,P,n){let k,a,m,d,v;if(P){for(d=P.offset,v=d+P.length,m=d;m>0&&!_(S,m-1);)m--;let c=v;for(;c<S.length&&!_(S,c);)c++;a=S.substring(m,c),k=y(a,n)}else a=S,k=0,m=0,d=0,v=S.length;const D=A(n,S);let I=!1,b=0,l;n.insertSpaces?l=C(" ",n.tabSize||4):l="	";const o=(0,f.createScanner)(a,!1);let g=!1;function t(){return D+C(l,k+b)}function u(){let c=o.scan();for(I=!1;c===15||c===14;)I=I||c===14,c=o.scan();return g=c===16||o.getTokenError()!==0,c}const r=[];function i(c,h,w){!g&&h<v&&w>d&&S.substring(h,w)!==c&&r.push({offset:h,length:w-h,content:c})}let s=u();if(s!==17){const c=o.getTokenOffset()+m,h=C(l,k);i(h,m,c)}for(;s!==17;){let c=o.getTokenOffset()+o.getTokenLength()+m,h=u(),w="";for(;!I&&(h===12||h===13);){const p=o.getTokenOffset()+m;i(" ",c,p),c=o.getTokenOffset()+o.getTokenLength()+m,w=h===12?t():"",h=u()}if(h===2)s!==1&&(b--,w=t());else if(h===4)s!==3&&(b--,w=t());else{switch(s){case 3:case 1:b++,w=t();break;case 5:case 12:w=t();break;case 13:I?w=t():w=" ";break;case 6:w=" ";break;case 10:if(h===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?w=" ":h!==5&&h!==17&&(g=!0);break;case 16:g=!0;break}I&&(h===12||h===13)&&(w=t())}const E=o.getTokenOffset()+m;i(w,c,E),s=h}return r}e.format=F;function C(S,P){let n="";for(let k=0;k<P;k++)n+=S;return n}function y(S,P){let n=0,k=0;const a=P.tabSize||4;for(;n<S.length;){const m=S.charAt(n);if(m===" ")k++;else if(m==="	")k+=a;else break;n++}return Math.floor(k/a)}function A(S,P){for(let n=0;n<P.length;n++){const k=P.charAt(n);if(k==="\r")return n+1<P.length&&P.charAt(n+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=A;function _(S,P){return`\r
`.indexOf(S.charAt(P))!==-1}e.isEOL=_}),define(fe[140],me([0,1,60,139]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(P,n,k){return y(P,n,void 0,k)}e.removeProperty=C;function y(P,n,k,a,m){const d=n.slice(),v=[],D=(0,f.parseTree)(P,v);let I,b;for(;d.length>0&&(b=d.pop(),I=(0,f.findNodeAtLocation)(D,d),I===void 0&&k!==void 0);)typeof b=="string"?k={[b]:k}:k=[k];if(I)if(I.type==="object"&&typeof b=="string"&&Array.isArray(I.children)){const l=(0,f.findNodeAtLocation)(I,[b]);if(l!==void 0)if(k===void 0){if(!l.parent)throw new Error("Malformed AST");const o=I.children.indexOf(l.parent);let g,t=l.parent.offset+l.parent.length;if(o>0){const u=I.children[o-1];g=u.offset+u.length}else g=I.offset+1,I.children.length>1&&(t=I.children[1].offset);return A(P,{offset:g,length:t-g,content:""},a)}else return A(P,{offset:l.offset,length:l.length,content:JSON.stringify(k)},a);else{if(k===void 0)return[];const o=`${JSON.stringify(b)}: ${JSON.stringify(k)}`,g=m?m(I.children.map(u=>u.children[0].value)):I.children.length;let t;if(g>0){const u=I.children[g-1];t={offset:u.offset+u.length,length:0,content:","+o}}else I.children.length===0?t={offset:I.offset+1,length:0,content:o}:t={offset:I.offset+1,length:0,content:o+","};return A(P,t,a)}}else if(I.type==="array"&&typeof b=="number"&&Array.isArray(I.children))if(k!==void 0){const l=`${JSON.stringify(k)}`;let o;if(I.children.length===0||b===0)o={offset:I.offset+1,length:0,content:I.children.length===0?l:l+","};else{const g=b===-1||b>I.children.length?I.children.length:b,t=I.children[g-1];o={offset:t.offset+t.length,length:0,content:","+l}}return A(P,o,a)}else{const l=b,o=I.children[l];let g;if(I.children.length===1)g={offset:I.offset+1,length:I.length-2,content:""};else if(I.children.length-1===l){const t=I.children[l-1],u=t.offset+t.length,r=I.offset+I.length;g={offset:u,length:r-2-u,content:""}}else g={offset:o.offset,length:I.children[l+1].offset-o.offset,content:""};return A(P,g,a)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${I.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return A(P,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(k)},a)}}e.setProperty=y;function A(P,n,k){let a=_(P,n),m=n.offset,d=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;m>0&&!(0,F.isEOL)(a,m-1);)m--;for(;d<a.length&&!(0,F.isEOL)(a,d);)d++}const v=(0,F.format)(a,{offset:m,length:d-m},k);for(let I=v.length-1;I>=0;I--){const b=v[I];a=_(a,b),m=Math.min(m,b.offset),d=Math.max(d,b.offset+b.length),d+=b.content.length-b.length}const D=P.length-(a.length-d)-m;return[{offset:m,length:D,content:a.substring(m,d)}]}e.withFormatting=A;function _(P,n){return P.substring(0,n.offset)+n.content+P.substring(n.offset+n.length)}e.applyEdit=_;function S(P,n){let k=n.slice(0).sort((m,d)=>{const v=m.offset-d.offset;return v===0?m.length-d.length:v}),a=P.length;for(let m=k.length-1;m>=0;m--){let d=k[m];if(d.offset+d.length<=a)P=_(P,d);else throw new Error("Overlapping edit");a=d.offset}return P}e.applyEdits=S}),define(fe[141],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class f{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new f(()=>C(this.getValue()))}}e.Lazy=f}),define(fe[6],me([0,1,75,94]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let y=null;function A(i){y=i}if(e.setDisposableTracker=A,C){const i="__is_disposable_tracked__";A(new class{trackDisposable(s){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[i]||console.log(c)},3e3)}setParent(s,c){if(s&&s!==b.None)try{s[i]=!0}catch{}}markAsDisposed(s){if(s&&s!==b.None)try{s[i]=!0}catch{}}markAsSingleton(s){}})}function _(i){return y?.trackDisposable(i),i}function S(i){y?.markAsDisposed(i)}function P(i,s){y?.setParent(i,s)}function n(i,s){if(!!y)for(const c of i)y.setParent(c,s)}function k(i){return y?.markAsSingleton(i),i}e.markAsSingleton=k;class a extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=a;function m(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=m;function d(i){if(F.Iterable.is(i)){let s=[];for(const c of i)if(c)try{c.dispose()}catch(h){s.push(h)}if(s.length===1)throw s[0];if(s.length>1)throw new a(s);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=d;function v(...i){const s=D(()=>d(i));return n(i,s),s}e.combinedDisposable=v;function D(i){const s=_({dispose:(0,f.once)(()=>{S(s),i()})});return s}e.toDisposable=D;class I{constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return P(s,this),this._isDisposed?I.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=I,I.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new I,_(this),P(this._store,this)}dispose(){S(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class l{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&P(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&P(s,null),s}}e.MutableDisposable=l;class o{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class g{constructor(){this.references=new Map}acquire(s,...c){let h=this.references.get(s);h||(h={counter:0,object:this.createReferencedObject(s,...c)},this.references.set(s,h));const{object:w}=h,E=(0,f.once)(()=>{--h.counter==0&&(this.destroyReferencedObject(s,h.object),this.references.delete(s))});return h.counter++,{object:w,dispose:E}}}e.ReferenceCollection=g;class t{constructor(s){this.referenceCollection=s}async acquire(s,...c){const h=this.referenceCollection.acquire(s,...c);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(w){throw h.dispose(),w}}}e.AsyncReferenceCollection=t;class u{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=u;function r(i){const s=new I;try{i(s)}finally{s.dispose()}}e.disposeOnReturn=r}),define(fe[95],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class f{constructor(y){this.element=y,this.next=f.Undefined,this.prev=f.Undefined}}f.Undefined=new f(void 0);class F{constructor(){this._first=f.Undefined,this._last=f.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===f.Undefined}clear(){let y=this._first;for(;y!==f.Undefined;){const A=y.next;y.prev=f.Undefined,y.next=f.Undefined,y=A}this._first=f.Undefined,this._last=f.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,A){const _=new f(y);if(this._first===f.Undefined)this._first=_,this._last=_;else if(A){const P=this._last;this._last=_,_.prev=P,P.next=_}else{const P=this._first;this._first=_,_.next=P,P.prev=_}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(_))}}shift(){if(this._first!==f.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==f.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==f.Undefined&&y.next!==f.Undefined){const A=y.prev;A.next=y.next,y.next.prev=A}else y.prev===f.Undefined&&y.next===f.Undefined?(this._first=f.Undefined,this._last=f.Undefined):y.next===f.Undefined?(this._last=this._last.prev,this._last.next=f.Undefined):y.prev===f.Undefined&&(this._first=this._first.next,this._first.prev=f.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==f.Undefined;)yield y.element,y=y.next}}e.LinkedList=F}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Te,De){for(var ke=0;ke<De.length;ke++){var ne=De[ke];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(Te,ne.key,ne)}}function e(Te,De,ke){return De&&Y(Te.prototype,De),ke&&Y(Te,ke),Te}function f(Te,De){if(!!Te){if(typeof Te=="string")return F(Te,De);var ke=Object.prototype.toString.call(Te).slice(8,-1);if(ke==="Object"&&Te.constructor&&(ke=Te.constructor.name),ke==="Map"||ke==="Set")return Array.from(Te);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return F(Te,De)}}function F(Te,De){(De==null||De>Te.length)&&(De=Te.length);for(var ke=0,ne=new Array(De);ke<De;ke++)ne[ke]=Te[ke];return ne}function C(Te,De){var ke=typeof Symbol!="undefined"&&Te[Symbol.iterator]||Te["@@iterator"];if(ke)return(ke=ke.call(Te)).next.bind(ke);if(Array.isArray(Te)||(ke=f(Te))||De&&Te&&typeof Te.length=="number"){ke&&(Te=ke);var ne=0;return function(){return ne>=Te.length?{done:!0}:{done:!1,value:Te[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var y={exports:{}};function A(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function _(Te){y.exports.defaults=Te}y.exports={defaults:A(),getDefaults:A,changeDefaults:_};var S=/[&<>"']/,P=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(De){return a[De]};function d(Te,De){if(De){if(S.test(Te))return Te.replace(P,m)}else if(n.test(Te))return Te.replace(k,m);return Te}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function D(Te){return Te.replace(v,function(De,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var I=/(^|[^\[])\^/g;function b(Te,De){Te=Te.source||Te,De=De||"";var ke={replace:function(ue,Ee){return Ee=Ee.source||Ee,Ee=Ee.replace(I,"$1"),Te=Te.replace(ue,Ee),ke},getRegex:function(){return new RegExp(Te,De)}};return ke}var l=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(Te,De,ke){if(Te){var ne;try{ne=decodeURIComponent(D(ke)).replace(l,"").toLowerCase()}catch(ue){return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}De&&!o.test(ke)&&(ke=s(De,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch(ue){return null}return ke}var t={},u=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(Te,De){t[" "+Te]||(u.test(Te)?t[" "+Te]=Te+"/":t[" "+Te]=E(Te,"/",!0)),Te=t[" "+Te];var ke=Te.indexOf(":")===-1;return De.substring(0,2)==="//"?ke?De:Te.replace(r,"$1")+De:De.charAt(0)==="/"?ke?De:Te.replace(i,"$1")+De:Te+De}var c={exec:function(){}};function h(Te){for(var De=1,ke,ne;De<arguments.length;De++){ke=arguments[De];for(ne in ke)Object.prototype.hasOwnProperty.call(ke,ne)&&(Te[ne]=ke[ne])}return Te}function w(Te,De){var ke=Te.replace(/\|/g,function(Ee,we,Fe){for(var Ge=!1,Ve=we;--Ve>=0&&Fe[Ve]==="\\";)Ge=!Ge;return Ge?"|":" |"}),ne=ke.split(/ \|/),ue=0;if(ne[0].trim()||ne.shift(),ne[ne.length-1].trim()||ne.pop(),ne.length>De)ne.splice(De);else for(;ne.length<De;)ne.push("");for(;ue<ne.length;ue++)ne[ue]=ne[ue].trim().replace(/\\\|/g,"|");return ne}function E(Te,De,ke){var ne=Te.length;if(ne===0)return"";for(var ue=0;ue<ne;){var Ee=Te.charAt(ne-ue-1);if(Ee===De&&!ke)ue++;else if(Ee!==De&&ke)ue++;else break}return Te.substr(0,ne-ue)}function p(Te,De){if(Te.indexOf(De[1])===-1)return-1;for(var ke=Te.length,ne=0,ue=0;ue<ke;ue++)if(Te[ue]==="\\")ue++;else if(Te[ue]===De[0])ne++;else if(Te[ue]===De[1]&&(ne--,ne<0))return ue;return-1}function T(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(Te,De){if(De<1)return"";for(var ke="";De>1;)De&1&&(ke+=Te),De>>=1,Te+=Te;return ke+Te}var M={escape:d,unescape:D,edit:b,cleanUrl:g,resolveUrl:s,noopTest:c,merge:h,splitCells:w,rtrim:E,findClosingBracket:p,checkSanitizeDeprecation:T,repeatString:L},R=y.exports.defaults,$=M.rtrim,z=M.splitCells,O=M.escape,V=M.findClosingBracket;function N(Te,De,ke,ne){var ue=De.href,Ee=De.title?O(De.title):null,we=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){ne.state.inLink=!0;var Fe={type:"link",raw:ke,href:ue,title:Ee,text:we,tokens:ne.inlineTokens(we,[])};return ne.state.inLink=!1,Fe}else return{type:"image",raw:ke,href:ue,title:Ee,text:O(we)}}function U(Te,De){var ke=Te.match(/^(\s+)(?:```)/);if(ke===null)return De;var ne=ke[1];return De.split(`
`).map(function(ue){var Ee=ue.match(/^\s+/);if(Ee===null)return ue;var we=Ee[0];return we.length>=ne.length?ue.slice(ne.length):ue}).join(`
`)}var x=function(){function Te(ke){this.options=ke||R}var De=Te.prototype;return De.space=function(ne){var ue=this.rules.block.newline.exec(ne);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},De.code=function(ne){var ue=this.rules.block.code.exec(ne);if(ue){var Ee=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?Ee:$(Ee,`
`)}}},De.fences=function(ne){var ue=this.rules.block.fences.exec(ne);if(ue){var Ee=ue[0],we=U(Ee,ue[3]||"");return{type:"code",raw:Ee,lang:ue[2]?ue[2].trim():ue[2],text:we}}},De.heading=function(ne){var ue=this.rules.block.heading.exec(ne);if(ue){var Ee=ue[2].trim();if(/#$/.test(Ee)){var we=$(Ee,"#");(this.options.pedantic||!we||/ $/.test(we))&&(Ee=we.trim())}var Fe={type:"heading",raw:ue[0],depth:ue[1].length,text:Ee,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},De.hr=function(ne){var ue=this.rules.block.hr.exec(ne);if(ue)return{type:"hr",raw:ue[0]}},De.blockquote=function(ne){var ue=this.rules.block.blockquote.exec(ne);if(ue){var Ee=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(Ee,[]),text:Ee}}},De.list=function(ne){var ue=this.rules.block.list.exec(ne);if(ue){var Ee,we,Fe,Ge,Ve,et,ot,Be,ge,_e,ie=ue[1].trim(),Q=ie.length>1,ye={type:"list",raw:"",ordered:Q,start:Q?+ie.slice(0,-1):"",loose:!1,items:[]};ie=Q?"\\d{1,9}\\"+ie.slice(-1):"\\"+ie,this.options.pedantic&&(ie=Q?ie:"[*+-]");for(var Le=new RegExp("^( {0,3}"+ie+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ne&&!(this.rules.block.hr.test(ne)||!(ue=Le.exec(ne)));){ge=ue[2].split(`
`),this.options.pedantic?(Ge=2,_e=ge[0].trimLeft()):(Ge=ue[2].search(/[^ ]/),Ge=ue[1].length+(Ge>4?1:Ge),_e=ge[0].slice(Ge-ue[1].length)),et=!1,Ee=ue[0],!ge[0]&&/^ *$/.test(ge[1])&&(Ee=ue[1]+ge.slice(0,2).join(`
`)+`
`,ye.loose=!0,ge=[]);var it=new RegExp("^ {0,"+Math.min(3,Ge-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Ve=1;Ve<ge.length;Ve++){if(Be=ge[Ve],this.options.pedantic&&(Be=Be.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),it.test(Be)){Ee=ue[1]+ge.slice(0,Ve).join(`
`)+`
`;break}if(!et){Be.trim()||(et=!0),Be.search(/[^ ]/)>=Ge?_e+=`
`+Be.slice(Ge):_e+=`
`+Be;continue}if(Be.search(/[^ ]/)>=Ge||!Be.trim()){_e+=`
`+Be.slice(Ge);continue}else{Ee=ue[1]+ge.slice(0,Ve).join(`
`)+`
`;break}}ye.loose||(ot?ye.loose=!0:/\n *\n *$/.test(Ee)&&(ot=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(_e),we&&(Fe=we[0]!=="[ ] ",_e=_e.replace(/^\[[ xX]\] +/,""))),ye.items.push({type:"list_item",raw:Ee,task:!!we,checked:Fe,loose:!1,text:_e}),ye.raw+=Ee,ne=ne.slice(Ee.length)}ye.items[ye.items.length-1].raw=Ee.trimRight(),ye.items[ye.items.length-1].text=_e.trimRight(),ye.raw=ye.raw.trimRight();var Ke=ye.items.length;for(Ve=0;Ve<Ke;Ve++)this.lexer.state.top=!1,ye.items[Ve].tokens=this.lexer.blockTokens(ye.items[Ve].text,[]),ye.items[Ve].tokens.some(function(pt){return pt.type==="space"})&&(ye.loose=!0,ye.items[Ve].loose=!0);return ye}},De.html=function(ne){var ue=this.rules.block.html.exec(ne);if(ue){var Ee={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(Ee.type="paragraph",Ee.text=this.options.sanitizer?this.options.sanitizer(ue[0]):O(ue[0]),Ee.tokens=[],this.lexer.inline(Ee.text,Ee.tokens)),Ee}},De.def=function(ne){var ue=this.rules.block.def.exec(ne);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var Ee=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Ee,raw:ue[0],href:ue[2],title:ue[3]}}},De.table=function(ne){var ue=this.rules.block.table.exec(ne);if(ue){var Ee={type:"table",header:z(ue[1]).map(function(ot){return{text:ot}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(Ee.header.length===Ee.align.length){Ee.raw=ue[0];var we=Ee.align.length,Fe,Ge,Ve,et;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(Ee.align[Fe])?Ee.align[Fe]="right":/^ *:-+: *$/.test(Ee.align[Fe])?Ee.align[Fe]="center":/^ *:-+ *$/.test(Ee.align[Fe])?Ee.align[Fe]="left":Ee.align[Fe]=null;for(we=Ee.rows.length,Fe=0;Fe<we;Fe++)Ee.rows[Fe]=z(Ee.rows[Fe],Ee.header.length).map(function(ot){return{text:ot}});for(we=Ee.header.length,Ge=0;Ge<we;Ge++)Ee.header[Ge].tokens=[],this.lexer.inlineTokens(Ee.header[Ge].text,Ee.header[Ge].tokens);for(we=Ee.rows.length,Ge=0;Ge<we;Ge++)for(et=Ee.rows[Ge],Ve=0;Ve<et.length;Ve++)et[Ve].tokens=[],this.lexer.inlineTokens(et[Ve].text,et[Ve].tokens);return Ee}}},De.lheading=function(ne){var ue=this.rules.block.lheading.exec(ne);if(ue){var Ee={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(Ee.text,Ee.tokens),Ee}},De.paragraph=function(ne){var ue=this.rules.block.paragraph.exec(ne);if(ue){var Ee={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(Ee.text,Ee.tokens),Ee}},De.text=function(ne){var ue=this.rules.block.text.exec(ne);if(ue){var Ee={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(Ee.text,Ee.tokens),Ee}},De.escape=function(ne){var ue=this.rules.inline.escape.exec(ne);if(ue)return{type:"escape",raw:ue[0],text:O(ue[1])}},De.tag=function(ne){var ue=this.rules.inline.tag.exec(ne);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):O(ue[0]):ue[0]}},De.link=function(ne){var ue=this.rules.inline.link.exec(ne);if(ue){var Ee=ue[2].trim();if(!this.options.pedantic&&/^</.test(Ee)){if(!/>$/.test(Ee))return;var we=$(Ee.slice(0,-1),"\\");if((Ee.length-we.length)%2==0)return}else{var Fe=V(ue[2],"()");if(Fe>-1){var Ge=ue[0].indexOf("!")===0?5:4,Ve=Ge+ue[1].length+Fe;ue[2]=ue[2].substring(0,Fe),ue[0]=ue[0].substring(0,Ve).trim(),ue[3]=""}}var et=ue[2],ot="";if(this.options.pedantic){var Be=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(et);Be&&(et=Be[1],ot=Be[3])}else ot=ue[3]?ue[3].slice(1,-1):"";return et=et.trim(),/^</.test(et)&&(this.options.pedantic&&!/>$/.test(Ee)?et=et.slice(1):et=et.slice(1,-1)),N(ue,{href:et&&et.replace(this.rules.inline._escapes,"$1"),title:ot&&ot.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},De.reflink=function(ne,ue){var Ee;if((Ee=this.rules.inline.reflink.exec(ne))||(Ee=this.rules.inline.nolink.exec(ne))){var we=(Ee[2]||Ee[1]).replace(/\s+/g," ");if(we=ue[we.toLowerCase()],!we||!we.href){var Fe=Ee[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return N(Ee,we,Ee[0],this.lexer)}},De.emStrong=function(ne,ue,Ee){Ee===void 0&&(Ee="");var we=this.rules.inline.emStrong.lDelim.exec(ne);if(!!we&&!(we[3]&&Ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(Ee===""||this.rules.inline.punctuation.exec(Ee))){var Ge=we[0].length-1,Ve,et,ot=Ge,Be=0,ge=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,ue=ue.slice(-1*ne.length+Ge);(we=ge.exec(ue))!=null;)if(Ve=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!Ve){if(et=Ve.length,we[3]||we[4]){ot+=et;continue}else if((we[5]||we[6])&&Ge%3&&!((Ge+et)%3)){Be+=et;continue}if(ot-=et,!(ot>0)){if(et=Math.min(et,et+ot+Be),Math.min(Ge,et)%2){var _e=ne.slice(1,Ge+we.index+et);return{type:"em",raw:ne.slice(0,Ge+we.index+et+1),text:_e,tokens:this.lexer.inlineTokens(_e,[])}}var ie=ne.slice(2,Ge+we.index+et-1);return{type:"strong",raw:ne.slice(0,Ge+we.index+et+1),text:ie,tokens:this.lexer.inlineTokens(ie,[])}}}}}},De.codespan=function(ne){var ue=this.rules.inline.code.exec(ne);if(ue){var Ee=ue[2].replace(/\n/g," "),we=/[^ ]/.test(Ee),Fe=/^ /.test(Ee)&&/ $/.test(Ee);return we&&Fe&&(Ee=Ee.substring(1,Ee.length-1)),Ee=O(Ee,!0),{type:"codespan",raw:ue[0],text:Ee}}},De.br=function(ne){var ue=this.rules.inline.br.exec(ne);if(ue)return{type:"br",raw:ue[0]}},De.del=function(ne){var ue=this.rules.inline.del.exec(ne);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},De.autolink=function(ne,ue){var Ee=this.rules.inline.autolink.exec(ne);if(Ee){var we,Fe;return Ee[2]==="@"?(we=O(this.options.mangle?ue(Ee[1]):Ee[1]),Fe="mailto:"+we):(we=O(Ee[1]),Fe=we),{type:"link",raw:Ee[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},De.url=function(ne,ue){var Ee;if(Ee=this.rules.inline.url.exec(ne)){var we,Fe;if(Ee[2]==="@")we=O(this.options.mangle?ue(Ee[0]):Ee[0]),Fe="mailto:"+we;else{var Ge;do Ge=Ee[0],Ee[0]=this.rules.inline._backpedal.exec(Ee[0])[0];while(Ge!==Ee[0]);we=O(Ee[0]),Ee[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:Ee[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},De.inlineText=function(ne,ue){var Ee=this.rules.inline.text.exec(ne);if(Ee){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Ee[0]):O(Ee[0]):Ee[0]:we=O(this.options.smartypants?ue(Ee[0]):Ee[0]),{type:"text",raw:Ee[0],text:we}}},Te}(),B=M.noopTest,H=M.edit,G=M.merge,K={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:B,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};K._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,K._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,K.def=H(K.def).replace("label",K._label).replace("title",K._title).getRegex(),K.bullet=/(?:[*+-]|\d{1,9}[.)])/,K.listItemStart=H(/^( *)(bull) */).replace("bull",K.bullet).getRegex(),K.list=H(K.list).replace(/bull/g,K.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+K.def.source+")").getRegex(),K._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",K._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,K.html=H(K.html,"i").replace("comment",K._comment).replace("tag",K._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),K.paragraph=H(K._paragraph).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",K._tag).getRegex(),K.blockquote=H(K.blockquote).replace("paragraph",K.paragraph).getRegex(),K.normal=G({},K),K.gfm=G({},K.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),K.gfm.table=H(K.gfm.table).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",K._tag).getRegex(),K.pedantic=G({},K.normal,{html:H(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",K._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:B,paragraph:H(K.normal._paragraph).replace("hr",K.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",K.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var X={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:B,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:B,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};X._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",X.punctuation=H(X.punctuation).replace(/punctuation/g,X._punctuation).getRegex(),X.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,X.escapedEmSt=/\\\*|\\_/g,X._comment=H(K._comment).replace("(?:-->|$)","-->").getRegex(),X.emStrong.lDelim=H(X.emStrong.lDelim).replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimAst=H(X.emStrong.rDelimAst,"g").replace(/punct/g,X._punctuation).getRegex(),X.emStrong.rDelimUnd=H(X.emStrong.rDelimUnd,"g").replace(/punct/g,X._punctuation).getRegex(),X._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,X._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,X._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,X.autolink=H(X.autolink).replace("scheme",X._scheme).replace("email",X._email).getRegex(),X._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,X.tag=H(X.tag).replace("comment",X._comment).replace("attribute",X._attribute).getRegex(),X._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,X._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,X._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,X.link=H(X.link).replace("label",X._label).replace("href",X._href).replace("title",X._title).getRegex(),X.reflink=H(X.reflink).replace("label",X._label).getRegex(),X.reflinkSearch=H(X.reflinkSearch,"g").replace("reflink",X.reflink).replace("nolink",X.nolink).getRegex(),X.normal=G({},X),X.pedantic=G({},X.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:H(/^!?\[(label)\]\((.*?)\)/).replace("label",X._label).getRegex(),reflink:H(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",X._label).getRegex()}),X.gfm=G({},X.normal,{escape:H(X.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),X.gfm.url=H(X.gfm.url,"i").replace("email",X.gfm._extended_email).getRegex(),X.breaks=G({},X.gfm,{br:H(X.br).replace("{2,}","*").getRegex(),text:H(X.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:K,inline:X},be=x,Se=y.exports.defaults,Ie=de.block,Oe=de.inline,xe=M.repeatString;function ze(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(Te){var De="",ke,ne,ue=Te.length;for(ke=0;ke<ue;ke++)ne=Te.charCodeAt(ke),Math.random()>.5&&(ne="x"+ne.toString(16)),De+="&#"+ne+";";return De}var ee=function(){function Te(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||Se,this.options.tokenizer=this.options.tokenizer||new be,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:Ie.normal,inline:Oe.normal};this.options.pedantic?(ne.block=Ie.pedantic,ne.inline=Oe.pedantic):this.options.gfm&&(ne.block=Ie.gfm,this.options.breaks?ne.inline=Oe.breaks:ne.inline=Oe.gfm),this.tokenizer.rules=ne}Te.lex=function(ne,ue){var Ee=new Te(ue);return Ee.lex(ne)},Te.lexInline=function(ne,ue){var Ee=new Te(ue);return Ee.inlineTokens(ne)};var De=Te.prototype;return De.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ne,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},De.blockTokens=function(ne,ue){var Ee=this;ue===void 0&&(ue=[]),this.options.pedantic&&(ne=ne.replace(/^ +$/gm,""));for(var we,Fe,Ge,Ve;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ot){return(we=ot.call({lexer:Ee},ne,ue))?(ne=ne.substring(we.raw.length),ue.push(we),!0):!1}))){if(we=this.tokenizer.space(ne)){ne=ne.substring(we.raw.length),we.type&&ue.push(we);continue}if(we=this.tokenizer.code(ne)){ne=ne.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we);continue}if(we=this.tokenizer.fences(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.heading(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.hr(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.blockquote(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.list(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.html(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.def(ne)){ne=ne.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.lheading(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(Ge=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var ot=1/0,Be=ne.slice(1),ge=void 0;Ee.options.extensions.startBlock.forEach(function(_e){ge=_e.call({lexer:this},Be),typeof ge=="number"&&ge>=0&&(ot=Math.min(ot,ge))}),ot<1/0&&ot>=0&&(Ge=ne.substring(0,ot+1))}(),this.state.top&&(we=this.tokenizer.paragraph(Ge))){Fe=ue[ue.length-1],Ve&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we),Ve=Ge.length!==ne.length,ne=ne.substring(we.raw.length);continue}if(we=this.tokenizer.text(ne)){ne=ne.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we);continue}if(ne){var et="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(et);break}else throw new Error(et)}}return this.state.top=!0,ue},De.inline=function(ne,ue){this.inlineQueue.push({src:ne,tokens:ue})},De.inlineTokens=function(ne,ue){var Ee=this;ue===void 0&&(ue=[]);var we,Fe,Ge,Ve=ne,et,ot,Be;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(et=this.tokenizer.rules.inline.reflinkSearch.exec(Ve))!=null;)ge.includes(et[0].slice(et[0].lastIndexOf("[")+1,-1))&&(Ve=Ve.slice(0,et.index)+"["+xe("a",et[0].length-2)+"]"+Ve.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(et=this.tokenizer.rules.inline.blockSkip.exec(Ve))!=null;)Ve=Ve.slice(0,et.index)+"["+xe("a",et[0].length-2)+"]"+Ve.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(et=this.tokenizer.rules.inline.escapedEmSt.exec(Ve))!=null;)Ve=Ve.slice(0,et.index)+"++"+Ve.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(ot||(Be=""),ot=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ie){return(we=ie.call({lexer:Ee},ne,ue))?(ne=ne.substring(we.raw.length),ue.push(we),!0):!1}))){if(we=this.tokenizer.escape(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.tag(ne)){ne=ne.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(we=this.tokenizer.link(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(we=this.tokenizer.emStrong(ne,Ve,Be)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.codespan(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.br(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.del(ne)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.autolink(ne,j)){ne=ne.substring(we.raw.length),ue.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(ne,j))){ne=ne.substring(we.raw.length),ue.push(we);continue}if(Ge=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var ie=1/0,Q=ne.slice(1),ye=void 0;Ee.options.extensions.startInline.forEach(function(Le){ye=Le.call({lexer:this},Q),typeof ye=="number"&&ye>=0&&(ie=Math.min(ie,ye))}),ie<1/0&&ie>=0&&(Ge=ne.substring(0,ie+1))}(),we=this.tokenizer.inlineText(Ge,ze)){ne=ne.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(Be=we.raw.slice(-1)),ot=!0,Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(ne){var _e="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(_e);break}else throw new Error(_e)}}return ue},e(Te,null,[{key:"rules",get:function(){return{block:Ie,inline:Oe}}}]),Te}(),re=y.exports.defaults,le=M.cleanUrl,Z=M.escape,ae=function(){function Te(ke){this.options=ke||re}var De=Te.prototype;return De.code=function(ne,ue,Ee){var we=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(ne,we);Fe!=null&&Fe!==ne&&(Ee=!0,ne=Fe)}return ne=ne.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+Z(we,!0)+'">'+(Ee?ne:Z(ne,!0))+`</code></pre>
`:"<pre><code>"+(Ee?ne:Z(ne,!0))+`</code></pre>
`},De.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},De.html=function(ne){return ne},De.heading=function(ne,ue,Ee,we){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+we.slug(Ee)+'">'+ne+"</h"+ue+`>
`:"<h"+ue+">"+ne+"</h"+ue+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(ne,ue,Ee){var we=ue?"ol":"ul",Fe=ue&&Ee!==1?' start="'+Ee+'"':"";return"<"+we+Fe+`>
`+ne+"</"+we+`>
`},De.listitem=function(ne){return"<li>"+ne+`</li>
`},De.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(ne){return"<p>"+ne+`</p>
`},De.table=function(ne,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+ue+`</table>
`},De.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},De.tablecell=function(ne,ue){var Ee=ue.header?"th":"td",we=ue.align?"<"+Ee+' align="'+ue.align+'">':"<"+Ee+">";return we+ne+"</"+Ee+`>
`},De.strong=function(ne){return"<strong>"+ne+"</strong>"},De.em=function(ne){return"<em>"+ne+"</em>"},De.codespan=function(ne){return"<code>"+ne+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(ne){return"<del>"+ne+"</del>"},De.link=function(ne,ue,Ee){if(ne=le(this.options.sanitize,this.options.baseUrl,ne),ne===null)return Ee;var we='<a href="'+Z(ne)+'"';return ue&&(we+=' title="'+ue+'"'),we+=">"+Ee+"</a>",we},De.image=function(ne,ue,Ee){if(ne=le(this.options.sanitize,this.options.baseUrl,ne),ne===null)return Ee;var we='<img src="'+ne+'" alt="'+Ee+'"';return ue&&(we+=' title="'+ue+'"'),we+=this.options.xhtml?"/>":">",we},De.text=function(ne){return ne},Te}(),pe=function(){function Te(){}var De=Te.prototype;return De.strong=function(ne){return ne},De.em=function(ne){return ne},De.codespan=function(ne){return ne},De.del=function(ne){return ne},De.html=function(ne){return ne},De.text=function(ne){return ne},De.link=function(ne,ue,Ee){return""+Ee},De.image=function(ne,ue,Ee){return""+Ee},De.br=function(){return""},Te}(),Me=function(){function Te(){this.seen={}}var De=Te.prototype;return De.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(ne,ue){var Ee=ne,we=0;if(this.seen.hasOwnProperty(Ee)){we=this.seen[ne];do we++,Ee=ne+"-"+we;while(this.seen.hasOwnProperty(Ee))}return ue||(this.seen[ne]=we,this.seen[Ee]=0),Ee},De.slug=function(ne,ue){ue===void 0&&(ue={});var Ee=this.serialize(ne);return this.getNextSafeSlug(Ee,ue.dryrun)},Te}(),qe=ae,Qe=pe,Je=Me,rt=y.exports.defaults,Ae=M.unescape,nt=function(){function Te(ke){this.options=ke||rt,this.options.renderer=this.options.renderer||new qe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Qe,this.slugger=new Je}Te.parse=function(ne,ue){var Ee=new Te(ue);return Ee.parse(ne)},Te.parseInline=function(ne,ue){var Ee=new Te(ue);return Ee.parseInline(ne)};var De=Te.prototype;return De.parse=function(ne,ue){ue===void 0&&(ue=!0);var Ee="",we,Fe,Ge,Ve,et,ot,Be,ge,_e,ie,Q,ye,Le,it,Ke,pt,bt,ft,wt,mt=ne.length;for(we=0;we<mt;we++){if(ie=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ie.type]&&(wt=this.options.extensions.renderers[ie.type].call({parser:this},ie),wt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ie.type))){Ee+=wt||"";continue}switch(ie.type){case"space":continue;case"hr":{Ee+=this.renderer.hr();continue}case"heading":{Ee+=this.renderer.heading(this.parseInline(ie.tokens),ie.depth,Ae(this.parseInline(ie.tokens,this.textRenderer)),this.slugger);continue}case"code":{Ee+=this.renderer.code(ie.text,ie.lang,ie.escaped);continue}case"table":{for(ge="",Be="",Ve=ie.header.length,Fe=0;Fe<Ve;Fe++)Be+=this.renderer.tablecell(this.parseInline(ie.header[Fe].tokens),{header:!0,align:ie.align[Fe]});for(ge+=this.renderer.tablerow(Be),_e="",Ve=ie.rows.length,Fe=0;Fe<Ve;Fe++){for(ot=ie.rows[Fe],Be="",et=ot.length,Ge=0;Ge<et;Ge++)Be+=this.renderer.tablecell(this.parseInline(ot[Ge].tokens),{header:!1,align:ie.align[Ge]});_e+=this.renderer.tablerow(Be)}Ee+=this.renderer.table(ge,_e);continue}case"blockquote":{_e=this.parse(ie.tokens),Ee+=this.renderer.blockquote(_e);continue}case"list":{for(Q=ie.ordered,ye=ie.start,Le=ie.loose,Ve=ie.items.length,_e="",Fe=0;Fe<Ve;Fe++)Ke=ie.items[Fe],pt=Ke.checked,bt=Ke.task,it="",Ke.task&&(ft=this.renderer.checkbox(pt),Le?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=ft+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=ft+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:ft}):it+=ft),it+=this.parse(Ke.tokens,Le),_e+=this.renderer.listitem(it,bt,pt);Ee+=this.renderer.list(_e,Q,ye);continue}case"html":{Ee+=this.renderer.html(ie.text);continue}case"paragraph":{Ee+=this.renderer.paragraph(this.parseInline(ie.tokens));continue}case"text":{for(_e=ie.tokens?this.parseInline(ie.tokens):ie.text;we+1<mt&&ne[we+1].type==="text";)ie=ne[++we],_e+=`
`+(ie.tokens?this.parseInline(ie.tokens):ie.text);Ee+=ue?this.renderer.paragraph(_e):_e;continue}default:{var Et='Token with "'+ie.type+'" type was not found.';if(this.options.silent){console.error(Et);return}else throw new Error(Et)}}}return Ee},De.parseInline=function(ne,ue){ue=ue||this.renderer;var Ee="",we,Fe,Ge,Ve=ne.length;for(we=0;we<Ve;we++){if(Fe=ne[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Ge=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){Ee+=Ge||"";continue}switch(Fe.type){case"escape":{Ee+=ue.text(Fe.text);break}case"html":{Ee+=ue.html(Fe.text);break}case"link":{Ee+=ue.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ue));break}case"image":{Ee+=ue.image(Fe.href,Fe.title,Fe.text);break}case"strong":{Ee+=ue.strong(this.parseInline(Fe.tokens,ue));break}case"em":{Ee+=ue.em(this.parseInline(Fe.tokens,ue));break}case"codespan":{Ee+=ue.codespan(Fe.text);break}case"br":{Ee+=ue.br();break}case"del":{Ee+=ue.del(this.parseInline(Fe.tokens,ue));break}case"text":{Ee+=ue.text(Fe.text);break}default:{var et='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}}return Ee},Te}(),J=ee,te=nt,ve=x,Xe=ae,tt=pe,ct=Me,ut=M.merge,_t=M.checkSanitizeDeprecation,ce=M.escape,Pe=y.exports.getDefaults,We=y.exports.changeDefaults,Ye=y.exports.defaults;function $e(Te,De,ke){if(typeof Te=="undefined"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof De=="function"&&(ke=De,De=null),De=ut({},$e.defaults,De||{}),_t(De),ke){var ne=De.highlight,ue;try{ue=J.lex(Te,De)}catch(Ge){return ke(Ge)}var Ee=function(Ve){var et;if(!Ve)try{De.walkTokens&&$e.walkTokens(ue,De.walkTokens),et=te.parse(ue,De)}catch(ot){Ve=ot}return De.highlight=ne,Ve?ke(Ve):ke(null,et)};if(!ne||ne.length<3||(delete De.highlight,!ue.length))return Ee();var we=0;$e.walkTokens(ue,function(Ge){Ge.type==="code"&&(we++,setTimeout(function(){ne(Ge.text,Ge.lang,function(Ve,et){if(Ve)return Ee(Ve);et!=null&&et!==Ge.text&&(Ge.text=et,Ge.escaped=!0),we--,we===0&&Ee()})},0))}),we===0&&Ee();return}try{var Fe=J.lex(Te,De);return De.walkTokens&&$e.walkTokens(Fe,De.walkTokens),te.parse(Fe,De)}catch(Ge){if(Ge.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+ce(Ge.message+"",!0)+"</pre>";throw Ge}}$e.options=$e.setOptions=function(Te){return ut($e.defaults,Te),We($e.defaults),$e},$e.getDefaults=Pe,$e.defaults=Ye,$e.use=function(){for(var Te=this,De=arguments.length,ke=new Array(De),ne=0;ne<De;ne++)ke[ne]=arguments[ne];var ue=ut.apply(void 0,[{}].concat(ke)),Ee=$e.defaults.extensions||{renderers:{},childTokens:{}},we;ke.forEach(function(Fe){if(Fe.extensions&&(we=!0,Fe.extensions.forEach(function(Ve){if(!Ve.name)throw new Error("extension name required");if(Ve.renderer){var et=Ee.renderers?Ee.renderers[Ve.name]:null;et?Ee.renderers[Ve.name]=function(){for(var ot=arguments.length,Be=new Array(ot),ge=0;ge<ot;ge++)Be[ge]=arguments[ge];var _e=Ve.renderer.apply(this,Be);return _e===!1&&(_e=et.apply(this,Be)),_e}:Ee.renderers[Ve.name]=Ve.renderer}if(Ve.tokenizer){if(!Ve.level||Ve.level!=="block"&&Ve.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Ee[Ve.level]?Ee[Ve.level].unshift(Ve.tokenizer):Ee[Ve.level]=[Ve.tokenizer],Ve.start&&(Ve.level==="block"?Ee.startBlock?Ee.startBlock.push(Ve.start):Ee.startBlock=[Ve.start]:Ve.level==="inline"&&(Ee.startInline?Ee.startInline.push(Ve.start):Ee.startInline=[Ve.start]))}Ve.childTokens&&(Ee.childTokens[Ve.name]=Ve.childTokens)})),Fe.renderer&&function(){var Ve=$e.defaults.renderer||new Xe,et=function(ge){var _e=Ve[ge];Ve[ge]=function(){for(var ie=arguments.length,Q=new Array(ie),ye=0;ye<ie;ye++)Q[ye]=arguments[ye];var Le=Fe.renderer[ge].apply(Ve,Q);return Le===!1&&(Le=_e.apply(Ve,Q)),Le}};for(var ot in Fe.renderer)et(ot);ue.renderer=Ve}(),Fe.tokenizer&&function(){var Ve=$e.defaults.tokenizer||new ve,et=function(ge){var _e=Ve[ge];Ve[ge]=function(){for(var ie=arguments.length,Q=new Array(ie),ye=0;ye<ie;ye++)Q[ye]=arguments[ye];var Le=Fe.tokenizer[ge].apply(Ve,Q);return Le===!1&&(Le=_e.apply(Ve,Q)),Le}};for(var ot in Fe.tokenizer)et(ot);ue.tokenizer=Ve}(),Fe.walkTokens){var Ge=$e.defaults.walkTokens;ue.walkTokens=function(Ve){Fe.walkTokens.call(Te,Ve),Ge&&Ge(Ve)}}we&&(ue.extensions=Ee),$e.setOptions(ue)})},$e.walkTokens=function(Te,De){for(var ke=function(){var we=ue.value;switch(De(we),we.type){case"table":{for(var Fe=C(we.header),Ge;!(Ge=Fe()).done;){var Ve=Ge.value;$e.walkTokens(Ve.tokens,De)}for(var et=C(we.rows),ot;!(ot=et()).done;)for(var Be=ot.value,ge=C(Be),_e;!(_e=ge()).done;){var ie=_e.value;$e.walkTokens(ie.tokens,De)}break}case"list":{$e.walkTokens(we.items,De);break}default:$e.defaults.extensions&&$e.defaults.extensions.childTokens&&$e.defaults.extensions.childTokens[we.type]?$e.defaults.extensions.childTokens[we.type].forEach(function(Q){$e.walkTokens(we[Q],De)}):we.tokens&&$e.walkTokens(we.tokens,De)}},ne=C(Te),ue;!(ue=ne()).done;)ke()},$e.parseInline=function(Te,De){if(typeof Te=="undefined"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");De=ut({},$e.defaults,De||{}),_t(De);try{var ke=J.lexInline(Te,De);return De.walkTokens&&$e.walkTokens(ke,De.walkTokens),te.parseInline(ke,De)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+ce(ne.message+"",!0)+"</pre>";throw ne}},$e.Parser=te,$e.parser=te.parse,$e.Renderer=Xe,$e.TextRenderer=tt,$e.Lexer=J,$e.lexer=J.lex,$e.Tokenizer=ve,$e.Slugger=ct,$e.parse=$e;var lt=$e;return lt}),define(fe[77],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function f(A,_,S){return Math.min(Math.max(A,_),S)}e.clamp=f;function F(A,_){return(_+A%_)%_}e.rot=F;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class y{constructor(){this._n=1,this._val=0}update(_){return this._val=this._val+(_-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y}),function(){function Y(C){const y=[];typeof C=="number"&&y.push("code/timeOrigin",C);function A(S){y.push(S,Date.now())}function _(){const S=[];for(let P=0;P<y.length;P+=2)S.push({name:y[P],startTime:y[P+1]});return S}return{mark:A,getMarks:_}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))y.push({name:A.name,startTime:Math.round(C+A.startTime)});return y}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function f(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return f(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=f(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=f(F))}(),define(fe[11],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const f="en";let F=!1,C=!1,y=!1,A=!1,_=!1,S=!1,P=!1,n,k=f,a,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const v=typeof d?.versions?.electron=="string"&&d.type==="renderer";if(e.isElectronSandboxed=v&&d?.sandboxed,typeof navigator=="object"&&!v)m=navigator.userAgent,F=m.indexOf("Windows")>=0,C=m.indexOf("Macintosh")>=0,P=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=m.indexOf("Linux")>=0,S=!0,n=navigator.language,k=n;else if(typeof d=="object"){F=d.platform==="win32",C=d.platform==="darwin",y=d.platform==="linux",A=y&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,n=f,k=f;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const i=JSON.parse(r),s=i.availableLanguages["*"];n=i.locale,k=s||f,a=i._translationsConfigFile}catch(i){}_=!0}else console.error("Unable to resolve platform.");var D;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function I(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=I;let b=0;C?b=1:F?b=3:y&&(b=2),e.isWindows=F,e.isMacintosh=C,e.isLinux=y,e.isLinuxSnap=A,e.isNative=_,e.isWeb=S,e.isIOS=P,e.platform=b,e.userAgent=m,e.language=k;var l;(function(r){function i(){return e.language}r.value=i;function s(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=s;function c(){return e.language==="en"}r.isDefault=c})(l=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=a,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeSetImmediateId)for(let w=0,E=s.length;w<E;w++){const p=s[w];if(p.id===h.data.vscodeSetImmediateId){s.splice(w,1),p.callback();return}}});let c=0;return h=>{const w=++c;s.push({id:w,callback:h}),e.globals.postMessage({vscodeSetImmediateId:w},"*")}}if(typeof d?.nextTick=="function")return d.nextTick.bind(d);const i=Promise.resolve();return s=>i.then(s)}();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||P?2:F?1:3;let g=!0,t=!1;function u(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,g=new Uint16Array(r.buffer)[0]===(2<<8)+1}return g}e.isLittleEndian=u}),define(fe[38],me([0,1,11]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let F;if(typeof f.globals.vscode!="undefined"&&typeof f.globals.vscode.process!="undefined"){const C=f.globals.vscode.process;F={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()},nextTick(y){return(0,f.setImmediate)(y)}}}else typeof process!="undefined"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:F={get platform(){return f.isWindows?"win32":f.isMacintosh?"darwin":"linux"},get arch(){},nextTick(C){return(0,f.setImmediate)(C)},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.platform=F.platform,e.nextTick=F.nextTick,e.arch=F.arch}),define(fe[8],me([0,1,38]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const F=65,C=97,y=90,A=122,_=46,S=47,P=92,n=58,k=63;class a extends Error{constructor(o,g,t){let u;typeof g=="string"&&g.indexOf("not ")===0?(u="must not be",g=g.replace(/^not /,"")):u="must be";const r=o.indexOf(".")!==-1?"property":"argument";let i=`The "${o}" ${r} ${u} of type ${g}`;i+=`. Received type ${typeof t}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function m(l,o){if(typeof l!="string")throw new a(o,"string",l)}function d(l){return l===S||l===P}function v(l){return l===S}function D(l){return l>=F&&l<=y||l>=C&&l<=A}function I(l,o,g,t){let u="",r=0,i=-1,s=0,c=0;for(let h=0;h<=l.length;++h){if(h<l.length)c=l.charCodeAt(h);else{if(t(c))break;c=S}if(t(c)){if(!(i===h-1||s===1))if(s===2){if(u.length<2||r!==2||u.charCodeAt(u.length-1)!==_||u.charCodeAt(u.length-2)!==_){if(u.length>2){const w=u.lastIndexOf(g);w===-1?(u="",r=0):(u=u.slice(0,w),r=u.length-1-u.lastIndexOf(g)),i=h,s=0;continue}else if(u.length!==0){u="",r=0,i=h,s=0;continue}}o&&(u+=u.length>0?`${g}..`:"..",r=2)}else u.length>0?u+=`${g}${l.slice(i+1,h)}`:u=l.slice(i+1,h),r=h-i-1;i=h,s=0}else c===_&&s!==-1?++s:s=-1}return u}function b(l,o){if(o===null||typeof o!="object")throw new a("pathObject","Object",o);const g=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return g?g===o.root?`${g}${t}`:`${g}${l}${t}`:t}e.win32={resolve(...l){let o="",g="",t=!1;for(let u=l.length-1;u>=-1;u--){let r;if(u>=0){if(r=l[u],m(r,"path"),r.length===0)continue}else o.length===0?r=f.cwd():(r=f.env[`=${o}`]||f.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===P)&&(r=`${o}\\`));const i=r.length;let s=0,c="",h=!1;const w=r.charCodeAt(0);if(i===1)d(w)&&(s=1,h=!0);else if(d(w))if(h=!0,d(r.charCodeAt(1))){let E=2,p=E;for(;E<i&&!d(r.charCodeAt(E));)E++;if(E<i&&E!==p){const T=r.slice(p,E);for(p=E;E<i&&d(r.charCodeAt(E));)E++;if(E<i&&E!==p){for(p=E;E<i&&!d(r.charCodeAt(E));)E++;(E===i||E!==p)&&(c=`\\\\${T}\\${r.slice(p,E)}`,s=E)}}}else s=1;else D(w)&&r.charCodeAt(1)===n&&(c=r.slice(0,2),s=2,i>2&&d(r.charCodeAt(2))&&(h=!0,s=3));if(c.length>0)if(o.length>0){if(c.toLowerCase()!==o.toLowerCase())continue}else o=c;if(t){if(o.length>0)break}else if(g=`${r.slice(s)}\\${g}`,t=h,h&&o.length>0)break}return g=I(g,!t,"\\",d),t?`${o}\\${g}`:`${o}${g}`||"."},normalize(l){m(l,"path");const o=l.length;if(o===0)return".";let g=0,t,u=!1;const r=l.charCodeAt(0);if(o===1)return v(r)?"\\":l;if(d(r))if(u=!0,d(l.charCodeAt(1))){let s=2,c=s;for(;s<o&&!d(l.charCodeAt(s));)s++;if(s<o&&s!==c){const h=l.slice(c,s);for(c=s;s<o&&d(l.charCodeAt(s));)s++;if(s<o&&s!==c){for(c=s;s<o&&!d(l.charCodeAt(s));)s++;if(s===o)return`\\\\${h}\\${l.slice(c)}\\`;s!==c&&(t=`\\\\${h}\\${l.slice(c,s)}`,g=s)}}}else g=1;else D(r)&&l.charCodeAt(1)===n&&(t=l.slice(0,2),g=2,o>2&&d(l.charCodeAt(2))&&(u=!0,g=3));let i=g<o?I(l.slice(g),!u,"\\",d):"";return i.length===0&&!u&&(i="."),i.length>0&&d(l.charCodeAt(o-1))&&(i+="\\"),t===void 0?u?`\\${i}`:i:u?`${t}\\${i}`:`${t}${i}`},isAbsolute(l){m(l,"path");const o=l.length;if(o===0)return!1;const g=l.charCodeAt(0);return d(g)||o>2&&D(g)&&l.charCodeAt(1)===n&&d(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let o,g;for(let r=0;r<l.length;++r){const i=l[r];m(i,"path"),i.length>0&&(o===void 0?o=g=i:o+=`\\${i}`)}if(o===void 0)return".";let t=!0,u=0;if(typeof g=="string"&&d(g.charCodeAt(0))){++u;const r=g.length;r>1&&d(g.charCodeAt(1))&&(++u,r>2&&(d(g.charCodeAt(2))?++u:t=!1))}if(t){for(;u<o.length&&d(o.charCodeAt(u));)u++;u>=2&&(o=`\\${o.slice(u)}`)}return e.win32.normalize(o)},relative(l,o){if(m(l,"from"),m(o,"to"),l===o)return"";const g=e.win32.resolve(l),t=e.win32.resolve(o);if(g===t||(l=g.toLowerCase(),o=t.toLowerCase(),l===o))return"";let u=0;for(;u<l.length&&l.charCodeAt(u)===P;)u++;let r=l.length;for(;r-1>u&&l.charCodeAt(r-1)===P;)r--;const i=r-u;let s=0;for(;s<o.length&&o.charCodeAt(s)===P;)s++;let c=o.length;for(;c-1>s&&o.charCodeAt(c-1)===P;)c--;const h=c-s,w=i<h?i:h;let E=-1,p=0;for(;p<w;p++){const L=l.charCodeAt(u+p);if(L!==o.charCodeAt(s+p))break;L===P&&(E=p)}if(p!==w){if(E===-1)return t}else{if(h>w){if(o.charCodeAt(s+p)===P)return t.slice(s+p+1);if(p===2)return t.slice(s+p)}i>w&&(l.charCodeAt(u+p)===P?E=p:p===2&&(E=3)),E===-1&&(E=0)}let T="";for(p=u+E+1;p<=r;++p)(p===r||l.charCodeAt(p)===P)&&(T+=T.length===0?"..":"\\..");return s+=E,T.length>0?`${T}${t.slice(s,c)}`:(t.charCodeAt(s)===P&&++s,t.slice(s,c))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const o=e.win32.resolve(l);if(o.length<=2)return l;if(o.charCodeAt(0)===P){if(o.charCodeAt(1)===P){const g=o.charCodeAt(2);if(g!==k&&g!==_)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(D(o.charCodeAt(0))&&o.charCodeAt(1)===n&&o.charCodeAt(2)===P)return`\\\\?\\${o}`;return l},dirname(l){m(l,"path");const o=l.length;if(o===0)return".";let g=-1,t=0;const u=l.charCodeAt(0);if(o===1)return d(u)?l:".";if(d(u)){if(g=t=1,d(l.charCodeAt(1))){let s=2,c=s;for(;s<o&&!d(l.charCodeAt(s));)s++;if(s<o&&s!==c){for(c=s;s<o&&d(l.charCodeAt(s));)s++;if(s<o&&s!==c){for(c=s;s<o&&!d(l.charCodeAt(s));)s++;if(s===o)return l;s!==c&&(g=t=s+1)}}}}else D(u)&&l.charCodeAt(1)===n&&(g=o>2&&d(l.charCodeAt(2))?3:2,t=g);let r=-1,i=!0;for(let s=o-1;s>=t;--s)if(d(l.charCodeAt(s))){if(!i){r=s;break}}else i=!1;if(r===-1){if(g===-1)return".";r=g}return l.slice(0,r)},basename(l,o){o!==void 0&&m(o,"ext"),m(l,"path");let g=0,t=-1,u=!0,r;if(l.length>=2&&D(l.charCodeAt(0))&&l.charCodeAt(1)===n&&(g=2),o!==void 0&&o.length>0&&o.length<=l.length){if(o===l)return"";let i=o.length-1,s=-1;for(r=l.length-1;r>=g;--r){const c=l.charCodeAt(r);if(d(c)){if(!u){g=r+1;break}}else s===-1&&(u=!1,s=r+1),i>=0&&(c===o.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=s))}return g===t?t=s:t===-1&&(t=l.length),l.slice(g,t)}for(r=l.length-1;r>=g;--r)if(d(l.charCodeAt(r))){if(!u){g=r+1;break}}else t===-1&&(u=!1,t=r+1);return t===-1?"":l.slice(g,t)},extname(l){m(l,"path");let o=0,g=-1,t=0,u=-1,r=!0,i=0;l.length>=2&&l.charCodeAt(1)===n&&D(l.charCodeAt(0))&&(o=t=2);for(let s=l.length-1;s>=o;--s){const c=l.charCodeAt(s);if(d(c)){if(!r){t=s+1;break}continue}u===-1&&(r=!1,u=s+1),c===_?g===-1?g=s:i!==1&&(i=1):g!==-1&&(i=-1)}return g===-1||u===-1||i===0||i===1&&g===u-1&&g===t+1?"":l.slice(g,u)},format:b.bind(null,"\\"),parse(l){m(l,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return o;const g=l.length;let t=0,u=l.charCodeAt(0);if(g===1)return d(u)?(o.root=o.dir=l,o):(o.base=o.name=l,o);if(d(u)){if(t=1,d(l.charCodeAt(1))){let E=2,p=E;for(;E<g&&!d(l.charCodeAt(E));)E++;if(E<g&&E!==p){for(p=E;E<g&&d(l.charCodeAt(E));)E++;if(E<g&&E!==p){for(p=E;E<g&&!d(l.charCodeAt(E));)E++;E===g?t=E:E!==p&&(t=E+1)}}}}else if(D(u)&&l.charCodeAt(1)===n){if(g<=2)return o.root=o.dir=l,o;if(t=2,d(l.charCodeAt(2))){if(g===3)return o.root=o.dir=l,o;t=3}}t>0&&(o.root=l.slice(0,t));let r=-1,i=t,s=-1,c=!0,h=l.length-1,w=0;for(;h>=t;--h){if(u=l.charCodeAt(h),d(u)){if(!c){i=h+1;break}continue}s===-1&&(c=!1,s=h+1),u===_?r===-1?r=h:w!==1&&(w=1):r!==-1&&(w=-1)}return s!==-1&&(r===-1||w===0||w===1&&r===s-1&&r===i+1?o.base=o.name=l.slice(i,s):(o.name=l.slice(i,r),o.base=l.slice(i,s),o.ext=l.slice(r,s))),i>0&&i!==t?o.dir=l.slice(0,i-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let o="",g=!1;for(let t=l.length-1;t>=-1&&!g;t--){const u=t>=0?l[t]:f.cwd();m(u,"path"),u.length!==0&&(o=`${u}/${o}`,g=u.charCodeAt(0)===S)}return o=I(o,!g,"/",v),g?`/${o}`:o.length>0?o:"."},normalize(l){if(m(l,"path"),l.length===0)return".";const o=l.charCodeAt(0)===S,g=l.charCodeAt(l.length-1)===S;return l=I(l,!o,"/",v),l.length===0?o?"/":g?"./":".":(g&&(l+="/"),o?`/${l}`:l)},isAbsolute(l){return m(l,"path"),l.length>0&&l.charCodeAt(0)===S},join(...l){if(l.length===0)return".";let o;for(let g=0;g<l.length;++g){const t=l[g];m(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(l,o){if(m(l,"from"),m(o,"to"),l===o||(l=e.posix.resolve(l),o=e.posix.resolve(o),l===o))return"";const g=1,t=l.length,u=t-g,r=1,i=o.length-r,s=u<i?u:i;let c=-1,h=0;for(;h<s;h++){const E=l.charCodeAt(g+h);if(E!==o.charCodeAt(r+h))break;E===S&&(c=h)}if(h===s)if(i>s){if(o.charCodeAt(r+h)===S)return o.slice(r+h+1);if(h===0)return o.slice(r+h)}else u>s&&(l.charCodeAt(g+h)===S?c=h:h===0&&(c=0));let w="";for(h=g+c+1;h<=t;++h)(h===t||l.charCodeAt(h)===S)&&(w+=w.length===0?"..":"/..");return`${w}${o.slice(r+c)}`},toNamespacedPath(l){return l},dirname(l){if(m(l,"path"),l.length===0)return".";const o=l.charCodeAt(0)===S;let g=-1,t=!0;for(let u=l.length-1;u>=1;--u)if(l.charCodeAt(u)===S){if(!t){g=u;break}}else t=!1;return g===-1?o?"/":".":o&&g===1?"//":l.slice(0,g)},basename(l,o){o!==void 0&&m(o,"ext"),m(l,"path");let g=0,t=-1,u=!0,r;if(o!==void 0&&o.length>0&&o.length<=l.length){if(o===l)return"";let i=o.length-1,s=-1;for(r=l.length-1;r>=0;--r){const c=l.charCodeAt(r);if(c===S){if(!u){g=r+1;break}}else s===-1&&(u=!1,s=r+1),i>=0&&(c===o.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=s))}return g===t?t=s:t===-1&&(t=l.length),l.slice(g,t)}for(r=l.length-1;r>=0;--r)if(l.charCodeAt(r)===S){if(!u){g=r+1;break}}else t===-1&&(u=!1,t=r+1);return t===-1?"":l.slice(g,t)},extname(l){m(l,"path");let o=-1,g=0,t=-1,u=!0,r=0;for(let i=l.length-1;i>=0;--i){const s=l.charCodeAt(i);if(s===S){if(!u){g=i+1;break}continue}t===-1&&(u=!1,t=i+1),s===_?o===-1?o=i:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||t===-1||r===0||r===1&&o===t-1&&o===g+1?"":l.slice(o,t)},format:b.bind(null,"/"),parse(l){m(l,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return o;const g=l.charCodeAt(0)===S;let t;g?(o.root="/",t=1):t=0;let u=-1,r=0,i=-1,s=!0,c=l.length-1,h=0;for(;c>=t;--c){const w=l.charCodeAt(c);if(w===S){if(!s){r=c+1;break}continue}i===-1&&(s=!1,i=c+1),w===_?u===-1?u=c:h!==1&&(h=1):u!==-1&&(h=-1)}if(i!==-1){const w=r===0&&g?1:r;u===-1||h===0||h===1&&u===i-1&&u===r+1?o.base=o.name=l.slice(w,i):(o.name=l.slice(w,u),o.base=l.slice(w,i),o.ext=l.slice(u,i))}return r>0?o.dir=l.slice(0,r-1):g&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=f.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f.platform==="win32"?e.win32.join:e.posix.join,e.resolve=f.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=f.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=f.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=f.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=f.platform==="win32"?e.win32.extname:e.posix.extname,e.format=f.platform==="win32"?e.win32.format:e.posix.format,e.parse=f.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=f.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=f.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(fe[96],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var f;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(f=e.Source||(e.Source={}));var F;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(F=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(y,...A){const _=A.reduce((n,k)=>(n[k]=!0,n),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(n=>!_[n]).forEach(n=>{for(let k=0;k<S.length;k++)if(n.search(S[k])!==-1){delete y[n];break}})}e.sanitizeProcessEnvironment=C}),define(fe[142],me([0,1]),function(Y,e){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class F{constructor(_,S,P){this.level=_,this.key=S,this.value=P,this.forward=[]}}const C=void 0;class y{constructor(_,S=2**16){this.comparator=_,this[f]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(S)|0),this._header=new F(this._maxLevel,C,C)}get size(){return this._size}clear(){this._header=new F(this._maxLevel,C,C)}has(_){return Boolean(y._search(this,_,this.comparator))}get(_){return y._search(this,_,this.comparator)?.value}set(_,S){return y._insert(this,_,S,this.comparator)&&(this._size+=1),this}delete(_){const S=y._delete(this,_,this.comparator);return S&&(this._size-=1),S}forEach(_,S){let P=this._header.forward[0];for(;P;)_.call(S,P.value,P.key,this),P=P.forward[0]}[(f=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let _=this._header.forward[0];for(;_;)yield[_.key,_.value],_=_.forward[0]}*keys(){let _=this._header.forward[0];for(;_;)yield _.key,_=_.forward[0]}*values(){let _=this._header.forward[0];for(;_;)yield _.value,_=_.forward[0]}toString(){let _="[SkipList]:",S=this._header.forward[0];for(;S;)_+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return _}static _search(_,S,P){let n=_._header;for(let k=_._level-1;k>=0;k--)for(;n.forward[k]&&P(n.forward[k].key,S)<0;)n=n.forward[k];if(n=n.forward[0],n&&P(n.key,S)===0)return n}static _insert(_,S,P,n){let k=[],a=_._header;for(let m=_._level-1;m>=0;m--){for(;a.forward[m]&&n(a.forward[m].key,S)<0;)a=a.forward[m];k[m]=a}if(a=a.forward[0],a&&n(a.key,S)===0)return a.value=P,!1;{let m=y._randomLevel(_);if(m>_._level){for(let d=_._level;d<m;d++)k[d]=_._header;_._level=m}a=new F(m,S,P);for(let d=0;d<m;d++)a.forward[d]=k[d].forward[d],k[d].forward[d]=a;return!0}}static _randomLevel(_,S=.5){let P=1;for(;Math.random()<S&&P<_._maxLevel;)P+=1;return P}static _delete(_,S,P){let n=[],k=_._header;for(let a=_._level-1;a>=0;a--){for(;k.forward[a]&&P(k.forward[a].key,S)<0;)k=k.forward[a];n[a]=k}if(k=k.forward[0],!k||P(k.key,S)!==0)return!1;for(let a=0;a<_._level&&n[a].forward[a]===k;a++)n[a].forward[a]=k.forward[a];for(;_._level>0&&_._header.forward[_._level-1]===C;)_._level-=1;return!0}}e.SkipList=y}),define(fe[46],me([0,1,11]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const F=f.globals.performance&&typeof f.globals.performance.now=="function";class C{constructor(A){this._highResolution=F&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new C(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?f.globals.performance.now():Date.now()}}e.StopWatch=C}),define(fe[3],me([0,1,18,75,6,95,46]),function(Y,e,f,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var _;(function(o){o.None=()=>C.Disposable.None;function g(O){return(V,N=null,U)=>{let x=!1,B;return B=O(H=>{if(!x)return B?B.dispose():x=!0,V.call(N,H)},null,U),x&&B.dispose(),B}}o.once=g;function t(O,V){return h((N,U=null,x)=>O(B=>N.call(U,V(B)),null,x))}o.map=t;function u(O,V){return h((N,U=null,x)=>O(B=>{V(B),N.call(U,B)},null,x))}o.forEach=u;function r(O,V){return h((N,U=null,x)=>O(B=>V(B)&&N.call(U,B),null,x))}o.filter=r;function i(O){return O}o.signal=i;function s(...O){return(V,N=null,U)=>(0,C.combinedDisposable)(...O.map(x=>x(B=>V.call(N,B),null,U)))}o.any=s;function c(O,V,N){let U=N;return t(O,x=>(U=V(U,x),U))}o.reduce=c;function h(O){let V;const N=new a({onFirstListenerAdd(){V=O(N.fire,N)},onLastListenerRemove(){V.dispose()}});return N.event}function w(O,V,N=100,U=!1,x){let B,H,G,K=0;const X=new a({leakWarningThreshold:x,onFirstListenerAdd(){B=O(de=>{K++,H=V(H,de),U&&!G&&(X.fire(H),H=void 0),clearTimeout(G),G=setTimeout(()=>{const be=H;H=void 0,G=void 0,(!U||K>1)&&X.fire(be),K=0},N)})},onLastListenerRemove(){B.dispose()}});return X.event}o.debounce=w;function E(O,V=(N,U)=>N===U){let N=!0,U;return r(O,x=>{const B=N||!V(x,U);return N=!1,U=x,B})}o.latch=E;function p(O,V){return[o.filter(O,V),o.filter(O,N=>!V(N))]}o.split=p;function T(O,V=!1,N=[]){let U=N.slice(),x=O(G=>{U?U.push(G):H.fire(G)});const B=()=>{U&&U.forEach(G=>H.fire(G)),U=null},H=new a({onFirstListenerAdd(){x||(x=O(G=>H.fire(G)))},onFirstListenerDidAdd(){U&&(V?setTimeout(B):B())},onLastListenerRemove(){x&&x.dispose(),x=null}});return H.event}o.buffer=T;class L{constructor(V){this.event=V}map(V){return new L(t(this.event,V))}forEach(V){return new L(u(this.event,V))}filter(V){return new L(r(this.event,V))}reduce(V,N){return new L(c(this.event,V,N))}latch(){return new L(E(this.event))}debounce(V,N=100,U=!1,x){return new L(w(this.event,V,N,U,x))}on(V,N,U){return this.event(V,N,U)}once(V,N,U){return g(this.event)(V,N,U)}}function M(O){return new L(O)}o.chain=M;function R(O,V,N=U=>U){const U=(...G)=>H.fire(N(...G)),x=()=>O.on(V,U),B=()=>O.removeListener(V,U),H=new a({onFirstListenerAdd:x,onLastListenerRemove:B});return H.event}o.fromNodeEventEmitter=R;function $(O,V,N=U=>U){const U=(...G)=>H.fire(N(...G)),x=()=>O.addEventListener(V,U),B=()=>O.removeEventListener(V,U),H=new a({onFirstListenerAdd:x,onLastListenerRemove:B});return H.event}o.fromDOMEventEmitter=$;function z(O){return new Promise(V=>g(O)(V))}o.toPromise=z})(_=e.Event||(e.Event={}));class S{constructor(g){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${g}_${S._idPool++}`}start(g){this._stopWatch=new A.StopWatch(!0),this._listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this._elapsedOverall+=g,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${g.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let P=-1;function n(o){const g=P;return P=o,{dispose(){P=g}}}e.setGlobalLeakWarningThreshold=n;class k{constructor(g,t=Math.random().toString(18).slice(2,5)){this.customThreshold=g,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(g){let t=P;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||g<t)return;this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(u)||0;if(this._stacks.set(u,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let i,s=0;for(const[c,h]of this._stacks)(!i||s<h)&&(i=c,s=h);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(u)||0;this._stacks.set(u,i-1)}}}class a{constructor(g){this._disposed=!1,this._options=g,this._leakageMon=P>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(g,t,u)=>{this._listeners||(this._listeners=new y.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(t?[g,t]:g);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,g,t);const s=this._leakageMon?.check(this._listeners.size),c=(0,C.toDisposable)(()=>{s&&s(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return u instanceof C.DisposableStore?u.add(c):Array.isArray(u)&&u.push(c),c}),this._event}fire(g){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,g]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,u]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,u):t[0].call(t[1],u)}catch(r){(0,f.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=a;class m extends a{async fireAsync(g,t,u){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,g]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),s=[],c={...i,waitUntil:h=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");u&&(h=u(h,typeof r=="function"?r:r[0])),s.push(h)}};try{typeof r=="function"?r.call(void 0,c):r[0].call(r[1],c)}catch(h){(0,f.onUnexpectedError)(h);continue}Object.freeze(s),await Promise.allSettled(s).then(h=>{for(const w of h)w.status==="rejected"&&(0,f.onUnexpectedError)(w.reason)})}}}}e.AsyncEmitter=m;class d extends a{constructor(g){super(g);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=g?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._listeners&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}e.PauseableEmitter=d;class v extends d{constructor(g){super(g);this._delay=g.delay??100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}e.DebounceEmitter=v;class D extends a{constructor(g){super(g);this._queuedEvents=[],this._mergeFn=g?.merge}fire(g){this._queuedEvents.push(g),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=D;class I{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new a({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(g){const t={event:g,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const u=()=>{this.hasListeners&&this.unhook(t);const r=this.events.indexOf(t);this.events.splice(r,1)};return(0,C.toDisposable)((0,F.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(g=>this.hook(g))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(g=>this.unhook(g))}hook(g){g.listener=g.event(t=>this.emitter.fire(t))}unhook(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=I;class b{constructor(){this.buffers=[]}wrapEvent(g){return(t,u,r)=>g(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>t.call(u,i)):t.call(u,i)},void 0,r)}bufferEvents(g){const t=[];this.buffers.push(t);const u=g();return this.buffers.pop(),t.forEach(r=>r()),u}}e.EventBufferer=b;class l{constructor(){this.listening=!1,this.inputEvent=_.None,this.inputEventListener=C.Disposable.None,this.emitter=new a({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=l}),define(fe[21],me([0,1,3]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const F=Object.freeze(function(_,S){const P=setTimeout(_.bind(S),0);return{dispose(){clearTimeout(P)}}});var C;(function(_){function S(P){return P===_.None||P===_.Cancelled||P instanceof y?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}_.isCancellationToken=S,_.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:f.Event.None}),_.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(C=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?F:(this._emitter||(this._emitter=new f.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=C.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=A}),define(fe[47],me([0,1,3]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class F{constructor(){this._icons=new Map,this._onDidRegister=new f.Emitter}add(k){const a=this._icons.get(k.id);a?k.description?a.description=k.description:console.error(`Duplicate registration of codicon ${k.id}`):(this._icons.set(k.id,k),this._onDidRegister.fire(k))}get(k){return this._icons.get(k)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new F;e.iconRegistry=C;function y(n,k){return new _(n,k)}e.registerCodicon=y;function A(n){return n?n.replace(/\$\((.*?)\)/g,(k,a)=>` ${a} `).trim():""}e.getCodiconAriaLabel=A;class _{constructor(k,a,m){this.id=k,this.definition=a,this.description=m,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=_;function S(n,k){const a=["codicon","codicon-"+n];return k&&a.push("codicon-modifier-"+k),a}e.getClassNamesArray=S;var P;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const k=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function a(v){if(v instanceof _)return["codicon","codicon-"+v.id];const D=k.exec(v.id);if(!D)return a(_.error);let[,I,b]=D;const l=["codicon","codicon-"+I];return b&&l.push("codicon-modifier-"+b.substr(1)),l}n.asClassNameArray=a;function m(v){return a(v).join(" ")}n.asClassName=m;function d(v){return"."+a(v).join(".")}n.asCSSSelector=d})(P=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",{fontCharacter:"\\eb0f"}),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(_=e.Codicon||(e.Codicon={}))}),define(fe[97],me([0,1,18,6]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(l){const o=l;return o?[o.on,o.pause,o.resume,o.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=C;function y(l){const o=l;return o?C(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=y;function A(l,o){return new _(l,o)}e.newWriteableStream=A;class _{constructor(o,g){this.reducer=o,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(g=>this.pendingWritePromises.push(g))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(g=>g(o))}emitError(o){this.listeners.error.length===0?(0,f.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(g=>g(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,g){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(o,g){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const u=t.indexOf(g);u>=0&&t.splice(u,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(l,o){const g=[];let t;for(;(t=l.read())!==null;)g.push(t);return o(g)}e.consumeReadable=S;function P(l,o,g){const t=[];let u;for(;(u=l.read())!==null&&t.length<g;)t.push(u);return u===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof u!="undefined"){const r=u;return u=void 0,r}return l.read()}}}e.peekReadable=P;function n(l,o){return new Promise((g,t)=>{const u=[];k(l,{onData:r=>{o&&u.push(r)},onError:r=>{o?t(r):g(void 0)},onEnd:()=>{g(o?o(u):void 0)}})})}e.consumeStream=n;function k(l,o){l.on("error",g=>o.onError(g)),l.on("end",()=>o.onEnd()),l.on("data",g=>o.onData(g))}e.listenStream=k;function a(l,o){return new Promise((g,t)=>{const u=new F.DisposableStore,r=[],i=h=>{if(r.push(h),r.length>o)return u.dispose(),l.pause(),g({stream:l,buffer:r,ended:!1})},s=h=>t(h),c=()=>g({stream:l,buffer:r,ended:!0});u.add((0,F.toDisposable)(()=>l.removeListener("error",s))),l.on("error",s),u.add((0,F.toDisposable)(()=>l.removeListener("end",c))),l.on("end",c),u.add((0,F.toDisposable)(()=>l.removeListener("data",i))),l.on("data",i)})}e.peekStream=a;function m(l,o){const g=A(o);return g.end(l),g}e.toStream=m;function d(){const l=A(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=d;function v(l){let o=!1;return{read:()=>o?null:(o=!0,l)}}e.toReadable=v;function D(l,o,g){const t=A(g);return k(l,{onData:u=>t.write(o.data(u)),onError:u=>t.error(o.error?o.error(u):u),onEnd:()=>t.end()}),t}e.transform=D;function I(l,o,g){let t=!1;return{read:()=>{const u=o.read();return t?u:(t=!0,u!==null?g([l,u]):l)}}}e.prefixedReadable=I;function b(l,o,g){let t=!1;const u=A(g);return k(o,{onData:r=>t?u.write(r):(t=!0,u.write(g([l,r]))),onError:r=>u.error(r),onEnd:()=>{t||(t=!0,u.write(l)),u.end()}}),u}e.prefixedStream=b}),define(fe[22],me([0,1,97]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const F=typeof Buffer!="undefined";let C,y;class A{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return F?new A(Buffer.allocUnsafe(i)):new A(new Uint8Array(i))}static wrap(i){return F&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new A(i)}static fromString(i,s){return!(s?.dontUseNodeBuffer||!1)&&F?new A(Buffer.from(i)):(C||(C=new TextEncoder),new A(C.encode(i)))}static concat(i,s){if(typeof s=="undefined"){s=0;for(let w=0,E=i.length;w<E;w++)s+=i[w].byteLength}const c=A.alloc(s);let h=0;for(let w=0,E=i.length;w<E;w++){const p=i[w];c.set(p,h),h+=p.byteLength}return c}toString(){return F?this.buffer.toString():(y||(y=new TextDecoder),y.decode(this.buffer))}slice(i,s){return new A(this.buffer.subarray(i,s))}set(i,s){i instanceof A?this.buffer.set(i.buffer,s):this.buffer.set(i,s)}readUInt32BE(i){return P(this.buffer,i)}writeUInt32BE(i,s){n(this.buffer,i,s)}readUInt32LE(i){return k(this.buffer,i)}writeUInt32LE(i,s){a(this.buffer,i,s)}readUInt8(i){return m(this.buffer,i)}writeUInt8(i,s){d(this.buffer,i,s)}}e.VSBuffer=A;function _(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=_;function S(r,i,s){r[s+0]=i&255,i=i>>>8,r[s+1]=i&255}e.writeUInt16LE=S;function P(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=P;function n(r,i,s){r[s+3]=i,i=i>>>8,r[s+2]=i,i=i>>>8,r[s+1]=i,i=i>>>8,r[s]=i}e.writeUInt32BE=n;function k(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=k;function a(r,i,s){r[s+0]=i&255,i=i>>>8,r[s+1]=i&255,i=i>>>8,r[s+2]=i&255,i=i>>>8,r[s+3]=i&255}e.writeUInt32LE=a;function m(r,i){return r[i]}e.readUInt8=m;function d(r,i,s){r[s]=i}e.writeUInt8=d;function v(r){return f.consumeReadable(r,i=>A.concat(i))}e.readableToBuffer=v;function D(r){return f.toReadable(r)}e.bufferToReadable=D;function I(r){return f.consumeStream(r,i=>A.concat(i))}e.streamToBuffer=I;async function b(r){return r.ended?A.concat(r.buffer):A.concat([...r.buffer,await I(r.stream)])}e.bufferedStreamToBuffer=b;function l(r){return f.toStream(r,i=>A.concat(i))}e.bufferToStream=l;function o(r){return f.transform(r,{data:i=>typeof i=="string"?A.fromString(i):A.wrap(i)},i=>A.concat(i))}e.streamToBufferReadableStream=o;function g(r){return f.newWriteableStream(i=>A.concat(i),r)}e.newWriteableBufferStream=g;function t(r,i){return f.prefixedReadable(r,i,s=>A.concat(s))}e.prefixedBufferReadable=t;function u(r,i){return f.prefixedStream(r,i,s=>A.concat(s))}e.prefixedBufferStream=u}),define(fe[9],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function f(ce){return!ce||typeof ce!="string"?!0:ce.trim().length===0}e.isFalsyOrWhitespace=f;const F=/{(\d+)}/g;function C(ce,...Pe){return Pe.length===0?ce:ce.replace(F,function(We,Ye){const $e=parseInt(Ye,10);return isNaN($e)||$e<0||$e>=Pe.length?We:Pe[$e]})}e.format=C;const y=/{([^}]+)}/g;function A(ce,Pe){return ce.replace(y,(We,Ye)=>Pe[Ye]??We)}e.format2=A;function _(ce){return ce.replace(/[<>&]/g,function(Pe){switch(Pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Pe}})}e.escape=_;function S(ce){return ce.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function P(ce,Pe){let We=0;const Ye=Pe.charCodeAt(0);for(let $e=ce.length-1;$e>=0;$e--)ce.charCodeAt($e)===Ye&&We++;return We}e.count=P;function n(ce,Pe,We="\u2026"){return ce.length<=Pe?ce:`${ce.substr(0,Pe)}${We}`}e.truncate=n;function k(ce,Pe=" "){const We=a(ce,Pe);return m(We,Pe)}e.trim=k;function a(ce,Pe){if(!ce||!Pe)return ce;const We=Pe.length;if(We===0||ce.length===0)return ce;let Ye=0;for(;ce.indexOf(Pe,Ye)===Ye;)Ye=Ye+We;return ce.substring(Ye)}e.ltrim=a;function m(ce,Pe){if(!ce||!Pe)return ce;const We=Pe.length,Ye=ce.length;if(We===0||Ye===0)return ce;let $e=Ye,lt=-1;for(;lt=ce.lastIndexOf(Pe,$e-1),!(lt===-1||lt+We!==$e);){if(lt===0)return"";$e=lt}return ce.substring(0,$e)}e.rtrim=m;function d(ce){return ce.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function v(ce){return ce.replace(/\*/g,"")}e.stripWildcards=v;function D(ce,Pe,We={}){if(!ce)throw new Error("Cannot create regex from empty string");Pe||(ce=S(ce)),We.wholeWord&&(/\B/.test(ce.charAt(0))||(ce="\\b"+ce),/\B/.test(ce.charAt(ce.length-1))||(ce=ce+"\\b"));let Ye="";return We.global&&(Ye+="g"),We.matchCase||(Ye+="i"),We.multiline&&(Ye+="m"),We.unicode&&(Ye+="u"),new RegExp(ce,Ye)}e.createRegExp=D;function I(ce){return ce.source==="^"||ce.source==="^$"||ce.source==="$"||ce.source==="^\\s*$"?!1:!!(ce.exec("")&&ce.lastIndex===0)}e.regExpLeadsToEndlessLoop=I;function b(ce){return!!ce.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function l(ce){return(ce.global?"g":"")+(ce.ignoreCase?"i":"")+(ce.multiline?"m":"")+(ce.unicode?"u":"")}e.regExpFlags=l;function o(ce){return ce.split(/\r\n|\r|\n/)}e.splitLines=o;function g(ce){for(let Pe=0,We=ce.length;Pe<We;Pe++){const Ye=ce.charCodeAt(Pe);if(Ye!==32&&Ye!==9)return Pe}return-1}e.firstNonWhitespaceIndex=g;function t(ce,Pe=0,We=ce.length){for(let Ye=Pe;Ye<We;Ye++){const $e=ce.charCodeAt(Ye);if($e!==32&&$e!==9)return ce.substring(Pe,Ye)}return ce.substring(Pe,We)}e.getLeadingWhitespace=t;function u(ce,Pe=ce.length-1){for(let We=Pe;We>=0;We--){const Ye=ce.charCodeAt(We);if(Ye!==32&&Ye!==9)return We}return-1}e.lastNonWhitespaceIndex=u;function r(ce,Pe){return ce<Pe?-1:ce>Pe?1:0}e.compare=r;function i(ce,Pe,We=0,Ye=ce.length,$e=0,lt=Pe.length){for(;We<Ye&&$e<lt;We++,$e++){let ke=ce.charCodeAt(We),ne=Pe.charCodeAt($e);if(ke<ne)return-1;if(ke>ne)return 1}const Te=Ye-We,De=lt-$e;return Te<De?-1:Te>De?1:0}e.compareSubstring=i;function s(ce,Pe){return c(ce,Pe,0,ce.length,0,Pe.length)}e.compareIgnoreCase=s;function c(ce,Pe,We=0,Ye=ce.length,$e=0,lt=Pe.length){for(;We<Ye&&$e<lt;We++,$e++){let ke=ce.charCodeAt(We),ne=Pe.charCodeAt($e);if(ke===ne)continue;const ue=ke-ne;if(!(ue===32&&w(ne))&&!(ue===-32&&w(ke)))return h(ke)&&h(ne)?ue:i(ce.toLowerCase(),Pe.toLowerCase(),We,Ye,$e,lt)}const Te=Ye-We,De=lt-$e;return Te<De?-1:Te>De?1:0}e.compareSubstringIgnoreCase=c;function h(ce){return ce>=97&&ce<=122}e.isLowerAsciiLetter=h;function w(ce){return ce>=65&&ce<=90}e.isUpperAsciiLetter=w;function E(ce){return h(ce)||w(ce)}function p(ce,Pe){return ce.length===Pe.length&&T(ce,Pe)}e.equalsIgnoreCase=p;function T(ce,Pe,We=ce.length){for(let Ye=0;Ye<We;Ye++){const $e=ce.charCodeAt(Ye),lt=Pe.charCodeAt(Ye);if($e!==lt){if(E($e)&&E(lt)){const Te=Math.abs($e-lt);if(Te!==0&&Te!==32)return!1}else if(String.fromCharCode($e).toLowerCase()!==String.fromCharCode(lt).toLowerCase())return!1}}return!0}function L(ce,Pe){const We=Pe.length;return Pe.length>ce.length?!1:T(ce,Pe,We)}e.startsWithIgnoreCase=L;function M(ce,Pe){let We,Ye=Math.min(ce.length,Pe.length);for(We=0;We<Ye;We++)if(ce.charCodeAt(We)!==Pe.charCodeAt(We))return We;return Ye}e.commonPrefixLength=M;function R(ce,Pe){let We,Ye=Math.min(ce.length,Pe.length);const $e=ce.length-1,lt=Pe.length-1;for(We=0;We<Ye;We++)if(ce.charCodeAt($e-We)!==Pe.charCodeAt(lt-We))return We;return Ye}e.commonSuffixLength=R;function $(ce){return 55296<=ce&&ce<=56319}e.isHighSurrogate=$;function z(ce){return 56320<=ce&&ce<=57343}e.isLowSurrogate=z;function O(ce,Pe){return(ce-55296<<10)+(Pe-56320)+65536}e.computeCodePoint=O;function V(ce,Pe,We){const Ye=ce.charCodeAt(We);if($(Ye)&&We+1<Pe){const $e=ce.charCodeAt(We+1);if(z($e))return O(Ye,$e)}return Ye}e.getNextCodePoint=V;function N(ce,Pe){const We=ce.charCodeAt(Pe-1);if(z(We)&&Pe>1){const Ye=ce.charCodeAt(Pe-2);if($(Ye))return O(Ye,We)}return We}function U(ce,Pe){const We=te.getInstance(),Ye=Pe,$e=ce.length,lt=V(ce,$e,Pe);Pe+=lt>=65536?2:1;let Te=We.getGraphemeBreakType(lt);for(;Pe<$e;){const De=V(ce,$e,Pe),ke=We.getGraphemeBreakType(De);if(nt(Te,ke))break;Pe+=De>=65536?2:1,Te=ke}return Pe-Ye}e.nextCharLength=U;function x(ce,Pe){const We=te.getInstance(),Ye=Pe,$e=N(ce,Pe);Pe-=$e>=65536?2:1;let lt=We.getGraphemeBreakType($e);for(;Pe>0;){const Te=N(ce,Pe),De=We.getGraphemeBreakType(Te);if(nt(De,lt))break;Pe-=Te>=65536?2:1,lt=De}return Ye-Pe}e.prevCharLength=x;function B(ce,Pe){const We=te.getInstance(),Ye=ce.length,$e=Pe,lt=V(ce,Ye,Pe),Te=We.getGraphemeBreakType(lt);Pe+=lt>=65536?2:1;let De=Te;for(;Pe<Ye;){const ne=V(ce,Ye,Pe),ue=We.getGraphemeBreakType(ne);if(nt(De,ue))break;Pe+=ne>=65536?2:1,De=ue}const ke=Pe;for(Pe=$e,De=Te;Pe>0;){const ne=N(ce,Pe),ue=We.getGraphemeBreakType(ne);if(nt(ue,De))break;Pe-=ne>=65536?2:1,De=ue}return[Pe,ke]}function H(ce,Pe){return Pe>0&&z(ce.charCodeAt(Pe))?B(ce,Pe-1):B(ce,Pe)}e.getCharContainingOffset=H;const G=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(ce){return G.test(ce)}e.containsRTL=K;const X=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function de(ce){return X.test(ce)}e.containsEmoji=de;const be=/^[\t\n\r\x20-\x7E]*$/;function Se(ce){return be.test(ce)}e.isBasicASCII=Se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ie(ce){return e.UNUSUAL_LINE_TERMINATORS.test(ce)}e.containsUnusualLineTerminators=Ie;function Oe(ce){for(let Pe=0,We=ce.length;Pe<We;Pe++)if(xe(ce.charCodeAt(Pe)))return!0;return!1}e.containsFullWidthCharacter=Oe;function xe(ce){return ce=+ce,ce>=11904&&ce<=55215||ce>=63744&&ce<=64255||ce>=65281&&ce<=65374}e.isFullWidthCharacter=xe;function ze(ce){return ce>=127462&&ce<=127487||ce===8986||ce===8987||ce===9200||ce===9203||ce>=9728&&ce<=10175||ce===11088||ce===11093||ce>=127744&&ce<=128591||ce>=128640&&ce<=128764||ce>=128992&&ce<=129003||ce>=129280&&ce<=129535||ce>=129648&&ce<=129750}e.isEmojiImprecise=ze;function j(ce,Pe){if(ce.length<Pe)return ce;const We=/\b/g;let Ye=0;for(;We.test(ce)&&!(ce.length-We.lastIndex<Pe);)Ye=We.lastIndex,We.lastIndex+=1;return ce.substring(Ye).replace(/^\s/,"")}e.lcut=j;const ee=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,le=/\x1b\[0?m/g;function Z(ce){return ce&&(ce=ce.replace(ee,""),ce=ce.replace(re,""),ce=ce.replace(le,"")),ce}e.removeAnsiEscapeCodes=Z,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ae(ce){return!!(ce&&ce.length>0&&ce.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ae;function pe(ce){return ae(ce)?ce.substr(1):ce}e.stripUTF8BOM=pe;function Me(ce,Pe){if(!ce||!Pe||ce.length<Pe.length)return!1;const We=Pe.length,Ye=ce.toLowerCase();let $e=0,lt=-1;for(;$e<We;){const Te=Ye.indexOf(Pe[$e],lt+1);if(Te<0)return!1;lt=Te,$e++}return!0}e.fuzzyContains=Me;function qe(ce,Pe=!1){return ce?(Pe&&(ce=ce.replace(/\\./g,"")),ce.toLowerCase()!==ce):!1}e.containsUppercaseCharacter=qe;function Qe(ce){return ce.charAt(0).toUpperCase()+ce.slice(1)}e.uppercaseFirstLetter=Qe;function Je(ce,Pe=1){if(Pe===0)return"";let We=-1;do We=ce.indexOf(`
`,We+1),Pe--;while(Pe>0&&We>=0);return We===-1?ce:(ce[We-1]==="\r"&&We--,ce.substr(0,We))}e.getNLines=Je;function rt(ce){const Pe=90-65+1;return ce=ce%(2*Pe),ce<Pe?String.fromCharCode(97+ce):String.fromCharCode(65+ce-Pe)}e.singleLetterHash=rt;function Ae(ce){return te.getInstance().getGraphemeBreakType(ce)}e.getGraphemeBreakType=Ae;function nt(ce,Pe){return ce===0?Pe!==5&&Pe!==7:ce===2&&Pe===3?!1:ce===4||ce===2||ce===3||Pe===4||Pe===2||Pe===3?!0:!(ce===8&&(Pe===8||Pe===9||Pe===11||Pe===12)||(ce===11||ce===9)&&(Pe===9||Pe===10)||(ce===12||ce===10)&&Pe===10||Pe===5||Pe===13||Pe===7||ce===1||ce===13&&Pe===14||ce===6&&Pe===6)}e.breakBetweenGraphemeBreakType=nt;var J;(function(ce){ce[ce.Other=0]="Other",ce[ce.Prepend=1]="Prepend",ce[ce.CR=2]="CR",ce[ce.LF=3]="LF",ce[ce.Control=4]="Control",ce[ce.Extend=5]="Extend",ce[ce.Regional_Indicator=6]="Regional_Indicator",ce[ce.SpacingMark=7]="SpacingMark",ce[ce.L=8]="L",ce[ce.V=9]="V",ce[ce.T=10]="T",ce[ce.LV=11]="LV",ce[ce.LVT=12]="LVT",ce[ce.ZWJ=13]="ZWJ",ce[ce.Extended_Pictographic=14]="Extended_Pictographic"})(J=e.GraphemeBreakType||(e.GraphemeBreakType={}));class te{constructor(){this._data=ve()}static getInstance(){return te._INSTANCE||(te._INSTANCE=new te),te._INSTANCE}getGraphemeBreakType(Pe){if(Pe<32)return Pe===10?3:Pe===13?2:4;if(Pe<127)return 0;const We=this._data,Ye=We.length/3;let $e=1;for(;$e<=Ye;)if(Pe<We[3*$e])$e=2*$e;else if(Pe>We[3*$e+1])$e=2*$e+1;else return We[3*$e+2];return 0}}te._INSTANCE=null;function ve(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Xe(ce,Pe){if(ce===0)return 0;const We=tt(ce,Pe);if(We!==void 0)return We;const Ye=N(Pe,ce);return ce-=ct(Ye),ce}e.getLeftDeleteOffset=Xe;function tt(ce,Pe){let We=N(Pe,ce);for(ce-=ct(We);ut(We)||We===65039||We===8419;){if(ce===0)return;We=N(Pe,ce),ce-=ct(We)}if(!!ze(We)){if(ce>=0){const Ye=N(Pe,ce);Ye===8205&&(ce-=ct(Ye))}return ce}}function ct(ce){return ce>=65536?2:1}function ut(ce){return 127995<=ce&&ce<=127999}var _t;(function(ce){ce[ce.zwj=8205]="zwj",ce[ce.emojiVariantSelector=65039]="emojiVariantSelector",ce[ce.enclosingKeyCap=8419]="enclosingKeyCap"})(_t||(_t={}))}),define(fe[48],me([0,1,9]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function F(I){return C(I,0)}e.hash=F;function C(I,b){switch(typeof I){case"object":return I===null?y(349,b):Array.isArray(I)?S(I,b):P(I,b);case"string":return _(I,b);case"boolean":return A(I,b);case"number":return y(I,b);case"undefined":return y(937,b);default:return y(617,b)}}e.doHash=C;function y(I,b){return(b<<5)-b+I|0}e.numberHash=y;function A(I,b){return y(I?433:863,b)}function _(I,b){b=y(149417,b);for(let l=0,o=I.length;l<o;l++)b=y(I.charCodeAt(l),b);return b}e.stringHash=_;function S(I,b){return b=y(104579,b),I.reduce((l,o)=>C(o,l),b)}function P(I,b){return b=y(181387,b),Object.keys(I).sort().reduce((l,o)=>(l=_(o,l),C(I[o],l)),b)}class n{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=C(b,this._value),this._value}}e.Hasher=n;var k;(function(I){I[I.BLOCK_SIZE=64]="BLOCK_SIZE",I[I.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function a(I,b,l=32){const o=l-b,g=~((1<<o)-1);return(I<<b|(g&I)>>>o)>>>0}function m(I,b=0,l=I.byteLength,o=0){for(let g=0;g<l;g++)I[b+g]=o}function d(I,b,l="0"){for(;I.length<b;)I=l+I;return I}function v(I,b=32){return I instanceof ArrayBuffer?Array.from(new Uint8Array(I)).map(l=>l.toString(16).padStart(2,"0")).join(""):d((I>>>0).toString(16),b/4)}e.toHexString=v;class D{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const l=b.length;if(l===0)return;const o=this._buff;let g=this._buffLen,t=this._leftoverHighSurrogate,u,r;for(t!==0?(u=t,r=-1,t=0):(u=b.charCodeAt(0),r=0);;){let i=u;if(f.isHighSurrogate(u))if(r+1<l){const s=b.charCodeAt(r+1);f.isLowSurrogate(s)?(r++,i=f.computeCodePoint(u,s)):i=65533}else{t=u;break}else f.isLowSurrogate(u)&&(i=65533);if(g=this._push(o,g,i),r++,r<l)u=b.charCodeAt(r);else break}this._buffLen=g,this._leftoverHighSurrogate=t}_push(b,l,o){return o<128?b[l++]=o:o<2048?(b[l++]=192|(o&1984)>>>6,b[l++]=128|(o&63)>>>0):o<65536?(b[l++]=224|(o&61440)>>>12,b[l++]=128|(o&4032)>>>6,b[l++]=128|(o&63)>>>0):(b[l++]=240|(o&1835008)>>>18,b[l++]=128|(o&258048)>>>12,b[l++]=128|(o&4032)>>>6,b[l++]=128|(o&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=D._bigBlock32,l=this._buffDV;for(let h=0;h<64;h+=4)b.setUint32(h,l.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)b.setUint32(h,a(b.getUint32(h-12,!1)^b.getUint32(h-32,!1)^b.getUint32(h-56,!1)^b.getUint32(h-64,!1),1),!1);let o=this._h0,g=this._h1,t=this._h2,u=this._h3,r=this._h4,i,s,c;for(let h=0;h<80;h++)h<20?(i=g&t|~g&u,s=1518500249):h<40?(i=g^t^u,s=1859775393):h<60?(i=g&t|g&u|t&u,s=2400959708):(i=g^t^u,s=3395469782),c=a(o,5)+i+r+s+b.getUint32(h*4,!1)&4294967295,r=u,u=t,t=a(g,30),g=o,o=c;this._h0=this._h0+o&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=D,D._bigBlock32=new DataView(new ArrayBuffer(320))}),define(fe[49],me([0,1,9]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(F||(F={})),function(C){const y="error",A="warning",_="warn",S="info",P="ignore";function n(a){return a?f.equalsIgnoreCase(y,a)?C.Error:f.equalsIgnoreCase(A,a)||f.equalsIgnoreCase(_,a)?C.Warning:f.equalsIgnoreCase(S,a)?C.Info:C.Ignore:C.Ignore}C.fromValue=n;function k(a){switch(a){case C.Error:return y;case C.Warning:return A;case C.Info:return S;default:return P}}C.toString=k}(F||(F={})),e.default=F}),define(fe[12],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function f(w){return Array.isArray(w)}e.isArray=f;function F(w){return typeof w=="string"}e.isString=F;function C(w){return Array.isArray(w)&&w.every(E=>F(E))}e.isStringArray=C;function y(w){return typeof w=="object"&&w!==null&&!Array.isArray(w)&&!(w instanceof RegExp)&&!(w instanceof Date)}e.isObject=y;function A(w){return typeof w=="number"&&!isNaN(w)}e.isNumber=A;function _(w){return!!w&&typeof w[Symbol.iterator]=="function"}e.isIterable=_;function S(w){return w===!0||w===!1}e.isBoolean=S;function P(w){return typeof w=="undefined"}e.isUndefined=P;function n(w){return!k(w)}e.isDefined=n;function k(w){return P(w)||w===null}e.isUndefinedOrNull=k;function a(w,E){if(!w)throw new Error(E?`Unexpected type, expected '${E}'`:"Unexpected type")}e.assertType=a;function m(w){if(k(w))throw new Error("Assertion Failed: argument is undefined or null");return w}e.assertIsDefined=m;function d(...w){const E=[];for(let p=0;p<w.length;p++){const T=w[p];if(k(T))throw new Error(`Assertion Failed: argument at index ${p} is undefined or null`);E.push(T)}return E}e.assertAllDefined=d;const v=Object.prototype.hasOwnProperty;function D(w){if(!y(w))return!1;for(let E in w)if(v.call(w,E))return!1;return!0}e.isEmptyObject=D;function I(w){return typeof w=="function"}e.isFunction=I;function b(...w){return w.length>0&&w.every(I)}e.areFunctions=b;function l(w,E){const p=Math.min(w.length,E.length);for(let T=0;T<p;T++)o(w[T],E[T])}e.validateConstraints=l;function o(w,E){if(F(E)){if(typeof w!==E)throw new Error(`argument does not match constraint: typeof ${E}`)}else if(I(E)){try{if(w instanceof E)return}catch{}if(!k(w)&&w.constructor===E||E.length===1&&E.call(void 0,w)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function g(w){let E=[],p=Object.getPrototypeOf(w);for(;Object.prototype!==p;)E=E.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return E}e.getAllPropertyNames=g;function t(w){const E=[];for(const p of g(w))typeof w[p]=="function"&&E.push(p);return E}e.getAllMethodNames=t;function u(w,E){const p=L=>function(){const M=Array.prototype.slice.call(arguments,0);return E(L,M)};let T={};for(const L of w)T[L]=p(L);return T}e.createProxyObject=u;function r(w){return w===null?void 0:w}e.withNullAsUndefined=r;function i(w){return typeof w=="undefined"?null:w}e.withUndefinedAsNull=i;function s(w){return class{constructor(){return new Proxy({},{get(E,p){if(E[p])return E[p];throw new Error(`Not Implemented: ${w}->${String(p)}`)}})}}}e.NotImplementedProxy=s;function c(w,E="Unreachable"){throw new Error(E)}e.assertNever=c;function h(w){return!!w&&typeof w.then=="function"&&typeof w.catch=="function"}e.isPromise=h}),define(fe[29],me([0,1,8,11,9,12]),function(Y,e,f,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(r){return r===47||r===92}e.isPathSeparator=A;function _(r){return r.replace(/[\\/]/g,f.posix.sep)}e.toSlashes=_;function S(r){return r.indexOf("/")===-1&&(r=_(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function P(r,i=f.posix.sep){if(!r)return"";const s=r.length,c=r.charCodeAt(0);if(A(c)){if(A(r.charCodeAt(1))&&!A(r.charCodeAt(2))){let w=3;const E=w;for(;w<s&&!A(r.charCodeAt(w));w++);if(E!==w&&!A(r.charCodeAt(w+1))){for(w+=1;w<s;w++)if(A(r.charCodeAt(w)))return r.slice(0,w+1).replace(/[\\/]/g,i)}}return i}else if(I(c)&&r.charCodeAt(1)===58)return A(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let h=r.indexOf("://");if(h!==-1){for(h+=3;h<s;h++)if(A(r.charCodeAt(h)))return r.slice(0,h+1)}return""}e.getRoot=P;function n(r){if(!F.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let s=2;const c=s;for(;s<r.length&&(i=r.charCodeAt(s),i!==92);s++);return!(c===s||(i=r.charCodeAt(s+1),isNaN(i)||i===92))}e.isUNC=n;const k=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,i=F.isWindows){const s=i?k:a;return!(!r||r.length===0||/^\s+$/.test(r)||(s.lastIndex=0,s.test(r))||i&&m.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function v(r,i,s){const c=r===i;return!s||c?c:!r||!i?!1:(0,C.equalsIgnoreCase)(r,i)}e.isEqual=v;function D(r,i,s,c=f.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(s){if(!(0,C.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let w=i.length;return i.charAt(i.length-1)===c&&w--,r.charAt(w)===c}return i.charAt(i.length-1)!==c&&(i+=c),r.indexOf(i)===0}e.isEqualOrParent=D;function I(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=I;function b(r,i){return F.isWindows&&r.endsWith(":")&&(r+=f.sep),(0,f.isAbsolute)(r)||(r=(0,f.join)(i,r)),r=(0,f.normalize)(r),F.isWindows?(r=(0,C.rtrim)(r,f.sep),r.endsWith(":")&&(r+=f.sep)):(r=(0,C.rtrim)(r,f.sep),r||(r=f.sep)),r}e.sanitizeFilePath=b;function l(r){const i=(0,f.normalize)(r);return F.isWindows?r.length>3?!1:o(i)&&(r.length===2||i.charCodeAt(2)===92):i===f.posix.sep}e.isRootOrDriveLetter=l;function o(r){return F.isWindows?I(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function g(r){return o(r)?r[0]:void 0}e.getDriveLetter=g;function t(r,i,s){return i.length>r.length?-1:r===i?0:(s&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=t;function u(r){const i=r.split(":");let s,c,h;if(i.forEach(w=>{const E=Number(w);(0,y.isNumber)(E)?c===void 0?c=E:h===void 0&&(h=E):s=s?[s,w].join(":"):w}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:c!==void 0?c:void 0,column:h!==void 0?h:c!==void 0?1:void 0}}e.parseLineAndColumnAware=u}),define(fe[25],me([0,1,12]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const D=Array.isArray(v)?[]:{};return Object.keys(v).forEach(I=>{v[I]&&typeof v[I]=="object"?D[I]=F(v[I]):D[I]=v[I]}),D}e.deepClone=F;function C(v){if(!v||typeof v!="object")return v;const D=[v];for(;D.length>0;){const I=D.shift();Object.freeze(I);for(const b in I)if(y.call(I,b)){const l=I[b];typeof l=="object"&&!Object.isFrozen(l)&&D.push(l)}}return v}e.deepFreeze=C;const y=Object.prototype.hasOwnProperty;function A(v,D){return _(v,D,new Set)}e.cloneAndChange=A;function _(v,D,I){if((0,f.isUndefinedOrNull)(v))return v;const b=D(v);if(typeof b!="undefined")return b;if((0,f.isArray)(v)){const l=[];for(const o of v)l.push(_(o,D,I));return l}if((0,f.isObject)(v)){if(I.has(v))throw new Error("Cannot clone recursive data-structure");I.add(v);const l={};for(let o in v)y.call(v,o)&&(l[o]=_(v[o],D,I));return I.delete(v),l}return v}function S(v,D,I=!0){return(0,f.isObject)(v)?((0,f.isObject)(D)&&Object.keys(D).forEach(b=>{b in v?I&&((0,f.isObject)(v[b])&&(0,f.isObject)(D[b])?S(v[b],D[b],I):v[b]=D[b]):v[b]=D[b]}),v):D}e.mixin=S;function P(v,D){if(v===D)return!0;if(v==null||D===null||D===void 0||typeof v!=typeof D||typeof v!="object"||Array.isArray(v)!==Array.isArray(D))return!1;let I,b;if(Array.isArray(v)){if(v.length!==D.length)return!1;for(I=0;I<v.length;I++)if(!P(v[I],D[I]))return!1}else{const l=[];for(b in v)l.push(b);l.sort();const o=[];for(b in D)o.push(b);if(o.sort(),!P(l,o))return!1;for(I=0;I<l.length;I++)if(!P(v[l[I]],D[l[I]]))return!1}return!0}e.equals=P;function n(v){const D=new Set;return JSON.stringify(v,(I,b)=>{if((0,f.isObject)(b)||Array.isArray(b)){if(D.has(b))return"[Circular]";D.add(b)}return b})}e.safeStringify=n;function k(v,D,I){const b=D(v);return typeof b=="undefined"?I:b}e.getOrDefault=k;function a(v,D){const I=Object.create(null);return!v||!D||Object.keys(D).forEach(l=>{const o=v[l],g=D[l];P(o,g)||(I[l]=g)}),I}e.distinct=a;function m(v,D){const I=D.toLowerCase(),b=Object.keys(v).find(l=>l.toLowerCase()===I);return b?v[b]:v[D]}e.getCaseInsensitive=m;function d(v,D){const I=Object.create(null);for(const b of Object.keys(v))D(b,v[b])&&(I[b]=v[b]);return I}e.filter=d}),define(fe[98],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var f;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(f=e.Constants||(e.Constants={}));function F(y){return y<0?0:y>255?255:y|0}e.toUint8=F;function C(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=C}),define(fe[2],me([0,1,8,11]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,y=/^\//,A=/^\/\//;function _(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!C.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!y.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(r,i){return!r&&!i?"file":r}function P(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==k&&(i=k+i):i=k;break}return i}const n="",k="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(i,s,c,h,w,E=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=S(i,E),this.authority=s||n,this.path=P(this.scheme,c||n),this.query=h||n,this.fragment=w||n,_(this,E))}static isUri(i){return i instanceof m?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return l(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:c,path:h,query:w,fragment:E}=i;return s===void 0?s=this.scheme:s===null&&(s=n),c===void 0?c=this.authority:c===null&&(c=n),h===void 0?h=this.path:h===null&&(h=n),w===void 0?w=this.query:w===null&&(w=n),E===void 0?E=this.fragment:E===null&&(E=n),s===this.scheme&&c===this.authority&&h===this.path&&w===this.query&&E===this.fragment?this:new v(s,c,h,w,E)}static parse(i,s=!1){const c=a.exec(i);return c?new v(c[2]||n,u(c[4]||n),u(c[5]||n),u(c[7]||n),u(c[9]||n),s):new v(n,n,n,n,n)}static file(i){let s=n;if(F.isWindows&&(i=i.replace(/\\/g,k)),i[0]===k&&i[1]===k){const c=i.indexOf(k,2);c===-1?(s=i.substring(2),i=k):(s=i.substring(2,c),i=i.substring(c)||k)}return new v("file",s,i,n,n)}static from(i){const s=new v(i.scheme,i.authority,i.path,i.query,i.fragment);return _(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return F.isWindows&&i.scheme==="file"?c=m.file(f.win32.join(l(i,!0),...s)).path:c=f.posix.join(i.path,...s),i.with({path:c})}toString(i=!1){return o(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof m)return i;{const s=new v(i);return s._formatted=i.external,s._fsPath=i._sep===d?i.fsPath:null,s}}else return i}}e.URI=m;const d=F.isWindows?1:void 0;class v extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(i=!1){return i?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=d),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function I(r,i){let s,c=-1;for(let h=0;h<r.length;h++){const w=r.charCodeAt(h);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||i&&w===47)c!==-1&&(s+=encodeURIComponent(r.substring(c,h)),c=-1),s!==void 0&&(s+=r.charAt(h));else{s===void 0&&(s=r.substr(0,h));const E=D[w];E!==void 0?(c!==-1&&(s+=encodeURIComponent(r.substring(c,h)),c=-1),s+=E):c===-1&&(c=h)}}return c!==-1&&(s+=encodeURIComponent(r.substring(c))),s!==void 0?s:r}function b(r){let i;for(let s=0;s<r.length;s++){const c=r.charCodeAt(s);c===35||c===63?(i===void 0&&(i=r.substr(0,s)),i+=D[c]):i!==void 0&&(i+=r[s])}return i!==void 0?i:r}function l(r,i){let s;return r.authority&&r.path.length>1&&r.scheme==="file"?s=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?s=r.path.substr(1):s=r.path[1].toLowerCase()+r.path.substr(2):s=r.path,F.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=l;function o(r,i){const s=i?b:I;let c="",{scheme:h,authority:w,path:E,query:p,fragment:T}=r;if(h&&(c+=h,c+=":"),(w||h==="file")&&(c+=k,c+=k),w){let L=w.indexOf("@");if(L!==-1){const M=w.substr(0,L);w=w.substr(L+1),L=M.indexOf(":"),L===-1?c+=s(M,!1):(c+=s(M.substr(0,L),!1),c+=":",c+=s(M.substr(L+1),!1)),c+="@"}w=w.toLowerCase(),L=w.indexOf(":"),L===-1?c+=s(w,!1):(c+=s(w.substr(0,L),!1),c+=w.substr(L))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const L=E.charCodeAt(1);L>=65&&L<=90&&(E=`/${String.fromCharCode(L+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const L=E.charCodeAt(0);L>=65&&L<=90&&(E=`${String.fromCharCode(L+32)}:${E.substr(2)}`)}c+=s(E,!0)}return p&&(c+="?",c+=s(p,!1)),T&&(c+="#",c+=i?T:I(T,!1)),c}function g(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+g(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(r){return r.match(t)?r.replace(t,i=>g(i)):r}});var st=this&&this.__classPrivateFieldSet||function(Y,e,f,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,f):C?C.value=f:e.set(Y,f),f},Ne=this&&this.__classPrivateFieldGet||function(Y,e,f,F){if(f==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?F:f==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[24],me([0,1,16,9,2]),function(Y,e,f,F,C){"use strict";var y,A,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(u,r,i){let s=u.get(r);return s===void 0&&(s=i,u.set(r,s)),s}e.getOrSet=S;function P(u){const r=[];return u.forEach((i,s)=>{r.push(`${s} => ${i}`)}),`Map(${u.size}) {${r.join(", ")}}`}e.mapToString=P;function n(u){const r=[];return u.forEach(i=>{r.push(i)}),`Set(${u.size}) {${r.join(", ")}}`}e.setToString=n;class k{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),s=this._value.charCodeAt(this._pos);return i-s}value(){return this._value[this._pos]}}e.StringIterator=k;class a{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,F.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=a;class m{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,F.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,F.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var d;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(d||(d={}));class v{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,F.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,F.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,F.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,F.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=v;class D{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class I{constructor(r){this._iter=r}static forUris(r=()=>!1){return new I(new v(r))}static forPaths(){return new I(new m)}static forStrings(){return new I(new k)}static forConfigKeys(){return new I(new a)}clear(){this._root=void 0}set(r,i){const s=this._iter.reset(r);let c;for(this._root||(this._root=new D,this._root.segment=s.value()),c=this._root;;){const w=s.cmp(c.segment);if(w>0)c.left||(c.left=new D,c.left.segment=s.value()),c=c.left;else if(w<0)c.right||(c.right=new D,c.right.segment=s.value()),c=c.right;else if(s.hasNext())s.next(),c.mid||(c.mid=new D,c.mid.segment=s.value()),c=c.mid;else break}const h=c.value;return c.value=i,c.key=r,h}fill(r,i){const s=i.slice(0);(0,f.shuffle)(s);for(let c of s)this.set(c,r)}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const c=i.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else break}return s}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const s=this._iter.reset(r),c=[];let h=this._root;for(;h;){const w=s.cmp(h.segment);if(w>0)c.push([1,h]),h=h.left;else if(w<0)c.push([-1,h]),h=h.right;else if(s.hasNext())s.next(),c.push([0,h]),h=h.mid;else{for(i?(h.left=void 0,h.mid=void 0,h.right=void 0):h.value=void 0;c.length>0&&h.isEmpty();){let[E,p]=c.pop();switch(E){case 1:p.left=void 0;break;case 0:p.mid=void 0;break;case-1:p.right=void 0;break}h=p}break}}}findSubstr(r){const i=this._iter.reset(r);let s=this._root,c;for(;s;){const h=i.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(i.hasNext())i.next(),c=s.value||c,s=s.mid;else break}return s&&s.value||c}findSuperstr(r){const i=this._iter.reset(r);let s=this._root;for(;s;){const c=i.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(i.hasNext())i.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(r){for(const[i,s]of this)r(s,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const s=i.pop();s&&(s.value&&(yield[s.key,s.value]),s.left&&i.push(s.left),s.mid&&i.push(s.mid),s.right&&i.push(s.right))}}}e.TernarySearchTree=I;class b{constructor(r,i){this[y]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=i??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[s,c]of this.map)r(c,C.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield C.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[C.URI.parse(r[0]),r[1]]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[C.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=u=>u.toString();var l;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class o{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const s=this._map.get(r);if(!!s)return i!==0&&this.touch(s,i),s.value}set(r,i,s=0){let c=this._map.get(r);if(c)c.value=i,s!==0&&this.touch(c,s);else{switch(c={key:r,value:i,next:void 0,previous:void 0},s){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const s=this._state;let c=this._head;for(;c;){if(i?r.bind(i)(c.value,c.key,this):r(c.value,c.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,i=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.key,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return c}values(){const r=this,i=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:s.value,done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return c}entries(){const r=this,i=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(s){const h={value:[s.key,s.value],done:!1};return s=s.next,h}else return{value:void 0,done:!0}}};return c}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,s=this.size;for(;i&&s>r;)this._map.delete(i.key),i=i.next,s--;this._head=i,this._size=s,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,s=r.previous;if(!i||!s)throw new Error("Invalid list");i.previous=s,s.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const s=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(s.previous=c,c.next=s),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const s=r.next,c=r.previous;r===this._head?(s.previous=void 0,this._head=s):(s.previous=c,c.next=s),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,s)=>{r.push([s,i])}),r}fromJSON(r){this.clear();for(const[i,s]of r)this.set(i,s)}}e.LinkedMap=o;class g extends o{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=g;class t{constructor(r){_.set(this,void 0),st(this,_,r,"f")}get size(){return Ne(this,_,"f").size}forEach(r,i){Ne(this,_,"f").forEach(r,i)}get(r){return Ne(this,_,"f").get(r)}has(r){return Ne(this,_,"f").has(r)}entries(){return Ne(this,_,"f").entries()}keys(){return Ne(this,_,"f").keys()}values(){return Ne(this,_,"f").values()}[(_=new WeakMap,Symbol.iterator)](){return Ne(this,_,"f").entries()}}e.ReadonlyMapView=t}),define(fe[99],me([0,1,24,9]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...Z){return function(ae,pe){for(let Me=0,qe=Z.length;Me<qe;Me++){const Qe=Z[Me](ae,pe);if(Qe)return Qe}return null}}e.or=C,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(Z,ae,pe){if(!pe||pe.length<ae.length)return null;let Me;return Z?Me=F.startsWithIgnoreCase(pe,ae):Me=pe.indexOf(ae)===0,Me?ae.length>0?[{start:0,end:ae.length}]:[]:null}function A(Z,ae){const pe=ae.toLowerCase().indexOf(Z.toLowerCase());return pe===-1?null:[{start:pe,end:pe+Z.length}]}e.matchesContiguousSubString=A;function _(Z,ae){return S(Z.toLowerCase(),ae.toLowerCase(),0,0)}e.matchesSubString=_;function S(Z,ae,pe,Me){if(pe===Z.length)return[];if(Me===ae.length)return null;if(Z[pe]===ae[Me]){let qe=null;return(qe=S(Z,ae,pe+1,Me+1))?I({start:Me,end:Me+1},qe):null}return S(Z,ae,pe,Me+1)}function P(Z){return 97<=Z&&Z<=122}function n(Z){return 65<=Z&&Z<=90}e.isUpper=n;function k(Z){return 48<=Z&&Z<=57}function a(Z){return Z===32||Z===9||Z===10||Z===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Z=>m.add(Z.charCodeAt(0)));function d(Z){return a(Z)||m.has(Z)}function v(Z,ae){return Z===ae||d(Z)&&d(ae)}function D(Z){return P(Z)||n(Z)||k(Z)}function I(Z,ae){return ae.length===0?ae=[Z]:Z.end===ae[0].start?ae[0].start=Z.start:ae.unshift(Z),ae}function b(Z,ae){for(let pe=ae;pe<Z.length;pe++){const Me=Z.charCodeAt(pe);if(n(Me)||k(Me)||pe>0&&!D(Z.charCodeAt(pe-1)))return pe}return Z.length}function l(Z,ae,pe,Me){if(pe===Z.length)return[];if(Me===ae.length)return null;if(Z[pe]!==ae[Me].toLowerCase())return null;{let qe=null,Qe=Me+1;for(qe=l(Z,ae,pe+1,Me+1);!qe&&(Qe=b(ae,Qe))<ae.length;)qe=l(Z,ae,pe+1,Qe),Qe++;return qe===null?null:I({start:Me,end:Me+1},qe)}}function o(Z){let ae=0,pe=0,Me=0,qe=0,Qe=0;for(let J=0;J<Z.length;J++)Qe=Z.charCodeAt(J),n(Qe)&&ae++,P(Qe)&&pe++,D(Qe)&&Me++,k(Qe)&&qe++;const Je=ae/Z.length,rt=pe/Z.length,Ae=Me/Z.length,nt=qe/Z.length;return{upperPercent:Je,lowerPercent:rt,alphaPercent:Ae,numericPercent:nt}}function g(Z){const{upperPercent:ae,lowerPercent:pe}=Z;return pe===0&&ae>.6}function t(Z){const{upperPercent:ae,lowerPercent:pe,alphaPercent:Me,numericPercent:qe}=Z;return pe>.2&&ae<.8&&Me>.6&&qe<.2}function u(Z){let ae=0,pe=0,Me=0,qe=0;for(let Qe=0;Qe<Z.length;Qe++)Me=Z.charCodeAt(Qe),n(Me)&&ae++,P(Me)&&pe++,a(Me)&&qe++;return(ae===0||pe===0)&&qe===0?Z.length<=30:ae<=5}function r(Z,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!u(Z)||ae.length>60)return null;const pe=o(ae);if(!t(pe)){if(!g(pe))return null;ae=ae.toLowerCase()}let Me=null,qe=0;for(Z=Z.toLowerCase();qe<ae.length&&(Me=l(Z,ae,0,qe))===null;)qe=b(ae,qe+1);return Me}e.matchesCamelCase=r;function i(Z,ae,pe=!1){if(!ae||ae.length===0)return null;let Me=null,qe=0;for(Z=Z.toLowerCase(),ae=ae.toLowerCase();qe<ae.length&&(Me=s(Z,ae,0,qe,pe))===null;)qe=c(ae,qe+1);return Me}e.matchesWords=i;function s(Z,ae,pe,Me,qe){if(pe===Z.length)return[];if(Me===ae.length)return null;if(v(Z.charCodeAt(pe),ae.charCodeAt(Me))){let Qe=null,Je=Me+1;if(Qe=s(Z,ae,pe+1,Me+1,qe),!qe)for(;!Qe&&(Je=c(ae,Je))<ae.length;)Qe=s(Z,ae,pe+1,Je,qe),Je++;return Qe===null?null:I({start:Me,end:Me+1},Qe)}else return null}function c(Z,ae){for(let pe=ae;pe<Z.length;pe++)if(d(Z.charCodeAt(pe))||pe>0&&d(Z.charCodeAt(pe-1)))return pe;return Z.length}const h=C(e.matchesPrefix,r,A),w=C(e.matchesPrefix,r,_),E=new f.LRUCache(1e4);function p(Z,ae,pe=!1){if(typeof Z!="string"||typeof ae!="string")return null;let Me=E.get(Z);Me||(Me=new RegExp(F.convertSimple2RegExpPattern(Z),"i"),E.set(Z,Me));const qe=Me.exec(ae);return qe?[{start:qe.index,end:qe.index+qe[0].length}]:pe?w(Z,ae):h(Z,ae)}e.matchesFuzzy=p;function T(Z,ae){const pe=Oe(Z,Z.toLowerCase(),0,ae,ae.toLowerCase(),0,!0);return pe?M(pe):null}e.matchesFuzzy2=T;function L(Z,ae,pe,Me,qe,Qe){const Je=Math.min(13,Z.length);for(;pe<Je;pe++){const rt=Oe(Z,ae,pe,Me,qe,Qe,!1);if(rt)return rt}return[0,Qe]}e.anyScore=L;function M(Z){if(typeof Z=="undefined")return[];const ae=[],pe=Z[1];for(let Me=Z.length-1;Me>1;Me--){const qe=Z[Me]+pe,Qe=ae[ae.length-1];Qe&&Qe.end===qe?Qe.end=qe+1:ae.push({start:qe,end:qe+1})}return ae}e.createMatches=M;const R=128;function $(){const Z=[],ae=[];for(let pe=0;pe<=R;pe++)ae[pe]=0;for(let pe=0;pe<=R;pe++)Z.push(ae.slice(0));return Z}function z(Z){const ae=[];for(let pe=0;pe<=Z;pe++)ae[pe]=0;return ae}const O=z(2*R),V=z(2*R),N=$(),U=$(),x=$(),B=!1;function H(Z,ae,pe,Me,qe){function Qe(rt,Ae,nt=" "){for(;rt.length<Ae;)rt=nt+rt;return rt}let Je=` |   |${Me.split("").map(rt=>Qe(rt,3)).join("|")}
`;for(let rt=0;rt<=pe;rt++)rt===0?Je+=" |":Je+=`${ae[rt-1]}|`,Je+=Z[rt].slice(0,qe+1).map(Ae=>Qe(Ae.toString(),3)).join("|")+`
`;return Je}function G(Z,ae,pe,Me){Z=Z.substr(ae),pe=pe.substr(Me),console.log(H(U,Z,Z.length,pe,pe.length)),console.log(H(x,Z,Z.length,pe,pe.length)),console.log(H(N,Z,Z.length,pe,pe.length))}function K(Z,ae){if(ae<0||ae>=Z.length)return!1;const pe=Z.codePointAt(ae);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(pe)}}function X(Z,ae){if(ae<0||ae>=Z.length)return!1;switch(Z.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function de(Z,ae,pe){return ae[Z]!==pe[Z]}function be(Z,ae,pe,Me,qe,Qe,Je=!1){for(;ae<pe&&qe<Qe;)Z[ae]===Me[qe]&&(Je&&(O[ae]=qe),ae+=1),qe+=1;return ae===pe}e.isPatternInWord=be;var Se;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var Ie;(function(Z){Z.Default=[-100,0];function ae(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}Z.isDefault=ae})(Ie=e.FuzzyScore||(e.FuzzyScore={}));function Oe(Z,ae,pe,Me,qe,Qe,Je){const rt=Z.length>R?R:Z.length,Ae=Me.length>R?R:Me.length;if(pe>=rt||Qe>=Ae||rt-pe>Ae-Qe||!be(ae,pe,rt,qe,Qe,Ae,!0))return;xe(rt,Ae,pe,Qe,ae,qe);let nt=1,J=1,te=pe,ve=Qe;const Xe=[!1];for(nt=1,te=pe;te<rt;nt++,te++){const ce=O[te],Pe=V[te],We=te+1<rt?V[te+1]:Ae;for(J=ce-Qe+1,ve=ce;ve<We;J++,ve++){let Ye=Number.MIN_SAFE_INTEGER,$e=!1;ve<=Pe&&(Ye=ze(Z,ae,te,pe,Me,qe,ve,Ae,Qe,N[nt-1][J-1]===0,Xe));let lt=0;Ye!==Number.MAX_SAFE_INTEGER&&($e=!0,lt=Ye+U[nt-1][J-1]);const Te=ve>ce,De=Te?U[nt][J-1]+(N[nt][J-1]>0?-5:0):0,ke=ve>ce+1&&N[nt][J-1]>0,ne=ke?U[nt][J-2]+(N[nt][J-2]>0?-5:0):0;if(ke&&(!Te||ne>=De)&&(!$e||ne>=lt))U[nt][J]=ne,x[nt][J]=3,N[nt][J]=0;else if(Te&&(!$e||De>=lt))U[nt][J]=De,x[nt][J]=2,N[nt][J]=0;else if($e)U[nt][J]=lt,x[nt][J]=1,N[nt][J]=N[nt-1][J-1]+1;else throw new Error("not possible")}}if(B&&G(Z,pe,Me,Qe),!Xe[0]&&!Je)return;nt--,J--;const tt=[U[nt][J],Qe];let ct=0,ut=0;for(;nt>=1;){let ce=J;do{const Pe=x[nt][ce];if(Pe===3)ce=ce-2;else if(Pe===2)ce=ce-1;else break}while(ce>=1);ct>1&&ae[pe+nt-1]===qe[Qe+J-1]&&!de(ce+Qe-1,Me,qe)&&ct+1>N[nt][ce]&&(ce=J),ce===J?ct++:ct=1,ut||(ut=ce),nt--,J=ce-1,tt.push(J)}Ae===rt&&(tt[0]+=2);const _t=ut-rt;return tt[0]-=_t,tt}e.fuzzyScore=Oe;function xe(Z,ae,pe,Me,qe,Qe){let Je=Z-1,rt=ae-1;for(;Je>=pe&&rt>=Me;)qe[Je]===Qe[rt]&&(V[Je]=rt,Je--),rt--}function ze(Z,ae,pe,Me,qe,Qe,Je,rt,Ae,nt,J){if(ae[pe]!==Qe[Je])return Number.MIN_SAFE_INTEGER;let te=1,ve=!1;return Je===pe-Me?te=Z[pe]===qe[Je]?7:5:de(Je,qe,Qe)&&(Je===0||!de(Je-1,qe,Qe))?(te=Z[pe]===qe[Je]?7:5,ve=!0):K(Qe,Je)&&(Je===0||!K(Qe,Je-1))?te=5:(K(Qe,Je-1)||X(Qe,Je-1))&&(te=5,ve=!0),te>1&&pe===Me&&(J[0]=!0),ve||(ve=de(Je,qe,Qe)||K(Qe,Je-1)||X(Qe,Je-1)),pe===Me?Je>Ae&&(te-=ve?3:5):nt?te+=ve?2:0:te+=ve?0:1,Je+1===rt&&(te-=ve?3:5),te}function j(Z,ae,pe,Me,qe,Qe,Je){return re(Z,ae,pe,Me,qe,Qe,!0,Je)}e.fuzzyScoreGracefulAggressive=j;function ee(Z,ae,pe,Me,qe,Qe,Je){return re(Z,ae,pe,Me,qe,Qe,!1,Je)}e.fuzzyScoreGraceful=ee;function re(Z,ae,pe,Me,qe,Qe,Je,rt){let Ae=Oe(Z,ae,pe,Me,qe,Qe,rt);if(Ae&&!Je)return Ae;if(Z.length>=3){const nt=Math.min(7,Z.length-1);for(let J=pe+1;J<nt;J++){const te=le(Z,J);if(te){const ve=Oe(te,te.toLowerCase(),pe,Me,qe,Qe,rt);ve&&(ve[0]-=3,(!Ae||ve[0]>Ae[0])&&(Ae=ve))}}}return Ae}function le(Z,ae){if(ae+1>=Z.length)return;const pe=Z[ae],Me=Z[ae+1];if(pe!==Me)return Z.slice(0,ae)+Me+pe+Z.slice(ae+2)}}),define(fe[143],me([0,1,47,99,9]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${y.source}`,"g");function _(v){return v.replace(A,(D,I)=>I?D:`\\${D}`)}e.escapeIcons=_;const S=new RegExp(`\\\\${y.source}`,"g");function P(v){return v.replace(S,D=>`\\${D}`)}e.markdownEscapeEscapedIcons=P;const n=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function k(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(n,(D,I,b,l)=>b?D:I||l||"")}e.stripIcons=k;function a(v){const D=v.indexOf(e.iconStartMarker);return D===-1?{text:v}:m(v,D)}e.parseLabelWithIcons=a;function m(v,D){const I=[];let b="";function l(c){if(c){b+=c;for(const h of c)I.push(t)}}let o=-1,g="",t=0,u,r,i=D;const s=v.length;for(l(v.substr(0,D));i<s;)u=v[i],r=v[i+1],u===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(o=i,l(g),g=e.iconStartMarker,i++):u===")"&&o!==-1?(t+=i-o+1,o=-1,g=""):o!==-1?/^[a-z0-9\-]$/i.test(u)?g+=u:(l(g),o=-1,g=""):l(u),i++;return l(g),{text:b,iconOffsets:I}}function d(v,D,I=!1){const{text:b,iconOffsets:l}=D;if(!l||l.length===0)return(0,F.matchesFuzzy)(v,b,I);const o=(0,C.ltrim)(b," "),g=b.length-o.length,t=(0,F.matchesFuzzy)(v,o,I);if(t)for(const u of t){const r=l[u.start+g]+g;u.start+=r,u.end+=r}return t}e.matchesFuzzyIconAware=d}),define(fe[100],me([0,1,18,143]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(C=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(m="",d=!1){if(this.value=m,typeof this.value!="string")throw(0,f.illegalArgument)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(m,d=0){return this.value+=P(this.supportThemeIcons?(0,F.escapeIcons)(m):m).replace(/([ \t]+)/g,(v,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,d){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}}e.MarkdownString=y;function A(a){return _(a)?!a.value:Array.isArray(a)?a.every(A):!0}e.isEmptyMarkdownString=A;function _(a){return a instanceof y?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=_;function S(a,m){return a===m?!0:!a||!m?!1:a.value===m.value&&a.isTrusted===m.isTrusted&&a.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=S;function P(a){return a.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function n(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function k(a){const m=[],d=a.split("|").map(D=>D.trim());a=d[0];const v=d[1];if(v){const D=/height=(\d+)/.exec(v),I=/width=(\d+)/.exec(v),b=D?D[1]:"",l=I?I[1]:"",o=isFinite(parseInt(l)),g=isFinite(parseInt(b));o&&m.push(`width="${l}"`),g&&m.push(`height="${b}"`)}return{href:a,dimensions:m}}e.parseHrefAndDimensions=k}),define(fe[61],me([0,1,22,9,2]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function y(n){return JSON.stringify(n,S)}e.stringify=y;function A(n){let k=JSON.parse(n);return k=P(k),k}e.parse=A;var _;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(_=e.MarshalledId||(e.MarshalledId={}));function S(n,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:(0,F.regExpFlags)(k)}:k}function P(n,k=0){if(!n||k>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return C.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof f.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let a=0;a<n.length;++a)n[a]=P(n[a],k+1);else for(const a in n)Object.hasOwnProperty.call(n,a)&&(n[a]=P(n[a],k+1))}return n}e.revive=P}),define(fe[10],me([0,1,11,2]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(_){_.inMemory="inmemory",_.vscode="vscode",_.internal="private",_.walkThrough="walkThrough",_.walkThroughSnippet="walkThroughSnippet",_.http="http",_.https="https",_.file="file",_.mailto="mailto",_.untitled="untitled",_.data="data",_.command="command",_.vscodeRemote="vscode-remote",_.vscodeRemoteResource="vscode-remote-resource",_.userData="vscode-userdata",_.vscodeCustomEditor="vscode-custom-editor",_.vscodeNotebook="vscode-notebook",_.vscodeNotebookCell="vscode-notebook-cell",_.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",_.vscodeNotebookCellOutput="vscode-notebook-cell-output",_.vscodeInteractive="vscode-interactive",_.vscodeInteractiveInput="vscode-interactive-input",_.vscodeSettings="vscode-settings",_.vscodeWorkspaceTrust="vscode-workspace-trust",_.vscodeTerminal="vscode-terminal",_.webviewPanel="webview-panel",_.vscodeWebview="vscode-webview",_.extension="extension",_.vscodeFileResource="vscode-file",_.tmp="tmp"})(C=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,P,n){this._hosts[S]=P,this._ports[S]=n}setConnectionToken(S,P){this._connectionTokens[S]=P}rewrite(S){if(this._delegate)return this._delegate(S);const P=S.authority;let n=this._hosts[P];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const k=this._ports[P],a=this._connectionTokens[P];let m=`path=${encodeURIComponent(S.path)}`;return typeof a=="string"&&(m+=`&tkn=${encodeURIComponent(a)}`),F.URI.from({scheme:f.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${n}:${k}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new y;class A{asBrowserUri(S,P){const n=this.toUri(S,P);return n.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===C.file&&(f.isNative||typeof f.globals.importScripts=="function"&&f.globals.origin===`${C.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?n.with({scheme:C.vscodeFileResource,authority:n.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(S,P){const n=this.toUri(S,P);return n.scheme===C.vscodeFileResource?n.with({scheme:C.file,authority:n.authority!==A.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(S,P){return F.URI.isUri(S)?S:F.URI.parse(P.toUrl(S))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(fe[78],me([0,1,24]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const F=new f.LRUCache(1e4);function C(P){return S(P,"NFC",F)}e.normalizeNFC=C;const y=new f.LRUCache(1e4);function A(P){return S(P,"NFD",y)}e.normalizeNFD=A;const _=/[^\u0000-\u0080]/;function S(P,n,k){if(!P)return P;const a=k.get(P);if(a)return a;let m;return _.test(P)?m=P.normalize(n):m=P,k.set(P,m),m}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(n){return A(n).replace(P,"")}}()}),define(fe[23],me([0,1,29,10,8,11,9,2]),function(Y,e,f,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(m){return(0,_.uriToFsPath)(m,!0)}e.originalFSPath=S;class P{constructor(d){this._ignorePathCasing=d}compare(d,v,D=!1){return d===v?0:(0,A.compare)(this.getComparisonKey(d,D),this.getComparisonKey(v,D))}isEqual(d,v,D=!1){return d===v?!0:!d||!v?!1:this.getComparisonKey(d,D)===this.getComparisonKey(v,D)}getComparisonKey(d,v=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,v,D=!1){if(d.scheme===v.scheme){if(d.scheme===F.Schemas.file)return f.isEqualOrParent(S(d),S(v),this._ignorePathCasing(d))&&d.query===v.query&&(D||d.fragment===v.fragment);if((0,e.isEqualAuthority)(d.authority,v.authority))return f.isEqualOrParent(d.path,v.path,this._ignorePathCasing(d),"/")&&d.query===v.query&&(D||d.fragment===v.fragment)}return!1}joinPath(d,...v){return _.URI.joinPath(d,...v)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return C.posix.basename(d.path)}extname(d){return C.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let v;return d.scheme===F.Schemas.file?v=_.URI.file(C.dirname(S(d))).path:(v=C.posix.dirname(d.path),d.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),v="/")),d.with({path:v})}normalizePath(d){if(!d.path.length)return d;let v;return d.scheme===F.Schemas.file?v=_.URI.file(C.normalize(S(d))).path:v=C.posix.normalize(d.path),d.with({path:v})}relativePath(d,v){if(d.scheme!==v.scheme||!(0,e.isEqualAuthority)(d.authority,v.authority))return;if(d.scheme===F.Schemas.file){const b=C.relative(S(d),S(v));return y.isWindows?f.toSlashes(b):b}let D=d.path||"/",I=v.path||"/";if(this._ignorePathCasing(d)){let b=0;for(const l=Math.min(D.length,I.length);b<l&&!(D.charCodeAt(b)!==I.charCodeAt(b)&&D.charAt(b).toLowerCase()!==I.charAt(b).toLowerCase());b++);D=I.substr(0,b)+D.substr(b)}return C.posix.relative(D,I)}resolvePath(d,v){if(d.scheme===F.Schemas.file){const D=_.URI.file(C.resolve(S(d),v));return d.with({authority:D.authority,path:D.path})}return v=f.toPosixPath(v),d.with({path:C.posix.resolve(d.path,v)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,v){return d===v||(0,A.equalsIgnoreCase)(d,v)}hasTrailingPathSeparator(d,v=C.sep){if(d.scheme===F.Schemas.file){const D=S(d);return D.length>f.getRoot(D).length&&D[D.length-1]===v}else{const D=d.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,v=C.sep){return(0,e.hasTrailingPathSeparator)(d,v)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,v=C.sep){let D=!1;if(d.scheme===F.Schemas.file){const I=S(d);D=I!==void 0&&I.length===f.getRoot(I).length&&I[I.length-1]===v}else{v="/";const I=d.path;D=I.length===1&&I.charCodeAt(I.length-1)===47}return!D&&!(0,e.hasTrailingPathSeparator)(d,v)?d.with({path:d.path+"/"}):d}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(m=>m.scheme===F.Schemas.file?!y.isLinux:!0),e.extUriIgnorePathCase=new P(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(m,d){const v=[];for(let D=0;D<m.length;D++){const I=d(m[D]);m.some((b,l)=>l===D?!1:(0,e.isEqualOrParent)(I,d(b)))||v.push(m[D])}return v}e.distinctParents=n;var k;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function d(v){const D=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(l=>{const[o,g]=l.split(":");o&&g&&D.set(o,g)});const b=v.path.substring(0,v.path.indexOf(";"));return b&&D.set(m.META_DATA_MIME,b),D}m.parseMetaData=d})(k=e.DataUri||(e.DataUri={}));function a(m,d,v){if(d){let D=m.path;return D&&D[0]!==C.posix.sep&&(D=C.posix.sep+D),m.with({scheme:v,authority:d,path:D})}return m.with({scheme:v})}e.toLocalResource=a}),define(fe[17],me([0,1,21,18,3,6,23]),function(Y,e,f,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function _(N){return!!N&&typeof N.then=="function"}e.isThenable=_;function S(N){const U=new f.CancellationTokenSource,x=N(U.token),B=new Promise((H,G)=>{const K=U.token.onCancellationRequested(()=>{K.dispose(),U.dispose(),G((0,F.canceled)())});Promise.resolve(x).then(X=>{K.dispose(),U.dispose(),H(X)},X=>{K.dispose(),U.dispose(),G(X)})});return new class{cancel(){U.cancel()}then(H,G){return B.then(H,G)}catch(H){return this.then(void 0,H)}finally(H){return B.finally(H)}}}e.createCancelablePromise=S;function P(N,U,x){return Promise.race([N,new Promise(B=>U.onCancellationRequested(()=>B(x)))])}e.raceCancellation=P;async function n(N){let U=-1;const x=N.map((H,G)=>H.then(K=>(U=G,K))),B=await Promise.race(x);return N.forEach((H,G)=>{G!==U&&H.cancel()}),B}e.raceCancellablePromises=n;function k(N,U,x){let B;const H=setTimeout(()=>{B?.(void 0),x?.()},U);return Promise.race([N.finally(()=>clearTimeout(H)),new Promise(G=>B=G)])}e.raceTimeout=k;function a(N){return new Promise((U,x)=>{const B=N();_(B)?B.then(U,x):U(B)})}e.asPromise=a;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(x,x).then(B)})}return new Promise((x,B)=>{this.queuedPromise.then(x,B)})}return this.activePromise=U(),new Promise((x,B)=>{this.activePromise.then(H=>{this.activePromise=null,x(H)},H=>{this.activePromise=null,B(H)})})}}e.Throttler=m;class d{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=d;class v{constructor(){this.promiseMap=new Map}queue(U,x){const H=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(U)===H&&this.promiseMap.delete(U)});return this.promiseMap.set(U,H),H}}e.SequencerByKey=v;class D{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,x=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,H)=>{this.doResolve=B,this.doReject=H}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,F.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=D;class I{constructor(U){this.delayer=new D(U),this.throttler=new m}trigger(U,x){return this.delayer.trigger(()=>this.throttler.queue(U),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class b{constructor(){this._isOpen=!1,this._promise=new Promise((U,x)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;class l extends b{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function o(N,U){return U?new Promise((x,B)=>{const H=setTimeout(()=>{G.dispose(),x()},N),G=U.onCancellationRequested(()=>{clearTimeout(H),G.dispose(),B((0,F.canceled)())})}):S(x=>o(N,x))}e.timeout=o;function g(N,U=0){const x=setTimeout(N,U);return(0,y.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=g;function t(N){const U=[];let x=0;const B=N.length;function H(){return x<B?N[x++]():null}function G(K){K!=null&&U.push(K);const X=H();return X?X.then(G):Promise.resolve(U)}return Promise.resolve(null).then(G)}e.sequence=t;function u(N,U=B=>!!B,x=null){let B=0;const H=N.length,G=()=>{if(B>=H)return Promise.resolve(x);const K=N[B++];return Promise.resolve(K()).then(de=>U(de)?Promise.resolve(de):G())};return G()}e.first=u;function r(N,U=B=>!!B,x=null){if(N.length===0)return Promise.resolve(x);let B=N.length;const H=()=>{B=-1;for(const G of N)G.cancel?.()};return new Promise((G,K)=>{for(const X of N)X.then(de=>{--B>=0&&U(de)?(H(),G(de)):B===0&&G(x)}).catch(de=>{--B>=0&&(H(),K(de))})})}e.firstParallel=r;class i{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((x,B)=>{this.outstandingPromises.push({factory:U,c:x,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const x=U.factory();x.then(U.c,U.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class s extends i{constructor(){super(1)}}e.Queue=s;class c{constructor(){this.queues=new Map}queueFor(U,x=A.extUri){const B=x.getComparisonKey(U);let H=this.queues.get(B);return H||(H=new s,C.Event.once(H.onFinished)(()=>{H?.dispose(),this.queues.delete(B)}),this.queues.set(B,H)),H}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=c;class h{constructor(U,x){this._token=-1,typeof U=="function"&&typeof x=="number"&&this.setIfNotSet(U,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},x)}setIfNotSet(U,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},x))}}e.TimeoutTimer=h;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,x){this.cancel(),this._token=setInterval(()=>{U()},x)}}e.IntervalTimer=w;class E{constructor(U,x){this.timeoutToken=-1,this.runner=U,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=E;class p{constructor(U,x){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=x,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=p;class T extends E{constructor(U,x){super(U,x);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=T;class L extends y.Disposable{constructor(U,x,B,H){super();this.maxWorkChunkSize=U,this.maxPendingWork=x,this.throttleDelay=B,this.handler=H,this.pendingWork=[],this.throttler=this._register(new y.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.maxPendingWork)return!1}else if(this.pending+U.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new E(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=L,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=N=>{const U=setTimeout(()=>{const B=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,B-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0,clearTimeout(U))}}}:e.runWhenIdle=(N,U)=>{const x=requestIdleCallback(N,typeof U=="number"?{timeout:U}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(x))}}}}();class M{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=M;async function R(N,U,x){let B;for(let H=0;H<x;H++)try{return await N()}catch(G){B=G,await o(U)}throw B}e.retry=R;class ${hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,x,B){return this._pending={taskId:U,cancel:()=>B?.(),promise:x},x.then(()=>this.donePending(U),()=>this.donePending(U)),x}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let x,B;const H=new Promise((G,K)=>{x=G,B=K});this._next={run:U,promise:H,promiseResolve:x,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=$;class z{constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class O{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,x)=>{this.completeCallback=U,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(x=>{this.completeCallback(U),this.resolved=!0,x()})}error(U){return new Promise(x=>{this.errorCallback(U),this.rejected=!0,x()})}cancel(){new Promise(U=>{this.errorCallback((0,F.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=O;var V;(function(N){async function U(x){let B;const H=await Promise.all(x.map(G=>G.then(K=>K,K=>{B||(B=K)})));if(typeof B!="undefined")throw B;return H}N.settled=U})(V=e.Promises||(e.Promises={}))}),define(fe[101],me([0,1,17,8]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new f.IdleValue(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),y=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new f.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function _(E,p,T=!1){const L=E||"",M=p||"",R=C.value.collator.compare(L,M);return C.value.collatorIsNumeric&&R===0&&L!==M?L<M?-1:1:R}e.compareFileNames=_;function S(E,p){const T=y.value.collator;return E=E||"",p=p||"",g(T,E,p)}e.compareFileNamesDefault=S;function P(E,p){const T=y.value.collator;return E=E||"",p=p||"",i(E,p)||g(T,E,p)}e.compareFileNamesUpper=P;function n(E,p){const T=y.value.collator;return E=E||"",p=p||"",r(E,p)||g(T,E,p)}e.compareFileNamesLower=n;function k(E,p){return E=E||"",p=p||"",E===p?0:E<p?-1:1}e.compareFileNamesUnicode=k;function a(E,p,T=!1){T||(E=E&&E.toLowerCase(),p=p&&p.toLowerCase());const[L,M]=l(E),[R,$]=l(p);return L!==R?L<R?-1:1:M===$?0:M<$?-1:1}e.noIntlCompareFileNames=a;function m(E,p){const[T,L]=l(E),[M,R]=l(p);let $=C.value.collator.compare(L,R);if($===0){if(C.value.collatorIsNumeric&&L!==R)return L<R?-1:1;if($=C.value.collator.compare(T,M),C.value.collatorIsNumeric&&$===0&&T!==M)return T<M?-1:1}return $}e.compareFileExtensions=m;function d(E,p){E=E||"",p=p||"";const T=o(E),L=o(p),M=y.value.collator,R=A.value.collator;return g(R,T,L)||g(M,E,p)}e.compareFileExtensionsDefault=d;function v(E,p){E=E||"",p=p||"";const T=o(E),L=o(p),M=y.value.collator,R=A.value.collator;return g(R,T,L)||i(E,p)||g(M,E,p)}e.compareFileExtensionsUpper=v;function D(E,p){E=E||"",p=p||"";const T=o(E),L=o(p),M=y.value.collator,R=A.value.collator;return g(R,T,L)||r(E,p)||g(M,E,p)}e.compareFileExtensionsLower=D;function I(E,p){E=E||"",p=p||"";const T=o(E).toLowerCase(),L=o(p).toLowerCase();return T!==L?T<L?-1:1:E!==p?E<p?-1:1:0}e.compareFileExtensionsUnicode=I;const b=/^(.*?)(\.([^.]*))?$/;function l(E,p=!1){const T=E?b.exec(E):[];let L=[T&&T[1]||"",T&&T[3]||""];return p&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function o(E){const p=E?b.exec(E):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function g(E,p,T){let L=E.compare(p,T);return L!==0?L:p.length!==T.length?p.length<T.length?-1:1:0}function t(E){const p=E.charAt(0);return p.toLocaleUpperCase()!==p}function u(E){const p=E.charAt(0);return p.toLocaleLowerCase()!==p}function r(E,p){return t(E)&&u(p)?-1:u(E)&&t(p)?1:0}function i(E,p){return u(E)&&t(p)?-1:t(E)&&u(p)?1:0}function s(E,p,T=!1){return T||(E=E&&E.toLowerCase(),p=p&&p.toLowerCase()),E===p?0:E<p?-1:1}function c(E,p,T=!1){const L=E.split(F.sep),M=p.split(F.sep),R=L.length-1,$=M.length-1;let z,O;for(let V=0;;V++){if(z=R===V,O=$===V,z&&O)return _(L[V],M[V],T);if(z)return-1;if(O)return 1;const N=s(L[V],M[V],T);if(N!==0)return N}}e.comparePaths=c;function h(E,p,T){const L=E.toLowerCase(),M=p.toLowerCase(),R=w(E,p,T);if(R)return R;const $=L.endsWith(T),z=M.endsWith(T);if($!==z)return $?-1:1;const O=_(L,M);return O!==0?O:L.localeCompare(M)}e.compareAnything=h;function w(E,p,T){const L=E.toLowerCase(),M=p.toLowerCase(),R=L.startsWith(T),$=M.startsWith(T);if(R!==$)return R?-1:1;if(R&&$){if(L.length<M.length)return-1;if(L.length>M.length)return 1}return 0}e.compareByPrefix=w}),define(fe[102],me([0,1,101,99,48,8,11,9]),function(Y,e,f,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,P=[S,[]];function n(N,U,x,B){if(!N||!U)return P;const H=N.length,G=U.length;if(H<G)return P;const K=N.toLowerCase();return k(U,x,G,N,K,H,B)}e.scoreFuzzy=n;function k(N,U,x,B,H,G,K){const X=[],de=[];for(let Oe=0;Oe<x;Oe++){const xe=Oe*G,ze=xe-G,j=Oe>0,ee=N[Oe],re=U[Oe];for(let le=0;le<G;le++){const Z=le>0,ae=xe+le,pe=ae-1,Me=ze+le-1,qe=Z?X[pe]:0,Qe=j&&Z?X[Me]:0,Je=j&&Z?de[Me]:0;let rt;!Qe&&j?rt=0:rt=a(ee,re,B,H,le,Je),rt&&Qe+rt>=qe&&(K||j||H.startsWith(U,le))?(de[ae]=Je+1,X[ae]=Qe+rt):(de[ae]=S,X[ae]=qe)}}const be=[];let Se=x-1,Ie=G-1;for(;Se>=0&&Ie>=0;){const Oe=Se*G+Ie;de[Oe]===S||(be.push(Ie),Se--),Ie--}return[X[x*G-1],be.reverse()]}function a(N,U,x,B,H,G){let K=0;if(!m(U,B[H]))return K;if(K+=1,G>0&&(K+=G*5),N===x[H]&&(K+=1),H===0)K+=8;else{const X=d(x.charCodeAt(H-1));X?K+=X:(0,F.isUpper)(x.charCodeAt(H))&&(K+=2)}return K}function m(N,U){return N===U?!0:N==="/"||N==="\\"?U==="/"||U==="\\":!1}function d(N){switch(N){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const v=[void 0,[]];function D(N,U,x=0,B=0){const H=U;return H.values&&H.values.length>1?I(N,H.values,x,B):b(N,U,x,B)}e.scoreFuzzy2=D;function I(N,U,x,B){let H=0;const G=[];for(const K of U){const[X,de]=b(N,K,x,B);if(typeof X!="number")return v;H+=X,G.push(...de)}return[H,w(G)]}function b(N,U,x,B){const H=(0,F.fuzzyScore)(U.original,U.originalLowercase,x,N,N.toLowerCase(),B,!0);return H?[H[0],(0,F.createMatches)(H)]:v}const l=Object.freeze({score:0}),o=1<<18,g=1<<17,t=1<<16;function u(N,U,x,B){const H=B.values?B.values:[B];return(0,C.hash)({[B.normalized]:{values:H.map(K=>({value:K.normalized,expectContiguousMatch:K.expectContiguousMatch})),label:N,description:U,allowNonContiguousMatches:x}})}function r(N,U,x,B,H){if(!N||!U.normalized)return l;const G=B.getItemLabel(N);if(!G)return l;const K=B.getItemDescription(N),X=u(G,K,x,U),de=H[X];if(de)return de;const be=i(G,K,B.getItemPath(N),U,x);return H[X]=be,be}e.scoreItemFuzzy=r;function i(N,U,x,B,H){const G=!x||!B.containsPathSeparator;return x&&(A.isLinux?B.pathNormalized===x:(0,_.equalsIgnoreCase)(B.pathNormalized,x))?{score:o,labelMatch:[{start:0,end:N.length}],descriptionMatch:U?[{start:0,end:U.length}]:void 0}:B.values&&B.values.length>1?s(N,U,x,B.values,G,H):c(N,U,x,B,G,H)}function s(N,U,x,B,H,G){let K=0;const X=[],de=[];for(const be of B){const{score:Se,labelMatch:Ie,descriptionMatch:Oe}=c(N,U,x,be,H,G);if(Se===S)return l;K+=Se,Ie&&X.push(...Ie),Oe&&de.push(...Oe)}return{score:K,labelMatch:w(X),descriptionMatch:w(de)}}function c(N,U,x,B,H,G){if(H||!U){const[K,X]=n(N,B.normalized,B.normalizedLowercase,G&&!B.expectContiguousMatch);if(K){const de=(0,F.matchesPrefix)(B.normalized,N);let be;return de?(be=g,be+=Math.round(B.normalized.length/N.length*100)):be=t,{score:be+K,labelMatch:de||h(X)}}}if(U){let K=U;x&&(K=`${U}${y.sep}`);const X=K.length,de=`${K}${N}`,[be,Se]=n(de,B.normalized,B.normalizedLowercase,G&&!B.expectContiguousMatch);if(be){const Ie=h(Se),Oe=[],xe=[];return Ie.forEach(ze=>{ze.start<X&&ze.end>X?(Oe.push({start:0,end:ze.end-X}),xe.push({start:ze.start,end:X})):ze.start>=X?Oe.push({start:ze.start-X,end:ze.end-X}):xe.push(ze)}),{score:be,labelMatch:Oe,descriptionMatch:xe}}}return l}function h(N){const U=[];if(!N)return U;let x;for(const B of N)x&&x.end===B?x.end+=1:(x={start:B,end:B+1},U.push(x));return U}function w(N){const U=N.sort((H,G)=>H.start-G.start),x=[];let B;for(const H of U)!B||!E(B,H)?(B=H,x.push(H)):(B.start=Math.min(B.start,H.start),B.end=Math.max(B.end,H.end));return x}function E(N,U){return!(N.end<U.start||U.end<N.start)}function p(N,U,x,B,H,G){const K=r(N,x,B,H,G),X=r(U,x,B,H,G),de=K.score,be=X.score;if((de===o||be===o)&&de!==be)return de===o?-1:1;if(de>t||be>t){if(de!==be)return de>be?-1:1;if(de<g&&be<g){const ee=L(K.labelMatch,X.labelMatch);if(ee!==0)return ee}const ze=H.getItemLabel(N)||"",j=H.getItemLabel(U)||"";if(ze.length!==j.length)return ze.length-j.length}if(de!==be)return de>be?-1:1;const Se=Array.isArray(K.labelMatch)&&K.labelMatch.length>0,Ie=Array.isArray(X.labelMatch)&&X.labelMatch.length>0;if(Se&&!Ie)return-1;if(Ie&&!Se)return 1;const Oe=T(N,K,H),xe=T(U,X,H);return Oe&&xe&&Oe!==xe?xe>Oe?-1:1:M(N,U,x,H)}e.compareItemsByFuzzyScore=p;function T(N,U,x){let B=-1,H=-1;if(U.descriptionMatch&&U.descriptionMatch.length?B=U.descriptionMatch[0].start:U.labelMatch&&U.labelMatch.length&&(B=U.labelMatch[0].start),U.labelMatch&&U.labelMatch.length){if(H=U.labelMatch[U.labelMatch.length-1].end,U.descriptionMatch&&U.descriptionMatch.length){const G=x.getItemDescription(N);G&&(H+=G.length)}}else U.descriptionMatch&&U.descriptionMatch.length&&(H=U.descriptionMatch[U.descriptionMatch.length-1].end);return H-B}function L(N,U){if(!N&&!U||(!N||!N.length)&&(!U||!U.length))return 0;if(!U||!U.length)return-1;if(!N||!N.length)return 1;const x=N[0].start,H=N[N.length-1].end-x,G=U[0].start,X=U[U.length-1].end-G;return H===X?0:X<H?1:-1}function M(N,U,x,B){const H=B.getItemLabel(N)||"",G=B.getItemLabel(U)||"",K=B.getItemDescription(N),X=B.getItemDescription(U),de=H.length+(K?K.length:0),be=G.length+(X?X.length:0);if(de!==be)return de-be;const Se=B.getItemPath(N),Ie=B.getItemPath(U);return Se&&Ie&&Se.length!==Ie.length?Se.length-Ie.length:H!==G?(0,f.compareAnything)(H,G,x.normalized):K&&X&&K!==X?(0,f.compareAnything)(K,X,x.normalized):Se&&Ie&&Se!==Ie?(0,f.compareAnything)(Se,Ie,x.normalized):0}function R(N){return N.startsWith('"')&&N.endsWith('"')}const $=" ";function z(N){typeof N!="string"&&(N="");const U=N.toLowerCase(),{pathNormalized:x,normalized:B,normalizedLowercase:H}=O(N),G=x.indexOf(y.sep)>=0,K=R(N);let X;const de=N.split($);if(de.length>1)for(const be of de){const Se=R(be),{pathNormalized:Ie,normalized:Oe,normalizedLowercase:xe}=O(be);Oe&&(X||(X=[]),X.push({original:be,originalLowercase:be.toLowerCase(),pathNormalized:Ie,normalized:Oe,normalizedLowercase:xe,expectContiguousMatch:Se}))}return{original:N,originalLowercase:U,pathNormalized:x,normalized:B,normalizedLowercase:H,values:X,containsPathSeparator:G,expectContiguousMatch:K}}e.prepareQuery=z;function O(N){let U;A.isWindows?U=N.replace(/\//g,y.sep):U=N.replace(/\\/g,y.sep);const x=(0,_.stripWildcards)(U).replace(/\s|"/g,"");return{pathNormalized:U,normalized:x,normalizedLowercase:x.toLowerCase()}}function V(N){return Array.isArray(N)?z(N.map(U=>U.original).join($)):z(N.original)}e.pieceToQuery=V}),define(fe[30],me([0,1,17,29,24,8,9]),function(Y,e,f,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function _(){return Object.create(null)}e.getEmptyExpression=_;const S="**",P="/",n="[/\\\\]",k="[^/\\\\]",a=/\//g;function m(B){switch(B){case 0:return"";case 1:return`${k}*?`;default:return`(?:${n}|${k}+${n}|${n}${k}+)*?`}}function d(B,H){if(!B)return[];const G=[];let K=!1,X=!1,de="";for(const be of B){switch(be){case H:if(!K&&!X){G.push(de),de="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":X=!0;break;case"]":X=!1;break}de+=be}return de&&G.push(de),G}e.splitGlobAware=d;function v(B){if(!B)return"";let H="";const G=d(B,P);if(G.every(K=>K===S))H=".*";else{let K=!1;G.forEach((X,de)=>{if(X===S){K||(H+=m(2),K=!0);return}let be=!1,Se="",Ie=!1,Oe="";for(const xe of X){if(xe!=="}"&&be){Se+=xe;continue}if(Ie&&(xe!=="]"||!Oe)){let ze;xe==="-"?ze=xe:(xe==="^"||xe==="!")&&!Oe?ze="^":xe===P?ze="":ze=A.escapeRegExpCharacters(xe),Oe+=ze;continue}switch(xe){case"{":be=!0;continue;case"[":Ie=!0;continue;case"}":H+=`(?:${d(Se,",").map(ee=>v(ee)).join("|")})`,be=!1,Se="";break;case"]":H+="["+Oe+"]",Ie=!1,Oe="";break;case"?":H+=k;continue;case"*":H+=m(1);continue;default:H+=A.escapeRegExpCharacters(xe)}}de<G.length-1&&(G[de+1]!==S||de+2<G.length)&&(H+=n),K=!1})}return H}const D=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new C.LRUCache(1e4),u=function(){return!1},r=function(){return null};function i(B,H){if(!B)return r;let G;typeof B!="string"?G=B.pattern:G=B,G=G.trim();const K=`${G}_${!!H.trimForExclusions}`;let X=t.get(K);if(X)return s(X,B);let de;if(D.test(G)){const be=G.substr(4);X=function(Se,Ie){return typeof Se=="string"&&Se.endsWith(be)?G:null}}else(de=I.exec(c(G,H)))?X=h(de[1],G):(H.trimForExclusions?l:b).test(G)?X=w(G,H):(de=o.exec(c(G,H)))?X=E(de[1].substr(1),G,!0):(de=g.exec(c(G,H)))?X=E(de[1],G,!1):X=p(G);return t.set(K,X),s(X,B)}function s(B,H){return typeof H=="string"?B:function(G,K){return F.isEqualOrParent(G,H.base)?B(y.relative(H.base,G),K):null}}function c(B,H){return H.trimForExclusions&&B.endsWith("/**")?B.substr(0,B.length-2):B}function h(B,H){const G=`/${B}`,K=`\\${B}`,X=function(be,Se){return typeof be!="string"?null:Se?Se===B?H:null:be===B||be.endsWith(G)||be.endsWith(K)?H:null},de=[B];return X.basenames=de,X.patterns=[H],X.allBasenames=de,X}function w(B,H){const G=x(B.slice(1,-1).split(",").map(Se=>i(Se,H)).filter(Se=>Se!==r),B),K=G.length;if(!K)return r;if(K===1)return G[0];const X=function(Se,Ie){for(let Oe=0,xe=G.length;Oe<xe;Oe++)if(G[Oe](Se,Ie))return B;return null},de=G.find(Se=>!!Se.allBasenames);de&&(X.allBasenames=de.allBasenames);const be=G.reduce((Se,Ie)=>Ie.allPaths?Se.concat(Ie.allPaths):Se,[]);return be.length&&(X.allPaths=be),X}function E(B,H,G){const K=y.sep===y.posix.sep,X=K?B:B.replace(a,y.sep),de=y.sep+X,be=y.posix.sep+B,Se=G?function(Ie,Oe){return typeof Ie=="string"&&(Ie===X||Ie.endsWith(de)||!K&&(Ie===B||Ie.endsWith(be)))?H:null}:function(Ie,Oe){return typeof Ie=="string"&&(Ie===X||!K&&Ie===B)?H:null};return Se.allPaths=[(G?"*/":"./")+B],Se}function p(B){try{const H=new RegExp(`^${v(B)}$`);return function(G){return H.lastIndex=0,typeof G=="string"&&H.test(G)?B:null}}catch(H){return r}}function T(B,H,G){return!B||typeof H!="string"?!1:L(B)(H,void 0,G)}e.match=T;function L(B,H={}){if(!B)return u;if(typeof B=="string"||z(B)){const G=i(B,H);if(G===r)return u;const K=function(X,de){return!!G(X,de)};return G.allBasenames&&(K.allBasenames=G.allBasenames),G.allPaths&&(K.allPaths=G.allPaths),K}return N(B,H)}e.parse=L;function M(B){if(!B)return;let H;return G=>(H||(H=(B()||Promise.resolve([])).then(K=>K?$(K):{})),H.then(K=>!!K[G]))}e.hasSiblingPromiseFn=M;function R(B){if(!B)return;let H;return G=>{if(!H){const K=B();H=K?$(K):{}}return!!H[G]}}e.hasSiblingFn=R;function $(B){const H={};for(const G of B)H[G]=!0;return H}function z(B){const H=B;return H&&typeof H.base=="string"&&typeof H.pattern=="string"}e.isRelativePattern=z;function O(B){return B.allBasenames||[]}e.getBasenameTerms=O;function V(B){return B.allPaths||[]}e.getPathTerms=V;function N(B,H){const G=x(Object.getOwnPropertyNames(B).map(Se=>U(Se,B[Se],H)).filter(Se=>Se!==r)),K=G.length;if(!K)return r;if(!G.some(Se=>!!Se.requiresSiblings)){if(K===1)return G[0];const Se=function(xe,ze){for(let j=0,ee=G.length;j<ee;j++){const re=G[j](xe,ze);if(re)return re}return null},Ie=G.find(xe=>!!xe.allBasenames);Ie&&(Se.allBasenames=Ie.allBasenames);const Oe=G.reduce((xe,ze)=>ze.allPaths?xe.concat(ze.allPaths):xe,[]);return Oe.length&&(Se.allPaths=Oe),Se}const X=function(Se,Ie,Oe){let xe;for(let ze=0,j=G.length;ze<j;ze++){const ee=G[ze];ee.requiresSiblings&&Oe&&(Ie||(Ie=y.basename(Se)),xe||(xe=Ie.substr(0,Ie.length-y.extname(Se).length)));const re=ee(Se,Ie,xe,Oe);if(re)return re}return null},de=G.find(Se=>!!Se.allBasenames);de&&(X.allBasenames=de.allBasenames);const be=G.reduce((Se,Ie)=>Ie.allPaths?Se.concat(Ie.allPaths):Se,[]);return be.length&&(X.allPaths=be),X}function U(B,H,G){if(H===!1)return r;const K=i(B,G);if(K===r)return r;if(typeof H=="boolean")return K;if(H){const X=H.when;if(typeof X=="string"){const de=(be,Se,Ie,Oe)=>{if(!Oe||!K(be,Se))return null;const xe=X.replace("$(basename)",Ie),ze=Oe(xe);return(0,f.isThenable)(ze)?ze.then(j=>j?B:null):ze?B:null};return de.requiresSiblings=!0,de}}return K}function x(B,H){const G=B.filter(Se=>!!Se.basenames);if(G.length<2)return B;const K=G.reduce((Se,Ie)=>{const Oe=Ie.basenames;return Oe?Se.concat(Oe):Se},[]);let X;if(H){X=[];for(let Se=0,Ie=K.length;Se<Ie;Se++)X.push(H)}else X=G.reduce((Se,Ie)=>{const Oe=Ie.patterns;return Oe?Se.concat(Oe):Se},[]);const de=function(Se,Ie){if(typeof Se!="string")return null;if(!Ie){let xe;for(xe=Se.length;xe>0;xe--){const ze=Se.charCodeAt(xe-1);if(ze===47||ze===92)break}Ie=Se.substr(xe)}const Oe=K.indexOf(Ie);return Oe!==-1?X[Oe]:null};de.basenames=K,de.patterns=X,de.allBasenames=K;const be=B.filter(Se=>!Se.basenames);return be.push(de),be}}),define(fe[79],me([0,1,29,10,8,11,23,9,2]),function(Y,e,f,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(i,s,c){if(typeof i=="string"&&(i=S.URI.file(i)),c){const w=c.getWorkspaceFolder(i);if(w){const E=c.getWorkspace().folders.length>1;let p;if((0,A.isEqual)(w.uri,i)?p="":p=(0,A.relativePath)(w.uri,i),E){const T=w.name?w.name:(0,A.basename)(w.uri);p=p?T+" \u2022 "+p:T}return p}}if(i.scheme!==F.Schemas.file&&i.scheme!==F.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,f.hasDriveLetter)(i.fsPath))return(0,C.normalize)(k(i.fsPath));let h=(0,C.normalize)(i.fsPath);return!y.isWindows&&s?.userHome&&(h=m(h,s.userHome.fsPath)),h}e.getPathLabel=P;function n(i){if(!i)return;typeof i=="string"&&(i=S.URI.file(i));const s=(0,A.basename)(i)||(i.scheme===F.Schemas.file?i.fsPath:i.path);return y.isWindows&&(0,f.isRootOrDriveLetter)(s)?k(s):s}e.getBaseLabel=n;function k(i){return(0,f.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=k;let a=Object.create(null);function m(i,s){if(y.isWindows||!i||!s)return i;let c=a.original===s?a.normalized:void 0;return c||(c=`${(0,_.rtrim)(s,C.posix.sep)}${C.posix.sep}`,a={original:s,normalized:c}),(y.isLinux?i.startsWith(c):(0,_.startsWithIgnoreCase)(i,c))&&(i=`~/${i.substr(c.length)}`),i}e.tildify=m;function d(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=d;const v="\u2026",D="\\\\",I="~";function b(i,s=C.sep){const c=new Array(i.length);let h=!1;for(let w=0;w<i.length;w++){let E=i[w];if(E===""){c[w]=`.${s}`;continue}if(!E){c[w]=E;continue}h=!0;let p="";E.indexOf(D)===0?(p=E.substr(0,E.indexOf(D)+D.length),E=E.substr(E.indexOf(D)+D.length)):E.indexOf(s)===0?(p=E.substr(0,E.indexOf(s)+s.length),E=E.substr(E.indexOf(s)+s.length)):E.indexOf(I)===0&&(p=E.substr(0,E.indexOf(I)+I.length),E=E.substr(E.indexOf(I)+I.length));const T=E.split(s);for(let L=1;h&&L<=T.length;L++)for(let M=T.length-L;h&&M>=0;M--){h=!1;let R=T.slice(M,M+L).join(s);for(let $=0;!h&&$<i.length;$++)if($!==w&&i[$]&&i[$].indexOf(R)>-1){const z=M+L===T.length,O=M>0&&i[$].indexOf(s)>-1?s+R:R,V=i[$].endsWith(O);h=!z||V}if(!h){let $="";(T[0].endsWith(":")||p!=="")&&(M===1&&(M=0,L++,R=T[0]+s+R),M>0&&($=T[0]+s),$=p+$),M>0&&($=$+v+s),$=$+R,M+L<T.length&&($=$+s+v),c[w]=$}}h&&(c[w]=E)}return c}e.shorten=b;var l;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function o(i,s=Object.create(null)){const c=[];let h=!1,w="";for(const E of i)if(E==="$"||h&&E==="{")w&&c.push({value:w,type:l.TEXT}),w="",h=!0;else if(E==="}"&&h){const p=s[w];if(typeof p=="string")p.length&&c.push({value:p,type:l.VARIABLE});else if(p){const T=c[c.length-1];(!T||T.type!==l.SEPARATOR)&&c.push({value:p.label,type:l.SEPARATOR})}w="",h=!1}else w+=E;return w&&!h&&c.push({value:w,type:l.TEXT}),c.filter((E,p)=>{if(E.type===l.SEPARATOR){const T=c[p-1],L=c[p+1];return[T,L].every(M=>M&&(M.type===l.VARIABLE||M.type===l.TEXT)&&M.value.length>0)}return!0}).map(E=>E.value).join("")}e.template=o;function g(i,s){return y.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function t(i,s){return y.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):y.isWindows?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function u(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=u;function r(i){const s=i.indexOf("/")!==-1?C.posix:C.win32,c=s.basename(i),h=s.dirname(i);return c.length?{name:c,parentPath:h}:{name:h,parentPath:""}}e.splitName=r}),define(fe[103],me([0,1,30,10,8,23,9]),function(Y,e,f,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var _;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown",i.latex="text/latex"})(_=e.Mimes||(e.Mimes={}));let S=[],P=[],n=[];function k(i,s=!1){const c=a(i);S.push(c),c.userConfigured?n.push(c):P.push(c),s&&!c.userConfigured&&S.forEach(h=>{h.mime===c.mime||h.userConfigured||(c.extension&&h.extension===c.extension&&console.warn(`Overwriting extension <<${c.extension}>> to now point to mime <<${c.mime}>>`),c.filename&&h.filename===c.filename&&console.warn(`Overwriting filename <<${c.filename}>> to now point to mime <<${c.mime}>>`),c.filepattern&&h.filepattern===c.filepattern&&console.warn(`Overwriting filepattern <<${c.filepattern}>> to now point to mime <<${c.mime}>>`),c.firstline&&h.firstline===c.firstline&&console.warn(`Overwriting firstline <<${c.firstline}>> to now point to mime <<${c.mime}>>`))})}e.registerTextMime=k;function a(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,f.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(C.posix.sep)>=0:!1}}function m(i){i?(S=S.filter(s=>!s.userConfigured),n=[]):(S=[],P=[],n=[])}e.clearTextMimes=m;function d(i,s){let c;if(i)switch(i.scheme){case F.Schemas.file:c=i.fsPath;break;case F.Schemas.data:c=y.DataUri.parseMetaData(i).get(y.DataUri.META_DATA_LABEL);break;default:c=i.path}if(!c)return[_.unknown];c=c.toLowerCase();const h=(0,C.basename)(c),w=v(c,h,n);if(w)return[w,_.text];const E=v(c,h,P);if(E)return[E,_.text];if(s){const p=D(s);if(p)return[p,_.text]}return[_.unknown]}e.guessMimeTypes=d;function v(i,s,c){let h=null,w=null,E=null;for(let p=c.length-1;p>=0;p--){const T=c[p];if(s===T.filenameLowercase){h=T;break}if(T.filepattern&&(!w||T.filepattern.length>w.filepattern.length)){const L=T.filepatternOnPath?i:s;T.filepatternLowercase?.(L)&&(w=T)}T.extension&&(!E||T.extension.length>E.extension.length)&&s.endsWith(T.extensionLowercase)&&(E=T)}return h?h.mime:w?w.mime:E?E.mime:null}function D(i){if((0,A.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let s=S.length-1;s>=0;s--){const c=S[s];if(!c.firstline)continue;const h=i.match(c.firstline);if(h&&h.length>0)return c.mime}return null}function I(i){return i?typeof i=="string"?i===_.binary||i===_.text||i===_.unknown:i.length===1&&I(i[0]):!0}e.isUnspecific=I;const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(i){const s=(0,C.extname)(i),c=b[s.toLowerCase()];return c!==void 0?c:g(i)}e.getMediaOrTextMime=o;function g(i){const s=(0,C.extname)(i);return l[s.toLowerCase()]}e.getMediaMime=g;function t(i){for(const s in l)if(l[s]===i)return s}e.getExtensionForMimeType=t;const u=/^(.+)\/(.+?)(;.+)?$/;function r(i,s){const c=u.exec(i);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:s?void 0:i}e.normalizeMimeType=r}),define(fe[104],me([0,1,2]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function F(n){return n.toJSON()}class C{constructor(k){this._uriTransformer=k}transformIncoming(k){const a=this._uriTransformer.transformIncoming(k);return a===k?k:F(f.URI.from(a))}transformOutgoing(k){const a=this._uriTransformer.transformOutgoing(k);return a===k?k:F(f.URI.from(a))}transformOutgoingURI(k){const a=this._uriTransformer.transformOutgoing(k);return a===k?k:f.URI.from(a)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function y(n,k,a){if(!n||a>200)return null;if(typeof n=="object"){if(n instanceof f.URI)return k.transformOutgoing(n);for(let m in n)if(Object.hasOwnProperty.call(n,m)){const d=y(n[m],k,a+1);d!==null&&(n[m]=d)}}return null}function A(n,k){const a=y(n,k,0);return a===null?n:a}e.transformOutgoingURIs=A;function _(n,k,a,m){if(!n||m>200)return null;if(typeof n=="object"){if(n.$mid===1)return a?f.URI.revive(k.transformIncoming(n)):k.transformIncoming(n);for(let d in n)if(Object.hasOwnProperty.call(n,d)){const v=_(n[d],k,a,m+1);v!==null&&(n[d]=v)}}return null}function S(n,k){const a=_(n,k,!1,0);return a===null?n:a}e.transformIncomingURIs=S;function P(n,k){const a=_(n,k,!0,0);return a===null?n:a}e.transformAndReviveIncomingURIs=P}),define(fe[32],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const f=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(S){return f.test(S)}e.isUUID=F;const C=new Uint8Array(16),y=[];for(let S=0;S<256;S++)y.push(S.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(S){for(let P=0;P<S.length;P++)S[P]=Math.floor(Math.random()*256);return S};function _(){A(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let S=0,P="";return P+=y[C[S++]],P+=y[C[S++]],P+=y[C[S++]],P+=y[C[S++]],P+="-",P+=y[C[S++]],P+=y[C[S++]],P+="-",P+=y[C[S++]],P+=y[C[S++]],P+="-",P+=y[C[S++]],P+=y[C[S++]],P+="-",P+=y[C[S++]],P+=y[C[S++]],P+=y[C[S++]],P+=y[C[S++]],P+=y[C[S++]],P+=y[C[S++]],P}e.generateUuid=_}),define(fe[144],me([0,1,105]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class F{constructor(y="utf8"){this.stringDecoder=new f.StringDecoder(y),this.remaining=null}write(y){const A=[],_=this.remaining?this.remaining+this.stringDecoder.write(y):this.stringDecoder.write(y);if(_.length<1)return A;let S=0,P,n=S;for(;n<_.length;)if(P=_.charCodeAt(n),P===13||P===10){if(A.push(_.substring(S,n)),n++,n<_.length){const k=P;P=_.charCodeAt(n),(k===13&&P===10||k===10&&P===13)&&n++}S=n}else n++;return this.remaining=S<_.length?_.substr(S):null,A}end(){return this.remaining}}e.LineDecoder=F}),define(fe[28],me([0,1,50,80,292,17,29,78,8,11,23,2,32]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function d(O,V=m.UNLINK){if((0,A.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return V===m.UNLINK?D(O):v(O)}async function v(O){try{const V=(0,S.join)((0,F.tmpdir)(),(0,a.generateUuid)());try{await e.Promises.rename(O,V)}catch(N){return D(O)}D(V).catch(N=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function D(O){return e.Promises.rmdir(O,{recursive:!0,maxRetries:3})}function I(O){if((0,A.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");f.rmdirSync(O,{recursive:!0})}e.rimrafSync=I;async function b(O,V){return g(await(V?l(O):(0,C.promisify)(f.readdir)(O)))}async function l(O){try{return await(0,C.promisify)(f.readdir)(O,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const V=[],N=await b(O);for(const U of N){let x=!1,B=!1,H=!1;try{const G=await e.Promises.lstat((0,S.join)(O,U));x=G.isFile(),B=G.isDirectory(),H=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}V.push({name:U,isFile:()=>x,isDirectory:()=>B,isSymbolicLink:()=>H})}return V}function o(O){return g(f.readdirSync(O))}e.readdirSync=o;function g(O){return O.map(V=>typeof V=="string"?P.isMacintosh?(0,_.normalizeNFC)(V):V:(V.name=P.isMacintosh?(0,_.normalizeNFC)(V.name):V.name,V))}async function t(O){const V=await b(O),N=[];for(const U of V)await r.existsDirectory((0,S.join)(O,U))&&N.push(U);return N}function u(O,V=1e3){return new Promise(N=>{let U=!1;const x=setInterval(()=>{U||(U=!0,f.access(O,B=>{U=!1,B&&(clearInterval(x),N(void 0))}))},V)})}e.whenDeleted=u;var r;(function(O){async function V(x){let B;try{if(B=await e.Promises.lstat(x),!B.isSymbolicLink())return{stat:B}}catch(H){}try{return{stat:await e.Promises.stat(x),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(P.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw G}throw H}}O.stat=V;async function N(x){try{const{stat:B,symbolicLink:H}=await O.stat(x);return B.isFile()&&H?.dangling!==!0}catch(B){}return!1}O.existsFile=N;async function U(x){try{const{stat:B,symbolicLink:H}=await O.stat(x);return B.isDirectory()&&H?.dangling!==!0}catch(B){}return!1}O.existsDirectory=U})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new y.ResourceQueue;function s(O,V,N){return i.queueFor(k.URI.file(O),n.extUriBiasedIgnorePathCase).queue(()=>{const U=E(N);return new Promise((x,B)=>h(O,V,U,H=>H?B(H):x()))})}let c=!0;function h(O,V,N,U){if(!c)return f.writeFile(O,V,{mode:N.mode,flag:N.flag},U);f.open(O,N.flag,N.mode,(x,B)=>{if(x)return U(x);f.writeFile(B,V,H=>{if(H)return f.close(B,()=>U(H));f.fdatasync(B,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),c=!1),f.close(B,K=>U(K))))})})}function w(O,V,N){const U=E(N);if(!c)return f.writeFileSync(O,V,{mode:U.mode,flag:U.flag});const x=f.openSync(O,U.flag,U.mode);try{f.writeFileSync(x,V);try{f.fdatasyncSync(x)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),c=!1}}finally{f.closeSync(x)}}e.writeFileSync=w;function E(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function p(O,V){if(O===V)return;async function N(U){try{const x=await e.Promises.lstat(U);if(x.isDirectory()||x.isSymbolicLink())return;await e.Promises.utimes(U,x.atime,new Date)}catch(x){}}try{await e.Promises.rename(O,V),await N(V)}catch(U){if(O.toLowerCase()!==V.toLowerCase()&&U.code==="EXDEV"||O.endsWith("."))await T(O,V,{preserveSymlinks:!1}),await d(O,m.MOVE),await N(V);else throw U}}async function T(O,V,N){return M(O,V,{root:{source:O,target:V},options:N,handledSourcePaths:new Set})}const L=511;async function M(O,V,N){if(N.handledSourcePaths.has(O))return;N.handledSourcePaths.add(O);const{stat:U,symbolicLink:x}=await r.stat(O);if(x){if(N.options.preserveSymlinks)try{return await z(O,V,N)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(x.dangling)return}return U.isDirectory()?R(O,V,U.mode&L,N):$(O,V,U.mode&L)}async function R(O,V,N,U){await e.Promises.mkdir(V,{recursive:!0,mode:N});const x=await b(O);for(const B of x)await M((0,S.join)(O,B),(0,S.join)(V,B),U)}async function $(O,V,N){await e.Promises.copyFile(O,V),await e.Promises.chmod(V,N)}async function z(O,V,N){let U=await e.Promises.readlink(O);(0,A.isEqualOrParent)(U,N.root.source,!P.isLinux)&&(U=(0,S.join)(N.root.target,U.substr(N.root.source.length+1))),await e.Promises.symlink(U,V)}e.Promises=new class{get access(){return(0,C.promisify)(f.access)}get stat(){return(0,C.promisify)(f.stat)}get lstat(){return(0,C.promisify)(f.lstat)}get utimes(){return(0,C.promisify)(f.utimes)}get read(){return(0,C.promisify)(f.read)}get readFile(){return(0,C.promisify)(f.readFile)}get write(){return(0,C.promisify)(f.write)}get appendFile(){return(0,C.promisify)(f.appendFile)}get fdatasync(){return(0,C.promisify)(f.fdatasync)}get truncate(){return(0,C.promisify)(f.truncate)}get rename(){return(0,C.promisify)(f.rename)}get copyFile(){return(0,C.promisify)(f.copyFile)}get open(){return(0,C.promisify)(f.open)}get close(){return(0,C.promisify)(f.close)}get symlink(){return(0,C.promisify)(f.symlink)}get readlink(){return(0,C.promisify)(f.readlink)}get chmod(){return(0,C.promisify)(f.chmod)}get mkdir(){return(0,C.promisify)(f.mkdir)}get unlink(){return(0,C.promisify)(f.unlink)}get rmdir(){return(0,C.promisify)(f.rmdir)}get realpath(){return(0,C.promisify)(f.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return t}get writeFile(){return s}get rm(){return d}get move(){return p}get copy(){return T}}}),define(fe[106],me([0,1,50,8,9,28]),function(Y,e,f,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(n){const k=(0,F.dirname)(n);if(n===k)return n;const a=((0,F.basename)(n)||n).toLowerCase();try{const d=(0,y.readdirSync)(k).filter(v=>v.toLowerCase()===a);if(d.length===1){const v=A(k);if(v)return(0,F.join)(v,d[0])}else if(d.length>1){const v=d.indexOf(a);if(v>=0){const D=A(k);if(D)return(0,F.join)(D,d[v])}}}catch(m){}return null}e.realcaseSync=A;async function _(n){try{return await y.Promises.realpath(n)}catch(k){const a=P(n);return await y.Promises.access(a,f.constants.R_OK),a}}e.realpath=_;function S(n){try{return f.realpathSync(n)}catch(k){const a=P(n);return f.accessSync(a,f.constants.R_OK),a}}e.realpathSync=S;function P(n){return(0,C.rtrim)((0,F.normalize)(n),F.sep)}});var je=this&&this.__decorate||function(Y,e,f,F){var C=arguments.length,y=C<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,f):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(Y,e,f,F);else for(var _=Y.length-1;_>=0;_--)(A=Y[_])&&(y=(C<3?A(y):C>3?A(e,f,y):A(e,f))||y);return C>3&&y&&Object.defineProperty(e,f,y),y};define(fe[107],me([0,1,16,17,22,21,59,18,3,6,61,9,12]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function d(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function D(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var I;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(I||(I={}));class b{constructor(B){this.buffer=B,this.pos=0}read(B){const H=this.buffer.slice(this.pos,this.pos+B);return this.pos+=H.byteLength,H}}class l{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(B){this.buffers.push(B)}}var o;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(o||(o={}));function g(x){const B=C.VSBuffer.alloc(4);return B.writeUInt32BE(x,0),B}function t(x){return x.read(4).readUInt32BE(0)}function u(x){const B=C.VSBuffer.alloc(1);return B.writeUInt8(x,0),B}const r={Undefined:u(o.Undefined),String:u(o.String),Buffer:u(o.Buffer),VSBuffer:u(o.VSBuffer),Array:u(o.Array),Object:u(o.Object)},i=typeof Buffer!="undefined";function s(x,B){if(typeof B=="undefined")x.write(r.Undefined);else if(typeof B=="string"){const H=C.VSBuffer.fromString(B);x.write(r.String),x.write(g(H.byteLength)),x.write(H)}else if(i&&Buffer.isBuffer(B)){const H=C.VSBuffer.wrap(B);x.write(r.Buffer),x.write(g(H.byteLength)),x.write(H)}else if(B instanceof C.VSBuffer)x.write(r.VSBuffer),x.write(g(B.byteLength)),x.write(B);else if(Array.isArray(B)){x.write(r.Array),x.write(g(B.length));for(const H of B)s(x,H)}else{const H=C.VSBuffer.fromString(JSON.stringify(B));x.write(r.Object),x.write(g(H.byteLength)),x.write(H)}}function c(x){switch(x.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return x.read(t(x)).toString();case o.Buffer:return x.read(t(x)).buffer;case o.VSBuffer:return x.read(t(x));case o.Array:{const H=t(x),G=[];for(let K=0;K<H;K++)G.push(c(x));return G}case o.Object:return JSON.parse(x.read(t(x)).toString())}}class h{constructor(B,H,G=null,K=1e3){this.protocol=B,this.ctx=H,this.logger=G,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(B,H){this.channels.set(B,H),setTimeout(()=>this.flushPendingRequests(B),0)}sendResponse(B){switch(B.type){case 200:{const H=this.send([B.type]);this.logger&&this.logger.logOutgoing(H,0,1,D(B.type));return}case 201:case 202:case 204:case 203:{const H=this.send([B.type,B.id],B.data);this.logger&&this.logger.logOutgoing(H,B.id,1,D(B.type),B.data);return}}}send(B,H=void 0){const G=new l;return s(G,B),s(G,H),this.sendBuffer(G.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch(H){return 0}}onRawMessage(B){const H=new b(B),G=c(H),K=c(H),X=G[0];switch(X){case 100:return this.logger&&this.logger.logIncoming(B.byteLength,G[1],1,`${d(X)}: ${G[2]}.${G[3]}`,K),this.onPromise({type:X,id:G[1],channelName:G[2],name:G[3],arg:K});case 102:return this.logger&&this.logger.logIncoming(B.byteLength,G[1],1,`${d(X)}: ${G[2]}.${G[3]}`,K),this.onEventListen({type:X,id:G[1],channelName:G[2],name:G[3],arg:K});case 101:return this.logger&&this.logger.logIncoming(B.byteLength,G[1],1,`${d(X)}`),this.disposeActiveRequest({type:X,id:G[1]});case 103:return this.logger&&this.logger.logIncoming(B.byteLength,G[1],1,`${d(X)}`),this.disposeActiveRequest({type:X,id:G[1]})}}onPromise(B){const H=this.channels.get(B.channelName);if(!H){this.collectPendingRequest(B);return}const G=new y.CancellationTokenSource;let K;try{K=H.call(this.ctx,B.name,B.arg,G.token)}catch(be){K=Promise.reject(be)}const X=B.id;K.then(be=>{this.sendResponse({id:X,data:be,type:201}),this.activeRequests.delete(B.id)},be=>{be instanceof Error?this.sendResponse({id:X,data:{message:be.message,name:be.name,stack:be.stack?be.stack.split?be.stack.split(`
`):be.stack:void 0},type:202}):this.sendResponse({id:X,data:be,type:203}),this.activeRequests.delete(B.id)});const de=(0,P.toDisposable)(()=>G.cancel());this.activeRequests.set(B.id,de)}onEventListen(B){const H=this.channels.get(B.channelName);if(!H){this.collectPendingRequest(B);return}const G=B.id,X=H.listen(this.ctx,B.name,B.arg)(de=>this.sendResponse({id:G,data:de,type:204}));this.activeRequests.set(B.id,X)}disposeActiveRequest(B){const H=this.activeRequests.get(B.id);H&&(H.dispose(),this.activeRequests.delete(B.id))}collectPendingRequest(B){let H=this.pendingRequests.get(B.channelName);H||(H=[],this.pendingRequests.set(B.channelName,H));const G=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.sendResponse({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);H.push({request:B,timeoutTimer:G})}flushPendingRequests(B){const H=this.pendingRequests.get(B);if(H){for(const G of H)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(B)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(B=>B.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var w;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(B,H=null){this.protocol=B,this.isDisposed=!1,this.state=I.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=H}getChannel(B){const H=this;return{call(G,K,X){return H.isDisposed?Promise.reject(_.canceled()):H.requestPromise(B,G,K,X)},listen(G,K){return H.isDisposed?Promise.reject(_.canceled()):H.requestEvent(B,G,K)}}}requestPromise(B,H,G,K=y.CancellationToken.None){const X=this.lastRequestId++,be={id:X,type:100,channelName:B,name:H,arg:G};if(K.isCancellationRequested)return Promise.reject(_.canceled());let Se;return new Promise((Oe,xe)=>{if(K.isCancellationRequested)return xe(_.canceled());const ze=()=>{const le=Z=>{switch(Z.type){case 201:this.handlers.delete(X),Oe(Z.data);break;case 202:this.handlers.delete(X);const ae=new Error(Z.data.message);ae.stack=Z.data.stack,ae.name=Z.data.name,xe(ae);break;case 203:this.handlers.delete(X),xe(Z.data);break}};this.handlers.set(X,le),this.sendRequest(be)};let j=null;this.state===I.Idle?ze():(j=(0,F.createCancelablePromise)(le=>this.whenInitialized()),j.then(()=>{j=null,ze()}));const ee=()=>{j?(j.cancel(),j=null):this.sendRequest({id:X,type:101}),xe(_.canceled())},re=K.onCancellationRequested(ee);Se=(0,P.combinedDisposable)((0,P.toDisposable)(ee),re),this.activeRequests.add(Se)}).finally(()=>{this.activeRequests.delete(Se)})}requestEvent(B,H,G){const K=this.lastRequestId++,de={id:K,type:102,channelName:B,name:H,arg:G};let be=null;const Se=new S.Emitter({onFirstListenerAdd:()=>{be=(0,F.createCancelablePromise)(Oe=>this.whenInitialized()),be.then(()=>{be=null,this.activeRequests.add(Se),this.sendRequest(de)})},onLastListenerRemove:()=>{be?(be.cancel(),be=null):(this.activeRequests.delete(Se),this.sendRequest({id:K,type:103}))}}),Ie=Oe=>Se.fire(Oe.data);return this.handlers.set(K,Ie),Se.event}sendRequest(B){switch(B.type){case 100:case 102:{const H=this.send([B.type,B.id,B.channelName,B.name],B.arg);this.logger&&this.logger.logOutgoing(H,B.id,0,`${d(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const H=this.send([B.type,B.id]);this.logger&&this.logger.logOutgoing(H,B.id,0,d(B.type));return}}}send(B,H=void 0){const G=new l;return s(G,B),s(G,H),this.sendBuffer(G.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch(H){return 0}}onBuffer(B){const H=new b(B),G=c(H),K=c(H),X=G[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(B.byteLength,0,0,D(X)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(B.byteLength,G[1],0,D(X),K),this.onResponse({type:G[0],id:G[1],data:K})}}onResponse(B){if(B.type===200){this.state=I.Idle,this._onDidInitialize.fire();return}const H=this.handlers.get(B.id);H&&H(B)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===I.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(B=>B.dispose()),this.activeRequests.clear()}}je([A.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class p{constructor(B){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,B(({protocol:H,onDidClientDisconnect:G})=>{S.Event.once(H.onMessage)(X=>{const de=new b(X),be=c(de),Se=new h(H,be),Ie=new E(H);this.channels.forEach((xe,ze)=>Se.registerChannel(ze,xe));const Oe={channelServer:Se,channelClient:Ie,ctx:be};this._connections.add(Oe),this._onDidAddConnection.fire(Oe),G(()=>{Se.dispose(),Ie.dispose(),this._connections.delete(Oe),this._onDidRemoveConnection.fire(Oe)})})})}get connections(){const B=[];return this._connections.forEach(H=>B.push(H)),B}getChannel(B,H){const G=this;return{call(K,X,de){let be;if((0,a.isFunction)(H)){let Ie=(0,f.getRandomElement)(G.connections.filter(H));be=Ie?Promise.resolve(Ie):S.Event.toPromise(S.Event.filter(G.onDidAddConnection,H))}else be=H.routeCall(G,K,X);const Se=be.then(Ie=>Ie.channelClient.getChannel(B));return L(Se).call(K,X,de)},listen(K,X){if((0,a.isFunction)(H))return G.getMulticastEvent(B,H,K,X);const de=H.routeEvent(G,K,X).then(be=>be.channelClient.getChannel(B));return L(de).listen(K,X)}}}getMulticastEvent(B,H,G,K){const X=this;let de=new P.DisposableStore;const be=new S.Emitter({onFirstListenerAdd:()=>{de=new P.DisposableStore;const Se=new S.EventMultiplexer,Ie=new Map,Oe=ze=>{const ee=ze.channelClient.getChannel(B).listen(G,K),re=Se.add(ee);Ie.set(ze,re)},xe=ze=>{const j=Ie.get(ze);!j||(j.dispose(),Ie.delete(ze))};X.connections.filter(H).forEach(Oe),S.Event.filter(X.onDidAddConnection,H)(Oe,void 0,de),X.onDidRemoveConnection(xe,void 0,de),Se.event(be.fire,be,de),de.add(Se)},onLastListenerRemove:()=>{de.dispose()}});return be.event}registerChannel(B,H){this.channels.set(B,H),this._connections.forEach(G=>{G.channelServer.registerChannel(B,H)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=p;class T{constructor(B,H,G=null){const K=new l;s(K,H),B.send(K.buffer),this.channelClient=new E(B,G),this.channelServer=new h(B,H,G)}getChannel(B){return this.channelClient.getChannel(B)}registerChannel(B,H){this.channelServer.registerChannel(B,H)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function L(x){return{call(B,H,G){return x.then(K=>K.call(B,H,G))},listen(B,H){const G=new S.Relay;return x.then(K=>G.input=K.listen(B,H)),G.event}}}e.getDelayedChannel=L;function M(x){let B=!1;return{call(H,G,K){return B?x.call(H,G,K):(0,F.timeout)(0).then(()=>B=!0).then(()=>x.call(H,G,K))},listen(H,G){if(B)return x.listen(H,G);const K=new S.Relay;return(0,F.timeout)(0).then(()=>B=!0).then(()=>K.input=x.listen(H,G)),K.event}}}e.getNextTickChannel=M;class R{constructor(B){this.fn=B}routeCall(B){return this.route(B)}routeEvent(B){return this.route(B)}async route(B){for(const H of B.connections)if(await Promise.resolve(this.fn(H.ctx)))return Promise.resolve(H);return await S.Event.toPromise(B.onDidAddConnection),await this.route(B)}}e.StaticRouter=R;var $;(function(x){function B(X,de){const be=X,Se=de&&de.disableMarshalling,Ie=new Map;for(const Oe in be)G(Oe)&&Ie.set(Oe,S.Event.buffer(be[Oe],!0));return new class{listen(Oe,xe,ze){const j=Ie.get(xe);if(j)return j;if(K(xe)){const ee=be[xe];if(typeof ee=="function")return ee.call(be,ze)}throw new Error(`Event not found: ${xe}`)}call(Oe,xe,ze){const j=be[xe];if(typeof j=="function"){if(!Se&&Array.isArray(ze))for(let ee=0;ee<ze.length;ee++)ze[ee]=(0,n.revive)(ze[ee]);return j.apply(be,ze)}throw new Error(`Method not found: ${xe}`)}}}x.fromService=B;function H(X,de){const be=de&&de.disableMarshalling;return new Proxy({},{get(Se,Ie){if(typeof Ie=="string")return de?.properties?.has(Ie)?de.properties.get(Ie):K(Ie)?function(Oe){return X.listen(Ie,Oe)}:G(Ie)?X.listen(Ie):async function(...Oe){let xe;de&&!(0,a.isUndefinedOrNull)(de.context)?xe=[de.context,...Oe]:xe=Oe;const ze=await X.call(Ie,xe);return be?ze:(0,n.revive)(ze)};throw new Error(`Property not found: ${String(Ie)}`)}})}x.toService=H;function G(X){return X[0]==="o"&&X[1]==="n"&&k.isUpperAsciiLetter(X.charCodeAt(2))}function K(X){return/^onDynamic/.test(X)&&k.isUpperAsciiLetter(X.charCodeAt(9))}})($=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let B=x.toString();if(B!=="[object Object]")return B}return x}function V(x){return Array.isArray(x)?x.map(O):O(x)}function N(x,B,H,G,K,X,de){de=V(de);const be=z[K],Se=be[G%be.length];let Ie=[`%c[${x}]%c[${String(B).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${Se}`];/\($/.test(X)?(Ie=Ie.concat(de),Ie.push(")")):Ie.push(de),console.log.apply(console,Ie)}e.logWithColors=N;class U{constructor(B,H){this._outgoingPrefix=B,this._incomingPrefix=H,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(B,H,G,K,X){this._totalOutgoing+=B,N(this._outgoingPrefix,this._totalOutgoing,B,H,G,K,X)}logIncoming(B,H,G,K,X){this._totalIncoming+=B,N(this._incomingPrefix,this._totalIncoming,B,H,G,K,X)}}e.IPCLogger=U}),define(fe[108],me([0,1,22,3,6,11,38,107]),function(Y,e,f,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var S;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function n(){return P||(P=f.VSBuffer.alloc(0)),P}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,s){if(i===0)return n();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const E=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=i),E}if(this._chunks[0].byteLength>i){const E=this._chunks[0].slice(0,i);return s&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),E}let c=f.VSBuffer.alloc(i),h=0,w=0;for(;i>0;){const E=this._chunks[w];if(E.byteLength>i){const p=E.slice(0,i);c.set(p,h),h+=i,s&&(this._chunks[w]=E.slice(i),this._totalLength-=i),i-=i}else c.set(E,h),h+=E.byteLength,s?(this._chunks.shift(),this._totalLength-=E.byteLength):w++,i-=E.byteLength}return c}}e.ChunkStream=k;var a;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(a||(a={}));var m;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(i,s,c,h){this.type=i,this.id=s,this.ack=c,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends C.Disposable{constructor(i){super();this._onMessage=this._register(new F.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5);else{const c=this._state.messageType,h=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(c,h,w,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class D{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=f.VSBuffer.alloc(13);s.writeUInt8(i.type,0),s.writeUInt32BE(i.id,1),s.writeUInt32BE(i.ack,5),s.writeUInt32BE(i.data.byteLength,9),this._writeSoon(s,i.data)}_bufferAdd(i,s){const c=this._totalLength===0;return this._data.push(i,s),this._totalLength+=i.byteLength+s.byteLength,c}_bufferTake(){const i=f.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,s){this._bufferAdd(i,s)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class I extends C.Disposable{constructor(i){super();this._onMessage=new F.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new D(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new d(1,0,0,i))}}e.Protocol=I;class b extends _.IPCClient{constructor(i,s,c=null){super(i,s,c);this.protocol=i}static fromSocket(i,s){return new b(new I(i),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=b;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new F.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,A.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class o{constructor(i){this.data=i,this.next=null}}class g{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],s=0,c=this._first;for(;c;)i[s++]=c.data,c=c.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const s=new o(i);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class t{constructor(){this.lastRuns=[];const i=Date.now();for(let s=0;s<t._HISTORY_LENGTH;s++)this.lastRuns[s]=i-1e3*s;setInterval(()=>{for(let s=t._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const i=Date.now(),s=(1+t._HISTORY_LENGTH)*1e3;let c=0;for(let h=0;h<t._HISTORY_LENGTH;h++)i-this.lastRuns[h]<=s&&c++;return 1-c/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class u{constructor(i,s=null,c=t.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new g,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),s&&this._socketReader.acceptChunk(s),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new d(5,0,0,n());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const s=new d(4,0,0,n());this._socketWriter.write(s),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,s){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new D(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let s=0,c=i.length;s<c;s++)this._socketWriter.write(i[s]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new d(6,0,0,n())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const s=this._outgoingUnackMsg.toArray();for(let c=0,h=s.length;c<h;c++)this._socketWriter.write(s[c]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new d(1,s,this._incomingAckId,i);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(i){const s=new d(2,0,0,i);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),s=Date.now()-i.writtenTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-s,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new d(3,0,this._incomingAckId,n());this._socketWriter.write(i)}}e.PersistentProtocol=u}),define(fe[109],me([0,1,98]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class F{constructor(_){let S=(0,f.toUint8)(_);this._defaultValue=S,this._asciiMap=F._createAsciiMap(S),this._map=new Map}static _createAsciiMap(_){let S=new Uint8Array(256);for(let P=0;P<256;P++)S[P]=_;return S}set(_,S){let P=(0,f.toUint8)(S);_>=0&&_<256?this._asciiMap[_]=P:this._map.set(_,P)}get(_){return _>=0&&_<256?this._asciiMap[_]:this._map.get(_)||this._defaultValue}}e.CharacterClassifier=F;var C;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(C||(C={}));class y{constructor(){this._actual=new F(0)}add(_){this._actual.set(_,1)}has(_){return this._actual.get(_)===1}}e.CharacterSet=y}),define(fe[145],me([0,1,109]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var F;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(F=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends f.CharacterClassifier{constructor(_){super(0);for(let S=0,P=_.length;S<P;S++)this.set(_.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function y(A){let _={};return S=>(_.hasOwnProperty(S)||(_[S]=A(S)),_[S])}e.getMapForWordSeparators=y(A=>new C(A))}),define(fe[51],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class f{constructor(C,y){this.lineNumber=C,this.column=y}with(C=this.lineNumber,y=this.column){return C===this.lineNumber&&y===this.column?this:new f(C,y)}delta(C=0,y=0){return this.with(this.lineNumber+C,this.column+y)}equals(C){return f.equals(this,C)}static equals(C,y){return!C&&!y?!0:!!C&&!!y&&C.lineNumber===y.lineNumber&&C.column===y.column}isBefore(C){return f.isBefore(this,C)}static isBefore(C,y){return C.lineNumber<y.lineNumber?!0:y.lineNumber<C.lineNumber?!1:C.column<y.column}isBeforeOrEqual(C){return f.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,y){return C.lineNumber<y.lineNumber?!0:y.lineNumber<C.lineNumber?!1:C.column<=y.column}static compare(C,y){let A=C.lineNumber|0,_=y.lineNumber|0;if(A===_){let S=C.column|0,P=y.column|0;return S-P}return A-_}clone(){return new f(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new f(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=f}),define(fe[42],me([0,1,51]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class F{constructor(y,A,_,S){y>_||y===_&&A>S?(this.startLineNumber=_,this.startColumn=S,this.endLineNumber=y,this.endColumn=A):(this.startLineNumber=y,this.startColumn=A,this.endLineNumber=_,this.endColumn=S)}isEmpty(){return F.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return F.containsPosition(this,y)}static containsPosition(y,A){return!(A.lineNumber<y.startLineNumber||A.lineNumber>y.endLineNumber||A.lineNumber===y.startLineNumber&&A.column<y.startColumn||A.lineNumber===y.endLineNumber&&A.column>y.endColumn)}containsRange(y){return F.containsRange(this,y)}static containsRange(y,A){return!(A.startLineNumber<y.startLineNumber||A.endLineNumber<y.startLineNumber||A.startLineNumber>y.endLineNumber||A.endLineNumber>y.endLineNumber||A.startLineNumber===y.startLineNumber&&A.startColumn<y.startColumn||A.endLineNumber===y.endLineNumber&&A.endColumn>y.endColumn)}strictContainsRange(y){return F.strictContainsRange(this,y)}static strictContainsRange(y,A){return!(A.startLineNumber<y.startLineNumber||A.endLineNumber<y.startLineNumber||A.startLineNumber>y.endLineNumber||A.endLineNumber>y.endLineNumber||A.startLineNumber===y.startLineNumber&&A.startColumn<=y.startColumn||A.endLineNumber===y.endLineNumber&&A.endColumn>=y.endColumn)}plusRange(y){return F.plusRange(this,y)}static plusRange(y,A){let _,S,P,n;return A.startLineNumber<y.startLineNumber?(_=A.startLineNumber,S=A.startColumn):A.startLineNumber===y.startLineNumber?(_=A.startLineNumber,S=Math.min(A.startColumn,y.startColumn)):(_=y.startLineNumber,S=y.startColumn),A.endLineNumber>y.endLineNumber?(P=A.endLineNumber,n=A.endColumn):A.endLineNumber===y.endLineNumber?(P=A.endLineNumber,n=Math.max(A.endColumn,y.endColumn)):(P=y.endLineNumber,n=y.endColumn),new F(_,S,P,n)}intersectRanges(y){return F.intersectRanges(this,y)}static intersectRanges(y,A){let _=y.startLineNumber,S=y.startColumn,P=y.endLineNumber,n=y.endColumn,k=A.startLineNumber,a=A.startColumn,m=A.endLineNumber,d=A.endColumn;return _<k?(_=k,S=a):_===k&&(S=Math.max(S,a)),P>m?(P=m,n=d):P===m&&(n=Math.min(n,d)),_>P||_===P&&S>n?null:new F(_,S,P,n)}equalsRange(y){return F.equalsRange(this,y)}static equalsRange(y,A){return!!y&&!!A&&y.startLineNumber===A.startLineNumber&&y.startColumn===A.startColumn&&y.endLineNumber===A.endLineNumber&&y.endColumn===A.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(y){return new f.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(y){return new f.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,A){return new F(this.startLineNumber,this.startColumn,y,A)}setStartPosition(y,A){return new F(y,A,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(y){return new F(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,A=y){return new F(y.lineNumber,y.column,A.lineNumber,A.column)}static lift(y){return y?new F(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,A){return!(y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn||A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn)}static areIntersecting(y,A){return!(y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn||A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,A){if(y&&A){const P=y.startLineNumber|0,n=A.startLineNumber|0;if(P===n){const k=y.startColumn|0,a=A.startColumn|0;if(k===a){const m=y.endLineNumber|0,d=A.endLineNumber|0;if(m===d){const v=y.endColumn|0,D=A.endColumn|0;return v-D}return m-d}return k-a}return P-n}return(y?1:0)-(A?1:0)}static compareRangesUsingEnds(y,A){return y.endLineNumber===A.endLineNumber?y.endColumn===A.endColumn?y.startLineNumber===A.startLineNumber?y.startColumn-A.startColumn:y.startLineNumber-A.startLineNumber:y.endColumn-A.endColumn:y.endLineNumber-A.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=F}),define(fe[146],me([0,1,51,42]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class y extends F.Range{constructor(_,S,P,n){super(_,S,P,n);this.selectionStartLineNumber=_,this.selectionStartColumn=S,this.positionLineNumber=P,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(_){return y.selectionsEqual(this,_)}static selectionsEqual(_,S){return _.selectionStartLineNumber===S.selectionStartLineNumber&&_.selectionStartColumn===S.selectionStartColumn&&_.positionLineNumber===S.positionLineNumber&&_.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(_,S){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,_,S):new y(_,S,this.startLineNumber,this.startColumn)}getPosition(){return new f.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(_,S){return this.getDirection()===0?new y(_,S,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,_,S)}static fromPositions(_,S=_){return new y(_.lineNumber,_.column,S.lineNumber,S.column)}static liftSelection(_){return new y(_.selectionStartLineNumber,_.selectionStartColumn,_.positionLineNumber,_.positionColumn)}static selectionsArrEqual(_,S){if(_&&!S||!_&&S)return!1;if(!_&&!S)return!0;if(_.length!==S.length)return!1;for(let P=0,n=_.length;P<n;P++)if(!this.selectionsEqual(_[P],S[P]))return!1;return!0}static isISelection(_){return _&&typeof _.selectionStartLineNumber=="number"&&typeof _.selectionStartColumn=="number"&&typeof _.positionLineNumber=="number"&&typeof _.positionColumn=="number"}static createWithDirection(_,S,P,n,k){return k===0?new y(_,S,P,n):new y(P,n,_,S)}}e.Selection=y}),define(fe[110],me([0,1,25]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.BracketPair=e.IndentGuide=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var F;(function(I){I[I.Left=1]="Left",I[I.Center=2]="Center",I[I.Right=4]="Right",I[I.Full=7]="Full"})(F=e.OverviewRulerLane||(e.OverviewRulerLane={}));var C;(function(I){I[I.Inline=1]="Inline",I[I.Gutter=2]="Gutter"})(C=e.MinimapPosition||(e.MinimapPosition={}));var y;(function(I){I[I.TextDefined=0]="TextDefined",I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(y=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(I){I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var _;(function(I){I[I.LF=0]="LF",I[I.CRLF=1]="CRLF"})(_=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(b){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,b.tabSize|0),this.indentSize=b.tabSize|0,this.insertSpaces=Boolean(b.insertSpaces),this.defaultEOL=b.defaultEOL|0,this.trimAutoWhitespace=Boolean(b.trimAutoWhitespace),this.bracketPairColorizationOptions=b.bracketPairColorizationOptions}equals(b){return this.tabSize===b.tabSize&&this.indentSize===b.indentSize&&this.insertSpaces===b.insertSpaces&&this.defaultEOL===b.defaultEOL&&this.trimAutoWhitespace===b.trimAutoWhitespace&&(0,f.equals)(this.bracketPairColorizationOptions,b.bracketPairColorizationOptions)}createChangeEvent(b){return{tabSize:this.tabSize!==b.tabSize,indentSize:this.indentSize!==b.indentSize,insertSpaces:this.insertSpaces!==b.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==b.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class P{constructor(b,l){this._findMatchBrand=void 0,this.range=b,this.matches=l}}e.FindMatch=P;var n;(function(I){I[I.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",I[I.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",I[I.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",I[I.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));class k{constructor(b,l){this.visibleColumn=b,this.className=l}}e.IndentGuide=k;class a{constructor(b,l,o,g){this.range=b,this.openingBracketRange=l,this.closingBracketRange=o,this.nestingLevel=g}}e.BracketPair=a;var m;(function(I){I[I.Left=0]="Left",I[I.Right=1]="Right",I[I.None=2]="None"})(m=e.PositionAffinity||(e.PositionAffinity={}));var d;(function(I){I[I.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(d=e.ModelConstants||(e.ModelConstants={}));class v{constructor(b,l,o,g,t,u){this.identifier=b,this.range=l,this.text=o,this.forceMoveMarkers=g,this.isAutoWhitespaceEdit=t,this._isTracked=u}}e.ValidAnnotatedEditOperation=v;class D{constructor(b,l,o){this.reverseEdits=b,this.changes=l,this.trimAutoWhitespaceLineNumbers=o}}e.ApplyEditsResult=D}),define(fe[147],me([0,1,9,145,51,42,110]),function(Y,e,f,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const _=999;class S{constructor(l,o,g,t){this.searchString=l,this.isRegex=o,this.matchCase=g,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let l;this.isRegex?l=P(this.searchString):l=this.searchString.indexOf(`
`)>=0;let o=null;try{o=f.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:l,global:!0,unicode:!0})}catch(t){return null}if(!o)return null;let g=!this.isRegex&&!l;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new n(o,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=S;function P(b){if(!b||b.length===0)return!1;for(let l=0,o=b.length;l<o;l++)if(b.charCodeAt(l)===92){if(l++,l>=o)break;const t=b.charCodeAt(l);if(t===110||t===114||t===87)return!0}return!1}e.isMultilineRegexSource=P;class n{constructor(l,o,g){this.regex=l,this.wordSeparators=o,this.simpleSearch=g}}e.SearchData=n;function k(b,l,o){if(!o)return new A.FindMatch(b,null);let g=[];for(let t=0,u=l.length;t<u;t++)g[t]=l[t];return new A.FindMatch(b,g)}e.createFindMatch=k;class a{constructor(l){let o=[],g=0;for(let t=0,u=l.length;t<u;t++)l.charCodeAt(t)===10&&(o[g++]=t);this._lineFeedsOffsets=o}findLineFeedCountBeforeOffset(l){const o=this._lineFeedsOffsets;let g=0,t=o.length-1;if(t===-1||l<=o[0])return 0;for(;g<t;){const u=g+((t-g)/2>>0);o[u]>=l?t=u-1:o[u+1]>=l?(g=u,t=u):g=u+1}return g+1}}class m{static findMatches(l,o,g,t,u){const r=o.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(l,g,new I(r.wordSeparators,r.regex),t,u):this._doFindMatchesLineByLine(l,g,r,t,u):[]}static _getMultilineMatchRange(l,o,g,t,u,r){let i,s=0;t?(s=t.findLineFeedCountBeforeOffset(u),i=o+u+s):i=o+u;let c;if(t){let p=t.findLineFeedCountBeforeOffset(u+r.length)-s;c=i+r.length+p}else c=i+r.length;const h=l.getPositionAt(i),w=l.getPositionAt(c);return new y.Range(h.lineNumber,h.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(l,o,g,t,u){const r=l.getOffsetAt(o.getStartPosition()),i=l.getValueInRange(o,1),s=l.getEOL()===`\r
`?new a(i):null,c=[];let h=0,w;for(g.reset(0);w=g.next(i);)if(c[h++]=k(this._getMultilineMatchRange(l,r,i,s,w.index,w[0]),w,t),h>=u)return c;return c}static _doFindMatchesLineByLine(l,o,g,t,u){const r=[];let i=0;if(o.startLineNumber===o.endLineNumber){const c=l.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return i=this._findMatchesInLine(g,c,o.startLineNumber,o.startColumn-1,i,r,t,u),r}const s=l.getLineContent(o.startLineNumber).substring(o.startColumn-1);i=this._findMatchesInLine(g,s,o.startLineNumber,o.startColumn-1,i,r,t,u);for(let c=o.startLineNumber+1;c<o.endLineNumber&&i<u;c++)i=this._findMatchesInLine(g,l.getLineContent(c),c,0,i,r,t,u);if(i<u){const c=l.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);i=this._findMatchesInLine(g,c,o.endLineNumber,0,i,r,t,u)}return r}static _findMatchesInLine(l,o,g,t,u,r,i,s){const c=l.wordSeparators;if(!i&&l.simpleSearch){const E=l.simpleSearch,p=E.length,T=o.length;let L=-p;for(;(L=o.indexOf(E,L+p))!==-1;)if((!c||D(c,o,T,L,p))&&(r[u++]=new A.FindMatch(new y.Range(g,L+1+t,g,L+1+p+t),null),u>=s))return u;return u}const h=new I(l.wordSeparators,l.regex);let w;h.reset(0);do if(w=h.next(o),w&&(r[u++]=k(new y.Range(g,w.index+1+t,g,w.index+1+w[0].length+t),w,i),u>=s))return u;while(w);return u}static findNextMatch(l,o,g,t){const u=o.parseSearchRequest();if(!u)return null;const r=new I(u.wordSeparators,u.regex);return u.regex.multiline?this._doFindNextMatchMultiline(l,g,r,t):this._doFindNextMatchLineByLine(l,g,r,t)}static _doFindNextMatchMultiline(l,o,g,t){const u=new C.Position(o.lineNumber,1),r=l.getOffsetAt(u),i=l.getLineCount(),s=l.getValueInRange(new y.Range(u.lineNumber,u.column,i,l.getLineMaxColumn(i)),1),c=l.getEOL()===`\r
`?new a(s):null;g.reset(o.column-1);let h=g.next(s);return h?k(this._getMultilineMatchRange(l,r,s,c,h.index,h[0]),h,t):o.lineNumber!==1||o.column!==1?this._doFindNextMatchMultiline(l,new C.Position(1,1),g,t):null}static _doFindNextMatchLineByLine(l,o,g,t){const u=l.getLineCount(),r=o.lineNumber,i=l.getLineContent(r),s=this._findFirstMatchInLine(g,i,r,o.column,t);if(s)return s;for(let c=1;c<=u;c++){const h=(r+c-1)%u,w=l.getLineContent(h+1),E=this._findFirstMatchInLine(g,w,h+1,1,t);if(E)return E}return null}static _findFirstMatchInLine(l,o,g,t,u){l.reset(t-1);const r=l.next(o);return r?k(new y.Range(g,r.index+1,g,r.index+1+r[0].length),r,u):null}static findPreviousMatch(l,o,g,t){const u=o.parseSearchRequest();if(!u)return null;const r=new I(u.wordSeparators,u.regex);return u.regex.multiline?this._doFindPreviousMatchMultiline(l,g,r,t):this._doFindPreviousMatchLineByLine(l,g,r,t)}static _doFindPreviousMatchMultiline(l,o,g,t){const u=this._doFindMatchesMultiline(l,new y.Range(1,1,o.lineNumber,o.column),g,t,10*_);if(u.length>0)return u[u.length-1];const r=l.getLineCount();return o.lineNumber!==r||o.column!==l.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(l,new C.Position(r,l.getLineMaxColumn(r)),g,t):null}static _doFindPreviousMatchLineByLine(l,o,g,t){const u=l.getLineCount(),r=o.lineNumber,i=l.getLineContent(r).substring(0,o.column-1),s=this._findLastMatchInLine(g,i,r,t);if(s)return s;for(let c=1;c<=u;c++){const h=(u+r-c-1)%u,w=l.getLineContent(h+1),E=this._findLastMatchInLine(g,w,h+1,t);if(E)return E}return null}static _findLastMatchInLine(l,o,g,t){let u=null,r;for(l.reset(0);r=l.next(o);)u=k(new y.Range(g,r.index+1,g,r.index+1+r[0].length),r,t);return u}}e.TextModelSearch=m;function d(b,l,o,g,t){if(g===0)return!0;const u=l.charCodeAt(g-1);if(b.get(u)!==0||u===13||u===10)return!0;if(t>0){const r=l.charCodeAt(g);if(b.get(r)!==0)return!0}return!1}function v(b,l,o,g,t){if(g+t===o)return!0;const u=l.charCodeAt(g+t);if(b.get(u)!==0||u===13||u===10)return!0;if(t>0){const r=l.charCodeAt(g+t-1);if(b.get(r)!==0)return!0}return!1}function D(b,l,o,g,t){return d(b,l,o,g,t)&&v(b,l,o,g,t)}e.isValidMatch=D;class I{constructor(l,o){this._wordSeparators=l,this._searchRegex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(l){this._searchRegex.lastIndex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(l){const o=l.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===o||(g=this._searchRegex.exec(l),!g))return null;const t=g.index,u=g[0].length;if(t===this._prevMatchStartIndex&&u===this._prevMatchLength){if(u===0){f.getNextCodePoint(l,o,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=u,!this._wordSeparators||D(this._wordSeparators,l,o,t,u))return g}while(g);return null}}e.Searcher=I}),define(fe[111],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(_=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)_.indexOf(P)>=0||(S+="\\"+P);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=f();function F(_){let S=e.DEFAULT_WORD_REGEXP;if(_&&_ instanceof RegExp)if(_.global)S=_;else{let P="g";_.ignoreCase&&(P+="i"),_.multiline&&(P+="m"),_.unicode&&(P+="u"),S=new RegExp(_.source,P)}return S.lastIndex=0,S}e.ensureValidWordDefinition=F;const C={maxLen:1e3,windowSize:15,timeBudget:150};function y(_,S,P,n,k=C){if(P.length>k.maxLen){let D=_-k.maxLen/2;return D<0?D=0:n+=D,P=P.substring(D,_+k.maxLen/2),y(_,S,P,n,k)}const a=Date.now(),m=_-1-n;let d=-1,v=null;for(let D=1;!(Date.now()-a>=k.timeBudget);D++){const I=m-k.windowSize*D;S.lastIndex=Math.max(0,I);const b=A(S,P,m,d);if(!b&&v||(v=b,I<=0))break;d=I}if(v){let D={word:v[0],startColumn:n+1+v.index,endColumn:n+1+v.index+v[0].length};return S.lastIndex=0,D}return null}e.getWordAtText=y;function A(_,S,P,n){let k;for(;k=_.exec(S);){const a=k.index||0;if(a<=P&&_.lastIndex>=P)return k;if(n>0&&a>n)return null}return null}}),define(fe[148],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var f;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(f=e.IndentAction||(e.IndentAction={}));class F{constructor(_){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=_.open,this.close=_.close,this._standardTokenMask=0,Array.isArray(_.notIn))for(let S=0,P=_.notIn.length;S<P;S++)switch(_.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(_){return(this._standardTokenMask&_)==0}}e.StandardAutoClosingPairConditional=F;class C{constructor(_){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of _)y(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),y(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),y(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),y(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&y(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=C;function y(A,_,S){A.has(_)?A.get(_).push(S):A.set(_,[S])}}),define(fe[81],me([0,1,30,8]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(y,A,_,S){if(Array.isArray(y)){let P=0;for(const n of y){const k=C(n,A,_,S);if(k===10)return k;k>P&&(P=k)}return P}else{if(typeof y=="string")return S?y==="*"?5:y===_?10:0:0;if(y){const{language:P,pattern:n,scheme:k,hasAccessToAllModels:a}=y;if(!S&&!a)return 0;let m=0;if(k)if(k===A.scheme)m=10;else if(k==="*")m=5;else return 0;if(P)if(P===_)m=10;else if(P==="*")m=Math.max(m,5);else return 0;if(n){let d;if(typeof n=="string"?d=n:d={...n,base:(0,F.normalize)(n.base)},d===A.fsPath||(0,f.match)(d,A.fsPath))m=10;else return 0}return m}else return 0}}e.score=C}),define(fe[149],me([0,1,109]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var F;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(F=e.State||(e.State={}));class C{constructor(d,v,D){const I=new Uint8Array(d*v);for(let b=0,l=d*v;b<l;b++)I[b]=D;this._data=I,this.rows=d,this.cols=v}get(d,v){return this._data[d*this.cols+v]}set(d,v,D){this._data[d*this.cols+v]=D}}e.Uint8Matrix=C;class y{constructor(d){let v=0,D=0;for(let b=0,l=d.length;b<l;b++){let[o,g,t]=d[b];g>v&&(v=g),o>D&&(D=o),t>D&&(D=t)}v++,D++;let I=new C(D,v,0);for(let b=0,l=d.length;b<l;b++){let[o,g,t]=d[b];I.set(o,g,t)}this._states=I,this._maxCharCode=v}nextState(d,v){return v<0||v>=this._maxCharCode?0:this._states.get(d,v)}}e.StateMachine=y;let A=null;function _(){return A===null&&(A=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var S;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let P=null;function n(){if(P===null){P=new f.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<m.length;v++)P.set(m.charCodeAt(v),1);const d=".,;";for(let v=0;v<d.length;v++)P.set(d.charCodeAt(v),2)}return P}class k{static _createLink(d,v,D,I,b){let l=b-1;do{const o=v.charCodeAt(l);if(d.get(o)!==2)break;l--}while(l>I);if(I>0){const o=v.charCodeAt(I-1),g=v.charCodeAt(l);(o===40&&g===41||o===91&&g===93||o===123&&g===125)&&l--}return{range:{startLineNumber:D,startColumn:I+1,endLineNumber:D,endColumn:l+2},url:v.substring(I,l+1)}}static computeLinks(d,v=_()){const D=n();let I=[];for(let b=1,l=d.getLineCount();b<=l;b++){const o=d.getLineContent(b),g=o.length;let t=0,u=0,r=0,i=1,s=!1,c=!1,h=!1,w=!1;for(;t<g;){let E=!1;const p=o.charCodeAt(t);if(i===13){let T;switch(p){case 40:s=!0,T=0;break;case 41:T=s?0:1;break;case 91:h=!0,c=!0,T=0;break;case 93:h=!1,T=c?0:1;break;case 123:w=!0,T=0;break;case 125:T=w?0:1;break;case 39:T=r===34||r===96?0:1;break;case 34:T=r===39||r===96?0:1;break;case 96:T=r===39||r===34?0:1;break;case 42:T=r===42?1:0;break;case 124:T=r===124?1:0;break;case 32:T=h?0:1;break;default:T=D.get(p)}T===1&&(I.push(k._createLink(D,o,b,u,t)),E=!0)}else if(i===12){let T;p===91?(c=!0,T=0):T=D.get(p),T===1?E=!0:i=13}else i=v.nextState(i,p),i===0&&(E=!0);E&&(i=1,s=!1,c=!1,w=!1,u=t+1,r=p),t++}i===13&&I.push(k._createLink(D,o,b,u,g))}return I}}e.LinkComputer=k;function a(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:k.computeLinks(m)}e.computeLinks=a}),define(fe[150],me([0,1,3,6]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class C{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new f.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,_){return this._map.set(A,_),this.fire([A]),(0,F.toDisposable)(()=>{this._map.get(A)===_&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,_){let S=null,P=!1;return this._promises.set(A,_.then(n=>{this._promises.delete(A),!(P||!n)&&(S=this.register(A,n))})),(0,F.toDisposable)(()=>{P=!0,S&&S.dispose()})}getPromise(A){const _=this.get(A);if(_)return Promise.resolve(_);const S=this._promises.get(A);return S?S.then(P=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=C}),define(fe[112],me([0,1,22,11]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function y(k){for(let a=0,m=k.length;a<m;a+=4){const d=k[a+0],v=k[a+1],D=k[a+2],I=k[a+3];k[a+0]=I,k[a+1]=D,k[a+2]=v,k[a+3]=d}}function A(k){const a=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return F.isLittleEndian()||y(a),f.VSBuffer.wrap(a)}function _(k){const a=k.buffer;if(F.isLittleEndian()||y(a),a.byteOffset%4==0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const m=new Uint8Array(a.byteLength);return m.set(a),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function S(k){const a=new Uint32Array(P(k));let m=0;if(a[m++]=k.id,k.type==="full")a[m++]=1,a[m++]=k.data.length,a.set(k.data,m),m+=k.data.length;else{a[m++]=2,a[m++]=k.deltas.length;for(const d of k.deltas)a[m++]=d.start,a[m++]=d.deleteCount,d.data?(a[m++]=d.data.length,a.set(d.data,m),m+=d.data.length):a[m++]=0}return A(a)}e.encodeSemanticTokensDto=S;function P(k){let a=0;if(a+=1+1,k.type==="full")a+=1+k.data.length;else{a+=1,a+=(1+1+1)*k.deltas.length;for(const m of k.deltas)m.data&&(a+=m.data.length)}return a}function n(k){const a=_(k);let m=0;const d=a[m++];if(a[m++]===1){const b=a[m++],l=a.subarray(m,m+b);return m+=b,{id:d,type:"full",data:l}}const D=a[m++];let I=[];for(let b=0;b<D;b++){const l=a[m++],o=a[m++],g=a[m++];let t;g>0&&(t=a.subarray(m,m+g),m+=g),I[b]={start:l,deleteCount:o,data:t}}return{id:d,type:"delta",deltas:I}}e.decodeSemanticTokensDto=n}),define(fe[113],me([0,1,98]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class F{constructor(A,_){this._prefixSumIndexOfResultBrand=void 0,this.index=A,this.remainder=_}}e.PrefixSumIndexOfResult=F;class C{constructor(A){this.values=A,this.prefixSum=new Uint32Array(A.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(A,_){A=(0,f.toUint32)(A);const S=this.values,P=this.prefixSum,n=_.length;return n===0?!1:(this.values=new Uint32Array(S.length+n),this.values.set(S.subarray(0,A),0),this.values.set(S.subarray(A),A+n),this.values.set(_,A),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(A,_){return A=(0,f.toUint32)(A),_=(0,f.toUint32)(_),this.values[A]===_?!1:(this.values[A]=_,A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),!0)}removeValues(A,_){A=(0,f.toUint32)(A),_=(0,f.toUint32)(_);const S=this.values,P=this.prefixSum;if(A>=S.length)return!1;let n=S.length-A;return _>=n&&(_=n),_===0?!1:(this.values=new Uint32Array(S.length-_),this.values.set(S.subarray(0,A),0),this.values.set(S.subarray(A+_),A),this.prefixSum=new Uint32Array(this.values.length),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(A){return A<0?0:(A=(0,f.toUint32)(A),this._getPrefixSum(A))}_getPrefixSum(A){if(A<=this.prefixSumValidIndex[0])return this.prefixSum[A];let _=this.prefixSumValidIndex[0]+1;_===0&&(this.prefixSum[0]=this.values[0],_++),A>=this.values.length&&(A=this.values.length-1);for(let S=_;S<=A;S++)this.prefixSum[S]=this.prefixSum[S-1]+this.values[S];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],A),this.prefixSum[A]}getIndexOf(A){A=Math.floor(A),this.getTotalSum();let _=0,S=this.values.length-1,P=0,n=0,k=0;for(;_<=S;)if(P=_+(S-_)/2|0,n=this.prefixSum[P],k=n-this.values[P],A<k)S=P-1;else if(A>=n)_=P+1;else break;return new F(P,A-k)}}e.PrefixSumComputer=C}),define(fe[151],me([0,1,9,51,113]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(_,S,P,n){this._uri=_,this._lines=S,this._eol=P,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(_){_.eol&&_.eol!==this._eol&&(this._eol=_.eol,this._lineStarts=null);const S=_.changes;for(const P of S)this._acceptDeleteRange(P.range),this._acceptInsertText(new F.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=_.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const _=this._eol.length,S=this._lines.length,P=new Uint32Array(S);for(let n=0;n<S;n++)P[n]=this._lines[n].length+_;this._lineStarts=new C.PrefixSumComputer(P)}}_setLineText(_,S){this._lines[_]=S,this._lineStarts&&this._lineStarts.changeValue(_,this._lines[_].length+this._eol.length)}_acceptDeleteRange(_){if(_.startLineNumber===_.endLineNumber){if(_.startColumn===_.endColumn)return;this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.startLineNumber-1].substring(_.endColumn-1));return}this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.endLineNumber-1].substring(_.endColumn-1)),this._lines.splice(_.startLineNumber,_.endLineNumber-_.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(_.startLineNumber,_.endLineNumber-_.startLineNumber)}_acceptInsertText(_,S){if(S.length===0)return;let P=(0,f.splitLines)(S);if(P.length===1){this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+P[0]+this._lines[_.lineNumber-1].substring(_.column-1));return}P[P.length-1]+=this._lines[_.lineNumber-1].substring(_.column-1),this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+P[0]);let n=new Uint32Array(P.length-1);for(let k=1;k<P.length;k++)this._lines.splice(_.lineNumber+k-1,0,P[k]),n[k-1]=P[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(_.lineNumber,n)}}e.MirrorTextModel=y}),define(fe[152],me([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(fe[153],me([0,1,152]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const F=60,C=F*60,y=C*24,A=y*7,_=y*30,S=y*365;function P(k,a){typeof k!="number"&&(k=k.getTime());const m=Math.round((new Date().getTime()-k)/1e3);if(m<-30)return(0,f.localize)(0,null,P(new Date().getTime()+m*1e3,!1));if(m<30)return(0,f.localize)(1,null);let d;return m<F?(d=m,a?d===1?(0,f.localize)(2,null,d):(0,f.localize)(3,null,d):d===1?(0,f.localize)(4,null,d):(0,f.localize)(5,null,d)):m<C?(d=Math.floor(m/F),a?d===1?(0,f.localize)(6,null,d):(0,f.localize)(7,null,d):d===1?(0,f.localize)(8,null,d):(0,f.localize)(9,null,d)):m<y?(d=Math.floor(m/C),a?d===1?(0,f.localize)(10,null,d):(0,f.localize)(11,null,d):d===1?(0,f.localize)(12,null,d):(0,f.localize)(13,null,d)):m<A?(d=Math.floor(m/y),a?d===1?(0,f.localize)(14,null,d):(0,f.localize)(15,null,d):d===1?(0,f.localize)(16,null,d):(0,f.localize)(17,null,d)):m<_?(d=Math.floor(m/A),a?d===1?(0,f.localize)(18,null,d):(0,f.localize)(19,null,d):d===1?(0,f.localize)(20,null,d):(0,f.localize)(21,null,d)):m<S?(d=Math.floor(m/_),a?d===1?(0,f.localize)(22,null,d):(0,f.localize)(23,null,d):d===1?(0,f.localize)(24,null,d):(0,f.localize)(25,null,d)):(d=Math.floor(m/S),a?d===1?(0,f.localize)(26,null,d):(0,f.localize)(27,null,d):d===1?(0,f.localize)(28,null,d):(0,f.localize)(29,null,d))}e.fromNow=P;function n(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(fe[154],me([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(fe[62],me([0,1,16,12,154]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(P,n){return n&&(P.stack||P.stacktrace)?C.localize(0,null,_(P),A(P.stack)||A(P.stacktrace)):_(P)}function A(P){return Array.isArray(P)?P.join(`
`):P}function _(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?C.localize(1,null,P.message):P.message||C.localize(2,null)}function S(P=null,n=!1){if(!P)return C.localize(3,null);if(Array.isArray(P)){const k=f.coalesce(P),a=S(k[0],n);return k.length>1?C.localize(4,null,a,k.length):a}if(F.isString(P))return P;if(P.detail){const k=P.detail;if(k.error)return y(k.error,n);if(k.exception)return y(k.exception,n)}return P.stack?y(P,n):P.message?P.message:C.localize(5,null)}e.toErrorMessage=S}),define(fe[155],me([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(fe[114],me([0,1,39,29,10,25,8,11,38,96,12,144,28,155]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function d(g){switch(g){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function v(g,t){if(_.isWindows)try{const u={stdio:["pipe","pipe","ignore"]};t&&(u.cwd=t);const r=f.execFile("taskkill",["/T","/F","/PID",g.pid.toString()],u);return new Promise(i=>{r.once("error",s=>{i({success:!1,error:s})}),r.once("exit",(s,c)=>{i(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(u){return Promise.resolve({success:!1,error:u,code:u.status?d(u.status):1})}else if(_.isLinux||_.isMacintosh)try{const u=C.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(r=>{f.execFile(u,[g.pid.toString()],{encoding:"utf8",shell:!0},(i,s,c)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(u){return Promise.resolve({success:!1,error:u})}else g.kill("SIGKILL");return Promise.resolve({success:!0})}function D(g=S.env){return g.comspec||"cmd.exe"}e.getWindowsShell=D;class I{constructor(t,u,r,i){if(u!==void 0&&r!==void 0&&i!==void 0)this.cmd=t,this.args=u,this.shell=r,this.options=i;else{const s=t;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(S.env).forEach(c=>{s[c]=S.env[c]}),Object.keys(this.options.env).forEach(c=>{s[c]=this.options.env[c]}),this.options.env=s}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const u=t.lastIndexOf(A.sep);return u!==-1&&(t=t.substring(u+1)),I.WellKnowCommands[t]?t:"other"}start(t){return _.isWindows&&(this.options&&this.options.cwd&&F.isUNC(this.options.cwd)||!this.options&&F.isUNC(S.cwd()))?Promise.reject(new Error(m.localize(0,null))):this.useExec().then(u=>{let r,i;const s=new Promise((c,h)=>{r=c,i=h});if(u){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=f.exec(c,this.options,(h,w,E)=>{this.childProcess=null;const p=h;p&&p.killed?i({killed:this.terminateRequested,stdout:w.toString(),stderr:E.toString()}):this.handleExec(r,t,h,w,E)})}else{let c=null;const h=w=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(w,r,t,i);const E={terminated:this.terminateRequested};n.isNumber(w)&&(E.cmdCode=w),r(E)};if(this.shell&&_.isWindows){const w=y.deepClone(this.options);w.windowsVerbatimArguments=!0,w.detached=!1;let E=!1,p=!1;const T=[];let L=this.ensureQuotes(this.cmd);T.push(L.value),E=L.quoted,this.args&&this.args.forEach(R=>{L=this.ensureQuotes(R),T.push(L.value),p=p&&L.quoted});const M=["/s","/c"];E?p?M.push('"'+T.join(" ")+'"'):T.length>1?M.push('"'+T[0]+'" '+T.slice(1).join(" ")):M.push('"'+T[0]+'"'):M.push(T.join(" ")),c=f.spawn(D(),M,w)}else this.cmd&&(c=f.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(n.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",w=>{this.childProcess=null,i({terminated:this.terminateRequested,error:w})}),c.pid&&(this.childProcess.on("close",h),this.handleSpawn(c,r,t,i,!0)))}return s})}handleClose(t,u,r,i){}ensureQuotes(t){return I.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,v(t,this.options.cwd).then(u=>(u.success&&(this.childProcess=null),u))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!_.isWindows)return t(!1);const u=f.spawn(D(),["/s","/c"]);u.on("error",r=>t(!0)),u.on("exit",r=>t(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class b extends I{constructor(t,u,r,i){super(t,u,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,u,r,i,s){[i,s].forEach((c,h)=>{const w=new k.LineDecoder;w.write(c).forEach(T=>{u({line:T,source:h===0?0:1})});const p=w.end();p&&u({line:p,source:h===0?0:1})}),t({terminated:this.terminateRequested,error:r})}handleSpawn(t,u,r,i,s){const c=new k.LineDecoder,h=new k.LineDecoder;t.stdout.on("data",w=>{c.write(w).forEach(p=>r({line:p,source:0}))}),t.stderr.on("data",w=>{h.write(w).forEach(p=>r({line:p,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=h}handleClose(t,u,r,i){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&r({line:s,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&r({line:c,source:1})}}e.LineProcess=b;function l(g){let t=[],u=!1;const r=function(i){if(u){t.push(i);return}(!g.send(i,c=>{if(c&&console.error(c),u=!1,t.length>0){const h=t.slice(0);t=[],h.forEach(w=>r(w))}})||_.isWindows)&&(u=!0)};return{send:r}}e.createQueuedSender=l;var o;(function(g){async function t(u,r,i){if(A.isAbsolute(u))return u;if(r===void 0&&(r=S.cwd()),A.dirname(u)!=="."||(i===void 0&&n.isString(S.env.PATH)&&(i=S.env.PATH.split(A.delimiter)),i===void 0||i.length===0))return A.join(r,u);async function c(h){if(await a.Promises.exists(h)){let w;try{w=await a.Promises.stat(h)}catch(E){E.message.startsWith("EACCES")&&(w=await a.Promises.lstat(h))}return w?!w.isDirectory():!1}return!1}for(let h of i){let w;if(A.isAbsolute(h)?w=A.join(h,u):w=A.join(r,h,u),await c(w))return w;let E=w+".com";if(await c(E)||(E=w+".exe",await c(E)))return E}return A.join(r,u)}g.findExecutable=t})(o=e.win32||(e.win32={}))}),define(fe[156],me([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(fe[115],me([0,1,156,11,111]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=A;class _{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,ve){this._values[te]=ve}}e.ValidatedEditorOptions=_;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class P{constructor(te,ve,Xe,tt){this.id=te,this.name=ve,this.defaultValue=Xe,this.schema=tt}compute(te,ve,Xe){return Xe}}class n{constructor(te,ve=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(te){return this.defaultValue}}class k{constructor(te,ve,Xe,tt){this.id=te,this.name=ve,this.defaultValue=Xe,this.schema=tt}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,ve,Xe){return Xe}}function a(J,te){return typeof J=="undefined"?te:J==="false"?!1:Boolean(J)}e.boolean=a;class m extends k{constructor(te,ve,Xe,tt=void 0){typeof tt!="undefined"&&(tt.type="boolean",tt.default=Xe);super(te,ve,Xe,tt)}validate(te){return a(te,this.defaultValue)}}function d(J,te,ve,Xe){if(typeof J=="undefined")return te;let tt=parseInt(J,10);return isNaN(tt)?te:(tt=Math.max(ve,tt),tt=Math.min(Xe,tt),tt|0)}e.clampedInt=d;class v extends k{constructor(te,ve,Xe,tt,ct,ut=void 0){typeof ut!="undefined"&&(ut.type="integer",ut.default=Xe,ut.minimum=tt,ut.maximum=ct);super(te,ve,Xe,ut);this.minimum=tt,this.maximum=ct}static clampedInt(te,ve,Xe,tt){return d(te,ve,Xe,tt)}validate(te){return v.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class D extends k{constructor(te,ve,Xe,tt,ct){typeof ct!="undefined"&&(ct.type="number",ct.default=Xe);super(te,ve,Xe,ct);this.validationFn=tt}static clamp(te,ve,Xe){return te<ve?ve:te>Xe?Xe:te}static float(te,ve){if(typeof te=="number")return te;if(typeof te=="undefined")return ve;const Xe=parseFloat(te);return isNaN(Xe)?ve:Xe}validate(te){return this.validationFn(D.float(te,this.defaultValue))}}class I extends k{static string(te,ve){return typeof te!="string"?ve:te}constructor(te,ve,Xe,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.default=Xe);super(te,ve,Xe,tt)}validate(te){return I.string(te,this.defaultValue)}}function b(J,te,ve){return typeof J!="string"||ve.indexOf(J)===-1?te:J}e.stringSet=b;class l extends k{constructor(te,ve,Xe,tt,ct=void 0){typeof ct!="undefined"&&(ct.type="string",ct.enum=tt,ct.default=Xe);super(te,ve,Xe,ct);this._allowedValues=tt}validate(te){return b(te,this.defaultValue,this._allowedValues)}}class o extends P{constructor(te,ve,Xe,tt,ct,ut,_t=void 0){typeof _t!="undefined"&&(_t.type="string",_t.enum=ct,_t.default=tt);super(te,ve,Xe,_t);this._allowedValues=ct,this._convert=ut}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function g(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class t extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[f.localize(0,null),f.localize(1,null),f.localize(2,null)],default:"auto",description:f.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,ve,Xe){return Xe===0?te.accessibilitySupport:Xe}}class u extends P{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:f.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:f.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{insertSpace:a(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var s;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(s=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function c(J){switch(J){case s.Line:return"line";case s.Block:return"block";case s.Underline:return"underline";case s.LineThin:return"line-thin";case s.BlockOutline:return"block-outline";case s.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=c;function h(J){switch(J){case"line":return s.Line;case"block":return s.Block;case"underline":return s.Underline;case"line-thin":return s.LineThin;case"block-outline":return s.BlockOutline;case"underline-thin":return s.UnderlineThin}}class w extends n{constructor(){super(126,[65,33])}compute(te,ve,Xe){const tt=["monaco-editor"];return ve.get(33)&&tt.push(ve.get(33)),te.extraEditorClassName&&tt.push(te.extraEditorClassName),ve.get(65)==="default"?tt.push("mouse-default"):ve.get(65)==="copy"&&tt.push("mouse-copy"),ve.get(99)&&tt.push("showUnused"),ve.get(124)&&tt.push("showDeprecated"),tt.join(" ")}}class E extends m{constructor(){super(32,"emptySelectionClipboard",!0,{description:f.localize(6,null)})}compute(te,ve,Xe){return Xe&&te.emptySelectionClipboard}}class p extends P{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:f.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:te.seedSearchStringFromSelection,enumDescriptions:[f.localize(8,null),f.localize(9,null),f.localize(10,null)],description:f.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[f.localize(12,null),f.localize(13,null),f.localize(14,null)],description:f.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:f.localize(16,null),included:F.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:f.localize(17,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:f.localize(18,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{cursorMoveOnType:a(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof te.seedSearchStringFromSelection=="boolean"?te.seedSearchStringFromSelection?"always":"never":b(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":b(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(ve.loop,this.defaultValue.loop)}}}class T extends P{constructor(){super(44,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:f.localize(19,null)},{type:"string",description:f.localize(20,null)}],description:f.localize(21,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?T.OFF:te==="true"?T.ON:te:Boolean(te)?T.ON:T.OFF}}e.EditorFontLigatures=T,T.OFF='"liga" off, "calt" off',T.ON='"liga" on, "calt" on';class L extends n{constructor(){super(43)}compute(te,ve,Xe){return te.fontInfo}}class M extends k{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:f.localize(22,null)})}validate(te){let ve=D.float(te,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:D.clamp(ve,6,100)}compute(te,ve,Xe){return te.fontInfo.fontSize}}class R extends P{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:R.MINIMUM_VALUE,maximum:R.MAXIMUM_VALUE,errorMessage:f.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:R.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:f.localize(24,null)})}validate(te){return te==="normal"||te==="bold"?te:String(v.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,R.MINIMUM_VALUE,R.MAXIMUM_VALUE))}}R.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],R.MINIMUM_VALUE=1,R.MAXIMUM_VALUE=1e3;class $ extends P{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[f.localize(25,null),f.localize(26,null),f.localize(27,null)]},Xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:f.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:f.localize(29,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:f.localize(30,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:f.localize(31,null),...ve},"editor.gotoLocation.multipleImplementations":{description:f.localize(32,null),...ve},"editor.gotoLocation.multipleReferences":{description:f.localize(33,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:Xe,description:f.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:Xe,description:f.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:Xe,description:f.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:Xe,description:f.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:Xe,description:f.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{multiple:b(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??b(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??b(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??b(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??b(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??b(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:I.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:I.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:I.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:I.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:I.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends P{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(52,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:f.localize(39,null)},"editor.hover.delay":{type:"number",default:te.delay,description:f.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:f.localize(41,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:a(ve.enabled,this.defaultValue.enabled),delay:v.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:a(ve.sticky,this.defaultValue.sticky)}}}var O;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(O=e.RenderMinimap||(e.RenderMinimap={}));class V extends n{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(te,ve,Xe){return V.computeLayout(ve,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const ve=te.height/te.lineHeight,Xe=te.scrollBeyondLastLine?ve-1:0,tt=(te.viewLineCount+Xe)/(te.pixelRatio*te.height),ct=Math.floor(te.viewLineCount/tt);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Xe,desiredRatio:tt,minimapLineCount:ct}}static _computeMinimapLayout(te,ve){const Xe=te.outerWidth,tt=te.outerHeight,ct=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ct*tt),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:tt};const ut=ve.stableMinimapLayoutInput,_t=ut&&te.outerHeight===ut.outerHeight&&te.lineHeight===ut.lineHeight&&te.typicalHalfwidthCharacterWidth===ut.typicalHalfwidthCharacterWidth&&te.pixelRatio===ut.pixelRatio&&te.scrollBeyondLastLine===ut.scrollBeyondLastLine&&te.minimap.enabled===ut.minimap.enabled&&te.minimap.side===ut.minimap.side&&te.minimap.size===ut.minimap.size&&te.minimap.showSlider===ut.minimap.showSlider&&te.minimap.renderCharacters===ut.minimap.renderCharacters&&te.minimap.maxColumn===ut.minimap.maxColumn&&te.minimap.scale===ut.minimap.scale&&te.verticalScrollbarWidth===ut.verticalScrollbarWidth&&te.isViewportWrapping===ut.isViewportWrapping,ce=te.lineHeight,Pe=te.typicalHalfwidthCharacterWidth,We=te.scrollBeyondLastLine,Ye=te.minimap.renderCharacters;let $e=ct>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const lt=te.minimap.maxColumn,Te=te.minimap.size,De=te.minimap.side,ke=te.verticalScrollbarWidth,ne=te.viewLineCount,ue=te.remainingWidth,Ee=te.isViewportWrapping,we=Ye?2:3;let Fe=Math.floor(ct*tt);const Ge=Fe/ct;let Ve=!1,et=!1,ot=we*$e,Be=$e/ct,ge=1;if(Te==="fill"||Te==="fit"){const{typicalViewportLineCount:Ke,extraLinesBeyondLastLine:pt,desiredRatio:bt,minimapLineCount:ft}=V.computeContainedMinimapLineCount({viewLineCount:ne,scrollBeyondLastLine:We,height:tt,lineHeight:ce,pixelRatio:ct});if(ne/ft>1)Ve=!0,et=!0,$e=1,ot=1,Be=$e/ct;else{let mt=!1,Et=$e+1;if(Te==="fit"){const Dt=Math.ceil((ne+pt)*ot);Ee&&_t&&ue<=ve.stableFitRemainingWidth?(mt=!0,Et=ve.stableFitMaxMinimapScale):mt=Dt>Fe}if(Te==="fill"||mt){Ve=!0;const Dt=$e;ot=Math.min(ce*ct,Math.max(1,Math.floor(1/bt))),Ee&&_t&&ue<=ve.stableFitRemainingWidth&&(Et=ve.stableFitMaxMinimapScale),$e=Math.min(Et,Math.max(1,Math.floor(ot/we))),$e>Dt&&(ge=Math.min(2,$e/Dt)),Be=$e/ct/ge,Fe=Math.ceil(Math.max(Ke,ne+pt)*ot),Ee?(ve.stableMinimapLayoutInput=te,ve.stableFitRemainingWidth=ue,ve.stableFitMaxMinimapScale=$e):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const _e=Math.floor(lt*Be),ie=Math.min(_e,Math.max(0,Math.floor((ue-ke-2)*Be/(Pe+Be)))+e.MINIMAP_GUTTER_WIDTH);let Q=Math.floor(ct*ie);const ye=Q/ct;Q=Math.floor(Q*ge);const Le=Ye?1:2,it=De==="left"?0:Xe-ie-ke;return{renderMinimap:Le,minimapLeft:it,minimapWidth:ie,minimapHeightIsEditorHeight:Ve,minimapIsSampling:et,minimapScale:$e,minimapLineHeight:ot,minimapCanvasInnerWidth:Q,minimapCanvasInnerHeight:Fe,minimapCanvasOuterWidth:ye,minimapCanvasOuterHeight:Ge}}static computeLayout(te,ve){const Xe=ve.outerWidth|0,tt=ve.outerHeight|0,ct=ve.lineHeight|0,ut=ve.lineNumbersDigitCount|0,_t=ve.typicalHalfwidthCharacterWidth,ce=ve.maxDigitWidth,Pe=ve.pixelRatio,We=ve.viewLineCount,Ye=te.get(121),$e=Ye==="inherit"?te.get(120):Ye,lt=$e==="inherit"?te.get(116):$e,Te=te.get(119),De=te.get(2),ke=ve.isDominatedByLongLines,ne=te.get(49),ue=te.get(59).renderType!==0,Ee=te.get(60),we=te.get(93),Fe=te.get(64),Ge=te.get(91),Ve=Ge.verticalScrollbarSize,et=Ge.verticalHasArrows,ot=Ge.arrowSize,Be=Ge.horizontalScrollbarSize,ge=te.get(57),_e=te.get(37);let ie;if(typeof ge=="string"&&/^\d+(\.\d+)?ch$/.test(ge)){const kt=parseFloat(ge.substr(0,ge.length-2));ie=v.clampedInt(kt*_t,0,0,1e3)}else ie=v.clampedInt(ge,0,0,1e3);_e&&(ie+=16);let Q=0;if(ue){const kt=Math.max(ut,Ee);Q=Math.round(kt*ce)}let ye=0;ne&&(ye=ct);let Le=0,it=Le+ye,Ke=it+Q,pt=Ke+ie;const bt=Xe-ye-Q-ie;let ft=!1,wt=!1,mt=-1;De!==2&&($e==="inherit"&&ke?(ft=!0,wt=!0):lt==="on"||lt==="bounded"?wt=!0:lt==="wordWrapColumn"&&(mt=Te));const Et=V._computeMinimapLayout({outerWidth:Xe,outerHeight:tt,lineHeight:ct,typicalHalfwidthCharacterWidth:_t,pixelRatio:Pe,scrollBeyondLastLine:we,minimap:Fe,verticalScrollbarWidth:Ve,viewLineCount:We,remainingWidth:bt,isViewportWrapping:wt},ve.memory||new S);Et.renderMinimap!==0&&Et.minimapLeft===0&&(Le+=Et.minimapWidth,it+=Et.minimapWidth,Ke+=Et.minimapWidth,pt+=Et.minimapWidth);const Dt=bt-Et.minimapWidth,xt=Math.max(1,Math.floor((Dt-Ve-2)/_t)),Vt=et?ot:0;return wt&&(mt=Math.max(1,xt),lt==="bounded"&&(mt=Math.min(mt,Te))),{width:Xe,height:tt,glyphMarginLeft:Le,glyphMarginWidth:ye,lineNumbersLeft:it,lineNumbersWidth:Q,decorationsLeft:Ke,decorationsWidth:ie,contentLeft:pt,contentWidth:Dt,minimap:Et,viewportColumn:xt,isWordWrapMinified:ft,isViewportWrapping:wt,wrappingColumn:mt,verticalScrollbarWidth:Ve,horizontalScrollbarHeight:Be,overviewRuler:{top:Vt,width:Ve,height:tt-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=V;class N extends P{constructor(){const te={enabled:!0};super(56,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:f.localize(42,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:a(te.enabled,this.defaultValue.enabled)}}}class U extends P{constructor(){const te={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:f.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,markdownDescription:f.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,markdownDescription:f.localize(45,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:a(ve.enabled,this.defaultValue.enabled),fontSize:v.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:I.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class x extends D{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,te=>D.clamp(te,0,150),{markdownDescription:f.localize(46,null)})}compute(te,ve,Xe){return te.fontInfo.lineHeight}}class B extends P{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:f.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[f.localize(48,null),f.localize(49,null),f.localize(50,null)],default:te.size,description:f.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:f.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:f.localize(53,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:f.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:f.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:f.localize(56,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:a(ve.enabled,this.defaultValue.enabled),size:b(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(ve.side,this.defaultValue.side,["right","left"]),showSlider:b(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(ve.renderCharacters,this.defaultValue.renderCharacters),scale:v.clampedInt(ve.scale,1,1,3),maxColumn:v.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function H(J){return J==="ctrlCmd"?F.isMacintosh?"metaKey":"ctrlKey":"altKey"}class G extends P{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:f.localize(58,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{top:v.clampedInt(ve.top,0,0,1e3),bottom:v.clampedInt(ve.bottom,0,0,1e3)}}}class K extends P{constructor(){const te={enabled:!0,cycle:!1};super(75,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:f.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:f.localize(60,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:a(ve.enabled,this.defaultValue.enabled),cycle:a(ve.cycle,this.defaultValue.cycle)}}}class X extends n{constructor(){super(127)}compute(te,ve,Xe){return te.pixelRatio}}class de extends P{constructor(){const te={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:f.localize(61,null)},comments:{type:"boolean",default:te.comments,description:f.localize(62,null)},other:{type:"boolean",default:te.other,description:f.localize(63,null)}}}],default:te,description:f.localize(64,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const ve=te,Xe={other:a(ve.other,this.defaultValue.other),comments:a(ve.comments,this.defaultValue.comments),strings:a(ve.strings,this.defaultValue.strings)};return Xe.other&&Xe.comments&&Xe.strings?!0:!Xe.other&&!Xe.comments&&!Xe.strings?!1:Xe}return this.defaultValue}}var be;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(be=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Se extends P{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[f.localize(65,null),f.localize(66,null),f.localize(67,null),f.localize(68,null)],default:"on",description:f.localize(69,null)})}validate(te){let ve=this.defaultValue.renderType,Xe=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(ve=4,Xe=te):te==="interval"?ve=3:te==="relative"?ve=2:te==="on"?ve=1:ve=0),{renderType:ve,renderFn:Xe}}}function Ie(J){const te=J.get(86);return te==="editable"?J.get(80):te!=="on"}e.filterValidationDecorations=Ie;class Oe extends P{constructor(){const te=[],ve={type:"number",description:f.localize(70,null)};super(90,"rulers",te,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:f.localize(71,null),format:"color-hex"}}}]},default:te,description:f.localize(72,null)})}validate(te){if(Array.isArray(te)){let ve=[];for(let Xe of te)if(typeof Xe=="number")ve.push({column:v.clampedInt(Xe,0,0,1e4),color:null});else if(Xe&&typeof Xe=="object"){const tt=Xe;ve.push({column:v.clampedInt(tt.column,0,0,1e4),color:tt.color})}return ve.sort((Xe,tt)=>Xe.column-tt.column),ve}return this.defaultValue}}function xe(J,te){if(typeof J!="string")return te;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class ze extends P{constructor(){const te={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",te,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(73,null),f.localize(74,null),f.localize(75,null)],default:"auto",description:f.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[f.localize(77,null),f.localize(78,null),f.localize(79,null)],default:"auto",description:f.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:te.verticalScrollbarSize,description:f.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:te.horizontalScrollbarSize,description:f.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:te.scrollByPage,description:f.localize(83,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te,Xe=v.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),tt=v.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:v.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:xe(ve.vertical,this.defaultValue.vertical),horizontal:xe(ve.horizontal,this.defaultValue.horizontal),useShadows:a(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Xe,horizontalSliderSize:v.clampedInt(ve.horizontalSliderSize,Xe,0,1e3),verticalScrollbarSize:tt,verticalSliderSize:v.clampedInt(ve.verticalSliderSize,tt,0,1e3),scrollByPage:a(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class j extends P{constructor(){const te={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",te,{"editor.inlineSuggest.enabled":{type:"boolean",default:te.enabled,description:f.localize(84,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:a(ve.enabled,this.defaultValue.enabled),mode:b(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends P{constructor(){const te={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",te,{"editor.bracketPairColorization.enabled":{type:"boolean",default:te.enabled,description:f.localize(85,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:a(te.enabled,this.defaultValue.enabled)}}}class re extends P{constructor(){const te={bracketPairs:!1,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",te,{"editor.guides.bracketPairs":{type:"boolean",default:te.bracketPairs,description:f.localize(86,null)},"editor.guides.indentation":{type:"boolean",default:te.indentation,description:f.localize(87,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:te.highlightActiveIndentation,description:f.localize(88,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{bracketPairs:a(ve.bracketPairs,this.defaultValue.bracketPairs),indentation:a(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:a(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}class le extends P{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[f.localize(89,null),f.localize(90,null)],default:te.insertMode,description:f.localize(91,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:f.localize(92,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:f.localize(93,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:f.localize(94,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:f.localize(95,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:f.localize(96,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:f.localize(97,null)},"editor.suggest.preview":{type:"boolean",default:te.preview,description:f.localize(98,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:f.localize(99,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:f.localize(100,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:f.localize(101,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:f.localize(102,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:f.localize(103,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:f.localize(104,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:f.localize(105,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:f.localize(106,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:f.localize(107,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:f.localize(108,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:f.localize(109,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:f.localize(110,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:f.localize(111,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:f.localize(112,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:f.localize(113,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:f.localize(114,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:f.localize(115,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:f.localize(116,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:f.localize(117,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:f.localize(118,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:f.localize(119,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:f.localize(120,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:f.localize(121,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:f.localize(122,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:f.localize(123,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:f.localize(124,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:f.localize(125,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:f.localize(126,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:f.localize(127,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:f.localize(128,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:f.localize(129,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:f.localize(130,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{insertMode:b(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:a(ve.showIcons,this.defaultValue.showIcons),showStatusBar:a(ve.showStatusBar,this.defaultValue.showStatusBar),preview:a(ve.preview,this.defaultValue.preview),previewMode:b(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(ve.showMethods,this.defaultValue.showMethods),showFunctions:a(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:a(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(ve.showDeprecated,this.defaultValue.showDeprecated),showFields:a(ve.showFields,this.defaultValue.showFields),showVariables:a(ve.showVariables,this.defaultValue.showVariables),showClasses:a(ve.showClasses,this.defaultValue.showClasses),showStructs:a(ve.showStructs,this.defaultValue.showStructs),showInterfaces:a(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:a(ve.showModules,this.defaultValue.showModules),showProperties:a(ve.showProperties,this.defaultValue.showProperties),showEvents:a(ve.showEvents,this.defaultValue.showEvents),showOperators:a(ve.showOperators,this.defaultValue.showOperators),showUnits:a(ve.showUnits,this.defaultValue.showUnits),showValues:a(ve.showValues,this.defaultValue.showValues),showConstants:a(ve.showConstants,this.defaultValue.showConstants),showEnums:a(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:a(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(ve.showKeywords,this.defaultValue.showKeywords),showWords:a(ve.showWords,this.defaultValue.showWords),showColors:a(ve.showColors,this.defaultValue.showColors),showFiles:a(ve.showFiles,this.defaultValue.showFiles),showReferences:a(ve.showReferences,this.defaultValue.showReferences),showFolders:a(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:a(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(ve.showSnippets,this.defaultValue.showSnippets),showUsers:a(ve.showUsers,this.defaultValue.showUsers),showIssues:a(ve.showIssues,this.defaultValue.showIssues)}}}class Z extends P{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:f.localize(131,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ae extends n{constructor(){super(128,[80])}compute(te,ve,Xe){return ve.get(80)?!0:te.tabFocusMode}}var pe;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(pe=e.WrappingIndent||(e.WrappingIndent={}));function Me(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class qe extends n{constructor(){super(130,[129])}compute(te,ve,Xe){const tt=ve.get(129);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:tt.isWordWrapMinified,isViewportWrapping:tt.isViewportWrapping,wrappingColumn:tt.wrappingColumn}}}const Qe="Consolas, 'Courier New', monospace",Je="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:F.isMacintosh?Je:F.isLinux?rt:Qe,fontWeight:"normal",fontSize:F.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Ae(J){return e.editorOptionsRegistry[J.id]=J,J}var nt;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.autoClosingBrackets=5]="autoClosingBrackets",J[J.autoClosingDelete=6]="autoClosingDelete",J[J.autoClosingOvertype=7]="autoClosingOvertype",J[J.autoClosingQuotes=8]="autoClosingQuotes",J[J.autoIndent=9]="autoIndent",J[J.automaticLayout=10]="automaticLayout",J[J.autoSurround=11]="autoSurround",J[J.bracketPairColorization=12]="bracketPairColorization",J[J.guides=13]="guides",J[J.codeLens=14]="codeLens",J[J.codeLensFontFamily=15]="codeLensFontFamily",J[J.codeLensFontSize=16]="codeLensFontSize",J[J.colorDecorators=17]="colorDecorators",J[J.columnSelection=18]="columnSelection",J[J.comments=19]="comments",J[J.contextmenu=20]="contextmenu",J[J.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",J[J.cursorBlinking=22]="cursorBlinking",J[J.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",J[J.cursorStyle=24]="cursorStyle",J[J.cursorSurroundingLines=25]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",J[J.cursorWidth=27]="cursorWidth",J[J.disableLayerHinting=28]="disableLayerHinting",J[J.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",J[J.domReadOnly=30]="domReadOnly",J[J.dragAndDrop=31]="dragAndDrop",J[J.emptySelectionClipboard=32]="emptySelectionClipboard",J[J.extraEditorClassName=33]="extraEditorClassName",J[J.fastScrollSensitivity=34]="fastScrollSensitivity",J[J.find=35]="find",J[J.fixedOverflowWidgets=36]="fixedOverflowWidgets",J[J.folding=37]="folding",J[J.foldingStrategy=38]="foldingStrategy",J[J.foldingHighlight=39]="foldingHighlight",J[J.foldingImportsByDefault=40]="foldingImportsByDefault",J[J.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=42]="fontFamily",J[J.fontInfo=43]="fontInfo",J[J.fontLigatures=44]="fontLigatures",J[J.fontSize=45]="fontSize",J[J.fontWeight=46]="fontWeight",J[J.formatOnPaste=47]="formatOnPaste",J[J.formatOnType=48]="formatOnType",J[J.glyphMargin=49]="glyphMargin",J[J.gotoLocation=50]="gotoLocation",J[J.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",J[J.hover=52]="hover",J[J.inDiffEditor=53]="inDiffEditor",J[J.inlineSuggest=54]="inlineSuggest",J[J.letterSpacing=55]="letterSpacing",J[J.lightbulb=56]="lightbulb",J[J.lineDecorationsWidth=57]="lineDecorationsWidth",J[J.lineHeight=58]="lineHeight",J[J.lineNumbers=59]="lineNumbers",J[J.lineNumbersMinChars=60]="lineNumbersMinChars",J[J.linkedEditing=61]="linkedEditing",J[J.links=62]="links",J[J.matchBrackets=63]="matchBrackets",J[J.minimap=64]="minimap",J[J.mouseStyle=65]="mouseStyle",J[J.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=67]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",J[J.multiCursorModifier=69]="multiCursorModifier",J[J.multiCursorPaste=70]="multiCursorPaste",J[J.occurrencesHighlight=71]="occurrencesHighlight",J[J.overviewRulerBorder=72]="overviewRulerBorder",J[J.overviewRulerLanes=73]="overviewRulerLanes",J[J.padding=74]="padding",J[J.parameterHints=75]="parameterHints",J[J.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",J[J.quickSuggestions=78]="quickSuggestions",J[J.quickSuggestionsDelay=79]="quickSuggestionsDelay",J[J.readOnly=80]="readOnly",J[J.renameOnType=81]="renameOnType",J[J.renderControlCharacters=82]="renderControlCharacters",J[J.renderFinalNewline=83]="renderFinalNewline",J[J.renderLineHighlight=84]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=86]="renderValidationDecorations",J[J.renderWhitespace=87]="renderWhitespace",J[J.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",J[J.roundedSelection=89]="roundedSelection",J[J.rulers=90]="rulers",J[J.scrollbar=91]="scrollbar",J[J.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=93]="scrollBeyondLastLine",J[J.scrollPredominantAxis=94]="scrollPredominantAxis",J[J.selectionClipboard=95]="selectionClipboard",J[J.selectionHighlight=96]="selectionHighlight",J[J.selectOnLineNumbers=97]="selectOnLineNumbers",J[J.showFoldingControls=98]="showFoldingControls",J[J.showUnused=99]="showUnused",J[J.snippetSuggestions=100]="snippetSuggestions",J[J.smartSelect=101]="smartSelect",J[J.smoothScrolling=102]="smoothScrolling",J[J.stickyTabStops=103]="stickyTabStops",J[J.stopRenderingLineAfter=104]="stopRenderingLineAfter",J[J.suggest=105]="suggest",J[J.suggestFontSize=106]="suggestFontSize",J[J.suggestLineHeight=107]="suggestLineHeight",J[J.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",J[J.suggestSelection=109]="suggestSelection",J[J.tabCompletion=110]="tabCompletion",J[J.tabIndex=111]="tabIndex",J[J.unusualLineTerminators=112]="unusualLineTerminators",J[J.useShadowDOM=113]="useShadowDOM",J[J.useTabStops=114]="useTabStops",J[J.wordSeparators=115]="wordSeparators",J[J.wordWrap=116]="wordWrap",J[J.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=119]="wordWrapColumn",J[J.wordWrapOverride1=120]="wordWrapOverride1",J[J.wordWrapOverride2=121]="wordWrapOverride2",J[J.wrappingIndent=122]="wrappingIndent",J[J.wrappingStrategy=123]="wrappingStrategy",J[J.showDeprecated=124]="showDeprecated",J[J.inlayHints=125]="inlayHints",J[J.editorClassName=126]="editorClassName",J[J.pixelRatio=127]="pixelRatio",J[J.tabFocusMode=128]="tabFocusMode",J[J.layoutInfo=129]="layoutInfo",J[J.wrappingInfo=130]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ae(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:f.localize(132,null)})),acceptSuggestionOnEnter:Ae(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",f.localize(133,null),""],markdownDescription:f.localize(134,null)})),accessibilitySupport:Ae(new t),accessibilityPageSize:Ae(new v(3,"accessibilityPageSize",10,1,1073741824,{description:f.localize(135,null)})),ariaLabel:Ae(new I(4,"ariaLabel",f.localize(136,null))),autoClosingBrackets:Ae(new l(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(137,null),f.localize(138,null),""],description:f.localize(139,null)})),autoClosingDelete:Ae(new l(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",f.localize(140,null),""],description:f.localize(141,null)})),autoClosingOvertype:Ae(new l(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",f.localize(142,null),""],description:f.localize(143,null)})),autoClosingQuotes:Ae(new l(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",f.localize(144,null),f.localize(145,null),""],description:f.localize(146,null)})),autoIndent:Ae(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],g,{enumDescriptions:[f.localize(147,null),f.localize(148,null),f.localize(149,null),f.localize(150,null),f.localize(151,null)],description:f.localize(152,null)})),automaticLayout:Ae(new m(10,"automaticLayout",!1)),autoSurround:Ae(new l(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[f.localize(153,null),f.localize(154,null),f.localize(155,null),""],description:f.localize(156,null)})),bracketPairColorization:Ae(new ee),bracketPairGuides:Ae(new re),stickyTabStops:Ae(new m(103,"stickyTabStops",!1,{description:f.localize(157,null)})),codeLens:Ae(new m(14,"codeLens",!0,{description:f.localize(158,null)})),codeLensFontFamily:Ae(new I(15,"codeLensFontFamily","",{description:f.localize(159,null)})),codeLensFontSize:Ae(new v(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:f.localize(160,null)})),colorDecorators:Ae(new m(17,"colorDecorators",!0,{description:f.localize(161,null)})),columnSelection:Ae(new m(18,"columnSelection",!1,{description:f.localize(162,null)})),comments:Ae(new u),contextmenu:Ae(new m(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Ae(new m(21,"copyWithSyntaxHighlighting",!0,{description:f.localize(163,null)})),cursorBlinking:Ae(new o(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:f.localize(164,null)})),cursorSmoothCaretAnimation:Ae(new m(23,"cursorSmoothCaretAnimation",!1,{description:f.localize(165,null)})),cursorStyle:Ae(new o(24,"cursorStyle",s.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],h,{description:f.localize(166,null)})),cursorSurroundingLines:Ae(new v(25,"cursorSurroundingLines",0,0,1073741824,{description:f.localize(167,null)})),cursorSurroundingLinesStyle:Ae(new l(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[f.localize(168,null),f.localize(169,null)],description:f.localize(170,null)})),cursorWidth:Ae(new v(27,"cursorWidth",0,0,1073741824,{markdownDescription:f.localize(171,null)})),disableLayerHinting:Ae(new m(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ae(new m(29,"disableMonospaceOptimizations",!1)),domReadOnly:Ae(new m(30,"domReadOnly",!1)),dragAndDrop:Ae(new m(31,"dragAndDrop",!0,{description:f.localize(172,null)})),emptySelectionClipboard:Ae(new E),extraEditorClassName:Ae(new I(33,"extraEditorClassName","")),fastScrollSensitivity:Ae(new D(34,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:f.localize(173,null)})),find:Ae(new p),fixedOverflowWidgets:Ae(new m(36,"fixedOverflowWidgets",!1)),folding:Ae(new m(37,"folding",!0,{description:f.localize(174,null)})),foldingStrategy:Ae(new l(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[f.localize(175,null),f.localize(176,null)],description:f.localize(177,null)})),foldingHighlight:Ae(new m(39,"foldingHighlight",!0,{description:f.localize(178,null)})),foldingImportsByDefault:Ae(new m(40,"foldingImportsByDefault",!1,{description:f.localize(179,null)})),unfoldOnClickAfterEndOfLine:Ae(new m(41,"unfoldOnClickAfterEndOfLine",!1,{description:f.localize(180,null)})),fontFamily:Ae(new I(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:f.localize(181,null)})),fontInfo:Ae(new L),fontLigatures2:Ae(new T),fontSize:Ae(new M),fontWeight:Ae(new R),formatOnPaste:Ae(new m(47,"formatOnPaste",!1,{description:f.localize(182,null)})),formatOnType:Ae(new m(48,"formatOnType",!1,{description:f.localize(183,null)})),glyphMargin:Ae(new m(49,"glyphMargin",!0,{description:f.localize(184,null)})),gotoLocation:Ae(new $),hideCursorInOverviewRuler:Ae(new m(51,"hideCursorInOverviewRuler",!1,{description:f.localize(185,null)})),hover:Ae(new z),inDiffEditor:Ae(new m(53,"inDiffEditor",!1)),letterSpacing:Ae(new D(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>D.clamp(J,-5,20),{description:f.localize(186,null)})),lightbulb:Ae(new N),lineDecorationsWidth:Ae(new k(57,"lineDecorationsWidth",10)),lineHeight:Ae(new x),lineNumbers:Ae(new Se),lineNumbersMinChars:Ae(new v(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Ae(new m(61,"linkedEditing",!1,{description:f.localize(187,null)})),links:Ae(new m(62,"links",!0,{description:f.localize(188,null)})),matchBrackets:Ae(new l(63,"matchBrackets","always",["always","near","never"],{description:f.localize(189,null)})),minimap:Ae(new B),mouseStyle:Ae(new l(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ae(new D(66,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:f.localize(190,null)})),mouseWheelZoom:Ae(new m(67,"mouseWheelZoom",!1,{markdownDescription:f.localize(191,null)})),multiCursorMergeOverlapping:Ae(new m(68,"multiCursorMergeOverlapping",!0,{description:f.localize(192,null)})),multiCursorModifier:Ae(new o(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],H,{markdownEnumDescriptions:[f.localize(193,null),f.localize(194,null)],markdownDescription:f.localize(195,null)})),multiCursorPaste:Ae(new l(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[f.localize(196,null),f.localize(197,null)],markdownDescription:f.localize(198,null)})),occurrencesHighlight:Ae(new m(71,"occurrencesHighlight",!0,{description:f.localize(199,null)})),overviewRulerBorder:Ae(new m(72,"overviewRulerBorder",!0,{description:f.localize(200,null)})),overviewRulerLanes:Ae(new v(73,"overviewRulerLanes",3,0,3)),padding:Ae(new G),parameterHints:Ae(new K),peekWidgetDefaultFocus:Ae(new l(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[f.localize(201,null),f.localize(202,null)],description:f.localize(203,null)})),definitionLinkOpensInPeek:Ae(new m(77,"definitionLinkOpensInPeek",!1,{description:f.localize(204,null)})),quickSuggestions:Ae(new de),quickSuggestionsDelay:Ae(new v(79,"quickSuggestionsDelay",10,0,1073741824,{description:f.localize(205,null)})),readOnly:Ae(new m(80,"readOnly",!1)),renameOnType:Ae(new m(81,"renameOnType",!1,{description:f.localize(206,null),markdownDeprecationMessage:f.localize(207,null)})),renderControlCharacters:Ae(new m(82,"renderControlCharacters",!1,{description:f.localize(208,null)})),renderFinalNewline:Ae(new m(83,"renderFinalNewline",!0,{description:f.localize(209,null)})),renderLineHighlight:Ae(new l(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",f.localize(210,null)],description:f.localize(211,null)})),renderLineHighlightOnlyWhenFocus:Ae(new m(85,"renderLineHighlightOnlyWhenFocus",!1,{description:f.localize(212,null)})),renderValidationDecorations:Ae(new l(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ae(new l(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",f.localize(213,null),f.localize(214,null),f.localize(215,null),""],description:f.localize(216,null)})),revealHorizontalRightPadding:Ae(new v(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ae(new m(89,"roundedSelection",!0,{description:f.localize(217,null)})),rulers:Ae(new Oe),scrollbar:Ae(new ze),scrollBeyondLastColumn:Ae(new v(92,"scrollBeyondLastColumn",5,0,1073741824,{description:f.localize(218,null)})),scrollBeyondLastLine:Ae(new m(93,"scrollBeyondLastLine",!0,{description:f.localize(219,null)})),scrollPredominantAxis:Ae(new m(94,"scrollPredominantAxis",!0,{description:f.localize(220,null)})),selectionClipboard:Ae(new m(95,"selectionClipboard",!0,{description:f.localize(221,null),included:F.isLinux})),selectionHighlight:Ae(new m(96,"selectionHighlight",!0,{description:f.localize(222,null)})),selectOnLineNumbers:Ae(new m(97,"selectOnLineNumbers",!0)),showFoldingControls:Ae(new l(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[f.localize(223,null),f.localize(224,null)],description:f.localize(225,null)})),showUnused:Ae(new m(99,"showUnused",!0,{description:f.localize(226,null)})),showDeprecated:Ae(new m(124,"showDeprecated",!0,{description:f.localize(227,null)})),inlayHints:Ae(new U),snippetSuggestions:Ae(new l(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[f.localize(228,null),f.localize(229,null),f.localize(230,null),f.localize(231,null)],description:f.localize(232,null)})),smartSelect:Ae(new Z),smoothScrolling:Ae(new m(102,"smoothScrolling",!1,{description:f.localize(233,null)})),stopRenderingLineAfter:Ae(new v(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ae(new le),inlineSuggest:Ae(new j),suggestFontSize:Ae(new v(106,"suggestFontSize",0,0,1e3,{markdownDescription:f.localize(234,null)})),suggestLineHeight:Ae(new v(107,"suggestLineHeight",0,0,1e3,{markdownDescription:f.localize(235,null)})),suggestOnTriggerCharacters:Ae(new m(108,"suggestOnTriggerCharacters",!0,{description:f.localize(236,null)})),suggestSelection:Ae(new l(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[f.localize(237,null),f.localize(238,null),f.localize(239,null)],description:f.localize(240,null)})),tabCompletion:Ae(new l(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[f.localize(241,null),f.localize(242,null),f.localize(243,null)],description:f.localize(244,null)})),tabIndex:Ae(new v(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ae(new l(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[f.localize(245,null),f.localize(246,null),f.localize(247,null)],description:f.localize(248,null)})),useShadowDOM:Ae(new m(113,"useShadowDOM",!0)),useTabStops:Ae(new m(114,"useTabStops",!0,{description:f.localize(249,null)})),wordSeparators:Ae(new I(115,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:f.localize(250,null)})),wordWrap:Ae(new l(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[f.localize(251,null),f.localize(252,null),f.localize(253,null),f.localize(254,null)],description:f.localize(255,null)})),wordWrapBreakAfterCharacters:Ae(new I(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ae(new I(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ae(new v(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:f.localize(256,null)})),wordWrapOverride1:Ae(new l(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ae(new l(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ae(new o(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Me,{enumDescriptions:[f.localize(257,null),f.localize(258,null),f.localize(259,null),f.localize(260,null)],description:f.localize(261,null)})),wrappingStrategy:Ae(new l(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[f.localize(262,null),f.localize(263,null)],description:f.localize(264,null)})),editorClassName:Ae(new w),pixelRatio:Ae(new X),tabFocusMode:Ae(new ae),layoutInfo:Ae(new V),wrappingInfo:Ae(new qe)}}),define(fe[157],me([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(fe[158],me([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(fe[159],me([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(fe[160],me([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(fe[161],me([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(fe[162],me([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(fe[163],me([19,20]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(fe[164],me([19,20]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(fe[165],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(fe[166],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(fe[167],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(fe[168],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(fe[169],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(fe[170],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(fe[171],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(fe[172],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(fe[173],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(fe[174],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(fe[175],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(fe[176],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(fe[177],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(fe[178],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(fe[179],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(fe[180],me([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(fe[181],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var f;(function(A){A[A.ACTIVATE=1]="ACTIVATE",A[A.RESTORE=2]="RESTORE",A[A.PRESERVE=3]="PRESERVE"})(f=e.EditorActivation||(e.EditorActivation={}));var F;(function(A){A[A.PICK=0]="PICK",A[A.DISABLED=1]="DISABLED",A[A.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(F=e.EditorResolution||(e.EditorResolution={}));var C;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(C=e.EditorOpenContext||(e.EditorOpenContext={}));var y;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(y=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(fe[182],me([0,1,159]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function y(a){return a=a.trim(),a==="*"||F.test(a)}e.isValidVersionStr=y;function A(a){if(!y(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=a.match(F);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=A;function _(a){if(!a)return null;let m=a.majorBase,d=a.majorMustEqual,v=a.minorBase,D=a.minorMustEqual,I=a.patchBase,b=a.patchMustEqual;a.hasCaret&&(m===0||(D=!1),b=!1);let l=0;if(a.preRelease){const o=C.exec(a.preRelease);if(o){const[,g,t,u]=o;l=Date.UTC(Number(g),Number(t)-1,Number(u))}}return{majorBase:m,majorMustEqual:d,minorBase:v,minorMustEqual:D,patchBase:I,patchMustEqual:b,isMinimum:a.hasGreaterEquals,notBefore:l}}e.normalizeVersion=_;function S(a,m,d){let v;typeof a=="string"?v=_(A(a)):v=a;let D;m instanceof Date?D=m.getTime():typeof m=="string"&&(D=new Date(m).getTime());let I;if(typeof d=="string"?I=_(A(d)):I=d,!v||!I)return!1;let b=v.majorBase,l=v.minorBase,o=v.patchBase,g=I.majorBase,t=I.minorBase,u=I.patchBase,r=I.notBefore,i=I.majorMustEqual,s=I.minorMustEqual,c=I.patchMustEqual;return I.isMinimum?b>g?!0:b<g?!1:l>t?!0:l<t||D&&D<r?!1:o>=u:(b===1&&g===0&&(!i||!s||!c)&&(g=1,t=0,u=0,i=!0,s=!1,c=!1),b<g?!1:b>g?!i:l<t?!1:l>t?!s:o<u?!1:o>u?!c:!(D&&D<r))}e.isValidVersion=S;function P(a,m,d,v){return d.isBuiltin||typeof d.main=="undefined"?!0:k(a,m,d.engines.vscode,v)}e.isValidExtensionVersion=P;function n(a,m,d){return a==="*"||k(m,d,a)}e.isEngineValid=n;function k(a,m,d,v=[]){let D=_(A(d));if(!D)return v.push(f.localize(0,null,d)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return v.push(f.localize(1,null,d)),!1}else if(!D.majorMustEqual)return v.push(f.localize(2,null,d)),!1;return S(a,m,D)?!0:(v.push(f.localize(3,null,a,d)),!1)}}),define(fe[116],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class f{constructor(C,y=[],A=!1){this.ctor=C,this.staticArguments=y,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=f}),define(fe[82],me([0,1,116]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const F=[];function C(A,_,S){_ instanceof f.SyncDescriptor||(_=new f.SyncDescriptor(_,[],S)),F.push([A,_])}e.registerSingleton=C;function y(){return F}e.getSingletonServiceDescriptors=y}),define(fe[183],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class f{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=f;class F{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let A of this._nodes.values())A.outgoing.size===0&&y.push(A);return y}insertEdge(y,A){const _=this.lookupOrInsertNode(y),S=this.lookupOrInsertNode(A);_.outgoing.set(this._hashFn(A),S),S.incoming.set(this._hashFn(y),_)}removeNode(y){const A=this._hashFn(y);this._nodes.delete(A);for(let _ of this._nodes.values())_.outgoing.delete(A),_.incoming.delete(A)}lookupOrInsertNode(y){const A=this._hashFn(y);let _=this._nodes.get(A);return _||(_=new f(y),this._nodes.set(A,_)),_}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[A,_]of this._nodes)y.push(`${A}, (incoming)[${[..._.incoming.keys()].join(", ")}], (outgoing)[${[..._.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,A]of this._nodes){const _=new Set([y]),S=this._findCycle(A,_);if(S)return S}}_findCycle(y,A){for(let[_,S]of y.outgoing){if(A.has(_))return[...A,_].join(" -> ");A.add(_);const P=this._findCycle(S,A);if(P)return P;A.delete(_)}}}e.Graph=F}),define(fe[4],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var f;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function S(P){return P[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=S})(f=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function F(_,S,P,n){S[f.DI_TARGET]===S?S[f.DI_DEPENDENCIES].push({id:_,index:P,optional:n}):(S[f.DI_DEPENDENCIES]=[{id:_,index:P,optional:n}],S[f.DI_TARGET]=S)}function C(_){if(f.serviceIds.has(_))return f.serviceIds.get(_);const S=function(P,n,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(S,P,k,!1)};return S.toString=()=>_,f.serviceIds.set(_,S),S}e.createDecorator=C;function y(_){return _}e.refineServiceDecorator=y;function A(_){return function(S,P,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");F(_,S,n,!0)}}e.optional=A}),define(fe[184],me([0,1,4]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,f.createDecorator)("modelService");function F(C){return!C.isTooLargeForSyncing()&&!C.isForSimpleWidget}e.shouldSynchronizeModel=F}),define(fe[185],me([0,1,3,48,6,24,77,81,184]),function(Y,e,f,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(v){return typeof v=="string"?!1:Array.isArray(v)?v.every(P):!!v.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new f.Emitter}get onDidChange(){return this._onDidChange.event}register(D,I){let b={selector:D,provider:I,_score:-1,_time:this._clock++};return this._entries.push(b),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,C.toDisposable)(()=>{if(b){let l=this._entries.indexOf(b);l>=0&&(this._entries.splice(l,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),b=void 0)}})}has(D){return this.all(D).length>0}all(D){if(!D)return[];this._updateScores(D);const I=[];for(let b of this._entries)b._score>0&&I.push(b.provider);return I}ordered(D){const I=[];return this._orderedForEach(D,b=>I.push(b.provider)),I}orderedGroups(D){const I=[];let b,l;return this._orderedForEach(D,o=>{b&&l===o._score?b.push(o.provider):(l=o._score,b=[o.provider],I.push(b))}),I}_orderedForEach(D,I){if(!!D){this._updateScores(D);for(const b of this._entries)b._score>0&&I(b)}}_updateScores(D){let I={uri:D.uri.toString(),language:D.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===I.language&&this._lastCandidate.uri===I.uri)){this._lastCandidate=I;for(let b of this._entries)if(b._score=(0,_.score)(b.selector,D.uri,D.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(D)),P(b.selector)&&b._score>0){for(let l of this._entries)l._score=0;b._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(D,I){return D._score<I._score?1:D._score>I._score?-1:D._time<I._time?1:D._time>I._time?-1:0}}e.LanguageFeatureRegistry=n;const k=new WeakMap;let a=0;function m(v){let D=k.get(v);return D===void 0&&(D=++a,k.set(v,D)),D}class d{constructor(D,I,b=Number.MAX_SAFE_INTEGER){this._registry=D,this.min=I,this.max=b,this._cache=new y.LRUCache(50,.7)}_key(D){return D.id+this._registry.all(D).reduce((I,b)=>(0,F.doHash)(m(b),I),0)}_clamp(D){return D===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(D*1.3)))}get(D){const I=this._key(D),b=this._cache.get(I);return this._clamp(b?.value)}update(D,I){const b=this._key(D);let l=this._cache.get(b);return l||(l=new A.MovingAverage,this._cache.set(b,l)),l.update(I),this.get(D)}}e.LanguageFeatureRequestDelays=d}),define(fe[83],me([0,1,2,42,185,150,47]),function(Y,e,f,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var _;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(_=e.LanguageId||(e.LanguageId={}));class S{constructor(T,L){this.language=T,this.id=L}}e.LanguageIdentifier=S;var P;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var n;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var k;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var a;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",p[p.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(a=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(T){return(T&255)>>>0}static getTokenType(T){return(T&1792)>>>8}static getFontStyle(T){return(T&14336)>>>11}static getForeground(T){return(T&8372224)>>>14}static getBackground(T){return(T&4286578688)>>>23}static getClassNameFromMetadata(T){let L=this.getForeground(T),M="mtk"+L,R=this.getFontStyle(T);return R&1&&(M+=" mtki"),R&2&&(M+=" mtkb"),R&4&&(M+=" mtku"),M}static getInlineStyleFromMetadata(T,L){const M=this.getForeground(T),R=this.getFontStyle(T);let $=`color: ${L[M]};`;return R&1&&($+="font-style: italic;"),R&2&&($+="font-weight: bold;"),R&4&&($+="text-decoration: underline;"),$}}e.TokenMetadata=m;var d;(function(p){p[p.Method=0]="Method",p[p.Function=1]="Function",p[p.Constructor=2]="Constructor",p[p.Field=3]="Field",p[p.Variable=4]="Variable",p[p.Class=5]="Class",p[p.Struct=6]="Struct",p[p.Interface=7]="Interface",p[p.Module=8]="Module",p[p.Property=9]="Property",p[p.Event=10]="Event",p[p.Operator=11]="Operator",p[p.Unit=12]="Unit",p[p.Value=13]="Value",p[p.Constant=14]="Constant",p[p.Enum=15]="Enum",p[p.EnumMember=16]="EnumMember",p[p.Keyword=17]="Keyword",p[p.Text=18]="Text",p[p.Color=19]="Color",p[p.File=20]="File",p[p.Reference=21]="Reference",p[p.Customcolor=22]="Customcolor",p[p.Folder=23]="Folder",p[p.TypeParameter=24]="TypeParameter",p[p.User=25]="User",p[p.Issue=26]="Issue",p[p.Snippet=27]="Snippet"})(d=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let p=Object.create(null);return p[0]="symbol-method",p[1]="symbol-function",p[2]="symbol-constructor",p[3]="symbol-field",p[4]="symbol-variable",p[5]="symbol-class",p[6]="symbol-struct",p[7]="symbol-interface",p[8]="symbol-module",p[9]="symbol-property",p[10]="symbol-event",p[11]="symbol-operator",p[12]="symbol-unit",p[13]="symbol-value",p[14]="symbol-constant",p[15]="symbol-enum",p[16]="symbol-enum-member",p[17]="symbol-keyword",p[27]="symbol-snippet",p[18]="symbol-text",p[19]="symbol-color",p[20]="symbol-file",p[21]="symbol-reference",p[22]="symbol-customcolor",p[23]="symbol-folder",p[24]="symbol-type-parameter",p[25]="account",p[26]="issues",function(T){const L=p[T];let M=L&&A.iconRegistry.get(L);return M||(console.info("No codicon found for CompletionItemKind "+T),M=A.Codicon.symbolProperty),M.classNames}}(),e.completionKindFromString=function(){let p=Object.create(null);return p.method=0,p.function=1,p.constructor=2,p.field=3,p.variable=4,p.class=5,p.struct=6,p.interface=7,p.module=8,p.property=9,p.event=10,p.operator=11,p.unit=12,p.value=13,p.constant=14,p.enum=15,p["enum-member"]=16,p.enumMember=16,p.keyword=17,p.snippet=27,p.text=18,p.color=19,p.file=20,p.reference=21,p.customcolor=22,p.folder=23,p["type-parameter"]=24,p.typeParameter=24,p.account=25,p.issue=26,function(T,L){let M=p[T];return typeof M=="undefined"&&!L&&(M=9),M}}();var v;(function(p){p[p.Deprecated=1]="Deprecated"})(v=e.CompletionItemTag||(e.CompletionItemTag={}));var D;(function(p){p[p.KeepWhitespace=1]="KeepWhitespace",p[p.InsertAsSnippet=4]="InsertAsSnippet"})(D=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var I;(function(p){p[p.Invoke=0]="Invoke",p[p.TriggerCharacter=1]="TriggerCharacter",p[p.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(I=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(p){p[p.Automatic=0]="Automatic",p[p.Explicit=1]="Explicit"})(b=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var l;(function(p){p[p.Invoke=1]="Invoke",p[p.Auto=2]="Auto"})(l=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(p){p[p.Invoke=1]="Invoke",p[p.TriggerCharacter=2]="TriggerCharacter",p[p.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(p){p[p.Text=0]="Text",p[p.Read=1]="Read",p[p.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(p){return p&&f.URI.isUri(p.uri)&&F.Range.isIRange(p.range)&&(F.Range.isIRange(p.originSelectionRange)||F.Range.isIRange(p.targetSelectionRange))}e.isLocationLink=t;var u;(function(p){p[p.File=0]="File",p[p.Module=1]="Module",p[p.Namespace=2]="Namespace",p[p.Package=3]="Package",p[p.Class=4]="Class",p[p.Method=5]="Method",p[p.Property=6]="Property",p[p.Field=7]="Field",p[p.Constructor=8]="Constructor",p[p.Enum=9]="Enum",p[p.Interface=10]="Interface",p[p.Function=11]="Function",p[p.Variable=12]="Variable",p[p.Constant=13]="Constant",p[p.String=14]="String",p[p.Number=15]="Number",p[p.Boolean=16]="Boolean",p[p.Array=17]="Array",p[p.Object=18]="Object",p[p.Key=19]="Key",p[p.Null=20]="Null",p[p.EnumMember=21]="EnumMember",p[p.Struct=22]="Struct",p[p.Event=23]="Event",p[p.Operator=24]="Operator",p[p.TypeParameter=25]="TypeParameter"})(u=e.SymbolKind||(e.SymbolKind={}));var r;(function(p){p[p.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var i;(function(p){const T=new Map;T.set("file",0),T.set("module",1),T.set("namespace",2),T.set("package",3),T.set("class",4),T.set("method",5),T.set("property",6),T.set("field",7),T.set("constructor",8),T.set("enum",9),T.set("interface",10),T.set("function",11),T.set("variable",12),T.set("constant",13),T.set("string",14),T.set("number",15),T.set("boolean",16),T.set("array",17),T.set("object",18),T.set("key",19),T.set("null",20),T.set("enum-member",21),T.set("struct",22),T.set("event",23),T.set("operator",24),T.set("type-parameter",25);const L=new Map;L.set(0,"file"),L.set(1,"module"),L.set(2,"namespace"),L.set(3,"package"),L.set(4,"class"),L.set(5,"method"),L.set(6,"property"),L.set(7,"field"),L.set(8,"constructor"),L.set(9,"enum"),L.set(10,"interface"),L.set(11,"function"),L.set(12,"variable"),L.set(13,"constant"),L.set(14,"string"),L.set(15,"number"),L.set(16,"boolean"),L.set(17,"array"),L.set(18,"object"),L.set(19,"key"),L.set(20,"null"),L.set(21,"enum-member"),L.set(22,"struct"),L.set(23,"event"),L.set(24,"operator"),L.set(25,"type-parameter");function M(z){return T.get(z)}p.fromString=M;function R(z){return L.get(z)}p.toString=R;function $(z,O){const V=L.get(z);let N=V&&A.iconRegistry.get("symbol-"+V);return N||(console.info("No codicon found for SymbolKind "+z),N=A.Codicon.symbolProperty),`${O?"inline":"block"} ${N.classNames}`}p.toCssClassName=$})(i=e.SymbolKinds||(e.SymbolKinds={}));class s{constructor(T){this.value=T}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var c;(function(p){p[p.Collapsed=0]="Collapsed",p[p.Expanded=1]="Expanded"})(c=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var h;(function(p){p[p.Editing=0]="Editing",p[p.Preview=1]="Preview"})(h=e.CommentMode||(e.CommentMode={}));var w;(function(p){p[p.Other=0]="Other",p[p.Type=1]="Type",p[p.Parameter=2]="Parameter"})(w=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new C.LanguageFeatureRegistry,e.RenameProviderRegistry=new C.LanguageFeatureRegistry,e.CompletionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new C.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new C.LanguageFeatureRegistry,e.HoverProviderRegistry=new C.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new C.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new C.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new C.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new C.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new C.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.LinkProviderRegistry=new C.LanguageFeatureRegistry,e.ColorProviderRegistry=new C.LanguageFeatureRegistry,e.SelectionRangeRegistry=new C.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var E;(function(p){p[p.None=0]="None",p[p.Option=1]="Option",p[p.Default=2]="Default",p[p.Preferred=3]="Preferred"})(E=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(fe[63],me([0,1,11,9,4]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=f.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",f.isMacintosh),A.set("isLinux",f.isLinux),A.set("isWindows",f.isWindows),A.set("isWeb",f.isWeb),A.set("isMacNative",f.isMacintosh&&!f.isWeb),A.set("isEdge",y.indexOf("Edg/")>=0),A.set("isFirefox",y.indexOf("Firefox")>=0),A.set("isChrome",y.indexOf("Chrome")>=0),A.set("isSafari",y.indexOf("Safari")>=0);const _=Object.prototype.hasOwnProperty;var S;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return a.INSTANCE}static true(){return m.INSTANCE}static has(R){return d.create(R)}static equals(R,$){return v.create(R,$)}static notEquals(R,$){return b.create(R,$)}static regex(R,$){return r.create(R,$)}static in(R,$){return D.create(R,$)}static not(R){return l.create(R)}static and(...R){return c.create(R,null)}static or(...R){return h.create(R,null,!0)}static greater(R,$){return o.create(R,$)}static less(R,$){return t.create(R,$)}static deserialize(R,$=!1){if(!!R)return this._deserializeOrExpression(R,$)}static _deserializeOrExpression(R,$){let z=R.split("||");return h.create(z.map(O=>this._deserializeAndExpression(O,$)),null,!0)}static _deserializeAndExpression(R,$){let z=R.split("&&");return c.create(z.map(O=>this._deserializeOne(O,$)),null)}static _deserializeOne(R,$){if(R=R.trim(),R.indexOf("!=")>=0){let z=R.split("!=");return b.create(z[0].trim(),this._deserializeValue(z[1],$))}if(R.indexOf("==")>=0){let z=R.split("==");return v.create(z[0].trim(),this._deserializeValue(z[1],$))}if(R.indexOf("=~")>=0){let z=R.split("=~");return r.create(z[0].trim(),this._deserializeRegexValue(z[1],$))}if(R.indexOf(" in ")>=0){let z=R.split(" in ");return D.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(R)){const z=R.split(">=");return g.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(R)){const z=R.split(">");return o.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(R)){const z=R.split("<=");return u.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(R)){const z=R.split("<");return t.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(R)?l.create(R.substr(1).trim()):d.create(R)}static _deserializeValue(R,$){if(R=R.trim(),R==="true")return!0;if(R==="false")return!1;let z=/^'([^']*)'$/.exec(R);return z?z[1].trim():R}static _deserializeRegexValue(R,$){if((0,F.isFalsyOrWhitespace)(R)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=R.indexOf("/"),O=R.lastIndexOf("/");if(z===O||z<0){if($)throw new Error(`bad regexp-value '${R}', missing /-enclosure`);return console.warn(`bad regexp-value '${R}', missing /-enclosure`),null}let V=R.slice(z+1,O),N=R[O+1]==="i"?"i":"";try{return new RegExp(V,N)}catch(U){if($)throw new Error(`bad regexp-value '${R}', parse error: ${U}`);return console.warn(`bad regexp-value '${R}', parse error: ${U}`),null}}}e.ContextKeyExpr=P;function n(M,R){const $=M?M.substituteConstants():void 0,z=R?R.substituteConstants():void 0;return!$&&!z?!0:!$||!z?!1:$.equals(z)}e.expressionsAreEqualWithConstantSubstitution=n;function k(M,R){return M.cmp(R)}class a{constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=a,a.INSTANCE=new a;class m{constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return a.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class d{constructor(R,$){this.key=R,this.negated=$,this.type=2}static create(R,$=null){const z=A.get(R);return typeof z=="boolean"?z?m.INSTANCE:a.INSTANCE:new d(R,$)}cmp(R){return R.type!==this.type?this.type-R.type:E(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=A.get(this.key);return typeof R=="boolean"?R?m.INSTANCE:a.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.negated||(this.negated=l.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=d;class v{constructor(R,$,z){this.key=R,this.value=$,this.negated=z,this.type=4}static create(R,$,z=null){if(typeof $=="boolean")return $?d.create(R,z):l.create(R,z);const O=A.get(R);return typeof O=="boolean"?$===(O?"true":"false")?m.INSTANCE:a.INSTANCE:new v(R,$,z)}cmp(R){return R.type!==this.type?this.type-R.type:p(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=A.get(this.key);if(typeof R=="boolean"){const $=R?"true":"false";return this.value===$?m.INSTANCE:a.INSTANCE}return this}evaluate(R){return R.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(R){return R.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=v;class D{constructor(R,$){this.key=R,this.valueKey=$,this.type=10,this.negated=null}static create(R,$){return new D(R,$)}cmp(R){return R.type!==this.type?this.type-R.type:p(this.key,this.valueKey,R.key,R.valueKey)}equals(R){return R.type===this.type?this.key===R.key&&this.valueKey===R.valueKey:!1}substituteConstants(){return this}evaluate(R){const $=R.getValue(this.valueKey),z=R.getValue(this.key);return Array.isArray($)?$.indexOf(z)>=0:typeof z=="string"&&typeof $=="object"&&$!==null?_.call($,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(R){return R.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=I.create(this)),this.negated}}e.ContextKeyInExpr=D;class I{constructor(R){this._actual=R,this.type=11}static create(R){return new I(R)}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(R){return new I(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotInExpr=I;class b{constructor(R,$,z){this.key=R,this.value=$,this.negated=z,this.type=5}static create(R,$,z=null){if(typeof $=="boolean")return $?l.create(R,z):d.create(R,z);const O=A.get(R);return typeof O=="boolean"?$===(O?"true":"false")?a.INSTANCE:m.INSTANCE:new b(R,$,z)}cmp(R){return R.type!==this.type?this.type-R.type:p(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){const R=A.get(this.key);if(typeof R=="boolean"){const $=R?"true":"false";return this.value===$?a.INSTANCE:m.INSTANCE}return this}evaluate(R){return R.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(R){return R.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class l{constructor(R,$){this.key=R,this.negated=$,this.type=3}static create(R,$=null){const z=A.get(R);return typeof z=="boolean"?z?a.INSTANCE:m.INSTANCE:new l(R,$)}cmp(R){return R.type!==this.type?this.type-R.type:E(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=A.get(this.key);return typeof R=="boolean"?R?a.INSTANCE:m.INSTANCE:this}evaluate(R){return!R.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(R){return R.mapNot(this.key)}negate(){return this.negated||(this.negated=d.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=l;class o{constructor(R,$,z){this.key=R,this.value=$,this.negated=z,this.type=12}static create(R,$,z=null){return new o(R,$,z)}cmp(R){return R.type!==this.type?this.type-R.type:p(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return parseFloat(R.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=o;class g{constructor(R,$,z){this.key=R,this.value=$,this.negated=z,this.type=13}static create(R,$,z=null){return new g(R,$,z)}cmp(R){return R.type!==this.type?this.type-R.type:p(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return parseFloat(R.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(R){return R.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=g;class t{constructor(R,$,z){this.key=R,this.value=$,this.negated=z,this.type=14}static create(R,$,z=null){return new t(R,$,z)}cmp(R){return R.type!==this.type?this.type-R.type:p(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return parseFloat(R.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class u{constructor(R,$,z){this.key=R,this.value=$,this.negated=z,this.type=15}static create(R,$,z=null){return new u(R,$,z)}cmp(R){return R.type!==this.type?this.type-R.type:p(this.key,this.value,R.key,R.value)}equals(R){return R.type===this.type?this.key===R.key&&this.value===R.value:!1}substituteConstants(){return this}evaluate(R){return parseFloat(R.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(R){return R.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=u;class r{constructor(R,$){this.key=R,this.regexp=$,this.type=7,this.negated=null}static create(R,$){return new r(R,$)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.key<R.key)return-1;if(this.key>R.key)return 1;const $=this.regexp?this.regexp.source:"",z=R.regexp?R.regexp.source:"";return $<z?-1:$>z?1:0}equals(R){if(R.type===this.type){const $=this.regexp?this.regexp.source:"",z=R.regexp?R.regexp.source:"";return this.key===R.key&&$===z}return!1}substituteConstants(){return this}evaluate(R){let $=R.getValue(this.key);return this.regexp?this.regexp.test($):!1}serialize(){const R=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${R}`}keys(){return[this.key]}map(R){return R.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class i{constructor(R){this._actual=R,this.type=8}static create(R){return new i(R)}cmp(R){return R.type!==this.type?this.type-R.type:this._actual.cmp(R._actual)}equals(R){return R.type===this.type?this._actual.equals(R._actual):!1}substituteConstants(){return this}evaluate(R){return!this._actual.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(R){return new i(this._actual.map(R))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function s(M){let R=null;for(let $=0,z=M.length;$<z;$++){const O=M[$].substituteConstants();if(M[$]!==O&&R===null){R=[];for(let V=0;V<$;V++)R[V]=M[V]}R!==null&&(R[$]=O)}return R===null?M:R}class c{constructor(R,$){this.expr=R,this.negated=$,this.type=6}static create(R,$){return c._normalizeArr(R,$)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let $=0,z=this.expr.length;$<z;$++){const O=k(this.expr[$],R.expr[$]);if(O!==0)return O}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let $=0,z=this.expr.length;$<z;$++)if(!this.expr[$].equals(R.expr[$]))return!1;return!0}return!1}substituteConstants(){const R=s(this.expr);return R===this.expr?this:c.create(R,this.negated)}evaluate(R){for(let $=0,z=this.expr.length;$<z;$++)if(!this.expr[$].evaluate(R))return!1;return!0}static _normalizeArr(R,$){const z=[];let O=!1;for(const V of R)if(!!V){if(V.type===1){O=!0;continue}if(V.type===0)return a.INSTANCE;if(V.type===6){z.push(...V.expr);continue}z.push(V)}if(z.length===0&&O)return m.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(k);for(let V=1;V<z.length;V++)z[V-1].equals(z[V])&&(z.splice(V,1),V--);if(z.length===1)return z[0];for(;z.length>1;){const V=z[z.length-1];if(V.type!==9)break;z.pop();const N=z.pop(),U=z.length===0,x=h.create(V.expr.map(B=>c.create([B,N],null)),null,U);x&&(z.push(x),z.sort(k))}return z.length===1?z[0]:new c(z,$)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(let $ of this.expr)R.push(...$.keys());return R}map(R){return new c(this.expr.map($=>$.map(R)),null)}negate(){if(!this.negated){const R=[];for(let $ of this.expr)R.push($.negate());this.negated=h.create(R,this,!0)}return this.negated}}class h{constructor(R,$){this.expr=R,this.negated=$,this.type=9}static create(R,$,z){return h._normalizeArr(R,$,z)}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let $=0,z=this.expr.length;$<z;$++){const O=k(this.expr[$],R.expr[$]);if(O!==0)return O}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let $=0,z=this.expr.length;$<z;$++)if(!this.expr[$].equals(R.expr[$]))return!1;return!0}return!1}substituteConstants(){const R=s(this.expr);return R===this.expr?this:h.create(R,this.negated,!1)}evaluate(R){for(let $=0,z=this.expr.length;$<z;$++)if(this.expr[$].evaluate(R))return!0;return!1}static _normalizeArr(R,$,z){let O=[],V=!1;if(R){for(let N=0,U=R.length;N<U;N++){const x=R[N];if(!!x){if(x.type===0){V=!0;continue}if(x.type===1)return m.INSTANCE;if(x.type===9){O=O.concat(x.expr);continue}O.push(x)}}if(O.length===0&&V)return a.INSTANCE;O.sort(k)}if(O.length!==0){if(O.length===1)return O[0];for(let N=1;N<O.length;N++)O[N-1].equals(O[N])&&(O.splice(N,1),N--);if(O.length===1)return O[0];if(z){for(let N=0;N<O.length;N++)for(let U=N+1;U<O.length;U++)T(O[N],O[U])&&(O.splice(U,1),U--);if(O.length===1)return O[0]}return new h(O,$)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(let $ of this.expr)R.push(...$.keys());return R}map(R){return new h(this.expr.map($=>$.map(R)),null)}negate(){if(!this.negated){let R=[];for(let $ of this.expr)R.push($.negate());for(;R.length>1;){const $=R.shift(),z=R.shift(),O=[];for(const N of L($))for(const U of L(z))O.push(c.create([N,U],null));const V=R.length===0;R.unshift(h.create(O,null,V))}this.negated=R[0]}return this.negated}}class w extends d{constructor(R,$,z){super(R,null);this._defaultValue=$,typeof z=="object"?w._info.push({...z,key:R}):z!==!0&&w._info.push({key:R,description:z,type:$!=null?typeof $:void 0})}static all(){return w._info.values()}bindTo(R){return R.createKey(this.key,this._defaultValue)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return v.create(this.key,R)}notEqualsTo(R){return b.create(this.key,R)}}e.RawContextKey=w,w._info=[],e.IContextKeyService=(0,C.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(M,R){return M<R?-1:M>R?1:0}function p(M,R,$,z){return M<$?-1:M>$?1:R<z?-1:R>z?1:0}function T(M,R){if(R.type===6&&M.type!==9&&M.type!==6){for(const O of R.expr)if(M.equals(O))return!0}const $=M.negate(),z=L($).concat(L(R));z.sort(k);for(let O=0;O<z.length;O++){const N=z[O].negate();for(let U=O+1;U<z.length;U++){const x=z[U];if(N.equals(x))return!0}}return!1}e.implies=T;function L(M){return M.type===9?M.expr:[M]}}),define(fe[186],me([0,1,4]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,f.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,f.refineServiceDecorator)(e.IEnvironmentService)}),define(fe[187],me([0,1,10,158,4]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var y;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));function A(b){switch(b){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=A;function _(b){switch(b){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=_;function S(b,l){switch(b){case 3:return l==="x64"?"win32-x64":l==="ia32"?"win32-ia32":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function P(b,l){return l==="web"&&!b.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function n(b,l,o){return P(l,o)?!1:b==="undefined"||b==="universal"?!0:b==="unknown"?!1:b===o?!0:k(o).includes(b)}e.isTargetPlatformCompatible=n;function k(b){switch(b){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function a(b){return b&&typeof b=="object"&&typeof b.id=="string"&&(!b.uuid||typeof b.uuid=="string")}e.isIExtensionIdentifier=a;var m;(function(b){b[b.NoneOrRelevance=0]="NoneOrRelevance",b[b.LastUpdatedDate=1]="LastUpdatedDate",b[b.Title=2]="Title",b[b.PublisherName=3]="PublisherName",b[b.InstallCount=4]="InstallCount",b[b.PublishedDate=10]="PublishedDate",b[b.AverageRating=6]="AverageRating",b[b.WeightedRating=12]="WeightedRating"})(m=e.SortBy||(e.SortBy={}));var d;(function(b){b[b.Default=0]="Default",b[b.Ascending=1]="Ascending",b[b.Descending=2]="Descending"})(d=e.SortOrder||(e.SortOrder={}));var v;(function(b){b.Install="install",b.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var D;(function(b){b[b.None=0]="None",b[b.Install=1]="Install",b[b.Update=2]="Update"})(D=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class I extends Error{constructor(l,o){super(l);this.code=o,this.name=o}}e.ExtensionManagementError=I,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=f.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,F.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,F.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(fe[26],me([0,1,9,4]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=C;function y(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class _{constructor(k){this.value=k,this._lower=k.toLowerCase()}static equals(k,a){if(typeof k=="undefined"||k===null)return typeof a=="undefined"||a===null;if(typeof a=="undefined"||a===null)return!1;if(typeof k=="string"||typeof a=="string"){let m=typeof k=="string"?k:k.value,d=typeof a=="string"?a:a.value;return f.equalsIgnoreCase(m,d)}return k._lower===a._lower}static toKey(k){return typeof k=="string"?k.toLowerCase():k._lower}}e.ExtensionIdentifier=_;function S(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function P(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(fe[188],me([0,1,9,26]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(d,v){return d.uuid&&v.uuid?d.uuid===v.uuid:d.id===v.id?!0:(0,f.compareIgnoreCase)(d.id,v.id)===0}e.areSameExtensions=C;class y{constructor(v,D){this.version=D,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof y?C(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=y;function A(d,v){return`${d}.${v}`}e.getExtensionId=A;function _(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=_;function S(d,v){return _(A(d,v))}e.getGalleryExtensionId=S;function P(d,v){const D=[],I=b=>{for(const l of D)if(l.some(o=>C(v(o),v(b))))return l;return null};for(const b of d){const l=I(b);l?l.push(b):D.push([b])}return D}e.groupByExtension=P;function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function k(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function a(d){const v=new Set;for(const D of d)D.malicious&&v.add(D.id.id);return v}e.getMaliciousExtensionsSet=a;function m(d,v){const D=[],I=v.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const b=I.shift();if(b&&D.every(l=>!C(l.identifier,{id:b}))){const l=d.filter(o=>C(o.identifier,{id:b}));l.length===1&&(D.push(l[0]),I.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return D}e.getExtensionDependencies=m}),define(fe[189],me([0,1,4]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,f.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,f.createDecorator)("externalTerminal")}),define(fe[190],me([0,1,39,10,8,11,96,28,114,160,189]),function(Y,e,f,F,C,y,A,_,S,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=P.localize(0,null);class a{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends a{openTerminal(o,g){return this.spawnTerminal(f,o,S.getWindowsShell(),g)}spawnTerminal(o,g,t,u){const r=g.windowsExec||m.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const i=C.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return o.spawn(r,u?[u]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return r.indexOf(" ")>=0&&s.push('""'),s.push(r),(i==="wt"||i==="wt.exe")&&s.push("-d ."),new Promise((c,h)=>{const w=D(process),E=o.spawn(t,s,{cwd:u,env:w});E.on("error",h),E.on("exit",()=>c())})}runInTerminal(o,g,t,u,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:m.getDefaultTerminalWindows();return new Promise((s,c)=>{const h=`"${g} - ${k}"`,w=`""${t.join('" "')}" & pause"`,E=["/c","start",h,"/wait",i,"/c",w],p=Object.assign({},D(process),u);Object.keys(p).filter(M=>p[M]===null).forEach(M=>delete p[M]);const T={cwd:g,env:p,windowsVerbatimArguments:!0};f.spawn(m.CMD,E,T).on("error",M=>{c(I(M))}),s(void 0)})}static getDefaultTerminalWindows(){if(!m._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return m._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=m,m.CMD="cmd.exe";class d extends a{openTerminal(o,g){return this.spawnTerminal(f,o,g)}runInTerminal(o,g,t,u,r){const i=r.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((s,c)=>{if(i===n.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const h=i===n.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",E=[F.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${h}.scpt`,Y).fsPath,"-t",o||k,"-w",g];for(let L of t)E.push("-a"),E.push(L);if(u){const L=Object.assign({},D(process),u);for(let M in L){const R=L[M];R===null?(E.push("-u"),E.push(M)):(E.push("-e"),E.push(`${M}=${R}`))}}let p="";const T=f.spawn(d.OSASCRIPT,E);T.on("error",L=>{c(I(L))}),T.stderr.on("data",L=>{p+=L.toString()}),T.on("exit",L=>{if(L===0)s(void 0);else if(p){const M=p.split(`
`,1);c(new Error(M[0]))}else c(new Error(P.localize(1,null,h,L)))})}else c(new Error(P.localize(2,null,i)))})}spawnTerminal(o,g,t){const u=g.osxExec||n.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const s=["-a",u];t&&s.push(t);const c=D(process),h=o.spawn("/usr/bin/open",s,{cwd:t,env:c});h.on("error",i),h.on("exit",()=>r())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class v extends a{openTerminal(o,g){return this.spawnTerminal(f,o,g)}runInTerminal(o,g,t,u,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((s,c)=>{let h=[];i.then(w=>{w.indexOf("gnome-terminal")>=0?h.push("-x"):h.push("-e"),h.push("bash"),h.push("-c");const E=`${b(t)}; echo; read -p "${v.WAIT_MESSAGE}" -n1;`;h.push(`''${E}''`);const p=Object.assign({},D(process),u);Object.keys(p).filter(R=>p[R]===null).forEach(R=>delete p[R]);const T={cwd:g,env:p};let L="";const M=f.spawn(w,h,T);M.on("error",R=>{c(I(R))}),M.stderr.on("data",R=>{L+=R.toString()}),M.on("exit",R=>{if(R===0)s(void 0);else if(L){const $=L.split(`
`,1);c(new Error($[0]))}else c(new Error(P.localize(4,null,w,R)))})})})}static async getDefaultTerminalLinuxReady(){return v._DEFAULT_TERMINAL_LINUX_READY||(v._DEFAULT_TERMINAL_LINUX_READY=new Promise(async o=>{y.isLinux?await _.Promises.exists("/etc/debian_version")?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm"):o("xterm")})),v._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,g,t){const u=g.linuxExec?Promise.resolve(g.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{u.then(s=>{const c=D(process),h=o.spawn(s,[],{cwd:t,env:c});h.on("error",i),h.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=v,v.WAIT_MESSAGE=P.localize(3,null);function D(l){const o={...l.env};return(0,A.sanitizeProcessEnvironment)(o),o}function I(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(P.localize(5,null,l.path)):l}function b(l){let o="";for(let g of l)g.indexOf(" ")>=0?o+='"'+g+'"':o+=g,o+=" ";return o}}),define(fe[43],me([0,1,24,8,9,12,2,161,4]),function(Y,e,f,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function P(O){return O.create===!0}e.isFileOpenForWriteOptions=P;var n;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var k;(function(O){O[O.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var a;(function(O){O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock"})(a=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=m;function d(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=d;function v(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function D(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=D;var I;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(V,N){super(V);this.code=N}}e.FileSystemProviderError=b;function l(O,V){const N=new b(O.toString(),V);return g(N,V),N}e.createFileSystemProviderError=l;function o(O){return O||l((0,_.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=o;function g(O,V){return O.name=V?`${V} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=g;function t(O){if(!O)return I.Unknown;if(O instanceof b)return O.code;const V=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!V)return I.Unknown;switch(V[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=t;function u(O){if(O instanceof w)return O.fileOperationResult;switch(t(O)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var r;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(V,N,U){this.resource=V,this.operation=N,this.target=U}isOperation(V){return this.operation===V}}e.FileOperationEvent=i;var s;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class c{constructor(V,N){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const U of V)switch(U.type){case 1:this.added||(this.added=f.TernarySearchTree.forUris(()=>N)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=f.TernarySearchTree.forUris(()=>N)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=f.TernarySearchTree.forUris(()=>N)),this.deleted.set(U.resource,U);break}}contains(V,...N){return this.doContains(V,{includeChildren:!1},...N)}affects(V,...N){return this.doContains(V,{includeChildren:!0},...N)}doContains(V,N,...U){if(!V)return!1;const x=U.length>0;return!!((!x||U.includes(1))&&(this.added?.get(V)||N.includeChildren&&this.added?.findSuperstr(V))||(!x||U.includes(0))&&(this.updated?.get(V)||N.includeChildren&&this.updated?.findSuperstr(V))||(!x||U.includes(2))&&(this.deleted?.findSubstr(V)||N.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function h(O,V,N){return!O||!V||O===V||V.length>O.length?!1:(V.charAt(V.length-1)!==F.sep&&(V+=F.sep),N?(0,C.startsWithIgnoreCase)(O,V):O.indexOf(V)===0)}e.isParent=h;class w extends Error{constructor(V,N,U){super(V);this.fileOperationResult=N,this.options=U}}e.FileOperationError=w;class E extends w{constructor(V,N,U){super(V,2,U);this.stat=N}}e.NotModifiedSinceFileOperationError=E;var p;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(p=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=L;async function M(O,V){if(!V.canHandleResource(A.URI.from({scheme:O.scheme})))return new Promise(N=>{const U=V.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===O.scheme&&x.added&&(U.dispose(),N())})})}e.whenProviderRegistered=M,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class R{static formatSize(V){return(0,y.isNumber)(V)||(V=0),V<R.KB?(0,_.localize)(1,null,V.toFixed(0)):V<R.MB?(0,_.localize)(2,null,(V/R.KB).toFixed(2)):V<R.GB?(0,_.localize)(3,null,(V/R.MB).toFixed(2)):V<R.TB?(0,_.localize)(4,null,(V/R.GB).toFixed(2)):(0,_.localize)(5,null,(V/R.TB).toFixed(2))}}e.ByteSize=R,R.KB=1024,R.MB=R.KB*R.KB,R.GB=R.MB*R.KB,R.TB=R.GB*R.KB;var $;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function z(O){return{maxFileSize:O===0?300*R.MB:16*R.GB,maxHeapSize:O===0?700*R.MB:2*700*R.MB}}e.getPlatformLimits=z}),define(fe[84],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class f{constructor(...C){this._entries=new Map;for(let[y,A]of C)this.set(y,A)}set(C,y){const A=this._entries.get(C);return this._entries.set(C,y),A}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=f}),define(fe[191],me([0,1,17,18,116,183,4,84]),function(Y,e,f,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class P extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class n{constructor(d=new _.ServiceCollection,v=!1,D){this._activeInstantiations=new Set,this._services=d,this._strict=v,this._parent=D,this._services.set(A.IInstantiationService,this)}createChild(d){return new n(d,this._strict,this)}invokeFunction(d,...v){let D=a.traceInvocation(d),I=!1;try{return d({get:(l,o)=>{if(I)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(l,D);if(!g&&o!==A.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return g}},...v)}finally{I=!0,D.stop()}}createInstance(d,...v){let D,I;return d instanceof C.SyncDescriptor?(D=a.traceCreation(d.ctor),I=this._createInstance(d.ctor,d.staticArguments.concat(v),D)):(D=a.traceCreation(d),I=this._createInstance(d,v,D)),D.stop(),I}_createInstance(d,v=[],D){let I=A._util.getServiceDependencies(d).sort((o,g)=>o.index-g.index),b=[];for(const o of I){let g=this._getOrCreateServiceInstance(o.id,D);if(!g&&this._strict&&!o.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${o.id}.`);b.push(g)}let l=I.length>0?I[0].index:v.length;if(v.length!==l){console.warn(`[createInstance] First service dependency of ${d.name} at position ${l+1} conflicts with ${v.length} static arguments`);let o=l-v.length;o>0?v=v.concat(new Array(o)):v=v.slice(0,l)}return new d(...[...v,...b])}_setServiceInstance(d,v){if(this._services.get(d)instanceof C.SyncDescriptor)this._services.set(d,v);else if(this._parent)this._parent._setServiceInstance(d,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let v=this._services.get(d);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):v}_getOrCreateServiceInstance(d,v){let D=this._getServiceInstanceOrDescriptor(d);return D instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,D,v.branch(d,!0)):(v.branch(d,!1),D)}_safeCreateAndCacheServiceInstance(d,v,D){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,v,D)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,v,D){const I=new y.Graph(o=>o.id.toString());let b=0;const l=[{id:d,desc:v,_trace:D}];for(;l.length;){const o=l.pop();if(I.lookupOrInsertNode(o),b++>1e3)throw new P(I);for(let g of A._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(g.id);if(!t&&!g.optional&&console.warn(`[createInstance] ${d} depends on ${g.id} which is NOT registered.`),t instanceof C.SyncDescriptor){const u={id:g.id,desc:t,_trace:o._trace.branch(g.id,!0)};I.insertEdge(o,u),l.push(u)}}}for(;;){const o=I.roots();if(o.length===0){if(!I.isEmpty())throw new P(I);break}for(const{data:g}of o){if(this._getServiceInstanceOrDescriptor(g.id)instanceof C.SyncDescriptor){const u=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,u)}I.removeNode(g)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,v,D=[],I,b){if(this._services.get(d)instanceof C.SyncDescriptor)return this._createServiceInstance(v,D,I,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,v,D,I,b);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(d,v=[],D,I){if(D){const b=new f.IdleValue(()=>this._createInstance(d,v,I));return new Proxy(Object.create(null),{get(l,o){if(o in l)return l[o];let g=b.value,t=g[o];return typeof t!="function"||(t=t.bind(g),l[o]=t),t},set(l,o,g){return b.value[o]=g,!0}})}else return this._createInstance(d,v,I)}}e.InstantiationService=n;var k;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(k||(k={}));class a{constructor(d,v){this.type=d,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return S?new a(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):a._None}static traceCreation(d){return S?new a(0,d.name):a._None}branch(d,v){let D=new a(2,d.toString());return this._dep.push([d,v,D]),D}stop(){let d=Date.now()-this._start;a._totals+=d;let v=!1;function D(b,l){let o=[],g=new Array(b+1).join("	");for(const[t,u,r]of l._dep)if(u&&r){v=!0,o.push(`${g}CREATES -> ${t}`);let i=D(b+1,r);i&&o.push(i)}else o.push(`${g}uses -> ${t}`);return o.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${a._totals.toFixed(2)}ms)`];(d>2||v)&&console.log(I.join(`
`))}}a._None=new class extends a{constructor(){super(-1,null)}stop(){}branch(){return this}},a._totals=0}),define(fe[13],me([0,1,62,3,6,11,4]),function(Y,e,f,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function _(){return new Date().toISOString()}var S;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class P extends C.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class n extends P{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...u){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...u]))}debug(t,...u){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...u]))}info(t,...u){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...u]))}warn(t,...u){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...u]))}error(t,...u){if(this.checkLogLevel(S.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(S.Error,this.format(r))}else this.log(S.Error,this.format([t,...u]))}critical(t,...u){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...u]))}flush(){}format(t){let u="";for(let r=0;r<t.length;r++){let i=t[r];if(typeof i=="object")try{i=JSON.stringify(i)}catch(s){}u+=(r>0?" ":"")+i}return u}}e.AbstractMessageLogger=n;class k extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!y.isWindows}trace(t,...u){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${_()}][0m`,t,...u):console.log(`[main ${_()}]`,t,...u))}debug(t,...u){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${_()}][0m`,t,...u):console.log(`[main ${_()}]`,t,...u))}info(t,...u){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${_()}][0m`,t,...u):console.log(`[main ${_()}]`,t,...u))}warn(t,...u){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${_()}][0m`,t,...u):console.warn(`[main ${_()}]`,t,...u))}error(t,...u){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${_()}][0m`,t,...u):console.error(`[main ${_()}]`,t,...u))}critical(t,...u){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${_()}][0m`,t,...u):console.error(`[main ${_()}]`,t,...u))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class a extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...u){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...u)}debug(t,...u){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...u)}info(t,...u){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...u)}warn(t,...u){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...u)}error(t,...u){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...u)}critical(t,...u){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...u)}dispose(){}flush(){}}e.ConsoleLogger=a;class m extends P{constructor(t,u=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(u)}trace(t,...u){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...u])}debug(t,...u){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...u])}info(t,...u){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...u])}warn(t,...u){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...u])}error(t,...u){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...u])}critical(t,...u){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...u])}extractMessage(t){return typeof t=="string"?t:(0,f.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class d extends P{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const u of this.logServices)u.setLevel(t);super.setLevel(t)}trace(t,...u){for(const r of this.logServices)r.trace(t,...u)}debug(t,...u){for(const r of this.logServices)r.debug(t,...u)}info(t,...u){for(const r of this.logServices)r.info(t,...u)}warn(t,...u){for(const r of this.logServices)r.warn(t,...u)}error(t,...u){for(const r of this.logServices)r.error(t,...u)}critical(t,...u){for(const r of this.logServices)r.critical(t,...u)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class v extends C.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...u){this.logger.trace(t,...u)}debug(t,...u){this.logger.debug(t,...u)}info(t,...u){this.logger.info(t,...u)}warn(t,...u){this.logger.warn(t,...u)}error(t,...u){this.logger.error(t,...u)}critical(t,...u){this.logger.critical(t,...u)}flush(){this.logger.flush()}}e.LogService=v;class D extends C.Disposable{constructor(t,u){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(u(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(r))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,u){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,u?.always?S.Trace:this.logLevel,u),this.loggers.set(t.toString(),r),u?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class I{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...u){}debug(t,...u){}info(t,...u){}warn(t,...u){}error(t,...u){}critical(t,...u){}dispose(){}flush(){}}e.NullLogService=I;function b(g){if(g.verbose)return S.Trace;if(typeof g.logLevel=="string"){const t=l(g.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function l(g){switch(g){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=l;function o(g){switch(g){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=o}),define(fe[117],me([0,1,43,13]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function C(S,P,n,k){try{const a=await new Promise((m,d)=>{Y(["spdlog"],m,d)});return a.setFlushOn(F.LogLevel.Trace),a.createAsyncRotatingLogger(S,P,n,k)}catch(a){console.error(a)}return null}function y(S,P,n,k){const a=Y.__$__nodeRequire("spdlog");return a.setFlushOn(F.LogLevel.Trace),a.createRotatingLogger(S,P,n,k)}e.createRotatingLogger=y;function A(S,P,n){switch(P){case F.LogLevel.Trace:S.trace(n);break;case F.LogLevel.Debug:S.debug(n);break;case F.LogLevel.Info:S.info(n);break;case F.LogLevel.Warning:S.warn(n);break;case F.LogLevel.Error:S.error(n);break;case F.LogLevel.Critical:S.critical(n);break;default:throw new Error("Invalid log level")}}class _ extends F.AbstractMessageLogger{constructor(P,n,k,a){super();this.name=P,this.filepath=n,this.rotating=k,this.buffer=[],this.setLevel(a),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const P=this.rotating?6:1,n=30/P*f.ByteSize.MB;return C(this.name,this.filepath,n,P).then(k=>{if(k){this._logger=k,this._logger.setLevel(this.getLevel());for(const{level:a,message:m}of this.buffer)A(this._logger,a,m);this.buffer=[]}})}log(P,n){this._logger?A(this._logger,P,n):this.getLevel()<=P&&this.buffer.push({level:P,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=_}),define(fe[118],me([0,1,49,162,4]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var A;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function P(d,v){return v-d}S.compare=P;const n=Object.create(null);n[S.Error]=(0,F.localize)(0,null),n[S.Warning]=(0,F.localize)(1,null),n[S.Info]=(0,F.localize)(2,null);function k(d){return n[d]||""}S.toString=k;function a(d){switch(d){case f.default.Error:return S.Error;case f.default.Warning:return S.Warning;case f.default.Info:return S.Info;case f.default.Ignore:return S.Hint}}S.fromSeverity=a;function m(d){switch(d){case S.Error:return f.default.Error;case S.Warning:return f.default.Warning;case S.Info:return f.default.Info;case S.Hint:return f.default.Ignore}}S.toSeverity=m}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var _;(function(S){const P="";function n(a){return k(a,!0)}S.makeKey=n;function k(a,m){let d=[P];return a.source?d.push(a.source.replace("\xA6","\\\xA6")):d.push(P),a.code?typeof a.code=="string"?d.push(a.code.replace("\xA6","\\\xA6")):d.push(a.code.value.replace("\xA6","\\\xA6")):d.push(P),a.severity!==void 0&&a.severity!==null?d.push(A.toString(a.severity)):d.push(P),a.message&&m?d.push(a.message.replace("\xA6","\\\xA6")):d.push(P),a.startLineNumber!==void 0&&a.startLineNumber!==null?d.push(a.startLineNumber.toString()):d.push(P),a.startColumn!==void 0&&a.startColumn!==null?d.push(a.startColumn.toString()):d.push(P),a.endLineNumber!==void 0&&a.endLineNumber!==null?d.push(a.endLineNumber.toString()):d.push(P),a.endColumn!==void 0&&a.endColumn!==null?d.push(a.endColumn.toString()):d.push(P),d.push(P),d.join("\xA6")}S.makeKeyOptionalMessage=k})(_=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,C.createDecorator)("markerService")}),define(fe[192],me([0,1,3,49,4]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,C.createDecorator)("notificationService");var y;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class _{constructor(){this.progress=new S,this.onDidClose=f.Event.None,this.onDidChangeVisibility=f.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=_;class S{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=S}),define(fe[193],me([0,1,6,9,2,4]),function(Y,e,f,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return f.Disposable.None},registerValidator(){return f.Disposable.None},registerExternalUriResolver(){return f.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return f.Disposable.None},async open(){return!1},async resolveExternalUri(_){return{resolved:_,dispose(){}}}});function A(_,S){return C.URI.isUri(_)?(0,F.equalsIgnoreCase)(_.scheme,S):(0,F.startsWithIgnoreCase)(_,S+":")}e.matchesScheme=A}),define(fe[194],me([0,1,10,11,38,23]),function(Y,e,f,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof F.globals.vscode!="undefined"&&typeof F.globals.vscode.context!="undefined"){const _=F.globals.vscode.context.configuration();if(_)A=_.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const _=(0,y.dirname)(f.FileAccess.asFileUri("",Y));A=Y.__$__nodeRequire((0,y.joinPath)(_,"product.json").fsPath);const S=Y.__$__nodeRequire((0,y.joinPath)(_,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:S.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A});var He=this&&this.__param||function(Y,e){return function(f,F){e(f,F,Y)}};define(fe[119],me([0,1,17,21,6,4]),function(Y,e,f,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,y.createDecorator)("progressService");var A;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class _{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=_,_.None=Object.freeze({report(){}});let S=class extends C.Disposable{constructor(k,a){super();this.deferred=new f.DeferredPromise,a.withProgress(k,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,C.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};S=je([He(1,e.IProgressService)],S),e.UnmanagedProgress=S;class P extends C.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(k){this.stop();const a=++this.currentOperationId,m=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{a===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,C.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,C.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,C.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:a,token:m.token,stop:()=>this.doStop(a),isCurrent:()=>this.currentOperationId===a}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,y.createDecorator)("editorProgressService")}),define(fe[34],me([0,1,57,12]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(A,_){f.ok(F.isString(A)),f.ok(F.isObject(_)),f.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,_)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new C}),define(fe[120],me([0,1,3,34]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(_){return _.length>0&&_.charAt(_.length-1)==="#"?_.substring(0,_.length-1):_}class y{constructor(){this._onDidChangeSchema=new f.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,P){this.schemasById[C(S)]=P,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new y;F.Registry.add(e.Extensions.JSONContribution,A)}),define(fe[85],me([0,1,16,3,12,157,120,34]),function(Y,e,f,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const n=_.Registry.as(A.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:y.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(l,o=!0){this.registerConfigurations([l],o)}registerConfigurations(l,o=!0){const g=this.doRegisterConfigurations(l,o);n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(g)}deregisterConfigurations(l){const o=this.doDeregisterConfigurations(l);n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:l,remove:o}){const g=[];g.push(...this.doDeregisterConfigurations(o)),g.push(...this.doRegisterConfigurations(l,!1)),n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,f.distinct)(g))}registerDefaultConfigurations(l){const o=[],g=[];for(const t of l)for(const u in t)if(o.push(u),e.OVERRIDE_PROPERTY_PATTERN.test(u)){this.defaultValues[u]={...this.defaultValues[u]||{},...t[u]};const r={type:"object",default:this.defaultValues[u],description:y.localize(1,null,u),$ref:e.resourceLanguageSettingsSchemaId};g.push(m(u)),this.configurationProperties[u]=r,this.defaultLanguageConfigurationOverridesNode.properties[u]=r}else{this.defaultValues[u]=t[u];const r=this.configurationProperties[u];r&&(this.updatePropertyDefaultValue(u,r),this.updateSchema(u,r))}this.registerOverrideIdentifiers(g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(l){const o=[];for(const g of l)for(const t in g)if(o.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const u=this.configurationProperties[t];u&&(this.updatePropertyDefaultValue(t,u),this.updateSchema(t,u))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const o of l)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,o){const g=[];return l.forEach(t=>{g.push(...this.validateAndRegisterProperties(t,o,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),g}doDeregisterConfigurations(l){const o=[],g=t=>{if(t.properties)for(const u in t.properties)o.push(u),delete this.configurationProperties[u],this.removeFromSchema(u,t.properties[u]);t.allOf&&t.allOf.forEach(u=>g(u))};for(const t of l){g(t);const u=this.configurationContributors.indexOf(t);u!==-1&&this.configurationContributors.splice(u,1)}return o}validateAndRegisterProperties(l,o=!0,g,t=3){t=C.isUndefinedOrNull(l.scope)?t:l.scope;let u=[],r=l.properties;if(r)for(let s in r){if(o&&D(s)){delete r[s];continue}const c=r[s];if(this.updatePropertyDefaultValue(s,c),e.OVERRIDE_PROPERTY_PATTERN.test(s)?c.scope=void 0:(c.scope=C.isUndefinedOrNull(c.scope)?t:c.scope,c.restricted=C.isUndefinedOrNull(c.restricted)?!!g?.restrictedConfigurations?.includes(s):c.restricted),r[s].hasOwnProperty("included")&&!r[s].included){this.excludedConfigurationProperties[s]=r[s],delete r[s];continue}else this.configurationProperties[s]=r[s];!r[s].deprecationMessage&&r[s].markdownDeprecationMessage&&(r[s].deprecationMessage=r[s].markdownDeprecationMessage),u.push(s)}let i=l.allOf;if(i)for(let s of i)u.push(...this.validateAndRegisterProperties(s,o,g,t));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(l){const o=g=>{let t=g.properties;if(t)for(const r in t)this.updateSchema(r,t[r]);let u=g.allOf;u&&u.forEach(o)};o(l)}updateSchema(l,o){switch(e.allSettings.properties[l]=o,o.scope){case 1:e.applicationSettings.properties[l]=o;break;case 2:e.machineSettings.properties[l]=o;break;case 6:e.machineOverridableSettings.properties[l]=o;break;case 3:e.windowSettings.properties[l]=o;break;case 4:e.resourceSettings.properties[l]=o;break;case 5:e.resourceSettings.properties[l]=o,this.resourceLanguageSettingsSchema.properties[l]=o;break}}removeFromSchema(l,o){switch(delete e.allSettings.properties[l],o.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const o=`[${l}]`,g={type:"object",description:y.localize(2,null),errorMessage:y.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,g),e.allSettings.properties[o]=g,e.applicationSettings.properties[o]=g,e.machineSettings.properties[o]=g,e.machineOverridableSettings.properties[o]=g,e.windowSettings.properties[o]=g,e.resourceSettings.properties[o]=g}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,o){let g=this.defaultValues[l];C.isUndefined(g)&&(g=o.default),C.isUndefined(g)&&(g=d(o.type)),o.default=g}}const a="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(a);function m(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=m;function d(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const v=new k;_.Registry.add(e.Extensions.Configuration,v);function D(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?y.localize(5,null,b):v.getConfigurationProperties()[b]!==void 0?y.localize(6,null,b):null:y.localize(4,null)}e.validateProperty=D;function I(){const b=[],l=v.getConfigurationProperties();for(const o of Object.keys(l))b.push([o,l[o].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=I}),define(fe[121],me([0,1,25,12,2,85,4,34]),function(Y,e,f,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function S(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof C.URI)}e.isConfigurationOverrides=S;var P;(function(u){u[u.USER=1]="USER",u[u.USER_LOCAL=2]="USER_LOCAL",u[u.USER_REMOTE=3]="USER_REMOTE",u[u.WORKSPACE=4]="WORKSPACE",u[u.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",u[u.DEFAULT=6]="DEFAULT",u[u.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(u){switch(u){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function k(u,r){const i=r?u?r.keys.filter(T=>u.keys.indexOf(T)===-1):[...r.keys]:[],s=u?r?u.keys.filter(T=>r.keys.indexOf(T)===-1):[...u.keys]:[],c=[];if(r&&u){for(const T of u.keys)if(r.keys.indexOf(T)!==-1){const L=I(u.contents,T),M=I(r.contents,T);f.equals(L,M)||c.push(T)}}const h=[],w=T=>{const L={};for(const M of T)for(const R of M.identifiers)L[g(R)]=M;return L},E=r?w(r.overrides):{},p=u?w(u.overrides):{};if(Object.keys(E).length)for(const T of i){const L=E[T];L&&h.push([(0,y.overrideIdentifierFromKey)(T),L.keys])}if(Object.keys(p).length)for(const T of s){const L=p[T];L&&h.push([(0,y.overrideIdentifierFromKey)(T),L.keys])}if(Object.keys(E).length&&Object.keys(p).length)for(const T of c){const L=p[T],M=E[T];if(L&&M){const R=k({contents:L.contents,keys:L.keys,overrides:[]},{contents:M.contents,keys:M.keys,overrides:[]});h.push([(0,y.overrideIdentifierFromKey)(T),[...R.added,...R.removed,...R.updated]])}}return{added:i,removed:s,updated:c,overrides:h}}e.compare=k;function a(u,r){const i=[];for(const s of Object.keys(u))if(y.OVERRIDE_PROPERTY_PATTERN.test(s)){const c={};for(const h in u[s])c[h]=u[s][h];i.push({identifiers:[(0,y.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(c),contents:m(c,r)})}return i}e.toOverrides=a;function m(u,r){const i=Object.create(null);for(let s in u)d(i,s,u[s],r);return i}e.toValuesTree=m;function d(u,r,i,s){const c=r.split("."),h=c.pop();let w=u;for(let E=0;E<c.length;E++){let p=c[E],T=w[p];switch(typeof T){case"undefined":T=w[p]=Object.create(null);break;case"object":break;default:s(`Ignoring ${r} as ${c.slice(0,E+1).join(".")} is ${JSON.stringify(T)}`);return}w=T}if(typeof w=="object"&&w!==null)try{w[h]=i}catch(E){s(`Ignoring ${r} as ${c.join(".")} is ${JSON.stringify(w)}`)}else s(`Ignoring ${r} as ${c.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=d;function v(u,r){const i=r.split(".");D(u,i)}e.removeFromValueTree=v;function D(u,r){const i=r.shift();if(r.length===0){delete u[i];return}if(Object.keys(u).indexOf(i)!==-1){const s=u[i];typeof s=="object"&&!Array.isArray(s)&&(D(s,r),Object.keys(s).length===0&&delete u[i])}}function I(u,r,i){function s(w,E){let p=w;for(const T of E){if(typeof p!="object"||p===null)return;p=p[T]}return p}const c=r.split("."),h=s(u,c);return typeof h=="undefined"?i:h}e.getConfigurationValue=I;function b(u,r,i){Object.keys(r).forEach(s=>{s!=="__proto__"&&(s in u?F.isObject(u[s])&&F.isObject(r[s])?b(u[s],r[s],i):i&&(u[s]=r[s]):u[s]=r[s])})}e.merge=b;function l(){const u=_.Registry.as(y.Extensions.Configuration).getConfigurationProperties();return Object.keys(u)}e.getConfigurationKeys=l;function o(){const u=Object.create(null),r=_.Registry.as(y.Extensions.Configuration).getConfigurationProperties();for(let i in r){let s=r[i].default;d(u,i,s,c=>console.error(`Conflict in default settings: ${c}`))}return u}e.getDefaultValues=o;function g(u){return`[${u}]`}e.keyFromOverrideIdentifier=g;function t(u,r,i){const s=u.inspect(r),c=u.inspect(i);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:s.defaultValue}e.getMigratedSettingValue=t}),define(fe[195],me([0,1,16,3,60,6,24,25,12,2,121,85,34]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},u=[],r=[]){this._contents=t,this._keys=u,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,u){const r=this.getContentsForOverrideIdentifer(u);return r?t?(0,n.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const u of this.overrides)if(u.identifiers.indexOf(t)!==-1)return u.keys;return[]}override(t){let u=this.overrideConfigurations.get(t);return u||(u=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,u)),u}merge(...t){const u=_.deepClone(this.contents),r=_.deepClone(this.overrides),i=[...this.keys];for(const s of t){this.mergeContents(u,s.contents);for(const c of s.overrides){const[h]=r.filter(w=>f.equals(w.identifiers,c.identifiers));h?this.mergeContents(h.contents,c.contents):r.push(_.deepClone(c))}for(const c of s.keys)i.indexOf(c)===-1&&i.push(c)}return new m(u,i,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(t){const u=this.getContentsForOverrideIdentifer(t);if(!u||typeof u!="object"||!Object.keys(u).length)return this;let r={};for(const i of f.distinct([...Object.keys(this.contents),...Object.keys(u)])){let s=this.contents[i],c=u[i];c&&(typeof s=="object"&&typeof c=="object"?(s=_.deepClone(s),this.mergeContents(s,c)):s=c),r[i]=s}return new m(r,this.keys,this.overrides)}mergeContents(t,u){for(const r of Object.keys(u)){if(r in t&&S.isObject(t[r])&&S.isObject(u[r])){this.mergeContents(t[r],u[r]);continue}t[r]=_.deepClone(u[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?_.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const u of this.overrides)if(u.identifiers.indexOf(t)!==-1)return u.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,u){this.addKey(t),(0,n.addToValueTree)(this.contents,t,u,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let u=this.keys.length;for(let r=0;r<u;r++)t.indexOf(this.keys[r])===0&&(u=r);this.keys.splice(u,1,t)}removeKey(t){let u=this.keys.indexOf(t);return u!==-1?(this.keys.splice(u,1),!0):!1}}e.ConfigurationModel=m;class d extends m{constructor(){const t=(0,n.getDefaultValues)(),u=(0,n.getConfigurationKeys)(),r=[];for(const i of Object.keys(t))k.OVERRIDE_PROPERTY_PATTERN.test(i)&&r.push({identifiers:[(0,k.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,n.toValuesTree)(t[i],s=>console.error(`Conflict in default settings file: ${s}`))});super(t,u,r)}}e.DefaultConfigurationModel=d;class v{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,u){if(!S.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,u)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,u){this._raw=t;const{contents:r,keys:i,overrides:s,restricted:c}=this.doParseRaw(t,u);this._configurationModel=new m(r,i,s),this._restrictedConfigurations=c||[]}doParseContent(t){let u={},r=null,i=[],s=[],c=[];function h(E){Array.isArray(i)?i.push(E):r!==null&&(i[r]=E)}let w={onObjectBegin:()=>{let E={};h(E),s.push(i),i=E,r=null},onObjectProperty:E=>{r=E},onObjectEnd:()=>{i=s.pop()},onArrayBegin:()=>{let E=[];h(E),s.push(i),i=E,r=null},onArrayEnd:()=>{i=s.pop()},onLiteralValue:h,onError:(E,p,T)=>{c.push({error:E,offset:p,length:T})}};if(t)try{C.visit(t,w),u=i[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return u}doParseRaw(t,u){const r=a.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,r,!0,u);t=i.raw;const s=(0,n.toValuesTree)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),c=Object.keys(t),h=(0,n.toOverrides)(t,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:s,keys:c,overrides:h,restricted:i.restricted}}filter(t,u,r,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const s={},c=[];for(let h in t)if(k.OVERRIDE_PROPERTY_PATTERN.test(h)&&r){const w=this.filter(t[h],u,!1,i);s[h]=w.raw,c.push(...w.restricted)}else{const w=u[h],E=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&c.push(h),(E===void 0||i.scopes===void 0||i.scopes.includes(E))&&(i.skipRestricted&&w?.restricted||(s[h]=t[h]))}return{raw:s,restricted:c}}}e.ConfigurationModelParser=v;class D extends y.Disposable{constructor(t,u,r,i){super();this.userSettingsResource=t,this.scopes=u,this.fileService=i,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class I{constructor(t,u,r=new m,i=new m,s=new A.ResourceMap,c=new m,h=new A.ResourceMap,w=!0){this._defaultConfiguration=t,this._localUserConfiguration=u,this._remoteUserConfiguration=r,this._workspaceConfiguration=i,this._folderConfigurations=s,this._memoryConfiguration=c,this._memoryConfigurationByResource=h,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,u,r){return this.getConsolidateConfigurationModel(u,r).getValue(t)}updateValue(t,u,r={}){let i;r.resource?(i=this._memoryConfigurationByResource.get(r.resource),i||(i=new m,this._memoryConfigurationByResource.set(r.resource,i))):i=this._memoryConfiguration,u===void 0?i.removeValue(t):i.setValue(t,u),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,u,r){const i=this.getConsolidateConfigurationModel(u,r),s=this.getFolderConfigurationModelForResource(u.resource,r),c=u.resource?this._memoryConfigurationByResource.get(u.resource)||this._memoryConfiguration:this._memoryConfiguration,h=u.overrideIdentifier?this._defaultConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),w=u.overrideIdentifier?this.userConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=u.overrideIdentifier?this.localUserConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),p=u.overrideIdentifier?this.remoteUserConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=r?u.overrideIdentifier?this._workspaceConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=s?u.overrideIdentifier?s.freeze().override(u.overrideIdentifier).getValue(t):s.freeze().getValue(t):void 0,M=u.overrideIdentifier?c.override(u.overrideIdentifier).getValue(t):c.getValue(t),R=i.getValue(t),$=f.distinct(f.flatten(i.overrides.map(z=>z.identifiers))).filter(z=>i.getOverrideValue(t,z)!==void 0);return{defaultValue:h,userValue:w,userLocalValue:E,userRemoteValue:p,workspaceValue:T,workspaceFolderValue:L,memoryValue:M,value:R,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,userRemote:p!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:s?.freeze().getValue(t),override:u.overrideIdentifier?s?.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,memory:M!==void 0?{value:c.getValue(t),override:u.overrideIdentifier?c.getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,overrideIdentifiers:$.length?$:void 0}}keys(t){const u=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:u?u.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,u){this._folderConfigurations.set(t,u),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,u){const r=u.filter(i=>k.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const s=(0,k.overrideIdentifierFromKey)(i),c=this._defaultConfiguration.getKeysForOverrideIdentifier(s),h=t.getKeysForOverrideIdentifier(s),w=[...h.filter(E=>c.indexOf(E)===-1),...c.filter(E=>h.indexOf(E)===-1),...c.filter(E=>!_.equals(this._defaultConfiguration.override(s).getValue(E),t.override(s).getValue(E)))];return[s,w]});return this.updateDefaultConfiguration(t),{keys:u,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:u,updated:r,removed:i,overrides:s}=(0,n.compare)(this.localUserConfiguration,t),c=[...u,...r,...i];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:u,updated:r,removed:i,overrides:s}=(0,n.compare)(this.remoteUserConfiguration,t);let c=[...u,...r,...i];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:u,updated:r,removed:i,overrides:s}=(0,n.compare)(this.workspaceConfiguration,t);let c=[...u,...r,...i];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:s}}compareAndUpdateFolderConfiguration(t,u){const r=this.folderConfigurations.get(t),{added:i,updated:s,removed:c,overrides:h}=(0,n.compare)(r,u);let w=[...i,...s,...c];return(w.length||!r)&&this.updateFolderConfiguration(t,u),{keys:w,overrides:h}}compareAndDeleteFolderConfiguration(t){const u=this.folderConfigurations.get(t);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:i,removed:s,overrides:c}=(0,n.compare)(u,void 0);return{keys:[...r,...i,...s],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,u){let r=this.getConsolidatedConfigurationModelForResource(t,u);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},u){let r=this.getWorkspaceConsolidatedConfiguration();if(u&&t){const i=u.getFolder(t);i&&(r=this.getFolderConsolidatedConfiguration(i.uri)||r);const s=this._memoryConfigurationByResource.get(t);s&&(r=r.merge(s))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let u=this._foldersConsolidatedConfigurations.get(t);if(!u){const r=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(u=r.merge(i),this._freeze&&(u=u.freeze()),this._foldersConsolidatedConfigurations.set(t,u)):u=r}return u}getFolderConfigurationModelForResource(t,u){if(u&&t){const r=u.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,u)=>{const{contents:r,overrides:i,keys:s}=this._folderConfigurations.get(u);return t.push([u,{contents:r,overrides:i,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(u=>t.add(u)),this.userConfiguration.freeze().keys.forEach(u=>t.add(u)),this._workspaceConfiguration.freeze().keys.forEach(u=>t.add(u)),this._folderConfigurations.forEach(u=>u.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const u=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>u.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>u.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>u.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(i=>u.add(i))),[...u.values()]}static parse(t){const u=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),s=t.folders.reduce((c,h)=>(c.set(P.URI.revive(h[0]),this.parseConfigurationModel(h[1])),c),new A.ResourceMap);return new I(u,r,new m,i,s,new m,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=I;function b(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const t=new Set,u=new Map;for(const i of g)i.keys.forEach(s=>t.add(s)),i.overrides.forEach(([s,c])=>{const h=(0,A.getOrSet)(u,s,new Set);c.forEach(w=>h.add(w))});const r=[];return u.forEach((i,s)=>r.push([s,[...i.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=b;class l{constructor(t,u,r,i){this.change=t,this.previous=u,this.currentConfiguraiton=r,this.currentWorkspace=i,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(h=>s.add(h)),t.overrides.forEach(([,h])=>h.forEach(w=>s.add(w))),this.affectedKeys=[...s.values()];const c=new m;this.affectedKeys.forEach(h=>c.setValue(h,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,u){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(u){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,u,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,u,this.currentWorkspace);return!_.equals(r,i)}return!0}return!1}doesAffectedKeysTreeContains(t,u){let r=(0,n.toValuesTree)({[u]:!0},()=>{}),i;for(;typeof r=="object"&&(i=Object.keys(r)[0]);){if(t=t[i],!t)return!1;r=r[i]}return!0}}e.ConfigurationChangeEvent=l;class o extends l{constructor(t,u,r,i){super({keys:t.allKeys(),overrides:[]},void 0,t,u);this.source=r,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=o}),define(fe[122],me([0,1,4]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,f.createDecorator)("remoteAuthorityResolverService");var F;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(F=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends Error{constructor(A,_=F.Unknown,S){super(A);this._message=A,this._code=_,this._detail=S,this.isHandled=_===F.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(A){return A instanceof C&&A._code===F.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof C&&A._code===F.NoResolverFound}static isHandled(A){return A instanceof C&&A.isHandled}}e.RemoteAuthorityResolverError=C}),define(fe[86],me([0,1,10]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function F(P){return P.scheme===f.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=F;function C(P){if(!P)return;const n=P.indexOf("+");return n<0?P:P.substr(0,n)}e.getRemoteName=C;function y(P){return P.scheme!==f.Schemas.file&&P.scheme!==f.Schemas.vscodeRemote}e.isVirtualResource=y;function A(P){if(P.folders.length)return P.folders.every(n=>y(n.uri))?P.folders[0].uri:void 0;if(P.configuration&&y(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=A;function _(P){return A(P)?.scheme}e.getVirtualWorkspaceScheme=_;function S(P){return A(P)!==void 0}e.isVirtualWorkspace=S}),define(fe[123],me([0,1,3,11,4,13]),function(Y,e,f,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService");var A;(function(d){d.Http="http",d.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var _;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(_=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function n(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=n,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=k;function a(d,v){return v?v!==1&&d<1024:!F.isWindows&&d<1024}e.isPortPrivileged=a;let m=class{constructor(v){this.logService=v,this._onTunnelOpened=new f.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new f.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new f.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(v,D){return this._tunnelProvider=v,v?(this._canElevate=D.elevation,this._privacyOptions=D.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return new Promise(async v=>{const D=[],I=Array.from(this._tunnels.values());for(let b of I){const l=Array.from(b.values());for(let o of l){const g=await o.value;g&&D.push(g)}}v(D)})}async dispose(){for(const v of this._tunnels.values()){for(const{value:D}of v.values())await D.then(I=>I?.dispose());v.clear()}this._tunnels.clear()}openTunnel(v,D,I,b,l=!1,o=_.Private,g){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${D}:${I} on local port ${b}.`),!v)return;D||(D="localhost");const t=this.retainOrCreateTunnel(v,D,I,b,l,o,g);return t?t.then(u=>{if(!u){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(D,I);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(u);return(u.tunnelRemoteHost!==D||u.tunnelRemotePort!==I)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const D=this._tunnels.get(v.tunnelRemoteHost);if(D){const I=D.get(v.tunnelRemotePort);I&&(I.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,I))}}}}async tryDisposeTunnel(v,D,I){if(I.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${D}.`);const b=I.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(D),b}}async closeTunnel(v,D){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${D} `);const I=this._tunnels.get(v);if(I&&I.has(D)){const b=I.get(D);b.refcount=0,await this.tryDisposeTunnel(v,D,b)}}addTunnelToMap(v,D,I){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(D,{refcount:1,value:I})}async removeEmptyTunnelFromMap(v,D){const I=this._tunnels.get(v);I&&(await I.get(D)||I.delete(D),I.size===0&&this._tunnels.delete(v))}getTunnelFromMap(v,D){let I=[v];n(v)?(I.push(...e.LOCALHOST_ADDRESSES),I.push(...e.ALL_INTERFACES_ADDRESSES)):k(v)&&I.push(...e.ALL_INTERFACES_ADDRESSES);const b=I.map(l=>this._tunnels.get(l));for(const l of b){const o=l?.get(D);if(o)return o}}canTunnel(v){return!!P(v)}createWithProvider(v,D,I,b,l,o,g){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${D}:${I} on local port ${b}.`);const u={elevationRequired:l?a(b===void 0?I:b):!1},r={remoteAddress:{host:D,port:I},localAddressPort:b,privacy:o,public:o!==_.Private,protocol:g},i=v.forwardPort(r,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(D,I,i),i}};m=je([He(0,y.ILogService)],m),e.AbstractTunnelService=m}),define(fe[196],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class f{vsda(){return new Promise((C,y)=>Y(["vsda"],C,y))}async sign(C){try{const y=await this.vsda(),A=new y.signer;if(A)return A.sign(C)}catch(y){}return C}}e.SignService=f}),define(fe[197],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class f{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,y,A=5){let _;return _=y(S=>{const P=typeof S=="string"?S:S.data;let n=this._terminalBufferMap.get(C);if(n){n.data.push(P);return}const k=setTimeout(()=>this.flushBuffer(C),A);n={data:[P],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),_.dispose()}},this._terminalBufferMap.set(C,n)}),_}stopBuffering(C){const y=this._terminalBufferMap.get(C);y&&y.dispose()}flushBuffer(C){const y=this._terminalBufferMap.get(C);y&&(this._terminalBufferMap.delete(C),this._callback(C,y.data.join("")))}}e.TerminalDataBufferer=f}),define(fe[198],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var f;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST="hc"})(f=e.ColorScheme||(e.ColorScheme={}))}),define(fe[64],me([0,1,47,3,6,4,34,198]),function(Y,e,f,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,y.createDecorator)("themeService");var S;(function(D){function I(b){return b&&typeof b=="object"&&typeof b.id=="string"}D.isThemeColor=I})(S=e.ThemeColor||(e.ThemeColor={}));function P(D){return{id:D}}e.themeColorFromId=P;var n;(function(D){function I(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color=="undefined"||S.isThemeColor(u.color))}D.isThemeIcon=I;const b=new RegExp(`^\\$\\((${f.CSSIcon.iconNameExpression}(?:${f.CSSIcon.iconModifierExpression})?)\\)$`);function l(u){const r=b.exec(u);if(!r)return;let[,i]=r;return{id:i}}D.fromString=l;function o(u,r){let i=u.id;const s=i.lastIndexOf("~");return s!==-1&&(i=i.substring(0,s)),r&&(i=`${i}~${r}`),{id:i}}D.modify=o;function g(u,r){return u.id===r.id&&u.color?.id===r.color?.id}D.isEqual=g;function t(u,r){return{id:u.id,color:r?P(r):void 0}}D.asThemeIcon=t,D.asClassNameArray=f.CSSIcon.asClassNameArray,D.asClassName=f.CSSIcon.asClassName,D.asCSSSelector=f.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=f.Codicon.file,e.FolderThemeIcon=f.Codicon.folder;function k(D){switch(D){case _.ColorScheme.DARK:return"vs-dark";case _.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class a{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new F.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,C.toDisposable)(()=>{const b=this.themingParticipants.indexOf(I);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new a;A.Registry.add(e.Extensions.ThemingContribution,m);function d(D){return m.onColorThemeChange(D)}e.registerThemingParticipant=d;class v extends C.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,b){let l=this.theme.getColor(I);return l&&b&&(l=b(l,this.theme)),l?l.toString():null}}e.Themable=v}),define(fe[199],me([0,1,17,47,3,163,120,34,64]),function(Y,e,f,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new C.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${F.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(I,b,l,o){const g=this.iconsById[I];if(g){if(l&&!g.description){g.description=l,this.iconSchema.properties[I].markdownDescription=`${l} $(${I})`;const r=this.iconReferenceSchema.enum.indexOf(I);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=l),this._onDidChange.fire()}return g}let t={id:I,description:l,defaults:b,deprecationMessage:o};this.iconsById[I]=t;let u={$ref:"#/definitions/icons"};return o&&(u.deprecationMessage=o),l&&(u.markdownDescription=`${l}: $(${I})`),this.iconSchema.properties[I]=u,this.iconReferenceSchema.enum.push(I),this.iconReferenceSchema.enumDescriptions.push(l||""),this._onDidChange.fire(),{id:I}}deregisterIcon(I){delete this.iconsById[I],delete this.iconSchema.properties[I];const b=this.iconReferenceSchema.enum.indexOf(I);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(I=>this.iconsById[I])}getIcon(I){return this.iconsById[I]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(I,b){const l=this.iconFontsById[I];if(l)return l;let o={id:I,definition:b};return this.iconFontsById[I]=o,this._onDidChange.fire(),o}deregisterIconFont(I){delete this.iconFontsById[I]}getIconFonts(){return Object.keys(this.iconFontsById).map(I=>this.iconFontsById[I])}getIconFont(I){return this.iconFontsById[I]}toString(){const I=(g,t)=>g.id.localeCompare(t.id),b=g=>{for(;S.ThemeIcon.isThemeIcon(g.defaults);)g=this.iconsById[g.defaults.id];return`codicon codicon-${g?g.id:""}`};let l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.iconsById).map(g=>this.iconsById[g]);for(const g of o.filter(t=>!!t.description).sort(I))l.push(`|<i class="${b(g)}"></i>|${g.id}|${S.ThemeIcon.isThemeIcon(g.defaults)?g.defaults.id:g.id}|${g.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const g of o.filter(t=>!S.ThemeIcon.isThemeIcon(t.defaults)).sort(I))l.push(`|<i class="${b(g)}"></i>|${g.id}|`);return l.join(`
`)}}const n=new P;_.Registry.add(e.Extensions.IconContribution,n);function k(D,I,b,l){return n.registerIcon(D,I,b,l)}e.registerIcon=k;function a(){return n}e.getIconRegistry=a;function m(){for(const D of F.iconRegistry.all)n.registerIcon(D.id,D.definition,D.description);F.iconRegistry.onDidRegister(D=>n.registerIcon(D.id,D.definition,D.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let d=_.Registry.as(A.Extensions.JSONContribution);d.registerSchema(e.iconsSchemaId,n.getIconSchema());const v=new f.RunOnceScheduler(()=>d.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.widgetClose=k("widget-close",F.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=k("goto-previous-location",F.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=k("goto-next-location",F.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=S.ThemeIcon.modify(F.Codicon.sync,"spin")}),define(fe[44],me([0,1,24,23,2,4]),function(Y,e,f,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,y.createDecorator)("contextService");var A;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function _(a){const m=a;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=_;function S(a){const m=a;return!!(m&&typeof m=="object"&&C.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=S;class P{constructor(m,d,v,D,I){this._id=m,this._transient=v,this._configuration=D,this._ignorePathCasing=I,this._foldersMap=f.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(m){this._id=m.id,this._configuration=m.configuration,this._transient=m.transient,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=f.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=P;class n{constructor(m,d){this.raw=d,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,F.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function k(a){return new n({uri:a,index:0,name:(0,F.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=k}),define(fe[200],me([0,1,29,60,140,79,10,8,11,23,2,164,4,86,44]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const v=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(O){return(typeof O=="string"?(0,_.extname)(O):(0,P.extname)(O))===v}e.hasWorkspaceFileExtension=D,e.IWorkspacesService=(0,a.createDecorator)("workspacesService");function I(O){return O.hasOwnProperty("workspace")}e.isRecentWorkspace=I;function b(O){return O.hasOwnProperty("folderUri")}e.isRecentFolder=b;function l(O){return O.hasOwnProperty("fileUri")}e.isRecentFile=l;function o(O){const V=O;return typeof V?.id=="string"&&n.URI.isUri(V.uri)}e.isSingleFolderWorkspaceIdentifier=o;function g(O){if(O.configuration)return{id:O.id,configPath:O.configuration};if(O.folders.length===1)return{id:O.id,uri:O.folders[0].uri}}e.toWorkspaceIdentifier=g;function t(O){const V=O;return typeof V?.id=="string"&&n.URI.isUri(V.configPath)}e.isWorkspaceIdentifier=t;function u(O){const V=O;if(V?.uri)return{id:V.id,uri:n.URI.revive(V.uri)};const N=O;if(N?.configPath)return{id:N.id,configPath:n.URI.revive(N.configPath)};if(O?.id)return{id:O.id}}e.reviveIdentifier=u;function r(O,V){return P.extUriBiasedIgnorePathCase.isEqualOrParent(O,V.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function i(O){return s(O)||c(O)}e.isStoredWorkspaceFolder=i;function s(O){const V=O;return typeof V?.path=="string"&&(!V.name||typeof V.name=="string")}e.isRawFileWorkspaceFolder=s;function c(O){const V=O;return typeof V?.uri=="string"&&(!V.name||typeof V.name=="string")}e.isRawUriWorkspaceFolder=c;function h(O,V,N,U,x=!S.isWindows,B){if(O.scheme!==U.scheme)return{name:N,uri:O.toString(!0)};let H=V?void 0:B.relativePath(U,O);if(H!==void 0)H.length===0?H=".":S.isWindows&&O.scheme===A.Schemas.file&&!x&&(H=H.replace(/\//g,"\\"));else if(O.scheme===A.Schemas.file)H=O.fsPath,S.isWindows&&(H=(0,y.normalizeDriveLetter)(H),x&&(H=(0,f.toSlashes)(H)));else{if(!B.isEqualAuthority(O.authority,U.authority))return{name:N,uri:O.toString(!0)};H=O.path}return{name:N,path:H}}e.getStoredWorkspaceFolder=h;function w(O,V,N){let U=[],x=new Set;const B=N.dirname(V);for(let H of O){let G;if(s(H))H.path&&(G=N.resolvePath(B,H.path));else if(c(H))try{G=n.URI.parse(H.uri),G.path[0]!=="/"&&(G=G.with({path:"/"+G.path}))}catch(K){console.warn(K)}if(G){let K=N.getComparisonKey(G);if(!x.has(K)){x.add(K);const X=H.name||N.basenameOrAuthority(G);U.push(new d.WorkspaceFolder({uri:G,name:X,index:U.length},H))}}}return U}e.toWorkspaceFolders=w;function E(O,V,N,U,x){let B=p(V,O);const H=x.dirname(V),G=x.dirname(U),K=[],X=T(B.folders);for(const Ie of B.folders){const Oe=s(Ie)?x.resolvePath(H,Ie.path):n.URI.parse(Ie.uri);let xe;N?xe=!1:xe=!s(Ie)||(0,_.isAbsolute)(Ie.path),K.push(h(Oe,xe,Ie.name,G,X,x))}const de={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},be=C.setProperty(O,["folders"],K,de);let Se=C.applyEdits(O,be);return B.remoteAuthority===(0,m.getRemoteAuthority)(U)&&(Se=C.applyEdits(Se,C.removeProperty(Se,["remoteAuthority"],de))),Se}e.rewriteWorkspaceFileForNewLocation=E;function p(O,V){let N=F.parse(V);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(U=>i(U));else throw new Error(`${O} looks like an invalid workspace file.`);return N}function T(O){return S.isWindows?O.some(V=>s(V)&&V.path.indexOf("/")>=0):!0}e.useSlashForPath=T;function L(O){return O.workspace&&typeof O.workspace=="object"&&typeof O.workspace.id=="string"&&typeof O.workspace.configPath=="string"}function M(O){return typeof O.folderUri=="string"}function R(O){return typeof O.fileUri=="string"}function $(O,V){const N={workspaces:[],files:[]};if(O){const U=function(B,H){for(let G=0;G<B.length;G++)try{H(B[G],G)}catch(K){V.warn(`Error restoring recent entry ${JSON.stringify(B[G])}: ${K.toString()}. Skip entry.`)}},x=O;if(Array.isArray(x.entries))U(x.entries,B=>{const H=B.label,G=B.remoteAuthority;L(B)?N.workspaces.push({label:H,remoteAuthority:G,workspace:{id:B.workspace.id,configPath:n.URI.parse(B.workspace.configPath)}}):M(B)?N.workspaces.push({label:H,remoteAuthority:G,folderUri:n.URI.parse(B.folderUri)}):R(B)&&N.files.push({label:H,remoteAuthority:G,fileUri:n.URI.parse(B.fileUri)})});else{const B=O;Array.isArray(B.workspaces3)&&U(B.workspaces3,(H,G)=>{const K=Array.isArray(B.workspaceLabels)&&B.workspaceLabels[G]||void 0;typeof H=="object"&&typeof H.id=="string"&&typeof H.configURIPath=="string"?N.workspaces.push({label:K,workspace:{id:H.id,configPath:n.URI.parse(H.configURIPath)}}):typeof H=="string"&&N.workspaces.push({label:K,folderUri:n.URI.parse(H)})}),Array.isArray(B.files2)&&U(B.files2,(H,G)=>{const K=Array.isArray(B.fileLabels)&&B.fileLabels[G]||void 0;typeof H=="string"&&N.files.push({label:K,fileUri:n.URI.parse(H)})})}}return N}e.restoreRecentlyOpened=$;function z(O){const V={entries:[]};for(const N of O.workspaces)b(N)?V.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):V.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of O.files)V.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return V}e.toStoreData=z}),define(fe[87],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class f{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const y=this._idPool++;return this._data.set(y,C),this.logDebugInfo(),y}get(C,y){return this._data.has(C)?this._data.get(C)[y]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!f.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=f,f.enableDebugLogging=!1}),define(fe[52],me([0,1,10,23,4]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class y{constructor(){this._systemSchemes=new Set(Object.keys(f.Schemas)),this._providerInfo=new Map,this.extUri=new F.ExtUri(_=>{const S=this._providerInfo.get(_.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(_,S){S===null?this._providerInfo.delete(_):this._providerInfo.set(_,S)}isFreeScheme(_){return!this._providerInfo.has(_)&&!this._systemSchemes.has(_)}getCapabilities(_){return this._providerInfo.get(_)}}e.ExtHostFileSystemInfo=y,e.IExtHostFileSystemInfo=(0,C.createDecorator)("IExtHostFileSystemInfo")}),define(fe[27],me([0,1,4]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,f.createDecorator)("IExtHostInitDataService")}),define(fe[201],me([0,1,17]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(A,_,S){this._deferredPromises=new Map,this._id=A,this._shared=_,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new f.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of P.values())n.complete()}catch(n){for(const k of P.values())k.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,_){let S=this._value[A];return typeof S=="undefined"&&(S=_),S}update(A,_){this._value[A]=_;let S=this._deferredPromises.get(A);if(S!==void 0)return S.p;const P=new f.DeferredPromise;return this._deferredPromises.set(A,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class C extends F{constructor(A,_){super(A.identifier.value,!0,_);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=C}),define(fe[202],me([0,1,3,2,13]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let y=class{constructor(_,S){this._logService=_,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new f.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new f.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(_,S,P){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(_)).acceptModelChanged(S.value,P)}$acceptDirtyStateChanged(_,S){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(_)).acceptDirty(S)}$acceptModelSaved(_){const S=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(_));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(_,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",_.path,S);const P=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(_));P.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};y=je([He(0,C.ILogService)],y),e.ExtHostNotebookDocuments=y}),define(fe[14],me([0,1,4]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,f.createDecorator)("IExtHostRpcService");class F{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=F});var st=this&&this.__classPrivateFieldSet||function(Y,e,f,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,f):C?C.value=f:e.set(Y,f),f},Ne=this&&this.__classPrivateFieldGet||function(Y,e,f,F){if(f==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?F:f==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[203],me([0,1,26,3]),function(Y,e,f,F){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(_,S){C.set(this,void 0),this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=f.ExtensionIdentifier.toKey(_.identifier),st(this,C,S,"f"),Ne(this,C,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(_){return Ne(this,C,"f").get(this._id,_)}store(_,S){return Ne(this,C,"f").store(this._id,_,S)}delete(_){return Ne(this,C,"f").delete(this._id,_)}}e.ExtensionSecrets=y,C=new WeakMap}),define(fe[124],me([0,1,4,3]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new F.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=(0,f.createDecorator)("IExtHostTelemetry")}),define(fe[65],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var f;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(f=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const F=new WeakMap,C=(b,l)=>{const o={controllerId:l};return F.set(b,o),o};e.createPrivateApiFor=C;const y=b=>F.get(b);e.getPrivateApiFor=y;const A=(b,l,o,g)=>{let t=o;return{enumerable:!0,configurable:!1,get(){return t},set(u){if(!g(t,u)){const r=t;t=u,b.listener?.({op:3,key:l,value:u,previous:r})}}}},_=(b,l)=>b===l,S={range:(b,l)=>b===l?!0:!b||!l?!1:b.isEqual(l),label:_,description:_,busy:_,error:_,canResolveChildren:_,tags:(b,l)=>!(b.length!==l.length||b.some(o=>!l.find(g=>o.id===g.id)))},P=Object.keys(S),n=(b,l)=>({range:A(b,"range",void 0,S.range),label:A(b,"label",l,S.label),description:A(b,"description",void 0,S.description),canResolveChildren:A(b,"canResolveChildren",!1,S.canResolveChildren),busy:A(b,"busy",!1,S.busy),error:A(b,"error",void 0,S.error),tags:A(b,"tags",[],S.tags)}),k=(b,l)=>{const o=new Map;for(const g of P)S[g](b[g],l[g])||o.set(g,l[g]);return o};e.diffTestItems=k;class a extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.DuplicateTestItemError=a;class m extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class d extends Error{constructor(l,o,g){super(`TestItem with ID "${l}" is from controller "${o}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=d;const v=b=>{const l=(0,e.getPrivateApiFor)(b);let o=new Map;return{get size(){return o.size},forEach(g,t){for(const u of o.values())g.call(t,u,this)},replace(g){const t=new Map,u=new Set(o.keys()),r={op:4,ops:[]};for(const i of g){if(!(i instanceof D))throw new m(i.id);const s=(0,e.getPrivateApiFor)(i).controllerId;if(s!==l.controllerId)throw new d(i.id,s,l.controllerId);if(t.has(i.id))throw new a(i.id);t.set(i.id,i),u.delete(i.id),r.ops.push({op:0,item:i})}for(const i of u.keys())r.ops.push({op:1,id:i});l.listener?.(r),o=t},add(g){if(!(g instanceof D))throw new m(g.id);o.set(g.id,g),l.listener?.({op:0,item:g})},delete(g){o.delete(g)&&l.listener?.({op:1,id:g})},get(g){return o.get(g)},toJSON(){return Array.from(o.values())},[Symbol.iterator](){return o.values()}}};class D{constructor(l,o,g,t){if(o.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(o)} symbol`);const u=(0,e.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:o,enumerable:!0,writable:!1},uri:{value:t,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof I?void 0:u.parent}},children:{value:v(this),enumerable:!0,writable:!1},...n(u,g)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=D;class I extends D{constructor(l,o){super(l,l,o,void 0)}}e.TestItemRootImpl=I}),define(fe[53],me([0,1,4,123,3,14]),function(Y,e,f,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(S){function P(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?F.TunnelPrivacyId.Public:F.TunnelPrivacyId.Private),protocol:k.protocol}}S.fromApiTunnel=P;function n(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==F.TunnelPrivacyId.ConstantPrivate&&k.privacy!==F.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}S.fromServiceTunnel=n})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,f.createDecorator)("IExtHostTunnelService");let _=class{constructor(P){this.onDidChangeTunnels=new C.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,n){return{dispose:()=>{}}}async $providePortAttributes(P,n,k,a,m){return[]}async $forwardPort(P,n){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};_=je([He(0,y.IExtHostRpcService)],_),e.ExtHostTunnelService=_});var st=this&&this.__classPrivateFieldSet||function(Y,e,f,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,f):C?C.value=f:e.set(Y,f),f},Ne=this&&this.__classPrivateFieldGet||function(Y,e,f,F){if(f==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?F:f==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[7],me([0,1,16,18,100,24,103,12,2,32,43,122]),function(Y,e,f,F,C,y,A,_,S,P,n,k){"use strict";var a,m,d,v,D,I,b,l,o,g,t,u,r,i,s,c,h,w,E,p;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function T(q){function W(){return Reflect.construct(q,arguments,this.constructor)}return Object.defineProperty(W,"name",Object.getOwnPropertyDescriptor(q,"name")),Object.setPrototypeOf(W,q),Object.setPrototypeOf(W.prototype,q.prototype),W}let L=D=class{constructor(W){a.set(this,void 0),st(this,a,W,"f")}static from(...W){let oe=W;return new D(function(){if(oe){for(const Ce of oe)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();oe=void 0}})}dispose(){typeof Ne(this,a,"f")=="function"&&(Ne(this,a,"f").call(this),st(this,a,void 0,"f"))}};a=new WeakMap,L=D=je([T],L),e.Disposable=L;let M=I=class{constructor(W,oe){if(W<0)throw(0,F.illegalArgument)("line must be non-negative");if(oe<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=W,this._character=oe}static Min(...W){if(W.length===0)throw new TypeError;let oe=W[0];for(let Ce=1;Ce<W.length;Ce++){const Ze=W[Ce];Ze.isBefore(oe)&&(oe=Ze)}return oe}static Max(...W){if(W.length===0)throw new TypeError;let oe=W[0];for(let Ce=1;Ce<W.length;Ce++){const Ze=W[Ce];Ze.isAfter(oe)&&(oe=Ze)}return oe}static isPosition(W){if(!W)return!1;if(W instanceof I)return!0;let{line:oe,character:Ce}=W;return typeof oe=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<W._character}isBeforeOrEqual(W){return this._line<W._line?!0:W._line<this._line?!1:this._character<=W._character}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this._line===W._line&&this._character===W._character}compareTo(W){return this._line<W._line?-1:this._line>W.line?1:this._character<W._character?-1:this._character>W._character?1:0}translate(W,oe=0){if(W===null||oe===null)throw(0,F.illegalArgument)();let Ce;return typeof W=="undefined"?Ce=0:typeof W=="number"?Ce=W:(Ce=typeof W.lineDelta=="number"?W.lineDelta:0,oe=typeof W.characterDelta=="number"?W.characterDelta:0),Ce===0&&oe===0?this:new I(this.line+Ce,this.character+oe)}with(W,oe=this.character){if(W===null||oe===null)throw(0,F.illegalArgument)();let Ce;return typeof W=="undefined"?Ce=this.line:typeof W=="number"?Ce=W:(Ce=typeof W.line=="number"?W.line:this.line,oe=typeof W.character=="number"?W.character:this.character),Ce===this.line&&oe===this.character?this:new I(Ce,oe)}toJSON(){return{line:this.line,character:this.character}}};M=I=je([T],M),e.Position=M;let R=b=class{constructor(W,oe,Ce,Ze){let at,ht;if(typeof W=="number"&&typeof oe=="number"&&typeof Ce=="number"&&typeof Ze=="number"?(at=new M(W,oe),ht=new M(Ce,Ze)):W instanceof M&&oe instanceof M&&(at=W,ht=oe),!at||!ht)throw new Error("Invalid arguments");at.isBefore(ht)?(this._start=at,this._end=ht):(this._start=ht,this._end=at)}static isRange(W){return W instanceof b?!0:W?M.isPosition(W.start)&&M.isPosition(W.end):!1}get start(){return this._start}get end(){return this._end}contains(W){return W instanceof b?this.contains(W._start)&&this.contains(W._end):W instanceof M?!(W.isBefore(this._start)||this._end.isBefore(W)):!1}isEqual(W){return this._start.isEqual(W._start)&&this._end.isEqual(W._end)}intersection(W){const oe=M.Max(W.start,this._start),Ce=M.Min(W.end,this._end);if(!oe.isAfter(Ce))return new b(oe,Ce)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const oe=M.Min(W.start,this._start),Ce=M.Max(W.end,this.end);return new b(oe,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(W,oe=this.end){if(W===null||oe===null)throw(0,F.illegalArgument)();let Ce;return W?M.isPosition(W)?Ce=W:(Ce=W.start||this.start,oe=W.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&oe.isEqual(this.end)?this:new b(Ce,oe)}toJSON(){return[this.start,this.end]}};R=b=je([T],R),e.Range=R;let $=l=class extends R{constructor(W,oe,Ce,Ze){let at,ht;if(typeof W=="number"&&typeof oe=="number"&&typeof Ce=="number"&&typeof Ze=="number"?(at=new M(W,oe),ht=new M(Ce,Ze)):W instanceof M&&oe instanceof M&&(at=W,ht=oe),!at||!ht)throw new Error("Invalid arguments");super(at,ht);this._anchor=at,this._active=ht}static isSelection(W){return W instanceof l?!0:W?R.isRange(W)&&M.isPosition(W.anchor)&&M.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};$=l=je([T],$),e.Selection=$;class z{constructor(W,oe,Ce){if(typeof W!="string"||W.length===0)throw(0,F.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,F.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,F.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(oe),this.connectionToken=Ce}}e.ResolvedAuthority=z;class O extends Error{constructor(W,oe=k.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(W);this._message=W,this._code=oe,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,O.prototype)}static NotAvailable(W,oe){return new O(W,k.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(W){return new O(W,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=O;var V;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var N;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(N=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let U=o=class{constructor(W,oe){this._range=W,this._newText=oe}static isTextEdit(W){return W instanceof o?!0:W?R.isRange(W)&&typeof W.newText=="string":!1}static replace(W,oe){return new o(W,oe)}static insert(W,oe){return o.replace(new R(W,W),oe)}static delete(W){return o.replace(W,"")}static setEndOfLine(W){const oe=new o(new R(new M(0,0),new M(0,0)),"");return oe.newEol=W,oe}get range(){return this._range}set range(W){if(W&&!R.isRange(W))throw(0,F.illegalArgument)("range");this._range=W}get newText(){return this._newText||""}set newText(W){if(W&&typeof W!="string")throw(0,F.illegalArgument)("newText");this._newText=W}get newEol(){return this._newEol}set newEol(W){if(W&&typeof W!="number")throw(0,F.illegalArgument)("newEol");this._newEol=W}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};U=o=je([T],U),e.TextEdit=U;var x;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace"})(x=e.FileEditType||(e.FileEditType={}));let B=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(W,oe,Ce,Ze){this._edits.push({_type:1,from:W,to:oe,options:Ce,metadata:Ze})}createFile(W,oe,Ce){this._edits.push({_type:1,from:void 0,to:W,options:oe,metadata:Ce})}deleteFile(W,oe,Ce){this._edits.push({_type:1,from:W,to:void 0,options:oe,metadata:Ce})}replaceNotebookMetadata(W,oe,Ce){this._edits.push({_type:3,metadata:Ce,uri:W,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells(W,oe,Ce,Ze,at){let ht,gt,It=[],At;if(zt.isNotebookRange(oe)&&Ft.isNotebookCellDataArray(Ce)&&!Ft.isNotebookCellDataArray(Ze)?(ht=oe.start,gt=oe.end,It=Ce,At=Ze):typeof oe=="number"&&typeof Ce=="number"&&Ft.isNotebookCellDataArray(Ze)&&(ht=oe,gt=Ce,It=Ze,At=at),ht===void 0||gt===void 0)throw new Error("Invalid arguments");(ht!==gt||It.length>0)&&this._edits.push({_type:5,uri:W,index:ht,count:gt-ht,cells:It,metadata:At})}replaceNotebookCellMetadata(W,oe,Ce,Ze){this._edits.push({_type:3,metadata:Ze,uri:W,edit:{editType:8,index:oe,metadata:Ce}})}replace(W,oe,Ce,Ze){this._edits.push({_type:2,uri:W,edit:new U(oe,Ce),metadata:Ze})}insert(W,oe,Ce,Ze){this.replace(W,new R(oe,oe),Ce,Ze)}delete(W,oe,Ce){this.replace(W,oe,"",Ce)}has(W){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===W.toString())}set(W,oe){if(oe)for(const Ce of oe)Ce&&this._edits.push({_type:2,uri:W,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const Ze=this._edits[Ce];Ze._type===2&&Ze.uri.toString()===W.toString()&&(this._edits[Ce]=void 0)}(0,f.coalesceInPlace)(this._edits)}}get(W){const oe=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===W.toString()&&oe.push(Ce.edit);return oe}entries(){const W=new y.ResourceMap;for(let oe of this._edits)if(oe._type===2){let Ce=W.get(oe.uri);Ce||(Ce=[oe.uri,[]],W.set(oe.uri,Ce)),Ce[1].push(oe.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};B=je([T],B),e.WorkspaceEdit=B;let H=g=class{constructor(W){this._tabstop=1,this.value=W||""}static isSnippetString(W){return W instanceof g?!0:W?typeof W.value=="string":!1}static _escape(W){return W.replace(/\$|}|\\/g,"\\$&")}appendText(W){return this.value+=g._escape(W),this}appendTabstop(W=this._tabstop++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,oe=this._tabstop++){if(typeof W=="function"){const Ce=new g;Ce._tabstop=this._tabstop,W(Ce),this._tabstop=Ce._tabstop,W=Ce.value}else W=g._escape(W);return this.value+="${",this.value+=oe,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,oe=this._tabstop++){const Ce=W.map(Ze=>Ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(W,oe){if(typeof oe=="function"){const Ce=new g;Ce._tabstop=this._tabstop,oe(Ce),this._tabstop=Ce._tabstop,oe=Ce.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};H=g=je([T],H),e.SnippetString=H;var G;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(G=e.DiagnosticTag||(e.DiagnosticTag={}));var K;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(K=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let X=t=class{constructor(W,oe){if(this.uri=W,oe)if(oe instanceof R)this.range=oe;else if(oe instanceof M)this.range=new R(oe,oe);else throw new Error("Illegal argument")}static isLocation(W){return W instanceof t?!0:W?R.isRange(W.range)&&S.URI.isUri(W.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};X=t=je([T],X),e.Location=X;let de=class{constructor(W,oe){this.location=W,this.message=oe}static is(W){return W?typeof W.message=="string"&&W.location&&R.isRange(W.location.range)&&S.URI.isUri(W.location.uri):!1}static isEqual(W,oe){return W===oe?!0:!W||!oe?!1:W.message===oe.message&&W.location.range.isEqual(oe.location.range)&&W.location.uri.toString()===oe.location.uri.toString()}};de=je([T],de),e.DiagnosticRelatedInformation=de;let be=class{constructor(W,oe,Ce=K.Error){if(!R.isRange(W))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=W,this.message=oe,this.severity=Ce}toJSON(){return{severity:K[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,oe){return W===oe?!0:!W||!oe?!1:W.message===oe.message&&W.severity===oe.severity&&W.code===oe.code&&W.severity===oe.severity&&W.source===oe.source&&W.range.isEqual(oe.range)&&(0,f.equals)(W.tags,oe.tags)&&(0,f.equals)(W.relatedInformation,oe.relatedInformation,de.isEqual)}};be=je([T],be),e.Diagnostic=be;let Se=class{constructor(W,oe){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=oe}};Se=je([T],Se),e.Hover=Se;var Ie;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(Ie=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Oe=class{constructor(W,oe=Ie.Text){this.range=W,this.kind=oe}toJSON(){return{range:this.range,kind:Ie[this.kind]}}};Oe=je([T],Oe),e.DocumentHighlight=Oe;var xe;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(xe=e.SymbolKind||(e.SymbolKind={}));var ze;(function(q){q[q.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let j=u=class{constructor(W,oe,Ce,Ze,at){this.name=W,this.kind=oe,this.containerName=at,typeof Ce=="string"&&(this.containerName=Ce),Ze instanceof X?this.location=Ze:Ce instanceof R&&(this.location=new X(Ze,Ce)),u.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:xe[this.kind],location:this.location,containerName:this.containerName}}};j=u=je([T],j),e.SymbolInformation=j;let ee=r=class{constructor(W,oe,Ce,Ze,at){this.name=W,this.detail=oe,this.kind=Ce,this.range=Ze,this.selectionRange=at,this.children=[],r.validate(this)}static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children&&W.children.forEach(r.validate)}};ee=r=je([T],ee),e.DocumentSymbol=ee;var re;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(re=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(W,oe){this.title=W,this.kind=oe}};le=je([T],le),e.CodeAction=le;let Z=i=class{constructor(W){this.value=W}append(W){return new i(this.value?this.value+i.sep+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+i.sep)}};Z.sep=".",Z=i=je([T],Z),e.CodeActionKind=Z,Z.Empty=new Z(""),Z.QuickFix=Z.Empty.append("quickfix"),Z.Refactor=Z.Empty.append("refactor"),Z.RefactorExtract=Z.Refactor.append("extract"),Z.RefactorInline=Z.Refactor.append("inline"),Z.RefactorRewrite=Z.Refactor.append("rewrite"),Z.Source=Z.Empty.append("source"),Z.SourceOrganizeImports=Z.Source.append("organizeImports"),Z.SourceFixAll=Z.Source.append("fixAll");let ae=class{constructor(W,oe){if(this.range=W,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ae=je([T],ae),e.SelectionRange=ae;class pe{constructor(W,oe,Ce,Ze,at,ht){this.kind=W,this.name=oe,this.detail=Ce,this.uri=Ze,this.range=at,this.selectionRange=ht}}e.CallHierarchyItem=pe;class Me{constructor(W,oe){this.fromRanges=oe,this.from=W}}e.CallHierarchyIncomingCall=Me;class qe{constructor(W,oe){this.fromRanges=oe,this.to=W}}e.CallHierarchyOutgoingCall=qe;var Qe;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Je=class{constructor(W,oe){this.range=W,this.command=oe}get isResolved(){return!!this.command}};Je=je([T],Je),e.CodeLens=Je;let rt=s=class{constructor(W,oe=!1){m.set(this,void 0),st(this,m,new C.MarkdownString(W,{supportThemeIcons:oe}),"f")}static isMarkdownString(W){return W instanceof s?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}get value(){return Ne(this,m,"f").value}set value(W){Ne(this,m,"f").value=W}get isTrusted(){return Ne(this,m,"f").isTrusted}set isTrusted(W){Ne(this,m,"f").isTrusted=W}get supportThemeIcons(){return Ne(this,m,"f").supportThemeIcons}set supportThemeIcons(W){Ne(this,m,"f").supportThemeIcons=W}get supportHtml(){return Ne(this,m,"f").supportHtml}set supportHtml(W){Ne(this,m,"f").supportHtml=W}appendText(W){return Ne(this,m,"f").appendText(W),this}appendMarkdown(W){return Ne(this,m,"f").appendMarkdown(W),this}appendCodeblock(W,oe){return Ne(this,m,"f").appendCodeblock(oe??"",W),this}};m=new WeakMap,rt=s=je([T],rt),e.MarkdownString=rt;let Ae=class{constructor(W,oe){this.label=W,this.documentation=oe}};Ae=je([T],Ae),e.ParameterInformation=Ae;let nt=class{constructor(W,oe){this.label=W,this.documentation=oe,this.parameters=[]}};nt=je([T],nt),e.SignatureInformation=nt;let J=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};J=je([T],J),e.SignatureHelp=J;var te;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(te=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ve;(function(q){q[q.Other=0]="Other",q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(ve=e.InlayHintKind||(e.InlayHintKind={}));let Xe=class{constructor(W,oe,Ce){this.text=W,this.position=oe,this.kind=Ce}};Xe=je([T],Xe),e.InlayHint=Xe;var tt;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(tt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ct;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(ct=e.CompletionItemKind||(e.CompletionItemKind={}));var ut;(function(q){q[q.Deprecated=1]="Deprecated"})(ut=e.CompletionItemTag||(e.CompletionItemTag={}));let _t=class{constructor(W,oe){this.label=W,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&ct[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};_t=je([T],_t),e.CompletionItem=_t;let ce=class{constructor(W=[],oe=!1){this.items=W,this.isIncomplete=oe}};ce=je([T],ce),e.CompletionList=ce;let Pe=class{constructor(W,oe,Ce){this.text=W,this.range=oe,this.command=Ce}};Pe=je([T],Pe),e.InlineSuggestion=Pe;let We=class{constructor(W){this.items=W}};We=je([T],We),e.InlineSuggestions=We;var Ye;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(Ye=e.ViewColumn||(e.ViewColumn={}));var $e;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})($e=e.StatusBarAlignment||(e.StatusBarAlignment={}));var lt;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(lt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Te;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(Te=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var De;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(De=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ke;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ne;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(ne=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ue;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(ue=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function W(oe){switch(oe){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=W}(ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ee=class{constructor(W,oe){if(oe&&!S.URI.isUri(oe))throw(0,F.illegalArgument)("target");if(!R.isRange(W)||W.isEmpty)throw(0,F.illegalArgument)("range");this.range=W,this.target=oe}};Ee=je([T],Ee),e.DocumentLink=Ee;let we=class{constructor(W,oe,Ce,Ze){this.red=W,this.green=oe,this.blue=Ce,this.alpha=Ze}};we=je([T],we),e.Color=we;let Fe=class{constructor(W,oe){if(oe&&!(oe instanceof we))throw(0,F.illegalArgument)("color");if(!R.isRange(W)||W.isEmpty)throw(0,F.illegalArgument)("range");this.range=W,this.color=oe}};Fe=je([T],Fe),e.ColorInformation=Fe;let Ge=class{constructor(W){if(!W||typeof W!="string")throw(0,F.illegalArgument)("label");this.label=W}};Ge=je([T],Ge),e.ColorPresentation=Ge;var Ve;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Ve=e.ColorFormat||(e.ColorFormat={}));var et;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(et=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ot{constructor(W,oe,Ce){if(this.startIndex=W,this.length=oe,this.tooltip=Ce,typeof W!="number"||W<0)throw(0,F.illegalArgument)("startIndex");if(typeof oe!="number"||oe<1)throw(0,F.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=ot;var Be;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(Be=e.TerminalLocation||(e.TerminalLocation={}));class ge{constructor(W){this.options=W,typeof W!="object"&&(0,F.illegalArgument)("options")}}e.TerminalProfile=ge;var _e;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(_e=e.TaskRevealKind||(e.TaskRevealKind={}));var ie;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(ie=e.TaskPanelKind||(e.TaskPanelKind={}));let Q=c=class{constructor(W,oe){if(this.label=oe,typeof W!="string"||typeof oe!="string")throw(0,F.illegalArgument)("name");this._id=W}static from(W){switch(W){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};Q.Clean=new c("clean","Clean"),Q.Build=new c("build","Build"),Q.Rebuild=new c("rebuild","Rebuild"),Q.Test=new c("test","Test"),Q=c=je([T],Q),e.TaskGroup=Q;function ye(q){let W="";for(let oe=0;oe<q.length;oe++)W+=q[oe].replace(/,/g,",,")+",";return W}let Le=class{constructor(W,oe,Ce){if(typeof W!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=W,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=Ce):this._options=oe)}get process(){return this._process}set process(W){if(typeof W!="string")throw(0,F.illegalArgument)("process");this._process=W}get args(){return this._args}set args(W){Array.isArray(W)||(W=[]),this._args=W}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("process"),this._process!==void 0&&W.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)W.push(oe);return ye(W)}};Le=je([T],Le),e.ProcessExecution=Le;let it=class{constructor(W,oe,Ce){if(this._args=[],Array.isArray(oe)){if(!W)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,F.illegalArgument)("command");this._command=W,this._args=oe,this._options=Ce}else{if(typeof W!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=W,this._options=oe}}get commandLine(){return this._commandLine}set commandLine(W){if(typeof W!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=W}get command(){return this._command?this._command:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,F.illegalArgument)("command");this._command=W}get args(){return this._args}set args(W){this._args=W||[]}get options(){return this._options}set options(W){this._options=W}computeId(){const W=[];if(W.push("shell"),this._commandLine!==void 0&&W.push(this._commandLine),this._command!==void 0&&W.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)W.push(typeof oe=="string"?oe:oe.value);return ye(W)}};it=je([T],it),e.ShellExecution=it;var Ke;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(Ke=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class bt{constructor(W){this._callback=W}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(W){this._callback=W}get callback(){return this._callback}}e.CustomExecution=bt;let ft=h=class{constructor(W,oe,Ce,Ze,at,ht){this.__deprecated=!1,this._definition=this.definition=W;let gt;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=Ce,this.execution=Ze,gt=at,this.__deprecated=!0):oe===pt.Global||oe===pt.Workspace?(this.target=oe,this._name=this.name=Ce,this._source=this.source=Ze,this.execution=at,gt=ht):(this.target=oe,this._name=this.name=Ce,this._source=this.source=Ze,this.execution=at,gt=ht),typeof gt=="string"?(this._problemMatchers=[gt],this._hasDefinedMatchers=!0):Array.isArray(gt)?(this._problemMatchers=gt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(W){this.__id=W}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Le?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof it?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof bt?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(W){if(W==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=W}get scope(){return this._scope}set target(W){this.clear(),this._scope=W}get name(){return this._name}set name(W){if(typeof W!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=W}get execution(){return this._execution}set execution(W){W===null&&(W=void 0),this.clear(),this._execution=W;const oe=this._definition.type;(h.EmptyType===oe||h.ProcessType===oe||h.ShellType===oe||h.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(W){if(Array.isArray(W))this.clear(),this._problemMatchers=W,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.clear(),this._isBackground=W}get source(){return this._source}set source(W){if(typeof W!="string"||W.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=W}get group(){return this._group}set group(W){W===null&&(W=void 0),this.clear(),this._group=W}get detail(){return this._detail}set detail(W){W===null&&(W=void 0),this._detail=W}get presentationOptions(){return this._presentationOptions}set presentationOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._presentationOptions=W}get runOptions(){return this._runOptions}set runOptions(W){W==null&&(W=Object.create(null)),this.clear(),this._runOptions=W}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=h=je([T],ft),e.Task=ft;var wt;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(wt=e.ProgressLocation||(e.ProgressLocation={}));let mt=class{constructor(W,oe=Et.None){this.collapsibleState=oe,S.URI.isUri(W)?this.resourceUri=W:this.label=W}};mt=je([T],mt),e.TreeItem=mt;var Et;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(Et=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Dt=class{constructor(W,oe){this.id=W,this.color=oe}};Dt=je([T],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let xt=class{constructor(W){this.id=W}};xt=je([T],xt),e.ThemeColor=xt;var Vt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(Vt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(W,oe){if(typeof W!="string"&&(!W||!S.URI.isUri(W)&&!S.URI.isUri(W.uri)))throw(0,F.illegalArgument)("base");if(typeof oe!="string")throw(0,F.illegalArgument)("pattern");typeof W=="string"?(this.baseFolder=S.URI.file(W),this.base=W):S.URI.isUri(W)?(this.baseFolder=W,this.base=W.fsPath):(this.baseFolder=W.uri,this.base=W.uri.fsPath),this.pattern=oe}};kt=je([T],kt),e.RelativePattern=kt;let $t=class{constructor(W,oe,Ce,Ze){this.enabled=typeof W=="boolean"?W:!0,typeof oe=="string"&&(this.condition=oe),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};$t=je([T],$t),e.Breakpoint=$t;let en=class extends $t{constructor(W,oe,Ce,Ze,at){super(oe,Ce,Ze,at);if(W===null)throw(0,F.illegalArgument)("location");this.location=W}};en=je([T],en),e.SourceBreakpoint=en;let St=class extends $t{constructor(W,oe,Ce,Ze,at){super(oe,Ce,Ze,at);this.functionName=W}};St=je([T],St),e.FunctionBreakpoint=St;let Qt=class extends $t{constructor(W,oe,Ce,Ze,at,ht,gt){super(Ze,at,ht,gt);if(!oe)throw(0,F.illegalArgument)("dataId");this.label=W,this.dataId=oe,this.canPersist=Ce}};Qt=je([T],Qt),e.DataBreakpoint=Qt;let jt=class{constructor(W,oe,Ce){this.command=W,this.args=oe||[],this.options=Ce}};jt=je([T],jt),e.DebugAdapterExecutable=jt;let tn=class{constructor(W,oe){this.port=W,this.host=oe}};tn=je([T],tn),e.DebugAdapterServer=tn;let nn=class{constructor(W){this.path=W}};nn=je([T],nn),e.DebugAdapterNamedPipeServer=nn;let Tt=class{constructor(W){this.implementation=W}};Tt=je([T],Tt),e.DebugAdapterInlineImplementation=Tt;let Xt=class{constructor(W,oe){this.range=W,this.expression=oe}};Xt=je([T],Xt),e.EvaluatableExpression=Xt;var bn;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})(bn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(W,oe){this.range=W,this.text=oe}};Wt=je([T],Wt),e.InlineValueText=Wt;let Ht=class{constructor(W,oe,Ce=!0){this.range=W,this.variableName=oe,this.caseSensitiveLookup=Ce}};Ht=je([T],Ht),e.InlineValueVariableLookup=Ht;let vt=class{constructor(W,oe){this.range=W,this.expression=oe}};vt=je([T],vt),e.InlineValueEvaluatableExpression=vt;let rn=class{constructor(W,oe){this.frameId=W,this.stoppedLocation=oe}};rn=je([T],rn),e.InlineValueContext=rn;var Ot;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=w=class extends Error{constructor(W,oe=n.FileSystemProviderErrorCode.Unknown,Ce){super(S.URI.isUri(W)?W.toString(!0):W);this.code=Ce?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(W){return new w(W,n.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(W){return new w(W,n.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(W){return new w(W,n.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(W){return new w(W,n.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(W){return new w(W,n.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(W){return new w(W,n.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}};Nt=w=je([T],Nt),e.FileSystemError=Nt;let Yt=class{constructor(W,oe,Ce){this.start=W,this.end=oe,this.kind=Ce}};Yt=je([T],Yt),e.FoldingRange=Yt;var En;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class mn{constructor(W,oe=[]){this.tokenTypes=W,this.tokenModifiers=oe}}e.SemanticTokensLegend=mn;function sn(q){return typeof q=="undefined"||(0,_.isStringArray)(q)}class on{constructor(W){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,W){this._hasLegend=!0;for(let oe=0,Ce=W.tokenTypes.length;oe<Ce;oe++)this._tokenTypeStrToInt.set(W.tokenTypes[oe],oe);for(let oe=0,Ce=W.tokenModifiers.length;oe<Ce;oe++)this._tokenModifierStrToInt.set(W.tokenModifiers[oe],oe)}}push(W,oe,Ce,Ze,at){if(typeof W=="number"&&typeof oe=="number"&&typeof Ce=="number"&&typeof Ze=="number"&&(typeof at=="number"||typeof at=="undefined"))return typeof at=="undefined"&&(at=0),this._pushEncoded(W,oe,Ce,Ze,at);if(R.isRange(W)&&typeof oe=="string"&&sn(Ce))return this._push(W,oe,Ce);throw(0,F.illegalArgument)()}_push(W,oe,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ze=W.start.line,at=W.start.character,ht=W.end.character-W.start.character,gt=this._tokenTypeStrToInt.get(oe);let It=0;if(Ce)for(const At of Ce){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(At);It|=1<<Lt>>>0}this._pushEncoded(Ze,at,ht,gt,It)}_pushEncoded(W,oe,Ce,Ze,at){if(this._dataIsSortedAndDeltaEncoded&&(W<this._prevLine||W===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const It=this._data.length/5|0;let At=0,Lt=0;for(let Mt=0;Mt<It;Mt++){let Ut=this._data[5*Mt],dn=this._data[5*Mt+1];Ut===0?(Ut=At,dn+=Lt):Ut+=At,this._data[5*Mt]=Ut,this._data[5*Mt+1]=dn,At=Ut,Lt=dn}}let ht=W,gt=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ht-=this._prevLine,ht===0&&(gt-=this._prevChar)),this._data[this._dataLen++]=ht,this._data[this._dataLen++]=gt,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=at,this._prevLine=W,this._prevChar=oe}static _sortAndDeltaEncode(W){let oe=[];const Ce=W.length/5|0;for(let gt=0;gt<Ce;gt++)oe[gt]=gt;oe.sort((gt,It)=>{const At=W[5*gt],Lt=W[5*It];if(At===Lt){const Mt=W[5*gt+1],Ut=W[5*It+1];return Mt-Ut}return At-Lt});const Ze=new Uint32Array(W.length);let at=0,ht=0;for(let gt=0;gt<Ce;gt++){const It=5*oe[gt],At=W[It+0],Lt=W[It+1],Mt=W[It+2],Ut=W[It+3],dn=W[It+4],Bn=At-at,Gn=Bn===0?Lt-ht:Lt,hn=5*gt;Ze[hn+0]=Bn,Ze[hn+1]=Gn,Ze[hn+2]=Mt,Ze[hn+3]=Ut,Ze[hn+4]=dn,at=At,ht=Lt}return Ze}build(W){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),W):new qt(on._sortAndDeltaEncode(this._data),W)}}e.SemanticTokensBuilder=on;class qt{constructor(W,oe){this.resultId=oe,this.data=W}}e.SemanticTokens=qt;class an{constructor(W,oe,Ce){this.start=W,this.deleteCount=oe,this.data=Ce}}e.SemanticTokensEdit=an;class Sn{constructor(W,oe){this.resultId=oe,this.edits=W}}e.SemanticTokensEdits=Sn;var yn;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(q){q[q.Initial=1]="Initial",q[q.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Jt=class{constructor(){}};Jt.Back={iconPath:new Dt("arrow-left")},Jt=je([T],Jt),e.QuickInputButtons=Jt;var Dn;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(W,oe,Ce){this.badge=W,this.tooltip=oe,this.color=Ce}static validate(W){if(W.badge&&W.badge.length!==1&&W.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let ln=class{constructor(W){this.kind=W}};ln=je([T],ln),e.ColorTheme=ln;var cn;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast"})(cn=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(W,oe){if(W<0)throw(0,F.illegalArgument)("start must be positive");if(oe<0)throw(0,F.illegalArgument)("end must be positive");W<=oe?(this._start=W,this._end=oe):(this._start=oe,this._end=W)}static isNotebookRange(W){return W instanceof zt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(W){let oe=this._start,Ce=this._end;return W.start!==void 0&&(oe=W.start),W.end!==void 0&&(Ce=W.end),oe===this._start&&Ce===this._end?this:new zt(oe,Ce)}}e.NotebookRange=zt;class Ft{constructor(W,oe,Ce,Ze,at,ht,gt){this.kind=W,this.value=oe,this.languageId=Ce,this.mime=Ze,this.outputs=at??[],this.metadata=ht,this.executionSummary=gt,Ft.validate(this)}static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(oe=>Ft.isNotebookCellData(oe))}static isNotebookCellData(W){return!0}}e.NotebookCellData=Ft;class Ue{constructor(W){this.cells=W}}e.NotebookData=Ue;class Rt{constructor(W,oe){this.data=W,this.mime=oe;const Ce=(0,A.normalizeMimeType)(oe,!0);if(!Ce)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}static isNotebookCellOutputItem(W){return W instanceof Rt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const oe={name:W.name,message:W.message,stack:W.stack};return Rt.json(oe,"application/vnd.code.notebook.error")}static stdout(W){return Rt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Rt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,oe="application/octet-stream"){return new Rt(W,oe)}static text(W,oe=A.Mimes.text){const Ce=Ne(Rt,d,"f",v).encode(String(W));return new Rt(Ce,oe)}static json(W,oe="application/json"){const Ce=JSON.stringify(W,void 0,"	");return Rt.text(Ce,oe)}}e.NotebookCellOutputItem=Rt,d=Rt,v={value:new TextEncoder};class Kt{constructor(W,oe,Ce){this.items=Kt.ensureUniqueMimeTypes(W,!0),typeof oe=="string"?(this.id=oe,this.metadata=Ce):(this.id=(0,P.generateUuid)(),this.metadata=oe??Ce)}static isNotebookCellOutput(W){return W instanceof Kt?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&(0,_.isArray)(W.items)}static ensureUniqueMimeTypes(W,oe=!1){const Ce=new Set,Ze=new Set;for(let at=0;at<W.length;at++){const ht=W[at],gt=(0,A.normalizeMimeType)(ht.mime);if(!Ce.has(gt)){Ce.add(gt);continue}Ze.add(at),oe&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Ze.size===0?W:W.filter((at,ht)=>!Ze.has(ht))}}e.NotebookCellOutput=Kt;var yt;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(yt=e.NotebookCellKind||(e.NotebookCellKind={}));var kn;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(kn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var In;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(In=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gn;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(gn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pn{constructor(W,oe){this.text=W,this.alignment=oe}}e.NotebookCellStatusBarItem=pn;var Pn;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(Pn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Tn{constructor(W,oe=[]){this.uri=W,this.provides=(0,f.asArray)(oe)}}e.NotebookRendererScript=Tn;let un=class{constructor(W,oe){this.label=W,this.timestamp=oe}};un=je([T],un),e.TimelineItem=un;var An;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(An=e.ExtensionMode||(e.ExtensionMode={}));var vn;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(vn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rn;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=4]="RegEx"})(Rn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor(W,oe){this.ranges=W,this.wordPattern=oe}}e.LinkedEditingRanges=Ln;class Fn{constructor(W,oe){this._port=W,this._autoForwardAction=oe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var Mn;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(Mn=e.TestResultState||(e.TestResultState={}));var On;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(On=e.TestRunProfileKind||(e.TestRunProfileKind={}));let se=class{constructor(W,oe,Ce){this.include=W,this.exclude=oe,this.profile=Ce}};se=je([T],se),e.TestRunRequest=se;let he=E=class{constructor(W){this.message=W}static diff(W,oe,Ce){const Ze=new E(W);return Ze.expectedOutput=oe,Ze.actualOutput=Ce,Ze}};he=E=je([T],he),e.TestMessage=he;let Re=class{constructor(W){this.id=W}};Re=je([T],Re),e.TestTag=Re;let dt=class{constructor(W,oe){this.covered=W,this.total=oe}};dt=je([T],dt),e.CoveredCount=dt;let Ct=p=class{constructor(W,oe,Ce,Ze){this.uri=W,this.statementCoverage=oe,this.branchCoverage=Ce,this.functionCoverage=Ze}static fromDetails(W,oe){const Ce=new dt(0,0),Ze=new dt(0,0),at=new dt(0,0);for(const gt of oe)if("branches"in gt){Ce.total+=1,Ce.covered+=gt.executionCount>0?1:0;for(const It of gt.branches)Ze.total+=1,Ze.covered+=It.executionCount>0?1:0}else at.total+=1,at.covered+=gt.executionCount>0?1:0;const ht=new p(W,Ce,Ze.total>0?Ze:void 0,at.total>0?at:void 0);return ht.detailedCoverage=oe,ht}};Ct=p=je([T],Ct),e.FileCoverage=Ct;let Pt=class{constructor(W,oe,Ce=[]){this.executionCount=W,this.location=oe,this.branches=Ce}};Pt=je([T],Pt),e.StatementCoverage=Pt;let Nn=class{constructor(W,oe){this.executionCount=W,this.location=oe}};Nn=je([T],Nn),e.BranchCoverage=Nn;let Un=class{constructor(W,oe){this.executionCount=W,this.location=oe}};Un=je([T],Un),e.FunctionCoverage=Un;var zn;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(zn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vn;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(Vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var jn;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(jn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qn{constructor(W,oe,Ce,Ze,at,ht){this.kind=W,this.name=oe,this.detail=Ce,this.uri=Ze,this.range=at,this.selectionRange=ht}}e.TypeHierarchyItem=qn}),define(fe[125],me([0,1,57,10,9,151,111,7,16]),function(Y,e,f,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function n(d,v){v?P.set(d,v):P.delete(d)}e.setWordDefinitionFor=n;function k(d){return P.get(d)}e.getWordDefinitionFor=k;class a extends y.MirrorTextModel{constructor(v,D,I,b,l,o,g,t){super(D,I,b,l);this._proxy=v,this._languageId=o,this._isDirty=g,this._notebook=t,this._isDisposed=!1}dispose(){(0,f.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(v){return(0,S.equals)(this._lines,v)}get document(){if(!this._document){const v=this;this._document={get uri(){return v._uri},get fileName(){return v._uri.fsPath},get isUntitled(){return v._uri.scheme===F.Schemas.untitled},get languageId(){return v._languageId},get version(){return v._versionId},get isClosed(){return v._isDisposed},get isDirty(){return v._isDirty},get notebook(){return v._notebook},save(){return v._save()},getText(D){return D?v._getTextInRange(D):v.getText()},get eol(){return v._eol===`
`?_.EndOfLine.LF:_.EndOfLine.CRLF},get lineCount(){return v._lines.length},lineAt(D){return v._lineAt(D)},offsetAt(D){return v._offsetAt(D)},positionAt(D){return v._positionAt(D)},validateRange(D){return v._validateRange(D)},validatePosition(D){return v._validatePosition(D)},getWordRangeAtPosition(D,I){return v._getWordRangeAtPosition(D,I)}}}return Object.freeze(this._document)}_acceptLanguageId(v){(0,f.ok)(!this._isDisposed),this._languageId=v}_acceptIsDirty(v){(0,f.ok)(!this._isDisposed),this._isDirty=v}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(v){const D=this._validateRange(v);if(D.isEmpty)return"";if(D.isSingleLine)return this._lines[D.start.line].substring(D.start.character,D.end.character);const I=this._eol,b=D.start.line,l=D.end.line,o=[];o.push(this._lines[b].substring(D.start.character));for(let g=b+1;g<l;g++)o.push(this._lines[g]);return o.push(this._lines[l].substring(0,D.end.character)),o.join(I)}_lineAt(v){let D;if(v instanceof _.Position?D=v.line:typeof v=="number"&&(D=v),typeof D!="number"||D<0||D>=this._lines.length||Math.floor(D)!==D)throw new Error("Illegal value for `line`");return new m(D,this._lines[D],D===this._lines.length-1)}_offsetAt(v){return v=this._validatePosition(v),this._ensureLineStarts(),this._lineStarts.getPrefixSum(v.line-1)+v.character}_positionAt(v){v=Math.floor(v),v=Math.max(0,v),this._ensureLineStarts();const D=this._lineStarts.getIndexOf(v),I=this._lines[D.index].length;return new _.Position(D.index,Math.min(D.remainder,I))}_validateRange(v){if(!(v instanceof _.Range))throw new Error("Invalid argument");const D=this._validatePosition(v.start),I=this._validatePosition(v.end);return D===v.start&&I===v.end?v:new _.Range(D.line,D.character,I.line,I.character)}_validatePosition(v){if(!(v instanceof _.Position))throw new Error("Invalid argument");if(this._lines.length===0)return v.with(0,0);let{line:D,character:I}=v,b=!1;if(D<0)D=0,I=0,b=!0;else if(D>=this._lines.length)D=this._lines.length-1,I=this._lines[D].length,b=!0;else{const l=this._lines[D].length;I<0?(I=0,b=!0):I>l&&(I=l,b=!0)}return b?new _.Position(D,I):v}_getWordRangeAtPosition(v,D){const I=this._validatePosition(v);if(!D)D=k(this._languageId);else if((0,C.regExpLeadsToEndlessLoop)(D))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${D.source}' because it matches the empty string.`);const b=(0,A.getWordAtText)(I.character+1,(0,A.ensureValidWordDefinition)(D),this._lines[I.line],0);if(b)return new _.Range(I.line,b.startColumn-1,I.line,b.endColumn-1)}}e.ExtHostDocumentData=a;class m{constructor(v,D,I){this._line=v,this._text=D,this._isLastLine=I}get lineNumber(){return this._line}get text(){return this._text}get range(){return new _.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new _.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(fe[204],me([0,1,7,3,113,6,81,24,2,32]),function(Y,e,f,F,C,y,A,_,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(a,m,d,v){this._notebook=d,this._selector=v,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(I=>{const b=this._cellUris.get(I.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const D=I=>{I===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(a.onDidChangeNotebookCells(I=>D(I.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new _.ResourceMap;const a=[],m=[];for(const d of this._notebook.getCells())d.kind===f.NotebookCellKind.Code&&(!this._selector||(0,A.score)(this._selector,d.document.uri,d.document.languageId,!0))&&(this._cellUris.set(d.document.uri,this._cells.length),this._cells.push(d),a.push(d.document.getText().length+1),m.push(d.document.lineCount));this._cellLengths=new C.PrefixSumComputer(new Uint32Array(a)),this._cellLines=new C.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(a){if(!a){let b="";for(const l of this._cells)b+=l.document.getText()+`
`;return b=b.slice(0,-1),b}if(a.isEmpty)return"";const m=this.locationAt(a.start),d=this.locationAt(a.end),v=this._cellUris.get(m.uri),D=this._cellUris.get(d.uri);if(v===void 0||D===void 0)return"";if(v===D)return this._cells[v].document.getText(new f.Range(m.range.start,d.range.end));const I=[this._cells[v].document.getText(new f.Range(m.range.start,new f.Position(this._cells[v].document.lineCount,0)))];for(let b=v+1;b<D;b++)I.push(this._cells[b].document.getText());return I.push(this._cells[D].document.getText(new f.Range(new f.Position(0,0),d.range.end))),I.join(`
`)}offsetAt(a){const m=this._cellLines.getIndexOf(a.line),d=this._cellLengths.getPrefixSum(m.index-1),v=this._cells[m.index].document.offsetAt(a.with(m.remainder));return d+v}positionAt(a){if(typeof a=="number"){const d=this._cellLengths.getIndexOf(a),v=this._cellLines.getPrefixSum(d.index-1);return this._cells[d.index].document.positionAt(d.remainder).translate(v)}const m=this._cellUris.get(a.uri);if(m!==void 0){const d=this._cellLines.getPrefixSum(m-1);return new f.Position(d+a.range.start.line,a.range.start.character)}return new f.Position(0,0)}locationAt(a){f.Range.isRange(a)||(a=new f.Range(a,a));const m=this._cellLines.getIndexOf(a.start.line);let d=m;a.isEmpty||(d=this._cellLines.getIndexOf(a.end.line));const v=new f.Position(m.remainder,a.start.character),D=new f.Position(d.remainder,a.end.character),I=new f.Range(v,D),b=this._cells[m.index];return new f.Location(b.document.uri,b.document.validateRange(I))}contains(a){return this._cellUris.has(a)}validateRange(a){const m=this.validatePosition(a.start),d=this.validatePosition(a.end);return a.with(m,d)}validatePosition(a){const m=this._cellLines.getIndexOf(a.line),d=new f.Position(m.remainder,a.character),v=this._cells[m.index].document.validatePosition(d),D=this._cellLines.getPrefixSum(m.index-1);return new f.Position(D+v.line,v.character)}}e.ExtHostNotebookConcatDocument=n}),define(fe[205],me([0,1,7,14,3]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(_){this._actual=new f.ColorTheme(f.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(_){let S=_==="light"?f.ColorThemeKind.Light:_==="dark"?f.ColorThemeKind.Dark:f.ColorThemeKind.HighContrast;this._actual=new f.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=je([He(0,F.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(fe[66],me([0,1,4]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,f.createDecorator)("IURITransformerService");class F{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=F}),define(fe[206],me([0,1,22]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(S){let P=this.buffers.indexOf(S);return P<0&&(P=this.buffers.length,this.buffers.push(S)),P}}function C(_,S){if(S.serializeBuffersForPostMessage){const P=new F,n=(m,d)=>{if(d instanceof ArrayBuffer){const v=P.add(d);return{$$vscode_array_buffer_reference$$:!0,index:v}}else if(ArrayBuffer.isView(d)){const v=y(d);if(v){const D=P.add(d.buffer);return{$$vscode_array_buffer_reference$$:!0,index:D,view:{type:v,byteLength:d.byteLength,byteOffset:d.byteOffset}}}}return d},k=JSON.stringify(_,n),a=P.buffers.map(m=>{const d=new Uint8Array(m);return f.VSBuffer.wrap(d)});return{message:k,buffers:a}}else return{message:JSON.stringify(_),buffers:[]}}e.serializeWebviewMessage=C;function y(_){switch(_.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(_,S){const P=S.map(a=>{const m=new ArrayBuffer(a.byteLength);return new Uint8Array(m).set(a.buffer),m}),n=S.length?(a,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const d=m,{index:v}=d,D=P[v];if(d.view)switch(d.view.type){case 1:return new Int8Array(D,d.view.byteOffset,d.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(D,d.view.byteOffset,d.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(D,d.view.byteOffset,d.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(D,d.view.byteOffset,d.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(D,d.view.byteOffset,d.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(D,d.view.byteOffset,d.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(D,d.view.byteOffset,d.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(D,d.view.byteOffset,d.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(D,d.view.byteOffset,d.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(D,d.view.byteOffset,d.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(D,d.view.byteOffset,d.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return D}return m}:void 0;return{message:JSON.parse(_,n),arrayBuffers:P}}e.deserializeWebviewMessage=A}),define(fe[207],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var f;(function(F){function C(A){const _={items:new Map};return A.types.forEach((S,P)=>{_.items.set(S,{asString:async()=>A.items[P].asString})}),_}F.toITreeDataTransfer=C;async function y(A){const _={types:[],items:[]},S=Array.from(A.items.entries());for(const P of S)_.types.push(P[0]),_.items.push({asString:await P[1].asString()});return _}F.toTreeDataTransferDTO=y})(f=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(fe[88],me([0,1,10,2]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function C(_,S){return _.scheme===f.Schemas.http||_.scheme===f.Schemas.https?_:(S&&S.authority&&S.isRemote&&_.scheme===f.Schemas.file&&(_=F.URI.from({scheme:f.Schemas.vscodeRemote,authority:S.authority,path:_.path})),F.URI.from({scheme:f.Schemas.https,authority:`${_.scheme}+${y(_.authority)}.${e.webviewRootResourceAuthority}`,path:_.path,fragment:_.fragment,query:_.query}))}e.asWebviewUri=C;function y(_){return _.replace(/./g,S=>{const P=S.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?S:"-"+P.toString(16).padStart(4,"0")})}function A(_){return _.replace(/-([0-9a-f]{4})/g,(S,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=A}),define(fe[208],me([0,1,3,6,88]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(_,S,P){this._proxy=_,this._editors=S,this._initData=P,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const n=S.getVisibleTextEditors();for(const k of this._insets.values())n.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(_=>_.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(_,S,P,n,k){let a;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===_){a=l;break}if(!a)throw new Error("not a visible editor");const m=this,d=this._handlePool++,v=new f.Emitter,D=new f.Emitter,I=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,C.asWebviewUri)(l,m._initData.remote)}get cspSource(){return C.webviewGenericCspSource}set options(l){this._options=l,m._proxy.$setOptions(d,l)}get options(){return this._options}set html(l){this._html=l,m._proxy.$setHtml(d,l)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(l){return m._proxy.$postMessage(d,l)}},b=new class{constructor(){this.editor=_,this.line=S,this.height=P,this.webview=I,this.onDidDispose=D.event}dispose(){m._insets.has(d)&&(m._insets.delete(d),m._proxy.$disposeEditorInset(d),D.fire(),D.dispose(),v.dispose())}};return this._proxy.$createEditorInset(d,a.id,a.value.document.uri,S+1,P,n||{},k.identifier,k.extensionLocation),this._insets.set(d,{editor:_,inset:b,onDidReceiveMessage:v}),b}$onDidDispose(_){const S=this._insets.get(_);S&&S.inset.dispose()}$onDidReceiveMessage(_,S){const P=this._insets.get(_);P&&P.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=y}),define(fe[209],me([0,1,174,12,2,6,4,63,34,16,10]),function(Y,e,f,F,C,y,A,_,S,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,f.localize)(0,null),providerDisplayName:(0,f.localize)(1,null)},e.ActiveEditorDirtyContext=new _.RawContextKey("activeEditorIsDirty",!1,(0,f.localize)(2,null)),e.ActiveEditorPinnedContext=new _.RawContextKey("activeEditorIsNotPreview",!1,(0,f.localize)(3,null)),e.ActiveEditorStickyContext=new _.RawContextKey("activeEditorIsPinned",!1,(0,f.localize)(4,null)),e.ActiveEditorReadonlyContext=new _.RawContextKey("activeEditorIsReadonly",!1,(0,f.localize)(5,null)),e.ActiveEditorCanRevertContext=new _.RawContextKey("activeEditorCanRevert",!1,(0,f.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new _.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new _.RawContextKey("activeEditor",null,{type:"string",description:(0,f.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new _.RawContextKey("activeEditorAvailableEditorIds","",(0,f.localize)(8,null)),e.TextCompareEditorVisibleContext=new _.RawContextKey("textCompareEditorVisible",!1,(0,f.localize)(9,null)),e.TextCompareEditorActiveContext=new _.RawContextKey("textCompareEditorActive",!1,(0,f.localize)(10,null)),e.SideBySideEditorActiveContext=new _.RawContextKey("sideBySideEditorActive",!1,(0,f.localize)(11,null)),e.EditorGroupEditorsCountContext=new _.RawContextKey("groupEditorsCount",0,(0,f.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new _.RawContextKey("activeEditorGroupEmpty",!1,(0,f.localize)(13,null)),e.ActiveEditorGroupIndexContext=new _.RawContextKey("activeEditorGroupIndex",0,(0,f.localize)(14,null)),e.ActiveEditorGroupLastContext=new _.RawContextKey("activeEditorGroupLast",!1,(0,f.localize)(15,null)),e.ActiveEditorGroupLockedContext=new _.RawContextKey("activeEditorGroupLocked",!1,(0,f.localize)(16,null)),e.MultipleEditorGroupsContext=new _.RawContextKey("multipleEditorGroups",!1,(0,f.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new _.RawContextKey("editorIsOpen",!1,(0,f.localize)(18,null)),e.InEditorZenModeContext=new _.RawContextKey("inZenMode",!1,(0,f.localize)(19,null)),e.IsCenteredLayoutContext=new _.RawContextKey("isCenteredLayout",!1,(0,f.localize)(20,null)),e.SplitEditorsVertically=new _.RawContextKey("splitEditorsVertically",!1,(0,f.localize)(21,null)),e.EditorAreaVisibleContext=new _.RawContextKey("editorAreaVisible",!0,(0,f.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function k(M,R,$){for(const z of $.visibleEditorPanes)if(z.group.id===R&&M.matches(z.input))return z.getViewState()}e.findViewStateForEditor=k;function a(M){if(o(M))return!1;const R=M;return C.URI.isUri(R?.resource)}e.isResourceEditorInput=a;function m(M){if(o(M))return!1;const R=M;return R?.original!==void 0&&R.modified!==void 0}e.isResourceDiffEditorInput=m;function d(M){if(o(M)||m(M))return!1;const R=M;return R?.primary!==void 0&&R.secondary!==void 0}e.isResourceSideBySideEditorInput=d;function v(M){if(o(M))return!1;const R=M;return R?R.resource===void 0||R.resource.scheme===n.Schemas.untitled||R.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=v;var D;(function(M){M[M.SHORT=0]="SHORT",M[M.MEDIUM=1]="MEDIUM",M[M.LONG=2]="LONG"})(D=e.Verbosity||(e.Verbosity={}));var I;(function(M){M[M.EXPLICIT=1]="EXPLICIT",M[M.AUTO=2]="AUTO",M[M.FOCUS_CHANGE=3]="FOCUS_CHANGE",M[M.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(I=e.SaveReason||(e.SaveReason={}));var b;(function(M){M[M.None=0]="None",M[M.Readonly=2]="Readonly",M[M.Untitled=4]="Untitled",M[M.Singleton=8]="Singleton",M[M.RequiresTrust=16]="RequiresTrust",M[M.CanSplitInGroup=32]="CanSplitInGroup",M[M.ForceDescription=64]="ForceDescription"})(b=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class l extends y.Disposable{}e.AbstractEditorInput=l;function o(M){return M instanceof l}e.isEditorInput=o;function g(M){const R=M;return C.URI.isUri(R?.preferredResource)}function t(M){const R=M;return o(R?.primary)&&o(R?.secondary)}e.isSideBySideEditorInput=t;function u(M){const R=M;return o(R?.modified)&&o(R?.original)}e.isDiffEditorInput=u;function r(M){return o(M?.editor)}e.isEditorInputWithOptions=r;function i(M){const R=M;return r(M)&&R?.group!==void 0}e.isEditorInputWithOptionsAndGroup=i;function s(M){const R=M;return typeof R?.groupId=="number"&&o(R.editor)}e.isEditorIdentifier=s;var c;(function(M){M[M.UNKNOWN=0]="UNKNOWN",M[M.REPLACE=1]="REPLACE",M[M.MOVE=2]="MOVE",M[M.UNPIN=3]="UNPIN"})(c=e.EditorCloseContext||(e.EditorCloseContext={}));var h;(function(M){M[M.PRIMARY=1]="PRIMARY",M[M.SECONDARY=2]="SECONDARY",M[M.BOTH=3]="BOTH",M[M.ANY=4]="ANY"})(h=e.SideBySideEditor||(e.SideBySideEditor={}));class w{getOriginalUri(R,$){if(!R)return;if($?.supportSideBySide){const{primary:O,secondary:V}=this.getSideEditors(R);if(O&&V){if($?.supportSideBySide===h.BOTH)return{primary:this.getOriginalUri(O,{filterByScheme:$.filterByScheme}),secondary:this.getOriginalUri(V,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===h.ANY)return this.getOriginalUri(O,{filterByScheme:$.filterByScheme})??this.getOriginalUri(V,{filterByScheme:$.filterByScheme});R=$.supportSideBySide===h.PRIMARY?O:V}}if(m(R)||d(R))return;const z=g(R)?R.preferredResource:R.resource;return!z||!$||!$.filterByScheme?z:this.filterUri(z,$.filterByScheme)}getSideEditors(R){return t(R)||d(R)?{primary:R.primary,secondary:R.secondary}:u(R)||m(R)?{primary:R.modified,secondary:R.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(R,$){if(!R)return;if($?.supportSideBySide){const{primary:O,secondary:V}=this.getSideEditors(R);if(O&&V){if($?.supportSideBySide===h.BOTH)return{primary:this.getCanonicalUri(O,{filterByScheme:$.filterByScheme}),secondary:this.getCanonicalUri(V,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===h.ANY)return this.getCanonicalUri(O,{filterByScheme:$.filterByScheme})??this.getCanonicalUri(V,{filterByScheme:$.filterByScheme});R=$.supportSideBySide===h.PRIMARY?O:V}}if(m(R)||d(R))return;const z=R.resource;return!z||!$||!$.filterByScheme?z:this.filterUri(z,$.filterByScheme)}filterUri(R,$){if(Array.isArray($)){if($.some(z=>R.scheme===z))return R}else if($===R.scheme)return R}}e.EditorResourceAccessor=new w;var E;(function(M){M[M.LEFT=0]="LEFT",M[M.RIGHT=1]="RIGHT"})(E=e.CloseDirection||(e.CloseDirection={}));class p{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(R){const $=this.instantiationService=R.get(A.IInstantiationService);for(const[z,O]of this.editorSerializerConstructors)this.createEditorSerializer(z,O,$);this.editorSerializerConstructors.clear()}createEditorSerializer(R,$,z){const O=z.createInstance($);this.editorSerializerInstances.set(R,O)}registerFileEditorFactory(R){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=R}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(R,$){if(this.editorSerializerConstructors.has(R)||this.editorSerializerInstances.has(R))throw new Error(`A editor serializer with type ID '${R}' was already registered.`);return this.instantiationService?this.createEditorSerializer(R,$,this.instantiationService):this.editorSerializerConstructors.set(R,$),(0,y.toDisposable)(()=>{this.editorSerializerConstructors.delete(R),this.editorSerializerInstances.delete(R)})}getEditorSerializer(R){return this.editorSerializerInstances.get(typeof R=="string"?R:R.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new p);async function T(M,R){if(!M||!M.length)return[];const $=await Promise.all(M.map(async z=>{const O=C.URI.revive(z.fileUri);if(!O||(await R.activateProvider(O.scheme),!R.canHandleResource(O)))return;const V=typeof z.exists=="boolean"?z.exists:await R.exists(O);if(!V&&z.openOnlyIfExists)return;const N={selection:V?z.selection:void 0,pinned:!0,override:z.editorOverrideId};let U;return V?U={resource:O,options:N}:U={resource:O,options:N,forceUntitled:!0},U}));return(0,P.coalesce)($)}e.pathsToEditors=T;var L;(function(M){M[M.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",M[M.SEQUENTIAL=1]="SEQUENTIAL"})(L=e.EditorsOrder||(e.EditorsOrder={}))}),define(fe[210],me([0,1,3,63,175,4,6,24,34,16,58,25,47,199]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",a.Codicon.window,(0,C.localize)(0,null));var d;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(d=e.Extensions||(e.Extensions={}));var v;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(v=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function D(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=D;function I(s){return`viewContainer.${s}.enabled`}e.getEnabledViewContainerContextKey=I;class b extends A.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new f.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new f.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(c,h,w){const E=this.get(c.id);if(E)return E;const p=c;return p.openCommandActionDescriptor=w?.donotRegisterOpenCommand?void 0:p.openCommandActionDescriptor??{id:p.id},(0,_.getOrSet)(this.viewContainers,h,[]).push(p),w?.isDefault&&this.defaultViewContainers.push(p),this._onDidRegister.fire({viewContainer:p,viewContainerLocation:h}),p}deregisterViewContainer(c){for(const h of this.viewContainers.keys()){const w=this.viewContainers.get(h),E=w?.indexOf(c);if(E!==-1){w?.splice(E,1),w.length===0&&this.viewContainers.delete(h),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:h});return}}}get(c){return this.all.filter(h=>h.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(h=>this.getViewContainers(h).filter(w=>w?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(h=>this.getViewContainerLocation(h)===c)}}S.Registry.add(d.ViewContainersRegistry,new b);var l;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(l=e.ViewContentGroups||(e.ViewContentGroups={}));function o(s,c){const h=s.group??l.More,w=c.group??l.More;return h!==w?h.localeCompare(w):(s.order??5)-(c.order??5)}class g extends A.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new f.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new f.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new f.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new f.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(c,h){this.registerViews2([{views:c,viewContainer:h}])}registerViews2(c){c.forEach(({views:h,viewContainer:w})=>this.addViews(h,w)),this._onViewsRegistered.fire(c)}deregisterViews(c,h){const w=this.removeViews(c,h);w.length&&this._onViewsDeregistered.fire({views:w,viewContainer:h})}moveViews(c,h){for(const w of this._views.keys())if(w!==h){const E=this.removeViews(c,w);E.length&&(this.addViews(E,h),this._onDidChangeContainer.fire({views:E,from:w,to:h}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const h of this._viewContainers){const w=(this._views.get(h)||[]).filter(E=>E.id===c)[0];if(w)return w}return null}getViewContainer(c){for(const h of this._viewContainers)if((this._views.get(h)||[]).filter(E=>E.id===c)[0])return h;return null}registerViewWelcomeContent(c,h){return this._viewWelcomeContents.add(c,h),this._onDidChangeViewWelcomeContent.fire(c),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(c,h),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,h){const w=new Map;for(const[E,p]of h)this._viewWelcomeContents.add(c,p),w.set(E,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(c,p),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),w}getViewWelcomeContent(c){const h=[];return this._viewWelcomeContents.forEach(c,w=>h.push(w)),h.sort(o)}addViews(c,h){let w=this._views.get(h);w||(w=[],this._views.set(h,w),this._viewContainers.push(h));for(const E of c){if(this.getView(E.id)!==null)throw new Error((0,C.localize)(1,null,E.id));w.push(E)}}removeViews(c,h){const w=this._views.get(h);if(!w)return[];const E=[],p=[];for(const T of w)c.includes(T)?E.push(T):p.push(T);return E.length&&(p.length?this._views.set(h,p):(this._views.delete(h),this._viewContainers.splice(this._viewContainers.indexOf(h),1))),E}}S.Registry.add(d.ViewsRegistry,new g),e.IViewsService=(0,y.createDecorator)("viewsService"),e.FocusedViewContext=new F.RawContextKey("focusedView","",(0,C.localize)(2,null));function t(s){return`view.${s}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,y.createDecorator)("viewDescriptorService");var u;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(u=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(c,h){this.resolved=!1,this._hasResolve=!1,(0,k.mixin)(this,c),this._hasResolve=!!h,this.resolve=async w=>{if(h&&!this.resolved){const E=await h(w);E&&(this.tooltip=this.tooltip??E.tooltip,this.command=this.command??E.command)}w.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(fe[126],me([0,1,3,17,176]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new f.Emitter,this._onExit=new f.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(_){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=_}onEvent(_){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=_}onRequest(_){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=_}sendResponse(_){_.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${_.command}`)):this.internalSend("response",_)}sendRequest(_,S,P,n){const k={command:_};if(S&&Object.keys(S).length>0&&(k.arguments=S),this.internalSend("request",k),typeof n=="number"){const a=setTimeout(()=>{clearTimeout(a);const m=this.pendingRequests.get(k.seq);if(m){this.pendingRequests.delete(k.seq);const d={type:"response",seq:0,request_seq:k.seq,success:!1,command:_,message:(0,C.localize)(0,null,n,_)};m(d)}},n)}return P&&this.pendingRequests.set(k.seq,P),k.seq}acceptMessage(_){this.messageCallback?this.messageCallback(_):(this.queue.push(_),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(_,S){return _.type!=="event"||S.type!=="event"}async processQueue(){let _;for(;this.queue.length;){if((!_||this.needsTaskBoundaryBetween(this.queue[0],_))&&await(0,F.timeout)(0),_=this.queue.shift(),!_)return;switch(_.type){case"event":this.eventCallback&&this.eventCallback(_);break;case"request":this.requestCallback&&this.requestCallback(_);break;case"response":const S=_,P=this.pendingRequests.get(S.request_seq);P&&(this.pendingRequests.delete(S.request_seq),P(S));break}}}internalSend(_,S){S.type=_,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const _=new Map;this.pendingRequests.forEach((S,P)=>_.set(P,S)),await(0,F.timeout)(500),_.forEach((S,P)=>{S({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(fe[211],me([0,1,9,2,8,25,10]),function(Y,e,f,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const _=/{([^}]+)}/g;function S(r,i,s){return r.replace(_,function(c,h){return i&&h.length>0&&h[0]!=="_"?c:s&&s.hasOwnProperty(h)?s[h]:c})}e.formatPII=S;function P(r){const i={};for(const s of Object.keys(r))s.startsWith("!")||(i[s]=r[s]);return i}e.filterExceptionsFromTelemetry=P;function n(r){return r.configuration.request==="attach"&&!k(r)&&(!r.parentSession||n(r.parentSession))}e.isSessionAttach=n;function k(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,f.equalsIgnoreCase)(i,"extensionhost")||(0,f.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?k(r.parentSession):void 0}e.getExtensionHostDebugSession=k;function a(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=a;function m(r,i,s){let c,h=0,w=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,E=null;for(;E=w.exec(r);){let p=E.index+1,T=p+E[0].length;if(p<=i&&T>=s){c=E[0],h=p;break}}if(c){let p=/\w+/g,T=null;for(;(T=p.exec(c))&&!(T.index+1+h+T[0].length>=s););T&&(c=c.substring(0,p.lastIndex))}return c?{start:h,end:h+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(r){return!!(r&&r.match(d))}e.isUri=v;function D(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(v(r.path))return F.URI.parse(r.path);if((0,C.isAbsolute)(r.path))return F.URI.file(r.path)}return r.path}function I(r){if(typeof r.path=="object"){const i=F.URI.revive(r.path);if(i)return i.scheme===A.Schemas.file?i.fsPath:i.toString()}return r.path}function b(r,i){const s=i?D:I,c=(0,y.deepClone)(r);return o(c,(h,w)=>{h&&w&&(w.path=s(w))}),c}e.convertToDAPaths=b;function l(r,i){const s=i?D:I,c=(0,y.deepClone)(r);return o(c,(h,w)=>{!h&&w&&(w.path=s(w))}),c}e.convertToVSCPaths=l;function o(r,i){switch(r.type){case"event":const s=r;switch(s.event){case"output":i(!1,s.body.source);break;case"loadedSource":i(!1,s.body.source);break;case"breakpoint":i(!1,s.body.breakpoint.source);break;default:break}break;case"request":const c=r;switch(c.command){case"setBreakpoints":i(!0,c.arguments.source);break;case"breakpointLocations":i(!0,c.arguments.source);break;case"source":i(!0,c.arguments.source);break;case"gotoTargets":i(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(w=>i(!1,w));break;default:break}break;case"response":const h=r;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(w=>i(!1,w.source));break;case"loadedSources":h.body.sources.forEach(w=>i(!1,w));break;case"scopes":h.body.scopes.forEach(w=>i(!1,w.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(w=>i(!1,w.source));break;case"setBreakpoints":h.body.breakpoints.forEach(w=>i(!1,w.source));break;default:break}break}}function g(r){return r.filter(i=>!i.presentation?.hidden).sort((i,s)=>i.presentation?s.presentation?i.presentation.group?s.presentation.group?i.presentation.group!==s.presentation.group?i.presentation.group.localeCompare(s.presentation.group):t(i.presentation.order,s.presentation.order):-1:s.presentation.group?1:t(i.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=g;function t(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function u(r,i){const s=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(s!=="none"&&(await i.saveAll(),s==="allEditorsInActiveGroup")){const c=i.activeEditorPane;c&&await i.save({editor:c.input,groupId:c.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(fe[212],me([0,1,28,39,177,127,8,9,25,11,187,126]),function(Y,e,f,F,C,y,A,_,S,P,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class a extends k.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,l){this.outputStream=l,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",o=>this.handleData(o))}sendMessage(b){if(this.outputStream){const l=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(l,"utf8")}${a.TWO_CRLF}${l}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const l=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,l.length>0)try{this.acceptMessage(JSON.parse(l))}catch(o){this._onError.fire(new Error((o.message||o)+`
`+l))}continue}}else{const l=this.rawData.indexOf(a.TWO_CRLF);if(l!==-1){const g=this.rawData.toString("utf8",0,l).split(a.HEADER_LINESEPARATOR);for(const t of g){const u=t.split(a.HEADER_FIELDSEPARATOR);u[0]==="Content-Length"&&(this.contentLength=Number(u[1]))}this.rawData=this.rawData.slice(l+a.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=a,a.TWO_CRLF=`\r
\r
`,a.HEADER_LINESEPARATOR=/\r?\n/,a.HEADER_FIELDSEPARATOR=/: */;class m extends a{startSession(){return new Promise((b,l)=>{let o=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),o=!0}),this.socket.on("close",()=>{o?this._onError.fire(new Error("connection closed")):l(new Error("connection closed"))}),this.socket.on("error",g=>{o?this._onError.fire(g):l(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class d extends m{constructor(b){super();this.adapterServer=b}createConnection(b){return y.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=d;class v extends m{constructor(b){super();this.adapterServer=b}createConnection(b){return y.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=v;class D extends a{constructor(b,l,o){super();this.adapterExecutable=b,this.debugType=l,this.outputService=o}async startSession(){const b=this.adapterExecutable.command,l=this.adapterExecutable.args,o=this.adapterExecutable.options||{};try{if(b)if(A.isAbsolute(b)){if(!await f.Promises.exists(b))throw new Error(C.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let g=process.env;if(o.env&&Object.keys(o.env).length>0&&(g=S.mixin(S.deepClone(process.env),o.env)),b==="node")if(Array.isArray(l)&&l.length>0){const u=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:g,execArgv:u?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(r.cwd=o.cwd);const i=F.fork(l[0],l.slice(1),r);if(!i.pid)throw new Error(C.localize(2,null,l[0]));this.serverProcess=i}else throw new Error(C.localize(3,null));else{const u={env:g};o.cwd&&(u.cwd=o.cwd),this.serverProcess=F.spawn(b,l,u)}this.serverProcess.on("error",u=>{this._onError.fire(u)}),this.serverProcess.on("exit",(u,r)=>{this._onExit.fire(u)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",u=>{this._onError.fire(u)}),this.serverProcess.stdin.on("error",u=>{this._onError.fire(u)});const t=this.outputService;if(t){const u=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const i=t.getChannel(n.ExtensionsChannelId);i&&i.append(u(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((b,l)=>{const o=F.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,t,u){if(g)return l(g)});o.on("exit",b),o.on("error",l)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,l){if(!b)return;const o=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?o.runtime=A.join(l,b.runtime):o.runtime=b.runtime),b.runtimeArgs&&(o.runtimeArgs=b.runtimeArgs),b.program&&(A.isAbsolute(b.program)?o.program=b.program:o.program=A.join(l,b.program)),b.args&&(o.args=b.args);const g=b;return g.win&&(o.win=D.extract(g.win,l)),g.winx86&&(o.winx86=D.extract(g.winx86,l)),g.windows&&(o.windows=D.extract(g.windows,l)),g.osx&&(o.osx=D.extract(g.osx,l)),g.linux&&(o.linux=D.extract(g.linux,l)),o}static platformAdapterExecutable(b,l){let o=Object.create(null);l=l.toLowerCase();for(const s of b)if(s.contributes){const c=s.contributes.debuggers;c&&c.length>0&&c.filter(h=>typeof h.type=="string"&&_.equalsIgnoreCase(h.type,l)).forEach(h=>{const w=D.extract(h,s.extensionLocation.fsPath);o=S.mixin(o,w,s.isBuiltin)})}let g;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=o.winx86||o.win||o.windows:P.isWindows?g=o.win||o.windows:P.isMacintosh?g=o.osx:P.isLinux&&(g=o.linux),g=g||o;let t=g.program||o.program;const u=g.args||o.args;let r=g.runtime||o.runtime;const i=g.runtimeArgs||o.runtimeArgs;if(r)return{type:"executable",command:r,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(u||[])};if(t)return{type:"executable",command:t,args:u||[]}}}e.ExecutableDebugAdapter=D}),define(fe[213],me([0,1,39,11,29,190]),function(Y,e,f,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function A(a,m){return new Promise((d,v)=>{let D="";const I=f.spawn(a,m);I.pid&&I.stdout.on("data",b=>{D+=b.toString()}),I.on("error",b=>{v(b)}),I.on("close",b=>{d(D)})})}let _;function S(a,m){if(!_)if(F.isWindows)_=new y.WindowsExternalTerminalService;else if(F.isMacintosh)_=new y.MacExternalTerminalService;else if(F.isLinux)_=new y.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const d=m.getConfiguration("terminal");return _.runInTerminal(a.title,a.cwd,a.args,a.env||{},d.external||{})}e.runInExternalTerminal=S;function P(a){return a?F.isWindows?new Promise(async m=>{(await new Promise((v,D)=>{Y(["windows-process-tree"],v,D)})).getProcessTree(a,v=>{m(v.children.length>0)})}):A("/usr/bin/pgrep",["-lP",String(a)]).then(m=>{const d=m.trim();return!(d.length===0||d.indexOf(" tmux")>=0)},m=>!0):Promise.resolve(!0)}e.hasChildProcesses=P;var n;(function(a){a[a.cmd=0]="cmd",a[a.powershell=1]="powershell",a[a.bash=2]="bash"})(n||(n={}));function k(a,m,d,v){a=a.trim().toLowerCase();let D;a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0?D=1:a.indexOf("cmd.exe")>=0?D=0:a.indexOf("bash")>=0?D=2:F.isWindows?D=0:D=2;let I,b=" ";switch(D){case 1:if(I=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),d){const o=(0,C.getDriveLetter)(d);o&&(b+=`${o}:; `),b+=`cd ${I(d)}; `}if(v)for(let o in v){const g=v[o];g===null?b+=`Remove-Item env:${o}; `:b+=`\${env:${o}}='${g}'; `}if(m.length>0){const o=I(m.shift());b+=o[0]==="'"?`& ${o} `:`${o} `;for(let g of m)b+=`${I(g)} `}break;case 0:if(I=o=>(o=o.replace(/\"/g,'""'),o.indexOf(" ")>=0||o.indexOf('"')>=0||o.length===0?`"${o}"`:o),d){const o=(0,C.getDriveLetter)(d);o&&(b+=`${o}: && `),b+=`cd ${I(d)} && `}if(v){b+='cmd /C "';for(let o in v){let g=v[o];g===null?b+=`set "${o}=" && `:(g=g.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),b+=`set "${o}=${g}" && `)}}for(let o of m)b+=`${I(o)} `;v&&(b+='"');break;case 2:I=o=>(o=o.replace(/(["'\\\$])/g,"\\$1"),o.indexOf(" ")>=0||o.indexOf(";")>=0||o.length===0?`"${o}"`:o);const l=o=>/[^\w@%\/+=,.:^-]/.test(o)?`'${o.replace(/'/g,"'\\''")}'`:o;if(d&&(b+=`cd ${I(d)} ; `),v){b+="/usr/bin/env";for(let o in v){const g=v[o];g===null?b+=` -u ${l(o)}`:b+=` ${l(`${o}=${g}`)}`}b+=" "}for(let o of m)b+=`${I(o)} `;break}return b}e.prepareCommand=k}),define(fe[128],me([0,1,30,103,10,8,11,63]),function(Y,e,f,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var S;(function(p){p[p.Markup=1]="Markup",p[p.Code=2]="Code"})(S=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.latex,F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.latex,F.Mimes.markdown,"application/json",F.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(p){p[p.Running=1]="Running",p[p.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(p){p[p.Pending=2]="Pending",p[p.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var k;(function(p){p[p.WithHardKernelDependency=0]="WithHardKernelDependency",p[p.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",p[p.Pure=2]="Pure",p[p.Never=3]="Never"})(k=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var a;(function(p){p.Always="always",p.Never="never",p.Optional="optional"})(a=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(p){p[p.ModelChange=1]="ModelChange",p[p.Move=2]="Move",p[p.ChangeLanguage=5]="ChangeLanguage",p[p.Initialize=6]="Initialize",p[p.ChangeCellMetadata=7]="ChangeCellMetadata",p[p.Output=8]="Output",p[p.OutputItem=9]="OutputItem",p[p.ChangeCellContent=10]="ChangeCellContent",p[p.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",p[p.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",p[p.ChangeCellMime=13]="ChangeCellMime",p[p.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(p){p[p.Handle=0]="Handle",p[p.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(p){p[p.Replace=1]="Replace",p[p.Output=2]="Output",p[p.Metadata=3]="Metadata",p[p.CellLanguage=4]="CellLanguage",p[p.DocumentMetadata=5]="DocumentMetadata",p[p.Move=6]="Move",p[p.OutputItems=7]="OutputItems",p[p.PartialMetadata=8]="PartialMetadata",p[p.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var D;(function(p){p.scheme=C.Schemas.vscodeNotebookCell;const T=/^ch(\d{7,})/;function L(O,V){return O.with({scheme:p.scheme,fragment:`ch${V.toString().padStart(7,"0")}${O.scheme!==C.Schemas.file?O.scheme:""}`})}p.generate=L;function M(O){if(O.scheme!==p.scheme)return;const V=T.exec(O.fragment);return V?{handle:Number(V[1]),notebook:O.with({scheme:O.fragment.substr(V[0].length)||C.Schemas.file,fragment:null})}:void 0}p.parse=M;function R(O){if(O.scheme!==C.Schemas.vscodeNotebookCellMetadata)return;const V=T.exec(O.fragment);return V?{handle:Number(V[1]),notebook:O.with({scheme:O.fragment.substr(V[0].length)||C.Schemas.file,fragment:null})}:void 0}p.parseCellMetadataUri=R;function $(O,V,N){return O.with({scheme:N,fragment:`ch${V.toString().padStart(7,"0")}${O.scheme!==C.Schemas.file?O.scheme:""}`})}p.generateCellUri=$;function z(O,V){if(O.scheme!==V)return;const N=T.exec(O.fragment);return N?{handle:Number(N[1]),notebook:O.with({scheme:O.fragment.substr(N[0].length)||C.Schemas.file,fragment:null})}:void 0}p.parseCellUri=z})(D=e.CellUri||(e.CellUri={}));const I=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function b(p){return I.get(p)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=b;function l(p){return I.get(p)?.supportedByCore??!1}e.mimeTypeSupportedByCore=l;function o(p){return I.get(p)?.mergeable??!1}e.mimeTypeIsMergeable=o;function g(p,T){return A.isWindows&&(p=p.replace(/\//g,"\\"),T=T.replace(/\//g,"\\")),f.match(p,T)}function t(p,T,L){let M=0;for(let R=0;R<T.length;R++){if(g(T[R],p))return M;M++}for(let R=0;R<L.length;R++){if(g(L[R],p))return M;M++}return M}function u(p,T,L){return p.sort((M,R)=>t(M,T,L)-t(R,T,L))}e.sortMimeTypes=u;function r(p,T,L,M=(R,$)=>R===$){const R=[];function $(V,N,U){if(N===0&&U.length===0)return;const x=R[R.length-1];x&&x.start+x.deleteCount===V?(x.deleteCount+=N,x.toInsert.push(...U)):R.push({start:V,deleteCount:N,toInsert:U})}let z=0,O=0;for(;;){if(z===p.length){$(z,0,T.slice(O));break}if(O===T.length){$(z,p.length-z,[]);break}const V=p[z],N=T[O];if(M(V,N)){z+=1,O+=1;continue}L(N)?($(z,1,[]),z+=1):($(z,0,[N]),O+=1)}return R}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(p){p.default="default",p.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(p){const T=p;return!!((typeof T.include=="string"||f.isRelativePattern(T.include))&&(typeof T.exclude=="string"||f.isRelativePattern(T.exclude)))}e.isDocumentExcludePattern=s;function c(p,T,L){if(Array.isArray(p.viewType)&&p.viewType.indexOf(T)>=0||p.viewType===T)return!0;if(p.filenamePattern){let M=s(p.filenamePattern)?p.filenamePattern.include:p.filenamePattern,R=s(p.filenamePattern)?p.filenamePattern.exclude:void 0;if(f.match(M,(0,y.basename)(L.fsPath).toLowerCase()))return!(R&&f.match(R,(0,y.basename)(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=c;class h{constructor(T){this.textModel=T}getElements(){const T=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)T[L]=this.textModel.cells[L].getHashValue();return T}}e.CellSequence=h,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var w;(function(p){p[p.Left=1]="Left",p[p.Right=2]="Right"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class E{static create(T){return`${E._prefix}${T}`}static parse(T){if(T.startsWith(E._prefix))return T.substr(E._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=E,E._prefix="notebook/"}),define(fe[214],me([0,1,4]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState",C[C.Complete=4]="Complete"})(F=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,f.createDecorator)("INotebookExecutionService")}),define(fe[215],me([0,1,179,4,63]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new C.RawContextKey("customExecutionSupported",!0,f.localize(0,null)),e.ShellExecutionSupportedContext=new C.RawContextKey("shellExecutionSupported",!1,f.localize(1,null)),e.ProcessExecutionSupportedContext=new C.RawContextKey("processExecutionSupported",!1,f.localize(2,null)),e.ITaskService=(0,F.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(fe[216],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function f(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=f;function F(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=F}),define(fe[129],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var f;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(f=e.TestResultState||(e.TestResultState={}));var F;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable"})(F=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var C;(function(k){k[k.Error=0]="Error",k[k.Info=1]="Info"})(C=e.TestMessageType||(e.TestMessageType={}));var y;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(y=e.TestItemExpandState||(e.TestItemExpandState={}));const A=(k,a)=>{a.expand!==void 0&&(k.expand=a.expand),a.item!==void 0&&(k.item=k.item?Object.assign(k.item,a.item):a.item)};e.applyTestItemUpdate=A;var _;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(_=e.DetailType||(e.DetailType={}));var S;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.Remove=2]="Remove",k[k.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",k[k.Retire=4]="Retire",k[k.AddTag=5]="AddTag",k[k.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(a){}update(a){}remove(a,m){}complete(){}}e.IncrementalChangeCollector=P;class n{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const m=this.createChangeCollector();for(const d of a)switch(d[0]){case 0:{const v=d[1];if(v.parent){if(this.items.has(v.parent)){const D=this.items.get(v.parent);D.children.add(v.item.extId);const I=this.createItem(v,D);this.items.set(v.item.extId,I),m.add(I)}}else{const D=this.createItem(v);this.roots.add(D),this.items.set(v.item.extId,D),m.add(D)}v.expand===2&&this.busyControllerCount++;break}case 1:{const v=d[1],D=this.items.get(v.extId);if(!D)break;v.expand!==void 0&&(D.expand===2&&this.busyControllerCount--,v.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(D,v),m.update(D);break}case 2:{const v=this.items.get(d[1]);if(!v)break;v.parent?this.items.get(v.parent).children.delete(v.item.extId):this.roots.delete(v);const D=[[d[1]]];for(;D.length;)for(const I of D.pop()){const b=this.items.get(I);b&&(D.push(b.children),this.items.delete(I),m.remove(b,b!==v),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(d[1]);break;case 3:this.updatePendingRoots(d[1]);break;case 5:this._tags.set(d[1].id,d[1]);break;case 6:this._tags.delete(d[1]);break}m.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=n}),define(fe[89],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var f;(function(y){y.Delimiter="\0"})(f=e.TestIdPathParts||(e.TestIdPathParts={}));var F;(function(y){y[y.IsSame=0]="IsSame",y[y.Disconnected=1]="Disconnected",y[y.IsChild=2]="IsChild",y[y.IsParent=3]="IsParent"})(F=e.TestPosition||(e.TestPosition={}));class C{constructor(A,_=A.length){if(this.path=A,this.viewEnd=_,A.length===0||_<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(A,_,S=A.parent){if(A.id===_)return new C([_]);let P=[A.id];for(let n=S;n&&n.id!==_;n=n.parent)P.push(n.id);return P.push(_),new C(P.reverse())}static isRoot(A){return!A.includes("\0")}static fromString(A){return new C(A.split("\0"))}static join(A,_){return new C([...A.path,_])}static joinToString(A,_){return A.toString()+"\0"+_}static compare(A,_){return A===_?0:_.startsWith(A+"\0")?2:A.startsWith(_+"\0")?3:1}get parentId(){return this.viewEnd>1?new C(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let _=0;_<A.viewEnd&&_<this.viewEnd;_++)if(A.path[_]!==this.path[_])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=C}),define(fe[217],me([0,1,8,38,12,25,11,79,180]),function(Y,e,f,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(k,a,m){this._contributedVariables=new Map,this._context=k,this._labelService=a,m&&(this._envVariablesPromise=m.then(d=>this.prepareEnv(d)))}prepareEnv(k){if(A.isWindows){const a=Object.create(null);return Object.keys(k).forEach(m=>{a[m.toLowerCase()]=k[m]}),a}return k}resolveWithEnvironment(k,a,m){return this.recursiveResolve(this.prepareEnv(k),a?a.uri:void 0,m)}async resolveAsync(k,a){return this.recursiveResolve(await this._envVariablesPromise,k?k.uri:void 0,a)}async resolveAnyBase(k,a,m,d){const v=y.deepClone(a);return A.isWindows&&v.windows?Object.keys(v.windows).forEach(D=>v[D]=v.windows[D]):A.isMacintosh&&v.osx?Object.keys(v.osx).forEach(D=>v[D]=v.osx[D]):A.isLinux&&v.linux&&Object.keys(v.linux).forEach(D=>v[D]=v.linux[D]),delete v.windows,delete v.osx,delete v.linux,this.recursiveResolve(await this._envVariablesPromise,k?k.uri:void 0,v,m,d)}async resolveAnyAsync(k,a,m){return this.resolveAnyBase(k,a,m)}async resolveAnyMap(k,a,m){const d=new Map;return{newConfig:await this.resolveAnyBase(k,a,m,d),resolvedVariables:d}}resolveWithInteractionReplace(k,a,m,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,a,m,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,a){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,a)}recursiveResolve(k,a,m,d,v){if(C.isString(m))return this.resolveString(k,a,m,d,v);if(C.isArray(m))return m.map(D=>this.recursiveResolve(k,a,D,d,v));if(C.isObject(m)){let D=Object.create(null);return Object.keys(m).forEach(I=>{const b=this.resolveString(k,a,I,d,v);D[b]=this.recursiveResolve(k,a,m[I],d,v)}),D}return m}resolveString(k,a,m,d,v){return m.replace(P.VARIABLE_REGEXP,(I,b)=>{if(b.includes(P.VARIABLE_LHS))return I;let l=this.evaluateSingleVariable(k,I,b,a,d);return v&&v.set(b,l),l!==I&&C.isString(l)&&l.match(P.VARIABLE_REGEXP)&&(l=this.resolveString(k,a,l,d,v)),l})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,a,m,d,v){let D;const I=m.split(":");I.length>1&&(m=I[0],D=I[1]);const b=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error((0,S.localize)(0,null,a))},l=()=>{const g=b();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,S.localize)(1,null,a,f.basename(g)))},o=()=>{if(D){const g=this._context.getFolderUri(D);if(g)return g;throw new Error((0,S.localize)(2,null,a,D))}if(d)return d;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,a)):new Error((0,S.localize)(4,null,a))};switch(m){case"env":if(D){if(k){const g=k[A.isWindows?D.toLowerCase():D];if(C.isString(g))return g}return""}throw new Error((0,S.localize)(5,null,a));case"config":if(D){const g=this._context.getConfigurationValue(d,D);if(C.isUndefinedOrNull(g))throw new Error((0,S.localize)(6,null,a,D));if(C.isObject(g))throw new Error((0,S.localize)(7,null,a,D));return g}throw new Error((0,S.localize)(8,null,a));case"command":return this.resolveFromMap(a,D,v,"command");case"input":return this.resolveFromMap(a,D,v,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,_.normalizeDriveLetter)(this.fsPath(o()));case"cwd":return d||D?(0,_.normalizeDriveLetter)(this.fsPath(o())):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return f.basename(this.fsPath(o()));case"lineNumber":const g=this._context.getLineNumber();if(g)return g;throw new Error((0,S.localize)(9,null,a));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,S.localize)(10,null,a));case"file":return b();case"fileWorkspaceFolder":return l();case"relativeFile":return d||D?f.relative(this.fsPath(o()),b()):b();case"relativeFileDirname":const u=f.dirname(b());if(d||D){const c=f.relative(this.fsPath(o()),u);return c.length===0?".":c}return u;case"fileDirname":return f.dirname(b());case"fileExtname":return f.extname(b());case"fileBasename":return f.basename(b());case"fileBasenameNoExtension":const r=f.basename(b());return r.slice(0,r.length-f.extname(r).length);case"fileDirnameBasename":return f.basename(f.dirname(b()));case"execPath":const i=this._context.getExecPath();return i||a;case"execInstallFolder":const s=this._context.getAppRoot();return s||a;case"pathSeparator":return f.sep;default:try{const c=D?`${m}:${D}`:m;return this.resolveFromMap(a,c,v,void 0)}catch(c){return a}}}}resolveFromMap(k,a,m,d){if(a&&m){const v=d===void 0?m[a]:m[d+":"+a];if(typeof v=="string")return v;throw new Error((0,S.localize)(11,null,k))}return k}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(fe[130],me([0,1,4,209]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,f.createDecorator)("editorGroupsService");var C;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(C=e.GroupDirection||(e.GroupDirection={}));var y;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(y=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var _;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(_=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function P(v){const D=v;return(0,F.isEditorInput)(D?.editor)&&(0,F.isEditorInput)(D?.replacement)}e.isEditorReplacement=P;var n;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(v){v[v.GROUP_ACTIVE=0]="GROUP_ACTIVE",v[v.GROUP_INDEX=1]="GROUP_INDEX",v[v.GROUP_LOCKED=2]="GROUP_LOCKED",v[v.EDITOR_OPEN=3]="EDITOR_OPEN",v[v.EDITOR_CLOSE=4]="EDITOR_CLOSE",v[v.EDITOR_MOVE=5]="EDITOR_MOVE",v[v.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",v[v.EDITOR_LABEL=7]="EDITOR_LABEL",v[v.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",v[v.EDITOR_PIN=9]="EDITOR_PIN",v[v.EDITOR_STICKY=10]="EDITOR_STICKY",v[v.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var a;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(a=e.OpenEditorContext||(e.OpenEditorContext={}));function m(v){const D=v;return!!D&&typeof D.id=="number"&&Array.isArray(D.editors)}e.isEditorGroup=m;function d(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=d}),define(fe[218],me([0,1,4,130]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,f.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function C(y){const A=y;return typeof y=="number"||(0,F.isEditorGroup)(A)}e.isPreferredGroup=C}),define(fe[15],me([0,1,16,22,100,293,61,25,12,2,42,83,181,118,65,128,89,218,7]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(ge){function _e(Q){const{selectionStartLineNumber:ye,selectionStartColumn:Le,positionLineNumber:it,positionColumn:Ke}=Q,pt=new b.Position(ye-1,Le-1),bt=new b.Position(it-1,Ke-1);return new b.Selection(pt,bt)}ge.to=_e;function ie(Q){const{anchor:ye,active:Le}=Q;return{selectionStartLineNumber:ye.line+1,selectionStartColumn:ye.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ge.from=ie})(l=e.Selection||(e.Selection={}));var o;(function(ge){function _e(Q){if(!Q)return;const{start:ye,end:Le}=Q;return{startLineNumber:ye.line+1,startColumn:ye.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ge.from=_e;function ie(Q){if(!Q)return;const{startLineNumber:ye,startColumn:Le,endLineNumber:it,endColumn:Ke}=Q;return new b.Range(ye-1,Le-1,it-1,Ke-1)}ge.to=ie})(o=e.Range||(e.Range={}));var g;(function(ge){function _e(ie){switch(ie){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}ge.to=_e})(g=e.TokenType||(e.TokenType={}));var t;(function(ge){function _e(Q){return new b.Position(Q.lineNumber-1,Q.column-1)}ge.to=_e;function ie(Q){return{lineNumber:Q.line+1,column:Q.character+1}}ge.from=ie})(t=e.Position||(e.Position={}));var u;(function(ge){function _e(ye,Le){return(0,f.coalesce)((0,f.asArray)(ye).map(it=>ie(it,Le)))}ge.from=_e;function ie(ye,Le){if(typeof ye=="string")return{$serialized:!0,language:ye};if(ye)return{$serialized:!0,language:ye.language,scheme:Q(ye.scheme,Le),pattern:typeof ye.pattern=="undefined"?void 0:ut.from(ye.pattern),exclusive:ye.exclusive}}function Q(ye,Le){return Le&&typeof ye=="string"?Le.transformOutgoingScheme(ye):ye}})(u=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(ge){function _e(Q){switch(Q){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}ge.from=_e;function ie(Q){switch(Q){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}ge.to=ie})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(ge){function _e(Q){let ye;return Q.code&&((0,S.isString)(Q.code)||(0,S.isNumber)(Q.code)?ye=String(Q.code):ye={value:String(Q.code.value),target:Q.code.target}),{...o.from(Q.range),message:Q.message,source:Q.source,code:ye,severity:c.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(s.from),tags:Array.isArray(Q.tags)?(0,f.coalesce)(Q.tags.map(r.from)):void 0}}ge.from=_e;function ie(Q){const ye=new b.Diagnostic(o.to(Q),Q.message,c.to(Q.severity));return ye.source=Q.source,ye.code=(0,S.isString)(Q.code)?Q.code:Q.code?.value,ye.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(s.to),ye.tags=Q.tags&&(0,f.coalesce)(Q.tags.map(r.to)),ye}ge.to=ie})(i=e.Diagnostic||(e.Diagnostic={}));var s;(function(ge){function _e(Q){return{...o.from(Q.location.range),message:Q.message,resource:Q.location.uri}}ge.from=_e;function ie(Q){return new b.DiagnosticRelatedInformation(new b.Location(Q.resource,o.to(Q)),Q.message)}ge.to=ie})(s=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var c;(function(ge){function _e(Q){switch(Q){case b.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}ge.from=_e;function ie(Q){switch(Q){case m.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ge.to=ie})(c=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var h;(function(ge){function _e(Q){return typeof Q=="number"&&Q>=b.ViewColumn.One?Q-1:Q===b.ViewColumn.Beside?I.SIDE_GROUP:I.ACTIVE_GROUP}ge.from=_e;function ie(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}ge.to=ie})(h=e.ViewColumn||(e.ViewColumn={}));function w(ge){return typeof ge.range!="undefined"}function E(ge){return ge.length===0?!0:!!w(ge[0])}e.isDecorationOptionsArr=E;var p;(function(ge){function _e(Ke){return Ke.map(ge.from)}ge.fromMany=_e;function ie(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function Q(Ke){let pt;if(ie(Ke)){const{language:mt,value:Et}=Ke;pt={value:"```"+mt+`
`+Et+"\n```\n"}}else b.MarkdownString.isMarkdownString(Ke)?pt={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml}:typeof Ke=="string"?pt={value:Ke}:pt={value:""};const bt=Object.create(null);pt.uris=bt;const ft=mt=>{try{let Et=P.URI.parse(mt,!0);Et=Et.with({query:ye(Et.query,bt)}),bt[mt]=Et}catch(Et){}return""},wt=new y.Renderer;return wt.link=ft,wt.image=mt=>ft(C.parseHrefAndDimensions(mt).href),y(pt.value,{renderer:wt}),pt}ge.from=Q;function ye(Ke,pt){if(!Ke)return Ke;let bt;try{bt=(0,A.parse)(Ke)}catch(wt){}if(!bt)return Ke;let ft=!1;return bt=(0,_.cloneAndChange)(bt,wt=>{if(P.URI.isUri(wt)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return pt[mt]=wt,ft=!0,mt}else return}),ft?JSON.stringify(bt):Ke}function Le(Ke){const pt=new b.MarkdownString(Ke.value,Ke.supportThemeIcons);return pt.isTrusted=Ke.isTrusted,pt.supportHtml=Ke.supportHtml,pt}ge.to=Le;function it(Ke){if(!!Ke)return typeof Ke=="string"?Ke:ge.from(Ke)}ge.fromStrict=it})(p=e.MarkdownString||(e.MarkdownString={}));function T(ge){return E(ge)?ge.map(_e=>({range:o.from(_e.range),hoverMessage:Array.isArray(_e.hoverMessage)?p.fromMany(_e.hoverMessage):_e.hoverMessage?p.from(_e.hoverMessage):void 0,renderOptions:_e.renderOptions})):ge.map(_e=>({range:o.from(_e)}))}e.fromRangeOrRangeWithMessage=T;function L(ge){return typeof ge=="undefined"?ge:typeof ge=="string"?P.URI.file(ge):ge}e.pathOrURIToURI=L;var M;(function(ge){function _e(ie){return typeof ie=="undefined"?ie:{contentText:ie.contentText,contentIconPath:ie.contentIconPath?L(ie.contentIconPath):void 0,border:ie.border,borderColor:ie.borderColor,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,color:ie.color,backgroundColor:ie.backgroundColor,margin:ie.margin,width:ie.width,height:ie.height}}ge.from=_e})(M=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var R;(function(ge){function _e(ie){return typeof ie=="undefined"?ie:{backgroundColor:ie.backgroundColor,outline:ie.outline,outlineColor:ie.outlineColor,outlineStyle:ie.outlineStyle,outlineWidth:ie.outlineWidth,border:ie.border,borderColor:ie.borderColor,borderRadius:ie.borderRadius,borderSpacing:ie.borderSpacing,borderStyle:ie.borderStyle,borderWidth:ie.borderWidth,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,cursor:ie.cursor,color:ie.color,opacity:ie.opacity,letterSpacing:ie.letterSpacing,gutterIconPath:ie.gutterIconPath?L(ie.gutterIconPath):void 0,gutterIconSize:ie.gutterIconSize,overviewRulerColor:ie.overviewRulerColor,before:ie.before?M.from(ie.before):void 0,after:ie.after?M.from(ie.after):void 0}}ge.from=_e})(R=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var $;(function(ge){function _e(ie){if(typeof ie=="undefined")return ie;switch(ie){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}ge.from=_e})($=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var z;(function(ge){function _e(ie){return{isWholeLine:ie.isWholeLine,rangeBehavior:ie.rangeBehavior?$.from(ie.rangeBehavior):void 0,overviewRulerLane:ie.overviewRulerLane,light:ie.light?R.from(ie.light):void 0,dark:ie.dark?R.from(ie.dark):void 0,backgroundColor:ie.backgroundColor,outline:ie.outline,outlineColor:ie.outlineColor,outlineStyle:ie.outlineStyle,outlineWidth:ie.outlineWidth,border:ie.border,borderColor:ie.borderColor,borderRadius:ie.borderRadius,borderSpacing:ie.borderSpacing,borderStyle:ie.borderStyle,borderWidth:ie.borderWidth,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,cursor:ie.cursor,color:ie.color,opacity:ie.opacity,letterSpacing:ie.letterSpacing,gutterIconPath:ie.gutterIconPath?L(ie.gutterIconPath):void 0,gutterIconSize:ie.gutterIconSize,overviewRulerColor:ie.overviewRulerColor,before:ie.before?M.from(ie.before):void 0,after:ie.after?M.from(ie.after):void 0}}ge.from=_e})(z=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var O;(function(ge){function _e(Q){return{text:Q.newText,eol:Q.newEol&&te.from(Q.newEol),range:o.from(Q.range)}}ge.from=_e;function ie(Q){const ye=new b.TextEdit(o.to(Q.range),Q.text);return ye.newEol=typeof Q.eol=="undefined"?void 0:te.to(Q.eol),ye}ge.to=ie})(O=e.TextEdit||(e.TextEdit={}));var V;(function(ge){function _e(Q,ye,Le){const it={edits:[]};if(Q instanceof b.WorkspaceEdit)for(let Ke of Q._allEntries())if(Ke._type===1)it.edits.push({_type:1,oldUri:Ke.from,newUri:Ke.to,options:Ke.options,metadata:Ke.metadata});else if(Ke._type===2){const pt=ye?.getDocument(Ke.uri);it.edits.push({_type:2,resource:Ke.uri,edit:O.from(Ke.edit),modelVersionId:pt?.version,metadata:Ke.metadata})}else Ke._type===3?it.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,edit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(Ke.uri,!0)?.apiNotebook.version}):Ke._type===5&&it.edits.push({_type:3,metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Le?.getNotebookDocument(Ke.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map($e.from)}});return it}ge.from=_e;function ie(Q){const ye=new b.WorkspaceEdit;for(const Le of Q.edits)Le.edit?ye.replace(P.URI.revive(Le.resource),o.to(Le.edit.range),Le.edit.text):ye.renameFile(P.URI.revive(Le.oldUri),P.URI.revive(Le.newUri),Le.options);return ye}ge.to=ie})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var N;(function(ge){const _e=Object.create(null);_e[b.SymbolKind.File]=0,_e[b.SymbolKind.Module]=1,_e[b.SymbolKind.Namespace]=2,_e[b.SymbolKind.Package]=3,_e[b.SymbolKind.Class]=4,_e[b.SymbolKind.Method]=5,_e[b.SymbolKind.Property]=6,_e[b.SymbolKind.Field]=7,_e[b.SymbolKind.Constructor]=8,_e[b.SymbolKind.Enum]=9,_e[b.SymbolKind.Interface]=10,_e[b.SymbolKind.Function]=11,_e[b.SymbolKind.Variable]=12,_e[b.SymbolKind.Constant]=13,_e[b.SymbolKind.String]=14,_e[b.SymbolKind.Number]=15,_e[b.SymbolKind.Boolean]=16,_e[b.SymbolKind.Array]=17,_e[b.SymbolKind.Object]=18,_e[b.SymbolKind.Key]=19,_e[b.SymbolKind.Null]=20,_e[b.SymbolKind.EnumMember]=21,_e[b.SymbolKind.Struct]=22,_e[b.SymbolKind.Event]=23,_e[b.SymbolKind.Operator]=24,_e[b.SymbolKind.TypeParameter]=25;function ie(ye){return typeof _e[ye]=="number"?_e[ye]:6}ge.from=ie;function Q(ye){for(const Le in _e)if(_e[Le]===ye)return Number(Le);return b.SymbolKind.Property}ge.to=Q})(N=e.SymbolKind||(e.SymbolKind={}));var U;(function(ge){function _e(Q){switch(Q){case b.SymbolTag.Deprecated:return 1}}ge.from=_e;function ie(Q){switch(Q){case 1:return b.SymbolTag.Deprecated}}ge.to=ie})(U=e.SymbolTag||(e.SymbolTag={}));var x;(function(ge){function _e(Q){return{name:Q.name,kind:N.from(Q.kind),tags:Q.tags&&Q.tags.map(U.from),containerName:Q.containerName,location:X.from(Q.location)}}ge.from=_e;function ie(Q){const ye=new b.SymbolInformation(Q.name,N.to(Q.kind),Q.containerName,X.to(Q.location));return ye.tags=Q.tags&&Q.tags.map(U.to),ye}ge.to=ie})(x=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var B;(function(ge){function _e(Q){const ye={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:o.from(Q.range),selectionRange:o.from(Q.selectionRange),kind:N.from(Q.kind),tags:Q.tags?.map(U.from)??[]};return Q.children&&(ye.children=Q.children.map(_e)),ye}ge.from=_e;function ie(Q){const ye=new b.DocumentSymbol(Q.name,Q.detail,N.to(Q.kind),o.to(Q.range),o.to(Q.selectionRange));return(0,f.isNonEmptyArray)(Q.tags)&&(ye.tags=Q.tags.map(U.to)),Q.children&&(ye.children=Q.children.map(ie)),ye}ge.to=ie})(B=e.DocumentSymbol||(e.DocumentSymbol={}));var H;(function(ge){function _e(Q){const ye=new b.CallHierarchyItem(N.to(Q.kind),Q.name,Q.detail||"",P.URI.revive(Q.uri),o.to(Q.range),o.to(Q.selectionRange));return ye._sessionId=Q._sessionId,ye._itemId=Q._itemId,ye}ge.to=_e;function ie(Q,ye,Le){if(ye=ye??Q._sessionId,Le=Le??Q._itemId,ye===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Le,name:Q.name,detail:Q.detail,kind:N.from(Q.kind),uri:Q.uri,range:o.from(Q.range),selectionRange:o.from(Q.selectionRange),tags:Q.tags?.map(U.from)}}ge.from=ie})(H=e.CallHierarchyItem||(e.CallHierarchyItem={}));var G;(function(ge){function _e(ie){return new b.CallHierarchyIncomingCall(H.to(ie.from),ie.fromRanges.map(Q=>o.to(Q)))}ge.to=_e})(G=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var K;(function(ge){function _e(ie){return new b.CallHierarchyOutgoingCall(H.to(ie.to),ie.fromRanges.map(Q=>o.to(Q)))}ge.to=_e})(K=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var X;(function(ge){function _e(Q){return{range:Q.range&&o.from(Q.range),uri:Q.uri}}ge.from=_e;function ie(Q){return new b.Location(P.URI.revive(Q.uri),o.to(Q.range))}ge.to=ie})(X=e.location||(e.location={}));var de;(function(ge){function _e(Q){const ye=Q,Le=Q;return{originSelectionRange:ye.originSelectionRange?o.from(ye.originSelectionRange):void 0,uri:ye.targetUri?ye.targetUri:Le.uri,range:o.from(ye.targetRange?ye.targetRange:Le.range),targetSelectionRange:ye.targetSelectionRange?o.from(ye.targetSelectionRange):void 0}}ge.from=_e;function ie(Q){return{targetUri:P.URI.revive(Q.uri),targetRange:o.to(Q.range),targetSelectionRange:Q.targetSelectionRange?o.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?o.to(Q.originSelectionRange):void 0}}ge.to=ie})(de=e.DefinitionLink||(e.DefinitionLink={}));var be;(function(ge){function _e(Q){return{range:o.from(Q.range),contents:p.fromMany(Q.contents)}}ge.from=_e;function ie(Q){return new b.Hover(Q.contents.map(p.to),o.to(Q.range))}ge.to=ie})(be=e.Hover||(e.Hover={}));var Se;(function(ge){function _e(Q){return{range:o.from(Q.range),expression:Q.expression}}ge.from=_e;function ie(Q){return new b.EvaluatableExpression(o.to(Q.range),Q.expression)}ge.to=ie})(Se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ie;(function(ge){function _e(Q){if(Q instanceof b.InlineValueText)return{type:"text",range:o.from(Q.range),text:Q.text};if(Q instanceof b.InlineValueVariableLookup)return{type:"variable",range:o.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}ge.from=_e;function ie(Q){switch(Q.type){case"text":return{range:o.to(Q.range),text:Q.text};case"variable":return{range:o.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:o.to(Q.range),expression:Q.expression}}}ge.to=ie})(Ie=e.InlineValue||(e.InlineValue={}));var Oe;(function(ge){function _e(Q){return{frameId:Q.frameId,stoppedLocation:o.from(Q.stoppedLocation)}}ge.from=_e;function ie(Q){return new b.InlineValueContext(Q.frameId,o.to(Q.stoppedLocation))}ge.to=ie})(Oe=e.InlineValueContext||(e.InlineValueContext={}));var xe;(function(ge){function _e(Q){return{range:o.from(Q.range),kind:Q.kind}}ge.from=_e;function ie(Q){return new b.DocumentHighlight(o.to(Q.range),Q.kind)}ge.to=ie})(xe=e.DocumentHighlight||(e.DocumentHighlight={}));var ze;(function(ge){function _e(ie){switch(ie){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}ge.to=_e})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var j;(function(ge){function _e(ie){return{triggerKind:ze.to(ie.triggerKind),triggerCharacter:ie.triggerCharacter}}ge.to=_e})(j=e.CompletionContext||(e.CompletionContext={}));var ee;(function(ge){function _e(Q){switch(Q){case b.CompletionItemTag.Deprecated:return 1}}ge.from=_e;function ie(Q){switch(Q){case 1:return b.CompletionItemTag.Deprecated}}ge.to=ie})(ee=e.CompletionItemTag||(e.CompletionItemTag={}));var re;(function(ge){const _e=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function ie(Le){return _e.get(Le)??9}ge.from=ie;const Q=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function ye(Le){return Q.get(Le)??b.CompletionItemKind.Property}ge.to=ye})(re=e.CompletionItemKind||(e.CompletionItemKind={}));var le;(function(ge){function _e(ie,Q){const ye=new b.CompletionItem(ie.label);return ye.insertText=ie.insertText,ye.kind=re.to(ie.kind),ye.tags=ie.tags?.map(ee.to),ye.detail=ie.detail,ye.documentation=C.isMarkdownString(ie.documentation)?p.to(ie.documentation):ie.documentation,ye.sortText=ie.sortText,ye.filterText=ie.filterText,ye.preselect=ie.preselect,ye.commitCharacters=ie.commitCharacters,n.Range.isIRange(ie.range)?ye.range=o.to(ie.range):typeof ie.range=="object"&&(ye.range={inserting:o.to(ie.range.insert),replacing:o.to(ie.range.replace)}),ye.keepWhitespace=typeof ie.insertTextRules=="undefined"?!1:Boolean(ie.insertTextRules&1),typeof ie.insertTextRules!="undefined"&&ie.insertTextRules&4?ye.insertText=new b.SnippetString(ie.insertText):(ye.insertText=ie.insertText,ye.textEdit=ye.range instanceof b.Range?new b.TextEdit(ye.range,ye.insertText):void 0),ie.additionalTextEdits&&ie.additionalTextEdits.length>0&&(ye.additionalTextEdits=ie.additionalTextEdits.map(Le=>O.to(Le))),ye.command=Q&&ie.command?Q.fromInternal(ie.command):void 0,ye}ge.to=_e})(le=e.CompletionItem||(e.CompletionItem={}));var Z;(function(ge){function _e(Q){return{label:Q.label,documentation:Q.documentation?p.fromStrict(Q.documentation):void 0}}ge.from=_e;function ie(Q){return{label:Q.label,documentation:C.isMarkdownString(Q.documentation)?p.to(Q.documentation):Q.documentation}}ge.to=ie})(Z=e.ParameterInformation||(e.ParameterInformation={}));var ae;(function(ge){function _e(Q){return{label:Q.label,documentation:Q.documentation?p.fromStrict(Q.documentation):void 0,parameters:Array.isArray(Q.parameters)?Q.parameters.map(Z.from):[],activeParameter:Q.activeParameter}}ge.from=_e;function ie(Q){return{label:Q.label,documentation:C.isMarkdownString(Q.documentation)?p.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(Z.to):[],activeParameter:Q.activeParameter}}ge.to=ie})(ae=e.SignatureInformation||(e.SignatureInformation={}));var pe;(function(ge){function _e(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(ae.from):[]}}ge.from=_e;function ie(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(ae.to):[]}}ge.to=ie})(pe=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(ge){function _e(Q){return{text:Q.text,position:t.from(Q.position),kind:qe.from(Q.kind??b.InlayHintKind.Other),whitespaceBefore:Q.whitespaceBefore,whitespaceAfter:Q.whitespaceAfter}}ge.from=_e;function ie(Q){const ye=new b.InlayHint(Q.text,t.to(Q.position),qe.to(Q.kind));return ye.whitespaceAfter=Q.whitespaceAfter,ye.whitespaceBefore=Q.whitespaceBefore,ye}ge.to=ie})(Me=e.InlayHint||(e.InlayHint={}));var qe;(function(ge){function _e(Q){return Q}ge.from=_e;function ie(Q){return Q}ge.to=ie})(qe=e.InlayHintKind||(e.InlayHintKind={}));var Qe;(function(ge){function _e(Q){return{range:o.from(Q.range),url:Q.target,tooltip:Q.tooltip}}ge.from=_e;function ie(Q){let ye;if(Q.url)try{ye=typeof Q.url=="string"?P.URI.parse(Q.url,!0):P.URI.revive(Q.url)}catch(Le){}return new b.DocumentLink(o.to(Q.range),ye)}ge.to=ie})(Qe=e.DocumentLink||(e.DocumentLink={}));var Je;(function(ge){function _e(Q){const ye=new b.ColorPresentation(Q.label);return Q.textEdit&&(ye.textEdit=O.to(Q.textEdit)),Q.additionalTextEdits&&(ye.additionalTextEdits=Q.additionalTextEdits.map(Le=>O.to(Le))),ye}ge.to=_e;function ie(Q){return{label:Q.label,textEdit:Q.textEdit?O.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(ye=>O.from(ye)):void 0}}ge.from=ie})(Je=e.ColorPresentation||(e.ColorPresentation={}));var rt;(function(ge){function _e(Q){return new b.Color(Q[0],Q[1],Q[2],Q[3])}ge.to=_e;function ie(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}ge.from=ie})(rt=e.Color||(e.Color={}));var Ae;(function(ge){function _e(Q){return{range:o.from(Q.range)}}ge.from=_e;function ie(Q){return new b.SelectionRange(o.to(Q.range))}ge.to=ie})(Ae=e.SelectionRange||(e.SelectionRange={}));var nt;(function(ge){function _e(ie){switch(ie){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}ge.to=_e})(nt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var J;(function(ge){function _e(Q){switch(Q){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}ge.from=_e;function ie(Q){switch(Q){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}ge.to=ie})(J=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var te;(function(ge){function _e(Q){if(Q===b.EndOfLine.CRLF)return 1;if(Q===b.EndOfLine.LF)return 0}ge.from=_e;function ie(Q){if(Q===1)return b.EndOfLine.CRLF;if(Q===0)return b.EndOfLine.LF}ge.to=ie})(te=e.EndOfLine||(e.EndOfLine={}));var ve;(function(ge){function _e(ie){if(typeof ie=="object")return ie.viewId;switch(ie){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ge.from=_e})(ve=e.ProgressLocation||(e.ProgressLocation={}));var Xe;(function(ge){function _e(ie){const Q={start:ie.start+1,end:ie.end+1};return ie.kind&&(Q.kind=tt.from(ie.kind)),Q}ge.from=_e})(Xe=e.FoldingRange||(e.FoldingRange={}));var tt;(function(ge){function _e(ie){if(ie)switch(ie){case b.FoldingRangeKind.Comment:return k.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return k.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return k.FoldingRangeKind.Region}}ge.from=_e})(tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ct;(function(ge){function _e(ie){if(ie)return{pinned:typeof ie.preview=="boolean"?!ie.preview:void 0,inactive:ie.background,preserveFocus:ie.preserveFocus,selection:typeof ie.selection=="object"?o.from(ie.selection):void 0,override:typeof ie.override=="boolean"?a.EditorResolution.DISABLED:void 0}}ge.from=_e})(ct=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ut;(function(ge){function _e(Q){return Q instanceof b.RelativePattern||typeof Q=="string"?Q:ie(Q)?new b.RelativePattern(Q.base,Q.pattern):Q}ge.from=_e;function ie(Q){const ye=Q;return ye&&typeof ye.base=="string"&&typeof ye.pattern=="string"}})(ut=e.GlobPattern||(e.GlobPattern={}));var _t;(function(ge){function _e(ie){if(ie){if(Array.isArray(ie))return ie.map(_e);if(typeof ie=="string")return ie;{const Q=ie;return{language:Q.language,scheme:Q.scheme,pattern:typeof Q.pattern=="undefined"?void 0:ut.from(Q.pattern),exclusive:Q.exclusive}}}else return}ge.from=_e})(_t=e.LanguageSelector||(e.LanguageSelector={}));var ce;(function(ge){function _e(Q){return{start:Q.start,end:Q.end}}ge.from=_e;function ie(Q){return new b.NotebookRange(Q.start,Q.end)}ge.to=ie})(ce=e.NotebookRange||(e.NotebookRange={}));var Pe;(function(ge){function _e(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}ge.to=_e;function ie(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}ge.from=ie})(Pe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var We;(function(ge){function _e(Q){switch(Q){case b.NotebookCellKind.Markup:return v.CellKind.Markup;case b.NotebookCellKind.Code:default:return v.CellKind.Code}}ge.from=_e;function ie(Q){switch(Q){case v.CellKind.Markup:return b.NotebookCellKind.Markup;case v.CellKind.Code:default:return b.NotebookCellKind.Code}}ge.to=ie})(We=e.NotebookCellKind||(e.NotebookCellKind={}));var Ye;(function(ge){function _e(Q){const ye={metadata:Q.metadata??Object.create(null),cells:[]};for(let Le of Q.cells)b.NotebookCellData.validate(Le),ye.cells.push($e.from(Le));return ye}ge.from=_e;function ie(Q){const ye=new b.NotebookData(Q.cells.map($e.to));return(0,S.isEmptyObject)(Q.metadata)||(ye.metadata=Q.metadata),ye}ge.to=ie})(Ye=e.NotebookData||(e.NotebookData={}));var $e;(function(ge){function _e(Q){return{cellKind:We.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:Pe.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(Te.from):[]}}ge.from=_e;function ie(Q){return new b.NotebookCellData(We.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(Te.to):void 0,Q.metadata,Q.internalMetadata?Pe.to(Q.internalMetadata):void 0)}ge.to=ie})($e=e.NotebookCellData||(e.NotebookCellData={}));var lt;(function(ge){function _e(Q){return{mime:Q.mime,valueBytes:F.VSBuffer.wrap(Q.data)}}ge.from=_e;function ie(Q){return new b.NotebookCellOutputItem(Q.valueBytes.buffer,Q.mime)}ge.to=ie})(lt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Te;(function(ge){function _e(Q){return{outputId:Q.id,items:Q.items.map(lt.from),metadata:Q.metadata}}ge.from=_e;function ie(Q){const ye=Q.items.map(lt.to);return new b.NotebookCellOutput(ye,Q.outputId,Q.metadata)}ge.to=ie})(Te=e.NotebookCellOutput||(e.NotebookCellOutput={}));var De;(function(ge){function _e(Le){if(Le!=null){if(Le instanceof b.RelativePattern||typeof Le=="string")return Le;if(ye(Le))return new b.RelativePattern(Le.base,Le.pattern);if(Q(Le))return{include:ut.from(Le.include)||void 0,exclude:ut.from(Le.exclude)||void 0}}}ge.from=_e;function ie(Le){return typeof Le=="string"?Le:ye(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}ge.to=ie;function Q(Le){const it=Le,Ke=ut.from(it.include);if(!(Ke&&Ke instanceof b.RelativePattern||typeof Ke=="string"))return!1;const pt=ut.from(it.exclude);return!!(pt&&pt instanceof b.RelativePattern||typeof pt=="string")}function ye(Le){const it=Le;return it&&typeof it.base=="string"&&typeof it.pattern=="string"}})(De=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ke;(function(ge){function _e(ie){return{backgroundColor:ie.backgroundColor,borderColor:ie.borderColor,top:ie.top?M.from(ie.top):void 0}}ge.from=_e})(ke=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ne;(function(ge){function _e(ie,Q,ye){const Le=typeof ie.command=="string"?{title:"",command:ie.command}:ie.command;return{alignment:ie.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Le,ye),text:ie.text,tooltip:ie.tooltip,accessibilityInformation:ie.accessibilityInformation,priority:ie.priority}}ge.from=_e})(ne=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(ge){function _e(ie){return{transientOutputs:ie?.transientOutputs??!1,transientCellMetadata:ie?.transientCellMetadata??{},transientDocumentMetadata:ie?.transientDocumentMetadata??{}}}ge.from=_e})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ee;(function(ge){function _e(Q){return{uri:Q.uri,provides:Q.provides}}ge.from=_e;function ie(Q){return new b.NotebookRendererScript(P.URI.revive(Q.uri),Q.provides)}ge.to=ie})(Ee=e.NotebookRendererScript||(e.NotebookRendererScript={}));var we;(function(ge){function _e(Q){return{message:p.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,location:Q.location?X.from(Q.location):void 0}}ge.from=_e;function ie(Q){const ye=new b.TestMessage(typeof Q.message=="string"?Q.message:p.to(Q.message));return ye.actualOutput=Q.actual,ye.expectedOutput=Q.expected,ye.location=Q.location?X.to(Q.location):void 0,ye}ge.to=ie})(we=e.TestMessage||(e.TestMessage={}));var Fe;(function(ge){let _e;(function(ie){ie.Delimiter="\0"})(_e||(_e={})),ge.namespace=(ie,Q)=>ie+"\0"+Q,ge.denamespace=ie=>{const Q=ie.indexOf("\0");return{ctrlId:ie.slice(0,Q),tagId:ie.slice(Q+1)}}})(Fe=e.TestTag||(e.TestTag={}));var Ge;(function(ge){function _e(Le){const it=(0,d.getPrivateApiFor)(Le).controllerId;return{extId:D.TestId.fromExtHostTestItem(Le,it).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(Ke=>Fe.namespace(it,Ke.id)),range:o.from(Le.range)||null,description:Le.description||null,error:Le.error&&p.fromStrict(Le.error)||null}}ge.from=_e;function ie(Le){return{id:D.TestId.fromString(Le.extId).localId,label:Le.label,uri:P.URI.revive(Le.uri),tags:(Le.tags||[]).map(it=>{const{tagId:Ke}=Fe.denamespace(it);return new b.TestTag(Ke)}),range:o.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}ge.toPlain=ie;function Q(Le){const it=D.TestId.fromString(Le.extId),Ke=new d.TestItemImpl(it.controllerId,it.localId,Le.label,P.URI.revive(Le.uri));return Ke.range=o.to(Le.range||void 0),Ke.description=Le.description||void 0,Ke}function ye(Le){let it;for(const Ke of Le.tests){const pt=Q(Ke.item);(0,d.getPrivateApiFor)(pt).parent=it,it=pt}return it}ge.toItemFromContext=ye})(Ge=e.TestItem||(e.TestItem={})),function(ge){function _e(Q){return{id:Q.id}}ge.from=_e;function ie(Q){return new b.TestTag(Q.id)}ge.to=ie}(Fe=e.TestTag||(e.TestTag={}));var Ve;(function(ge){const _e=(Q,ye)=>{const Le={...Ge.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(it=>({state:it.state,duration:it.duration,messages:it.messages.filter(Ke=>Ke.type===0).map(we.to)})),children:Q.children.map(it=>ye.get(it)).filter(S.isDefined).map(it=>_e(it,ye))};for(const it of Le.children)it.parent=Le;return Le};function ie(Q){const ye=[],Le=new Map;for(const it of Q.items)Le.set(it.item.extId,it),Q.request.targets.some(Ke=>Ke.controllerId===it.controllerId&&Ke.testIds.includes(it.item.extId))&&ye.push(it);return{completedAt:Q.completedAt,results:ye.map(it=>_e(it,Le))}}ge.to=ie})(Ve=e.TestResults||(e.TestResults={}));var et;(function(ge){function _e(Le){return{covered:Le.covered,total:Le.covered}}function ie(Le){return"line"in Le?t.from(Le):o.from(Le)}function Q(Le){return"branches"in Le?{count:Le.executionCount,location:ie(Le.location),type:1,branches:Le.branches.length?Le.branches.map(it=>({count:it.executionCount,location:it.location&&ie(it.location)})):void 0}:{type:0,count:Le.executionCount,location:ie(Le.location)}}ge.fromDetailed=Q;function ye(Le){return{uri:Le.uri,statement:_e(Le.statementCoverage),branch:Le.branchCoverage&&_e(Le.branchCoverage),function:Le.functionCoverage&&_e(Le.functionCoverage),details:Le.detailedCoverage?.map(Q)}}ge.fromFile=ye})(et=e.TestCoverage||(e.TestCoverage={}));var ot;(function(ge){function _e(ie){switch(ie){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}ge.to=_e})(ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Be;(function(ge){function _e(Q){const ye=new b.TypeHierarchyItem(N.to(Q.kind),Q.name,Q.detail||"",P.URI.revive(Q.uri),o.to(Q.range),o.to(Q.selectionRange));return ye._sessionId=Q._sessionId,ye._itemId=Q._itemId,ye}ge.to=_e;function ie(Q,ye,Le){if(ye=ye??Q._sessionId,Le=Le??Q._itemId,ye===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Le,kind:N.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:o.from(Q.range),selectionRange:o.from(Q.selectionRange),tags:Q.tags?.map(U.from)}}ge.from=ie})(Be=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(fe[219],me([0,1,2,18,7,15,95]),function(Y,e,f,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class _{constructor(P,n,k,a={timeout:1500,errors:3}){this._logService=P,this._documents=n,this._mainThreadBulkEdits=k,this._thresholds=a,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(n,k,a)=>{const d={dispose:this._callbacks.push([n,k,P])};return Array.isArray(a)&&a.push(d),d}}async $participateInSave(P,n){const k=f.URI.revive(P);let a=!1;const m=setTimeout(()=>a=!0,this._thresholds.timeout),d=[];try{for(let v of[...this._callbacks]){if(a)break;const D=this._documents.getDocument(k),I=await this._deliverEventAsyncAndBlameBadListeners(v,{document:D,reason:y.TextDocumentSaveReason.to(n)});d.push(I)}}finally{clearTimeout(m)}return d}_deliverEventAsyncAndBlameBadListeners([P,n,k],a){const m=this._badListeners.get(P);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,P,n,a).then(()=>!0,d=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(d),!(d instanceof Error)||d.message!=="concurrent_edits"){const v=this._badListeners.get(P);this._badListeners.set(P,v?v+1:1),typeof v=="number"&&v>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,n,k,a){const m=[],d=Date.now(),{document:v,reason:D}=a,{version:I}=v,b=Object.freeze({document:v,reason:D,waitUntil(l){if(Object.isFrozen(m))throw(0,F.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(l))}});try{n.apply(k,[b])}catch(l){return Promise.reject(l)}return Object.freeze(m),new Promise((l,o)=>{const g=setTimeout(()=>o(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-d}ms`),clearTimeout(g),l(t)}).catch(t=>{clearTimeout(g),o(t)})}).then(l=>{const o={edits:[]};for(const g of l)if(Array.isArray(g)&&g.every(t=>t instanceof C.TextEdit))for(const{newText:t,newEol:u,range:r}of g)o.edits.push({_type:2,resource:v.uri,edit:{range:r&&y.Range.from(r),text:t,eol:u&&y.EndOfLine.from(u)}});if(o.edits.length!==0)return I===v.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=_}),define(fe[220],me([0,1,3,30,2,15,7]),function(Y,e,f,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{constructor(n,k,a,m,d){this._onDidCreate=new f.Emitter,this._onDidChange=new f.Emitter,this._onDidDelete=new f.Emitter,this._config=0,a&&(this._config+=1),m&&(this._config+=2),d&&(this._config+=4);const v=(0,F.parse)(k),D=n(I=>{if(!a)for(let b of I.created){const l=C.URI.revive(b);v(l.fsPath)&&this._onDidCreate.fire(l)}if(!m)for(let b of I.changed){const l=C.URI.revive(b);v(l.fsPath)&&this._onDidChange.fire(l)}if(!d)for(let b of I.deleted){const l=C.URI.revive(b);v(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=A.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,D)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(n,k,a){this._logService=k,this._extHostDocumentsAndEditors=a,this._onFileSystemEvent=new f.Emitter,this._onDidRenameFile=new f.Emitter,this._onDidCreateFile=new f.Emitter,this._onDidDeleteFile=new f.Emitter,this._onWillRenameFile=new f.AsyncEmitter,this._onWillCreateFile=new f.AsyncEmitter,this._onWillDeleteFile=new f.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,k,a,m){return new _(this._onFileSystemEvent.event,n,k,a,m)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,k){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:k.map(a=>({oldUri:C.URI.revive(a.source),newUri:C.URI.revive(a.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:k.map(a=>C.URI.revive(a.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:k.map(a=>C.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,k){return(a,m,d)=>{const v=function(I){a.call(m,I)};return v.extension=n,k.event(v,void 0,d)}}async $onWillRunFileOperation(n,k,a,m){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:k.map(d=>({oldUri:C.URI.revive(d.source),newUri:C.URI.revive(d.target)}))},a,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:k.map(d=>C.URI.revive(d.target))},a,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:k.map(d=>C.URI.revive(d.target))},a,m)}}async _fireWillEvent(n,k,a,m){const d=new Set,v=[];if(await n.fireAsync(k,m,async(I,b)=>{const l=Date.now(),o=await Promise.resolve(I);o instanceof A.WorkspaceEdit&&(v.push(o),d.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-l>a&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),m.isCancellationRequested||v.length===0)return;const D={edits:[]};for(let I of v){let{edits:b}=y.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);D.edits=D.edits.concat(b)}return{edit:D,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=S}),define(fe[221],me([0,1,10,25,2,15,7,128]),function(Y,e,f,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(a,m,d,v){this.start=a,this.deletedCount=m,this.deletedItems=d,this.items=v}static asApiEvents(a){return a.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(d=>d.apiCell)}))}}class P{constructor(a,m,d){this.notebook=a,this._extHostDocument=m,this._cellData=d,this.handle=d.handle,this.uri=C.URI.revive(d.uri),this.cellKind=d.cellKind,this._outputs=d.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=d.internalMetadata??{},this._metadata=Object.freeze(d.metadata??{}),this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(d.internalMetadata??{}))}static asModelAddData(a,m){return{EOL:m.eol,lines:m.source,modeId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:a}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const a=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return a.notebook.getCellIndex(a)},notebook:a.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return a._mime},set mime(d){a._mime=d},get outputs(){return a._outputs.slice(0)},get metadata(){return a._metadata},get executionSummary(){return a._previousResult}})}return this._apiCell}setOutputs(a){this._outputs=a.map(y.NotebookCellOutput.to)}setOutputItems(a,m,d){const v=d.map(y.NotebookCellOutputItem.to),D=this._outputs.find(I=>I.id===a);D&&(m||(D.items.length=0),D.items.push(...v))}setMetadata(a){this._metadata=Object.freeze(a)}setInternalMetadata(a){this._internalMetadata=a,this._previousResult=Object.freeze(y.NotebookCellExecutionSummary.to(a))}setMime(a){}}e.ExtHostCell=P;class n{constructor(a,m,d,v,D,I){this._proxy=a,this._textDocumentsAndEditors=m,this._textDocuments=d,this._emitter=v,this.uri=D,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=I.viewType,this._metadata=Object.freeze(I.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,I.cells]],!0),this._versionId=I.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const a=this;this._notebook={get uri(){return a.uri},get version(){return a._versionId},get notebookType(){return a._notebookType},get isDirty(){return a._isDirty},get isUntitled(){return a.uri.scheme===f.Schemas.untitled},get isClosed(){return a._disposed},get metadata(){return a._metadata},get cellCount(){return a._cells.length},cellAt(m){return m=a._validateIndex(m),a._cells[m].apiCell},getCells(m){return(m?a._getCells(m):a._cells).map(v=>v.apiCell)},save(){return a._save()}}}return this._notebook}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(a){a.metadata&&(this._metadata=Object.freeze({...this._metadata,...a.metadata}))}acceptDirty(a){this._isDirty=a}acceptModelChanged(a,m){this._versionId=a.versionId,this._isDirty=m;for(const d of a.rawEvents)d.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1):d.kind===_.NotebookCellsChangeType.Move?this._moveCell(d.index,d.newIdx):d.kind===_.NotebookCellsChangeType.Output?this._setCellOutputs(d.index,d.outputs):d.kind===_.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems):d.kind===_.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(d.index,d.language):d.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(d.index,d.mime):d.kind===_.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(d.index,d.metadata):d.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(d.index,d.internalMetadata)}_validateIndex(a){return a=a|0,a<0?0:a>=this._cells.length?this._cells.length-1:a}_validateRange(a){let m=a.start|0,d=a.end|0;return m<0&&(m=0),d>this._cells.length&&(d=this._cells.length),a.with({start:m,end:d})}_getCells(a){a=this._validateRange(a);const m=[];for(let d=a.start;d<a.end;d++)m.push(this._cells[d]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(a,m){if(this._disposed)return;const d=[],v=[],D=[];a.reverse().forEach(I=>{const l=I[2].map(t=>{const u=new P(this,this._textDocumentsAndEditors,t);return m||v.push(P.asModelAddData(this.apiNotebook,t)),u}),o=new S(I[0],I[1],[],l),g=this._cells.splice(I[0],I[1],...l);for(const t of g)D.push(t.uri),o.deletedItems.push(t.apiCell);d.push(o)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:D}),m||this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(d)}))}_moveCell(a,m){const d=this._cells.splice(a,1);this._cells.splice(m,0,...d);const v=[new S(a,1,d.map(D=>D.apiCell),[]),new S(m,0,[],d)];this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(v)}))}_setCellOutputs(a,m){const d=this._cells[a];d.setOutputs(m),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[d.apiCell]}))}_setCellOutputItems(a,m,d,v){const D=this._cells[a];D.setOutputItems(m,d,v),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[D.apiCell]}))}_changeCellLanguage(a,m){const d=this._cells[a];d.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(d.uri,m)}_changeCellMime(a,m){const d=this._cells[a];d.apiCell.mime=m}_changeCellMetadata(a,m){const d=this._cells[a],v=d.apiCell.metadata;d.setMetadata(m);const D=d.apiCell.metadata;(0,F.equals)(v,D)||this._emitter.emitCellMetadataChange((0,F.deepFreeze)({document:this.apiNotebook,cell:d.apiCell}))}_changeCellInternalMetadata(a,m){const d=this._cells[a],v=d.internalMetadata;if(d.setInternalMetadata(m),v.runState!==m.runState){const D=m.runState??A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,F.deepFreeze)({document:this.apiNotebook,cell:d.apiCell,state:D}))}}getCellFromApiCell(a){return this._cells.find(m=>m.apiCell===a)}getCellFromIndex(a){return this._cells[a]}getCell(a){return this._cells.find(m=>m.handle===a)}getCellIndex(a){return this._cells.indexOf(a)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(fe[131],me([0,1,7,15,18]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class y{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:P})}replaceCells(S,P,n){this._throwIfFinalized(),!(S===P&&n.length===0)&&this._collectedEdits.push({editType:1,index:S,count:P-S,cells:n.map(F.NotebookCellData.from)})}}class A{constructor(S,P,n,k,a,m){this.id=S,this._proxy=P,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=a,this._visibleRanges=k,this._viewColumn=m}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(P){if(!Array.isArray(P)||!P.every(f.NotebookRange.isNotebookRange))throw(0,C.illegalArgument)("selections");S._selections=P,S._trySetSelections(P)},get visibleRanges(){return S._visibleRanges},revealRange(P,n){S._proxy.$tryRevealRange(S.id,F.NotebookRange.from(P),n??f.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(P){const n=new y(this.document.version);return P(n),S._applyEdit(n.finalize())},setDecorations(P,n){return S.setDecorations(P,n)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(F.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const P=[];let n=-1;for(let k=0;k<S.cellEdits.length;k++){if(n<0){P.push(S.cellEdits[k]),n++;continue}const m=P[n],d=S.cellEdits[k];if(m.editType===1&&d.editType===1&&m.index===d.index){m.cells.push(...S.cellEdits[k].cells),m.count+=S.cellEdits[k].count;continue}P.push(S.cellEdits[k]),n++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,P)}setDecorations(S,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return P.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,F.NotebookRange.from(P),S.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(fe[222],me([0,1,15,119,167,21,59]),function(Y,e,f,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class _{constructor(k){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=k}withProgress(k,a,m){const d=this._handles++,{title:v,location:D,cancellable:I}=a,b={label:(0,C.localize)(0,null,k.displayName||k.name),id:k.identifier.value};return this._proxy.$startProgress(d,{location:f.ProgressLocation.from(D),title:v,source:b,cancellable:I},k),this._withProgress(d,m,!!I)}_withProgress(k,a,m){let d;m&&(d=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(k,d));const v=I=>{this._proxy.$progressEnd(I),this._mapHandleToCancellationSource.delete(I),d&&d.dispose()};let D;try{D=a(new P(this._proxy,k),m&&d?d.token:y.CancellationToken.None)}catch(I){throw v(k),I}return D.then(I=>v(k),I=>v(k)),D}$acceptProgressCanceled(k){const a=this._mapHandleToCancellationSource.get(k);a&&(a.cancel(),this._mapHandleToCancellationSource.delete(k))}}e.ExtHostProgress=_;function S(n,k){return n.message=k.message,typeof k.increment=="number"&&(typeof n.increment=="number"?n.increment+=k.increment:n.increment=k.increment),n}class P extends F.Progress{constructor(k,a){super(m=>this.throttledReport(m));this._proxy=k,this._handle=a}throttledReport(k){this._proxy.$progressReport(this._handle,k)}}je([(0,A.throttle)(100,(n,k)=>S(n,k),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(fe[132],me([0,1,57,18,76,15,7]),function(Y,e,f,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class _{constructor(a,m,d){const v=_._Keys.nextId();a.$registerTextEditorDecorationType(m.identifier,v,y.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:v,dispose(){a.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=_,_._Keys=new C.IdGenerator("TextEditorDecorationType");class S{constructor(a,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=a,this._documentVersionId=a.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(a,m){this._throwIfFinalized();let d=null;if(a instanceof A.Position)d=new A.Range(a,a);else if(a instanceof A.Range)d=a;else throw new Error("Unrecognized location");this._pushEdit(d,m,!1)}insert(a,m){this._throwIfFinalized(),this._pushEdit(new A.Range(a,a),m,!0)}delete(a){this._throwIfFinalized();let m=null;if(a instanceof A.Range)m=a;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(a,m,d){const v=this._document.validateRange(a);this._collectedEdits.push({range:v,text:m,forceMoveMarkers:d})}setEndOfLine(a){if(this._throwIfFinalized(),a!==A.EndOfLine.LF&&a!==A.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=a}}e.TextEditorEdit=S;class P{constructor(a,m,d,v){this._proxy=a,this._id=m,this._accept(d),this._logService=v;const D=this;this.value={get tabSize(){return D._tabSize},set tabSize(I){D._setTabSize(I)},get insertSpaces(){return D._insertSpaces},set insertSpaces(I){D._setInsertSpaces(I)},get cursorStyle(){return D._cursorStyle},set cursorStyle(I){D._setCursorStyle(I)},get lineNumbers(){return D._lineNumbers},set lineNumbers(I){D._setLineNumbers(I)}}}_accept(a){this._tabSize=a.tabSize,this._insertSpaces=a.insertSpaces,this._cursorStyle=a.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(a.lineNumbers)}_validateTabSize(a){if(a==="auto")return"auto";if(typeof a=="number"){const m=Math.floor(a);return m>0?m:null}if(typeof a=="string"){const m=parseInt(a,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(a){const m=this._validateTabSize(a);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(a){return a==="auto"?"auto":a==="false"?!1:Boolean(a)}_setInsertSpaces(a){const m=this._validateInsertSpaces(a);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(a){this._cursorStyle!==a&&(this._cursorStyle=a,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:a})))}_setLineNumbers(a){this._lineNumbers!==a&&(this._lineNumbers=a,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(a)})))}assign(a){const m={};let d=!1;if(typeof a.tabSize!="undefined"){const v=this._validateTabSize(a.tabSize);v==="auto"?(d=!0,m.tabSize=v):typeof v=="number"&&this._tabSize!==v&&(this._tabSize=v,d=!0,m.tabSize=v)}if(typeof a.insertSpaces!="undefined"){const v=this._validateInsertSpaces(a.insertSpaces);v==="auto"?(d=!0,m.insertSpaces=v):this._insertSpaces!==v&&(this._insertSpaces=v,d=!0,m.insertSpaces=v)}typeof a.cursorStyle!="undefined"&&this._cursorStyle!==a.cursorStyle&&(this._cursorStyle=a.cursorStyle,d=!0,m.cursorStyle=a.cursorStyle),typeof a.lineNumbers!="undefined"&&this._lineNumbers!==a.lineNumbers&&(this._lineNumbers=a.lineNumbers,d=!0,m.lineNumbers=y.TextEditorLineNumbersStyle.from(a.lineNumbers)),d&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(a){a.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=P;class n{constructor(a,m,d,v,D,I,b,l){this.id=a,this._proxy=m,this._logService=d,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=D,this._options=new P(this._proxy,this.id,I,d),this._visibleRanges=b,this._viewColumn=l;const o=this;this.value=Object.freeze({get document(){return v.getValue()},set document(g){throw(0,F.readonly)("document")},get selection(){return o._selections&&o._selections[0]},set selection(g){if(!(g instanceof A.Selection))throw(0,F.illegalArgument)("selection");o._selections=[g],o._trySetSelection()},get selections(){return o._selections},set selections(g){if(!Array.isArray(g)||g.some(t=>!(t instanceof A.Selection)))throw(0,F.illegalArgument)("selections");o._selections=g,o._trySetSelection()},get visibleRanges(){return o._visibleRanges},set visibleRanges(g){throw(0,F.readonly)("visibleRanges")},get options(){return o._options.value},set options(g){o._disposed||o._options.assign(g)},get viewColumn(){return o._viewColumn},set viewColumn(g){throw(0,F.readonly)("viewColumn")},edit(g,t={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new S(v.getValue(),t);return g(u),o._applyEdit(u)},insertSnippet(g,t,u={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=o._selections.map(i=>y.Range.from(i));else if(t instanceof A.Position){const{lineNumber:i,column:s}=y.Position.from(t);r=[{startLineNumber:i,startColumn:s,endLineNumber:i,endColumn:s}]}else if(t instanceof A.Range)r=[y.Range.from(t)];else{r=[];for(const i of t)if(i instanceof A.Range)r.push(y.Range.from(i));else{const{lineNumber:s,column:c}=y.Position.from(i);r.push({startLineNumber:s,startColumn:c,endLineNumber:s,endColumn:c})}}return m.$tryInsertSnippet(a,g.value,r,u)},setDecorations(g,t){const u=t.length===0;u&&!o._hasDecorationsForKey.has(g.key)||(u?o._hasDecorationsForKey.delete(g.key):o._hasDecorationsForKey.add(g.key),o._runOnProxy(()=>{if(y.isDecorationOptionsArr(t))return m.$trySetDecorations(a,g.key,y.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let i=0,s=t.length;i<s;i++){const c=t[i];r[4*i]=c.start.line+1,r[4*i+1]=c.start.character+1,r[4*i+2]=c.end.line+1,r[4*i+3]=c.end.character+1}return m.$trySetDecorationsFast(a,g.key,r)}}))},revealRange(g,t){o._runOnProxy(()=>m.$tryRevealRange(a,y.Range.from(g),t||A.TextEditorRevealType.Default))},show(g){m.$tryShowEditor(a,y.ViewColumn.from(g))},hide(){m.$tryHideEditor(a)}})}dispose(){(0,f.ok)(!this._disposed),this._disposed=!0}_acceptOptions(a){(0,f.ok)(!this._disposed),this._options._accept(a)}_acceptVisibleRanges(a){(0,f.ok)(!this._disposed),this._visibleRanges=a}_acceptViewColumn(a){(0,f.ok)(!this._disposed),this._viewColumn=a}_acceptSelections(a){(0,f.ok)(!this._disposed),this._selections=a}async _trySetSelection(){const a=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,a)),this.value}_applyEdit(a){const m=a.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const d=m.edits.map(D=>D.range);d.sort((D,I)=>D.end.line===I.end.line?D.end.character===I.end.character?D.start.line===I.start.line?D.start.character-I.start.character:D.start.line-I.start.line:D.end.character-I.end.character:D.end.line-I.end.line);for(let D=0,I=d.length-1;D<I;D++){const b=d[D].end;if(d[D+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=m.edits.map(D=>({range:y.Range.from(D.range),text:D.text,forceMoveMarkers:D.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,v,{setEndOfLine:typeof m.setEndOfLine=="number"?y.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(a){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=n}),define(fe[223],me([0,1,170,23,2,3,6,210,17,7,12,16,15,21,207]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function v(b,l){if((0,n.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let o;return Array.isArray(b.highlights)&&(o=b.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),o=o.length?o:void 0),{label:b.label,highlights:o}}}class D{constructor(l,o,g){this._proxy=l,this.commands=o,this.logService=g,this.treeViews=new Map;function t(u){return u&&u.$treeViewId&&u.$treeItemHandle}o.registerArgumentProcessor({processArgument:u=>t(u)?this.convertArgument(u):Array.isArray(u)&&u.length>0?u.map(r=>t(r)?this.convertArgument(r):r):u})}registerTreeDataProvider(l,o,g){const t=this.createTreeView(l,{treeDataProvider:o},g);return{dispose:()=>t.dispose()}}createTreeView(l,o,g){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=o.dragAndDropController!==void 0,u=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,canDragAndDrop:t}),r=this.createExtHostTreeView(l,o,g);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(i){r.message=i},get title(){return r.title},set title(i){r.title=i},get description(){return r.description},set description(i){r.description=i},reveal:(i,s)=>r.reveal(i,s),dispose:async()=>{await u,this.treeViews.delete(l),r.dispose()}}}$getChildren(l,o){const g=this.treeViews.get(l);return g?g.getChildren(o):Promise.reject(new Error((0,f.localize)(0,null,l)))}async $onDrop(l,o,g){const t=this.treeViews.get(l);if(!t)return Promise.reject(new Error((0,f.localize)(1,null,l)));const u=d.TreeDataTransferConverter.toITreeDataTransfer(o);if(u.items.has(_.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await u.items.get(_.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(s=>t.getExtensionElement(s)).filter(s=>!!s);i.length>0?u.items.set(_.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):u.items.delete(_.TREE_ITEM_DATA_TRANSFER_TYPE)}return t.onDrop(u,g)}async $hasResolve(l){const o=this.treeViews.get(l);if(!o)throw new Error((0,f.localize)(2,null,l));return o.hasResolve}$resolve(l,o,g){const t=this.treeViews.get(l);if(!t)throw new Error((0,f.localize)(3,null,l));return t.resolveTreeItem(o,g)}$setExpanded(l,o,g){const t=this.treeViews.get(l);if(!t)throw new Error((0,f.localize)(4,null,l));t.setExpanded(o,g)}$setSelection(l,o){const g=this.treeViews.get(l);if(!g)throw new Error((0,f.localize)(5,null,l));g.setSelection(o)}$setVisible(l,o){const g=this.treeViews.get(l);if(!g)throw new Error((0,f.localize)(6,null,l));g.setVisible(o)}createExtHostTreeView(l,o,g){const t=new I(l,o,this._proxy,this.commands.converter,this.logService,g);return this.treeViews.set(l,t),t}convertArgument(l){const o=this.treeViews.get(l.$treeViewId);return o?o.getExtensionElement(l.$treeItemHandle):null}}e.ExtHostTreeViews=D;class I extends A.Disposable{constructor(l,o,g,t,u,r){super();if(this.viewId=l,this.proxy=g,this.commands=t,this.logService=u,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,r.contributes&&r.contributes.views)for(const c in r.contributes.views)for(const h of r.contributes.views[c])h.id===l&&(this._title=h.name);this.dataProvider=o.treeDataProvider,this.dndController=o.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(c=>this._onDidChangeData.fire({message:!1,element:c}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let i,s;this._register(y.Event.debounce(this._onDidChangeData.event,(c,h)=>(c||(c={message:!1,elements:[]}),h.element!==!1&&(i||(i=new Promise(w=>s=w),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(h.element)?c.elements.push(...h.element):c.elements.push(h.element)),h.message&&(c.message=!0),c),200,!0)(({message:c,elements:h})=>{h.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=s;return i=null,this.refresh(h).then(()=>w())})),c&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,n.isUndefinedOrNull)(l))}async getChildren(l){const o=l?this.getExtensionElement(l):void 0;if(l&&!o)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let g=this.getChildrenNodes(l);return g||(g=await this.fetchChildrenNodes(o)),g?g.map(t=>t.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,o){o=o||{select:!0,focus:!1};const g=(0,n.isUndefinedOrNull)(o.select)?!0:o.select,t=(0,n.isUndefinedOrNull)(o.focus)?!1:o.focus,u=(0,n.isUndefinedOrNull)(o.expand)?!1:o.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(r=>this.resolveTreeNode(l,r[r.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:r.map(s=>s.item)},{select:g,focus:t,expand:u})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:g,focus:t,expand:u})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}setExpanded(l,o){const g=this.getExtensionElement(l);g&&(o?this._onDidExpandElement.fire(Object.freeze({element:g})):this._onDidCollapseElement.fire(Object.freeze({element:g})))}setSelection(l){(0,k.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(l,o){const g=this.getExtensionElement(o);if(!!g)return(0,S.asPromise)(()=>this.dndController?.onDrop(l,g))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,o){if(!this.dataProvider.resolveTreeItem)return;const g=this.elements.get(l);if(g){const t=this.nodes.get(g);if(t){const u=await this.dataProvider.resolveTreeItem(t.extensionItem,g,o)??t.extensionItem;return t.item.tooltip=this.getTooltip(u.tooltip),t.item.command=this.getCommand(t.disposableStore,u.command),t.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(o=>o?this.resolveUnknownParentChain(o).then(g=>this.resolveTreeNode(o,g[g.length-1]).then(t=>(g.push(t),g))):Promise.resolve([]))}resolveParent(l){const o=this.nodes.get(l);return o?Promise.resolve(o.parent?this.elements.get(o.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,o){const g=this.nodes.get(l);return g?Promise.resolve(g):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(t=>this.createHandle(l,t,o,!0)).then(t=>this.getChildren(o?o.item.handle:void 0).then(()=>{const u=this.getExtensionElement(t);if(u){const r=this.nodes.get(u);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}getChildrenNodes(l){if(l){let o;if(typeof l=="string"){const g=this.getExtensionElement(l);o=g?this.nodes.get(g):void 0}else o=l;return o&&o.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const o=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const g=l?this.nodes.get(l):void 0,t=await this.dataProvider.getChildren(l);if(o.token.isCancellationRequested)return;const u=await Promise.all((0,k.coalesce)(t||[]).map(async r=>{const i=await this.dataProvider.getTreeItem(r);return i&&!o.token.isCancellationRequested?this.createAndRegisterTreeNode(r,i,g):null}));return o.token.isCancellationRequested?void 0:(0,k.coalesce)(u)}finally{o.dispose()}}refresh(l){if(l.some(g=>!g))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const g=this.getHandlesToRefresh(l);if(g.length)return this.refreshHandles(g)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const o=new Set,g=l.map(u=>this.nodes.get(u));for(const u of g)if(u&&!o.has(u.item.handle)){let r=u;for(;r&&r.parent&&g.findIndex(i=>r&&r.parent&&i&&i.item.handle===r.parent.item.handle)===-1;){const i=this.elements.get(r.parent.item.handle);r=i?this.nodes.get(i):void 0}r&&!r.parent&&o.add(u.item.handle)}const t=[];return o.forEach(u=>{const r=this.elements.get(u);if(r){const i=this.nodes.get(r);i&&(!i.parent||!o.has(i.parent.item.handle))&&t.push(u)}}),t}refreshHandles(l){const o={};return Promise.all(l.map(g=>this.refreshNode(g).then(t=>{t&&(o[g]=t.item)}))).then(()=>Object.keys(o).length?this.proxy.$refresh(this.viewId,o):void 0)}refreshNode(l){const o=this.getExtensionElement(l);if(o){const g=this.nodes.get(o);if(g)return this.clearChildren(o),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(t=>{if(t){const u=this.createTreeNode(o,t,g.parent);return this.updateNodeCache(o,u,g,g.parent),g.dispose(),u}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,o,g){const t=this.createTreeNode(l,o,g);if(o.id&&this.elements.has(t.item.handle))throw new Error((0,f.localize)(7,null,o.id));return this.addNodeToCache(l,t),this.addNodeToParentCache(t,g),t}getTooltip(l){return P.MarkdownString.isMarkdownString(l)?a.MarkdownString.from(l):l}getCommand(l,o){return o?this.commands.toInternal(o,l):void 0}createTreeNode(l,o,g){const t=new A.DisposableStore,u=this.createHandle(l,o,g),r=this.getLightIconPath(o);return{item:{handle:u,parentHandle:g?g.item.handle:void 0,label:v(o.label,this.extension),description:o.description,resourceUri:o.resourceUri,tooltip:this.getTooltip(o.tooltip),command:this.getCommand(t,o.command),contextValue:o.contextValue,icon:r,iconDark:this.getDarkIconPath(o)||r,themeIcon:this.getThemeIcon(o),collapsibleState:(0,n.isUndefinedOrNull)(o.collapsibleState)?P.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation},extensionItem:o,parent:g,children:void 0,disposableStore:t,dispose(){t.dispose()}}}getThemeIcon(l){return l.iconPath instanceof P.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:o,label:g,resourceUri:t},u,r){if(o)return`${I.ID_HANDLE_PREFIX}/${o}`;const i=v(g,this.extension),s=u?u.item.handle:I.LABEL_HANDLE_PREFIX;let c=i?i.label:t?(0,F.basename)(t):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const h=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,w=this.getChildrenNodes(u)||[];let E,p=0;do{if(E=`${s}/${p}:${c}`,r||!this.elements.has(E)||h===E)break;p++}while(p<=w.length);return E}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof P.ThemeIcon))return typeof l.iconPath=="string"||C.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof P.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return C.URI.isUri(l)?l:C.URI.file(l)}addNodeToCache(l,o){this.elements.set(o.item.handle,l),this.nodes.set(l,o)}updateNodeCache(l,o,g,t){this.elements.delete(o.item.handle),this.nodes.delete(l),o.item.handle!==g.item.handle&&this.elements.delete(g.item.handle),this.addNodeToCache(l,o);const u=this.getChildrenNodes(t)||[],r=u.filter(i=>i.item.handle===g.item.handle)[0];r&&u.splice(u.indexOf(r),1,o)}addNodeToParentCache(l,o){o?(o.children||(o.children=[]),o.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const o=this.nodes.get(l);if(o){if(o.children)for(const g of o.children){const t=this.elements.get(g.item.handle);t&&this.clear(t)}o.children=void 0}}else this.clearAll()}clear(l){const o=this.nodes.get(l);if(o){if(o.children)for(const g of o.children){const t=this.elements.get(g.item.handle);t&&this.clear(t)}this.nodes.delete(l),this.elements.delete(o.item.handle),o.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}I.LABEL_HANDLE_PREFIX="0",I.ID_HANDLE_PREFIX="1"}),define(fe[224],me([0,1,17,3,6,12,65,15,129,89]),function(Y,e,f,F,C,y,A,_,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class n extends C.Disposable{constructor(a){super();this.controllerId=a,this.debounceSendDiff=this._register(new f.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.root=new A.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(a){this._resolveHandler=a;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const a=this.diff;return this.diff=[],a}pushDiff(a){const m=this.diff[this.diff.length-1];if(m&&a[0]===1){if(m[0]===1&&m[1].extId===a[1].extId){(0,S.applyTestItemUpdate)(m[1],a[1]);return}if(m[0]===0&&m[1].item.extId===a[1].extId){(0,S.applyTestItemUpdate)(m[1],a[1]);return}}this.diff.push(a),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(a,m){const d=this.tree.get(a);if(!!d){if((d.expandLevels===void 0||m>d.expandLevels)&&(d.expandLevels=m),d.expand===1){const v=this.resolveChildren(d);return v.isOpen()?this.expandChildren(d,m-1):v.wait().then(()=>this.expandChildren(d,m-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.expandChildren(d,m-1)):this.expandChildren(d,m-1)}}dispose(){for(const a of this.tree.values())(0,A.getPrivateApiFor)(a.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(a,m){switch(m.op){case 2:this.pushDiff([4,a.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(a.fullId,m.id));break;case 0:this.upsertItem(m.item,a);break;case 4:for(const b of m.ops)this.onTestItemEvent(a,b);break;case 3:const{key:d,value:v,previous:D}=m,I=a.fullId.toString();switch(d){case"canResolveChildren":this.updateExpandability(a);break;case"tags":this.diffTagRefs(v,D,I);break;case"range":this.pushDiff([1,{extId:I,item:{range:_.Range.from(v)}}]);break;case"error":this.pushDiff([1,{extId:I,item:{error:_.MarkdownString.fromStrict(v)||null}}]);break;default:this.pushDiff([1,{extId:I,item:{[d]:v??null}}]);break}break;default:(0,y.assertNever)(m)}}upsertItem(a,m){if(!(a instanceof A.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${a.id} did not`);const d=P.TestId.fromExtHostTestItem(a,this.root.id,m?.actual),v=(0,A.getPrivateApiFor)(a);v.parent&&v.parent!==m?.actual&&v.parent.children.delete(a.id);let D=this.tree.get(d.toString());if(!D){D={fullId:d,actual:a,parent:m?d.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},a.tags.forEach(this.incrementTagRefs,this),this.tree.set(D.fullId.toString(),D),this.setItemParent(a,m),this.pushDiff([0,{parent:D.parent&&D.parent.toString(),controllerId:this.controllerId,expand:D.expand,item:_.TestItem.from(a)}]),this.connectItemAndChildren(a,D,m);return}if(D.actual===a){this.connectItem(a,D,m);return}const I=D.actual.children,b=D.actual,l=(0,A.diffTestItems)(b,a);(0,A.getPrivateApiFor)(b).listener=void 0,D.actual=a,D.expand=0;for(const[o,g]of l)this.onTestItemEvent(D,{op:3,key:o,value:g,previous:b[o]});this.connectItemAndChildren(a,D,m);for(const o of I)a.children.get(o.id)||this.removeItem(P.TestId.joinToString(d,o.id))}diffTagRefs(a,m,d){const v=new Set(m.map(D=>D.id));for(const D of a)v.delete(D.id)||this.incrementTagRefs(D);this.pushDiff([1,{extId:d,item:{tags:a.map(D=>_.TestTag.namespace(this.controllerId,D.id))}}]),v.forEach(this.decrementTagRefs,this)}incrementTagRefs(a){const m=this.tags.get(a.id);m?m.refCount++:(this.tags.set(a.id,{refCount:1}),this.pushDiff([5,{id:_.TestTag.namespace(this.controllerId,a.id),ctrlLabel:this.root.label}]))}decrementTagRefs(a){const m=this.tags.get(a);m&&!--m.refCount&&(this.tags.delete(a),this.pushDiff([6,_.TestTag.namespace(this.controllerId,a)]))}setItemParent(a,m){(0,A.getPrivateApiFor)(a).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(a,m,d){this.setItemParent(a,d);const v=(0,A.getPrivateApiFor)(a);v.parent=d?.actual,v.listener=D=>this.onTestItemEvent(m,D),this.updateExpandability(m)}connectItemAndChildren(a,m,d){this.connectItem(a,m,d);for(const v of a.children)this.upsertItem(v,m)}updateExpandability(a){let m;this._resolveHandler?a.resolveBarrier?m=a.resolveBarrier.isOpen()?3:2:m=a.actual.canResolveChildren?1:0:m=0,m!==a.expand&&(a.expand=m,this.pushDiff([1,{extId:a.fullId.toString(),expand:m}]),m===1&&a.expandLevels!==void 0&&this.resolveChildren(a))}expandChildren(a,m){if(m<0)return;const d=[];for(const v of a.actual.children){const D=this.expand(P.TestId.joinToString(a.fullId,v.id),m);(0,f.isThenable)(D)&&d.push(D)}if(d.length)return Promise.all(d).then(()=>{})}resolveChildren(a){if(a.resolveBarrier)return a.resolveBarrier;if(!this._resolveHandler){const D=new f.Barrier;return D.open(),D}a.expand=2,this.pushExpandStateUpdate(a);const m=a.resolveBarrier=new f.Barrier,d=D=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),a.actual!==this.root&&(a.actual.error=D.stack||D.message||String(D))};let v;try{v=this._resolveHandler(a.actual===this.root?void 0:a.actual)}catch(D){d(D)}return(0,f.isThenable)(v)?v.catch(d).then(()=>{m.open(),this.updateExpandability(a)}):(m.open(),this.updateExpandability(a)),a.resolveBarrier}pushExpandStateUpdate(a){this.pushDiff([1,{extId:a.fullId.toString(),expand:a.expand}])}removeItem(a){const m=this.tree.get(a);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,a]);const d=[m];for(;d.length;){const v=d.pop();if(!!v){(0,A.getPrivateApiFor)(v.actual).listener=void 0;for(const D of v.actual.tags)this.decrementTagRefs(D.id);this.tree.delete(v.fullId.toString());for(const D of v.actual.children)d.push(this.tree.get(P.TestId.joinToString(v.fullId,D.id)))}}}flushDiff(){const a=this.collectDiff();a.length&&this.diffOpEmitter.fire(a)}}e.SingleUseTestCollection=n}),define(fe[225],me([0,1,4,186]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,f.refineServiceDecorator)(F.IEnvironmentService)}),define(fe[226],me([0,1,26,3,8]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=y;class A{constructor(n){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(f.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(f.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let k of n.activationEvents)k==="onUri"&&(k=`onUri:${f.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(k)||this._activationMap.set(k,[]),this._activationMap.get(k).push(n)}}keepOnly(n){const k=new Set;n.forEach(a=>k.add(f.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>k.has(f.ExtensionIdentifier.toKey(a.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,k){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const a=A._findLoopingExtensions(this._extensionDescriptions);if(k=k.concat(a.map(m=>m.identifier)),k.length>0){const m=new Set;k.forEach(d=>m.add(f.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>!m.has(f.ExtensionIdentifier.toKey(d.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(a)}static _findLoopingExtensions(n){const k=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(D){this._nodesSet.has(D)||(this._nodesSet.add(D),this._nodesArr.push(D))}addArc(D,I){this.addNode(D),this.addNode(I),this._arcs.has(D)?this._arcs.get(D).push(I):this._arcs.set(D,[I])}getArcs(D){return this._arcs.has(D)?this._arcs.get(D):[]}hasOnlyGoodArcs(D,I){const b=k.getArcs(D);for(let l=0;l<b.length;l++)if(!I.has(b[l]))return!1;return!0}getNodes(){return this._nodesArr}};let a=new Map;for(let D of n){const I=f.ExtensionIdentifier.toKey(D.identifier);if(a.set(I,D),D.extensionDependencies)for(let b of D.extensionDependencies){const l=f.ExtensionIdentifier.toKey(b);k.addArc(I,l)}}let m=new Set;k.getNodes().filter(D=>k.getArcs(D).length===0).forEach(D=>m.add(D));let d=k.getNodes().filter(D=>!m.has(D)),v;do{v=!1;for(let D=0;D<d.length;D++){const I=d[D];k.hasOnlyGoodArcs(I,m)&&(d.splice(D,1),D--,m.add(I),v=!0)}}while(v);return d.map(D=>a.get(D))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(f.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const k=this._activationMap.get(n);return k?k.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const k=this._extensionsMap.get(f.ExtensionIdentifier.toKey(n));return k||void 0}}e.ExtensionDescriptionRegistry=A;var _;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(_||(_={}));function S(P,n){const k=P.isBuiltin?0:P.isUnderDevelopment?2:1,a=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(k!==a)return k-a;const m=C.posix.basename(P.extensionLocation.path),d=C.posix.basename(n.extensionLocation.path);return m<d?-1:m>d?1:0}}),define(fe[227],me([0,1,22]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var F;(function(_){_[_.VersionMismatch=55]="VersionMismatch",_[_.UnexpectedError=81]="UnexpectedError"})(F=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var C;(function(_){_[_.Initialized=0]="Initialized",_[_.Ready=1]="Ready",_[_.Terminate=2]="Terminate"})(C=e.MessageType||(e.MessageType={}));function y(_){const S=f.VSBuffer.alloc(1);switch(_){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=y;function A(_,S){if(_.byteLength!==1)return!1;switch(_.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=A}),define(fe[35],me([0,1,3,2,4,26,188]),function(Y,e,f,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,C.createDecorator)("extensionService");var _;(function(o){o[o.None=0]="None",o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(_=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(o){switch(o){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class P{constructor(g){this.dependency=g}}e.MissingExtensionDependency=P;var n;(function(o){o[o.LocalProcess=0]="LocalProcess",o[o.LocalWebWorker=1]="LocalWebWorker",o[o.Remote=2]="Remote"})(n=e.ExtensionHostKind||(e.ExtensionHostKind={}));function k(o){switch(o){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=k;class a{constructor(g,t,u,r){this.codeLoadingTime=g,this.activateCallTime=t,this.activateResolvedTime=u,this.activationReason=r}}e.ActivationTimes=a;class m{constructor(g,t){this.description=g,this.value=t}}e.ExtensionPointContribution=m,e.ExtensionHostLogFileName="exthost";var d;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(d=e.ActivationKind||(e.ActivationKind={}));function v(o){o.enableProposedApi||D(o)}e.checkProposedApiEnabled=v;function D(o){throw new Error(`[${o.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.throwProposedApiError=D;function I(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,A.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation}}e.toExtension=I;function b(o,g){return{identifier:new y.ExtensionIdentifier(o.identifier.id),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!g,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid}}e.toExtensionDescription=b;class l{constructor(){this.onDidRegisterExtensions=f.Event.None,this.onDidChangeExtensionsStatus=f.Event.None,this.onDidChangeExtensions=f.Event.None,this.onWillActivateByEvent=f.Event.None,this.onDidChangeResponsiveChange=f.Event.None}activateByEvent(g){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(g){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(g,t){return Promise.resolve()}_onWillActivateExtension(g){}_onDidActivateExtension(g,t,u,r,i){}_onDidActivateExtensionError(g,t){}_onExtensionRuntimeError(g,t){}_onExtensionHostExit(g){}}e.NullExtensionService=l}),define(fe[228],me([0,1,26,35,13]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class A{constructor(d,v,D,I){this.startup=d,this.codeLoadingTime=v,this.activateCallTime=D,this.activateResolvedTime=I}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class _{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,v){return d===-1||v===-1?-1:v-d}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=_;class S{constructor(d,v,D,I,b,l){this.activationFailed=d,this.activationFailedError=v,this.activationTimes=D,this.module=I,this.exports=b,this.subscriptions=l}}e.ActivatedExtension=S;class P extends S{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class n extends S{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class k extends S{constructor(d){super(!0,d,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=k;let a=class{constructor(d,v,D,I,b){this._logService=b,this._registry=d,this._resolvedExtensionsSet=new Set,v.forEach(l=>this._resolvedExtensionsSet.add(f.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,D.forEach(l=>this._hostExtensionsMap.set(f.ExtensionIdentifier.toKey(l),l)),this._host=I,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(d){const v=f.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(v)}getActivatedExtension(d){const v=f.ExtensionIdentifier.toKey(d),D=this._activatedExtensions.get(v);if(!D)throw new Error("Extension `"+d.value+"` is not known or not activated");return D}activateByEvent(d,v){if(this._alreadyActivatedEvents[d])return y;const D=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(D.map(I=>({id:I.identifier,reason:{startup:v,extensionId:I.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,v){const D=this._registry.getExtensionDescription(d);if(!D)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:D.identifier,reason:v}])}_handleActivateRequest(d,v,D){if(this._hostExtensionsMap.has(f.ExtensionIdentifier.toKey(d.id))){v[f.ExtensionIdentifier.toKey(d.id)]=d;return}const I=this._registry.getExtensionDescription(d.id);if(!I){const o=new Error(`Cannot activate unknown extension '${d.id.value}'`);this._host.onExtensionActivationError(d.id,o,new F.MissingExtensionDependency(d.id.value)),this._activatedExtensions.set(f.ExtensionIdentifier.toKey(d.id),new k(o));return}const b=typeof I.extensionDependencies=="undefined"?[]:I.extensionDependencies;let l=!0;for(let o=0,g=b.length;o<g;o++){const t=b[o];if(this._resolvedExtensionsSet.has(f.ExtensionIdentifier.toKey(t)))continue;const u=this._activatedExtensions.get(f.ExtensionIdentifier.toKey(t));if(u&&!u.activationFailed)continue;if(u&&u.activationFailed){const c=I.displayName||I.identifier.value,h=this._registry.getExtensionDescription(t),w=h&&h.displayName||t,E=new Error(`Cannot activate the '${c}' extension because its dependency '${w}' failed to activate`);E.detail=u.activationFailedError,this._host.onExtensionActivationError(I.identifier,E,null),this._activatedExtensions.set(f.ExtensionIdentifier.toKey(I.identifier),new k(E));return}if(this._hostExtensionsMap.has(f.ExtensionIdentifier.toKey(t))){l=!1,v[f.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(f.ExtensionIdentifier.toKey(t)),reason:d.reason};continue}const r=this._registry.getExtensionDescription(t);if(r){if(!r.main&&!r.browser)continue;l=!1,v[f.ExtensionIdentifier.toKey(t)]={id:r.identifier,reason:d.reason};continue}const i=I.displayName||I.identifier.value,s=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(I.identifier,s,new F.MissingExtensionDependency(t)),this._activatedExtensions.set(f.ExtensionIdentifier.toKey(I.identifier),new k(s));return}l?v[f.ExtensionIdentifier.toKey(I.identifier)]=d:D.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(b=>!this._activatedExtensions.has(f.ExtensionIdentifier.toKey(b.id))),d.length===0))return Promise.resolve(void 0);const v=Object.create(null),D=[];for(let b=0,l=d.length;b<l;b++)this._handleActivateRequest(d[b],v,D);for(let b=0,l=D.length;b<l;b++){const o=f.ExtensionIdentifier.toKey(D[b].id);v[o]&&delete v[o]}const I=Object.keys(v).map(b=>v[b]);return D.length===0?Promise.all(I.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(I).then(b=>this._activateExtensions(D))}_activateExtension(d,v){const D=f.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(D))return Promise.resolve(void 0);const I=this._activatingExtensions.get(D);if(I)return I;const b=this._host.actualActivateExtension(d,v).then(void 0,l=>{const o=new Error;return l&&l.name&&(o.name=l.name),l&&l.message?o.message=`Activating extension '${d.value}' failed: ${l.message}.`:o.message=`Activating extension '${d.value}' failed: ${l}.`,l&&l.stack&&(o.stack=l.stack),this._host.onExtensionActivationError(d,o,null),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(l),new k(l)}).then(l=>{this._activatedExtensions.set(D,l),this._activatingExtensions.delete(D)});return this._activatingExtensions.set(D,b),b}};a=je([He(4,C.ILogService)],a),e.ExtensionsActivator=a}),define(fe[229],me([0,1,13,35,27,10,117]),function(Y,e,f,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let _=class extends f.LogService{constructor(P){if(P.logFile.scheme!==y.Schemas.file)throw new Error("Only file-logging supported");super(new A.SpdLogLogger(F.ExtensionHostLogFileName,P.logFile.fsPath,!0,P.logLevel))}$setLevel(P){this.setLevel(P)}};_=je([He(0,C.IExtHostInitDataService)],_),e.ExtHostLogService=_}),define(fe[230],me([0,1,18]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,A)=>{this._actualOk=y,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,f.onUnexpectedError)(y))}then(y,A){return this._ensureActual().then(y,A)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=F}),define(fe[54],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class f{constructor(P,n){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=n,this.nid=++f.count}}e.ProxyIdentifier=f,f.count=0;const F=[];function C(S){const P=new f(!0,S);return F[P.nid]=P,P}e.createMainContextProxyIdentifier=C;function y(S){const P=new f(!1,S);return F[P.nid]=P,P}e.createExtHostContextProxyIdentifier=y;function A(S){return F[S].sid}e.getStringIdentifierForProxy=A;class _{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=_}),define(fe[5],me([0,1,61,2,54]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var A;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var _;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));var a;(function(l){l.name="$ident";function o(t,u){return Object.defineProperty(t,l.name,{value:u,enumerable:!0}),t}l.mixin=o;function g(t){return t[l.name]}l.of=g})(a=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(o){return o._id=m._n++,o}}e.IdObject=m,m._n=0;var d;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var D;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(D=e.WorkspaceEditType||(e.WorkspaceEditType={}));function I(l){if(l&&l.edits)for(const o of l.edits)typeof o.resource=="object"?o.resource=F.URI.revive(o.resource):(o.newUri=F.URI.revive(o.newUri),o.oldUri=F.URI.revive(o.oldUri)),o.metadata&&o.metadata.iconPath&&(o.metadata=(0,f.revive)(o.metadata));return l}e.reviveWorkspaceEditDto=I;var b;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,C.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,C.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,C.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,C.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,C.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,C.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,C.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,C.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,C.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,C.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,C.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,C.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,C.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,C.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,C.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,C.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,C.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,C.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,C.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,C.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,C.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,C.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,C.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,C.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,C.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,C.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,C.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,C.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,C.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,C.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,C.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,C.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,C.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,C.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,C.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,C.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,C.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,C.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,C.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,C.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,C.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,C.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,C.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,C.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,C.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,C.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,C.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,C.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,C.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,C.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,C.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,C.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,C.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,C.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,C.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,C.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,C.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,C.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,C.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,C.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,C.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(fe[90],me([0,1,5,3,4]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(_){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=_.getProxy(f.MainContext.MainThreadSecretState)}async $onDidChangePassword(_){this._onDidChangePassword.fire(_)}get(_,S){return this._proxy.$getPassword(_,S)}store(_,S,P){return this._proxy.$setPassword(_,S,P)}delete(_,S){return this._proxy.$deletePassword(_,S)}}e.ExtHostSecretState=y,e.IExtHostSecretState=(0,C.createDecorator)("IExtHostSecretState")}),define(fe[67],me([0,1,4,13,5,14]),function(Y,e,f,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,f.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(S,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(C.MainContext.MainThreadTelemetry)}report(S,P,n){const k=this.getUsageKey(S,P);this._reportedUsages.has(k)||(this._reportedUsages.add(k),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:S}))}getUsageKey(S,P){return`${S}-${P.identifier.value}`}};A=je([He(0,y.IExtHostRpcService),He(1,F.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(_,S,P){}})}),define(fe[231],me([0,1,3,5,7,26]),function(Y,e,f,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new f.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,P,n,k={}){const a=y.ExtensionIdentifier.toKey(S.identifier),m=this._inFlightRequests.get(a)||[],d=[...n].sort().join(" ");let v=m.find(D=>D.scopes===d);if(v)return v.result;{const D=this._getSession(S,a,P,n,k);v={scopes:d,result:D},m.push(v),this._inFlightRequests.set(a,m);try{await D}finally{const I=m.findIndex(b=>b.scopes===d);I>-1&&(m.splice(I),this._inFlightRequests.set(a,m))}return D}}async _getSession(S,P,n,k,a={}){await this._proxy.$ensureProvider(n);const m=S.displayName||S.name;return this._proxy.$getSession(n,k,P,m,a)}async removeSession(S,P){const n=this._authenticationProviders.get(S);return n?n.provider.removeSession(P):this._proxy.$removeSession(S,P)}registerAuthenticationProvider(S,P,n,k){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:P,provider:n,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===S)||this._providers.push({id:S,label:P});const a=n.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(S,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,P,k?.supportsMultipleAccounts??!1),new C.Disposable(()=>{a.dispose(),this._authenticationProviders.delete(S);const m=this._providers.findIndex(d=>d.id===S);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,P){const n=this._authenticationProviders.get(S);if(n)return Promise.resolve(n.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,P){const n=this._authenticationProviders.get(S);if(n)return Promise.resolve(n.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,P){const n=this._authenticationProviders.get(S);if(n)return Promise.resolve(n.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,P){return this._onDidChangeSessions.fire({provider:{id:S,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(fe[232],me([0,1,5,14,15]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(_,S){this._extHostDocumentsAndEditors=S,this._proxy=_.getProxy(f.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(_){const S=C.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};y=je([He(0,F.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(fe[233],me([0,1,5]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(y){const A=y.getProxy(f.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(_){return A.$writeText(_)}})}}e.ExtHostClipboard=F}),define(fe[40],me([0,1,12,7,15,25,5,16,13,61,42,51,2,6,4,14,65,22,54]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let l=class{constructor(i,s){this._commands=new Map,this._apiCommands=new Map,this._proxy=i.getProxy(A.MainContext.MainThreadCommands),this._logService=s,this.converter=new o(this,c=>{const h=this._apiCommands.get(c);return h?.result===t.Void?h:void 0},s),this._argumentProcessors=[{processArgument(c){return(0,P.revive)(c)}},{processArgument(c){return(0,y.cloneAndChange)(c,function(h){if(n.Range.isIRange(h))return C.Range.to(h);if(k.Position.isIPosition(h))return C.Position.to(h);if(n.Range.isIRange(h.range)&&a.URI.isUri(h.uri))return C.location.to(h);if(h instanceof I.VSBuffer)return h.buffer.buffer;if(!Array.isArray(h))return h})}}]}registerArgumentProcessor(i){this._argumentProcessors.push(i)}registerApiCommand(i){const s=this.registerCommand(!1,i.id,async(...c)=>{const h=i.args.map((E,p)=>{if(!E.validate(c[p]))throw new Error(`Invalid argument '${E.name}' when running '${i.id}', received: ${c[p]}`);return E.convert(c[p])}),w=await this.executeCommand(i.internalId,...h);return i.result.convert(w,c,this.converter)},void 0,{description:i.description,args:i.args,returns:i.result.description});return this._apiCommands.set(i.id,i),new F.Disposable(()=>{s.dispose(),this._apiCommands.delete(i.id)})}registerCommand(i,s,c,h,w){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:c,thisArg:h,description:w}),i&&this._proxy.$registerCommand(s),new F.Disposable(()=>{this._commands.delete(s)&&i&&this._proxy.$unregisterCommand(s)})}executeCommand(i,...s){return this._logService.trace("ExtHostCommands#executeCommand",i),this._doExecuteCommand(i,s,!0)}async _doExecuteCommand(i,s,c){if(this._commands.has(i))return this._executeContributedCommand(i,s);{let h=!1;const w=(0,y.cloneAndChange)(s,function(E){if(E instanceof F.Position)return C.Position.from(E);if(E instanceof F.Range)return C.Range.from(E);if(E instanceof F.Location)return C.location.from(E);if(F.NotebookRange.isNotebookRange(E))return C.NotebookRange.from(E);if(E instanceof ArrayBuffer)return h=!0,I.VSBuffer.wrap(new Uint8Array(E));if(E instanceof Uint8Array)return h=!0,I.VSBuffer.wrap(E);if(!Array.isArray(E))return E});try{const E=await this._proxy.$executeCommand(i,h?new b.SerializableObjectWithBuffers(w):w,c);return(0,P.revive)(E)}catch(E){if(E instanceof Error&&E.message==="$executeCommand:retry")return this._doExecuteCommand(i,s,!1);throw E}}}async _executeContributedCommand(i,s){const c=this._commands.get(i);if(!c)throw new Error("Unknown command");let{callback:h,thisArg:w,description:E}=c;if(E)for(let p=0;p<E.args.length;p++)try{(0,f.validateConstraint)(s[p],E.args[p].constraint)}catch(T){throw new Error(`Running the contributed command: '${i}' failed. Illegal argument '${E.args[p].name}' - ${E.args[p].description}`)}try{return await h.apply(w,s)}catch(p){if(i===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...s);T&&(i=T.command)}throw this._logService.error(p,i),new Error(`Running the contributed command: '${i}' failed.`)}}$executeContributedCommand(i,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",i),this._commands.has(i)?(s=s.map(c=>this._argumentProcessors.reduce((h,w)=>w.processArgument(h),c)),this._executeContributedCommand(i,s)):Promise.reject(new Error(`Contributed command '${i}' does not exist.`))}getCommands(i=!1){return this._logService.trace("ExtHostCommands#getCommands",i),this._proxy.$getCommands().then(s=>(i&&(s=s.filter(c=>c[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const i=Object.create(null);for(let[s,c]of this._commands){let{description:h}=c;h&&(i[s]=h)}return Promise.resolve(i)}};l=je([He(0,v.IExtHostRpcService),He(1,S.ILogService)],l),e.ExtHostCommands=l,e.IExtHostCommands=(0,d.createDecorator)("IExtHostCommands");class o{constructor(i,s,c){this._commands=i,this._lookupApiCommand=s,this._logService=c,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(i,s){if(!i)return;const c={$ident:void 0,id:i.command,title:i.title,tooltip:i.tooltip};if(!i.command)return c;const h=this._lookupApiCommand(i.command);if(h)c.id=h.internalId,c.arguments=h.args.map((w,E)=>w.convert(i.arguments&&i.arguments[E]));else if((0,_.isNonEmptyArray)(i.arguments)){const w=++this._cachIdPool;this._cache.set(w,i),s.add((0,m.toDisposable)(()=>{this._cache.delete(w),this._logService.trace("CommandsConverter#DISPOSE",w)})),c.$ident=w,c.id=this.delegatingCommandId,c.arguments=[w],this._logService.trace("CommandsConverter#CREATE",i.command,w)}return c}fromInternal(i){const s=A.ObjectIdentifier.of(i);return typeof s=="number"?this._cache.get(s):{command:i.id,title:i.title,arguments:i.arguments}}getActualCommand(...i){return this._cache.get(i[0])}_executeConvertedCommand(...i){const s=this.getActualCommand(...i);return this._logService.trace("CommandsConverter#EXECUTE",i[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=o;class g{constructor(i,s,c,h){this.name=i,this.description=s,this.validate=c,this.convert=h}optional(){return new g(this.name,`(optional) ${this.description}`,i=>i==null||this.validate(i),i=>i===void 0?void 0:i===null?null:this.convert(i))}with(i,s){return new g(i??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=g,g.Uri=new g("uri","Uri of a text document",r=>a.URI.isUri(r),r=>r),g.Position=new g("position","A position in a text document",r=>F.Position.isPosition(r),C.Position.from),g.Range=new g("range","A range in a text document",r=>F.Range.isRange(r),C.Range.from),g.Selection=new g("selection","A selection in a text document",r=>F.Selection.isSelection(r),C.Selection.from),g.Number=new g("number","",r=>typeof r=="number",r=>r),g.String=new g("string","",r=>typeof r=="string",r=>r),g.CallHierarchyItem=new g("item","A call hierarchy item",r=>r instanceof F.CallHierarchyItem,C.CallHierarchyItem.from),g.TypeHierarchyItem=new g("item","A type hierarchy item",r=>r instanceof F.TypeHierarchyItem,C.TypeHierarchyItem.from),g.TestItem=new g("testItem","A VS Code TestItem",r=>r instanceof D.TestItemImpl,C.TestItem.from);class t{constructor(i,s){this.description=i,this.convert=s}}e.ApiCommandResult=t,t.Void=new t("no result",r=>r);class u{constructor(i,s,c,h,w){this.id=i,this.internalId=s,this.description=c,this.args=h,this.result=w}}e.ApiCommand=u}),define(fe[234],me([0,1,15,7,83,40,16,112]),function(Y,e,f,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(f.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,m)=>{if((0,A.isFalsyOrEmpty)(a))return;class d extends F.SymbolInformation{static to(D){const I=new d(D.name,f.SymbolKind.to(D.kind),D.containerName||"",new F.Location(m[0],f.Range.to(D.range)));return I.detail=D.detail,I.range=I.location.range,I.selectionRange=f.Range.to(D.selectionRange),I.children=D.children?D.children.map(d.to):[],I}}return a.map(d.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(f.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(f.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(f.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(f.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(f.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(m=>F.Position.isPosition(m)),a=>a.map(f.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(m=>{let d;for(const v of m.reverse())d=new F.SelectionRange(f.Range.to(v),d);return d}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const m=[];if(Array.isArray(a))for(let d of a)m.push(...d[1].map(f.WorkspaceSymbol.to));return m})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(f.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(f.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(f.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(!!a)return{range:f.Range.to(a.range),placeholder:a.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return f.WorkspaceEdit.to(a)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(f.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new F.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,_.decodeSemanticTokensDto)(a);if(m.type==="full")return new F.SemanticTokens(m.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new F.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,_.decodeSemanticTokensDto)(a);if(m.type==="full")return new F.SemanticTokens(m.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,m,d)=>{if(!a)return new F.CompletionList([]);const v=a.suggestions.map(D=>f.CompletionItem.to(D,d));return new F.CompletionList(v,a.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return f.SignatureHelp.to(a)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,m,d)=>n(v=>new F.CodeLens(f.Range.to(v.range),v.command&&d.fromInternal(v.command)))(a))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>F.Range.isRange(a),a=>F.Selection.isSelection(a)?f.Selection.from(a):f.Range.from(a)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,m,d)=>n(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(v.command)}else{const D=new F.CodeAction(v.title,v.kind?new F.CodeActionKind(v.kind):void 0);return v.edit&&(D.edit=f.WorkspaceEdit.to(v.edit)),v.command&&(D.command=d.fromInternal(v.command)),D.isPreferred=v.isPreferred,D}})(a))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(m=>new F.ColorInformation(f.Range.to(m.range),f.Color.to(m.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",a=>a instanceof F.Color,f.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:f.Range.from(a.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(f.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",a=>a.map(f.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(m=>f.NotebookExclusiveDocumentPattern.to(m))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(f.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[f.ViewColumn.from(a.viewColumn),f.TextEditorOpenOptions.from(a)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[f.ViewColumn.from(a.viewColumn),f.TextEditorOpenOptions.from(a)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[f.ViewColumn.from(a.viewColumn),f.TextEditorOpenOptions.from(a)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(f.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(f.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(f.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void)];class P{static register(m){S.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=P;function n(a){return m=>{if(Array.isArray(m))return m.map(a)}}function k(a){if(!Array.isArray(a))return;const m=[];for(const d of a)C.isLocationLink(d)?m.push(f.DefinitionLink.to(d)):m.push(f.location.to(d));return m}}),define(fe[235],me([0,1,17,59,3,6,2,83,26,15,7,5]),function(Y,e,f,F,C,y,A,_,S,P,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function a(m,d,v){const D=m.getProxy(k.MainContext.MainThreadComments);class I{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,d.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const s=this._commentControllers.get(i.handle);return s||i}else if(i&&i.$mid===7){const s=this._commentControllers.get(i.commentControlHandle);if(!s)return i;const c=s.getCommentThread(i.commentThreadHandle);return c||i}else if(i&&i.$mid===8){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const c=s.getCommentThread(i.thread.commentThreadHandle);return c?{thread:c,text:i.text}:i}else if(i&&i.$mid===9){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const c=s.getCommentThread(i.thread.commentThreadHandle);if(!c)return i;let h=i.commentUniqueId,w=c.getCommentByUniqueId(h);return w||i}else if(i&&i.$mid===10){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const c=s.getCommentThread(i.thread.commentThreadHandle);if(!c)return i;let h=i.text,w=i.commentUniqueId,E=c.getCommentByUniqueId(w);return E?(E.body=h,E):i}return i}})}createCommentController(i,s,c){const h=I.handlePool++,w=new l(i,h,s,c);this._commentControllers.set(w.handle,w);const E=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(i.identifier))||[];return E.push(w),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(i.identifier),E),w.value}$createCommentThreadTemplate(i,s,c){const h=this._commentControllers.get(i);!h||h.$createCommentThreadTemplate(s,c)}async $updateCommentThreadTemplate(i,s,c){const h=this._commentControllers.get(i);!h||h.$updateCommentThreadTemplate(s,c)}$deleteCommentThread(i,s){const c=this._commentControllers.get(i);c&&c.$deleteCommentThread(s)}$provideCommentingRanges(i,s,c){const h=this._commentControllers.get(i);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const w=v.getDocument(A.URI.revive(s));return(0,f.asPromise)(()=>h.commentingRangeProvider.provideCommentingRanges(w,c)).then(E=>E?E.map(p=>P.Range.from(p)):void 0)}$toggleReaction(i,s,c,h,w){const E=this._commentControllers.get(i);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,f.asPromise)(()=>{const p=E.getCommentThread(s);if(p){const T=p.getCommentByUniqueId(h.uniqueIdInThread);if(E!==void 0&&T&&E.reactionHandler)return E.reactionHandler(T,t(w))}return Promise.resolve(void 0)})}dispose(){}}I.handlePool=0;class b{constructor(i,s,c,h,w,E,p){this._commentControllerHandle=s,this._id=c,this._uri=h,this._range=w,this._comments=E,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),D.$createCommentThread(s,this.handle,this._id,this._uri,P.Range.from(this._range),p),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this._localDisposables.push({dispose:()=>{D.$deleteCommentThread(s,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(L){T.range=L},get comments(){return T.comments},set comments(L){T.comments=L},get collapsibleState(){return T.collapsibleState},set collapsibleState(L){T.collapsibleState=L},get canReply(){return T.canReply},set canReply(L){T.canReply=L},get contextValue(){return T.contextValue},set contextValue(L){T.contextValue=L},get label(){return T.label},set label(L){T.label=L},dispose:()=>{T.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const i=c=>Object.prototype.hasOwnProperty.call(this.modifications,c),s={};i("range")&&(s.range=P.Range.from(this._range)),i("label")&&(s.label=this.label),i("contextValue")&&(s.contextValue=this.contextValue),i("comments")&&(s.comments=this._comments.map(c=>o(this,c,this._commentsMap))),i("collapsibleState")&&(s.collapseState=u(this._collapseState)),i("canReply")&&(s.canReply=this.canReply),this.modifications={},D.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,s)}getCommentByUniqueId(i){for(let s of this._commentsMap){let c=s[0],h=s[1];if(i===h)return c}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}b._handlePool=0,je([(0,F.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(i,s,c,h){this._extension=i,this._handle=s,this._id=c,this._label=h,this._threads=new Map,D.$registerCommentController(this.handle,c,h);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(E){w.options=E},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(E){w.commentingRangeProvider=E},get reactionHandler(){return w.reactionHandler},set reactionHandler(E){w.reactionHandler=E},createCommentThread(E,p,T){return w.createCommentThread(E,p,T).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{D.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,D.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,D.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,s,c,h){if(typeof i=="string"){const w=new b(this.id,this.handle,i,s,c,h,this._extension.identifier);return this._threads.set(w.handle,w),w}else{const w=new b(this.id,this.handle,void 0,i,s,c,this._extension.identifier);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(i,s){const c=new b(this.id,this.handle,void 0,A.URI.revive(i),P.Range.to(s),[],this._extension.identifier);return c.collapsibleState=_.CommentThreadCollapsibleState.Expanded,this._threads.set(c.handle,c),c}$updateCommentThreadTemplate(i,s){let c=this._threads.get(i);c&&(c.range=P.Range.to(s))}$deleteCommentThread(i){let s=this._threads.get(i);s&&s.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function o(r,i,s){let c=s.get(i);c||(c=++r.commentHandle,s.set(i,c));const h=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:c,body:P.MarkdownString.from(i.body),userName:i.author.name,userIconPath:h,label:i.label,commentReactions:i.reactions?i.reactions.map(w=>g(w)):void 0}}function g(r){return{label:r.label,iconPath:r.iconPath?P.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function t(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?A.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function u(r){if(r!==void 0)switch(r){case n.CommentThreadCollapsibleState.Expanded:return _.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return _.CommentThreadCollapsibleState.Collapsed}return _.CommentThreadCollapsibleState.Collapsed}return new I}e.createExtHostComments=a}),define(fe[133],me([0,1,2,5,7,4,14,13,16,9,8]),function(Y,e,f,F,C,y,A,_,S,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class wn{constructor(m,d){this._logService=d,this._provider=new Map,this._proxy=m.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,d){const v=wn._handlePool++;this._provider.set(v,{provider:m,extensionId:d}),this._proxy.$registerDecorationProvider(v,d.value);const D=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(I=>{if(!I){this._proxy.$onDidChange(v,null);return}let b=(0,S.asArray)(I);if(b.length<=wn._maxEventSize){this._proxy.$onDidChange(v,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",d.value,b.length);const l=b.map(t=>({uri:t,rank:(0,P.count)(t.path,"/")})),o=(0,S.groupBy)(l,(t,u)=>t.rank-u.rank||(0,P.compare)(t.uri.path,u.uri.path));let g=[];e:for(let t of o){let u;for(let r of t){let i=(0,n.dirname)(r.uri.path);if(u!==i&&(u=i,g.push(r.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(v,g)});return new C.Disposable(()=>{D?.dispose(),this._proxy.$unregisterDecorationProvider(v),this._provider.delete(v)})}async $provideDecorations(m,d,v){if(!this._provider.has(m))return Object.create(null);const D=Object.create(null),{provider:I,extensionId:b}=this._provider.get(m);return await Promise.all(d.map(async l=>{try{const{uri:o,id:g}=l,t=await Promise.resolve(I.provideFileDecoration(f.URI.revive(o),v));if(!t)return;try{C.FileDecoration.validate(t),D[g]=[t.propagate,t.tooltip,t.badge,t.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${b.value}': ${u}`)}}catch(o){this._logService.error(o)}})),D}};k._handlePool=0,k._maxEventSize=250,k=je([He(0,A.IExtHostRpcService),He(1,_.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,y.createDecorator)("IExtHostDecorations")});var st=this&&this.__classPrivateFieldSet||function(Y,e,f,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,f):C?C.value=f:e.set(Y,f),f},Ne=this&&this.__classPrivateFieldGet||function(Y,e,f,F){if(f==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?F:f==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[236],me([0,1,165,118,2,5,7,15,3,13,24,52,142]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a){"use strict";var m,d,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class D{constructor(l,o,g,t,u,r){this._name=l,this._owner=o,this._maxDiagnosticsPerFile=g,m.set(this,void 0),d.set(this,void 0),v.set(this,void 0),this._isDisposed=!1,st(this,v,new a.SkipList((i,s)=>t.compare(i,s)),"f"),st(this,m,u,"f"),st(this,d,r,"f")}dispose(){this._isDisposed||(Ne(this,d,"f").fire([...Ne(this,v,"f").keys()]),Ne(this,m,"f")&&Ne(this,m,"f").$clear(this._owner),Ne(this,v,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(l,o){if(!l){this.clear();return}this._checkDisposed();let g=[];if(C.URI.isUri(l)){if(!o){this.delete(l);return}Ne(this,v,"f").set(l,o.slice()),g=[l]}else if(Array.isArray(l)){g=[];let u;l=[...l].sort(D._compareIndexedTuplesByUri);for(const r of l){const[i,s]=r;if((!u||i.toString()!==u.toString())&&(u&&Ne(this,v,"f").get(u).length===0&&Ne(this,v,"f").delete(u),u=i,g.push(i),Ne(this,v,"f").set(i,[])),s){const c=Ne(this,v,"f").get(i);c&&c.push(...s)}else{const c=Ne(this,v,"f").get(i);c&&(c.length=0)}}}if(Ne(this,d,"f").fire(g),!Ne(this,m,"f"))return;const t=[];for(let u of g){let r=[];const i=Ne(this,v,"f").get(u);if(i)if(i.length>this._maxDiagnosticsPerFile){r=[];const s=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(let h of i)if(h.severity===s[c]&&r.push(_.Diagnostic.from(h))===this._maxDiagnosticsPerFile)break e;r.push({severity:F.MarkerSeverity.Info,message:(0,f.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=i.map(s=>_.Diagnostic.from(s));t.push([u,r])}Ne(this,m,"f").$changeMany(this._owner,t)}delete(l){this._checkDisposed(),Ne(this,d,"f").fire([l]),Ne(this,v,"f").delete(l),Ne(this,m,"f")&&Ne(this,m,"f").$changeMany(this._owner,[[l,void 0]])}clear(){this._checkDisposed(),Ne(this,d,"f").fire([...Ne(this,v,"f").keys()]),Ne(this,v,"f").clear(),Ne(this,m,"f")&&Ne(this,m,"f").$clear(this._owner)}forEach(l,o){this._checkDisposed();for(let g of Ne(this,v,"f").keys())l.apply(o,[g,this.get(g),this])}get(l){this._checkDisposed();const o=Ne(this,v,"f").get(l);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(l){return this._checkDisposed(),Array.isArray(Ne(this,v,"f").get(l))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(l,o){return l[0].toString()<o[0].toString()?-1:l[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=D,m=new WeakMap,d=new WeakMap,v=new WeakMap;let I=class Zt{constructor(l,o,g){this._logService=o,this._fileSystemInfoService=g,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,Zt._mapper),this._proxy=l.getProxy(y.MainContext.MainThreadDiagnostics)}static _mapper(l){const o=new n.ResourceMap;for(const g of l)o.set(g,g);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(l,o){const{_collections:g,_proxy:t,_onDidChangeDiagnostics:u,_logService:r,_fileSystemInfoService:i}=this,s=new class{$changeMany(w,E){t.$changeMany(w,E),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,w,E.length===0?"CLEARING":E)}$clear(w){t.$clear(w),r.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,w)}dispose(){t.dispose()}};let c;if(!o)o="_generated_diagnostic_collection_name_#"+Zt._idPool++,c=o;else if(!g.has(o))c=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do c=o+Zt._idPool++;while(g.has(c))}return new class extends D{constructor(){super(o,c,Zt._maxDiagnosticsPerFile,i.extUri,s,u);g.set(c,this)}dispose(){super.dispose(),g.delete(c)}}}getDiagnostics(l){if(l)return this._getDiagnostics(l);{const o=new Map,g=[];for(const t of this._collections.values())t.forEach((u,r)=>{let i=o.get(u.toString());typeof i=="undefined"&&(i=g.length,o.set(u.toString(),i),g.push([u,[]])),g[i][1]=g[i][1].concat(...r)});return g}}_getDiagnostics(l){let o=[];for(let g of this._collections.values())g.has(l)&&(o=o.concat(g.get(l)));return o}$acceptMarkersChange(l){if(!this._mirrorCollection){const o="_generated_mirror",g=new D(o,o,Zt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,g),this._mirrorCollection=g}for(const[o,g]of l)this._mirrorCollection.set(C.URI.revive(o),g.map(_.Diagnostic.to))}};I._idPool=0,I._maxDiagnosticsPerFile=1e3,I=je([He(1,P.ILogService),He(2,k.IExtHostFileSystemInfo)],I),e.ExtHostDiagnostics=I}),define(fe[237],me([0,1,2,5]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(A){this._proxy=A.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(_=>_?_.map(S=>f.URI.revive(S)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(_=>_?f.URI.revive(_):void 0)}}e.ExtHostDialogs=C}),define(fe[238],me([0,1,18,2,7,5,10,21,9]),function(Y,e,f,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(k,a,m){this._documentsAndEditors=a,this._logService=m,this._documentContentProviders=new Map,this._proxy=k.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,a){if(Object.keys(A.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const m=P._handlePool++;this._documentContentProviders.set(m,a),this._proxy.$registerTextContentProvider(m,k);let d;return typeof a.onDidChange=="function"&&(d=a.onDidChange(v=>{if(v.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(v)&&this.$provideTextDocumentContent(m,v).then(D=>{if(!D&&typeof D!="string")return;const I=this._documentsAndEditors.getDocument(v);if(!I)return;const b=(0,S.splitLines)(D);if(!I.equalLines(b))return this._proxy.$onVirtualDocumentChange(v,D)},f.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(k,a){const m=this._documentContentProviders.get(k);return m?Promise.resolve(m.provideTextDocumentContent(F.URI.revive(a),_.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(fe[239],me([0,1,3,6,2,5,125,15,12,25,7]),function(Y,e,f,F,C,y,A,_,S,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(m,d){this._onDidAddDocument=new f.Emitter,this._onDidRemoveDocument=new f.Emitter,this._onDidChangeDocument=new f.Emitter,this._onDidSaveDocument=new f.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=d,this._documentsAndEditors.onDidRemoveDocuments(v=>{for(const D of v)this._onDidRemoveDocument.fire(D.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(v=>{for(const D of v)this._onDidAddDocument.fire(D.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const d=this._documentsAndEditors.getDocument(m);if(d)return d}getDocument(m){const d=this.getDocumentData(m);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return d.document}ensureDocumentData(m){const d=this._documentsAndEditors.getDocument(m);if(d)return Promise.resolve(d);let v=this._documentLoader.get(m.toString());return v||(v=this._proxy.$tryOpenDocument(m).then(D=>{this._documentLoader.delete(m.toString());const I=C.URI.revive(D);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(I))},D=>(this._documentLoader.delete(m.toString()),Promise.reject(D))),this._documentLoader.set(m.toString(),v)),v}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(d=>C.URI.revive(d))}$acceptModelModeChanged(m,d){const v=C.URI.revive(m),D=this._documentsAndEditors.getDocument(v);if(!D)throw new Error("unknown document");this._onDidRemoveDocument.fire(D.document),D._acceptLanguageId(d),this._onDidAddDocument.fire(D.document)}$acceptModelSaved(m){const d=C.URI.revive(m),v=this._documentsAndEditors.getDocument(d);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(v.document)}$acceptDirtyStateChanged(m,d){const v=C.URI.revive(m),D=this._documentsAndEditors.getDocument(v);if(!D)throw new Error("unknown document");D._acceptIsDirty(d),this._onDidChangeDocument.fire({document:D.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,d,v){const D=C.URI.revive(m),I=this._documentsAndEditors.getDocument(D);if(!I)throw new Error("unknown document");I._acceptIsDirty(v),I.onEvents(d);let b;d.isUndoing?b=n.TextDocumentChangeReason.Undo:d.isRedoing&&(b=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:I.document,contentChanges:d.changes.map(l=>({range:_.Range.to(l.range),rangeOffset:l.rangeOffset,rangeLength:l.rangeLength,text:l.text})),reason:b}))}setWordDefinitionFor(m,d){(0,A.setWordDefinitionFor)(m,d)}}e.ExtHostDocuments=k}),define(fe[45],me([0,1,57,3,6,2,4,5,125,14,132,15,13,24,10,94,141]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class I{constructor(o){this.value=o,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(o,g){this._extHostRpc=o,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const g=[],t=[],u=[];if(o.removedDocuments)for(const r of o.removedDocuments){const i=y.URI.revive(r),s=this._documents.get(i);s?.unref()&&(this._documents.delete(i),g.push(s.value))}if(o.addedDocuments)for(const r of o.addedDocuments){const i=y.URI.revive(r.uri);let s=this._documents.get(i);if(s&&i.scheme!==d.Schemas.vscodeNotebookCell&&i.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);s||(s=new I(new S.ExtHostDocumentData(this._extHostRpc.getProxy(_.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(i,s),t.push(s.value)),s.ref()}if(o.removedEditors)for(const r of o.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&u.push(i)}if(o.addedEditors)for(const r of o.addedEditors){const i=y.URI.revive(r.documentUri);f.ok(this._documents.has(i),`document '${i}' does not exist`),f.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const s=this._documents.get(i).value,c=new n.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(_.MainContext.MainThreadTextEditors),this._logService,new D.Lazy(()=>s.document),r.selections.map(k.Selection.to),r.options,r.visibleRanges.map(h=>k.Range.to(h)),typeof r.editorPosition=="number"?k.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,c)}o.newActiveEditor!==void 0&&(f.ok(o.newActiveEditor===null||this._editors.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this._activeEditorId=o.newActiveEditor),(0,C.dispose)(g),(0,C.dispose)(u),o.removedDocuments&&this._onDidRemoveDocuments.fire(g),o.addedDocuments&&this._onDidAddDocuments.fire(t),(o.removedEditors||o.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),o.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(o){return this._documents.get(o)?.value}allDocuments(){return v.Iterable.map(this._documents.values(),o=>o.value)}getEditor(o){return this._editors.get(o)}activeEditor(o){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return o?g:g?.value}allEditors(){return[...this._editors.values()]}};b=je([He(0,P.IExtHostRpcService),He(1,a.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(fe[55],me([0,1,15,5,2,3,4,14,17]),function(Y,e,f,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");let P=class{constructor(k){this._onDidChangeTabs=new y.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new y.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=k.getProxy(F.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(k){let a=-1;this._tabs=k.map((d,v)=>(d.isActive&&(a=v),Object.freeze({label:d.label,viewColumn:f.ViewColumn.to(d.viewColumn),index:v,resource:C.URI.revive(d.resource),additionalResourcesAndViewIds:d.additionalResourcesAndViewIds.map(({resource:D,viewId:I})=>({resource:C.URI.revive(D),viewId:I})),viewId:d.editorId,isActive:d.isActive,move:async(D,I)=>{this._proxy.$moveTab(d,D,f.ViewColumn.from(I)),await(0,S.raceTimeout)(y.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(d),await(0,S.raceTimeout)(y.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((d,v)=>d.viewColumn===v.viewColumn?d.index-v.index:d.viewColumn-v.viewColumn);const m=this._activeTab;this._activeTab=a===-1?void 0:this._tabs[a],this._activeTab!==m&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};P=je([He(0,_.IExtHostRpcService)],P),e.ExtHostEditorTabs=P}),define(fe[240],me([0,1,2,5,6,7,15,149,9,22]),function(Y,e,f,F,C,y,A,_,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const d=this._schemes.indexOf(m);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),d=[];let v,D,I=14,b=14;for(const l of m){let o=v?(0,S.commonPrefixLength)(v,l):0;for(o===0?D=1:D=b;o<l.length;o++)o+1===l.length?(I=b,b=9):b+=1,d.push([D,l.toUpperCase().charCodeAt(o),b]),d.push([D,l.toLowerCase().charCodeAt(o),b]),D=b;v=l,b=I}d.push([9,58,10]),d.push([10,47,12]),this._stateMachine=new _.StateMachine(d)}}provideDocumentLinks(m){this._initStateMachine();const d=[],v=_.LinkComputer.computeLinks({getLineContent(D){return m.lineAt(D-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const D of v){const I=A.DocumentLink.to(D);I.target&&d.push(I)}return d}}class k{constructor(m,d){this._extHostLanguageFeatures=d,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,d,v,D={}){if(this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const I=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(I,v);let b=2;D.isCaseSensitive&&(b+=1024),D.isReadonly&&(b+=2048),typeof v.copy=="function"&&(b+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&(b+=4),this._proxy.$registerFileSystemProvider(I,d,b).catch(o=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${d}`),console.error(o)});const l=v.onDidChangeFile(o=>{const g=[];for(const t of o){let{uri:u,type:r}=t;if(u.scheme!==d)continue;let i;switch(r){case y.FileChangeType.Changed:i=0;break;case y.FileChangeType.Created:i=1;break;case y.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}g.push({resource:u,type:i})}this._proxy.$onFileSystemChange(I,g)});return(0,C.toDisposable)(()=>{l.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(I),this._proxy.$unregisterProvider(I)})}static _asIStat(m){const{type:d,ctime:v,mtime:D,size:I,permissions:b}=m;return{type:d,ctime:v,mtime:D,size:I,permissions:b}}$stat(m,d){return Promise.resolve(this._getFsProvider(m).stat(f.URI.revive(d))).then(v=>k._asIStat(v))}$readdir(m,d){return Promise.resolve(this._getFsProvider(m).readDirectory(f.URI.revive(d)))}$readFile(m,d){return Promise.resolve(this._getFsProvider(m).readFile(f.URI.revive(d))).then(v=>P.VSBuffer.wrap(v))}$writeFile(m,d,v,D){return Promise.resolve(this._getFsProvider(m).writeFile(f.URI.revive(d),v.buffer,D))}$delete(m,d,v){return Promise.resolve(this._getFsProvider(m).delete(f.URI.revive(d),v))}$rename(m,d,v,D){return Promise.resolve(this._getFsProvider(m).rename(f.URI.revive(d),f.URI.revive(v),D))}$copy(m,d,v,D){const I=this._getFsProvider(m);if(!I.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(I.copy(f.URI.revive(d),f.URI.revive(v),D))}$mkdir(m,d){return Promise.resolve(this._getFsProvider(m).createDirectory(f.URI.revive(d)))}$watch(m,d,v,D){const I=this._getFsProvider(m).watch(f.URI.revive(v),D);this._watches.set(d,I)}$unwatch(m,d){const v=this._watches.get(d);v&&(v.dispose(),this._watches.delete(d))}$open(m,d,v){const D=this._getFsProvider(m);if(!D.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(D.open(f.URI.revive(d),v))}$close(m,d){const v=this._getFsProvider(m);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(d))}$read(m,d,v,D){const I=this._getFsProvider(m);if(!I.read)throw new Error('FileSystemProvider does not implement "read"');const b=P.VSBuffer.alloc(D);return Promise.resolve(I.read(d,v,b.buffer,0,D)).then(l=>b.slice(0,l))}$write(m,d,v,D){const I=this._getFsProvider(m);if(!I.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(I.write(d,v,D.buffer,0,D.byteLength))}_getFsProvider(m){const d=this._fsProvider.get(m);if(!d){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return d}}e.ExtHostFileSystem=k}),define(fe[91],me([0,1,5,43,7,22,4,14,52]),function(Y,e,f,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Bt{constructor(k,a){const m=k.getProxy(f.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(d){return m.$stat(d).catch(Bt._handleError)},readDirectory(d){return m.$readdir(d).catch(Bt._handleError)},createDirectory(d){return m.$mkdir(d).catch(Bt._handleError)},async readFile(d){return m.$readFile(d).then(v=>v.buffer).catch(Bt._handleError)},writeFile(d,v){return m.$writeFile(d,y.VSBuffer.wrap(v)).catch(Bt._handleError)},delete(d,v){return m.$delete(d,{recursive:!1,useTrash:!1,...v}).catch(Bt._handleError)},rename(d,v,D){return m.$rename(d,v,{overwrite:!1,...D}).catch(Bt._handleError)},copy(d,v,D){return m.$copy(d,v,{overwrite:!1,...D}).catch(Bt._handleError)},isWritableFileSystem(d){const v=a.getCapabilities(d);if(typeof v=="number")return!(v&2048)}})}static _handleError(k){if(!(k instanceof Error))throw new C.FileSystemError(String(k));if(k.name==="ENOPRO")throw C.FileSystemError.Unavailable(k.message);switch(k.name){case F.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(k.message);case F.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(k.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(k.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(k.message);case F.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(k.message);case F.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(k.message);default:throw new C.FileSystemError(k.message,k.name)}}};P=je([He(0,_.IExtHostRpcService),He(1,S.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(fe[241],me([0,1,2,40]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class C{constructor(A,_,S,P){this._extHostNotebooks=_,this._textDocumentsAndEditors=S,this._commands=P;const n=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",k=>!0,k=>k),new F.ApiCommandArgument("resource","Interactive resource Uri",k=>!0,k=>k),new F.ApiCommandArgument("controllerId","Notebook controller Id",k=>!0,k=>k),new F.ApiCommandArgument("title","Interactive editor title",k=>!0,k=>k)],new F.ApiCommandResult("Notebook and input URI",k=>{if(k.notebookEditorId!==void 0){const a=this._extHostNotebooks.getEditorById(k.notebookEditorId);return{notebookUri:f.URI.revive(k.notebookUri),inputUri:f.URI.revive(k.inputUri),notebookEditor:a.apiEditor}}return{notebookUri:f.URI.revive(k.notebookUri),inputUri:f.URI.revive(k.inputUri)}}));this._commands.registerApiCommand(n)}$willAddInteractiveDocument(A,_,S,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:_,lines:[""],modeId:S,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(f.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,_){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=C}),define(fe[242],me([0,1,6,5]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(A){this._handlePool=0,this._proxy=A.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const _=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(_,A),(0,f.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(_)})}}e.ExtHostLabelService=C}),define(fe[243],me([0,1,2,25,15,7,5,9,42,16,12,146,6,112,76,87,46,18,3]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class l{constructor(j,ee){this._documents=j,this._provider=ee}async provideDocumentSymbols(j,ee){const re=this._documents.getDocument(j),le=await this._provider.provideDocumentSymbols(re,ee);if(!(0,P.isFalsyOrEmpty)(le))return le[0]instanceof y.DocumentSymbol?le.map(C.DocumentSymbol.from):l._asDocumentSymbolTree(le)}static _asDocumentSymbolTree(j){j=j.slice(0).sort((le,Z)=>{let ae=le.location.range.start.compareTo(Z.location.range.start);return ae===0&&(ae=Z.location.range.end.compareTo(le.location.range.end)),ae});const ee=[],re=[];for(const le of j){const Z={name:le.name||"!!MISSING: name!!",kind:C.SymbolKind.from(le.kind),tags:le.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:le.containerName,range:C.Range.from(le.location.range),selectionRange:C.Range.from(le.location.range),children:[]};for(;;){if(re.length===0){re.push(Z),ee.push(Z);break}const ae=re[re.length-1];if(S.Range.containsRange(ae.range,Z.range)&&!S.Range.equalsRange(ae.range,Z.range)){ae.children&&ae.children.push(Z),re.push(Z);break}re.pop()}}return ee}}class o{constructor(j,ee,re){this._documents=j,this._commands=ee,this._provider=re,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(j,ee){const re=this._documents.getDocument(j),le=await this._provider.provideCodeLenses(re,ee);if(!le||ee.isCancellationRequested)return;const Z=this._cache.add(le),ae=new a.DisposableStore;this._disposables.set(Z,ae);const pe={cacheId:Z,lenses:[]};for(let Me=0;Me<le.length;Me++)pe.lenses.push({cacheId:[Z,Me],range:C.Range.from(le[Me].range),command:this._commands.toInternal(le[Me].command,ae)});return pe}async resolveCodeLens(j,ee){const re=j.cacheId&&this._cache.get(...j.cacheId);if(!re)return;let le;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?le=re:le=await this._provider.resolveCodeLens(re,ee),le||(le=re),ee.isCancellationRequested)return;const Z=j.cacheId&&this._disposables.get(j.cacheId[0]);if(!!Z)return j.command=this._commands.toInternal(le.command??o._badCmd,Z),j}releaseCodeLenses(j){this._disposables.get(j)?.dispose(),this._disposables.delete(j),this._cache.delete(j)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function g(ze){return Array.isArray(ze)?ze.map(C.DefinitionLink.from):ze?[C.DefinitionLink.from(ze)]:[]}class t{constructor(j,ee){this._documents=j,this._provider=ee}async provideDefinition(j,ee,re){const le=this._documents.getDocument(j),Z=C.Position.to(ee),ae=await this._provider.provideDefinition(le,Z,re);return g(ae)}}class u{constructor(j,ee){this._documents=j,this._provider=ee}async provideDeclaration(j,ee,re){const le=this._documents.getDocument(j),Z=C.Position.to(ee),ae=await this._provider.provideDeclaration(le,Z,re);return g(ae)}}class r{constructor(j,ee){this._documents=j,this._provider=ee}async provideImplementation(j,ee,re){const le=this._documents.getDocument(j),Z=C.Position.to(ee),ae=await this._provider.provideImplementation(le,Z,re);return g(ae)}}class i{constructor(j,ee){this._documents=j,this._provider=ee}async provideTypeDefinition(j,ee,re){const le=this._documents.getDocument(j),Z=C.Position.to(ee),ae=await this._provider.provideTypeDefinition(le,Z,re);return g(ae)}}class s{constructor(j,ee){this._documents=j,this._provider=ee}async provideHover(j,ee,re){const le=this._documents.getDocument(j),Z=C.Position.to(ee),ae=await this._provider.provideHover(le,Z,re);if(!(!ae||(0,P.isFalsyOrEmpty)(ae.contents)))return ae.range||(ae.range=le.getWordRangeAtPosition(Z)),ae.range||(ae.range=new y.Range(Z,Z)),C.Hover.from(ae)}}class c{constructor(j,ee){this._documents=j,this._provider=ee}async provideEvaluatableExpression(j,ee,re){const le=this._documents.getDocument(j),Z=C.Position.to(ee),ae=await this._provider.provideEvaluatableExpression(le,Z,re);if(ae)return C.EvaluatableExpression.from(ae)}}class h{constructor(j,ee){this._documents=j,this._provider=ee}async provideInlineValues(j,ee,re,le){const Z=this._documents.getDocument(j),ae=await this._provider.provideInlineValues(Z,C.Range.to(ee),C.InlineValueContext.to(re),le);if(Array.isArray(ae))return ae.map(pe=>C.InlineValue.from(pe))}}class w{constructor(j,ee){this._documents=j,this._provider=ee}async provideDocumentHighlights(j,ee,re){const le=this._documents.getDocument(j),Z=C.Position.to(ee),ae=await this._provider.provideDocumentHighlights(le,Z,re);if(Array.isArray(ae))return ae.map(C.DocumentHighlight.from)}}class E{constructor(j,ee){this._documents=j,this._provider=ee}async provideLinkedEditingRanges(j,ee,re){const le=this._documents.getDocument(j),Z=C.Position.to(ee),ae=await this._provider.provideLinkedEditingRanges(le,Z,re);if(ae&&Array.isArray(ae.ranges))return{ranges:(0,P.coalesce)(ae.ranges.map(C.Range.from)),wordPattern:ae.wordPattern}}}class p{constructor(j,ee){this._documents=j,this._provider=ee}async provideReferences(j,ee,re,le){const Z=this._documents.getDocument(j),ae=C.Position.to(ee),pe=await this._provider.provideReferences(Z,ae,re,le);if(Array.isArray(pe))return pe.map(C.location.from)}}class T{constructor(j,ee,re,le,Z,ae,pe){this._documents=j,this._commands=ee,this._diagnostics=re,this._provider=le,this._logService=Z,this._extension=ae,this._apiDeprecation=pe,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(j,ee,re,le){const Z=this._documents.getDocument(j),ae=k.Selection.isISelection(ee)?C.Selection.to(ee):C.Range.to(ee),pe=[];for(const Ae of this._diagnostics.getDiagnostics(j))if(ae.intersection(Ae.range)&&pe.push(Ae)>T._maxCodeActionsPerFile)break;const Me={diagnostics:pe,only:re.only?new y.CodeActionKind(re.only):void 0,triggerKind:C.CodeActionTriggerKind.to(re.trigger)},qe=await this._provider.provideCodeActions(Z,ae,Me,le);if(!(0,P.isNonEmptyArray)(qe)||le.isCancellationRequested)return;const Qe=this._cache.add(qe),Je=new a.DisposableStore;this._disposables.set(Qe,Je);const rt=[];for(let Ae=0;Ae<qe.length;Ae++){const nt=qe[Ae];!nt||(T._isCommand(nt)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:nt.title,command:this._commands.toInternal(nt,Je)})):(Me.only&&(nt.kind?Me.only.contains(nt.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[Qe,Ae],title:nt.title,command:nt.command&&this._commands.toInternal(nt.command,Je),diagnostics:nt.diagnostics&&nt.diagnostics.map(C.Diagnostic.from),edit:nt.edit&&C.WorkspaceEdit.from(nt.edit),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,disabled:nt.disabled?.reason})))}return{cacheId:Qe,actions:rt}}async resolveCodeAction(j,ee){const[re,le]=j,Z=this._cache.get(re,le);if(!Z||T._isCommand(Z)||!this._provider.resolveCodeAction)return;const ae=await this._provider.resolveCodeAction(Z,ee)??Z;return ae?.edit?C.WorkspaceEdit.from(ae.edit):void 0}releaseCodeActions(j){this._disposables.get(j)?.dispose(),this._disposables.delete(j),this._cache.delete(j)}static _isCommand(j){return typeof j.command=="string"&&typeof j.title=="string"}}T._maxCodeActionsPerFile=1e3;class L{constructor(j,ee){this._documents=j,this._provider=ee}async provideDocumentFormattingEdits(j,ee,re){const le=this._documents.getDocument(j),Z=await this._provider.provideDocumentFormattingEdits(le,ee,re);if(Array.isArray(Z))return Z.map(C.TextEdit.from)}}class M{constructor(j,ee){this._documents=j,this._provider=ee}async provideDocumentRangeFormattingEdits(j,ee,re,le){const Z=this._documents.getDocument(j),ae=C.Range.to(ee),pe=await this._provider.provideDocumentRangeFormattingEdits(Z,ae,re,le);if(Array.isArray(pe))return pe.map(C.TextEdit.from)}}class R{constructor(j,ee){this._documents=j,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,ee,re,le,Z){const ae=this._documents.getDocument(j),pe=C.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(ae,pe,re,le,Z);if(Array.isArray(Me))return Me.map(C.TextEdit.from)}}class ${constructor(j,ee){this._provider=j,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(j,ee){const re=A.IdObject.mixin({symbols:[]}),le=await this._provider.provideWorkspaceSymbols(j,ee);if((0,P.isNonEmptyArray)(le))for(const Z of le){if(!Z)continue;if(!Z.name){this._logService.warn("INVALID SymbolInformation, lacks name",Z);continue}const ae=A.IdObject.mixin(C.WorkspaceSymbol.from(Z));this._symbolCache.set(ae._id,Z),re.symbols.push(ae)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(j,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return j;const re=this._symbolCache.get(j._id);if(re){const le=await this._provider.resolveWorkspaceSymbol(re,ee);return le&&(0,F.mixin)(j,C.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(j){const ee=this._resultCache.get(j);if(ee){for(let[re,le]=ee;re<=le;re++)this._symbolCache.delete(re);this._resultCache.delete(j)}}}class z{constructor(j,ee,re){this._documents=j,this._provider=ee,this._logService=re}static supportsResolving(j){return typeof j.prepareRename=="function"}async provideRenameEdits(j,ee,re,le){const Z=this._documents.getDocument(j),ae=C.Position.to(ee);try{const pe=await this._provider.provideRenameEdits(Z,ae,re,le);return pe?C.WorkspaceEdit.from(pe):void 0}catch(pe){const Me=z._asMessage(pe);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(pe)}}async resolveRenameLocation(j,ee,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(j),Z=C.Position.to(ee);try{const ae=await this._provider.prepareRename(le,Z,re);let pe,Me;if(y.Range.isRange(ae)?(pe=ae,Me=le.getText(ae)):(0,n.isObject)(ae)&&(pe=ae.range,Me=ae.placeholder),!pe||!Me)return;if(pe.start.line>Z.line||pe.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(pe),text:Me}}catch(ae){const pe=z._asMessage(ae);return pe?{rejectReason:pe,range:void 0,text:void 0}:Promise.reject(ae)}}static _asMessage(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class O{constructor(j,ee){this.resultId=j,this.tokens=ee}}class V{constructor(j,ee){this._documents=j,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(j,ee,re){const le=this._documents.getDocument(j),Z=ee!==0?this._previousResults.get(ee):null;let ae=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(le,Z.resultId,re):await this._provider.provideDocumentSemanticTokens(le,re);return Z&&this._previousResults.delete(ee),ae?(ae=V._fixProvidedSemanticTokens(ae),this._send(V._convertToEdits(Z,ae),ae)):null}async releaseDocumentSemanticColoring(j){this._previousResults.delete(j)}static _fixProvidedSemanticTokens(j){return V._isSemanticTokens(j)?V._isCorrectSemanticTokens(j)?j:new y.SemanticTokens(new Uint32Array(j.data),j.resultId):V._isSemanticTokensEdits(j)?V._isCorrectSemanticTokensEdits(j)?j:new y.SemanticTokensEdits(j.edits.map(ee=>new y.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),j.resultId):j}static _isSemanticTokens(j){return j&&!!j.data}static _isCorrectSemanticTokens(j){return j.data instanceof Uint32Array}static _isSemanticTokensEdits(j){return j&&Array.isArray(j.edits)}static _isCorrectSemanticTokensEdits(j){for(const ee of j.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(j,ee){if(!V._isSemanticTokens(ee)||!j||!j.tokens)return ee;const re=j.tokens,le=re.length,Z=ee.data,ae=Z.length;let pe=0;const Me=Math.min(le,ae);for(;pe<Me&&re[pe]===Z[pe];)pe++;if(pe===le&&pe===ae)return new y.SemanticTokensEdits([],ee.resultId);let qe=0;const Qe=Me-pe;for(;qe<Qe&&re[le-qe-1]===Z[ae-qe-1];)qe++;return new y.SemanticTokensEdits([{start:pe,deleteCount:le-pe-qe,data:Z.subarray(pe,ae-qe)}],ee.resultId)}_send(j,ee){if(V._isSemanticTokens(j)){const re=this._nextResultId++;return this._previousResults.set(re,new O(j.resultId,j.data)),(0,m.encodeSemanticTokensDto)({id:re,type:"full",data:j.data})}if(V._isSemanticTokensEdits(j)){const re=this._nextResultId++;return V._isSemanticTokens(ee)?this._previousResults.set(re,new O(ee.resultId,ee.data)):this._previousResults.set(re,new O(j.resultId)),(0,m.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(j.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class N{constructor(j,ee){this._documents=j,this._provider=ee}async provideDocumentRangeSemanticTokens(j,ee,re){const le=this._documents.getDocument(j),Z=await this._provider.provideDocumentRangeSemanticTokens(le,C.Range.to(ee),re);return Z?this._send(Z):null}_send(j){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:j.data})}}e.DocumentRangeSemanticTokensAdapter=N;class U{constructor(j,ee,re,le,Z){this._documents=j,this._commands=ee,this._provider=re,this._apiDeprecation=le,this._extension=Z,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}async provideCompletionItems(j,ee,re,le){const Z=this._documents.getDocument(j),ae=C.Position.to(ee),pe=Z.getWordRangeAtPosition(ae)||new y.Range(ae,ae),Me=pe.with({end:ae}),qe=new D.StopWatch(!0),Qe=await this._provider.provideCompletionItems(Z,ae,le,C.CompletionContext.to(re));if(!Qe||le.isCancellationRequested)return;const Je=Array.isArray(Qe)?new y.CompletionList(Qe):Qe,rt=U.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),Ae=new a.DisposableStore;this._disposables.set(rt,Ae);const nt=[],J={x:rt,b:nt,a:{replace:C.Range.from(pe),insert:C.Range.from(Me)},c:Je.isIncomplete||void 0,d:qe.elapsed()};for(let te=0;te<Je.items.length;te++){const ve=Je.items[te],Xe=this._convertCompletionItem(ve,[rt,te],Me,pe);nt.push(Xe)}return J}async resolveCompletionItem(j,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...j);if(!re)return;const le=await this._provider.resolveCompletionItem(re,ee);if(!!le)return this._convertCompletionItem(le,j)}releaseCompletionItems(j){this._disposables.get(j)?.dispose(),this._disposables.delete(j),this._cache.delete(j)}_convertCompletionItem(j,ee,re,le){const Z=this._disposables.get(ee[0]);if(!Z)throw Error("DisposableStore is missing...");const ae={x:ee,a:j.label,b:j.kind!==void 0?C.CompletionItemKind.from(j.kind):void 0,n:j.tags&&j.tags.map(C.CompletionItemTag.from),c:j.detail,d:typeof j.documentation=="undefined"?void 0:C.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters,l:j.additionalTextEdits&&j.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(j.command,Z)};j.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=j.textEdit.newText):typeof j.insertText=="string"?ae.h=j.insertText:j.insertText instanceof y.SnippetString&&(ae.h=j.insertText.value,ae.i|=4);let pe;return j.textEdit?pe=j.textEdit.range:j.range&&(pe=j.range),y.Range.isRange(pe)?ae.j=C.Range.from(pe):pe&&(!re?.isEqual(pe.inserting)||!le?.isEqual(pe.replacing))&&(ae.j={insert:C.Range.from(pe.inserting),replace:C.Range.from(pe.replacing)}),ae}}class x{constructor(j,ee,re){this._documents=j,this._provider=ee,this._commands=re,this._cache=new v.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(j,ee,re,le){const Z=this._documents.getDocument(j),ae=C.Position.to(ee),pe=await this._provider.provideInlineCompletionItems(Z,ae,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:C.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text}:void 0,triggerKind:re.triggerKind},le);if(!pe||le.isCancellationRequested)return;const Me=(0,n.isArray)(pe)?{items:pe}:pe,qe=this._cache.add(Me.items);let Qe;return{pid:qe,items:Me.items.map((Je,rt)=>{let Ae;return Je.command&&(Qe||(Qe=new a.DisposableStore,this._disposables.set(qe,Qe)),Ae=this._commands.toInternal(Je.command,Qe)),{text:Je.text,range:Je.range?C.Range.from(Je.range):void 0,command:Ae,idx:rt}})}}disposeCompletions(j){this._cache.delete(j);const ee=this._disposables.get(j);ee&&ee.clear(),this._disposables.delete(j)}handleDidShowCompletionItem(j,ee){const re=this._cache.get(j,ee);re&&B.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class B{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(j){let ee=B.map.get(j);return ee||(ee=new B,B.map.set(j,ee)),ee}fireOnDidShowCompletionItem(j){this._onDidShowCompletionItemEmitter.fire(j)}}e.InlineCompletionController=B,B.map=new WeakMap;class H{constructor(j,ee){this._documents=j,this._provider=ee,this._cache=new v.Cache("SignatureHelp")}async provideSignatureHelp(j,ee,re,le){const Z=this._documents.getDocument(j),ae=C.Position.to(ee),pe=this.reviveContext(re),Me=await this._provider.provideSignatureHelp(Z,ae,le,pe);if(Me){const qe=this._cache.add([Me]);return{...C.SignatureHelp.from(Me),id:qe}}}reviveContext(j){let ee;if(j.activeSignatureHelp){const re=C.SignatureHelp.to(j.activeSignatureHelp),le=this._cache.get(j.activeSignatureHelp.id,0);le?(ee=le,ee.activeSignature=re.activeSignature,ee.activeParameter=re.activeParameter):ee=re}return{...j,activeSignatureHelp:ee}}releaseSignatureHelp(j){this._cache.delete(j)}}class G{constructor(j,ee){this._documents=j,this._provider=ee}async provideInlayHints(j,ee,re){const le=this._documents.getDocument(j),Z=await this._provider.provideInlayHints(le,C.Range.to(ee),re);return Z?{hints:Z.map(C.InlayHint.from)}:void 0}}class K{constructor(j,ee){this._documents=j,this._provider=ee,this._cache=new v.Cache("DocumentLink")}async provideLinks(j,ee){const re=this._documents.getDocument(j),le=await this._provider.provideDocumentLinks(re,ee);if(!(!Array.isArray(le)||le.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.filter(K._validateLink).map(C.DocumentLink.from)};{const Z=this._cache.add(le),ae={links:[],id:Z};for(let pe=0;pe<le.length;pe++){if(!K._validateLink(le[pe]))continue;const Me=C.DocumentLink.from(le[pe]);Me.cacheId=[Z,pe],ae.links.push(Me)}return ae}}}static _validateLink(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...j);if(!re)return;const le=await this._provider.resolveDocumentLink(re,ee);if(!(!le||!K._validateLink(le)))return C.DocumentLink.from(le)}releaseLinks(j){this._cache.delete(j)}}class X{constructor(j,ee){this._documents=j,this._provider=ee}async provideColors(j,ee){const re=this._documents.getDocument(j),le=await this._provider.provideDocumentColors(re,ee);return Array.isArray(le)?le.map(ae=>({color:C.Color.from(ae.color),range:C.Range.from(ae.range)})):[]}async provideColorPresentations(j,ee,re){const le=this._documents.getDocument(j),Z=C.Range.to(ee.range),ae=C.Color.to(ee.color),pe=await this._provider.provideColorPresentations(ae,{document:le,range:Z},re);if(!!Array.isArray(pe))return pe.map(C.ColorPresentation.from)}}class de{constructor(j,ee){this._documents=j,this._provider=ee}async provideFoldingRanges(j,ee,re){const le=this._documents.getDocument(j),Z=await this._provider.provideFoldingRanges(le,ee,re);if(!!Array.isArray(Z))return Z.map(C.FoldingRange.from)}}class be{constructor(j,ee,re){this._documents=j,this._provider=ee,this._logService=re}async provideSelectionRanges(j,ee,re){const le=this._documents.getDocument(j),Z=ee.map(C.Position.to),ae=await this._provider.provideSelectionRanges(le,Z,re);if(!(0,P.isNonEmptyArray)(ae))return[];if(ae.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const pe=[];for(let Me=0;Me<Z.length;Me++){const qe=[];pe.push(qe);let Qe=Z[Me],Je=ae[Me];for(;;){if(!Je.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(qe.push(C.SelectionRange.from(Je)),!Je.parent)break;Qe=Je.range,Je=Je.parent}}return pe}}class Se{constructor(j,ee){this._documents=j,this._provider=ee,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(j,ee,re){const le=this._documents.getDocument(j),Z=C.Position.to(ee),ae=await this._provider.prepareCallHierarchy(le,Z,re);if(!ae)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(ae)?ae.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,ae)]}async provideCallsTo(j,ee,re){const le=this._itemFromCache(j,ee);if(!le)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(le,re);if(!!Z)return Z.map(ae=>({from:this._cacheAndConvertItem(j,ae.from),fromRanges:ae.fromRanges.map(pe=>C.Range.from(pe))}))}async provideCallsFrom(j,ee,re){const le=this._itemFromCache(j,ee);if(!le)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(le,re);if(!!Z)return Z.map(ae=>({to:this._cacheAndConvertItem(j,ae.to),fromRanges:ae.fromRanges.map(pe=>C.Range.from(pe))}))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,ee){const re=this._cache.get(j),le=C.CallHierarchyItem.from(ee,j,re.size.toString(36));return re.set(le._itemId,ee),le}_itemFromCache(j,ee){return this._cache.get(j)?.get(ee)}}class Ie{constructor(j,ee){this._documents=j,this._provider=ee,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(j,ee,re){const le=this._documents.getDocument(j),Z=C.Position.to(ee),ae=await this._provider.prepareTypeHierarchy(le,Z,re);if(!ae)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(ae)?ae.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,ae)]}async provideSupertypes(j,ee,re){const le=this._itemFromCache(j,ee);if(!le)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(le,re);if(!!Z)return Z.map(ae=>this._cacheAndConvertItem(j,ae))}async provideSubtypes(j,ee,re){const le=this._itemFromCache(j,ee);if(!le)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(le,re);if(!!Z)return Z.map(ae=>this._cacheAndConvertItem(j,ae))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,ee){const re=this._cache.get(j),le=C.TypeHierarchyItem.from(ee,j,re.size.toString(36));return re.set(le._itemId,ee),le}_itemFromCache(j,ee){return this._cache.get(j)?.get(ee)}}class Oe{constructor(j,ee){this.adapter=j,this.extension=ee}}class xe{constructor(j,ee,re,le,Z,ae,pe){this._adapter=new Map,this._uriTransformer=ee,this._proxy=j.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=le,this._diagnostics=Z,this._logService=ae,this._apiDeprecation=pe}_transformDocumentSelector(j){return C.DocumentSelector.from(j,this._uriTransformer)}_createDisposable(j){return new y.Disposable(()=>{this._adapter.delete(j),this._proxy.$unregister(j)})}_nextHandle(){return xe._handlePool++}_withAdapter(j,ee,re,le,Z=!1){const ae=this._adapter.get(j);if(!ae)return Promise.resolve(le);if(ae.adapter instanceof ee){let pe;ae.extension&&(pe=Date.now(),this._logService.trace(`[${ae.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=re(ae.adapter,ae.extension),qe=ae.extension;return qe&&Promise.resolve(Me).then(()=>this._logService.trace(`[${qe.identifier.value}] provider DONE after ${Date.now()-pe}ms`),Qe=>{Z&&Qe instanceof I.CancellationError||(this._logService.error(`[${qe.identifier.value}] provider FAILED`),this._logService.error(Qe))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(j,ee){const re=this._nextHandle();return this._adapter.set(re,new Oe(j,ee)),re}static _extLabel(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,ee,re,le){const Z=this._addNewAdapter(new l(this._documents,re),j),ae=le&&le.label||xe._extLabel(j);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(ee),ae),this._createDisposable(Z)}$provideDocumentSymbols(j,ee,re){return this._withAdapter(j,l,le=>le.provideDocumentSymbols(f.URI.revive(ee),re),void 0)}registerCodeLensProvider(j,ee,re){const le=this._nextHandle(),Z=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new Oe(new o(this._documents,this._commands.converter,re),j)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(ee),Z);let ae=this._createDisposable(le);if(Z!==void 0){const pe=re.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Z));ae=y.Disposable.from(ae,pe)}return ae}$provideCodeLenses(j,ee,re){return this._withAdapter(j,o,le=>le.provideCodeLenses(f.URI.revive(ee),re),void 0)}$resolveCodeLens(j,ee,re){return this._withAdapter(j,o,le=>le.resolveCodeLens(ee,re),void 0)}$releaseCodeLenses(j,ee){this._withAdapter(j,o,re=>Promise.resolve(re.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(j,ee,re){const le=this._addNewAdapter(new t(this._documents,re),j);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDefinition(j,ee,re,le){return this._withAdapter(j,t,Z=>Z.provideDefinition(f.URI.revive(ee),re,le),[])}registerDeclarationProvider(j,ee,re){const le=this._addNewAdapter(new u(this._documents,re),j);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDeclaration(j,ee,re,le){return this._withAdapter(j,u,Z=>Z.provideDeclaration(f.URI.revive(ee),re,le),[])}registerImplementationProvider(j,ee,re){const le=this._addNewAdapter(new r(this._documents,re),j);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideImplementation(j,ee,re,le){return this._withAdapter(j,r,Z=>Z.provideImplementation(f.URI.revive(ee),re,le),[])}registerTypeDefinitionProvider(j,ee,re){const le=this._addNewAdapter(new i(this._documents,re),j);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideTypeDefinition(j,ee,re,le){return this._withAdapter(j,i,Z=>Z.provideTypeDefinition(f.URI.revive(ee),re,le),[])}registerHoverProvider(j,ee,re,le){const Z=this._addNewAdapter(new s(this._documents,re),j);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideHover(j,ee,re,le){return this._withAdapter(j,s,Z=>Z.provideHover(f.URI.revive(ee),re,le),void 0)}registerEvaluatableExpressionProvider(j,ee,re,le){const Z=this._addNewAdapter(new c(this._documents,re),j);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideEvaluatableExpression(j,ee,re,le){return this._withAdapter(j,c,Z=>Z.provideEvaluatableExpression(f.URI.revive(ee),re,le),void 0)}registerInlineValuesProvider(j,ee,re,le){const Z=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new h(this._documents,re),j);this._proxy.$registerInlineValuesProvider(ae,this._transformDocumentSelector(ee),Z);let pe=this._createDisposable(ae);if(Z!==void 0){const Me=re.onDidChangeInlineValues(qe=>this._proxy.$emitInlineValuesEvent(Z));pe=y.Disposable.from(pe,Me)}return pe}$provideInlineValues(j,ee,re,le,Z){return this._withAdapter(j,h,ae=>ae.provideInlineValues(f.URI.revive(ee),re,le,Z),void 0)}registerDocumentHighlightProvider(j,ee,re){const le=this._addNewAdapter(new w(this._documents,re),j);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentHighlights(j,ee,re,le){return this._withAdapter(j,w,Z=>Z.provideDocumentHighlights(f.URI.revive(ee),re,le),void 0)}registerLinkedEditingRangeProvider(j,ee,re){const le=this._addNewAdapter(new E(this._documents,re),j);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideLinkedEditingRanges(j,ee,re,le){return this._withAdapter(j,E,async Z=>{const ae=await Z.provideLinkedEditingRanges(f.URI.revive(ee),re,le);if(ae)return{ranges:ae.ranges,wordPattern:ae.wordPattern?xe._serializeRegExp(ae.wordPattern):void 0}},void 0)}registerReferenceProvider(j,ee,re){const le=this._addNewAdapter(new p(this._documents,re),j);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideReferences(j,ee,re,le,Z){return this._withAdapter(j,p,ae=>ae.provideReferences(f.URI.revive(ee),re,le,Z),void 0)}registerCodeActionProvider(j,ee,re,le){const Z=new a.DisposableStore,ae=this._addNewAdapter(new T(this._documents,this._commands.converter,this._diagnostics,re,this._logService,j,this._apiDeprecation),j);return this._proxy.$registerQuickFixSupport(ae,this._transformDocumentSelector(ee),{providedKinds:le?.providedCodeActionKinds?.map(pe=>pe.value),documentation:le?.documentation?.map(pe=>({kind:pe.kind.value,command:this._commands.converter.toInternal(pe.command,Z)}))},xe._extLabel(j),Boolean(re.resolveCodeAction)),Z.add(this._createDisposable(ae)),Z}$provideCodeActions(j,ee,re,le,Z){return this._withAdapter(j,T,ae=>ae.provideCodeActions(f.URI.revive(ee),re,le,Z),void 0)}$resolveCodeAction(j,ee,re){return this._withAdapter(j,T,le=>le.resolveCodeAction(ee,re),void 0)}$releaseCodeActions(j,ee){this._withAdapter(j,T,re=>Promise.resolve(re.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(j,ee,re){const le=this._addNewAdapter(new L(this._documents,re),j);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(ee),j.identifier,j.displayName||j.name),this._createDisposable(le)}$provideDocumentFormattingEdits(j,ee,re,le){return this._withAdapter(j,L,Z=>Z.provideDocumentFormattingEdits(f.URI.revive(ee),re,le),void 0)}registerDocumentRangeFormattingEditProvider(j,ee,re){const le=this._addNewAdapter(new M(this._documents,re),j);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(ee),j.identifier,j.displayName||j.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(j,ee,re,le,Z){return this._withAdapter(j,M,ae=>ae.provideDocumentRangeFormattingEdits(f.URI.revive(ee),re,le,Z),void 0)}registerOnTypeFormattingEditProvider(j,ee,re,le){const Z=this._addNewAdapter(new R(this._documents,re),j);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(ee),le,j.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(j,ee,re,le,Z,ae){return this._withAdapter(j,R,pe=>pe.provideOnTypeFormattingEdits(f.URI.revive(ee),re,le,Z,ae),void 0)}registerWorkspaceSymbolProvider(j,ee){const re=this._addNewAdapter(new $(ee,this._logService),j);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(j,ee,re){return this._withAdapter(j,$,le=>le.provideWorkspaceSymbols(ee,re),{symbols:[]})}$resolveWorkspaceSymbol(j,ee,re){return this._withAdapter(j,$,le=>le.resolveWorkspaceSymbol(ee,re),void 0)}$releaseWorkspaceSymbols(j,ee){this._withAdapter(j,$,re=>re.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(j,ee,re){const le=this._addNewAdapter(new z(this._documents,re,this._logService),j);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(ee),z.supportsResolving(re)),this._createDisposable(le)}$provideRenameEdits(j,ee,re,le,Z){return this._withAdapter(j,z,ae=>ae.provideRenameEdits(f.URI.revive(ee),re,le,Z),void 0)}$resolveRenameLocation(j,ee,re,le){return this._withAdapter(j,z,Z=>Z.resolveRenameLocation(f.URI.revive(ee),re,le),void 0)}registerDocumentSemanticTokensProvider(j,ee,re,le){const Z=this._nextHandle(),ae=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Z,new Oe(new V(this._documents,re),j)),this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(ee),le,ae);let pe=this._createDisposable(Z);if(ae){const Me=re.onDidChangeSemanticTokens(qe=>this._proxy.$emitDocumentSemanticTokensEvent(ae));pe=y.Disposable.from(pe,Me)}return pe}$provideDocumentSemanticTokens(j,ee,re,le){return this._withAdapter(j,V,Z=>Z.provideDocumentSemanticTokens(f.URI.revive(ee),re,le),null,!0)}$releaseDocumentSemanticTokens(j,ee){this._withAdapter(j,V,re=>re.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(j,ee,re,le){const Z=this._addNewAdapter(new N(this._documents,re),j);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(ee),le),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(j,ee,re,le){return this._withAdapter(j,N,Z=>Z.provideDocumentRangeSemanticTokens(f.URI.revive(ee),re,le),null,!0)}registerCompletionItemProvider(j,ee,re,le){const Z=this._addNewAdapter(new U(this._documents,this._commands.converter,re,this._apiDeprecation,j),j);return this._proxy.$registerSuggestSupport(Z,this._transformDocumentSelector(ee),le,U.supportsResolving(re),`${j.identifier.value}(${le.join("")})`),this._createDisposable(Z)}$provideCompletionItems(j,ee,re,le,Z){return this._withAdapter(j,U,ae=>ae.provideCompletionItems(f.URI.revive(ee),re,le,Z),void 0)}$resolveCompletionItem(j,ee,re){return this._withAdapter(j,U,le=>le.resolveCompletionItem(ee,re),void 0)}$releaseCompletionItems(j,ee){this._withAdapter(j,U,re=>re.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(j,ee,re){const le=this._addNewAdapter(new x(this._documents,re,this._commands.converter),j);return this._proxy.$registerInlineCompletionsSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideInlineCompletions(j,ee,re,le,Z){return this._withAdapter(j,x,ae=>ae.provideInlineCompletions(f.URI.revive(ee),re,le,Z),void 0)}$handleInlineCompletionDidShow(j,ee,re){this._withAdapter(j,x,async le=>{le.handleDidShowCompletionItem(ee,re)},void 0)}$freeInlineCompletionsList(j,ee){this._withAdapter(j,x,async re=>{re.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(j,ee,re,le){const Z=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,ae=this._addNewAdapter(new H(this._documents,re),j);return this._proxy.$registerSignatureHelpProvider(ae,this._transformDocumentSelector(ee),Z),this._createDisposable(ae)}$provideSignatureHelp(j,ee,re,le,Z){return this._withAdapter(j,H,ae=>ae.provideSignatureHelp(f.URI.revive(ee),re,le,Z),void 0)}$releaseSignatureHelp(j,ee){this._withAdapter(j,H,re=>re.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(j,ee,re){const le=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new G(this._documents,re),j);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(ee),le);let ae=this._createDisposable(Z);if(le!==void 0){const pe=re.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(le));ae=y.Disposable.from(ae,pe)}return ae}$provideInlayHints(j,ee,re,le){return this._withAdapter(j,G,Z=>Z.provideInlayHints(f.URI.revive(ee),re,le),void 0)}registerDocumentLinkProvider(j,ee,re){const le=this._addNewAdapter(new K(this._documents,re),j);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(ee),typeof re.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(j,ee,re){return this._withAdapter(j,K,le=>le.provideLinks(f.URI.revive(ee),re),void 0)}$resolveDocumentLink(j,ee,re){return this._withAdapter(j,K,le=>le.resolveLink(ee,re),void 0)}$releaseDocumentLinks(j,ee){this._withAdapter(j,K,re=>re.releaseLinks(ee),void 0)}registerColorProvider(j,ee,re){const le=this._addNewAdapter(new X(this._documents,re),j);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentColors(j,ee,re){return this._withAdapter(j,X,le=>le.provideColors(f.URI.revive(ee),re),[])}$provideColorPresentations(j,ee,re,le){return this._withAdapter(j,X,Z=>Z.provideColorPresentations(f.URI.revive(ee),re,le),void 0)}registerFoldingRangeProvider(j,ee,re){const le=this._nextHandle(),Z=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new Oe(new de(this._documents,re),j)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(ee),Z);let ae=this._createDisposable(le);if(Z!==void 0){const pe=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));ae=y.Disposable.from(ae,pe)}return ae}$provideFoldingRanges(j,ee,re,le){return this._withAdapter(j,de,Z=>Z.provideFoldingRanges(f.URI.revive(ee),re,le),void 0)}registerSelectionRangeProvider(j,ee,re){const le=this._addNewAdapter(new be(this._documents,re,this._logService),j);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideSelectionRanges(j,ee,re,le){return this._withAdapter(j,be,Z=>Z.provideSelectionRanges(f.URI.revive(ee),re,le),[])}registerCallHierarchyProvider(j,ee,re){const le=this._addNewAdapter(new Se(this._documents,re),j);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareCallHierarchy(j,ee,re,le){return this._withAdapter(j,Se,Z=>Promise.resolve(Z.prepareSession(f.URI.revive(ee),re,le)),void 0)}$provideCallHierarchyIncomingCalls(j,ee,re,le){return this._withAdapter(j,Se,Z=>Z.provideCallsTo(ee,re,le),void 0)}$provideCallHierarchyOutgoingCalls(j,ee,re,le){return this._withAdapter(j,Se,Z=>Z.provideCallsFrom(ee,re,le),void 0)}$releaseCallHierarchy(j,ee){this._withAdapter(j,Se,re=>Promise.resolve(re.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(j,ee,re){const le=this._addNewAdapter(new Ie(this._documents,re),j);return this._proxy.$registerTypeHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareTypeHierarchy(j,ee,re,le){return this._withAdapter(j,Ie,Z=>Promise.resolve(Z.prepareSession(f.URI.revive(ee),re,le)),void 0)}$provideTypeHierarchySupertypes(j,ee,re,le){return this._withAdapter(j,Ie,Z=>Z.provideSupertypes(ee,re,le),void 0)}$provideTypeHierarchySubtypes(j,ee,re,le){return this._withAdapter(j,Ie,Z=>Z.provideSubtypes(ee,re,le),void 0)}$releaseTypeHierarchy(j,ee){this._withAdapter(j,Ie,re=>Promise.resolve(re.releaseSession(ee)),void 0)}static _serializeRegExp(j){return{pattern:j.source,flags:(0,_.regExpFlags)(j)}}static _serializeIndentationRule(j){return{decreaseIndentPattern:xe._serializeRegExp(j.decreaseIndentPattern),increaseIndentPattern:xe._serializeRegExp(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?xe._serializeRegExp(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?xe._serializeRegExp(j.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(j){return{beforeText:xe._serializeRegExp(j.beforeText),afterText:j.afterText?xe._serializeRegExp(j.afterText):void 0,previousLineText:j.previousLineText?xe._serializeRegExp(j.previousLineText):void 0,action:j.action}}static _serializeOnEnterRules(j){return j.map(xe._serializeOnEnterRule)}setLanguageConfiguration(j,ee,re){let{wordPattern:le}=re;if(le&&(0,_.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(ee,le):this._documents.setWordDefinitionFor(ee,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const Z=this._nextHandle(),ae={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?xe._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?xe._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?xe._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,ee,ae),this._createDisposable(Z)}$setWordDefinitions(j){for(const ee of j)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=xe,xe._handlePool=0}),define(fe[244],me([0,1,5,15,7,49,17,6]),function(Y,e,f,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(n,k,a,m){this._documents=k,this._commands=a,this._uriTransformer=m,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=n.getProxy(f.MainContext.MainThreadLanguages)}$acceptLanguageIds(n){this._languageIds=n}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(n,k){await this._proxy.$changeLanguage(n,k);const a=this._documents.getDocumentData(n);if(!a)throw new Error(`document '${n.toString}' NOT found`);return a.document}async tokenAtPosition(n,k){const a=n.version,m=F.Position.from(k),d=await this._proxy.$tokensAtPosition(n.uri,m),v={type:C.StandardTokenType.Other,range:n.getWordRangeAtPosition(k)??new C.Range(k.line,k.character,k.line,k.character)};if(!d)return v;const D={range:F.Range.to(d.range),type:F.TokenType.to(d.type)};return!D.range.contains(k)||a!==n.version?v:D}createLanguageStatusItem(n,k,a){const m=this._handlePool++,d=this._proxy,v=this._ids,D=`${n.identifier.value}/${k}`;if(v.has(D))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);v.add(D);const I={selector:a,id:k,name:n.displayName??n.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let b,l=new _.DisposableStore;const o=()=>{b?.dispose(),b=(0,A.disposableTimeout)(()=>{l.clear(),this._proxy.$setLanguageStatus(m,{id:D,name:I.name??n.displayName??n.name,source:n.displayName??n.name,selector:F.DocumentSelector.from(I.selector,this._uriTransformer),label:I.text,detail:I.detail??"",severity:I.severity===C.LanguageStatusSeverity.Error?y.default.Error:I.severity===C.LanguageStatusSeverity.Warning?y.default.Warning:y.default.Info,command:I.command&&this._commands.toInternal(I.command,l),accessibilityInfo:I.accessibilityInformation})},0)},g={dispose(){l.dispose(),b?.dispose(),d.$removeLanguageStatus(m),v.delete(D)},get id(){return I.id},get name(){return I.name},set name(t){I.name=t,o()},get selector(){return I.selector},set selector(t){I.selector=t,o()},get text(){return I.text},set text(t){I.text=t,o()},get detail(){return I.detail},set detail(t){I.detail=t,o()},get severity(){return I.severity},set severity(t){I.severity=t,o()},get accessibilityInformation(){return I.accessibilityInformation},set accessibilityInformation(t){I.accessibilityInformation=t,o()},get command(){return I.command},set command(t){I.command=t,o()}};return o(),g}}e.ExtHostLanguages=S}),define(fe[245],me([0,1,5,13,35]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(_){return _&&_.title}let A=class{constructor(S,P){this._logService=P,this._proxy=S.getProxy(f.MainContext.MainThreadMessageService)}showMessage(S,P,n,k,a){const m={extension:S};let d;typeof k=="string"||y(k)?d=[k,...a]:(m.modal=k?.modal,m.useCustom=k?.useCustom,m.detail=k?.detail,d=a),m.useCustom&&(0,C.checkProposedApiEnabled)(S);const v=[];for(let D=0;D<d.length;D++){const I=d[D];if(typeof I=="string")v.push({title:I,handle:D,isCloseAffordance:!1});else if(typeof I=="object"){let{title:b,isCloseAffordance:l}=I;v.push({title:b,isCloseAffordance:!!l,handle:D})}else this._logService.warn("Invalid message item:",I)}return this._proxy.$showMessage(P,n,m,v).then(D=>{if(typeof D=="number")return d[D]})}};A=je([He(1,F.ILogService)],A),e.ExtHostMessageService=A}),define(fe[246],me([0,1,22,3,48,6,24,9,12,2,87,5,15,7,54,221,131]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class I{constructor(l,o,g,t,u){this._textDocumentsAndEditors=g,this._textDocuments=t,this._extensionStoragePaths=u,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new F.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new F.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new F.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new F.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new F.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new F.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new F.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(k.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(k.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(k.MainContext.MainThreadNotebookEditors),this._commandsConverter=o.converter,o.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,s=r.cell.handle,h=this._documents.get(i)?.getCell(s);if(h)return h.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const o=this._editors.get(l);if(!o)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return o}getIdByEditor(l){for(const[o,g]of this._editors)if(g.apiEditor===l)return o}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,o){const g=this._documents.get(l);if(!g&&!o)throw new Error(`NO notebook document for '${l}'`);return g}_getProviderData(l){const o=this._notebookContentProviders.get(l);if(!o)throw new Error(`NO provider for '${l}'`);return o}registerNotebookContentProvider(l,o,g,t,u){if((0,_.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(o))throw new Error(`Notebook provider for '${o}' already registered`);this._notebookContentProviders.set(o,{extension:l,provider:g});let r;return g.onDidChangeNotebookContentOptions&&(r=g.onDidChangeNotebookContentOptions(()=>{const i=a.NotebookDocumentContentOptions.from(g.options);this._notebookProxy.$updateNotebookProviderOptions(o,i)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},o,a.NotebookDocumentContentOptions.from(t),I._convertNotebookRegistrationData(l,u)),new m.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(o),this._notebookProxy.$unregisterNotebookProvider(o)})}static _convertNotebookRegistrationData(l,o){if(!o)return;const g=o.filenamePattern.map(t=>a.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(o.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:o.displayName,filenamePattern:g,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,o,g){const t=I._notebookStatusBarItemProviderHandlePool++,u=typeof g.onDidChangeCellStatusBarItems=="function"?I._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,u,o);let r;return u!==void 0&&(r=g.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(u))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,u),r&&r.dispose()})}async createNotebookDocument(l){const o=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&a.NotebookData.from(l.content)});return P.URI.revive(o)}async openNotebookDocument(l){const o=this._documents.get(l);if(o)return o.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(l),t=this._documents.get(P.URI.revive(g));return(0,S.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(l,o){P.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let g;typeof o=="object"?g={position:a.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(a.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:g={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,g),u=t&&this._editors.get(t)?.apiEditor;if(u)return u;throw t?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,o,g,t){const u=this._notebookStatusBarItemProviders.get(l),r=P.URI.revive(o),i=this._documents.get(r);if(!i||!u)return;const s=i.getCellFromIndex(g);if(!s)return;const c=await u.provideCellStatusBarItems(s.apiCell,t);if(!c)return;const h=new y.DisposableStore,w=this._statusBarCache.add([h]),p=(Array.isArray(c)?c:[c]).map(T=>a.NotebookStatusBarItem.from(T,this._commandsConverter,h));return{cacheId:w,items:p}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,o,g,t,u){if((0,_.isFalsyOrWhitespace)(o))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,g),this._notebookProxy.$registerNotebookSerializer(r,{id:l.identifier,location:l.extensionLocation},o,a.NotebookDocumentContentOptions.from(t),I._convertNotebookRegistrationData(l,u)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(l,o,g){const t=this._notebookSerializer.get(l);if(!t)throw new Error("NO serializer found");const u=await t.deserializeNotebook(o.buffer,g);return new d.SerializableObjectWithBuffers(a.NotebookData.from(u))}async $notebookToData(l,o,g){const t=this._notebookSerializer.get(l);if(!t)throw new Error("NO serializer found");const u=await t.serializeNotebook(a.NotebookData.to(o.value),g);return f.VSBuffer.wrap(u)}async $openNotebook(l,o,g,t,u){const{provider:r}=this._getProviderData(l),i=await r.openNotebook(P.URI.revive(o),{backupId:g,untitledDocumentData:t?.buffer},u);return new d.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(a.NotebookCellData.from)})}async $saveNotebook(l,o,g){const t=this.getNotebookDocument(P.URI.revive(o)),{provider:u}=this._getProviderData(l);return await u.saveNotebook(t.apiNotebook,g),!0}async $saveNotebookAs(l,o,g,t){const u=this.getNotebookDocument(P.URI.revive(o)),{provider:r}=this._getProviderData(l);return await r.saveNotebookAs(P.URI.revive(g),u.apiNotebook,t),!0}async $backupNotebook(l,o,g){const t=this.getNotebookDocument(P.URI.revive(o)),u=this._getProviderData(l),r=this._extensionStoragePaths.workspaceValue(u.extension)??this._extensionStoragePaths.globalValue(u.extension),i=String((0,C.hash)([t.uri.toString(),this._backupIdPool++])),s=P.URI.joinPath(r,i),c=await u.provider.backupNotebook(t.apiNotebook,{destination:s},g);return t.updateBackup(c),c.id}_createExtHostEditor(l,o,g){if(this._editors.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const t=new D.ExtHostNotebookEditor(o,this._notebookEditorsProxy,l,g.visibleRanges.map(a.NotebookRange.to),g.selections.map(a.NotebookRange.to),typeof g.viewColumn=="number"?a.ViewColumn.to(g.viewColumn):void 0);this._editors.set(o,t)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const g of l.value.removedDocuments){const t=P.URI.revive(g),u=this._documents.get(t);u&&(u.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:u.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(u.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===t.toString()&&this._editors.delete(r.id)}if(l.value.addedDocuments){const g=[];for(const t of l.value.addedDocuments){const u=P.URI.revive(t.uri);if(this._documents.has(u))throw new Error(`adding EXISTING notebook ${u} `);const r=this,i=new v.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(s){r._onDidChangeNotebookCells.fire(s)},emitCellOutputsChange(s){r._onDidChangeCellOutputs.fire(s)},emitCellMetadataChange(s){r._onDidChangeCellMetadata.fire(s)},emitCellExecutionStateChange(s){r._onDidChangeCellExecutionState.fire(s)}},u,t);g.push(...t.cells.map(s=>v.ExtHostCell.asModelAddData(i.apiNotebook,s))),this._documents.get(u)?.dispose(),this._documents.set(u,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(l.value.addedEditors)for(const g of l.value.addedEditors){if(this._editors.has(g.id))return;const t=P.URI.revive(g.documentUri),u=this._documents.get(t);u&&this._createExtHostEditor(u,g.id,g)}const o=[];if(l.value.removedEditors)for(const g of l.value.removedEditors){const t=this._editors.get(g);t&&(this._editors.delete(g),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),o.push(t))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const g=new Set;this._visibleNotebookEditors.forEach(t=>g.add(t.id));for(const t of this._editors.values()){const u=g.has(t.id);t._acceptVisibility(u)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=I,I._notebookStatusBarItemProviderHandlePool=0}),define(fe[247],me([0,1,3,76,13,5,14,15]),function(Y,e,f,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(k,a){const m=S._Keys.nextId();k.$registerNotebookEditorDecorationType(m,_.NotebookDecorationRenderOptions.from(a)),this.value={key:m,dispose(){k.$removeNotebookEditorDecorationType(m)}}}}S._Keys=new F.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(k,a,m){this._logService=k,this._extHostRpc=a,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new f.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new f.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(k){return new S(this._extHostRpc.getProxy(y.MainContext.MainThreadNotebookEditors),k).value}$acceptEditorPropertiesChanged(k,a){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,a);const m=this._notebooksAndEditors.getEditorById(k);a.visibleRanges&&m._acceptVisibleRanges(a.visibleRanges.ranges.map(_.NotebookRange.to)),a.selections&&m._acceptSelections(a.selections.selections.map(_.NotebookRange.to)),a.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),a.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const a in k)this._notebooksAndEditors.getEditorById(a)._acceptViewColumn(_.ViewColumn.to(k[a]))}};P=je([He(0,C.ILogService),He(1,A.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(fe[248],me([0,1,16,17,21,3,6,24,2,26,13,5,40,15,7,88,214,35,54]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let l=class{constructor(r,i,s,c,h){this._initData=i,this._extHostNotebook=s,this._commands=c,this._logService=h,this._activeExecutions=new _.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(k.MainContext.MainThreadNotebookKernels);const w=new a.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.ApiCommandArgument("options","Select kernel options",E=>!0,E=>{if(E&&"notebookEditor"in E&&"id"in E){const p=this._extHostNotebook.getIdByEditor(E.notebookEditor);return{id:E.id,extension:E.extension,notebookEditorId:p}}else if(E&&"notebookEditor"in E){const p=this._extHostNotebook.getIdByEditor(E.notebookEditor);if(p===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${E.notebookEditor.document.uri.toString()}`);return{notebookEditorId:p}}return E})],a.ApiCommandResult.Void);this._commands.registerApiCommand(w)}createNotebookController(r,i,s,c,h,w){for(let H of this._kernelData.values())if(H.controller.id===i&&P.ExtensionIdentifier.equals(r.identifier,H.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const E=this._handlePool++,p=this;this._logService.trace(`NotebookController[${E}], CREATED by ${r.identifier.value}, ${i}`);const T=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${r.identifier}'`);let L=!1;const M=new A.DisposableStore,R=new y.Emitter,$=new y.Emitter,z={id:`${r.identifier.value}/${i}`,notebookType:s,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:c||r.identifier.value,preloads:w?w.map(m.NotebookRendererScript.from):[]};let O=h??T,V;this._proxy.$addKernel(E,z).catch(H=>{console.log(H),L=!0});let N=0;const U=()=>{if(L)return;const H=++N;Promise.resolve().then(()=>{H===N&&this._proxy.$updateKernel(E,z)})},x=new _.ResourceMap,B={get id(){return i},get notebookType(){return z.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return z.label},set label(H){z.label=H??r.displayName??r.name,U()},get detail(){return z.detail??""},set detail(H){z.detail=H,U()},get description(){return z.description??""},set description(H){z.description=H,U()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(H){z.supportedLanguages=H,U()},get supportsExecutionOrder(){return z.supportsExecutionOrder??!1},set supportsExecutionOrder(H){z.supportsExecutionOrder=H,U()},get rendererScripts(){return z.preloads?z.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return O},set executeHandler(H){O=H??T},get interruptHandler(){return V},set interruptHandler(H){V=H,z.supportsInterrupt=Boolean(H),U()},createNotebookCellExecution(H){if(L)throw new Error("notebook controller is DISPOSED");if(!x.has(H.notebook.uri))throw p._logService.trace(`NotebookController[${E}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(G=>G.toString())),new Error(`notebook controller is NOT associated to notebook: ${H.notebook.uri.toString()}`);return p._createNotebookCellExecution(H)},dispose:()=>{L||(this._logService.trace(`NotebookController[${E}], DISPOSED`),L=!0,this._kernelData.delete(E),M.dispose(),R.dispose(),$.dispose(),this._proxy.$removeKernel(E))},updateNotebookAffinity(H,G){p._proxy.$updateNotebookPriority(E,H.uri,G)},onDidReceiveMessage:$.event,postMessage(H,G){return(0,I.checkProposedApiEnabled)(r),p._proxy.$postMessage(E,G&&p._extHostNotebook.getIdByEditor(G),H)},asWebviewUri(H){return(0,I.checkProposedApiEnabled)(r),(0,v.asWebviewUri)(H,p._initData.remote)}};return this._kernelData.set(E,{extensionId:r.identifier,controller:B,onDidReceiveMessage:$,onDidChangeSelection:R,associatedNotebooks:x}),B}$acceptNotebookAssociation(r,i,s){const c=this._kernelData.get(r);if(c){const h=this._extHostNotebook.getNotebookDocument(S.URI.revive(i));s?c.associatedNotebooks.set(h.uri,!0):c.associatedNotebooks.delete(h.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,h.uri.toString(),s),c.onDidChangeSelection.fire({selected:s,notebook:h.apiNotebook})}}async $executeCells(r,i,s){const c=this._kernelData.get(r);if(!c)return;const h=this._extHostNotebook.getNotebookDocument(S.URI.revive(i)),w=[];for(let E of s){const p=h.getCell(E);p&&w.push(p.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,h.uri.toString(),w.length),await c.controller.executeHandler.call(c.controller,w,h.apiNotebook,c.controller)}catch(E){this._logService.error(`NotebookController[${r}] execute cells FAILED`,E),console.error(E)}}async $cancelCells(r,i,s){const c=this._kernelData.get(r);if(!c)return;const h=this._extHostNotebook.getNotebookDocument(S.URI.revive(i));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,h.apiNotebook);else for(let w of s){const E=h.getCell(w);E&&this._activeExecutions.get(E.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,i,s){const c=this._kernelData.get(r);if(!c)return;const h=this._extHostNotebook.getEditorById(i);c.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:s}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const c=new g(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,c);const h=c.onDidChangeState(()=>{c.state===o.Resolved&&(c.dispose(),h.dispose(),this._activeExecutions.delete(s.uri))});return c.asApiObject()}};l=je([He(4,n.ILogService)],l),e.ExtHostNotebookKernels=l;var o;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(o||(o={}));class g extends A.Disposable{constructor(r,i,s){super();this._document=r,this._cell=i,this._proxy=s,this._handle=g.HANDLE++,this._onDidChangeState=new y.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new C.CancellationTokenSource),this._collector=new t(10,c=>this.update(c)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const i=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new b.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let i=this._cell;if(r&&(i=this._document.getCellFromApiCell(r)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(r){return r.map(i=>{const s=d.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return s===i.items?m.NotebookCellOutput.from(i):m.NotebookCellOutput.from({items:s,id:i.id,metadata:i.metadata})})}async updateOutputs(r,i,s){const c=this.cellIndexToHandle(i),h=this.validateAndConvertOutputs((0,f.asArray)(r));return this.updateSoon({editType:D.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:c,append:s,outputs:h})}async updateOutputItems(r,i,s){return r=d.NotebookCellOutput.ensureUniqueMimeTypes((0,f.asArray)(r),!0),this.updateSoon({editType:D.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(m.NotebookCellOutputItem.from),outputId:i.id,append:s})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(s){r._executionOrder=s,r.update([{editType:D.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(s){if(r._state===o.Resolved||r._state===o.Started)throw new Error("Cannot call start again");r._state=o.Started,r._onDidChangeState.fire(),r.update({editType:D.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:s})},end(s,c){if(r._state===o.Resolved)throw new Error("Cannot call resolve twice");r._state=o.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:D.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:c,lastRunSuccess:s}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(s){return r.verifyStateForOutput(),r.updateOutputs([],s,!1)},appendOutput(s,c){return r.verifyStateForOutput(),r.updateOutputs(s,c,!0)},replaceOutput(s,c){return r.verifyStateForOutput(),r.updateOutputs(s,c,!1)},appendOutputItems(s,c){return r.verifyStateForOutput(),r.updateOutputItems(s,c,!0)},replaceOutputItems(s,c){return r.verifyStateForOutput(),r.updateOutputItems(s,c,!1)}})}}g.HANDLE=0;class t{constructor(r,i){this.delay=r,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new F.DeferredPromise,this.startedTimer=Date.now(),(0,F.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>r.complete())}}}),define(fe[249],me([0,1,3,5,131]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(_,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=_.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(_,S,P){const n=this._extHostNotebook.getEditorById(_);this._rendererMessageEmitters.get(S)?.fire({editor:n.apiEditor,message:P})}createRendererMessaging(_,S){if(!_.contributes?.notebookRenderer?.some(a=>a.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);const P=!!_.enableProposedApi,n=new WeakMap;return{onDidReceiveMessage:(a,m,d)=>{const v=P?a:D=>{const I={};n.set(I,D.editor),a({editor:I,message:D.message})};return this.getOrCreateEmitterFor(S).event(v,m,d)},postMessage:(a,m)=>{C.ExtHostNotebookEditor.apiEditorsToExtHost.has(a)&&([a,m]=[m,a]);const d=P?m:n.get(m),v=d&&C.ExtHostNotebookEditor.apiEditorsToExtHost.get(d);return this.proxy.$postMessage(v?.id,S,a)}}}getOrCreateEmitterFor(_){let S=this._rendererMessageEmitters.get(_);return S||(S=new f.Emitter({onLastListenerRemove:()=>{S?.dispose(),this._rendererMessageEmitters.delete(_)}}),this._rendererMessageEmitters.set(_,S),S)}}e.ExtHostNotebookRenderers=y}),define(fe[68],me([0,1,5,3,6,22,4,14]),function(Y,e,f,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends C.Disposable{constructor(d,v,D,I,b){super();this._onDidAppend=this._register(new F.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=d,this._proxy=b,this._id=b.$register(this.name,v,D,I),this._disposed=!1,this._offset=0}get name(){return this._name}append(d){this.validate(),this._offset+=d?y.VSBuffer.fromString(d).byteLength:0}update(){this._id.then(d=>this._proxy.$update(d))}appendLine(d){this.validate(),this.append(d+`
`)}clear(){this.validate();const d=this._offset;this._id.then(v=>this._proxy.$clear(v,d))}show(d,v){this.validate(),this._id.then(D=>this._proxy.$reveal(D,!!(typeof d=="boolean"?d:v)))}hide(){this.validate(),this._id.then(d=>this._proxy.$close(d))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(d=>this._proxy.$dispose(d)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class P extends S{constructor(d,v,D){super(d,!1,void 0,v,D)}append(d){super.append(d),this._id.then(v=>this._proxy.$append(v,d)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class n extends S{constructor(d,v,D){super(d,!0,v,void 0,D)}append(d){throw new Error("Not supported")}}class k{constructor(d,v){this.name=d,this._channel=v}append(d){this._channel.then(v=>v.append(d))}appendLine(d){this._channel.then(v=>v.appendLine(d))}clear(){this._channel.then(d=>d.clear())}show(d,v){this._channel.then(D=>D.show(d,v))}hide(){this._channel.then(d=>d.hide())}dispose(){this._channel.then(d=>d.dispose())}}e.LazyOutputChannel=k;let a=class{constructor(d){this._proxy=d.getProxy(f.MainContext.MainThreadOutputService)}$setVisibleChannel(d){}createOutputChannel(d,v){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");return new P(d,v.identifier.value,this._proxy)}createOutputChannelFromLogFile(d,v){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");if(!v)throw new Error("illegal argument `file`. must not be falsy");return new n(d,v,this._proxy)}};a=je([He(0,_.IExtHostRpcService)],a),e.ExtHostOutputService=a,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(fe[250],me([0,1,17,21,3,6,5,2,7,18,16,49,64]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(d,v,D){const I=d.getProxy(A.MainContext.MainThreadQuickOpen);class b{constructor(c,h){this._sessions=new Map,this._instances=0,this._workspace=c,this._commands=h}showQuickPick(c,h,w,E=F.CancellationToken.None){this._onDidSelectItem=void 0;const p=Promise.resolve(c),T=++this._instances,L=I.$show(T,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},E),M={},R=L.then(()=>M);return Promise.race([R,p]).then($=>{if($!==M)return p.then(z=>{const O=[];for(let V=0;V<z.length;V++){const N=z[V];let U,x,B,H,G;typeof N=="string"?U=N:(U=N.label,x=N.description,B=N.detail,H=N.picked,G=N.alwaysShow),O.push({label:U,description:x,handle:V,detail:B,picked:H,alwaysShow:G})}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=V=>{w.onDidSelectItem(z[V])}),I.$setItems(T,O),L.then(V=>{if(typeof V=="number")return z[V];if(Array.isArray(V))return V.map(N=>z[N])})})}).then(void 0,$=>{if(!(0,P.isPromiseCanceledError)($))return I.$setError(T,$),Promise.reject($)})}$onItemSelected(c){this._onDidSelectItem&&this._onDidSelectItem(c)}showInput(c,h=F.CancellationToken.None){return this._validateInput=c?c.validateInput:void 0,I.$input(c,typeof this._validateInput=="function",h).then(void 0,w=>{if(!(0,P.isPromiseCanceledError)(w))return Promise.reject(w)})}$validateInput(c){return this._validateInput?(0,f.asPromise)(()=>this._validateInput(c)):Promise.resolve(void 0)}async showWorkspaceFolderPick(c,h=F.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!w)return;const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(p=>p.uri.toString()===w.uri.toString())}createQuickPick(c,h){const w=new r(c,h,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(c){const h=new i(c,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}$onDidChangeValue(c,h){const w=this._sessions.get(c);w&&w._fireDidChangeValue(h)}$onDidAccept(c){const h=this._sessions.get(c);h&&h._fireDidAccept()}$onDidChangeActive(c,h){const w=this._sessions.get(c);w instanceof r&&w._fireDidChangeActive(h)}$onDidChangeSelection(c,h){const w=this._sessions.get(c);w instanceof r&&w._fireDidChangeSelection(h)}$onDidTriggerButton(c,h){const w=this._sessions.get(c);w&&w._fireDidTriggerButton(h)}$onDidTriggerItemButton(c,h,w){const E=this._sessions.get(c);E instanceof r&&E._fireDidTriggerItemButton(h,w)}$onDidHide(c){const h=this._sessions.get(c);h&&h._fireDidHide()}}class l{constructor(c,h){this._extensionId=c,this._onDidDispose=h,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(c){this._title=c,this.update({title:c})}get step(){return this._steps}set step(c){this._steps=c,this.update({step:c})}get totalSteps(){return this._totalSteps}set totalSteps(c){this._totalSteps=c,this.update({totalSteps:c})}get enabled(){return this._enabled}set enabled(c){this._enabled=c,this.update({enabled:c})}get busy(){return this._busy}set busy(c){this._busy=c,this.update({busy:c})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(c){this._ignoreFocusOut=c,this.update({ignoreFocusOut:c})}get value(){return this._value}set value(c){this._value=c,this.update({value:c})}get placeholder(){return this._placeholder}set placeholder(c){this._placeholder=c,this.update({placeholder:c})}get buttons(){return this._buttons}set buttons(c){this._buttons=c.slice(),this._handlesToButtons.clear(),c.forEach((h,w)=>{const E=h===S.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(E,h)}),this.update({buttons:c.map((h,w)=>({...u(h),tooltip:h.tooltip,handle:h===S.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(c){this._value=c,this._onDidChangeValueEmitter.fire(c)}_fireDidTriggerButton(c){const h=this._handlesToButtons.get(c);h&&this._onDidTriggerButtonEmitter.fire(h)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,y.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),I.$dispose(this._id))}update(c){if(!this._disposed){for(const h of Object.keys(c)){const w=c[h];this._pendingUpdate[h]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){I.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}l._nextId=1;function o(s){if(s instanceof S.ThemeIcon)return{id:s.id};const c=t(s),h=g(s);return{dark:typeof c=="string"?_.URI.file(c):c,light:typeof h=="string"?_.URI.file(h):h}}function g(s){return typeof s=="object"&&"light"in s?s.light:s}function t(s){return typeof s=="object"&&"dark"in s?s.dark:s}function u(s){const c=o(s.iconPath);let h,w;return"id"in c?w=a.ThemeIcon.asClassName(c):h=c,{iconPath:h,iconClass:w}}class r extends l{constructor(c,h,w){super(c,w);this.enableProposedApi=h,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this._onDidTriggerItemButtonEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(c){this._items=c.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),c.forEach((h,w)=>{this._handlesToItems.set(w,h),this._itemsToHandles.set(h,w)}),this.update({items:c.map((h,w)=>({label:h.label,description:h.description,handle:w,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons&&this.enableProposedApi?h.buttons.map((E,p)=>({...u(E),tooltip:E.tooltip,handle:p})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(c){this._canSelectMany=c,this.update({canSelectMany:c})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(c){this._matchOnDescription=c,this.update({matchOnDescription:c})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(c){this._matchOnDetail=c,this.update({matchOnDetail:c})}get sortByLabel(){return this._sortByLabel}set sortByLabel(c){this._sortByLabel=c,this.update({sortByLabel:c})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(c){this._keepScrollPosition=c,this.update({keepScrollPosition:c})}get activeItems(){return this._activeItems}set activeItems(c){this._activeItems=c.filter(h=>this._itemsToHandles.has(h)),this.update({activeItems:this._activeItems.map(h=>this._itemsToHandles.get(h))})}get selectedItems(){return this._selectedItems}set selectedItems(c){this._selectedItems=c.filter(h=>this._itemsToHandles.has(h)),this.update({selectedItems:this._selectedItems.map(h=>this._itemsToHandles.get(h))})}_fireDidChangeActive(c){const h=(0,n.coalesce)(c.map(w=>this._handlesToItems.get(w)));this._activeItems=h,this._onDidChangeActiveEmitter.fire(h)}_fireDidChangeSelection(c){const h=(0,n.coalesce)(c.map(w=>this._handlesToItems.get(w)));this._selectedItems=h,this._onDidChangeSelectionEmitter.fire(h)}_fireDidTriggerItemButton(c,h){const w=this._handlesToItems.get(c);if(!w||!w.buttons||!w.buttons.length)return;const E=w.buttons[h];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:w})}}class i extends l{constructor(c,h){super(c,h);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(c){this._password=c,this.update({password:c})}get prompt(){return this._prompt}set prompt(c){this._prompt=c,this.update({prompt:c})}get validationMessage(){return this._validationMessage}set validationMessage(c){this._validationMessage=c,this.update({validationMessage:c,severity:c?k.default.Error:k.default.Ignore})}}return new b(v,D)}e.createExtHostQuickOpen=m}),define(fe[251],me([0,1,2,3,59,6,17,5,16,101,13,26,35,64,15]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function v(c){if(c)return typeof c.iconPath=="string"?f.URI.file(c.iconPath):f.URI.isUri(c.iconPath)||m.ThemeIcon.isThemeIcon(c.iconPath)?c.iconPath:void 0}function D(c,h){if(!c.iconPath&&!h.iconPath)return 0;if(c.iconPath){if(!h.iconPath)return 1}else return-1;const w=typeof c.iconPath=="string"?c.iconPath:f.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id,E=typeof h.iconPath=="string"?h.iconPath:f.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,P.comparePaths)(w,E)}function I(c,h){let w=0;if(c.strikeThrough!==h.strikeThrough)return c.strikeThrough?1:-1;if(c.faded!==h.faded)return c.faded?1:-1;if(c.tooltip!==h.tooltip)return(c.tooltip||"").localeCompare(h.tooltip||"");if(w=D(c,h),w!==0)return w;if(c.light&&h.light)w=D(c.light,h.light);else{if(c.light)return 1;if(h.light)return-1}if(w!==0)return w;if(c.dark&&h.dark)w=D(c.dark,h.dark);else{if(c.dark)return 1;if(h.dark)return-1}return w}function b(c,h){if(c.command!==h.command)return c.command<h.command?-1:1;if(c.title!==h.title)return c.title<h.title?-1:1;if(c.tooltip!==h.tooltip){if(c.tooltip!==void 0&&h.tooltip!==void 0)return c.tooltip<h.tooltip?-1:1;if(c.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(c.arguments===h.arguments)return 0;if(c.arguments)if(h.arguments){if(c.arguments.length!==h.arguments.length)return c.arguments.length-h.arguments.length}else return 1;else return-1;for(let w=0;w<c.arguments.length;w++){const E=c.arguments[w],p=h.arguments[w];if(E!==p)return E<p?-1:1}return 0}function l(c,h){let w=(0,P.comparePaths)(c.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(w!==0)return w;if(c.command&&h.command)w=b(c.command,h.command);else{if(c.command)return 1;if(h.command)return-1}if(w!==0)return w;if(c.decorations&&h.decorations)w=I(c.decorations,h.decorations);else{if(c.decorations)return 1;if(h.decorations)return-1}return w}function o(c,h){for(let w=0;w<c.length;w++)if(c[w]!==h[w])return!1;return!0}function g(c,h){return c.command===h.command&&c.title===h.title&&c.tooltip===h.tooltip&&(c.arguments&&h.arguments?o(c.arguments,h.arguments):c.arguments===h.arguments)}function t(c,h){return(0,S.equals)(c,h,g)}class u{constructor(h,w,E){this._extension=h,this._proxy=w,this._sourceControlHandle=E,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(h){this._proxy.$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,a.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(h){if((0,a.checkProposedApiEnabled)(this._extension),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,h))}focus(){(0,a.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(h,w){(0,a.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,h,w)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=u;class r{constructor(h,w,E,p,T){this._proxy=h,this._commands=w,this._sourceControlHandle=E,this._id=p,this._label=T,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,w){const E=this._resourceStatesCommandsMap.get(h);return E?(0,A.asPromise)(()=>this._commands.executeCommand(E.command,...E.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(l),E=(0,S.sortedDiff)(this._resourceSnapshot,h,l).map(L=>{const M=L.toInsert.map(R=>{const $=this._resourceHandlePool++;this._resourceStatesMap.set($,R);const z=R.resourceUri;let O;if(R.command)if(R.command.command==="vscode.open"||R.command.command==="vscode.diff"){const de=new y.DisposableStore;O=this._commands.converter.toInternal(R.command,de),this._resourceStatesDisposablesMap.set($,de)}else this._resourceStatesCommandsMap.set($,R.command);const V=v(R.decorations),N=R.decorations&&v(R.decorations.light)||V,U=R.decorations&&v(R.decorations.dark)||V,x=[N,U],B=R.decorations&&R.decorations.tooltip||"",H=R.decorations&&!!R.decorations.strikeThrough,G=R.decorations&&!!R.decorations.faded,K=R.contextValue||"";return{rawResource:[$,z,x,B,H,G,K,O],handle:$}});return{start:L.start,deleteCount:L.deleteCount,toInsert:M}}),p=E.map(({start:L,deleteCount:M,toInsert:R})=>[L,M,R.map($=>$.rawResource)]),T=E.reverse();for(const{start:L,deleteCount:M,toInsert:R}of T){const $=R.map(O=>O.handle),z=this._handlesSnapshot.splice(L,M,...$);for(const O of z)this._resourceStatesMap.delete(O),this._resourceStatesCommandsMap.delete(O),this._resourceStatesDisposablesMap.get(O)?.dispose(),this._resourceStatesDisposablesMap.delete(O)}return this._resourceSnapshot=h,p}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class i{constructor(h,w,E,p,T,L){this._extension=h,this._proxy=w,this._commands=E,this._id=p,this._label=T,this._rootUri=L,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new y.MutableDisposable,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new u(h,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,p,T,L)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,this._proxy.$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,this._proxy.$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=h;const w=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:w})}get actionButton(){return(0,a.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(h){(0,a.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new y.DisposableStore,this._actionButton=h;const w=h!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:w??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&t(this._statusBarCommands,h))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=h;const w=(h||[]).map(E=>this._commands.converter.toInternal(E,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(h,w){const E=new r(this._proxy,this._commands,this.handle,h,w),p=F.Event.once(E.onDidDispose)(()=>this.createdResourceGroups.delete(E));return this.createdResourceGroups.set(E,p),this.eventuallyAddResourceGroups(),E}eventuallyAddResourceGroups(){const h=[],w=[];for(const[E,p]of this.createdResourceGroups){p.dispose();const T=E.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(E),this.eventuallyUpdateResourceStates()});F.Event.once(E.onDidDispose)(()=>{this.updatedResourceGroups.delete(E),T.dispose(),this._groups.delete(E.handle),this._proxy.$unregisterGroup(this.handle,E.handle)}),h.push([E.handle,E.id,E.label,E.features]);const L=E._takeResourceStateSnapshot();L.length>0&&w.push([E.handle,L]),this._groups.set(E.handle,E)}this._proxy.$registerGroups(this.handle,h,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(w=>{const E=w._takeResourceStateSnapshot();E.length!==0&&h.push([w.handle,E])}),h.length>0&&this._proxy.$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,je([(0,C.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),je([(0,C.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let s=class xn{constructor(h,w,E){this._commands=w,this.logService=E,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=h.getProxy(_.MainContext.MainThreadSCM),this._telemetry=h.getProxy(_.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:p=>{if(p&&p.$mid===3){const T=this._sourceControls.get(p.sourceControlHandle);if(!T)return p;const L=T.getResourceGroup(p.groupHandle);return L?L.getResourceState(p.handle):p}else if(p&&p.$mid===4){const T=this._sourceControls.get(p.sourceControlHandle);return T?T.getResourceGroup(p.groupHandle):p}else if(p&&p.$mid===5){const T=this._sourceControls.get(p.handle);return T||p}return p}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(h,w,E,p){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,w,E,p),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const T=xn._handlePool++,L=new i(h,this._proxy,this._commands,w,E,p);this._sourceControls.set(T,L);const M=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(h.identifier))||[];return M.push(L),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(h.identifier),M),L}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const w=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(h.identifier)),E=w&&w[w.length-1];return E&&E.inputBox}$provideOriginalResource(h,w,E){const p=f.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,p.toString());const T=this._sourceControls.get(h);return!T||!T.quickDiffProvider||!T.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>T.quickDiffProvider.provideOriginalResource(p,E)).then(L=>L||null)}$onInputBoxValueChange(h,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const E=this._sourceControls.get(h);return E&&E.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(h,w,E,p){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,w,E);const T=this._sourceControls.get(h);if(!T)return Promise.resolve(void 0);const L=T.getResourceGroup(w);return L?L.$executeResourceCommand(E,p):Promise.resolve(void 0)}$validateInput(h,w,E){this.logService.trace("ExtHostSCM#$validateInput",h);const p=this._sourceControls.get(h);return!p||!p.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>p.inputBox.validateInput(w,E)).then(T=>{if(!T)return Promise.resolve(void 0);const L=d.MarkdownString.fromStrict(T.message);return L?Promise.resolve([L,T.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};s._handlePool=0,s=je([He(2,n.ILogService)],s),e.ExtHostSCM=s});var st=this&&this.__classPrivateFieldSet||function(Y,e,f,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,f):C?C.value=f:e.set(Y,f),f},Ne=this&&this.__classPrivateFieldGet||function(Y,e,f,F){if(f==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?F:f==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[252],me([0,1,7,5,168,6,15,12]),function(Y,e,f,F,C,y,A,_){"use strict";var S,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class n{constructor(d,v,D,I,b=f.StatusBarAlignment.Left,l){S.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,st(this,S,d,"f"),st(this,P,v,"f"),this._entryId=n.ID_GEN++,this._extension=D,this._id=I,this._alignment=b,this._priority=this.validatePriority(l)}validatePriority(d){if(!!(0,_.isNumber)(d))return d===Number.POSITIVE_INFINITY?Number.MAX_VALUE:d===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:d}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set name(d){this._name=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!n.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){this._command?.fromApi!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Ne(this,P,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Ne(this,P,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ne(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let d;this._extension?this._id?d=`${this._extension.identifier.value}.${this._id}`:d=this._extension.identifier.value:d=this._id;let v;this._name?v=this._name:v=(0,C.localize)(0,null,this._extension.displayName||this._extension.name);let D=this._color;this._backgroundColor&&(D=n.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const I=this._tooltip?A.MarkdownString.fromStrict(this._tooltip):void 0;Ne(this,S,"f").$setEntry(this._entryId,d,v,this._text,I,this._command?.internal,D,this._backgroundColor,this._alignment===f.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=n,S=new WeakMap,P=new WeakMap,n.ID_GEN=0,n.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new f.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new f.ThemeColor("statusBarItem.warningForeground")]]);class k{constructor(d){this._messages=[],this._item=d.createStatusBarEntry(void 0,"status.extensionMessage",f.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,C.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const v={message:d};return this._messages.unshift(v),this._update(),new f.Disposable(()=>{const D=this._messages.indexOf(v);D>=0&&(this._messages.splice(D,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class a{constructor(d,v){this._proxy=d.getProxy(F.MainContext.MainThreadStatusBar),this._commands=v,this._statusMessage=new k(this)}createStatusBarEntry(d,v,D,I){return new n(this._proxy,this._commands,d,v,D,I)}setStatusBarMessage(d,v){const D=this._statusMessage.setMessage(d);let I;return typeof v=="number"?I=setTimeout(()=>D.dispose(),v):typeof v!="undefined"&&v.then(()=>D.dispose(),()=>D.dispose()),new f.Disposable(()=>{D.dispose(),clearTimeout(I)})}}e.ExtHostStatusBar=a}),define(fe[92],me([0,1,5,3,4]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(_){this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=_.getProxy(f.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(_,S){this._proxy.$registerExtensionStorageKeysToSync(_,S)}getValue(_,S,P){return this._proxy.$getValue(_,S).then(n=>n||P)}setValue(_,S,P){return this._proxy.$setValue(_,S,P)}$acceptValue(_,S,P){this._onDidChangeStorage.fire({shared:_,key:S,value:P})}}e.ExtHostStorage=y,e.IExtHostStorage=(0,C.createDecorator)("IExtHostStorage")}),define(fe[69],me([0,1,4,27,13,91,2]),function(Y,e,f,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,f.createDecorator)("IExtensionStoragePaths");let _=class{constructor(P,n,k){this._logService=n,this._extHostFileSystem=k,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(a=>this._value=a)}async _getWorkspaceStorageURI(P){return A.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,n=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(P){if(this._value)return A.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return A.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};_=je([He(0,F.IExtHostInitDataService),He(1,C.ILogService),He(2,y.IExtHostConsumerFileSystem)],_),e.ExtensionStoragePaths=_}),define(fe[33],me([0,1,3,5,4,2,14,6,7,169,18,216,21,32,197,64,12]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,C.createDecorator)("IExtHostTerminalService");class I{constructor(s,c,h,w){this._proxy=s,this._id=c,this._creationOptions=h,this._name=w,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(p=>this._pidPromiseComplete=p);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(p,T=!0){E._checkDisposed(),E._proxy.$sendText(E._id,p,T)},show(p){E._checkDisposed(),E._proxy.$show(E._id,p)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(s,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:s.name,shellPath:(0,D.withNullAsUndefined)(s.shellPath),shellArgs:(0,D.withNullAsUndefined)(s.shellArgs),cwd:(0,D.withNullAsUndefined)(s.cwd),env:(0,D.withNullAsUndefined)(s.env),icon:(0,D.withNullAsUndefined)(u(s.iconPath)),color:v.ThemeColor.isThemeColor(s.color)?s.color.id:void 0,initialText:(0,D.withNullAsUndefined)(s.message),strictEnv:(0,D.withNullAsUndefined)(s.strictEnv),hideFromUser:(0,D.withNullAsUndefined)(s.hideFromUser),isFeatureTerminal:(0,D.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,D.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(s.location,c?.resolvedExtHostIdentifier)})}async createExtensionTerminal(s,c,h,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:v.ThemeColor.isThemeColor(w)?w.id:void 0,location:this._serializeParentTerminal(s,c)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(s,c){return typeof s=="object"?"parentTerminal"in s&&s.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in s?{viewColumn:s.viewColumn,preserveFocus:s.preserveFocus}:void 0:s}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(s){this._name=s}setExitCode(s){this._exitStatus=Object.freeze({code:s})}setDimensions(s,c){return s===this._cols&&c===this._rows||s===0||c===0?!1:(this._cols=s,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(s){this._pidPromiseComplete?(this._pidPromiseComplete(s),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==s&&(this._pidPromise=Promise.resolve(s))})}}e.ExtHostTerminal=I;class b{constructor(s){this._pty=s,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new f.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new f.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new f.Emitter,this._onProcessTitleChanged=new f.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new f.Emitter,this._onProcessShellTypeChanged=new f.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new f.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(s){return Promise.resolve("")}async updateProperty(s,c){Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(s){this._pty.handleInput&&this._pty.handleInput(s)}resize(s,c){this._pty.setDimensions&&this._pty.setDimensions({columns:s,rows:c})}async processBinary(s){}acknowledgeDataEvent(s){}async setUnicodeVersion(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose&&this._pty.onDidClose((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(c=>this._onProcessOverrideDimensions.fire(c&&{cols:c.columns,rows:c.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(c=>this._onProcessTitleChanged.fire(c)),this._pty.open(s||void 0),this._pty.setDimensions&&s&&this._pty.setDimensions(s),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=b;let l=1,o=class extends _.Disposable{constructor(s,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new f.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new f.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new f.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new f.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new f.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new d.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new f.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(s),this._register({dispose:()=>{for(const[h,w]of this._terminalProcesses)w.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(s=>s.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(s){return(s?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(s){return(s?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(s,c){const h=new I(this._proxy,(0,m.generateUuid)(),s,s.name),w=new b(s.pty);return h.createExtensionTerminal(s.location,this._serializeParentTerminal(s,c).resolvedExtHostIdentifier,u(s.iconPath),r(s.color)).then(E=>{const p=this._setupExtHostProcessListeners(E,w);this._terminalProcessDisposables[E]=p}),this._terminals.push(h),h.value}_serializeParentTerminal(s,c){if(c=c||{},s.location&&typeof s.location=="object"&&"parentTerminal"in s.location){const h=s.location.parentTerminal;if(h){const w=this._terminals.find(E=>E.value===h);w&&(c.resolvedExtHostIdentifier=w._id)}}else s.location&&typeof s.location!="object"?c.location=s.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(s,c){if(!this._getTerminalById(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const w=new b(c),E=this._setupExtHostProcessListeners(s,w);this._terminalProcessDisposables[s]=E}async $acceptActiveTerminalChanged(s){const c=this._activeTerminal;if(s===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(s);h&&(this._activeTerminal=h,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(s,c){const h=this._getTerminalById(s);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:c})}async $acceptTerminalDimensions(s,c,h){const w=this._getTerminalById(s);w&&w.setDimensions(c,h)&&this._onDidChangeTerminalDimensions.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(s,c,h){this._terminalProcesses.get(s)?.resize(c,h)}async $acceptTerminalTitleChange(s,c){const h=this._getTerminalById(s);h&&(h.name=c)}async $acceptTerminalClosed(s,c){const h=this._getTerminalObjectIndexById(this._terminals,s);if(h!==null){const w=this._terminals.splice(h,1)[0];w.setExitCode(c),this._onDidCloseTerminal.fire(w.value)}}$acceptTerminalOpened(s,c,h,w){if(c){const T=this._getTerminalObjectIndexById(this._terminals,c);if(T!==null){this._terminals[T]._id=s,this._onDidOpenTerminal.fire(this.terminals[T]),this._terminals[T].isOpen=!0;return}}const E={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:y.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},p=new I(this._proxy,s,E,h);this._terminals.push(p),this._onDidOpenTerminal.fire(p.value),p.isOpen=!0}async $acceptTerminalProcessId(s,c){const h=this._getTerminalById(s);h&&h._setProcessId(c)}async $startExtensionTerminal(s,c){const h=this._getTerminalById(s);if(!h)return{message:(0,P.localize)(0,null,s)};h.isOpen||await new Promise(E=>{const p=this.onDidOpenTerminal(async T=>{T===h.value&&(p.dispose(),E())})});const w=this._terminalProcesses.get(s);w?w.startSendingEvents(c):this._extensionTerminalAwaitingStart[s]={initialDimensions:c}}_setupExtHostProcessListeners(s,c){const h=new _.DisposableStore;h.add(c.onProcessReady(E=>this._proxy.$sendProcessReady(s,E.pid,E.cwd))),h.add(c.onProcessTitleChanged(E=>this._proxy.$sendProcessTitle(s,E))),this._bufferer.startBuffering(s,c.onProcessData),h.add(c.onProcessExit(E=>this._onProcessExit(s,E))),c.onProcessOverrideDimensions&&h.add(c.onProcessOverrideDimensions(E=>this._proxy.$sendOverrideDimensions(s,E))),this._terminalProcesses.set(s,c);const w=this._extensionTerminalAwaitingStart[s];return w&&c instanceof b&&(c.startSendingEvents(w.initialDimensions),delete this._extensionTerminalAwaitingStart[s]),h}$acceptProcessAckDataEvent(s,c){this._terminalProcesses.get(s)?.acknowledgeDataEvent(c)}$acceptProcessInput(s,c){this._terminalProcesses.get(s)?.input(c)}$acceptTerminalInteraction(s){const c=this._getTerminalById(s);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(s,c,h){try{this._terminalProcesses.get(s)?.resize(c,h)}catch(w){if(w.code!=="EPIPE"&&w.code!=="ERR_IPC_CHANNEL_CLOSED")throw w}}$acceptProcessShutdown(s,c){this._terminalProcesses.get(s)?.shutdown(c)}$acceptProcessRequestInitialCwd(s){this._terminalProcesses.get(s)?.getInitialCwd().then(c=>this._proxy.$sendProcessInitialCwd(s,c))}$acceptProcessRequestCwd(s){this._terminalProcesses.get(s)?.getCwd().then(c=>this._proxy.$sendProcessCwd(s,c))}$acceptProcessRequestLatency(s){return s}registerLinkProvider(s){return this._linkProviders.add(s),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(s),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(s,c,h){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,h),this._proxy.$registerProfileProvider(c,s.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(s,c){const h=new a.CancellationTokenSource().token,w=await this._profileProviders.get(s)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(!w||!("options"in w))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in w.options){this.createExtensionTerminal(w.options,c);return}this.createTerminalFromOptions(w.options,c)}}async $provideLinks(s,c){const h=this._getTerminalById(s);if(!h)return[];this._terminalLinkCache.delete(s);const w=this._terminalLinkCancellationSource.get(s);w&&w.dispose(!0);const E=new a.CancellationTokenSource;this._terminalLinkCancellationSource.set(s,E);const p=[],T={terminal:h.value,line:c},L=[];for(const $ of this._linkProviders)L.push(new Promise(async z=>{E.token.onCancellationRequested(()=>z({provider:$,links:[]}));const O=await $.provideTerminalLinks(T,E.token)||[];E.token.isCancellationRequested||z({provider:$,links:O})}));const M=await Promise.all(L);if(E.token.isCancellationRequested)return[];const R=new Map;for(const $ of M)$&&$.links.length>0&&p.push(...$.links.map(z=>{const O={id:l++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return R.set(O.id,{provider:$.provider,link:z}),O}));return this._terminalLinkCache.set(s,R),p}$activateLink(s,c){const h=this._terminalLinkCache.get(s)?.get(c);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(s,c){this._bufferer.stopBuffering(s),this._terminalProcesses.delete(s),delete this._extensionTerminalAwaitingStart[s];const h=this._terminalProcessDisposables[s];h&&(h.dispose(),delete this._terminalProcessDisposables[s]),this._proxy.$sendProcessExit(s,c)}_getTerminalById(s){return this._getTerminalObjectById(this._terminals,s)}_getTerminalObjectById(s,c){const h=this._getTerminalObjectIndexById(s,c);return h!==null?s[h]:null}_getTerminalObjectIndexById(s,c){let h=null;return s.some((w,E)=>w._id===c?(h=E,!0):!1),h}getEnvironmentVariableCollection(s){let c=this._environmentVariableCollections.get(s.identifier.value);return c||(c=new g,this._setEnvironmentVariableCollection(s.identifier.value,c)),c}_syncEnvironmentVariableCollection(s,c){const h=(0,k.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(s,c.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(s){s.forEach(c=>{const h=c[0],w=new g(c[1]);this._setEnvironmentVariableCollection(h,w)})}$acceptDefaultProfile(s,c){this._defaultProfile=s,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(s,c){this._environmentVariableCollections.set(s,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(s,c)})}};o=je([He(1,A.IExtHostRpcService)],o),e.BaseExtHostTerminalService=o;class g{constructor(s){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new f.Emitter,this.map=new Map(s)}get persistent(){return this._persistent}set persistent(s){this._persistent=s,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(s,c){this._setIfDiffers(s,{value:c,type:S.EnvironmentVariableMutatorType.Replace})}append(s,c){this._setIfDiffers(s,{value:c,type:S.EnvironmentVariableMutatorType.Append})}prepend(s,c){this._setIfDiffers(s,{value:c,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(s,c){const h=this.map.get(s);(!h||h.value!==c.value||h.type!==c.type)&&(this.map.set(s,c),this._onDidChangeCollection.fire())}get(s){return this.map.get(s)}forEach(s,c){this.map.forEach((h,w)=>s.call(c,w,h,this))}delete(s){this.map.delete(s),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=g;let t=class extends o{constructor(s){super(!1,s)}createTerminal(s,c,h){throw new n.NotSupportedError}createTerminalFromOptions(s,c){throw new n.NotSupportedError}};t=je([He(0,A.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function u(i){if(!(!i||typeof i=="string"))return"id"in i?{id:i.id,color:i.color}:i}function r(i){return v.ThemeColor.isThemeColor(i)?i:void 0}});var st=this&&this.__classPrivateFieldSet||function(Y,e,f,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,f):C?C.value=f:e.set(Y,f),f},Ne=this&&this.__classPrivateFieldGet||function(Y,e,f,F){if(f==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?F:f==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[253],me([0,1,16,22,21,3,75,48,6,25,12,32,5,14,65,15,7,224,129,89]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D,I,b,l){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let g=class{constructor(L,M){this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(a.MainContext.MainThreadTesting),this.observer=new w(this.proxy),this.runTracker=new u(this.proxy),M.registerArgumentProcessor({processArgument:R=>R?.$mid===13?v.TestItem.toItemFromContext(R):R})}createTestController(L,M){if(this.controllers.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const R=new S.DisposableStore,$=R.add(new I.SingleUseTestCollection(L));$.root.label=M;const z=new Map,O=this.proxy,V={items:$.root.children,get label(){return M},set label(U){M=U,$.root.label=U,O.$updateControllerLabel(L,M)},get id(){return L},createRunProfile:(U,x,B,H,G)=>{let K=(0,_.hash)(U);for(;z.has(K);)K++;const X=new E(this.proxy,L,K,U,x,B,H,G);return z.set(K,X),X},createTestItem(U,x,B){return new d.TestItemImpl(L,U,x,B)},createTestRun:(U,x,B=!0)=>this.runTracker.createTestRun(L,$,U,x,B),set resolveHandler(U){$.resolveHandler=U},get resolveHandler(){return $.resolveHandler},dispose:()=>{R.dispose()}};V.createRunConfiguration=V.createRunProfile,O.$registerTestController(L,M),R.add((0,S.toDisposable)(()=>O.$unregisterTestController(L)));const N={controller:V,collection:$,profiles:z};return this.controllers.set(L,N),R.add((0,S.toDisposable)(()=>this.controllers.delete(L))),R.add($.onDidGenerateDiff(U=>O.$publishDiff(L,U))),V}createTestObserver(){return this.observer.checkout()}async runTests(L,M=C.CancellationToken.None){const R=r(L);if(!R)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const $=this.controllers.get(R.controllerId);if(!$)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:L.include?.map(z=>z.id)??[$.collection.root.id],profileGroup:p[R.kind],profileId:R.profileId,controllerId:R.controllerId}],exclude:L.exclude?.map(z=>z.id)},M)}$provideFileCoverage(L,M,R){return(0,f.mapFind)(this.runTracker.trackers,z=>z.id===L?z.getCoverage(M):void 0)?.provideFileCoverage(R)??Promise.resolve([])}$resolveFileCoverage(L,M,R,$){return(0,f.mapFind)(this.runTracker.trackers,O=>O.id===L?O.getCoverage(M):void 0)?.resolveFileCoverage(R,$)??Promise.resolve([])}$configureRunProfile(L,M){this.controllers.get(L)?.profiles.get(M)?.configureHandler?.()}$publishTestResults(L){this.results=Object.freeze(L.map(M=>(0,P.deepFreeze)(v.TestResults.to(M))).concat(this.results).sort((M,R)=>R.completedAt-M.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(L,M){const R=this.controllers.get(l.TestId.fromString(L).controllerId)?.collection;R&&(await R.expand(L,M<0?1/0:M),R.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L)}async $runControllerTests(L,M){const R=this.controllers.get(L.controllerId);if(!R)return;const{collection:$,profiles:z}=R,O=z.get(L.profileId);if(!O)return;const V=L.testIds.map(B=>$.tree.get(B)).filter(n.isDefined),N=L.excludeExtIds.map(B=>R.collection.tree.get(B)).filter(n.isDefined).filter(B=>V.some(H=>H.fullId.compare(B.fullId)===2));if(!V.length)return;const U=new D.TestRunRequest(V.some(B=>B.actual instanceof d.TestItemRootImpl)?void 0:V.map(B=>B.actual),N.map(B=>B.actual),O),x=this.runTracker.prepareForMainThreadTestRun(U,i.fromInternal(L,R.collection),M);try{await O.runHandler(U,M)}finally{x.isRunning&&!M.isCancellationRequested&&await y.Event.toPromise(x.onEnd),x.dispose()}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};g=je([He(0,m.IExtHostRpcService)],g),e.ExtHostTesting=g;class t extends S.Disposable{constructor(L,M,R){super();this.dto=L,this.proxy=M,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new y.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new C.CancellationTokenSource(R)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:$}of this.tasks.values())$.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const M=this.dto.id,R=this.dto.controllerId,$=(0,k.generateUuid)(),z=new s(this.proxy,M,$),O=x=>(B,...H)=>{if(N){console.warn(`Setting the state of test "${B.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(B)||(this.ensureTestIsKnown(B),x(B,...H))},V=(x,B)=>{const H=B instanceof Array?B.map(v.TestMessage.from):[v.TestMessage.from(B)];if(x.uri&&x.range){const G={range:v.Range.from(x.range),uri:x.uri};for(const K of H)K.location=K.location||G}this.proxy.$appendTestMessagesInRun(M,$,l.TestId.fromExtHostTestItem(x,R).toString(),H)};let N=!1;const U={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return z.coverageProvider},set coverageProvider(x){z.coverageProvider=x},enqueued:O(x=>{this.proxy.$updateTestStateInRun(M,$,l.TestId.fromExtHostTestItem(x,R).toString(),1)}),skipped:O(x=>{this.proxy.$updateTestStateInRun(M,$,l.TestId.fromExtHostTestItem(x,R).toString(),5)}),started:O(x=>{this.proxy.$updateTestStateInRun(M,$,l.TestId.fromExtHostTestItem(x,R).toString(),2)}),errored:O((x,B,H)=>{V(x,B),this.proxy.$updateTestStateInRun(M,$,l.TestId.fromExtHostTestItem(x,R).toString(),6,H)}),failed:O((x,B,H)=>{V(x,B),this.proxy.$updateTestStateInRun(M,$,l.TestId.fromExtHostTestItem(x,R).toString(),4,H)}),passed:O((x,B)=>{this.proxy.$updateTestStateInRun(M,$,l.TestId.fromExtHostTestItem(x,this.dto.controllerId).toString(),3,B)}),appendOutput:(x,B,H)=>{N||(H&&(this.dto.isIncluded(H)?this.ensureTestIsKnown(H):H=void 0),this.proxy.$appendOutputToRun(M,$,F.VSBuffer.fromString(x),B&&v.location.from(B),H&&l.TestId.fromExtHostTestItem(H,R).toString()))},end:()=>{N||(N=!0,this.proxy.$finishedTestRunTask(M,$),this.tasks.delete($),this.isRunning||this.dispose())}};return this.tasks.set($,{run:U,coverage:z}),this.proxy.$startedTestRunTask(M,{id:$,name:L,running:!0}),U}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(L){if(!(L instanceof d.TestItemImpl))throw new d.InvalidTestItemError(L.id);if(this.sharedTestIds.has(l.TestId.fromExtHostTestItem(L,this.dto.controllerId).toString()))return;const M=[],R=this.dto.colllection.root;for(;;){const $=v.TestItem.from(L);if(M.unshift($),this.sharedTestIds.has($.extId)||(this.sharedTestIds.add($.extId),L===R))break;L=L.parent||R}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,M)}}class u{constructor(L){this.proxy=L,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(L,M,R){return this.getTracker(L,M,R)}cancelRunById(L){for(const M of this.tracked.values())if(M.id===L){M.dispose();return}}cancelAllRuns(){for(const L of this.tracked.values())L.dispose()}createTestRun(L,M,R,$,z){const O=this.tracked.get(R);if(O)return O.createRun($);const V=i.fromPublic(L,M,R,z),N=r(R);this.proxy.$startedExtensionTestRun({controllerId:L,profile:N&&{group:p[N.kind],id:N.profileId},exclude:R.exclude?.map(x=>x.id)??[],id:V.id,include:R.include?.map(x=>x.id)??[M.root.id],persist:z});const U=this.getTracker(R,V);return U.onEnd(()=>this.proxy.$finishedExtensionTestRun(V.id)),U.createRun($)}getTracker(L,M,R){const $=new t(M,this.proxy,R);return this.tracked.set(L,$),$.onEnd(()=>this.tracked.delete(L)),$}}e.TestRunCoordinator=u;const r=T=>{if(!!T.profile){if(!(T.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return T.profile}};class i{constructor(L,M,R,$,z,O){this.controllerId=L,this.id=M,this.isPersisted=z,this.colllection=O,this.includePrefix=R.map(V=>V+"\0"),this.excludePrefix=$.map(V=>V+"\0")}static fromPublic(L,M,R,$){return new i(L,(0,k.generateUuid)(),R.include?.map(z=>l.TestId.fromExtHostTestItem(z,L).toString())??[L],R.exclude?.map(z=>l.TestId.fromExtHostTestItem(z,L).toString())??[],$,M)}static fromInternal(L,M){return new i(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,M)}isIncluded(L){const M=l.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const R of this.excludePrefix)if(M===R||M.startsWith(R))return!1;for(const R of this.includePrefix)if(M===R||M.startsWith(R))return!0;return!1}}e.TestRunDto=i;class s{constructor(L,M,R){this.proxy=L,this.runId=M,this.taskId=R}set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!L||(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(v.TestCoverage.fromFile)??[]}catch(M){throw this.fileCoverage=void 0,M}}async resolveFileCoverage(L,M){const R=await this.fileCoverage;let $=R?.[L];return!this._coverageProvider||!R||!$?[]:($.detailedCoverage||($=R[L]=await this._coverageProvider.resolveFileCoverage?.($,M)??$),$.detailedCoverage?.map(v.TestCoverage.fromDetailed)??[])}}class c extends b.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,v.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:M,removed:R}=this;return{get added(){return[...L].map($=>$.revived)},get updated(){return[...M].map($=>$.revived)},get removed(){return[...R].map($=>$.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class h extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,M){return{...L,revived:v.TestItem.toPlain(L.item),depth:M?M.depth+1:0,children:new Set}}createChangeCollector(){return new c(this.changeEmitter)}}e.MirroredTestCollection=h;class w{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(M=>M.revived)},dispose:(0,A.once)(()=>{--L.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new h;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class E{constructor(L,M,R,$,z,O,V=!1,N=void 0){this.controllerId=M,this.profileId=R,this._label=$,this.kind=z,this.runHandler=O,this._isDefault=V,this._tag=N,o.set(this,void 0),st(this,o,L,"f");const U=p[z];if(typeof U!="number")throw new Error(`Unknown TestRunProfile.group ${z}`);Ne(this,o,"f").$publishTestRunProfile({profileId:R,controllerId:M,tag:N?v.TestTag.namespace(this.controllerId,N.id):null,label:$,group:U,isDefault:V,hasConfigurationHandler:!1})}get label(){return this._label}set label(L){L!==this._label&&(this._label=L,Ne(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,Ne(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,Ne(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?v.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,Ne(this,o,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}dispose(){Ne(this,o,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=E,o=new WeakMap;const p={[D.TestRunProfileKind.Coverage]:8,[D.TestRunProfileKind.Debug]:4,[D.TestRunProfileKind.Run]:2}}),define(fe[254],me([0,1,3,16,5,132,15,7]),function(Y,e,f,F,C,y,A,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(n,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new f.Emitter,this._onDidChangeTextEditorOptions=new f.Emitter,this._onDidChangeTextEditorVisibleRanges=new f.Emitter,this._onDidChangeTextEditorViewColumn=new f.Emitter,this._onDidChangeActiveTextEditor=new f.Emitter,this._onDidChangeVisibleTextEditors=new f.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(a=>this._onDidChangeVisibleTextEditors.fire(a)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(a=>this._onDidChangeActiveTextEditor.fire(a))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const k=this._extHostDocumentsAndEditors.allEditors();return n?k:k.map(a=>a.value)}async showTextDocument(n,k,a){let m;typeof k=="number"?m={position:A.ViewColumn.from(k),preserveFocus:a}:typeof k=="object"?m={position:A.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?A.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:m={preserveFocus:!1};const d=await this._proxy.$tryShowTextDocument(n.uri,m),v=d&&this._extHostDocumentsAndEditors.getEditor(d);if(v)return v.value;throw d?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,k){return new y.TextEditorDecorationType(this._proxy,n,k).value}$acceptEditorPropertiesChanged(n,k){const a=this._extHostDocumentsAndEditors.getEditor(n);if(!a)throw new Error("unknown text editor");if(k.options&&a._acceptOptions(k.options),k.selections){const m=k.selections.selections.map(A.Selection.to);a._acceptSelections(m)}if(k.visibleRanges){const m=F.coalesce(k.visibleRanges.map(A.Range.to));a._acceptVisibleRanges(m)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:a.value,options:{...k.options,lineNumbers:A.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const m=_.TextEditorSelectionChangeKind.fromValue(k.selections.source),d=k.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:a.value,selections:d,kind:m})}if(k.visibleRanges){const m=F.coalesce(k.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:a.value,visibleRanges:m})}}$acceptEditorPositionData(n){for(const k in n){const a=this._extHostDocumentsAndEditors.getEditor(k);if(!a)throw new Error("Unknown text editor");const m=A.ViewColumn.to(n[k]);a.value.viewColumn!==m&&(a._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:a.value,viewColumn:m}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=S}),define(fe[255],me([0,1,2,4,5,6,7]),function(Y,e,f,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class _{constructor(n,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(C.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===11){const m=a.uri===void 0?void 0:f.URI.revive(a.uri);return this._itemsBySourceAndUriMap.get(a.source)?.get(S(m))?.get(a.handle)}return a}})}async $getTimeline(n,k,a,m,d){return this._providers.get(n)?.provideTimeline(f.URI.revive(k),a,m,d)}registerTimelineProvider(n,k,a,m){const d=new y.DisposableStore,v=this.convertTimelineItem(k.id,m,d).bind(this);let D;k.onDidChange&&(D=k.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:k.id}),this));const I=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...k,scheme:n,onDidChange:void 0,async provideTimeline(b,l,o,g){g?.resetCache&&(d.clear(),I.get(k.id)?.clear());const t=await k.provideTimeline(b,l,o);if(t==null)return;const u=v(b,g);return{...t,source:k.id,items:t.items.map(u)}},dispose(){for(const b of I.values())b.get(k.id)?.clear();D?.dispose(),d.dispose()}})}convertTimelineItem(n,k,a){return(m,d)=>{let v;if(d?.cacheResults){let D=this._itemsBySourceAndUriMap.get(n);D===void 0&&(D=new Map,this._itemsBySourceAndUriMap.set(n,D));const I=S(m);v=D.get(I),v===void 0&&(v=new Map,D.set(I,v))}return D=>{const{iconPath:I,...b}=D,l=`${n}|${D.id??D.timestamp}`;v?.set(l,D);let o,g,t;return D.iconPath&&(I instanceof A.ThemeIcon?t={id:I.id,color:I.color}:f.URI.isUri(I)?(o=I,g=I):{light:o,dark:g}=I),{...b,id:b.id??void 0,handle:l,source:n,command:D.command?k.toInternal(D.command,a):void 0,icon:o,iconDark:g,themeIcon:t,accessibilityInformation:D.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,y.toDisposable)(()=>{for(const a of this._itemsBySourceAndUriMap.values())a.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=_;function S(P){return P?.toString()}}),define(fe[256],me([0,1,6,10,2,5]),function(Y,e,f,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(S){this._openers=new Map,this._proxy=S.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,P,n,k){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const a=k.schemes.find(m=>!A.supportedSchemes.has(m));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,n),this._proxy.$registerUriOpener(P,k.schemes,S,k.label),(0,f.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(S,P,n){const k=this._openers.get(S);if(!k)throw new Error(`Unknown opener with id: ${S}`);const a=C.URI.revive(P);return k.canOpenExternalUri(a,n)}async $openUri(S,P,n){const k=this._openers.get(S);if(!k)throw new Error(`Unknown opener id: '${S}'`);return k.openExternalUri(C.URI.revive(P.resolvedUri),{sourceUri:C.URI.revive(P.sourceUri)},n)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}),define(fe[257],me([0,1,5,2,6,18,26]),function(Y,e,f,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class _{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(f.MainContext.MainThreadUrls)}registerUriHandler(P,n){if(this.handles.has(A.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const k=_.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(P)),this.handlers.set(k,n),this._proxy.$registerUriHandler(k,P),(0,C.toDisposable)(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(P)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(P,n){const k=this.handlers.get(P);if(!k)return Promise.resolve(void 0);try{k.handleUri(F.URI.revive(n))}catch(a){(0,y.onUnexpectedError)(a)}return Promise.resolve(void 0)}async createAppUri(P){return F.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=_,_.HandlePool=0});var st=this&&this.__classPrivateFieldSet||function(Y,e,f,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,f):C?C.value=f:e.set(Y,f),f},Ne=this&&this.__classPrivateFieldGet||function(Y,e,f,F){if(f==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?F:f==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[70],me([0,1,3,2,182,206,88,5]),function(Y,e,f,F,C,y,A,_){"use strict";var S,P,n,k,a,m,d,v,D,I,b,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(h,w,E,p,T,L,M){S.set(this,void 0),P.set(this,void 0),n.set(this,void 0),k.set(this,void 0),a.set(this,void 0),m.set(this,void 0),d.set(this,""),v.set(this,void 0),D.set(this,!1),I.set(this,!1),b.set(this,!1),this._onMessageEmitter=new f.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new f.Emitter),this._onDidDispose=Ne(this,l,"f").event,st(this,S,h,"f"),st(this,P,w,"f"),st(this,v,E,"f"),st(this,k,p,"f"),st(this,a,T,"f"),st(this,m,L,"f"),st(this,b,g(L),"f"),st(this,n,M,"f")}dispose(){st(this,D,!0,"f"),Ne(this,l,"f").fire(),Ne(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return st(this,I,!0,"f"),(0,A.asWebviewUri)(h,Ne(this,k,"f").remote)}get cspSource(){return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ne(this,d,"f")}set html(h){this.assertNotDisposed(),Ne(this,d,"f")!==h&&(st(this,d,h,"f"),!Ne(this,I,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(st(this,I,!0,"f"),Ne(this,n,"f").report("Webview vscode-resource: uris",Ne(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ne(this,P,"f").$setHtml(Ne(this,S,"f"),h))}get options(){return this.assertNotDisposed(),Ne(this,v,"f")}set options(h){this.assertNotDisposed(),Ne(this,P,"f").$setOptions(Ne(this,S,"f"),r(Ne(this,m,"f"),Ne(this,a,"f"),h)),st(this,v,h,"f")}async postMessage(h){if(Ne(this,D,"f"))return!1;const w=(0,y.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Ne(this,b,"f")});return Ne(this,P,"f").$postMessage(Ne(this,S,"f"),w.message,...w.buffers)}assertNotDisposed(){if(Ne(this,D,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=o,S=new WeakMap,P=new WeakMap,n=new WeakMap,k=new WeakMap,a=new WeakMap,m=new WeakMap,d=new WeakMap,v=new WeakMap,D=new WeakMap,I=new WeakMap,b=new WeakMap,l=new WeakMap;function g(c){try{const h=(0,C.normalizeVersion)((0,C.parseVersion)(c.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=g;class t{constructor(h,w,E,p,T){this.initData=w,this.workspace=E,this._logService=p,this._deprecationService=T,this._webviews=new Map,this._webviewProxy=h.getProxy(_.MainContext.MainThreadWebviews)}$onMessage(h,w,...E){const p=this.getWebview(h);if(p){const{message:T}=(0,y.deserializeWebviewMessage)(w,E);p._onMessageEmitter.fire(T)}}$onMissingCsp(h,w){this._logService.warn(`${w} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,w,E){const p=new o(h,this._webviewProxy,i(w),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(h,p),p._onDidDispose(()=>{this._webviews.delete(h)}),p}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=t;function u(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=u;function r(c,h,w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,enableForms:w.enableForms,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots||s(c,h)}}e.serializeWebviewOptions=r;function i(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(h=>F.URI.from(h))}}e.reviveOptions=i;function s(c,h){return[...(h?.getWorkspaceFolders()||[]).map(w=>w.uri),c.extensionLocation]}}),define(fe[258],me([0,1,21,48,6,10,23,2,15,70,87,5,7]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,u){this.document=t,this._storagePath=u,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,u){await this.getEdit(t).undo(),u||this.disposeBackup()}async redo(t,u){await this.getEdit(t).redo(),u||this.disposeBackup()}disposeEdits(t){for(const u of t)this._edits.delete(u)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=o(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const u=this._edits.get(t,0);if(!u)throw new Error("No edit found");return u}}class d{constructor(){this._documents=new Map}get(t,u){return this._documents.get(this.key(t,u))}add(t,u,r){const i=this.key(t,u.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${u.uri}`);const s=new m(u,r);return this._documents.set(i,s),s}delete(t,u){const r=this.key(t,u.uri);this._documents.delete(r)}key(t,u){return`${t}@@@${u}`}}var v;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(v||(v={}));class D{constructor(){this._providers=new Map}addTextProvider(t,u,r){return this.add(0,t,u,r)}addCustomProvider(t,u,r){return this.add(1,t,u,r)}get(t){return this._providers.get(t)}add(t,u,r,i){if(this._providers.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this._providers.set(u,{type:t,extension:r,provider:i}),new a.Disposable(()=>this._providers.delete(u))}}class I{constructor(t,u,r,i,s){this._extHostDocuments=u,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=s,this._editorProviders=new D,this._documents=new d,this._proxy=t.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,u,r,i){const s=new C.DisposableStore;return b(r)?(s.add(this._editorProviders.addTextProvider(u,t,r)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(t),u,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(t))):(s.add(this._editorProviders.addCustomProvider(u,t,r)),this.supportEditing(r)&&s.add(r.onDidChangeCustomDocument(c=>{const h=this.getCustomDocumentEntry(u,c.document.uri);if(l(c)){const w=h.addEdit(c);this._proxy.$onDidEdit(c.document.uri,u,w,c.label)}else this._proxy.$onContentChange(c.document.uri,u)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(t),u,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(t))),a.Disposable.from(s,new a.Disposable(()=>{this._proxy.$unregisterEditorProvider(u)}))}async $createCustomDocument(t,u,r,i,s){const c=this._editorProviders.get(u);if(!c)throw new Error(`No provider found for '${u}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${u}'`);const h=_.URI.revive(t),w=await c.provider.openCustomDocument(h,{backupId:r,untitledDocumentData:i?.buffer},s);let E;return this.supportEditing(c.provider)&&this._extensionStoragePaths&&(E=this._extensionStoragePaths.workspaceValue(c.extension)??this._extensionStoragePaths.globalValue(c.extension)),this._documents.add(u,w,E),{editable:this.supportEditing(c.provider)}}async $disposeCustomDocument(t,u){const r=this._editorProviders.get(u);if(!r)throw new Error(`No provider found for '${u}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${u}'`);const i=_.URI.revive(t),{document:s}=this.getCustomDocumentEntry(u,i);this._documents.delete(u,s),s.dispose()}async $resolveWebviewEditor(t,u,r,i,s,c){const h=this._editorProviders.get(r);if(!h)throw new Error(`No provider found for '${r}'`);const w=S.ViewColumn.to(s),E=this._extHostWebview.createNewWebview(u,i.webviewOptions,h.extension),p=this._extHostWebviewPanels.createNewWebviewPanel(u,r,i.title,w,i.panelOptions,E),T=_.URI.revive(t);switch(h.type){case 1:{const{document:L}=this.getCustomDocumentEntry(r,T);return h.provider.resolveCustomEditor(L,p,c)}case 0:{const L=this._extHostDocuments.getDocument(T);return h.provider.resolveCustomTextEditor(L,p,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,u,r){this.getCustomDocumentEntry(u,t).disposeEdits(r)}async $onMoveCustomEditor(t,u,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const s=this._extHostWebviewPanels.getWebviewPanel(t);if(!s)throw new Error("No webview found");const c=_.URI.revive(u),h=this._extHostDocuments.getDocument(c);await i.provider.moveCustomTextEditor(h,s,f.CancellationToken.None)}async $undo(t,u,r,i){return this.getCustomDocumentEntry(u,t).undo(r,i)}async $redo(t,u,r,i){return this.getCustomDocumentEntry(u,t).redo(r,i)}async $revert(t,u,r){const i=this.getCustomDocumentEntry(u,t);await this.getCustomEditorProvider(u).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(t,u,r){const i=this.getCustomDocumentEntry(u,t);await this.getCustomEditorProvider(u).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(t,u,r,i){const s=this.getCustomDocumentEntry(u,t);return this.getCustomEditorProvider(u).saveCustomDocumentAs(s.document,_.URI.revive(r),i)}async $backup(t,u,r){const i=this.getCustomDocumentEntry(u,t),c=await this.getCustomEditorProvider(u).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(c),c.id}getCustomDocumentEntry(t,u){const r=this._documents.get(t,_.URI.revive(u));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(t){const r=this._editorProviders.get(t)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=I;function b(g){return typeof g.resolveCustomTextEditor=="function"}function l(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function o(g){const t=g.scheme===y.Schemas.file||g.scheme===y.Schemas.untitled?g.fsPath:g.toString();return(0,F.hash)(t)+""}});var st=this&&this.__classPrivateFieldSet||function(Y,e,f,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,f):C?C.value=f:e.set(Y,f),f},Ne=this&&this.__classPrivateFieldGet||function(Y,e,f,F){if(f==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?F:f==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[259],me([0,1,3,6,2,32,15,70,5,7]),function(Y,e,f,F,C,y,A,_,S,P){"use strict";var n,k,a,m,d,v,D,I,b,l,o,g,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends F.Disposable{constructor(c,h,w,E,p,T,L){super();n.set(this,void 0),k.set(this,void 0),a.set(this,void 0),m.set(this,void 0),d.set(this,void 0),v.set(this,void 0),D.set(this,void 0),I.set(this,void 0),b.set(this,!0),l.set(this,!0),o.set(this,!1),g.set(this,this._register(new f.Emitter)),this.onDidDispose=Ne(this,g,"f").event,t.set(this,this._register(new f.Emitter)),this.onDidChangeViewState=Ne(this,t,"f").event,st(this,n,c,"f"),st(this,k,h,"f"),st(this,a,w,"f"),st(this,d,T,"f"),st(this,I,p,"f"),st(this,v,E,"f"),st(this,m,L,"f")}dispose(){Ne(this,o,"f")||(st(this,o,!0,"f"),Ne(this,g,"f").fire(),Ne(this,k,"f").$disposeWebview(Ne(this,n,"f")),Ne(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ne(this,m,"f")}get viewType(){return this.assertNotDisposed(),Ne(this,a,"f")}get title(){return this.assertNotDisposed(),Ne(this,v,"f")}set title(c){this.assertNotDisposed(),Ne(this,v,"f")!==c&&(st(this,v,c,"f"),Ne(this,k,"f").$setTitle(Ne(this,n,"f"),c))}get iconPath(){return this.assertNotDisposed(),Ne(this,D,"f")}set iconPath(c){this.assertNotDisposed(),Ne(this,D,"f")!==c&&(st(this,D,c,"f"),Ne(this,k,"f").$setIconPath(Ne(this,n,"f"),C.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Ne(this,d,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ne(this,I,"f")=="number"&&Ne(this,I,"f")<0))return Ne(this,I,"f")}get active(){return this.assertNotDisposed(),Ne(this,l,"f")}get visible(){return this.assertNotDisposed(),Ne(this,b,"f")}_updateViewState(c){Ne(this,o,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(st(this,l,c.active,"f"),st(this,b,c.visible,"f"),st(this,I,c.viewColumn,"f"),Ne(this,t,"f").fire({webviewPanel:this}))}reveal(c,h){this.assertNotDisposed(),Ne(this,k,"f").$reveal(Ne(this,n,"f"),{viewColumn:c?A.ViewColumn.from(c):void 0,preserveFocus:!!h})}assertNotDisposed(){if(Ne(this,o,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,k=new WeakMap,a=new WeakMap,m=new WeakMap,d=new WeakMap,v=new WeakMap,D=new WeakMap,I=new WeakMap,b=new WeakMap,l=new WeakMap,o=new WeakMap,g=new WeakMap,t=new WeakMap;class r{constructor(c,h,w){this.webviews=h,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,y.generateUuid)()}createWebviewPanel(c,h,w,E,p={}){const T=typeof E=="object"?E.viewColumn:E,L={viewColumn:A.ViewColumn.from(T),preserveFocus:typeof E=="object"&&!!E.preserveFocus},M=(0,_.shouldSerializeBuffersForPostMessage)(c),R=r.newHandle();this._proxy.$createWebviewPanel((0,_.toExtensionData)(c),R,h,{title:w,panelOptions:i(p),webviewOptions:(0,_.serializeWebviewOptions)(c,this.workspace,p),serializeBuffersForPostMessage:M},L);const $=this.webviews.createNewWebview(R,p,c);return this.createNewWebviewPanel(R,h,w,T,p,$)}$onDidChangeWebviewPanelViewStates(c){const h=Object.keys(c);h.sort((w,E)=>{const p=c[w],T=c[E];return p.active?1:T.active?-1:+p.visible-+T.visible});for(const w of h){const E=this.getWebviewPanel(w);if(!E)continue;const p=c[w];E._updateViewState({active:p.active,visible:p.visible,viewColumn:A.ViewColumn.to(p.position)})}}async $onDidDisposeWebviewPanel(c){this.getWebviewPanel(c)?.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,h,w){if(this._serializers.has(h))throw new Error(`Serializer for '${h}' already registered`);return this._serializers.set(h,{serializer:w,extension:c}),this._proxy.$registerSerializer(h,{serializeBuffersForPostMessage:(0,_.shouldSerializeBuffersForPostMessage)(c)}),new P.Disposable(()=>{this._serializers.delete(h),this._proxy.$unregisterSerializer(h)})}async $deserializeWebviewPanel(c,h,w,E){const p=this._serializers.get(h);if(!p)throw new Error(`No serializer found for '${h}'`);const{serializer:T,extension:L}=p,M=this.webviews.createNewWebview(c,w.webviewOptions,L),R=this.createNewWebviewPanel(c,h,w.title,E,w.panelOptions,M);await T.deserializeWebviewPanel(R,w.state)}createNewWebviewPanel(c,h,w,E,p,T){const L=new u(c,this._proxy,h,w,E,p,T);return this._webviewPanels.set(c,L),L}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=r;function i(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var st=this&&this.__classPrivateFieldSet||function(Y,e,f,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,f):C?C.value=f:e.set(Y,f),f},Ne=this&&this.__classPrivateFieldGet||function(Y,e,f,F){if(f==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?F:f==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[260],me([0,1,3,6,70,5,7]),function(Y,e,f,F,C,y,A){"use strict";var _,S,P,n,k,a,m,d,v,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class I extends F.Disposable{constructor(o,g,t,u,r,i){super();_.set(this,void 0),S.set(this,void 0),P.set(this,void 0),n.set(this,void 0),k.set(this,!1),a.set(this,void 0),m.set(this,void 0),d.set(this,void 0),v.set(this,this._register(new f.Emitter)),this.onDidChangeVisibility=Ne(this,v,"f").event,D.set(this,this._register(new f.Emitter)),this.onDidDispose=Ne(this,D,"f").event,st(this,P,t,"f"),st(this,m,u,"f"),st(this,_,o,"f"),st(this,S,g,"f"),st(this,n,r,"f"),st(this,a,i,"f")}dispose(){Ne(this,k,"f")||(st(this,k,!0,"f"),Ne(this,D,"f").fire(),Ne(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ne(this,m,"f")}set title(o){this.assertNotDisposed(),Ne(this,m,"f")!==o&&(st(this,m,o,"f"),Ne(this,S,"f").$setWebviewViewTitle(Ne(this,_,"f"),o))}get description(){return this.assertNotDisposed(),Ne(this,d,"f")}set description(o){this.assertNotDisposed(),Ne(this,d,"f")!==o&&(st(this,d,o,"f"),Ne(this,S,"f").$setWebviewViewDescription(Ne(this,_,"f"),o))}get visible(){return Ne(this,a,"f")}get webview(){return Ne(this,n,"f")}get viewType(){return Ne(this,P,"f")}_setVisible(o){o===Ne(this,a,"f")||Ne(this,k,"f")||(st(this,a,o,"f"),Ne(this,v,"f").fire())}show(o){this.assertNotDisposed(),Ne(this,S,"f").$show(Ne(this,_,"f"),!!o)}assertNotDisposed(){if(Ne(this,k,"f"))throw new Error("Webview is disposed")}}_=new WeakMap,S=new WeakMap,P=new WeakMap,n=new WeakMap,k=new WeakMap,a=new WeakMap,m=new WeakMap,d=new WeakMap,v=new WeakMap,D=new WeakMap;class b{constructor(o,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=o.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(o,g,t,u){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:t,extension:o}),this._proxy.$registerWebviewViewProvider((0,C.toExtensionData)(o),g,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(o,g,t,u,r){const i=this._viewProviders.get(g);if(!i)throw new Error(`No view provider found for '${g}'`);const{provider:s,extension:c}=i,h=this._extHostWebview.createNewWebview(o,{},c),w=new I(o,this._proxy,g,t,h,!0);this._webviewViews.set(o,w),await s.resolveWebviewView(w,{state:u},r)}async $onDidChangeWebviewViewVisibility(o,g){this.getWebviewView(o)._setVisible(g)}async $disposeWebviewView(o){const g=this.getWebviewView(o);this._webviewViews.delete(o),g.dispose(),this._extHostWebview.deleteWebview(o)}getWebviewView(o){const g=this._webviewViews.get(o);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=b}),define(fe[134],me([0,1,3,5,2,10,9,4,14]),function(Y,e,f,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class $n{constructor(k){this._onDidChangeWindowState=new f.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$n.InitialState,this._proxy=k.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(a=>this.$onDidChangeWindowFocus(a))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state={...this._state,focused:k},this._onDidChangeWindowState.fire(this._state))}openUri(k,a){let m;if(typeof k=="string"){m=k;try{k=C.URI.parse(k)}catch(d){return Promise.reject(`Invalid uri - '${k}'`)}}return(0,A.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,m,a)}async asExternalUri(k,a){if((0,A.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(k,a);return C.URI.from(m)}};P.InitialState={focused:!0},P=je([He(0,S.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,_.createDecorator)("IExtHostWindow")}),define(fe[261],me([0,1,8,80,32,40,6,5,2,14]),function(Y,e,f,F,C,y,A,_,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let n=class extends A.Disposable{constructor(a,m){super();const d=a.getProxy(_.MainContext.MainThreadDownloadService);m.registerCommand(!1,"_workbench.downloadResource",async v=>{const D=S.URI.file((0,f.join)((0,F.tmpdir)(),(0,C.generateUuid)()));return await d.$download(v,D),D})}};n=je([He(0,P.IExtHostRpcService),He(1,y.IExtHostCommands)],n),e.ExtHostDownloadService=n}),define(fe[262],me([0,1,2,8,153,28,68,27,14,6,13,117,43]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class m{constructor(I,b,l){this.name=I,this.file=b,this.appender=l}static async create(I,b){const l=await(0,k.createRotatingLogger)(I,b,30*a.ByteSize.MB,1);return l.clearFormatters(),new m(I,b,l)}append(I){this.appender.critical(I)}flush(){this.appender.flush()}}class d extends A.AbstractExtHostOutputChannel{constructor(I,b,l,o){super(I,!1,f.URI.file(b.file),l,o);this._appender=b}append(I){super.append(I),this._appender.append(I),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(I,b){this._appender.flush(),super.show(I,b)}clear(){this._appender.flush(),super.clear()}}let v=class extends A.ExtHostOutputService{constructor(I,b,l){super(I);this.logService=b,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new P.MutableDisposable,this._logsLocation=l.logsLocation}$setVisibleChannel(I){if(I){const b=this._channels.get(I);b&&(this._visibleChannelDisposable.value=b.onDidAppend(()=>b.update()))}}createOutputChannel(I,b){if(I=I.trim(),!I)throw new Error("illegal argument `name`. must not be falsy");const l=this._doCreateOutChannel(I,b);return l.then(o=>o._id.then(g=>this._channels.set(g,o))),new A.LazyOutputChannel(I,l)}async _doCreateOutChannel(I,b){try{const l=(0,F.join)(this._logsLocation.fsPath,`output_logging_${(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await y.SymlinkSupport.existsDirectory(l)||await y.Promises.mkdir(l,{recursive:!0});const g=`${this._namePool++}-${I.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=f.URI.file((0,F.join)(l,`${g}.log`)),u=await m.create(g,t.fsPath);return new d(I,u,b.identifier.value,this._proxy)}catch(l){return this.logService.error(l),new A.ExtHostPushOutputChannel(I,b.identifier.value,this._proxy)}}};v=je([He(0,S.IExtHostRpcService),He(1,n.ILogService),He(2,_.IExtHostInitDataService)],v),e.ExtHostOutputService2=v}),define(fe[263],me([0,1,50,294,2,69,6,10,17]),function(Y,e,f,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class P extends y.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(g){const t=await super._getWorkspaceStorageURI(g);if(t.scheme!==_.Schemas.file)return t;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${t.fsPath}.`),t;const u=t.fsPath;let r=0;do{let i;r===0?i=u:i=/[/\\]$/.test(u)?`${u.substr(0,u.length-1)}-${r}`:`${u}-${r}`,await n(i);const s=F.join(i,"vscode.lock"),c=await d(this._logService,s,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),C.URI.file(i);r++}while(r<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=P;async function n(o){try{await f.promises.stat(o);return}catch{}try{await f.promises.mkdir(o,{recursive:!0})}catch{}}const k=1e3,a=10*60*1e3;class m extends A.Disposable{constructor(g,t){super();this.logService=g,this.filename=t,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const u=await v(g,t);(!u||u.pid!==process.pid)&&(g.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await f.promises.utimes(t,new Date,new Date)}catch(r){g.error(r),g.info(`Lock '${t}': Could not update mtime.`)}},k)}dispose(){super.dispose();try{f.unlinkSync(this.filename)}catch(g){}}async setWillRelease(g){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${g} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+g};await f.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function d(o,g,t){try{const r={pid:process.pid,willReleaseAt:0};await f.promises.writeFile(g,JSON.stringify(r),{flag:"wx"})}catch(r){o.error(r)}const u=await v(o,g);return!u||u.pid!==process.pid?t?(o.info(`Lock '${g}': Could not acquire lock, giving up.`),null):(o.info(`Lock '${g}': Could not acquire lock, checking if the file is stale.`),b(o,g)):(o.info(`Lock '${g}': Lock acquired.`),new m(o,g))}async function v(o,g){let t;try{t=await f.promises.readFile(g)}catch(u){return o.error(u),null}try{return JSON.parse(String(t))}catch(u){return o.error(u),null}}async function D(o,g){let t;try{t=await f.promises.stat(g)}catch(u){return o.error(u),0}return t.mtime.getTime()}function I(o){try{return process.kill(o,0),!0}catch(g){return!1}}async function b(o,g){const t=await v(o,g);if(!t)return o.info(`Lock '${g}': Could not read pid of lock holder.`),l(o,g);if(t.willReleaseAt){let c=t.willReleaseAt-Date.now();if(c<5e3){for(c>0?o.info(`Lock '${g}': The lockfile is scheduled to be released in ${c} ms.`):o.info(`Lock '${g}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,S.timeout)(Math.min(100,c)),await D(o,g)===0)return l(o,g);c=t.willReleaseAt-Date.now()}return l(o,g)}}if(!I(t.pid))return o.info(`Lock '${g}': The pid ${t.pid} appears to be gone.`),l(o,g);const u=await D(o,g),r=Date.now()-u;if(r<=a)return o.info(`Lock '${g}': The lock does not look stale, elapsed: ${r} ms, giving up.`),null;o.info(`Lock '${g}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const i=await D(o,g),s=Date.now()-i;return s<=a?(o.info(`Lock '${g}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null):(o.info(`Lock '${g}': The lock looks stale even after waiting for 2s.`),l(o,g))}async function l(o,g){o.info(`Lock '${g}': Deleting a stale lock.`);try{await f.promises.unlink(g)}catch(t){}return d(o,g,!0)}}),define(fe[264],me([0,1,32,14,33]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let y=class extends C.BaseExtHostTerminalService{constructor(_){super(!0,_)}createTerminal(_,S,P){return this.createTerminalFromOptions({name:_,shellPath:S,shellArgs:P})}createTerminalFromOptions(_,S){const P=new C.ExtHostTerminal(this._proxy,(0,f.generateUuid)(),_,_.name);return this._terminals.push(P),P.create(_,this._serializeParentTerminal(_,S)),P.value}};y=je([He(0,F.IExtHostRpcService)],y),e.ExtHostTerminalService=y}),define(fe[265],me([0,1,5,14,173,6,27,2,39,23,28,7,11,53,3,123,77,13]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(w,E,p){this.remoteAddress=w,this.localAddress=E,this._dispose=p,this._onDispose=new d.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function l(h){const w=h.trim().split(`
`),E=[];return w.forEach(T=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(T);L&&L.length>=3&&E.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),E.reduce((T,L)=>(T[L.socket]=L,T),{})}e.getSockets=l;function o(...h){const w=[].concat(...h.map(t));return[...new Map(w.filter(E=>E.st==="0A").map(E=>{const p=E.local_address.split(":");return{socket:parseInt(E.inode,10),ip:g(p[0]),port:parseInt(p[1],16)}}).map(E=>[E.ip+":"+E.port,E])).values()]}e.loadListeningPorts=o;function g(h){let w="";if(h.length===8)for(let E=h.length-2;E>=0;E-=2)w+=parseInt(h.substr(E,2),16),E!==0&&(w+=".");else for(let E=h.length-4;E>=0;E-=4)w+=parseInt(h.substr(E,4),16).toString(16),E!==0&&(w+=":");return w}e.parseIpAddress=g;function t(h){const w=h.trim().split(`
`),E=w.shift().trim().split(/\s+/).filter(T=>T!=="rx_queue"&&T!=="tm->when");return w.map(T=>T.trim().split(/\s+/).reduce((L,M,R)=>(L[E[R]||R]=M,L),{}))}e.loadConnectionTable=t;function u(h){return!!h.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||h.indexOf("out/vs/server/main.js")!==-1||h.indexOf("_productName=VSCode")!==-1}function r(h){const w=h.trim().split(`
`),E=[];return w.forEach(p=>{const T=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(p);T&&T.length>=4&&E.push({pid:parseInt(T[1],10),ppid:parseInt(T[2]),cmd:T[3]})}),E}e.getRootProcesses=r;async function i(h,w,E){const p=E.reduce((L,M)=>(L[M.pid]=M,L),{}),T=[];return h.forEach(({socket:L,ip:M,port:R})=>{const $=w[L]?w[L].pid:void 0,z=$?p[$]?.cmd:void 0;$&&z&&!u(z)&&T.push({host:M,port:R,detail:z,pid:$})}),T}e.findPorts=i;function s(h,w,E){const p=new Map,T=r(w);for(const L of h){const M=E.get(L.port);if(M){p.set(L.port,M);continue}const R=T.find($=>$.cmd.includes(`${L.port}`));if(R){let $=R,z;do z=T.find(O=>O.ppid===$.pid),z&&($=z);while(z);p.set(L.port,{host:L.ip,port:L.port,pid:$.pid,detail:$.cmd,ppid:$.ppid})}else p.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return p}e.tryFindRootPorts=s;let c=class extends y.Disposable{constructor(w,E,p){super();this.logService=p,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new d.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=w.getProxy(f.MainContext.MainThreadTunnelService),a.isLinux&&E.remote.isRemote&&E.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(w,E){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${w.identifier.value} called openTunnel API for ${E.remoteAddress.host}:${E.remoteAddress.port}.`);const p=await this._proxy.$openTunnel(E,w.displayName);if(p){const T=new b(p.remoteAddress,p.localAddress,()=>this._proxy.$closeTunnel(p.remoteAddress));return this._register(T),T}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(w){return Math.max(w*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(w,E){const p=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(p,{selector:w,provider:E}),this._proxy.$registerPortsAttributesProvider(w,p),new k.Disposable(()=>{this._portAttributesProviders.delete(p),this._proxy.$unregisterPortsAttributesProvider(p)})}async $providePortAttributes(w,E,p,T,L){const M=[];for(const $ of w){const z=this._portAttributesProviders.get($);if(!z)return[];M.push(...await Promise.all(E.map(async O=>z.provider.providePortAttributes(O,p,T,L))))}const R=M.filter($=>!!$);return R.length>0?R.map($=>({autoForwardAction:$.autoForwardAction,port:$.port})):[]}async $registerCandidateFinder(w){if(w&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=w;let E=new D.MovingAverage,p;for(;this._candidateFindingEnabled;){const T=new Date().getTime(),L=(await this.findCandidatePorts()).filter(R=>(0,v.isLocalhost)(R.host)||(0,v.isAllInterfaces)(R.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${L.map(R=>R.port).join(", ")}`);const M=new Date().getTime()-T;E.update(M),(!p||JSON.stringify(p)!==JSON.stringify(L))&&(p=L,await this._proxy.$onFoundNewCandidates(p)),await new Promise(R=>setTimeout(()=>R(),this.calculateDelay(E.value)))}}async setTunnelExtensionFunctions(w){if(w){if(w.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(w.candidatePortSource),w.showCandidatePort&&(this._showCandidatePort=w.showCandidatePort,this._proxy.$setCandidateFilter()),w.tunnelFactory){this._forwardPortProvider=w.tunnelFactory;let E=w.tunnelFeatures?.privacyOptions??[];w.tunnelFeatures?.public&&E.length===0&&(E=[{id:"private",label:C.localize(0,null),themeIcon:"lock"},{id:"public",label:C.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!w.tunnelFeatures?.elevation,public:!!w.tunnelFeatures?.public,privacyOptions:E})}}else this._forwardPortProvider=void 0;return(0,y.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(w,E){if(this._extensionTunnels.has(w.host)){const p=this._extensionTunnels.get(w.host);p.has(w.port)&&(E&&p.get(w.port).disposeListener.dispose(),await p.get(w.port).tunnel.dispose(),p.delete(w.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(w,E){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const p=this._forwardPortProvider(w,E);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),p!==void 0){const T=await p;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(w.remoteAddress.host)||this._extensionTunnels.set(w.remoteAddress.host,new Map);const L=this._register(T.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(T.remoteAddress))));return this._extensionTunnels.get(w.remoteAddress.host).set(w.remoteAddress.port,{tunnel:T,disposeListener:L}),m.TunnelDto.fromApiTunnel(T)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(p){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(w){const E=await Promise.all(w.map(T=>this._showCandidatePort(T.host,T.port,T.detail??""))),p=w.filter((T,L)=>E[L]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${w.map(T=>T.port).join(", ")} to ${p.map(T=>T.port).join(", ")}`),p}async findCandidatePorts(){let w="",E="";try{w=await n.Promises.readFile("/proc/net/tcp","utf8"),E=await n.Promises.readFile("/proc/net/tcp6","utf8")}catch(N){}const p=o(w,E),T=await new Promise(N=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(U,x,B)=>{N(x)})}),L=l(T),M=await n.Promises.readdir("/proc"),R=[];for(let N of M)try{const U=Number(N),x=P.joinPath(_.URI.file("/proc"),N);if((await n.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(U)){const H=await n.Promises.readlink(P.joinPath(x,"cwd").fsPath),G=await n.Promises.readFile(P.joinPath(x,"cmdline").fsPath,"utf8");R.push({pid:U,cwd:H,cmd:G})}}catch(U){}const $=[],z=p.filter(N=>{const U=L[N.socket];return U||$.push(N),U}),O=i(z,L,R);let V;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${$.length}`),$.length>0){const N=await new Promise(U=>{(0,S.exec)("ps -F -A -l | grep root",(x,B,H)=>{U(B)})});this._foundRootPorts=s($,N,this._foundRootPorts),V=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${V.join(", ")}`)}return O.then(N=>V?N.concat(V):N)}};c=je([He(0,F.IExtHostRpcService),He(1,A.IExtHostInitDataService),He(2,I.ILogService)],c),e.ExtHostTunnelService=c}),define(fe[266],me([0,1,17,22,21,18,3,6,104,230,54]),function(Y,e,f,F,C,y,A,_,S,P,n){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function a(p,T){try{return JSON.stringify(p,T)}catch(L){return"null"}}const m="$$ref$$",d={[m]:-1};class v{constructor(T,L){this.jsonString=T,this.referencedBuffers=L}}function D(p,T=null,L=!1){const M=[];return{jsonString:(L?a:JSON.stringify)(p,($,z)=>{if(typeof z=="undefined")return d;if(typeof z=="object"){if(z instanceof F.VSBuffer){const O=M.push(z)-1;return{[m]:O}}if(T)return T($,z)}return z}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=D;function I(p,T,L){return JSON.parse(p,(M,R)=>{if(R){const $=R[m];if(typeof $=="number")return T[$];if(L&&R.$mid===1)return L.transformIncoming(R)}return R})}e.parseJsonAndRestoreBufferRefs=I;function b(p,T){return JSON.stringify(p,T)}function l(p){return p?(T,L)=>L&&L.$mid===1?p.transformOutgoing(L):L:null}var o;(function(p){p[p.LocalSide=0]="LocalSide",p[p.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(p){p[p.Responsive=0]="Responsive",p[p.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},u=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends _.Disposable{constructor(T,L=null,M=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=L,this._uriTransformer=M,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let R=0,$=n.ProxyIdentifier.count;R<$;R++)this._locals[R]=null,this._proxies[R]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new f.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(R=>this._receiveOneMessage(R))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{this._pendingRPCReplies[T].resolveErr(y.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,S.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:L,sid:M}=T;return this._proxies[L]||(this._proxies[L]=this._createProxy(L,M)),this._proxies[L]}_createProxy(T,L){let M={get:(R,$)=>(typeof $=="string"&&!R[$]&&$.charCodeAt(0)===36&&(R[$]=(...z)=>this._remoteCall(T,$,z)),$===r?L:R[$])};return new Proxy(Object.create(null),M)}set(T,L){return this._locals[T.nid]=L,L}assertRegistered(T){for(let L=0,M=T.length;L<M;L++){const R=T[L];if(!this._locals[R.nid])throw new Error(`Missing actor ${R.sid} (isMain: ${R.isMain})`)}}_receiveOneMessage(T){if(this._isDisposed)return;const L=T.byteLength,M=s.read(T,0),R=M.readUInt8(),$=M.readUInt32();switch(R){case 1:case 2:{let{rpcId:z,method:O,args:V}=h.deserializeRequestJSONArgs(M);this._uriTransformer&&(V=(0,S.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(L,$,z,O,V,R===2);break}case 3:case 4:{let{rpcId:z,method:O,args:V}=h.deserializeRequestMixedArgs(M);this._uriTransformer&&(V=(0,S.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(L,$,z,O,V,R===4);break}case 5:{this._logger&&this._logger.logIncoming(L,$,0,"ack"),this._onDidReceiveAcknowledge($);break}case 6:{this._receiveCancel(L,$);break}case 7:{this._receiveReply(L,$,void 0);break}case 9:{let z=h.deserializeReplyOKJSON(M);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReply(L,$,z);break}case 10:{const z=h.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(L,$,z);break}case 8:{let z=h.deserializeReplyOKVSBuffer(M);this._receiveReply(L,$,z);break}case 11:{let z=h.deserializeReplyErrError(M);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveReplyErr(L,$,z);break}case 12:{this._receiveReplyErr(L,$,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,L,M,R,$,z){this._logger&&this._logger.logIncoming(T,L,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(M)}.${R}(`,$);const O=String(L);let V,N;if(z){const x=new C.CancellationTokenSource;$.push(x.token),V=this._invokeHandler(M,R,$),N=()=>x.cancel()}else V=this._invokeHandler(M,R,$),N=t;this._cancelInvokedHandlers[O]=N;const U=h.serializeAcknowledged(L);this._logger&&this._logger.logOutgoing(U.byteLength,L,1,"ack"),this._protocol.send(U),V.then(x=>{delete this._cancelInvokedHandlers[O];const B=h.serializeReplyOK(L,x,this._uriReplacer);this._logger&&this._logger.logOutgoing(B.byteLength,L,1,"reply:",x),this._protocol.send(B)},x=>{delete this._cancelInvokedHandlers[O];const B=h.serializeReplyErr(L,x);this._logger&&this._logger.logOutgoing(B.byteLength,L,1,"replyErr:",x),this._protocol.send(B)})}_receiveCancel(T,L){this._logger&&this._logger.logIncoming(T,L,1,"receiveCancel");const M=String(L);this._cancelInvokedHandlers[M]&&this._cancelInvokedHandlers[M]()}_receiveReply(T,L,M){this._logger&&this._logger.logIncoming(T,L,0,"receiveReply:",M);const R=String(L);if(!this._pendingRPCReplies.hasOwnProperty(R))return;const $=this._pendingRPCReplies[R];delete this._pendingRPCReplies[R],$.resolveOk(M)}_receiveReplyErr(T,L,M){this._logger&&this._logger.logIncoming(T,L,0,"receiveReplyErr:",M);const R=String(L);if(!this._pendingRPCReplies.hasOwnProperty(R))return;const $=this._pendingRPCReplies[R];delete this._pendingRPCReplies[R];let z;M&&(M.$isError?(z=new Error,z.name=M.name,z.message=M.message,z.stack=M.stack):z=M),$.resolveErr(z)}_invokeHandler(T,L,M){try{return Promise.resolve(this._doInvokeHandler(T,L,M))}catch(R){return Promise.reject(R)}}_doInvokeHandler(T,L,M){const R=this._locals[T];if(!R)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(T));let $=R[L];if(typeof $!="function")throw new Error("Unknown method "+L+" on actor "+(0,n.getStringIdentifierForProxy)(T));return $.apply(R,M)}_remoteCall(T,L,M){if(this._isDisposed)return Promise.reject(y.canceled());let R=null;if(M.length>0&&C.CancellationToken.isCancellationToken(M[M.length-1])&&(R=M.pop()),R&&R.isCancellationRequested)return Promise.reject(y.canceled());const $=h.serializeRequestArguments(M,this._uriReplacer),z=++this._lastMessageId,O=String(z),V=new P.LazyPromise;R&&R.onCancellationRequested(()=>{const U=h.serializeCancel(z);this._logger&&this._logger.logOutgoing(U.byteLength,z,0,"cancel"),this._protocol.send(h.serializeCancel(z))}),this._pendingRPCReplies[O]=V,this._onWillSendRequest(z);const N=h.serializeRequest(z,T,L,$,!!R);return this._logger&&this._logger.logOutgoing(N.byteLength,z,0,`request: ${(0,n.getStringIdentifierForProxy)(T)}.${L}(`,M),this._protocol.send(N),V}}e.RPCProtocol=i,k=u,i.UNRESPONSIVE_TIME=3*1e3;class s{constructor(T,L){this._buff=T,this._offset=L}static alloc(T,L,M){let R=new s(F.VSBuffer.alloc(M+1+4),0);return R.writeUInt8(T),R.writeUInt32(L),R}static read(T,L){return new s(T,L)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,M}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,M}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,L}static sizeMixedArray(T){let L=0;L+=1;for(let M=0,R=T.length;M<R;M++){const $=T[M];switch(L+=1,$.type){case 1:L+=this.sizeLongString($.value);break;case 2:L+=this.sizeVSBuffer($.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString($.value);for(let z=0;z<$.buffers.length;++z)L+=this.sizeVSBuffer($.buffers[z]);break;case 4:break}}return L}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let L=0,M=T.length;L<M;L++){const R=T[L];switch(R.type){case 1:this.writeUInt8(1),this.writeLongString(R.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(R.value);break;case 3:this.writeUInt8(3),this.writeUInt32(R.buffers.length),this.writeLongString(R.value);for(let $=0;$<R.buffers.length;++$)this.writeBuffer(R.buffers[$]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;let L=new Array(T);for(let M=0;M<T;M++)switch(this.readUInt8()){case 1:L[M]=this.readLongString();break;case 2:L[M]=this.readVSBuffer();break;case 3:const $=this.readUInt32(),z=this.readLongString(),O=[];for(let V=0;V<$;++V)O.push(this.readVSBuffer());L[M]=new n.SerializableObjectWithBuffers(I(z,O,null));break;case 4:L[M]=void 0;break}return L}}s.sizeUInt32=4;var c;(function(p){p[p.Simple=0]="Simple",p[p.Mixed=1]="Mixed"})(c||(c={}));class h{static _useMixedArgSerialization(T){for(let L=0,M=T.length;L<M;L++)if(T[L]instanceof F.VSBuffer||T[L]instanceof n.SerializableObjectWithBuffers||typeof T[L]=="undefined")return!0;return!1}static serializeRequestArguments(T,L){if(this._useMixedArgSerialization(T)){const M=[];for(let R=0,$=T.length;R<$;R++){const z=T[R];if(z instanceof F.VSBuffer)M[R]={type:2,value:z};else if(typeof z=="undefined")M[R]={type:4};else if(z instanceof n.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:V}=D(z.value,L);M[R]={type:3,value:F.VSBuffer.fromString(O),buffers:V}}else M[R]={type:1,value:F.VSBuffer.fromString(b(z,L))}}return{type:1,args:M}}return{type:0,args:b(T,L)}}static serializeRequest(T,L,M,R,$){switch(R.type){case 0:return this._requestJSONArgs(T,L,M,R.args,$);case 1:return this._requestMixedArgs(T,L,M,R.args,$)}}static _requestJSONArgs(T,L,M,R,$){const z=F.VSBuffer.fromString(M),O=F.VSBuffer.fromString(R);let V=0;V+=s.sizeUInt8(),V+=s.sizeShortString(z),V+=s.sizeLongString(O);let N=s.alloc($?2:1,T,V);return N.writeUInt8(L),N.writeShortString(z),N.writeLongString(O),N.buffer}static deserializeRequestJSONArgs(T){const L=T.readUInt8(),M=T.readShortString(),R=T.readLongString();return{rpcId:L,method:M,args:JSON.parse(R)}}static _requestMixedArgs(T,L,M,R,$){const z=F.VSBuffer.fromString(M);let O=0;O+=s.sizeUInt8(),O+=s.sizeShortString(z),O+=s.sizeMixedArray(R);let V=s.alloc($?4:3,T,O);return V.writeUInt8(L),V.writeShortString(z),V.writeMixedArray(R),V.buffer}static deserializeRequestMixedArgs(T){const L=T.readUInt8(),M=T.readShortString(),R=T.readMixedArray(),$=new Array(R.length);for(let z=0,O=R.length;z<O;z++){const V=R[z];typeof V=="string"?$[z]=JSON.parse(V):$[z]=V}return{rpcId:L,method:M,args:$}}static serializeAcknowledged(T){return s.alloc(5,T,0).buffer}static serializeCancel(T){return s.alloc(6,T,0).buffer}static serializeReplyOK(T,L,M){if(typeof L=="undefined")return this._serializeReplyOKEmpty(T);if(L instanceof F.VSBuffer)return this._serializeReplyOKVSBuffer(T,L);if(L instanceof n.SerializableObjectWithBuffers){const{jsonString:R,referencedBuffers:$}=D(L.value,M,!0);return this._serializeReplyOKJSONWithBuffers(T,R,$)}else return this._serializeReplyOKJSON(T,a(L,M))}static _serializeReplyOKEmpty(T){return s.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,L){let M=0;M+=s.sizeVSBuffer(L);let R=s.alloc(8,T,M);return R.writeVSBuffer(L),R.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,L){const M=F.VSBuffer.fromString(L);let R=0;R+=s.sizeLongString(M);let $=s.alloc(9,T,R);return $.writeLongString(M),$.buffer}static _serializeReplyOKJSONWithBuffers(T,L,M){const R=F.VSBuffer.fromString(L);let $=0;$+=s.sizeUInt32,$+=s.sizeLongString(R);for(const O of M)$+=s.sizeVSBuffer(O);let z=s.alloc(10,T,$);z.writeUInt32(M.length),z.writeLongString(R);for(const O of M)z.writeBuffer(O);return z.buffer}static deserializeReplyOKJSON(T){const L=T.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(T,L){const M=T.readUInt32(),R=T.readLongString(),$=[];for(let z=0;z<M;++z)$.push(T.readVSBuffer());return new n.SerializableObjectWithBuffers(I(R,$,L))}static serializeReplyErr(T,L){return L?this._serializeReplyErrEror(T,L):this._serializeReplyErrEmpty(T)}static _serializeReplyErrEror(T,L){const M=F.VSBuffer.fromString(a(y.transformErrorForSerialization(L),null));let R=0;R+=s.sizeLongString(M);let $=s.alloc(11,T,R);return $.writeLongString(M),$.buffer}static deserializeReplyErrError(T){const L=T.readLongString();return JSON.parse(L)}static _serializeReplyErrEmpty(T){return s.alloc(12,T,0).buffer}}var w;(function(p){p[p.RequestJSONArgs=1]="RequestJSONArgs",p[p.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",p[p.RequestMixedArgs=3]="RequestMixedArgs",p[p.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",p[p.Acknowledged=5]="Acknowledged",p[p.Cancel=6]="Cancel",p[p.ReplyOKEmpty=7]="ReplyOKEmpty",p[p.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",p[p.ReplyOKJSON=9]="ReplyOKJSON",p[p.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",p[p.ReplyErrError=11]="ReplyErrError",p[p.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var E;(function(p){p[p.String=1]="String",p[p.VSBuffer=2]="VSBuffer",p[p.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",p[p.Undefined=4]="Undefined"})(E||(E={}))}),define(fe[267],me([0,1,4]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,f.createDecorator)("remoteAgentService")}),define(fe[268],me([0,1,10,8,11,2,4,86,44,225,267]),function(Y,e,f,F,C,y,A,_,S,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,A.createDecorator)("pathService");let k=class Wn{constructor(m,d,v,D){this.localUserHome=m,this.remoteAgentService=d,this.environmentService=v,this.contextService=D,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||C.OS)(),this.resolveUserHome=(async()=>{const I=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=I?.userHome||m})()}get defaultUriScheme(){return Wn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,d){if(m.remoteAuthority)return f.Schemas.vscodeRemote;const v=(0,_.getVirtualWorkspaceScheme)(d.getWorkspace());if(v)return v;const D=d.getWorkspace().folders[0];if(D)return D.uri.scheme;const I=d.getWorkspace().configuration;return I?I.scheme:f.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?F.win32:F.posix)}async fileURI(m){let d="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const D=m.indexOf("/",2);D===-1?(d=m.substring(2),m="/"):(d=m.substring(2,D),m=m.substring(D)||"/")}return y.URI.from({scheme:f.Schemas.file,authority:d,path:m,query:"",fragment:""})}};k=je([He(1,n.IRemoteAgentService),He(2,P.IWorkbenchEnvironmentService),He(3,S.IWorkspaceContextService)],k),e.AbstractPathService=k}),define(fe[71],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class f{constructor(A,_){this.line=A,this.character=_}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,_){return new f(0,0)}with(A){return new f(0,0)}}e.Position=f;class F{constructor(A,_,S,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new f(A,_),this.end=new f(S,P)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new F(0,0,0,0)}with(A){return new F(0,0,0,0)}}e.Range=F;var C;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(fe[31],me([0,1,16,30,25,29,9,4,8,18,71,12]),function(Y,e,f,F,C,y,A,_,S,P,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const a="\u27EA ",m=" characters skipped \u27EB",d=(a.length+m.length+5)*2;e.ISearchService=(0,_.createDecorator)("searchService");var v;(function(U){U[U.file=0]="file",U[U.text=1]="text"})(v=e.SearchProviderType||(e.SearchProviderType={}));var D;(function(U){U[U.File=1]="File",U[U.Text=2]="Text"})(D=e.QueryType||(e.QueryType={}));function I(U){return!!U.preview}e.resultIsMatch=I;function b(U){return!!U.resource}e.isFileMatch=b;function l(U){return!!U.message}e.isProgressMessage=l;var o;(function(U){U[U.Normal=0]="Normal",U[U.NewSearchStarted=1]="NewSearchStarted"})(o=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(x){this.resource=x,this.results=[]}}e.FileMatch=g;class t{constructor(x,B,H){this.ranges=B;const G=Array.isArray(B)?B:[B];if(H&&H.matchLines===1&&u(G)){x=(0,A.getNLines)(x,H.matchLines);let K="",X=0,de=0;const be=Math.floor(H.charsPerLine/5),Se=[];for(const Ie of G){const Oe=Math.max(Ie.startColumn-be,0),xe=Ie.startColumn+H.charsPerLine;if(Oe>de+be+d){const ze=a+(Oe-de)+m;K+=ze+x.slice(Oe,xe),X+=Oe-(de+ze.length)}else K+=x.slice(de,xe);Se.push(new i(0,Ie.startColumn-X,Ie.endColumn-X)),de=xe}this.preview={text:K,matches:Array.isArray(this.ranges)?Se:Se[0]}}else{const K=Array.isArray(B)?B[0].startLineNumber:B.startLineNumber;this.preview={text:x,matches:(0,f.mapArrayOrNot)(B,X=>new r(X.startLineNumber-K,X.startColumn,X.endLineNumber-K,X.endColumn))}}}}e.TextSearchMatch=t;function u(U){const x=U[0].startLineNumber;for(const B of U)if(B.startLineNumber!==x||B.endLineNumber!==x)return!1;return!0}class r{constructor(x,B,H,G){this.startLineNumber=x,this.startColumn=B,this.endLineNumber=H,this.endColumn=G}}e.SearchRange=r;class i extends r{constructor(x,B,H){super(x,B,x,H)}}e.OneLineRange=i;var s;(function(U){U.Default="default",U.FileNames="fileNames",U.Type="type",U.Modified="modified",U.CountDescending="countDescending",U.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function c(U,x=!0){const B=U&&U.files&&U.files.exclude,H=x&&U&&U.search&&U.search.exclude;if(!B&&!H)return;if(!B||!H)return B||H;let G=Object.create(null);return G=C.mixin(G,C.deepClone(B)),G=C.mixin(G,C.deepClone(H),!0),G}e.getExcludes=c;function h(U,x){return U.excludePattern&&F.match(U.excludePattern,x)?!1:U.includePattern||U.usingSearchPaths?U.includePattern&&F.match(U.includePattern,x)?!0:U.usingSearchPaths?!!U.folderQueries&&U.folderQueries.some(B=>{const H=B.folder.fsPath;if(y.isEqualOrParent(x,H)){const G=S.relative(H,x);return!B.includePattern||!!F.match(B.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var w;(function(U){U[U.unknownEncoding=1]="unknownEncoding",U[U.regexParseError=2]="regexParseError",U[U.globParseError=3]="globParseError",U[U.invalidLiteral=4]="invalidLiteral",U[U.rgProcessError=5]="rgProcessError",U[U.other=6]="other",U[U.canceled=7]="canceled"})(w=e.SearchErrorCode||(e.SearchErrorCode={}));class E extends Error{constructor(x,B){super(x);this.code=B}}e.SearchError=E;function p(U){const x=U.message;if((0,P.isPromiseCanceledError)(U))return new E(x,w.canceled);try{const B=JSON.parse(x);return new E(B.message,B.code)}catch(B){return new E(x,w.other)}}e.deserializeSearchError=p;function T(U){const x={message:U.message,code:U.code};return new Error(JSON.stringify(x))}e.serializeSearchError=T;function L(U){return U.type==="error"?!0:U.type==="success"}e.isSerializedSearchComplete=L;function M(U){return U.type==="success"}e.isSerializedSearchSuccess=M;function R(U){return!!U.path}e.isSerializedFileMatch=R;function $(U,x){const B=U.searchPath?U.searchPath:U.relativePath;return(0,A.fuzzyContains)(B,x)}e.isFilePatternMatch=$;class z{constructor(x){this.path=x,this.results=[]}addMatch(x){this.results.push(x)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=z;function O(U,x){const B={...U||{},...x||{}};return Object.keys(B).filter(H=>{const G=B[H];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=O;class V{constructor(x,B){this._parsedIncludeExpression=null,this._excludeExpression={...x.excludePattern||{},...B.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let H=x.includePattern;B.includePattern&&(H?H={...H,...B.includePattern}:H=B.includePattern),H&&(this._parsedIncludeExpression=F.parse(H))}matchesExcludesSync(x,B,H){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(x,B,H))}includedInQuerySync(x,B,H){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(x,B,H)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(x,B,H))}includedInQuery(x,B,H){const G=this._parsedExcludeExpression(x,B,H),K=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(x,B,H):!0;return(0,k.isPromise)(G)?G.then(X=>X?!1:K()):K()}hasSiblingExcludeClauses(){return N(this._excludeExpression)}}e.QueryGlobTester=V;function N(U){for(const x in U)if(typeof U[x]!="boolean")return!0;return!1}}),define(fe[36],me([0,1,16,17,21,3,24,10,77,23,9,12,2,171,4,13,192,44,52,27,14,7,31,5]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D,I,b,l,o,g,t,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(T,L,M){return new P.ExtUri(R=>h(R,M)).isEqual(T,L)}function i(T,L,M){return r(T.uri,L.uri,M)?0:(0,n.compare)(T.uri.toString(),L.uri.toString())}function s(T,L,M){return T.index!==L.index?T.index<L.index?-1:1:r(T.uri,L.uri,M)?(0,n.compare)(T.name,L.name):(0,n.compare)(T.uri.toString(),L.uri.toString())}function c(T,L,M,R){const $=T.slice(0).sort((O,V)=>M(O,V,R)),z=L.slice(0).sort((O,V)=>M(O,V,R));return(0,f.delta)($,z,(O,V)=>M(O,V,R))}function h(T,L){const M=L.getCapabilities(T.scheme);return!(M&&M&1024)}class w extends I.Workspace{constructor(L,M,R,$,z,O,V){super(L,R.map(N=>new I.WorkspaceFolder(N)),$,z,V);this._name=M,this._isUntitled=O,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(V),R.forEach(N=>{this._workspaceFolders.push(N),this._structure.set(N.uri,N)})}static toExtHostWorkspace(L,M,R,$){if(!L)return{workspace:null,added:[],removed:[]};const{id:z,name:O,folders:V,configuration:N,transient:U,isUntitled:x}=L,B=[],H=M;M?V.forEach((de,be)=>{const Se=a.URI.revive(de.uri),Ie=w._findFolder(R||M,Se,$);Ie?(Ie.name=de.name,Ie.index=de.index,B.push(Ie)):B.push({uri:Se,name:de.name,index:be})}):B.push(...V.map(({uri:de,name:be,index:Se})=>({uri:a.URI.revive(de),name:be,index:Se}))),B.sort((de,be)=>de.index<be.index?-1:1);const G=new w(z,O,B,!!U,N?a.URI.revive(N):null,!!x,de=>h(de,$)),{added:K,removed:X}=c(H?H.workspaceFolders:[],G.workspaceFolders,i,$);return{workspace:G,added:K,removed:X}}static _findFolder(L,M,R){for(let $=0;$<L.folders.length;$++){const z=L.workspaceFolders[$];if(r(z.uri,M,R))return z}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,M){return M&&this._structure.get(L)&&(L=(0,P.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let E=class{constructor(L,M,R,$){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=$,this._extHostFileSystemInfo=R,this._requestIdProvider=new S.Counter,this._barrier=new F.Barrier,this._proxy=L.getProxy(u.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(u.MainContext.MainThreadMessageService);const z=M.workspace;this._confirmedWorkspace=z?new w(z.id,z.name,[],!!z.transient,z.configuration?a.URI.revive(z.configuration):null,!!z.isUntitled,O=>h(O,R)):void 0}$initializeWorkspace(L,M){this._trusted=M,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?a.URI.from({scheme:_.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,M,R,...$){const z=[];if(Array.isArray($)&&$.forEach(x=>{a.URI.isUri(x.uri)&&!z.some(B=>r(B.uri,x.uri,this._extHostFileSystemInfo))&&z.push({uri:x.uri,name:x.name||(0,P.basenameOrAuthority)(x.uri)})}),this._unconfirmedWorkspace||[M,R].some(x=>typeof x!="number"||x<0)||R===0&&z.length===0)return!1;const O=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(M+R>O.length)return!1;const V=O.slice(0);V.splice(M,R,...z.map(x=>({uri:x.uri,name:x.name||(0,P.basenameOrAuthority)(x.uri),index:void 0})));for(let x=0;x<V.length;x++){const B=V[x];if(V.some((H,G)=>G!==x&&r(B.uri,H.uri,this._extHostFileSystemInfo)))return!1}V.forEach((x,B)=>x.index=B);const{added:N,removed:U}=c(O,V,s,this._extHostFileSystemInfo);if(N.length===0&&U.length===0)return!1;if(this._proxy){const x=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(x,M,R,z).then(void 0,B=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(D.Severity.Error,(0,m.localize)(0,null,x,B.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(L,M){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,M)}async getWorkspaceFolder2(L,M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,M)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,M){let R,$="";if(typeof L=="string"?(R=a.URI.file(L),$=L):typeof L!="undefined"&&(R=L,$=L.fsPath),!R)return $;const z=this.getWorkspaceFolder(R,!0);if(!z)return $;typeof M=="undefined"&&this._actualWorkspace&&(M=this._actualWorkspace.folders.length>1);let O=(0,P.relativePath)(z.uri,R);return M&&z.name&&(O=`${z.name}/${O}`),O}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:M,added:R,removed:$}=w.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=M||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:R,removed:$}))}findFiles(L,M,R,$,z=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${$.value}, entryPoint: findFiles`);let O;if(M===null?O=!1:M&&(typeof M=="string"?O=M:O=M.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:N}=p(L);return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(V),(0,k.withUndefinedAsNull)(N),(0,k.withUndefinedAsNull)(O),(0,k.withUndefinedAsNull)(R),z).then(U=>Array.isArray(U)?U.map(x=>a.URI.revive(x)):[])}async findTextInFiles(L,M,R,$,z=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${$.value}, entryPoint: findTextInFiles`);const O=this._requestIdProvider.getNext(),V=typeof M.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:N,folder:U}=p(M.include),x=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,B={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:V,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:N,excludePattern:x},H=!1;if(this._activeSearchCallbacks[O]=G=>{if(H)return;const K=a.URI.revive(G.resource);G.results.forEach(X=>{(0,t.resultIsMatch)(X)?R({uri:K,preview:{text:X.preview.text,matches:(0,f.mapArrayOrNot)(X.preview.matches,de=>new g.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,f.mapArrayOrNot)(X.ranges,de=>new g.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):R({uri:K,text:X.text,lineNumber:X.lineNumber})})},z.isCancellationRequested)return{};try{const G=await this._proxy.$startTextSearch(L,(0,k.withUndefinedAsNull)(U),B,O,z);return delete this._activeSearchCallbacks[O],G||{}}catch(G){throw delete this._activeSearchCallbacks[O],G}}$handleTextSearchResult(L,M){this._activeSearchCallbacks[M]&&this._activeSearchCallbacks[M](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};E=je([He(0,o.IExtHostRpcService),He(1,l.IExtHostInitDataService),He(2,b.IExtHostFileSystemInfo),He(3,v.ILogService)],E),e.ExtHostWorkspace=E,e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function p(T){let L,M;return T&&(typeof T=="string"?L=T:(L=T.pattern,M=T.baseFolder||a.URI.file(T.base))),{includePattern:L,folder:M}}}),define(fe[37],me([0,1,25,3,36,5,7,195,85,12,17,4,14,13,2]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(u,r){if(r){const i=r.split(".");let s=u;for(let c=0;s&&c<i.length;c++)s=s[i[c]];return s}}function D(u){return u instanceof d.URI}function I(u){return u&&u.uri instanceof d.URI&&u.languageId&&typeof u.languageId=="string"}function b(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function l(u){return u&&u.uri instanceof d.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function o(u){if(D(u))return{resource:u};if(I(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(b(u))return{overrideIdentifier:u.languageId};if(l(u))return{resource:u.uri};if(u===null)return{resource:null}}let g=class{constructor(r,i,s){this._proxy=r.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=s,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(r,i))}};g=je([He(0,a.IExtHostRpcService),He(1,C.IExtHostWorkspace),He(2,m.ILogService)],g),e.ExtHostConfiguration=g;class t{constructor(r,i,s,c){this._onDidChangeConfiguration=new F.Emitter,this._proxy=r,this._logService=c,this._extHostWorkspace=i,this._configuration=_.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=_.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,s))}getConfiguration(r,i,s){const c=o(i)||{},h=this._toReadonlyValue(r?v(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,c,s?.identifier);function w(p){if(p==null)return null;if(typeof p=="boolean")return p?1:4;switch(p){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const E={has(p){return typeof v(h,p)!="undefined"},get:(p,T)=>{this._validateConfigurationAccess(r?`${r}.${p}`:p,c,s?.identifier);let L=v(h,p);if(typeof L=="undefined")L=T;else{let M;const R=($,z)=>{let O;const V=()=>{M=M||(0,f.deepClone)(h),O=O||v(M,z)};return(0,P.isObject)($)?new Proxy($,{get:(N,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return V(),()=>O;if(M)return O=O||v(M,z),O[U];const x=N[U];return typeof U=="string"?R(x,`${z}.${U}`):x},set:(N,U,x)=>(V(),O&&(O[U]=x),!0),deleteProperty:(N,U)=>(V(),O&&delete O[U],!0),defineProperty:(N,U,x)=>(V(),O&&Object.defineProperty(O,U,x),!0)}):$};L=R(L,p)}return L},update:(p,T,L,M)=>{p=r?`${r}.${p}`:p;const R=w(L);return T!==void 0?this._proxy.$updateConfigurationOption(R,p,T,c,M):this._proxy.$removeConfigurationOption(R,p,c,M)},inspect:p=>{p=r?`${r}.${p}`:p;const T=(0,f.deepClone)(this._configuration.inspect(p,c,this._extHostWorkspace.workspace));if(T)return{key:p,defaultValue:T.default?.value,globalValue:T.user?.value,workspaceValue:T.workspace?.value,workspaceFolderValue:T.workspaceFolder?.value,defaultLanguageValue:T.default?.override,globalLanguageValue:T.user?.override,workspaceLanguageValue:T.workspace?.override,workspaceFolderLanguageValue:T.workspaceFolder?.override,languageIds:T.overrideIdentifiers}}};return typeof h=="object"&&(0,f.mixin)(E,h,!1),Object.freeze(E)}_toReadonlyValue(r){const i=s=>(0,P.isObject)(s)?new Proxy(s,{get:(c,h)=>i(c[h]),set:(c,h,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(h)}' of object`)},deleteProperty:(c,h)=>{throw new Error(`TypeError: Cannot delete read only property '${String(h)}' of object`)},defineProperty:(c,h)=>{throw new Error(`TypeError: Cannot define property '${String(h)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return i(r)}_validateConfigurationAccess(r,i,s){const c=S.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),h=s?`[${s.value}] `:"";if(c===4){typeof i?.resource=="undefined"&&this._logService.warn(`${h}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){i?.resource&&this._logService.warn(`${h}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const s=new _.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,h)=>s.affectsConfiguration(c,o(h))})}_toMap(r){return r.reduce((i,s)=>(i.set(s[0],s[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var st=this&&this.__classPrivateFieldSet||function(Y,e,f,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,f):C?C.value=f:e.set(Y,f),f},Ne=this&&this.__classPrivateFieldGet||function(Y,e,f,F){if(f==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?F:f==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[72],me([0,1,2,17,3,5,7,36,45,37,21,33,14,27,4,10,11,13,67,215,18]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D,I,b,l,o){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(z){function O(N){if(N!=null)return N}z.from=O;function V(N){if(N!=null)return N}z.to=V})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function(z){function O(N){if(N!=null)return N}z.from=O;function V(N){if(N!=null)return N}z.to=V})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(z){function O(N){if(N!=null)return N}z.from=O;function V(N){if(N!=null)return N}z.to=V})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(z){function O(U){if(U){const x=U;return x&&!!x.process}else return!1}z.is=O;function V(U){if(U==null)return;const x={process:U.process,args:U.args};return U.options&&(x.options=r.from(U.options)),x}z.from=V;function N(U){if(U!=null)return new A.ProcessExecution(U.process,U.args,U.options)}z.to=N})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(z){function O(N){if(N!=null)return N}z.from=O;function V(N){if(N!=null)return N}z.to=V})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function(z){function O(U){if(U){const x=U;return x&&(!!x.commandLine||!!x.command)}else return!1}z.is=O;function V(U){if(U==null)return;const x={};return U.commandLine!==void 0?x.commandLine=U.commandLine:(x.command=U.command,x.args=U.args),U.options&&(x.options=s.from(U.options)),x}z.from=V;function N(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new A.ShellExecution(U.commandLine,U.options):new A.ShellExecution(U.command,U.args?U.args:[],U.options)}z.to=N})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var h;(function(z){function O(U){if(U){let x=U;return x&&x.customExecution==="customExecution"}else return!1}z.is=O;function V(U){return{customExecution:"customExecution"}}z.from=V;function N(U,x){return x.get(U)}z.to=N})(h=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var w;(function(z){function O(V,N){let U;return V.scope!==void 0&&typeof V.scope!="number"?U=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===A.TaskScope.Workspace&&N&&N.workspaceFile?U=N.workspaceFile:U=l.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:U}}z.from=O})(w=e.TaskHandleDTO||(e.TaskHandleDTO={}));var E;(function(z){function O(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}z.from=O})(E=e.TaskGroupDTO||(e.TaskGroupDTO={}));var p;(function(z){function O(U,x){if(U==null)return[];const B=[];for(let H of U){const G=V(H,x);G&&B.push(G)}return B}z.fromMany=O;function V(U,x){if(U==null)return;let B;U.execution instanceof A.ProcessExecution?B=i.from(U.execution):U.execution instanceof A.ShellExecution?B=c.from(U.execution):U.execution&&U.execution instanceof A.CustomExecution&&(B=h.from(U.execution));const H=t.from(U.definition);let G;return U.scope?typeof U.scope=="number"?G=U.scope:G=U.scope.uri:G=A.TaskScope.Workspace,!H||!G?void 0:{_id:U._id,definition:H,name:U.name,source:{extensionId:x.identifier.value,label:U.source,scope:G},execution:B,isBackground:U.isBackground,group:E.from(U.group),presentationOptions:u.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}z.from=V;async function N(U,x,B){if(U==null)return;let H;i.is(U.execution)?H=i.to(U.execution):c.is(U.execution)?H=c.to(U.execution):h.is(U.execution)&&(H=h.to(U._id,B));const G=t.to(U.definition);let K;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?K=U.source.scope:K=await x.resolveWorkspaceFolder(f.URI.revive(U.source.scope)):K=A.TaskScope.Workspace),!G||!K)return;const X=new A.Task(G,K,U.name,U.source.label,H,U.problemMatchers);return U.isBackground!==void 0&&(X.isBackground=U.isBackground),U.group!==void 0&&(X.group=A.TaskGroup.from(U.group._id),X.group&&U.group.isDefault&&(X.group=new A.TaskGroup(X.group.id,X.group.label),U.group.isDefault&&(X.group.isDefault=U.group.isDefault))),U.presentationOptions&&(X.presentationOptions=u.to(U.presentationOptions)),U._id&&(X._id=U._id),U.detail&&(X.detail=U.detail),X}z.to=N})(p=e.TaskDTO||(e.TaskDTO={}));var T;(function(z){function O(N){return N}z.from=O;function V(N){if(!!N)return Object.assign(Object.create(null),N)}z.to=V})(T=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(O,V,N){this._id=V,this._task=N,g.set(this,void 0),st(this,g,O,"f")}get task(){return this._task}terminate(){Ne(this,g,"f").terminateTask(this)}fireDidStartProcess(O){}fireDidEndProcess(O){}}g=new WeakMap;var M;(function(z){function O(V){return{id:V._id,task:void 0}}z.from=O})(M=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let R=class{constructor(O,V,N,U,x,B,H,G){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=O.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=U,this._configurationService=x,this._terminalService=B,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=H,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(O,V,N){if(!N)return new A.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:V,provider:N,extension:O}),this._proxy.$registerTaskProvider(U,V),new A.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(O,V){this._proxy.$registerTaskSystem(O,V)}fetchTasks(O){return this._proxy.$fetchTasks(T.from(O)).then(async V=>{const N=[];for(let U of V){const x=await p.to(U,this._workspaceProvider,this._providedCustomExecutions2);x&&N.push(x)}return N})}get taskExecutions(){const O=[];return this._taskExecutions.forEach(V=>O.push(V)),O}terminateTask(O){if(!(O instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(O._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(O,V,N){const U=this._providedCustomExecutions2.get(O.id);if(U){if(this._activeCustomExecutions2.get(O.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(O.id,U),this._terminalService.attachPtyToTerminal(V,await U.callback(N))}this._lastStartedTask=O.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(O)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(O){const V=await this.getTaskExecution(O);this._taskExecutionPromises.delete(O.id),this._taskExecutions.delete(O.id),this.customExecutionComplete(O),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(O){const V=await this.getTaskExecution(O.id);this._onDidTaskProcessStarted.fire({execution:V,processId:O.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(O){const V=await this.getTaskExecution(O.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:O.exitCode})}$provideTasks(O,V){const N=this._handlers.get(O);if(!N)return Promise.reject(new Error("no handler found"));const U=[],x=(0,F.asPromise)(()=>N.provider.provideTasks(n.CancellationToken.None)).then(B=>this.provideTasksInternal(V,U,N,B));return new Promise(B=>{x.then(H=>{Promise.all(U).then(()=>{B(H)})})})}async $resolveTask(O,V){const N=this._handlers.get(O);if(!N)return Promise.reject(new Error("no handler found"));if(V.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${N.type}].`);const U=await p.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const x=await N.provider.resolveTask(U,n.CancellationToken.None);if(!x)return;this.checkDeprecation(x,N);const B=p.from(x,N.extension);if(!B)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(B.execution)&&await this.addCustomExecution(B,x,!0),await this.resolveTaskInternal(B)}nextHandle(){return this._handleCounter++}async addCustomExecution(O,V,N){const U=await this._proxy.$createTaskId(O);!N&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,V.execution)}async getTaskExecution(O,V){if(typeof O=="string"){const x=this._taskExecutionPromises.get(O);if(!x)throw new Error("Unexpected: The specified task is missing an execution");return x}let N=this._taskExecutionPromises.get(O.id);if(N)return N;const U=new Promise(async(x,B)=>{const H=V||await p.to(O.task,this._workspaceProvider,this._providedCustomExecutions2);H?x(new L(this,O.id,H)):B("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(O.id,U),U.then(x=>(this._taskExecutions.set(O.id,x),x),x=>Promise.reject(x))}checkDeprecation(O,V){O._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(O){this._activeCustomExecutions2.get(O.id)&&this._activeCustomExecutions2.delete(O.id),this._notProvidedCustomExecutions.has(O.id)&&this._lastStartedTask!==O.id&&(this._providedCustomExecutions2.delete(O.id),this._notProvidedCustomExecutions.delete(O.id));let N=this._notProvidedCustomExecutions.values(),U=N.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=N.next()}};R=je([He(0,a.IExtHostRpcService),He(1,m.IExtHostInitDataService),He(2,_.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,k.IExtHostTerminalService),He(6,I.ILogService),He(7,b.IExtHostApiDeprecationService)],R),e.ExtHostTaskBase=R;let $=class extends R{constructor(O,V,N,U,x,B,H,G){super(O,V,N,U,x,B,H,G);this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:D.PlatformToString(0)})}async executeTask(O,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const N=p.from(V,O);if(N===void 0)throw new Error("Task is not valid");if(h.is(N.execution))await this.addCustomExecution(N,V,!1);else throw new o.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),V);return this._proxy.$executeTask(N).catch(x=>{throw new Error(x)}),U}provideTasksInternal(O,V,N,U){const x=[];if(U)for(let B of U){this.checkDeprecation(B,N),(!B.definition||!O[B.definition.type])&&this._logService.warn(`The task [${B.source}, ${B.name}] uses an undefined task type. The task will be ignored in the future.`);const H=p.from(B,N.extension);H&&h.is(H.execution)?(x.push(H),V.push(this.addCustomExecution(H,B,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:N.extension}}async resolveTaskInternal(O){if(h.is(O.execution))return O;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(O,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(O,V,N){}};$=je([He(0,a.IExtHostRpcService),He(1,m.IExtHostInitDataService),He(2,_.IExtHostWorkspace),He(3,S.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,k.IExtHostTerminalService),He(6,I.ILogService),He(7,b.IExtHostApiDeprecationService)],$),e.WorkerExtHostTask=$,e.IExtHostTask=(0,d.createDecorator)("IExtHostTask")}),define(fe[269],me([0,1,16,58,30,79,24,10,8,23,9,12,2,147,178,121,44,130,268,31]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let o=class{constructor(w,E,p,T){this.configurationService=w,this.workspaceContextService=E,this.editorGroupsService=p,this.pathService=T}text(w,E,p={}){w=this.getContentPattern(w,p);const T=this.configurationService.getValue(),L=E&&E.some(R=>!this.configurationService.getValue({resource:R}).search.useRipgrep);return{...this.commonQuery(E?.map(D.toWorkspaceFolder),p),type:2,contentPattern:w,previewOptions:p.previewOptions,maxFileSize:p.maxFileSize,usePCRE2:T.search.usePCRE2||L||!1,beforeContext:p.beforeContext,afterContext:p.afterContext,userDisabledExcludesAndIgnoreFiles:p.disregardExcludeSettings&&p.disregardIgnoreFiles}}getContentPattern(w,E){const p=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const T={...w,wordSeparators:p.editor.wordSeparators};return this.isCaseSensitive(w,E)&&(T.isCaseSensitive=!0),this.isMultiline(w)&&(T.isMultiline=!0),T}file(w,E={}){return{...this.commonQuery(w,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}handleIncludeExclude(w,E){return w?(w=Array.isArray(w)?w.map(i):i(w),E?this.parseSearchPaths(w):{pattern:t(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],E={}){const p=this.handleIncludeExclude(E.includePattern,E.expandPatterns),T=this.handleIncludeExclude(E.excludePattern,E.expandPatterns),L=w.length>1,M=(p.searchPaths&&p.searchPaths.length?p.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,E,T)):w.map(z=>this.getFolderQueryForRoot(z,E,T,L))).filter(z=>!!z),R={_reason:E._reason,folderQueries:M,usingSearchPaths:!!(p.searchPaths&&p.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:T.pattern,includePattern:p.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const O=f.coalesce(f.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(U=>U.resource)))).filter(N=>(0,l.pathIncludedInQuery)(R,N.fsPath)),V=this.commonQueryFromFileList(O);return{...R,...V}}const $=E.extraFileResources&&E.extraFileResources.filter(z=>(0,l.pathIncludedInQuery)(R,z.fsPath));return R.extraFileResources=$&&$.length?$:void 0,R}commonQueryFromFileList(w){const E=[],p=new A.ResourceMap,T={};let L=!1;return w.forEach(M=>{if(M.scheme===_.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(M)){const $=this.workspaceContextService.getWorkspaceFolder(M)?.uri??M.with({path:S.dirname(M.fsPath)});let z=p.get($);z||(L=!0,z={folder:$,includePattern:{}},E.push(z),p.set($,z));const O=S.relative($.fsPath,M.fsPath);(0,k.assertIsDefined)(z.includePattern)[O.replace(/\\/g,"/")]=!0}else M.fsPath&&(L=!0,T[M.fsPath]=!0)}),{folderQueries:E,includePattern:T,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(w,E){if(E.isSmartCase){if(w.isRegExp){if(n.containsUppercaseCharacter(w.pattern,!0))return!0}else if(n.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,m.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const E=V=>S.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),T=(Array.isArray(w)?w:u(w)).map(V=>{const N=this.pathService.resolvedUserHome;return N?(0,y.untildify)(V,N.scheme===_.Schemas.file?N.fsPath:N.path):V}),L=F.groupBy(T,V=>E(V)?"searchPaths":"exprSegments"),M=(L.exprSegments||[]).map(V=>n.rtrim(V,"/")).map(V=>n.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),r(V))),R={},$=this.expandSearchPathPatterns(L.searchPaths||[]);$&&$.length&&(R.searchPaths=$);const z=f.flatten(M),O=t(...z);return O&&(R.pattern=O),R}getExcludesForFolder(w,E){return E.disregardExcludeSettings?void 0:(0,l.getExcludes)(w,!E.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const E=f.flatten(w.map(T=>{let{pathPortion:L,globPortion:M}=g(T);M&&(M=s(M));const R=this.expandOneSearchPath(L);return f.flatten(R.map($=>this.resolveOneSearchPathPattern($,M)))})),p=new Map;return E.forEach(T=>{const L=T.searchPath.toString(),M=p.get(L);M?T.pattern&&(M.pattern=M.pattern||{},M.pattern[T.pattern]=!0):p.set(L,{searchPath:T.searchPath,pattern:T.pattern?t(T.pattern):void 0})}),Array.from(p.values())}expandOneSearchPath(w){if(S.isAbsolute(w)){const E=this.workspaceContextService.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==_.Schemas.file?[{searchPath:E[0].uri.with({path:w})}]:[{searchPath:a.URI.file(S.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const E=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=i(w),w.startsWith("../")||w===".."){const T=S.posix.resolve(E.path,w);return[{searchPath:E.with({path:T})}]}const p=s(w);return[{searchPath:E,pattern:p}]}else{if(w==="./"||w===".\\")return[];{const E=w.replace(/^\.[\/\\]/,""),T=this.workspaceContextService.getWorkspace().folders.map(L=>{const M=E.match(new RegExp(`^${n.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return M?{match:M,folder:L}:null}).filter(k.isDefined);if(T.length)return T.map(L=>{const M=L.match[1];return{searchPath:L.folder.uri,pattern:M&&s(M)}});{const L=w.match(/\.[\/\\](.+)[\/\\]?/),M=L?L[1]:w,R=d.localize(0,null,M);throw new Error(R)}}}}resolveOneSearchPathPattern(w,E){const p=w.pattern&&E?`${w.pattern}/${E}`:w.pattern||E,T=[{searchPath:w.searchPath,pattern:p}];return p&&!p.endsWith("**")&&T.push({searchPath:w.searchPath,pattern:p+"/**"}),T}getFolderQueryForSearchPath(w,E,p){const T=this.getFolderQueryForRoot((0,D.toWorkspaceFolder)(w.searchPath),E,p,!1);return T?{...T,includePattern:w.pattern}:null}getFolderQueryForRoot(w,E,p,T){let L;const M=a.URI.isUri(w)?w:w.uri;if(p.searchPaths){const V=p.searchPaths.filter(N=>(0,P.isEqual)(N.searchPath,M))[0];if(V&&!V.pattern)return null;V&&(L=V.pattern)}const R=this.configurationService.getValue({resource:M}),z={...this.getExcludesForFolder(R,E)||{},...L||{}},O=a.URI.isUri(w)?(0,P.basename)(w):w.name;return{folder:M,folderName:T?O:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:R.files&&R.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!R.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!R.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!R.search.followSymlinks}}};o=je([He(0,v.IConfigurationService),He(1,D.IWorkspaceContextService),He(2,I.IEditorGroupsService),He(3,b.IPathService)],o),e.QueryBuilder=o;function g(h){const w=h.match(/[\*\{\}\(\)\[\]\?]/);if(w){const E=w.index,p=h.substr(0,E).match(/[/|\\][^/\\]*$/);if(p){let T=h.substr(0,p.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:h.substr((p.index||0)+1)}}}return{pathPortion:h}}function t(...h){return h.length?h.reduce((w,E)=>(w[E]=!0,w),Object.create(null)):void 0}function u(h){return C.splitGlobAware(h,",").map(w=>w.trim()).filter(w=>!!w.length)}function r(h){return[`**/${h}/**`,`**/${h}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function i(h){return h.replace(/\\/g,"/")}function s(h){return i(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(h,w){h=f.distinct(h,T=>T.toString());const E=[],p=w.getWorkspace();return h&&h.forEach(T=>{let L;if(w.getWorkbenchState()===2)L=(0,P.relativePath)(p.folders[0].uri,T),L&&L!=="."&&(L="./"+L);else{const M=w.getWorkspaceFolder(T);if(M){const R=M.name;if(p.folders.filter(z=>z.name===R).length===1){const z=(0,P.relativePath)(M.uri,T);z===""?L=`./${M.name}`:L=`./${M.name}/${z}`}else L=T.fsPath}}L&&E.push(L)}),E}e.resolveResourcesForSearchIncludes=c}),define(fe[270],me([0,1,23,2,21,18,4,269,31,44]),function(Y,e,f,F,C,y,A,_,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function k(v,D){const I=D.activationEvents;if(!I)return Promise.resolve(void 0);const b=[],l=[];for(const i of I)if(/^workspaceContains:/.test(i)){const s=i.substr("workspaceContains:".length);s.indexOf("*")>=0||s.indexOf("?")>=0||v.forceUsingSearch?l.push(s):b.push(s)}if(b.length===0&&l.length===0)return Promise.resolve(void 0);let o;const g=new Promise((i,s)=>{o=i}),t=i=>o({activationEvent:i}),u=Promise.all(b.map(i=>a(v,i,t))).then(()=>{}),r=m(v,D.identifier,l,t);return Promise.all([u,r]).then(()=>{o(void 0)}),g}e.checkActivateWorkspaceContainsExtension=k;async function a(v,D,I){for(const b of v.folders)if(await v.exists(f.joinPath(F.URI.revive(b),D))){I(`workspaceContains:${D}`);return}}async function m(v,D,I,b){if(I.length===0)return Promise.resolve(void 0);const l=new C.CancellationTokenSource,o=v.checkExists(v.folders,I,l.token),g=setTimeout(async()=>{l.cancel(),b(`workspaceContainsTimeout:${I.join(",")}`)},n);let t=!1;try{t=await o}catch(u){y.isPromiseCanceledError(u)||y.onUnexpectedError(u)}l.dispose(),clearTimeout(g),t&&b(`workspaceContains:${I.join(",")}`)}function d(v,D,I,b){const l=v.get(A.IInstantiationService),o=v.get(S.ISearchService),t=l.createInstance(_.QueryBuilder).file(D.map(u=>(0,P.toWorkspaceFolder)(F.URI.revive(u))),{_reason:"checkExists",includePattern:I,exists:!0});return o.fileSearch(t,b).then(u=>!!u.limitHit,u=>y.isPromiseCanceledError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=d});var st=this&&this.__classPrivateFieldSet||function(Y,e,f,F,C){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!C:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?C.call(Y,f):C?C.value=f:e.set(Y,f),f},Ne=this&&this.__classPrivateFieldGet||function(Y,e,f,F){if(f==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!F:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?F:f==="a"?F.call(Y):F?F.value:e.get(Y)};define(fe[41],me([0,1,166,8,73,23,17,6,24,2,13,5,37,228,92,36,35,226,18,26,22,201,7,122,4,27,69,14,84,53,33,3,270,90,203]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D,I,b,l,o,g,t,u,r,i,s,c,h,w,E,p,T,L,M){"use strict";var R,$,z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let O=class Hn extends _.Disposable{constructor(x,B,H,G,K,X,de,be,Se,Ie){super();this._onDidChangeRemoteConnectionData=this._register(new p.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=B,this._extHostContext=H,this._initData=de,this._extHostWorkspace=G,this._extHostConfiguration=K,this._logService=X,this._extHostTunnelService=Se,this._extHostTerminalService=Ie,this._disposables=new _.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new I.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new d.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=be,this._instaService=x.createChild(new h.ServiceCollection([d.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const Oe=new Set;this._initData.hostExtensions.forEach(xe=>Oe.add(l.ExtensionIdentifier.toKey(xe))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(xe,ze,j)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(xe,b.transformErrorForSerialization(ze),j)},actualActivateExtension:async(xe,ze)=>{if(Oe.has(l.ExtensionIdentifier.toKey(xe)))return await this._mainThreadExtensionsProxy.$activateExtension(xe,ze),new m.HostExtension;const j=this._registry.getExtensionDescription(xe);return this._activateExtension(j,ze)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(x){b.onUnexpectedError(x)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let x=[];try{x=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch(B){}await Promise.all(x)}isActivated(x){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(x):!1}_activateByEvent(x,B){return this._activator.activateByEvent(x,B)}_activateById(x,B){return this._activator.activateById(x,B)}activateByIdWithErrors(x,B){return this._activateById(x,B).then(()=>{const H=this._activator.getActivatedExtension(x);if(H.activationFailed)return Promise.reject(H.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(x=>this._registry)}getExtensionExports(x){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(x).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const x=S.TernarySearchTree.forPaths(),B=this._registry.getAllExtensionDescriptions().map(H=>{if(!!this._getEntryPoint(H))return this._hostUtils.realpath(H.extensionLocation.fsPath).then(G=>x.set(P.URI.file(G).fsPath,H))});this._extensionPathIndex=Promise.all(B).then(()=>x)}return this._extensionPathIndex}_deactivate(x){let B=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(x))return B;const H=this._activator.getActivatedExtension(x);if(!H)return B;try{typeof H.module.deactivate=="function"&&(B=Promise.resolve(H.module.deactivate()).then(void 0,G=>(this._logService.error(G),Promise.resolve(void 0))))}catch(G){this._logService.error(G)}try{(0,_.dispose)(H.subscriptions)}catch(G){this._logService.error(G)}return B}async _activateExtension(x,B){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier),this._doActivateExtension(x,B).then(H=>{const G=H.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(x.identifier,G.codeLoadingTime,G.activateCallTime,G.activateResolvedTime,B),this._logExtensionActivationTimes(x,B,"success",G),H},H=>{throw this._logExtensionActivationTimes(x,B,"failure"),H})}_logExtensionActivationTimes(x,B,H,G){const K=V(x,B);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...K,...G||{},outcome:H})}_doActivateExtension(x,B){const H=V(x,B);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",H);const G=this._getEntryPoint(x);if(!G)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${x.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${x.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this._logService.flush();const K=new m.ExtensionActivationTimesBuilder(B.startup);return Promise.all([this._loadCommonJSModule(x.identifier,(0,y.joinPath)(x.extensionLocation,G),K),this._loadExtensionContext(x)]).then(X=>(C.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),Hn._callActivate(this._logService,x.identifier,X[0],X[1],K))).then(X=>(C.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),X))}_loadExtensionContext(x){const B=new g.ExtensionGlobalMemento(x,this._storage),H=new g.ExtensionMemento(x.identifier.value,!1,this._storage),G=new M.ExtensionSecrets(x,this._secretState),K=x.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,X=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([B.whenReady,H.whenReady,this._storagePath.whenReady]).then(()=>{const de=this;let be;return Object.freeze({globalState:B,workspaceState:H,secrets:G,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(Se){return F.join(x.extensionLocation.fsPath,Se)},get storagePath(){return de._storagePath.workspaceValue(x)?.fsPath},get globalStoragePath(){return de._storagePath.globalValue(x).fsPath},get logPath(){return F.join(de._initData.logsLocation.fsPath,x.identifier.value)},get logUri(){return P.URI.joinPath(de._initData.logsLocation,x.identifier.value)},get storageUri(){return de._storagePath.workspaceValue(x)},get globalStorageUri(){return de._storagePath.globalValue(x)},get extensionMode(){return K},get extension(){return be===void 0&&(be=new N(de,x.identifier,x,X)),be},get extensionRuntime(){return(0,D.checkProposedApiEnabled)(x),de.extensionRuntime},get environmentVariableCollection(){return de._extHostTerminalService.getEnvironmentVariableCollection(x)}})})}static _callActivate(x,B,H,G,K){return H=H||{activate:void 0,deactivate:void 0},this._callActivateOptional(x,B,H,G,K).then(X=>new m.ActivatedExtension(!1,null,K.build(),H,X,G.subscriptions))}static _callActivateOptional(x,B,H,G,K){if(typeof H.activate=="function")try{K.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${B.value}`);const X=typeof global=="object"?global:self,de=H.activate.apply(X,[G]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(de).then(be=>(K.activateResolveStop(),be))}catch(X){return Promise.reject(X)}else return Promise.resolve(H)}_activateOneStartupFinished(x,B){this._activateById(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:B}).then(void 0,H=>{this._logService.error(H)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const x of this._registry.getAllExtensionDescriptions())if(x.activationEvents)for(const B of x.activationEvents)B==="onStartupFinished"&&this._activateOneStartupFinished(x,B)}_handleEagerExtensions(){const x=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const B=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],H=this._handleWorkspaceContainsEagerExtensions(B),G=Promise.all([x,H]).then(()=>{});return Promise.race([G,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),G}_handleWorkspaceContainsEagerExtensions(x){return x.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(B=>this._handleWorkspaceContainsEagerExtension(x,B))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(x,B){if(this.isActivated(B.identifier))return;const H=!this._initData.remote.isRemote&&!!this._initData.remote.authority,G={folders:x.map(X=>X.uri),forceUsingSearch:H,exists:X=>this._hostUtils.exists(X.fsPath),checkExists:(X,de,be)=>this._mainThreadWorkspaceProxy.$checkExists(X,de,be)},K=await(0,T.checkActivateWorkspaceContainsExtension)(G,B);if(!!K)return this._activateById(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:K.activationEvent}).then(void 0,X=>this._logService.error(X))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(x){throw console.error(x),x}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:B}=this._initData.environment;if(!x||!B)throw new Error(f.localize(0,null));const H=await this._loadCommonJSModule(null,B,new m.ExtensionActivationTimesBuilder(!1));if(!H||typeof H.run!="function")throw new Error(f.localize(1,null,B.toString()));return new Promise((G,K)=>{const X=(Se,Ie)=>{Se?K(Se):G(typeof Ie=="number"&&Ie>0?1:0)},de=(0,y.originalFSPath)(B),be=H.run(de,X);be&&be.then&&be.then(()=>{G(0)}).catch(Se=>{K(Se.toString())})})}async $extensionTestsExit(x){this._logService.info(`extension host terminating: test runner requested exit with code ${x}`),this._logService.info(`exiting with code ${x}`),this._logService.flush(),this._hostUtils.exit(x)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(x,B){return this._resolvers[x]=B,(0,_.toDisposable)(()=>{delete this._resolvers[x]})}async _activateAndGetResolver(x){const B=x.indexOf("+");if(B===-1)throw new Error("Not an authority that can be resolved!");const H=x.substr(0,B);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${H}`,!1),{authorityPrefix:H,resolver:this._resolvers[H]}}async $resolveAuthority(x,B){const{authorityPrefix:H,resolver:G}=await this._activateAndGetResolver(x);if(!G)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${H}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(G)),C.mark(`code/extHost/willResolveAuthority/${H}`);const K=await G.resolve(x,{resolveAttempt:B});C.mark(`code/extHost/didResolveAuthorityOK/${H}`);const X={authority:x,host:K.host,port:K.port,connectionToken:K.connectionToken},de={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted};return{type:"ok",value:{authority:X,options:de,tunnelInformation:{environmentTunnels:K.environmentTunnels}}}}catch(K){if(C.mark(`code/extHost/didResolveAuthorityError/${H}`),K instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(x,B){const{authorityPrefix:H,resolver:G}=await this._activateAndGetResolver(x);if(!G)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${H}`);const K=P.URI.revive(B);if(typeof G.getCanonicalURI=="undefined")return K;const X=await(0,A.asPromise)(()=>G.getCanonicalURI(K));return X||K}$startExtensionHost(x){return this._registry.keepOnly(x),this._startExtensionHost()}$activateByEvent(x,B){return B===1?this._activateByEvent(x,!1):this._readyToRunExtensions.wait().then(H=>this._activateByEvent(x,!1))}async $activate(x,B){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(x)?(await this._activateById(x,B),!0):!1}async $deltaExtensions(x,B){x.forEach(G=>G.extensionLocation=P.URI.revive(G.extensionLocation));const H=await this.getExtensionPathIndex();return await Promise.all(B.map(async G=>{const K=this._registry.getExtensionDescription(G);if(!K)return;const X=await this._hostUtils.realpath(K.extensionLocation.fsPath);H.delete(P.URI.file(X).fsPath)})),await Promise.all(x.map(async G=>{const K=await this._hostUtils.realpath(G.extensionLocation.fsPath);H.set(P.URI.file(K).fsPath,G)})),this._registry.deltaExtensions(x,B),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){let B=o.VSBuffer.alloc(x),H=Math.random()%256;for(let G=0;G<x;G++)B.writeUInt8(H,G);return B}async $updateRemoteConnectionData(x){this._remoteConnectionData=x,this._onDidChangeRemoteConnectionData.fire()}};O=je([He(0,r.IInstantiationService),He(1,e.IHostUtils),He(2,c.IExtHostRpcService),He(3,v.IExtHostWorkspace),He(4,a.IExtHostConfiguration),He(5,n.ILogService),He(6,i.IExtHostInitDataService),He(7,s.IExtensionStoragePaths),He(8,w.IExtHostTunnelService),He(9,E.IExtHostTerminalService)],O),e.AbstractExtHostExtensionService=O;function V(U,x){return{id:U.identifier.value,name:U.name,extensionVersion:U.version,publisherDisplayName:U.publisher,activationEvents:U.activationEvents?U.activationEvents.join(","):null,isBuiltin:U.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class N{constructor(x,B,H,G){R.set(this,void 0),$.set(this,void 0),z.set(this,void 0),st(this,R,x,"f"),st(this,$,B,"f"),st(this,z,H.identifier,"f"),this.id=H.identifier.value,this.extensionUri=H.extensionLocation,this.extensionPath=F.normalize((0,y.originalFSPath)(H.extensionLocation)),this.packageJSON=H,this.extensionKind=G}get isActive(){return Ne(this,R,"f").isActivated(Ne(this,z,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ne(this,R,"f").getExtensionExports(Ne(this,z,"f"))}activate(){return Ne(this,R,"f").activateByIdWithErrors(Ne(this,z,"f"),{startup:!1,extensionId:Ne(this,$,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=N,R=new WeakMap,$=new WeakMap,z=new WeakMap}),define(fe[56],me([0,1,8,2,3,17,5,7,126,36,41,45,217,37,211,14,4,12,38,55]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let o=class{constructor(h,w,E,p,T,L){this._workspaceService=w,this._extensionService=E,this._editorsService=p,this._configurationService=T,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=h.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(M=>{M.onDidChange(R=>{this.registerAllDebugTypes(M)}),this.registerAllDebugTypes(M)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(h,w){const E=h;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let p=`debug:${encodeURIComponent(E.path||"")}`,T="?";return w&&(p+=`${T}session=${encodeURIComponent(w.id)}`,T="&"),p+=`${T}ref=${E.sourceReference}`,F.URI.parse(p)}else{if(E.path)return F.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(h){const w=[];for(const E of h.getAllExtensionDescriptions())if(E.contributes){const p=E.contributes.debuggers;if(p&&p.length>0)for(const T of p)(0,d.isDebuggerMainContribution)(T)&&w.push(T.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const h=[];return this._breakpoints.forEach(w=>h.push(w)),h}addBreakpoints(h){this.startBreakpoints();const w=h.filter(T=>{const L=T.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,T),!0)});this.fireBreakpointChanges(w,[],[]);const E=[],p=new Map;for(const T of w)if(T instanceof _.SourceBreakpoint){let L=p.get(T.location.uri.toString());L||(L={type:"sourceMulti",uri:T.location.uri,lines:[]},p.set(T.location.uri.toString(),L),E.push(L)),L.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof _.FunctionBreakpoint&&E.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(E)}removeBreakpoints(h){this.startBreakpoints();const w=h.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],w,[]);const E=w.filter(L=>L instanceof _.SourceBreakpoint).map(L=>L.id),p=w.filter(L=>L instanceof _.FunctionBreakpoint).map(L=>L.id),T=w.filter(L=>L instanceof _.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(E,p,T)}startDebugging(h,w,E){return this._debugServiceProxy.$startDebugging(h?h.uri:void 0,w,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===_.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,debugUI:E.debugUI,suppressSaveBeforeStart:E.suppressSaveBeforeStart})}stopDebugging(h){return this._debugServiceProxy.$stopDebugging(h?h.id:void 0)}registerDebugConfigurationProvider(h,w,E){if(!w)return new _.Disposable(()=>{});const p=this._configProviderHandleCounter++;return this._configProviders.push({type:h,handle:p,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(h,E,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,p),new _.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(h,w,E){if(!E)return new _.Disposable(()=>{});if(!this.definesDebugType(h,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:p,factory:E}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,p),new _.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==E),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(h,w){if(!w)return new _.Disposable(()=>{});const E=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:h,handle:E,factory:w}),new _.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(p=>p.factory!==w)})}async $runInTerminal(h,w){return Promise.resolve(void 0)}async $substituteVariables(h,w){if(!this._variableResolver){const[T,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,L)}let E;const p=await this.getFolder(h);return p&&(E={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(E,w)}createDebugAdapter(h,w){if(h.type==="implementation")return new i(h.implementation)}createSignService(){}async $startDASession(h,w){const E=this,p=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(p.type),p).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const L=this.convertToDto(T),M=this.createDebugAdapter(L,p);if(!M)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const R=M;return this._debugAdapters.set(h,R),this.getDebugAdapterTrackers(p).then($=>($&&this._debugAdaptersTrackers.set(h,$),R.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const O=z,V={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(O.arguments.value);V.body={signature:N},R.sendResponse(V)}else throw new Error("no signer")}catch(N){V.success=!1,V.message=N.message,R.sendResponse(V)}}else $&&$.onDidSendMessage&&$.onDidSendMessage(z),z=(0,d.convertToVSCPaths)(z,!0),E._debugServiceProxy.$acceptDAMessage(h,z)}),R.onError(z=>{$&&$.onError&&$.onError(z),this._debugServiceProxy.$acceptDAError(h,z.name,z.message,z.stack)}),R.onExit(z=>{$&&$.onExit&&$.onExit((0,I.withNullAsUndefined)(z),void 0),this._debugServiceProxy.$acceptDAExit(h,(0,I.withNullAsUndefined)(z),void 0)}),$&&$.onWillStartSession&&$.onWillStartSession(),R.startSession()))})}$sendDAMessage(h,w){w=(0,d.convertToDAPaths)(w,!1);const E=this._debugAdaptersTrackers.get(h);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(w);const p=this._debugAdapters.get(h);p&&p.sendMessage(w)}$stopDASession(h){const w=this._debugAdaptersTrackers.get(h);this._debugAdaptersTrackers.delete(h),w&&w.onWillStopSession&&w.onWillStopSession();const E=this._debugAdapters.get(h);return this._debugAdapters.delete(h),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(h){const w=[],E=[],p=[];if(h.added)for(const T of h.added){const L=T.id;if(L&&!this._breakpoints.has(L)){let M;if(T.type==="function")M=new _.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")M=new _.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const R=F.URI.revive(T.uri);M=new _.SourceBreakpoint(new _.Location(R,new _.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}M._id=L,this._breakpoints.set(L,M),w.push(M)}}if(h.removed)for(const T of h.removed){const L=this._breakpoints.get(T);L&&(this._breakpoints.delete(T),E.push(L))}if(h.changed){for(const T of h.changed)if(T.id){const L=this._breakpoints.get(T.id);if(L){if(L instanceof _.FunctionBreakpoint&&T.type==="function"){const M=L;M.enabled=T.enabled,M.condition=T.condition,M.hitCondition=T.hitCondition,M.logMessage=T.logMessage,M.functionName=T.functionName}else if(L instanceof _.SourceBreakpoint&&T.type==="source"){const M=L;M.enabled=T.enabled,M.condition=T.condition,M.hitCondition=T.hitCondition,M.logMessage=T.logMessage,M.location=new _.Location(F.URI.revive(T.uri),new _.Position(T.line,T.character))}p.push(L)}}}this.fireBreakpointChanges(w,E,p)}$provideDebugConfigurations(h,w,E){return(0,y.asPromise)(async()=>{const p=this.getConfigProviderByHandle(h);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(w);return p.provideDebugConfigurations(T,E)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(h,w,E,p){return(0,y.asPromise)(async()=>{const T=this.getConfigProviderByHandle(h);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(w);return T.resolveDebugConfiguration(L,E,p)})}$resolveDebugConfigurationWithSubstitutedVariables(h,w,E,p){return(0,y.asPromise)(async()=>{const T=this.getConfigProviderByHandle(h);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(w);return T.resolveDebugConfigurationWithSubstitutedVariables(L,E,p)})}async $provideDebugAdapter(h,w){const E=this.getAdapterDescriptorFactoryByHandle(h);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.getSession(w);return this.getAdapterDescriptor(E,p).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(h){const w=await this.getSession(h);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(h){const w=await this.getSession(h);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(h){this._activeDebugSession=h?await this.getSession(h):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(h,w){const E=await this.getSession(h);E&&E._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(h,w){const p={session:await this.getSession(h),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(p)}convertToDto(h){if(h instanceof _.DebugAdapterExecutable)return{type:"executable",command:h.command,args:h.args,options:h.options};if(h instanceof _.DebugAdapterServer)return{type:"server",port:h.port,host:h.host};if(h instanceof _.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:h.path};if(h instanceof _.DebugAdapterInlineImplementation)return{type:"implementation",implementation:h.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(h){const w=this._adapterFactories.filter(E=>E.type===h);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(h){const w=this._adapterFactories.filter(E=>E.handle===h);if(w.length>0)return w[0].factory}getConfigProviderByHandle(h){const w=this._configProviders.filter(E=>E.handle===h);if(w.length>0)return w[0].provider}definesDebugType(h,w){if(h.contributes){const E=h.contributes.debuggers;if(E&&E.length>0){for(const p of E)if(p.label&&p.type&&p.type===w)return!0}}return!1}getDebugAdapterTrackers(h){const E=h.configuration.type,p=this._trackerFactories.filter(T=>T.type===E||T.type==="*").map(T=>(0,y.asPromise)(()=>T.factory.createDebugAdapterTracker(h)).then(L=>L,L=>null));return Promise.race([Promise.all(p).then(T=>{const L=T.filter(M=>!!M);if(L.length>0)return new r(L)}),new Promise((T,L)=>{const M=setTimeout(()=>{clearTimeout(M),L(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(h,w){const E=w.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new _.DebugAdapterServer(E));if(h){const T=await this._extensionService.getExtensionRegistry();return(0,y.asPromise)(()=>h.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,T))).then(L=>{if(L)return L})}const p=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,p))}daExecutableFromPackage(h,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(h,w,E){(h.length>0||w.length>0||E.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:h,removed:w,changed:E}))}async getSession(h){if(h)if(typeof h=="string"){const w=this._debugSessions.get(h);if(w)return w}else{let w=this._debugSessions.get(h.id);if(!w){const E=await this.getFolder(h.folderUri),p=h.parent?this._debugSessions.get(h.parent):void 0;w=new g(this._debugServiceProxy,h.id,h.type,h.name,E,h.configuration,p),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(h){if(h){const w=F.URI.revive(h);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};o=je([He(0,v.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,n.IExtHostExtensionService),He(3,k.IExtHostDocumentsAndEditors),He(4,m.IExtHostConfiguration),He(5,l.IExtHostEditorTabs)],o),e.ExtHostDebugServiceBase=o;class g{constructor(h,w,E,p,T,L,M){this._debugServiceProxy=h,this._id=w,this._type=E,this._name=p,this._workspaceFolder=T,this._configuration=L,this._parentSession=M}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(h){this._name=h,this._debugServiceProxy.$setDebugSessionName(this._id,h)}get parentSession(){return this._parentSession}_acceptNameChanged(h){this._name=h}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(h,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,h,w)}getDebugProtocolBreakpoint(h){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,h.id)}}e.ExtHostDebugSession=g;class t{constructor(h){this.value=Object.freeze({append(w){h.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=t;class u extends a.AbstractVariableResolverService{constructor(h,w,E,p,T){function L(){if(w){const M=w.activeEditor();if(M)return M.document.uri;const R=p.tabs.filter($=>$.isActive);if(R.length>0){const $=R[0].resource;return $&&($.primary||$.secondary)?$.primary??$.secondary:R[0].resource}}}super({getFolderUri:M=>{const R=h.filter($=>$.name===M);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:(M,R)=>E.getConfiguration(void 0,M).get(R),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const M=L();if(M)return f.normalize(M.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const M=L();if(M){const R=T.getWorkspaceFolder(M);if(R)return f.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(w){const M=w.activeEditor();if(M&&!M.selection.isEmpty)return M.document.getText(M.selection)}},getLineNumber:()=>{if(w){const M=w.activeEditor();if(M)return String(M.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=u;class r{constructor(h){this.trackers=h}onWillStartSession(){this.trackers.forEach(h=>h.onWillStartSession?h.onWillStartSession():void 0)}onWillReceiveMessage(h){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(h):void 0)}onDidSendMessage(h){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(h):void 0)}onWillStopSession(){this.trackers.forEach(h=>h.onWillStopSession?h.onWillStopSession():void 0)}onError(h){this.trackers.forEach(w=>w.onError?w.onError(h):void 0)}onExit(h,w){this.trackers.forEach(E=>E.onExit?E.onExit(h,w):void 0)}}class i extends S.AbstractDebugAdapter{constructor(h){super();this.implementation=h,h.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(h){this.implementation.handleMessage(h)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends o{constructor(h,w,E,p,T,L){super(h,w,E,p,T,L)}createVariableResolver(h,w,E){return new u(h,w,E,this._editorTabs)}};s=je([He(0,v.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,n.IExtHostExtensionService),He(3,k.IExtHostDocumentsAndEditors),He(4,m.IExtHostConfiguration),He(5,l.IExtHostEditorTabs)],s),e.WorkerExtHostDebugService=s}),define(fe[271],me([0,1,73,2,5,37,35,26,14,27,4,41,38,13]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(l,o,g,t,u,r,i){this._apiFactory=l,this._extensionRegistry=o,this._instaService=g,this._extHostConfiguration=t,this._extHostExtensionService=u,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),f.mark("code/extHost/willWaitForConfig");const l=await this._extHostConfiguration.getConfigProvider();f.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new v(this._apiFactory,o,this._extensionRegistry,l,this._logService)),this.register(this._instaService.createInstance(D)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(I,o,this._initData.environment.appUriScheme))}register(l){if(Array.isArray(l.nodeModuleName))for(let o of l.nodeModuleName)this._factories.set(o,l);else this._factories.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this._alternatives.push(o=>l.alternativeModuleName(o))}};d=je([He(2,n.IInstantiationService),He(3,y.IExtHostConfiguration),He(4,k.IExtHostExtensionService),He(5,P.IExtHostInitDataService),He(6,m.ILogService)],d),e.RequireInterceptor=d;class v{constructor(l,o,g,t,u){this._apiFactory=l,this._extensionPaths=o,this._extensionRegistry=g,this._configProvider=t,this._logService=u,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(l,o){const g=this._extensionPaths.findSubstr(o.fsPath);if(g){let t=this._extApiImpl.get(_.ExtensionIdentifier.toKey(g.identifier));return t||(t=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(_.ExtensionIdentifier.toKey(g.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((u,r)=>t+=`	${r} -> ${u.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let D=class{constructor(l,o){this.nodeModuleName="keytar";const{environment:g}=o,t=l.getProxy(C.MainContext.MainThreadKeytar);if(g.appRoot){let u=g.appRoot.fsPath;a.platform==="win32"&&(u=u.replace(/\\/g,"/")),u[u.length-1]==="/"&&(u=u.substr(0,u.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${u}/node_modules.asar/keytar`),this.alternativeNames.add(`${u}/node_modules/keytar`)}this._impl={getPassword:(u,r)=>t.$getPassword(u,r),setPassword:(u,r,i)=>t.$setPassword(u,r,i),deletePassword:(u,r)=>t.$deletePassword(u,r),findPassword:u=>t.$findPassword(u),findCredentials(u){return t.$findCredentials(u)}}}load(l,o){return this._impl}alternativeModuleName(l){const o=l.length;if(o<=7||!this.alternativeNames)return;const g=o-7;if((l.charAt(g)==="/"||l.charAt(g)==="\\")&&l.endsWith("keytar")&&(l=l.replace(/\\/g,"/"),this.alternativeNames.has(l)))return"keytar"}};D=je([He(0,S.IExtHostRpcService),He(1,P.IExtHostInitDataService)],D);let I=class{constructor(l,o,g){this._extensionPaths=l,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(C.MainContext.MainThreadTelemetry);const t=g.getProxy(C.MainContext.MainThreadWindow);this._impl=(u,r)=>{const i=F.URI.parse(u);return r?this.callOriginal(u,r):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,u,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,u,{}):this.callOriginal(u,r)}}load(l,o,g){const t=this._extensionPaths.findSubstr(o.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=g(l),this._impl}callOriginal(l,o){return this.sendNoForwardTelemetry(),this._original(l,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};I=je([He(2,S.IExtHostRpcService)],I)}),define(fe[272],me([0,1,172,11,7,212,36,41,45,37,33,14,56,196,17,213,55]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let I=class extends a.ExtHostDebugServiceBase{constructor(o,g,t,u,r,i,s){super(o,g,t,u,r,s);this._terminalService=i,this._integratedTerminalInstances=new b}createDebugAdapter(o,g){switch(o.type){case"server":return new y.SocketDebugAdapter(o);case"pipeServer":return new y.NamedPipeDebugAdapter(o);case"executable":return new y.ExecutableDebugAdapter(o,g.type)}return super.createDebugAdapter(o,g)}daExecutableFromPackage(o,g){const t=y.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),o.type);if(t)return new C.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new m.SignService}async $runInTerminal(o,g){if(o.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const t=await this._configurationService.getConfigProvider(),u=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),i=o.title||f.localize(0,null),s=JSON.stringify({shell:u,shellArgs:r});let c=await this._integratedTerminalInstances.checkout(s,i),h,w=!1;if(c)h=o.cwd;else{const L={shellPath:u,shellArgs:r,cwd:o.cwd,name:i,iconPath:new C.ThemeIcon("debug")};w=!0,c=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(c,s)}c.show(!0);const E=await c.processId;w?await new Promise(L=>setTimeout(L,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0||u.indexOf("cmd.exe")>=0?c.sendText("cls"):u.indexOf("bash")>=0?c.sendText("clear"):F.isWindows?c.sendText("cls"):c.sendText("clear"));const p=(0,v.prepareCommand)(u,o.args,h,o.env);c.sendText(p);const T=this.onDidTerminateDebugSession(L=>{L.id===g&&(this._integratedTerminalInstances.free(c),T.dispose())});return E}else if(o.kind==="external")return(0,v.runInExternalTerminal)(o,await this._configurationService.getConfigProvider());return super.$runInTerminal(o,g)}createVariableResolver(o,g,t){return new a.ExtHostVariableResolverService(o,g,t,this._editorTabs,this._workspaceService)}};I=je([He(0,k.IExtHostRpcService),He(1,A.IExtHostWorkspace),He(2,_.IExtHostExtensionService),He(3,S.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,n.IExtHostTerminalService),He(6,D.IExtHostEditorTabs)],I),e.ExtHostDebugService=I;class b{constructor(){this._terminalInstances=new Map}async checkout(o,g){const u=[...this._terminalInstances.entries()].map(([r,i])=>(0,d.createCancelablePromise)(async s=>{if(r.name!==g||i.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await r.processId))return null;const c=Date.now();return i.lastUsedAt+b.minUseDelay>c||s.isCancellationRequested||i.config!==o?null:(i.lastUsedAt=c,r)}));return await(0,d.firstParallel)(u,r=>!!r)}insert(o,g){this._terminalInstances.set(o,{lastUsedAt:Date.now(),config:g})}free(o){const g=this._terminalInstances.get(o);g&&(g.lastUsedAt=-1)}onTerminalClosed(o){this._terminalInstances.delete(o)}}b.minUseDelay=1e3}),define(fe[273],me([0,1,8,2,114,36,56,45,37,44,33,14,27,72,10,13,67,55,23,80]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D,I,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let o=class extends m.ExtHostTaskBase{constructor(t,u,r,i,s,c,h,w,E){super(t,u,r,i,s,c,h,w);this.workspaceService=r,this.editorTabs=E,u.remote.isRemote&&u.remote.authority?this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:u.remote.authority,platform:process.platform}):this.registerTaskSystem(d.Schemas.file,{scheme:d.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(t,u){const r=u;if(!u.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const i=m.TaskHandleDTO.from(r,this.workspaceService),s=await this._proxy.$getTaskExecution(i);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.getTaskExecution(s,u);return this._proxy.$executeTask(i).catch(()=>{}),c}else{const i=m.TaskDTO.from(u,t);if(i===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,u,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),u);return this._proxy.$executeTask(i).catch(()=>{}),s}}provideTasksInternal(t,u,r,i){const s=[];if(i)for(let c of i){this.checkDeprecation(c,r),(!c.definition||!t[c.definition.type])&&this._logService.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const h=m.TaskDTO.from(c,r.extension);h&&(s.push(h),m.CustomExecutionDTO.is(h.execution)&&u.push(this.addCustomExecution(h,c,!0)))}return{tasks:s,extension:r.extension}}async resolveTaskInternal(t){return t}async getVariableResolver(t){if(this._variableResolver===void 0){const u=await this._configurationService.getConfigProvider();this._variableResolver=new A.ExtHostVariableResolverService(t,this._editorService,u,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(t){let u=t&&t.length>0?t[0]:void 0;if(!u){const r=F.URI.file((0,l.homedir)());u=new P.WorkspaceFolder({uri:r,name:b.basename(r),index:0})}return{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(t,u){const r=F.URI.revive(t),i={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(r),c=await this._workspaceProvider.getWorkspaceFolders2()??[],h=await this.getVariableResolver(c),w=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(c);for(let E of u.variables)i.variables[E]=await h.resolveAsync(w,E);if(u.process!==void 0){let E;if(u.process.path!==void 0){E=u.process.path.split(f.delimiter);for(let p=0;p<E.length;p++)E[p]=await h.resolveAsync(w,E[p])}i.process=await C.win32.findExecutable(await h.resolveAsync(w,u.process.name),u.process.cwd!==void 0?await h.resolveAsync(w,u.process.cwd):void 0,E)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(t,u,r){return C.win32.findExecutable(t,u,r)}};o=je([He(0,k.IExtHostRpcService),He(1,a.IExtHostInitDataService),He(2,y.IExtHostWorkspace),He(3,_.IExtHostDocumentsAndEditors),He(4,S.IExtHostConfiguration),He(5,n.IExtHostTerminalService),He(6,v.ILogService),He(7,D.IExtHostApiDeprecationService),He(8,I.IExtHostEditorTabs)],o),e.ExtHostTask=o}),define(fe[274],me([0,1,17,18,73,6,2,5,266,13,82,84,27,191,14,66,41,33]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(o,g,t,u){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new S.RPCProtocol(o,null,u),g=b._transform(g,this._rpcProtocol);const r=new k.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());r.set(a.IExtHostInitDataService,{_serviceBrand:void 0,...g}),r.set(d.IExtHostRpcService,new d.ExtHostRpcService(this._rpcProtocol)),r.set(v.IURITransformerService,new v.URITransformerService(u)),r.set(D.IHostUtils,t);const i=new m.InstantiationService(r,!0),s=i.invokeFunction(E=>E.get(I.IExtHostTerminalService));this._disposables.add(s),this._logService=i.invokeFunction(E=>E.get(P.ILogService)),C.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",g),this._extensionService=i.invokeFunction(E=>E.get(D.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const c=new WeakMap;this._extensionService.getExtensionPathIndex().then(E=>{Error.prepareStackTrace=(p,T)=>{let L="",M,R;for(const $ of T)L+=`
	at ${$.toString()}`,R=$.getFileName(),!M&&R&&(M=E.findSubstr(R));return c.set(p,M),`${p.name||"Error"}: ${p.message||""}${L}`}});const h=this._rpcProtocol.getProxy(_.MainContext.MainThreadExtensionService),w=this._rpcProtocol.getProxy(_.MainContext.MainThreadErrors);F.setUnexpectedErrorHandler(E=>{const p=F.transformErrorForSerialization(E),T=c.get(E);T?h.$onExtensionRuntimeError(T.identifier,p):w.$onUnexpectedError(p)})}terminate(o){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${o}`),this._logService.flush(),this._disposables.dispose(),F.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,f.timeout)(4e3),g]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(o,g){o.extensions.forEach(u=>u.extensionLocation=A.URI.revive(g.transformIncomingURIs(u.extensionLocation))),o.environment.appRoot=A.URI.revive(g.transformIncomingURIs(o.environment.appRoot));const t=o.environment.extensionDevelopmentLocationURI;return t&&(o.environment.extensionDevelopmentLocationURI=t.map(u=>A.URI.revive(g.transformIncomingURIs(u)))),o.environment.extensionTestsLocationURI=A.URI.revive(g.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=A.URI.revive(g.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=A.URI.revive(g.transformIncomingURIs(o.environment.workspaceStorageHome)),o.logsLocation=A.URI.revive(g.transformIncomingURIs(o.logsLocation)),o.logFile=A.URI.revive(g.transformIncomingURIs(o.logFile)),o.workspace=g.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=b}),define(fe[275],me([0,1,8,21,62,30,23,46,31]),function(Y,e,f,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(a,m,d){this.config=a,this.provider=m,this.sessionToken=d,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=a.filePattern,this.includePattern=a.includePattern&&y.parse(a.includePattern),this.maxResults=a.maxResults||void 0,this.exists=a.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=a.excludePattern&&y.parse(a.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(a=>a.cancel()),this.activeCancellationTokens=new Set}search(a){const m=this.config.folderQueries||[];return new Promise((d,v)=>{const D=I=>{this.resultCount++,a(I)};if(this.isCanceled)return d({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(I=>{const b=I.toString(),l=f.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,l)||this.matchFile(D,{base:I,basename:l})}),Promise.all(m.map(I=>this.searchInFolder(I,D))).then(I=>{d({limitHit:this.isLimitHit,stats:I[0]||void 0})},I=>{v(new Error((0,C.toErrorMessage)(I)))})})}async searchInFolder(a,m){const d=new F.CancellationTokenSource,v=this.getSearchOptionsForFolder(a),D=this.initDirectoryTree(),I=new S.QueryGlobTester(this.config,a),b=!I.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(d),l=_.StopWatch.create();const o=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,d.token),g=l.elapsed(),t=_.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(o&&o.forEach(u=>{const r=f.posix.relative(a.folder.path,u.path);if(b){const i=f.basename(u.path);this.matchFile(m,{base:a.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(D,a.folder,r,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(D,I,m),{providerTime:g,postProcessTime:t.elapsed()})}finally{d.dispose(),this.activeCancellationTokens.delete(d)}}getSearchOptionsForFolder(a){const m=(0,S.resolvePatternsForProvider)(this.config.includePattern,a.includePattern),d=(0,S.resolvePatternsForProvider)(this.config.excludePattern,a.excludePattern);return{folder:a.folder,excludes:d,includes:m,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}addDirectoryEntries({pathToEntries:a},m,d,v){if(d===this.filePattern){const I=f.basename(this.filePattern);this.matchFile(v,{base:m,relativePath:this.filePattern,basename:I})}function D(I){const b=f.basename(I),l=f.dirname(I);let o=a[l];o||(o=a[l]=[],D(l)),o.push({base:m,relativePath:I,basename:b})}D(d)}matchDirectoryTree({rootEntries:a,pathToEntries:m},d,v){const D=this,I=this.filePattern;function b(l){const o=y.hasSiblingFn(()=>l.map(g=>g.basename));for(let g=0,t=l.length;g<t;g++){const u=l[g],{relativePath:r,basename:i}=u;if(d.matchesExcludesSync(r,i,I!==i?o:void 0))continue;const s=m[r];if(s)b(s);else{if(r===I)continue;D.matchFile(v,u)}if(D.isLimitHit)break}}b(a)}matchFile(a,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||a(m))}}class n{constructor(){this.sessions=new Map}fileSearch(a,m,d,v){const D=this.getSessionTokenSource(a.cacheKey),I=new P(a,m,D&&D.token);let b=0;const l=o=>{b+=o.length,d(o.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(I,n.BATCH_SIZE,l,v).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:o.stats}}))}clearCache(a){const m=this.getSessionTokenSource(a);m&&m.cancel()}getSessionTokenSource(a){if(!!a)return this.sessions.has(a)||this.sessions.set(a,new F.CancellationTokenSource),this.sessions.get(a)}rawMatchToSearchItem(a){return a.relativePath?{resource:A.joinPath(a.base,a.relativePath)}:{resource:a.base}}doSearch(a,m,d,v){v.onCancellationRequested(()=>{a.cancel()});const D=b=>{b&&(I.push(b),m>0&&I.length>=m&&(d(I),I=[]))};let I=[];return a.search(D).then(b=>(I.length&&d(I),b),b=>(I.length&&d(I),Promise.reject(b)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(fe[135],me([0,1,16,21,62,30,10,8,23,12,2,31]),function(Y,e,f,F,C,y,A,_,S,P,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class a{constructor(l,o,g,t){this.query=l,this.provider=o,this.fileUtils=g,this.processType=t,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,o){const g=this.query.folderQueries||[],t=new F.CancellationTokenSource;return o.onCancellationRequested(()=>t.cancel()),new Promise((u,r)=>{this.collector=new d(l);let i=!1;const s=(c,h)=>{if(!i&&!this.isLimitHit){const w=this.resultSize(c);D(c)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const E=this.resultSize(c);this.resultCount+=E,(E>0||!D(c))&&this.collector.add(c,h)}};Promise.all(g.map((c,h)=>this.searchInFolder(c,w=>s(w,h),t.token))).then(c=>{t.dispose(),this.collector.flush();const h=c.some(w=>!!w&&!!w.limitHit);u({limitHit:this.isLimitHit||h,messages:(0,f.flatten)(c.map(w=>w?.message?(0,P.isArray)(w.message)?w.message:[w.message]:[])),stats:{type:this.processType}})},c=>{t.dispose();const h=(0,C.toErrorMessage)(c);r(new Error(h))})})}resultSize(l){return D(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,o){const g=Array.isArray(l.ranges)?l.ranges:[l.ranges],t=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:g.slice(0,o),preview:{matches:t.slice(0,o),text:l.preview.text},uri:l.uri}}async searchInFolder(l,o,g){const t=new k.QueryGlobTester(this.query,l),u=[],r={report:c=>{if(!this.validateProviderResult(c))return;const h=l.folder.scheme===A.Schemas.file?y.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(c.uri))):void 0,w=S.relativePath(l.folder,c.uri);if(w){const E=t.includedInQuery(w,_.basename(w),h);(0,P.isPromise)(E)?u.push(E.then(p=>{p&&o(c)})):E&&o(c)}}},i=this.getSearchOptionsForFolder(l),s=await this.provider.provideTextSearchResults(m(this.query.contentPattern),i,r,g);return u.length&&await Promise.all(u),s}validateProviderResult(l){if(D(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const o=(0,k.resolvePatternsForProvider)(this.query.includePattern,l.includePattern),g=(0,k.resolvePatternsForProvider)(this.query.excludePattern,l.excludePattern),t={folder:n.URI.from(l.folder),excludes:g,includes:o,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=a;function m(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class d{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new I(512,o=>this.sendItems(o))}add(l,o){this._currentFileMatch&&(this._currentFolderIdx!==o||!S.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=o,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(v(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=d;function v(b){return D(b)?{preview:{matches:(0,f.mapArrayOrNot)(b.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:b.preview.text},ranges:(0,f.mapArrayOrNot)(b.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function D(b){return!!b.preview}e.extensionResultIsMatch=D;class I{constructor(l,o){this.maxBatchSize=l,this.cb=o,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,o){!l||this.addItemToBatch(l,o)}addItems(l,o){!l||this.addItemsToBatch(l,o)}addItemToBatch(l,o){this.batch.push(l),this.batchSize+=o,this.onUpdate()}addItemsToBatch(l,o){this.batch=this.batch.concat(l),this.batchSize+=o,this.onUpdate()}onUpdate(){this.totalNumberCompleted<I.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},I.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=I,I.TIMEOUT=4e3,I.START_BATCH_AFTER_COUNT=50}),define(fe[74],me([0,1,6,5,4,275,14,66,13,2,135]),function(Y,e,f,F,C,y,A,_,S,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,C.createDecorator)("IExtHostSearch");let k=class{constructor(v,D,I){this.extHostRpc=v,this._uriTransformer=D,this._logService=I,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}registerTextSearchProvider(v,D){if(this._textSearchUsedSchemes.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this._textSearchUsedSchemes.add(v);const I=this._handlePool++;return this._textSearchProvider.set(I,D),this._proxy.$registerTextSearchProvider(I,this._transformScheme(v)),(0,f.toDisposable)(()=>{this._textSearchUsedSchemes.delete(v),this._textSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}registerFileSearchProvider(v,D){if(this._fileSearchUsedSchemes.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this._fileSearchUsedSchemes.add(v);const I=this._handlePool++;return this._fileSearchProvider.set(I,D),this._proxy.$registerFileSearchProvider(I,this._transformScheme(v)),(0,f.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(v),this._fileSearchProvider.delete(I),this._proxy.$unregisterProvider(I)})}$provideFileSearchResults(v,D,I,b){const l=a(I),o=this._fileSearchProvider.get(v);if(o)return this._fileSearchManager.fileSearch(l,o,g=>{this._proxy.$handleFileMatch(v,D,g.map(t=>t.resource))},b);throw new Error("unknown provider: "+v)}$clearCache(v){return this._fileSearchManager.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,D,I,b){const l=this._textSearchProvider.get(v);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const o=a(I);return this.createTextSearchManager(o,l).search(t=>this._proxy.$handleTextMatch(v,D,t),b)}$enableExtensionHostSearch(){}createTextSearchManager(v,D){return new n.TextSearchManager(v,D,{readdir:I=>Promise.resolve([]),toCanonicalName:I=>I},"textSearchProvider")}};k=je([He(0,A.IExtHostRpcService),He(1,_.IURITransformerService),He(2,S.ILogService)],k),e.ExtHostSearch=k;function a(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(m),extraFileResources:d.extraFileResources&&d.extraFileResources.map(v=>P.URI.revive(v))}}e.reviveQuery=a;function m(d){return{...d,folder:P.URI.revive(d.folder)}}}),define(fe[276],me([0,1,21,18,3,49,2,115,110,148,81,43,5,234,233,40,235,37,236,237,238,219,239,45,41,240,220,243,244,245,68,222,250,251,252,92,33,254,223,15,7,257,70,134,36,35,58,208,242,86,133,72,56,74,13,66,14,27,246,205,53,67,231,255,204,69,91,260,258,259,232,52,253,256,90,55,124,248,71,249,10,193,247,202,241]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D,I,b,l,o,g,t,u,r,i,s,c,h,w,E,p,T,L,M,R,$,z,O,V,N,U,x,B,H,G,K,X,de,be,Se,Ie,Oe,xe,ze,j,ee,re,le,Z,ae,pe,Me,qe,Qe,Je,rt,Ae,nt,J,te,ve,Xe,tt,ct,ut,_t,ce,Pe,We,Ye,$e,lt,Te,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ke(ne){const ue=ne.get(re.IExtHostInitDataService),Ee=ne.get(ve.IExtHostFileSystemInfo),we=ne.get(rt.IExtHostConsumerFileSystem),Fe=ne.get(r.IExtHostExtensionService),Ge=ne.get(H.IExtHostWorkspace),Ve=ne.get(_t.IExtHostTelemetry),et=ne.get(I.IExtHostConfiguration),ot=ne.get(j.IURITransformerService),Be=ne.get(ee.IExtHostRpcService),ge=ne.get(R.IExtHostStorage),_e=ne.get(Je.IExtensionStoragePaths),ie=ne.get(ze.ILogService),Q=ne.get(ae.IExtHostTunnelService),ye=ne.get(pe.IExtHostApiDeprecationService),Le=ne.get(B.IExtHostWindow),it=ne.get(ct.IExtHostSecretState),Ke=ne.get(ut.IExtHostEditorTabs);Be.set(a.ExtHostContext.ExtHostFileSystemInfo,Ee),Be.set(a.ExtHostContext.ExtHostLogService,ie),Be.set(a.ExtHostContext.ExtHostWorkspace,Ge),Be.set(a.ExtHostContext.ExtHostConfiguration,et),Be.set(a.ExtHostContext.ExtHostExtensionService,Fe),Be.set(a.ExtHostContext.ExtHostStorage,ge),Be.set(a.ExtHostContext.ExtHostTunnelService,Q),Be.set(a.ExtHostContext.ExtHostWindow,Le),Be.set(a.ExtHostContext.ExtHostSecretState,it),Be.set(a.ExtHostContext.ExtHostTelemetry,Ve),Be.set(a.ExtHostContext.ExtHostEditorTabs,Ke);const pt=Be.set(a.ExtHostContext.ExtHostDecorations,ne.get(Se.IExtHostDecorations)),bt=Be.set(a.ExtHostContext.ExtHostDocumentsAndEditors,ne.get(u.IExtHostDocumentsAndEditors)),ft=Be.set(a.ExtHostContext.ExtHostCommands,ne.get(v.IExtHostCommands)),wt=Be.set(a.ExtHostContext.ExtHostTerminalService,ne.get($.IExtHostTerminalService)),mt=Be.set(a.ExtHostContext.ExtHostDebugService,ne.get(Oe.IExtHostDebugService)),Et=Be.set(a.ExtHostContext.ExtHostSearch,ne.get(xe.IExtHostSearch)),Dt=Be.set(a.ExtHostContext.ExtHostTask,ne.get(Ie.IExtHostTask)),xt=Be.set(a.ExtHostContext.ExtHostOutputService,ne.get(E.IExtHostOutputService)),Vt=Be.set(a.ExtHostContext.ExtHostUrls,new U.ExtHostUrls(Be)),kt=Be.set(a.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(Be,bt)),$t=Be.set(a.ExtHostContext.ExtHostDocumentContentProviders,new o.ExtHostDocumentContentProvider(Be,bt,ie)),en=Be.set(a.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(ie,kt,Be.getProxy(a.MainContext.MainThreadBulkEdits))),St=Be.set(a.ExtHostContext.ExtHostNotebook,new le.ExtHostNotebookController(Be,ft,bt,kt,_e)),Qt=Be.set(a.ExtHostContext.ExtHostNotebookDocuments,new Te.ExtHostNotebookDocuments(ie,St)),jt=Be.set(a.ExtHostContext.ExtHostNotebookEditors,new lt.ExtHostNotebookEditors(ie,Be,St)),tn=Be.set(a.ExtHostContext.ExtHostNotebookKernels,new ce.ExtHostNotebookKernels(Be,ue,St,ft,ie)),nn=Be.set(a.ExtHostContext.ExtHostNotebookRenderers,new We.ExtHostNotebookRenderers(Be,St)),Tt=Be.set(a.ExtHostContext.ExtHostEditors,new z.ExtHostEditors(Be,bt)),Xt=Be.set(a.ExtHostContext.ExtHostTreeViews,new O.ExtHostTreeViews(Be.getProxy(a.MainContext.MainThreadTreeViews),ft,ie)),bn=Be.set(a.ExtHostContext.ExtHostEditorInsets,new X.ExtHostEditorInsets(Be.getProxy(a.MainContext.MainThreadEditorInsets),Tt,ue)),Wt=Be.set(a.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Be,ie,Ee)),Ht=Be.set(a.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(Be,kt,ft.converter,ot)),vt=Be.set(a.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Be,ot,kt,ft,Wt,ie,ye)),rn=Be.set(a.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Be,vt)),Ot=Be.set(a.ExtHostContext.ExtHostFileSystemEventService,new s.ExtHostFileSystemEventService(Be,ie,bt)),Nt=Be.set(a.ExtHostContext.ExtHostQuickOpen,(0,T.createExtHostQuickOpen)(Be,Ge,ft)),Yt=Be.set(a.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(Be,ft,ie)),En=Be.set(a.ExtHostContext.ExtHostComments,(0,D.createExtHostComments)(Be,ft,kt)),fn=Be.set(a.ExtHostContext.ExtHostProgress,new p.ExtHostProgress(Be.getProxy(a.MainContext.MainThreadProgress))),_n=Be.set(a.ExtHostContext.ExtHosLabelService,new de.ExtHostLabelService(Be)),mn=Be.set(a.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(Be)),sn=Be.set(a.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(Be)),on=Be.set(a.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(Be,ft)),qt=Be.set(a.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(Be,{remote:ue.remote},Ge,ie,ye)),an=Be.set(a.ExtHostContext.ExtHostWebviewPanels,new J.ExtHostWebviewPanels(Be,qt,Ge)),Sn=Be.set(a.ExtHostContext.ExtHostCustomEditors,new nt.ExtHostCustomEditors(Be,kt,_e,qt,an)),yn=Be.set(a.ExtHostContext.ExtHostWebviewViews,new Ae.ExtHostWebviewViews(Be,qt)),Gt=Be.set(a.ExtHostContext.ExtHostTesting,new Xe.ExtHostTesting(Be,ft)),Jt=Be.set(a.ExtHostContext.ExtHostUriOpeners,new tt.ExtHostUriOpeners(Be));Be.set(a.ExtHostContext.ExtHostInteractive,new De.ExtHostInteractive(Be,St,bt,ft));const Dn=(0,K.values)(a.ExtHostContext);Be.assertRegistered(Dn);const Cn=new te.ExtHostBulkEdits(Be,bt),ln=new d.ExtHostClipboard(Be),cn=new w.ExtHostMessageService(Be,ie),zt=new l.ExtHostDialogs(Be),Ft=new M.ExtHostStatusBar(Be,ft.converter);return m.ExtHostApiCommands.register(ft),function(Ue,Rt,Kt){const yt=function(){let se=!Ue.isUnderDevelopment;function he(Re){se||(ie.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Re(dt){if(Array.isArray(dt))dt.forEach(Re);else if(typeof dt=="string")he(dt);else{const Ct=dt;typeof Ct.scheme=="undefined"&&he(dt),!Ue.enableProposedApi&&typeof Ct.exclusive=="boolean"&&(0,G.throwProposedApiError)(Ue)}return dt}}(),kn={getSession(se,he,Re){return Re?.forceNewSession&&(0,G.checkProposedApiEnabled)(Ue),sn.getSession(Ue,se,he,Re)},get onDidChangeSessions(){return sn.onDidChangeSessions},registerAuthenticationProvider(se,he,Re,dt){return sn.registerAuthenticationProvider(se,he,Re,dt)}},In={registerCommand(se,he,Re){return ft.registerCommand(!0,se,he,Re)},registerTextEditorCommand(se,he,Re){return ft.registerCommand(!0,se,(...dt)=>{const Ct=Tt.getActiveTextEditor();if(!Ct){ie.warn("Cannot execute "+se+" because there is no active text editor.");return}return Ct.edit(Pt=>{he.apply(Re,[Ct,Pt,...dt])}).then(Pt=>{Pt||ie.warn("Edits from command "+se+" were not applied.")},Pt=>{ie.warn("An error occurred while running command "+se,Pt)})})},registerDiffInformationCommand:(se,he,Re)=>((0,G.checkProposedApiEnabled)(Ue),ft.registerCommand(!0,se,async(...dt)=>{const Ct=bt.activeEditor(!0);if(!Ct){ie.warn("Cannot execute "+se+" because there is no active text editor.");return}const Pt=await Tt.getDiffInformation(Ct.id);he.apply(Re,[Pt,...dt])})),executeCommand(se,...he){return ft.executeCommand(se,...he)},getCommands(se=!1){return ft.getCommands(se)}},gn={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return wt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ve.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ve.onDidChangeTelemetryEnabled},get isNewAppInstall(){const se=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(se)?!1:se<1e3*60*60*24},openExternal(se,he){return Le.openUri(se,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===ue.environment.appUriScheme)return Vt.createAppUri(se);try{return await Le.asExternalUri(se,{allowTunneling:!!ue.remote.authority})}catch(he){if((0,$e.matchesScheme)(se,Ye.Schemas.http)||(0,$e.matchesScheme)(se,Ye.Schemas.https))return se;throw he}},get remoteName(){return(0,be.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,G.checkProposedApiEnabled)(Ue),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=ue.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,Pn={createTestController(se,he){return Gt.createTestController(se,he)},createTestObserver(){return(0,G.checkProposedApiEnabled)(Ue),Gt.createTestObserver()},runTests(se){return(0,G.checkProposedApiEnabled)(Ue),Gt.runTests(se)},get onDidChangeTestResults(){return(0,G.checkProposedApiEnabled)(Ue),Gt.onResultsChanged},get testResults(){return(0,G.checkProposedApiEnabled)(Ue),Gt.results}},Tn={getExtension(se){const he=Rt.getExtensionDescription(se);if(he)return new r.Extension(Fe,Ue.identifier,he,pn)},get all(){return Rt.getAllExtensionDescriptions().map(se=>new r.Extension(Fe,Ue.identifier,se,pn))},get onDidChange(){return Rt.onDidChange}},un={createDiagnosticCollection(se){return Wt.createDiagnosticCollection(Ue.identifier,se)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:se=>Wt.getDiagnostics(se),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(se,he){return Ht.changeLanguage(se.uri,he)},match(se,he){return(0,n.score)(V.LanguageSelector.from(se),he.uri,he.languageId,!0)},registerCodeActionsProvider(se,he,Re){return vt.registerCodeActionProvider(Ue,yt(se),he,Re)},registerCodeLensProvider(se,he){return vt.registerCodeLensProvider(Ue,yt(se),he)},registerDefinitionProvider(se,he){return vt.registerDefinitionProvider(Ue,yt(se),he)},registerDeclarationProvider(se,he){return vt.registerDeclarationProvider(Ue,yt(se),he)},registerImplementationProvider(se,he){return vt.registerImplementationProvider(Ue,yt(se),he)},registerTypeDefinitionProvider(se,he){return vt.registerTypeDefinitionProvider(Ue,yt(se),he)},registerHoverProvider(se,he){return vt.registerHoverProvider(Ue,yt(se),he,Ue.identifier)},registerEvaluatableExpressionProvider(se,he){return vt.registerEvaluatableExpressionProvider(Ue,yt(se),he,Ue.identifier)},registerInlineValuesProvider(se,he){return vt.registerInlineValuesProvider(Ue,yt(se),he,Ue.identifier)},registerDocumentHighlightProvider(se,he){return vt.registerDocumentHighlightProvider(Ue,yt(se),he)},registerLinkedEditingRangeProvider(se,he){return vt.registerLinkedEditingRangeProvider(Ue,yt(se),he)},registerReferenceProvider(se,he){return vt.registerReferenceProvider(Ue,yt(se),he)},registerRenameProvider(se,he){return vt.registerRenameProvider(Ue,yt(se),he)},registerDocumentSymbolProvider(se,he,Re){return vt.registerDocumentSymbolProvider(Ue,yt(se),he,Re)},registerWorkspaceSymbolProvider(se){return vt.registerWorkspaceSymbolProvider(Ue,se)},registerDocumentFormattingEditProvider(se,he){return vt.registerDocumentFormattingEditProvider(Ue,yt(se),he)},registerDocumentRangeFormattingEditProvider(se,he){return vt.registerDocumentRangeFormattingEditProvider(Ue,yt(se),he)},registerOnTypeFormattingEditProvider(se,he,Re,...dt){return vt.registerOnTypeFormattingEditProvider(Ue,yt(se),he,[Re].concat(dt))},registerDocumentSemanticTokensProvider(se,he,Re){return vt.registerDocumentSemanticTokensProvider(Ue,yt(se),he,Re)},registerDocumentRangeSemanticTokensProvider(se,he,Re){return vt.registerDocumentRangeSemanticTokensProvider(Ue,yt(se),he,Re)},registerSignatureHelpProvider(se,he,Re,...dt){return typeof Re=="object"?vt.registerSignatureHelpProvider(Ue,yt(se),he,Re):vt.registerSignatureHelpProvider(Ue,yt(se),he,typeof Re=="undefined"?[]:[Re,...dt])},registerCompletionItemProvider(se,he,...Re){return vt.registerCompletionItemProvider(Ue,yt(se),he,Re)},registerInlineCompletionItemProvider(se,he){return(0,G.checkProposedApiEnabled)(Ue),vt.registerInlineCompletionsProvider(Ue,yt(se),he)},registerDocumentLinkProvider(se,he){return vt.registerDocumentLinkProvider(Ue,yt(se),he)},registerColorProvider(se,he){return vt.registerColorProvider(Ue,yt(se),he)},registerFoldingRangeProvider(se,he){return vt.registerFoldingRangeProvider(Ue,yt(se),he)},registerSelectionRangeProvider(se,he){return vt.registerSelectionRangeProvider(Ue,se,he)},registerCallHierarchyProvider(se,he){return vt.registerCallHierarchyProvider(Ue,se,he)},registerTypeHierarchyProvider(se,he){return vt.registerTypeHierarchyProvider(Ue,se,he)},setLanguageConfiguration:(se,he)=>vt.setLanguageConfiguration(Ue,se,he),getTokenInformationAtPosition(se,he){return(0,G.checkProposedApiEnabled)(Ue),Ht.tokenAtPosition(se,he)},registerInlayHintsProvider(se,he){return(0,G.checkProposedApiEnabled)(Ue),vt.registerInlayHintsProvider(Ue,se,he)},createLanguageStatusItem(se,he){return(0,G.checkProposedApiEnabled)(Ue),Ht.createLanguageStatusItem(Ue,se,he)}},An={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return wt.activeTerminal},get terminals(){return wt.terminals},async showTextDocument(se,he,Re){const dt=await(A.URI.isUri(se)?Promise.resolve(vn.openTextDocument(se)):Promise.resolve(se));return Tt.showTextDocument(dt,he,Re)},createTextEditorDecorationType(se){return Tt.createTextEditorDecorationType(Ue,se)},onDidChangeActiveTextEditor(se,he,Re){return Tt.onDidChangeActiveTextEditor(se,he,Re)},onDidChangeVisibleTextEditors(se,he,Re){return Tt.onDidChangeVisibleTextEditors(se,he,Re)},onDidChangeTextEditorSelection(se,he,Re){return Tt.onDidChangeTextEditorSelection(se,he,Re)},onDidChangeTextEditorOptions(se,he,Re){return Tt.onDidChangeTextEditorOptions(se,he,Re)},onDidChangeTextEditorVisibleRanges(se,he,Re){return Tt.onDidChangeTextEditorVisibleRanges(se,he,Re)},onDidChangeTextEditorViewColumn(se,he,Re){return Tt.onDidChangeTextEditorViewColumn(se,he,Re)},onDidCloseTerminal(se,he,Re){return wt.onDidCloseTerminal(se,he,Re)},onDidOpenTerminal(se,he,Re){return wt.onDidOpenTerminal(se,he,Re)},onDidChangeActiveTerminal(se,he,Re){return wt.onDidChangeActiveTerminal(se,he,Re)},onDidChangeTerminalDimensions(se,he,Re){return(0,G.checkProposedApiEnabled)(Ue),wt.onDidChangeTerminalDimensions(se,he,Re)},onDidChangeTerminalState(se,he,Re){return wt.onDidChangeTerminalState(se,he,Re)},onDidWriteTerminalData(se,he,Re){return(0,G.checkProposedApiEnabled)(Ue),wt.onDidWriteTerminalData(se,he,Re)},get state(){return Le.state},onDidChangeWindowState(se,he,Re){return Le.onDidChangeWindowState(se,he,Re)},showInformationMessage(se,...he){return cn.showMessage(Ue,y.default.Info,se,he[0],he.slice(1))},showWarningMessage(se,...he){return cn.showMessage(Ue,y.default.Warning,se,he[0],he.slice(1))},showErrorMessage(se,...he){return cn.showMessage(Ue,y.default.Error,se,he[0],he.slice(1))},showQuickPick(se,he,Re){return Nt.showQuickPick(se,!!Ue.enableProposedApi,he,Re)},showWorkspaceFolderPick(se){return Nt.showWorkspaceFolderPick(se)},showInputBox(se,he){return Nt.showInput(se,he)},showOpenDialog(se){return zt.showOpenDialog(se)},showSaveDialog(se){return zt.showSaveDialog(se)},createStatusBarItem(se,he,Re){let dt,Ct,Pt;return typeof se=="string"?(dt=se,Ct=he,Pt=Re):(Ct=se,Pt=he),Ft.createStatusBarEntry(Ue,dt,Ct,Pt)},setStatusBarMessage(se,he){return Ft.setStatusBarMessage(se,he)},withScmProgress(se){return ye.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),fn.withProgress(Ue,{location:N.ProgressLocation.SourceControl},(he,Re)=>se({report(dt){}}))},withProgress(se,he){return fn.withProgress(Ue,se,he)},createOutputChannel(se){return xt.createOutputChannel(se,Ue)},createWebviewPanel(se,he,Re,dt){return an.createWebviewPanel(Ue,se,he,Re,dt)},createWebviewTextEditorInset(se,he,Re,dt){return(0,G.checkProposedApiEnabled)(Ue),bn.createWebviewEditorInset(se,he,Re,dt,Ue)},createTerminal(se,he,Re){return typeof se=="object"?("location"in se&&(0,G.checkProposedApiEnabled)(Ue),"pty"in se?wt.createExtensionTerminal(se):wt.createTerminalFromOptions(se)):wt.createTerminal(se,he,Re)},registerTerminalLinkProvider(se){return wt.registerLinkProvider(se)},registerTerminalProfileProvider(se,he){return wt.registerProfileProvider(Ue,se,he)},registerTreeDataProvider(se,he){return Xt.registerTreeDataProvider(se,he,Ue)},createTreeView(se,he){return Xt.createTreeView(se,he,Ue)},registerWebviewPanelSerializer:(se,he)=>an.registerWebviewPanelSerializer(Ue,se,he),registerCustomEditorProvider:(se,he,Re={})=>Sn.registerCustomEditorProvider(Ue,se,he,Re),registerFileDecorationProvider(se){return pt.registerFileDecorationProvider(se,Ue.identifier)},registerUriHandler(se){return Vt.registerUriHandler(Ue.identifier,se)},createQuickPick(){return Nt.createQuickPick(Ue.identifier,!!Ue.enableProposedApi)},createInputBox(){return Nt.createInputBox(Ue.identifier)},get activeColorTheme(){return mn.activeColorTheme},onDidChangeActiveColorTheme(se,he,Re){return mn.onDidChangeActiveColorTheme(se,he,Re)},registerWebviewViewProvider(se,he,Re){return yn.registerWebviewViewProvider(Ue,se,he,Re?.webviewOptions)},get activeNotebookEditor(){return(0,G.checkProposedApiEnabled)(Ue),St.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,he,Re){return(0,G.checkProposedApiEnabled)(Ue),St.onDidChangeActiveNotebookEditor(se,he,Re)},get visibleNotebookEditors(){return(0,G.checkProposedApiEnabled)(Ue),St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,G.checkProposedApiEnabled)(Ue),St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,he,Re){return(0,G.checkProposedApiEnabled)(Ue),jt.onDidChangeNotebookEditorSelection(se,he,Re)},onDidChangeNotebookEditorVisibleRanges(se,he,Re){return(0,G.checkProposedApiEnabled)(Ue),jt.onDidChangeNotebookEditorVisibleRanges(se,he,Re)},showNotebookDocument(se,he){return(0,G.checkProposedApiEnabled)(Ue),St.showNotebookDocument(se,he)},registerExternalUriOpener(se,he,Re){return(0,G.checkProposedApiEnabled)(Ue),Jt.registerExternalUriOpener(Ue.identifier,se,he,Re)},get tabs(){return(0,G.checkProposedApiEnabled)(Ue),Ke.tabs},get activeTab(){return(0,G.checkProposedApiEnabled)(Ue),Ke.activeTab},get onDidChangeTabs(){return(0,G.checkProposedApiEnabled)(Ue),Ke.onDidChangeTabs},get onDidChangeActiveTab(){return(0,G.checkProposedApiEnabled)(Ue),Ke.onDidChangeActiveTab},getInlineCompletionItemController(se){return(0,G.checkProposedApiEnabled)(Ue),c.InlineCompletionController.get(se)}},vn={get rootPath(){return ye.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ge.getPath()},set rootPath(se){throw F.readonly()},getWorkspaceFolder(se){return Ge.getWorkspaceFolder(se)},get workspaceFolders(){return Ge.getWorkspaceFolders()},get name(){return Ge.name},set name(se){throw F.readonly()},get workspaceFile(){return Ge.workspaceFile},set workspaceFile(se){throw F.readonly()},updateWorkspaceFolders:(se,he,...Re)=>Ge.updateWorkspaceFolders(Ue,se,he||0,...Re),onDidChangeWorkspaceFolders:function(se,he,Re){return Ge.onDidChangeWorkspace(se,he,Re)},asRelativePath:(se,he)=>Ge.getRelativePath(se,he),findFiles:(se,he,Re,dt)=>Ge.findFiles(V.GlobPattern.from(se),V.GlobPattern.from(he),Re,Ue.identifier,dt),findTextInFiles:(se,he,Re,dt)=>{let Ct,Pt;return typeof he=="object"?(Ct=he,Pt=Re):(Ct={},Pt=he,dt=Re),Ge.findTextInFiles(se,Ct||{},Pt,Ue.identifier,dt)},saveAll:se=>Ge.saveAll(se),applyEdit(se){return Cn.applyWorkspaceEdit(se)},createFileSystemWatcher:(se,he,Re,dt)=>Ot.createFileSystemWatcher(V.GlobPattern.from(se),he,Re,dt),get textDocuments(){return kt.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw F.readonly()},openTextDocument(se){let he;const Re=se;if(typeof se=="string")he=Promise.resolve(A.URI.file(se));else if(A.URI.isUri(se))he=Promise.resolve(se);else if(!Re||typeof Re=="object")he=kt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(dt=>kt.ensureDocumentData(dt).then(Ct=>Ct.document))},onDidOpenTextDocument:(se,he,Re)=>kt.onDidAddDocument(se,he,Re),onDidCloseTextDocument:(se,he,Re)=>kt.onDidRemoveDocument(se,he,Re),onDidChangeTextDocument:(se,he,Re)=>kt.onDidChangeDocument(se,he,Re),onDidSaveTextDocument:(se,he,Re)=>kt.onDidSaveDocument(se,he,Re),onWillSaveTextDocument:(se,he,Re)=>en.getOnWillSaveTextDocumentEvent(Ue)(se,he,Re),get notebookDocuments(){return St.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,he){let Re;if(A.URI.isUri(se))Re=se,await St.openNotebookDocument(se);else if(typeof se=="string")Re=A.URI.revive(await St.createNotebookDocument({viewType:se,content:he}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Re).apiNotebook},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(se,he,Re,dt){return St.registerNotebookSerializer(Ue,se,he,Re,Ue.enableProposedApi?dt:void 0)},registerNotebookContentProvider:(se,he,Re,dt)=>((0,G.checkProposedApiEnabled)(Ue),St.registerNotebookContentProvider(Ue,se,he,Re,Ue.enableProposedApi?dt:void 0)),onDidChangeConfiguration:(se,he,Re)=>Kt.onDidChangeConfiguration(se,he,Re),getConfiguration(se,he){return he=arguments.length===1?void 0:he,Kt.getConfiguration(se,he,Ue)},registerTextDocumentContentProvider(se,he){return $t.registerTextDocumentContentProvider(se,he)},registerTaskProvider:(se,he)=>(ye.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Dt.registerTaskProvider(Ue,se,he)),registerFileSystemProvider(se,he,Re){return rn.registerFileSystemProvider(Ue.identifier,se,he,Re)},get fs(){return we.value},registerFileSearchProvider:(se,he)=>((0,G.checkProposedApiEnabled)(Ue),Et.registerFileSearchProvider(se,he)),registerTextSearchProvider:(se,he)=>((0,G.checkProposedApiEnabled)(Ue),Et.registerTextSearchProvider(se,he)),registerRemoteAuthorityResolver:(se,he)=>((0,G.checkProposedApiEnabled)(Ue),Fe.registerRemoteAuthorityResolver(se,he)),registerResourceLabelFormatter:se=>((0,G.checkProposedApiEnabled)(Ue),_n.$registerResourceLabelFormatter(se)),onDidCreateFiles:(se,he,Re)=>Ot.onDidCreateFile(se,he,Re),onDidDeleteFiles:(se,he,Re)=>Ot.onDidDeleteFile(se,he,Re),onDidRenameFiles:(se,he,Re)=>Ot.onDidRenameFile(se,he,Re),onWillCreateFiles:(se,he,Re)=>Ot.getOnWillCreateFileEvent(Ue)(se,he,Re),onWillDeleteFiles:(se,he,Re)=>Ot.getOnWillDeleteFileEvent(Ue)(se,he,Re),onWillRenameFiles:(se,he,Re)=>Ot.getOnWillRenameFileEvent(Ue)(se,he,Re),openTunnel:se=>((0,G.checkProposedApiEnabled)(Ue),Q.openTunnel(Ue,se).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,G.checkProposedApiEnabled)(Ue),Q.getTunnels()},onDidChangeTunnels:(se,he,Re)=>((0,G.checkProposedApiEnabled)(Ue),Q.onDidChangeTunnels(se,he,Re)),registerPortAttributesProvider:(se,he)=>((0,G.checkProposedApiEnabled)(Ue),Q.registerPortsAttributesProvider(se,he)),registerTimelineProvider:(se,he)=>((0,G.checkProposedApiEnabled)(Ue),on.registerTimelineProvider(se,he,Ue.identifier,ft.converter)),get isTrusted(){return Ge.trusted},requestWorkspaceTrust:se=>((0,G.checkProposedApiEnabled)(Ue),Ge.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,he,Re)=>Ge.onDidGrantWorkspaceTrust(se,he,Re)},Rn={get inputBox(){return ye.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Yt.getLastInputBox(Ue)},createSourceControl(se,he,Re){return Yt.createSourceControl(Ue,se,he,Re)}},Ln={createCommentController(se,he){return En.createCommentController(Ue,se,he)}},Fn={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(se,he,Re){return mt.onDidStartDebugSession(se,he,Re)},onDidTerminateDebugSession(se,he,Re){return mt.onDidTerminateDebugSession(se,he,Re)},onDidChangeActiveDebugSession(se,he,Re){return mt.onDidChangeActiveDebugSession(se,he,Re)},onDidReceiveDebugSessionCustomEvent(se,he,Re){return mt.onDidReceiveDebugSessionCustomEvent(se,he,Re)},onDidChangeBreakpoints(se,he,Re){return mt.onDidChangeBreakpoints(se,he,Re)},registerDebugConfigurationProvider(se,he,Re){return mt.registerDebugConfigurationProvider(se,he,Re||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,he){return mt.registerDebugAdapterDescriptorFactory(Ue,se,he)},registerDebugAdapterTrackerFactory(se,he){return mt.registerDebugAdapterTrackerFactory(se,he)},startDebugging(se,he,Re){return!Re||typeof Re=="object"&&"configuration"in Re?mt.startDebugging(se,he,{parentSession:Re}):mt.startDebugging(se,he,Re||{})},stopDebugging(se){return mt.stopDebugging(se)},addBreakpoints(se){return mt.addBreakpoints(se)},removeBreakpoints(se){return mt.removeBreakpoints(se)},asDebugSourceUri(se,he){return mt.asDebugSourceUri(se,he)}},Mn={registerTaskProvider:(se,he)=>Dt.registerTaskProvider(Ue,se,he),fetchTasks:se=>Dt.fetchTasks(se),executeTask:se=>Dt.executeTask(Ue,se),get taskExecutions(){return Dt.taskExecutions},onDidStartTask:(se,he,Re)=>Dt.onDidStartTask(se,he,Re),onDidEndTask:(se,he,Re)=>Dt.onDidEndTask(se,he,Re),onDidStartTaskProcess:(se,he,Re)=>Dt.onDidStartTaskProcess(se,he,Re),onDidEndTaskProcess:(se,he,Re)=>Dt.onDidEndTaskProcess(se,he,Re)},On={createNotebookController(se,he,Re,dt,Ct){return tn.createNotebookController(Ue,se,he,Re,dt,Ue.enableProposedApi?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(se,he)=>St.registerNotebookCellStatusBarItemProvider(Ue,se,he),get onDidSaveNotebookDocument(){return(0,G.checkProposedApiEnabled)(Ue),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(se){return(0,G.checkProposedApiEnabled)(Ue),jt.createNotebookEditorDecorationType(se)},createRendererMessaging(se){return nn.createRendererMessaging(Ue,se)},onDidChangeNotebookDocumentMetadata(se,he,Re){return(0,G.checkProposedApiEnabled)(Ue),Qt.onDidChangeNotebookDocumentMetadata(se,he,Re)},onDidChangeNotebookCells(se,he,Re){return(0,G.checkProposedApiEnabled)(Ue),St.onDidChangeNotebookCells(se,he,Re)},onDidChangeNotebookCellExecutionState(se,he,Re){return(0,G.checkProposedApiEnabled)(Ue),St.onDidChangeNotebookCellExecutionState(se,he,Re)},onDidChangeCellOutputs(se,he,Re){return(0,G.checkProposedApiEnabled)(Ue),St.onDidChangeCellOutputs(se,he,Re)},onDidChangeCellMetadata(se,he,Re){return(0,G.checkProposedApiEnabled)(Ue),St.onDidChangeCellMetadata(se,he,Re)},createConcatTextDocument(se,he){return(0,G.checkProposedApiEnabled)(Ue),new Qe.ExtHostNotebookConcatDocument(St,kt,se,he)}};return{version:ue.version,authentication:kn,commands:In,comments:Ln,debug:Fn,env:gn,extensions:Tn,languages:un,notebooks:On,scm:Rn,tasks:Mn,tests:Pn,window:An,workspace:vn,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:f.CancellationTokenSource,CandidatePortSource:a.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionList:N.InlineSuggestions,Hover:N.Hover,IndentAction:P.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:_.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:a.UIKind,Uri:A.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:Pe.TextSearchCompleteMessageType,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=ke}),define(fe[277],me([0,1,82,68,36,133,37,40,45,33,72,56,74,92,53,67,134,91,52,90,124,55]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D,I,b,l,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,f.registerSingleton)(_.IExtHostCommands,_.ExtHostCommands),(0,f.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration),(0,f.registerSingleton)(I.IExtHostConsumerFileSystem,I.ExtHostConsumerFileSystem),(0,f.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,f.registerSingleton)(y.IExtHostDecorations,y.ExtHostDecorations),(0,f.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,f.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,f.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService),(0,f.registerSingleton)(a.IExtHostSearch,a.ExtHostSearch),(0,f.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,f.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,f.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,f.registerSingleton)(d.IExtHostTunnelService,d.ExtHostTunnelService),(0,f.registerSingleton)(D.IExtHostWindow,D.ExtHostWindow),(0,f.registerSingleton)(C.IExtHostWorkspace,C.ExtHostWorkspace),(0,f.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,f.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry),(0,f.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs)}),define(fe[93],me([0,1,16,13,31,71]),function(Y,e,f,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=A;function _(k,a,m,d){const v=(0,f.mapArrayOrNot)(m,S),D=new C.TextSearchMatch(a,v,d),I=D.preview.matches;return{ranges:(0,f.mapArrayOrNot)(v,P),uri:k,preview:{text:D.preview.text,matches:(0,f.mapArrayOrNot)(I,P)}}}e.createTextSearchResult=_;function S(k){return new C.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function P(k){return new y.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let n=class{constructor(a,m){this.prefix=a,this.logService=m}appendLine(a){this.logService.debug(`${this.prefix}#search`,a)}};n=je([He(1,F.ILogService)],n),e.OutputChannel=n}),define(fe[278],me([0,1,97,22]),function(Y,e,f,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(u=>u===t)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const y=512,A=512,_=512*8,S=512*128;class P{constructor(u){this.iconvLiteDecoder=u}static async create(u){let r;if(u!==e.UTF8)r=(await new Promise((s,c)=>{Y(["iconv-lite-umd"],s,c)})).getDecoder(m(u));else{const i=new TextDecoder;r={write(s){return i.decode(s,{stream:!0})},end(){return i.decode()}}}return new P(r)}write(u){return this.iconvLiteDecoder.write(u)}end(){return this.iconvLiteDecoder.end()}}function n(t,u){const r=u.minBytesRequiredForDetection??u.guessEncoding?_:A;return new Promise((i,s)=>{const c=(0,f.newWriteableStream)(T=>T.join("")),h=[];let w=0,E;const p=async()=>{try{const T=await g({buffer:F.VSBuffer.concat(h),bytesRead:w},u.guessEncoding);T.encoding=await u.overwriteEncoding(T.encoding),E=await P.create(T.encoding);const L=E.write(F.VSBuffer.concat(h).buffer);c.write(L),h.length=0,w=0,i({stream:c,detected:T})}catch(T){s(T)}};(0,f.listenStream)(t,{onData:async T=>{E?c.write(E.write(T.buffer)):(h.push(T),w+=T.byteLength,w>=r&&(t.pause(),await p(),setTimeout(()=>t.resume())))},onError:T=>c.error(T),onEnd:async()=>{E||await p(),c.end(E?.end())}})})}e.toDecodeStream=n;async function k(t,u,r){const s=(await new Promise((w,E)=>{Y(["iconv-lite-umd"],w,E)})).getEncoder(m(u),r);let c=!1,h=!1;return{read(){if(h)return null;const w=t.read();if(typeof w!="string"){if(h=!0,!c&&r?.addBOM)switch(u){case e.UTF8:case e.UTF8_with_bom:return F.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return F.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return F.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const E=s.end();return E&&E.length>0?(c=!0,F.VSBuffer.wrap(E)):null}return c=!0,F.VSBuffer.wrap(s.write(w))}}}e.toEncodeReadable=k;async function a(t){return(await new Promise((r,i)=>{Y(["iconv-lite-umd"],r,i)})).encodingExists(m(t))}e.encodingExists=a;function m(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=m;function d(t,u){if(!t||u<e.UTF16be_BOM.length)return null;const r=t.readUInt8(0),i=t.readUInt8(1);if(r===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(u<e.UTF8_BOM.length)return null;const s=t.readUInt8(2);return r===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&s===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=d;const v=["ascii","utf-16","utf-32"];async function D(t){const u=await new Promise((h,w)=>{Y(["jschardet"],h,w)}),r=t.slice(0,S),i=l(r.buffer),s=u.detect(i);if(!s||!s.encoding)return null;const c=s.encoding.toLowerCase();return 0<=v.indexOf(c)?null:b(s.encoding)}const I={ibm866:"cp866",big5:"cp950"};function b(t){const u=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return I[u]||u}function l(t){let u="";for(let r=0;r<t.length;r++)u+=String.fromCharCode(t[r]);return u}function o(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const u=t.match(/windows(\d+)/);return u?"windows-"+u[1]:t}}e.toCanonicalName=o;function g({buffer:t,bytesRead:u},r){let i=d(t,u),s=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let c=!0,h=!0,w=!1;for(let E=0;E<u&&E<y;E++){const p=E%2==1,T=t.readUInt8(E)===0;if(T&&(w=!0),c&&(p&&!T||!p&&T)&&(c=!1),h&&(p&&T||!p&&!T)&&(h=!1),T&&!c&&!h)break}w&&(c?i=e.UTF16le:h?i=e.UTF16be:s=!0)}return r&&!s&&!i&&t?D(t.slice(0,u)).then(c=>({seemsBinary:!1,encoding:c})):{seemsBinary:s,encoding:i}}e.detectEncodingFromBuffer=g,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(fe[136],me([0,1,278,28,135]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class y extends C.TextSearchManager{constructor(_,S,P=F,n="searchProcess"){super(_,S,{readdir:k=>P.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,f.toCanonicalName)(k)},n)}}e.NativeTextSearchManager=y}),define(fe[279],me([0,1,280,295,296,2,297]),function(Y,e,f,F,C,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function _(k,a,m,d,v,D){const I=D.environment.useHostProxy,b=typeof I=="boolean"?I:!D.remote.isRemote,l=(0,A.createProxyResolver)({resolveProxy:g=>k.resolveProxy(g),getHttpProxySetting:()=>a.getConfiguration("http").get("proxy"),log:(g,t,...u)=>{switch(g){case A.LogLevel.Trace:d.trace(t,...u);break;case A.LogLevel.Debug:d.debug(t,...u);break;case A.LogLevel.Info:d.info(t,...u);break;case A.LogLevel.Warning:d.warn(t,...u);break;case A.LogLevel.Error:d.error(t,...u);break;case A.LogLevel.Critical:d.critical(t,...u);break;case A.LogLevel.Off:break;default:r(g,t,u);break}function r(i,s,...c){d.error("Unknown log level",i),d.error(s,...c)}},getLogLevel:()=>d.getLevel(),proxyResolveTelemetry:g=>{v.$publicLog2("resolveProxy",g)},useHostProxy:b,env:process.env}),o=S(a,l);return n(m,o)}e.connectProxyResolver=_;function S(k,a){const m={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(v=>{m.config=k.getConfiguration("http").get("proxySupport")||"off"});const d={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(v=>{d.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},f,(0,A.createHttpPatch)(f,a,{config:"off"},d,!0)),on:Object.assign({},f,(0,A.createHttpPatch)(f,a,{config:"on"},d,!0)),override:Object.assign({},f,(0,A.createHttpPatch)(f,a,{config:"override"},d,!0)),onRequest:Object.assign({},f,(0,A.createHttpPatch)(f,a,m,d,!0)),default:Object.assign(f,(0,A.createHttpPatch)(f,a,m,d,!1))},https:{off:Object.assign({},F,(0,A.createHttpPatch)(F,a,{config:"off"},d,!0)),on:Object.assign({},F,(0,A.createHttpPatch)(F,a,{config:"on"},d,!0)),override:Object.assign({},F,(0,A.createHttpPatch)(F,a,{config:"override"},d,!0)),onRequest:Object.assign({},F,(0,A.createHttpPatch)(F,a,m,d,!0)),default:Object.assign(F,(0,A.createHttpPatch)(F,a,m,d,!1))},tls:Object.assign(C,(0,A.createTlsPatch)(C))}}const P=new Map;function n(k,a){return k.getExtensionPathIndex().then(m=>{const d=Y.__$__nodeRequire("module"),v=d._load;d._load=function(I,b,l){if(I==="tls")return a.tls;if(I!=="http"&&I!=="https")return v.apply(this,arguments);const o=a[I],g=m.findSubstr(y.URI.file(b.filename).fsPath);let t=P.get(g);if(t||P.set(g,t={}),!t[I]){let u=o.default;g&&g.enableProposedApi&&(u=o[g.proxySupport]||o.onRequest),t[I]={...u}}return t[I]}})}}),define(fe[281],me([0,1,39,8,78,29,11,9,93,282]),function(Y,e,f,F,C,y,A,_,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const n=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(l,o,g,t){const u=a(l,o,g,t),r=o.folder.fsPath;return{cmd:f.spawn(n,u.args,{cwd:r}),rgDiskPath:n,siblingClauses:u.siblingClauses,rgArgs:u,cwd:r}}e.spawnRipgrepCmd=k;function a(l,o,g,t){const u=["--files","--hidden","--case-sensitive"];d([o],g,!1).forEach(i=>{const s=(0,S.anchorGlob)(i);if(u.push("-g",s),A.isMacintosh){const c=(0,C.normalizeNFD)(s);c!==s&&u.push("-g",c)}});const r=m([o],t,void 0,!1);return r.globArgs.forEach(i=>{const s=`!${(0,S.anchorGlob)(i)}`;if(u.push("-g",s),A.isMacintosh){const c=(0,C.normalizeNFD)(s);c!==s&&u.push("-g",c)}}),o.disregardIgnoreFiles!==!1?u.push("--no-ignore"):u.push("--no-ignore-parent"),o.ignoreSymlinks||u.push("--follow"),l.exists&&u.push("--quiet"),u.push("--no-config"),o.disregardGlobalIgnoreFiles&&u.push("--no-ignore-global"),{args:u,siblingClauses:r.siblingClauses}}function m(l,o,g,t=!0){const u=[];let r={};return l.forEach(i=>{const s=Object.assign({},i.excludePattern||{},o||{}),c=v(s,t?i.folder.fsPath:void 0,g);u.push(...c.globArgs),c.siblingClauses&&(r=Object.assign(r,c.siblingClauses))}),{globArgs:u,siblingClauses:r}}e.foldersToRgExcludeGlobs=m;function d(l,o,g=!0){const t=[];return l.forEach(u=>{const r=Object.assign({},o||{},u.includePattern||{}),i=v(r,g?u.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=d;function v(l,o,g){const t=[],u={};return Object.keys(l).forEach(r=>{if(g&&g.has(r)||!r)return;const i=l[r];r=I(o?D(o,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof i=="boolean"&&i?(r.startsWith("\\\\")&&(r+="**"),t.push(b(r))):i&&i.when&&(u[r]=i)}),{globArgs:t,siblingClauses:u}}function D(l,o){return F.isAbsolute(o)?o:F.join(l,o)}e.getAbsoluteGlob=D;function I(l){return l=_.rtrim(l,"\\"),_.rtrim(l,"/")}function b(l){return y.getRoot(l).toLowerCase()==="c:/"?l.replace(/^c:[/\\]/i,"/"):l}e.fixDriveC=b}),define(fe[283],me([0,1,39,50,8,105,16,62,30,78,29,11,46,9,12,28,31,281,102]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const l=new Set;process.on("exit",()=>{l.forEach(r=>r())});class o{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&S.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&S.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(s=>{const c=Object.assign({},s.excludePattern||{},this.config.excludePattern||{}),h=s.folder.fsPath;i.folderQueries.map(w=>w.folder.fsPath).filter(w=>w!==h).forEach(w=>{(0,n.isEqualOrParent)(w,h)&&(c[C.relative(h,w)]=!0)}),this.folderExcludePatterns.set(h,new t(c,h))})}cancel(){this.isCanceled=!0}walk(i,s,c,h,w){if(this.fileWalkSW=a.StopWatch.create(!1),this.isCanceled)return w(null,this.isLimitHit);s.forEach(E=>{const p=C.basename(E.fsPath);this.globalExcludePattern&&this.globalExcludePattern(E.fsPath,p)||this.matchFile(c,{relativePath:E.fsPath,searchPath:void 0})}),this.cmdSW=a.StopWatch.create(!1),this.parallel(i,(E,p)=>{this.call(this.cmdTraversal,this,E,c,h,T=>{if(T){const L=(0,_.toErrorMessage)(T);console.error(L),this.errors.push(L),p(T,void 0)}else p(null,void 0)})},(E,p)=>{this.fileWalkSW.stop();const T=E?A.coalesce(E)[0]:null;w(T,this.isLimitHit)})}parallel(i,s,c){const h=new Array(i.length),w=new Array(i.length);let E=!1,p=0;if(i.length===0)return c(null,[]);i.forEach((T,L)=>{s(T,(M,R)=>{if(M?(E=!0,h[L]=null,w[L]=M):(h[L]=R,w[L]=null),++p===i.length)return c(E?w:null,h)})})}call(i,s,...c){try{i.apply(s,c)}catch(h){c[c.length-1](h)}}cmdTraversal(i,s,c,h){const w=i.folder.fsPath,E=k.isMacintosh;let p;const T=()=>p&&p.kill();l.add(T);let L=N=>{l.delete(T),L=()=>{},h(N)},M="";const R=this.initDirectoryTree();let $;const z=(0,I.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);p=z.cmd,$=!Object.keys(z.siblingClauses).length;const O=z.rgArgs.args.map(N=>N.match(/^-/)?N:`'${N}'`).join(" ");let V=`${z.rgDiskPath} ${O}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(V+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),c({message:V}),this.cmdResultCount=0,this.collectStdout(p,"utf8",c,(N,U,x)=>{if(N){L(N);return}if(this.isLimitHit){L();return}const H=(M+(E?P.normalizeNFC(U||""):U)).split(`
`);if(x){const G=H.length;H[G-1]=H[G-1].trim(),H[G-1]||H.pop()}else M=H.pop()||"";if(H.length&&H[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=H.length,$){for(const G of H)if(this.matchFile(s,{base:w,relativePath:G,searchPath:this.getSearchPath(i,G)}),this.isLimitHit){T();break}(x||this.isLimitHit)&&L();return}this.addDirectoryEntries(i,R,w,H,s),x&&(this.matchDirectoryTree(R,w,s),L())})}spawnFindCmd(i){const s=this.folderExcludePatterns.get(i.folder.fsPath),c=s.getBasenameTerms(),h=s.getPathTerms(),w=["-L","."];if(c.length||h.length){w.push("-not","(","(");for(const E of c)w.push("-name",E),w.push("-o");for(const E of h)w.push("-path",E),w.push("-o");w.pop(),w.push(")","-prune",")")}return w.push("-type","f"),f.spawn("find",w,{cwd:i.folder.fsPath})}readStdout(i,s,c){let h="";this.collectStdout(i,s,()=>{},(w,E,p)=>{if(w){c(w);return}h+=E,p&&c(null,h)})}collectStdout(i,s,c,h){let w=(T,L,M)=>{(T||M)&&(w=()=>{},this.cmdSW&&this.cmdSW.stop()),h(T,L,M)},E=!1;i.stdout?(this.forwardData(i.stdout,s,w),i.stdout.once("data",()=>E=!0)):c({message:"stdout is null"});let p;i.stderr?p=this.collectData(i.stderr):c({message:"stderr is null"}),i.on("error",T=>{w(T)}),i.on("close",T=>{let L;!E&&(L=this.decodeData(p,s))&&u(L)?w(new Error(`command failed with error code ${T}: ${this.decodeData(p,s)}`)):(this.exists&&T===0&&(this.isLimitHit=!0),w(null,"",!0))})}forwardData(i,s,c){const h=new y.StringDecoder(s);return i.on("data",w=>{c(null,h.write(w))}),h}collectData(i){const s=[];return i.on("data",c=>{s.push(c)}),s}decodeData(i,s){const c=new y.StringDecoder(s);return i.map(h=>c.write(h)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:s},c,h,w){h.indexOf(this.filePattern)!==-1&&this.matchFile(w,{base:c,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const E=p=>{const T=C.basename(p),L=C.dirname(p);let M=s[L];M||(M=s[L]=[],E(L)),M.push({base:c,relativePath:p,basename:T,searchPath:this.getSearchPath(i,p)})};h.forEach(E)}matchDirectoryTree({rootEntries:i,pathToEntries:s},c,h){const w=this,E=this.folderExcludePatterns.get(c),p=this.filePattern;function T(L){w.directoriesWalked++;const M=S.hasSiblingFn(()=>L.map(R=>R.basename));for(let R=0,$=L.length;R<$;R++){const z=L[R],{relativePath:O,basename:V}=z;if(E.test(O,V,p!==V?M:void 0))continue;const N=s[O];if(N)T(N);else{if(w.filesWalked++,O===p)continue;w.matchFile(h,z)}if(w.isLimitHit)break}}T(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,s,c,h,w){const E=i.folder,p=S.hasSiblingFn(()=>c);this.parallel(c,(T,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const M=s?[s,T].join(C.sep):T;if(this.folderExcludePatterns.get(i.folder.fsPath).test(M,T,this.config.filePattern!==T?p:void 0))return L(null);const R=[E.fsPath,M].join(C.sep);F.lstat(R,($,z)=>{if($||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(R,z,(O,V)=>O||this.isCanceled||this.isLimitHit?L(null):V.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(R,z,(N,U)=>N||this.isCanceled||this.isLimitHit||(U=U||"",this.walkedPaths[U])?L(null):(this.walkedPaths[U]=!0,v.Promises.readdir(R).then(x=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(i,M,x,h,B=>L(B||null))},x=>{L(null)})))):(this.filesWalked++,M===this.filePattern||this.maxFilesize&&d.isNumber(V.size)&&V.size>this.maxFilesize||this.matchFile(h,{base:E.fsPath,relativePath:M,searchPath:this.getSearchPath(i,M)}),L(null,void 0)))})},T=>{const L=T&&A.coalesce(T);return w(L&&L.length>0?L[0]:void 0)})}matchFile(i,s){this.isFileMatch(s)&&(!this.includePattern||this.includePattern(s.relativePath,C.basename(s.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(s))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,D.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,s,c){return s.isSymbolicLink()?F.stat(i,c):c(null,s)}realPathIfNeeded(i,s,c){return s.isSymbolicLink()?F.realpath(i,(h,w)=>h?c(h):c(null,w)):c(null,i)}getSearchPath(i,s){return i.folderName?C.join(i.folderName,s):s}}e.FileWalker=o;class g{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new o(i)}search(i,s,c){this.walker.walk(this.folderQueries,this.extraFiles,i,s,(h,w)=>{c(h,{limitHit:w,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class t{constructor(i,s){this.expression=i,this.root=s,this.init(i)}init(i){let s,c;Object.keys(i).filter(h=>i[h]).forEach(h=>{C.isAbsolute(h)?(s=s||S.getEmptyExpression(),s[h]=i[h]):(c=c||S.getEmptyExpression(),c[h]=i[h])}),this.absoluteParsedExpr=s&&S.parse(s,{trimForExclusions:!0}),this.relativeParsedExpr=c&&S.parse(c,{trimForExclusions:!0})}test(i,s,c){return this.relativeParsedExpr&&this.relativeParsedExpr(i,s,c)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,i),s,c)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...S.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...S.getPathTerms(this.relativeParsedExpr)),i}}function u(r){const i=r.trim().split(`
`),s=i[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return m.uppercaseFirstLetter(i[i.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}e.rgErrorMsgForDisplay=u}),define(fe[137],me([0,1,39,298,105,16,58,30,8,9,2,31,71,299,282,93]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const D=d.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class I{constructor(E){this.outputChannel=E}provideTextSearchResults(E,p,T,L){return this.outputChannel.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...p,folder:p.folder.toString()})}`),new Promise((M,R)=>{L.onCancellationRequested(()=>B());const $=u(E,p),z=p.folder.fsPath,O=$.map(de=>de.match(/^-/)?de:`'${de}'`).join(" ");this.outputChannel.appendLine(`${D} ${O}
 - cwd: ${z}`);let V=f.spawn(D,$,{cwd:z});V.on("error",de=>{console.error(de),this.outputChannel.appendLine("Error: "+(de&&de.message)),R((0,k.serializeSearchError)(new k.SearchError(de&&de.message,k.SearchErrorCode.rgProcessError)))});let N=!1;const U=new o(p.maxResults,z,p.previewOptions);U.on("result",de=>{N=!0,G="",T.report(de)});let x=!1;const B=()=>{x=!0,V&&V.kill(),U&&U.cancel()};let H=!1;U.on("hitLimit",()=>{H=!0,B()});let G="";V.stdout.on("data",de=>{U.handleData(de),N||(G+=de)});let K=!1;V.stdout.once("data",()=>K=!0);let X="";V.stderr.on("data",de=>{const be=de.toString();this.outputChannel.appendLine(be),X+=be}),V.on("close",()=>{if(this.outputChannel.appendLine(K?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(N?"Got result from parser":"No result from parser"),G&&this.outputChannel.appendLine(`Got data without result: ${G}`),this.outputChannel.appendLine(""),x)M({limitHit:H});else{U.flush(),V=null;let de;X&&!K&&(de=b(X))?R((0,k.serializeSearchError)(new k.SearchError(de.message,de.code))):M({limitHit:H})}})})}}e.RipgrepTextSearchEngine=I;function b(w){const E=w.split(`
`),p=E[0].trim();if(E.some(L=>L.startsWith("regex parse error")))return new k.SearchError(l(E),k.SearchErrorCode.regexParseError);const T=p.match(/grep config error: unknown encoding: (.*)/);if(T)return new k.SearchError(`Unknown encoding: ${T[1]}`,k.SearchErrorCode.unknownEncoding);if(p.startsWith("error parsing glob"))return new k.SearchError(p.charAt(0).toUpperCase()+p.substr(1),k.SearchErrorCode.globParseError);if(p.startsWith("the literal"))return new k.SearchError(p.charAt(0).toUpperCase()+p.substr(1),k.SearchErrorCode.invalidLiteral);if(p.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(p,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function l(w){const E=["Regex parse error"],p=w.filter(T=>T.startsWith("PCRE2:"));if(p.length>=1){const T=p[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const L=T.split(":")[1];E.push(":"+L)}}return E.join("")}e.buildRegexParseError=l;class o extends F.EventEmitter{constructor(E,p,T){super();this.maxResults=E,this.rootFolder=p,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(E,p){return super.on(E,p),this}handleData(E){if(this.isDone)return;const p=typeof E=="string"?E:this.stringDecoder.write(E);this.handleDecodedData(p)}handleDecodedData(E){let p=E.indexOf(`
`);const T=this.remainder+E;if(p>=0)p+=this.remainder.length;else{this.remainder=T;return}let L=0;for(;p>=0;)this.handleLine(T.substring(L,p).trim()),L=p+1,p=T.indexOf(`
`,L);this.remainder=T.substring(L)}handleLine(E){if(this.isDone||!E)return;let p;try{p=JSON.parse(E)}catch(T){throw new Error(`malformed line from rg: ${E}`)}if(p.type==="match"){const T=g(p.data.path),L=n.URI.file(S.join(this.rootFolder,T)),M=this.createTextSearchMatch(p.data,L);this.onResult(M),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(p.type==="context"){const T=g(p.data.path),L=n.URI.file(S.join(this.rootFolder,T));this.createTextSearchContext(p.data,L).forEach(R=>this.onResult(R))}}createTextSearchMatch(E,p){const T=E.line_number-1,L=g(E.lines),M=Buffer.from(L);let R=0,$=0,z=T;E.submatches.length===0&&E.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const O=(0,y.coalesce)(E.submatches.map((V,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const U=g(V.match),x=M.slice(R,V.start).toString().length,B=$+x,H=t(U),G=z,K=H.numLines+G,X=H.numLines>0?H.lastLineLength:H.lastLineLength+B;return R=V.end,$=X,z=K,new a.Range(G,B,K,X)}));return(0,v.createTextSearchResult)(p,L,O,this.previewOptions)}createTextSearchContext(E,p){const T=g(E.lines),L=E.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((M,R)=>({text:M,uri:p,lineNumber:L+R}))}onResult(E){this.emit("result",E)}}e.RipgrepParser=o;function g(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function t(w){const E=/\n/g;let p=0,T=-1,L;for(;L=E.exec(w);)p++,T=L.index;const M=T>=0?w.length-T-1:w.length;return{numLines:p,lastLineLength:M}}function u(w,E){const p=["--hidden"];p.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:L}=(0,A.groupBy)(E.includes,R=>R.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const R=new Set;L.forEach($=>{R.add($)}),p.push("-g","!*"),R.forEach($=>{r($).map(v.anchorGlob).forEach(z=>{p.push("-g",z)})})}T&&T.length&&T.forEach(R=>{p.push("-g",R)}),E.excludes.map(v.anchorGlob).forEach(R=>p.push("-g",`!${R}`)),E.maxFileSize&&p.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?p.push("--no-ignore-parent"):p.push("--no-ignore"),E.followSymlinks&&p.push("--follow"),E.encoding&&E.encoding!=="utf8"&&p.push("--encoding",E.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,P.escapeRegExpCharacters)(w.pattern),w.isRegExp=!0),E.usePCRE2&&p.push("--pcre2"),p.push("--crlf"),w.isRegExp&&(w.pattern=i(w.pattern),p.push("--auto-hybrid-regex"));let M;if(w.isWordMatch){const $=(0,P.createRegExp)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");p.push("--regexp",$)}else if(w.isRegExp){let R=c(w.pattern);R=h(R),p.push("--regexp",R)}else M=w.pattern,p.push("--fixed-strings");return p.push("--no-config"),E.useGlobalIgnoreFiles||p.push("--no-ignore-global"),p.push("--json"),w.isMultiline&&p.push("--multiline"),E.beforeContext&&p.push("--before-context",E.beforeContext+""),E.afterContext&&p.push("--after-context",E.afterContext+""),p.push("--"),M&&p.push(M),p.push("."),p}function r(w){const E=(0,_.splitGlobAware)(w,"/");return E.map((p,T)=>E.slice(0,T+1).join("/"))}e.spreadGlobComponents=r;function i(w){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(E);)w=w.replace(E,"$1\\x{$2}");const p=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(p);)w=w.replace(p,"$1\\x{$2}");return w}e.unicodeEscapesToPCRE2=i;const s=w=>w.type==="Assertion"&&w.kind==="lookbehind";function c(w){let E;try{E=new m.RegExpParser().parsePattern(w)}catch{return w}let p="",T=0;const L=($,z,O)=>{p+=w.slice(T,$)+O,T=z},M=[];return new m.RegExpVisitor({onCharacterEnter($){if($.raw!=="\\n")return;const z=M[0];if(!z)L($.start,$.end,"\\r?\\n");else if(!M.some(s))if(z.type==="CharacterClass")if(z.negate){const O=w.slice(z.start+2,$.start)+w.slice($.end,z.end-1);L(z.start,z.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=w.slice(z.start+1,$.start)+w.slice($.end,z.end-1);L(z.start,z.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else z.type==="Quantifier"&&L($.start,$.end,"(?:\\r?\\n)")},onQuantifierEnter($){M.unshift($)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter($){M.unshift($)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter($){M.unshift($)},onCharacterClassLeave(){M.shift()},onAssertionEnter($){s($)&&M.push($)},onAssertionLeave($){M[0]===$&&M.shift()}}).visit(E),p+=w.slice(T),p}e.fixRegexNewline=c;function h(w){return w.replace(/\n/g,"\\r?\\n")}e.fixNewline=h}),define(fe[284],me([0,1,21,137,119,10]),function(Y,e,f,F,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,n,k,a){const m=new F.RipgrepTextSearchEngine(this.outputChannel);if(n.folder.scheme===y.Schemas.userData){const d={...n,folder:n.folder.with({scheme:y.Schemas.file})},v=new C.Progress(D=>k.report({...D,uri:D.uri.with({scheme:n.folder.scheme})}));return this.withToken(a,D=>m.provideTextSearchResults(P,d,v,D))}else return this.withToken(a,d=>m.provideTextSearchResults(P,n,k,d))}async withToken(P,n){const k=_(P);this.inProgress.add(k);const a=await n(k.token);return this.inProgress.delete(k),a}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=A;function _(S){const P=new f.CancellationTokenSource;return S.onCancellationRequested(()=>P.cancel()),P}}),define(fe[285],me([0,1,28,137,136]),function(Y,e,f,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class y{constructor(S){this.query=S}search(S,P,n){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(m){n({message:m})}},a=new C.NativeTextSearchManager(this.query,new F.RipgrepTextSearchEngine(k),f);return new Promise((m,d)=>a.search(v=>{P(v.map(A))},S).then(v=>m({limitHit:v.limitHit,type:"success",stats:v.stats}),d))}}e.TextSearchEngineAdapter=y;function A(_){return{path:_.resource&&_.resource.fsPath,results:_.results,numMatches:(_.results||[]).reduce((S,P)=>{if(P.ranges){const n=P;return S+(Array.isArray(n.ranges)?n.ranges.length:1)}else return S+1},0)}}}),define(fe[286],me([0,1,50,300,16,17,18,3,102,8,46,2,43,31,283,285]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,F.gracefulify(f);class D{constructor(t="searchProcess"){this.processType=t,this.caches=Object.create(null)}fileSearch(t){let u;const r=l(t),i=new _.Emitter({onFirstListenerDidAdd:()=>{u=(0,y.createCancelablePromise)(s=>this.doFileSearchWithEngine(d.Engine,r,c=>i.fire(c),s)),u.then(s=>i.fire(s),s=>i.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{u.cancel()}});return i.event}textSearch(t){let u;const r=l(t),i=new _.Emitter({onFirstListenerDidAdd:()=>{u=(0,y.createCancelablePromise)(s=>this.ripgrepTextSearch(r,c=>i.fire(c),s)),u.then(s=>i.fire(s),s=>i.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onLastListenerRemove:()=>{u.cancel()}});return i.event}ripgrepTextSearch(t,u,r){return t.maxFileSize=(0,a.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new v.TextSearchEngineAdapter(t).search(r,u,u)}doFileSearch(t,u,r){return this.doFileSearchWithEngine(d.Engine,t,u,r)}doFileSearchWithEngine(t,u,r,i,s=D.BATCH_SIZE){let c=0;const h=E=>{Array.isArray(E)?(c+=E.length,r(E.map(p=>this.rawMatchToSearchItem(p)))):E.relativePath?(c++,r(this.rawMatchToSearchItem(E))):r(E)};if(u.sortByScore){let E=this.trySortedSearchFromCache(u,h,i);if(!E){const p=u.maxResults?Object.assign({},u,{maxResults:null}):u,T=new t(p);E=this.doSortedSearch(T,u,r,h,i)}return new Promise((p,T)=>{E.then(([L,M])=>{const R=M.map($=>this.rawMatchToSearchItem($));this.sendProgress(R,r,s),p(L)},T)})}const w=new t(u);return this.doSearch(w,h,s,i).then(E=>({limitHit:E.limitHit,type:"success",stats:{detailStats:E.stats,type:this.processType,fromCache:!1,resultCount:c,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,P.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,u,r,i,s){const c=new _.Emitter;let h=(0,y.createCancelablePromise)(E=>{let p=[];const T=L=>{Array.isArray(L)?p=L:(i(L),c.fire(L))};return this.doSearch(t,T,-1,E).then(L=>[L,p])}),w;if(u.cacheKey){w=this.getOrCreateCache(u.cacheKey);const E={promise:h,event:c.event,resolved:!1};w.resultsToSearchCache[u.filePattern||""]=E,h.then(()=>{E.resolved=!0},p=>{delete w.resultsToSearchCache[u.filePattern||""]}),h=this.preventCancellation(h)}return h.then(([E,p])=>{const T=w?w.scorerCache:Object.create(null),L=(typeof u.maxResults!="number"||u.maxResults>0)&&n.StopWatch.create(!1);return this.sortResults(u,p,T,s).then(M=>{const R=L?L.elapsed():-1;return[{type:"success",stats:{detailStats:E.stats,sortingTime:R,fromCache:!1,type:this.processType,workspaceFolderCount:u.folderQueries.length,resultCount:M.length},messages:E.messages,limitHit:E.limitHit||typeof u.maxResults=="number"&&p.length>u.maxResults},M]})})}getOrCreateCache(t){const u=this.caches[t];return u||(this.caches[t]=new I)}trySortedSearchFromCache(t,u,r){const i=t.cacheKey&&this.caches[t.cacheKey];if(!i)return;const s=this.getResultsFromCache(i,t.filePattern||"",u,r);if(s)return s.then(([c,h,w])=>{const E=n.StopWatch.create(!1);return this.sortResults(t,h,i.scorerCache,r).then(p=>{const T=E.elapsed(),L={fromCache:!0,detailStats:w,type:this.processType,resultCount:h.length,sortingTime:T};return[{type:"success",limitHit:c.limitHit||typeof t.maxResults=="number"&&h.length>t.maxResults,stats:L},p]})})}sortResults(t,u,r,i){const s=(0,S.prepareQuery)(t.filePattern||""),c=(w,E)=>(0,S.compareItemsByFuzzyScore)(w,E,s,!0,b,r),h=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return C.topAsync(u,c,h,1e4,i)}sendProgress(t,u,r){if(r&&r>0)for(let i=0;i<t.length;i+=r)u(t.slice(i,i+r));else u(t)}getResultsFromCache(t,u,r,i){const s=n.StopWatch.create(!1),c=u.indexOf(P.sep)>=0;let h;for(const T in t.resultsToSearchCache)if(u.startsWith(T)){if(c&&T.indexOf(P.sep)<0&&T!=="")continue;const L=t.resultsToSearchCache[T];h={promise:this.preventCancellation(L.promise),event:L.event,resolved:L.resolved};break}if(!h)return null;const w=s.elapsed(),E=n.StopWatch.create(!1),p=h.event(r);return i&&i.onCancellationRequested(()=>{p.dispose()}),h.promise.then(([T,L])=>{if(i&&i.isCancellationRequested)throw(0,A.canceled)();const M=[],R=(0,S.prepareQuery)(u).normalizedLowercase;for(const $ of L)!(0,m.isFilePatternMatch)($,R)||M.push($);return[T,M,{cacheWasResolved:h.resolved,cacheLookupTime:w,cacheFilterTime:E.elapsed(),cacheEntryCount:L.length}]})}doSearch(t,u,r,i){return new Promise((s,c)=>{let h=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(w=>{w&&(r?(h.push(w),r>0&&h.length>=r&&(u(h),h=[])):u(w))},w=>{u(w)},(w,E)=>{h.length&&u(h),w?c(w):s(E)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(u,r){return t.then(u,r)}catch(u){return this.then(void 0,u)}finally(u){return t.finally(u)}}}}e.SearchService=D,D.BATCH_SIZE=512;class I{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(g){return(0,P.basename)(g.relativePath)}getItemDescription(g){return(0,P.dirname)(g.relativePath)}getItemPath(g){return g.relativePath}};function l(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(o),extraFileResources:g.extraFileResources&&g.extraFileResources.map(t=>k.URI.revive(t))}}function o(g){return{...g,folder:k.URI.revive(g.folder)}}}),define(fe[287],me([0,1,6,10,2,28,13,27,14,74,66,31,286,284,93,136]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let D=class extends P.ExtHostSearch{constructor(b,l,o,g){super(b,o,g);this._pfs=y,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const t=new d.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(F.Schemas.userData,new m.RipgrepSearchProvider(t)),l.remote.isRemote&&l.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const b=new d.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(F.Schemas.file,new m.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(F.Schemas.file,new a.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(b,l){const o=this._handlePool++;return this._internalFileSearchProvider=l,this._internalFileSearchHandle=o,this._proxy.$registerFileSearchProvider(o,this._transformScheme(b)),(0,f.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(b,l,o,g){const t=(0,P.reviveQuery)(o);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,l,t,g):super.$provideFileSearchResults(b,l,o,g)}doInternalFileSearch(b,l,o,g){const t=u=>{if((0,k.isSerializedFileMatch)(u)&&(u=[u]),Array.isArray(u)){this._proxy.$handleFileMatch(b,l,u.map(r=>C.URI.file(r.path)));return}u.message&&this._logService.debug("ExtHostSearch",u.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(o,t,g)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,l){return new v.NativeTextSearchManager(b,l,void 0,"textSearchProvider")}};D=je([He(0,S.IExtHostRpcService),He(1,_.IExtHostInitDataService),He(2,n.IURITransformerService),He(3,A.ILogService)],D),e.NativeExtHostSearch=D}),define(fe[138],me([0,1,301,127,80,22,18,3,6,8,11,32,107,108,302]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(h){this.socket=h,this._errorListener=w=>{if(w){if(w.code==="EPIPE")return;(0,A.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(h){const w=E=>h(y.VSBuffer.wrap(E));return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(h){const w=E=>{h({type:0,hadError:E,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(h){return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(h){if(!this.socket.destroyed)try{this.socket.write(h.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,A.onUnexpectedError)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,A.onUnexpectedError)(w)}}end(){this.socket.end()}drain(){return new Promise((h,w)=>{if(this.socket.bufferSize===0){h();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),h()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.NodeSocket=v;var D;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(D||(D={}));var I;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(I||(I={}));class b extends S.Disposable{constructor(h,w,E,p){super();this._onDidZlibFlush=this._register(new _.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new _.Emitter),this._onClose=this._register(new _.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=h,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=w,this._recordInflateBytes=p,w?(this._zlibInflate=d.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",T=>{console.error(T),(0,A.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibInflate.on("data",T=>{this._pendingInflateData.push(T)}),E&&(this._zlibInflate.write(E.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",T=>{console.error(T),(0,A.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibDeflate.on("data",T=>{this._pendingDeflateData.push(T)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new m.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(T=>this._onClose.fire(T)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?y.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):y.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this._onData.event(h)}onClose(h){return this._onClose.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){this._totalOutgoingDataBytes+=h.byteLength,this._zlibDeflate?(this._zlibDeflate.write(h.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let w=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,w=w.slice(0,w.length-4),this._isEnded||this._write(y.VSBuffer.wrap(w),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(h,!1)}_write(h,w){let E=2;h.byteLength<126?E+=0:h.byteLength<2**16?E+=2:E+=8;const p=y.VSBuffer.alloc(E);if(w?p.writeUInt8(194,0):p.writeUInt8(130,0),h.byteLength<126)p.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){p.writeUInt8(126,1);let T=1;p.writeUInt8(h.byteLength>>>8&255,++T),p.writeUInt8(h.byteLength>>>0&255,++T)}else{p.writeUInt8(127,1);let T=1;p.writeUInt8(0,++T),p.writeUInt8(0,++T),p.writeUInt8(0,++T),p.writeUInt8(0,++T),p.writeUInt8(h.byteLength>>>24&255,++T),p.writeUInt8(h.byteLength>>>16&255,++T),p.writeUInt8(h.byteLength>>>8&255,++T),p.writeUInt8(h.byteLength>>>0&255,++T)}this._totalOutgoingWireBytes+=p.byteLength+h.byteLength,this.socket.write(y.VSBuffer.concat([p,h]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(h){if(h.byteLength!==0){for(this._totalIncomingWireBytes+=h.byteLength,this._incomingData.acceptChunk(h);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const w=this._incomingData.peek(this._state.readLen),E=w.readUInt8(0),p=(E&128)>>>7,T=(E&64)>>>6,L=w.readUInt8(1),M=(L&128)>>>7,R=L&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(R===126?2:0)+(R===127?8:0),this._state.fin=p,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(T)),this._state.firstFrameOfMessage=Boolean(p),this._state.mask=0}else if(this._state.state===2){const w=this._incomingData.read(this._state.readLen),E=w.readUInt8(1),p=(E&128)>>>7;let T=E&127,L=1;T===126?T=w.readUInt8(++L)*2**8+w.readUInt8(++L):T===127&&(T=w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*0+w.readUInt8(++L)*2**24+w.readUInt8(++L)*2**16+w.readUInt8(++L)*2**8+w.readUInt8(++L));let M=0;p&&(M=w.readUInt8(++L)*2**24+w.readUInt8(++L)*2**16+w.readUInt8(++L)*2**8+w.readUInt8(++L)),this._state.state=3,this._state.readLen=T,this._state.mask=M}else if(this._state.state===3){const w=this._incomingData.read(this._state.readLen);l(w,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(w.buffer)),this._zlibInflate.write(w.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const E=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=E.length,this._onData.fire(y.VSBuffer.wrap(E))})):(this._totalIncomingDataBytes+=w.byteLength,this._onData.fire(w))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await _.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function l(c,h){if(h===0)return;let w=c.byteLength>>>2;for(let R=0;R<w;R++){const $=c.readUInt32BE(R*4);c.writeUInt32BE($^h,R*4)}let E=w*4,p=c.byteLength-E;const T=h>>>24&255,L=h>>>16&255,M=h>>>8&255;p>=1&&c.writeUInt8(c.readUInt8(E)^T,E),p>=2&&c.writeUInt8(c.readUInt8(E+1)^L,E+1),p>=3&&c.writeUInt8(c.readUInt8(E+2)^M,E+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function g(){const c=(0,k.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let h;return e.XDG_RUNTIME_DIR?h=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):h=(0,P.join)((0,C.tmpdir)(),`vscode-ipc-${c}.sock`),u(h),h}e.createRandomIPCHandle=g;function t(c,h,w){const E=(0,f.createHash)("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${E}-${w}-${h}-sock`;let p;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?p=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${E.substr(0,8)}-${w}-${h}.sock`):p=(0,P.join)(c,`${w}-${h}.sock`),u(p),p}e.createStaticIPCHandle=t;function u(c){const h=o[n.platform];typeof h=="number"&&c.length>=h&&console.warn(`WARNING: IPC handle "${c}" is longer than ${h} chars, try a shorter --user-data-dir`)}class r extends a.IPCServer{constructor(h){super(r.toClientConnectionEvent(h));this.server=h}static toClientConnectionEvent(h){const w=_.Event.fromNodeEventEmitter(h,"connection");return _.Event.map(w,E=>({protocol:new m.Protocol(new v(E)),onDidClientDisconnect:_.Event.once(_.Event.fromNodeEventEmitter(E,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function i(c){return new Promise((h,w)=>{const E=(0,F.createServer)();E.on("error",w),E.listen(c,()=>{E.removeListener("error",w),h(new r(E))})})}e.serve=i;function s(c,h){return new Promise((w,E)=>{const p=(0,F.createConnection)(c,()=>{p.removeListener("error",E),w(m.Client.fromSocket(new v(p),h))});p.once("error",E)})}e.connect=s}),define(fe[288],me([0,1,138,280,50,40,2,200,13]),function(Y,e,f,F,C,y,A,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(a,m,d){this._commands=a,this.logService=m,this._ipcHandlePath=d,this._server=F.createServer((v,D)=>this.onRequest(v,D)),this.setup().catch(v=>(m.error(v),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",a=>this.logService.error(a))}catch(a){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(a,m){const d=[];a.setEncoding("utf8"),a.on("data",v=>d.push(v)),a.on("end",()=>{const v=JSON.parse(d.join(""));switch(v.type){case"open":this.open(v,m);break;case"openExternal":this.openExternal(v,m);break;case"status":this.getStatus(v,m);break;case"extensionManagement":this.manageExtensions(v,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${v.type}`,D=>{D&&this.logService.error(D)}),m.end();break}})}open(a,m){let{fileURIs:d,folderURIs:v,forceNewWindow:D,diffMode:I,addMode:b,forceReuseWindow:l,gotoLineMode:o,waitMarkerFilePath:g}=a;const t=[];if(Array.isArray(v))for(const u of v)try{t.push({folderUri:A.URI.parse(u)})}catch(r){}if(Array.isArray(d))for(const u of d)try{(0,_.hasWorkspaceFileExtension)(u)?t.push({workspaceUri:A.URI.parse(u)}):t.push({fileUri:A.URI.parse(u)})}catch(r){}if(t.length){const u=g?A.URI.file(g):void 0,i={forceNewWindow:D,diffMode:I,addMode:b,gotoLineMode:o,forceReuseWindow:l,preferNewWindow:!l&&!u&&!b,waitMarkerFileURI:u};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}m.writeHead(200),m.end()}async openExternal(a,m){for(const d of a.uris){const v=A.URI.parse(d),D=v.scheme==="file"?v:d;await this._commands.executeCommand("_remoteCLI.openExternal",D)}m.writeHead(200),m.end()}async manageExtensions(a,m){try{const d=I=>I?.map(b=>/\.vsix$/i.test(b)?A.URI.parse(b):b),v={list:a.list,install:d(a.install),uninstall:d(a.uninstall),force:a.force},D=await this._commands.executeCommand("_remoteCLI.manageExtensions",v);m.writeHead(200),m.write(D)}catch(d){m.writeHead(500),m.write(String(d),v=>{v&&this.logService.error(v)})}m.end()}async getStatus(a,m){try{const d=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(d),m.end()}catch(d){m.writeHead(500),m.write(String(d),v=>{v&&this.logService.error(v)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let n=class extends P{constructor(a,m){super(a,m,(0,f.createRandomIPCHandle)())}};n=je([He(0,y.IExtHostCommands),He(1,S.ILogService)],n),e.CLIServer=n}),define(fe[289],me([0,1,73,276,271,5,279,41,261,2,10,7,288,106]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class d extends C.RequireInterceptor{_installInterceptor(){const I=this,b=Y.__$__nodeRequire("module"),l=b._load;b._load=function(g,t,u){for(let r of I._alternatives){let i=r(g);if(i){g=i;break}}return I._factories.has(g)?I._factories.get(g).load(g,P.URI.file((0,m.realpathSync)(t.filename)),r=>l.apply(this,[r,t,u])):l.apply(this,arguments)}}}class v extends _.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=k.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const I=this._instaService.invokeFunction(F.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(a.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(d,I,this._registry).install(),f.mark("code/extHost/didInitAPI");const l=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,l,this,this._logService,this._mainThreadTelemetryProxy,this._initData),f.mark("code/extHost/didInitProxyResolver");const o=process.send,g=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?o.apply(process,t):(g.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(I){return I.main}_loadCommonJSModule(I,b,l){if(b.scheme!==n.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let o=null;l.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{I&&f.mark(`code/extHost/willLoadExtensionCode/${I.value}`),o=Y.__$__nodeRequire(b.fsPath)}catch(g){return Promise.reject(g)}finally{I&&f.mark(`code/extHost/didLoadExtensionCode/${I.value}`),l.codeLoadingStop()}return Promise.resolve(o)}async $setRemoteEnvironment(I){if(!!this._initData.remote.isRemote)for(const b in I){const l=I[b];l===null?delete process.env[b]:process.env[b]=l}}}e.ExtHostExtensionService=v}),define(fe[290],me([0,1,82,262,264,273,272,287,289,229,265,56,41,68,74,72,33,53,13,69,263]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D,I,b,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.registerSingleton)(a.IExtHostExtensionService,S.ExtHostExtensionService),(0,f.registerSingleton)(b.ILogService,P.ExtHostLogService),(0,f.registerSingleton)(l.IExtensionStoragePaths,o.ExtensionStoragePaths),(0,f.registerSingleton)(k.IExtHostDebugService,A.ExtHostDebugService),(0,f.registerSingleton)(m.IExtHostOutputService,F.ExtHostOutputService2),(0,f.registerSingleton)(d.IExtHostSearch,_.NativeExtHostSearch),(0,f.registerSingleton)(v.IExtHostTask,y.ExtHostTask),(0,f.registerSingleton)(D.IExtHostTerminalService,C.ExtHostTerminalService),(0,f.registerSingleton)(I.IExtHostTunnelService,n.ExtHostTunnelService)}),define(fe[291],me([0,1,127,303,73,18,108,138,194,227,274,22,104,28,106,17,115,277,290]),function(Y,e,f,F,C,y,A,_,S,P,n,k,a,m,d,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let s=0;s<process.execArgv.length;s++)process.execArgv[s]==="--inspect-port=0"&&(process.execArgv.splice(s,1),s--)}();const I=F(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const i=Y.__$__nodeRequire("module"),s=i._load;i._load=function(c){if(c==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return s.apply(this,arguments)}})();const b=process.exit.bind(process);function l(i){process.exit=function(s){if(i)b(s);else{const c=new Error("An extension called process.exit() and this was prevented.");console.warn(c.stack)}},process.crash=function(){const s=new Error("An extension called process.crash() and this was prevented.");console.warn(s.stack)}}let o=function(i){b()};function g(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,s)=>{let c=null,h=setTimeout(()=>{o("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const w=108e5,E=3e5,p=new v.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (1)"),w),T=new v.ProcessTimeRunOnceScheduler(()=>o("renderer disconnected for too long (2)"),E);process.on("message",(M,R)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){const $=k.VSBuffer.wrap(Buffer.from(M.initialDataChunk,"base64"));let z;if(M.skipWebSocketFrames)z=new _.NodeSocket(R);else{const O=k.VSBuffer.wrap(Buffer.from(M.inflateBytes,"base64"));z=new _.WebSocketNodeSocket(new _.NodeSocket(R),M.permessageDeflate,O,!1)}c?(p.cancel(),T.cancel(),c.beginAcceptReconnection(z,$),c.endAcceptReconnection()):(clearTimeout(h),c=new A.PersistentProtocol(z,$),c.onDidDispose(()=>o("renderer disconnected")),i(c),c.onSocketClose(()=>{p.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(T.isScheduled())return;p.isScheduled()&&T.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((s,c)=>{const h=f.createConnection(i,()=>{h.removeListener("error",c),s(new A.PersistentProtocol(new _.NodeSocket(h)))});h.once("error",c),h.on("close",()=>{o("renderer closed the socket")})})}}async function t(){const i=await g();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(s=>{(0,P.isMessageOfType)(s,2)?(this._terminating=!0,o("received terminate message from renderer")):this._onMessage.fire(s)})}send(s){this._terminating||i.send(s)}drain(){return i.drain()}}}function u(i){return new Promise(s=>{const c=i.onMessage(h=>{c.dispose();const w=JSON.parse(h.toString()),E=w.commit,p=S.default.commit;E&&p&&E!==p&&b(55);const T=[];process.on("unhandledRejection",(R,$)=>{T.push($),setTimeout(()=>{const z=T.indexOf($);z>=0&&$.catch(O=>{T.splice(z,1),(0,y.isPromiseCanceledError)(O)||(console.warn(`rejected promise not handled within 1 second: ${O}`),O&&O.stack&&console.warn(`stack trace: ${O.stack}`),(0,y.onUnexpectedError)(R))})},1e3)}),process.on("rejectionHandled",R=>{const $=T.indexOf(R);$>=0&&T.splice($,1)}),process.on("uncaughtException",function(R){(0,y.onUnexpectedError)(R)});let L=0;setInterval(function(){try{process.kill(w.parentPid,0),L=0}catch(R){R&&R.code==="EPERM"?(L++,L>=3&&o(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${R.message} (code: ${R.code}) (errno: ${R.errno})`)):o(`parent process ${w.parentPid} does not exist anymore: ${R.message} (code: ${R.code}) (errno: ${R.errno})`)}},1e3);let M;try{M=Y.__$__nodeRequire("native-watchdog"),M.start(w.parentPid)}catch(R){(0,y.onUnexpectedError)(R)}i.send((0,P.createMessageOfType)(0)),s({protocol:i,initData:w})});i.send((0,P.createMessageOfType)(1))})}async function r(){C.mark("code/extHost/willConnectToRenderer");const i=await t();C.mark("code/extHost/didConnectToRenderer");const s=await u(i);C.mark("code/extHost/didWaitForInitData");const{initData:c}=s;l(!!c.environment.extensionTestsLocationURI),c.environment.useHostProxy=I.useHostProxy!==void 0?I.useHostProxy!=="false":void 0,c.environment.skipWorkspaceStorageLock=(0,D.boolean)(I.skipWorkspaceStorageLock,!1);const h=new class{exit(T){b(T)}exists(T){return m.Promises.exists(T)}realpath(T){return(0,d.realpath)(T)}};let w=null;if(c.remote.authority&&I.uriTransformerPath)try{const T=Y.__$__nodeRequire(I.uriTransformerPath)(c.remote.authority);w=new a.URITransformer(T)}catch(p){console.error(p)}const E=new n.ExtensionHostMain(s.protocol,c,h,w);o=p=>E.terminate(p)}e.startExtensionHostProcess=r}),define(fe[304],me([0,1,291]),function(Y,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.startExtensionHostProcess)().catch(F=>console.log(F))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
