/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/skipList","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/base/common/iterator","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(re){for(var e=[],c=0,M=re.length;c<M;c++)e[c]=be[re[c]];return e};define(be[42],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function c(M,E){if(!M)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=c}),define(be[51],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const c=Object.prototype.hasOwnProperty;function M(t){const b=[];for(let n in t)c.call(t,n)&&b.push(t[n]);return b}e.values=M;function E(t,b){for(let n in t)if(c.call(t,n)&&b({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=E;function A(t,b){const n=Object.create(null);for(const f of t){const o=b(f);let l=n[o];l||(l=n[o]=[]),l.push(f)}return n}e.groupBy=A;function R(t){const b=Object.create(null);return t&&t.forEach((n,f)=>{b[f]=n}),b}e.fromMap=R;function C(t,b){const n=[],f=[];for(let o of t)b.has(o)||n.push(o);for(let o of b)t.has(o)||f.push(o);return{removed:n,added:f}}e.diffSets=C;function y(t,b){const n=[],f=[];for(let[o,l]of t)b.has(o)||n.push(l);for(let[o,l]of b)t.has(o)||f.push(l);return{removed:n,added:f}}e.diffMaps=y;class P{constructor(){this.map=new Map}add(b,n){let f=this.map.get(b);f||(f=new Set,this.map.set(b,f)),f.add(n)}delete(b,n){const f=this.map.get(b);!f||(f.delete(n),f.size===0&&this.map.delete(b))}forEach(b,n){const f=this.map.get(b);!f||f.forEach(n)}}e.SetMap=P}),define(be[52],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function c(R){return(C,y,P)=>{let t=null,b=null;if(typeof P.value=="function"?(t="value",b=P.value):typeof P.get=="function"&&(t="get",b=P.get),!b)throw new Error("not supported");P[t]=R(b,y)}}e.createDecorator=c;function M(R,C,y){let P=null,t=null;if(typeof y.value=="function"?(P="value",t=y.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(P="get",t=y.get),!t)throw new Error("not supported");const b=`$memoize$${C}`;y[P]=function(...n){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[b]}}e.memoize=M;function E(R,C,y){return c((P,t)=>{const b=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...f){this[n]||(this[n]=y?y():void 0),clearTimeout(this[b]),C&&(this[n]=C(this[n],...f),f=[this[n]]),this[b]=setTimeout(()=>{P.apply(this,f),this[n]=y?y():void 0},R)}})}e.debounce=E;function A(R,C,y){return c((P,t)=>{const b=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,f=`$throttle$lastRun$${t}`,o=`$throttle$pending$${t}`;return function(...l){if(this[n]||(this[n]=y?y():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),C&&(this[n]=C(this[n],...l)),this[o])return;const v=this[f]+R;v<=Date.now()?(this[f]=Date.now(),P.apply(this,[this[n]]),this[n]=y?y():void 0):(this[o]=!0,this[b]=setTimeout(()=>{this[o]=!1,this[f]=Date.now(),P.apply(this,[this[n]]),this[n]=y?y():void 0},v-Date.now()))}})}e.throttle=A}),define(be[13],Ee([0,1,16]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(Z,oe=0){return Z[Z.length-(1+oe)]}e.tail=M;function E(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=E;function A(Z,oe,ve=(Ae,Se)=>Ae===Se){if(Z===oe)return!0;if(!Z||!oe||Z.length!==oe.length)return!1;for(let Ae=0,Se=Z.length;Ae<Se;Ae++)if(!ve(Z[Ae],oe[Ae]))return!1;return!0}e.equals=A;function R(Z,oe,ve){let Ae=0,Se=Z.length-1;for(;Ae<=Se;){const Ne=(Ae+Se)/2|0,We=ve(Z[Ne],oe);if(We<0)Ae=Ne+1;else if(We>0)Se=Ne-1;else return Ne}return-(Ae+1)}e.binarySearch=R;function C(Z,oe){let ve=0,Ae=Z.length;if(Ae===0)return 0;for(;ve<Ae;){const Se=Math.floor((ve+Ae)/2);oe(Z[Se])?Ae=Se:ve=Se+1}return ve}e.findFirstInSorted=C;function y(Z,oe,ve){if(Z=Z|0,Z>=oe.length)throw new TypeError("invalid index");let Ae=oe[Math.floor(oe.length*Math.random())],Se=[],Ne=[],We=[];for(let je of oe){const qe=ve(je,Ae);qe<0?Se.push(je):qe>0?Ne.push(je):We.push(je)}return Z<Se.length?y(Z,Se,ve):Z<Se.length+We.length?We[0]:y(Z-(Se.length+We.length),Ne,ve)}e.quickSelect=y;function P(Z,oe){const ve=[];let Ae;for(const Se of Z.slice(0).sort(oe))!Ae||oe(Ae[0],Se)!==0?(Ae=[Se],ve.push(Ae)):Ae.push(Se);return ve}e.groupBy=P;function t(Z,oe,ve){const Ae=[];function Se(je,qe,$){if(qe===0&&$.length===0)return;const K=Ae[Ae.length-1];K&&K.start+K.deleteCount===je?(K.deleteCount+=qe,K.toInsert.push(...$)):Ae.push({start:je,deleteCount:qe,toInsert:$})}let Ne=0,We=0;for(;;){if(Ne===Z.length){Se(Ne,0,oe.slice(We));break}if(We===oe.length){Se(Ne,Z.length-Ne,[]);break}const je=Z[Ne],qe=oe[We],$=ve(je,qe);$===0?(Ne+=1,We+=1):$<0?(Se(Ne,1,[]),Ne+=1):$>0&&(Se(Ne,0,[qe]),We+=1)}return Ae}e.sortedDiff=t;function b(Z,oe,ve){const Ae=t(Z,oe,ve),Se=[],Ne=[];for(const We of Ae)Se.push(...Z.slice(We.start,We.start+We.deleteCount)),Ne.push(...We.toInsert);return{removed:Se,added:Ne}}e.delta=b;function n(Z,oe,ve){if(ve===0)return[];const Ae=Z.slice(0,ve).sort(oe);return o(Z,oe,Ae,ve,Z.length),Ae}e.top=n;function f(Z,oe,ve,Ae,Se){return ve===0?Promise.resolve([]):new Promise((Ne,We)=>{(async()=>{const je=Z.length,qe=Z.slice(0,ve).sort(oe);for(let $=ve,K=Math.min(ve+Ae,je);$<je;$=K,K=Math.min(K+Ae,je)){if($>ve&&await new Promise(ee=>setTimeout(ee)),Se&&Se.isCancellationRequested)throw(0,c.canceled)();o(Z,oe,qe,$,K)}return qe})().then(Ne,We)})}e.topAsync=f;function o(Z,oe,ve,Ae,Se){for(const Ne=ve.length;Ae<Se;Ae++){const We=Z[Ae];if(oe(We,ve[Ne-1])<0){ve.pop();const je=C(ve,qe=>oe(We,qe)<0);ve.splice(je,0,We)}}}function l(Z){return Z.filter(oe=>!!oe)}e.coalesce=l;function v(Z){let oe=0;for(let ve=0;ve<Z.length;ve++)Z[ve]&&(Z[oe]=Z[ve],oe+=1);Z.length=oe}e.coalesceInPlace=v;function D(Z,oe,ve){Z.splice(ve,0,Z.splice(oe,1)[0])}e.move=D;function _(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=_;function a(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=a;function d(Z,oe){if(!oe)return Z.filter((Ae,Se)=>Z.indexOf(Ae)===Se);const ve=Object.create(null);return Z.filter(Ae=>{const Se=oe(Ae);return ve[Se]?!1:(ve[Se]=!0,!0)})}e.distinct=d;function S(Z){const oe=new Set;return Z.filter(ve=>oe.has(ve)?!1:(oe.add(ve),!0))}e.distinctES6=S;function i(Z){const oe=Object.create(null);return ve=>{const Ae=Z(ve);return oe[Ae]?!1:(oe[Ae]=!0,!0)}}e.uniqueFilter=i;function p(Z,oe){const ve=r(Z,oe);if(ve!==-1)return Z[ve]}e.findLast=p;function r(Z,oe){for(let ve=Z.length-1;ve>=0;ve--){const Ae=Z[ve];if(oe(Ae))return ve}return-1}e.lastIndex=r;function s(Z,oe){return Z.length>0?Z[0]:oe}e.firstOrDefault=s;function u(Z,oe,ve=(Ae,Se)=>Ae===Se){let Ae=0;for(let Se=0,Ne=Math.min(Z.length,oe.length);Se<Ne&&ve(Z[Se],oe[Se]);Se++)Ae++;return Ae}e.commonPrefixLength=u;function h(Z){return[].concat(...Z)}e.flatten=h;function m(Z,oe){let ve=typeof oe=="number"?Z:0;typeof oe=="number"?ve=Z:(ve=0,oe=Z);const Ae=[];if(ve<=oe)for(let Se=ve;Se<oe;Se++)Ae.push(Se);else for(let Se=ve;Se>oe;Se--)Ae.push(Se);return Ae}e.range=m;function k(Z,oe,ve){return Z.reduce((Ae,Se)=>(Ae[oe(Se)]=ve?ve(Se):Se,Ae),Object.create(null))}e.index=k;function T(Z,oe){return Z.push(oe),()=>g(Z,oe)}e.insert=T;function g(Z,oe){const ve=Z.indexOf(oe);if(ve>-1)return Z.splice(ve,1),oe}e.remove=g;function I(Z,oe,ve){const Ae=Z.slice(0,oe),Se=Z.slice(oe);return Ae.concat(ve,Se)}e.arrayInsert=I;function F(Z,oe){let ve;if(typeof oe=="number"){let Ae=oe;ve=()=>{const Se=Math.sin(Ae++)*179426549;return Se-Math.floor(Se)}}else ve=Math.random;for(let Ae=Z.length-1;Ae>0;Ae-=1){const Se=Math.floor(ve()*(Ae+1)),Ne=Z[Ae];Z[Ae]=Z[Se],Z[Se]=Ne}}e.shuffle=F;function L(Z,oe){const ve=Z.indexOf(oe);ve>-1&&(Z.splice(ve,1),Z.unshift(oe))}e.pushToStart=L;function w(Z,oe){const ve=Z.indexOf(oe);ve>-1&&(Z.splice(ve,1),Z.push(oe))}e.pushToEnd=w;function x(Z,oe){return Array.isArray(Z)?Z.map(oe):oe(Z)}e.mapArrayOrNot=x;function W(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=W;function B(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=B;function G(Z,oe){for(const ve of Z){const Ae=oe(ve);if(Ae!==void 0)return Ae}}e.mapFind=G;function H(Z,oe,ve){const Ae=V(Z,oe),Se=Z.length,Ne=ve.length;Z.length=Se+Ne;for(let We=Se-1;We>=Ae;We--)Z[We+Ne]=Z[We];for(let We=0;We<Ne;We++)Z[We+Ae]=ve[We]}e.insertInto=H;function U(Z,oe,ve,Ae){const Se=V(Z,oe),Ne=Z.splice(Se,ve);return H(Z,Se,Ae),Ne}e.splice=U;function V(Z,oe){return oe<0?Math.max(oe+Z.length,0):Math.min(oe,Z.length)}function Q(Z,oe){let ve=Number.MAX_SAFE_INTEGER,Ae=0;return Z.forEach((Se,Ne)=>{const We=oe(Se);We<ve&&(ve=We,Ae=Ne)}),Ae}e.minIndex=Q;function ne(Z,oe){let ve=Number.MIN_SAFE_INTEGER,Ae=0;return Z.forEach((Se,Ne)=>{const We=oe(Se);We>ve&&(ve=We,Ae=Ne)}),Ae}e.maxIndex=ne;class ce{constructor(oe){this.items=oe,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(oe){let ve=this.firstIdx;for(;ve<this.items.length&&oe(this.items[ve]);)ve++;const Ae=ve===this.firstIdx?null:this.items.slice(this.firstIdx,ve);return this.firstIdx=ve,Ae}takeFromEndWhile(oe){let ve=this.lastIdx;for(;ve>=0&&oe(this.items[ve]);)ve--;const Ae=ve===this.lastIdx?null:this.items.slice(ve+1,this.lastIdx+1);return this.lastIdx=ve,Ae}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=ce}),define(be[53],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(E){this._prefix=E,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(be[102],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var E;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(E=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function R(i,p=!1){let r=0,s=i.length,u="",h=0,m=16,k=0;function T(W){let B=0,G=0;for(;B<W;){const H=i.charCodeAt(r);if(H>=48&&H<=57)G=G*16+H-48;else if(H>=65&&H<=70)G=G*16+H-65+10;else if(H>=97&&H<=102)G=G*16+H-97+10;else break;r++,B++}return B<W&&(G=-1),G}function g(W){r=W,u="",h=0,m=16,k=0}function I(){const W=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&P(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&P(i.charCodeAt(r)))for(r++;r<i.length&&P(i.charCodeAt(r));)r++;else return k=3,i.substring(W,r);let B=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&P(i.charCodeAt(r))){for(r++;r<i.length&&P(i.charCodeAt(r));)r++;B=r}else k=3;return i.substring(W,B)}function F(){let W="",B=r;for(;;){if(r>=s){W+=i.substring(B,r),k=2;break}const G=i.charCodeAt(r);if(G===34){W+=i.substring(B,r),r++;break}if(G===92){if(W+=i.substring(B,r),r++,r>=s){k=2;break}switch(i.charCodeAt(r++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:const U=T(4);U>=0?W+=String.fromCharCode(U):k=4;break;default:k=5}B=r;continue}if(G>=0&&G<=31)if(y(G)){W+=i.substring(B,r),k=2;break}else k=6;r++}return W}function L(){if(u="",k=0,h=r,r>=s)return h=s,m=17;let W=i.charCodeAt(r);if(C(W)){do r++,u+=String.fromCharCode(W),W=i.charCodeAt(r);while(C(W));return m=15}if(y(W))return r++,u+=String.fromCharCode(W),W===13&&i.charCodeAt(r)===10&&(r++,u+=`
`),m=14;switch(W){case 123:return r++,m=1;case 125:return r++,m=2;case 91:return r++,m=3;case 93:return r++,m=4;case 58:return r++,m=6;case 44:return r++,m=5;case 34:return r++,u=F(),m=10;case 47:const B=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<s&&!y(i.charCodeAt(r));)r++;return u=i.substring(B,r),m=12}if(i.charCodeAt(r+1)===42){r+=2;const G=s-1;let H=!1;for(;r<G;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,k=1),u=i.substring(B,r),m=13}return u+=String.fromCharCode(W),r++,m=16;case 45:if(u+=String.fromCharCode(W),r++,r===s||!P(i.charCodeAt(r)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=I(),m=11;default:for(;r<s&&w(W);)r++,W=i.charCodeAt(r);if(h!==r){switch(u=i.substring(h,r),u){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return u+=String.fromCharCode(W),r++,m=16}}function w(W){if(C(W)||y(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let W;do W=L();while(W>=12&&W<=15);return W}return{setPosition:g,getPosition:()=>r,scan:p?x:L,getToken:()=>m,getTokenValue:()=>u,getTokenOffset:()=>h,getTokenLength:()=>r-h,getTokenError:()=>k}}e.createScanner=R;function C(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function y(i){return i===10||i===13||i===8232||i===8233}function P(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function b(i,p){const r=[],s=new Object;let u;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function k(T,g,I,F){h.value=T,h.offset=g,h.length=I,h.type=F,h.colonOffset=void 0,u=h}try{a(i,{onObjectBegin:(T,g)=>{if(p<=T)throw s;u=void 0,m=p>T,r.push("")},onObjectProperty:(T,g,I)=>{if(p<g||(k(T,g,I,"property"),r[r.length-1]=T,p<=g+I))throw s},onObjectEnd:(T,g)=>{if(p<=T)throw s;u=void 0,r.pop()},onArrayBegin:(T,g)=>{if(p<=T)throw s;u=void 0,r.push(0)},onArrayEnd:(T,g)=>{if(p<=T)throw s;u=void 0,r.pop()},onLiteralValue:(T,g,I)=>{if(p<g||(k(T,g,I,S(T)),p<=g+I))throw s},onSeparator:(T,g,I)=>{if(p<=g)throw s;if(T===":"&&u&&u.type==="property")u.colonOffset=g,m=!1,u=void 0;else if(T===","){const F=r[r.length-1];typeof F=="number"?r[r.length-1]=F+1:(m=!0,r[r.length-1]=""),u=void 0}}})}catch(T){if(T!==s)throw T}return{path:r,previousNode:u,isAtPropertyKey:m,matches:T=>{let g=0;for(let I=0;g<T.length&&I<r.length;I++)if(T[g]===r[I]||T[g]==="*")g++;else if(T[g]!=="**")return!1;return g===T.length}}}e.getLocation=b;function n(i,p=[],r=A.DEFAULT){let s=null,u=[];const h=[];function m(T){Array.isArray(u)?u.push(T):s!==null&&(u[s]=T)}return a(i,{onObjectBegin:()=>{const T={};m(T),h.push(u),u=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{u=h.pop()},onArrayBegin:()=>{const T=[];m(T),h.push(u),u=T,s=null},onArrayEnd:()=>{u=h.pop()},onLiteralValue:m,onError:(T,g,I)=>{p.push({error:T,offset:g,length:I})}},r),u[0]}e.parse=n;function f(i,p=[],r=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(T){s.type==="property"&&(s.length=T-s.offset,s=s.parent)}function h(T){return s.children.push(T),T}a(i,{onObjectBegin:T=>{s=h({type:"object",offset:T,length:-1,parent:s,children:[]})},onObjectProperty:(T,g,I)=>{s=h({type:"property",offset:g,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:T,offset:g,length:I,parent:s})},onObjectEnd:(T,g)=>{s.length=T+g-s.offset,s=s.parent,u(T+g)},onArrayBegin:(T,g)=>{s=h({type:"array",offset:T,length:-1,parent:s,children:[]})},onArrayEnd:(T,g)=>{s.length=T+g-s.offset,s=s.parent,u(T+g)},onLiteralValue:(T,g,I)=>{h({type:S(T),offset:g,length:I,parent:s,value:T}),u(g+I)},onSeparator:(T,g,I)=>{s.type==="property"&&(T===":"?s.colonOffset=g:T===","&&u(g))},onError:(T,g,I)=>{p.push({error:T,offset:g,length:I})}},r);const k=s.children[0];return k&&delete k.parent,k}e.parseTree=f;function o(i,p){if(!i)return;let r=i;for(let s of p)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let u=!1;for(const h of r.children)if(Array.isArray(h.children)&&h.children[0].value===s){r=h.children[1],u=!0;break}if(!u)return}else{const u=s;if(r.type!=="array"||u<0||!Array.isArray(r.children)||u>=r.children.length)return;r=r.children[u]}return r}e.findNodeAtLocation=o;function l(i){if(!i.parent||!i.parent.children)return[];const p=l(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;p.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&p.push(r)}return p}e.getNodePath=l;function v(i){switch(i.type){case"array":return i.children.map(v);case"object":const p=Object.create(null);for(let r of i.children){const s=r.children[1];s&&(p[r.children[0].value]=v(s))}return p;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=v;function D(i,p,r=!1){return p>=i.offset&&p<i.offset+i.length||r&&p===i.offset+i.length}e.contains=D;function _(i,p,r=!1){if(D(i,p,r)){const s=i.children;if(Array.isArray(s))for(let u=0;u<s.length&&s[u].offset<=p;u++){const h=_(s[u],p,r);if(h)return h}return i}}e.findNodeAtOffset=_;function a(i,p,r=A.DEFAULT){const s=R(i,!1);function u(oe){return oe?()=>oe(s.getTokenOffset(),s.getTokenLength()):()=>!0}function h(oe){return oe?ve=>oe(ve,s.getTokenOffset(),s.getTokenLength()):()=>!0}const m=u(p.onObjectBegin),k=h(p.onObjectProperty),T=u(p.onObjectEnd),g=u(p.onArrayBegin),I=u(p.onArrayEnd),F=h(p.onLiteralValue),L=h(p.onSeparator),w=u(p.onComment),x=h(p.onError),W=r&&r.disallowComments,B=r&&r.allowTrailingComma;function G(){for(;;){const oe=s.scan();switch(s.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:W||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(oe){case 12:case 13:W?H(10):w();break;case 16:H(1);break;case 15:case 14:break;default:return oe}}}function H(oe,ve=[],Ae=[]){if(x(oe),ve.length+Ae.length>0){let Se=s.getToken();for(;Se!==17;){if(ve.indexOf(Se)!==-1){G();break}else if(Ae.indexOf(Se)!==-1)break;Se=G()}}}function U(oe){const ve=s.getTokenValue();return oe?F(ve):k(ve),G(),!0}function V(){switch(s.getToken()){case 11:let oe=0;try{oe=JSON.parse(s.getTokenValue()),typeof oe!="number"&&(H(2),oe=0)}catch(ve){H(2)}F(oe);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return G(),!0}function Q(){return s.getToken()!==10?(H(3,[],[2,5]),!1):(U(!1),s.getToken()===6?(L(":"),G(),Z()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function ne(){m(),G();let oe=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(oe||H(4,[],[]),L(","),G(),s.getToken()===2&&B)break}else oe&&H(6,[],[]);Q()||H(4,[],[2,5]),oe=!0}return T(),s.getToken()!==2?H(7,[2],[]):G(),!0}function ce(){g(),G();let oe=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(oe||H(4,[],[]),L(","),G(),s.getToken()===4&&B)break}else oe&&H(6,[],[]);Z()||H(4,[],[4,5]),oe=!0}return I(),s.getToken()!==4?H(8,[4],[]):G(),!0}function Z(){switch(s.getToken()){case 3:return ce();case 1:return ne();case 10:return U(!0);default:return V()}}return G(),s.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):Z()?(s.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=a;function d(i,p){let r=R(i),s=[],u,h=0,m;do switch(m=r.getPosition(),u=r.scan(),u){case 12:case 13:case 17:h!==m&&s.push(i.substring(h,m)),p!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,p)),h=r.getPosition();break}while(u!==17);return s.join("")}e.stripComments=d;function S(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=S}),define(be[103],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(E){this.executor=E,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(E){this._error=E}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(E){return new c(()=>E(this.getValue()))}}e.Lazy=c}),function(re,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(re=typeof globalThis!="undefined"?globalThis:re||self,re.marked=e())}(this,function(){"use strict";function re(Te,ye){for(var Ce=0;Ce<ye.length;Ce++){var te=ye[Ce];te.enumerable=te.enumerable||!1,te.configurable=!0,"value"in te&&(te.writable=!0),Object.defineProperty(Te,te.key,te)}}function e(Te,ye,Ce){return ye&&re(Te.prototype,ye),Ce&&re(Te,Ce),Te}function c(Te,ye){if(!!Te){if(typeof Te=="string")return M(Te,ye);var Ce=Object.prototype.toString.call(Te).slice(8,-1);if(Ce==="Object"&&Te.constructor&&(Ce=Te.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Te);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return M(Te,ye)}}function M(Te,ye){(ye==null||ye>Te.length)&&(ye=Te.length);for(var Ce=0,te=new Array(ye);Ce<ye;Ce++)te[Ce]=Te[Ce];return te}function E(Te,ye){var Ce=typeof Symbol!="undefined"&&Te[Symbol.iterator]||Te["@@iterator"];if(Ce)return(Ce=Ce.call(Te)).next.bind(Ce);if(Array.isArray(Te)||(Ce=c(Te))||ye&&Te&&typeof Te.length=="number"){Ce&&(Te=Ce);var te=0;return function(){return te>=Te.length?{done:!0}:{done:!1,value:Te[te++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function R(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function C(Te){A.exports.defaults=Te}A.exports={defaults:R(),getDefaults:R,changeDefaults:C};var y=/[&<>"']/,P=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,b=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(ye){return n[ye]};function o(Te,ye){if(ye){if(y.test(Te))return Te.replace(P,f)}else if(t.test(Te))return Te.replace(b,f);return Te}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(Te){return Te.replace(l,function(ye,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var D=/(^|[^\[])\^/g;function _(Te,ye){Te=Te.source||Te,ye=ye||"";var Ce={replace:function(le,ge){return ge=ge.source||ge,ge=ge.replace(D,"$1"),Te=Te.replace(le,ge),Ce},getRegex:function(){return new RegExp(Te,ye)}};return Ce}var a=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(Te,ye,Ce){if(Te){var te;try{te=decodeURIComponent(v(Ce)).replace(a,"").toLowerCase()}catch(le){return null}if(te.indexOf("javascript:")===0||te.indexOf("vbscript:")===0||te.indexOf("data:")===0)return null}ye&&!d.test(Ce)&&(Ce=u(ye,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(le){return null}return Ce}var i={},p=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(Te,ye){i[" "+Te]||(p.test(Te)?i[" "+Te]=Te+"/":i[" "+Te]=T(Te,"/",!0)),Te=i[" "+Te];var Ce=Te.indexOf(":")===-1;return ye.substring(0,2)==="//"?Ce?ye:Te.replace(r,"$1")+ye:ye.charAt(0)==="/"?Ce?ye:Te.replace(s,"$1")+ye:Te+ye}var h={exec:function(){}};function m(Te){for(var ye=1,Ce,te;ye<arguments.length;ye++){Ce=arguments[ye];for(te in Ce)Object.prototype.hasOwnProperty.call(Ce,te)&&(Te[te]=Ce[te])}return Te}function k(Te,ye){var Ce=Te.replace(/\|/g,function(ge,fe,Pe){for(var xe=!1,Oe=fe;--Oe>=0&&Pe[Oe]==="\\";)xe=!xe;return xe?"|":" |"}),te=Ce.split(/ \|/),le=0;if(te[0].trim()||te.shift(),te[te.length-1].trim()||te.pop(),te.length>ye)te.splice(ye);else for(;te.length<ye;)te.push("");for(;le<te.length;le++)te[le]=te[le].trim().replace(/\\\|/g,"|");return te}function T(Te,ye,Ce){var te=Te.length;if(te===0)return"";for(var le=0;le<te;){var ge=Te.charAt(te-le-1);if(ge===ye&&!Ce)le++;else if(ge!==ye&&Ce)le++;else break}return Te.substr(0,te-le)}function g(Te,ye){if(Te.indexOf(ye[1])===-1)return-1;for(var Ce=Te.length,te=0,le=0;le<Ce;le++)if(Te[le]==="\\")le++;else if(Te[le]===ye[0])te++;else if(Te[le]===ye[1]&&(te--,te<0))return le;return-1}function I(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(Te,ye){if(ye<1)return"";for(var Ce="";ye>1;)ye&1&&(Ce+=Te),ye>>=1,Te+=Te;return Ce+Te}var L={escape:o,unescape:v,edit:_,cleanUrl:S,resolveUrl:u,noopTest:h,merge:m,splitCells:k,rtrim:T,findClosingBracket:g,checkSanitizeDeprecation:I,repeatString:F},w=A.exports.defaults,x=L.rtrim,W=L.splitCells,B=L.escape,G=L.findClosingBracket;function H(Te,ye,Ce,te){var le=ye.href,ge=ye.title?B(ye.title):null,fe=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){te.state.inLink=!0;var Pe={type:"link",raw:Ce,href:le,title:ge,text:fe,tokens:te.inlineTokens(fe,[])};return te.state.inLink=!1,Pe}else return{type:"image",raw:Ce,href:le,title:ge,text:B(fe)}}function U(Te,ye){var Ce=Te.match(/^(\s+)(?:```)/);if(Ce===null)return ye;var te=Ce[1];return ye.split(`
`).map(function(le){var ge=le.match(/^\s+/);if(ge===null)return le;var fe=ge[0];return fe.length>=te.length?le.slice(te.length):le}).join(`
`)}var V=function(){function Te(Ce){this.options=Ce||w}var ye=Te.prototype;return ye.space=function(te){var le=this.rules.block.newline.exec(te);if(le)return le[0].length>1?{type:"space",raw:le[0]}:{raw:`
`}},ye.code=function(te){var le=this.rules.block.code.exec(te);if(le){var ge=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:x(ge,`
`)}}},ye.fences=function(te){var le=this.rules.block.fences.exec(te);if(le){var ge=le[0],fe=U(ge,le[3]||"");return{type:"code",raw:ge,lang:le[2]?le[2].trim():le[2],text:fe}}},ye.heading=function(te){var le=this.rules.block.heading.exec(te);if(le){var ge=le[2].trim();if(/#$/.test(ge)){var fe=x(ge,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(ge=fe.trim())}var Pe={type:"heading",raw:le[0],depth:le[1].length,text:ge,tokens:[]};return this.lexer.inline(Pe.text,Pe.tokens),Pe}},ye.hr=function(te){var le=this.rules.block.hr.exec(te);if(le)return{type:"hr",raw:le[0]}},ye.blockquote=function(te){var le=this.rules.block.blockquote.exec(te);if(le){var ge=le[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},ye.list=function(te){var le=this.rules.block.list.exec(te);if(le){var ge,fe,Pe,xe,Oe,Ke,tt,Le,de,pe,Y=le[1].trim(),z=Y.length>1,we={type:"list",raw:"",ordered:z,start:z?+Y.slice(0,-1):"",loose:!1,items:[]};Y=z?"\\d{1,9}\\"+Y.slice(-1):"\\"+Y,this.options.pedantic&&(Y=z?Y:"[*+-]");for(var Ie=new RegExp("^( {0,3}"+Y+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");te&&!(this.rules.block.hr.test(te)||!(le=Ie.exec(te)));){de=le[2].split(`
`),this.options.pedantic?(xe=2,pe=de[0].trimLeft()):(xe=le[2].search(/[^ ]/),xe=le[1].length+(xe>4?1:xe),pe=de[0].slice(xe-le[1].length)),Ke=!1,ge=le[0],!de[0]&&/^ *$/.test(de[1])&&(ge=le[1]+de.slice(0,2).join(`
`)+`
`,we.loose=!0,de=[]);var Je=new RegExp("^ {0,"+Math.min(3,xe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Oe=1;Oe<de.length;Oe++){if(Le=de[Oe],this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Je.test(Le)){ge=le[1]+de.slice(0,Oe).join(`
`)+`
`;break}if(!Ke){Le.trim()||(Ke=!0),Le.search(/[^ ]/)>=xe?pe+=`
`+Le.slice(xe):pe+=`
`+Le;continue}if(Le.search(/[^ ]/)>=xe||!Le.trim()){pe+=`
`+Le.slice(xe);continue}else{ge=le[1]+de.slice(0,Oe).join(`
`)+`
`;break}}we.loose||(tt?we.loose=!0:/\n *\n *$/.test(ge)&&(tt=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(pe),fe&&(Pe=fe[0]!=="[ ] ",pe=pe.replace(/^\[[ xX]\] +/,""))),we.items.push({type:"list_item",raw:ge,task:!!fe,checked:Pe,loose:!1,text:pe}),we.raw+=ge,te=te.slice(ge.length)}we.items[we.items.length-1].raw=ge.trimRight(),we.items[we.items.length-1].text=pe.trimRight(),we.raw=we.raw.trimRight();var Ue=we.items.length;for(Oe=0;Oe<Ue;Oe++)this.lexer.state.top=!1,we.items[Oe].tokens=this.lexer.blockTokens(we.items[Oe].text,[]),we.items[Oe].tokens.some(function(dt){return dt.type==="space"})&&(we.loose=!0,we.items[Oe].loose=!0);return we}},ye.html=function(te){var le=this.rules.block.html.exec(te);if(le){var ge={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};return this.options.sanitize&&(ge.type="paragraph",ge.text=this.options.sanitizer?this.options.sanitizer(le[0]):B(le[0]),ge.tokens=[],this.lexer.inline(ge.text,ge.tokens)),ge}},ye.def=function(te){var le=this.rules.block.def.exec(te);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var ge=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:le[0],href:le[2],title:le[3]}}},ye.table=function(te){var le=this.rules.block.table.exec(te);if(le){var ge={type:"table",header:W(le[1]).map(function(tt){return{text:tt}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]?le[3].replace(/\n$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=le[0];var fe=ge.align.length,Pe,xe,Oe,Ke;for(Pe=0;Pe<fe;Pe++)/^ *-+: *$/.test(ge.align[Pe])?ge.align[Pe]="right":/^ *:-+: *$/.test(ge.align[Pe])?ge.align[Pe]="center":/^ *:-+ *$/.test(ge.align[Pe])?ge.align[Pe]="left":ge.align[Pe]=null;for(fe=ge.rows.length,Pe=0;Pe<fe;Pe++)ge.rows[Pe]=W(ge.rows[Pe],ge.header.length).map(function(tt){return{text:tt}});for(fe=ge.header.length,xe=0;xe<fe;xe++)ge.header[xe].tokens=[],this.lexer.inlineTokens(ge.header[xe].text,ge.header[xe].tokens);for(fe=ge.rows.length,xe=0;xe<fe;xe++)for(Ke=ge.rows[xe],Oe=0;Oe<Ke.length;Oe++)Ke[Oe].tokens=[],this.lexer.inlineTokens(Ke[Oe].text,Ke[Oe].tokens);return ge}}},ye.lheading=function(te){var le=this.rules.block.lheading.exec(te);if(le){var ge={type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.paragraph=function(te){var le=this.rules.block.paragraph.exec(te);if(le){var ge={type:"paragraph",raw:le[0],text:le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.text=function(te){var le=this.rules.block.text.exec(te);if(le){var ge={type:"text",raw:le[0],text:le[0],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.escape=function(te){var le=this.rules.inline.escape.exec(te);if(le)return{type:"escape",raw:le[0],text:B(le[1])}},ye.tag=function(te){var le=this.rules.inline.tag.exec(te);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):B(le[0]):le[0]}},ye.link=function(te){var le=this.rules.inline.link.exec(te);if(le){var ge=le[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var fe=x(ge.slice(0,-1),"\\");if((ge.length-fe.length)%2==0)return}else{var Pe=G(le[2],"()");if(Pe>-1){var xe=le[0].indexOf("!")===0?5:4,Oe=xe+le[1].length+Pe;le[2]=le[2].substring(0,Pe),le[0]=le[0].substring(0,Oe).trim(),le[3]=""}}var Ke=le[2],tt="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ke);Le&&(Ke=Le[1],tt=Le[3])}else tt=le[3]?le[3].slice(1,-1):"";return Ke=Ke.trim(),/^</.test(Ke)&&(this.options.pedantic&&!/>$/.test(ge)?Ke=Ke.slice(1):Ke=Ke.slice(1,-1)),H(le,{href:Ke&&Ke.replace(this.rules.inline._escapes,"$1"),title:tt&&tt.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},ye.reflink=function(te,le){var ge;if((ge=this.rules.inline.reflink.exec(te))||(ge=this.rules.inline.nolink.exec(te))){var fe=(ge[2]||ge[1]).replace(/\s+/g," ");if(fe=le[fe.toLowerCase()],!fe||!fe.href){var Pe=ge[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return H(ge,fe,ge[0],this.lexer)}},ye.emStrong=function(te,le,ge){ge===void 0&&(ge="");var fe=this.rules.inline.emStrong.lDelim.exec(te);if(!!fe&&!(fe[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=fe[1]||fe[2]||"";if(!Pe||Pe&&(ge===""||this.rules.inline.punctuation.exec(ge))){var xe=fe[0].length-1,Oe,Ke,tt=xe,Le=0,de=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,le=le.slice(-1*te.length+xe);(fe=de.exec(le))!=null;)if(Oe=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Oe){if(Ke=Oe.length,fe[3]||fe[4]){tt+=Ke;continue}else if((fe[5]||fe[6])&&xe%3&&!((xe+Ke)%3)){Le+=Ke;continue}if(tt-=Ke,!(tt>0)){if(Ke=Math.min(Ke,Ke+tt+Le),Math.min(xe,Ke)%2){var pe=te.slice(1,xe+fe.index+Ke);return{type:"em",raw:te.slice(0,xe+fe.index+Ke+1),text:pe,tokens:this.lexer.inlineTokens(pe,[])}}var Y=te.slice(2,xe+fe.index+Ke-1);return{type:"strong",raw:te.slice(0,xe+fe.index+Ke+1),text:Y,tokens:this.lexer.inlineTokens(Y,[])}}}}}},ye.codespan=function(te){var le=this.rules.inline.code.exec(te);if(le){var ge=le[2].replace(/\n/g," "),fe=/[^ ]/.test(ge),Pe=/^ /.test(ge)&&/ $/.test(ge);return fe&&Pe&&(ge=ge.substring(1,ge.length-1)),ge=B(ge,!0),{type:"codespan",raw:le[0],text:ge}}},ye.br=function(te){var le=this.rules.inline.br.exec(te);if(le)return{type:"br",raw:le[0]}},ye.del=function(te){var le=this.rules.inline.del.exec(te);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2],[])}},ye.autolink=function(te,le){var ge=this.rules.inline.autolink.exec(te);if(ge){var fe,Pe;return ge[2]==="@"?(fe=B(this.options.mangle?le(ge[1]):ge[1]),Pe="mailto:"+fe):(fe=B(ge[1]),Pe=fe),{type:"link",raw:ge[0],text:fe,href:Pe,tokens:[{type:"text",raw:fe,text:fe}]}}},ye.url=function(te,le){var ge;if(ge=this.rules.inline.url.exec(te)){var fe,Pe;if(ge[2]==="@")fe=B(this.options.mangle?le(ge[0]):ge[0]),Pe="mailto:"+fe;else{var xe;do xe=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(xe!==ge[0]);fe=B(ge[0]),ge[1]==="www."?Pe="http://"+fe:Pe=fe}return{type:"link",raw:ge[0],text:fe,href:Pe,tokens:[{type:"text",raw:fe,text:fe}]}}},ye.inlineText=function(te,le){var ge=this.rules.inline.text.exec(te);if(ge){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):B(ge[0]):ge[0]:fe=B(this.options.smartypants?le(ge[0]):ge[0]),{type:"text",raw:ge[0],text:fe}}},Te}(),Q=L.noopTest,ne=L.edit,ce=L.merge,Z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:Q,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Z._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Z.def=ne(Z.def).replace("label",Z._label).replace("title",Z._title).getRegex(),Z.bullet=/(?:[*+-]|\d{1,9}[.)])/,Z.listItemStart=ne(/^( *)(bull) */).replace("bull",Z.bullet).getRegex(),Z.list=ne(Z.list).replace(/bull/g,Z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Z.def.source+")").getRegex(),Z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Z.html=ne(Z.html,"i").replace("comment",Z._comment).replace("tag",Z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Z.paragraph=ne(Z._paragraph).replace("hr",Z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Z._tag).getRegex(),Z.blockquote=ne(Z.blockquote).replace("paragraph",Z.paragraph).getRegex(),Z.normal=ce({},Z),Z.gfm=ce({},Z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Z.gfm.table=ne(Z.gfm.table).replace("hr",Z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Z._tag).getRegex(),Z.pedantic=ce({},Z.normal,{html:ne(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:Q,paragraph:ne(Z.normal._paragraph).replace("hr",Z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Q,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Q,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=ne(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=ne(Z._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=ne(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=ne(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=ne(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=ne(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=ne(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=ne(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=ne(oe.reflink).replace("label",oe._label).getRegex(),oe.reflinkSearch=ne(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=ce({},oe),oe.pedantic=ce({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:ne(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:ne(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=ce({},oe.normal,{escape:ne(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=ne(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=ce({},oe.gfm,{br:ne(oe.br).replace("{2,}","*").getRegex(),text:ne(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:Z,inline:oe},Ae=V,Se=A.exports.defaults,Ne=ve.block,We=ve.inline,je=L.repeatString;function qe(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(Te){var ye="",Ce,te,le=Te.length;for(Ce=0;Ce<le;Ce++)te=Te.charCodeAt(Ce),Math.random()>.5&&(te="x"+te.toString(16)),ye+="&#"+te+";";return ye}var K=function(){function Te(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Se,this.options.tokenizer=this.options.tokenizer||new Ae,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var te={block:Ne.normal,inline:We.normal};this.options.pedantic?(te.block=Ne.pedantic,te.inline=We.pedantic):this.options.gfm&&(te.block=Ne.gfm,this.options.breaks?te.inline=We.breaks:te.inline=We.gfm),this.tokenizer.rules=te}Te.lex=function(te,le){var ge=new Te(le);return ge.lex(te)},Te.lexInline=function(te,le){var ge=new Te(le);return ge.inlineTokens(te)};var ye=Te.prototype;return ye.lex=function(te){te=te.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(te,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},ye.blockTokens=function(te,le){var ge=this;le===void 0&&(le=[]),this.options.pedantic&&(te=te.replace(/^ +$/gm,""));for(var fe,Pe,xe,Oe;te;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(tt){return(fe=tt.call({lexer:ge},te,le))?(te=te.substring(fe.raw.length),le.push(fe),!0):!1}))){if(fe=this.tokenizer.space(te)){te=te.substring(fe.raw.length),fe.type&&le.push(fe);continue}if(fe=this.tokenizer.code(te)){te=te.substring(fe.raw.length),Pe=le[le.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+fe.raw,Pe.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):le.push(fe);continue}if(fe=this.tokenizer.fences(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.heading(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.hr(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.blockquote(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.list(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.html(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.def(te)){te=te.substring(fe.raw.length),Pe=le[le.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+fe.raw,Pe.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.lheading(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(xe=te,this.options.extensions&&this.options.extensions.startBlock&&function(){var tt=1/0,Le=te.slice(1),de=void 0;ge.options.extensions.startBlock.forEach(function(pe){de=pe.call({lexer:this},Le),typeof de=="number"&&de>=0&&(tt=Math.min(tt,de))}),tt<1/0&&tt>=0&&(xe=te.substring(0,tt+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(xe))){Pe=le[le.length-1],Oe&&Pe.type==="paragraph"?(Pe.raw+=`
`+fe.raw,Pe.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):le.push(fe),Oe=xe.length!==te.length,te=te.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(te)){te=te.substring(fe.raw.length),Pe=le[le.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+fe.raw,Pe.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):le.push(fe);continue}if(te){var Ke="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(Ke);break}else throw new Error(Ke)}}return this.state.top=!0,le},ye.inline=function(te,le){this.inlineQueue.push({src:te,tokens:le})},ye.inlineTokens=function(te,le){var ge=this;le===void 0&&(le=[]);var fe,Pe,xe,Oe=te,Ke,tt,Le;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;(Ke=this.tokenizer.rules.inline.reflinkSearch.exec(Oe))!=null;)de.includes(Ke[0].slice(Ke[0].lastIndexOf("[")+1,-1))&&(Oe=Oe.slice(0,Ke.index)+"["+je("a",Ke[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ke=this.tokenizer.rules.inline.blockSkip.exec(Oe))!=null;)Oe=Oe.slice(0,Ke.index)+"["+je("a",Ke[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ke=this.tokenizer.rules.inline.escapedEmSt.exec(Oe))!=null;)Oe=Oe.slice(0,Ke.index)+"++"+Oe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;te;)if(tt||(Le=""),tt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Y){return(fe=Y.call({lexer:ge},te,le))?(te=te.substring(fe.raw.length),le.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.tag(te)){te=te.substring(fe.raw.length),Pe=le[le.length-1],Pe&&fe.type==="text"&&Pe.type==="text"?(Pe.raw+=fe.raw,Pe.text+=fe.text):le.push(fe);continue}if(fe=this.tokenizer.link(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.reflink(te,this.tokens.links)){te=te.substring(fe.raw.length),Pe=le[le.length-1],Pe&&fe.type==="text"&&Pe.type==="text"?(Pe.raw+=fe.raw,Pe.text+=fe.text):le.push(fe);continue}if(fe=this.tokenizer.emStrong(te,Oe,Le)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.codespan(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.br(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.del(te)){te=te.substring(fe.raw.length),le.push(fe);continue}if(fe=this.tokenizer.autolink(te,$)){te=te.substring(fe.raw.length),le.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(te,$))){te=te.substring(fe.raw.length),le.push(fe);continue}if(xe=te,this.options.extensions&&this.options.extensions.startInline&&function(){var Y=1/0,z=te.slice(1),we=void 0;ge.options.extensions.startInline.forEach(function(Ie){we=Ie.call({lexer:this},z),typeof we=="number"&&we>=0&&(Y=Math.min(Y,we))}),Y<1/0&&Y>=0&&(xe=te.substring(0,Y+1))}(),fe=this.tokenizer.inlineText(xe,qe)){te=te.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(Le=fe.raw.slice(-1)),tt=!0,Pe=le[le.length-1],Pe&&Pe.type==="text"?(Pe.raw+=fe.raw,Pe.text+=fe.text):le.push(fe);continue}if(te){var pe="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return le},e(Te,null,[{key:"rules",get:function(){return{block:Ne,inline:We}}}]),Te}(),ee=A.exports.defaults,ae=L.cleanUrl,q=L.escape,se=function(){function Te(Ce){this.options=Ce||ee}var ye=Te.prototype;return ye.code=function(te,le,ge){var fe=(le||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(te,fe);Pe!=null&&Pe!==te&&(ge=!0,te=Pe)}return te=te.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+q(fe,!0)+'">'+(ge?te:q(te,!0))+`</code></pre>
`:"<pre><code>"+(ge?te:q(te,!0))+`</code></pre>
`},ye.blockquote=function(te){return`<blockquote>
`+te+`</blockquote>
`},ye.html=function(te){return te},ye.heading=function(te,le,ge,fe){return this.options.headerIds?"<h"+le+' id="'+this.options.headerPrefix+fe.slug(ge)+'">'+te+"</h"+le+`>
`:"<h"+le+">"+te+"</h"+le+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(te,le,ge){var fe=le?"ol":"ul",Pe=le&&ge!==1?' start="'+ge+'"':"";return"<"+fe+Pe+`>
`+te+"</"+fe+`>
`},ye.listitem=function(te){return"<li>"+te+`</li>
`},ye.checkbox=function(te){return"<input "+(te?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(te){return"<p>"+te+`</p>
`},ye.table=function(te,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+te+`</thead>
`+le+`</table>
`},ye.tablerow=function(te){return`<tr>
`+te+`</tr>
`},ye.tablecell=function(te,le){var ge=le.header?"th":"td",fe=le.align?"<"+ge+' align="'+le.align+'">':"<"+ge+">";return fe+te+"</"+ge+`>
`},ye.strong=function(te){return"<strong>"+te+"</strong>"},ye.em=function(te){return"<em>"+te+"</em>"},ye.codespan=function(te){return"<code>"+te+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(te){return"<del>"+te+"</del>"},ye.link=function(te,le,ge){if(te=ae(this.options.sanitize,this.options.baseUrl,te),te===null)return ge;var fe='<a href="'+q(te)+'"';return le&&(fe+=' title="'+le+'"'),fe+=">"+ge+"</a>",fe},ye.image=function(te,le,ge){if(te=ae(this.options.sanitize,this.options.baseUrl,te),te===null)return ge;var fe='<img src="'+te+'" alt="'+ge+'"';return le&&(fe+=' title="'+le+'"'),fe+=this.options.xhtml?"/>":">",fe},ye.text=function(te){return te},Te}(),he=function(){function Te(){}var ye=Te.prototype;return ye.strong=function(te){return te},ye.em=function(te){return te},ye.codespan=function(te){return te},ye.del=function(te){return te},ye.html=function(te){return te},ye.text=function(te){return te},ye.link=function(te,le,ge){return""+ge},ye.image=function(te,le,ge){return""+ge},ye.br=function(){return""},Te}(),Re=function(){function Te(){this.seen={}}var ye=Te.prototype;return ye.serialize=function(te){return te.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(te,le){var ge=te,fe=0;if(this.seen.hasOwnProperty(ge)){fe=this.seen[te];do fe++,ge=te+"-"+fe;while(this.seen.hasOwnProperty(ge))}return le||(this.seen[te]=fe,this.seen[ge]=0),ge},ye.slug=function(te,le){le===void 0&&(le={});var ge=this.serialize(te);return this.getNextSafeSlug(ge,le.dryrun)},Te}(),Be=se,ze=he,Qe=Re,it=A.exports.defaults,ke=L.unescape,Ze=function(){function Te(Ce){this.options=Ce||it,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ze,this.slugger=new Qe}Te.parse=function(te,le){var ge=new Te(le);return ge.parse(te)},Te.parseInline=function(te,le){var ge=new Te(le);return ge.parseInline(te)};var ye=Te.prototype;return ye.parse=function(te,le){le===void 0&&(le=!0);var ge="",fe,Pe,xe,Oe,Ke,tt,Le,de,pe,Y,z,we,Ie,Je,Ue,dt,gt,lt,ft,ut=te.length;for(fe=0;fe<ut;fe++){if(Y=te[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Y.type]&&(ft=this.options.extensions.renderers[Y.type].call({parser:this},Y),ft!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Y.type))){ge+=ft||"";continue}switch(Y.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(Y.tokens),Y.depth,ke(this.parseInline(Y.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(Y.text,Y.lang,Y.escaped);continue}case"table":{for(de="",Le="",Oe=Y.header.length,Pe=0;Pe<Oe;Pe++)Le+=this.renderer.tablecell(this.parseInline(Y.header[Pe].tokens),{header:!0,align:Y.align[Pe]});for(de+=this.renderer.tablerow(Le),pe="",Oe=Y.rows.length,Pe=0;Pe<Oe;Pe++){for(tt=Y.rows[Pe],Le="",Ke=tt.length,xe=0;xe<Ke;xe++)Le+=this.renderer.tablecell(this.parseInline(tt[xe].tokens),{header:!1,align:Y.align[xe]});pe+=this.renderer.tablerow(Le)}ge+=this.renderer.table(de,pe);continue}case"blockquote":{pe=this.parse(Y.tokens),ge+=this.renderer.blockquote(pe);continue}case"list":{for(z=Y.ordered,we=Y.start,Ie=Y.loose,Oe=Y.items.length,pe="",Pe=0;Pe<Oe;Pe++)Ue=Y.items[Pe],dt=Ue.checked,gt=Ue.task,Je="",Ue.task&&(lt=this.renderer.checkbox(dt),Ie?Ue.tokens.length>0&&Ue.tokens[0].type==="paragraph"?(Ue.tokens[0].text=lt+" "+Ue.tokens[0].text,Ue.tokens[0].tokens&&Ue.tokens[0].tokens.length>0&&Ue.tokens[0].tokens[0].type==="text"&&(Ue.tokens[0].tokens[0].text=lt+" "+Ue.tokens[0].tokens[0].text)):Ue.tokens.unshift({type:"text",text:lt}):Je+=lt),Je+=this.parse(Ue.tokens,Ie),pe+=this.renderer.listitem(Je,gt,dt);ge+=this.renderer.list(pe,z,we);continue}case"html":{ge+=this.renderer.html(Y.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(Y.tokens));continue}case"text":{for(pe=Y.tokens?this.parseInline(Y.tokens):Y.text;fe+1<ut&&te[fe+1].type==="text";)Y=te[++fe],pe+=`
`+(Y.tokens?this.parseInline(Y.tokens):Y.text);ge+=le?this.renderer.paragraph(pe):pe;continue}default:{var pt='Token with "'+Y.type+'" type was not found.';if(this.options.silent){console.error(pt);return}else throw new Error(pt)}}}return ge},ye.parseInline=function(te,le){le=le||this.renderer;var ge="",fe,Pe,xe,Oe=te.length;for(fe=0;fe<Oe;fe++){if(Pe=te[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(xe=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),xe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){ge+=xe||"";continue}switch(Pe.type){case"escape":{ge+=le.text(Pe.text);break}case"html":{ge+=le.html(Pe.text);break}case"link":{ge+=le.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,le));break}case"image":{ge+=le.image(Pe.href,Pe.title,Pe.text);break}case"strong":{ge+=le.strong(this.parseInline(Pe.tokens,le));break}case"em":{ge+=le.em(this.parseInline(Pe.tokens,le));break}case"codespan":{ge+=le.codespan(Pe.text);break}case"br":{ge+=le.br();break}case"del":{ge+=le.del(this.parseInline(Pe.tokens,le));break}case"text":{ge+=le.text(Pe.text);break}default:{var Ke='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(Ke);return}else throw new Error(Ke)}}}return ge},Te}(),j=K,J=Ze,me=V,He=se,Ye=he,st=Re,ot=L.merge,Et=L.checkSanitizeDeprecation,mt=L.escape,Dt=A.exports.getDefaults,Pt=A.exports.changeDefaults,It=A.exports.defaults;function Xe(Te,ye,Ce){if(typeof Te=="undefined"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof ye=="function"&&(Ce=ye,ye=null),ye=ot({},Xe.defaults,ye||{}),Et(ye),Ce){var te=ye.highlight,le;try{le=j.lex(Te,ye)}catch(xe){return Ce(xe)}var ge=function(Oe){var Ke;if(!Oe)try{ye.walkTokens&&Xe.walkTokens(le,ye.walkTokens),Ke=J.parse(le,ye)}catch(tt){Oe=tt}return ye.highlight=te,Oe?Ce(Oe):Ce(null,Ke)};if(!te||te.length<3||(delete ye.highlight,!le.length))return ge();var fe=0;Xe.walkTokens(le,function(xe){xe.type==="code"&&(fe++,setTimeout(function(){te(xe.text,xe.lang,function(Oe,Ke){if(Oe)return ge(Oe);Ke!=null&&Ke!==xe.text&&(xe.text=Ke,xe.escaped=!0),fe--,fe===0&&ge()})},0))}),fe===0&&ge();return}try{var Pe=j.lex(Te,ye);return ye.walkTokens&&Xe.walkTokens(Pe,ye.walkTokens),J.parse(Pe,ye)}catch(xe){if(xe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+mt(xe.message+"",!0)+"</pre>";throw xe}}Xe.options=Xe.setOptions=function(Te){return ot(Xe.defaults,Te),Pt(Xe.defaults),Xe},Xe.getDefaults=Dt,Xe.defaults=It,Xe.use=function(){for(var Te=this,ye=arguments.length,Ce=new Array(ye),te=0;te<ye;te++)Ce[te]=arguments[te];var le=ot.apply(void 0,[{}].concat(Ce)),ge=Xe.defaults.extensions||{renderers:{},childTokens:{}},fe;Ce.forEach(function(Pe){if(Pe.extensions&&(fe=!0,Pe.extensions.forEach(function(Oe){if(!Oe.name)throw new Error("extension name required");if(Oe.renderer){var Ke=ge.renderers?ge.renderers[Oe.name]:null;Ke?ge.renderers[Oe.name]=function(){for(var tt=arguments.length,Le=new Array(tt),de=0;de<tt;de++)Le[de]=arguments[de];var pe=Oe.renderer.apply(this,Le);return pe===!1&&(pe=Ke.apply(this,Le)),pe}:ge.renderers[Oe.name]=Oe.renderer}if(Oe.tokenizer){if(!Oe.level||Oe.level!=="block"&&Oe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Oe.level]?ge[Oe.level].unshift(Oe.tokenizer):ge[Oe.level]=[Oe.tokenizer],Oe.start&&(Oe.level==="block"?ge.startBlock?ge.startBlock.push(Oe.start):ge.startBlock=[Oe.start]:Oe.level==="inline"&&(ge.startInline?ge.startInline.push(Oe.start):ge.startInline=[Oe.start]))}Oe.childTokens&&(ge.childTokens[Oe.name]=Oe.childTokens)})),Pe.renderer&&function(){var Oe=Xe.defaults.renderer||new He,Ke=function(de){var pe=Oe[de];Oe[de]=function(){for(var Y=arguments.length,z=new Array(Y),we=0;we<Y;we++)z[we]=arguments[we];var Ie=Pe.renderer[de].apply(Oe,z);return Ie===!1&&(Ie=pe.apply(Oe,z)),Ie}};for(var tt in Pe.renderer)Ke(tt);le.renderer=Oe}(),Pe.tokenizer&&function(){var Oe=Xe.defaults.tokenizer||new me,Ke=function(de){var pe=Oe[de];Oe[de]=function(){for(var Y=arguments.length,z=new Array(Y),we=0;we<Y;we++)z[we]=arguments[we];var Ie=Pe.tokenizer[de].apply(Oe,z);return Ie===!1&&(Ie=pe.apply(Oe,z)),Ie}};for(var tt in Pe.tokenizer)Ke(tt);le.tokenizer=Oe}(),Pe.walkTokens){var xe=Xe.defaults.walkTokens;le.walkTokens=function(Oe){Pe.walkTokens.call(Te,Oe),xe&&xe(Oe)}}fe&&(le.extensions=ge),Xe.setOptions(le)})},Xe.walkTokens=function(Te,ye){for(var Ce=function(){var fe=le.value;switch(ye(fe),fe.type){case"table":{for(var Pe=E(fe.header),xe;!(xe=Pe()).done;){var Oe=xe.value;Xe.walkTokens(Oe.tokens,ye)}for(var Ke=E(fe.rows),tt;!(tt=Ke()).done;)for(var Le=tt.value,de=E(Le),pe;!(pe=de()).done;){var Y=pe.value;Xe.walkTokens(Y.tokens,ye)}break}case"list":{Xe.walkTokens(fe.items,ye);break}default:Xe.defaults.extensions&&Xe.defaults.extensions.childTokens&&Xe.defaults.extensions.childTokens[fe.type]?Xe.defaults.extensions.childTokens[fe.type].forEach(function(z){Xe.walkTokens(fe[z],ye)}):fe.tokens&&Xe.walkTokens(fe.tokens,ye)}},te=E(Te),le;!(le=te()).done;)Ce()},Xe.parseInline=function(Te,ye){if(typeof Te=="undefined"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");ye=ot({},Xe.defaults,ye||{}),Et(ye);try{var Ce=j.lexInline(Te,ye);return ye.walkTokens&&Xe.walkTokens(Ce,ye.walkTokens),J.parseInline(Ce,ye)}catch(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+mt(te.message+"",!0)+"</pre>";throw te}},Xe.Parser=J,Xe.parser=J.parse,Xe.Renderer=He,Xe.TextRenderer=Ye,Xe.Lexer=j,Xe.lexer=j.lex,Xe.Tokenizer=me,Xe.Slugger=st,Xe.parse=Xe;var St=Xe;return St}),define(be[75],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(R,C,y){return Math.min(Math.max(R,C),y)}e.clamp=c;function M(R,C){return(C+R%C)%C}e.rot=M;class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class A{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A}),function(){function re(E){const A=[];typeof E=="number"&&A.push("code/timeOrigin",E);function R(y){A.push(y,Date.now())}function C(){const y=[];for(let P=0;P<A.length;P+=2)y.push({name:A[P],startTime:A[P+1]});return y}return{mark:R,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(E+R.startTime)});return A}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function c(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=c(M))}(),define(be[104],Ee([0,1]),function(re,e){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class M{constructor(C,y,P){this.level=C,this.key=y,this.value=P,this.forward=[]}}const E=void 0;class A{constructor(C,y=2**16){this.comparator=C,this[c]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(y)|0),this._header=new M(this._maxLevel,E,E)}get size(){return this._size}clear(){this._header=new M(this._maxLevel,E,E)}has(C){return Boolean(A._search(this,C,this.comparator))}get(C){return A._search(this,C,this.comparator)?.value}set(C,y){return A._insert(this,C,y,this.comparator)&&(this._size+=1),this}delete(C){const y=A._delete(this,C,this.comparator);return y&&(this._size-=1),y}forEach(C,y){let P=this._header.forward[0];for(;P;)C.call(y,P.value,P.key,this),P=P.forward[0]}[(c=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this._header.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this._header.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this._header.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",y=this._header.forward[0];for(;y;)C+=`node(${y.key}, ${y.value}, lvl:${y.level})`,y=y.forward[0];return C}static _search(C,y,P){let t=C._header;for(let b=C._level-1;b>=0;b--)for(;t.forward[b]&&P(t.forward[b].key,y)<0;)t=t.forward[b];if(t=t.forward[0],t&&P(t.key,y)===0)return t}static _insert(C,y,P,t){let b=[],n=C._header;for(let f=C._level-1;f>=0;f--){for(;n.forward[f]&&t(n.forward[f].key,y)<0;)n=n.forward[f];b[f]=n}if(n=n.forward[0],n&&t(n.key,y)===0)return n.value=P,!1;{let f=A._randomLevel(C);if(f>C._level){for(let o=C._level;o<f;o++)b[o]=C._header;C._level=f}n=new M(f,y,P);for(let o=0;o<f;o++)n.forward[o]=b[o].forward[o],b[o].forward[o]=n;return!0}}static _randomLevel(C,y=.5){let P=1;for(;Math.random()<y&&P<C._maxLevel;)P+=1;return P}static _delete(C,y,P){let t=[],b=C._header;for(let n=C._level-1;n>=0;n--){for(;b.forward[n]&&P(b.forward[n].key,y)<0;)b=b.forward[n];t[n]=b}if(b=b.forward[0],!b||P(b.key,y)!==0)return!1;for(let n=0;n<C._level&&t[n].forward[n]===b;n++)t[n].forward[n]=b.forward[n];for(;C._level>0&&C._header.forward[C._level-1]===E;)C._level-=1;return!0}}e.SkipList=A}),define(be[34],Ee([0,1,3]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new c.Emitter}add(b){const n=this._icons.get(b.id);n?b.description?n.description=b.description:console.error(`Duplicate registration of codicon ${b.id}`):(this._icons.set(b.id,b),this._onDidRegister.fire(b))}get(b){return this._icons.get(b)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const E=new M;e.iconRegistry=E;function A(t,b){return new C(t,b)}e.registerCodicon=A;function R(t){return t?t.replace(/\$\((.*?)\)/g,(b,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=R;class C{constructor(b,n,f){this.id=b,this.definition=n,this.description=f,E.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function y(t,b){const n=["codicon","codicon-"+t];return b&&n.push("codicon-modifier-"+b),n}e.getClassNamesArray=y;var P;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const b=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(l){if(l instanceof C)return["codicon","codicon-"+l.id];const v=b.exec(l.id);if(!v)return n(C.error);let[,D,_]=v;const a=["codicon","codicon-"+D];return _&&a.push("codicon-modifier-"+_.substr(1)),a}t.asClassNameArray=n;function f(l){return n(l).join(" ")}t.asClassName=f;function o(l){return"."+n(l).join(".")}t.asCSSSelector=o})(P=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",{fontCharacter:"\\eb0f"}),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(be[105],Ee([0,1,16,6]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function E(a){const d=a;return d?[d.on,d.pause,d.resume,d.destroy].every(S=>typeof S=="function"):!1}e.isReadableStream=E;function A(a){const d=a;return d?E(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=A;function R(a,d){return new C(a,d)}e.newWriteableStream=R;class C{constructor(d,S){this.reducer=d,this.options=S,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(S=>this.pendingWritePromises.push(S))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d!="undefined"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(S=>S(d))}emitError(d){this.listeners.error.length===0?(0,c.onUnexpectedError)(d):this.listeners.error.slice(0).forEach(S=>S(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,S){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(S),this.resume();break;case"end":this.listeners.end.push(S),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(S),this.state.flowing&&this.flowErrors();break}}removeListener(d,S){if(this.state.destroyed)return;let i;switch(d){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const p=i.indexOf(S);p>=0&&i.splice(p,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const S=[...this.pendingWritePromises];this.pendingWritePromises.length=0,S.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(a,d){const S=[];let i;for(;(i=a.read())!==null;)S.push(i);return d(S)}e.consumeReadable=y;function P(a,d,S){const i=[];let p;for(;(p=a.read())!==null&&i.length<S;)i.push(p);return p===null&&i.length>0?d(i):{read:()=>{if(i.length>0)return i.shift();if(typeof p!="undefined"){const r=p;return p=void 0,r}return a.read()}}}e.peekReadable=P;function t(a,d){return new Promise((S,i)=>{const p=[];b(a,{onData:r=>{d&&p.push(r)},onError:r=>{d?i(r):S(void 0)},onEnd:()=>{S(d?d(p):void 0)}})})}e.consumeStream=t;function b(a,d){a.on("error",S=>d.onError(S)),a.on("end",()=>d.onEnd()),a.on("data",S=>d.onData(S))}e.listenStream=b;function n(a,d){return new Promise((S,i)=>{const p=new M.DisposableStore,r=[],s=m=>{if(r.push(m),r.length>d)return p.dispose(),a.pause(),S({stream:a,buffer:r,ended:!1})},u=m=>i(m),h=()=>S({stream:a,buffer:r,ended:!0});p.add((0,M.toDisposable)(()=>a.removeListener("error",u))),a.on("error",u),p.add((0,M.toDisposable)(()=>a.removeListener("end",h))),a.on("end",h),p.add((0,M.toDisposable)(()=>a.removeListener("data",s))),a.on("data",s)})}e.peekStream=n;function f(a,d){const S=R(d);return S.end(a),S}e.toStream=f;function o(){const a=R(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=o;function l(a){let d=!1;return{read:()=>d?null:(d=!0,a)}}e.toReadable=l;function v(a,d,S){const i=R(S);return b(a,{onData:p=>i.write(d.data(p)),onError:p=>i.error(d.error?d.error(p):p),onEnd:()=>i.end()}),i}e.transform=v;function D(a,d,S){let i=!1;return{read:()=>{const p=d.read();return i?p:(i=!0,p!==null?S([a,p]):a)}}}e.prefixedReadable=D;function _(a,d,S){let i=!1;const p=R(S);return b(d,{onData:r=>i?p.write(r):(i=!0,p.write(S([a,r]))),onError:r=>p.error(r),onEnd:()=>{i||(i=!0,p.write(a)),p.end()}}),p}e.prefixedStream=_}),define(be[22],Ee([0,1,105]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let E,A;class R{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return M?new R(Buffer.allocUnsafe(s)):new R(new Uint8Array(s))}static wrap(s){return M&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new R(s)}static fromString(s,u){return!(u?.dontUseNodeBuffer||!1)&&M?new R(Buffer.from(s)):(E||(E=new TextEncoder),new R(E.encode(s)))}static concat(s,u){if(typeof u=="undefined"){u=0;for(let k=0,T=s.length;k<T;k++)u+=s[k].byteLength}const h=R.alloc(u);let m=0;for(let k=0,T=s.length;k<T;k++){const g=s[k];h.set(g,m),m+=g.byteLength}return h}toString(){return M?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(s,u){return new R(this.buffer.subarray(s,u))}set(s,u){s instanceof R?this.buffer.set(s.buffer,u):this.buffer.set(s,u)}readUInt32BE(s){return P(this.buffer,s)}writeUInt32BE(s,u){t(this.buffer,s,u)}readUInt32LE(s){return b(this.buffer,s)}writeUInt32LE(s,u){n(this.buffer,s,u)}readUInt8(s){return f(this.buffer,s)}writeUInt8(s,u){o(this.buffer,s,u)}}e.VSBuffer=R;function C(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0}e.readUInt16LE=C;function y(r,s,u){r[u+0]=s&255,s=s>>>8,r[u+1]=s&255}e.writeUInt16LE=y;function P(r,s){return r[s]*2**24+r[s+1]*2**16+r[s+2]*2**8+r[s+3]}e.readUInt32BE=P;function t(r,s,u){r[u+3]=s,s=s>>>8,r[u+2]=s,s=s>>>8,r[u+1]=s,s=s>>>8,r[u]=s}e.writeUInt32BE=t;function b(r,s){return r[s+0]<<0>>>0|r[s+1]<<8>>>0|r[s+2]<<16>>>0|r[s+3]<<24>>>0}e.readUInt32LE=b;function n(r,s,u){r[u+0]=s&255,s=s>>>8,r[u+1]=s&255,s=s>>>8,r[u+2]=s&255,s=s>>>8,r[u+3]=s&255}e.writeUInt32LE=n;function f(r,s){return r[s]}e.readUInt8=f;function o(r,s,u){r[u]=s}e.writeUInt8=o;function l(r){return c.consumeReadable(r,s=>R.concat(s))}e.readableToBuffer=l;function v(r){return c.toReadable(r)}e.bufferToReadable=v;function D(r){return c.consumeStream(r,s=>R.concat(s))}e.streamToBuffer=D;async function _(r){return r.ended?R.concat(r.buffer):R.concat([...r.buffer,await D(r.stream)])}e.bufferedStreamToBuffer=_;function a(r){return c.toStream(r,s=>R.concat(s))}e.bufferToStream=a;function d(r){return c.transform(r,{data:s=>typeof s=="string"?R.fromString(s):R.wrap(s)},s=>R.concat(s))}e.streamToBufferReadableStream=d;function S(r){return c.newWriteableStream(s=>R.concat(s),r)}e.newWriteableBufferStream=S;function i(r,s){return c.prefixedReadable(r,s,u=>R.concat(u))}e.prefixedBufferReadable=i;function p(r,s){return c.prefixedStream(r,s,u=>R.concat(u))}e.prefixedBufferStream=p}),define(be[35],Ee([0,1,9]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(M||(M={})),function(E){const A="error",R="warning",C="warn",y="info",P="ignore";function t(n){return n?c.equalsIgnoreCase(A,n)?E.Error:c.equalsIgnoreCase(R,n)||c.equalsIgnoreCase(C,n)?E.Warning:c.equalsIgnoreCase(y,n)?E.Info:E.Ignore:E.Ignore}E.fromValue=t;function b(n){switch(n){case E.Error:return A;case E.Warning:return R;case E.Info:return y;default:return P}}E.toString=b}(M||(M={})),e.default=M}),define(be[43],Ee([0,1,17,25,9,10]),function(re,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(r){return r===47||r===92}e.isPathSeparator=R;function C(r){return r.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=C;function y(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=y;function P(r,s=c.posix.sep){if(!r)return"";const u=r.length,h=r.charCodeAt(0);if(R(h)){if(R(r.charCodeAt(1))&&!R(r.charCodeAt(2))){let k=3;const T=k;for(;k<u&&!R(r.charCodeAt(k));k++);if(T!==k&&!R(r.charCodeAt(k+1))){for(k+=1;k<u;k++)if(R(r.charCodeAt(k)))return r.slice(0,k+1).replace(/[\\/]/g,s)}}return s}else if(D(h)&&r.charCodeAt(1)===58)return R(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let m=r.indexOf("://");if(m!==-1){for(m+=3;m<u;m++)if(R(r.charCodeAt(m)))return r.slice(0,m+1)}return""}e.getRoot=P;function t(r){if(!M.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let u=2;const h=u;for(;u<r.length&&(s=r.charCodeAt(u),s!==92);u++);return!(h===u||(s=r.charCodeAt(u+1),isNaN(s)||s===92))}e.isUNC=t;const b=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(r,s=M.isWindows){const u=s?b:n;return!(!r||r.length===0||/^\s+$/.test(r)||(u.lastIndex=0,u.test(r))||s&&f.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=o;function l(r,s,u){const h=r===s;return!u||h?h:!r||!s?!1:(0,E.equalsIgnoreCase)(r,s)}e.isEqual=l;function v(r,s,u,h=c.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(u){if(!(0,E.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let k=s.length;return s.charAt(s.length-1)===h&&k--,r.charAt(k)===h}return s.charAt(s.length-1)!==h&&(s+=h),r.indexOf(s)===0}e.isEqualOrParent=v;function D(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=D;function _(r,s){return M.isWindows&&r.endsWith(":")&&(r+=c.sep),(0,c.isAbsolute)(r)||(r=(0,c.join)(s,r)),r=(0,c.normalize)(r),M.isWindows?(r=(0,E.rtrim)(r,c.sep),r.endsWith(":")&&(r+=c.sep)):(r=(0,E.rtrim)(r,c.sep),r||(r=c.sep)),r}e.sanitizeFilePath=_;function a(r){const s=(0,c.normalize)(r);return M.isWindows?r.length>3?!1:d(s)&&(r.length===2||s.charCodeAt(2)===92):s===c.posix.sep}e.isRootOrDriveLetter=a;function d(r){return M.isWindows?D(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function S(r){return d(r)?r[0]:void 0}e.getDriveLetter=S;function i(r,s,u){return s.length>r.length?-1:r===s?0:(u&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=i;function p(r){const s=r.split(":");let u,h,m;if(s.forEach(k=>{const T=Number(k);(0,A.isNumber)(T)?h===void 0?h=T:m===void 0&&(m=T):u=u?[u,k].join(":"):k}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:h!==void 0?h:void 0,column:m!==void 0?m:h!==void 0?1:void 0}}e.parseLineAndColumnAware=p}),define(be[23],Ee([0,1,10]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const v=Array.isArray(l)?[]:{};return Object.keys(l).forEach(D=>{l[D]&&typeof l[D]=="object"?v[D]=M(l[D]):v[D]=l[D]}),v}e.deepClone=M;function E(l){if(!l||typeof l!="object")return l;const v=[l];for(;v.length>0;){const D=v.shift();Object.freeze(D);for(const _ in D)if(A.call(D,_)){const a=D[_];typeof a=="object"&&!Object.isFrozen(a)&&v.push(a)}}return l}e.deepFreeze=E;const A=Object.prototype.hasOwnProperty;function R(l,v){return C(l,v,new Set)}e.cloneAndChange=R;function C(l,v,D){if((0,c.isUndefinedOrNull)(l))return l;const _=v(l);if(typeof _!="undefined")return _;if((0,c.isArray)(l)){const a=[];for(const d of l)a.push(C(d,v,D));return a}if((0,c.isObject)(l)){if(D.has(l))throw new Error("Cannot clone recursive data-structure");D.add(l);const a={};for(let d in l)A.call(l,d)&&(a[d]=C(l[d],v,D));return D.delete(l),a}return l}function y(l,v,D=!0){return(0,c.isObject)(l)?((0,c.isObject)(v)&&Object.keys(v).forEach(_=>{_ in l?D&&((0,c.isObject)(l[_])&&(0,c.isObject)(v[_])?y(l[_],v[_],D):l[_]=v[_]):l[_]=v[_]}),l):v}e.mixin=y;function P(l,v){if(l===v)return!0;if(l==null||v===null||v===void 0||typeof l!=typeof v||typeof l!="object"||Array.isArray(l)!==Array.isArray(v))return!1;let D,_;if(Array.isArray(l)){if(l.length!==v.length)return!1;for(D=0;D<l.length;D++)if(!P(l[D],v[D]))return!1}else{const a=[];for(_ in l)a.push(_);a.sort();const d=[];for(_ in v)d.push(_);if(d.sort(),!P(a,d))return!1;for(D=0;D<a.length;D++)if(!P(l[a[D]],v[a[D]]))return!1}return!0}e.equals=P;function t(l){const v=new Set;return JSON.stringify(l,(D,_)=>{if((0,c.isObject)(_)||Array.isArray(_)){if(v.has(_))return"[Circular]";v.add(_)}return _})}e.safeStringify=t;function b(l,v,D){const _=v(l);return typeof _=="undefined"?D:_}e.getOrDefault=b;function n(l,v){const D=Object.create(null);return!l||!v||Object.keys(v).forEach(a=>{const d=l[a],S=v[a];P(d,S)||(D[a]=S)}),D}e.distinct=n;function f(l,v){const D=v.toLowerCase(),_=Object.keys(l).find(a=>a.toLowerCase()===D);return _?l[_]:l[v]}e.getCaseInsensitive=f;function o(l,v){const D=Object.create(null);for(const _ of Object.keys(l))v(_,l[_])&&(D[_]=l[_]);return D}e.filter=o});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Fe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(be[20],Ee([0,1,13,9,2]),function(re,e,c,M,E){"use strict";var A,R,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(p,r,s){let u=p.get(r);return u===void 0&&(u=s,p.set(r,u)),u}e.getOrSet=y;function P(p){const r=[];return p.forEach((s,u)=>{r.push(`${u} => ${s}`)}),`Map(${p.size}) {${r.join(", ")}}`}e.mapToString=P;function t(p){const r=[];return p.forEach(s=>{r.push(s)}),`Set(${p.size}) {${r.join(", ")}}`}e.setToString=t;class b{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),u=this._value.charCodeAt(this._pos);return s-u}value(){return this._value[this._pos]}}e.StringIterator=b;class n{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=n;class f{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,M.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var o;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(o||(o={}));class l{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,M.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class v{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class D{constructor(r){this._iter=r}static forUris(r=()=>!1){return new D(new l(r))}static forPaths(){return new D(new f)}static forStrings(){return new D(new b)}static forConfigKeys(){return new D(new n)}clear(){this._root=void 0}set(r,s){const u=this._iter.reset(r);let h;for(this._root||(this._root=new v,this._root.segment=u.value()),h=this._root;;){const k=u.cmp(h.segment);if(k>0)h.left||(h.left=new v,h.left.segment=u.value()),h=h.left;else if(k<0)h.right||(h.right=new v,h.right.segment=u.value()),h=h.right;else if(u.hasNext())u.next(),h.mid||(h.mid=new v,h.mid.segment=u.value()),h=h.mid;else break}const m=h.value;return h.value=s,h.key=r,m}fill(r,s){const u=s.slice(0);(0,c.shuffle)(u);for(let h of u)this.set(h,r)}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let u=this._root;for(;u;){const h=s.cmp(u.segment);if(h>0)u=u.left;else if(h<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else break}return u}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const u=this._iter.reset(r),h=[];let m=this._root;for(;m;){const k=u.cmp(m.segment);if(k>0)h.push([1,m]),m=m.left;else if(k<0)h.push([-1,m]),m=m.right;else if(u.hasNext())u.next(),h.push([0,m]),m=m.mid;else{for(s?(m.left=void 0,m.mid=void 0,m.right=void 0):m.value=void 0;h.length>0&&m.isEmpty();){let[T,g]=h.pop();switch(T){case 1:g.left=void 0;break;case 0:g.mid=void 0;break;case-1:g.right=void 0;break}m=g}break}}}findSubstr(r){const s=this._iter.reset(r);let u=this._root,h;for(;u;){const m=s.cmp(u.segment);if(m>0)u=u.left;else if(m<0)u=u.right;else if(s.hasNext())s.next(),h=u.value||h,u=u.mid;else break}return u&&u.value||h}findSuperstr(r){const s=this._iter.reset(r);let u=this._root;for(;u;){const h=s.cmp(u.segment);if(h>0)u=u.left;else if(h<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(r){for(const[s,u]of this)r(u,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const u=s.pop();u&&(u.value&&(yield[u.key,u.value]),u.left&&s.push(u.left),u.mid&&s.push(u.mid),u.right&&s.push(u.right))}}}e.TernarySearchTree=D;class _{constructor(r,s){this[A]="ResourceMap",r instanceof _?(this.map=new Map(r.map),this.toKey=s??_.defaultToKey):(this.map=new Map,this.toKey=r??_.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[u,h]of this.map)r(h,E.URI.parse(u),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield E.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[E.URI.parse(r[0]),r[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[E.URI.parse(r[0]),r[1]]}}e.ResourceMap=_,_.defaultToKey=p=>p.toString();var a;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class d{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const u=this._map.get(r);if(!!u)return s!==0&&this.touch(u,s),u.value}set(r,s,u=0){let h=this._map.get(r);if(h)h.value=s,u!==0&&this.touch(h,u);else{switch(h={key:r,value:s,next:void 0,previous:void 0},u){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(r,h),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const u=this._state;let h=this._head;for(;h;){if(s?r.bind(s)(h.value,h.key,this):r(h.value,h.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const r=this,s=this._state;let u=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const m={value:u.key,done:!1};return u=u.next,m}else return{value:void 0,done:!0}}};return h}values(){const r=this,s=this._state;let u=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const m={value:u.value,done:!1};return u=u.next,m}else return{value:void 0,done:!0}}};return h}entries(){const r=this,s=this._state;let u=this._head;const h={[Symbol.iterator](){return h},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(u){const m={value:[u.key,u.value],done:!1};return u=u.next,m}else return{value:void 0,done:!0}}};return h}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,u=this.size;for(;s&&u>r;)this._map.delete(s.key),s=s.next,u--;this._head=s,this._size=u,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,u=r.previous;if(!s||!u)throw new Error("Invalid list");s.previous=u,u.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const u=r.next,h=r.previous;r===this._tail?(h.next=void 0,this._tail=h):(u.previous=h,h.next=u),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const u=r.next,h=r.previous;r===this._head?(u.previous=void 0,this._head=u):(u.previous=h,h.next=u),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,u)=>{r.push([u,s])}),r}fromJSON(r){this.clear();for(const[s,u]of r)this.set(s,u)}}e.LinkedMap=d;class S extends d{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=S;class i{constructor(r){C.set(this,void 0),et(this,C,r,"f")}get size(){return Fe(this,C,"f").size}forEach(r,s){Fe(this,C,"f").forEach(r,s)}get(r){return Fe(this,C,"f").get(r)}has(r){return Fe(this,C,"f").has(r)}entries(){return Fe(this,C,"f").entries()}keys(){return Fe(this,C,"f").keys()}values(){return Fe(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Fe(this,C,"f").entries()}}e.ReadonlyMapView=i}),define(be[106],Ee([0,1,20,9]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function E(...q){return function(se,he){for(let Re=0,Be=q.length;Re<Be;Re++){const ze=q[Re](se,he);if(ze)return ze}return null}}e.or=E,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(q,se,he){if(!he||he.length<se.length)return null;let Re;return q?Re=M.startsWithIgnoreCase(he,se):Re=he.indexOf(se)===0,Re?se.length>0?[{start:0,end:se.length}]:[]:null}function R(q,se){const he=se.toLowerCase().indexOf(q.toLowerCase());return he===-1?null:[{start:he,end:he+q.length}]}e.matchesContiguousSubString=R;function C(q,se){return y(q.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=C;function y(q,se,he,Re){if(he===q.length)return[];if(Re===se.length)return null;if(q[he]===se[Re]){let Be=null;return(Be=y(q,se,he+1,Re+1))?D({start:Re,end:Re+1},Be):null}return y(q,se,he,Re+1)}function P(q){return 97<=q&&q<=122}function t(q){return 65<=q&&q<=90}e.isUpper=t;function b(q){return 48<=q&&q<=57}function n(q){return q===32||q===9||q===10||q===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(q=>f.add(q.charCodeAt(0)));function o(q){return n(q)||f.has(q)}function l(q,se){return q===se||o(q)&&o(se)}function v(q){return P(q)||t(q)||b(q)}function D(q,se){return se.length===0?se=[q]:q.end===se[0].start?se[0].start=q.start:se.unshift(q),se}function _(q,se){for(let he=se;he<q.length;he++){const Re=q.charCodeAt(he);if(t(Re)||b(Re)||he>0&&!v(q.charCodeAt(he-1)))return he}return q.length}function a(q,se,he,Re){if(he===q.length)return[];if(Re===se.length)return null;if(q[he]!==se[Re].toLowerCase())return null;{let Be=null,ze=Re+1;for(Be=a(q,se,he+1,Re+1);!Be&&(ze=_(se,ze))<se.length;)Be=a(q,se,he+1,ze),ze++;return Be===null?null:D({start:Re,end:Re+1},Be)}}function d(q){let se=0,he=0,Re=0,Be=0,ze=0;for(let j=0;j<q.length;j++)ze=q.charCodeAt(j),t(ze)&&se++,P(ze)&&he++,v(ze)&&Re++,b(ze)&&Be++;const Qe=se/q.length,it=he/q.length,ke=Re/q.length,Ze=Be/q.length;return{upperPercent:Qe,lowerPercent:it,alphaPercent:ke,numericPercent:Ze}}function S(q){const{upperPercent:se,lowerPercent:he}=q;return he===0&&se>.6}function i(q){const{upperPercent:se,lowerPercent:he,alphaPercent:Re,numericPercent:Be}=q;return he>.2&&se<.8&&Re>.6&&Be<.2}function p(q){let se=0,he=0,Re=0,Be=0;for(let ze=0;ze<q.length;ze++)Re=q.charCodeAt(ze),t(Re)&&se++,P(Re)&&he++,n(Re)&&Be++;return(se===0||he===0)&&Be===0?q.length<=30:se<=5}function r(q,se){if(!se||(se=se.trim(),se.length===0)||!p(q)||se.length>60)return null;const he=d(se);if(!i(he)){if(!S(he))return null;se=se.toLowerCase()}let Re=null,Be=0;for(q=q.toLowerCase();Be<se.length&&(Re=a(q,se,0,Be))===null;)Be=_(se,Be+1);return Re}e.matchesCamelCase=r;function s(q,se,he=!1){if(!se||se.length===0)return null;let Re=null,Be=0;for(q=q.toLowerCase(),se=se.toLowerCase();Be<se.length&&(Re=u(q,se,0,Be,he))===null;)Be=h(se,Be+1);return Re}e.matchesWords=s;function u(q,se,he,Re,Be){if(he===q.length)return[];if(Re===se.length)return null;if(l(q.charCodeAt(he),se.charCodeAt(Re))){let ze=null,Qe=Re+1;if(ze=u(q,se,he+1,Re+1,Be),!Be)for(;!ze&&(Qe=h(se,Qe))<se.length;)ze=u(q,se,he+1,Qe,Be),Qe++;return ze===null?null:D({start:Re,end:Re+1},ze)}else return null}function h(q,se){for(let he=se;he<q.length;he++)if(o(q.charCodeAt(he))||he>0&&o(q.charCodeAt(he-1)))return he;return q.length}const m=E(e.matchesPrefix,r,R),k=E(e.matchesPrefix,r,C),T=new c.LRUCache(1e4);function g(q,se,he=!1){if(typeof q!="string"||typeof se!="string")return null;let Re=T.get(q);Re||(Re=new RegExp(M.convertSimple2RegExpPattern(q),"i"),T.set(q,Re));const Be=Re.exec(se);return Be?[{start:Be.index,end:Be.index+Be[0].length}]:he?k(q,se):m(q,se)}e.matchesFuzzy=g;function I(q,se){const he=We(q,q.toLowerCase(),0,se,se.toLowerCase(),0,!0);return he?L(he):null}e.matchesFuzzy2=I;function F(q,se,he,Re,Be,ze){const Qe=Math.min(13,q.length);for(;he<Qe;he++){const it=We(q,se,he,Re,Be,ze,!1);if(it)return it}return[0,ze]}e.anyScore=F;function L(q){if(typeof q=="undefined")return[];const se=[],he=q[1];for(let Re=q.length-1;Re>1;Re--){const Be=q[Re]+he,ze=se[se.length-1];ze&&ze.end===Be?ze.end=Be+1:se.push({start:Be,end:Be+1})}return se}e.createMatches=L;const w=128;function x(){const q=[],se=[];for(let he=0;he<=w;he++)se[he]=0;for(let he=0;he<=w;he++)q.push(se.slice(0));return q}function W(q){const se=[];for(let he=0;he<=q;he++)se[he]=0;return se}const B=W(2*w),G=W(2*w),H=x(),U=x(),V=x(),Q=!1;function ne(q,se,he,Re,Be){function ze(it,ke,Ze=" "){for(;it.length<ke;)it=Ze+it;return it}let Qe=` |   |${Re.split("").map(it=>ze(it,3)).join("|")}
`;for(let it=0;it<=he;it++)it===0?Qe+=" |":Qe+=`${se[it-1]}|`,Qe+=q[it].slice(0,Be+1).map(ke=>ze(ke.toString(),3)).join("|")+`
`;return Qe}function ce(q,se,he,Re){q=q.substr(se),he=he.substr(Re),console.log(ne(U,q,q.length,he,he.length)),console.log(ne(V,q,q.length,he,he.length)),console.log(ne(H,q,q.length,he,he.length))}function Z(q,se){if(se<0||se>=q.length)return!1;const he=q.codePointAt(se);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(he)}}function oe(q,se){if(se<0||se>=q.length)return!1;switch(q.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function ve(q,se,he){return se[q]!==he[q]}function Ae(q,se,he,Re,Be,ze,Qe=!1){for(;se<he&&Be<ze;)q[se]===Re[Be]&&(Qe&&(B[se]=Be),se+=1),Be+=1;return se===he}e.isPatternInWord=Ae;var Se;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var Ne;(function(q){q.Default=[-100,0];function se(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}q.isDefault=se})(Ne=e.FuzzyScore||(e.FuzzyScore={}));function We(q,se,he,Re,Be,ze,Qe){const it=q.length>w?w:q.length,ke=Re.length>w?w:Re.length;if(he>=it||ze>=ke||it-he>ke-ze||!Ae(se,he,it,Be,ze,ke,!0))return;je(it,ke,he,ze,se,Be);let Ze=1,j=1,J=he,me=ze;const He=[!1];for(Ze=1,J=he;J<it;Ze++,J++){const mt=B[J],Dt=G[J],Pt=J+1<it?G[J+1]:ke;for(j=mt-ze+1,me=mt;me<Pt;j++,me++){let It=Number.MIN_SAFE_INTEGER,Xe=!1;me<=Dt&&(It=qe(q,se,J,he,Re,Be,me,ke,ze,H[Ze-1][j-1]===0,He));let St=0;It!==Number.MAX_SAFE_INTEGER&&(Xe=!0,St=It+U[Ze-1][j-1]);const Te=me>mt,ye=Te?U[Ze][j-1]+(H[Ze][j-1]>0?-5:0):0,Ce=me>mt+1&&H[Ze][j-1]>0,te=Ce?U[Ze][j-2]+(H[Ze][j-2]>0?-5:0):0;if(Ce&&(!Te||te>=ye)&&(!Xe||te>=St))U[Ze][j]=te,V[Ze][j]=3,H[Ze][j]=0;else if(Te&&(!Xe||ye>=St))U[Ze][j]=ye,V[Ze][j]=2,H[Ze][j]=0;else if(Xe)U[Ze][j]=St,V[Ze][j]=1,H[Ze][j]=H[Ze-1][j-1]+1;else throw new Error("not possible")}}if(Q&&ce(q,he,Re,ze),!He[0]&&!Qe)return;Ze--,j--;const Ye=[U[Ze][j],ze];let st=0,ot=0;for(;Ze>=1;){let mt=j;do{const Dt=V[Ze][mt];if(Dt===3)mt=mt-2;else if(Dt===2)mt=mt-1;else break}while(mt>=1);st>1&&se[he+Ze-1]===Be[ze+j-1]&&!ve(mt+ze-1,Re,Be)&&st+1>H[Ze][mt]&&(mt=j),mt===j?st++:st=1,ot||(ot=mt),Ze--,j=mt-1,Ye.push(j)}ke===it&&(Ye[0]+=2);const Et=ot-it;return Ye[0]-=Et,Ye}e.fuzzyScore=We;function je(q,se,he,Re,Be,ze){let Qe=q-1,it=se-1;for(;Qe>=he&&it>=Re;)Be[Qe]===ze[it]&&(G[Qe]=it,Qe--),it--}function qe(q,se,he,Re,Be,ze,Qe,it,ke,Ze,j){if(se[he]!==ze[Qe])return Number.MIN_SAFE_INTEGER;let J=1,me=!1;return Qe===he-Re?J=q[he]===Be[Qe]?7:5:ve(Qe,Be,ze)&&(Qe===0||!ve(Qe-1,Be,ze))?(J=q[he]===Be[Qe]?7:5,me=!0):Z(ze,Qe)&&(Qe===0||!Z(ze,Qe-1))?J=5:(Z(ze,Qe-1)||oe(ze,Qe-1))&&(J=5,me=!0),J>1&&he===Re&&(j[0]=!0),me||(me=ve(Qe,Be,ze)||Z(ze,Qe-1)||oe(ze,Qe-1)),he===Re?Qe>ke&&(J-=me?3:5):Ze?J+=me?2:0:J+=me?0:1,Qe+1===it&&(J-=me?3:5),J}function $(q,se,he,Re,Be,ze,Qe){return ee(q,se,he,Re,Be,ze,!0,Qe)}e.fuzzyScoreGracefulAggressive=$;function K(q,se,he,Re,Be,ze,Qe){return ee(q,se,he,Re,Be,ze,!1,Qe)}e.fuzzyScoreGraceful=K;function ee(q,se,he,Re,Be,ze,Qe,it){let ke=We(q,se,he,Re,Be,ze,it);if(ke&&!Qe)return ke;if(q.length>=3){const Ze=Math.min(7,q.length-1);for(let j=he+1;j<Ze;j++){const J=ae(q,j);if(J){const me=We(J,J.toLowerCase(),he,Re,Be,ze,it);me&&(me[0]-=3,(!ke||me[0]>ke[0])&&(ke=me))}}}return ke}function ae(q,se){if(se+1>=q.length)return;const he=q[se],Re=q[se+1];if(he!==Re)return q.slice(0,se)+Re+he+q.slice(se+2)}}),define(be[107],Ee([0,1,34,106,9]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${A.source}`,"g");function C(l){return l.replace(R,(v,D)=>D?v:`\\${v}`)}e.escapeIcons=C;const y=new RegExp(`\\\\${A.source}`,"g");function P(l){return l.replace(y,v=>`\\${v}`)}e.markdownEscapeEscapedIcons=P;const t=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function b(l){return l.indexOf(e.iconStartMarker)===-1?l:l.replace(t,(v,D,_,a)=>_?v:D||a||"")}e.stripIcons=b;function n(l){const v=l.indexOf(e.iconStartMarker);return v===-1?{text:l}:f(l,v)}e.parseLabelWithIcons=n;function f(l,v){const D=[];let _="";function a(h){if(h){_+=h;for(const m of h)D.push(i)}}let d=-1,S="",i=0,p,r,s=v;const u=l.length;for(a(l.substr(0,v));s<u;)p=l[s],r=l[s+1],p===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(d=s,a(S),S=e.iconStartMarker,s++):p===")"&&d!==-1?(i+=s-d+1,d=-1,S=""):d!==-1?/^[a-z0-9\-]$/i.test(p)?S+=p:(a(S),d=-1,S=""):a(p),s++;return a(S),{text:_,iconOffsets:D}}function o(l,v,D=!1){const{text:_,iconOffsets:a}=v;if(!a||a.length===0)return(0,M.matchesFuzzy)(l,_,D);const d=(0,E.ltrim)(_," "),S=_.length-d.length,i=(0,M.matchesFuzzy)(l,d,D);if(i)for(const p of i){const r=a[p.start+S]+S;p.start+=r,p.end+=r}return i}e.matchesFuzzyIconAware=o}),define(be[76],Ee([0,1,16,107]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(f="",o=!1){if(this.value=f,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(f,o=0){return this.value+=P(this.supportThemeIcons?(0,M.escapeIcons)(f):f).replace(/([ \t]+)/g,(l,v)=>"&nbsp;".repeat(v.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,o){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}}e.MarkdownString=A;function R(n){return C(n)?!n.value:Array.isArray(n)?n.every(R):!0}e.isEmptyMarkdownString=R;function C(n){return n instanceof A?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function y(n,f){return n===f?!0:!n||!f?!1:n.value===f.value&&n.isTrusted===f.isTrusted&&n.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=y;function P(n){return n.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function b(n){const f=[],o=n.split("|").map(v=>v.trim());n=o[0];const l=o[1];if(l){const v=/height=(\d+)/.exec(l),D=/width=(\d+)/.exec(l),_=v?v[1]:"",a=D?D[1]:"",d=isFinite(parseInt(a)),S=isFinite(parseInt(_));d&&f.push(`width="${a}"`),S&&f.push(`height="${_}"`)}return{href:n,dimensions:f}}e.parseHrefAndDimensions=b}),define(be[54],Ee([0,1,22,9,2]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(t){return JSON.stringify(t,y)}e.stringify=A;function R(t){let b=JSON.parse(t);return b=P(b),b}e.parse=R;var C;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function y(t,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,M.regExpFlags)(b)}:b}function P(t,b=0){if(!t||b>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return E.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof c.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=P(t[n],b+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=P(t[n],b+1))}return t}e.revive=P}),define(be[11],Ee([0,1,25,2]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var E;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(E=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,P,t){this._hosts[y]=P,this._ports[y]=t}setConnectionToken(y,P){this._connectionTokens[y]=P}rewrite(y){if(this._delegate)return this._delegate(y);const P=y.authority;let t=this._hosts[P];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const b=this._ports[P],n=this._connectionTokens[P];let f=`path=${encodeURIComponent(y.path)}`;return typeof n=="string"&&(f+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:c.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${t}:${b}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new A;class R{asBrowserUri(y,P){const t=this.toUri(y,P);return t.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===E.file&&(c.isNative||typeof c.globals.importScripts=="function"&&c.globals.origin===`${E.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?t.with({scheme:E.vscodeFileResource,authority:t.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(y,P){const t=this.toUri(y,P);return t.scheme===E.vscodeFileResource?t.with({scheme:E.file,authority:t.authority!==R.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(y,P){return M.URI.isUri(y)?y:M.URI.parse(P.toUrl(y))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R}),define(be[24],Ee([0,1,43,11,17,25,9,2]),function(re,e,c,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(f){return(0,C.uriToFsPath)(f,!0)}e.originalFSPath=y;class P{constructor(o){this._ignorePathCasing=o}compare(o,l,v=!1){return o===l?0:(0,R.compare)(this.getComparisonKey(o,v),this.getComparisonKey(l,v))}isEqual(o,l,v=!1){return o===l?!0:!o||!l?!1:this.getComparisonKey(o,v)===this.getComparisonKey(l,v)}getComparisonKey(o,l=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,l,v=!1){if(o.scheme===l.scheme){if(o.scheme===M.Schemas.file)return c.isEqualOrParent(y(o),y(l),this._ignorePathCasing(o))&&o.query===l.query&&(v||o.fragment===l.fragment);if((0,e.isEqualAuthority)(o.authority,l.authority))return c.isEqualOrParent(o.path,l.path,this._ignorePathCasing(o),"/")&&o.query===l.query&&(v||o.fragment===l.fragment)}return!1}joinPath(o,...l){return C.URI.joinPath(o,...l)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return E.posix.basename(o.path)}extname(o){return E.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let l;return o.scheme===M.Schemas.file?l=C.URI.file(E.dirname(y(o))).path:(l=E.posix.dirname(o.path),o.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),l="/")),o.with({path:l})}normalizePath(o){if(!o.path.length)return o;let l;return o.scheme===M.Schemas.file?l=C.URI.file(E.normalize(y(o))).path:l=E.posix.normalize(o.path),o.with({path:l})}relativePath(o,l){if(o.scheme!==l.scheme||!(0,e.isEqualAuthority)(o.authority,l.authority))return;if(o.scheme===M.Schemas.file){const _=E.relative(y(o),y(l));return A.isWindows?c.toSlashes(_):_}let v=o.path||"/",D=l.path||"/";if(this._ignorePathCasing(o)){let _=0;for(const a=Math.min(v.length,D.length);_<a&&!(v.charCodeAt(_)!==D.charCodeAt(_)&&v.charAt(_).toLowerCase()!==D.charAt(_).toLowerCase());_++);v=D.substr(0,_)+v.substr(_)}return E.posix.relative(v,D)}resolvePath(o,l){if(o.scheme===M.Schemas.file){const v=C.URI.file(E.resolve(y(o),l));return o.with({authority:v.authority,path:v.path})}return l=c.toPosixPath(l),o.with({path:E.posix.resolve(o.path,l)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,l){return o===l||(0,R.equalsIgnoreCase)(o,l)}hasTrailingPathSeparator(o,l=E.sep){if(o.scheme===M.Schemas.file){const v=y(o);return v.length>c.getRoot(v).length&&v[v.length-1]===l}else{const v=o.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,l=E.sep){return(0,e.hasTrailingPathSeparator)(o,l)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,l=E.sep){let v=!1;if(o.scheme===M.Schemas.file){const D=y(o);v=D!==void 0&&D.length===c.getRoot(D).length&&D[D.length-1]===l}else{l="/";const D=o.path;v=D.length===1&&D.charCodeAt(D.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(o,l)?o.with({path:o.path+"/"}):o}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(f=>f.scheme===M.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new P(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(f,o){const l=[];for(let v=0;v<f.length;v++){const D=o(f[v]);f.some((_,a)=>a===v?!1:(0,e.isEqualOrParent)(D,o(_)))||l.push(f[v])}return l}e.distinctParents=t;var b;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function o(l){const v=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(a=>{const[d,S]=a.split(":");d&&S&&v.set(d,S)});const _=l.path.substring(0,l.path.indexOf(";"));return _&&v.set(f.META_DATA_MIME,_),v}f.parseMetaData=o})(b=e.DataUri||(e.DataUri={}));function n(f,o,l){if(o){let v=f.path;return v&&v[0]!==E.posix.sep&&(v=E.posix.sep+v),f.with({scheme:l,authority:o,path:v})}return f.with({scheme:l})}e.toLocalResource=n}),define(be[14],Ee([0,1,21,16,3,6,24]),function(re,e,c,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(H){return!!H&&typeof H.then=="function"}e.isThenable=C;function y(H){const U=new c.CancellationTokenSource,V=H(U.token),Q=new Promise((ne,ce)=>{const Z=U.token.onCancellationRequested(()=>{Z.dispose(),U.dispose(),ce((0,M.canceled)())});Promise.resolve(V).then(oe=>{Z.dispose(),U.dispose(),ne(oe)},oe=>{Z.dispose(),U.dispose(),ce(oe)})});return new class{cancel(){U.cancel()}then(ne,ce){return Q.then(ne,ce)}catch(ne){return this.then(void 0,ne)}finally(ne){return Q.finally(ne)}}}e.createCancelablePromise=y;function P(H,U,V){return Promise.race([H,new Promise(Q=>U.onCancellationRequested(()=>Q(V)))])}e.raceCancellation=P;async function t(H){let U=-1;const V=H.map((ne,ce)=>ne.then(Z=>(U=ce,Z))),Q=await Promise.race(V);return H.forEach((ne,ce)=>{ce!==U&&ne.cancel()}),Q}e.raceCancellablePromises=t;function b(H,U,V){let Q;const ne=setTimeout(()=>{Q?.(void 0),V?.()},U);return Promise.race([H.finally(()=>clearTimeout(ne)),new Promise(ce=>Q=ce)])}e.raceTimeout=b;function n(H){return new Promise((U,V)=>{const Q=H();C(Q)?Q.then(U,V):U(Q)})}e.asPromise=n;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const V=()=>{this.queuedPromise=null;const Q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Q};this.queuedPromise=new Promise(Q=>{this.activePromise.then(V,V).then(Q)})}return new Promise((V,Q)=>{this.queuedPromise.then(V,Q)})}return this.activePromise=U(),new Promise((V,Q)=>{this.activePromise.then(ne=>{this.activePromise=null,V(ne)},ne=>{this.activePromise=null,Q(ne)})})}}e.Throttler=f;class o{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=o;class l{constructor(){this.promiseMap=new Map}queue(U,V){const ne=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.promiseMap.get(U)===ne&&this.promiseMap.delete(U)});return this.promiseMap.set(U,ne),ne}}e.SequencerByKey=l;class v{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,V=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Q,ne)=>{this.doResolve=Q,this.doReject=ne}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Q=this.task;return this.task=null,Q()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},V),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=v;class D{constructor(U){this.delayer=new v(U),this.throttler=new f}trigger(U,V){return this.delayer.trigger(()=>this.throttler.queue(U),V)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=D;class _{constructor(){this._isOpen=!1,this._promise=new Promise((U,V)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=_;class a extends _{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function d(H,U){return U?new Promise((V,Q)=>{const ne=setTimeout(()=>{ce.dispose(),V()},H),ce=U.onCancellationRequested(()=>{clearTimeout(ne),ce.dispose(),Q((0,M.canceled)())})}):y(V=>d(H,V))}e.timeout=d;function S(H,U=0){const V=setTimeout(H,U);return(0,A.toDisposable)(()=>clearTimeout(V))}e.disposableTimeout=S;function i(H){const U=[];let V=0;const Q=H.length;function ne(){return V<Q?H[V++]():null}function ce(Z){Z!=null&&U.push(Z);const oe=ne();return oe?oe.then(ce):Promise.resolve(U)}return Promise.resolve(null).then(ce)}e.sequence=i;function p(H,U=Q=>!!Q,V=null){let Q=0;const ne=H.length,ce=()=>{if(Q>=ne)return Promise.resolve(V);const Z=H[Q++];return Promise.resolve(Z()).then(ve=>U(ve)?Promise.resolve(ve):ce())};return ce()}e.first=p;function r(H,U=Q=>!!Q,V=null){if(H.length===0)return Promise.resolve(V);let Q=H.length;const ne=()=>{Q=-1;for(const ce of H)ce.cancel?.()};return new Promise((ce,Z)=>{for(const oe of H)oe.then(ve=>{--Q>=0&&U(ve)?(ne(),ce(ve)):Q===0&&ce(V)}).catch(ve=>{--Q>=0&&(ne(),Z(ve))})})}e.firstParallel=r;class s{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new E.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((V,Q)=>{this.outstandingPromises.push({factory:U,c:V,e:Q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const V=U.factory();V.then(U.c,U.e),V.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class u extends s{constructor(){super(1)}}e.Queue=u;class h{constructor(){this.queues=new Map}queueFor(U,V=R.extUri){const Q=V.getComparisonKey(U);let ne=this.queues.get(Q);return ne||(ne=new u,E.Event.once(ne.onFinished)(()=>{ne?.dispose(),this.queues.delete(Q)}),this.queues.set(Q,ne)),ne}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=h;class m{constructor(U,V){this._token=-1,typeof U=="function"&&typeof V=="number"&&this.setIfNotSet(U,V)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,V){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},V)}setIfNotSet(U,V){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},V))}}e.TimeoutTimer=m;class k{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,V){this.cancel(),this._token=setInterval(()=>{U()},V)}}e.IntervalTimer=k;class T{constructor(U,V){this.timeoutToken=-1,this.runner=U,this.timeout=V,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class g{constructor(U,V){V%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=V,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=g;class I extends T{constructor(U,V){super(U,V);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=I;class F extends A.Disposable{constructor(U,V,Q,ne){super();this.maxWorkChunkSize=U,this.maxPendingWork=V,this.throttleDelay=Q,this.handler=ne,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.maxPendingWork)return!1}else if(this.pending+U.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new T(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=H=>{const U=setTimeout(()=>{const Q=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Q-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0,clearTimeout(U))}}}:e.runWhenIdle=(H,U)=>{const V=requestIdleCallback(H,typeof U=="number"?{timeout:U}:void 0);let Q=!1;return{dispose(){Q||(Q=!0,cancelIdleCallback(V))}}}}();class L{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=L;async function w(H,U,V){let Q;for(let ne=0;ne<V;ne++)try{return await H()}catch(ce){Q=ce,await d(U)}throw Q}e.retry=w;class x{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,V,Q){return this._pending={taskId:U,cancel:()=>Q?.(),promise:V},V.then(()=>this.donePending(U),()=>this.donePending(U)),V}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let V,Q;const ne=new Promise((ce,Z)=>{V=ce,Q=Z});this._next={run:U,promise:ne,promiseResolve:V,promiseReject:Q}}return this._next.promise}}e.TaskSequentializer=x;class W{constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,V)=>{this.completeCallback=U,this.errorCallback=V})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(V=>{this.completeCallback(U),this.resolved=!0,V()})}error(U){return new Promise(V=>{this.errorCallback(U),this.rejected=!0,V()})}cancel(){new Promise(U=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=B;var G;(function(H){async function U(V){let Q;const ne=await Promise.all(V.map(ce=>ce.then(Z=>Z,Z=>{Q||(Q=Z)})));if(typeof Q!="undefined")throw Q;return ne}H.settled=U})(G=e.Promises||(e.Promises={}))}),define(be[108],Ee([0,1,14,17]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const E=new c.IdleValue(()=>{const T=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:T,collatorIsNumeric:T.resolvedOptions().numeric}}),A=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(T,g,I=!1){const F=T||"",L=g||"",w=E.value.collator.compare(F,L);return E.value.collatorIsNumeric&&w===0&&F!==L?F<L?-1:1:w}e.compareFileNames=C;function y(T,g){const I=A.value.collator;return T=T||"",g=g||"",S(I,T,g)}e.compareFileNamesDefault=y;function P(T,g){const I=A.value.collator;return T=T||"",g=g||"",s(T,g)||S(I,T,g)}e.compareFileNamesUpper=P;function t(T,g){const I=A.value.collator;return T=T||"",g=g||"",r(T,g)||S(I,T,g)}e.compareFileNamesLower=t;function b(T,g){return T=T||"",g=g||"",T===g?0:T<g?-1:1}e.compareFileNamesUnicode=b;function n(T,g,I=!1){I||(T=T&&T.toLowerCase(),g=g&&g.toLowerCase());const[F,L]=a(T),[w,x]=a(g);return F!==w?F<w?-1:1:L===x?0:L<x?-1:1}e.noIntlCompareFileNames=n;function f(T,g){const[I,F]=a(T),[L,w]=a(g);let x=E.value.collator.compare(F,w);if(x===0){if(E.value.collatorIsNumeric&&F!==w)return F<w?-1:1;if(x=E.value.collator.compare(I,L),E.value.collatorIsNumeric&&x===0&&I!==L)return I<L?-1:1}return x}e.compareFileExtensions=f;function o(T,g){T=T||"",g=g||"";const I=d(T),F=d(g),L=A.value.collator,w=R.value.collator;return S(w,I,F)||S(L,T,g)}e.compareFileExtensionsDefault=o;function l(T,g){T=T||"",g=g||"";const I=d(T),F=d(g),L=A.value.collator,w=R.value.collator;return S(w,I,F)||s(T,g)||S(L,T,g)}e.compareFileExtensionsUpper=l;function v(T,g){T=T||"",g=g||"";const I=d(T),F=d(g),L=A.value.collator,w=R.value.collator;return S(w,I,F)||r(T,g)||S(L,T,g)}e.compareFileExtensionsLower=v;function D(T,g){T=T||"",g=g||"";const I=d(T).toLowerCase(),F=d(g).toLowerCase();return I!==F?I<F?-1:1:T!==g?T<g?-1:1:0}e.compareFileExtensionsUnicode=D;const _=/^(.*?)(\.([^.]*))?$/;function a(T,g=!1){const I=T?_.exec(T):[];let F=[I&&I[1]||"",I&&I[3]||""];return g&&(!F[0]&&F[1]||F[0]&&F[0].charAt(0)===".")&&(F=[F[0]+"."+F[1],""]),F}function d(T){const g=T?_.exec(T):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function S(T,g,I){let F=T.compare(g,I);return F!==0?F:g.length!==I.length?g.length<I.length?-1:1:0}function i(T){const g=T.charAt(0);return g.toLocaleUpperCase()!==g}function p(T){const g=T.charAt(0);return g.toLocaleLowerCase()!==g}function r(T,g){return i(T)&&p(g)?-1:p(T)&&i(g)?1:0}function s(T,g){return p(T)&&i(g)?-1:i(T)&&p(g)?1:0}function u(T,g,I=!1){return I||(T=T&&T.toLowerCase(),g=g&&g.toLowerCase()),T===g?0:T<g?-1:1}function h(T,g,I=!1){const F=T.split(M.sep),L=g.split(M.sep),w=F.length-1,x=L.length-1;let W,B;for(let G=0;;G++){if(W=w===G,B=x===G,W&&B)return C(F[G],L[G],I);if(W)return-1;if(B)return 1;const H=u(F[G],L[G],I);if(H!==0)return H}}e.comparePaths=h;function m(T,g,I){const F=T.toLowerCase(),L=g.toLowerCase(),w=k(T,g,I);if(w)return w;const x=F.endsWith(I),W=L.endsWith(I);if(x!==W)return x?-1:1;const B=C(F,L);return B!==0?B:F.localeCompare(L)}e.compareAnything=m;function k(T,g,I){const F=T.toLowerCase(),L=g.toLowerCase(),w=F.startsWith(I),x=L.startsWith(I);if(w!==x)return w?-1:1;if(w&&x){if(F.length<L.length)return-1;if(F.length>L.length)return 1}return 0}e.compareByPrefix=k}),define(be[27],Ee([0,1,14,43,20,17,9]),function(re,e,c,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const y="**",P="/",t="[/\\\\]",b="[^/\\\\]",n=/\//g;function f(Q){switch(Q){case 0:return"";case 1:return`${b}*?`;default:return`(?:${t}|${b}+${t}|${t}${b}+)*?`}}function o(Q,ne){if(!Q)return[];const ce=[];let Z=!1,oe=!1,ve="";for(const Ae of Q){switch(Ae){case ne:if(!Z&&!oe){ce.push(ve),ve="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}ve+=Ae}return ve&&ce.push(ve),ce}e.splitGlobAware=o;function l(Q){if(!Q)return"";let ne="";const ce=o(Q,P);if(ce.every(Z=>Z===y))ne=".*";else{let Z=!1;ce.forEach((oe,ve)=>{if(oe===y){Z||(ne+=f(2),Z=!0);return}let Ae=!1,Se="",Ne=!1,We="";for(const je of oe){if(je!=="}"&&Ae){Se+=je;continue}if(Ne&&(je!=="]"||!We)){let qe;je==="-"?qe=je:(je==="^"||je==="!")&&!We?qe="^":je===P?qe="":qe=R.escapeRegExpCharacters(je),We+=qe;continue}switch(je){case"{":Ae=!0;continue;case"[":Ne=!0;continue;case"}":ne+=`(?:${o(Se,",").map(K=>l(K)).join("|")})`,Ae=!1,Se="";break;case"]":ne+="["+We+"]",Ne=!1,We="";break;case"?":ne+=b;continue;case"*":ne+=f(1);continue;default:ne+=R.escapeRegExpCharacters(je)}}ve<ce.length-1&&(ce[ve+1]!==y||ve+2<ce.length)&&(ne+=t),Z=!1})}return ne}const v=/^\*\*\/\*\.[\w\.-]+$/,D=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,S=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new E.LRUCache(1e4),p=function(){return!1},r=function(){return null};function s(Q,ne){if(!Q)return r;let ce;typeof Q!="string"?ce=Q.pattern:ce=Q,ce=ce.trim();const Z=`${ce}_${!!ne.trimForExclusions}`;let oe=i.get(Z);if(oe)return u(oe,Q);let ve;if(v.test(ce)){const Ae=ce.substr(4);oe=function(Se,Ne){return typeof Se=="string"&&Se.endsWith(Ae)?ce:null}}else(ve=D.exec(h(ce,ne)))?oe=m(ve[1],ce):(ne.trimForExclusions?a:_).test(ce)?oe=k(ce,ne):(ve=d.exec(h(ce,ne)))?oe=T(ve[1].substr(1),ce,!0):(ve=S.exec(h(ce,ne)))?oe=T(ve[1],ce,!1):oe=g(ce);return i.set(Z,oe),u(oe,Q)}function u(Q,ne){return typeof ne=="string"?Q:function(ce,Z){return M.isEqualOrParent(ce,ne.base)?Q(A.relative(ne.base,ce),Z):null}}function h(Q,ne){return ne.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function m(Q,ne){const ce=`/${Q}`,Z=`\\${Q}`,oe=function(Ae,Se){return typeof Ae!="string"?null:Se?Se===Q?ne:null:Ae===Q||Ae.endsWith(ce)||Ae.endsWith(Z)?ne:null},ve=[Q];return oe.basenames=ve,oe.patterns=[ne],oe.allBasenames=ve,oe}function k(Q,ne){const ce=V(Q.slice(1,-1).split(",").map(Se=>s(Se,ne)).filter(Se=>Se!==r),Q),Z=ce.length;if(!Z)return r;if(Z===1)return ce[0];const oe=function(Se,Ne){for(let We=0,je=ce.length;We<je;We++)if(ce[We](Se,Ne))return Q;return null},ve=ce.find(Se=>!!Se.allBasenames);ve&&(oe.allBasenames=ve.allBasenames);const Ae=ce.reduce((Se,Ne)=>Ne.allPaths?Se.concat(Ne.allPaths):Se,[]);return Ae.length&&(oe.allPaths=Ae),oe}function T(Q,ne,ce){const Z=A.sep===A.posix.sep,oe=Z?Q:Q.replace(n,A.sep),ve=A.sep+oe,Ae=A.posix.sep+Q,Se=ce?function(Ne,We){return typeof Ne=="string"&&(Ne===oe||Ne.endsWith(ve)||!Z&&(Ne===Q||Ne.endsWith(Ae)))?ne:null}:function(Ne,We){return typeof Ne=="string"&&(Ne===oe||!Z&&Ne===Q)?ne:null};return Se.allPaths=[(ce?"*/":"./")+Q],Se}function g(Q){try{const ne=new RegExp(`^${l(Q)}$`);return function(ce){return ne.lastIndex=0,typeof ce=="string"&&ne.test(ce)?Q:null}}catch(ne){return r}}function I(Q,ne,ce){return!Q||typeof ne!="string"?!1:F(Q)(ne,void 0,ce)}e.match=I;function F(Q,ne={}){if(!Q)return p;if(typeof Q=="string"||W(Q)){const ce=s(Q,ne);if(ce===r)return p;const Z=function(oe,ve){return!!ce(oe,ve)};return ce.allBasenames&&(Z.allBasenames=ce.allBasenames),ce.allPaths&&(Z.allPaths=ce.allPaths),Z}return H(Q,ne)}e.parse=F;function L(Q){if(!Q)return;let ne;return ce=>(ne||(ne=(Q()||Promise.resolve([])).then(Z=>Z?x(Z):{})),ne.then(Z=>!!Z[ce]))}e.hasSiblingPromiseFn=L;function w(Q){if(!Q)return;let ne;return ce=>{if(!ne){const Z=Q();ne=Z?x(Z):{}}return!!ne[ce]}}e.hasSiblingFn=w;function x(Q){const ne={};for(const ce of Q)ne[ce]=!0;return ne}function W(Q){const ne=Q;return ne&&typeof ne.base=="string"&&typeof ne.pattern=="string"}e.isRelativePattern=W;function B(Q){return Q.allBasenames||[]}e.getBasenameTerms=B;function G(Q){return Q.allPaths||[]}e.getPathTerms=G;function H(Q,ne){const ce=V(Object.getOwnPropertyNames(Q).map(Se=>U(Se,Q[Se],ne)).filter(Se=>Se!==r)),Z=ce.length;if(!Z)return r;if(!ce.some(Se=>!!Se.requiresSiblings)){if(Z===1)return ce[0];const Se=function(je,qe){for(let $=0,K=ce.length;$<K;$++){const ee=ce[$](je,qe);if(ee)return ee}return null},Ne=ce.find(je=>!!je.allBasenames);Ne&&(Se.allBasenames=Ne.allBasenames);const We=ce.reduce((je,qe)=>qe.allPaths?je.concat(qe.allPaths):je,[]);return We.length&&(Se.allPaths=We),Se}const oe=function(Se,Ne,We){let je;for(let qe=0,$=ce.length;qe<$;qe++){const K=ce[qe];K.requiresSiblings&&We&&(Ne||(Ne=A.basename(Se)),je||(je=Ne.substr(0,Ne.length-A.extname(Se).length)));const ee=K(Se,Ne,je,We);if(ee)return ee}return null},ve=ce.find(Se=>!!Se.allBasenames);ve&&(oe.allBasenames=ve.allBasenames);const Ae=ce.reduce((Se,Ne)=>Ne.allPaths?Se.concat(Ne.allPaths):Se,[]);return Ae.length&&(oe.allPaths=Ae),oe}function U(Q,ne,ce){if(ne===!1)return r;const Z=s(Q,ce);if(Z===r)return r;if(typeof ne=="boolean")return Z;if(ne){const oe=ne.when;if(typeof oe=="string"){const ve=(Ae,Se,Ne,We)=>{if(!We||!Z(Ae,Se))return null;const je=oe.replace("$(basename)",Ne),qe=We(je);return(0,c.isThenable)(qe)?qe.then($=>$?Q:null):qe?Q:null};return ve.requiresSiblings=!0,ve}}return Z}function V(Q,ne){const ce=Q.filter(Se=>!!Se.basenames);if(ce.length<2)return Q;const Z=ce.reduce((Se,Ne)=>{const We=Ne.basenames;return We?Se.concat(We):Se},[]);let oe;if(ne){oe=[];for(let Se=0,Ne=Z.length;Se<Ne;Se++)oe.push(ne)}else oe=ce.reduce((Se,Ne)=>{const We=Ne.patterns;return We?Se.concat(We):Se},[]);const ve=function(Se,Ne){if(typeof Se!="string")return null;if(!Ne){let je;for(je=Se.length;je>0;je--){const qe=Se.charCodeAt(je-1);if(qe===47||qe===92)break}Ne=Se.substr(je)}const We=Z.indexOf(Ne);return We!==-1?oe[We]:null};ve.basenames=Z,ve.patterns=oe,ve.allBasenames=Z;const Ae=Q.filter(Se=>!Se.basenames);return Ae.push(ve),Ae}}),define(be[77],Ee([0,1,43,11,17,25,24,9,2]),function(re,e,c,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(s,u,h){if(typeof s=="string"&&(s=y.URI.file(s)),h){const k=h.getWorkspaceFolder(s);if(k){const T=h.getWorkspace().folders.length>1;let g;if((0,R.isEqual)(k.uri,s)?g="":g=(0,R.relativePath)(k.uri,s),T){const I=k.name?k.name:(0,R.basename)(k.uri);g=g?I+" \u2022 "+g:I}return g}}if(s.scheme!==M.Schemas.file&&s.scheme!==M.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,c.hasDriveLetter)(s.fsPath))return(0,E.normalize)(b(s.fsPath));let m=(0,E.normalize)(s.fsPath);return!A.isWindows&&u?.userHome&&(m=f(m,u.userHome.fsPath)),m}e.getPathLabel=P;function t(s){if(!s)return;typeof s=="string"&&(s=y.URI.file(s));const u=(0,R.basename)(s)||(s.scheme===M.Schemas.file?s.fsPath:s.path);return A.isWindows&&(0,c.isRootOrDriveLetter)(u)?b(u):u}e.getBaseLabel=t;function b(s){return(0,c.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=b;let n=Object.create(null);function f(s,u){if(A.isWindows||!s||!u)return s;let h=n.original===u?n.normalized:void 0;return h||(h=`${(0,C.rtrim)(u,E.posix.sep)}${E.posix.sep}`,n={original:u,normalized:h}),(A.isLinux?s.startsWith(h):(0,C.startsWithIgnoreCase)(s,h))&&(s=`~/${s.substr(h.length)}`),s}e.tildify=f;function o(s,u){return s.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=o;const l="\u2026",v="\\\\",D="~";function _(s,u=E.sep){const h=new Array(s.length);let m=!1;for(let k=0;k<s.length;k++){let T=s[k];if(T===""){h[k]=`.${u}`;continue}if(!T){h[k]=T;continue}m=!0;let g="";T.indexOf(v)===0?(g=T.substr(0,T.indexOf(v)+v.length),T=T.substr(T.indexOf(v)+v.length)):T.indexOf(u)===0?(g=T.substr(0,T.indexOf(u)+u.length),T=T.substr(T.indexOf(u)+u.length)):T.indexOf(D)===0&&(g=T.substr(0,T.indexOf(D)+D.length),T=T.substr(T.indexOf(D)+D.length));const I=T.split(u);for(let F=1;m&&F<=I.length;F++)for(let L=I.length-F;m&&L>=0;L--){m=!1;let w=I.slice(L,L+F).join(u);for(let x=0;!m&&x<s.length;x++)if(x!==k&&s[x]&&s[x].indexOf(w)>-1){const W=L+F===I.length,B=L>0&&s[x].indexOf(u)>-1?u+w:w,G=s[x].endsWith(B);m=!W||G}if(!m){let x="";(I[0].endsWith(":")||g!=="")&&(L===1&&(L=0,F++,w=I[0]+u+w),L>0&&(x=I[0]+u),x=g+x),L>0&&(x=x+l+u),x=x+w,L+F<I.length&&(x=x+u+l),h[k]=x}}m&&(h[k]=T)}return h}e.shorten=_;var a;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function d(s,u=Object.create(null)){const h=[];let m=!1,k="";for(const T of s)if(T==="$"||m&&T==="{")k&&h.push({value:k,type:a.TEXT}),k="",m=!0;else if(T==="}"&&m){const g=u[k];if(typeof g=="string")g.length&&h.push({value:g,type:a.VARIABLE});else if(g){const I=h[h.length-1];(!I||I.type!==a.SEPARATOR)&&h.push({value:g.label,type:a.SEPARATOR})}k="",m=!1}else k+=T;return k&&!m&&h.push({value:k,type:a.TEXT}),h.filter((T,g)=>{if(T.type===a.SEPARATOR){const I=h[g-1],F=h[g+1];return[I,F].every(L=>L&&(L.type===a.VARIABLE||L.type===a.TEXT)&&L.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=d;function S(s,u){return A.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):s.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function i(s,u){return A.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,""):A.isWindows?s.replace(/&&|&/g,h=>h==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function p(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=p;function r(s){const u=s.indexOf("/")!==-1?E.posix:E.win32,h=u.basename(s),m=u.dirname(s);return h.length?{name:h,parentPath:m}:{name:m,parentPath:""}}e.splitName=r}),define(be[78],Ee([0,1,27,11,17,24,9]),function(re,e,c,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown",s.latex="text/latex"})(C=e.Mimes||(e.Mimes={}));let y=[],P=[],t=[];function b(s,u=!1){const h=n(s);y.push(h),h.userConfigured?t.push(h):P.push(h),u&&!h.userConfigured&&y.forEach(m=>{m.mime===h.mime||m.userConfigured||(h.extension&&m.extension===h.extension&&console.warn(`Overwriting extension <<${h.extension}>> to now point to mime <<${h.mime}>>`),h.filename&&m.filename===h.filename&&console.warn(`Overwriting filename <<${h.filename}>> to now point to mime <<${h.mime}>>`),h.filepattern&&m.filepattern===h.filepattern&&console.warn(`Overwriting filepattern <<${h.filepattern}>> to now point to mime <<${h.mime}>>`),h.firstline&&m.firstline===h.firstline&&console.warn(`Overwriting firstline <<${h.firstline}>> to now point to mime <<${h.mime}>>`))})}e.registerTextMime=b;function n(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?(0,c.parse)(s.filepattern.toLowerCase()):void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(E.posix.sep)>=0:!1}}function f(s){s?(y=y.filter(u=>!u.userConfigured),t=[]):(y=[],P=[],t=[])}e.clearTextMimes=f;function o(s,u){let h;if(s)switch(s.scheme){case M.Schemas.file:h=s.fsPath;break;case M.Schemas.data:h=A.DataUri.parseMetaData(s).get(A.DataUri.META_DATA_LABEL);break;default:h=s.path}if(!h)return[C.unknown];h=h.toLowerCase();const m=(0,E.basename)(h),k=l(h,m,t);if(k)return[k,C.text];const T=l(h,m,P);if(T)return[T,C.text];if(u){const g=v(u);if(g)return[g,C.text]}return[C.unknown]}e.guessMimeTypes=o;function l(s,u,h){let m=null,k=null,T=null;for(let g=h.length-1;g>=0;g--){const I=h[g];if(u===I.filenameLowercase){m=I;break}if(I.filepattern&&(!k||I.filepattern.length>k.filepattern.length)){const F=I.filepatternOnPath?s:u;I.filepatternLowercase?.(F)&&(k=I)}I.extension&&(!T||I.extension.length>T.extension.length)&&u.endsWith(I.extensionLowercase)&&(T=I)}return m?m.mime:k?k.mime:T?T.mime:null}function v(s){if((0,R.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let u=y.length-1;u>=0;u--){const h=y[u];if(!h.firstline)continue;const m=s.match(h.firstline);if(m&&m.length>0)return h.mime}return null}function D(s){return s?typeof s=="string"?s===C.binary||s===C.text||s===C.unknown:s.length===1&&D(s[0]):!0}e.isUnspecific=D;const _={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},a={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function d(s){const u=(0,E.extname)(s),h=_[u.toLowerCase()];return h!==void 0?h:S(s)}e.getMediaOrTextMime=d;function S(s){const u=(0,E.extname)(s);return a[u.toLowerCase()]}e.getMediaMime=S;function i(s){for(const u in a)if(a[u]===s)return u}e.getExtensionForMimeType=i;const p=/^(.+)\/(.+?)(;.+)?$/;function r(s,u){const h=p.exec(s);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:u?void 0:s}e.normalizeMimeType=r}),define(be[109],Ee([0,1,2]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class E{constructor(b){this._uriTransformer=b}transformIncoming(b){const n=this._uriTransformer.transformIncoming(b);return n===b?b:M(c.URI.from(n))}transformOutgoing(b){const n=this._uriTransformer.transformOutgoing(b);return n===b?b:M(c.URI.from(n))}transformOutgoingURI(b){const n=this._uriTransformer.transformOutgoing(b);return n===b?b:c.URI.from(n)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=E,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function A(t,b,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof c.URI)return b.transformOutgoing(t);for(let f in t)if(Object.hasOwnProperty.call(t,f)){const o=A(t[f],b,n+1);o!==null&&(t[f]=o)}}return null}function R(t,b){const n=A(t,b,0);return n===null?t:n}e.transformOutgoingURIs=R;function C(t,b,n,f){if(!t||f>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?c.URI.revive(b.transformIncoming(t)):b.transformIncoming(t);for(let o in t)if(Object.hasOwnProperty.call(t,o)){const l=C(t[o],b,n,f+1);l!==null&&(t[o]=l)}}return null}function y(t,b){const n=C(t,b,!1,0);return n===null?t:n}e.transformIncomingURIs=y;function P(t,b){const n=C(t,b,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=P}),define(be[36],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(y){return c.test(y)}e.isUUID=M;const E=new Uint8Array(16),A=[];for(let y=0;y<256;y++)A.push(y.toString(16).padStart(2,"0"));let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(y){for(let P=0;P<y.length;P++)y[P]=Math.floor(Math.random()*256);return y};function C(){R(E),E[6]=E[6]&15|64,E[8]=E[8]&63|128;let y=0,P="";return P+=A[E[y++]],P+=A[E[y++]],P+=A[E[y++]],P+=A[E[y++]],P+="-",P+=A[E[y++]],P+=A[E[y++]],P+="-",P+=A[E[y++]],P+=A[E[y++]],P+="-",P+=A[E[y++]],P+=A[E[y++]],P+="-",P+=A[E[y++]],P+=A[E[y++]],P+=A[E[y++]],P+=A[E[y++]],P+=A[E[y++]],P+=A[E[y++]],P}e.generateUuid=C}),define(be[110],Ee([0,1,227]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class E extends c.CharacterClassifier{constructor(C){super(0);for(let y=0,P=C.length;y<P;y++)this.set(C.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=E;function A(R){let C={};return y=>(C.hasOwnProperty(y)||(C[y]=R(y)),C[y])}e.getMapForWordSeparators=A(R=>new E(R))}),define(be[79],Ee([0,1,23]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.BracketPair=e.IndentGuide=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(D){D[D.Left=1]="Left",D[D.Center=2]="Center",D[D.Right=4]="Right",D[D.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var E;(function(D){D[D.Inline=1]="Inline",D[D.Gutter=2]="Gutter"})(E=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(D){D[D.TextDefined=0]="TextDefined",D[D.LF=1]="LF",D[D.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var R;(function(D){D[D.LF=1]="LF",D[D.CRLF=2]="CRLF"})(R=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var C;(function(D){D[D.LF=0]="LF",D[D.CRLF=1]="CRLF"})(C=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(_){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,_.tabSize|0),this.indentSize=_.tabSize|0,this.insertSpaces=Boolean(_.insertSpaces),this.defaultEOL=_.defaultEOL|0,this.trimAutoWhitespace=Boolean(_.trimAutoWhitespace),this.bracketPairColorizationOptions=_.bracketPairColorizationOptions}equals(_){return this.tabSize===_.tabSize&&this.indentSize===_.indentSize&&this.insertSpaces===_.insertSpaces&&this.defaultEOL===_.defaultEOL&&this.trimAutoWhitespace===_.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,_.bracketPairColorizationOptions)}createChangeEvent(_){return{tabSize:this.tabSize!==_.tabSize,indentSize:this.indentSize!==_.indentSize,insertSpaces:this.insertSpaces!==_.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==_.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class P{constructor(_,a){this._findMatchBrand=void 0,this.range=_,this.matches=a}}e.FindMatch=P;var t;(function(D){D[D.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",D[D.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",D[D.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",D[D.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));class b{constructor(_,a){this.visibleColumn=_,this.className=a}}e.IndentGuide=b;class n{constructor(_,a,d,S){this.range=_,this.openingBracketRange=a,this.closingBracketRange=d,this.nestingLevel=S}}e.BracketPair=n;var f;(function(D){D[D.Left=0]="Left",D[D.Right=1]="Right",D[D.None=2]="None"})(f=e.PositionAffinity||(e.PositionAffinity={}));var o;(function(D){D[D.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(o=e.ModelConstants||(e.ModelConstants={}));class l{constructor(_,a,d,S,i,p){this.identifier=_,this.range=a,this.text=d,this.forceMoveMarkers=S,this.isAutoWhitespaceEdit=i,this._isTracked=p}}e.ValidAnnotatedEditOperation=l;class v{constructor(_,a,d){this.reverseEdits=_,this.changes=a,this.trimAutoWhitespaceLineNumbers=d}}e.ApplyEditsResult=v}),define(be[111],Ee([0,1,9,110,112,44,79]),function(re,e,c,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class y{constructor(a,d,S,i){this.searchString=a,this.isRegex=d,this.matchCase=S,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=P(this.searchString):a=this.searchString.indexOf(`
`)>=0;let d=null;try{d=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch(i){return null}if(!d)return null;let S=!this.isRegex&&!a;return S&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(S=this.matchCase),new t(d,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,S?this.searchString:null)}}e.SearchParams=y;function P(_){if(!_||_.length===0)return!1;for(let a=0,d=_.length;a<d;a++)if(_.charCodeAt(a)===92){if(a++,a>=d)break;const i=_.charCodeAt(a);if(i===110||i===114||i===87)return!0}return!1}e.isMultilineRegexSource=P;class t{constructor(a,d,S){this.regex=a,this.wordSeparators=d,this.simpleSearch=S}}e.SearchData=t;function b(_,a,d){if(!d)return new R.FindMatch(_,null);let S=[];for(let i=0,p=a.length;i<p;i++)S[i]=a[i];return new R.FindMatch(_,S)}e.createFindMatch=b;class n{constructor(a){let d=[],S=0;for(let i=0,p=a.length;i<p;i++)a.charCodeAt(i)===10&&(d[S++]=i);this._lineFeedsOffsets=d}findLineFeedCountBeforeOffset(a){const d=this._lineFeedsOffsets;let S=0,i=d.length-1;if(i===-1||a<=d[0])return 0;for(;S<i;){const p=S+((i-S)/2>>0);d[p]>=a?i=p-1:d[p+1]>=a?(S=p,i=p):S=p+1}return S+1}}class f{static findMatches(a,d,S,i,p){const r=d.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(a,S,new D(r.wordSeparators,r.regex),i,p):this._doFindMatchesLineByLine(a,S,r,i,p):[]}static _getMultilineMatchRange(a,d,S,i,p,r){let s,u=0;i?(u=i.findLineFeedCountBeforeOffset(p),s=d+p+u):s=d+p;let h;if(i){let g=i.findLineFeedCountBeforeOffset(p+r.length)-u;h=s+r.length+g}else h=s+r.length;const m=a.getPositionAt(s),k=a.getPositionAt(h);return new A.Range(m.lineNumber,m.column,k.lineNumber,k.column)}static _doFindMatchesMultiline(a,d,S,i,p){const r=a.getOffsetAt(d.getStartPosition()),s=a.getValueInRange(d,1),u=a.getEOL()===`\r
`?new n(s):null,h=[];let m=0,k;for(S.reset(0);k=S.next(s);)if(h[m++]=b(this._getMultilineMatchRange(a,r,s,u,k.index,k[0]),k,i),m>=p)return h;return h}static _doFindMatchesLineByLine(a,d,S,i,p){const r=[];let s=0;if(d.startLineNumber===d.endLineNumber){const h=a.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return s=this._findMatchesInLine(S,h,d.startLineNumber,d.startColumn-1,s,r,i,p),r}const u=a.getLineContent(d.startLineNumber).substring(d.startColumn-1);s=this._findMatchesInLine(S,u,d.startLineNumber,d.startColumn-1,s,r,i,p);for(let h=d.startLineNumber+1;h<d.endLineNumber&&s<p;h++)s=this._findMatchesInLine(S,a.getLineContent(h),h,0,s,r,i,p);if(s<p){const h=a.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);s=this._findMatchesInLine(S,h,d.endLineNumber,0,s,r,i,p)}return r}static _findMatchesInLine(a,d,S,i,p,r,s,u){const h=a.wordSeparators;if(!s&&a.simpleSearch){const T=a.simpleSearch,g=T.length,I=d.length;let F=-g;for(;(F=d.indexOf(T,F+g))!==-1;)if((!h||v(h,d,I,F,g))&&(r[p++]=new R.FindMatch(new A.Range(S,F+1+i,S,F+1+g+i),null),p>=u))return p;return p}const m=new D(a.wordSeparators,a.regex);let k;m.reset(0);do if(k=m.next(d),k&&(r[p++]=b(new A.Range(S,k.index+1+i,S,k.index+1+k[0].length+i),k,s),p>=u))return p;while(k);return p}static findNextMatch(a,d,S,i){const p=d.parseSearchRequest();if(!p)return null;const r=new D(p.wordSeparators,p.regex);return p.regex.multiline?this._doFindNextMatchMultiline(a,S,r,i):this._doFindNextMatchLineByLine(a,S,r,i)}static _doFindNextMatchMultiline(a,d,S,i){const p=new E.Position(d.lineNumber,1),r=a.getOffsetAt(p),s=a.getLineCount(),u=a.getValueInRange(new A.Range(p.lineNumber,p.column,s,a.getLineMaxColumn(s)),1),h=a.getEOL()===`\r
`?new n(u):null;S.reset(d.column-1);let m=S.next(u);return m?b(this._getMultilineMatchRange(a,r,u,h,m.index,m[0]),m,i):d.lineNumber!==1||d.column!==1?this._doFindNextMatchMultiline(a,new E.Position(1,1),S,i):null}static _doFindNextMatchLineByLine(a,d,S,i){const p=a.getLineCount(),r=d.lineNumber,s=a.getLineContent(r),u=this._findFirstMatchInLine(S,s,r,d.column,i);if(u)return u;for(let h=1;h<=p;h++){const m=(r+h-1)%p,k=a.getLineContent(m+1),T=this._findFirstMatchInLine(S,k,m+1,1,i);if(T)return T}return null}static _findFirstMatchInLine(a,d,S,i,p){a.reset(i-1);const r=a.next(d);return r?b(new A.Range(S,r.index+1,S,r.index+1+r[0].length),r,p):null}static findPreviousMatch(a,d,S,i){const p=d.parseSearchRequest();if(!p)return null;const r=new D(p.wordSeparators,p.regex);return p.regex.multiline?this._doFindPreviousMatchMultiline(a,S,r,i):this._doFindPreviousMatchLineByLine(a,S,r,i)}static _doFindPreviousMatchMultiline(a,d,S,i){const p=this._doFindMatchesMultiline(a,new A.Range(1,1,d.lineNumber,d.column),S,i,10*C);if(p.length>0)return p[p.length-1];const r=a.getLineCount();return d.lineNumber!==r||d.column!==a.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(a,new E.Position(r,a.getLineMaxColumn(r)),S,i):null}static _doFindPreviousMatchLineByLine(a,d,S,i){const p=a.getLineCount(),r=d.lineNumber,s=a.getLineContent(r).substring(0,d.column-1),u=this._findLastMatchInLine(S,s,r,i);if(u)return u;for(let h=1;h<=p;h++){const m=(p+r-h-1)%p,k=a.getLineContent(m+1),T=this._findLastMatchInLine(S,k,m+1,i);if(T)return T}return null}static _findLastMatchInLine(a,d,S,i){let p=null,r;for(a.reset(0);r=a.next(d);)p=b(new A.Range(S,r.index+1,S,r.index+1+r[0].length),r,i);return p}}e.TextModelSearch=f;function o(_,a,d,S,i){if(S===0)return!0;const p=a.charCodeAt(S-1);if(_.get(p)!==0||p===13||p===10)return!0;if(i>0){const r=a.charCodeAt(S);if(_.get(r)!==0)return!0}return!1}function l(_,a,d,S,i){if(S+i===d)return!0;const p=a.charCodeAt(S+i);if(_.get(p)!==0||p===13||p===10)return!0;if(i>0){const r=a.charCodeAt(S+i-1);if(_.get(r)!==0)return!0}return!1}function v(_,a,d,S,i){return o(_,a,d,S,i)&&l(_,a,d,S,i)}e.isValidMatch=v;class D{constructor(a,d){this._wordSeparators=a,this._searchRegex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const d=a.length;let S;do{if(this._prevMatchStartIndex+this._prevMatchLength===d||(S=this._searchRegex.exec(a),!S))return null;const i=S.index,p=S[0].length;if(i===this._prevMatchStartIndex&&p===this._prevMatchLength){if(p===0){c.getNextCodePoint(a,d,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=p,!this._wordSeparators||v(this._wordSeparators,a,d,i,p))return S}while(S);return null}}e.Searcher=D}),define(be[113],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class M{constructor(C){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let y=0,P=C.notIn.length;y<P;y++)switch(C.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=M;class E{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of C)A(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),A(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),A(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),A(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&A(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=E;function A(R,C,y){R.has(C)?R.get(C).push(y):R.set(C,[y])}}),define(be[55],Ee([0,1,27,17]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function E(A,R,C,y){if(Array.isArray(A)){let P=0;for(const t of A){const b=E(t,R,C,y);if(b===10)return b;b>P&&(P=b)}return P}else{if(typeof A=="string")return y?A==="*"?5:A===C?10:0:0;if(A){const{language:P,pattern:t,scheme:b,hasAccessToAllModels:n}=A;if(!y&&!n)return 0;let f=0;if(b)if(b===R.scheme)f=10;else if(b==="*")f=5;else return 0;if(P)if(P===C)f=10;else if(P==="*")f=Math.max(f,5);else return 0;if(t){let o;if(typeof t=="string"?o=t:o={...t,base:(0,M.normalize)(t.base)},o===R.fsPath||(0,c.match)(o,R.fsPath))f=10;else return 0}return f}else return 0}}e.score=E}),define(be[114],Ee([0,1,3,6]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class E{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new c.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(R){this._onDidChange.fire({changedLanguages:R,changedColorMap:!1})}register(R,C){return this._map.set(R,C),this.fire([R]),(0,M.toDisposable)(()=>{this._map.get(R)===C&&(this._map.delete(R),this.fire([R]))})}registerPromise(R,C){let y=null,P=!1;return this._promises.set(R,C.then(t=>{this._promises.delete(R),!(P||!t)&&(y=this.register(R,t))})),(0,M.toDisposable)(()=>{P=!0,y&&y.dispose()})}getPromise(R){const C=this.get(R);if(C)return Promise.resolve(C);const y=this._promises.get(R);return y?y.then(P=>this.get(R)):null}get(R){return this._map.get(R)||null}setColorMap(R){this._colorMap=R,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=E}),define(be[80],Ee([0,1,22,25]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var E;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(E||(E={}));function A(b){for(let n=0,f=b.length;n<f;n+=4){const o=b[n+0],l=b[n+1],v=b[n+2],D=b[n+3];b[n+0]=D,b[n+1]=v,b[n+2]=l,b[n+3]=o}}function R(b){const n=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return M.isLittleEndian()||A(n),c.VSBuffer.wrap(n)}function C(b){const n=b.buffer;if(M.isLittleEndian()||A(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const f=new Uint8Array(n.byteLength);return f.set(n),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function y(b){const n=new Uint32Array(P(b));let f=0;if(n[f++]=b.id,b.type==="full")n[f++]=1,n[f++]=b.data.length,n.set(b.data,f),f+=b.data.length;else{n[f++]=2,n[f++]=b.deltas.length;for(const o of b.deltas)n[f++]=o.start,n[f++]=o.deleteCount,o.data?(n[f++]=o.data.length,n.set(o.data,f),f+=o.data.length):n[f++]=0}return R(n)}e.encodeSemanticTokensDto=y;function P(b){let n=0;if(n+=1+1,b.type==="full")n+=1+b.data.length;else{n+=1,n+=(1+1+1)*b.deltas.length;for(const f of b.deltas)f.data&&(n+=f.data.length)}return n}function t(b){const n=C(b);let f=0;const o=n[f++];if(n[f++]===1){const _=n[f++],a=n.subarray(f,f+_);return f+=_,{id:o,type:"full",data:a}}const v=n[f++];let D=[];for(let _=0;_<v;_++){const a=n[f++],d=n[f++],S=n[f++];let i;S>0&&(i=n.subarray(f,f+S),f+=S),D[_]={start:a,deleteCount:d,data:i}}return{id:o,type:"delta",deltas:D}}e.decodeSemanticTokensDto=t}),define(be[115],Ee([18,19]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(be[56],Ee([0,1,13,10,115]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(P,t){return t&&(P.stack||P.stacktrace)?E.localize(0,null,C(P),R(P.stack)||R(P.stacktrace)):C(P)}function R(P){return Array.isArray(P)?P.join(`
`):P}function C(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?E.localize(1,null,P.message):P.message||E.localize(2,null)}function y(P=null,t=!1){if(!P)return E.localize(3,null);if(Array.isArray(P)){const b=c.coalesce(P),n=y(b[0],t);return b.length>1?E.localize(4,null,n,b.length):n}if(M.isString(P))return P;if(P.detail){const b=P.detail;if(b.error)return A(b.error,t);if(b.exception)return A(b.exception,t)}return P.stack?A(P,t):P.message?P.message:E.localize(5,null)}e.toErrorMessage=y}),define(be[116],Ee([18,19]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(be[117],Ee([0,1,116,25,118]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(j){j[j.None=0]="None",j[j.Keep=1]="Keep",j[j.Brackets=2]="Brackets",j[j.Advanced=3]="Advanced",j[j.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=R;class C{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,me){this._values[J]=me}}e.ValidatedEditorOptions=C;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class P{constructor(J,me,He,Ye){this.id=J,this.name=me,this.defaultValue=He,this.schema=Ye}compute(J,me,He){return He}}class t{constructor(J,me=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=me}validate(J){return this.defaultValue}}class b{constructor(J,me,He,Ye){this.id=J,this.name=me,this.defaultValue=He,this.schema=Ye}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,me,He){return He}}function n(j,J){return typeof j=="undefined"?J:j==="false"?!1:Boolean(j)}e.boolean=n;class f extends b{constructor(J,me,He,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="boolean",Ye.default=He);super(J,me,He,Ye)}validate(J){return n(J,this.defaultValue)}}function o(j,J,me,He){if(typeof j=="undefined")return J;let Ye=parseInt(j,10);return isNaN(Ye)?J:(Ye=Math.max(me,Ye),Ye=Math.min(He,Ye),Ye|0)}e.clampedInt=o;class l extends b{constructor(J,me,He,Ye,st,ot=void 0){typeof ot!="undefined"&&(ot.type="integer",ot.default=He,ot.minimum=Ye,ot.maximum=st);super(J,me,He,ot);this.minimum=Ye,this.maximum=st}static clampedInt(J,me,He,Ye){return o(J,me,He,Ye)}validate(J){return l.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class v extends b{constructor(J,me,He,Ye,st){typeof st!="undefined"&&(st.type="number",st.default=He);super(J,me,He,st);this.validationFn=Ye}static clamp(J,me,He){return J<me?me:J>He?He:J}static float(J,me){if(typeof J=="number")return J;if(typeof J=="undefined")return me;const He=parseFloat(J);return isNaN(He)?me:He}validate(J){return this.validationFn(v.float(J,this.defaultValue))}}class D extends b{static string(J,me){return typeof J!="string"?me:J}constructor(J,me,He,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.default=He);super(J,me,He,Ye)}validate(J){return D.string(J,this.defaultValue)}}function _(j,J,me){return typeof j!="string"||me.indexOf(j)===-1?J:j}e.stringSet=_;class a extends b{constructor(J,me,He,Ye,st=void 0){typeof st!="undefined"&&(st.type="string",st.enum=Ye,st.default=He);super(J,me,He,st);this._allowedValues=Ye}validate(J){return _(J,this.defaultValue,this._allowedValues)}}class d extends P{constructor(J,me,He,Ye,st,ot,Et=void 0){typeof Et!="undefined"&&(Et.type="string",Et.enum=st,Et.default=Ye);super(J,me,He,Et);this._allowedValues=st,this._convert=ot}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function S(j){switch(j){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",description:c.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,me,He){return He===0?J.accessibilitySupport:He}}class p extends P{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:c.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{insertSpace:n(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(j){j[j.Hidden=0]="Hidden",j[j.Blink=1]="Blink",j[j.Smooth=2]="Smooth",j[j.Phase=3]="Phase",j[j.Expand=4]="Expand",j[j.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(j){switch(j){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(j){j[j.Line=1]="Line",j[j.Block=2]="Block",j[j.Underline=3]="Underline",j[j.LineThin=4]="LineThin",j[j.BlockOutline=5]="BlockOutline",j[j.UnderlineThin=6]="UnderlineThin"})(u=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function h(j){switch(j){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=h;function m(j){switch(j){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class k extends t{constructor(){super(126,[65,33])}compute(J,me,He){const Ye=["monaco-editor"];return me.get(33)&&Ye.push(me.get(33)),J.extraEditorClassName&&Ye.push(J.extraEditorClassName),me.get(65)==="default"?Ye.push("mouse-default"):me.get(65)==="copy"&&Ye.push("mouse-copy"),me.get(99)&&Ye.push("showUnused"),me.get(124)&&Ye.push("showDeprecated"),Ye.join(" ")}}class T extends f{constructor(){super(32,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(J,me,He){return He&&J.emptySelectionClipboard}}class g extends P{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:c.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:c.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{cursorMoveOnType:n(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":_(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":_(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(me.loop,this.defaultValue.loop)}}}class I extends P{constructor(){super(44,"fontLigatures",I.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?I.OFF:J==="true"?I.ON:J:Boolean(J)?I.ON:I.OFF}}e.EditorFontLigatures=I,I.OFF='"liga" off, "calt" off',I.ON='"liga" on, "calt" on';class F extends t{constructor(){super(43)}compute(J,me,He){return J.fontInfo}}class L extends b{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(22,null)})}validate(J){let me=v.float(J,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(me,6,100)}compute(J,me,He){return J.fontInfo.fontSize}}class w extends P{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:w.MINIMUM_VALUE,maximum:w.MAXIMUM_VALUE,errorMessage:c.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:w.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(l.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,w.MINIMUM_VALUE,w.MAXIMUM_VALUE))}}w.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],w.MINIMUM_VALUE=1,w.MAXIMUM_VALUE=1e3;class x extends P{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[c.localize(25,null),c.localize(26,null),c.localize(27,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(29,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(30,null),...me},"editor.gotoLocation.multipleDeclarations":{description:c.localize(31,null),...me},"editor.gotoLocation.multipleImplementations":{description:c.localize(32,null),...me},"editor.gotoLocation.multipleReferences":{description:c.localize(33,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:He,description:c.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:He,description:c.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:He,description:c.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:He,description:c.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:He,description:c.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{multiple:_(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??_(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??_(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??_(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??_(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??_(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:D.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:D.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:D.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:D.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:D.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class W extends P{constructor(){const J={enabled:!0,delay:300,sticky:!0};super(52,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:c.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:c.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:c.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),delay:l.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:n(me.sticky,this.defaultValue.sticky)}}}var B;(function(j){j[j.None=0]="None",j[j.Text=1]="Text",j[j.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class G extends t{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(J,me,He){return G.computeLayout(me,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const me=J.height/J.lineHeight,He=J.scrollBeyondLastLine?me-1:0,Ye=(J.viewLineCount+He)/(J.pixelRatio*J.height),st=Math.floor(J.viewLineCount/Ye);return{typicalViewportLineCount:me,extraLinesBeyondLastLine:He,desiredRatio:Ye,minimapLineCount:st}}static _computeMinimapLayout(J,me){const He=J.outerWidth,Ye=J.outerHeight,st=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const ot=me.stableMinimapLayoutInput,Et=ot&&J.outerHeight===ot.outerHeight&&J.lineHeight===ot.lineHeight&&J.typicalHalfwidthCharacterWidth===ot.typicalHalfwidthCharacterWidth&&J.pixelRatio===ot.pixelRatio&&J.scrollBeyondLastLine===ot.scrollBeyondLastLine&&J.minimap.enabled===ot.minimap.enabled&&J.minimap.side===ot.minimap.side&&J.minimap.size===ot.minimap.size&&J.minimap.showSlider===ot.minimap.showSlider&&J.minimap.renderCharacters===ot.minimap.renderCharacters&&J.minimap.maxColumn===ot.minimap.maxColumn&&J.minimap.scale===ot.minimap.scale&&J.verticalScrollbarWidth===ot.verticalScrollbarWidth&&J.isViewportWrapping===ot.isViewportWrapping,mt=J.lineHeight,Dt=J.typicalHalfwidthCharacterWidth,Pt=J.scrollBeyondLastLine,It=J.minimap.renderCharacters;let Xe=st>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const St=J.minimap.maxColumn,Te=J.minimap.size,ye=J.minimap.side,Ce=J.verticalScrollbarWidth,te=J.viewLineCount,le=J.remainingWidth,ge=J.isViewportWrapping,fe=It?2:3;let Pe=Math.floor(st*Ye);const xe=Pe/st;let Oe=!1,Ke=!1,tt=fe*Xe,Le=Xe/st,de=1;if(Te==="fill"||Te==="fit"){const{typicalViewportLineCount:Ue,extraLinesBeyondLastLine:dt,desiredRatio:gt,minimapLineCount:lt}=G.computeContainedMinimapLineCount({viewLineCount:te,scrollBeyondLastLine:Pt,height:Ye,lineHeight:mt,pixelRatio:st});if(te/lt>1)Oe=!0,Ke=!0,Xe=1,tt=1,Le=Xe/st;else{let ut=!1,pt=Xe+1;if(Te==="fit"){const bt=Math.ceil((te+dt)*tt);ge&&Et&&le<=me.stableFitRemainingWidth?(ut=!0,pt=me.stableFitMaxMinimapScale):ut=bt>Pe}if(Te==="fill"||ut){Oe=!0;const bt=Xe;tt=Math.min(mt*st,Math.max(1,Math.floor(1/gt))),ge&&Et&&le<=me.stableFitRemainingWidth&&(pt=me.stableFitMaxMinimapScale),Xe=Math.min(pt,Math.max(1,Math.floor(tt/fe))),Xe>bt&&(de=Math.min(2,Xe/bt)),Le=Xe/st/de,Pe=Math.ceil(Math.max(Ue,te+dt)*tt),ge?(me.stableMinimapLayoutInput=J,me.stableFitRemainingWidth=le,me.stableFitMaxMinimapScale=Xe):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const pe=Math.floor(St*Le),Y=Math.min(pe,Math.max(0,Math.floor((le-Ce-2)*Le/(Dt+Le)))+e.MINIMAP_GUTTER_WIDTH);let z=Math.floor(st*Y);const we=z/st;z=Math.floor(z*de);const Ie=It?1:2,Je=ye==="left"?0:He-Y-Ce;return{renderMinimap:Ie,minimapLeft:Je,minimapWidth:Y,minimapHeightIsEditorHeight:Oe,minimapIsSampling:Ke,minimapScale:Xe,minimapLineHeight:tt,minimapCanvasInnerWidth:z,minimapCanvasInnerHeight:Pe,minimapCanvasOuterWidth:we,minimapCanvasOuterHeight:xe}}static computeLayout(J,me){const He=me.outerWidth|0,Ye=me.outerHeight|0,st=me.lineHeight|0,ot=me.lineNumbersDigitCount|0,Et=me.typicalHalfwidthCharacterWidth,mt=me.maxDigitWidth,Dt=me.pixelRatio,Pt=me.viewLineCount,It=J.get(121),Xe=It==="inherit"?J.get(120):It,St=Xe==="inherit"?J.get(116):Xe,Te=J.get(119),ye=J.get(2),Ce=me.isDominatedByLongLines,te=J.get(49),le=J.get(59).renderType!==0,ge=J.get(60),fe=J.get(93),Pe=J.get(64),xe=J.get(91),Oe=xe.verticalScrollbarSize,Ke=xe.verticalHasArrows,tt=xe.arrowSize,Le=xe.horizontalScrollbarSize,de=J.get(57),pe=J.get(37);let Y;if(typeof de=="string"&&/^\d+(\.\d+)?ch$/.test(de)){const yt=parseFloat(de.substr(0,de.length-2));Y=l.clampedInt(yt*Et,0,0,1e3)}else Y=l.clampedInt(de,0,0,1e3);pe&&(Y+=16);let z=0;if(le){const yt=Math.max(ot,ge);z=Math.round(yt*mt)}let we=0;te&&(we=st);let Ie=0,Je=Ie+we,Ue=Je+z,dt=Ue+Y;const gt=He-we-z-Y;let lt=!1,ft=!1,ut=-1;ye!==2&&(Xe==="inherit"&&Ce?(lt=!0,ft=!0):St==="on"||St==="bounded"?ft=!0:St==="wordWrapColumn"&&(ut=Te));const pt=G._computeMinimapLayout({outerWidth:He,outerHeight:Ye,lineHeight:st,typicalHalfwidthCharacterWidth:Et,pixelRatio:Dt,scrollBeyondLastLine:fe,minimap:Pe,verticalScrollbarWidth:Oe,viewLineCount:Pt,remainingWidth:gt,isViewportWrapping:ft},me.memory||new y);pt.renderMinimap!==0&&pt.minimapLeft===0&&(Ie+=pt.minimapWidth,Je+=pt.minimapWidth,Ue+=pt.minimapWidth,dt+=pt.minimapWidth);const bt=gt-pt.minimapWidth,Ut=Math.max(1,Math.floor((bt-Oe-2)/Et)),Vt=Ke?tt:0;return ft&&(ut=Math.max(1,Ut),St==="bounded"&&(ut=Math.min(ut,Te))),{width:He,height:Ye,glyphMarginLeft:Ie,glyphMarginWidth:we,lineNumbersLeft:Je,lineNumbersWidth:z,decorationsLeft:Ue,decorationsWidth:Y,contentLeft:dt,contentWidth:bt,minimap:pt,viewportColumn:Ut,isWordWrapMinified:lt,isViewportWrapping:ft,wrappingColumn:ut,verticalScrollbarWidth:Oe,horizontalScrollbarHeight:Le,overviewRuler:{top:Vt,width:Oe,height:Ye-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=G;class H extends P{constructor(){const J={enabled:!0};super(56,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:c.localize(42,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class U extends P{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:c.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:c.localize(45,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:D.string(me.fontFamily,this.defaultValue.fontFamily)}}}class V extends v{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>v.clamp(J,0,150),{markdownDescription:c.localize(46,null)})}compute(J,me,He){return J.fontInfo.lineHeight}}class Q extends P{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:c.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(48,null),c.localize(49,null),c.localize(50,null)],default:J.size,description:c.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:c.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:c.localize(53,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:c.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:c.localize(56,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),size:_(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:_(me.side,this.defaultValue.side,["right","left"]),showSlider:_(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(me.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(me.scale,1,1,3),maxColumn:l.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ne(j){return j==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ce extends P{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(58,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{top:l.clampedInt(me.top,0,0,1e3),bottom:l.clampedInt(me.bottom,0,0,1e3)}}}class Z extends P{constructor(){const J={enabled:!0,cycle:!1};super(75,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:c.localize(60,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),cycle:n(me.cycle,this.defaultValue.cycle)}}}class oe extends t{constructor(){super(127)}compute(J,me,He){return J.pixelRatio}}class ve extends P{constructor(){const J={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:c.localize(61,null)},comments:{type:"boolean",default:J.comments,description:c.localize(62,null)},other:{type:"boolean",default:J.other,description:c.localize(63,null)}}}],default:J,description:c.localize(64,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const me=J,He={other:n(me.other,this.defaultValue.other),comments:n(me.comments,this.defaultValue.comments),strings:n(me.strings,this.defaultValue.strings)};return He.other&&He.comments&&He.strings?!0:!He.other&&!He.comments&&!He.strings?!1:He}return this.defaultValue}}var Ae;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval",j[j.Custom=4]="Custom"})(Ae=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Se extends P{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(65,null),c.localize(66,null),c.localize(67,null),c.localize(68,null)],default:"on",description:c.localize(69,null)})}validate(J){let me=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(me=4,He=J):J==="interval"?me=3:J==="relative"?me=2:J==="on"?me=1:me=0),{renderType:me,renderFn:He}}}function Ne(j){const J=j.get(86);return J==="editable"?j.get(80):J!=="on"}e.filterValidationDecorations=Ne;class We extends P{constructor(){const J=[],me={type:"number",description:c.localize(70,null)};super(90,"rulers",J,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:c.localize(71,null),format:"color-hex"}}}]},default:J,description:c.localize(72,null)})}validate(J){if(Array.isArray(J)){let me=[];for(let He of J)if(typeof He=="number")me.push({column:l.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const Ye=He;me.push({column:l.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return me.sort((He,Ye)=>He.column-Ye.column),me}return this.defaultValue}}function je(j,J){if(typeof j!="string")return J;switch(j){case"hidden":return 2;case"visible":return 3;default:return 1}}class qe extends P{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(73,null),c.localize(74,null),c.localize(75,null)],default:"auto",description:c.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(77,null),c.localize(78,null),c.localize(79,null)],default:"auto",description:c.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:c.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:c.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:c.localize(83,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J,He=l.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=l.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:je(me.vertical,this.defaultValue.vertical),horizontal:je(me.horizontal,this.defaultValue.horizontal),useShadows:n(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:l.clampedInt(me.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:l.clampedInt(me.verticalSliderSize,Ye,0,1e3),scrollByPage:n(me.scrollByPage,this.defaultValue.scrollByPage)}}}class $ extends P{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:c.localize(84,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{enabled:n(me.enabled,this.defaultValue.enabled),mode:_(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class K extends P{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:c.localize(85,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class ee extends P{constructor(){const J={bracketPairs:!1,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",J,{"editor.guides.bracketPairs":{type:"boolean",default:J.bracketPairs,description:c.localize(86,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:c.localize(87,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:J.highlightActiveIndentation,description:c.localize(88,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{bracketPairs:n(me.bracketPairs,this.defaultValue.bracketPairs),indentation:n(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:n(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}class ae extends P{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(89,null),c.localize(90,null)],default:J.insertMode,description:c.localize(91,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:c.localize(92,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:c.localize(93,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:c.localize(94,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:c.localize(95,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:c.localize(96,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:c.localize(97,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:c.localize(98,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:c.localize(99,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(100,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(101,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(102,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(103,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(104,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(105,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(106,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(107,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(108,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(109,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(110,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(111,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(112,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(113,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(114,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(115,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(116,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(117,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(118,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(119,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(120,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(121,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(122,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(123,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(124,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(125,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(126,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(127,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(128,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(129,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(130,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const me=J;return{insertMode:_(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(me.showIcons,this.defaultValue.showIcons),showStatusBar:n(me.showStatusBar,this.defaultValue.showStatusBar),preview:n(me.preview,this.defaultValue.preview),previewMode:_(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(me.showMethods,this.defaultValue.showMethods),showFunctions:n(me.showFunctions,this.defaultValue.showFunctions),showConstructors:n(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(me.showDeprecated,this.defaultValue.showDeprecated),showFields:n(me.showFields,this.defaultValue.showFields),showVariables:n(me.showVariables,this.defaultValue.showVariables),showClasses:n(me.showClasses,this.defaultValue.showClasses),showStructs:n(me.showStructs,this.defaultValue.showStructs),showInterfaces:n(me.showInterfaces,this.defaultValue.showInterfaces),showModules:n(me.showModules,this.defaultValue.showModules),showProperties:n(me.showProperties,this.defaultValue.showProperties),showEvents:n(me.showEvents,this.defaultValue.showEvents),showOperators:n(me.showOperators,this.defaultValue.showOperators),showUnits:n(me.showUnits,this.defaultValue.showUnits),showValues:n(me.showValues,this.defaultValue.showValues),showConstants:n(me.showConstants,this.defaultValue.showConstants),showEnums:n(me.showEnums,this.defaultValue.showEnums),showEnumMembers:n(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(me.showKeywords,this.defaultValue.showKeywords),showWords:n(me.showWords,this.defaultValue.showWords),showColors:n(me.showColors,this.defaultValue.showColors),showFiles:n(me.showFiles,this.defaultValue.showFiles),showReferences:n(me.showReferences,this.defaultValue.showReferences),showFolders:n(me.showFolders,this.defaultValue.showFolders),showTypeParameters:n(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(me.showSnippets,this.defaultValue.showSnippets),showUsers:n(me.showUsers,this.defaultValue.showUsers),showIssues:n(me.showIssues,this.defaultValue.showIssues)}}}class q extends P{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(131,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class se extends t{constructor(){super(128,[80])}compute(J,me,He){return me.get(80)?!0:J.tabFocusMode}}var he;(function(j){j[j.None=0]="None",j[j.Same=1]="Same",j[j.Indent=2]="Indent",j[j.DeepIndent=3]="DeepIndent"})(he=e.WrappingIndent||(e.WrappingIndent={}));function Re(j){switch(j){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Be extends t{constructor(){super(130,[129])}compute(J,me,He){const Ye=me.get(129);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}const ze="Consolas, 'Courier New', monospace",Qe="Menlo, Monaco, 'Courier New', monospace",it="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?Qe:M.isLinux?it:ze,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ke(j){return e.editorOptionsRegistry[j.id]=j,j}var Ze;(function(j){j[j.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",j[j.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",j[j.accessibilitySupport=2]="accessibilitySupport",j[j.accessibilityPageSize=3]="accessibilityPageSize",j[j.ariaLabel=4]="ariaLabel",j[j.autoClosingBrackets=5]="autoClosingBrackets",j[j.autoClosingDelete=6]="autoClosingDelete",j[j.autoClosingOvertype=7]="autoClosingOvertype",j[j.autoClosingQuotes=8]="autoClosingQuotes",j[j.autoIndent=9]="autoIndent",j[j.automaticLayout=10]="automaticLayout",j[j.autoSurround=11]="autoSurround",j[j.bracketPairColorization=12]="bracketPairColorization",j[j.guides=13]="guides",j[j.codeLens=14]="codeLens",j[j.codeLensFontFamily=15]="codeLensFontFamily",j[j.codeLensFontSize=16]="codeLensFontSize",j[j.colorDecorators=17]="colorDecorators",j[j.columnSelection=18]="columnSelection",j[j.comments=19]="comments",j[j.contextmenu=20]="contextmenu",j[j.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",j[j.cursorBlinking=22]="cursorBlinking",j[j.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",j[j.cursorStyle=24]="cursorStyle",j[j.cursorSurroundingLines=25]="cursorSurroundingLines",j[j.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",j[j.cursorWidth=27]="cursorWidth",j[j.disableLayerHinting=28]="disableLayerHinting",j[j.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",j[j.domReadOnly=30]="domReadOnly",j[j.dragAndDrop=31]="dragAndDrop",j[j.emptySelectionClipboard=32]="emptySelectionClipboard",j[j.extraEditorClassName=33]="extraEditorClassName",j[j.fastScrollSensitivity=34]="fastScrollSensitivity",j[j.find=35]="find",j[j.fixedOverflowWidgets=36]="fixedOverflowWidgets",j[j.folding=37]="folding",j[j.foldingStrategy=38]="foldingStrategy",j[j.foldingHighlight=39]="foldingHighlight",j[j.foldingImportsByDefault=40]="foldingImportsByDefault",j[j.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",j[j.fontFamily=42]="fontFamily",j[j.fontInfo=43]="fontInfo",j[j.fontLigatures=44]="fontLigatures",j[j.fontSize=45]="fontSize",j[j.fontWeight=46]="fontWeight",j[j.formatOnPaste=47]="formatOnPaste",j[j.formatOnType=48]="formatOnType",j[j.glyphMargin=49]="glyphMargin",j[j.gotoLocation=50]="gotoLocation",j[j.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",j[j.hover=52]="hover",j[j.inDiffEditor=53]="inDiffEditor",j[j.inlineSuggest=54]="inlineSuggest",j[j.letterSpacing=55]="letterSpacing",j[j.lightbulb=56]="lightbulb",j[j.lineDecorationsWidth=57]="lineDecorationsWidth",j[j.lineHeight=58]="lineHeight",j[j.lineNumbers=59]="lineNumbers",j[j.lineNumbersMinChars=60]="lineNumbersMinChars",j[j.linkedEditing=61]="linkedEditing",j[j.links=62]="links",j[j.matchBrackets=63]="matchBrackets",j[j.minimap=64]="minimap",j[j.mouseStyle=65]="mouseStyle",j[j.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",j[j.mouseWheelZoom=67]="mouseWheelZoom",j[j.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",j[j.multiCursorModifier=69]="multiCursorModifier",j[j.multiCursorPaste=70]="multiCursorPaste",j[j.occurrencesHighlight=71]="occurrencesHighlight",j[j.overviewRulerBorder=72]="overviewRulerBorder",j[j.overviewRulerLanes=73]="overviewRulerLanes",j[j.padding=74]="padding",j[j.parameterHints=75]="parameterHints",j[j.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",j[j.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",j[j.quickSuggestions=78]="quickSuggestions",j[j.quickSuggestionsDelay=79]="quickSuggestionsDelay",j[j.readOnly=80]="readOnly",j[j.renameOnType=81]="renameOnType",j[j.renderControlCharacters=82]="renderControlCharacters",j[j.renderFinalNewline=83]="renderFinalNewline",j[j.renderLineHighlight=84]="renderLineHighlight",j[j.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",j[j.renderValidationDecorations=86]="renderValidationDecorations",j[j.renderWhitespace=87]="renderWhitespace",j[j.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",j[j.roundedSelection=89]="roundedSelection",j[j.rulers=90]="rulers",j[j.scrollbar=91]="scrollbar",j[j.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",j[j.scrollBeyondLastLine=93]="scrollBeyondLastLine",j[j.scrollPredominantAxis=94]="scrollPredominantAxis",j[j.selectionClipboard=95]="selectionClipboard",j[j.selectionHighlight=96]="selectionHighlight",j[j.selectOnLineNumbers=97]="selectOnLineNumbers",j[j.showFoldingControls=98]="showFoldingControls",j[j.showUnused=99]="showUnused",j[j.snippetSuggestions=100]="snippetSuggestions",j[j.smartSelect=101]="smartSelect",j[j.smoothScrolling=102]="smoothScrolling",j[j.stickyTabStops=103]="stickyTabStops",j[j.stopRenderingLineAfter=104]="stopRenderingLineAfter",j[j.suggest=105]="suggest",j[j.suggestFontSize=106]="suggestFontSize",j[j.suggestLineHeight=107]="suggestLineHeight",j[j.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",j[j.suggestSelection=109]="suggestSelection",j[j.tabCompletion=110]="tabCompletion",j[j.tabIndex=111]="tabIndex",j[j.unusualLineTerminators=112]="unusualLineTerminators",j[j.useShadowDOM=113]="useShadowDOM",j[j.useTabStops=114]="useTabStops",j[j.wordSeparators=115]="wordSeparators",j[j.wordWrap=116]="wordWrap",j[j.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",j[j.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",j[j.wordWrapColumn=119]="wordWrapColumn",j[j.wordWrapOverride1=120]="wordWrapOverride1",j[j.wordWrapOverride2=121]="wordWrapOverride2",j[j.wrappingIndent=122]="wrappingIndent",j[j.wrappingStrategy=123]="wrappingStrategy",j[j.showDeprecated=124]="showDeprecated",j[j.inlayHints=125]="inlayHints",j[j.editorClassName=126]="editorClassName",j[j.pixelRatio=127]="pixelRatio",j[j.tabFocusMode=128]="tabFocusMode",j[j.layoutInfo=129]="layoutInfo",j[j.wrappingInfo=130]="wrappingInfo"})(Ze=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(132,null)})),acceptSuggestionOnEnter:ke(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(133,null),""],markdownDescription:c.localize(134,null)})),accessibilitySupport:ke(new i),accessibilityPageSize:ke(new l(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(135,null)})),ariaLabel:ke(new D(4,"ariaLabel",c.localize(136,null))),autoClosingBrackets:ke(new a(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(137,null),c.localize(138,null),""],description:c.localize(139,null)})),autoClosingDelete:ke(new a(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(140,null),""],description:c.localize(141,null)})),autoClosingOvertype:ke(new a(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(142,null),""],description:c.localize(143,null)})),autoClosingQuotes:ke(new a(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(144,null),c.localize(145,null),""],description:c.localize(146,null)})),autoIndent:ke(new d(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],S,{enumDescriptions:[c.localize(147,null),c.localize(148,null),c.localize(149,null),c.localize(150,null),c.localize(151,null)],description:c.localize(152,null)})),automaticLayout:ke(new f(10,"automaticLayout",!1)),autoSurround:ke(new a(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(153,null),c.localize(154,null),c.localize(155,null),""],description:c.localize(156,null)})),bracketPairColorization:ke(new K),bracketPairGuides:ke(new ee),stickyTabStops:ke(new f(103,"stickyTabStops",!1,{description:c.localize(157,null)})),codeLens:ke(new f(14,"codeLens",!0,{description:c.localize(158,null)})),codeLensFontFamily:ke(new D(15,"codeLensFontFamily","",{description:c.localize(159,null)})),codeLensFontSize:ke(new l(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(160,null)})),colorDecorators:ke(new f(17,"colorDecorators",!0,{description:c.localize(161,null)})),columnSelection:ke(new f(18,"columnSelection",!1,{description:c.localize(162,null)})),comments:ke(new p),contextmenu:ke(new f(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new f(21,"copyWithSyntaxHighlighting",!0,{description:c.localize(163,null)})),cursorBlinking:ke(new d(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:c.localize(164,null)})),cursorSmoothCaretAnimation:ke(new f(23,"cursorSmoothCaretAnimation",!1,{description:c.localize(165,null)})),cursorStyle:ke(new d(24,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],m,{description:c.localize(166,null)})),cursorSurroundingLines:ke(new l(25,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(167,null)})),cursorSurroundingLinesStyle:ke(new a(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(168,null),c.localize(169,null)],description:c.localize(170,null)})),cursorWidth:ke(new l(27,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(171,null)})),disableLayerHinting:ke(new f(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new f(29,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new f(30,"domReadOnly",!1)),dragAndDrop:ke(new f(31,"dragAndDrop",!0,{description:c.localize(172,null)})),emptySelectionClipboard:ke(new T),extraEditorClassName:ke(new D(33,"extraEditorClassName","")),fastScrollSensitivity:ke(new v(34,"fastScrollSensitivity",5,j=>j<=0?5:j,{markdownDescription:c.localize(173,null)})),find:ke(new g),fixedOverflowWidgets:ke(new f(36,"fixedOverflowWidgets",!1)),folding:ke(new f(37,"folding",!0,{description:c.localize(174,null)})),foldingStrategy:ke(new a(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(175,null),c.localize(176,null)],description:c.localize(177,null)})),foldingHighlight:ke(new f(39,"foldingHighlight",!0,{description:c.localize(178,null)})),foldingImportsByDefault:ke(new f(40,"foldingImportsByDefault",!1,{description:c.localize(179,null)})),unfoldOnClickAfterEndOfLine:ke(new f(41,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(180,null)})),fontFamily:ke(new D(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(181,null)})),fontInfo:ke(new F),fontLigatures2:ke(new I),fontSize:ke(new L),fontWeight:ke(new w),formatOnPaste:ke(new f(47,"formatOnPaste",!1,{description:c.localize(182,null)})),formatOnType:ke(new f(48,"formatOnType",!1,{description:c.localize(183,null)})),glyphMargin:ke(new f(49,"glyphMargin",!0,{description:c.localize(184,null)})),gotoLocation:ke(new x),hideCursorInOverviewRuler:ke(new f(51,"hideCursorInOverviewRuler",!1,{description:c.localize(185,null)})),hover:ke(new W),inDiffEditor:ke(new f(53,"inDiffEditor",!1)),letterSpacing:ke(new v(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,j=>v.clamp(j,-5,20),{description:c.localize(186,null)})),lightbulb:ke(new H),lineDecorationsWidth:ke(new b(57,"lineDecorationsWidth",10)),lineHeight:ke(new V),lineNumbers:ke(new Se),lineNumbersMinChars:ke(new l(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new f(61,"linkedEditing",!1,{description:c.localize(187,null)})),links:ke(new f(62,"links",!0,{description:c.localize(188,null)})),matchBrackets:ke(new a(63,"matchBrackets","always",["always","near","never"],{description:c.localize(189,null)})),minimap:ke(new Q),mouseStyle:ke(new a(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new v(66,"mouseWheelScrollSensitivity",1,j=>j===0?1:j,{markdownDescription:c.localize(190,null)})),mouseWheelZoom:ke(new f(67,"mouseWheelZoom",!1,{markdownDescription:c.localize(191,null)})),multiCursorMergeOverlapping:ke(new f(68,"multiCursorMergeOverlapping",!0,{description:c.localize(192,null)})),multiCursorModifier:ke(new d(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ne,{markdownEnumDescriptions:[c.localize(193,null),c.localize(194,null)],markdownDescription:c.localize(195,null)})),multiCursorPaste:ke(new a(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(196,null),c.localize(197,null)],markdownDescription:c.localize(198,null)})),occurrencesHighlight:ke(new f(71,"occurrencesHighlight",!0,{description:c.localize(199,null)})),overviewRulerBorder:ke(new f(72,"overviewRulerBorder",!0,{description:c.localize(200,null)})),overviewRulerLanes:ke(new l(73,"overviewRulerLanes",3,0,3)),padding:ke(new ce),parameterHints:ke(new Z),peekWidgetDefaultFocus:ke(new a(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(201,null),c.localize(202,null)],description:c.localize(203,null)})),definitionLinkOpensInPeek:ke(new f(77,"definitionLinkOpensInPeek",!1,{description:c.localize(204,null)})),quickSuggestions:ke(new ve),quickSuggestionsDelay:ke(new l(79,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(205,null)})),readOnly:ke(new f(80,"readOnly",!1)),renameOnType:ke(new f(81,"renameOnType",!1,{description:c.localize(206,null),markdownDeprecationMessage:c.localize(207,null)})),renderControlCharacters:ke(new f(82,"renderControlCharacters",!1,{description:c.localize(208,null)})),renderFinalNewline:ke(new f(83,"renderFinalNewline",!0,{description:c.localize(209,null)})),renderLineHighlight:ke(new a(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(210,null)],description:c.localize(211,null)})),renderLineHighlightOnlyWhenFocus:ke(new f(85,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(212,null)})),renderValidationDecorations:ke(new a(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new a(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(213,null),c.localize(214,null),c.localize(215,null),""],description:c.localize(216,null)})),revealHorizontalRightPadding:ke(new l(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ke(new f(89,"roundedSelection",!0,{description:c.localize(217,null)})),rulers:ke(new We),scrollbar:ke(new qe),scrollBeyondLastColumn:ke(new l(92,"scrollBeyondLastColumn",5,0,1073741824,{description:c.localize(218,null)})),scrollBeyondLastLine:ke(new f(93,"scrollBeyondLastLine",!0,{description:c.localize(219,null)})),scrollPredominantAxis:ke(new f(94,"scrollPredominantAxis",!0,{description:c.localize(220,null)})),selectionClipboard:ke(new f(95,"selectionClipboard",!0,{description:c.localize(221,null),included:M.isLinux})),selectionHighlight:ke(new f(96,"selectionHighlight",!0,{description:c.localize(222,null)})),selectOnLineNumbers:ke(new f(97,"selectOnLineNumbers",!0)),showFoldingControls:ke(new a(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[c.localize(223,null),c.localize(224,null)],description:c.localize(225,null)})),showUnused:ke(new f(99,"showUnused",!0,{description:c.localize(226,null)})),showDeprecated:ke(new f(124,"showDeprecated",!0,{description:c.localize(227,null)})),inlayHints:ke(new U),snippetSuggestions:ke(new a(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(228,null),c.localize(229,null),c.localize(230,null),c.localize(231,null)],description:c.localize(232,null)})),smartSelect:ke(new q),smoothScrolling:ke(new f(102,"smoothScrolling",!1,{description:c.localize(233,null)})),stopRenderingLineAfter:ke(new l(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new ae),inlineSuggest:ke(new $),suggestFontSize:ke(new l(106,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(234,null)})),suggestLineHeight:ke(new l(107,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(235,null)})),suggestOnTriggerCharacters:ke(new f(108,"suggestOnTriggerCharacters",!0,{description:c.localize(236,null)})),suggestSelection:ke(new a(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(237,null),c.localize(238,null),c.localize(239,null)],description:c.localize(240,null)})),tabCompletion:ke(new a(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(241,null),c.localize(242,null),c.localize(243,null)],description:c.localize(244,null)})),tabIndex:ke(new l(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ke(new a(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(245,null),c.localize(246,null),c.localize(247,null)],description:c.localize(248,null)})),useShadowDOM:ke(new f(113,"useShadowDOM",!0)),useTabStops:ke(new f(114,"useTabStops",!0,{description:c.localize(249,null)})),wordSeparators:ke(new D(115,"wordSeparators",E.USUAL_WORD_SEPARATORS,{description:c.localize(250,null)})),wordWrap:ke(new a(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(251,null),c.localize(252,null),c.localize(253,null),c.localize(254,null)],description:c.localize(255,null)})),wordWrapBreakAfterCharacters:ke(new D(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new D(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new l(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(256,null)})),wordWrapOverride1:ke(new a(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new a(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new d(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Re,{enumDescriptions:[c.localize(257,null),c.localize(258,null),c.localize(259,null),c.localize(260,null)],description:c.localize(261,null)})),wrappingStrategy:ke(new a(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[c.localize(262,null),c.localize(263,null)],description:c.localize(264,null)})),editorClassName:ke(new k),pixelRatio:ke(new oe),tabFocusMode:ke(new se),layoutInfo:ke(new G),wrappingInfo:ke(new Be)}}),define(be[119],Ee([18,19]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[120],Ee([18,19]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[121],Ee([18,19]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(be[122],Ee([18,19]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(be[123],Ee([18,19]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(be[124],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[125],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[126],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(be[127],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[128],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[129],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[130],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[131],Ee([18,19]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(be[132],Ee([18,19]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(be[133],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[134],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[135],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[136],Ee([18,19]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[137],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var c;(function(R){R[R.ACTIVATE=1]="ACTIVATE",R[R.RESTORE=2]="RESTORE",R[R.PRESERVE=3]="PRESERVE"})(c=e.EditorActivation||(e.EditorActivation={}));var M;(function(R){R[R.PICK=0]="PICK",R[R.DISABLED=1]="DISABLED",R[R.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var E;(function(R){R[R.API=0]="API",R[R.USER=1]="USER"})(E=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(R){R[R.Center=0]="Center",R[R.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",R[R.NearTop=2]="NearTop",R[R.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[138],Ee([0,1,120]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function A(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=A;function R(n){if(!A(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=n.match(M);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=R;function C(n){if(!n)return null;let f=n.majorBase,o=n.majorMustEqual,l=n.minorBase,v=n.minorMustEqual,D=n.patchBase,_=n.patchMustEqual;n.hasCaret&&(f===0||(v=!1),_=!1);let a=0;if(n.preRelease){const d=E.exec(n.preRelease);if(d){const[,S,i,p]=d;a=Date.UTC(Number(S),Number(i)-1,Number(p))}}return{majorBase:f,majorMustEqual:o,minorBase:l,minorMustEqual:v,patchBase:D,patchMustEqual:_,isMinimum:n.hasGreaterEquals,notBefore:a}}e.normalizeVersion=C;function y(n,f,o){let l;typeof n=="string"?l=C(R(n)):l=n;let v;f instanceof Date?v=f.getTime():typeof f=="string"&&(v=new Date(f).getTime());let D;if(typeof o=="string"?D=C(R(o)):D=o,!l||!D)return!1;let _=l.majorBase,a=l.minorBase,d=l.patchBase,S=D.majorBase,i=D.minorBase,p=D.patchBase,r=D.notBefore,s=D.majorMustEqual,u=D.minorMustEqual,h=D.patchMustEqual;return D.isMinimum?_>S?!0:_<S?!1:a>i?!0:a<i||v&&v<r?!1:d>=p:(_===1&&S===0&&(!s||!u||!h)&&(S=1,i=0,p=0,s=!0,u=!1,h=!1),_<S?!1:_>S?!s:a<i?!1:a>i?!u:d<p?!1:d>p?!h:!(v&&v<r))}e.isValidVersion=y;function P(n,f,o,l){return o.isBuiltin||typeof o.main=="undefined"?!0:b(n,f,o.engines.vscode,l)}e.isValidExtensionVersion=P;function t(n,f,o){return n==="*"||b(f,o,n)}e.isEngineValid=t;function b(n,f,o,l=[]){let v=C(R(o));if(!v)return l.push(c.localize(0,null,o)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return l.push(c.localize(1,null,o)),!1}else if(!v.majorMustEqual)return l.push(c.localize(2,null,o)),!1;return y(n,f,v)?!0:(l.push(c.localize(3,null,n,o)),!1)}}),define(be[81],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(E,A=[],R=!1){this.ctor=E,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=c}),define(be[57],Ee([0,1,81]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function E(R,C,y){C instanceof c.SyncDescriptor||(C=new c.SyncDescriptor(C,[],y)),M.push([R,C])}e.registerSingleton=E;function A(){return M}e.getSingletonServiceDescriptors=A}),define(be[139],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=c;class M{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let R of this._nodes.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const C=this.lookupOrInsertNode(A),y=this.lookupOrInsertNode(R);C.outgoing.set(this._hashFn(R),y),y.incoming.set(this._hashFn(A),C)}removeNode(A){const R=this._hashFn(A);this._nodes.delete(R);for(let C of this._nodes.values())C.outgoing.delete(R),C.incoming.delete(R)}lookupOrInsertNode(A){const R=this._hashFn(A);let C=this._nodes.get(R);return C||(C=new c(A),this._nodes.set(R,C)),C}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[R,C]of this._nodes)A.push(`${R}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,R]of this._nodes){const C=new Set([A]),y=this._findCycle(R,C);if(y)return y}}_findCycle(A,R){for(let[C,y]of A.outgoing){if(R.has(C))return[...R,C].join(" -> ");R.add(C);const P=this._findCycle(y,R);if(P)return P;R.delete(C)}}}e.Graph=M}),define(be[4],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function y(P){return P[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=y})(c=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function M(C,y,P,t){y[c.DI_TARGET]===y?y[c.DI_DEPENDENCIES].push({id:C,index:P,optional:t}):(y[c.DI_DEPENDENCIES]=[{id:C,index:P,optional:t}],y[c.DI_TARGET]=y)}function E(C){if(c.serviceIds.has(C))return c.serviceIds.get(C);const y=function(P,t,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(y,P,b,!1)};return y.toString=()=>C,c.serviceIds.set(C,y),y}e.createDecorator=E;function A(C){return C}e.refineServiceDecorator=A;function R(C){return function(y,P,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(C,y,t,!0)}}e.optional=R}),define(be[140],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,c.createDecorator)("modelService");function M(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(be[141],Ee([0,1,3,58,6,20,75,55,140]),function(re,e,c,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(P):!!l.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new c.Emitter}get onDidChange(){return this._onDidChange.event}register(v,D){let _={selector:v,provider:D,_score:-1,_time:this._clock++};return this._entries.push(_),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,E.toDisposable)(()=>{if(_){let a=this._entries.indexOf(_);a>=0&&(this._entries.splice(a,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),_=void 0)}})}has(v){return this.all(v).length>0}all(v){if(!v)return[];this._updateScores(v);const D=[];for(let _ of this._entries)_._score>0&&D.push(_.provider);return D}ordered(v){const D=[];return this._orderedForEach(v,_=>D.push(_.provider)),D}orderedGroups(v){const D=[];let _,a;return this._orderedForEach(v,d=>{_&&a===d._score?_.push(d.provider):(a=d._score,_=[d.provider],D.push(_))}),D}_orderedForEach(v,D){if(!!v){this._updateScores(v);for(const _ of this._entries)_._score>0&&D(_)}}_updateScores(v){let D={uri:v.uri.toString(),language:v.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===D.language&&this._lastCandidate.uri===D.uri)){this._lastCandidate=D;for(let _ of this._entries)if(_._score=(0,C.score)(_.selector,v.uri,v.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(v)),P(_.selector)&&_._score>0){for(let a of this._entries)a._score=0;_._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(v,D){return v._score<D._score?1:v._score>D._score?-1:v._time<D._time?1:v._time>D._time?-1:0}}e.LanguageFeatureRegistry=t;const b=new WeakMap;let n=0;function f(l){let v=b.get(l);return v===void 0&&(v=++n,b.set(l,v)),v}class o{constructor(v,D,_=Number.MAX_SAFE_INTEGER){this._registry=v,this.min=D,this.max=_,this._cache=new A.LRUCache(50,.7)}_key(v){return v.id+this._registry.all(v).reduce((D,_)=>(0,M.doHash)(f(_),D),0)}_clamp(v){return v===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(v*1.3)))}get(v){const D=this._key(v),_=this._cache.get(D);return this._clamp(_?.value)}update(v,D){const _=this._key(v);let a=this._cache.get(_);return a||(a=new R.MovingAverage,this._cache.set(_,a)),a.update(D),this.get(v)}}e.LanguageFeatureRequestDelays=o}),define(be[59],Ee([0,1,2,44,141,114,34]),function(re,e,c,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(g){g[g.Null=0]="Null",g[g.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class y{constructor(I,F){this.language=I,this.id=F}}e.LanguageIdentifier=y;var P;(function(g){g[g.NotSet=-1]="NotSet",g[g.None=0]="None",g[g.Italic=1]="Italic",g[g.Bold=2]="Bold",g[g.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var t;(function(g){g[g.None=0]="None",g[g.DefaultForeground=1]="DefaultForeground",g[g.DefaultBackground=2]="DefaultBackground"})(t=e.ColorId||(e.ColorId={}));var b;(function(g){g[g.Other=0]="Other",g[g.Comment=1]="Comment",g[g.String=2]="String",g[g.RegEx=4]="RegEx"})(b=e.StandardTokenType||(e.StandardTokenType={}));var n;(function(g){g[g.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",g[g.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",g[g.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",g[g.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",g[g.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",g[g.ITALIC_MASK=2048]="ITALIC_MASK",g[g.BOLD_MASK=4096]="BOLD_MASK",g[g.UNDERLINE_MASK=8192]="UNDERLINE_MASK",g[g.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",g[g.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",g[g.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",g[g.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",g[g.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",g[g.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",g[g.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",g[g.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",g[g.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",g[g.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(n=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(I){return(I&255)>>>0}static getTokenType(I){return(I&1792)>>>8}static getFontStyle(I){return(I&14336)>>>11}static getForeground(I){return(I&8372224)>>>14}static getBackground(I){return(I&4286578688)>>>23}static getClassNameFromMetadata(I){let F=this.getForeground(I),L="mtk"+F,w=this.getFontStyle(I);return w&1&&(L+=" mtki"),w&2&&(L+=" mtkb"),w&4&&(L+=" mtku"),L}static getInlineStyleFromMetadata(I,F){const L=this.getForeground(I),w=this.getFontStyle(I);let x=`color: ${F[L]};`;return w&1&&(x+="font-style: italic;"),w&2&&(x+="font-weight: bold;"),w&4&&(x+="text-decoration: underline;"),x}}e.TokenMetadata=f;var o;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(o=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let g=Object.create(null);return g[0]="symbol-method",g[1]="symbol-function",g[2]="symbol-constructor",g[3]="symbol-field",g[4]="symbol-variable",g[5]="symbol-class",g[6]="symbol-struct",g[7]="symbol-interface",g[8]="symbol-module",g[9]="symbol-property",g[10]="symbol-event",g[11]="symbol-operator",g[12]="symbol-unit",g[13]="symbol-value",g[14]="symbol-constant",g[15]="symbol-enum",g[16]="symbol-enum-member",g[17]="symbol-keyword",g[27]="symbol-snippet",g[18]="symbol-text",g[19]="symbol-color",g[20]="symbol-file",g[21]="symbol-reference",g[22]="symbol-customcolor",g[23]="symbol-folder",g[24]="symbol-type-parameter",g[25]="account",g[26]="issues",function(I){const F=g[I];let L=F&&R.iconRegistry.get(F);return L||(console.info("No codicon found for CompletionItemKind "+I),L=R.Codicon.symbolProperty),L.classNames}}(),e.completionKindFromString=function(){let g=Object.create(null);return g.method=0,g.function=1,g.constructor=2,g.field=3,g.variable=4,g.class=5,g.struct=6,g.interface=7,g.module=8,g.property=9,g.event=10,g.operator=11,g.unit=12,g.value=13,g.constant=14,g.enum=15,g["enum-member"]=16,g.enumMember=16,g.keyword=17,g.snippet=27,g.text=18,g.color=19,g.file=20,g.reference=21,g.customcolor=22,g.folder=23,g["type-parameter"]=24,g.typeParameter=24,g.account=25,g.issue=26,function(I,F){let L=g[I];return typeof L=="undefined"&&!F&&(L=9),L}}();var l;(function(g){g[g.Deprecated=1]="Deprecated"})(l=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(g){g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var D;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(D=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(g){g[g.Automatic=0]="Automatic",g[g.Explicit=1]="Explicit"})(_=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var a;(function(g){g[g.Invoke=1]="Invoke",g[g.Auto=2]="Auto"})(a=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var S;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(S=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(g){return g&&c.URI.isUri(g.uri)&&M.Range.isIRange(g.range)&&(M.Range.isIRange(g.originSelectionRange)||M.Range.isIRange(g.targetSelectionRange))}e.isLocationLink=i;var p;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(p=e.SymbolKind||(e.SymbolKind={}));var r;(function(g){g[g.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var s;(function(g){const I=new Map;I.set("file",0),I.set("module",1),I.set("namespace",2),I.set("package",3),I.set("class",4),I.set("method",5),I.set("property",6),I.set("field",7),I.set("constructor",8),I.set("enum",9),I.set("interface",10),I.set("function",11),I.set("variable",12),I.set("constant",13),I.set("string",14),I.set("number",15),I.set("boolean",16),I.set("array",17),I.set("object",18),I.set("key",19),I.set("null",20),I.set("enum-member",21),I.set("struct",22),I.set("event",23),I.set("operator",24),I.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function L(W){return I.get(W)}g.fromString=L;function w(W){return F.get(W)}g.toString=w;function x(W,B){const G=F.get(W);let H=G&&R.iconRegistry.get("symbol-"+G);return H||(console.info("No codicon found for SymbolKind "+W),H=R.Codicon.symbolProperty),`${B?"inline":"block"} ${H.classNames}`}g.toCssClassName=x})(s=e.SymbolKinds||(e.SymbolKinds={}));class u{constructor(I){this.value=I}}e.FoldingRangeKind=u,u.Comment=new u("comment"),u.Imports=new u("imports"),u.Region=new u("region");var h;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(h=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var k;(function(g){g[g.Other=0]="Other",g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(k=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new E.LanguageFeatureRegistry,e.RenameProviderRegistry=new E.LanguageFeatureRegistry,e.CompletionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new E.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new E.LanguageFeatureRegistry,e.HoverProviderRegistry=new E.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new E.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new E.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new E.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new E.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new E.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.LinkProviderRegistry=new E.LanguageFeatureRegistry,e.ColorProviderRegistry=new E.LanguageFeatureRegistry,e.SelectionRangeRegistry=new E.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var T;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(T=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[45],Ee([0,1,25,9,4]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=c.userAgent||"";const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",c.isMacintosh),R.set("isLinux",c.isLinux),R.set("isWindows",c.isWindows),R.set("isWeb",c.isWeb),R.set("isMacNative",c.isMacintosh&&!c.isWeb),R.set("isEdge",A.indexOf("Edg/")>=0),R.set("isFirefox",A.indexOf("Firefox")>=0),R.set("isChrome",A.indexOf("Chrome")>=0),R.set("isSafari",A.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var y;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return n.INSTANCE}static true(){return f.INSTANCE}static has(w){return o.create(w)}static equals(w,x){return l.create(w,x)}static notEquals(w,x){return _.create(w,x)}static regex(w,x){return r.create(w,x)}static in(w,x){return v.create(w,x)}static not(w){return a.create(w)}static and(...w){return h.create(w,null)}static or(...w){return m.create(w,null,!0)}static greater(w,x){return d.create(w,x)}static less(w,x){return i.create(w,x)}static deserialize(w,x=!1){if(!!w)return this._deserializeOrExpression(w,x)}static _deserializeOrExpression(w,x){let W=w.split("||");return m.create(W.map(B=>this._deserializeAndExpression(B,x)),null,!0)}static _deserializeAndExpression(w,x){let W=w.split("&&");return h.create(W.map(B=>this._deserializeOne(B,x)),null)}static _deserializeOne(w,x){if(w=w.trim(),w.indexOf("!=")>=0){let W=w.split("!=");return _.create(W[0].trim(),this._deserializeValue(W[1],x))}if(w.indexOf("==")>=0){let W=w.split("==");return l.create(W[0].trim(),this._deserializeValue(W[1],x))}if(w.indexOf("=~")>=0){let W=w.split("=~");return r.create(W[0].trim(),this._deserializeRegexValue(W[1],x))}if(w.indexOf(" in ")>=0){let W=w.split(" in ");return v.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(w)){const W=w.split(">=");return S.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(w)){const W=w.split(">");return d.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(w)){const W=w.split("<=");return p.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(w)){const W=w.split("<");return i.create(W[0].trim(),W[1].trim())}return/^\!\s*/.test(w)?a.create(w.substr(1).trim()):o.create(w)}static _deserializeValue(w,x){if(w=w.trim(),w==="true")return!0;if(w==="false")return!1;let W=/^'([^']*)'$/.exec(w);return W?W[1].trim():w}static _deserializeRegexValue(w,x){if((0,M.isFalsyOrWhitespace)(w)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let W=w.indexOf("/"),B=w.lastIndexOf("/");if(W===B||W<0){if(x)throw new Error(`bad regexp-value '${w}', missing /-enclosure`);return console.warn(`bad regexp-value '${w}', missing /-enclosure`),null}let G=w.slice(W+1,B),H=w[B+1]==="i"?"i":"";try{return new RegExp(G,H)}catch(U){if(x)throw new Error(`bad regexp-value '${w}', parse error: ${U}`);return console.warn(`bad regexp-value '${w}', parse error: ${U}`),null}}}e.ContextKeyExpr=P;function t(L,w){const x=L?L.substituteConstants():void 0,W=w?w.substituteConstants():void 0;return!x&&!W?!0:!x||!W?!1:x.equals(W)}e.expressionsAreEqualWithConstantSubstitution=t;function b(L,w){return L.cmp(w)}class n{constructor(){this.type=0}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}substituteConstants(){return this}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class f{constructor(){this.type=1}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}substituteConstants(){return this}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class o{constructor(w,x){this.key=w,this.negated=x,this.type=2}static create(w,x=null){const W=R.get(w);return typeof W=="boolean"?W?f.INSTANCE:n.INSTANCE:new o(w,x)}cmp(w){return w.type!==this.type?this.type-w.type:T(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}substituteConstants(){const w=R.get(this.key);return typeof w=="boolean"?w?f.INSTANCE:n.INSTANCE:this}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=o;class l{constructor(w,x,W){this.key=w,this.value=x,this.negated=W,this.type=4}static create(w,x,W=null){if(typeof x=="boolean")return x?o.create(w,W):a.create(w,W);const B=R.get(w);return typeof B=="boolean"?x===(B?"true":"false")?f.INSTANCE:n.INSTANCE:new l(w,x,W)}cmp(w){return w.type!==this.type?this.type-w.type:g(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){const w=R.get(this.key);if(typeof w=="boolean"){const x=w?"true":"false";return this.value===x?f.INSTANCE:n.INSTANCE}return this}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=l;class v{constructor(w,x){this.key=w,this.valueKey=x,this.type=10,this.negated=null}static create(w,x){return new v(w,x)}cmp(w){return w.type!==this.type?this.type-w.type:g(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}substituteConstants(){return this}evaluate(w){const x=w.getValue(this.valueKey),W=w.getValue(this.key);return Array.isArray(x)?x.indexOf(W)>=0:typeof W=="string"&&typeof x=="object"&&x!==null?C.call(x,W):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=D.create(this)),this.negated}}e.ContextKeyInExpr=v;class D{constructor(w){this._actual=w,this.type=11}static create(w){return new D(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}substituteConstants(){return this}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new D(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class _{constructor(w,x,W){this.key=w,this.value=x,this.negated=W,this.type=5}static create(w,x,W=null){if(typeof x=="boolean")return x?a.create(w,W):o.create(w,W);const B=R.get(w);return typeof B=="boolean"?x===(B?"true":"false")?n.INSTANCE:f.INSTANCE:new _(w,x,W)}cmp(w){return w.type!==this.type?this.type-w.type:g(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){const w=R.get(this.key);if(typeof w=="boolean"){const x=w?"true":"false";return this.value===x?n.INSTANCE:f.INSTANCE}return this}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=_;class a{constructor(w,x){this.key=w,this.negated=x,this.type=3}static create(w,x=null){const W=R.get(w);return typeof W=="boolean"?W?n.INSTANCE:f.INSTANCE:new a(w,x)}cmp(w){return w.type!==this.type?this.type-w.type:T(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}substituteConstants(){const w=R.get(this.key);return typeof w=="boolean"?w?n.INSTANCE:f.INSTANCE:this}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=a;class d{constructor(w,x,W){this.key=w,this.value=x,this.negated=W,this.type=12}static create(w,x,W=null){return new d(w,x,W)}cmp(w){return w.type!==this.type?this.type-w.type:g(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return parseFloat(w.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=d;class S{constructor(w,x,W){this.key=w,this.value=x,this.negated=W,this.type=13}static create(w,x,W=null){return new S(w,x,W)}cmp(w){return w.type!==this.type?this.type-w.type:g(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return parseFloat(w.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=S;class i{constructor(w,x,W){this.key=w,this.value=x,this.negated=W,this.type=14}static create(w,x,W=null){return new i(w,x,W)}cmp(w){return w.type!==this.type?this.type-w.type:g(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return parseFloat(w.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class p{constructor(w,x,W){this.key=w,this.value=x,this.negated=W,this.type=15}static create(w,x,W=null){return new p(w,x,W)}cmp(w){return w.type!==this.type?this.type-w.type:g(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}substituteConstants(){return this}evaluate(w){return parseFloat(w.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=p;class r{constructor(w,x){this.key=w,this.regexp=x,this.type=7,this.negated=null}static create(w,x){return new r(w,x)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const x=this.regexp?this.regexp.source:"",W=w.regexp?w.regexp.source:"";return x<W?-1:x>W?1:0}equals(w){if(w.type===this.type){const x=this.regexp?this.regexp.source:"",W=w.regexp?w.regexp.source:"";return this.key===w.key&&x===W}return!1}substituteConstants(){return this}evaluate(w){let x=w.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class s{constructor(w){this._actual=w,this.type=8}static create(w){return new s(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}substituteConstants(){return this}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new s(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function u(L){let w=null;for(let x=0,W=L.length;x<W;x++){const B=L[x].substituteConstants();if(L[x]!==B&&w===null){w=[];for(let G=0;G<x;G++)w[G]=L[G]}w!==null&&(w[x]=B)}return w===null?L:w}class h{constructor(w,x){this.expr=w,this.negated=x,this.type=6}static create(w,x){return h._normalizeArr(w,x)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let x=0,W=this.expr.length;x<W;x++){const B=b(this.expr[x],w.expr[x]);if(B!==0)return B}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let x=0,W=this.expr.length;x<W;x++)if(!this.expr[x].equals(w.expr[x]))return!1;return!0}return!1}substituteConstants(){const w=u(this.expr);return w===this.expr?this:h.create(w,this.negated)}evaluate(w){for(let x=0,W=this.expr.length;x<W;x++)if(!this.expr[x].evaluate(w))return!1;return!0}static _normalizeArr(w,x){const W=[];let B=!1;for(const G of w)if(!!G){if(G.type===1){B=!0;continue}if(G.type===0)return n.INSTANCE;if(G.type===6){W.push(...G.expr);continue}W.push(G)}if(W.length===0&&B)return f.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(b);for(let G=1;G<W.length;G++)W[G-1].equals(W[G])&&(W.splice(G,1),G--);if(W.length===1)return W[0];for(;W.length>1;){const G=W[W.length-1];if(G.type!==9)break;W.pop();const H=W.pop(),U=W.length===0,V=m.create(G.expr.map(Q=>h.create([Q,H],null)),null,U);V&&(W.push(V),W.sort(b))}return W.length===1?W[0]:new h(W,x)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(let x of this.expr)w.push(...x.keys());return w}map(w){return new h(this.expr.map(x=>x.map(w)),null)}negate(){if(!this.negated){const w=[];for(let x of this.expr)w.push(x.negate());this.negated=m.create(w,this,!0)}return this.negated}}class m{constructor(w,x){this.expr=w,this.negated=x,this.type=9}static create(w,x,W){return m._normalizeArr(w,x,W)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let x=0,W=this.expr.length;x<W;x++){const B=b(this.expr[x],w.expr[x]);if(B!==0)return B}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let x=0,W=this.expr.length;x<W;x++)if(!this.expr[x].equals(w.expr[x]))return!1;return!0}return!1}substituteConstants(){const w=u(this.expr);return w===this.expr?this:m.create(w,this.negated,!1)}evaluate(w){for(let x=0,W=this.expr.length;x<W;x++)if(this.expr[x].evaluate(w))return!0;return!1}static _normalizeArr(w,x,W){let B=[],G=!1;if(w){for(let H=0,U=w.length;H<U;H++){const V=w[H];if(!!V){if(V.type===0){G=!0;continue}if(V.type===1)return f.INSTANCE;if(V.type===9){B=B.concat(V.expr);continue}B.push(V)}}if(B.length===0&&G)return n.INSTANCE;B.sort(b)}if(B.length!==0){if(B.length===1)return B[0];for(let H=1;H<B.length;H++)B[H-1].equals(B[H])&&(B.splice(H,1),H--);if(B.length===1)return B[0];if(W){for(let H=0;H<B.length;H++)for(let U=H+1;U<B.length;U++)I(B[H],B[U])&&(B.splice(U,1),U--);if(B.length===1)return B[0]}return new m(B,x)}}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(let x of this.expr)w.push(...x.keys());return w}map(w){return new m(this.expr.map(x=>x.map(w)),null)}negate(){if(!this.negated){let w=[];for(let x of this.expr)w.push(x.negate());for(;w.length>1;){const x=w.shift(),W=w.shift(),B=[];for(const H of F(x))for(const U of F(W))B.push(h.create([H,U],null));const G=w.length===0;w.unshift(m.create(B,null,G))}this.negated=w[0]}return this.negated}}class k extends o{constructor(w,x,W){super(w,null);this._defaultValue=x,typeof W=="object"?k._info.push({...W,key:w}):W!==!0&&k._info.push({key:w,description:W,type:x!=null?typeof x:void 0})}static all(){return k._info.values()}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(w){return l.create(this.key,w)}notEqualsTo(w){return _.create(this.key,w)}}e.RawContextKey=k,k._info=[],e.IContextKeyService=(0,E.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function T(L,w){return L<w?-1:L>w?1:0}function g(L,w,x,W){return L<x?-1:L>x?1:w<W?-1:w>W?1:0}function I(L,w){if(w.type===6&&L.type!==9&&L.type!==6){for(const B of w.expr)if(L.equals(B))return!0}const x=L.negate(),W=F(x).concat(F(w));W.sort(b);for(let B=0;B<W.length;B++){const H=W[B].negate();for(let U=B+1;U<W.length;U++){const V=W[U];if(H.equals(V))return!0}}return!1}e.implies=I;function F(L){return L.type===9?L.expr:[L]}}),define(be[142],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(be[26],Ee([0,1,9,4]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function E(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=E;function A(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class C{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,n){if(typeof b=="undefined"||b===null)return typeof n=="undefined"||n===null;if(typeof n=="undefined"||n===null)return!1;if(typeof b=="string"||typeof n=="string"){let f=typeof b=="string"?b:b.value,o=typeof n=="string"?n:n.value;return c.equalsIgnoreCase(f,o)}return b._lower===n._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=C;function y(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function P(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[143],Ee([0,1,9,26]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function E(o,l){return o.uuid&&l.uuid?o.uuid===l.uuid:o.id===l.id?!0:(0,c.compareIgnoreCase)(o.id,l.id)===0}e.areSameExtensions=E;class A{constructor(l,v){this.version=v,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof A?E(this,l)&&this.version===l.version:!1}}e.ExtensionIdentifierWithVersion=A;function R(o,l){return`${o}.${l}`}e.getExtensionId=R;function C(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function y(o,l){return C(R(o,l))}e.getGalleryExtensionId=y;function P(o,l){const v=[],D=_=>{for(const a of v)if(a.some(d=>E(l(d),l(_))))return a;return null};for(const _ of o){const a=D(_);a?a.push(_):v.push([_])}return v}e.groupByExtension=P;function t(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function b(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(o){const l=new Set;for(const v of o)v.malicious&&l.add(v.id.id);return l}e.getMaliciousExtensionsSet=n;function f(o,l){const v=[],D=l.manifest.extensionDependencies?.slice(0)??[];for(;D.length;){const _=D.shift();if(_&&v.every(a=>!E(a.identifier,{id:_}))){const a=o.filter(d=>E(d.identifier,{id:_}));a.length===1&&(v.push(a[0]),D.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=f}),define(be[60],Ee([0,1,20,17,9,10,2,121,4]),function(re,e,c,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function P(B){return B.create===!0}e.isFileOpenForWriteOptions=P;var t;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var b;(function(B){B[B.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var n;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=f;function o(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=o;function l(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function v(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=v;var D;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(D=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class _ extends Error{constructor(G,H){super(G);this.code=H}}e.FileSystemProviderError=_;function a(B,G){const H=new _(B.toString(),G);return S(H,G),H}e.createFileSystemProviderError=a;function d(B){return B||a((0,C.localize)(0,null),D.Unknown)}e.ensureFileSystemProviderError=d;function S(B,G){return B.name=G?`${G} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=S;function i(B){if(!B)return D.Unknown;if(B instanceof _)return B.code;const G=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!G)return D.Unknown;switch(G[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileExceedsMemoryLimit:return D.FileExceedsMemoryLimit;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=i;function p(B){if(B instanceof k)return B.fileOperationResult;switch(i(B)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 10;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileExceedsMemoryLimit:return 9;case D.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=p;var r;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class s{constructor(G,H,U){this.resource=G,this.operation=H,this.target=U}isOperation(G){return this.operation===G}}e.FileOperationEvent=s;var u;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class h{constructor(G,H){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const U of G)switch(U.type){case 1:this.added||(this.added=c.TernarySearchTree.forUris(()=>H)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=c.TernarySearchTree.forUris(()=>H)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=c.TernarySearchTree.forUris(()=>H)),this.deleted.set(U.resource,U);break}}contains(G,...H){return this.doContains(G,{includeChildren:!1},...H)}affects(G,...H){return this.doContains(G,{includeChildren:!0},...H)}doContains(G,H,...U){if(!G)return!1;const V=U.length>0;return!!((!V||U.includes(1))&&(this.added?.get(G)||H.includeChildren&&this.added?.findSuperstr(G))||(!V||U.includes(0))&&(this.updated?.get(G)||H.includeChildren&&this.updated?.findSuperstr(G))||(!V||U.includes(2))&&(this.deleted?.findSubstr(G)||H.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=h;function m(B,G,H){return!B||!G||B===G||G.length>B.length?!1:(G.charAt(G.length-1)!==M.sep&&(G+=M.sep),H?(0,E.startsWithIgnoreCase)(B,G):B.indexOf(G)===0)}e.isParent=m;class k extends Error{constructor(G,H,U){super(G);this.fileOperationResult=H,this.options=U}}e.FileOperationError=k;class T extends k{constructor(G,H,U){super(G,2,U);this.stat=H}}e.NotModifiedSinceFileOperationError=T;var g;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(g=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var I;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(I=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=F;async function L(B,G){if(!G.canHandleResource(R.URI.from({scheme:B.scheme})))return new Promise(H=>{const U=G.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===B.scheme&&V.added&&(U.dispose(),H())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class w{static formatSize(G){return(0,A.isNumber)(G)||(G=0),G<w.KB?(0,C.localize)(1,null,G.toFixed(0)):G<w.MB?(0,C.localize)(2,null,(G/w.KB).toFixed(2)):G<w.GB?(0,C.localize)(3,null,(G/w.MB).toFixed(2)):G<w.TB?(0,C.localize)(4,null,(G/w.GB).toFixed(2)):(0,C.localize)(5,null,(G/w.TB).toFixed(2))}}e.ByteSize=w,w.KB=1024,w.MB=w.KB*w.KB,w.GB=w.MB*w.KB,w.TB=w.GB*w.KB;var x;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(x=e.Arch||(e.Arch={}));function W(B){return{maxFileSize:B===0?300*w.MB:16*w.GB,maxHeapSize:B===0?700*w.MB:2*700*w.MB}}e.getPlatformLimits=W}),define(be[61],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...E){this._entries=new Map;for(let[A,R]of E)this.set(A,R)}set(E,A){const R=this._entries.get(E);return this._entries.set(E,A),R}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=c}),define(be[144],Ee([0,1,14,16,81,139,4,61]),function(re,e,c,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class P extends Error{constructor(o){super("cyclic dependency between services");this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class t{constructor(o=new C.ServiceCollection,l=!1,v){this._activeInstantiations=new Set,this._services=o,this._strict=l,this._parent=v,this._services.set(R.IInstantiationService,this)}createChild(o){return new t(o,this._strict,this)}invokeFunction(o,...l){let v=n.traceInvocation(o),D=!1;try{return o({get:(a,d)=>{if(D)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const S=this._getOrCreateServiceInstance(a,v);if(!S&&d!==R.optional)throw new Error(`[invokeFunction] unknown service '${a}'`);return S}},...l)}finally{D=!0,v.stop()}}createInstance(o,...l){let v,D;return o instanceof E.SyncDescriptor?(v=n.traceCreation(o.ctor),D=this._createInstance(o.ctor,o.staticArguments.concat(l),v)):(v=n.traceCreation(o),D=this._createInstance(o,l,v)),v.stop(),D}_createInstance(o,l=[],v){let D=R._util.getServiceDependencies(o).sort((d,S)=>d.index-S.index),_=[];for(const d of D){let S=this._getOrCreateServiceInstance(d.id,v);if(!S&&this._strict&&!d.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${d.id}.`);_.push(S)}let a=D.length>0?D[0].index:l.length;if(l.length!==a){console.warn(`[createInstance] First service dependency of ${o.name} at position ${a+1} conflicts with ${l.length} static arguments`);let d=a-l.length;d>0?l=l.concat(new Array(d)):l=l.slice(0,a)}return new o(...[...l,..._])}_setServiceInstance(o,l){if(this._services.get(o)instanceof E.SyncDescriptor)this._services.set(o,l);else if(this._parent)this._parent._setServiceInstance(o,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let l=this._services.get(o);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):l}_getOrCreateServiceInstance(o,l){let v=this._getServiceInstanceOrDescriptor(o);return v instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,v,l.branch(o,!0)):(l.branch(o,!1),v)}_safeCreateAndCacheServiceInstance(o,l,v){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,l,v)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,l,v){const D=new A.Graph(d=>d.id.toString());let _=0;const a=[{id:o,desc:l,_trace:v}];for(;a.length;){const d=a.pop();if(D.lookupOrInsertNode(d),_++>1e3)throw new P(D);for(let S of R._util.getServiceDependencies(d.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(S.id);if(!i&&!S.optional&&console.warn(`[createInstance] ${o} depends on ${S.id} which is NOT registered.`),i instanceof E.SyncDescriptor){const p={id:S.id,desc:i,_trace:d._trace.branch(S.id,!0)};D.insertEdge(d,p),a.push(p)}}}for(;;){const d=D.roots();if(d.length===0){if(!D.isEmpty())throw new P(D);break}for(const{data:S}of d){if(this._getServiceInstanceOrDescriptor(S.id)instanceof E.SyncDescriptor){const p=this._createServiceInstanceWithOwner(S.id,S.desc.ctor,S.desc.staticArguments,S.desc.supportsDelayedInstantiation,S._trace);this._setServiceInstance(S.id,p)}D.removeNode(S)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,l,v=[],D,_){if(this._services.get(o)instanceof E.SyncDescriptor)return this._createServiceInstance(l,v,D,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,l,v,D,_);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(o,l=[],v,D){if(v){const _=new c.IdleValue(()=>this._createInstance(o,l,D));return new Proxy(Object.create(null),{get(a,d){if(d in a)return a[d];let S=_.value,i=S[d];return typeof i!="function"||(i=i.bind(S),a[d]=i),i},set(a,d,S){return _.value[d]=S,!0}})}else return this._createInstance(o,l,D)}}e.InstantiationService=t;var b;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(b||(b={}));class n{constructor(o,l){this.type=o,this.name=l,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return y?new n(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(o){return y?new n(0,o.name):n._None}branch(o,l){let v=new n(2,o.toString());return this._dep.push([o,l,v]),v}stop(){let o=Date.now()-this._start;n._totals+=o;let l=!1;function v(_,a){let d=[],S=new Array(_+1).join("	");for(const[i,p,r]of a._dep)if(p&&r){l=!0,d.push(`${S}CREATES -> ${i}`);let s=v(_+1,r);s&&d.push(s)}else d.push(`${S}uses -> ${i}`);return d.join(`
`)}let D=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(o>2||l)&&console.log(D.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(be[15],Ee([0,1,56,3,6,25,4]),function(re,e,c,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,R.createDecorator)("logService"),e.ILoggerService=(0,R.createDecorator)("loggerService");function C(){return new Date().toISOString()}var y;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class P extends E.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class t extends P{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...p){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([i,...p]))}debug(i,...p){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([i,...p]))}info(i,...p){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([i,...p]))}warn(i,...p){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([i,...p]))}error(i,...p){if(this.checkLogLevel(y.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(y.Error,this.format(r))}else this.log(y.Error,this.format([i,...p]))}critical(i,...p){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([i,...p]))}flush(){}format(i){let p="";for(let r=0;r<i.length;r++){let s=i[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch(u){}p+=(r>0?" ":"")+s}return p}}e.AbstractMessageLogger=t;class b extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...p){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...p):console.log(`[main ${C()}]`,i,...p))}debug(i,...p){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...p):console.log(`[main ${C()}]`,i,...p))}info(i,...p){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,i,...p):console.log(`[main ${C()}]`,i,...p))}warn(i,...p){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,i,...p):console.warn(`[main ${C()}]`,i,...p))}error(i,...p){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,i,...p):console.error(`[main ${C()}]`,i,...p))}critical(i,...p){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,i,...p):console.error(`[main ${C()}]`,i,...p))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class n extends P{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...p){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",i,...p)}debug(i,...p){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...p)}info(i,...p){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",i,...p)}warn(i,...p){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",i,...p)}error(i,...p){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",i,...p)}critical(i,...p){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...p)}dispose(){}flush(){}}e.ConsoleLogger=n;class f extends P{constructor(i,p=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(p)}trace(i,...p){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(i),...p])}debug(i,...p){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(i),...p])}info(i,...p){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(i),...p])}warn(i,...p){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(i),...p])}error(i,...p){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(i),...p])}critical(i,...p){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(i),...p])}extractMessage(i){return typeof i=="string"?i:(0,c.toErrorMessage)(i,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class o extends P{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const p of this.logServices)p.setLevel(i);super.setLevel(i)}trace(i,...p){for(const r of this.logServices)r.trace(i,...p)}debug(i,...p){for(const r of this.logServices)r.debug(i,...p)}info(i,...p){for(const r of this.logServices)r.info(i,...p)}warn(i,...p){for(const r of this.logServices)r.warn(i,...p)}error(i,...p){for(const r of this.logServices)r.error(i,...p)}critical(i,...p){for(const r of this.logServices)r.critical(i,...p)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=o;class l extends E.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...p){this.logger.trace(i,...p)}debug(i,...p){this.logger.debug(i,...p)}info(i,...p){this.logger.info(i,...p)}warn(i,...p){this.logger.warn(i,...p)}error(i,...p){this.logger.error(i,...p)}critical(i,...p){this.logger.critical(i,...p)}flush(){this.logger.flush()}}e.LogService=l;class v extends E.Disposable{constructor(i,p){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(p(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,p){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,p?.always?y.Trace:this.logLevel,p),this.loggers.set(i.toString(),r),p?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class D{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(i){}getLevel(){return y.Info}trace(i,...p){}debug(i,...p){}info(i,...p){}warn(i,...p){}error(i,...p){}critical(i,...p){}dispose(){}flush(){}}e.NullLogService=D;function _(S){if(S.verbose)return y.Trace;if(typeof S.logLevel=="string"){const i=a(S.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=_;function a(S){switch(S){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=a;function d(S){switch(S){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=d}),define(be[82],Ee([0,1,35,122,4]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var R;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function P(o,l){return l-o}y.compare=P;const t=Object.create(null);t[y.Error]=(0,M.localize)(0,null),t[y.Warning]=(0,M.localize)(1,null),t[y.Info]=(0,M.localize)(2,null);function b(o){return t[o]||""}y.toString=b;function n(o){switch(o){case c.default.Error:return y.Error;case c.default.Warning:return y.Warning;case c.default.Info:return y.Info;case c.default.Ignore:return y.Hint}}y.fromSeverity=n;function f(o){switch(o){case y.Error:return c.default.Error;case y.Warning:return c.default.Warning;case y.Info:return c.default.Info;case y.Hint:return c.default.Ignore}}y.toSeverity=f}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(y){const P="";function t(n){return b(n,!0)}y.makeKey=t;function b(n,f){let o=[P];return n.source?o.push(n.source.replace("\xA6","\\\xA6")):o.push(P),n.code?typeof n.code=="string"?o.push(n.code.replace("\xA6","\\\xA6")):o.push(n.code.value.replace("\xA6","\\\xA6")):o.push(P),n.severity!==void 0&&n.severity!==null?o.push(R.toString(n.severity)):o.push(P),n.message&&f?o.push(n.message.replace("\xA6","\\\xA6")):o.push(P),n.startLineNumber!==void 0&&n.startLineNumber!==null?o.push(n.startLineNumber.toString()):o.push(P),n.startColumn!==void 0&&n.startColumn!==null?o.push(n.startColumn.toString()):o.push(P),n.endLineNumber!==void 0&&n.endLineNumber!==null?o.push(n.endLineNumber.toString()):o.push(P),n.endColumn!==void 0&&n.endColumn!==null?o.push(n.endColumn.toString()):o.push(P),o.push(P),o.join("\xA6")}y.makeKeyOptionalMessage=b})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(be[145],Ee([0,1,3,35,4]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,E.createDecorator)("notificationService");var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var R;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(R=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new y,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=C;class y{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=y}),define(be[146],Ee([0,1,6,9,2,4]),function(re,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return c.Disposable.None},registerValidator(){return c.Disposable.None},registerExternalUriResolver(){return c.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return c.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function R(C,y){return E.URI.isUri(C)?(0,M.equalsIgnoreCase)(C.scheme,y):(0,M.startsWithIgnoreCase)(C,y+":")}e.matchesScheme=R});var $e=this&&this.__decorate||function(re,e,c,M){var E=arguments.length,A=E<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,c):M,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(re,e,c,M);else for(var C=re.length-1;C>=0;C--)(R=re[C])&&(A=(E<3?R(A):E>3?R(e,c,A):R(e,c))||A);return E>3&&A&&Object.defineProperty(e,c,A),A},Ve=this&&this.__param||function(re,e){return function(c,M){e(c,M,re)}};define(be[147],Ee([0,1,14,21,6,4]),function(re,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var R;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(b){this.callback=b}get value(){return this._value}report(b){this._value=b,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let y=class extends E.Disposable{constructor(b,n){super();this.deferred=new c.DeferredPromise,n.withProgress(b,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,E.toDisposable)(()=>this.deferred.complete()))}report(b){this.reporter?this.reporter.report(b):this.lastStep=b}};y=$e([Ve(1,e.IProgressService)],y),e.UnmanagedProgress=y;class P extends E.Disposable{constructor(b){super();this.progressIndicator=b,this.currentOperationId=0,this.currentOperationDisposables=this._register(new E.DisposableStore)}start(b){this.stop();const n=++this.currentOperationId,f=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},b),this.currentOperationDisposables.add((0,E.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,E.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,E.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:f.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(b){this.currentOperationId===b&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(be[28],Ee([0,1,42,10]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(R,C){c.ok(M.isString(R)),c.ok(M.isObject(C)),c.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,C)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new E}),define(be[83],Ee([0,1,3,28]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function E(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class A{constructor(){this._onDidChangeSchema=new c.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,P){this.schemasById[E(y)]=P,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new A;M.Registry.add(e.Extensions.JSONContribution,R)}),define(be[62],Ee([0,1,13,3,10,119,83,28]),function(re,e,c,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(_){_.Multiline="multilineText",_.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const t=C.Registry.as(R.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(a,d=!0){this.registerConfigurations([a],d)}registerConfigurations(a,d=!0){const S=this.doRegisterConfigurations(a,d);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterConfigurations(a){const d=this.doDeregisterConfigurations(a);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}updateConfigurations({add:a,remove:d}){const S=[];S.push(...this.doDeregisterConfigurations(d)),S.push(...this.doRegisterConfigurations(a,!1)),t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,c.distinct)(S))}registerDefaultConfigurations(a){const d=[],S=[];for(const i of a)for(const p in i)if(d.push(p),e.OVERRIDE_PROPERTY_PATTERN.test(p)){this.defaultValues[p]={...this.defaultValues[p]||{},...i[p]};const r={type:"object",default:this.defaultValues[p],description:A.localize(1,null,p),$ref:e.resourceLanguageSettingsSchemaId};S.push(f(p)),this.configurationProperties[p]=r,this.defaultLanguageConfigurationOverridesNode.properties[p]=r}else{this.defaultValues[p]=i[p];const r=this.configurationProperties[p];r&&(this.updatePropertyDefaultValue(p,r),this.updateSchema(p,r))}this.registerOverrideIdentifiers(S),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterDefaultConfigurations(a){const d=[];for(const S of a)for(const i in S)if(d.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_PATTERN.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const p=this.configurationProperties[i];p&&(this.updatePropertyDefaultValue(i,p),this.updateSchema(i,p))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const d of a)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,d){const S=[];return a.forEach(i=>{S.push(...this.validateAndRegisterProperties(i,d,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),S}doDeregisterConfigurations(a){const d=[],S=i=>{if(i.properties)for(const p in i.properties)d.push(p),delete this.configurationProperties[p],this.removeFromSchema(p,i.properties[p]);i.allOf&&i.allOf.forEach(p=>S(p))};for(const i of a){S(i);const p=this.configurationContributors.indexOf(i);p!==-1&&this.configurationContributors.splice(p,1)}return d}validateAndRegisterProperties(a,d=!0,S,i=3){i=E.isUndefinedOrNull(a.scope)?i:a.scope;let p=[],r=a.properties;if(r)for(let u in r){if(d&&v(u)){delete r[u];continue}const h=r[u];if(this.updatePropertyDefaultValue(u,h),e.OVERRIDE_PROPERTY_PATTERN.test(u)?h.scope=void 0:(h.scope=E.isUndefinedOrNull(h.scope)?i:h.scope,h.restricted=E.isUndefinedOrNull(h.restricted)?!!S?.restrictedConfigurations?.includes(u):h.restricted),r[u].hasOwnProperty("included")&&!r[u].included){this.excludedConfigurationProperties[u]=r[u],delete r[u];continue}else this.configurationProperties[u]=r[u];!r[u].deprecationMessage&&r[u].markdownDeprecationMessage&&(r[u].deprecationMessage=r[u].markdownDeprecationMessage),p.push(u)}let s=a.allOf;if(s)for(let u of s)p.push(...this.validateAndRegisterProperties(u,d,S,i));return p}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(a){const d=S=>{let i=S.properties;if(i)for(const r in i)this.updateSchema(r,i[r]);let p=S.allOf;p&&p.forEach(d)};d(a)}updateSchema(a,d){switch(e.allSettings.properties[a]=d,d.scope){case 1:e.applicationSettings.properties[a]=d;break;case 2:e.machineSettings.properties[a]=d;break;case 6:e.machineOverridableSettings.properties[a]=d;break;case 3:e.windowSettings.properties[a]=d;break;case 4:e.resourceSettings.properties[a]=d;break;case 5:e.resourceSettings.properties[a]=d,this.resourceLanguageSettingsSchema.properties[a]=d;break}}removeFromSchema(a,d){switch(delete e.allSettings.properties[a],d.scope){case 1:delete e.applicationSettings.properties[a];break;case 2:delete e.machineSettings.properties[a];break;case 6:delete e.machineOverridableSettings.properties[a];break;case 3:delete e.windowSettings.properties[a];break;case 4:case 5:delete e.resourceSettings.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const d=`[${a}]`,S={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,S),e.allSettings.properties[d]=S,e.applicationSettings.properties[d]=S,e.machineSettings.properties[d]=S,e.machineOverridableSettings.properties[d]=S,e.windowSettings.properties[d]=S,e.resourceSettings.properties[d]=S}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,d){let S=this.defaultValues[a];E.isUndefined(S)&&(S=d.default),E.isUndefined(S)&&(S=o(d.type)),d.default=S}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function f(_){return _.substring(1,_.length-1)}e.overrideIdentifierFromKey=f;function o(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const l=new b;C.Registry.add(e.Extensions.Configuration,l);function v(_){return _.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(_)?A.localize(5,null,_):l.getConfigurationProperties()[_]!==void 0?A.localize(6,null,_):null:A.localize(4,null)}e.validateProperty=v;function D(){const _=[],a=l.getConfigurationProperties();for(const d of Object.keys(a))_.push([d,a[d].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=D}),define(be[84],Ee([0,1,23,10,2,62,4,28]),function(re,e,c,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function y(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof E.URI)}e.isConfigurationOverrides=y;var P;(function(p){p[p.USER=1]="USER",p[p.USER_LOCAL=2]="USER_LOCAL",p[p.USER_REMOTE=3]="USER_REMOTE",p[p.WORKSPACE=4]="WORKSPACE",p[p.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",p[p.DEFAULT=6]="DEFAULT",p[p.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(p){switch(p){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function b(p,r){const s=r?p?r.keys.filter(I=>p.keys.indexOf(I)===-1):[...r.keys]:[],u=p?r?p.keys.filter(I=>r.keys.indexOf(I)===-1):[...p.keys]:[],h=[];if(r&&p){for(const I of p.keys)if(r.keys.indexOf(I)!==-1){const F=D(p.contents,I),L=D(r.contents,I);c.equals(F,L)||h.push(I)}}const m=[],k=I=>{const F={};for(const L of I)for(const w of L.identifiers)F[S(w)]=L;return F},T=r?k(r.overrides):{},g=p?k(p.overrides):{};if(Object.keys(T).length)for(const I of s){const F=T[I];F&&m.push([(0,A.overrideIdentifierFromKey)(I),F.keys])}if(Object.keys(g).length)for(const I of u){const F=g[I];F&&m.push([(0,A.overrideIdentifierFromKey)(I),F.keys])}if(Object.keys(T).length&&Object.keys(g).length)for(const I of h){const F=g[I],L=T[I];if(F&&L){const w=b({contents:F.contents,keys:F.keys,overrides:[]},{contents:L.contents,keys:L.keys,overrides:[]});m.push([(0,A.overrideIdentifierFromKey)(I),[...w.added,...w.removed,...w.updated]])}}return{added:s,removed:u,updated:h,overrides:m}}e.compare=b;function n(p,r){const s=[];for(const u of Object.keys(p))if(A.OVERRIDE_PROPERTY_PATTERN.test(u)){const h={};for(const m in p[u])h[m]=p[u][m];s.push({identifiers:[(0,A.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(h),contents:f(h,r)})}return s}e.toOverrides=n;function f(p,r){const s=Object.create(null);for(let u in p)o(s,u,p[u],r);return s}e.toValuesTree=f;function o(p,r,s,u){const h=r.split("."),m=h.pop();let k=p;for(let T=0;T<h.length;T++){let g=h[T],I=k[g];switch(typeof I){case"undefined":I=k[g]=Object.create(null);break;case"object":break;default:u(`Ignoring ${r} as ${h.slice(0,T+1).join(".")} is ${JSON.stringify(I)}`);return}k=I}if(typeof k=="object"&&k!==null)try{k[m]=s}catch(T){u(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(k)}`)}else u(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(k)}`)}e.addToValueTree=o;function l(p,r){const s=r.split(".");v(p,s)}e.removeFromValueTree=l;function v(p,r){const s=r.shift();if(r.length===0){delete p[s];return}if(Object.keys(p).indexOf(s)!==-1){const u=p[s];typeof u=="object"&&!Array.isArray(u)&&(v(u,r),Object.keys(u).length===0&&delete p[s])}}function D(p,r,s){function u(k,T){let g=k;for(const I of T){if(typeof g!="object"||g===null)return;g=g[I]}return g}const h=r.split("."),m=u(p,h);return typeof m=="undefined"?s:m}e.getConfigurationValue=D;function _(p,r,s){Object.keys(r).forEach(u=>{u!=="__proto__"&&(u in p?M.isObject(p[u])&&M.isObject(r[u])?_(p[u],r[u],s):s&&(p[u]=r[u]):p[u]=r[u])})}e.merge=_;function a(){const p=C.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(p)}e.getConfigurationKeys=a;function d(){const p=Object.create(null),r=C.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let s in r){let u=r[s].default;o(p,s,u,h=>console.error(`Conflict in default settings: ${h}`))}return p}e.getDefaultValues=d;function S(p){return`[${p}]`}e.keyFromOverrideIdentifier=S;function i(p,r,s){const u=p.inspect(r),h=p.inspect(s);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:u.defaultValue}e.getMigratedSettingValue=i}),define(be[148],Ee([0,1,13,3,102,6,20,23,10,2,84,62,28]),function(re,e,c,M,E,A,R,C,y,P,t,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(i={},p=[],r=[]){this._contents=i,this._keys=p,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,p){const r=this.getContentsForOverrideIdentifer(p);return r?i?(0,t.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const p of this.overrides)if(p.identifiers.indexOf(i)!==-1)return p.keys;return[]}override(i){let p=this.overrideConfigurations.get(i);return p||(p=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,p)),p}merge(...i){const p=C.deepClone(this.contents),r=C.deepClone(this.overrides),s=[...this.keys];for(const u of i){this.mergeContents(p,u.contents);for(const h of u.overrides){const[m]=r.filter(k=>c.equals(k.identifiers,h.identifiers));m?this.mergeContents(m.contents,h.contents):r.push(C.deepClone(h))}for(const h of u.keys)s.indexOf(h)===-1&&s.push(h)}return new f(p,s,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const p=this.getContentsForOverrideIdentifer(i);if(!p||typeof p!="object"||!Object.keys(p).length)return this;let r={};for(const s of c.distinct([...Object.keys(this.contents),...Object.keys(p)])){let u=this.contents[s],h=p[s];h&&(typeof u=="object"&&typeof h=="object"?(u=C.deepClone(u),this.mergeContents(u,h)):u=h),r[s]=u}return new f(r,this.keys,this.overrides)}mergeContents(i,p){for(const r of Object.keys(p)){if(r in i&&y.isObject(i[r])&&y.isObject(p[r])){this.mergeContents(i[r],p[r]);continue}i[r]=C.deepClone(p[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?C.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const p of this.overrides)if(p.identifiers.indexOf(i)!==-1)return p.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,p){this.addKey(i),(0,t.addToValueTree)(this.contents,i,p,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let p=this.keys.length;for(let r=0;r<p;r++)i.indexOf(this.keys[r])===0&&(p=r);this.keys.splice(p,1,i)}removeKey(i){let p=this.keys.indexOf(i);return p!==-1?(this.keys.splice(p,1),!0):!1}}e.ConfigurationModel=f;class o extends f{constructor(){const i=(0,t.getDefaultValues)(),p=(0,t.getConfigurationKeys)(),r=[];for(const s of Object.keys(i))b.OVERRIDE_PROPERTY_PATTERN.test(s)&&r.push({identifiers:[(0,b.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(i[s]),contents:(0,t.toValuesTree)(i[s],u=>console.error(`Conflict in default settings file: ${u}`))});super(i,p,r)}}e.DefaultConfigurationModel=o;class l{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,p){if(!y.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,p)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,p){this._raw=i;const{contents:r,keys:s,overrides:u,restricted:h}=this.doParseRaw(i,p);this._configurationModel=new f(r,s,u),this._restrictedConfigurations=h||[]}doParseContent(i){let p={},r=null,s=[],u=[],h=[];function m(T){Array.isArray(s)?s.push(T):r!==null&&(s[r]=T)}let k={onObjectBegin:()=>{let T={};m(T),u.push(s),s=T,r=null},onObjectProperty:T=>{r=T},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{let T=[];m(T),u.push(s),s=T,r=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:m,onError:(T,g,I)=>{h.push({error:T,offset:g,length:I})}};if(i)try{E.visit(i,k),p=s[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return p}doParseRaw(i,p){const r=n.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,r,!0,p);i=s.raw;const u=(0,t.toValuesTree)(i,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),h=Object.keys(i),m=(0,t.toOverrides)(i,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:u,keys:h,overrides:m,restricted:s.restricted}}filter(i,p,r,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const u={},h=[];for(let m in i)if(b.OVERRIDE_PROPERTY_PATTERN.test(m)&&r){const k=this.filter(i[m],p,!1,s);u[m]=k.raw,h.push(...k.restricted)}else{const k=p[m],T=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&h.push(m),(T===void 0||s.scopes===void 0||s.scopes.includes(T))&&(s.skipRestricted&&k?.restricted||(u[m]=i[m]))}return{raw:u,restricted:h}}}e.ConfigurationModelParser=l;class v extends A.Disposable{constructor(i,p,r,s){super();this.userSettingsResource=i,this.scopes=p,this.fileService=s,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class D{constructor(i,p,r=new f,s=new f,u=new R.ResourceMap,h=new f,m=new R.ResourceMap,k=!0){this._defaultConfiguration=i,this._localUserConfiguration=p,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=h,this._memoryConfigurationByResource=m,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(i,p,r){return this.getConsolidateConfigurationModel(p,r).getValue(i)}updateValue(i,p,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new f,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,p===void 0?s.removeValue(i):s.setValue(i,p),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,p,r){const s=this.getConsolidateConfigurationModel(p,r),u=this.getFolderConfigurationModelForResource(p.resource,r),h=p.resource?this._memoryConfigurationByResource.get(p.resource)||this._memoryConfiguration:this._memoryConfiguration,m=p.overrideIdentifier?this._defaultConfiguration.freeze().override(p.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),k=p.overrideIdentifier?this.userConfiguration.freeze().override(p.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),T=p.overrideIdentifier?this.localUserConfiguration.freeze().override(p.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),g=p.overrideIdentifier?this.remoteUserConfiguration.freeze().override(p.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),I=r?p.overrideIdentifier?this._workspaceConfiguration.freeze().override(p.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,F=u?p.overrideIdentifier?u.freeze().override(p.overrideIdentifier).getValue(i):u.freeze().getValue(i):void 0,L=p.overrideIdentifier?h.override(p.overrideIdentifier).getValue(i):h.getValue(i),w=s.getValue(i),x=c.distinct(c.flatten(s.overrides.map(W=>W.identifiers))).filter(W=>s.getOverrideValue(i,W)!==void 0);return{defaultValue:m,userValue:k,userLocalValue:T,userRemoteValue:g,workspaceValue:I,workspaceFolderValue:F,memoryValue:L,value:w,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:p.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:p.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:p.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,userRemote:g!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:p.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,workspace:I!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:p.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:u?.freeze().getValue(i),override:p.overrideIdentifier?u?.freeze().getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,memory:L!==void 0?{value:h.getValue(i),override:p.overrideIdentifier?h.getOverrideValue(i,p.overrideIdentifier):void 0}:void 0,overrideIdentifiers:x.length?x:void 0}}keys(i){const p=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:p?p.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,p){this._folderConfigurations.set(i,p),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,p){const r=p.filter(s=>b.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const u=(0,b.overrideIdentifierFromKey)(s),h=this._defaultConfiguration.getKeysForOverrideIdentifier(u),m=i.getKeysForOverrideIdentifier(u),k=[...m.filter(T=>h.indexOf(T)===-1),...h.filter(T=>m.indexOf(T)===-1),...h.filter(T=>!C.equals(this._defaultConfiguration.override(u).getValue(T),i.override(u).getValue(T)))];return[u,k]});return this.updateDefaultConfiguration(i),{keys:p,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:p,updated:r,removed:s,overrides:u}=(0,t.compare)(this.localUserConfiguration,i),h=[...p,...r,...s];return h.length&&this.updateLocalUserConfiguration(i),{keys:h,overrides:u}}compareAndUpdateRemoteUserConfiguration(i){const{added:p,updated:r,removed:s,overrides:u}=(0,t.compare)(this.remoteUserConfiguration,i);let h=[...p,...r,...s];return h.length&&this.updateRemoteUserConfiguration(i),{keys:h,overrides:u}}compareAndUpdateWorkspaceConfiguration(i){const{added:p,updated:r,removed:s,overrides:u}=(0,t.compare)(this.workspaceConfiguration,i);let h=[...p,...r,...s];return h.length&&this.updateWorkspaceConfiguration(i),{keys:h,overrides:u}}compareAndUpdateFolderConfiguration(i,p){const r=this.folderConfigurations.get(i),{added:s,updated:u,removed:h,overrides:m}=(0,t.compare)(r,p);let k=[...s,...u,...h];return(k.length||!r)&&this.updateFolderConfiguration(i,p),{keys:k,overrides:m}}compareAndDeleteFolderConfiguration(i){const p=this.folderConfigurations.get(i);if(!p)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:s,removed:u,overrides:h}=(0,t.compare)(p,void 0);return{keys:[...r,...s,...u],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,p){let r=this.getConsolidatedConfigurationModelForResource(i,p);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},p){let r=this.getWorkspaceConsolidatedConfiguration();if(p&&i){const s=p.getFolder(i);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const u=this._memoryConfigurationByResource.get(i);u&&(r=r.merge(u))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let p=this._foldersConsolidatedConfigurations.get(i);if(!p){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(p=r.merge(s),this._freeze&&(p=p.freeze()),this._foldersConsolidatedConfigurations.set(i,p)):p=r}return p}getFolderConfigurationModelForResource(i,p){if(p&&i){const r=p.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,p)=>{const{contents:r,overrides:s,keys:u}=this._folderConfigurations.get(p);return i.push([p,{contents:r,overrides:s,keys:u}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(p=>i.add(p)),this.userConfiguration.freeze().keys.forEach(p=>i.add(p)),this._workspaceConfiguration.freeze().keys.forEach(p=>i.add(p)),this._folderConfigurations.forEach(p=>p.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const p=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>p.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>p.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>p.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(s=>p.add(s))),[...p.values()]}static parse(i){const p=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),u=i.folders.reduce((h,m)=>(h.set(P.URI.revive(m[0]),this.parseConfigurationModel(m[1])),h),new R.ResourceMap);return new D(p,r,new f,s,u,new f,new R.ResourceMap,!1)}static parseConfigurationModel(i){return new f(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=D;function _(...S){if(S.length===0)return{keys:[],overrides:[]};if(S.length===1)return S[0];const i=new Set,p=new Map;for(const s of S)s.keys.forEach(u=>i.add(u)),s.overrides.forEach(([u,h])=>{const m=(0,R.getOrSet)(p,u,new Set);h.forEach(k=>m.add(k))});const r=[];return p.forEach((s,u)=>r.push([u,[...s.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=_;class a{constructor(i,p,r,s){this.change=i,this.previous=p,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const u=new Set;i.keys.forEach(m=>u.add(m)),i.overrides.forEach(([,m])=>m.forEach(k=>u.add(k))),this.affectedKeys=[...u.values()];const h=new f;this.affectedKeys.forEach(m=>h.setValue(m,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=D.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,p){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(p){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,p,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,p,this.currentWorkspace);return!C.equals(r,s)}return!0}return!1}doesAffectedKeysTreeContains(i,p){let r=(0,t.toValuesTree)({[p]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(i=i[s],!i)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=a;class d extends a{constructor(i,p,r,s){super({keys:i.allKeys(),overrides:[]},void 0,i,p);this.source=r,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=d}),define(be[85],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,c.createDecorator)("remoteAuthorityResolverService");var M;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class E extends Error{constructor(R,C=M.Unknown,y){super(R);this._message=R,this._code=C,this._detail=y,this.isHandled=C===M.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype)}static isTemporarilyNotAvailable(R){return R instanceof E&&R._code===M.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof E&&R._code===M.NoResolverFound}static isHandled(R){return R instanceof E&&R.isHandled}}e.RemoteAuthorityResolverError=E}),define(be[86],Ee([0,1,11]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(P){return P.scheme===c.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=M;function E(P){if(!P)return;const t=P.indexOf("+");return t<0?P:P.substr(0,t)}e.getRemoteName=E;function A(P){return P.scheme!==c.Schemas.file&&P.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=A;function R(P){if(P.folders.length)return P.folders.every(t=>A(t.uri))?P.folders[0].uri:void 0;if(P.configuration&&A(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=R;function C(P){return R(P)?.scheme}e.getVirtualWorkspaceScheme=C;function y(P){return R(P)!==void 0}e.isVirtualWorkspace=y}),define(be[149],Ee([0,1,3,25,4,15]),function(re,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,E.createDecorator)("tunnelService");var R;(function(o){o.Http="http",o.Https="https"})(R=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(C=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(!!l)return{address:l[1],port:+l[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function t(o){return e.LOCALHOST_ADDRESSES.indexOf(o)>=0}e.isLocalhost=t,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(o){return e.ALL_INTERFACES_ADDRESSES.indexOf(o)>=0}e.isAllInterfaces=b;function n(o,l){return l?l!==1&&o<1024:!M.isWindows&&o<1024}e.isPortPrivileged=n;let f=class{constructor(l){this.logService=l,this._onTunnelOpened=new c.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new c.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new c.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(l,v){return this._tunnelProvider=l,l?(this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return new Promise(async l=>{const v=[],D=Array.from(this._tunnels.values());for(let _ of D){const a=Array.from(_.values());for(let d of a){const S=await d.value;S&&v.push(S)}}l(v)})}async dispose(){for(const l of this._tunnels.values()){for(const{value:v}of l.values())await v.then(D=>D?.dispose());l.clear()}this._tunnels.clear()}openTunnel(l,v,D,_,a=!1,d=C.Private,S){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${D} on local port ${_}.`),!l)return;v||(v="localhost");const i=this.retainOrCreateTunnel(l,v,D,_,a,d,S);return i?i.then(p=>{if(!p){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,D);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(p);return(p.tunnelRemoteHost!==v||p.tunnelRemotePort!==D)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const v=this._tunnels.get(l.tunnelRemoteHost);if(v){const D=v.get(l.tunnelRemotePort);D&&(D.refcount--,await this.tryDisposeTunnel(l.tunnelRemoteHost,l.tunnelRemotePort,D))}}}}async tryDisposeTunnel(l,v,D){if(D.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${v}.`);const _=D.value.then(async a=>{a&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(l)&&this._tunnels.get(l).delete(v),_}}async closeTunnel(l,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${v} `);const D=this._tunnels.get(l);if(D&&D.has(v)){const _=D.get(v);_.refcount=0,await this.tryDisposeTunnel(l,v,_)}}addTunnelToMap(l,v,D){this._tunnels.has(l)||this._tunnels.set(l,new Map),this._tunnels.get(l).set(v,{refcount:1,value:D})}async removeEmptyTunnelFromMap(l,v){const D=this._tunnels.get(l);D&&(await D.get(v)||D.delete(v),D.size===0&&this._tunnels.delete(l))}getTunnelFromMap(l,v){let D=[l];t(l)?(D.push(...e.LOCALHOST_ADDRESSES),D.push(...e.ALL_INTERFACES_ADDRESSES)):b(l)&&D.push(...e.ALL_INTERFACES_ADDRESSES);const _=D.map(a=>this._tunnels.get(a));for(const a of _){const d=a?.get(v);if(d)return d}}canTunnel(l){return!!P(l)}createWithProvider(l,v,D,_,a,d,S){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${D} on local port ${_}.`);const p={elevationRequired:a?n(_===void 0?D:_):!1},r={remoteAddress:{host:v,port:D},localAddressPort:_,privacy:d,public:d!==C.Private,protocol:S},s=l.forwardPort(r,p);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),s&&this.addTunnelToMap(v,D,s),s}};f=$e([Ve(0,A.ILogService)],f),e.AbstractTunnelService=f}),define(be[150],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,A,R=5){let C;return C=A(y=>{const P=typeof y=="string"?y:y.data;let t=this._terminalBufferMap.get(E);if(t){t.data.push(P);return}const b=setTimeout(()=>this.flushBuffer(E),R);t={data:[P],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(E),C.dispose()}},this._terminalBufferMap.set(E,t)}),C}stopBuffering(E){const A=this._terminalBufferMap.get(E);A&&A.dispose()}flushBuffer(E){const A=this._terminalBufferMap.get(E);A&&(this._terminalBufferMap.delete(E),this._callback(E,A.data.join("")))}}e.TerminalDataBufferer=c}),define(be[151],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var c;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(c=e.ColorScheme||(e.ColorScheme={}))}),define(be[46],Ee([0,1,34,3,6,4,28,151]),function(re,e,c,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var y;(function(v){function D(_){return _&&typeof _=="object"&&typeof _.id=="string"}v.isThemeColor=D})(y=e.ThemeColor||(e.ThemeColor={}));function P(v){return{id:v}}e.themeColorFromId=P;var t;(function(v){function D(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color=="undefined"||y.isThemeColor(p.color))}v.isThemeIcon=D;const _=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function a(p){const r=_.exec(p);if(!r)return;let[,s]=r;return{id:s}}v.fromString=a;function d(p,r){let s=p.id;const u=s.lastIndexOf("~");return u!==-1&&(s=s.substring(0,u)),r&&(s=`${s}~${r}`),{id:s}}v.modify=d;function S(p,r){return p.id===r.id&&p.color?.id===r.color?.id}v.isEqual=S;function i(p,r){return{id:p.id,color:r?P(r):void 0}}v.asThemeIcon=i,v.asClassNameArray=c.CSSIcon.asClassNameArray,v.asClassName=c.CSSIcon.asClassName,v.asCSSSelector=c.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function b(v){switch(v){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(D){return this.themingParticipants.push(D),this.onThemingParticipantAddedEmitter.fire(D),(0,E.toDisposable)(()=>{const _=this.themingParticipants.indexOf(D);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new n;R.Registry.add(e.Extensions.ThemingContribution,f);function o(v){return f.onColorThemeChange(v)}e.registerThemingParticipant=o;class l extends E.Disposable{constructor(D){super();this.themeService=D,this.theme=D.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(D){this.theme=D,this.updateStyles()}updateStyles(){}getColor(D,_){let a=this.theme.getColor(D);return a&&_&&(a=_(a,this.theme)),a?a.toString():null}}e.Themable=l}),define(be[152],Ee([0,1,14,34,3,123,83,28,46]),function(re,e,c,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(D,_,a,d){const S=this.iconsById[D];if(S){if(a&&!S.description){S.description=a,this.iconSchema.properties[D].markdownDescription=`${a} $(${D})`;const r=this.iconReferenceSchema.enum.indexOf(D);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=a),this._onDidChange.fire()}return S}let i={id:D,description:a,defaults:_,deprecationMessage:d};this.iconsById[D]=i;let p={$ref:"#/definitions/icons"};return d&&(p.deprecationMessage=d),a&&(p.markdownDescription=`${a}: $(${D})`),this.iconSchema.properties[D]=p,this.iconReferenceSchema.enum.push(D),this.iconReferenceSchema.enumDescriptions.push(a||""),this._onDidChange.fire(),{id:D}}deregisterIcon(D){delete this.iconsById[D],delete this.iconSchema.properties[D];const _=this.iconReferenceSchema.enum.indexOf(D);_!==-1&&(this.iconReferenceSchema.enum.splice(_,1),this.iconReferenceSchema.enumDescriptions.splice(_,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(D=>this.iconsById[D])}getIcon(D){return this.iconsById[D]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(D,_){const a=this.iconFontsById[D];if(a)return a;let d={id:D,definition:_};return this.iconFontsById[D]=d,this._onDidChange.fire(),d}deregisterIconFont(D){delete this.iconFontsById[D]}getIconFonts(){return Object.keys(this.iconFontsById).map(D=>this.iconFontsById[D])}getIconFont(D){return this.iconFontsById[D]}toString(){const D=(S,i)=>S.id.localeCompare(i.id),_=S=>{for(;y.ThemeIcon.isThemeIcon(S.defaults);)S=this.iconsById[S.defaults.id];return`codicon codicon-${S?S.id:""}`};let a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.iconsById).map(S=>this.iconsById[S]);for(const S of d.filter(i=>!!i.description).sort(D))a.push(`|<i class="${_(S)}"></i>|${S.id}|${y.ThemeIcon.isThemeIcon(S.defaults)?S.defaults.id:S.id}|${S.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const S of d.filter(i=>!y.ThemeIcon.isThemeIcon(i.defaults)).sort(D))a.push(`|<i class="${_(S)}"></i>|${S.id}|`);return a.join(`
`)}}const t=new P;C.Registry.add(e.Extensions.IconContribution,t);function b(v,D,_,a){return t.registerIcon(v,D,_,a)}e.registerIcon=b;function n(){return t}e.getIconRegistry=n;function f(){for(const v of M.iconRegistry.all)t.registerIcon(v.id,v.definition,v.description);M.iconRegistry.onDidRegister(v=>t.registerIcon(v.id,v.definition,v.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let o=C.Registry.as(R.Extensions.JSONContribution);o.registerSchema(e.iconsSchemaId,t.getIconSchema());const l=new c.RunOnceScheduler(()=>o.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{l.isScheduled()||l.schedule()}),e.widgetClose=b("widget-close",M.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=b("goto-previous-location",M.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=b("goto-next-location",M.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=y.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(be[47],Ee([0,1,20,24,2,4]),function(re,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var R;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(R=e.WorkbenchState||(e.WorkbenchState={}));function C(n){const f=n;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=C;function y(n){const f=n;return!!(f&&typeof f=="object"&&E.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=y;class P{constructor(f,o,l,v,D){this._id=f,this._transient=l,this._configuration=v,this._ignorePathCasing=D,this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(f){this._id=f.id,this._configuration=f.configuration,this._transient=f.transient,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=P;class t{constructor(f,o){this.raw=o,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,M.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function b(n){return new t({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=b}),define(be[63],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(E){this.id=E,this._data=new Map,this._idPool=1}add(E){const A=this._idPool++;return this._data.set(A,E),this.logDebugInfo(),A}get(E,A){return this._data.has(E)?this._data.get(E)[A]:void 0}delete(E){this._data.delete(E),this.logDebugInfo()}logDebugInfo(){!c.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=c,c.enableDebugLogging=!1}),define(be[37],Ee([0,1,11,24,4]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(c.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(C=>{const y=this._providerInfo.get(C.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(C,y){y===null?this._providerInfo.delete(C):this._providerInfo.set(C,y)}isFreeScheme(C){return!this._providerInfo.has(C)&&!this._systemSchemes.has(C)}getCapabilities(C){return this._providerInfo.get(C)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,E.createDecorator)("IExtHostFileSystemInfo")}),define(be[29],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(be[153],Ee([0,1,14]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(R,C,y){this._deferredPromises=new Map,this._id=R,this._shared=C,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new c.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of P.values())t.complete()}catch(t){for(const b of P.values())b.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,C){let y=this._value[R];return typeof y=="undefined"&&(y=C),y}update(R,C){this._value[R]=C;let y=this._deferredPromises.get(R);if(y!==void 0)return y.p;const P=new c.DeferredPromise;return this._deferredPromises.set(R,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class E extends M{constructor(R,C){super(R.identifier.value,!0,C);this._extension=R}setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}}e.ExtensionGlobalMemento=E}),define(be[154],Ee([0,1,3,2,15]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(C,y){this._logService=C,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new c.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new c.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(C,y,P){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C)).acceptModelChanged(y.value,P)}$acceptDirtyStateChanged(C,y){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C)).acceptDirty(y)}$acceptModelSaved(C){const y=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(C,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",C.path,y);const P=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(C));P.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};A=$e([Ve(0,E.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(be[12],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class M{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=M});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Fe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(be[155],Ee([0,1,26,3]),function(re,e,c,M){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(C,y){E.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=c.ExtensionIdentifier.toKey(C.identifier),et(this,E,y,"f"),Fe(this,E,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(C){return Fe(this,E,"f").get(this._id,C)}store(C,y){return Fe(this,E,"f").store(this._id,C,y)}delete(C){return Fe(this,E,"f").delete(this._id,C)}}e.ExtensionSecrets=A,E=new WeakMap}),define(be[87],Ee([0,1,4,3]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class E{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(R){this._enabled=R}$onDidChangeTelemetryEnabled(R){this._enabled=R,this._onDidChangeTelemetryEnabled.fire(R)}}e.ExtHostTelemetry=E,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(be[48],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var c;(function(_){_[_.Upsert=0]="Upsert",_[_.RemoveChild=1]="RemoveChild",_[_.Invalidated=2]="Invalidated",_[_.SetProp=3]="SetProp",_[_.Bulk=4]="Bulk"})(c=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,E=(_,a)=>{const d={controllerId:a};return M.set(_,d),d};e.createPrivateApiFor=E;const A=_=>M.get(_);e.getPrivateApiFor=A;const R=(_,a,d,S)=>{let i=d;return{enumerable:!0,configurable:!1,get(){return i},set(p){if(!S(i,p)){const r=i;i=p,_.listener?.({op:3,key:a,value:p,previous:r})}}}},C=(_,a)=>_===a,y={range:(_,a)=>_===a?!0:!_||!a?!1:_.isEqual(a),label:C,description:C,busy:C,error:C,canResolveChildren:C,tags:(_,a)=>!(_.length!==a.length||_.some(d=>!a.find(S=>d.id===S.id)))},P=Object.keys(y),t=(_,a)=>({range:R(_,"range",void 0,y.range),label:R(_,"label",a,y.label),description:R(_,"description",void 0,y.description),canResolveChildren:R(_,"canResolveChildren",!1,y.canResolveChildren),busy:R(_,"busy",!1,y.busy),error:R(_,"error",void 0,y.error),tags:R(_,"tags",[],y.tags)}),b=(_,a)=>{const d=new Map;for(const S of P)y[S](_[S],a[S])||d.set(S,a[S]);return d};e.diffTestItems=b;class n extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=n;class f extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class o extends Error{constructor(a,d,S){super(`TestItem with ID "${a}" is from controller "${d}" and cannot be added as a child of an item from controller "${S}".`)}}e.MixedTestItemController=o;const l=_=>{const a=(0,e.getPrivateApiFor)(_);let d=new Map;return{get size(){return d.size},forEach(S,i){for(const p of d.values())S.call(i,p,this)},replace(S){const i=new Map,p=new Set(d.keys()),r={op:4,ops:[]};for(const s of S){if(!(s instanceof v))throw new f(s.id);const u=(0,e.getPrivateApiFor)(s).controllerId;if(u!==a.controllerId)throw new o(s.id,u,a.controllerId);if(i.has(s.id))throw new n(s.id);i.set(s.id,s),p.delete(s.id),r.ops.push({op:0,item:s})}for(const s of p.keys())r.ops.push({op:1,id:s});a.listener?.(r),d=i},add(S){if(!(S instanceof v))throw new f(S.id);d.set(S.id,S),a.listener?.({op:0,item:S})},delete(S){d.delete(S)&&a.listener?.({op:1,id:S})},get(S){return d.get(S)},toJSON(){return Array.from(d.values())},[Symbol.iterator](){return d.values()}}};class v{constructor(a,d,S,i){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const p=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return p.parent instanceof D?void 0:p.parent}},children:{value:l(this),enumerable:!0,writable:!1},...t(p,S)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=v;class D extends v{constructor(a,d){super(a,a,d,void 0)}}e.TestItemRootImpl=D}),define(be[64],Ee([0,1,4,149,3,12]),function(re,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var R;(function(y){function P(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?M.TunnelPrivacyId.Public:M.TunnelPrivacyId.Private),protocol:b.protocol}}y.fromApiTunnel=P;function t(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==M.TunnelPrivacyId.ConstantPrivate&&b.privacy!==M.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}y.fromServiceTunnel=t})(R=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let C=class{constructor(P){this.onDidChangeTunnels=new E.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,t){}async getTunnels(){return[]}async setTunnelExtensionFunctions(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,t){return{dispose:()=>{}}}async $providePortAttributes(P,t,b,n,f){return[]}async $forwardPort(P,t){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};C=$e([Ve(0,A.IExtHostRpcService)],C),e.ExtHostTunnelService=C});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Fe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(be[7],Ee([0,1,13,16,76,20,78,10,2,36,60,85]),function(re,e,c,M,E,A,R,C,y,P,t,b){"use strict";var n,f,o,l,v,D,_,a,d,S,i,p,r,s,u,h,m,k,T,g;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function I(N){function O(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(O,N),Object.setPrototypeOf(O.prototype,N.prototype),O}let F=v=class{constructor(O){n.set(this,void 0),et(this,n,O,"f")}static from(...O){let ie=O;return new v(function(){if(ie){for(const _e of ie)_e&&typeof _e.dispose=="function"&&_e.dispose();ie=void 0}})}dispose(){typeof Fe(this,n,"f")=="function"&&(Fe(this,n,"f").call(this),et(this,n,void 0,"f"))}};n=new WeakMap,F=v=$e([I],F),e.Disposable=F;let L=D=class{constructor(O,ie){if(O<0)throw(0,M.illegalArgument)("line must be non-negative");if(ie<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=O,this._character=ie}static Min(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isBefore(ie)&&(ie=Ge)}return ie}static Max(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let _e=1;_e<O.length;_e++){const Ge=O[_e];Ge.isAfter(ie)&&(ie=Ge)}return ie}static isPosition(O){if(!O)return!1;if(O instanceof D)return!0;let{line:ie,character:_e}=O;return typeof ie=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,ie=0){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=0:typeof O=="number"?_e=O:(_e=typeof O.lineDelta=="number"?O.lineDelta:0,ie=typeof O.characterDelta=="number"?O.characterDelta:0),_e===0&&ie===0?this:new D(this.line+_e,this.character+ie)}with(O,ie=this.character){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=this.line:typeof O=="number"?_e=O:(_e=typeof O.line=="number"?O.line:this.line,ie=typeof O.character=="number"?O.character:this.character),_e===this.line&&ie===this.character?this:new D(_e,ie)}toJSON(){return{line:this.line,character:this.character}}};L=D=$e([I],L),e.Position=L;let w=_=class{constructor(O,ie,_e,Ge){let nt,at;if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"?(nt=new L(O,ie),at=new L(_e,Ge)):O instanceof L&&ie instanceof L&&(nt=O,at=ie),!nt||!at)throw new Error("Invalid arguments");nt.isBefore(at)?(this._start=nt,this._end=at):(this._start=at,this._end=nt)}static isRange(O){return O instanceof _?!0:O?L.isPosition(O.start)&&L.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof _?this.contains(O._start)&&this.contains(O._end):O instanceof L?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const ie=L.Max(O.start,this._start),_e=L.Min(O.end,this._end);if(!ie.isAfter(_e))return new _(ie,_e)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const ie=L.Min(O.start,this._start),_e=L.Max(O.end,this.end);return new _(ie,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,ie=this.end){if(O===null||ie===null)throw(0,M.illegalArgument)();let _e;return O?L.isPosition(O)?_e=O:(_e=O.start||this.start,ie=O.end||this.end):_e=this.start,_e.isEqual(this._start)&&ie.isEqual(this.end)?this:new _(_e,ie)}toJSON(){return[this.start,this.end]}};w=_=$e([I],w),e.Range=w;let x=a=class extends w{constructor(O,ie,_e,Ge){let nt,at;if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"?(nt=new L(O,ie),at=new L(_e,Ge)):O instanceof L&&ie instanceof L&&(nt=O,at=ie),!nt||!at)throw new Error("Invalid arguments");super(nt,at);this._anchor=nt,this._active=at}static isSelection(O){return O instanceof a?!0:O?w.isRange(O)&&L.isPosition(O.anchor)&&L.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=a=$e([I],x),e.Selection=x;class W{constructor(O,ie,_e){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,M.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,M.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(ie),this.connectionToken=_e}}e.ResolvedAuthority=W;class B extends Error{constructor(O,ie=b.RemoteAuthorityResolverErrorCode.Unknown,_e){super(O);this._message=O,this._code=ie,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,B.prototype)}static NotAvailable(O,ie){return new B(O,b.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(O){return new B(O,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=B;var G;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(G=e.EndOfLine||(e.EndOfLine={}));var H;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(H=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let U=d=class{constructor(O,ie){this._range=O,this._newText=ie}static isTextEdit(O){return O instanceof d?!0:O?w.isRange(O)&&typeof O.newText=="string":!1}static replace(O,ie){return new d(O,ie)}static insert(O,ie){return d.replace(new w(O,O),ie)}static delete(O){return d.replace(O,"")}static setEndOfLine(O){const ie=new d(new w(new L(0,0),new L(0,0)),"");return ie.newEol=O,ie}get range(){return this._range}set range(O){if(O&&!w.isRange(O))throw(0,M.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,M.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,M.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};U=d=$e([I],U),e.TextEdit=U;var V;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(V=e.FileEditType||(e.FileEditType={}));let Q=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,ie,_e,Ge){this._edits.push({_type:1,from:O,to:ie,options:_e,metadata:Ge})}createFile(O,ie,_e){this._edits.push({_type:1,from:void 0,to:O,options:ie,metadata:_e})}deleteFile(O,ie,_e){this._edits.push({_type:1,from:O,to:void 0,options:ie,metadata:_e})}replaceNotebookMetadata(O,ie,_e){this._edits.push({_type:3,metadata:_e,uri:O,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(O,ie,_e,Ge,nt){let at,ct,Ct=[],At;if(zt.isNotebookRange(ie)&&Mt.isNotebookCellDataArray(_e)&&!Mt.isNotebookCellDataArray(Ge)?(at=ie.start,ct=ie.end,Ct=_e,At=Ge):typeof ie=="number"&&typeof _e=="number"&&Mt.isNotebookCellDataArray(Ge)&&(at=ie,ct=_e,Ct=Ge,At=nt),at===void 0||ct===void 0)throw new Error("Invalid arguments");(at!==ct||Ct.length>0)&&this._edits.push({_type:5,uri:O,index:at,count:ct-at,cells:Ct,metadata:At})}replaceNotebookCellMetadata(O,ie,_e,Ge){this._edits.push({_type:3,metadata:Ge,uri:O,edit:{editType:8,index:ie,metadata:_e}})}replace(O,ie,_e,Ge){this._edits.push({_type:2,uri:O,edit:new U(ie,_e),metadata:Ge})}insert(O,ie,_e,Ge){this.replace(O,new w(ie,ie),_e,Ge)}delete(O,ie,_e){this.replace(O,ie,"",_e)}has(O){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===O.toString())}set(O,ie){if(ie)for(const _e of ie)_e&&this._edits.push({_type:2,uri:O,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ge=this._edits[_e];Ge._type===2&&Ge.uri.toString()===O.toString()&&(this._edits[_e]=void 0)}(0,c.coalesceInPlace)(this._edits)}}get(O){const ie=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===O.toString()&&ie.push(_e.edit);return ie}entries(){const O=new A.ResourceMap;for(let ie of this._edits)if(ie._type===2){let _e=O.get(ie.uri);_e||(_e=[ie.uri,[]],O.set(ie.uri,_e)),_e[1].push(ie.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Q=$e([I],Q),e.WorkspaceEdit=Q;let ne=S=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof S?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=S._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,ie=this._tabstop++){if(typeof O=="function"){const _e=new S;_e._tabstop=this._tabstop,O(_e),this._tabstop=_e._tabstop,O=_e.value}else O=S._escape(O);return this.value+="${",this.value+=ie,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,ie=this._tabstop++){const _e=O.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(O,ie){if(typeof ie=="function"){const _e=new S;_e._tabstop=this._tabstop,ie(_e),this._tabstop=_e._tabstop,ie=_e.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};ne=S=$e([I],ne),e.SnippetString=ne;var ce;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(ce=e.DiagnosticTag||(e.DiagnosticTag={}));var Z;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(Z=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=i=class{constructor(O,ie){if(this.uri=O,ie)if(ie instanceof w)this.range=ie;else if(ie instanceof L)this.range=new w(ie,ie);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof i?!0:O?w.isRange(O.range)&&y.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};oe=i=$e([I],oe),e.Location=oe;let ve=class{constructor(O,ie){this.location=O,this.message=ie}static is(O){return O?typeof O.message=="string"&&O.location&&w.isRange(O.location.range)&&y.URI.isUri(O.location.uri):!1}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.location.range.isEqual(ie.location.range)&&O.location.uri.toString()===ie.location.uri.toString()}};ve=$e([I],ve),e.DiagnosticRelatedInformation=ve;let Ae=class{constructor(O,ie,_e=Z.Error){if(!w.isRange(O))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=O,this.message=ie,this.severity=_e}toJSON(){return{severity:Z[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.severity===ie.severity&&O.code===ie.code&&O.severity===ie.severity&&O.source===ie.source&&O.range.isEqual(ie.range)&&(0,c.equals)(O.tags,ie.tags)&&(0,c.equals)(O.relatedInformation,ie.relatedInformation,ve.isEqual)}};Ae=$e([I],Ae),e.Diagnostic=Ae;let Se=class{constructor(O,ie){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=ie}};Se=$e([I],Se),e.Hover=Se;var Ne;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Ne=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let We=class{constructor(O,ie=Ne.Text){this.range=O,this.kind=ie}toJSON(){return{range:this.range,kind:Ne[this.kind]}}};We=$e([I],We),e.DocumentHighlight=We;var je;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(je=e.SymbolKind||(e.SymbolKind={}));var qe;(function(N){N[N.Deprecated=1]="Deprecated"})(qe=e.SymbolTag||(e.SymbolTag={}));let $=p=class{constructor(O,ie,_e,Ge,nt){this.name=O,this.kind=ie,this.containerName=nt,typeof _e=="string"&&(this.containerName=_e),Ge instanceof oe?this.location=Ge:_e instanceof w&&(this.location=new oe(Ge,_e)),p.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:je[this.kind],location:this.location,containerName:this.containerName}}};$=p=$e([I],$),e.SymbolInformation=$;let K=r=class{constructor(O,ie,_e,Ge,nt){this.name=O,this.detail=ie,this.kind=_e,this.range=Ge,this.selectionRange=nt,this.children=[],r.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(r.validate)}};K=r=$e([I],K),e.DocumentSymbol=K;var ee;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(O,ie){this.title=O,this.kind=ie}};ae=$e([I],ae),e.CodeAction=ae;let q=s=class{constructor(O){this.value=O}append(O){return new s(this.value?this.value+s.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+s.sep)}};q.sep=".",q=s=$e([I],q),e.CodeActionKind=q,q.Empty=new q(""),q.QuickFix=q.Empty.append("quickfix"),q.Refactor=q.Empty.append("refactor"),q.RefactorExtract=q.Refactor.append("extract"),q.RefactorInline=q.Refactor.append("inline"),q.RefactorRewrite=q.Refactor.append("rewrite"),q.Source=q.Empty.append("source"),q.SourceOrganizeImports=q.Source.append("organizeImports"),q.SourceFixAll=q.Source.append("fixAll");let se=class{constructor(O,ie){if(this.range=O,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};se=$e([I],se),e.SelectionRange=se;class he{constructor(O,ie,_e,Ge,nt,at){this.kind=O,this.name=ie,this.detail=_e,this.uri=Ge,this.range=nt,this.selectionRange=at}}e.CallHierarchyItem=he;class Re{constructor(O,ie){this.fromRanges=ie,this.from=O}}e.CallHierarchyIncomingCall=Re;class Be{constructor(O,ie){this.fromRanges=ie,this.to=O}}e.CallHierarchyOutgoingCall=Be;var ze;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Qe=class{constructor(O,ie){this.range=O,this.command=ie}get isResolved(){return!!this.command}};Qe=$e([I],Qe),e.CodeLens=Qe;let it=u=class{constructor(O,ie=!1){f.set(this,void 0),et(this,f,new E.MarkdownString(O,{supportThemeIcons:ie}),"f")}static isMarkdownString(O){return O instanceof u?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Fe(this,f,"f").value}set value(O){Fe(this,f,"f").value=O}get isTrusted(){return Fe(this,f,"f").isTrusted}set isTrusted(O){Fe(this,f,"f").isTrusted=O}get supportThemeIcons(){return Fe(this,f,"f").supportThemeIcons}set supportThemeIcons(O){Fe(this,f,"f").supportThemeIcons=O}get supportHtml(){return Fe(this,f,"f").supportHtml}set supportHtml(O){Fe(this,f,"f").supportHtml=O}appendText(O){return Fe(this,f,"f").appendText(O),this}appendMarkdown(O){return Fe(this,f,"f").appendMarkdown(O),this}appendCodeblock(O,ie){return Fe(this,f,"f").appendCodeblock(ie??"",O),this}};f=new WeakMap,it=u=$e([I],it),e.MarkdownString=it;let ke=class{constructor(O,ie){this.label=O,this.documentation=ie}};ke=$e([I],ke),e.ParameterInformation=ke;let Ze=class{constructor(O,ie){this.label=O,this.documentation=ie,this.parameters=[]}};Ze=$e([I],Ze),e.SignatureInformation=Ze;let j=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};j=$e([I],j),e.SignatureHelp=j;var J;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(J=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var me;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(me=e.InlayHintKind||(e.InlayHintKind={}));let He=class{constructor(O,ie,_e){this.text=O,this.position=ie,this.kind=_e}};He=$e([I],He),e.InlayHint=He;var Ye;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var st;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(st=e.CompletionItemKind||(e.CompletionItemKind={}));var ot;(function(N){N[N.Deprecated=1]="Deprecated"})(ot=e.CompletionItemTag||(e.CompletionItemTag={}));let Et=class{constructor(O,ie){this.label=O,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&st[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Et=$e([I],Et),e.CompletionItem=Et;let mt=class{constructor(O=[],ie=!1){this.items=O,this.isIncomplete=ie}};mt=$e([I],mt),e.CompletionList=mt;let Dt=class{constructor(O,ie,_e){this.text=O,this.range=ie,this.command=_e}};Dt=$e([I],Dt),e.InlineSuggestion=Dt;let Pt=class{constructor(O){this.items=O}};Pt=$e([I],Pt),e.InlineSuggestions=Pt;var It;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(It=e.ViewColumn||(e.ViewColumn={}));var Xe;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Xe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var St;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(St=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Te;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Te=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ce;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var te;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(te=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var le;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(le=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function O(ie){switch(ie){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=O}(Ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ge=class{constructor(O,ie){if(ie&&!y.URI.isUri(ie))throw(0,M.illegalArgument)("target");if(!w.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.target=ie}};ge=$e([I],ge),e.DocumentLink=ge;let fe=class{constructor(O,ie,_e,Ge){this.red=O,this.green=ie,this.blue=_e,this.alpha=Ge}};fe=$e([I],fe),e.Color=fe;let Pe=class{constructor(O,ie){if(ie&&!(ie instanceof fe))throw(0,M.illegalArgument)("color");if(!w.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.color=ie}};Pe=$e([I],Pe),e.ColorInformation=Pe;let xe=class{constructor(O){if(!O||typeof O!="string")throw(0,M.illegalArgument)("label");this.label=O}};xe=$e([I],xe),e.ColorPresentation=xe;var Oe;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Oe=e.ColorFormat||(e.ColorFormat={}));var Ke;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(Ke=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class tt{constructor(O,ie,_e){if(this.startIndex=O,this.length=ie,this.tooltip=_e,typeof O!="number"||O<0)throw(0,M.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,M.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=tt;var Le;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(Le=e.TerminalLocation||(e.TerminalLocation={}));class de{constructor(O){this.options=O,typeof O!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=de;var pe;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(pe=e.TaskRevealKind||(e.TaskRevealKind={}));var Y;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(Y=e.TaskPanelKind||(e.TaskPanelKind={}));let z=h=class{constructor(O,ie){if(this.label=ie,typeof O!="string"||typeof ie!="string")throw(0,M.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}get id(){return this._id}};z.Clean=new h("clean","Clean"),z.Build=new h("build","Build"),z.Rebuild=new h("rebuild","Rebuild"),z.Test=new h("test","Test"),z=h=$e([I],z),e.TaskGroup=z;function we(N){let O="";for(let ie=0;ie<N.length;ie++)O+=N[ie].replace(/,/g,",,")+",";return O}let Ie=class{constructor(O,ie,_e){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=O,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=_e):this._options=ie)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let ie of this._args)O.push(ie);return we(O)}};Ie=$e([I],Ie),e.ProcessExecution=Ie;let Je=class{constructor(O,ie,_e){if(this._args=[],Array.isArray(ie)){if(!O)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O,this._args=ie,this._options=_e}else{if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ie of this._args)O.push(typeof ie=="string"?ie:ie.value);return we(O)}};Je=$e([I],Je),e.ShellExecution=Je;var Ue;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(Ue=e.ShellQuoting||(e.ShellQuoting={}));var dt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(dt=e.TaskScope||(e.TaskScope={}));class gt{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=gt;let lt=m=class{constructor(O,ie,_e,Ge,nt,at){this.__deprecated=!1,this._definition=this.definition=O;let ct;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=_e,this.execution=Ge,ct=nt,this.__deprecated=!0):ie===dt.Global||ie===dt.Workspace?(this.target=ie,this._name=this.name=_e,this._source=this.source=Ge,this.execution=nt,ct=at):(this.target=ie,this._name=this.name=_e,this._source=this.source=Ge,this.execution=nt,ct=at),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ie?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof Je?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof gt?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const ie=this._definition.type;(m.EmptyType===ie||m.ProcessType===ie||m.ShellType===ie||m.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};lt.ExtensionCallbackType="customExecution",lt.ProcessType="process",lt.ShellType="shell",lt.EmptyType="$empty",lt=m=$e([I],lt),e.Task=lt;var ft;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let ut=class{constructor(O,ie=pt.None){this.collapsibleState=ie,y.URI.isUri(O)?this.resourceUri=O:this.label=O}};ut=$e([I],ut),e.TreeItem=ut;var pt;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(pt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let bt=class{constructor(O,ie){this.id=O,this.color=ie}};bt=$e([I],bt),e.ThemeIcon=bt,bt.File=new bt("file"),bt.Folder=new bt("folder");let Ut=class{constructor(O){this.id=O}};Ut=$e([I],Ut),e.ThemeColor=Ut;var Vt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(Vt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let yt=class{constructor(O,ie){if(typeof O!="string"&&(!O||!y.URI.isUri(O)&&!y.URI.isUri(O.uri)))throw(0,M.illegalArgument)("base");if(typeof ie!="string")throw(0,M.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=y.URI.file(O),this.base=O):y.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=ie}};yt=$e([I],yt),e.RelativePattern=yt;let $t=class{constructor(O,ie,_e,Ge){this.enabled=typeof O=="boolean"?O:!0,typeof ie=="string"&&(this.condition=ie),typeof _e=="string"&&(this.hitCondition=_e),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};$t=$e([I],$t),e.Breakpoint=$t;let ei=class extends $t{constructor(O,ie,_e,Ge,nt){super(ie,_e,Ge,nt);if(O===null)throw(0,M.illegalArgument)("location");this.location=O}};ei=$e([I],ei),e.SourceBreakpoint=ei;let vt=class extends $t{constructor(O,ie,_e,Ge,nt){super(ie,_e,Ge,nt);this.functionName=O}};vt=$e([I],vt),e.FunctionBreakpoint=vt;let Qt=class extends $t{constructor(O,ie,_e,Ge,nt,at,ct){super(Ge,nt,at,ct);if(!ie)throw(0,M.illegalArgument)("dataId");this.label=O,this.dataId=ie,this.canPersist=_e}};Qt=$e([I],Qt),e.DataBreakpoint=Qt;let jt=class{constructor(O,ie,_e){this.command=O,this.args=ie||[],this.options=_e}};jt=$e([I],jt),e.DebugAdapterExecutable=jt;let ti=class{constructor(O,ie){this.port=O,this.host=ie}};ti=$e([I],ti),e.DebugAdapterServer=ti;let ii=class{constructor(O){this.path=O}};ii=$e([I],ii),e.DebugAdapterNamedPipeServer=ii;let Tt=class{constructor(O){this.implementation=O}};Tt=$e([I],Tt),e.DebugAdapterInlineImplementation=Tt;let Yt=class{constructor(O,ie){this.range=O,this.expression=ie}};Yt=$e([I],Yt),e.EvaluatableExpression=Yt;var wi;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(wi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(O,ie){this.range=O,this.text=ie}};Wt=$e([I],Wt),e.InlineValueText=Wt;let Ht=class{constructor(O,ie,_e=!0){this.range=O,this.variableName=ie,this.caseSensitiveLookup=_e}};Ht=$e([I],Ht),e.InlineValueVariableLookup=Ht;let ht=class{constructor(O,ie){this.range=O,this.expression=ie}};ht=$e([I],ht),e.InlineValueEvaluatableExpression=ht;let ni=class{constructor(O,ie){this.frameId=O,this.stoppedLocation=ie}};ni=$e([I],ni),e.InlineValueContext=ni;var Ot;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=k=class extends Error{constructor(O,ie=t.FileSystemProviderErrorCode.Unknown,_e){super(y.URI.isUri(O)?O.toString(!0):O);this.code=_e?.name??"Unknown",(0,t.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(O){return new k(O,t.FileSystemProviderErrorCode.FileExists,k.FileExists)}static FileNotFound(O){return new k(O,t.FileSystemProviderErrorCode.FileNotFound,k.FileNotFound)}static FileNotADirectory(O){return new k(O,t.FileSystemProviderErrorCode.FileNotADirectory,k.FileNotADirectory)}static FileIsADirectory(O){return new k(O,t.FileSystemProviderErrorCode.FileIsADirectory,k.FileIsADirectory)}static NoPermissions(O){return new k(O,t.FileSystemProviderErrorCode.NoPermissions,k.NoPermissions)}static Unavailable(O){return new k(O,t.FileSystemProviderErrorCode.Unavailable,k.Unavailable)}};Nt=k=$e([I],Nt),e.FileSystemError=Nt;let Jt=class{constructor(O,ie,_e){this.start=O,this.end=ie,this.kind=_e}};Jt=$e([I],Jt),e.FoldingRange=Jt;var bi;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hi;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(hi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ei;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(Ei=e.CommentMode||(e.CommentMode={}));class fi{constructor(O,ie=[]){this.tokenTypes=O,this.tokenModifiers=ie}}e.SemanticTokensLegend=fi;function ri(N){return typeof N=="undefined"||(0,C.isStringArray)(N)}class si{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let ie=0,_e=O.tokenTypes.length;ie<_e;ie++)this._tokenTypeStrToInt.set(O.tokenTypes[ie],ie);for(let ie=0,_e=O.tokenModifiers.length;ie<_e;ie++)this._tokenModifierStrToInt.set(O.tokenModifiers[ie],ie)}}push(O,ie,_e,Ge,nt){if(typeof O=="number"&&typeof ie=="number"&&typeof _e=="number"&&typeof Ge=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(O,ie,_e,Ge,nt);if(w.isRange(O)&&typeof ie=="string"&&ri(_e))return this._push(O,ie,_e);throw(0,M.illegalArgument)()}_push(O,ie,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ge=O.start.line,nt=O.start.character,at=O.end.character-O.start.character,ct=this._tokenTypeStrToInt.get(ie);let Ct=0;if(_e)for(const At of _e){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(At);Ct|=1<<Ft>>>0}this._pushEncoded(Ge,nt,at,ct,Ct)}_pushEncoded(O,ie,_e,Ge,nt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ct=this._data.length/5|0;let At=0,Ft=0;for(let Lt=0;Lt<Ct;Lt++){let xt=this._data[5*Lt],ci=this._data[5*Lt+1];xt===0?(xt=At,ci+=Ft):xt+=At,this._data[5*Lt]=xt,this._data[5*Lt+1]=ci,At=xt,Ft=ci}}let at=O,ct=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=nt,this._prevLine=O,this._prevChar=ie}static _sortAndDeltaEncode(O){let ie=[];const _e=O.length/5|0;for(let ct=0;ct<_e;ct++)ie[ct]=ct;ie.sort((ct,Ct)=>{const At=O[5*ct],Ft=O[5*Ct];if(At===Ft){const Lt=O[5*ct+1],xt=O[5*Ct+1];return Lt-xt}return At-Ft});const Ge=new Uint32Array(O.length);let nt=0,at=0;for(let ct=0;ct<_e;ct++){const Ct=5*ie[ct],At=O[Ct+0],Ft=O[Ct+1],Lt=O[Ct+2],xt=O[Ct+3],ci=O[Ct+4],xi=At-nt,qi=xi===0?Ft-at:Ft,di=5*ct;Ge[di+0]=xi,Ge[di+1]=qi,Ge[di+2]=Lt,Ge[di+3]=xt,Ge[di+4]=ci,nt=At,at=Ft}return Ge}build(O){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),O):new qt(si._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=si;class qt{constructor(O,ie){this.resultId=ie,this.data=O}}e.SemanticTokens=qt;class oi{constructor(O,ie,_e){this.start=O,this.deleteCount=ie,this.data=_e}}e.SemanticTokensEdit=oi;class _i{constructor(O,ie){this.resultId=ie,this.edits=O}}e.SemanticTokensEdits=_i;var yi;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(yi=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new bt("arrow-left")},Xt=$e([I],Xt),e.QuickInputButtons=Xt;var Si;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(O,ie,_e){this.badge=O,this.tooltip=ie,this.color=_e}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Di;let ai=class{constructor(O){this.kind=O}};ai=$e([I],ai),e.ColorTheme=ai;var li;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(li=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(O,ie){if(O<0)throw(0,M.illegalArgument)("start must be positive");if(ie<0)throw(0,M.illegalArgument)("end must be positive");O<=ie?(this._start=O,this._end=ie):(this._start=ie,this._end=O)}static isNotebookRange(O){return O instanceof zt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let ie=this._start,_e=this._end;return O.start!==void 0&&(ie=O.start),O.end!==void 0&&(_e=O.end),ie===this._start&&_e===this._end?this:new zt(ie,_e)}}e.NotebookRange=zt;class Mt{constructor(O,ie,_e,Ge,nt,at,ct){this.kind=O,this.value=ie,this.languageId=_e,this.mime=Ge,this.outputs=nt??[],this.metadata=at,this.executionSummary=ct,Mt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(ie=>Mt.isNotebookCellData(ie))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Mt;class Me{constructor(O){this.cells=O}}e.NotebookData=Me;class Rt{constructor(O,ie){this.data=O,this.mime=ie;const _e=(0,R.normalizeMimeType)(ie,!0);if(!_e)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(O){return O instanceof Rt?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const ie={name:O.name,message:O.message,stack:O.stack};return Rt.json(ie,"application/vnd.code.notebook.error")}static stdout(O){return Rt.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Rt.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,ie="application/octet-stream"){return new Rt(O,ie)}static text(O,ie=R.Mimes.text){const _e=Fe(Rt,o,"f",l).encode(String(O));return new Rt(_e,ie)}static json(O,ie="application/json"){const _e=JSON.stringify(O,void 0,"	");return Rt.text(_e,ie)}}e.NotebookCellOutputItem=Rt,o=Rt,l={value:new TextEncoder};class Kt{constructor(O,ie,_e){this.items=Kt.ensureUniqueMimeTypes(O,!0),typeof ie=="string"?(this.id=ie,this.metadata=_e):(this.id=(0,P.generateUuid)(),this.metadata=ie??_e)}static isNotebookCellOutput(O){return O instanceof Kt?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,C.isArray)(O.items)}static ensureUniqueMimeTypes(O,ie=!1){const _e=new Set,Ge=new Set;for(let nt=0;nt<O.length;nt++){const at=O[nt],ct=(0,R.normalizeMimeType)(at.mime);if(!_e.has(ct)){_e.add(ct);continue}Ge.add(nt),ie&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?O:O.filter((nt,at)=>!Ge.has(at))}}e.NotebookCellOutput=Kt;var wt;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(wt=e.NotebookCellKind||(e.NotebookCellKind={}));var Ci;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Ci=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ki;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(ki=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mi;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(mi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class gi{constructor(O,ie){this.text=O,this.alignment=ie}}e.NotebookCellStatusBarItem=gi;var Ii;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Ii=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pi{constructor(O,ie=[]){this.uri=O,this.provides=(0,c.asArray)(ie)}}e.NotebookRendererScript=Pi;let ui=class{constructor(O,ie){this.label=O,this.timestamp=ie}};ui=$e([I],ui),e.TimelineItem=ui;var Ti;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Ti=e.ExtensionMode||(e.ExtensionMode={}));var pi;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(pi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ai;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Ai=e.StandardTokenType||(e.StandardTokenType={}));class Ri{constructor(O,ie){this.ranges=O,this.wordPattern=ie}}e.LinkedEditingRanges=Ri;class Fi{constructor(O,ie){this._port=O,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Li;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let X=class{constructor(O,ie,_e){this.include=O,this.exclude=ie,this.profile=_e}};X=$e([I],X),e.TestRunRequest=X;let ue=T=class{constructor(O){this.message=O}static diff(O,ie,_e){const Ge=new T(O);return Ge.expectedOutput=ie,Ge.actualOutput=_e,Ge}};ue=T=$e([I],ue),e.TestMessage=ue;let De=class{constructor(O){this.id=O}};De=$e([I],De),e.TestTag=De;let rt=class{constructor(O,ie){this.covered=O,this.total=ie}};rt=$e([I],rt),e.CoveredCount=rt;let _t=g=class{constructor(O,ie,_e,Ge){this.uri=O,this.statementCoverage=ie,this.branchCoverage=_e,this.functionCoverage=Ge}static fromDetails(O,ie){const _e=new rt(0,0),Ge=new rt(0,0),nt=new rt(0,0);for(const ct of ie)if("branches"in ct){_e.total+=1,_e.covered+=ct.executionCount>0?1:0;for(const Ct of ct.branches)Ge.total+=1,Ge.covered+=Ct.executionCount>0?1:0}else nt.total+=1,nt.covered+=ct.executionCount>0?1:0;const at=new g(O,_e,Ge.total>0?Ge:void 0,nt.total>0?nt:void 0);return at.detailedCoverage=ie,at}};_t=g=$e([I],_t),e.FileCoverage=_t;let kt=class{constructor(O,ie,_e=[]){this.executionCount=O,this.location=ie,this.branches=_e}};kt=$e([I],kt),e.StatementCoverage=kt;let Oi=class{constructor(O,ie){this.executionCount=O,this.location=ie}};Oi=$e([I],Oi),e.BranchCoverage=Oi;let Ni=class{constructor(O,ie){this.executionCount=O,this.location=ie}};Ni=$e([I],Ni),e.FunctionCoverage=Ni;var Hi;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zi;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(zi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vi;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ji{constructor(O,ie,_e,Ge,nt,at){this.kind=O,this.name=ie,this.detail=_e,this.uri=Ge,this.range=nt,this.selectionRange=at}}e.TypeHierarchyItem=ji}),define(be[88],Ee([0,1,42,11,9,228,118,7,13]),function(re,e,c,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function t(o,l){l?P.set(o,l):P.delete(o)}e.setWordDefinitionFor=t;function b(o){return P.get(o)}e.getWordDefinitionFor=b;class n extends A.MirrorTextModel{constructor(l,v,D,_,a,d,S,i){super(v,D,_,a);this._proxy=l,this._languageId=d,this._isDirty=S,this._notebook=i,this._isDisposed=!1}dispose(){(0,c.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(l){return(0,y.equals)(this._lines,l)}get document(){if(!this._document){const l=this;this._document={get uri(){return l._uri},get fileName(){return l._uri.fsPath},get isUntitled(){return l._uri.scheme===M.Schemas.untitled},get languageId(){return l._languageId},get version(){return l._versionId},get isClosed(){return l._isDisposed},get isDirty(){return l._isDirty},get notebook(){return l._notebook},save(){return l._save()},getText(v){return v?l._getTextInRange(v):l.getText()},get eol(){return l._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return l._lines.length},lineAt(v){return l._lineAt(v)},offsetAt(v){return l._offsetAt(v)},positionAt(v){return l._positionAt(v)},validateRange(v){return l._validateRange(v)},validatePosition(v){return l._validatePosition(v)},getWordRangeAtPosition(v,D){return l._getWordRangeAtPosition(v,D)}}}return Object.freeze(this._document)}_acceptLanguageId(l){(0,c.ok)(!this._isDisposed),this._languageId=l}_acceptIsDirty(l){(0,c.ok)(!this._isDisposed),this._isDirty=l}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(l){const v=this._validateRange(l);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const D=this._eol,_=v.start.line,a=v.end.line,d=[];d.push(this._lines[_].substring(v.start.character));for(let S=_+1;S<a;S++)d.push(this._lines[S]);return d.push(this._lines[a].substring(0,v.end.character)),d.join(D)}_lineAt(l){let v;if(l instanceof C.Position?v=l.line:typeof l=="number"&&(v=l),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new f(v,this._lines[v],v===this._lines.length-1)}_offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getPrefixSum(l.line-1)+l.character}_positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(l),D=this._lines[v.index].length;return new C.Position(v.index,Math.min(v.remainder,D))}_validateRange(l){if(!(l instanceof C.Range))throw new Error("Invalid argument");const v=this._validatePosition(l.start),D=this._validatePosition(l.end);return v===l.start&&D===l.end?l:new C.Range(v.line,v.character,D.line,D.character)}_validatePosition(l){if(!(l instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return l.with(0,0);let{line:v,character:D}=l,_=!1;if(v<0)v=0,D=0,_=!0;else if(v>=this._lines.length)v=this._lines.length-1,D=this._lines[v].length,_=!0;else{const a=this._lines[v].length;D<0?(D=0,_=!0):D>a&&(D=a,_=!0)}return _?new C.Position(v,D):l}_getWordRangeAtPosition(l,v){const D=this._validatePosition(l);if(!v)v=b(this._languageId);else if((0,E.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const _=(0,R.getWordAtText)(D.character+1,(0,R.ensureValidWordDefinition)(v),this._lines[D.line],0);if(_)return new C.Range(D.line,_.startColumn-1,D.line,_.endColumn-1)}}e.ExtHostDocumentData=n;class f{constructor(l,v,D){this._line=l,this._text=v,this._isLastLine=D}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(be[156],Ee([0,1,7,3,229,6,55,20,2,36]),function(re,e,c,M,E,A,R,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,f,o,l){this._notebook=o,this._selector=l,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(D=>{const _=this._cellUris.get(D.document.uri);_!==void 0&&(this._cellLengths.changeValue(_,this._cells[_].document.getText().length+1),this._cellLines.changeValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=D=>{D===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(D=>v(D.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const n=[],f=[];for(const o of this._notebook.getCells())o.kind===c.NotebookCellKind.Code&&(!this._selector||(0,R.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),n.push(o.document.getText().length+1),f.push(o.document.lineCount));this._cellLengths=new E.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new E.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(n){if(!n){let _="";for(const a of this._cells)_+=a.document.getText()+`
`;return _=_.slice(0,-1),_}if(n.isEmpty)return"";const f=this.locationAt(n.start),o=this.locationAt(n.end),l=this._cellUris.get(f.uri),v=this._cellUris.get(o.uri);if(l===void 0||v===void 0)return"";if(l===v)return this._cells[l].document.getText(new c.Range(f.range.start,o.range.end));const D=[this._cells[l].document.getText(new c.Range(f.range.start,new c.Position(this._cells[l].document.lineCount,0)))];for(let _=l+1;_<v;_++)D.push(this._cells[_].document.getText());return D.push(this._cells[v].document.getText(new c.Range(new c.Position(0,0),o.range.end))),D.join(`
`)}offsetAt(n){const f=this._cellLines.getIndexOf(n.line),o=this._cellLengths.getPrefixSum(f.index-1),l=this._cells[f.index].document.offsetAt(n.with(f.remainder));return o+l}positionAt(n){if(typeof n=="number"){const o=this._cellLengths.getIndexOf(n),l=this._cellLines.getPrefixSum(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(l)}const f=this._cellUris.get(n.uri);if(f!==void 0){const o=this._cellLines.getPrefixSum(f-1);return new c.Position(o+n.range.start.line,n.range.start.character)}return new c.Position(0,0)}locationAt(n){c.Range.isRange(n)||(n=new c.Range(n,n));const f=this._cellLines.getIndexOf(n.start.line);let o=f;n.isEmpty||(o=this._cellLines.getIndexOf(n.end.line));const l=new c.Position(f.remainder,n.start.character),v=new c.Position(o.remainder,n.end.character),D=new c.Range(l,v),_=this._cells[f.index];return new c.Location(_.document.uri,_.document.validateRange(D))}contains(n){return this._cellUris.has(n)}validateRange(n){const f=this.validatePosition(n.start),o=this.validatePosition(n.end);return n.with(f,o)}validatePosition(n){const f=this._cellLines.getIndexOf(n.line),o=new c.Position(f.remainder,n.character),l=this._cells[f.index].document.validatePosition(o),v=this._cellLines.getPrefixSum(f.index-1);return new c.Position(v+l.line,l.character)}}e.ExtHostNotebookConcatDocument=t}),define(be[157],Ee([0,1,7,12,3]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(C){this._actual=new c.ColorTheme(c.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new E.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let y=C==="light"?c.ColorThemeKind.Light:C==="dark"?c.ColorThemeKind.Dark:c.ColorThemeKind.HighContrast;this._actual=new c.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=$e([Ve(0,M.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(be[65],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class M{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=M}),define(be[158],Ee([0,1,22]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(y){let P=this.buffers.indexOf(y);return P<0&&(P=this.buffers.length,this.buffers.push(y)),P}}function E(C,y){if(y.serializeBuffersForPostMessage){const P=new M,t=(f,o)=>{if(o instanceof ArrayBuffer){const l=P.add(o);return{$$vscode_array_buffer_reference$$:!0,index:l}}else if(ArrayBuffer.isView(o)){const l=A(o);if(l){const v=P.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:l,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},b=JSON.stringify(C,t),n=P.buffers.map(f=>{const o=new Uint8Array(f);return c.VSBuffer.wrap(o)});return{message:b,buffers:n}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=E;function A(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(C,y){const P=y.map(n=>{const f=new ArrayBuffer(n.byteLength);return new Uint8Array(f).set(n.buffer),f}),t=y.length?(n,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const o=f,{index:l}=o,v=P[l];if(o.view)switch(o.view.type){case 1:return new Int8Array(v,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return f}:void 0;return{message:JSON.parse(C,t),arrayBuffers:P}}e.deserializeWebviewMessage=R}),define(be[159],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var c;(function(M){function E(R){const C={items:new Map};return R.types.forEach((y,P)=>{C.items.set(y,{asString:async()=>R.items[P].asString})}),C}M.toITreeDataTransfer=E;async function A(R){const C={types:[],items:[]},y=Array.from(R.items.entries());for(const P of y)C.types.push(P[0]),C.items.push({asString:await P[1].asString()});return C}M.toTreeDataTransferDTO=A})(c=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[66],Ee([0,1,11,2]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function E(C,y){return C.scheme===c.Schemas.http||C.scheme===c.Schemas.https?C:(y&&y.authority&&y.isRemote&&C.scheme===c.Schemas.file&&(C=M.URI.from({scheme:c.Schemas.vscodeRemote,authority:y.authority,path:C.path})),M.URI.from({scheme:c.Schemas.https,authority:`${C.scheme}+${A(C.authority)}.${e.webviewRootResourceAuthority}`,path:C.path,fragment:C.fragment,query:C.query}))}e.asWebviewUri=E;function A(C){return C.replace(/./g,y=>{const P=y.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?y:"-"+P.toString(16).padStart(4,"0")})}function R(C){return C.replace(/-([0-9a-f]{4})/g,(y,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=R}),define(be[160],Ee([0,1,3,6,66]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(C,y,P){this._proxy=C,this._editors=y,this._initData=P,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const t=y.getVisibleTextEditors();for(const b of this._insets.values())t.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,y,P,t,b){let n;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===C){n=a;break}if(!n)throw new Error("not a visible editor");const f=this,o=this._handlePool++,l=new c.Emitter,v=new c.Emitter,D=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,E.asWebviewUri)(a,f._initData.remote)}get cspSource(){return E.webviewGenericCspSource}set options(a){this._options=a,f._proxy.$setOptions(o,a)}get options(){return this._options}set html(a){this._html=a,f._proxy.$setHtml(o,a)}get html(){return this._html}get onDidReceiveMessage(){return l.event}postMessage(a){return f._proxy.$postMessage(o,a)}},_=new class{constructor(){this.editor=C,this.line=y,this.height=P,this.webview=D,this.onDidDispose=v.event}dispose(){f._insets.has(o)&&(f._insets.delete(o),f._proxy.$disposeEditorInset(o),v.fire(),v.dispose(),l.dispose())}};return this._proxy.$createEditorInset(o,n.id,n.value.document.uri,y+1,P,t||{},b.identifier,b.extensionLocation),this._insets.set(o,{editor:C,inset:_,onDidReceiveMessage:l}),_}$onDidDispose(C){const y=this._insets.get(C);y&&y.inset.dispose()}$onDidReceiveMessage(C,y){const P=this._insets.get(C);P&&P.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=A}),define(be[161],Ee([0,1,131,10,2,6,4,45,28,13,11]),function(re,e,c,M,E,A,R,C,y,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.ActiveEditorDirtyContext=new C.RawContextKey("activeEditorIsDirty",!1,(0,c.localize)(2,null)),e.ActiveEditorPinnedContext=new C.RawContextKey("activeEditorIsNotPreview",!1,(0,c.localize)(3,null)),e.ActiveEditorStickyContext=new C.RawContextKey("activeEditorIsPinned",!1,(0,c.localize)(4,null)),e.ActiveEditorReadonlyContext=new C.RawContextKey("activeEditorIsReadonly",!1,(0,c.localize)(5,null)),e.ActiveEditorCanRevertContext=new C.RawContextKey("activeEditorCanRevert",!1,(0,c.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new C.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new C.RawContextKey("activeEditor",null,{type:"string",description:(0,c.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new C.RawContextKey("activeEditorAvailableEditorIds","",(0,c.localize)(8,null)),e.TextCompareEditorVisibleContext=new C.RawContextKey("textCompareEditorVisible",!1,(0,c.localize)(9,null)),e.TextCompareEditorActiveContext=new C.RawContextKey("textCompareEditorActive",!1,(0,c.localize)(10,null)),e.SideBySideEditorActiveContext=new C.RawContextKey("sideBySideEditorActive",!1,(0,c.localize)(11,null)),e.EditorGroupEditorsCountContext=new C.RawContextKey("groupEditorsCount",0,(0,c.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new C.RawContextKey("activeEditorGroupEmpty",!1,(0,c.localize)(13,null)),e.ActiveEditorGroupIndexContext=new C.RawContextKey("activeEditorGroupIndex",0,(0,c.localize)(14,null)),e.ActiveEditorGroupLastContext=new C.RawContextKey("activeEditorGroupLast",!1,(0,c.localize)(15,null)),e.ActiveEditorGroupLockedContext=new C.RawContextKey("activeEditorGroupLocked",!1,(0,c.localize)(16,null)),e.MultipleEditorGroupsContext=new C.RawContextKey("multipleEditorGroups",!1,(0,c.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new C.RawContextKey("editorIsOpen",!1,(0,c.localize)(18,null)),e.InEditorZenModeContext=new C.RawContextKey("inZenMode",!1,(0,c.localize)(19,null)),e.IsCenteredLayoutContext=new C.RawContextKey("isCenteredLayout",!1,(0,c.localize)(20,null)),e.SplitEditorsVertically=new C.RawContextKey("splitEditorsVertically",!1,(0,c.localize)(21,null)),e.EditorAreaVisibleContext=new C.RawContextKey("editorAreaVisible",!0,(0,c.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function b(L,w,x){for(const W of x.visibleEditorPanes)if(W.group.id===w&&L.matches(W.input))return W.getViewState()}e.findViewStateForEditor=b;function n(L){if(d(L))return!1;const w=L;return E.URI.isUri(w?.resource)}e.isResourceEditorInput=n;function f(L){if(d(L))return!1;const w=L;return w?.original!==void 0&&w.modified!==void 0}e.isResourceDiffEditorInput=f;function o(L){if(d(L)||f(L))return!1;const w=L;return w?.primary!==void 0&&w.secondary!==void 0}e.isResourceSideBySideEditorInput=o;function l(L){if(d(L))return!1;const w=L;return w?w.resource===void 0||w.resource.scheme===t.Schemas.untitled||w.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;var v;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(v=e.Verbosity||(e.Verbosity={}));var D;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(D=e.SaveReason||(e.SaveReason={}));var _;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription"})(_=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class a extends A.Disposable{}e.AbstractEditorInput=a;function d(L){return L instanceof a}e.isEditorInput=d;function S(L){const w=L;return E.URI.isUri(w?.preferredResource)}function i(L){const w=L;return d(w?.primary)&&d(w?.secondary)}e.isSideBySideEditorInput=i;function p(L){const w=L;return d(w?.modified)&&d(w?.original)}e.isDiffEditorInput=p;function r(L){return d(L?.editor)}e.isEditorInputWithOptions=r;function s(L){const w=L;return r(L)&&w?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function u(L){const w=L;return typeof w?.groupId=="number"&&d(w.editor)}e.isEditorIdentifier=u;var h;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(h=e.EditorCloseContext||(e.EditorCloseContext={}));var m;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(m=e.SideBySideEditor||(e.SideBySideEditor={}));class k{getOriginalUri(w,x){if(!w)return;if(x?.supportSideBySide){const{primary:B,secondary:G}=this.getSideEditors(w);if(B&&G){if(x?.supportSideBySide===m.BOTH)return{primary:this.getOriginalUri(B,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(G,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===m.ANY)return this.getOriginalUri(B,{filterByScheme:x.filterByScheme})??this.getOriginalUri(G,{filterByScheme:x.filterByScheme});w=x.supportSideBySide===m.PRIMARY?B:G}}if(f(w)||o(w))return;const W=S(w)?w.preferredResource:w.resource;return!W||!x||!x.filterByScheme?W:this.filterUri(W,x.filterByScheme)}getSideEditors(w){return i(w)||o(w)?{primary:w.primary,secondary:w.secondary}:p(w)||f(w)?{primary:w.modified,secondary:w.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(w,x){if(!w)return;if(x?.supportSideBySide){const{primary:B,secondary:G}=this.getSideEditors(w);if(B&&G){if(x?.supportSideBySide===m.BOTH)return{primary:this.getCanonicalUri(B,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(G,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===m.ANY)return this.getCanonicalUri(B,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(G,{filterByScheme:x.filterByScheme});w=x.supportSideBySide===m.PRIMARY?B:G}}if(f(w)||o(w))return;const W=w.resource;return!W||!x||!x.filterByScheme?W:this.filterUri(W,x.filterByScheme)}filterUri(w,x){if(Array.isArray(x)){if(x.some(W=>w.scheme===W))return w}else if(x===w.scheme)return w}}e.EditorResourceAccessor=new k;var T;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(T=e.CloseDirection||(e.CloseDirection={}));class g{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(w){const x=this.instantiationService=w.get(R.IInstantiationService);for(const[W,B]of this.editorSerializerConstructors)this.createEditorSerializer(W,B,x);this.editorSerializerConstructors.clear()}createEditorSerializer(w,x,W){const B=W.createInstance(x);this.editorSerializerInstances.set(w,B)}registerFileEditorFactory(w){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=w}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(w,x){if(this.editorSerializerConstructors.has(w)||this.editorSerializerInstances.has(w))throw new Error(`A editor serializer with type ID '${w}' was already registered.`);return this.instantiationService?this.createEditorSerializer(w,x,this.instantiationService):this.editorSerializerConstructors.set(w,x),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(w),this.editorSerializerInstances.delete(w)})}getEditorSerializer(w){return this.editorSerializerInstances.get(typeof w=="string"?w:w.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new g);async function I(L,w){if(!L||!L.length)return[];const x=await Promise.all(L.map(async W=>{const B=E.URI.revive(W.fileUri);if(!B||(await w.activateProvider(B.scheme),!w.canHandleResource(B)))return;const G=typeof W.exists=="boolean"?W.exists:await w.exists(B);if(!G&&W.openOnlyIfExists)return;const H={selection:G?W.selection:void 0,pinned:!0,override:W.editorOverrideId};let U;return G?U={resource:B,options:H}:U={resource:B,options:H,forceUntitled:!0},U}));return(0,P.coalesce)(x)}e.pathsToEditors=I;var F;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(F=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[162],Ee([0,1,3,45,132,4,6,20,28,13,51,23,34,152]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",n.Codicon.window,(0,E.localize)(0,null));var o;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(o=e.Extensions||(e.Extensions={}));var l;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel",u[u.AuxiliaryBar=2]="AuxiliaryBar"})(l=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function v(u){switch(u){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=v;function D(u){return`viewContainer.${u}.enabled`}e.getEnabledViewContainerContextKey=D;class _ extends R.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new c.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new c.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(h,m,k){const T=this.get(h.id);if(T)return T;const g=h;return g.openCommandActionDescriptor=k?.donotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,C.getOrSet)(this.viewContainers,m,[]).push(g),k?.isDefault&&this.defaultViewContainers.push(g),this._onDidRegister.fire({viewContainer:g,viewContainerLocation:m}),g}deregisterViewContainer(h){for(const m of this.viewContainers.keys()){const k=this.viewContainers.get(m),T=k?.indexOf(h);if(T!==-1){k?.splice(T,1),k.length===0&&this.viewContainers.delete(m),this._onDidDeregister.fire({viewContainer:h,viewContainerLocation:m});return}}}get(h){return this.all.filter(m=>m.id===h)[0]}getViewContainers(h){return[...this.viewContainers.get(h)||[]]}getViewContainerLocation(h){return[...this.viewContainers.keys()].filter(m=>this.getViewContainers(m).filter(k=>k?.id===h.id).length>0)[0]}getDefaultViewContainer(h){return this.defaultViewContainers.find(m=>this.getViewContainerLocation(m)===h)}}y.Registry.add(o.ViewContainersRegistry,new _);var a;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function d(u,h){const m=u.group??a.More,k=h.group??a.More;return m!==k?m.localeCompare(k):(u.order??5)-(h.order??5)}class S extends R.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new c.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new c.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new c.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new c.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(h,m){this.registerViews2([{views:h,viewContainer:m}])}registerViews2(h){h.forEach(({views:m,viewContainer:k})=>this.addViews(m,k)),this._onViewsRegistered.fire(h)}deregisterViews(h,m){const k=this.removeViews(h,m);k.length&&this._onViewsDeregistered.fire({views:k,viewContainer:m})}moveViews(h,m){for(const k of this._views.keys())if(k!==m){const T=this.removeViews(h,k);T.length&&(this.addViews(T,m),this._onDidChangeContainer.fire({views:T,from:k,to:m}))}}getViews(h){return this._views.get(h)||[]}getView(h){for(const m of this._viewContainers){const k=(this._views.get(m)||[]).filter(T=>T.id===h)[0];if(k)return k}return null}getViewContainer(h){for(const m of this._viewContainers)if((this._views.get(m)||[]).filter(T=>T.id===h)[0])return m;return null}registerViewWelcomeContent(h,m){return this._viewWelcomeContents.add(h,m),this._onDidChangeViewWelcomeContent.fire(h),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(h,m),this._onDidChangeViewWelcomeContent.fire(h)})}registerViewWelcomeContent2(h,m){const k=new Map;for(const[T,g]of m)this._viewWelcomeContents.add(h,g),k.set(T,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(h,g),this._onDidChangeViewWelcomeContent.fire(h)}));return this._onDidChangeViewWelcomeContent.fire(h),k}getViewWelcomeContent(h){const m=[];return this._viewWelcomeContents.forEach(h,k=>m.push(k)),m.sort(d)}addViews(h,m){let k=this._views.get(m);k||(k=[],this._views.set(m,k),this._viewContainers.push(m));for(const T of h){if(this.getView(T.id)!==null)throw new Error((0,E.localize)(1,null,T.id));k.push(T)}}removeViews(h,m){const k=this._views.get(m);if(!k)return[];const T=[],g=[];for(const I of k)h.includes(I)?T.push(I):g.push(I);return T.length&&(g.length?this._views.set(m,g):(this._views.delete(m),this._viewContainers.splice(this._viewContainers.indexOf(m),1))),T}}y.Registry.add(o.ViewsRegistry,new S),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,E.localize)(2,null));function i(u){return`view.${u}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var p;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(p=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class s{constructor(h,m){this.resolved=!1,this._hasResolve=!1,(0,b.mixin)(this,h),this._hasResolve=!!m,this.resolve=async k=>{if(m&&!this.resolved){const T=await m(k);T&&(this.tooltip=this.tooltip??T.tooltip,this.command=this.command??T.command)}k.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[163],Ee([0,1,3,14,133]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new c.Emitter,this._onExit=new c.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,y,P,t){const b={command:C};if(y&&Object.keys(y).length>0&&(b.arguments=y),this.internalSend("request",b),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const f=this.pendingRequests.get(b.seq);if(f){this.pendingRequests.delete(b.seq);const o={type:"response",seq:0,request_seq:b.seq,success:!1,command:C,message:(0,E.localize)(0,null,t,C)};f(o)}},t)}return P&&this.pendingRequests.set(b.seq,P),b.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,y){return C.type!=="event"||y.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,M.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const y=C,P=this.pendingRequests.get(y.request_seq);P&&(this.pendingRequests.delete(y.request_seq),P(y));break}}}internalSend(C,y){y.type=C,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((y,P)=>C.set(P,y)),await(0,M.timeout)(500),C.forEach((y,P)=>{y({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(be[164],Ee([0,1,9,2,17,23,11]),function(re,e,c,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function y(r,s,u){return r.replace(C,function(h,m){return s&&m.length>0&&m[0]!=="_"?h:u&&u.hasOwnProperty(m)?u[m]:h})}e.formatPII=y;function P(r){const s={};for(const u of Object.keys(r))u.startsWith("!")||(s[u]=r[u]);return s}e.filterExceptionsFromTelemetry=P;function t(r){return r.configuration.request==="attach"&&!b(r)&&(!r.parentSession||t(r.parentSession))}e.isSessionAttach=t;function b(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(s,"extensionhost")||(0,c.equalsIgnoreCase)(s,"pwa-extensionhost")?r:r.parentSession?b(r.parentSession):void 0}e.getExtensionHostDebugSession=b;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function f(r,s,u){let h,m=0,k=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,T=null;for(;T=k.exec(r);){let g=T.index+1,I=g+T[0].length;if(g<=s&&I>=u){h=T[0],m=g;break}}if(h){let g=/\w+/g,I=null;for(;(I=g.exec(h))&&!(I.index+1+m+I[0].length>=u););I&&(h=h.substring(0,g.lastIndex))}return h?{start:m,end:m+h.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function l(r){return!!(r&&r.match(o))}e.isUri=l;function v(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(l(r.path))return M.URI.parse(r.path);if((0,E.isAbsolute)(r.path))return M.URI.file(r.path)}return r.path}function D(r){if(typeof r.path=="object"){const s=M.URI.revive(r.path);if(s)return s.scheme===R.Schemas.file?s.fsPath:s.toString()}return r.path}function _(r,s){const u=s?v:D,h=(0,A.deepClone)(r);return d(h,(m,k)=>{m&&k&&(k.path=u(k))}),h}e.convertToDAPaths=_;function a(r,s){const u=s?v:D,h=(0,A.deepClone)(r);return d(h,(m,k)=>{!m&&k&&(k.path=u(k))}),h}e.convertToVSCPaths=a;function d(r,s){switch(r.type){case"event":const u=r;switch(u.event){case"output":s(!1,u.body.source);break;case"loadedSource":s(!1,u.body.source);break;case"breakpoint":s(!1,u.body.breakpoint.source);break;default:break}break;case"request":const h=r;switch(h.command){case"setBreakpoints":s(!0,h.arguments.source);break;case"breakpointLocations":s(!0,h.arguments.source);break;case"source":s(!0,h.arguments.source);break;case"gotoTargets":s(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(k=>s(!1,k));break;default:break}break;case"response":const m=r;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(k=>s(!1,k.source));break;case"loadedSources":m.body.sources.forEach(k=>s(!1,k));break;case"scopes":m.body.scopes.forEach(k=>s(!1,k.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(k=>s(!1,k.source));break;case"setBreakpoints":m.body.breakpoints.forEach(k=>s(!1,k.source));break;default:break}break}}function S(r){return r.filter(s=>!s.presentation?.hidden).sort((s,u)=>s.presentation?u.presentation?s.presentation.group?u.presentation.group?s.presentation.group!==u.presentation.group?s.presentation.group.localeCompare(u.presentation.group):i(s.presentation.order,u.presentation.order):-1:u.presentation.group?1:i(s.presentation.order,u.presentation.order):-1:u.presentation?1:0)}e.getVisibleAndSorted=S;function i(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}async function p(r,s){const u=r.getValue("debug.saveBeforeStart",{overrideIdentifier:s.activeTextEditorMode});if(u!=="none"&&(await s.saveAll(),u==="allEditorsInActiveGroup")){const h=s.activeEditorPane;h&&await s.save({editor:h.input,groupId:h.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=p}),define(be[89],Ee([0,1,27,78,11,17,25,45]),function(re,e,c,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(g){g[g.Markup=1]="Markup",g[g.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(g){g[g.Running=1]="Running",g[g.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(g){g[g.Pending=2]="Pending",g[g.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var b;(function(g){g[g.WithHardKernelDependency=0]="WithHardKernelDependency",g[g.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",g[g.Pure=2]="Pure",g[g.Never=3]="Never"})(b=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var n;(function(g){g.Always="always",g.Never="never",g.Optional="optional"})(n=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(g){g[g.ModelChange=1]="ModelChange",g[g.Move=2]="Move",g[g.ChangeLanguage=5]="ChangeLanguage",g[g.Initialize=6]="Initialize",g[g.ChangeCellMetadata=7]="ChangeCellMetadata",g[g.Output=8]="Output",g[g.OutputItem=9]="OutputItem",g[g.ChangeCellContent=10]="ChangeCellContent",g[g.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",g[g.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",g[g.ChangeCellMime=13]="ChangeCellMime",g[g.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(g){g[g.Handle=0]="Handle",g[g.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(g){g[g.Replace=1]="Replace",g[g.Output=2]="Output",g[g.Metadata=3]="Metadata",g[g.CellLanguage=4]="CellLanguage",g[g.DocumentMetadata=5]="DocumentMetadata",g[g.Move=6]="Move",g[g.OutputItems=7]="OutputItems",g[g.PartialMetadata=8]="PartialMetadata",g[g.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var v;(function(g){g.scheme=E.Schemas.vscodeNotebookCell;const I=/^ch(\d{7,})/;function F(B,G){return B.with({scheme:g.scheme,fragment:`ch${G.toString().padStart(7,"0")}${B.scheme!==E.Schemas.file?B.scheme:""}`})}g.generate=F;function L(B){if(B.scheme!==g.scheme)return;const G=I.exec(B.fragment);return G?{handle:Number(G[1]),notebook:B.with({scheme:B.fragment.substr(G[0].length)||E.Schemas.file,fragment:null})}:void 0}g.parse=L;function w(B){if(B.scheme!==E.Schemas.vscodeNotebookCellMetadata)return;const G=I.exec(B.fragment);return G?{handle:Number(G[1]),notebook:B.with({scheme:B.fragment.substr(G[0].length)||E.Schemas.file,fragment:null})}:void 0}g.parseCellMetadataUri=w;function x(B,G,H){return B.with({scheme:H,fragment:`ch${G.toString().padStart(7,"0")}${B.scheme!==E.Schemas.file?B.scheme:""}`})}g.generateCellUri=x;function W(B,G){if(B.scheme!==G)return;const H=I.exec(B.fragment);return H?{handle:Number(H[1]),notebook:B.with({scheme:B.fragment.substr(H[0].length)||E.Schemas.file,fragment:null})}:void 0}g.parseCellUri=W})(v=e.CellUri||(e.CellUri={}));const D=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function _(g){return D.get(g)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=_;function a(g){return D.get(g)?.supportedByCore??!1}e.mimeTypeSupportedByCore=a;function d(g){return D.get(g)?.mergeable??!1}e.mimeTypeIsMergeable=d;function S(g,I){return R.isWindows&&(g=g.replace(/\//g,"\\"),I=I.replace(/\//g,"\\")),c.match(g,I)}function i(g,I,F){let L=0;for(let w=0;w<I.length;w++){if(S(I[w],g))return L;L++}for(let w=0;w<F.length;w++){if(S(F[w],g))return L;L++}return L}function p(g,I,F){return g.sort((L,w)=>i(L,I,F)-i(w,I,F))}e.sortMimeTypes=p;function r(g,I,F,L=(w,x)=>w===x){const w=[];function x(G,H,U){if(H===0&&U.length===0)return;const V=w[w.length-1];V&&V.start+V.deleteCount===G?(V.deleteCount+=H,V.toInsert.push(...U)):w.push({start:G,deleteCount:H,toInsert:U})}let W=0,B=0;for(;;){if(W===g.length){x(W,0,I.slice(B));break}if(B===I.length){x(W,g.length-W,[]);break}const G=g[W],H=I[B];if(L(G,H)){W+=1,B+=1;continue}F(H)?(x(W,1,[]),W+=1):(x(W,0,[H]),B+=1)}return w}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(g){g.default="default",g.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(g){const I=g;return!!((typeof I.include=="string"||c.isRelativePattern(I.include))&&(typeof I.exclude=="string"||c.isRelativePattern(I.exclude)))}e.isDocumentExcludePattern=u;function h(g,I,F){if(Array.isArray(g.viewType)&&g.viewType.indexOf(I)>=0||g.viewType===I)return!0;if(g.filenamePattern){let L=u(g.filenamePattern)?g.filenamePattern.include:g.filenamePattern,w=u(g.filenamePattern)?g.filenamePattern.exclude:void 0;if(c.match(L,(0,A.basename)(F.fsPath).toLowerCase()))return!(w&&c.match(w,(0,A.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=h;class m{constructor(I){this.textModel=I}getElements(){const I=new Int32Array(this.textModel.cells.length);for(let F=0;F<this.textModel.cells.length;F++)I[F]=this.textModel.cells[F].getHashValue();return I}}e.CellSequence=m,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var k;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(k=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class T{static create(I){return`${T._prefix}${I}`}static parse(I){if(I.startsWith(T._prefix))return I.substr(T._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=T,T._prefix="notebook/"}),define(be[165],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(E){E[E.Output=1]="Output",E[E.OutputItems=2]="OutputItems",E[E.ExecutionState=3]="ExecutionState",E[E.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(be[166],Ee([0,1,135,4,45]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new E.RawContextKey("customExecutionSupported",!0,c.localize(0,null)),e.ShellExecutionSupportedContext=new E.RawContextKey("shellExecutionSupported",!1,c.localize(1,null)),e.ProcessExecutionSupportedContext=new E.RawContextKey("processExecutionSupported",!1,c.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[167],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=c;function M(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=M}),define(be[90],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var c;(function(b){b[b.Unset=0]="Unset",b[b.Queued=1]="Queued",b[b.Running=2]="Running",b[b.Passed=3]="Passed",b[b.Failed=4]="Failed",b[b.Skipped=5]="Skipped",b[b.Errored=6]="Errored"})(c=e.TestResultState||(e.TestResultState={}));var M;(function(b){b[b.Run=2]="Run",b[b.Debug=4]="Debug",b[b.Coverage=8]="Coverage",b[b.HasNonDefaultProfile=16]="HasNonDefaultProfile",b[b.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(b){b[b.Error=0]="Error",b[b.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var A;(function(b){b[b.NotExpandable=0]="NotExpandable",b[b.Expandable=1]="Expandable",b[b.BusyExpanding=2]="BusyExpanding",b[b.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(b,n)=>{n.expand!==void 0&&(b.expand=n.expand),n.item!==void 0&&(b.item=b.item?Object.assign(b.item,n.item):n.item)};e.applyTestItemUpdate=R;var C;(function(b){b[b.Function=0]="Function",b[b.Statement=1]="Statement"})(C=e.DetailType||(e.DetailType={}));var y;(function(b){b[b.Add=0]="Add",b[b.Update=1]="Update",b[b.Remove=2]="Remove",b[b.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",b[b.Retire=4]="Retire",b[b.AddTag=5]="AddTag",b[b.RemoveTag=6]="RemoveTag"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(n){}update(n){}remove(n,f){}complete(){}}e.IncrementalChangeCollector=P;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const f=this.createChangeCollector();for(const o of n)switch(o[0]){case 0:{const l=o[1];if(l.parent){if(this.items.has(l.parent)){const v=this.items.get(l.parent);v.children.add(l.item.extId);const D=this.createItem(l,v);this.items.set(l.item.extId,D),f.add(D)}}else{const v=this.createItem(l);this.roots.add(v),this.items.set(l.item.extId,v),f.add(v)}l.expand===2&&this.busyControllerCount++;break}case 1:{const l=o[1],v=this.items.get(l.extId);if(!v)break;l.expand!==void 0&&(v.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(v,l),f.update(v);break}case 2:{const l=this.items.get(o[1]);if(!l)break;l.parent?this.items.get(l.parent).children.delete(l.item.extId):this.roots.delete(l);const v=[[o[1]]];for(;v.length;)for(const D of v.pop()){const _=this.items.get(D);_&&(v.push(_.children),this.items.delete(D),f.remove(_,_!==l),_.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(o[1]);break;case 3:this.updatePendingRoots(o[1]);break;case 5:this._tags.set(o[1].id,o[1]);break;case 6:this._tags.delete(o[1]);break}f.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=t}),define(be[67],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(A){A.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class E{constructor(R,C=R.length){if(this.path=R,this.viewEnd=C,R.length===0||C<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(R,C,y=R.parent){if(R.id===C)return new E([C]);let P=[R.id];for(let t=y;t&&t.id!==C;t=t.parent)P.push(t.id);return P.push(C),new E(P.reverse())}static isRoot(R){return!R.includes("\0")}static fromString(R){return new E(R.split("\0"))}static join(R,C){return new E([...R.path,C])}static joinToString(R,C){return R.toString()+"\0"+C}static compare(R,C){return R===C?0:C.startsWith(R+"\0")?2:R.startsWith(C+"\0")?3:1}get parentId(){return this.viewEnd>1?new E(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new E(this.path,R)}compare(R){if(typeof R=="string")return E.compare(this.toString(),R);for(let C=0;C<R.viewEnd&&C<this.viewEnd;C++)if(R.path[C]!==this.path[C])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=E}),define(be[168],Ee([0,1,17,91,10,23,25,77,136]),function(re,e,c,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(b,n,f){this._contributedVariables=new Map,this._context=b,this._labelService=n,f&&(this._envVariablesPromise=f.then(o=>this.prepareEnv(o)))}prepareEnv(b){if(R.isWindows){const n=Object.create(null);return Object.keys(b).forEach(f=>{n[f.toLowerCase()]=b[f]}),n}return b}resolveWithEnvironment(b,n,f){return this.recursiveResolve(this.prepareEnv(b),n?n.uri:void 0,f)}async resolveAsync(b,n){return this.recursiveResolve(await this._envVariablesPromise,b?b.uri:void 0,n)}async resolveAnyBase(b,n,f,o){const l=A.deepClone(n);return R.isWindows&&l.windows?Object.keys(l.windows).forEach(v=>l[v]=l.windows[v]):R.isMacintosh&&l.osx?Object.keys(l.osx).forEach(v=>l[v]=l.osx[v]):R.isLinux&&l.linux&&Object.keys(l.linux).forEach(v=>l[v]=l.linux[v]),delete l.windows,delete l.osx,delete l.linux,this.recursiveResolve(await this._envVariablesPromise,b?b.uri:void 0,l,f,o)}async resolveAnyAsync(b,n,f){return this.resolveAnyBase(b,n,f)}async resolveAnyMap(b,n,f){const o=new Map;return{newConfig:await this.resolveAnyBase(b,n,f,o),resolvedVariables:o}}resolveWithInteractionReplace(b,n,f,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,n,f,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,n){if(this._contributedVariables.has(b))throw new Error("Variable "+b+" is contributed twice.");this._contributedVariables.set(b,n)}recursiveResolve(b,n,f,o,l){if(E.isString(f))return this.resolveString(b,n,f,o,l);if(E.isArray(f))return f.map(v=>this.recursiveResolve(b,n,v,o,l));if(E.isObject(f)){let v=Object.create(null);return Object.keys(f).forEach(D=>{const _=this.resolveString(b,n,D,o,l);v[_]=this.recursiveResolve(b,n,f[D],o,l)}),v}return f}resolveString(b,n,f,o,l){return f.replace(P.VARIABLE_REGEXP,(D,_)=>{if(_.includes(P.VARIABLE_LHS))return D;let a=this.evaluateSingleVariable(b,D,_,n,o);return l&&l.set(_,a),a!==D&&E.isString(a)&&a.match(P.VARIABLE_REGEXP)&&(a=this.resolveString(b,n,a,o,l)),a})}fsPath(b){return this._labelService?this._labelService.getUriLabel(b,{noPrefix:!0}):b.fsPath}evaluateSingleVariable(b,n,f,o,l){let v;const D=f.split(":");D.length>1&&(f=D[0],v=D[1]);const _=()=>{const S=this._context.getFilePath();if(S)return S;throw new Error((0,y.localize)(0,null,n))},a=()=>{const S=_();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,y.localize)(1,null,n,c.basename(S)))},d=()=>{if(v){const S=this._context.getFolderUri(v);if(S)return S;throw new Error((0,y.localize)(2,null,n,v))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,n)):new Error((0,y.localize)(4,null,n))};switch(f){case"env":if(v){if(b){const S=b[R.isWindows?v.toLowerCase():v];if(E.isString(S))return S}return""}throw new Error((0,y.localize)(5,null,n));case"config":if(v){const S=this._context.getConfigurationValue(o,v);if(E.isUndefinedOrNull(S))throw new Error((0,y.localize)(6,null,n,v));if(E.isObject(S))throw new Error((0,y.localize)(7,null,n,v));return S}throw new Error((0,y.localize)(8,null,n));case"command":return this.resolveFromMap(n,v,l,"command");case"input":return this.resolveFromMap(n,v,l,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(d()));case"cwd":return o||v?(0,C.normalizeDriveLetter)(this.fsPath(d())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return c.basename(this.fsPath(d()));case"lineNumber":const S=this._context.getLineNumber();if(S)return S;throw new Error((0,y.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,y.localize)(10,null,n));case"file":return _();case"fileWorkspaceFolder":return a();case"relativeFile":return o||v?c.relative(this.fsPath(d()),_()):_();case"relativeFileDirname":const p=c.dirname(_());if(o||v){const h=c.relative(this.fsPath(d()),p);return h.length===0?".":h}return p;case"fileDirname":return c.dirname(_());case"fileExtname":return c.extname(_());case"fileBasename":return c.basename(_());case"fileBasenameNoExtension":const r=c.basename(_());return r.slice(0,r.length-c.extname(r).length);case"fileDirnameBasename":return c.basename(c.dirname(_()));case"execPath":const s=this._context.getExecPath();return s||n;case"execInstallFolder":const u=this._context.getAppRoot();return u||n;case"pathSeparator":return c.sep;default:try{const h=v?`${f}:${v}`:f;return this.resolveFromMap(n,h,l,void 0)}catch(h){return n}}}}resolveFromMap(b,n,f,o){if(n&&f){const l=o===void 0?f[n]:f[o+":"+n];if(typeof l=="string")return l;throw new Error((0,y.localize)(11,null,b))}return b}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[92],Ee([0,1,4,161]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var E;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(E=e.GroupDirection||(e.GroupDirection={}));var A;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var C;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(C=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function P(l){const v=l;return(0,M.isEditorInput)(v?.editor)&&(0,M.isEditorInput)(v?.replacement)}e.isEditorReplacement=P;var t;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var b;(function(l){l[l.GROUP_ACTIVE=0]="GROUP_ACTIVE",l[l.GROUP_INDEX=1]="GROUP_INDEX",l[l.GROUP_LOCKED=2]="GROUP_LOCKED",l[l.EDITOR_OPEN=3]="EDITOR_OPEN",l[l.EDITOR_CLOSE=4]="EDITOR_CLOSE",l[l.EDITOR_MOVE=5]="EDITOR_MOVE",l[l.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",l[l.EDITOR_LABEL=7]="EDITOR_LABEL",l[l.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",l[l.EDITOR_PIN=9]="EDITOR_PIN",l[l.EDITOR_STICKY=10]="EDITOR_STICKY",l[l.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(b=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function f(l){const v=l;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.isEditorGroup=f;function o(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=o}),define(be[169],Ee([0,1,4,92]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function E(A){const R=A;return typeof A=="number"||(0,M.isEditorGroup)(R)}e.isPreferredGroup=E}),define(be[8],Ee([0,1,13,22,76,230,54,23,10,2,44,59,137,82,48,89,67,169,7]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o,l,v,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(de){function pe(z){const{selectionStartLineNumber:we,selectionStartColumn:Ie,positionLineNumber:Je,positionColumn:Ue}=z,dt=new _.Position(we-1,Ie-1),gt=new _.Position(Je-1,Ue-1);return new _.Selection(dt,gt)}de.to=pe;function Y(z){const{anchor:we,active:Ie}=z;return{selectionStartLineNumber:we.line+1,selectionStartColumn:we.character+1,positionLineNumber:Ie.line+1,positionColumn:Ie.character+1}}de.from=Y})(a=e.Selection||(e.Selection={}));var d;(function(de){function pe(z){if(!z)return;const{start:we,end:Ie}=z;return{startLineNumber:we.line+1,startColumn:we.character+1,endLineNumber:Ie.line+1,endColumn:Ie.character+1}}de.from=pe;function Y(z){if(!z)return;const{startLineNumber:we,startColumn:Ie,endLineNumber:Je,endColumn:Ue}=z;return new _.Range(we-1,Ie-1,Je-1,Ue-1)}de.to=Y})(d=e.Range||(e.Range={}));var S;(function(de){function pe(Y){switch(Y){case 1:return _.StandardTokenType.Comment;case 0:return _.StandardTokenType.Other;case 4:return _.StandardTokenType.RegEx;case 2:return _.StandardTokenType.String}}de.to=pe})(S=e.TokenType||(e.TokenType={}));var i;(function(de){function pe(z){return new _.Position(z.lineNumber-1,z.column-1)}de.to=pe;function Y(z){return{lineNumber:z.line+1,column:z.character+1}}de.from=Y})(i=e.Position||(e.Position={}));var p;(function(de){function pe(we,Ie){return(0,c.coalesce)((0,c.asArray)(we).map(Je=>Y(Je,Ie)))}de.from=pe;function Y(we,Ie){if(typeof we=="string")return{$serialized:!0,language:we};if(we)return{$serialized:!0,language:we.language,scheme:z(we.scheme,Ie),pattern:typeof we.pattern=="undefined"?void 0:ot.from(we.pattern),exclusive:we.exclusive}}function z(we,Ie){return Ie&&typeof we=="string"?Ie.transformOutgoingScheme(we):we}})(p=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(de){function pe(z){switch(z){case _.DiagnosticTag.Unnecessary:return 1;case _.DiagnosticTag.Deprecated:return 2}}de.from=pe;function Y(z){switch(z){case 1:return _.DiagnosticTag.Unnecessary;case 2:return _.DiagnosticTag.Deprecated;default:return}}de.to=Y})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(de){function pe(z){let we;return z.code&&((0,y.isString)(z.code)||(0,y.isNumber)(z.code)?we=String(z.code):we={value:String(z.code.value),target:z.code.target}),{...d.from(z.range),message:z.message,source:z.source,code:we,severity:h.from(z.severity),relatedInformation:z.relatedInformation&&z.relatedInformation.map(u.from),tags:Array.isArray(z.tags)?(0,c.coalesce)(z.tags.map(r.from)):void 0}}de.from=pe;function Y(z){const we=new _.Diagnostic(d.to(z),z.message,h.to(z.severity));return we.source=z.source,we.code=(0,y.isString)(z.code)?z.code:z.code?.value,we.relatedInformation=z.relatedInformation&&z.relatedInformation.map(u.to),we.tags=z.tags&&(0,c.coalesce)(z.tags.map(r.to)),we}de.to=Y})(s=e.Diagnostic||(e.Diagnostic={}));var u;(function(de){function pe(z){return{...d.from(z.location.range),message:z.message,resource:z.location.uri}}de.from=pe;function Y(z){return new _.DiagnosticRelatedInformation(new _.Location(z.resource,d.to(z)),z.message)}de.to=Y})(u=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var h;(function(de){function pe(z){switch(z){case _.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case _.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case _.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case _.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}de.from=pe;function Y(z){switch(z){case f.MarkerSeverity.Info:return _.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return _.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return _.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return _.DiagnosticSeverity.Hint;default:return _.DiagnosticSeverity.Error}}de.to=Y})(h=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var m;(function(de){function pe(z){return typeof z=="number"&&z>=_.ViewColumn.One?z-1:z===_.ViewColumn.Beside?D.SIDE_GROUP:D.ACTIVE_GROUP}de.from=pe;function Y(z){if(typeof z=="number"&&z>=0)return z+1;throw new Error("invalid 'EditorGroupColumn'")}de.to=Y})(m=e.ViewColumn||(e.ViewColumn={}));function k(de){return typeof de.range!="undefined"}function T(de){return de.length===0?!0:!!k(de[0])}e.isDecorationOptionsArr=T;var g;(function(de){function pe(Ue){return Ue.map(de.from)}de.fromMany=pe;function Y(Ue){return Ue&&typeof Ue=="object"&&typeof Ue.language=="string"&&typeof Ue.value=="string"}function z(Ue){let dt;if(Y(Ue)){const{language:ut,value:pt}=Ue;dt={value:"```"+ut+`
`+pt+"\n```\n"}}else _.MarkdownString.isMarkdownString(Ue)?dt={value:Ue.value,isTrusted:Ue.isTrusted,supportThemeIcons:Ue.supportThemeIcons,supportHtml:Ue.supportHtml}:typeof Ue=="string"?dt={value:Ue}:dt={value:""};const gt=Object.create(null);dt.uris=gt;const lt=ut=>{try{let pt=P.URI.parse(ut,!0);pt=pt.with({query:we(pt.query,gt)}),gt[ut]=pt}catch(pt){}return""},ft=new A.Renderer;return ft.link=lt,ft.image=ut=>lt(E.parseHrefAndDimensions(ut).href),A(dt.value,{renderer:ft}),dt}de.from=z;function we(Ue,dt){if(!Ue)return Ue;let gt;try{gt=(0,R.parse)(Ue)}catch(ft){}if(!gt)return Ue;let lt=!1;return gt=(0,C.cloneAndChange)(gt,ft=>{if(P.URI.isUri(ft)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[ut]=ft,lt=!0,ut}else return}),lt?JSON.stringify(gt):Ue}function Ie(Ue){const dt=new _.MarkdownString(Ue.value,Ue.supportThemeIcons);return dt.isTrusted=Ue.isTrusted,dt.supportHtml=Ue.supportHtml,dt}de.to=Ie;function Je(Ue){if(!!Ue)return typeof Ue=="string"?Ue:de.from(Ue)}de.fromStrict=Je})(g=e.MarkdownString||(e.MarkdownString={}));function I(de){return T(de)?de.map(pe=>({range:d.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?g.fromMany(pe.hoverMessage):pe.hoverMessage?g.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):de.map(pe=>({range:d.from(pe)}))}e.fromRangeOrRangeWithMessage=I;function F(de){return typeof de=="undefined"?de:typeof de=="string"?P.URI.file(de):de}e.pathOrURIToURI=F;var L;(function(de){function pe(Y){return typeof Y=="undefined"?Y:{contentText:Y.contentText,contentIconPath:Y.contentIconPath?F(Y.contentIconPath):void 0,border:Y.border,borderColor:Y.borderColor,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,color:Y.color,backgroundColor:Y.backgroundColor,margin:Y.margin,width:Y.width,height:Y.height}}de.from=pe})(L=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var w;(function(de){function pe(Y){return typeof Y=="undefined"?Y:{backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?F(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?L.from(Y.before):void 0,after:Y.after?L.from(Y.after):void 0}}de.from=pe})(w=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var x;(function(de){function pe(Y){if(typeof Y=="undefined")return Y;switch(Y){case _.DecorationRangeBehavior.OpenOpen:return 0;case _.DecorationRangeBehavior.ClosedClosed:return 1;case _.DecorationRangeBehavior.OpenClosed:return 2;case _.DecorationRangeBehavior.ClosedOpen:return 3}}de.from=pe})(x=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var W;(function(de){function pe(Y){return{isWholeLine:Y.isWholeLine,rangeBehavior:Y.rangeBehavior?x.from(Y.rangeBehavior):void 0,overviewRulerLane:Y.overviewRulerLane,light:Y.light?w.from(Y.light):void 0,dark:Y.dark?w.from(Y.dark):void 0,backgroundColor:Y.backgroundColor,outline:Y.outline,outlineColor:Y.outlineColor,outlineStyle:Y.outlineStyle,outlineWidth:Y.outlineWidth,border:Y.border,borderColor:Y.borderColor,borderRadius:Y.borderRadius,borderSpacing:Y.borderSpacing,borderStyle:Y.borderStyle,borderWidth:Y.borderWidth,fontStyle:Y.fontStyle,fontWeight:Y.fontWeight,textDecoration:Y.textDecoration,cursor:Y.cursor,color:Y.color,opacity:Y.opacity,letterSpacing:Y.letterSpacing,gutterIconPath:Y.gutterIconPath?F(Y.gutterIconPath):void 0,gutterIconSize:Y.gutterIconSize,overviewRulerColor:Y.overviewRulerColor,before:Y.before?L.from(Y.before):void 0,after:Y.after?L.from(Y.after):void 0}}de.from=pe})(W=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var B;(function(de){function pe(z){return{text:z.newText,eol:z.newEol&&J.from(z.newEol),range:d.from(z.range)}}de.from=pe;function Y(z){const we=new _.TextEdit(d.to(z.range),z.text);return we.newEol=typeof z.eol=="undefined"?void 0:J.to(z.eol),we}de.to=Y})(B=e.TextEdit||(e.TextEdit={}));var G;(function(de){function pe(z,we,Ie){const Je={edits:[]};if(z instanceof _.WorkspaceEdit)for(let Ue of z._allEntries())if(Ue._type===1)Je.edits.push({_type:1,oldUri:Ue.from,newUri:Ue.to,options:Ue.options,metadata:Ue.metadata});else if(Ue._type===2){const dt=we?.getDocument(Ue.uri);Je.edits.push({_type:2,resource:Ue.uri,edit:B.from(Ue.edit),modelVersionId:dt?.version,metadata:Ue.metadata})}else Ue._type===3?Je.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,edit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:Ie?.getNotebookDocument(Ue.uri,!0)?.apiNotebook.version}):Ue._type===5&&Je.edits.push({_type:3,metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:Ie?.getNotebookDocument(Ue.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ue.index,count:Ue.count,cells:Ue.cells.map(Xe.from)}});return Je}de.from=pe;function Y(z){const we=new _.WorkspaceEdit;for(const Ie of z.edits)Ie.edit?we.replace(P.URI.revive(Ie.resource),d.to(Ie.edit.range),Ie.edit.text):we.renameFile(P.URI.revive(Ie.oldUri),P.URI.revive(Ie.newUri),Ie.options);return we}de.to=Y})(G=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(de){const pe=Object.create(null);pe[_.SymbolKind.File]=0,pe[_.SymbolKind.Module]=1,pe[_.SymbolKind.Namespace]=2,pe[_.SymbolKind.Package]=3,pe[_.SymbolKind.Class]=4,pe[_.SymbolKind.Method]=5,pe[_.SymbolKind.Property]=6,pe[_.SymbolKind.Field]=7,pe[_.SymbolKind.Constructor]=8,pe[_.SymbolKind.Enum]=9,pe[_.SymbolKind.Interface]=10,pe[_.SymbolKind.Function]=11,pe[_.SymbolKind.Variable]=12,pe[_.SymbolKind.Constant]=13,pe[_.SymbolKind.String]=14,pe[_.SymbolKind.Number]=15,pe[_.SymbolKind.Boolean]=16,pe[_.SymbolKind.Array]=17,pe[_.SymbolKind.Object]=18,pe[_.SymbolKind.Key]=19,pe[_.SymbolKind.Null]=20,pe[_.SymbolKind.EnumMember]=21,pe[_.SymbolKind.Struct]=22,pe[_.SymbolKind.Event]=23,pe[_.SymbolKind.Operator]=24,pe[_.SymbolKind.TypeParameter]=25;function Y(we){return typeof pe[we]=="number"?pe[we]:6}de.from=Y;function z(we){for(const Ie in pe)if(pe[Ie]===we)return Number(Ie);return _.SymbolKind.Property}de.to=z})(H=e.SymbolKind||(e.SymbolKind={}));var U;(function(de){function pe(z){switch(z){case _.SymbolTag.Deprecated:return 1}}de.from=pe;function Y(z){switch(z){case 1:return _.SymbolTag.Deprecated}}de.to=Y})(U=e.SymbolTag||(e.SymbolTag={}));var V;(function(de){function pe(z){return{name:z.name,kind:H.from(z.kind),tags:z.tags&&z.tags.map(U.from),containerName:z.containerName,location:oe.from(z.location)}}de.from=pe;function Y(z){const we=new _.SymbolInformation(z.name,H.to(z.kind),z.containerName,oe.to(z.location));return we.tags=z.tags&&z.tags.map(U.to),we}de.to=Y})(V=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Q;(function(de){function pe(z){const we={name:z.name||"!!MISSING: name!!",detail:z.detail,range:d.from(z.range),selectionRange:d.from(z.selectionRange),kind:H.from(z.kind),tags:z.tags?.map(U.from)??[]};return z.children&&(we.children=z.children.map(pe)),we}de.from=pe;function Y(z){const we=new _.DocumentSymbol(z.name,z.detail,H.to(z.kind),d.to(z.range),d.to(z.selectionRange));return(0,c.isNonEmptyArray)(z.tags)&&(we.tags=z.tags.map(U.to)),z.children&&(we.children=z.children.map(Y)),we}de.to=Y})(Q=e.DocumentSymbol||(e.DocumentSymbol={}));var ne;(function(de){function pe(z){const we=new _.CallHierarchyItem(H.to(z.kind),z.name,z.detail||"",P.URI.revive(z.uri),d.to(z.range),d.to(z.selectionRange));return we._sessionId=z._sessionId,we._itemId=z._itemId,we}de.to=pe;function Y(z,we,Ie){if(we=we??z._sessionId,Ie=Ie??z._itemId,we===void 0||Ie===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:Ie,name:z.name,detail:z.detail,kind:H.from(z.kind),uri:z.uri,range:d.from(z.range),selectionRange:d.from(z.selectionRange),tags:z.tags?.map(U.from)}}de.from=Y})(ne=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ce;(function(de){function pe(Y){return new _.CallHierarchyIncomingCall(ne.to(Y.from),Y.fromRanges.map(z=>d.to(z)))}de.to=pe})(ce=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Z;(function(de){function pe(Y){return new _.CallHierarchyOutgoingCall(ne.to(Y.to),Y.fromRanges.map(z=>d.to(z)))}de.to=pe})(Z=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var oe;(function(de){function pe(z){return{range:z.range&&d.from(z.range),uri:z.uri}}de.from=pe;function Y(z){return new _.Location(P.URI.revive(z.uri),d.to(z.range))}de.to=Y})(oe=e.location||(e.location={}));var ve;(function(de){function pe(z){const we=z,Ie=z;return{originSelectionRange:we.originSelectionRange?d.from(we.originSelectionRange):void 0,uri:we.targetUri?we.targetUri:Ie.uri,range:d.from(we.targetRange?we.targetRange:Ie.range),targetSelectionRange:we.targetSelectionRange?d.from(we.targetSelectionRange):void 0}}de.from=pe;function Y(z){return{targetUri:P.URI.revive(z.uri),targetRange:d.to(z.range),targetSelectionRange:z.targetSelectionRange?d.to(z.targetSelectionRange):void 0,originSelectionRange:z.originSelectionRange?d.to(z.originSelectionRange):void 0}}de.to=Y})(ve=e.DefinitionLink||(e.DefinitionLink={}));var Ae;(function(de){function pe(z){return{range:d.from(z.range),contents:g.fromMany(z.contents)}}de.from=pe;function Y(z){return new _.Hover(z.contents.map(g.to),d.to(z.range))}de.to=Y})(Ae=e.Hover||(e.Hover={}));var Se;(function(de){function pe(z){return{range:d.from(z.range),expression:z.expression}}de.from=pe;function Y(z){return new _.EvaluatableExpression(d.to(z.range),z.expression)}de.to=Y})(Se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ne;(function(de){function pe(z){if(z instanceof _.InlineValueText)return{type:"text",range:d.from(z.range),text:z.text};if(z instanceof _.InlineValueVariableLookup)return{type:"variable",range:d.from(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};if(z instanceof _.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(z.range),expression:z.expression};throw new Error("Unknown 'InlineValue' type")}de.from=pe;function Y(z){switch(z.type){case"text":return{range:d.to(z.range),text:z.text};case"variable":return{range:d.to(z.range),variableName:z.variableName,caseSensitiveLookup:z.caseSensitiveLookup};case"expression":return{range:d.to(z.range),expression:z.expression}}}de.to=Y})(Ne=e.InlineValue||(e.InlineValue={}));var We;(function(de){function pe(z){return{frameId:z.frameId,stoppedLocation:d.from(z.stoppedLocation)}}de.from=pe;function Y(z){return new _.InlineValueContext(z.frameId,d.to(z.stoppedLocation))}de.to=Y})(We=e.InlineValueContext||(e.InlineValueContext={}));var je;(function(de){function pe(z){return{range:d.from(z.range),kind:z.kind}}de.from=pe;function Y(z){return new _.DocumentHighlight(d.to(z.range),z.kind)}de.to=Y})(je=e.DocumentHighlight||(e.DocumentHighlight={}));var qe;(function(de){function pe(Y){switch(Y){case 1:return _.CompletionTriggerKind.TriggerCharacter;case 2:return _.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return _.CompletionTriggerKind.Invoke}}de.to=pe})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $;(function(de){function pe(Y){return{triggerKind:qe.to(Y.triggerKind),triggerCharacter:Y.triggerCharacter}}de.to=pe})($=e.CompletionContext||(e.CompletionContext={}));var K;(function(de){function pe(z){switch(z){case _.CompletionItemTag.Deprecated:return 1}}de.from=pe;function Y(z){switch(z){case 1:return _.CompletionItemTag.Deprecated}}de.to=Y})(K=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(de){const pe=new Map([[_.CompletionItemKind.Method,0],[_.CompletionItemKind.Function,1],[_.CompletionItemKind.Constructor,2],[_.CompletionItemKind.Field,3],[_.CompletionItemKind.Variable,4],[_.CompletionItemKind.Class,5],[_.CompletionItemKind.Interface,7],[_.CompletionItemKind.Struct,6],[_.CompletionItemKind.Module,8],[_.CompletionItemKind.Property,9],[_.CompletionItemKind.Unit,12],[_.CompletionItemKind.Value,13],[_.CompletionItemKind.Constant,14],[_.CompletionItemKind.Enum,15],[_.CompletionItemKind.EnumMember,16],[_.CompletionItemKind.Keyword,17],[_.CompletionItemKind.Snippet,27],[_.CompletionItemKind.Text,18],[_.CompletionItemKind.Color,19],[_.CompletionItemKind.File,20],[_.CompletionItemKind.Reference,21],[_.CompletionItemKind.Folder,23],[_.CompletionItemKind.Event,10],[_.CompletionItemKind.Operator,11],[_.CompletionItemKind.TypeParameter,24],[_.CompletionItemKind.Issue,26],[_.CompletionItemKind.User,25]]);function Y(Ie){return pe.get(Ie)??9}de.from=Y;const z=new Map([[0,_.CompletionItemKind.Method],[1,_.CompletionItemKind.Function],[2,_.CompletionItemKind.Constructor],[3,_.CompletionItemKind.Field],[4,_.CompletionItemKind.Variable],[5,_.CompletionItemKind.Class],[7,_.CompletionItemKind.Interface],[6,_.CompletionItemKind.Struct],[8,_.CompletionItemKind.Module],[9,_.CompletionItemKind.Property],[12,_.CompletionItemKind.Unit],[13,_.CompletionItemKind.Value],[14,_.CompletionItemKind.Constant],[15,_.CompletionItemKind.Enum],[16,_.CompletionItemKind.EnumMember],[17,_.CompletionItemKind.Keyword],[27,_.CompletionItemKind.Snippet],[18,_.CompletionItemKind.Text],[19,_.CompletionItemKind.Color],[20,_.CompletionItemKind.File],[21,_.CompletionItemKind.Reference],[23,_.CompletionItemKind.Folder],[10,_.CompletionItemKind.Event],[11,_.CompletionItemKind.Operator],[24,_.CompletionItemKind.TypeParameter],[25,_.CompletionItemKind.User],[26,_.CompletionItemKind.Issue]]);function we(Ie){return z.get(Ie)??_.CompletionItemKind.Property}de.to=we})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var ae;(function(de){function pe(Y,z){const we=new _.CompletionItem(Y.label);return we.insertText=Y.insertText,we.kind=ee.to(Y.kind),we.tags=Y.tags?.map(K.to),we.detail=Y.detail,we.documentation=E.isMarkdownString(Y.documentation)?g.to(Y.documentation):Y.documentation,we.sortText=Y.sortText,we.filterText=Y.filterText,we.preselect=Y.preselect,we.commitCharacters=Y.commitCharacters,t.Range.isIRange(Y.range)?we.range=d.to(Y.range):typeof Y.range=="object"&&(we.range={inserting:d.to(Y.range.insert),replacing:d.to(Y.range.replace)}),we.keepWhitespace=typeof Y.insertTextRules=="undefined"?!1:Boolean(Y.insertTextRules&1),typeof Y.insertTextRules!="undefined"&&Y.insertTextRules&4?we.insertText=new _.SnippetString(Y.insertText):(we.insertText=Y.insertText,we.textEdit=we.range instanceof _.Range?new _.TextEdit(we.range,we.insertText):void 0),Y.additionalTextEdits&&Y.additionalTextEdits.length>0&&(we.additionalTextEdits=Y.additionalTextEdits.map(Ie=>B.to(Ie))),we.command=z&&Y.command?z.fromInternal(Y.command):void 0,we}de.to=pe})(ae=e.CompletionItem||(e.CompletionItem={}));var q;(function(de){function pe(z){return{label:z.label,documentation:z.documentation?g.fromStrict(z.documentation):void 0}}de.from=pe;function Y(z){return{label:z.label,documentation:E.isMarkdownString(z.documentation)?g.to(z.documentation):z.documentation}}de.to=Y})(q=e.ParameterInformation||(e.ParameterInformation={}));var se;(function(de){function pe(z){return{label:z.label,documentation:z.documentation?g.fromStrict(z.documentation):void 0,parameters:Array.isArray(z.parameters)?z.parameters.map(q.from):[],activeParameter:z.activeParameter}}de.from=pe;function Y(z){return{label:z.label,documentation:E.isMarkdownString(z.documentation)?g.to(z.documentation):z.documentation,parameters:Array.isArray(z.parameters)?z.parameters.map(q.to):[],activeParameter:z.activeParameter}}de.to=Y})(se=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(de){function pe(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(se.from):[]}}de.from=pe;function Y(z){return{activeSignature:z.activeSignature,activeParameter:z.activeParameter,signatures:Array.isArray(z.signatures)?z.signatures.map(se.to):[]}}de.to=Y})(he=e.SignatureHelp||(e.SignatureHelp={}));var Re;(function(de){function pe(z){return{text:z.text,position:i.from(z.position),kind:Be.from(z.kind??_.InlayHintKind.Other),whitespaceBefore:z.whitespaceBefore,whitespaceAfter:z.whitespaceAfter}}de.from=pe;function Y(z){const we=new _.InlayHint(z.text,i.to(z.position),Be.to(z.kind));return we.whitespaceAfter=z.whitespaceAfter,we.whitespaceBefore=z.whitespaceBefore,we}de.to=Y})(Re=e.InlayHint||(e.InlayHint={}));var Be;(function(de){function pe(z){return z}de.from=pe;function Y(z){return z}de.to=Y})(Be=e.InlayHintKind||(e.InlayHintKind={}));var ze;(function(de){function pe(z){return{range:d.from(z.range),url:z.target,tooltip:z.tooltip}}de.from=pe;function Y(z){let we;if(z.url)try{we=typeof z.url=="string"?P.URI.parse(z.url,!0):P.URI.revive(z.url)}catch(Ie){}return new _.DocumentLink(d.to(z.range),we)}de.to=Y})(ze=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(de){function pe(z){const we=new _.ColorPresentation(z.label);return z.textEdit&&(we.textEdit=B.to(z.textEdit)),z.additionalTextEdits&&(we.additionalTextEdits=z.additionalTextEdits.map(Ie=>B.to(Ie))),we}de.to=pe;function Y(z){return{label:z.label,textEdit:z.textEdit?B.from(z.textEdit):void 0,additionalTextEdits:z.additionalTextEdits?z.additionalTextEdits.map(we=>B.from(we)):void 0}}de.from=Y})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var it;(function(de){function pe(z){return new _.Color(z[0],z[1],z[2],z[3])}de.to=pe;function Y(z){return[z.red,z.green,z.blue,z.alpha]}de.from=Y})(it=e.Color||(e.Color={}));var ke;(function(de){function pe(z){return{range:d.from(z.range)}}de.from=pe;function Y(z){return new _.SelectionRange(d.to(z.range))}de.to=Y})(ke=e.SelectionRange||(e.SelectionRange={}));var Ze;(function(de){function pe(Y){switch(Y){case 2:return _.TextDocumentSaveReason.AfterDelay;case 1:return _.TextDocumentSaveReason.Manual;case 3:case 4:return _.TextDocumentSaveReason.FocusOut}}de.to=pe})(Ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var j;(function(de){function pe(z){switch(z){case _.TextEditorLineNumbersStyle.Off:return 0;case _.TextEditorLineNumbersStyle.Relative:return 2;case _.TextEditorLineNumbersStyle.On:default:return 1}}de.from=pe;function Y(z){switch(z){case 0:return _.TextEditorLineNumbersStyle.Off;case 2:return _.TextEditorLineNumbersStyle.Relative;case 1:default:return _.TextEditorLineNumbersStyle.On}}de.to=Y})(j=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(de){function pe(z){if(z===_.EndOfLine.CRLF)return 1;if(z===_.EndOfLine.LF)return 0}de.from=pe;function Y(z){if(z===1)return _.EndOfLine.CRLF;if(z===0)return _.EndOfLine.LF}de.to=Y})(J=e.EndOfLine||(e.EndOfLine={}));var me;(function(de){function pe(Y){if(typeof Y=="object")return Y.viewId;switch(Y){case _.ProgressLocation.SourceControl:return 3;case _.ProgressLocation.Window:return 10;case _.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}de.from=pe})(me=e.ProgressLocation||(e.ProgressLocation={}));var He;(function(de){function pe(Y){const z={start:Y.start+1,end:Y.end+1};return Y.kind&&(z.kind=Ye.from(Y.kind)),z}de.from=pe})(He=e.FoldingRange||(e.FoldingRange={}));var Ye;(function(de){function pe(Y){if(Y)switch(Y){case _.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case _.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case _.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}de.from=pe})(Ye=e.FoldingRangeKind||(e.FoldingRangeKind={}));var st;(function(de){function pe(Y){if(Y)return{pinned:typeof Y.preview=="boolean"?!Y.preview:void 0,inactive:Y.background,preserveFocus:Y.preserveFocus,selection:typeof Y.selection=="object"?d.from(Y.selection):void 0,override:typeof Y.override=="boolean"?n.EditorResolution.DISABLED:void 0}}de.from=pe})(st=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ot;(function(de){function pe(z){return z instanceof _.RelativePattern||typeof z=="string"?z:Y(z)?new _.RelativePattern(z.base,z.pattern):z}de.from=pe;function Y(z){const we=z;return we&&typeof we.base=="string"&&typeof we.pattern=="string"}})(ot=e.GlobPattern||(e.GlobPattern={}));var Et;(function(de){function pe(Y){if(Y){if(Array.isArray(Y))return Y.map(pe);if(typeof Y=="string")return Y;{const z=Y;return{language:z.language,scheme:z.scheme,pattern:typeof z.pattern=="undefined"?void 0:ot.from(z.pattern),exclusive:z.exclusive}}}else return}de.from=pe})(Et=e.LanguageSelector||(e.LanguageSelector={}));var mt;(function(de){function pe(z){return{start:z.start,end:z.end}}de.from=pe;function Y(z){return new _.NotebookRange(z.start,z.end)}de.to=Y})(mt=e.NotebookRange||(e.NotebookRange={}));var Dt;(function(de){function pe(z){return{timing:typeof z.runStartTime=="number"&&typeof z.runEndTime=="number"?{startTime:z.runStartTime,endTime:z.runEndTime}:void 0,executionOrder:z.executionOrder,success:z.lastRunSuccess}}de.to=pe;function Y(z){return{lastRunSuccess:z.success,runStartTime:z.timing?.startTime,runEndTime:z.timing?.endTime,executionOrder:z.executionOrder}}de.from=Y})(Dt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Pt;(function(de){function pe(z){switch(z){case _.NotebookCellKind.Markup:return l.CellKind.Markup;case _.NotebookCellKind.Code:default:return l.CellKind.Code}}de.from=pe;function Y(z){switch(z){case l.CellKind.Markup:return _.NotebookCellKind.Markup;case l.CellKind.Code:default:return _.NotebookCellKind.Code}}de.to=Y})(Pt=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(de){function pe(z){const we={metadata:z.metadata??Object.create(null),cells:[]};for(let Ie of z.cells)_.NotebookCellData.validate(Ie),we.cells.push(Xe.from(Ie));return we}de.from=pe;function Y(z){const we=new _.NotebookData(z.cells.map(Xe.to));return(0,y.isEmptyObject)(z.metadata)||(we.metadata=z.metadata),we}de.to=Y})(It=e.NotebookData||(e.NotebookData={}));var Xe;(function(de){function pe(z){return{cellKind:Pt.from(z.kind),language:z.languageId,mime:z.mime,source:z.value,metadata:z.metadata,internalMetadata:Dt.from(z.executionSummary??{}),outputs:z.outputs?z.outputs.map(Te.from):[]}}de.from=pe;function Y(z){return new _.NotebookCellData(Pt.to(z.cellKind),z.source,z.language,z.mime,z.outputs?z.outputs.map(Te.to):void 0,z.metadata,z.internalMetadata?Dt.to(z.internalMetadata):void 0)}de.to=Y})(Xe=e.NotebookCellData||(e.NotebookCellData={}));var St;(function(de){function pe(z){return{mime:z.mime,valueBytes:M.VSBuffer.wrap(z.data)}}de.from=pe;function Y(z){return new _.NotebookCellOutputItem(z.valueBytes.buffer,z.mime)}de.to=Y})(St=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Te;(function(de){function pe(z){return{outputId:z.id,items:z.items.map(St.from),metadata:z.metadata}}de.from=pe;function Y(z){const we=z.items.map(St.to);return new _.NotebookCellOutput(we,z.outputId,z.metadata)}de.to=Y})(Te=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ye;(function(de){function pe(Ie){if(Ie!=null){if(Ie instanceof _.RelativePattern||typeof Ie=="string")return Ie;if(we(Ie))return new _.RelativePattern(Ie.base,Ie.pattern);if(z(Ie))return{include:ot.from(Ie.include)||void 0,exclude:ot.from(Ie.exclude)||void 0}}}de.from=pe;function Y(Ie){return typeof Ie=="string"?Ie:we(Ie)?{base:Ie.base,pattern:Ie.pattern}:{include:Ie.include,exclude:Ie.exclude}}de.to=Y;function z(Ie){const Je=Ie,Ue=ot.from(Je.include);if(!(Ue&&Ue instanceof _.RelativePattern||typeof Ue=="string"))return!1;const dt=ot.from(Je.exclude);return!!(dt&&dt instanceof _.RelativePattern||typeof dt=="string")}function we(Ie){const Je=Ie;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(ye=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ce;(function(de){function pe(Y){return{backgroundColor:Y.backgroundColor,borderColor:Y.borderColor,top:Y.top?L.from(Y.top):void 0}}de.from=pe})(Ce=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var te;(function(de){function pe(Y,z,we){const Ie=typeof Y.command=="string"?{title:"",command:Y.command}:Y.command;return{alignment:Y.alignment===_.NotebookCellStatusBarAlignment.Left?1:2,command:z.toInternal(Ie,we),text:Y.text,tooltip:Y.tooltip,accessibilityInformation:Y.accessibilityInformation,priority:Y.priority}}de.from=pe})(te=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var le;(function(de){function pe(Y){return{transientOutputs:Y?.transientOutputs??!1,transientCellMetadata:Y?.transientCellMetadata??{},transientDocumentMetadata:Y?.transientDocumentMetadata??{}}}de.from=pe})(le=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ge;(function(de){function pe(z){return{uri:z.uri,provides:z.provides}}de.from=pe;function Y(z){return new _.NotebookRendererScript(P.URI.revive(z.uri),z.provides)}de.to=Y})(ge=e.NotebookRendererScript||(e.NotebookRendererScript={}));var fe;(function(de){function pe(z){return{message:g.fromStrict(z.message)||"",type:0,expected:z.expectedOutput,actual:z.actualOutput,location:z.location?oe.from(z.location):void 0}}de.from=pe;function Y(z){const we=new _.TestMessage(typeof z.message=="string"?z.message:g.to(z.message));return we.actualOutput=z.actual,we.expectedOutput=z.expected,we.location=z.location?oe.to(z.location):void 0,we}de.to=Y})(fe=e.TestMessage||(e.TestMessage={}));var Pe;(function(de){let pe;(function(Y){Y.Delimiter="\0"})(pe||(pe={})),de.namespace=(Y,z)=>Y+"\0"+z,de.denamespace=Y=>{const z=Y.indexOf("\0");return{ctrlId:Y.slice(0,z),tagId:Y.slice(z+1)}}})(Pe=e.TestTag||(e.TestTag={}));var xe;(function(de){function pe(Ie){const Je=(0,o.getPrivateApiFor)(Ie).controllerId;return{extId:v.TestId.fromExtHostTestItem(Ie,Je).toString(),label:Ie.label,uri:Ie.uri,tags:Ie.tags.map(Ue=>Pe.namespace(Je,Ue.id)),range:d.from(Ie.range)||null,description:Ie.description||null,error:Ie.error&&g.fromStrict(Ie.error)||null}}de.from=pe;function Y(Ie){return{id:v.TestId.fromString(Ie.extId).localId,label:Ie.label,uri:P.URI.revive(Ie.uri),tags:(Ie.tags||[]).map(Je=>{const{tagId:Ue}=Pe.denamespace(Je);return new _.TestTag(Ue)}),range:d.to(Ie.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ie.description||void 0}}de.toPlain=Y;function z(Ie){const Je=v.TestId.fromString(Ie.extId),Ue=new o.TestItemImpl(Je.controllerId,Je.localId,Ie.label,P.URI.revive(Ie.uri));return Ue.range=d.to(Ie.range||void 0),Ue.description=Ie.description||void 0,Ue}function we(Ie){let Je;for(const Ue of Ie.tests){const dt=z(Ue.item);(0,o.getPrivateApiFor)(dt).parent=Je,Je=dt}return Je}de.toItemFromContext=we})(xe=e.TestItem||(e.TestItem={})),function(de){function pe(z){return{id:z.id}}de.from=pe;function Y(z){return new _.TestTag(z.id)}de.to=Y}(Pe=e.TestTag||(e.TestTag={}));var Oe;(function(de){const pe=(z,we)=>{const Ie={...xe.toPlain(z.item),parent:void 0,taskStates:z.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(Ue=>Ue.type===0).map(fe.to)})),children:z.children.map(Je=>we.get(Je)).filter(y.isDefined).map(Je=>pe(Je,we))};for(const Je of Ie.children)Je.parent=Ie;return Ie};function Y(z){const we=[],Ie=new Map;for(const Je of z.items)Ie.set(Je.item.extId,Je),z.request.targets.some(Ue=>Ue.controllerId===Je.controllerId&&Ue.testIds.includes(Je.item.extId))&&we.push(Je);return{completedAt:z.completedAt,results:we.map(Je=>pe(Je,Ie))}}de.to=Y})(Oe=e.TestResults||(e.TestResults={}));var Ke;(function(de){function pe(Ie){return{covered:Ie.covered,total:Ie.covered}}function Y(Ie){return"line"in Ie?i.from(Ie):d.from(Ie)}function z(Ie){return"branches"in Ie?{count:Ie.executionCount,location:Y(Ie.location),type:1,branches:Ie.branches.length?Ie.branches.map(Je=>({count:Je.executionCount,location:Je.location&&Y(Je.location)})):void 0}:{type:0,count:Ie.executionCount,location:Y(Ie.location)}}de.fromDetailed=z;function we(Ie){return{uri:Ie.uri,statement:pe(Ie.statementCoverage),branch:Ie.branchCoverage&&pe(Ie.branchCoverage),function:Ie.functionCoverage&&pe(Ie.functionCoverage),details:Ie.detailedCoverage?.map(z)}}de.fromFile=we})(Ke=e.TestCoverage||(e.TestCoverage={}));var tt;(function(de){function pe(Y){switch(Y){case 1:return _.CodeActionTriggerKind.Invoke;case 2:return _.CodeActionTriggerKind.Automatic}}de.to=pe})(tt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Le;(function(de){function pe(z){const we=new _.TypeHierarchyItem(H.to(z.kind),z.name,z.detail||"",P.URI.revive(z.uri),d.to(z.range),d.to(z.selectionRange));return we._sessionId=z._sessionId,we._itemId=z._itemId,we}de.to=pe;function Y(z,we,Ie){if(we=we??z._sessionId,Ie=Ie??z._itemId,we===void 0||Ie===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:Ie,kind:H.from(z.kind),name:z.name,detail:z.detail??"",uri:z.uri,range:d.from(z.range),selectionRange:d.from(z.selectionRange),tags:z.tags?.map(U.from)}}de.from=Y})(Le=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[170],Ee([0,1,2,16,7,8,231]),function(re,e,c,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(P,t,b,n={timeout:1500,errors:3}){this._logService=P,this._documents=t,this._mainThreadBulkEdits=b,this._thresholds=n,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(t,b,n)=>{const o={dispose:this._callbacks.push([t,b,P])};return Array.isArray(n)&&n.push(o),o}}async $participateInSave(P,t){const b=c.URI.revive(P);let n=!1;const f=setTimeout(()=>n=!0,this._thresholds.timeout),o=[];try{for(let l of[...this._callbacks]){if(n)break;const v=this._documents.getDocument(b),D=await this._deliverEventAsyncAndBlameBadListeners(l,{document:v,reason:A.TextDocumentSaveReason.to(t)});o.push(D)}}finally{clearTimeout(f)}return o}_deliverEventAsyncAndBlameBadListeners([P,t,b],n){const f=this._badListeners.get(P);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(b,P,t,n).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const l=this._badListeners.get(P);this._badListeners.set(P,l?l+1:1),typeof l=="number"&&l>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,t,b,n){const f=[],o=Date.now(),{document:l,reason:v}=n,{version:D}=l,_=Object.freeze({document:l,reason:v,waitUntil(a){if(Object.isFrozen(f))throw(0,M.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(a))}});try{t.apply(b,[_])}catch(a){return Promise.reject(a)}return Object.freeze(f),new Promise((a,d)=>{const S=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(S),a(i)}).catch(i=>{clearTimeout(S),d(i)})}).then(a=>{const d={edits:[]};for(const S of a)if(Array.isArray(S)&&S.every(i=>i instanceof E.TextEdit))for(const{newText:i,newEol:p,range:r}of S)d.edits.push({_type:2,resource:l.uri,edit:{range:r&&A.Range.from(r),text:i,eol:p&&A.EndOfLine.from(p)}});if(d.edits.length!==0)return D===l.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(be[171],Ee([0,1,3,27,2,8,7]),function(re,e,c,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(t,b,n,f,o){this._onDidCreate=new c.Emitter,this._onDidChange=new c.Emitter,this._onDidDelete=new c.Emitter,this._config=0,n&&(this._config+=1),f&&(this._config+=2),o&&(this._config+=4);const l=(0,M.parse)(b),v=t(D=>{if(!n)for(let _ of D.created){const a=E.URI.revive(_);l(a.fsPath)&&this._onDidCreate.fire(a)}if(!f)for(let _ of D.changed){const a=E.URI.revive(_);l(a.fsPath)&&this._onDidChange.fire(a)}if(!o)for(let _ of D.deleted){const a=E.URI.revive(_);l(a.fsPath)&&this._onDidDelete.fire(a)}});this._disposable=R.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class y{constructor(t,b,n){this._logService=b,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new c.Emitter,this._onDidRenameFile=new c.Emitter,this._onDidCreateFile=new c.Emitter,this._onDidDeleteFile=new c.Emitter,this._onWillRenameFile=new c.AsyncEmitter,this._onWillCreateFile=new c.AsyncEmitter,this._onWillDeleteFile=new c.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,b,n,f){return new C(this._onFileSystemEvent.event,t,b,n,f)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,b){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:b.map(n=>({oldUri:E.URI.revive(n.source),newUri:E.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:b.map(n=>E.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:b.map(n=>E.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,b){return(n,f,o)=>{const l=function(D){n.call(f,D)};return l.extension=t,b.event(l,void 0,o)}}async $onWillRunFileOperation(t,b,n,f){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:b.map(o=>({oldUri:E.URI.revive(o.source),newUri:E.URI.revive(o.target)}))},n,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:b.map(o=>E.URI.revive(o.target))},n,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:b.map(o=>E.URI.revive(o.target))},n,f)}}async _fireWillEvent(t,b,n,f){const o=new Set,l=[];if(await t.fireAsync(b,f,async(D,_)=>{const a=Date.now(),d=await Promise.resolve(D);d instanceof R.WorkspaceEdit&&(l.push(d),o.add(_.extension.displayName??_.extension.identifier.value)),Date.now()-a>n&&this._logService.warn("SLOW file-participant",_.extension.identifier)}),f.isCancellationRequested||l.length===0)return;const v={edits:[]};for(let D of l){let{edits:_}=A.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(_)}return{edit:v,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=y}),define(be[172],Ee([0,1,11,23,2,8,7,89]),function(re,e,c,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(n,f,o,l){this.start=n,this.deletedCount=f,this.deletedItems=o,this.items=l}static asApiEvents(n){return n.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(o=>o.apiCell)}))}}class P{constructor(n,f,o){this.notebook=n,this._extHostDocument=f,this._cellData=o,this.handle=o.handle,this.uri=E.URI.revive(o.uri),this.cellKind=o.cellKind,this._outputs=o.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=o.internalMetadata??{},this._metadata=Object.freeze(o.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(o.internalMetadata??{}))}static asModelAddData(n,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return n._mime},set mime(o){n._mime=o},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(A.NotebookCellOutput.to)}setOutputItems(n,f,o){const l=o.map(A.NotebookCellOutputItem.to),v=this._outputs.find(D=>D.id===n);v&&(f||(v.items.length=0),v.items.push(...l))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=P;class t{constructor(n,f,o,l,v,D){this._proxy=n,this._textDocumentsAndEditors=f,this._textDocuments=o,this._emitter=l,this.uri=v,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=D.viewType,this._metadata=Object.freeze(D.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,D.cells]],!0),this._versionId=D.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===c.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(f){return f=n._validateIndex(f),n._cells[f].apiCell},getCells(f){return(f?n._getCells(f):n._cells).map(l=>l.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,f){this._versionId=n.versionId,this._isDirty=f;for(const o of n.rawEvents)o.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1):o.kind===C.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx):o.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(o.index,o.outputs):o.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems):o.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(o.index,o.language):o.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(o.index,o.metadata):o.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(o.index,o.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let f=n.start|0,o=n.end|0;return f<0&&(f=0),o>this._cells.length&&(o=this._cells.length),n.with({start:f,end:o})}_getCells(n){n=this._validateRange(n);const f=[];for(let o=n.start;o<n.end;o++)f.push(this._cells[o]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,f){if(this._disposed)return;const o=[],l=[],v=[];n.reverse().forEach(D=>{const a=D[2].map(i=>{const p=new P(this,this._textDocumentsAndEditors,i);return f||l.push(P.asModelAddData(this.apiNotebook,i)),p}),d=new y(D[0],D[1],[],a),S=this._cells.splice(D[0],D[1],...a);for(const i of S)v.push(i.uri),d.deletedItems.push(i.apiCell);o.push(d)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:v}),f||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(o)}))}_moveCell(n,f){const o=this._cells.splice(n,1);this._cells.splice(f,0,...o);const l=[new y(n,1,o.map(v=>v.apiCell),[]),new y(f,0,[],o)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(l)}))}_setCellOutputs(n,f){const o=this._cells[n];o.setOutputs(f),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[o.apiCell]}))}_setCellOutputItems(n,f,o,l){const v=this._cells[n];v.setOutputItems(f,o,l),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[v.apiCell]}))}_changeCellLanguage(n,f){const o=this._cells[n];o.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(o.uri,f)}_changeCellMime(n,f){const o=this._cells[n];o.apiCell.mime=f}_changeCellMetadata(n,f){const o=this._cells[n],l=o.apiCell.metadata;o.setMetadata(f);const v=o.apiCell.metadata;(0,M.equals)(l,v)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:o.apiCell}))}_changeCellInternalMetadata(n,f){const o=this._cells[n],l=o.internalMetadata;if(o.setInternalMetadata(f),l.runState!==f.runState){const v=f.runState??R.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:o.apiCell,state:v}))}}getCellFromApiCell(n){return this._cells.find(f=>f.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(f=>f.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(be[93],Ee([0,1,7,8,16]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:P})}replaceCells(y,P,t){this._throwIfFinalized(),!(y===P&&t.length===0)&&this._collectedEdits.push({editType:1,index:y,count:P-y,cells:t.map(M.NotebookCellData.from)})}}class R{constructor(y,P,t,b,n,f){this.id=y,this._proxy=P,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=b,this._viewColumn=f}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(P){if(!Array.isArray(P)||!P.every(c.NotebookRange.isNotebookRange))throw(0,E.illegalArgument)("selections");y._selections=P,y._trySetSelections(P)},get visibleRanges(){return y._visibleRanges},revealRange(P,t){y._proxy.$tryRevealRange(y.id,M.NotebookRange.from(P),t??c.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(P){const t=new A(this.document.version);return P(t),y._applyEdit(t.finalize())},setDecorations(P,t){return y.setDecorations(P,t)}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(M.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const P=[];let t=-1;for(let b=0;b<y.cellEdits.length;b++){if(t<0){P.push(y.cellEdits[b]),t++;continue}const f=P[t],o=y.cellEdits[b];if(f.editType===1&&o.editType===1&&f.index===o.index){f.cells.push(...y.cellEdits[b].cells),f.count+=y.cellEdits[b].count;continue}P.push(y.cellEdits[b]),t++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,P)}setDecorations(y,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return P.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(P),y.key)}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(be[173],Ee([0,1,8,147,126,21,52]),function(re,e,c,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(b){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=b}withProgress(b,n,f){const o=this._handles++,{title:l,location:v,cancellable:D}=n,_={label:(0,E.localize)(0,null,b.displayName||b.name),id:b.identifier.value};return this._proxy.$startProgress(o,{location:c.ProgressLocation.from(v),title:l,source:_,cancellable:D},b),this._withProgress(o,f,!!D)}_withProgress(b,n,f){let o;f&&(o=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(b,o));const l=D=>{this._proxy.$progressEnd(D),this._mapHandleToCancellationSource.delete(D),o&&o.dispose()};let v;try{v=n(new P(this._proxy,b),f&&o?o.token:A.CancellationToken.None)}catch(D){throw l(b),D}return v.then(D=>l(b),D=>l(b)),v}$acceptProgressCanceled(b){const n=this._mapHandleToCancellationSource.get(b);n&&(n.cancel(),this._mapHandleToCancellationSource.delete(b))}}e.ExtHostProgress=C;function y(t,b){return t.message=b.message,typeof b.increment=="number"&&(typeof t.increment=="number"?t.increment+=b.increment:t.increment=b.increment),t}class P extends M.Progress{constructor(b,n){super(f=>this.throttledReport(f));this._proxy=b,this._handle=n}throttledReport(b){this._proxy.$progressReport(this._handle,b)}}$e([(0,R.throttle)(100,(t,b)=>y(t,b),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(be[94],Ee([0,1,42,16,53,8,7]),function(re,e,c,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(n,f,o){const l=C._Keys.nextId();n.$registerTextEditorDecorationType(f.identifier,l,A.DecorationRenderOptions.from(o)),this.value=Object.freeze({key:l,dispose(){n.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=C,C._Keys=new E.IdGenerator("TextEditorDecorationType");class y{constructor(n,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,f){this._throwIfFinalized();let o=null;if(n instanceof R.Position)o=new R.Range(n,n);else if(n instanceof R.Range)o=n;else throw new Error("Unrecognized location");this._pushEdit(o,f,!1)}insert(n,f){this._throwIfFinalized(),this._pushEdit(new R.Range(n,n),f,!0)}delete(n){this._throwIfFinalized();let f=null;if(n instanceof R.Range)f=n;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(n,f,o){const l=this._document.validateRange(n);this._collectedEdits.push({range:l,text:f,forceMoveMarkers:o})}setEndOfLine(n){if(this._throwIfFinalized(),n!==R.EndOfLine.LF&&n!==R.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=y;class P{constructor(n,f,o,l){this._proxy=n,this._id=f,this._accept(o),this._logService=l;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(D){v._setTabSize(D)},get insertSpaces(){return v._insertSpaces},set insertSpaces(D){v._setInsertSpaces(D)},get cursorStyle(){return v._cursorStyle},set cursorStyle(D){v._setCursorStyle(D)},get lineNumbers(){return v._lineNumbers},set lineNumbers(D){v._setLineNumbers(D)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const f=Math.floor(n);return f>0?f:null}if(typeof n=="string"){const f=parseInt(n,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(n){const f=this._validateTabSize(n);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const f=this._validateInsertSpaces(n);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(n)})))}assign(n){const f={};let o=!1;if(typeof n.tabSize!="undefined"){const l=this._validateTabSize(n.tabSize);l==="auto"?(o=!0,f.tabSize=l):typeof l=="number"&&this._tabSize!==l&&(this._tabSize=l,o=!0,f.tabSize=l)}if(typeof n.insertSpaces!="undefined"){const l=this._validateInsertSpaces(n.insertSpaces);l==="auto"?(o=!0,f.insertSpaces=l):this._insertSpaces!==l&&(this._insertSpaces=l,o=!0,f.insertSpaces=l)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,o=!0,f.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,o=!0,f.lineNumbers=A.TextEditorLineNumbersStyle.from(n.lineNumbers)),o&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(n){n.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=P;class t{constructor(n,f,o,l,v,D,_,a){this.id=n,this._proxy=f,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new P(this._proxy,this.id,D,o),this._visibleRanges=_,this._viewColumn=a;const d=this;this.value=Object.freeze({get document(){return l.getValue()},set document(S){throw(0,M.readonly)("document")},get selection(){return d._selections&&d._selections[0]},set selection(S){if(!(S instanceof R.Selection))throw(0,M.illegalArgument)("selection");d._selections=[S],d._trySetSelection()},get selections(){return d._selections},set selections(S){if(!Array.isArray(S)||S.some(i=>!(i instanceof R.Selection)))throw(0,M.illegalArgument)("selections");d._selections=S,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(S){throw(0,M.readonly)("visibleRanges")},get options(){return d._options.value},set options(S){d._disposed||d._options.assign(S)},get viewColumn(){return d._viewColumn},set viewColumn(S){throw(0,M.readonly)("viewColumn")},edit(S,i={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const p=new y(l.getValue(),i);return S(p),d._applyEdit(p)},insertSnippet(S,i,p={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=d._selections.map(s=>A.Range.from(s));else if(i instanceof R.Position){const{lineNumber:s,column:u}=A.Position.from(i);r=[{startLineNumber:s,startColumn:u,endLineNumber:s,endColumn:u}]}else if(i instanceof R.Range)r=[A.Range.from(i)];else{r=[];for(const s of i)if(s instanceof R.Range)r.push(A.Range.from(s));else{const{lineNumber:u,column:h}=A.Position.from(s);r.push({startLineNumber:u,startColumn:h,endLineNumber:u,endColumn:h})}}return f.$tryInsertSnippet(n,S.value,r,p)},setDecorations(S,i){const p=i.length===0;p&&!d._hasDecorationsForKey.has(S.key)||(p?d._hasDecorationsForKey.delete(S.key):d._hasDecorationsForKey.add(S.key),d._runOnProxy(()=>{if(A.isDecorationOptionsArr(i))return f.$trySetDecorations(n,S.key,A.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let s=0,u=i.length;s<u;s++){const h=i[s];r[4*s]=h.start.line+1,r[4*s+1]=h.start.character+1,r[4*s+2]=h.end.line+1,r[4*s+3]=h.end.character+1}return f.$trySetDecorationsFast(n,S.key,r)}}))},revealRange(S,i){d._runOnProxy(()=>f.$tryRevealRange(n,A.Range.from(S),i||R.TextEditorRevealType.Default))},show(S){f.$tryShowEditor(n,A.ViewColumn.from(S))},hide(){f.$tryHideEditor(n)}})}dispose(){(0,c.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,c.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,c.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,c.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,c.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const f=n.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const o=f.edits.map(v=>v.range);o.sort((v,D)=>v.end.line===D.end.line?v.end.character===D.end.character?v.start.line===D.start.line?v.start.character-D.start.character:v.start.line-D.start.line:v.end.character-D.end.character:v.end.line-D.end.line);for(let v=0,D=o.length-1;v<D;v++){const _=o[v].end;if(o[v+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=f.edits.map(v=>({range:A.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,l,{setEndOfLine:typeof f.setEndOfLine=="number"?A.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=t}),define(be[174],Ee([0,1,129,24,2,3,6,162,14,7,10,13,8,21,159]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function l(_,a){if((0,t.isString)(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let d;return Array.isArray(_.highlights)&&(d=_.highlights.filter(S=>S.length===2&&typeof S[0]=="number"&&typeof S[1]=="number"),d=d.length?d:void 0),{label:_.label,highlights:d}}}class v{constructor(a,d,S){this._proxy=a,this.commands=d,this.logService=S,this.treeViews=new Map;function i(p){return p&&p.$treeViewId&&p.$treeItemHandle}d.registerArgumentProcessor({processArgument:p=>i(p)?this.convertArgument(p):Array.isArray(p)&&p.length>0?p.map(r=>i(r)?this.convertArgument(r):r):p})}registerTreeDataProvider(a,d,S){const i=this.createTreeView(a,{treeDataProvider:d},S);return{dispose:()=>i.dispose()}}createTreeView(a,d,S){if(!d||!d.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=d.dragAndDropController!==void 0,p=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!d.showCollapseAll,canSelectMany:!!d.canSelectMany,canDragAndDrop:i}),r=this.createExtHostTreeView(a,d,S);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(s){r.message=s},get title(){return r.title},set title(s){r.title=s},get description(){return r.description},set description(s){r.description=s},reveal:(s,u)=>r.reveal(s,u),dispose:async()=>{await p,this.treeViews.delete(a),r.dispose()}}}$getChildren(a,d){const S=this.treeViews.get(a);return S?S.getChildren(d):Promise.reject(new Error((0,c.localize)(0,null,a)))}async $onDrop(a,d,S){const i=this.treeViews.get(a);if(!i)return Promise.reject(new Error((0,c.localize)(1,null,a)));const p=o.TreeDataTransferConverter.toITreeDataTransfer(d);if(p.items.has(C.TREE_ITEM_DATA_TRANSFER_TYPE)){const s=JSON.parse(await p.items.get(C.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(u=>i.getExtensionElement(u)).filter(u=>!!u);s.length>0?p.items.set(C.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(s)}):p.items.delete(C.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(p,S)}async $hasResolve(a){const d=this.treeViews.get(a);if(!d)throw new Error((0,c.localize)(2,null,a));return d.hasResolve}$resolve(a,d,S){const i=this.treeViews.get(a);if(!i)throw new Error((0,c.localize)(3,null,a));return i.resolveTreeItem(d,S)}$setExpanded(a,d,S){const i=this.treeViews.get(a);if(!i)throw new Error((0,c.localize)(4,null,a));i.setExpanded(d,S)}$setSelection(a,d){const S=this.treeViews.get(a);if(!S)throw new Error((0,c.localize)(5,null,a));S.setSelection(d)}$setVisible(a,d){const S=this.treeViews.get(a);if(!S)throw new Error((0,c.localize)(6,null,a));S.setVisible(d)}createExtHostTreeView(a,d,S){const i=new D(a,d,this._proxy,this.commands.converter,this.logService,S);return this.treeViews.set(a,i),i}convertArgument(a){const d=this.treeViews.get(a.$treeViewId);return d?d.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=v;class D extends R.Disposable{constructor(a,d,S,i,p,r){super();if(this.viewId=a,this.proxy=S,this.commands=i,this.logService=p,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new f.CancellationTokenSource,r.contributes&&r.contributes.views)for(const h in r.contributes.views)for(const m of r.contributes.views[h])m.id===a&&(this._title=m.name);this.dataProvider=d.treeDataProvider,this.dndController=d.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(h=>this._onDidChangeData.fire({message:!1,element:h}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(h=>this._onDidChangeData.fire({message:!1,element:h})));let s,u;this._register(A.Event.debounce(this._onDidChangeData.event,(h,m)=>(h||(h={message:!1,elements:[]}),m.element!==!1&&(s||(s=new Promise(k=>u=k),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(m.element)?h.elements.push(...m.element):h.elements.push(m.element)),m.message&&(h.message=!0),h),200,!0)(({message:h,elements:m})=>{m.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const k=u;return s=null,this.refresh(m).then(()=>k())})),h&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,t.isUndefinedOrNull)(a))}async getChildren(a){const d=a?this.getExtensionElement(a):void 0;if(a&&!d)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let S=this.getChildrenNodes(a);return S||(S=await this.fetchChildrenNodes(d)),S?S.map(i=>i.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,d){d=d||{select:!0,focus:!1};const S=(0,t.isUndefinedOrNull)(d.select)?!0:d.select,i=(0,t.isUndefinedOrNull)(d.focus)?!1:d.focus,p=(0,t.isUndefinedOrNull)(d.expand)?!1:d.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(r=>this.resolveTreeNode(a,r[r.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:r.map(u=>u.item)},{select:S,focus:i,expand:p})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:S,focus:i,expand:p})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,d){const S=this.getExtensionElement(a);S&&(d?this._onDidExpandElement.fire(Object.freeze({element:S})):this._onDidCollapseElement.fire(Object.freeze({element:S})))}setSelection(a){(0,b.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(a,d){const S=this.getExtensionElement(d);if(!!S)return(0,y.asPromise)(()=>this.dndController?.onDrop(a,S))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,d){if(!this.dataProvider.resolveTreeItem)return;const S=this.elements.get(a);if(S){const i=this.nodes.get(S);if(i){const p=await this.dataProvider.resolveTreeItem(i.extensionItem,S,d)??i.extensionItem;return i.item.tooltip=this.getTooltip(p.tooltip),i.item.command=this.getCommand(i.disposableStore,p.command),i.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(d=>d?this.resolveUnknownParentChain(d).then(S=>this.resolveTreeNode(d,S[S.length-1]).then(i=>(S.push(i),S))):Promise.resolve([]))}resolveParent(a){const d=this.nodes.get(a);return d?Promise.resolve(d.parent?this.elements.get(d.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,d){const S=this.nodes.get(a);return S?Promise.resolve(S):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(i=>this.createHandle(a,i,d,!0)).then(i=>this.getChildren(d?d.item.handle:void 0).then(()=>{const p=this.getExtensionElement(i);if(p){const r=this.nodes.get(p);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(a){if(a){let d;if(typeof a=="string"){const S=this.getExtensionElement(a);d=S?this.nodes.get(S):void 0}else d=a;return d&&d.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const d=new f.CancellationTokenSource(this._refreshCancellationSource.token);try{const S=a?this.nodes.get(a):void 0,i=await this.dataProvider.getChildren(a);if(d.token.isCancellationRequested)return;const p=await Promise.all((0,b.coalesce)(i||[]).map(async r=>{const s=await this.dataProvider.getTreeItem(r);return s&&!d.token.isCancellationRequested?this.createAndRegisterTreeNode(r,s,S):null}));return d.token.isCancellationRequested?void 0:(0,b.coalesce)(p)}finally{d.dispose()}}refresh(a){if(a.some(S=>!S))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new f.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const S=this.getHandlesToRefresh(a);if(S.length)return this.refreshHandles(S)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const d=new Set,S=a.map(p=>this.nodes.get(p));for(const p of S)if(p&&!d.has(p.item.handle)){let r=p;for(;r&&r.parent&&S.findIndex(s=>r&&r.parent&&s&&s.item.handle===r.parent.item.handle)===-1;){const s=this.elements.get(r.parent.item.handle);r=s?this.nodes.get(s):void 0}r&&!r.parent&&d.add(p.item.handle)}const i=[];return d.forEach(p=>{const r=this.elements.get(p);if(r){const s=this.nodes.get(r);s&&(!s.parent||!d.has(s.parent.item.handle))&&i.push(p)}}),i}refreshHandles(a){const d={};return Promise.all(a.map(S=>this.refreshNode(S).then(i=>{i&&(d[S]=i.item)}))).then(()=>Object.keys(d).length?this.proxy.$refresh(this.viewId,d):void 0)}refreshNode(a){const d=this.getExtensionElement(a);if(d){const S=this.nodes.get(d);if(S)return this.clearChildren(d),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(i=>{if(i){const p=this.createTreeNode(d,i,S.parent);return this.updateNodeCache(d,p,S,S.parent),S.dispose(),p}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,d,S){const i=this.createTreeNode(a,d,S);if(d.id&&this.elements.has(i.item.handle))throw new Error((0,c.localize)(7,null,d.id));return this.addNodeToCache(a,i),this.addNodeToParentCache(i,S),i}getTooltip(a){return P.MarkdownString.isMarkdownString(a)?n.MarkdownString.from(a):a}getCommand(a,d){return d?this.commands.toInternal(d,a):void 0}createTreeNode(a,d,S){const i=new R.DisposableStore,p=this.createHandle(a,d,S),r=this.getLightIconPath(d);return{item:{handle:p,parentHandle:S?S.item.handle:void 0,label:l(d.label,this.extension),description:d.description,resourceUri:d.resourceUri,tooltip:this.getTooltip(d.tooltip),command:this.getCommand(i,d.command),contextValue:d.contextValue,icon:r,iconDark:this.getDarkIconPath(d)||r,themeIcon:this.getThemeIcon(d),collapsibleState:(0,t.isUndefinedOrNull)(d.collapsibleState)?P.TreeItemCollapsibleState.None:d.collapsibleState,accessibilityInformation:d.accessibilityInformation},extensionItem:d,parent:S,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(a){return a.iconPath instanceof P.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:d,label:S,resourceUri:i},p,r){if(d)return`${D.ID_HANDLE_PREFIX}/${d}`;const s=l(S,this.extension),u=p?p.item.handle:D.LABEL_HANDLE_PREFIX;let h=s?s.label:i?(0,M.basename)(i):"";h=h.indexOf("/")!==-1?h.replace("/","//"):h;const m=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,k=this.getChildrenNodes(p)||[];let T,g=0;do{if(T=`${u}/${g}:${h}`,r||!this.elements.has(T)||m===T)break;g++}while(g<=k.length);return T}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof P.ThemeIcon))return typeof a.iconPath=="string"||E.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof P.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return E.URI.isUri(a)?a:E.URI.file(a)}addNodeToCache(a,d){this.elements.set(d.item.handle,a),this.nodes.set(a,d)}updateNodeCache(a,d,S,i){this.elements.delete(d.item.handle),this.nodes.delete(a),d.item.handle!==S.item.handle&&this.elements.delete(S.item.handle),this.addNodeToCache(a,d);const p=this.getChildrenNodes(i)||[],r=p.filter(s=>s.item.handle===S.item.handle)[0];r&&p.splice(p.indexOf(r),1,d)}addNodeToParentCache(a,d){d?(d.children||(d.children=[]),d.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const d=this.nodes.get(a);if(d){if(d.children)for(const S of d.children){const i=this.elements.get(S.item.handle);i&&this.clear(i)}d.children=void 0}}else this.clearAll()}clear(a){const d=this.nodes.get(a);if(d){if(d.children)for(const S of d.children){const i=this.elements.get(S.item.handle);i&&this.clear(i)}this.nodes.delete(a),this.elements.delete(d.item.handle),d.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}D.LABEL_HANDLE_PREFIX="0",D.ID_HANDLE_PREFIX="1"}),define(be[175],Ee([0,1,14,3,6,10,48,8,90,67]),function(re,e,c,M,E,A,R,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends E.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new R.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const f=this.diff[this.diff.length-1];if(f&&n[0]===1){if(f[0]===1&&f[1].extId===n[1].extId){(0,y.applyTestItemUpdate)(f[1],n[1]);return}if(f[0]===0&&f[1].item.extId===n[1].extId){(0,y.applyTestItemUpdate)(f[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,f){const o=this.tree.get(n);if(!!o){if((o.expandLevels===void 0||f>o.expandLevels)&&(o.expandLevels=f),o.expand===1){const l=this.resolveChildren(o);return l.isOpen()?this.expandChildren(o,f-1):l.wait().then(()=>this.expandChildren(o,f-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.expandChildren(o,f-1)):this.expandChildren(o,f-1)}}dispose(){for(const n of this.tree.values())(0,R.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,f){switch(f.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(n.fullId,f.id));break;case 0:this.upsertItem(f.item,n);break;case 4:for(const _ of f.ops)this.onTestItemEvent(n,_);break;case 3:const{key:o,value:l,previous:v}=f,D=n.fullId.toString();switch(o){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(l,v,D);break;case"range":this.pushDiff([1,{extId:D,item:{range:C.Range.from(l)}}]);break;case"error":this.pushDiff([1,{extId:D,item:{error:C.MarkdownString.fromStrict(l)||null}}]);break;default:this.pushDiff([1,{extId:D,item:{[o]:l??null}}]);break}break;default:(0,A.assertNever)(f)}}upsertItem(n,f){if(!(n instanceof R.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const o=P.TestId.fromExtHostTestItem(n,this.root.id,f?.actual),l=(0,R.getPrivateApiFor)(n);l.parent&&l.parent!==f?.actual&&l.parent.children.delete(n.id);let v=this.tree.get(o.toString());if(!v){v={fullId:o,actual:n,parent:f?o.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(v.fullId.toString(),v),this.setItemParent(n,f),this.pushDiff([0,{parent:v.parent&&v.parent.toString(),controllerId:this.controllerId,expand:v.expand,item:C.TestItem.from(n)}]),this.connectItemAndChildren(n,v,f);return}if(v.actual===n){this.connectItem(n,v,f);return}const D=v.actual.children,_=v.actual,a=(0,R.diffTestItems)(_,n);(0,R.getPrivateApiFor)(_).listener=void 0,v.actual=n,v.expand=0;for(const[d,S]of a)this.onTestItemEvent(v,{op:3,key:d,value:S,previous:_[d]});this.connectItemAndChildren(n,v,f);for(const d of D)n.children.get(d.id)||this.removeItem(P.TestId.joinToString(o,d.id))}diffTagRefs(n,f,o){const l=new Set(f.map(v=>v.id));for(const v of n)l.delete(v.id)||this.incrementTagRefs(v);this.pushDiff([1,{extId:o,item:{tags:n.map(v=>C.TestTag.namespace(this.controllerId,v.id))}}]),l.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const f=this.tags.get(n.id);f?f.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:C.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const f=this.tags.get(n);f&&!--f.refCount&&(this.tags.delete(n),this.pushDiff([6,C.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,f){(0,R.getPrivateApiFor)(n).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(n,f,o){this.setItemParent(n,o);const l=(0,R.getPrivateApiFor)(n);l.parent=o?.actual,l.listener=v=>this.onTestItemEvent(f,v),this.updateExpandability(f)}connectItemAndChildren(n,f,o){this.connectItem(n,f,o);for(const l of n.children)this.upsertItem(l,f)}updateExpandability(n){let f;this._resolveHandler?n.resolveBarrier?f=n.resolveBarrier.isOpen()?3:2:f=n.actual.canResolveChildren?1:0:f=0,f!==n.expand&&(n.expand=f,this.pushDiff([1,{extId:n.fullId.toString(),expand:f}]),f===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,f){if(f<0)return;const o=[];for(const l of n.actual.children){const v=this.expand(P.TestId.joinToString(n.fullId,l.id),f);(0,c.isThenable)(v)&&o.push(v)}if(o.length)return Promise.all(o).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const v=new c.Barrier;return v.open(),v}n.expand=2,this.pushExpandStateUpdate(n);const f=n.resolveBarrier=new c.Barrier,o=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=v.stack||v.message||String(v))};let l;try{l=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(v){o(v)}return(0,c.isThenable)(l)?l.catch(o).then(()=>{f.open(),this.updateExpandability(n)}):(f.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const f=this.tree.get(n);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const o=[f];for(;o.length;){const l=o.pop();if(!!l){(0,R.getPrivateApiFor)(l.actual).listener=void 0;for(const v of l.actual.tags)this.decrementTagRefs(v.id);this.tree.delete(l.fullId.toString());for(const v of l.actual.children)o.push(this.tree.get(P.TestId.joinToString(l.fullId,v.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(be[176],Ee([0,1,4,142]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(M.IEnvironmentService)}),define(be[177],Ee([0,1,26,3,17]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=A;class R{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(c.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(c.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let b of t.activationEvents)b==="onUri"&&(b=`onUri:${c.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(b)||this._activationMap.set(b,[]),this._activationMap.get(b).push(t)}}keepOnly(t){const b=new Set;t.forEach(n=>b.add(c.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>b.has(c.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,b){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=R._findLoopingExtensions(this._extensionDescriptions);if(b=b.concat(n.map(f=>f.identifier)),b.length>0){const f=new Set;b.forEach(o=>f.add(c.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!f.has(c.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(n)}static _findLoopingExtensions(t){const b=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,D){this.addNode(v),this.addNode(D),this._arcs.has(v)?this._arcs.get(v).push(D):this._arcs.set(v,[D])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,D){const _=b.getArcs(v);for(let a=0;a<_.length;a++)if(!D.has(_[a]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let v of t){const D=c.ExtensionIdentifier.toKey(v.identifier);if(n.set(D,v),v.extensionDependencies)for(let _ of v.extensionDependencies){const a=c.ExtensionIdentifier.toKey(_);b.addArc(D,a)}}let f=new Set;b.getNodes().filter(v=>b.getArcs(v).length===0).forEach(v=>f.add(v));let o=b.getNodes().filter(v=>!f.has(v)),l;do{l=!1;for(let v=0;v<o.length;v++){const D=o[v];b.hasOnlyGoodArcs(D,f)&&(o.splice(v,1),v--,f.add(D),l=!0)}}while(l);return o.map(v=>n.get(v))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(c.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const b=this._activationMap.get(t);return b?b.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const b=this._extensionsMap.get(c.ExtensionIdentifier.toKey(t));return b||void 0}}e.ExtensionDescriptionRegistry=R;var C;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(C||(C={}));function y(P,t){const b=P.isBuiltin?0:P.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(b!==n)return b-n;const f=E.posix.basename(P.extensionLocation.path),o=E.posix.basename(t.extensionLocation.path);return f<o?-1:f>o?1:0}}),define(be[178],Ee([0,1,22]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var E;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(E=e.MessageType||(e.MessageType={}));function A(C){const y=c.VSBuffer.alloc(1);switch(C){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=A;function R(C,y){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=R}),define(be[30],Ee([0,1,3,2,4,26,143]),function(re,e,c,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");var C;(function(d){d[d.None=0]="None",d[d.LocalProcess=1]="LocalProcess",d[d.LocalWebWorker=2]="LocalWebWorker",d[d.Remote=3]="Remote"})(C=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function y(d){switch(d){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=y;class P{constructor(S){this.dependency=S}}e.MissingExtensionDependency=P;var t;(function(d){d[d.LocalProcess=0]="LocalProcess",d[d.LocalWebWorker=1]="LocalWebWorker",d[d.Remote=2]="Remote"})(t=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(d){switch(d){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=b;class n{constructor(S,i,p,r){this.codeLoadingTime=S,this.activateCallTime=i,this.activateResolvedTime=p,this.activationReason=r}}e.ActivationTimes=n;class f{constructor(S,i){this.description=S,this.value=i}}e.ExtensionPointContribution=f,e.ExtensionHostLogFileName="exthost";var o;(function(d){d[d.Normal=0]="Normal",d[d.Immediate=1]="Immediate"})(o=e.ActivationKind||(e.ActivationKind={}));function l(d){d.enableProposedApi||v(d)}e.checkProposedApiEnabled=l;function v(d){throw new Error(`[${d.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`)}e.throwProposedApiError=v;function D(d){return{type:d.isBuiltin?0:1,isBuiltin:d.isBuiltin||d.isUserBuiltin,identifier:{id:(0,R.getGalleryExtensionId)(d.publisher,d.name),uuid:d.uuid},manifest:d,location:d.extensionLocation}}e.toExtension=D;function _(d,S){return{identifier:new A.ExtensionIdentifier(d.identifier.id),isBuiltin:d.type===0,isUserBuiltin:d.type===1&&d.isBuiltin,isUnderDevelopment:!!S,extensionLocation:d.location,...d.manifest,uuid:d.identifier.uuid}}e.toExtensionDescription=_;class a{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(S,i){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,i,p,r,s){}_onDidActivateExtensionError(S,i){}_onExtensionRuntimeError(S,i){}_onExtensionHostExit(S){}}e.NullExtensionService=a}),define(be[179],Ee([0,1,26,30,15]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class R{constructor(o,l,v,D){this.startup=o,this.codeLoadingTime=l,this.activateCallTime=v,this.activateResolvedTime=D}}e.ExtensionActivationTimes=R,R.NONE=new R(!1,-1,-1,-1);class C{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,l){return o===-1||l===-1?-1:l-o}build(){return new R(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class y{constructor(o,l,v,D,_,a){this.activationFailed=o,this.activationFailedError=l,this.activationTimes=v,this.module=D,this.exports=_,this.subscriptions=a}}e.ActivatedExtension=y;class P extends y{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class t extends y{constructor(){super(!1,null,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class b extends y{constructor(o){super(!0,o,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=b;let n=class{constructor(o,l,v,D,_){this._logService=_,this._registry=o,this._resolvedExtensionsSet=new Set,l.forEach(a=>this._resolvedExtensionsSet.add(c.ExtensionIdentifier.toKey(a))),this._hostExtensionsMap=new Map,v.forEach(a=>this._hostExtensionsMap.set(c.ExtensionIdentifier.toKey(a),a)),this._host=D,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(o){const l=c.ExtensionIdentifier.toKey(o);return this._activatedExtensions.has(l)}getActivatedExtension(o){const l=c.ExtensionIdentifier.toKey(o),v=this._activatedExtensions.get(l);if(!v)throw new Error("Extension `"+o.value+"` is not known or not activated");return v}activateByEvent(o,l){if(this._alreadyActivatedEvents[o])return A;const v=this._registry.getExtensionDescriptionsForActivationEvent(o);return this._activateExtensions(v.map(D=>({id:D.identifier,reason:{startup:l,extensionId:D.identifier,activationEvent:o}}))).then(()=>{this._alreadyActivatedEvents[o]=!0})}activateById(o,l){const v=this._registry.getExtensionDescription(o);if(!v)throw new Error("Extension `"+o+"` is not known");return this._activateExtensions([{id:v.identifier,reason:l}])}_handleActivateRequest(o,l,v){if(this._hostExtensionsMap.has(c.ExtensionIdentifier.toKey(o.id))){l[c.ExtensionIdentifier.toKey(o.id)]=o;return}const D=this._registry.getExtensionDescription(o.id);if(!D){const d=new Error(`Cannot activate unknown extension '${o.id.value}'`);this._host.onExtensionActivationError(o.id,d,new M.MissingExtensionDependency(o.id.value)),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(o.id),new b(d));return}const _=typeof D.extensionDependencies=="undefined"?[]:D.extensionDependencies;let a=!0;for(let d=0,S=_.length;d<S;d++){const i=_[d];if(this._resolvedExtensionsSet.has(c.ExtensionIdentifier.toKey(i)))continue;const p=this._activatedExtensions.get(c.ExtensionIdentifier.toKey(i));if(p&&!p.activationFailed)continue;if(p&&p.activationFailed){const h=D.displayName||D.identifier.value,m=this._registry.getExtensionDescription(i),k=m&&m.displayName||i,T=new Error(`Cannot activate the '${h}' extension because its dependency '${k}' failed to activate`);T.detail=p.activationFailedError,this._host.onExtensionActivationError(D.identifier,T,null),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(D.identifier),new b(T));return}if(this._hostExtensionsMap.has(c.ExtensionIdentifier.toKey(i))){a=!1,l[c.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(c.ExtensionIdentifier.toKey(i)),reason:o.reason};continue}const r=this._registry.getExtensionDescription(i);if(r){if(!r.main&&!r.browser)continue;a=!1,l[c.ExtensionIdentifier.toKey(i)]={id:r.identifier,reason:o.reason};continue}const s=D.displayName||D.identifier.value,u=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(D.identifier,u,new M.MissingExtensionDependency(i)),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(D.identifier),new b(u));return}a?l[c.ExtensionIdentifier.toKey(D.identifier)]=o:v.push(o)}_activateExtensions(o){if(o.length===0||(o=o.filter(_=>!this._activatedExtensions.has(c.ExtensionIdentifier.toKey(_.id))),o.length===0))return Promise.resolve(void 0);const l=Object.create(null),v=[];for(let _=0,a=o.length;_<a;_++)this._handleActivateRequest(o[_],l,v);for(let _=0,a=v.length;_<a;_++){const d=c.ExtensionIdentifier.toKey(v[_].id);l[d]&&delete l[d]}const D=Object.keys(l).map(_=>l[_]);return v.length===0?Promise.all(D.map(_=>this._activateExtension(_.id,_.reason))).then(_=>{}):this._activateExtensions(D).then(_=>this._activateExtensions(v))}_activateExtension(o,l){const v=c.ExtensionIdentifier.toKey(o);if(this._activatedExtensions.has(v))return Promise.resolve(void 0);const D=this._activatingExtensions.get(v);if(D)return D;const _=this._host.actualActivateExtension(o,l).then(void 0,a=>{const d=new Error;return a&&a.name&&(d.name=a.name),a&&a.message?d.message=`Activating extension '${o.value}' failed: ${a.message}.`:d.message=`Activating extension '${o.value}' failed: ${a}.`,a&&a.stack&&(d.stack=a.stack),this._host.onExtensionActivationError(o,d,null),this._logService.error(`Activating extension ${o.value} failed due to an error:`),this._logService.error(a),new b(a)}).then(a=>{this._activatedExtensions.set(v,a),this._activatingExtensions.delete(v)});return this._activatingExtensions.set(v,_),_}};n=$e([Ve(4,E.ILogService)],n),e.ExtensionsActivator=n}),define(be[180],Ee([0,1,16]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,R)=>{this._actualOk=A,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,c.onUnexpectedError)(A))}then(A,R){return this._ensureActual().then(A,R)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=M}),define(be[38],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(P,t){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=t,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const M=[];function E(y){const P=new c(!0,y);return M[P.nid]=P,P}e.createMainContextProxyIdentifier=E;function A(y){const P=new c(!1,y);return M[P.nid]=P,P}e.createExtHostContextProxyIdentifier=A;function R(y){return M[y].sid}e.getStringIdentifierForProxy=R;class C{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=C}),define(be[5],Ee([0,1,54,2,38]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var R;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var b;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(b=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(a){a.name="$ident";function d(i,p){return Object.defineProperty(i,a.name,{value:p,enumerable:!0}),i}a.mixin=d;function S(i){return i[a.name]}a.of=S})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(d){return d._id=f._n++,d}}e.IdObject=f,f._n=0;var o;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var l;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(l=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function D(a){if(a&&a.edits)for(const d of a.edits)typeof d.resource=="object"?d.resource=M.URI.revive(d.resource):(d.newUri=M.URI.revive(d.newUri),d.oldUri=M.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=(0,c.revive)(d.metadata));return a}e.reviveWorkspaceEditDto=D;var _;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(_=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,E.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,E.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,E.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,E.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,E.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,E.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,E.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,E.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,E.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[68],Ee([0,1,5,3,4]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(C){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,y){return this._proxy.$getPassword(C,y)}store(C,y,P){return this._proxy.$setPassword(C,y,P)}delete(C,y){return this._proxy.$deletePassword(C,y)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,E.createDecorator)("IExtHostSecretState")}),define(be[69],Ee([0,1,4,15,5,12]),function(re,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(y,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(E.MainContext.MainThreadTelemetry)}report(y,P,t){const b=this.getUsageKey(y,P);this._reportedUsages.has(b)||(this._reportedUsages.add(b),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:y}))}getUsageKey(y,P){return`${y}-${P.identifier.value}`}};R=$e([Ve(0,A.IExtHostRpcService),Ve(1,M.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(C,y,P){}})}),define(be[181],Ee([0,1,3,5,7,26]),function(re,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new c.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,P,t,b={}){const n=A.ExtensionIdentifier.toKey(y.identifier),f=this._inFlightRequests.get(n)||[],o=[...t].sort().join(" ");let l=f.find(v=>v.scopes===o);if(l)return l.result;{const v=this._getSession(y,n,P,t,b);l={scopes:o,result:v},f.push(l),this._inFlightRequests.set(n,f);try{await v}finally{const D=f.findIndex(_=>_.scopes===o);D>-1&&(f.splice(D),this._inFlightRequests.set(n,f))}return v}}async _getSession(y,P,t,b,n={}){await this._proxy.$ensureProvider(t);const f=y.displayName||y.name;return this._proxy.$getSession(t,b,P,f,n)}async removeSession(y,P){const t=this._authenticationProviders.get(y);return t?t.provider.removeSession(P):this._proxy.$removeSession(y,P)}registerAuthenticationProvider(y,P,t,b){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:P,provider:t,options:b??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===y)||this._providers.push({id:y,label:P});const n=t.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(y,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,P,b?.supportsMultipleAccounts??!1),new E.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(y);const f=this._providers.findIndex(o=>o.id===y);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,P){const t=this._authenticationProviders.get(y);if(t)return Promise.resolve(t.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,P){const t=this._authenticationProviders.get(y);if(t)return Promise.resolve(t.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,P){const t=this._authenticationProviders.get(y);if(t)return Promise.resolve(t.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,P){return this._onDidChangeSessions.fire({provider:{id:y,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=R}),define(be[182],Ee([0,1,5,12,8]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(C,y){this._extHostDocumentsAndEditors=y,this._proxy=C.getProxy(c.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const y=E.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};A=$e([Ve(0,M.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(be[183],Ee([0,1,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(A){const R=A.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(C){return R.$writeText(C)}})}}e.ExtHostClipboard=M}),define(be[39],Ee([0,1,10,7,8,23,5,13,15,54,44,112,2,6,4,12,48,22,38]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o,l,v,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{constructor(s,u){this._commands=new Map,this._apiCommands=new Map,this._proxy=s.getProxy(R.MainContext.MainThreadCommands),this._logService=u,this.converter=new d(this,h=>{const m=this._apiCommands.get(h);return m?.result===i.Void?m:void 0},u),this._argumentProcessors=[{processArgument(h){return(0,P.revive)(h)}},{processArgument(h){return(0,A.cloneAndChange)(h,function(m){if(t.Range.isIRange(m))return E.Range.to(m);if(b.Position.isIPosition(m))return E.Position.to(m);if(t.Range.isIRange(m.range)&&n.URI.isUri(m.uri))return E.location.to(m);if(m instanceof D.VSBuffer)return m.buffer.buffer;if(!Array.isArray(m))return m})}}]}registerArgumentProcessor(s){this._argumentProcessors.push(s)}registerApiCommand(s){const u=this.registerCommand(!1,s.id,async(...h)=>{const m=s.args.map((T,g)=>{if(!T.validate(h[g]))throw new Error(`Invalid argument '${T.name}' when running '${s.id}', received: ${h[g]}`);return T.convert(h[g])}),k=await this.executeCommand(s.internalId,...m);return s.result.convert(k,h,this.converter)},void 0,{description:s.description,args:s.args,returns:s.result.description});return this._apiCommands.set(s.id,s),new M.Disposable(()=>{u.dispose(),this._apiCommands.delete(s.id)})}registerCommand(s,u,h,m,k){if(this._logService.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this._commands.has(u))throw new Error(`command '${u}' already exists`);return this._commands.set(u,{callback:h,thisArg:m,description:k}),s&&this._proxy.$registerCommand(u),new M.Disposable(()=>{this._commands.delete(u)&&s&&this._proxy.$unregisterCommand(u)})}executeCommand(s,...u){return this._logService.trace("ExtHostCommands#executeCommand",s),this._doExecuteCommand(s,u,!0)}async _doExecuteCommand(s,u,h){if(this._commands.has(s))return this._executeContributedCommand(s,u);{let m=!1;const k=(0,A.cloneAndChange)(u,function(T){if(T instanceof M.Position)return E.Position.from(T);if(T instanceof M.Range)return E.Range.from(T);if(T instanceof M.Location)return E.location.from(T);if(M.NotebookRange.isNotebookRange(T))return E.NotebookRange.from(T);if(T instanceof ArrayBuffer)return m=!0,D.VSBuffer.wrap(new Uint8Array(T));if(T instanceof Uint8Array)return m=!0,D.VSBuffer.wrap(T);if(!Array.isArray(T))return T});try{const T=await this._proxy.$executeCommand(s,m?new _.SerializableObjectWithBuffers(k):k,h);return(0,P.revive)(T)}catch(T){if(T instanceof Error&&T.message==="$executeCommand:retry")return this._doExecuteCommand(s,u,!1);throw T}}}async _executeContributedCommand(s,u){const h=this._commands.get(s);if(!h)throw new Error("Unknown command");let{callback:m,thisArg:k,description:T}=h;if(T)for(let g=0;g<T.args.length;g++)try{(0,c.validateConstraint)(u[g],T.args[g].constraint)}catch(I){throw new Error(`Running the contributed command: '${s}' failed. Illegal argument '${T.args[g].name}' - ${T.args[g].description}`)}try{return await m.apply(k,u)}catch(g){if(s===this.converter.delegatingCommandId){const I=this.converter.getActualCommand(...u);I&&(s=I.command)}throw this._logService.error(g,s),new Error(`Running the contributed command: '${s}' failed.`)}}$executeContributedCommand(s,...u){return this._logService.trace("ExtHostCommands#$executeContributedCommand",s),this._commands.has(s)?(u=u.map(h=>this._argumentProcessors.reduce((m,k)=>k.processArgument(m),h)),this._executeContributedCommand(s,u)):Promise.reject(new Error(`Contributed command '${s}' does not exist.`))}getCommands(s=!1){return this._logService.trace("ExtHostCommands#getCommands",s),this._proxy.$getCommands().then(u=>(s&&(u=u.filter(h=>h[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const s=Object.create(null);for(let[u,h]of this._commands){let{description:m}=h;m&&(s[u]=m)}return Promise.resolve(s)}};a=$e([Ve(0,l.IExtHostRpcService),Ve(1,y.ILogService)],a),e.ExtHostCommands=a,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class d{constructor(s,u,h){this._commands=s,this._lookupApiCommand=u,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(s,u){if(!s)return;const h={$ident:void 0,id:s.command,title:s.title,tooltip:s.tooltip};if(!s.command)return h;const m=this._lookupApiCommand(s.command);if(m)h.id=m.internalId,h.arguments=m.args.map((k,T)=>k.convert(s.arguments&&s.arguments[T]));else if((0,C.isNonEmptyArray)(s.arguments)){const k=++this._cachIdPool;this._cache.set(k,s),u.add((0,f.toDisposable)(()=>{this._cache.delete(k),this._logService.trace("CommandsConverter#DISPOSE",k)})),h.$ident=k,h.id=this.delegatingCommandId,h.arguments=[k],this._logService.trace("CommandsConverter#CREATE",s.command,k)}return h}fromInternal(s){const u=R.ObjectIdentifier.of(s);return typeof u=="number"?this._cache.get(u):{command:s.id,title:s.title,arguments:s.arguments}}getActualCommand(...s){return this._cache.get(s[0])}_executeConvertedCommand(...s){const u=this.getActualCommand(...s);return this._logService.trace("CommandsConverter#EXECUTE",s[0],u?u.command:"MISSING"),u?this._commands.executeCommand(u.command,...u.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=d;class S{constructor(s,u,h,m){this.name=s,this.description=u,this.validate=h,this.convert=m}optional(){return new S(this.name,`(optional) ${this.description}`,s=>s==null||this.validate(s),s=>s===void 0?void 0:s===null?null:this.convert(s))}with(s,u){return new S(s??this.name,u??this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",r=>n.URI.isUri(r),r=>r),S.Position=new S("position","A position in a text document",r=>M.Position.isPosition(r),E.Position.from),S.Range=new S("range","A range in a text document",r=>M.Range.isRange(r),E.Range.from),S.Selection=new S("selection","A selection in a text document",r=>M.Selection.isSelection(r),E.Selection.from),S.Number=new S("number","",r=>typeof r=="number",r=>r),S.String=new S("string","",r=>typeof r=="string",r=>r),S.CallHierarchyItem=new S("item","A call hierarchy item",r=>r instanceof M.CallHierarchyItem,E.CallHierarchyItem.from),S.TypeHierarchyItem=new S("item","A type hierarchy item",r=>r instanceof M.TypeHierarchyItem,E.TypeHierarchyItem.from),S.TestItem=new S("testItem","A VS Code TestItem",r=>r instanceof v.TestItemImpl,E.TestItem.from);class i{constructor(s,u){this.description=s,this.convert=u}}e.ApiCommandResult=i,i.Void=new i("no result",r=>r);class p{constructor(s,u,h,m,k){this.id=s,this.internalId=u,this.description=h,this.args=m,this.result=k}}e.ApiCommand=p}),define(be[184],Ee([0,1,8,7,59,39,13,80]),function(re,e,c,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(c.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,f)=>{if((0,R.isFalsyOrEmpty)(n))return;class o extends M.SymbolInformation{static to(v){const D=new o(v.name,c.SymbolKind.to(v.kind),v.containerName||"",new M.Location(f[0],c.Range.to(v.range)));return D.detail=v.detail,D.range=D.location.range,D.selectionRange=c.Range.to(v.selectionRange),D.children=v.children?v.children.map(o.to):[],D}}return n.map(o.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new A.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",b)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(c.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(c.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(f=>M.Position.isPosition(f)),n=>n.map(c.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(f=>{let o;for(const l of f.reverse())o=new M.SelectionRange(c.Range.to(l),o);return o}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const f=[];if(Array.isArray(n))for(let o of n)f.push(...o[1].map(c.WorkspaceSymbol.to));return f})),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:c.Range.to(n.range),placeholder:n.text}})),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return c.WorkspaceEdit.to(n)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(c.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,C.decodeSemanticTokensDto)(n);if(f.type==="full")return new M.SemanticTokens(f.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,C.decodeSemanticTokensDto)(n);if(f.type==="full")return new M.SemanticTokens(f.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,f,o)=>{if(!n)return new M.CompletionList([]);const l=n.suggestions.map(v=>c.CompletionItem.to(v,o));return new M.CompletionList(l,n.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return c.SignatureHelp.to(n)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,f,o)=>t(l=>new M.CodeLens(c.Range.to(l.range),l.command&&o.fromInternal(l.command)))(n))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?c.Selection.from(n):c.Range.from(n)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,f,o)=>t(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(l.command)}else{const v=new M.CodeAction(l.title,l.kind?new M.CodeActionKind(l.kind):void 0);return l.edit&&(v.edit=c.WorkspaceEdit.to(l.edit)),l.command&&(v.command=o.fromInternal(l.command)),v.isPreferred=l.isPreferred,v}})(n))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(f=>new M.ColorInformation(c.Range.to(f.range),c.Color.to(f.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,c.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:c.Range.from(n.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(c.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(c.InlayHint.to))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(f=>c.NotebookExclusiveDocumentPattern.to(f))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(c.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new A.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[A.ApiCommandArgument.TestItem],A.ApiCommandResult.Void)];class P{static register(f){y.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=P;function t(n){return f=>{if(Array.isArray(f))return f.map(n)}}function b(n){if(!Array.isArray(n))return;const f=[];for(const o of n)E.isLocationLink(o)?f.push(c.DefinitionLink.to(o)):f.push(c.location.to(o));return f}}),define(be[185],Ee([0,1,14,52,3,6,2,59,26,8,7,5]),function(re,e,c,M,E,A,R,C,y,P,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(f,o,l){const v=f.getProxy(b.MainContext.MainThreadComments);class D{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,o.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===6){const u=this._commentControllers.get(s.handle);return u||s}else if(s&&s.$mid===7){const u=this._commentControllers.get(s.commentControlHandle);if(!u)return s;const h=u.getCommentThread(s.commentThreadHandle);return h||s}else if(s&&s.$mid===8){const u=this._commentControllers.get(s.thread.commentControlHandle);if(!u)return s;const h=u.getCommentThread(s.thread.commentThreadHandle);return h?{thread:h,text:s.text}:s}else if(s&&s.$mid===9){const u=this._commentControllers.get(s.thread.commentControlHandle);if(!u)return s;const h=u.getCommentThread(s.thread.commentThreadHandle);if(!h)return s;let m=s.commentUniqueId,k=h.getCommentByUniqueId(m);return k||s}else if(s&&s.$mid===10){const u=this._commentControllers.get(s.thread.commentControlHandle);if(!u)return s;const h=u.getCommentThread(s.thread.commentThreadHandle);if(!h)return s;let m=s.text,k=s.commentUniqueId,T=h.getCommentByUniqueId(k);return T?(T.body=m,T):s}return s}})}createCommentController(s,u,h){const m=D.handlePool++,k=new a(s,m,u,h);this._commentControllers.set(k.handle,k);const T=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(s.identifier))||[];return T.push(k),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(s.identifier),T),k.value}$createCommentThreadTemplate(s,u,h){const m=this._commentControllers.get(s);!m||m.$createCommentThreadTemplate(u,h)}async $updateCommentThreadTemplate(s,u,h){const m=this._commentControllers.get(s);!m||m.$updateCommentThreadTemplate(u,h)}$deleteCommentThread(s,u){const h=this._commentControllers.get(s);h&&h.$deleteCommentThread(u)}$provideCommentingRanges(s,u,h){const m=this._commentControllers.get(s);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const k=l.getDocument(R.URI.revive(u));return(0,c.asPromise)(()=>m.commentingRangeProvider.provideCommentingRanges(k,h)).then(T=>T?T.map(g=>P.Range.from(g)):void 0)}$toggleReaction(s,u,h,m,k){const T=this._commentControllers.get(s);return!T||!T.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const g=T.getCommentThread(u);if(g){const I=g.getCommentByUniqueId(m.uniqueIdInThread);if(T!==void 0&&I&&T.reactionHandler)return T.reactionHandler(I,i(k))}return Promise.resolve(void 0)})}dispose(){}}D.handlePool=0;class _{constructor(s,u,h,m,k,T,g){this._commentControllerHandle=u,this._id=h,this._uri=m,this._range=k,this._comments=T,this.handle=_._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new E.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${s}.${this.handle}`),v.$createCommentThread(u,this.handle,this._id,this._uri,P.Range.from(this._range),g),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=T,this._localDisposables.push({dispose:()=>{v.$deleteCommentThread(u,this.handle)}});const I=this;this.value={get uri(){return I.uri},get range(){return I.range},set range(F){I.range=F},get comments(){return I.comments},set comments(F){I.comments=F},get collapsibleState(){return I.collapsibleState},set collapsibleState(F){I.collapsibleState=F},get canReply(){return I.canReply},set canReply(F){I.canReply=F},get contextValue(){return I.contextValue},set contextValue(F){I.contextValue=F},get label(){return I.label},set label(F){I.label=F},dispose:()=>{I.dispose()}}}set threadId(s){this._id=s}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(s){s.isEqual(this._range)||(this._range=s,this.modifications.range=s,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(s){this._canReply!==s&&(this._canReply=s,this.modifications.canReply=s,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(s){this._label=s,this.modifications.label=s,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(s){this._contextValue=s,this.modifications.contextValue=s,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(s){this._comments=s,this.modifications.comments=s,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(s){this._collapseState=s,this.modifications.collapsibleState=s,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const s=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),u={};s("range")&&(u.range=P.Range.from(this._range)),s("label")&&(u.label=this.label),s("contextValue")&&(u.contextValue=this.contextValue),s("comments")&&(u.comments=this._comments.map(h=>d(this,h,this._commentsMap))),s("collapsibleState")&&(u.collapseState=p(this._collapseState)),s("canReply")&&(u.canReply=this.canReply),this.modifications={},v.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,u)}getCommentByUniqueId(s){for(let u of this._commentsMap){let h=u[0],m=u[1];if(s===m)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(s=>s.dispose())}}_._handlePool=0,$e([(0,M.debounce)(100)],_.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(s,u,h,m){this._extension=s,this._handle=u,this._id=h,this._label=m,this._threads=new Map,v.$registerCommentController(this.handle,h,m);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(T){k.options=T},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(T){k.commentingRangeProvider=T},get reactionHandler(){return k.reactionHandler},set reactionHandler(T){k.reactionHandler=T},createCommentThread(T,g,I){return k.createCommentThread(T,g,I).value},dispose:()=>{k.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{v.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(s){this._reactionHandler=s,v.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!s})}get options(){return this._options}set options(s){this._options=s,v.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(s,u,h,m){if(typeof s=="string"){const k=new _(this.id,this.handle,s,u,h,m,this._extension.identifier);return this._threads.set(k.handle,k),k}else{const k=new _(this.id,this.handle,void 0,s,u,h,this._extension.identifier);return this._threads.set(k.handle,k),k}}$createCommentThreadTemplate(s,u){const h=new _(this.id,this.handle,void 0,R.URI.revive(s),P.Range.to(u),[],this._extension.identifier);return h.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(s,u){let h=this._threads.get(s);h&&(h.range=P.Range.to(u))}$deleteCommentThread(s){let u=this._threads.get(s);u&&u.dispose(),this._threads.delete(s)}getCommentThread(s){return this._threads.get(s)}dispose(){this._threads.forEach(s=>{s.dispose()}),this._localDisposables.forEach(s=>s.dispose())}}function d(r,s,u){let h=u.get(s);h||(h=++r.commentHandle,u.set(s,h));const m=s.author&&s.author.iconPath?s.author.iconPath.toString():void 0;return{mode:s.mode,contextValue:s.contextValue,uniqueIdInThread:h,body:P.MarkdownString.from(s.body),userName:s.author.name,userIconPath:m,label:s.label,commentReactions:s.reactions?s.reactions.map(k=>S(k)):void 0}}function S(r){return{label:r.label,iconPath:r.iconPath?P.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function i(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?R.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function p(r){if(r!==void 0)switch(r){case t.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}return new D}e.createExtHostComments=n}),define(be[95],Ee([0,1,2,5,7,4,12,15,13,9,17]),function(re,e,c,M,E,A,R,C,y,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let b=class vi{constructor(f,o){this._logService=o,this._provider=new Map,this._proxy=f.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,o){const l=vi._handlePool++;this._provider.set(l,{provider:f,extensionId:o}),this._proxy.$registerDecorationProvider(l,o.value);const v=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(D=>{if(!D){this._proxy.$onDidChange(l,null);return}let _=(0,y.asArray)(D);if(_.length<=vi._maxEventSize){this._proxy.$onDidChange(l,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,_.length);const a=_.map(i=>({uri:i,rank:(0,P.count)(i.path,"/")})),d=(0,y.groupBy)(a,(i,p)=>i.rank-p.rank||(0,P.compare)(i.uri.path,p.uri.path));let S=[];e:for(let i of d){let p;for(let r of i){let s=(0,t.dirname)(r.uri.path);if(p!==s&&(p=s,S.push(r.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(l,S)});return new E.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(l),this._provider.delete(l)})}async $provideDecorations(f,o,l){if(!this._provider.has(f))return Object.create(null);const v=Object.create(null),{provider:D,extensionId:_}=this._provider.get(f);return await Promise.all(o.map(async a=>{try{const{uri:d,id:S}=a,i=await Promise.resolve(D.provideFileDecoration(c.URI.revive(d),l));if(!i)return;try{E.FileDecoration.validate(i),v[S]=[i.propagate,i.tooltip,i.badge,i.color]}catch(p){this._logService.warn(`INVALID decoration from extension '${_.value}': ${p}`)}}catch(d){this._logService.error(d)}})),v}};b._handlePool=0,b._maxEventSize=250,b=$e([Ve(0,R.IExtHostRpcService),Ve(1,C.ILogService)],b),e.ExtHostDecorations=b,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Fe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(be[186],Ee([0,1,124,82,2,5,7,8,3,15,20,37,104]),function(re,e,c,M,E,A,R,C,y,P,t,b,n){"use strict";var f,o,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{constructor(a,d,S,i,p,r){this._name=a,this._owner=d,this._maxDiagnosticsPerFile=S,f.set(this,void 0),o.set(this,void 0),l.set(this,void 0),this._isDisposed=!1,et(this,l,new n.SkipList((s,u)=>i.compare(s,u)),"f"),et(this,f,p,"f"),et(this,o,r,"f")}dispose(){this._isDisposed||(Fe(this,o,"f").fire([...Fe(this,l,"f").keys()]),Fe(this,f,"f")&&Fe(this,f,"f").$clear(this._owner),Fe(this,l,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,d){if(!a){this.clear();return}this._checkDisposed();let S=[];if(E.URI.isUri(a)){if(!d){this.delete(a);return}Fe(this,l,"f").set(a,d.slice()),S=[a]}else if(Array.isArray(a)){S=[];let p;a=[...a].sort(v._compareIndexedTuplesByUri);for(const r of a){const[s,u]=r;if((!p||s.toString()!==p.toString())&&(p&&Fe(this,l,"f").get(p).length===0&&Fe(this,l,"f").delete(p),p=s,S.push(s),Fe(this,l,"f").set(s,[])),u){const h=Fe(this,l,"f").get(s);h&&h.push(...u)}else{const h=Fe(this,l,"f").get(s);h&&(h.length=0)}}}if(Fe(this,o,"f").fire(S),!Fe(this,f,"f"))return;const i=[];for(let p of S){let r=[];const s=Fe(this,l,"f").get(p);if(s)if(s.length>this._maxDiagnosticsPerFile){r=[];const u=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(let m of s)if(m.severity===u[h]&&r.push(C.Diagnostic.from(m))===this._maxDiagnosticsPerFile)break e;r.push({severity:M.MarkerSeverity.Info,message:(0,c.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(u=>C.Diagnostic.from(u));i.push([p,r])}Fe(this,f,"f").$changeMany(this._owner,i)}delete(a){this._checkDisposed(),Fe(this,o,"f").fire([a]),Fe(this,l,"f").delete(a),Fe(this,f,"f")&&Fe(this,f,"f").$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),Fe(this,o,"f").fire([...Fe(this,l,"f").keys()]),Fe(this,l,"f").clear(),Fe(this,f,"f")&&Fe(this,f,"f").$clear(this._owner)}forEach(a,d){this._checkDisposed();for(let S of Fe(this,l,"f").keys())a.apply(d,[S,this.get(S),this])}get(a){this._checkDisposed();const d=Fe(this,l,"f").get(a);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(Fe(this,l,"f").get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,d){return a[0].toString()<d[0].toString()?-1:a[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=v,f=new WeakMap,o=new WeakMap,l=new WeakMap;let D=class Zt{constructor(a,d,S){this._logService=d,this._fileSystemInfoService=S,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,Zt._mapper),this._proxy=a.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(a){const d=new t.ResourceMap;for(const S of a)d.set(S,S);return{uris:Object.freeze(Array.from(d.values()))}}createDiagnosticCollection(a,d){const{_collections:S,_proxy:i,_onDidChangeDiagnostics:p,_logService:r,_fileSystemInfoService:s}=this,u=new class{$changeMany(k,T){i.$changeMany(k,T),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,k,T.length===0?"CLEARING":T)}$clear(k){i.$clear(k),r.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,k)}dispose(){i.dispose()}};let h;if(!d)d="_generated_diagnostic_collection_name_#"+Zt._idPool++,h=d;else if(!S.has(d))h=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do h=d+Zt._idPool++;while(S.has(h))}return new class extends v{constructor(){super(d,h,Zt._maxDiagnosticsPerFile,s.extUri,u,p);S.set(h,this)}dispose(){super.dispose(),S.delete(h)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const d=new Map,S=[];for(const i of this._collections.values())i.forEach((p,r)=>{let s=d.get(p.toString());typeof s=="undefined"&&(s=S.length,d.set(p.toString(),s),S.push([p,[]])),S[s][1]=S[s][1].concat(...r)});return S}}_getDiagnostics(a){let d=[];for(let S of this._collections.values())S.has(a)&&(d=d.concat(S.get(a)));return d}$acceptMarkersChange(a){if(!this._mirrorCollection){const d="_generated_mirror",S=new v(d,d,Zt._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(d,S),this._mirrorCollection=S}for(const[d,S]of a)this._mirrorCollection.set(E.URI.revive(d),S.map(C.Diagnostic.to))}};D._idPool=0,D._maxDiagnosticsPerFile=1e3,D=$e([Ve(1,P.ILogService),Ve(2,b.IExtHostFileSystemInfo)],D),e.ExtHostDiagnostics=D}),define(be[187],Ee([0,1,2,5]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class E{constructor(R){this._proxy=R.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(R){return this._proxy.$showOpenDialog(R).then(C=>C?C.map(y=>c.URI.revive(y)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(C=>C?c.URI.revive(C):void 0)}}e.ExtHostDialogs=E}),define(be[188],Ee([0,1,16,2,7,5,11,21,9]),function(re,e,c,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(b,n,f){this._documentsAndEditors=n,this._logService=f,this._documentContentProviders=new Map,this._proxy=b.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,n){if(Object.keys(R.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const f=P._handlePool++;this._documentContentProviders.set(f,n),this._proxy.$registerTextContentProvider(f,b);let o;return typeof n.onDidChange=="function"&&(o=n.onDidChange(l=>{if(l.scheme!==b){this._logService.warn(`Provider for scheme '${b}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(l)&&this.$provideTextDocumentContent(f,l).then(v=>{if(!v&&typeof v!="string")return;const D=this._documentsAndEditors.getDocument(l);if(!D)return;const _=(0,y.splitLines)(v);if(!D.equalLines(_))return this._proxy.$onVirtualDocumentChange(l,v)},c.onUnexpectedError)})),new E.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(b,n){const f=this._documentContentProviders.get(b);return f?Promise.resolve(f.provideTextDocumentContent(M.URI.revive(n),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(be[189],Ee([0,1,3,6,2,5,88,8,10,23,7]),function(re,e,c,M,E,A,R,C,y,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class b{constructor(f,o){this._onDidAddDocument=new c.Emitter,this._onDidRemoveDocument=new c.Emitter,this._onDidChangeDocument=new c.Emitter,this._onDidSaveDocument=new c.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=o,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const v of l)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const v of l)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!f)return;const o=this._documentsAndEditors.getDocument(f);if(o)return o}getDocument(f){const o=this.getDocumentData(f);if(!o?.document)throw new Error(`Unable to retrieve document from URI '${f}'`);return o.document}ensureDocumentData(f){const o=this._documentsAndEditors.getDocument(f);if(o)return Promise.resolve(o);let l=this._documentLoader.get(f.toString());return l||(l=this._proxy.$tryOpenDocument(f).then(v=>{this._documentLoader.delete(f.toString());const D=E.URI.revive(v);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(D))},v=>(this._documentLoader.delete(f.toString()),Promise.reject(v))),this._documentLoader.set(f.toString(),l)),l}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(o=>E.URI.revive(o))}$acceptModelModeChanged(f,o){const l=E.URI.revive(f),v=this._documentsAndEditors.getDocument(l);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(o),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(f){const o=E.URI.revive(f),l=this._documentsAndEditors.getDocument(o);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(f,o){const l=E.URI.revive(f),v=this._documentsAndEditors.getDocument(l);if(!v)throw new Error("unknown document");v._acceptIsDirty(o),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(f,o,l){const v=E.URI.revive(f),D=this._documentsAndEditors.getDocument(v);if(!D)throw new Error("unknown document");D._acceptIsDirty(l),D.onEvents(o);let _;o.isUndoing?_=t.TextDocumentChangeReason.Undo:o.isRedoing&&(_=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:D.document,contentChanges:o.changes.map(a=>({range:C.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:_}))}setWordDefinitionFor(f,o){(0,R.setWordDefinitionFor)(f,o)}}e.ExtHostDocuments=b}),define(be[49],Ee([0,1,42,3,6,2,4,5,88,12,94,8,15,20,11,232,103]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class D{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(d,S){this._extHostRpc=d,this._logService=S,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const S=[],i=[],p=[];if(d.removedDocuments)for(const r of d.removedDocuments){const s=A.URI.revive(r),u=this._documents.get(s);u?.unref()&&(this._documents.delete(s),S.push(u.value))}if(d.addedDocuments)for(const r of d.addedDocuments){const s=A.URI.revive(r.uri);let u=this._documents.get(s);if(u&&s.scheme!==o.Schemas.vscodeNotebookCell&&s.scheme!==o.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);u||(u=new D(new y.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(s,u),i.push(u.value)),u.ref()}if(d.removedEditors)for(const r of d.removedEditors){const s=this._editors.get(r);this._editors.delete(r),s&&p.push(s)}if(d.addedEditors)for(const r of d.addedEditors){const s=A.URI.revive(r.documentUri);c.ok(this._documents.has(s),`document '${s}' does not exist`),c.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const u=this._documents.get(s).value,h=new t.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>u.document),r.selections.map(b.Selection.to),r.options,r.visibleRanges.map(m=>b.Range.to(m)),typeof r.editorPosition=="number"?b.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,h)}d.newActiveEditor!==void 0&&(c.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),(0,E.dispose)(S),(0,E.dispose)(p),d.removedDocuments&&this._onDidRemoveDocuments.fire(S),d.addedDocuments&&this._onDidAddDocuments.fire(i),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){return this._documents.get(d)?.value}allDocuments(){return l.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!this._activeEditorId)return;const S=this._editors.get(this._activeEditorId);return d?S:S?.value}allEditors(){return[...this._editors.values()]}};_=$e([Ve(0,P.IExtHostRpcService),Ve(1,n.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[70],Ee([0,1,8,5,2,3,4,12,14]),function(re,e,c,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,R.createDecorator)("IExtHostEditorTabs");let P=class{constructor(b){this._onDidChangeTabs=new A.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new A.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=b.getProxy(M.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(b){let n=-1;this._tabs=b.map((o,l)=>(o.isActive&&(n=l),Object.freeze({label:o.label,viewColumn:c.ViewColumn.to(o.viewColumn),index:l,resource:E.URI.revive(o.resource),additionalResourcesAndViewIds:o.additionalResourcesAndViewIds.map(({resource:v,viewId:D})=>({resource:E.URI.revive(v),viewId:D})),viewId:o.editorId,isActive:o.isActive,move:async(v,D)=>{this._proxy.$moveTab(o,v,c.ViewColumn.from(D)),await(0,y.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(o),await(0,y.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((o,l)=>o.viewColumn===l.viewColumn?o.index-l.index:o.viewColumn-l.viewColumn);const f=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==f&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};P=$e([Ve(0,C.IExtHostRpcService)],P),e.ExtHostEditorTabs=P}),define(be[190],Ee([0,1,2,5,6,7,8,233,9,22]),function(re,e,c,M,E,A,R,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const o=this._schemes.indexOf(f);o>=0&&(this._schemes.splice(o,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),o=[];let l,v,D=14,_=14;for(const a of f){let d=l?(0,y.commonPrefixLength)(l,a):0;for(d===0?v=1:v=_;d<a.length;d++)d+1===a.length?(D=_,_=9):_+=1,o.push([v,a.toUpperCase().charCodeAt(d),_]),o.push([v,a.toLowerCase().charCodeAt(d),_]),v=_;l=a,_=D}o.push([9,58,10]),o.push([10,47,12]),this._stateMachine=new C.StateMachine(o)}}provideDocumentLinks(f){this._initStateMachine();const o=[],l=C.LinkComputer.computeLinks({getLineContent(v){return f.lineAt(v-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const v of l){const D=R.DocumentLink.to(v);D.target&&o.push(D)}return o}}class b{constructor(f,o){this._extHostLanguageFeatures=o,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,o,l,v={}){if(this._registeredSchemes.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const D=this._handlePool++;this._linkProvider.add(o),this._registeredSchemes.add(o),this._fsProvider.set(D,l);let _=2;v.isCaseSensitive&&(_+=1024),v.isReadonly&&(_+=2048),typeof l.copy=="function"&&(_+=8),typeof l.open=="function"&&typeof l.close=="function"&&typeof l.read=="function"&&typeof l.write=="function"&&(_+=4),this._proxy.$registerFileSystemProvider(D,o,_).catch(d=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${o}`),console.error(d)});const a=l.onDidChangeFile(d=>{const S=[];for(const i of d){let{uri:p,type:r}=i;if(p.scheme!==o)continue;let s;switch(r){case A.FileChangeType.Changed:s=0;break;case A.FileChangeType.Created:s=1;break;case A.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}S.push({resource:p,type:s})}this._proxy.$onFileSystemChange(D,S)});return(0,E.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(o),this._registeredSchemes.delete(o),this._fsProvider.delete(D),this._proxy.$unregisterProvider(D)})}static _asIStat(f){const{type:o,ctime:l,mtime:v,size:D,permissions:_}=f;return{type:o,ctime:l,mtime:v,size:D,permissions:_}}$stat(f,o){return Promise.resolve(this._getFsProvider(f).stat(c.URI.revive(o))).then(l=>b._asIStat(l))}$readdir(f,o){return Promise.resolve(this._getFsProvider(f).readDirectory(c.URI.revive(o)))}$readFile(f,o){return Promise.resolve(this._getFsProvider(f).readFile(c.URI.revive(o))).then(l=>P.VSBuffer.wrap(l))}$writeFile(f,o,l,v){return Promise.resolve(this._getFsProvider(f).writeFile(c.URI.revive(o),l.buffer,v))}$delete(f,o,l){return Promise.resolve(this._getFsProvider(f).delete(c.URI.revive(o),l))}$rename(f,o,l,v){return Promise.resolve(this._getFsProvider(f).rename(c.URI.revive(o),c.URI.revive(l),v))}$copy(f,o,l,v){const D=this._getFsProvider(f);if(!D.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(D.copy(c.URI.revive(o),c.URI.revive(l),v))}$mkdir(f,o){return Promise.resolve(this._getFsProvider(f).createDirectory(c.URI.revive(o)))}$watch(f,o,l,v){const D=this._getFsProvider(f).watch(c.URI.revive(l),v);this._watches.set(o,D)}$unwatch(f,o){const l=this._watches.get(o);l&&(l.dispose(),this._watches.delete(o))}$open(f,o,l){const v=this._getFsProvider(f);if(!v.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(v.open(c.URI.revive(o),l))}$close(f,o){const l=this._getFsProvider(f);if(!l.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(l.close(o))}$read(f,o,l,v){const D=this._getFsProvider(f);if(!D.read)throw new Error('FileSystemProvider does not implement "read"');const _=P.VSBuffer.alloc(v);return Promise.resolve(D.read(o,l,_.buffer,0,v)).then(a=>_.slice(0,a))}$write(f,o,l,v){const D=this._getFsProvider(f);if(!D.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(D.write(o,l,v.buffer,0,v.byteLength))}_getFsProvider(f){const o=this._fsProvider.get(f);if(!o){const l=new Error;throw l.name="ENOPRO",l.message="no provider",l}return o}}e.ExtHostFileSystem=b}),define(be[71],Ee([0,1,5,60,7,22,4,12,37]),function(re,e,c,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Bt{constructor(b,n){const f=b.getProxy(c.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(o){return f.$stat(o).catch(Bt._handleError)},readDirectory(o){return f.$readdir(o).catch(Bt._handleError)},createDirectory(o){return f.$mkdir(o).catch(Bt._handleError)},async readFile(o){return f.$readFile(o).then(l=>l.buffer).catch(Bt._handleError)},writeFile(o,l){return f.$writeFile(o,A.VSBuffer.wrap(l)).catch(Bt._handleError)},delete(o,l){return f.$delete(o,{recursive:!1,useTrash:!1,...l}).catch(Bt._handleError)},rename(o,l,v){return f.$rename(o,l,{overwrite:!1,...v}).catch(Bt._handleError)},copy(o,l,v){return f.$copy(o,l,{overwrite:!1,...v}).catch(Bt._handleError)},isWritableFileSystem(o){const l=n.getCapabilities(o);if(typeof l=="number")return!(l&2048)}})}static _handleError(b){if(!(b instanceof Error))throw new E.FileSystemError(String(b));if(b.name==="ENOPRO")throw E.FileSystemError.Unavailable(b.message);switch(b.name){case M.FileSystemProviderErrorCode.FileExists:throw E.FileSystemError.FileExists(b.message);case M.FileSystemProviderErrorCode.FileNotFound:throw E.FileSystemError.FileNotFound(b.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw E.FileSystemError.FileNotADirectory(b.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw E.FileSystemError.FileIsADirectory(b.message);case M.FileSystemProviderErrorCode.NoPermissions:throw E.FileSystemError.NoPermissions(b.message);case M.FileSystemProviderErrorCode.Unavailable:throw E.FileSystemError.Unavailable(b.message);default:throw new E.FileSystemError(b.message,b.name)}}};P=$e([Ve(0,C.IExtHostRpcService),Ve(1,y.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(be[191],Ee([0,1,2,39]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class E{constructor(R,C,y,P){this._extHostNotebooks=C,this._textDocumentsAndEditors=y,this._commands=P;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",b=>!0,b=>b),new M.ApiCommandArgument("resource","Interactive resource Uri",b=>!0,b=>b),new M.ApiCommandArgument("controllerId","Notebook controller Id",b=>!0,b=>b),new M.ApiCommandArgument("title","Interactive editor title",b=>!0,b=>b)],new M.ApiCommandResult("Notebook and input URI",b=>{if(b.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(b.notebookEditorId);return{notebookUri:c.URI.revive(b.notebookUri),inputUri:c.URI.revive(b.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:c.URI.revive(b.notebookUri),inputUri:c.URI.revive(b.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(R,C,y,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:C,lines:[""],modeId:y,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(c.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=E}),define(be[192],Ee([0,1,6,5]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class E{constructor(R){this._handlePool=0,this._proxy=R.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,R),(0,c.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=E}),define(be[193],Ee([0,1,2,23,8,7,5,9,44,13,10,234,6,80,53,63,194,16,3]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o,l,v,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor($,K){this._documents=$,this._provider=K}async provideDocumentSymbols($,K){const ee=this._documents.getDocument($),ae=await this._provider.provideDocumentSymbols(ee,K);if(!(0,P.isFalsyOrEmpty)(ae))return ae[0]instanceof A.DocumentSymbol?ae.map(E.DocumentSymbol.from):a._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree($){$=$.slice(0).sort((ae,q)=>{let se=ae.location.range.start.compareTo(q.location.range.start);return se===0&&(se=q.location.range.end.compareTo(ae.location.range.end)),se});const K=[],ee=[];for(const ae of $){const q={name:ae.name||"!!MISSING: name!!",kind:E.SymbolKind.from(ae.kind),tags:ae.tags?.map(E.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:E.Range.from(ae.location.range),selectionRange:E.Range.from(ae.location.range),children:[]};for(;;){if(ee.length===0){ee.push(q),K.push(q);break}const se=ee[ee.length-1];if(y.Range.containsRange(se.range,q.range)&&!y.Range.equalsRange(se.range,q.range)){se.children&&se.children.push(q),ee.push(q);break}ee.pop()}}return K}}class d{constructor($,K,ee){this._documents=$,this._commands=K,this._provider=ee,this._cache=new l.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,K){const ee=this._documents.getDocument($),ae=await this._provider.provideCodeLenses(ee,K);if(!ae||K.isCancellationRequested)return;const q=this._cache.add(ae),se=new n.DisposableStore;this._disposables.set(q,se);const he={cacheId:q,lenses:[]};for(let Re=0;Re<ae.length;Re++)he.lenses.push({cacheId:[q,Re],range:E.Range.from(ae[Re].range),command:this._commands.toInternal(ae[Re].command,se)});return he}async resolveCodeLens($,K){const ee=$.cacheId&&this._cache.get(...$.cacheId);if(!ee)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||ee.isResolved?ae=ee:ae=await this._provider.resolveCodeLens(ee,K),ae||(ae=ee),K.isCancellationRequested)return;const q=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!q)return $.command=this._commands.toInternal(ae.command??d._badCmd,q),$}releaseCodeLenses($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function S(qe){return Array.isArray(qe)?qe.map(E.DefinitionLink.from):qe?[E.DefinitionLink.from(qe)]:[]}class i{constructor($,K){this._documents=$,this._provider=K}async provideDefinition($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.provideDefinition(ae,q,ee);return S(se)}}class p{constructor($,K){this._documents=$,this._provider=K}async provideDeclaration($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.provideDeclaration(ae,q,ee);return S(se)}}class r{constructor($,K){this._documents=$,this._provider=K}async provideImplementation($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.provideImplementation(ae,q,ee);return S(se)}}class s{constructor($,K){this._documents=$,this._provider=K}async provideTypeDefinition($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.provideTypeDefinition(ae,q,ee);return S(se)}}class u{constructor($,K){this._documents=$,this._provider=K}async provideHover($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.provideHover(ae,q,ee);if(!(!se||(0,P.isFalsyOrEmpty)(se.contents)))return se.range||(se.range=ae.getWordRangeAtPosition(q)),se.range||(se.range=new A.Range(q,q)),E.Hover.from(se)}}class h{constructor($,K){this._documents=$,this._provider=K}async provideEvaluatableExpression($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.provideEvaluatableExpression(ae,q,ee);if(se)return E.EvaluatableExpression.from(se)}}class m{constructor($,K){this._documents=$,this._provider=K}async provideInlineValues($,K,ee,ae){const q=this._documents.getDocument($),se=await this._provider.provideInlineValues(q,E.Range.to(K),E.InlineValueContext.to(ee),ae);if(Array.isArray(se))return se.map(he=>E.InlineValue.from(he))}}class k{constructor($,K){this._documents=$,this._provider=K}async provideDocumentHighlights($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.provideDocumentHighlights(ae,q,ee);if(Array.isArray(se))return se.map(E.DocumentHighlight.from)}}class T{constructor($,K){this._documents=$,this._provider=K}async provideLinkedEditingRanges($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.provideLinkedEditingRanges(ae,q,ee);if(se&&Array.isArray(se.ranges))return{ranges:(0,P.coalesce)(se.ranges.map(E.Range.from)),wordPattern:se.wordPattern}}}class g{constructor($,K){this._documents=$,this._provider=K}async provideReferences($,K,ee,ae){const q=this._documents.getDocument($),se=E.Position.to(K),he=await this._provider.provideReferences(q,se,ee,ae);if(Array.isArray(he))return he.map(E.location.from)}}class I{constructor($,K,ee,ae,q,se,he){this._documents=$,this._commands=K,this._diagnostics=ee,this._provider=ae,this._logService=q,this._extension=se,this._apiDeprecation=he,this._cache=new l.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions($,K,ee,ae){const q=this._documents.getDocument($),se=b.Selection.isISelection(K)?E.Selection.to(K):E.Range.to(K),he=[];for(const ke of this._diagnostics.getDiagnostics($))if(se.intersection(ke.range)&&he.push(ke)>I._maxCodeActionsPerFile)break;const Re={diagnostics:he,only:ee.only?new A.CodeActionKind(ee.only):void 0,triggerKind:E.CodeActionTriggerKind.to(ee.trigger)},Be=await this._provider.provideCodeActions(q,se,Re,ae);if(!(0,P.isNonEmptyArray)(Be)||ae.isCancellationRequested)return;const ze=this._cache.add(Be),Qe=new n.DisposableStore;this._disposables.set(ze,Qe);const it=[];for(let ke=0;ke<Be.length;ke++){const Ze=Be[ke];!Ze||(I._isCommand(Ze)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ze.title,command:this._commands.toInternal(Ze,Qe)})):(Re.only&&(Ze.kind?Re.only.contains(Ze.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action is of kind '${Ze.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[ze,ke],title:Ze.title,command:Ze.command&&this._commands.toInternal(Ze.command,Qe),diagnostics:Ze.diagnostics&&Ze.diagnostics.map(E.Diagnostic.from),edit:Ze.edit&&E.WorkspaceEdit.from(Ze.edit),kind:Ze.kind&&Ze.kind.value,isPreferred:Ze.isPreferred,disabled:Ze.disabled?.reason})))}return{cacheId:ze,actions:it}}async resolveCodeAction($,K){const[ee,ae]=$,q=this._cache.get(ee,ae);if(!q||I._isCommand(q)||!this._provider.resolveCodeAction)return;const se=await this._provider.resolveCodeAction(q,K)??q;return se?.edit?E.WorkspaceEdit.from(se.edit):void 0}releaseCodeActions($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}I._maxCodeActionsPerFile=1e3;class F{constructor($,K){this._documents=$,this._provider=K}async provideDocumentFormattingEdits($,K,ee){const ae=this._documents.getDocument($),q=await this._provider.provideDocumentFormattingEdits(ae,K,ee);if(Array.isArray(q))return q.map(E.TextEdit.from)}}class L{constructor($,K){this._documents=$,this._provider=K}async provideDocumentRangeFormattingEdits($,K,ee,ae){const q=this._documents.getDocument($),se=E.Range.to(K),he=await this._provider.provideDocumentRangeFormattingEdits(q,se,ee,ae);if(Array.isArray(he))return he.map(E.TextEdit.from)}}class w{constructor($,K){this._documents=$,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits($,K,ee,ae,q){const se=this._documents.getDocument($),he=E.Position.to(K),Re=await this._provider.provideOnTypeFormattingEdits(se,he,ee,ae,q);if(Array.isArray(Re))return Re.map(E.TextEdit.from)}}class x{constructor($,K){this._provider=$,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols($,K){const ee=R.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols($,K);if((0,P.isNonEmptyArray)(ae))for(const q of ae){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const se=R.IdObject.mixin(E.WorkspaceSymbol.from(q));this._symbolCache.set(se._id,q),ee.symbols.push(se)}return ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee}async resolveWorkspaceSymbol($,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const ee=this._symbolCache.get($._id);if(ee){const ae=await this._provider.resolveWorkspaceSymbol(ee,K);return ae&&(0,M.mixin)($,E.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols($){const K=this._resultCache.get($);if(K){for(let[ee,ae]=K;ee<=ae;ee++)this._symbolCache.delete(ee);this._resultCache.delete($)}}}class W{constructor($,K,ee){this._documents=$,this._provider=K,this._logService=ee}static supportsResolving($){return typeof $.prepareRename=="function"}async provideRenameEdits($,K,ee,ae){const q=this._documents.getDocument($),se=E.Position.to(K);try{const he=await this._provider.provideRenameEdits(q,se,ee,ae);return he?E.WorkspaceEdit.from(he):void 0}catch(he){const Re=W._asMessage(he);return Re?{rejectReason:Re,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation($,K,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument($),q=E.Position.to(K);try{const se=await this._provider.prepareRename(ae,q,ee);let he,Re;if(A.Range.isRange(se)?(he=se,Re=ae.getText(se)):(0,t.isObject)(se)&&(he=se.range,Re=se.placeholder),!he||!Re)return;if(he.start.line>q.line||he.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:E.Range.from(he),text:Re}}catch(se){const he=W._asMessage(se);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(se)}}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class B{constructor($,K){this.resultId=$,this.tokens=K}}class G{constructor($,K){this._documents=$,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens($,K,ee){const ae=this._documents.getDocument($),q=K!==0?this._previousResults.get(K):null;let se=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,q.resultId,ee):await this._provider.provideDocumentSemanticTokens(ae,ee);return q&&this._previousResults.delete(K),se?(se=G._fixProvidedSemanticTokens(se),this._send(G._convertToEdits(q,se),se)):null}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return G._isSemanticTokens($)?G._isCorrectSemanticTokens($)?$:new A.SemanticTokens(new Uint32Array($.data),$.resultId):G._isSemanticTokensEdits($)?G._isCorrectSemanticTokensEdits($)?$:new A.SemanticTokensEdits($.edits.map(K=>new A.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const K of $.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,K){if(!G._isSemanticTokens(K)||!$||!$.tokens)return K;const ee=$.tokens,ae=ee.length,q=K.data,se=q.length;let he=0;const Re=Math.min(ae,se);for(;he<Re&&ee[he]===q[he];)he++;if(he===ae&&he===se)return new A.SemanticTokensEdits([],K.resultId);let Be=0;const ze=Re-he;for(;Be<ze&&ee[ae-Be-1]===q[se-Be-1];)Be++;return new A.SemanticTokensEdits([{start:he,deleteCount:ae-he-Be,data:q.subarray(he,se-Be)}],K.resultId)}_send($,K){if(G._isSemanticTokens($)){const ee=this._nextResultId++;return this._previousResults.set(ee,new B($.resultId,$.data)),(0,f.encodeSemanticTokensDto)({id:ee,type:"full",data:$.data})}if(G._isSemanticTokensEdits($)){const ee=this._nextResultId++;return G._isSemanticTokens(K)?this._previousResults.set(ee,new B(K.resultId,K.data)):this._previousResults.set(ee,new B($.resultId)),(0,f.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:($.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=G;class H{constructor($,K){this._documents=$,this._provider=K}async provideDocumentRangeSemanticTokens($,K,ee){const ae=this._documents.getDocument($),q=await this._provider.provideDocumentRangeSemanticTokens(ae,E.Range.to(K),ee);return q?this._send(q):null}_send($){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=H;class U{constructor($,K,ee,ae,q){this._documents=$,this._commands=K,this._provider=ee,this._apiDeprecation=ae,this._extension=q,this._cache=new l.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,K,ee,ae){const q=this._documents.getDocument($),se=E.Position.to(K),he=q.getWordRangeAtPosition(se)||new A.Range(se,se),Re=he.with({end:se}),Be=new v.StopWatch(!0),ze=await this._provider.provideCompletionItems(q,se,ae,E.CompletionContext.to(ee));if(!ze||ae.isCancellationRequested)return;const Qe=Array.isArray(ze)?new A.CompletionList(ze):ze,it=U.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),ke=new n.DisposableStore;this._disposables.set(it,ke);const Ze=[],j={x:it,b:Ze,a:{replace:E.Range.from(he),insert:E.Range.from(Re)},c:Qe.isIncomplete||void 0,d:Be.elapsed()};for(let J=0;J<Qe.items.length;J++){const me=Qe.items[J],He=this._convertCompletionItem(me,[it,J],Re,he);Ze.push(He)}return j}async resolveCompletionItem($,K){if(typeof this._provider.resolveCompletionItem!="function")return;const ee=this._cache.get(...$);if(!ee)return;const ae=await this._provider.resolveCompletionItem(ee,K);if(!!ae)return this._convertCompletionItem(ae,$)}releaseCompletionItems($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,K,ee,ae){const q=this._disposables.get(K[0]);if(!q)throw Error("DisposableStore is missing...");const se={x:K,a:$.label,b:$.kind!==void 0?E.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(E.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:E.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(E.TextEdit.from),m:this._commands.toInternal($.command,q)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=$.textEdit.newText):typeof $.insertText=="string"?se.h=$.insertText:$.insertText instanceof A.SnippetString&&(se.h=$.insertText.value,se.i|=4);let he;return $.textEdit?he=$.textEdit.range:$.range&&(he=$.range),A.Range.isRange(he)?se.j=E.Range.from(he):he&&(!ee?.isEqual(he.inserting)||!ae?.isEqual(he.replacing))&&(se.j={insert:E.Range.from(he.inserting),replace:E.Range.from(he.replacing)}),se}}class V{constructor($,K,ee){this._documents=$,this._provider=K,this._commands=ee,this._cache=new l.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions($,K,ee,ae){const q=this._documents.getDocument($),se=E.Position.to(K),he=await this._provider.provideInlineCompletionItems(q,se,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:E.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:ee.triggerKind},ae);if(!he||ae.isCancellationRequested)return;const Re=(0,t.isArray)(he)?{items:he}:he,Be=this._cache.add(Re.items);let ze;return{pid:Be,items:Re.items.map((Qe,it)=>{let ke;return Qe.command&&(ze||(ze=new n.DisposableStore,this._disposables.set(Be,ze)),ke=this._commands.toInternal(Qe.command,ze)),{text:Qe.text,range:Qe.range?E.Range.from(Qe.range):void 0,command:ke,idx:it}})}}disposeCompletions($){this._cache.delete($);const K=this._disposables.get($);K&&K.clear(),this._disposables.delete($)}handleDidShowCompletionItem($,K){const ee=this._cache.get($,K);ee&&Q.get(this._provider).fireOnDidShowCompletionItem({completionItem:ee})}}class Q{constructor(){this._onDidShowCompletionItemEmitter=new _.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get($){let K=Q.map.get($);return K||(K=new Q,Q.map.set($,K)),K}fireOnDidShowCompletionItem($){this._onDidShowCompletionItemEmitter.fire($)}}e.InlineCompletionController=Q,Q.map=new WeakMap;class ne{constructor($,K){this._documents=$,this._provider=K,this._cache=new l.Cache("SignatureHelp")}async provideSignatureHelp($,K,ee,ae){const q=this._documents.getDocument($),se=E.Position.to(K),he=this.reviveContext(ee),Re=await this._provider.provideSignatureHelp(q,se,ae,he);if(Re){const Be=this._cache.add([Re]);return{...E.SignatureHelp.from(Re),id:Be}}}reviveContext($){let K;if($.activeSignatureHelp){const ee=E.SignatureHelp.to($.activeSignatureHelp),ae=this._cache.get($.activeSignatureHelp.id,0);ae?(K=ae,K.activeSignature=ee.activeSignature,K.activeParameter=ee.activeParameter):K=ee}return{...$,activeSignatureHelp:K}}releaseSignatureHelp($){this._cache.delete($)}}class ce{constructor($,K){this._documents=$,this._provider=K}async provideInlayHints($,K,ee){const ae=this._documents.getDocument($),q=await this._provider.provideInlayHints(ae,E.Range.to(K),ee);return q?{hints:q.map(E.InlayHint.from)}:void 0}}class Z{constructor($,K){this._documents=$,this._provider=K,this._cache=new l.Cache("DocumentLink")}async provideLinks($,K){const ee=this._documents.getDocument($),ae=await this._provider.provideDocumentLinks(ee,K);if(!(!Array.isArray(ae)||ae.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(Z._validateLink).map(E.DocumentLink.from)};{const q=this._cache.add(ae),se={links:[],id:q};for(let he=0;he<ae.length;he++){if(!Z._validateLink(ae[he]))continue;const Re=E.DocumentLink.from(ae[he]);Re.cacheId=[q,he],se.links.push(Re)}return se}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,K){if(typeof this._provider.resolveDocumentLink!="function")return;const ee=this._cache.get(...$);if(!ee)return;const ae=await this._provider.resolveDocumentLink(ee,K);if(!(!ae||!Z._validateLink(ae)))return E.DocumentLink.from(ae)}releaseLinks($){this._cache.delete($)}}class oe{constructor($,K){this._documents=$,this._provider=K}async provideColors($,K){const ee=this._documents.getDocument($),ae=await this._provider.provideDocumentColors(ee,K);return Array.isArray(ae)?ae.map(se=>({color:E.Color.from(se.color),range:E.Range.from(se.range)})):[]}async provideColorPresentations($,K,ee){const ae=this._documents.getDocument($),q=E.Range.to(K.range),se=E.Color.to(K.color),he=await this._provider.provideColorPresentations(se,{document:ae,range:q},ee);if(!!Array.isArray(he))return he.map(E.ColorPresentation.from)}}class ve{constructor($,K){this._documents=$,this._provider=K}async provideFoldingRanges($,K,ee){const ae=this._documents.getDocument($),q=await this._provider.provideFoldingRanges(ae,K,ee);if(!!Array.isArray(q))return q.map(E.FoldingRange.from)}}class Ae{constructor($,K,ee){this._documents=$,this._provider=K,this._logService=ee}async provideSelectionRanges($,K,ee){const ae=this._documents.getDocument($),q=K.map(E.Position.to),se=await this._provider.provideSelectionRanges(ae,q,ee);if(!(0,P.isNonEmptyArray)(se))return[];if(se.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Re=0;Re<q.length;Re++){const Be=[];he.push(Be);let ze=q[Re],Qe=se[Re];for(;;){if(!Qe.range.contains(ze))throw new Error("INVALID selection range, must contain the previous range");if(Be.push(E.SelectionRange.from(Qe)),!Qe.parent)break;ze=Qe.range,Qe=Qe.parent}}return he}}class Se{constructor($,K){this._documents=$,this._provider=K,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.prepareCallHierarchy(ae,q,ee);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Re=>this._cacheAndConvertItem(he,Re)):[this._cacheAndConvertItem(he,se)]}async provideCallsTo($,K,ee){const ae=this._itemFromCache($,K);if(!ae)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(ae,ee);if(!!q)return q.map(se=>({from:this._cacheAndConvertItem($,se.from),fromRanges:se.fromRanges.map(he=>E.Range.from(he))}))}async provideCallsFrom($,K,ee){const ae=this._itemFromCache($,K);if(!ae)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(ae,ee);if(!!q)return q.map(se=>({to:this._cacheAndConvertItem($,se.to),fromRanges:se.fromRanges.map(he=>E.Range.from(he))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,K){const ee=this._cache.get($),ae=E.CallHierarchyItem.from(K,$,ee.size.toString(36));return ee.set(ae._itemId,K),ae}_itemFromCache($,K){return this._cache.get($)?.get(K)}}class Ne{constructor($,K){this._documents=$,this._provider=K,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession($,K,ee){const ae=this._documents.getDocument($),q=E.Position.to(K),se=await this._provider.prepareTypeHierarchy(ae,q,ee);if(!se)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(se)?se.map(Re=>this._cacheAndConvertItem(he,Re)):[this._cacheAndConvertItem(he,se)]}async provideSupertypes($,K,ee){const ae=this._itemFromCache($,K);if(!ae)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(ae,ee);if(!!q)return q.map(se=>this._cacheAndConvertItem($,se))}async provideSubtypes($,K,ee){const ae=this._itemFromCache($,K);if(!ae)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(ae,ee);if(!!q)return q.map(se=>this._cacheAndConvertItem($,se))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,K){const ee=this._cache.get($),ae=E.TypeHierarchyItem.from(K,$,ee.size.toString(36));return ee.set(ae._itemId,K),ae}_itemFromCache($,K){return this._cache.get($)?.get(K)}}class We{constructor($,K){this.adapter=$,this.extension=K}}class je{constructor($,K,ee,ae,q,se,he){this._adapter=new Map,this._uriTransformer=K,this._proxy=$.getProxy(R.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ae,this._diagnostics=q,this._logService=se,this._apiDeprecation=he}_transformDocumentSelector($){return E.DocumentSelector.from($,this._uriTransformer)}_createDisposable($){return new A.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return je._handlePool++}_withAdapter($,K,ee,ae,q=!1){const se=this._adapter.get($);if(!se)return Promise.resolve(ae);if(se.adapter instanceof K){let he;se.extension&&(he=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${K.name}'`));const Re=ee(se.adapter,se.extension),Be=se.extension;return Be&&Promise.resolve(Re).then(()=>this._logService.trace(`[${Be.identifier.value}] provider DONE after ${Date.now()-he}ms`),ze=>{q&&ze instanceof D.CancellationError||(this._logService.error(`[${Be.identifier.value}] provider FAILED`),this._logService.error(ze))}),Re}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,K){const ee=this._nextHandle();return this._adapter.set(ee,new We($,K)),ee}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,K,ee,ae){const q=this._addNewAdapter(new a(this._documents,ee),$),se=ae&&ae.label||je._extLabel($);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(K),se),this._createDisposable(q)}$provideDocumentSymbols($,K,ee){return this._withAdapter($,a,ae=>ae.provideDocumentSymbols(c.URI.revive(K),ee),void 0)}registerCodeLensProvider($,K,ee){const ae=this._nextHandle(),q=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new We(new d(this._documents,this._commands.converter,ee),$)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(K),q);let se=this._createDisposable(ae);if(q!==void 0){const he=ee.onDidChangeCodeLenses(Re=>this._proxy.$emitCodeLensEvent(q));se=A.Disposable.from(se,he)}return se}$provideCodeLenses($,K,ee){return this._withAdapter($,d,ae=>ae.provideCodeLenses(c.URI.revive(K),ee),void 0)}$resolveCodeLens($,K,ee){return this._withAdapter($,d,ae=>ae.resolveCodeLens(K,ee),void 0)}$releaseCodeLenses($,K){this._withAdapter($,d,ee=>Promise.resolve(ee.releaseCodeLenses(K)),void 0)}registerDefinitionProvider($,K,ee){const ae=this._addNewAdapter(new i(this._documents,ee),$);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDefinition($,K,ee,ae){return this._withAdapter($,i,q=>q.provideDefinition(c.URI.revive(K),ee,ae),[])}registerDeclarationProvider($,K,ee){const ae=this._addNewAdapter(new p(this._documents,ee),$);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDeclaration($,K,ee,ae){return this._withAdapter($,p,q=>q.provideDeclaration(c.URI.revive(K),ee,ae),[])}registerImplementationProvider($,K,ee){const ae=this._addNewAdapter(new r(this._documents,ee),$);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideImplementation($,K,ee,ae){return this._withAdapter($,r,q=>q.provideImplementation(c.URI.revive(K),ee,ae),[])}registerTypeDefinitionProvider($,K,ee){const ae=this._addNewAdapter(new s(this._documents,ee),$);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideTypeDefinition($,K,ee,ae){return this._withAdapter($,s,q=>q.provideTypeDefinition(c.URI.revive(K),ee,ae),[])}registerHoverProvider($,K,ee,ae){const q=this._addNewAdapter(new u(this._documents,ee),$);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideHover($,K,ee,ae){return this._withAdapter($,u,q=>q.provideHover(c.URI.revive(K),ee,ae),void 0)}registerEvaluatableExpressionProvider($,K,ee,ae){const q=this._addNewAdapter(new h(this._documents,ee),$);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideEvaluatableExpression($,K,ee,ae){return this._withAdapter($,h,q=>q.provideEvaluatableExpression(c.URI.revive(K),ee,ae),void 0)}registerInlineValuesProvider($,K,ee,ae){const q=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new m(this._documents,ee),$);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(K),q);let he=this._createDisposable(se);if(q!==void 0){const Re=ee.onDidChangeInlineValues(Be=>this._proxy.$emitInlineValuesEvent(q));he=A.Disposable.from(he,Re)}return he}$provideInlineValues($,K,ee,ae,q){return this._withAdapter($,m,se=>se.provideInlineValues(c.URI.revive(K),ee,ae,q),void 0)}registerDocumentHighlightProvider($,K,ee){const ae=this._addNewAdapter(new k(this._documents,ee),$);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDocumentHighlights($,K,ee,ae){return this._withAdapter($,k,q=>q.provideDocumentHighlights(c.URI.revive(K),ee,ae),void 0)}registerLinkedEditingRangeProvider($,K,ee){const ae=this._addNewAdapter(new T(this._documents,ee),$);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideLinkedEditingRanges($,K,ee,ae){return this._withAdapter($,T,async q=>{const se=await q.provideLinkedEditingRanges(c.URI.revive(K),ee,ae);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?je._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider($,K,ee){const ae=this._addNewAdapter(new g(this._documents,ee),$);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideReferences($,K,ee,ae,q){return this._withAdapter($,g,se=>se.provideReferences(c.URI.revive(K),ee,ae,q),void 0)}registerCodeActionProvider($,K,ee,ae){const q=new n.DisposableStore,se=this._addNewAdapter(new I(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(se,this._transformDocumentSelector(K),{providedKinds:ae?.providedCodeActionKinds?.map(he=>he.value),documentation:ae?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,q)}))},je._extLabel($),Boolean(ee.resolveCodeAction)),q.add(this._createDisposable(se)),q}$provideCodeActions($,K,ee,ae,q){return this._withAdapter($,I,se=>se.provideCodeActions(c.URI.revive(K),ee,ae,q),void 0)}$resolveCodeAction($,K,ee){return this._withAdapter($,I,ae=>ae.resolveCodeAction(K,ee),void 0)}$releaseCodeActions($,K){this._withAdapter($,I,ee=>Promise.resolve(ee.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider($,K,ee){const ae=this._addNewAdapter(new F(this._documents,ee),$);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(K),$.identifier,$.displayName||$.name),this._createDisposable(ae)}$provideDocumentFormattingEdits($,K,ee,ae){return this._withAdapter($,F,q=>q.provideDocumentFormattingEdits(c.URI.revive(K),ee,ae),void 0)}registerDocumentRangeFormattingEditProvider($,K,ee){const ae=this._addNewAdapter(new L(this._documents,ee),$);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(K),$.identifier,$.displayName||$.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits($,K,ee,ae,q){return this._withAdapter($,L,se=>se.provideDocumentRangeFormattingEdits(c.URI.revive(K),ee,ae,q),void 0)}registerOnTypeFormattingEditProvider($,K,ee,ae){const q=this._addNewAdapter(new w(this._documents,ee),$);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(K),ae,$.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits($,K,ee,ae,q,se){return this._withAdapter($,w,he=>he.provideOnTypeFormattingEdits(c.URI.revive(K),ee,ae,q,se),void 0)}registerWorkspaceSymbolProvider($,K){const ee=this._addNewAdapter(new x(K,this._logService),$);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols($,K,ee){return this._withAdapter($,x,ae=>ae.provideWorkspaceSymbols(K,ee),{symbols:[]})}$resolveWorkspaceSymbol($,K,ee){return this._withAdapter($,x,ae=>ae.resolveWorkspaceSymbol(K,ee),void 0)}$releaseWorkspaceSymbols($,K){this._withAdapter($,x,ee=>ee.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider($,K,ee){const ae=this._addNewAdapter(new W(this._documents,ee,this._logService),$);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(K),W.supportsResolving(ee)),this._createDisposable(ae)}$provideRenameEdits($,K,ee,ae,q){return this._withAdapter($,W,se=>se.provideRenameEdits(c.URI.revive(K),ee,ae,q),void 0)}$resolveRenameLocation($,K,ee,ae){return this._withAdapter($,W,q=>q.resolveRenameLocation(c.URI.revive(K),ee,ae),void 0)}registerDocumentSemanticTokensProvider($,K,ee,ae){const q=this._nextHandle(),se=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new We(new G(this._documents,ee),$)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(K),ae,se);let he=this._createDisposable(q);if(se){const Re=ee.onDidChangeSemanticTokens(Be=>this._proxy.$emitDocumentSemanticTokensEvent(se));he=A.Disposable.from(he,Re)}return he}$provideDocumentSemanticTokens($,K,ee,ae){return this._withAdapter($,G,q=>q.provideDocumentSemanticTokens(c.URI.revive(K),ee,ae),null,!0)}$releaseDocumentSemanticTokens($,K){this._withAdapter($,G,ee=>ee.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider($,K,ee,ae){const q=this._addNewAdapter(new H(this._documents,ee),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(K),ae),this._createDisposable(q)}$provideDocumentRangeSemanticTokens($,K,ee,ae){return this._withAdapter($,H,q=>q.provideDocumentRangeSemanticTokens(c.URI.revive(K),ee,ae),null,!0)}registerCompletionItemProvider($,K,ee,ae){const q=this._addNewAdapter(new U(this._documents,this._commands.converter,ee,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(K),ae,U.supportsResolving(ee),`${$.identifier.value}(${ae.join("")})`),this._createDisposable(q)}$provideCompletionItems($,K,ee,ae,q){return this._withAdapter($,U,se=>se.provideCompletionItems(c.URI.revive(K),ee,ae,q),void 0)}$resolveCompletionItem($,K,ee){return this._withAdapter($,U,ae=>ae.resolveCompletionItem(K,ee),void 0)}$releaseCompletionItems($,K){this._withAdapter($,U,ee=>ee.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider($,K,ee){const ae=this._addNewAdapter(new V(this._documents,ee,this._commands.converter),$);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideInlineCompletions($,K,ee,ae,q){return this._withAdapter($,V,se=>se.provideInlineCompletions(c.URI.revive(K),ee,ae,q),void 0)}$handleInlineCompletionDidShow($,K,ee){this._withAdapter($,V,async ae=>{ae.handleDidShowCompletionItem(K,ee)},void 0)}$freeInlineCompletionsList($,K){this._withAdapter($,V,async ee=>{ee.disposeCompletions(K)},void 0)}registerSignatureHelpProvider($,K,ee,ae){const q=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,se=this._addNewAdapter(new ne(this._documents,ee),$);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(K),q),this._createDisposable(se)}$provideSignatureHelp($,K,ee,ae,q){return this._withAdapter($,ne,se=>se.provideSignatureHelp(c.URI.revive(K),ee,ae,q),void 0)}$releaseSignatureHelp($,K){this._withAdapter($,ne,ee=>ee.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider($,K,ee){const ae=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new ce(this._documents,ee),$);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(K),ae);let se=this._createDisposable(q);if(ae!==void 0){const he=ee.onDidChangeInlayHints(Re=>this._proxy.$emitInlayHintsEvent(ae));se=A.Disposable.from(se,he)}return se}$provideInlayHints($,K,ee,ae){return this._withAdapter($,ce,q=>q.provideInlayHints(c.URI.revive(K),ee,ae),void 0)}registerDocumentLinkProvider($,K,ee){const ae=this._addNewAdapter(new Z(this._documents,ee),$);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(K),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks($,K,ee){return this._withAdapter($,Z,ae=>ae.provideLinks(c.URI.revive(K),ee),void 0)}$resolveDocumentLink($,K,ee){return this._withAdapter($,Z,ae=>ae.resolveLink(K,ee),void 0)}$releaseDocumentLinks($,K){this._withAdapter($,Z,ee=>ee.releaseLinks(K),void 0)}registerColorProvider($,K,ee){const ae=this._addNewAdapter(new oe(this._documents,ee),$);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDocumentColors($,K,ee){return this._withAdapter($,oe,ae=>ae.provideColors(c.URI.revive(K),ee),[])}$provideColorPresentations($,K,ee,ae){return this._withAdapter($,oe,q=>q.provideColorPresentations(c.URI.revive(K),ee,ae),void 0)}registerFoldingRangeProvider($,K,ee){const ae=this._nextHandle(),q=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new We(new ve(this._documents,ee),$)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(K),q);let se=this._createDisposable(ae);if(q!==void 0){const he=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));se=A.Disposable.from(se,he)}return se}$provideFoldingRanges($,K,ee,ae){return this._withAdapter($,ve,q=>q.provideFoldingRanges(c.URI.revive(K),ee,ae),void 0)}registerSelectionRangeProvider($,K,ee){const ae=this._addNewAdapter(new Ae(this._documents,ee,this._logService),$);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideSelectionRanges($,K,ee,ae){return this._withAdapter($,Ae,q=>q.provideSelectionRanges(c.URI.revive(K),ee,ae),[])}registerCallHierarchyProvider($,K,ee){const ae=this._addNewAdapter(new Se(this._documents,ee),$);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$prepareCallHierarchy($,K,ee,ae){return this._withAdapter($,Se,q=>Promise.resolve(q.prepareSession(c.URI.revive(K),ee,ae)),void 0)}$provideCallHierarchyIncomingCalls($,K,ee,ae){return this._withAdapter($,Se,q=>q.provideCallsTo(K,ee,ae),void 0)}$provideCallHierarchyOutgoingCalls($,K,ee,ae){return this._withAdapter($,Se,q=>q.provideCallsFrom(K,ee,ae),void 0)}$releaseCallHierarchy($,K){this._withAdapter($,Se,ee=>Promise.resolve(ee.releaseSession(K)),void 0)}registerTypeHierarchyProvider($,K,ee){const ae=this._addNewAdapter(new Ne(this._documents,ee),$);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$prepareTypeHierarchy($,K,ee,ae){return this._withAdapter($,Ne,q=>Promise.resolve(q.prepareSession(c.URI.revive(K),ee,ae)),void 0)}$provideTypeHierarchySupertypes($,K,ee,ae){return this._withAdapter($,Ne,q=>q.provideSupertypes(K,ee,ae),void 0)}$provideTypeHierarchySubtypes($,K,ee,ae){return this._withAdapter($,Ne,q=>q.provideSubtypes(K,ee,ae),void 0)}$releaseTypeHierarchy($,K){this._withAdapter($,Ne,ee=>Promise.resolve(ee.releaseSession(K)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:(0,C.regExpFlags)($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:je._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:je._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?je._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?je._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:je._serializeRegExp($.beforeText),afterText:$.afterText?je._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?je._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(je._serializeOnEnterRule)}setLanguageConfiguration($,K,ee){let{wordPattern:ae}=ee;if(ae&&(0,C.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(K,ae):this._documents.setWordDefinitionFor(K,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const q=this._nextHandle(),se={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?je._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?je._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?je._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,K,se),this._createDisposable(q)}$setWordDefinitions($){for(const K of $)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=je,je._handlePool=0}),define(be[195],Ee([0,1,5,8,7,35,14,6]),function(re,e,c,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(t,b,n,f){this._documents=b,this._commands=n,this._uriTransformer=f,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,b){await this._proxy.$changeLanguage(t,b);const n=this._documents.getDocumentData(t);if(!n)throw new Error(`document '${t.toString}' NOT found`);return n.document}async tokenAtPosition(t,b){const n=t.version,f=M.Position.from(b),o=await this._proxy.$tokensAtPosition(t.uri,f),l={type:E.StandardTokenType.Other,range:t.getWordRangeAtPosition(b)??new E.Range(b.line,b.character,b.line,b.character)};if(!o)return l;const v={range:M.Range.to(o.range),type:M.TokenType.to(o.type)};return!v.range.contains(b)||n!==t.version?l:v}createLanguageStatusItem(t,b,n){const f=this._handlePool++,o=this._proxy,l=this._ids,v=`${t.identifier.value}/${b}`;if(l.has(v))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);l.add(v);const D={selector:n,id:b,name:t.displayName??t.name,severity:E.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let _,a=new C.DisposableStore;const d=()=>{_?.dispose(),_=(0,R.disposableTimeout)(()=>{a.clear(),this._proxy.$setLanguageStatus(f,{id:v,name:D.name??t.displayName??t.name,source:t.displayName??t.name,selector:M.DocumentSelector.from(D.selector,this._uriTransformer),label:D.text,detail:D.detail??"",severity:D.severity===E.LanguageStatusSeverity.Error?A.default.Error:D.severity===E.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:D.command&&this._commands.toInternal(D.command,a),accessibilityInfo:D.accessibilityInformation})},0)},S={dispose(){a.dispose(),_?.dispose(),o.$removeLanguageStatus(f),l.delete(v)},get id(){return D.id},get name(){return D.name},set name(i){D.name=i,d()},get selector(){return D.selector},set selector(i){D.selector=i,d()},get text(){return D.text},set text(i){D.text=i,d()},get detail(){return D.detail},set detail(i){D.detail=i,d()},get severity(){return D.severity},set severity(i){D.severity=i,d()},get accessibilityInformation(){return D.accessibilityInformation},set accessibilityInformation(i){D.accessibilityInformation=i,d()},get command(){return D.command},set command(i){D.command=i,d()}};return d(),S}}e.ExtHostLanguages=y}),define(be[196],Ee([0,1,5,15,30]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(C){return C&&C.title}let R=class{constructor(y,P){this._logService=P,this._proxy=y.getProxy(c.MainContext.MainThreadMessageService)}showMessage(y,P,t,b,n){const f={extension:y};let o;typeof b=="string"||A(b)?o=[b,...n]:(f.modal=b?.modal,f.useCustom=b?.useCustom,f.detail=b?.detail,o=n),f.useCustom&&(0,E.checkProposedApiEnabled)(y);const l=[];for(let v=0;v<o.length;v++){const D=o[v];if(typeof D=="string")l.push({title:D,handle:v,isCloseAffordance:!1});else if(typeof D=="object"){let{title:_,isCloseAffordance:a}=D;l.push({title:_,isCloseAffordance:!!a,handle:v})}else this._logService.warn("Invalid message item:",D)}return this._proxy.$showMessage(P,t,f,l).then(v=>{if(typeof v=="number")return o[v]})}};R=$e([Ve(1,M.ILogService)],R),e.ExtHostMessageService=R}),define(be[197],Ee([0,1,22,3,58,6,20,9,10,2,63,5,8,7,38,172,93]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class D{constructor(a,d,S,i,p){this._textDocumentsAndEditors=S,this._textDocuments=i,this._extensionStoragePaths=p,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(b.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(b.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(b.MainContext.MainThreadNotebookEditors),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const s=r.notebookEditor?.notebookUri,u=r.cell.handle,m=this._documents.get(s)?.getCell(u);if(m)return m.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const d=this._editors.get(a);if(!d)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return d}getIdByEditor(a){for(const[d,S]of this._editors)if(S.apiEditor===a)return d}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,d){const S=this._documents.get(a);if(!S&&!d)throw new Error(`NO notebook document for '${a}'`);return S}_getProviderData(a){const d=this._notebookContentProviders.get(a);if(!d)throw new Error(`NO provider for '${a}'`);return d}registerNotebookContentProvider(a,d,S,i,p){if((0,C.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(d))throw new Error(`Notebook provider for '${d}' already registered`);this._notebookContentProviders.set(d,{extension:a,provider:S});let r;return S.onDidChangeNotebookContentOptions&&(r=S.onDidChangeNotebookContentOptions(()=>{const s=n.NotebookDocumentContentOptions.from(S.options);this._notebookProxy.$updateNotebookProviderOptions(d,s)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},d,n.NotebookDocumentContentOptions.from(i),D._convertNotebookRegistrationData(a,p)),new f.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(d),this._notebookProxy.$unregisterNotebookProvider(d)})}static _convertNotebookRegistrationData(a,d){if(!d)return;const S=d.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(d.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:d.displayName,filenamePattern:S,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,d,S){const i=D._notebookStatusBarItemProviderHandlePool++,p=typeof S.onDidChangeCellStatusBarItems=="function"?D._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,S),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,p,d);let r;return p!==void 0&&(r=S.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(p))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,p),r&&r.dispose()})}async createNotebookDocument(a){const d=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&n.NotebookData.from(a.content)});return P.URI.revive(d)}async openNotebookDocument(a){const d=this._documents.get(a);if(d)return d.apiNotebook;const S=await this._notebookDocumentsProxy.$tryOpenNotebook(a),i=this._documents.get(P.URI.revive(S));return(0,y.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(a,d){P.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let S;typeof d=="object"?S={position:n.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(n.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:S={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,S),p=i&&this._editors.get(i)?.apiEditor;if(p)return p;throw i?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,d,S,i){const p=this._notebookStatusBarItemProviders.get(a),r=P.URI.revive(d),s=this._documents.get(r);if(!s||!p)return;const u=s.getCellFromIndex(S);if(!u)return;const h=await p.provideCellStatusBarItems(u.apiCell,i);if(!h)return;const m=new A.DisposableStore,k=this._statusBarCache.add([m]),g=(Array.isArray(h)?h:[h]).map(I=>n.NotebookStatusBarItem.from(I,this._commandsConverter,m));return{cacheId:k,items:g}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,d,S,i,p){if((0,C.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,S),this._notebookProxy.$registerNotebookSerializer(r,{id:a.identifier,location:a.extensionLocation},d,n.NotebookDocumentContentOptions.from(i),D._convertNotebookRegistrationData(a,p)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(a,d,S){const i=this._notebookSerializer.get(a);if(!i)throw new Error("NO serializer found");const p=await i.deserializeNotebook(d.buffer,S);return new o.SerializableObjectWithBuffers(n.NotebookData.from(p))}async $notebookToData(a,d,S){const i=this._notebookSerializer.get(a);if(!i)throw new Error("NO serializer found");const p=await i.serializeNotebook(n.NotebookData.to(d.value),S);return c.VSBuffer.wrap(p)}async $openNotebook(a,d,S,i,p){const{provider:r}=this._getProviderData(a),s=await r.openNotebook(P.URI.revive(d),{backupId:S,untitledDocumentData:i?.buffer},p);return new o.SerializableObjectWithBuffers({metadata:s.metadata??Object.create(null),cells:s.cells.map(n.NotebookCellData.from)})}async $saveNotebook(a,d,S){const i=this.getNotebookDocument(P.URI.revive(d)),{provider:p}=this._getProviderData(a);return await p.saveNotebook(i.apiNotebook,S),!0}async $saveNotebookAs(a,d,S,i){const p=this.getNotebookDocument(P.URI.revive(d)),{provider:r}=this._getProviderData(a);return await r.saveNotebookAs(P.URI.revive(S),p.apiNotebook,i),!0}async $backupNotebook(a,d,S){const i=this.getNotebookDocument(P.URI.revive(d)),p=this._getProviderData(a),r=this._extensionStoragePaths.workspaceValue(p.extension)??this._extensionStoragePaths.globalValue(p.extension),s=String((0,E.hash)([i.uri.toString(),this._backupIdPool++])),u=P.URI.joinPath(r,s),h=await p.provider.backupNotebook(i.apiNotebook,{destination:u},S);return i.updateBackup(h),h.id}_createExtHostEditor(a,d,S){if(this._editors.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const i=new v.ExtHostNotebookEditor(d,this._notebookEditorsProxy,a,S.visibleRanges.map(n.NotebookRange.to),S.selections.map(n.NotebookRange.to),typeof S.viewColumn=="number"?n.ViewColumn.to(S.viewColumn):void 0);this._editors.set(d,i)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const S of a.value.removedDocuments){const i=P.URI.revive(S),p=this._documents.get(i);p&&(p.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(p.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===i.toString()&&this._editors.delete(r.id)}if(a.value.addedDocuments){const S=[];for(const i of a.value.addedDocuments){const p=P.URI.revive(i.uri);if(this._documents.has(p))throw new Error(`adding EXISTING notebook ${p} `);const r=this,s=new l.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(u){r._onDidChangeNotebookCells.fire(u)},emitCellOutputsChange(u){r._onDidChangeCellOutputs.fire(u)},emitCellMetadataChange(u){r._onDidChangeCellMetadata.fire(u)},emitCellExecutionStateChange(u){r._onDidChangeCellExecutionState.fire(u)}},p,i);S.push(...i.cells.map(u=>l.ExtHostCell.asModelAddData(s.apiNotebook,u))),this._documents.get(p)?.dispose(),this._documents.set(p,s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this._onDidOpenNotebookDocument.fire(s.apiNotebook)}}if(a.value.addedEditors)for(const S of a.value.addedEditors){if(this._editors.has(S.id))return;const i=P.URI.revive(S.documentUri),p=this._documents.get(i);p&&this._createExtHostEditor(p,S.id,S)}const d=[];if(a.value.removedEditors)for(const S of a.value.removedEditors){const i=this._editors.get(S);i&&(this._editors.delete(S),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),d.push(i))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const S=new Set;this._visibleNotebookEditors.forEach(i=>S.add(i.id));for(const i of this._editors.values()){const p=S.has(i.id);i._acceptVisibility(p)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=D,D._notebookStatusBarItemProviderHandlePool=0}),define(be[198],Ee([0,1,3,53,15,5,12,8]),function(re,e,c,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(b,n){const f=y._Keys.nextId();b.$registerNotebookEditorDecorationType(f,C.NotebookDecorationRenderOptions.from(n)),this.value={key:f,dispose(){b.$removeNotebookEditorDecorationType(f)}}}}y._Keys=new M.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(b,n,f){this._logService=b,this._extHostRpc=n,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new c.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new c.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(b){return new y(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),b).value}$acceptEditorPropertiesChanged(b,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,n);const f=this._notebooksAndEditors.getEditorById(b);n.visibleRanges&&f._acceptVisibleRanges(n.visibleRanges.ranges.map(C.NotebookRange.to)),n.selections&&f._acceptSelections(n.selections.selections.map(C.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const n in b)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(C.ViewColumn.to(b[n]))}};P=$e([Ve(0,E.ILogService),Ve(1,R.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(be[199],Ee([0,1,13,14,21,3,6,20,2,26,15,5,39,8,7,66,165,30,38]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o,l,v,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let a=class{constructor(r,s,u,h,m){this._initData=s,this._extHostNotebook=u,this._commands=h,this._logService=m,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(b.MainContext.MainThreadNotebookKernels);const k=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const g=this._extHostNotebook.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:g}}else if(T&&"notebookEditor"in T){const g=this._extHostNotebook.getIdByEditor(T.notebookEditor);if(g===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.document.uri.toString()}`);return{notebookEditorId:g}}return T})],n.ApiCommandResult.Void);this._commands.registerApiCommand(k)}createNotebookController(r,s,u,h,m,k){for(let ne of this._kernelData.values())if(ne.controller.id===s&&P.ExtensionIdentifier.equals(r.identifier,ne.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const T=this._handlePool++,g=this;this._logService.trace(`NotebookController[${T}], CREATED by ${r.identifier.value}, ${s}`);const I=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${r.identifier}'`);let F=!1;const L=new R.DisposableStore,w=new A.Emitter,x=new A.Emitter,W={id:`${r.identifier.value}/${s}`,notebookType:u,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:h||r.identifier.value,preloads:k?k.map(f.NotebookRendererScript.from):[]};let B=m??I,G;this._proxy.$addKernel(T,W).catch(ne=>{console.log(ne),F=!0});let H=0;const U=()=>{if(F)return;const ne=++H;Promise.resolve().then(()=>{ne===H&&this._proxy.$updateKernel(T,W)})},V=new C.ResourceMap,Q={get id(){return s},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:w.event,get label(){return W.label},set label(ne){W.label=ne??r.displayName??r.name,U()},get detail(){return W.detail??""},set detail(ne){W.detail=ne,U()},get description(){return W.description??""},set description(ne){W.description=ne,U()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages(ne){W.supportedLanguages=ne,U()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){W.supportsExecutionOrder=ne,U()},get rendererScripts(){return W.preloads?W.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return B},set executeHandler(ne){B=ne??I},get interruptHandler(){return G},set interruptHandler(ne){G=ne,W.supportsInterrupt=Boolean(ne),U()},createNotebookCellExecution(ne){if(F)throw new Error("notebook controller is DISPOSED");if(!V.has(ne.notebook.uri))throw g._logService.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return g._createNotebookCellExecution(ne)},dispose:()=>{F||(this._logService.trace(`NotebookController[${T}], DISPOSED`),F=!0,this._kernelData.delete(T),L.dispose(),w.dispose(),x.dispose(),this._proxy.$removeKernel(T))},updateNotebookAffinity(ne,ce){g._proxy.$updateNotebookPriority(T,ne.uri,ce)},onDidReceiveMessage:x.event,postMessage(ne,ce){return(0,D.checkProposedApiEnabled)(r),g._proxy.$postMessage(T,ce&&g._extHostNotebook.getIdByEditor(ce),ne)},asWebviewUri(ne){return(0,D.checkProposedApiEnabled)(r),(0,l.asWebviewUri)(ne,g._initData.remote)}};return this._kernelData.set(T,{extensionId:r.identifier,controller:Q,onDidReceiveMessage:x,onDidChangeSelection:w,associatedNotebooks:V}),Q}$acceptNotebookAssociation(r,s,u){const h=this._kernelData.get(r);if(h){const m=this._extHostNotebook.getNotebookDocument(y.URI.revive(s));u?h.associatedNotebooks.set(m.uri,!0):h.associatedNotebooks.delete(m.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,m.uri.toString(),u),h.onDidChangeSelection.fire({selected:u,notebook:m.apiNotebook})}}async $executeCells(r,s,u){const h=this._kernelData.get(r);if(!h)return;const m=this._extHostNotebook.getNotebookDocument(y.URI.revive(s)),k=[];for(let T of u){const g=m.getCell(T);g&&k.push(g.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,m.uri.toString(),k.length),await h.controller.executeHandler.call(h.controller,k,m.apiNotebook,h.controller)}catch(T){this._logService.error(`NotebookController[${r}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(r,s,u){const h=this._kernelData.get(r);if(!h)return;const m=this._extHostNotebook.getNotebookDocument(y.URI.revive(s));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,m.apiNotebook);else for(let k of u){const T=m.getCell(k);T&&this._activeExecutions.get(T.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,s,u){const h=this._kernelData.get(r);if(!h)return;const m=this._extHostNotebook.getEditorById(s);h.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:u}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!u)throw new Error("invalid cell");if(this._activeExecutions.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const h=new S(u.notebook,u,this._proxy);this._activeExecutions.set(u.uri,h);const m=h.onDidChangeState(()=>{h.state===d.Resolved&&(h.dispose(),m.dispose(),this._activeExecutions.delete(u.uri))});return h.asApiObject()}};a=$e([Ve(4,t.ILogService)],a),e.ExtHostNotebookKernels=a;var d;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(d||(d={}));class S extends R.Disposable{constructor(r,s,u){super();this._document=r,this._cell=s,this._proxy=u,this._handle=S.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=d.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._collector=new i(10,h=>this.update(h)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const s=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new _.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===d.Init)throw new Error("Must call start before modifying cell output");if(this._state===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let s=this._cell;if(r&&(s=this._document.getCellFromApiCell(r)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(r){return r.map(s=>{const u=o.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return u===s.items?f.NotebookCellOutput.from(s):f.NotebookCellOutput.from({items:u,id:s.id,metadata:s.metadata})})}async updateOutputs(r,s,u){const h=this.cellIndexToHandle(s),m=this.validateAndConvertOutputs((0,c.asArray)(r));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:h,append:u,outputs:m})}async updateOutputItems(r,s,u){return r=o.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(r),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(f.NotebookCellOutputItem.from),outputId:s.id,append:u})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(u){r._executionOrder=u,r.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(u){if(r._state===d.Resolved||r._state===d.Started)throw new Error("Cannot call start again");r._state=d.Started,r._onDidChangeState.fire(),r.update({editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:u})},end(u,h){if(r._state===d.Resolved)throw new Error("Cannot call resolve twice");r._state=d.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:v.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:h,lastRunSuccess:u}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(u){return r.verifyStateForOutput(),r.updateOutputs([],u,!1)},appendOutput(u,h){return r.verifyStateForOutput(),r.updateOutputs(u,h,!0)},replaceOutput(u,h){return r.verifyStateForOutput(),r.updateOutputs(u,h,!1)},appendOutputItems(u,h){return r.verifyStateForOutput(),r.updateOutputItems(u,h,!0)},replaceOutputItems(u,h){return r.verifyStateForOutput(),r.updateOutputItems(u,h,!1)}})}}S.HANDLE=0;class i{constructor(r,s){this.delay=r,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>r.complete())}}}),define(be[200],Ee([0,1,3,5,93]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(C,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,y,P){const t=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(y)?.fire({editor:t.apiEditor,message:P})}createRendererMessaging(C,y){if(!C.contributes?.notebookRenderer?.some(n=>n.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);const P=!!C.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,f,o)=>{const l=P?n:v=>{const D={};t.set(D,v.editor),n({editor:D,message:v.message})};return this.getOrCreateEmitterFor(y).event(l,f,o)},postMessage:(n,f)=>{E.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,f]=[f,n]);const o=P?f:t.get(f),l=o&&E.ExtHostNotebookEditor.apiEditorsToExtHost.get(o);return this.proxy.$postMessage(l?.id,y,n)}}}getOrCreateEmitterFor(C){let y=this._rendererMessageEmitters.get(C);return y||(y=new c.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,y),y)}}e.ExtHostNotebookRenderers=A}),define(be[96],Ee([0,1,5,3,6,22,4,12]),function(re,e,c,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends E.Disposable{constructor(o,l,v,D,_){super();this._onDidAppend=this._register(new M.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=o,this._proxy=_,this._id=_.$register(this.name,l,v,D),this._disposed=!1,this._offset=0}get name(){return this._name}append(o){this.validate(),this._offset+=o?A.VSBuffer.fromString(o).byteLength:0}update(){this._id.then(o=>this._proxy.$update(o))}appendLine(o){this.validate(),this.append(o+`
`)}clear(){this.validate();const o=this._offset;this._id.then(l=>this._proxy.$clear(l,o))}show(o,l){this.validate(),this._id.then(v=>this._proxy.$reveal(v,!!(typeof o=="boolean"?o:l)))}hide(){this.validate(),this._id.then(o=>this._proxy.$close(o))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(o=>this._proxy.$dispose(o)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class P extends y{constructor(o,l,v){super(o,!1,void 0,l,v)}append(o){super.append(o),this._id.then(l=>this._proxy.$append(l,o)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class t extends y{constructor(o,l,v){super(o,!0,l,void 0,v)}append(o){throw new Error("Not supported")}}class b{constructor(o,l){this.name=o,this._channel=l}append(o){this._channel.then(l=>l.append(o))}appendLine(o){this._channel.then(l=>l.appendLine(o))}clear(){this._channel.then(o=>o.clear())}show(o,l){this._channel.then(v=>v.show(o,l))}hide(){this._channel.then(o=>o.hide())}dispose(){this._channel.then(o=>o.dispose())}}e.LazyOutputChannel=b;let n=class{constructor(o){this._proxy=o.getProxy(c.MainContext.MainThreadOutputService)}$setVisibleChannel(o){}createOutputChannel(o,l){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");return new P(o,l.identifier.value,this._proxy)}createOutputChannelFromLogFile(o,l){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");if(!l)throw new Error("illegal argument `file`. must not be falsy");return new t(o,l,this._proxy)}};n=$e([Ve(0,C.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(be[201],Ee([0,1,14,21,3,6,5,2,7,16,13,35,46]),function(re,e,c,M,E,A,R,C,y,P,t,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(o,l,v){const D=o.getProxy(R.MainContext.MainThreadQuickOpen);class _{constructor(h,m){this._sessions=new Map,this._instances=0,this._workspace=h,this._commands=m}showQuickPick(h,m,k,T=M.CancellationToken.None){this._onDidSelectItem=void 0;const g=Promise.resolve(h),I=++this._instances,F=D.$show(I,{title:k?.title,placeHolder:k?.placeHolder,matchOnDescription:k?.matchOnDescription,matchOnDetail:k?.matchOnDetail,ignoreFocusLost:k?.ignoreFocusOut,canPickMany:k?.canPickMany},T),L={},w=F.then(()=>L);return Promise.race([w,g]).then(x=>{if(x!==L)return g.then(W=>{const B=[];for(let G=0;G<W.length;G++){const H=W[G];let U,V,Q,ne,ce;typeof H=="string"?U=H:(U=H.label,V=H.description,Q=H.detail,ne=H.picked,ce=H.alwaysShow),B.push({label:U,description:V,handle:G,detail:Q,picked:ne,alwaysShow:ce})}return k&&typeof k.onDidSelectItem=="function"&&(this._onDidSelectItem=G=>{k.onDidSelectItem(W[G])}),D.$setItems(I,B),F.then(G=>{if(typeof G=="number")return W[G];if(Array.isArray(G))return G.map(H=>W[H])})})}).then(void 0,x=>{if(!(0,P.isPromiseCanceledError)(x))return D.$setError(I,x),Promise.reject(x)})}$onItemSelected(h){this._onDidSelectItem&&this._onDidSelectItem(h)}showInput(h,m=M.CancellationToken.None){return this._validateInput=h?h.validateInput:void 0,D.$input(h,typeof this._validateInput=="function",m).then(void 0,k=>{if(!(0,P.isPromiseCanceledError)(k))return Promise.reject(k)})}$validateInput(h){return this._validateInput?(0,c.asPromise)(()=>this._validateInput(h)):Promise.resolve(void 0)}async showWorkspaceFolderPick(h,m=M.CancellationToken.None){const k=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[h]);if(!k)return;const T=await this._workspace.getWorkspaceFolders2();if(!!T)return T.find(g=>g.uri.toString()===k.uri.toString())}createQuickPick(h,m){const k=new r(h,m,()=>this._sessions.delete(k._id));return this._sessions.set(k._id,k),k}createInputBox(h){const m=new s(h,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}$onDidChangeValue(h,m){const k=this._sessions.get(h);k&&k._fireDidChangeValue(m)}$onDidAccept(h){const m=this._sessions.get(h);m&&m._fireDidAccept()}$onDidChangeActive(h,m){const k=this._sessions.get(h);k instanceof r&&k._fireDidChangeActive(m)}$onDidChangeSelection(h,m){const k=this._sessions.get(h);k instanceof r&&k._fireDidChangeSelection(m)}$onDidTriggerButton(h,m){const k=this._sessions.get(h);k&&k._fireDidTriggerButton(m)}$onDidTriggerItemButton(h,m,k){const T=this._sessions.get(h);T instanceof r&&T._fireDidTriggerItemButton(m,k)}$onDidHide(h){const m=this._sessions.get(h);m&&m._fireDidHide()}}class a{constructor(h,m){this._extensionId=h,this._onDidDispose=m,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new E.Emitter,this._onDidChangeValueEmitter=new E.Emitter,this._onDidTriggerButtonEmitter=new E.Emitter,this._onDidHideEmitter=new E.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(h){this._title=h,this.update({title:h})}get step(){return this._steps}set step(h){this._steps=h,this.update({step:h})}get totalSteps(){return this._totalSteps}set totalSteps(h){this._totalSteps=h,this.update({totalSteps:h})}get enabled(){return this._enabled}set enabled(h){this._enabled=h,this.update({enabled:h})}get busy(){return this._busy}set busy(h){this._busy=h,this.update({busy:h})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(h){this._ignoreFocusOut=h,this.update({ignoreFocusOut:h})}get value(){return this._value}set value(h){this._value=h,this.update({value:h})}get placeholder(){return this._placeholder}set placeholder(h){this._placeholder=h,this.update({placeholder:h})}get buttons(){return this._buttons}set buttons(h){this._buttons=h.slice(),this._handlesToButtons.clear(),h.forEach((m,k)=>{const T=m===y.QuickInputButtons.Back?-1:k;this._handlesToButtons.set(T,m)}),this.update({buttons:h.map((m,k)=>({...p(m),tooltip:m.tooltip,handle:m===y.QuickInputButtons.Back?-1:k}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(h){this._value=h,this._onDidChangeValueEmitter.fire(h)}_fireDidTriggerButton(h){const m=this._handlesToButtons.get(h);m&&this._onDidTriggerButtonEmitter.fire(m)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),D.$dispose(this._id))}update(h){if(!this._disposed){for(const m of Object.keys(h)){const k=h[m];this._pendingUpdate[m]=k===void 0?null:k}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){D.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}a._nextId=1;function d(u){if(u instanceof y.ThemeIcon)return{id:u.id};const h=i(u),m=S(u);return{dark:typeof h=="string"?C.URI.file(h):h,light:typeof m=="string"?C.URI.file(m):m}}function S(u){return typeof u=="object"&&"light"in u?u.light:u}function i(u){return typeof u=="object"&&"dark"in u?u.dark:u}function p(u){const h=d(u.iconPath);let m,k;return"id"in h?k=n.ThemeIcon.asClassName(h):m=h,{iconPath:m,iconClass:k}}class r extends a{constructor(h,m,k){super(h,k);this.enableProposedApi=m,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new E.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new E.Emitter,this._onDidTriggerItemButtonEmitter=new E.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(h){this._items=h.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),h.forEach((m,k)=>{this._handlesToItems.set(k,m),this._itemsToHandles.set(m,k)}),this.update({items:h.map((m,k)=>({label:m.label,description:m.description,handle:k,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,buttons:m.buttons&&this.enableProposedApi?m.buttons.map((T,g)=>({...p(T),tooltip:T.tooltip,handle:g})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(h){this._canSelectMany=h,this.update({canSelectMany:h})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(h){this._matchOnDescription=h,this.update({matchOnDescription:h})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(h){this._matchOnDetail=h,this.update({matchOnDetail:h})}get sortByLabel(){return this._sortByLabel}set sortByLabel(h){this._sortByLabel=h,this.update({sortByLabel:h})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(h){this._keepScrollPosition=h,this.update({keepScrollPosition:h})}get activeItems(){return this._activeItems}set activeItems(h){this._activeItems=h.filter(m=>this._itemsToHandles.has(m)),this.update({activeItems:this._activeItems.map(m=>this._itemsToHandles.get(m))})}get selectedItems(){return this._selectedItems}set selectedItems(h){this._selectedItems=h.filter(m=>this._itemsToHandles.has(m)),this.update({selectedItems:this._selectedItems.map(m=>this._itemsToHandles.get(m))})}_fireDidChangeActive(h){const m=(0,t.coalesce)(h.map(k=>this._handlesToItems.get(k)));this._activeItems=m,this._onDidChangeActiveEmitter.fire(m)}_fireDidChangeSelection(h){const m=(0,t.coalesce)(h.map(k=>this._handlesToItems.get(k)));this._selectedItems=m,this._onDidChangeSelectionEmitter.fire(m)}_fireDidTriggerItemButton(h,m){const k=this._handlesToItems.get(h);if(!k||!k.buttons||!k.buttons.length)return;const T=k.buttons[m];T&&this._onDidTriggerItemButtonEmitter.fire({button:T,item:k})}}class s extends a{constructor(h,m){super(h,m);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(h){this._password=h,this.update({password:h})}get prompt(){return this._prompt}set prompt(h){this._prompt=h,this.update({prompt:h})}get validationMessage(){return this._validationMessage}set validationMessage(h){this._validationMessage=h,this.update({validationMessage:h,severity:h?b.default.Error:b.default.Ignore})}}return new _(l,v)}e.createExtHostQuickOpen=f}),define(be[202],Ee([0,1,2,3,52,6,14,5,13,108,15,26,30,46,8]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(h){if(h)return typeof h.iconPath=="string"?c.URI.file(h.iconPath):c.URI.isUri(h.iconPath)||f.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function v(h,m){if(!h.iconPath&&!m.iconPath)return 0;if(h.iconPath){if(!m.iconPath)return 1}else return-1;const k=typeof h.iconPath=="string"?h.iconPath:c.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,T=typeof m.iconPath=="string"?m.iconPath:c.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,P.comparePaths)(k,T)}function D(h,m){let k=0;if(h.strikeThrough!==m.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==m.faded)return h.faded?1:-1;if(h.tooltip!==m.tooltip)return(h.tooltip||"").localeCompare(m.tooltip||"");if(k=v(h,m),k!==0)return k;if(h.light&&m.light)k=v(h.light,m.light);else{if(h.light)return 1;if(m.light)return-1}if(k!==0)return k;if(h.dark&&m.dark)k=v(h.dark,m.dark);else{if(h.dark)return 1;if(m.dark)return-1}return k}function _(h,m){if(h.command!==m.command)return h.command<m.command?-1:1;if(h.title!==m.title)return h.title<m.title?-1:1;if(h.tooltip!==m.tooltip){if(h.tooltip!==void 0&&m.tooltip!==void 0)return h.tooltip<m.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(h.arguments===m.arguments)return 0;if(h.arguments)if(m.arguments){if(h.arguments.length!==m.arguments.length)return h.arguments.length-m.arguments.length}else return 1;else return-1;for(let k=0;k<h.arguments.length;k++){const T=h.arguments[k],g=m.arguments[k];if(T!==g)return T<g?-1:1}return 0}function a(h,m){let k=(0,P.comparePaths)(h.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(k!==0)return k;if(h.command&&m.command)k=_(h.command,m.command);else{if(h.command)return 1;if(m.command)return-1}if(k!==0)return k;if(h.decorations&&m.decorations)k=D(h.decorations,m.decorations);else{if(h.decorations)return 1;if(m.decorations)return-1}return k}function d(h,m){for(let k=0;k<h.length;k++)if(h[k]!==m[k])return!1;return!0}function S(h,m){return h.command===m.command&&h.title===m.title&&h.tooltip===m.tooltip&&(h.arguments&&m.arguments?d(h.arguments,m.arguments):h.arguments===m.arguments)}function i(h,m){return(0,y.equals)(h,m,S)}class p{constructor(m,k,T){this._extension=m,this._proxy=k,this._sourceControlHandle=T,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(m){this._proxy.$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(m){if((0,n.checkProposedApiEnabled)(this._extension),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,m))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(m,k){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,m,k)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=p;class r{constructor(m,k,T,g,I){this._proxy=m,this._commands=k,this._sourceControlHandle=T,this._id=g,this._label=I,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,k){const T=this._resourceStatesCommandsMap.get(m);return T?(0,R.asPromise)(()=>this._commands.executeCommand(T.command,...T.arguments||[],k)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(a),T=(0,y.sortedDiff)(this._resourceSnapshot,m,a).map(F=>{const L=F.toInsert.map(w=>{const x=this._resourceHandlePool++;this._resourceStatesMap.set(x,w);const W=w.resourceUri;let B;if(w.command)if(w.command.command==="vscode.open"||w.command.command==="vscode.diff"){const ve=new A.DisposableStore;B=this._commands.converter.toInternal(w.command,ve),this._resourceStatesDisposablesMap.set(x,ve)}else this._resourceStatesCommandsMap.set(x,w.command);const G=l(w.decorations),H=w.decorations&&l(w.decorations.light)||G,U=w.decorations&&l(w.decorations.dark)||G,V=[H,U],Q=w.decorations&&w.decorations.tooltip||"",ne=w.decorations&&!!w.decorations.strikeThrough,ce=w.decorations&&!!w.decorations.faded,Z=w.contextValue||"";return{rawResource:[x,W,V,Q,ne,ce,Z,B],handle:x}});return{start:F.start,deleteCount:F.deleteCount,toInsert:L}}),g=T.map(({start:F,deleteCount:L,toInsert:w})=>[F,L,w.map(x=>x.rawResource)]),I=T.reverse();for(const{start:F,deleteCount:L,toInsert:w}of I){const x=w.map(B=>B.handle),W=this._handlesSnapshot.splice(F,L,...x);for(const B of W)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),this._resourceStatesDisposablesMap.get(B)?.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=m,g}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class s{constructor(m,k,T,g,I,F){this._extension=m,this._proxy=k,this._commands=T,this._id=g,this._label=I,this._rootUri=F,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=s._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new p(m,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,g,I,F)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,this._proxy.$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,this._proxy.$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=m;const k=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:k})}get actionButton(){return(0,n.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(m){(0,n.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=m;const k=m!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:k??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&i(this._statusBarCommands,m))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=m;const k=(m||[]).map(T=>this._commands.converter.toInternal(T,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:k})}get selected(){return this._selected}createResourceGroup(m,k){const T=new r(this._proxy,this._commands,this.handle,m,k),g=M.Event.once(T.onDidDispose)(()=>this.createdResourceGroups.delete(T));return this.createdResourceGroups.set(T,g),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const m=[],k=[];for(const[T,g]of this.createdResourceGroups){g.dispose();const I=T.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(T),this.eventuallyUpdateResourceStates()});M.Event.once(T.onDidDispose)(()=>{this.updatedResourceGroups.delete(T),I.dispose(),this._groups.delete(T.handle),this._proxy.$unregisterGroup(this.handle,T.handle)}),m.push([T.handle,T.id,T.label,T.features]);const F=T._takeResourceStateSnapshot();F.length>0&&k.push([T.handle,F]),this._groups.set(T.handle,T)}this._proxy.$registerGroups(this.handle,m,k),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(k=>{const T=k._takeResourceStateSnapshot();T.length!==0&&m.push([k.handle,T])}),m.length>0&&this._proxy.$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}s._handlePool=0,$e([(0,E.debounce)(100)],s.prototype,"eventuallyAddResourceGroups",null),$e([(0,E.debounce)(100)],s.prototype,"eventuallyUpdateResourceStates",null);let u=class Bi{constructor(m,k,T){this._commands=k,this.logService=T,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=m.getProxy(C.MainContext.MainThreadSCM),this._telemetry=m.getProxy(C.MainContext.MainThreadTelemetry),k.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===3){const I=this._sourceControls.get(g.sourceControlHandle);if(!I)return g;const F=I.getResourceGroup(g.groupHandle);return F?F.getResourceState(g.handle):g}else if(g&&g.$mid===4){const I=this._sourceControls.get(g.sourceControlHandle);return I?I.getResourceGroup(g.groupHandle):g}else if(g&&g.$mid===5){const I=this._sourceControls.get(g.handle);return I||g}return g}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(m,k,T,g){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,k,T,g),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const I=Bi._handlePool++,F=new s(m,this._proxy,this._commands,k,T,g);this._sourceControls.set(I,F);const L=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(m.identifier))||[];return L.push(F),this._sourceControlsByExtension.set(b.ExtensionIdentifier.toKey(m.identifier),L),F}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const k=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(m.identifier)),T=k&&k[k.length-1];return T&&T.inputBox}$provideOriginalResource(m,k,T){const g=c.URI.revive(k);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,g.toString());const I=this._sourceControls.get(m);return!I||!I.quickDiffProvider||!I.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>I.quickDiffProvider.provideOriginalResource(g,T)).then(F=>F||null)}$onInputBoxValueChange(m,k){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const T=this._sourceControls.get(m);return T&&T.inputBox.$onInputBoxValueChange(k),Promise.resolve(void 0)}$executeResourceCommand(m,k,T,g){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,k,T);const I=this._sourceControls.get(m);if(!I)return Promise.resolve(void 0);const F=I.getResourceGroup(k);return F?F.$executeResourceCommand(T,g):Promise.resolve(void 0)}$validateInput(m,k,T){this.logService.trace("ExtHostSCM#$validateInput",m);const g=this._sourceControls.get(m);return!g||!g.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>g.inputBox.validateInput(k,T)).then(I=>{if(!I)return Promise.resolve(void 0);const F=o.MarkdownString.fromStrict(I.message);return F?Promise.resolve([F,I.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}};u._handlePool=0,u=$e([Ve(2,t.ILogService)],u),e.ExtHostSCM=u});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Fe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(be[203],Ee([0,1,7,5,127,6,8,10]),function(re,e,c,M,E,A,R,C){"use strict";var y,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class t{constructor(o,l,v,D,_=c.StatusBarAlignment.Left,a){y.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,et(this,y,o,"f"),et(this,P,l,"f"),this._entryId=t.ID_GEN++,this._extension=v,this._id=D,this._alignment=_,this._priority=this.validatePriority(a)}validatePriority(o){if(!!(0,C.isNumber)(o))return o===Number.POSITIVE_INFINITY?Number.MAX_VALUE:o===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:o}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(o){this._text=o,this.update()}set name(o){this._name=o,this.update()}set tooltip(o){this._tooltip=o,this.update()}set color(o){this._color=o,this.update()}set backgroundColor(o){o&&!t.ALLOWED_BACKGROUND_COLORS.has(o.id)&&(o=void 0),this._backgroundColor=o,this.update()}set command(o){this._command?.fromApi!==o&&(this._internalCommandRegistration.clear(),typeof o=="string"?this._command={fromApi:o,internal:Fe(this,P,"f").toInternal({title:"",command:o},this._internalCommandRegistration)}:o?this._command={fromApi:o,internal:Fe(this,P,"f").toInternal(o,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(o){this._accessibilityInformation=o,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Fe(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let o;this._extension?this._id?o=`${this._extension.identifier.value}.${this._id}`:o=this._extension.identifier.value:o=this._id;let l;this._name?l=this._name:l=(0,E.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=t.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const D=this._tooltip?R.MarkdownString.fromStrict(this._tooltip):void 0;Fe(this,y,"f").$setEntry(this._entryId,o,l,this._text,D,this._command?.internal,v,this._backgroundColor,this._alignment===c.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=t,y=new WeakMap,P=new WeakMap,t.ID_GEN=0,t.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class b{constructor(o){this._messages=[],this._item=o.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,E.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(o){const l={message:o};return this._messages.unshift(l),this._update(),new c.Disposable(()=>{const v=this._messages.indexOf(l);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(o,l){this._proxy=o.getProxy(M.MainContext.MainThreadStatusBar),this._commands=l,this._statusMessage=new b(this)}createStatusBarEntry(o,l,v,D){return new t(this._proxy,this._commands,o,l,v,D)}setStatusBarMessage(o,l){const v=this._statusMessage.setMessage(o);let D;return typeof l=="number"?D=setTimeout(()=>v.dispose(),l):typeof l!="undefined"&&l.then(()=>v.dispose(),()=>v.dispose()),new c.Disposable(()=>{v.dispose(),clearTimeout(D)})}}e.ExtHostStatusBar=n}),define(be[72],Ee([0,1,5,3,4]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(C){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,y){this._proxy.$registerExtensionStorageKeysToSync(C,y)}getValue(C,y,P){return this._proxy.$getValue(C,y).then(t=>t||P)}setValue(C,y,P){return this._proxy.$setValue(C,y,P)}$acceptValue(C,y,P){this._onDidChangeStorage.fire({shared:C,key:y,value:P})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,E.createDecorator)("IExtHostStorage")}),define(be[73],Ee([0,1,4,29,15,71,2]),function(re,e,c,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let C=class{constructor(P,t,b){this._logService=t,this._extHostFileSystem=b,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(P){return R.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,t=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(P){if(this._value)return R.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return R.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};C=$e([Ve(0,M.IExtHostInitDataService),Ve(1,E.ILogService),Ve(2,A.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(be[40],Ee([0,1,3,5,4,2,12,6,7,128,16,167,21,36,150,46,10]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,E.createDecorator)("IExtHostTerminalService");class D{constructor(u,h,m,k){this._proxy=u,this._id=h,this._creationOptions=m,this._name=k,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(g=>this._pidPromiseComplete=g);const T=this;this.value={get name(){return T._name||""},get processId(){return T._pidPromise},get creationOptions(){return T._creationOptions},get exitStatus(){return T._exitStatus},get state(){return T._state},sendText(g,I=!0){T._checkDisposed(),T._proxy.$sendText(T._id,g,I)},show(g){T._checkDisposed(),T._proxy.$show(T._id,g)},hide(){T._checkDisposed(),T._proxy.$hide(T._id)},dispose(){T._disposed||(T._disposed=!0,T._proxy.$dispose(T._id))},get dimensions(){if(!(T._cols===void 0||T._rows===void 0))return{columns:T._cols,rows:T._rows}}}}async create(u,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:u.name,shellPath:(0,v.withNullAsUndefined)(u.shellPath),shellArgs:(0,v.withNullAsUndefined)(u.shellArgs),cwd:(0,v.withNullAsUndefined)(u.cwd),env:(0,v.withNullAsUndefined)(u.env),icon:(0,v.withNullAsUndefined)(p(u.iconPath)),color:l.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,v.withNullAsUndefined)(u.message),strictEnv:(0,v.withNullAsUndefined)(u.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(u.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(h?.useShellEnvironment),location:h?.location||this._serializeParentTerminal(u.location,h?.resolvedExtHostIdentifier)})}async createExtensionTerminal(u,h,m,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:l.ThemeColor.isThemeColor(k)?k.id:void 0,location:this._serializeParentTerminal(u,h)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(u,h){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in u?{viewColumn:u.viewColumn,preserveFocus:u.preserveFocus}:void 0:u}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(u){this._name=u}setExitCode(u){this._exitStatus=Object.freeze({code:u})}setDimensions(u,h){return u===this._cols&&h===this._rows||u===0||h===0?!1:(this._cols=u,this._rows=h,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(u){this._pidPromiseComplete?(this._pidPromiseComplete(u),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==u&&(this._pidPromise=Promise.resolve(u))})}}e.ExtHostTerminal=D;class _{constructor(u){this._pty=u,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new c.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new c.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new c.Emitter,this._onProcessTitleChanged=new c.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new c.Emitter,this._onProcessShellTypeChanged=new c.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onDidChangeProperty=new c.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}refreshProperty(u){return Promise.resolve("")}async updateProperty(u,h){Promise.resolve("")}async start(){}shutdown(){this._pty.close()}input(u){this._pty.handleInput&&this._pty.handleInput(u)}resize(u,h){this._pty.setDimensions&&this._pty.setDimensions({columns:u,rows:h})}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(u){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose&&this._pty.onDidClose((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(h=>this._onProcessOverrideDimensions.fire(h&&{cols:h.columns,rows:h.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(h=>this._onProcessTitleChanged.fire(h)),this._pty.open(u||void 0),this._pty.setDimensions&&u&&this._pty.setDimensions(u),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=_;let a=1,d=class extends C.Disposable{constructor(u,h){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new c.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new c.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new c.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new c.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new c.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=h.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new c.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(u),this._register({dispose:()=>{for(const[m,k]of this._terminalProcesses)k.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(u=>u.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(u,h){const m=new D(this._proxy,(0,f.generateUuid)(),u,u.name),k=new _(u.pty);return m.createExtensionTerminal(u.location,this._serializeParentTerminal(u,h).resolvedExtHostIdentifier,p(u.iconPath),r(u.color)).then(T=>{const g=this._setupExtHostProcessListeners(T,k);this._terminalProcessDisposables[T]=g}),this._terminals.push(m),m.value}_serializeParentTerminal(u,h){if(h=h||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const m=u.location.parentTerminal;if(m){const k=this._terminals.find(T=>T.value===m);k&&(h.resolvedExtHostIdentifier=k._id)}}else u.location&&typeof u.location!="object"?h.location=u.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(u,h){if(!this._getTerminalById(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const k=new _(h),T=this._setupExtHostProcessListeners(u,k);this._terminalProcessDisposables[u]=T}async $acceptActiveTerminalChanged(u){const h=this._activeTerminal;if(u===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(u);m&&(this._activeTerminal=m,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(u,h){const m=this._getTerminalById(u);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:h})}async $acceptTerminalDimensions(u,h,m){const k=this._getTerminalById(u);k&&k.setDimensions(h,m)&&this._onDidChangeTerminalDimensions.fire({terminal:k.value,dimensions:k.value.dimensions})}async $acceptTerminalMaximumDimensions(u,h,m){this._terminalProcesses.get(u)?.resize(h,m)}async $acceptTerminalTitleChange(u,h){const m=this._getTerminalById(u);m&&(m.name=h)}async $acceptTerminalClosed(u,h){const m=this._getTerminalObjectIndexById(this._terminals,u);if(m!==null){const k=this._terminals.splice(m,1)[0];k.setExitCode(h),this._onDidCloseTerminal.fire(k.value)}}$acceptTerminalOpened(u,h,m,k){if(h){const I=this._getTerminalObjectIndexById(this._terminals,h);if(I!==null){this._terminals[I]._id=u,this._onDidOpenTerminal.fire(this.terminals[I]),this._terminals[I].isOpen=!0;return}}const T={name:k.name,shellPath:k.executable,shellArgs:k.args,cwd:typeof k.cwd=="string"?k.cwd:A.URI.revive(k.cwd),env:k.env,hideFromUser:k.hideFromUser},g=new D(this._proxy,u,T,m);this._terminals.push(g),this._onDidOpenTerminal.fire(g.value),g.isOpen=!0}async $acceptTerminalProcessId(u,h){const m=this._getTerminalById(u);m&&m._setProcessId(h)}async $startExtensionTerminal(u,h){const m=this._getTerminalById(u);if(!m)return{message:(0,P.localize)(0,null,u)};m.isOpen||await new Promise(T=>{const g=this.onDidOpenTerminal(async I=>{I===m.value&&(g.dispose(),T())})});const k=this._terminalProcesses.get(u);k?k.startSendingEvents(h):this._extensionTerminalAwaitingStart[u]={initialDimensions:h}}_setupExtHostProcessListeners(u,h){const m=new C.DisposableStore;m.add(h.onProcessReady(T=>this._proxy.$sendProcessReady(u,T.pid,T.cwd))),m.add(h.onProcessTitleChanged(T=>this._proxy.$sendProcessTitle(u,T))),this._bufferer.startBuffering(u,h.onProcessData),m.add(h.onProcessExit(T=>this._onProcessExit(u,T))),h.onProcessOverrideDimensions&&m.add(h.onProcessOverrideDimensions(T=>this._proxy.$sendOverrideDimensions(u,T))),this._terminalProcesses.set(u,h);const k=this._extensionTerminalAwaitingStart[u];return k&&h instanceof _&&(h.startSendingEvents(k.initialDimensions),delete this._extensionTerminalAwaitingStart[u]),m}$acceptProcessAckDataEvent(u,h){this._terminalProcesses.get(u)?.acknowledgeDataEvent(h)}$acceptProcessInput(u,h){this._terminalProcesses.get(u)?.input(h)}$acceptTerminalInteraction(u){const h=this._getTerminalById(u);h?.setInteractedWith()&&this._onDidChangeTerminalState.fire(h.value)}$acceptProcessResize(u,h,m){try{this._terminalProcesses.get(u)?.resize(h,m)}catch(k){if(k.code!=="EPIPE"&&k.code!=="ERR_IPC_CHANNEL_CLOSED")throw k}}$acceptProcessShutdown(u,h){this._terminalProcesses.get(u)?.shutdown(h)}$acceptProcessRequestInitialCwd(u){this._terminalProcesses.get(u)?.getInitialCwd().then(h=>this._proxy.$sendProcessInitialCwd(u,h))}$acceptProcessRequestCwd(u){this._terminalProcesses.get(u)?.getCwd().then(h=>this._proxy.$sendProcessCwd(u,h))}$acceptProcessRequestLatency(u){return u}registerLinkProvider(u){return this._linkProviders.add(u),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(u),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(u,h,m){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,m),this._proxy.$registerProfileProvider(h,u.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}async $createContributedProfileTerminal(u,h){const m=new n.CancellationTokenSource().token,k=await this._profileProviders.get(u)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(!k||!("options"in k))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in k.options){this.createExtensionTerminal(k.options,h);return}this.createTerminalFromOptions(k.options,h)}}async $provideLinks(u,h){const m=this._getTerminalById(u);if(!m)return[];this._terminalLinkCache.delete(u);const k=this._terminalLinkCancellationSource.get(u);k&&k.dispose(!0);const T=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(u,T);const g=[],I={terminal:m.value,line:h},F=[];for(const x of this._linkProviders)F.push(new Promise(async W=>{T.token.onCancellationRequested(()=>W({provider:x,links:[]}));const B=await x.provideTerminalLinks(I,T.token)||[];T.token.isCancellationRequested||W({provider:x,links:B})}));const L=await Promise.all(F);if(T.token.isCancellationRequested)return[];const w=new Map;for(const x of L)x&&x.links.length>0&&g.push(...x.links.map(W=>{const B={id:a++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return w.set(B.id,{provider:x.provider,link:W}),B}));return this._terminalLinkCache.set(u,w),g}$activateLink(u,h){const m=this._terminalLinkCache.get(u)?.get(h);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(u,h){this._bufferer.stopBuffering(u),this._terminalProcesses.delete(u),delete this._extensionTerminalAwaitingStart[u];const m=this._terminalProcessDisposables[u];m&&(m.dispose(),delete this._terminalProcessDisposables[u]),this._proxy.$sendProcessExit(u,h)}_getTerminalById(u){return this._getTerminalObjectById(this._terminals,u)}_getTerminalObjectById(u,h){const m=this._getTerminalObjectIndexById(u,h);return m!==null?u[m]:null}_getTerminalObjectIndexById(u,h){let m=null;return u.some((k,T)=>k._id===h?(m=T,!0):!1),m}getEnvironmentVariableCollection(u){let h=this._environmentVariableCollections.get(u.identifier.value);return h||(h=new S,this._setEnvironmentVariableCollection(u.identifier.value,h)),h}_syncEnvironmentVariableCollection(u,h){const m=(0,b.serializeEnvironmentVariableCollection)(h.map);this._proxy.$setEnvironmentVariableCollection(u,h.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(u){u.forEach(h=>{const m=h[0],k=new S(h[1]);this._setEnvironmentVariableCollection(m,k)})}$acceptDefaultProfile(u,h){this._defaultProfile=u,this._defaultAutomationProfile=h}_setEnvironmentVariableCollection(u,h){this._environmentVariableCollections.set(u,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(u,h)})}};d=$e([Ve(1,R.IExtHostRpcService)],d),e.BaseExtHostTerminalService=d;class S{constructor(u){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new c.Emitter,this.map=new Map(u)}get persistent(){return this._persistent}set persistent(u){this._persistent=u,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(u,h){this._setIfDiffers(u,{value:h,type:y.EnvironmentVariableMutatorType.Replace})}append(u,h){this._setIfDiffers(u,{value:h,type:y.EnvironmentVariableMutatorType.Append})}prepend(u,h){this._setIfDiffers(u,{value:h,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(u,h){const m=this.map.get(u);(!m||m.value!==h.value||m.type!==h.type)&&(this.map.set(u,h),this._onDidChangeCollection.fire())}get(u){return this.map.get(u)}forEach(u,h){this.map.forEach((m,k)=>u.call(h,k,m,this))}delete(u){this.map.delete(u),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=S;let i=class extends d{constructor(u){super(!1,u)}createTerminal(u,h,m){throw new t.NotSupportedError}createTerminalFromOptions(u,h){throw new t.NotSupportedError}};i=$e([Ve(0,R.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function p(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function r(s){return l.ThemeColor.isThemeColor(s)?s:void 0}});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Fe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(be[204],Ee([0,1,13,22,21,3,235,58,6,23,10,36,5,12,48,8,7,175,90,67]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o,l,v,D,_,a){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let S=class{constructor(F,L){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(n.MainContext.MainThreadTesting),this.observer=new k(this.proxy),this.runTracker=new p(this.proxy),L.registerArgumentProcessor({processArgument:w=>w?.$mid===13?l.TestItem.toItemFromContext(w):w})}createTestController(F,L){if(this.controllers.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const w=new y.DisposableStore,x=w.add(new D.SingleUseTestCollection(F));x.root.label=L;const W=new Map,B=this.proxy,G={items:x.root.children,get label(){return L},set label(U){L=U,x.root.label=U,B.$updateControllerLabel(F,L)},get id(){return F},createRunProfile:(U,V,Q,ne,ce)=>{let Z=(0,C.hash)(U);for(;W.has(Z);)Z++;const oe=new T(this.proxy,F,Z,U,V,Q,ne,ce);return W.set(Z,oe),oe},createTestItem(U,V,Q){return new o.TestItemImpl(F,U,V,Q)},createTestRun:(U,V,Q=!0)=>this.runTracker.createTestRun(F,x,U,V,Q),set resolveHandler(U){x.resolveHandler=U},get resolveHandler(){return x.resolveHandler},dispose:()=>{w.dispose()}};G.createRunConfiguration=G.createRunProfile,B.$registerTestController(F,L),w.add((0,y.toDisposable)(()=>B.$unregisterTestController(F)));const H={controller:G,collection:x,profiles:W};return this.controllers.set(F,H),w.add((0,y.toDisposable)(()=>this.controllers.delete(F))),w.add(x.onDidGenerateDiff(U=>B.$publishDiff(F,U))),G}createTestObserver(){return this.observer.checkout()}async runTests(F,L=E.CancellationToken.None){const w=r(F);if(!w)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const x=this.controllers.get(w.controllerId);if(!x)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:F.include?.map(W=>W.id)??[x.collection.root.id],profileGroup:g[w.kind],profileId:w.profileId,controllerId:w.controllerId}],exclude:F.exclude?.map(W=>W.id)},L)}$provideFileCoverage(F,L,w){return(0,c.mapFind)(this.runTracker.trackers,W=>W.id===F?W.getCoverage(L):void 0)?.provideFileCoverage(w)??Promise.resolve([])}$resolveFileCoverage(F,L,w,x){return(0,c.mapFind)(this.runTracker.trackers,B=>B.id===F?B.getCoverage(L):void 0)?.resolveFileCoverage(w,x)??Promise.resolve([])}$configureRunProfile(F,L){this.controllers.get(F)?.profiles.get(L)?.configureHandler?.()}$publishTestResults(F){this.results=Object.freeze(F.map(L=>(0,P.deepFreeze)(l.TestResults.to(L))).concat(this.results).sort((L,w)=>w.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(F,L){const w=this.controllers.get(a.TestId.fromString(F).controllerId)?.collection;w&&(await w.expand(F,L<0?1/0:L),w.flushDiff())}$acceptDiff(F){this.observer.applyDiff(F)}async $runControllerTests(F,L){const w=this.controllers.get(F.controllerId);if(!w)return;const{collection:x,profiles:W}=w,B=W.get(F.profileId);if(!B)return;const G=F.testIds.map(Q=>x.tree.get(Q)).filter(t.isDefined),H=F.excludeExtIds.map(Q=>w.collection.tree.get(Q)).filter(t.isDefined).filter(Q=>G.some(ne=>ne.fullId.compare(Q.fullId)===2));if(!G.length)return;const U=new v.TestRunRequest(G.some(Q=>Q.actual instanceof o.TestItemRootImpl)?void 0:G.map(Q=>Q.actual),H.map(Q=>Q.actual),B),V=this.runTracker.prepareForMainThreadTestRun(U,s.fromInternal(F,w.collection),L);try{await B.runHandler(U,L)}finally{V.isRunning&&!L.isCancellationRequested&&await A.Event.toPromise(V.onEnd),V.dispose()}}$cancelExtensionTestRun(F){F===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(F)}};S=$e([Ve(0,f.IExtHostRpcService)],S),e.ExtHostTesting=S;class i extends y.Disposable{constructor(F,L,w){super();this.dto=F,this.proxy=L,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new E.CancellationTokenSource(w)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:x}of this.tasks.values())x.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(F){return this.tasks.get(F)?.coverage}createRun(F){const L=this.dto.id,w=this.dto.controllerId,x=(0,b.generateUuid)(),W=new u(this.proxy,L,x),B=V=>(Q,...ne)=>{if(H){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Q)||(this.ensureTestIsKnown(Q),V(Q,...ne))},G=(V,Q)=>{const ne=Q instanceof Array?Q.map(l.TestMessage.from):[l.TestMessage.from(Q)];if(V.uri&&V.range){const ce={range:l.Range.from(V.range),uri:V.uri};for(const Z of ne)Z.location=Z.location||ce}this.proxy.$appendTestMessagesInRun(L,x,a.TestId.fromExtHostTestItem(V,w).toString(),ne)};let H=!1;const U={isPersisted:this.dto.isPersisted,token:this.cts.token,name:F,get coverageProvider(){return W.coverageProvider},set coverageProvider(V){W.coverageProvider=V},enqueued:B(V=>{this.proxy.$updateTestStateInRun(L,x,a.TestId.fromExtHostTestItem(V,w).toString(),1)}),skipped:B(V=>{this.proxy.$updateTestStateInRun(L,x,a.TestId.fromExtHostTestItem(V,w).toString(),5)}),started:B(V=>{this.proxy.$updateTestStateInRun(L,x,a.TestId.fromExtHostTestItem(V,w).toString(),2)}),errored:B((V,Q,ne)=>{G(V,Q),this.proxy.$updateTestStateInRun(L,x,a.TestId.fromExtHostTestItem(V,w).toString(),6,ne)}),failed:B((V,Q,ne)=>{G(V,Q),this.proxy.$updateTestStateInRun(L,x,a.TestId.fromExtHostTestItem(V,w).toString(),4,ne)}),passed:B((V,Q)=>{this.proxy.$updateTestStateInRun(L,x,a.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString(),3,Q)}),appendOutput:(V,Q,ne)=>{H||(ne&&(this.dto.isIncluded(ne)?this.ensureTestIsKnown(ne):ne=void 0),this.proxy.$appendOutputToRun(L,x,M.VSBuffer.fromString(V),Q&&l.location.from(Q),ne&&a.TestId.fromExtHostTestItem(ne,w).toString()))},end:()=>{H||(H=!0,this.proxy.$finishedTestRunTask(L,x),this.tasks.delete(x),this.isRunning||this.dispose())}};return this.tasks.set(x,{run:U,coverage:W}),this.proxy.$startedTestRunTask(L,{id:x,name:F,running:!0}),U}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(F){if(!(F instanceof o.TestItemImpl))throw new o.InvalidTestItemError(F.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(F,this.dto.controllerId).toString()))return;const L=[],w=this.dto.colllection.root;for(;;){const x=l.TestItem.from(F);if(L.unshift(x),this.sharedTestIds.has(x.extId)||(this.sharedTestIds.add(x.extId),F===w))break;F=F.parent||w}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,L)}}class p{constructor(F){this.proxy=F,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(F,L,w){return this.getTracker(F,L,w)}cancelRunById(F){for(const L of this.tracked.values())if(L.id===F){L.dispose();return}}cancelAllRuns(){for(const F of this.tracked.values())F.dispose()}createTestRun(F,L,w,x,W){const B=this.tracked.get(w);if(B)return B.createRun(x);const G=s.fromPublic(F,L,w,W),H=r(w);this.proxy.$startedExtensionTestRun({controllerId:F,profile:H&&{group:g[H.kind],id:H.profileId},exclude:w.exclude?.map(V=>V.id)??[],id:G.id,include:w.include?.map(V=>V.id)??[L.root.id],persist:W});const U=this.getTracker(w,G);return U.onEnd(()=>this.proxy.$finishedExtensionTestRun(G.id)),U.createRun(x)}getTracker(F,L,w){const x=new i(L,this.proxy,w);return this.tracked.set(F,x),x.onEnd(()=>this.tracked.delete(F)),x}}e.TestRunCoordinator=p;const r=I=>{if(!!I.profile){if(!(I.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return I.profile}};class s{constructor(F,L,w,x,W,B){this.controllerId=F,this.id=L,this.isPersisted=W,this.colllection=B,this.includePrefix=w.map(G=>G+"\0"),this.excludePrefix=x.map(G=>G+"\0")}static fromPublic(F,L,w,x){return new s(F,(0,b.generateUuid)(),w.include?.map(W=>a.TestId.fromExtHostTestItem(W,F).toString())??[F],w.exclude?.map(W=>a.TestId.fromExtHostTestItem(W,F).toString())??[],x,L)}static fromInternal(F,L){return new s(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,L)}isIncluded(F){const L=a.TestId.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const w of this.excludePrefix)if(L===w||L.startsWith(w))return!1;for(const w of this.includePrefix)if(L===w||L.startsWith(w))return!0;return!1}}e.TestRunDto=s;class u{constructor(F,L,w){this.proxy=F,this.runId=L,this.taskId=w}set coverageProvider(F){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!F||(this._coverageProvider=F,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(F){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(F))());try{return(await this.fileCoverage)?.map(l.TestCoverage.fromFile)??[]}catch(L){throw this.fileCoverage=void 0,L}}async resolveFileCoverage(F,L){const w=await this.fileCoverage;let x=w?.[F];return!this._coverageProvider||!w||!x?[]:(x.detailedCoverage||(x=w[F]=await this._coverageProvider.resolveFileCoverage?.(x,L)??x),x.detailedCoverage?.map(l.TestCoverage.fromDetailed)??[])}}class h extends _.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,l.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:L,removed:w}=this;return{get added(){return[...F].map(x=>x.revived)},get updated(){return[...L].map(x=>x.revived)},get removed(){return[...w].map(x=>x.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class m extends _.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,L){return{...F,revived:l.TestItem.toPlain(F.item),depth:L?L.depth+1:0,children:new Set}}createChangeCollector(){return new h(this.changeEmitter)}}e.MirroredTestCollection=m;class k{constructor(F){this.proxy=F}checkout(){this.current||(this.current=this.createObserverData());const F=this.current;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(L=>L.revived)},dispose:(0,R.once)(()=>{--F.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(F){return this.current?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.current?.tests.apply(F)}createObserverData(){const F=new m;return this.proxy.$subscribeToDiffs(),{observers:0,tests:F}}}class T{constructor(F,L,w,x,W,B,G=!1,H=void 0){this.controllerId=L,this.profileId=w,this._label=x,this.kind=W,this.runHandler=B,this._isDefault=G,this._tag=H,d.set(this,void 0),et(this,d,F,"f");const U=g[W];if(typeof U!="number")throw new Error(`Unknown TestRunProfile.group ${W}`);Fe(this,d,"f").$publishTestRunProfile({profileId:w,controllerId:L,tag:H?l.TestTag.namespace(this.controllerId,H.id):null,label:x,group:U,isDefault:G,hasConfigurationHandler:!1})}get label(){return this._label}set label(F){F!==this._label&&(this._label=F,Fe(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:F}))}get isDefault(){return this._isDefault}set isDefault(F){F!==this._isDefault&&(this._isDefault=F,Fe(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,Fe(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:F?l.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(F){F!==this._configureHandler&&(this._configureHandler=F,Fe(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!F}))}dispose(){Fe(this,d,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=T,d=new WeakMap;const g={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(be[205],Ee([0,1,3,13,5,94,8,7]),function(re,e,c,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(t,b){this._extHostDocumentsAndEditors=b,this._onDidChangeTextEditorSelection=new c.Emitter,this._onDidChangeTextEditorOptions=new c.Emitter,this._onDidChangeTextEditorVisibleRanges=new c.Emitter,this._onDidChangeTextEditorViewColumn=new c.Emitter,this._onDidChangeActiveTextEditor=new c.Emitter,this._onDidChangeVisibleTextEditors=new c.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(E.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const b=this._extHostDocumentsAndEditors.allEditors();return t?b:b.map(n=>n.value)}async showTextDocument(t,b,n){let f;typeof b=="number"?f={position:R.ViewColumn.from(b),preserveFocus:n}:typeof b=="object"?f={position:R.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selection:typeof b.selection=="object"?R.Range.from(b.selection):void 0,pinned:typeof b.preview=="boolean"?!b.preview:void 0}:f={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(t.uri,f),l=o&&this._extHostDocumentsAndEditors.getEditor(o);if(l)return l.value;throw o?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,b){return new A.TextEditorDecorationType(this._proxy,t,b).value}$acceptEditorPropertiesChanged(t,b){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(b.options&&n._acceptOptions(b.options),b.selections){const f=b.selections.selections.map(R.Selection.to);n._acceptSelections(f)}if(b.visibleRanges){const f=M.coalesce(b.visibleRanges.map(R.Range.to));n._acceptVisibleRanges(f)}if(b.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{...b.options,lineNumbers:R.TextEditorLineNumbersStyle.to(b.options.lineNumbers)}}),b.selections){const f=C.TextEditorSelectionChangeKind.fromValue(b.selections.source),o=b.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:o,kind:f})}if(b.visibleRanges){const f=M.coalesce(b.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:f})}}$acceptEditorPositionData(t){for(const b in t){const n=this._extHostDocumentsAndEditors.getEditor(b);if(!n)throw new Error("Unknown text editor");const f=R.ViewColumn.to(t[b]);n.value.viewColumn!==f&&(n._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:f}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=y}),define(be[206],Ee([0,1,2,4,5,6,7]),function(re,e,c,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class C{constructor(t,b){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadTimeline),b.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const f=n.uri===void 0?void 0:c.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(y(f))?.get(n.handle)}return n}})}async $getTimeline(t,b,n,f,o){return this._providers.get(t)?.provideTimeline(c.URI.revive(b),n,f,o)}registerTimelineProvider(t,b,n,f){const o=new A.DisposableStore,l=this.convertTimelineItem(b.id,f,o).bind(this);let v;b.onDidChange&&(v=b.onDidChange(_=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,..._,id:b.id}),this));const D=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...b,scheme:t,onDidChange:void 0,async provideTimeline(_,a,d,S){S?.resetCache&&(o.clear(),D.get(b.id)?.clear());const i=await b.provideTimeline(_,a,d);if(i==null)return;const p=l(_,S);return{...i,source:b.id,items:i.items.map(p)}},dispose(){for(const _ of D.values())_.get(b.id)?.clear();v?.dispose(),o.dispose()}})}convertTimelineItem(t,b,n){return(f,o)=>{let l;if(o?.cacheResults){let v=this._itemsBySourceAndUriMap.get(t);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(t,v));const D=y(f);l=v.get(D),l===void 0&&(l=new Map,v.set(D,l))}return v=>{const{iconPath:D,..._}=v,a=`${t}|${v.id??v.timestamp}`;l?.set(a,v);let d,S,i;return v.iconPath&&(D instanceof R.ThemeIcon?i={id:D.id,color:D.color}:c.URI.isUri(D)?(d=D,S=D):{light:d,dark:S}=D),{..._,id:_.id??void 0,handle:a,source:t,command:v.command?b.toInternal(v.command,n):void 0,icon:d,iconDark:S,themeIcon:i,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,A.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=C;function y(P){return P?.toString()}}),define(be[207],Ee([0,1,6,11,2,5]),function(re,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(y){this._openers=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,P,t,b){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const n=b.schemes.find(f=>!R.supportedSchemes.has(f));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,t),this._proxy.$registerUriOpener(P,b.schemes,y,b.label),(0,c.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(y,P,t){const b=this._openers.get(y);if(!b)throw new Error(`Unknown opener with id: ${y}`);const n=E.URI.revive(P);return b.canOpenExternalUri(n,t)}async $openUri(y,P,t){const b=this._openers.get(y);if(!b)throw new Error(`Unknown opener id: '${y}'`);return b.openExternalUri(E.URI.revive(P.resolvedUri),{sourceUri:E.URI.revive(P.sourceUri)},t)}}e.ExtHostUriOpeners=R,R.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(be[208],Ee([0,1,5,2,6,16,26]),function(re,e,c,M,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(P,t){if(this.handles.has(R.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const b=C.HandlePool++;return this.handles.add(R.ExtensionIdentifier.toKey(P)),this.handlers.set(b,t),this._proxy.$registerUriHandler(b,P),(0,E.toDisposable)(()=>{this.handles.delete(R.ExtensionIdentifier.toKey(P)),this.handlers.delete(b),this._proxy.$unregisterUriHandler(b)})}$handleExternalUri(P,t){const b=this.handlers.get(P);if(!b)return Promise.resolve(void 0);try{b.handleUri(M.URI.revive(t))}catch(n){(0,A.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(P){return M.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=C,C.HandlePool=0});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Fe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(be[50],Ee([0,1,3,2,138,158,66,5]),function(re,e,c,M,E,A,R,C){"use strict";var y,P,t,b,n,f,o,l,v,D,_,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(m,k,T,g,I,F,L){y.set(this,void 0),P.set(this,void 0),t.set(this,void 0),b.set(this,void 0),n.set(this,void 0),f.set(this,void 0),o.set(this,""),l.set(this,void 0),v.set(this,!1),D.set(this,!1),_.set(this,!1),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new c.Emitter),this._onDidDispose=Fe(this,a,"f").event,et(this,y,m,"f"),et(this,P,k,"f"),et(this,l,T,"f"),et(this,b,g,"f"),et(this,n,I,"f"),et(this,f,F,"f"),et(this,_,S(F),"f"),et(this,t,L,"f")}dispose(){et(this,v,!0,"f"),Fe(this,a,"f").fire(),Fe(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return et(this,D,!0,"f"),(0,R.asWebviewUri)(m,Fe(this,b,"f").remote)}get cspSource(){return R.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Fe(this,o,"f")}set html(m){this.assertNotDisposed(),Fe(this,o,"f")!==m&&(et(this,o,m,"f"),!Fe(this,D,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(et(this,D,!0,"f"),Fe(this,t,"f").report("Webview vscode-resource: uris",Fe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Fe(this,P,"f").$setHtml(Fe(this,y,"f"),m))}get options(){return this.assertNotDisposed(),Fe(this,l,"f")}set options(m){this.assertNotDisposed(),Fe(this,P,"f").$setOptions(Fe(this,y,"f"),r(Fe(this,f,"f"),Fe(this,n,"f"),m)),et(this,l,m,"f")}async postMessage(m){if(Fe(this,v,"f"))return!1;const k=(0,A.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Fe(this,_,"f")});return Fe(this,P,"f").$postMessage(Fe(this,y,"f"),k.message,...k.buffers)}assertNotDisposed(){if(Fe(this,v,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=d,y=new WeakMap,P=new WeakMap,t=new WeakMap,b=new WeakMap,n=new WeakMap,f=new WeakMap,o=new WeakMap,l=new WeakMap,v=new WeakMap,D=new WeakMap,_=new WeakMap,a=new WeakMap;function S(h){try{const m=(0,E.normalizeVersion)((0,E.parseVersion)(h.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=S;class i{constructor(m,k,T,g,I){this.initData=k,this.workspace=T,this._logService=g,this._deprecationService=I,this._webviews=new Map,this._webviewProxy=m.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(m,k,...T){const g=this.getWebview(m);if(g){const{message:I}=(0,A.deserializeWebviewMessage)(k,T);g._onMessageEmitter.fire(I)}}$onMissingCsp(m,k){this._logService.warn(`${k} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,k,T){const g=new d(m,this._webviewProxy,s(k),this.initData,this.workspace,T,this._deprecationService);return this._webviews.set(m,g),g._onDidDispose(()=>{this._webviews.delete(m)}),g}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=i;function p(h){return{id:h.identifier,location:h.extensionLocation}}e.toExtensionData=p;function r(h,m,k){return{enableCommandUris:k.enableCommandUris,enableScripts:k.enableScripts,enableForms:k.enableForms,portMapping:k.portMapping,localResourceRoots:k.localResourceRoots||u(h,m)}}e.serializeWebviewOptions=r;function s(h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots?.map(m=>M.URI.from(m))}}e.reviveOptions=s;function u(h,m){return[...(m?.getWorkspaceFolders()||[]).map(k=>k.uri),h.extensionLocation]}}),define(be[209],Ee([0,1,21,58,6,11,24,2,8,50,63,5,7]),function(re,e,c,M,E,A,R,C,y,P,t,b,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(i,p){this.document=i,this._storagePath=p,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,p){await this.getEdit(i).undo(),p||this.disposeBackup()}async redo(i,p){await this.getEdit(i).redo(),p||this.disposeBackup()}disposeEdits(i){for(const p of i)this._edits.delete(p)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=d(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const p=this._edits.get(i,0);if(!p)throw new Error("No edit found");return p}}class o{constructor(){this._documents=new Map}get(i,p){return this._documents.get(this.key(i,p))}add(i,p,r){const s=this.key(i,p.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${i} resource:${p.uri}`);const u=new f(p,r);return this._documents.set(s,u),u}delete(i,p){const r=this.key(i,p.uri);this._documents.delete(r)}key(i,p){return`${i}@@@${p}`}}var l;(function(S){S[S.Text=0]="Text",S[S.Custom=1]="Custom"})(l||(l={}));class v{constructor(){this._providers=new Map}addTextProvider(i,p,r){return this.add(0,i,p,r)}addCustomProvider(i,p,r){return this.add(1,i,p,r)}get(i){return this._providers.get(i)}add(i,p,r,s){if(this._providers.has(p))throw new Error(`Provider for viewType:${p} already registered`);return this._providers.set(p,{type:i,extension:r,provider:s}),new n.Disposable(()=>this._providers.delete(p))}}class D{constructor(i,p,r,s,u){this._extHostDocuments=p,this._extensionStoragePaths=r,this._extHostWebview=s,this._extHostWebviewPanels=u,this._editorProviders=new v,this._documents=new o,this._proxy=i.getProxy(b.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,p,r,s){const u=new E.DisposableStore;return _(r)?(u.add(this._editorProviders.addTextProvider(p,i,r)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(i),p,s.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(i))):(u.add(this._editorProviders.addCustomProvider(p,i,r)),this.supportEditing(r)&&u.add(r.onDidChangeCustomDocument(h=>{const m=this.getCustomDocumentEntry(p,h.document.uri);if(a(h)){const k=m.addEdit(h);this._proxy.$onDidEdit(h.document.uri,p,k,h.label)}else this._proxy.$onContentChange(h.document.uri,p)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(i),p,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(u,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(p)}))}async $createCustomDocument(i,p,r,s,u){const h=this._editorProviders.get(p);if(!h)throw new Error(`No provider found for '${p}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${p}'`);const m=C.URI.revive(i),k=await h.provider.openCustomDocument(m,{backupId:r,untitledDocumentData:s?.buffer},u);let T;return this.supportEditing(h.provider)&&this._extensionStoragePaths&&(T=this._extensionStoragePaths.workspaceValue(h.extension)??this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(p,k,T),{editable:this.supportEditing(h.provider)}}async $disposeCustomDocument(i,p){const r=this._editorProviders.get(p);if(!r)throw new Error(`No provider found for '${p}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${p}'`);const s=C.URI.revive(i),{document:u}=this.getCustomDocumentEntry(p,s);this._documents.delete(p,u),u.dispose()}async $resolveWebviewEditor(i,p,r,s,u,h){const m=this._editorProviders.get(r);if(!m)throw new Error(`No provider found for '${r}'`);const k=y.ViewColumn.to(u),T=this._extHostWebview.createNewWebview(p,s.webviewOptions,m.extension),g=this._extHostWebviewPanels.createNewWebviewPanel(p,r,s.title,k,s.panelOptions,T),I=C.URI.revive(i);switch(m.type){case 1:{const{document:F}=this.getCustomDocumentEntry(r,I);return m.provider.resolveCustomEditor(F,g,h)}case 0:{const F=this._extHostDocuments.getDocument(I);return m.provider.resolveCustomTextEditor(F,g,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,p,r){this.getCustomDocumentEntry(p,i).disposeEdits(r)}async $onMoveCustomEditor(i,p,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const u=this._extHostWebviewPanels.getWebviewPanel(i);if(!u)throw new Error("No webview found");const h=C.URI.revive(p),m=this._extHostDocuments.getDocument(h);await s.provider.moveCustomTextEditor(m,u,c.CancellationToken.None)}async $undo(i,p,r,s){return this.getCustomDocumentEntry(p,i).undo(r,s)}async $redo(i,p,r,s){return this.getCustomDocumentEntry(p,i).redo(r,s)}async $revert(i,p,r){const s=this.getCustomDocumentEntry(p,i);await this.getCustomEditorProvider(p).revertCustomDocument(s.document,r),s.disposeBackup()}async $onSave(i,p,r){const s=this.getCustomDocumentEntry(p,i);await this.getCustomEditorProvider(p).saveCustomDocument(s.document,r),s.disposeBackup()}async $onSaveAs(i,p,r,s){const u=this.getCustomDocumentEntry(p,i);return this.getCustomEditorProvider(p).saveCustomDocumentAs(u.document,C.URI.revive(r),s)}async $backup(i,p,r){const s=this.getCustomDocumentEntry(p,i),h=await this.getCustomEditorProvider(p).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},r);return s.updateBackup(h),h.id}getCustomDocumentEntry(i,p){const r=this._documents.get(i,C.URI.revive(p));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(i){const r=this._editorProviders.get(i)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=D;function _(S){return typeof S.resolveCustomTextEditor=="function"}function a(S){return typeof S.undo=="function"&&typeof S.redo=="function"}function d(S){const i=S.scheme===A.Schemas.file||S.scheme===A.Schemas.untitled?S.fsPath:S.toString();return(0,M.hash)(i)+""}});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Fe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(be[210],Ee([0,1,3,6,2,36,8,50,5,7]),function(re,e,c,M,E,A,R,C,y,P){"use strict";var t,b,n,f,o,l,v,D,_,a,d,S,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class p extends M.Disposable{constructor(h,m,k,T,g,I,F){super();t.set(this,void 0),b.set(this,void 0),n.set(this,void 0),f.set(this,void 0),o.set(this,void 0),l.set(this,void 0),v.set(this,void 0),D.set(this,void 0),_.set(this,!0),a.set(this,!0),d.set(this,!1),S.set(this,this._register(new c.Emitter)),this.onDidDispose=Fe(this,S,"f").event,i.set(this,this._register(new c.Emitter)),this.onDidChangeViewState=Fe(this,i,"f").event,et(this,t,h,"f"),et(this,b,m,"f"),et(this,n,k,"f"),et(this,o,I,"f"),et(this,D,g,"f"),et(this,l,T,"f"),et(this,f,F,"f")}dispose(){Fe(this,d,"f")||(et(this,d,!0,"f"),Fe(this,S,"f").fire(),Fe(this,b,"f").$disposeWebview(Fe(this,t,"f")),Fe(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Fe(this,f,"f")}get viewType(){return this.assertNotDisposed(),Fe(this,n,"f")}get title(){return this.assertNotDisposed(),Fe(this,l,"f")}set title(h){this.assertNotDisposed(),Fe(this,l,"f")!==h&&(et(this,l,h,"f"),Fe(this,b,"f").$setTitle(Fe(this,t,"f"),h))}get iconPath(){return this.assertNotDisposed(),Fe(this,v,"f")}set iconPath(h){this.assertNotDisposed(),Fe(this,v,"f")!==h&&(et(this,v,h,"f"),Fe(this,b,"f").$setIconPath(Fe(this,t,"f"),E.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return Fe(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Fe(this,D,"f")=="number"&&Fe(this,D,"f")<0))return Fe(this,D,"f")}get active(){return this.assertNotDisposed(),Fe(this,a,"f")}get visible(){return this.assertNotDisposed(),Fe(this,_,"f")}_updateViewState(h){Fe(this,d,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(et(this,a,h.active,"f"),et(this,_,h.visible,"f"),et(this,D,h.viewColumn,"f"),Fe(this,i,"f").fire({webviewPanel:this}))}reveal(h,m){this.assertNotDisposed(),Fe(this,b,"f").$reveal(Fe(this,t,"f"),{viewColumn:h?R.ViewColumn.from(h):void 0,preserveFocus:!!m})}assertNotDisposed(){if(Fe(this,d,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,b=new WeakMap,n=new WeakMap,f=new WeakMap,o=new WeakMap,l=new WeakMap,v=new WeakMap,D=new WeakMap,_=new WeakMap,a=new WeakMap,d=new WeakMap,S=new WeakMap,i=new WeakMap;class r{constructor(h,m,k){this.webviews=m,this.workspace=k,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(h,m,k,T,g={}){const I=typeof T=="object"?T.viewColumn:T,F={viewColumn:R.ViewColumn.from(I),preserveFocus:typeof T=="object"&&!!T.preserveFocus},L=(0,C.shouldSerializeBuffersForPostMessage)(h),w=r.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(h),w,m,{title:k,panelOptions:s(g),webviewOptions:(0,C.serializeWebviewOptions)(h,this.workspace,g),serializeBuffersForPostMessage:L},F);const x=this.webviews.createNewWebview(w,g,h);return this.createNewWebviewPanel(w,m,k,I,g,x)}$onDidChangeWebviewPanelViewStates(h){const m=Object.keys(h);m.sort((k,T)=>{const g=h[k],I=h[T];return g.active?1:I.active?-1:+g.visible-+I.visible});for(const k of m){const T=this.getWebviewPanel(k);if(!T)continue;const g=h[k];T._updateViewState({active:g.active,visible:g.visible,viewColumn:R.ViewColumn.to(g.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,m,k){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:k,extension:h}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(h)}),new P.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(h,m,k,T){const g=this._serializers.get(m);if(!g)throw new Error(`No serializer found for '${m}'`);const{serializer:I,extension:F}=g,L=this.webviews.createNewWebview(h,k.webviewOptions,F),w=this.createNewWebviewPanel(h,m,k.title,T,k.panelOptions,L);await I.deserializeWebviewPanel(w,k.state)}createNewWebviewPanel(h,m,k,T,g,I){const F=new p(h,this._proxy,m,k,T,g,I);return this._webviewPanels.set(h,F),F}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=r;function s(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Fe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(be[211],Ee([0,1,3,6,50,5,7]),function(re,e,c,M,E,A,R){"use strict";var C,y,P,t,b,n,f,o,l,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class D extends M.Disposable{constructor(d,S,i,p,r,s){super();C.set(this,void 0),y.set(this,void 0),P.set(this,void 0),t.set(this,void 0),b.set(this,!1),n.set(this,void 0),f.set(this,void 0),o.set(this,void 0),l.set(this,this._register(new c.Emitter)),this.onDidChangeVisibility=Fe(this,l,"f").event,v.set(this,this._register(new c.Emitter)),this.onDidDispose=Fe(this,v,"f").event,et(this,P,i,"f"),et(this,f,p,"f"),et(this,C,d,"f"),et(this,y,S,"f"),et(this,t,r,"f"),et(this,n,s,"f")}dispose(){Fe(this,b,"f")||(et(this,b,!0,"f"),Fe(this,v,"f").fire(),Fe(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Fe(this,f,"f")}set title(d){this.assertNotDisposed(),Fe(this,f,"f")!==d&&(et(this,f,d,"f"),Fe(this,y,"f").$setWebviewViewTitle(Fe(this,C,"f"),d))}get description(){return this.assertNotDisposed(),Fe(this,o,"f")}set description(d){this.assertNotDisposed(),Fe(this,o,"f")!==d&&(et(this,o,d,"f"),Fe(this,y,"f").$setWebviewViewDescription(Fe(this,C,"f"),d))}get visible(){return Fe(this,n,"f")}get webview(){return Fe(this,t,"f")}get viewType(){return Fe(this,P,"f")}_setVisible(d){d===Fe(this,n,"f")||Fe(this,b,"f")||(et(this,n,d,"f"),Fe(this,l,"f").fire())}show(d){this.assertNotDisposed(),Fe(this,y,"f").$show(Fe(this,C,"f"),!!d)}assertNotDisposed(){if(Fe(this,b,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,y=new WeakMap,P=new WeakMap,t=new WeakMap,b=new WeakMap,n=new WeakMap,f=new WeakMap,o=new WeakMap,l=new WeakMap,v=new WeakMap;class _{constructor(d,S){this._extHostWebview=S,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=d.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(d,S,i,p){if(this._viewProviders.has(S))throw new Error(`View provider for '${S}' already registered`);return this._viewProviders.set(S,{provider:i,extension:d}),this._proxy.$registerWebviewViewProvider((0,E.toExtensionData)(d),S,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new R.Disposable(()=>{this._viewProviders.delete(S),this._proxy.$unregisterWebviewViewProvider(S)})}async $resolveWebviewView(d,S,i,p,r){const s=this._viewProviders.get(S);if(!s)throw new Error(`No view provider found for '${S}'`);const{provider:u,extension:h}=s,m=this._extHostWebview.createNewWebview(d,{},h),k=new D(d,this._proxy,S,i,m,!0);this._webviewViews.set(d,k),await u.resolveWebviewView(k,{state:p},r)}async $onDidChangeWebviewViewVisibility(d,S){this.getWebviewView(d)._setVisible(S)}async $disposeWebviewView(d){const S=this.getWebviewView(d);this._webviewViews.delete(d),S.dispose(),this._extHostWebview.deleteWebview(d)}getWebviewView(d){const S=this._webviewViews.get(d);if(!S)throw new Error("No webview found");return S}}e.ExtHostWebviewViews=_}),define(be[97],Ee([0,1,3,5,2,11,9,4,12]),function(re,e,c,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Ui{constructor(b){this._onDidChangeWindowState=new c.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ui.InitialState,this._proxy=b.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(b){b!==this._state.focused&&(this._state={...this._state,focused:b},this._onDidChangeWindowState.fire(this._state))}openUri(b,n){let f;if(typeof b=="string"){f=b;try{b=E.URI.parse(b)}catch(o){return Promise.reject(`Invalid uri - '${b}'`)}}return(0,R.isFalsyOrWhitespace)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this._proxy.$openUri(b,f,n)}async asExternalUri(b,n){if((0,R.isFalsyOrWhitespace)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(b,n);return E.URI.from(f)}};P.InitialState={focused:!0},P=$e([Ve(0,y.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(be[212],Ee([0,1,15,5,29,12]),function(re,e,c,M,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends c.AbstractLogger{constructor(y,P){super();this._proxy=y.getProxy(M.MainContext.MainThreadLog),this._logFile=P.logFile.toJSON(),this.setLevel(P.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...P){this.getLevel()<=c.LogLevel.Trace&&this._proxy.$log(this._logFile,c.LogLevel.Trace,Array.from(arguments))}debug(y,...P){this.getLevel()<=c.LogLevel.Debug&&this._proxy.$log(this._logFile,c.LogLevel.Debug,Array.from(arguments))}info(y,...P){this.getLevel()<=c.LogLevel.Info&&this._proxy.$log(this._logFile,c.LogLevel.Info,Array.from(arguments))}warn(y,...P){this.getLevel()<=c.LogLevel.Warning&&this._proxy.$log(this._logFile,c.LogLevel.Warning,Array.from(arguments))}error(y,...P){this.getLevel()<=c.LogLevel.Error&&this._proxy.$log(this._logFile,c.LogLevel.Error,Array.from(arguments))}critical(y,...P){this.getLevel()<=c.LogLevel.Critical&&this._proxy.$log(this._logFile,c.LogLevel.Critical,Array.from(arguments))}flush(){}};R=$e([Ve(0,A.IExtHostRpcService),Ve(1,E.IExtHostInitDataService)],R),e.ExtHostLogService=R}),define(be[213],Ee([0,1,14,22,21,16,3,6,109,180,38]),function(re,e,c,M,E,A,R,C,y,P,t){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(g,I){try{return JSON.stringify(g,I)}catch(F){return"null"}}const f="$$ref$$",o={[f]:-1};class l{constructor(I,F){this.jsonString=I,this.referencedBuffers=F}}function v(g,I=null,F=!1){const L=[];return{jsonString:(F?n:JSON.stringify)(g,(x,W)=>{if(typeof W=="undefined")return o;if(typeof W=="object"){if(W instanceof M.VSBuffer){const B=L.push(W)-1;return{[f]:B}}if(I)return I(x,W)}return W}),referencedBuffers:L}}e.stringifyJsonWithBufferRefs=v;function D(g,I,F){return JSON.parse(g,(L,w)=>{if(w){const x=w[f];if(typeof x=="number")return I[x];if(F&&w.$mid===1)return F.transformIncoming(w)}return w})}e.parseJsonAndRestoreBufferRefs=D;function _(g,I){return JSON.stringify(g,I)}function a(g){return g?(I,F)=>F&&F.$mid===1?g.transformOutgoing(F):F:null}var d;(function(g){g[g.LocalSide=0]="LocalSide",g[g.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(g){g[g.Responsive=0]="Responsive",g[g.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},p=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class s extends C.Disposable{constructor(I,F=null,L=null){super();this[b]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=I,this._logger=F,this._uriTransformer=L,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let w=0,x=t.ProxyIdentifier.count;w<x;w++)this._locals[w]=null,this._proxies[w]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new c.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(w=>this._receiveOneMessage(w))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(I=>{this._pendingRPCReplies[I].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(I){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(I){this._unresponsiveTime=Date.now()+s.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(I){this._responsiveState!==I&&(this._responsiveState=I,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(I){return this._uriTransformer?(0,y.transformIncomingURIs)(I,this._uriTransformer):I}getProxy(I){const{nid:F,sid:L}=I;return this._proxies[F]||(this._proxies[F]=this._createProxy(F,L)),this._proxies[F]}_createProxy(I,F){let L={get:(w,x)=>(typeof x=="string"&&!w[x]&&x.charCodeAt(0)===36&&(w[x]=(...W)=>this._remoteCall(I,x,W)),x===r?F:w[x])};return new Proxy(Object.create(null),L)}set(I,F){return this._locals[I.nid]=F,F}assertRegistered(I){for(let F=0,L=I.length;F<L;F++){const w=I[F];if(!this._locals[w.nid])throw new Error(`Missing actor ${w.sid} (isMain: ${w.isMain})`)}}_receiveOneMessage(I){if(this._isDisposed)return;const F=I.byteLength,L=u.read(I,0),w=L.readUInt8(),x=L.readUInt32();switch(w){case 1:case 2:{let{rpcId:W,method:B,args:G}=m.deserializeRequestJSONArgs(L);this._uriTransformer&&(G=(0,y.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(F,x,W,B,G,w===2);break}case 3:case 4:{let{rpcId:W,method:B,args:G}=m.deserializeRequestMixedArgs(L);this._uriTransformer&&(G=(0,y.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(F,x,W,B,G,w===4);break}case 5:{this._logger&&this._logger.logIncoming(F,x,0,"ack"),this._onDidReceiveAcknowledge(x);break}case 6:{this._receiveCancel(F,x);break}case 7:{this._receiveReply(F,x,void 0);break}case 9:{let W=m.deserializeReplyOKJSON(L);this._uriTransformer&&(W=(0,y.transformIncomingURIs)(W,this._uriTransformer)),this._receiveReply(F,x,W);break}case 10:{const W=m.deserializeReplyOKJSONWithBuffers(L,this._uriTransformer);this._receiveReply(F,x,W);break}case 8:{let W=m.deserializeReplyOKVSBuffer(L);this._receiveReply(F,x,W);break}case 11:{let W=m.deserializeReplyErrError(L);this._uriTransformer&&(W=(0,y.transformIncomingURIs)(W,this._uriTransformer)),this._receiveReplyErr(F,x,W);break}case 12:{this._receiveReplyErr(F,x,void 0);break}default:console.error("received unexpected message"),console.error(I)}}_receiveRequest(I,F,L,w,x,W){this._logger&&this._logger.logIncoming(I,F,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(L)}.${w}(`,x);const B=String(F);let G,H;if(W){const V=new E.CancellationTokenSource;x.push(V.token),G=this._invokeHandler(L,w,x),H=()=>V.cancel()}else G=this._invokeHandler(L,w,x),H=i;this._cancelInvokedHandlers[B]=H;const U=m.serializeAcknowledged(F);this._logger&&this._logger.logOutgoing(U.byteLength,F,1,"ack"),this._protocol.send(U),G.then(V=>{delete this._cancelInvokedHandlers[B];const Q=m.serializeReplyOK(F,V,this._uriReplacer);this._logger&&this._logger.logOutgoing(Q.byteLength,F,1,"reply:",V),this._protocol.send(Q)},V=>{delete this._cancelInvokedHandlers[B];const Q=m.serializeReplyErr(F,V);this._logger&&this._logger.logOutgoing(Q.byteLength,F,1,"replyErr:",V),this._protocol.send(Q)})}_receiveCancel(I,F){this._logger&&this._logger.logIncoming(I,F,1,"receiveCancel");const L=String(F);this._cancelInvokedHandlers[L]&&this._cancelInvokedHandlers[L]()}_receiveReply(I,F,L){this._logger&&this._logger.logIncoming(I,F,0,"receiveReply:",L);const w=String(F);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const x=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w],x.resolveOk(L)}_receiveReplyErr(I,F,L){this._logger&&this._logger.logIncoming(I,F,0,"receiveReplyErr:",L);const w=String(F);if(!this._pendingRPCReplies.hasOwnProperty(w))return;const x=this._pendingRPCReplies[w];delete this._pendingRPCReplies[w];let W;L&&(L.$isError?(W=new Error,W.name=L.name,W.message=L.message,W.stack=L.stack):W=L),x.resolveErr(W)}_invokeHandler(I,F,L){try{return Promise.resolve(this._doInvokeHandler(I,F,L))}catch(w){return Promise.reject(w)}}_doInvokeHandler(I,F,L){const w=this._locals[I];if(!w)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(I));let x=w[F];if(typeof x!="function")throw new Error("Unknown method "+F+" on actor "+(0,t.getStringIdentifierForProxy)(I));return x.apply(w,L)}_remoteCall(I,F,L){if(this._isDisposed)return Promise.reject(A.canceled());let w=null;if(L.length>0&&E.CancellationToken.isCancellationToken(L[L.length-1])&&(w=L.pop()),w&&w.isCancellationRequested)return Promise.reject(A.canceled());const x=m.serializeRequestArguments(L,this._uriReplacer),W=++this._lastMessageId,B=String(W),G=new P.LazyPromise;w&&w.onCancellationRequested(()=>{const U=m.serializeCancel(W);this._logger&&this._logger.logOutgoing(U.byteLength,W,0,"cancel"),this._protocol.send(m.serializeCancel(W))}),this._pendingRPCReplies[B]=G,this._onWillSendRequest(W);const H=m.serializeRequest(W,I,F,x,!!w);return this._logger&&this._logger.logOutgoing(H.byteLength,W,0,`request: ${(0,t.getStringIdentifierForProxy)(I)}.${F}(`,L),this._protocol.send(H),G}}e.RPCProtocol=s,b=p,s.UNRESPONSIVE_TIME=3*1e3;class u{constructor(I,F){this._buff=I,this._offset=F}static alloc(I,F,L){let w=new u(M.VSBuffer.alloc(L+1+4),0);return w.writeUInt8(I),w.writeUInt32(F),w}static read(I,F){return new u(I,F)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(I){this._buff.writeUInt8(I,this._offset),this._offset+=1}readUInt8(){const I=this._buff.readUInt8(this._offset);return this._offset+=1,I}writeUInt32(I){this._buff.writeUInt32BE(I,this._offset),this._offset+=4}readUInt32(){const I=this._buff.readUInt32BE(this._offset);return this._offset+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this._buff.writeUInt8(I.byteLength,this._offset),this._offset+=1,this._buff.set(I,this._offset),this._offset+=I.byteLength}readShortString(){const I=this._buff.readUInt8(this._offset);this._offset+=1;const L=this._buff.slice(this._offset,this._offset+I).toString();return this._offset+=I,L}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}readLongString(){const I=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+I).toString();return this._offset+=I,L}writeBuffer(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this._buff.writeUInt32BE(I.byteLength,this._offset),this._offset+=4,this._buff.set(I,this._offset),this._offset+=I.byteLength}readVSBuffer(){const I=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+I);return this._offset+=I,F}static sizeMixedArray(I){let F=0;F+=1;for(let L=0,w=I.length;L<w;L++){const x=I[L];switch(F+=1,x.type){case 1:F+=this.sizeLongString(x.value);break;case 2:F+=this.sizeVSBuffer(x.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(x.value);for(let W=0;W<x.buffers.length;++W)F+=this.sizeVSBuffer(x.buffers[W]);break;case 4:break}}return F}writeMixedArray(I){this._buff.writeUInt8(I.length,this._offset),this._offset+=1;for(let F=0,L=I.length;F<L;F++){const w=I[F];switch(w.type){case 1:this.writeUInt8(1),this.writeLongString(w.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(w.value);break;case 3:this.writeUInt8(3),this.writeUInt32(w.buffers.length),this.writeLongString(w.value);for(let x=0;x<w.buffers.length;++x)this.writeBuffer(w.buffers[x]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this._buff.readUInt8(this._offset);this._offset+=1;let F=new Array(I);for(let L=0;L<I;L++)switch(this.readUInt8()){case 1:F[L]=this.readLongString();break;case 2:F[L]=this.readVSBuffer();break;case 3:const x=this.readUInt32(),W=this.readLongString(),B=[];for(let G=0;G<x;++G)B.push(this.readVSBuffer());F[L]=new t.SerializableObjectWithBuffers(D(W,B,null));break;case 4:F[L]=void 0;break}return F}}u.sizeUInt32=4;var h;(function(g){g[g.Simple=0]="Simple",g[g.Mixed=1]="Mixed"})(h||(h={}));class m{static _useMixedArgSerialization(I){for(let F=0,L=I.length;F<L;F++)if(I[F]instanceof M.VSBuffer||I[F]instanceof t.SerializableObjectWithBuffers||typeof I[F]=="undefined")return!0;return!1}static serializeRequestArguments(I,F){if(this._useMixedArgSerialization(I)){const L=[];for(let w=0,x=I.length;w<x;w++){const W=I[w];if(W instanceof M.VSBuffer)L[w]={type:2,value:W};else if(typeof W=="undefined")L[w]={type:4};else if(W instanceof t.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:G}=v(W.value,F);L[w]={type:3,value:M.VSBuffer.fromString(B),buffers:G}}else L[w]={type:1,value:M.VSBuffer.fromString(_(W,F))}}return{type:1,args:L}}return{type:0,args:_(I,F)}}static serializeRequest(I,F,L,w,x){switch(w.type){case 0:return this._requestJSONArgs(I,F,L,w.args,x);case 1:return this._requestMixedArgs(I,F,L,w.args,x)}}static _requestJSONArgs(I,F,L,w,x){const W=M.VSBuffer.fromString(L),B=M.VSBuffer.fromString(w);let G=0;G+=u.sizeUInt8(),G+=u.sizeShortString(W),G+=u.sizeLongString(B);let H=u.alloc(x?2:1,I,G);return H.writeUInt8(F),H.writeShortString(W),H.writeLongString(B),H.buffer}static deserializeRequestJSONArgs(I){const F=I.readUInt8(),L=I.readShortString(),w=I.readLongString();return{rpcId:F,method:L,args:JSON.parse(w)}}static _requestMixedArgs(I,F,L,w,x){const W=M.VSBuffer.fromString(L);let B=0;B+=u.sizeUInt8(),B+=u.sizeShortString(W),B+=u.sizeMixedArray(w);let G=u.alloc(x?4:3,I,B);return G.writeUInt8(F),G.writeShortString(W),G.writeMixedArray(w),G.buffer}static deserializeRequestMixedArgs(I){const F=I.readUInt8(),L=I.readShortString(),w=I.readMixedArray(),x=new Array(w.length);for(let W=0,B=w.length;W<B;W++){const G=w[W];typeof G=="string"?x[W]=JSON.parse(G):x[W]=G}return{rpcId:F,method:L,args:x}}static serializeAcknowledged(I){return u.alloc(5,I,0).buffer}static serializeCancel(I){return u.alloc(6,I,0).buffer}static serializeReplyOK(I,F,L){if(typeof F=="undefined")return this._serializeReplyOKEmpty(I);if(F instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(I,F);if(F instanceof t.SerializableObjectWithBuffers){const{jsonString:w,referencedBuffers:x}=v(F.value,L,!0);return this._serializeReplyOKJSONWithBuffers(I,w,x)}else return this._serializeReplyOKJSON(I,n(F,L))}static _serializeReplyOKEmpty(I){return u.alloc(7,I,0).buffer}static _serializeReplyOKVSBuffer(I,F){let L=0;L+=u.sizeVSBuffer(F);let w=u.alloc(8,I,L);return w.writeVSBuffer(F),w.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static _serializeReplyOKJSON(I,F){const L=M.VSBuffer.fromString(F);let w=0;w+=u.sizeLongString(L);let x=u.alloc(9,I,w);return x.writeLongString(L),x.buffer}static _serializeReplyOKJSONWithBuffers(I,F,L){const w=M.VSBuffer.fromString(F);let x=0;x+=u.sizeUInt32,x+=u.sizeLongString(w);for(const B of L)x+=u.sizeVSBuffer(B);let W=u.alloc(10,I,x);W.writeUInt32(L.length),W.writeLongString(w);for(const B of L)W.writeBuffer(B);return W.buffer}static deserializeReplyOKJSON(I){const F=I.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(I,F){const L=I.readUInt32(),w=I.readLongString(),x=[];for(let W=0;W<L;++W)x.push(I.readVSBuffer());return new t.SerializableObjectWithBuffers(D(w,x,F))}static serializeReplyErr(I,F){return F?this._serializeReplyErrEror(I,F):this._serializeReplyErrEmpty(I)}static _serializeReplyErrEror(I,F){const L=M.VSBuffer.fromString(n(A.transformErrorForSerialization(F),null));let w=0;w+=u.sizeLongString(L);let x=u.alloc(11,I,w);return x.writeLongString(L),x.buffer}static deserializeReplyErrError(I){const F=I.readLongString();return JSON.parse(F)}static _serializeReplyErrEmpty(I){return u.alloc(12,I,0).buffer}}var k;(function(g){g[g.RequestJSONArgs=1]="RequestJSONArgs",g[g.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",g[g.RequestMixedArgs=3]="RequestMixedArgs",g[g.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",g[g.Acknowledged=5]="Acknowledged",g[g.Cancel=6]="Cancel",g[g.ReplyOKEmpty=7]="ReplyOKEmpty",g[g.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",g[g.ReplyOKJSON=9]="ReplyOKJSON",g[g.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",g[g.ReplyErrError=11]="ReplyErrError",g[g.ReplyErrEmpty=12]="ReplyErrEmpty"})(k||(k={}));var T;(function(g){g[g.String=1]="String",g[g.VSBuffer=2]="VSBuffer",g[g.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",g[g.Undefined=4]="Undefined"})(T||(T={}))}),define(be[214],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const c=function(A){const R=C=>{self.removeEventListener("message",R);const y=C.data;Object.defineProperties(self,{postMessage:{value(P,t){y.postMessage(P,t)}},onmessage:{get(){return y.onmessage},set(P){y.onmessage=P}}}),y.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",R)}.toString();class M extends EventTarget{constructor(A,R,C){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${c})('${R}'))`,P=new Blob([y],{type:"application/javascript"}),t=URL.createObjectURL(P),b=new MessageChannel,n=t,f={type:"_newWorker",id:n,port:b.port2,url:t,options:C};A(f,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{const o={type:"_terminateWorker",id:n};b.port1.postMessage(o),URL.revokeObjectURL(t),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(o){b.port1.onmessage=o}},onmessageerror:{get(){return b.port1.onmessageerror},set(o){b.port1.onmessageerror=o}}}),b.port1.addEventListener("messageerror",o=>{const l=new MessageEvent("messageerror",{data:o.data});this.dispatchEvent(l)}),b.port1.addEventListener("message",o=>{const l=new MessageEvent("message",{data:o.data});this.dispatchEvent(l)}),b.port1.start()}}e.NestedWorker=M}),define(be[215],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(be[216],Ee([0,1,11,17,25,2,4,86,47,176,215]),function(re,e,c,M,E,A,R,C,y,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,R.createDecorator)("pathService");let b=class $i{constructor(f,o,l,v){this.localUserHome=f,this.remoteAgentService=o,this.environmentService=l,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||E.OS)(),this.resolveUserHome=(async()=>{const D=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=D?.userHome||f})()}get defaultUriScheme(){return $i.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,o){if(f.remoteAuthority)return c.Schemas.vscodeRemote;const l=(0,C.getVirtualWorkspaceScheme)(o.getWorkspace());if(l)return l;const v=o.getWorkspace().folders[0];if(v)return v.uri.scheme;const D=o.getWorkspace().configuration;return D?D.scheme:c.Schemas.file}async userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?M.win32:M.posix)}async fileURI(f){let o="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const v=f.indexOf("/",2);v===-1?(o=f.substring(2),f="/"):(o=f.substring(2,v),f=f.substring(v)||"/")}return A.URI.from({scheme:c.Schemas.file,authority:o,path:f,query:"",fragment:""})}};b=$e([Ve(1,t.IRemoteAgentService),Ve(2,P.IWorkbenchEnvironmentService),Ve(3,y.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(be[98],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(R,C){this.line=R,this.character=C}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,C){return new c(0,0)}with(R){return new c(0,0)}}e.Position=c;class M{constructor(R,C,y,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(R,C),this.end=new c(y,P)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new M(0,0,0,0)}with(R){return new M(0,0,0,0)}}e.Range=M;var E;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(E=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[41],Ee([0,1,13,27,23,43,9,4,17,16,98,10]),function(re,e,c,M,E,A,R,C,y,P,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",f=" characters skipped \u27EB",o=(n.length+f.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var l;(function(U){U[U.file=0]="file",U[U.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(U){U[U.File=1]="File",U[U.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function D(U){return!!U.preview}e.resultIsMatch=D;function _(U){return!!U.resource}e.isFileMatch=_;function a(U){return!!U.message}e.isProgressMessage=a;var d;(function(U){U[U.Normal=0]="Normal",U[U.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class S{constructor(V){this.resource=V,this.results=[]}}e.FileMatch=S;class i{constructor(V,Q,ne){this.ranges=Q;const ce=Array.isArray(Q)?Q:[Q];if(ne&&ne.matchLines===1&&p(ce)){V=(0,R.getNLines)(V,ne.matchLines);let Z="",oe=0,ve=0;const Ae=Math.floor(ne.charsPerLine/5),Se=[];for(const Ne of ce){const We=Math.max(Ne.startColumn-Ae,0),je=Ne.startColumn+ne.charsPerLine;if(We>ve+Ae+o){const qe=n+(We-ve)+f;Z+=qe+V.slice(We,je),oe+=We-(ve+qe.length)}else Z+=V.slice(ve,je);Se.push(new s(0,Ne.startColumn-oe,Ne.endColumn-oe)),ve=je}this.preview={text:Z,matches:Array.isArray(this.ranges)?Se:Se[0]}}else{const Z=Array.isArray(Q)?Q[0].startLineNumber:Q.startLineNumber;this.preview={text:V,matches:(0,c.mapArrayOrNot)(Q,oe=>new r(oe.startLineNumber-Z,oe.startColumn,oe.endLineNumber-Z,oe.endColumn))}}}}e.TextSearchMatch=i;function p(U){const V=U[0].startLineNumber;for(const Q of U)if(Q.startLineNumber!==V||Q.endLineNumber!==V)return!1;return!0}class r{constructor(V,Q,ne,ce){this.startLineNumber=V,this.startColumn=Q,this.endLineNumber=ne,this.endColumn=ce}}e.SearchRange=r;class s extends r{constructor(V,Q,ne){super(V,Q,V,ne)}}e.OneLineRange=s;var u;(function(U){U.Default="default",U.FileNames="fileNames",U.Type="type",U.Modified="modified",U.CountDescending="countDescending",U.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function h(U,V=!0){const Q=U&&U.files&&U.files.exclude,ne=V&&U&&U.search&&U.search.exclude;if(!Q&&!ne)return;if(!Q||!ne)return Q||ne;let ce=Object.create(null);return ce=E.mixin(ce,E.deepClone(Q)),ce=E.mixin(ce,E.deepClone(ne),!0),ce}e.getExcludes=h;function m(U,V){return U.excludePattern&&M.match(U.excludePattern,V)?!1:U.includePattern||U.usingSearchPaths?U.includePattern&&M.match(U.includePattern,V)?!0:U.usingSearchPaths?!!U.folderQueries&&U.folderQueries.some(Q=>{const ne=Q.folder.fsPath;if(A.isEqualOrParent(V,ne)){const ce=y.relative(ne,V);return!Q.includePattern||!!M.match(Q.includePattern,ce)}else return!1}):!1:!0}e.pathIncludedInQuery=m;var k;(function(U){U[U.unknownEncoding=1]="unknownEncoding",U[U.regexParseError=2]="regexParseError",U[U.globParseError=3]="globParseError",U[U.invalidLiteral=4]="invalidLiteral",U[U.rgProcessError=5]="rgProcessError",U[U.other=6]="other",U[U.canceled=7]="canceled"})(k=e.SearchErrorCode||(e.SearchErrorCode={}));class T extends Error{constructor(V,Q){super(V);this.code=Q}}e.SearchError=T;function g(U){const V=U.message;if((0,P.isPromiseCanceledError)(U))return new T(V,k.canceled);try{const Q=JSON.parse(V);return new T(Q.message,Q.code)}catch(Q){return new T(V,k.other)}}e.deserializeSearchError=g;function I(U){const V={message:U.message,code:U.code};return new Error(JSON.stringify(V))}e.serializeSearchError=I;function F(U){return U.type==="error"?!0:U.type==="success"}e.isSerializedSearchComplete=F;function L(U){return U.type==="success"}e.isSerializedSearchSuccess=L;function w(U){return!!U.path}e.isSerializedFileMatch=w;function x(U,V){const Q=U.searchPath?U.searchPath:U.relativePath;return(0,R.fuzzyContains)(Q,V)}e.isFilePatternMatch=x;class W{constructor(V){this.path=V,this.results=[]}addMatch(V){this.results.push(V)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=W;function B(U,V){const Q={...U||{},...V||{}};return Object.keys(Q).filter(ne=>{const ce=Q[ne];return typeof ce=="boolean"&&ce})}e.resolvePatternsForProvider=B;class G{constructor(V,Q){this._parsedIncludeExpression=null,this._excludeExpression={...V.excludePattern||{},...Q.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let ne=V.includePattern;Q.includePattern&&(ne?ne={...ne,...Q.includePattern}:ne=Q.includePattern),ne&&(this._parsedIncludeExpression=M.parse(ne))}matchesExcludesSync(V,Q,ne){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,Q,ne))}includedInQuerySync(V,Q,ne){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,Q,ne)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(V,Q,ne))}includedInQuery(V,Q,ne){const ce=this._parsedExcludeExpression(V,Q,ne),Z=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(V,Q,ne):!0;return(0,b.isPromise)(ce)?ce.then(oe=>oe?!1:Z()):Z()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=G;function H(U){for(const V in U)if(typeof U[V]!="boolean")return!0;return!1}}),define(be[31],Ee([0,1,13,14,21,3,20,11,75,24,9,10,2,130,4,15,145,47,37,29,12,7,41,5]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o,l,v,D,_,a,d,S,i,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(I,F,L){return new P.ExtUri(w=>m(w,L)).isEqual(I,F)}function s(I,F,L){return r(I.uri,F.uri,L)?0:(0,t.compare)(I.uri.toString(),F.uri.toString())}function u(I,F,L){return I.index!==F.index?I.index<F.index?-1:1:r(I.uri,F.uri,L)?(0,t.compare)(I.name,F.name):(0,t.compare)(I.uri.toString(),F.uri.toString())}function h(I,F,L,w){const x=I.slice(0).sort((B,G)=>L(B,G,w)),W=F.slice(0).sort((B,G)=>L(B,G,w));return(0,c.delta)(x,W,(B,G)=>L(B,G,w))}function m(I,F){const L=F.getCapabilities(I.scheme);return!(L&&L&1024)}class k extends D.Workspace{constructor(F,L,w,x,W,B,G){super(F,w.map(H=>new D.WorkspaceFolder(H)),x,W,G);this._name=L,this._isUntitled=B,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(G),w.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(F,L,w,x){if(!F)return{workspace:null,added:[],removed:[]};const{id:W,name:B,folders:G,configuration:H,transient:U,isUntitled:V}=F,Q=[],ne=L;L?G.forEach((ve,Ae)=>{const Se=n.URI.revive(ve.uri),Ne=k._findFolder(w||L,Se,x);Ne?(Ne.name=ve.name,Ne.index=ve.index,Q.push(Ne)):Q.push({uri:Se,name:ve.name,index:Ae})}):Q.push(...G.map(({uri:ve,name:Ae,index:Se})=>({uri:n.URI.revive(ve),name:Ae,index:Se}))),Q.sort((ve,Ae)=>ve.index<Ae.index?-1:1);const ce=new k(W,B,Q,!!U,H?n.URI.revive(H):null,!!V,ve=>m(ve,x)),{added:Z,removed:oe}=h(ne?ne.workspaceFolders:[],ce.workspaceFolders,s,x);return{workspace:ce,added:Z,removed:oe}}static _findFolder(F,L,w){for(let x=0;x<F.folders.length;x++){const W=F.workspaceFolders[x];if(r(W.uri,L,w))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,L){return L&&this._structure.get(F)&&(F=(0,P.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let T=class{constructor(F,L,w,x){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=x,this._extHostFileSystemInfo=w,this._requestIdProvider=new y.Counter,this._barrier=new M.Barrier,this._proxy=F.getProxy(p.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(p.MainContext.MainThreadMessageService);const W=L.workspace;this._confirmedWorkspace=W?new k(W.id,W.name,[],!!W.transient,W.configuration?n.URI.revive(W.configuration):null,!!W.isUntitled,B=>m(B,w)):void 0}$initializeWorkspace(F,L){this._trusted=L,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:C.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,L,w,...x){const W=[];if(Array.isArray(x)&&x.forEach(V=>{n.URI.isUri(V.uri)&&!W.some(Q=>r(Q.uri,V.uri,this._extHostFileSystemInfo))&&W.push({uri:V.uri,name:V.name||(0,P.basenameOrAuthority)(V.uri)})}),this._unconfirmedWorkspace||[L,w].some(V=>typeof V!="number"||V<0)||w===0&&W.length===0)return!1;const B=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(L+w>B.length)return!1;const G=B.slice(0);G.splice(L,w,...W.map(V=>({uri:V.uri,name:V.name||(0,P.basenameOrAuthority)(V.uri),index:void 0})));for(let V=0;V<G.length;V++){const Q=G[V];if(G.some((ne,ce)=>ce!==V&&r(Q.uri,ne.uri,this._extHostFileSystemInfo)))return!1}G.forEach((V,Q)=>V.index=Q);const{added:H,removed:U}=h(B,G,u,this._extHostFileSystemInfo);if(H.length===0&&U.length===0)return!1;if(this._proxy){const V=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(V,L,w,W).then(void 0,Q=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(v.Severity.Error,(0,f.localize)(0,null,V,Q.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(G),!0}getWorkspaceFolder(F,L){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,L)}async getWorkspaceFolder2(F,L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,L)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!this._actualWorkspace)return;const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,L){let w,x="";if(typeof F=="string"?(w=n.URI.file(F),x=F):typeof F!="undefined"&&(w=F,x=F.fsPath),!w)return x;const W=this.getWorkspaceFolder(w,!0);if(!W)return x;typeof L=="undefined"&&this._actualWorkspace&&(L=this._actualWorkspace.folders.length>1);let B=(0,P.relativePath)(W.uri,w);return L&&W.name&&(B=`${W.name}/${B}`),B}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=k.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:L,added:w,removed:x}=k.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=L||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:w,removed:x}))}findFiles(F,L,w,x,W=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${x.value}, entryPoint: findFiles`);let B;if(L===null?B=!1:L&&(typeof L=="string"?B=L:B=L.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:G,folder:H}=g(F);return this._proxy.$startFileSearch((0,b.withUndefinedAsNull)(G),(0,b.withUndefinedAsNull)(H),(0,b.withUndefinedAsNull)(B),(0,b.withUndefinedAsNull)(w),W).then(U=>Array.isArray(U)?U.map(V=>n.URI.revive(V)):[])}async findTextInFiles(F,L,w,x,W=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${x.value}, entryPoint: findTextInFiles`);const B=this._requestIdProvider.getNext(),G=typeof L.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:L.previewOptions,{includePattern:H,folder:U}=g(L.include),V=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,Q={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!0,fileEncoding:L.encoding,maxResults:L.maxResults,previewOptions:G,afterContext:L.afterContext,beforeContext:L.beforeContext,includePattern:H,excludePattern:V},ne=!1;if(this._activeSearchCallbacks[B]=ce=>{if(ne)return;const Z=n.URI.revive(ce.resource);ce.results.forEach(oe=>{(0,i.resultIsMatch)(oe)?w({uri:Z,preview:{text:oe.preview.text,matches:(0,c.mapArrayOrNot)(oe.preview.matches,ve=>new S.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,c.mapArrayOrNot)(oe.ranges,ve=>new S.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):w({uri:Z,text:oe.text,lineNumber:oe.lineNumber})})},W.isCancellationRequested)return{};try{const ce=await this._proxy.$startTextSearch(F,(0,b.withUndefinedAsNull)(U),Q,B,W);return delete this._activeSearchCallbacks[B],ce||{}}catch(ce){throw delete this._activeSearchCallbacks[B],ce}}$handleTextSearchResult(F,L){this._activeSearchCallbacks[L]&&this._activeSearchCallbacks[L](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};T=$e([Ve(0,d.IExtHostRpcService),Ve(1,a.IExtHostInitDataService),Ve(2,_.IExtHostFileSystemInfo),Ve(3,l.ILogService)],T),e.ExtHostWorkspace=T,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function g(I){let F,L;return I&&(typeof I=="string"?F=I:(F=I.pattern,L=I.baseFolder||n.URI.file(I.base))),{includePattern:F,folder:L}}}),define(be[32],Ee([0,1,23,3,31,5,7,148,62,10,14,4,12,15,2]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(p,r){if(r){const s=r.split(".");let u=p;for(let h=0;u&&h<s.length;h++)u=u[s[h]];return u}}function v(p){return p instanceof o.URI}function D(p){return p&&p.uri instanceof o.URI&&p.languageId&&typeof p.languageId=="string"}function _(p){return p&&!p.uri&&p.languageId&&typeof p.languageId=="string"}function a(p){return p&&p.uri instanceof o.URI&&(!p.name||typeof p.name=="string")&&(!p.index||typeof p.index=="number")}function d(p){if(v(p))return{resource:p};if(D(p))return{resource:p.uri,overrideIdentifier:p.languageId};if(_(p))return{overrideIdentifier:p.languageId};if(a(p))return{resource:p.uri};if(p===null)return{resource:null}}let S=class{constructor(r,s,u){this._proxy=r.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=u,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new i(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(r,s))}};S=$e([Ve(0,n.IExtHostRpcService),Ve(1,E.IExtHostWorkspace),Ve(2,f.ILogService)],S),e.ExtHostConfiguration=S;class i{constructor(r,s,u,h){this._onDidChangeConfiguration=new M.Emitter,this._proxy=r,this._logService=h,this._extHostWorkspace=s,this._configuration=C.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,s){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,u))}getConfiguration(r,s,u){const h=d(s)||{},m=this._toReadonlyValue(r?l(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,h,u?.identifier);function k(g){if(g==null)return null;if(typeof g=="boolean")return g?1:4;switch(g){case R.ConfigurationTarget.Global:return 1;case R.ConfigurationTarget.Workspace:return 4;case R.ConfigurationTarget.WorkspaceFolder:return 5}}const T={has(g){return typeof l(m,g)!="undefined"},get:(g,I)=>{this._validateConfigurationAccess(r?`${r}.${g}`:g,h,u?.identifier);let F=l(m,g);if(typeof F=="undefined")F=I;else{let L;const w=(x,W)=>{let B;const G=()=>{L=L||(0,c.deepClone)(m),B=B||l(L,W)};return(0,P.isObject)(x)?new Proxy(x,{get:(H,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return G(),()=>B;if(L)return B=B||l(L,W),B[U];const V=H[U];return typeof U=="string"?w(V,`${W}.${U}`):V},set:(H,U,V)=>(G(),B&&(B[U]=V),!0),deleteProperty:(H,U)=>(G(),B&&delete B[U],!0),defineProperty:(H,U,V)=>(G(),B&&Object.defineProperty(B,U,V),!0)}):x};F=w(F,g)}return F},update:(g,I,F,L)=>{g=r?`${r}.${g}`:g;const w=k(F);return I!==void 0?this._proxy.$updateConfigurationOption(w,g,I,h,L):this._proxy.$removeConfigurationOption(w,g,h,L)},inspect:g=>{g=r?`${r}.${g}`:g;const I=(0,c.deepClone)(this._configuration.inspect(g,h,this._extHostWorkspace.workspace));if(I)return{key:g,defaultValue:I.default?.value,globalValue:I.user?.value,workspaceValue:I.workspace?.value,workspaceFolderValue:I.workspaceFolder?.value,defaultLanguageValue:I.default?.override,globalLanguageValue:I.user?.override,workspaceLanguageValue:I.workspace?.override,workspaceFolderLanguageValue:I.workspaceFolder?.override,languageIds:I.overrideIdentifiers}}};return typeof m=="object"&&(0,c.mixin)(T,m,!1),Object.freeze(T)}_toReadonlyValue(r){const s=u=>(0,P.isObject)(u)?new Proxy(u,{get:(h,m)=>s(h[m]),set:(h,m,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(h,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(h,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return s(r)}_validateConfigurationAccess(r,s,u){const h=y.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),m=u?`[${u.value}] `:"";if(h===4){typeof s?.resource=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){s?.resource&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,s){const u=new C.ConfigurationChangeEvent(r,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,m)=>u.affectsConfiguration(h,d(m))})}_toMap(r){return r.reduce((s,u)=>(s.set(u[0],u[1]),s),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,b.createDecorator)("IExtHostConfiguration")});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Fe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(be[99],Ee([0,1,2,14,3,5,7,31,49,32,21,40,12,29,4,11,25,15,69,166,16]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o,l,v,D,_,a,d){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(W){function B(H){if(H!=null)return H}W.from=B;function G(H){if(H!=null)return H}W.to=G})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var p;(function(W){function B(H){if(H!=null)return H}W.from=B;function G(H){if(H!=null)return H}W.to=G})(p=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(W){function B(H){if(H!=null)return H}W.from=B;function G(H){if(H!=null)return H}W.to=G})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(W){function B(U){if(U){const V=U;return V&&!!V.process}else return!1}W.is=B;function G(U){if(U==null)return;const V={process:U.process,args:U.args};return U.options&&(V.options=r.from(U.options)),V}W.from=G;function H(U){if(U!=null)return new R.ProcessExecution(U.process,U.args,U.options)}W.to=H})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(W){function B(H){if(H!=null)return H}W.from=B;function G(H){if(H!=null)return H}W.to=G})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var h;(function(W){function B(U){if(U){const V=U;return V&&(!!V.commandLine||!!V.command)}else return!1}W.is=B;function G(U){if(U==null)return;const V={};return U.commandLine!==void 0?V.commandLine=U.commandLine:(V.command=U.command,V.args=U.args),U.options&&(V.options=u.from(U.options)),V}W.from=G;function H(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new R.ShellExecution(U.commandLine,U.options):new R.ShellExecution(U.command,U.args?U.args:[],U.options)}W.to=H})(h=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var m;(function(W){function B(U){if(U){let V=U;return V&&V.customExecution==="customExecution"}else return!1}W.is=B;function G(U){return{customExecution:"customExecution"}}W.from=G;function H(U,V){return V.get(U)}W.to=H})(m=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var k;(function(W){function B(G,H){let U;return G.scope!==void 0&&typeof G.scope!="number"?U=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===R.TaskScope.Workspace&&H&&H.workspaceFile?U=H.workspaceFile:U=a.USER_TASKS_GROUP_KEY),{id:G._id,workspaceFolder:U}}W.from=B})(k=e.TaskHandleDTO||(e.TaskHandleDTO={}));var T;(function(W){function B(G){if(G!=null)return{_id:G.id,isDefault:G.isDefault}}W.from=B})(T=e.TaskGroupDTO||(e.TaskGroupDTO={}));var g;(function(W){function B(U,V){if(U==null)return[];const Q=[];for(let ne of U){const ce=G(ne,V);ce&&Q.push(ce)}return Q}W.fromMany=B;function G(U,V){if(U==null)return;let Q;U.execution instanceof R.ProcessExecution?Q=s.from(U.execution):U.execution instanceof R.ShellExecution?Q=h.from(U.execution):U.execution&&U.execution instanceof R.CustomExecution&&(Q=m.from(U.execution));const ne=i.from(U.definition);let ce;return U.scope?typeof U.scope=="number"?ce=U.scope:ce=U.scope.uri:ce=R.TaskScope.Workspace,!ne||!ce?void 0:{_id:U._id,definition:ne,name:U.name,source:{extensionId:V.identifier.value,label:U.source,scope:ce},execution:Q,isBackground:U.isBackground,group:T.from(U.group),presentationOptions:p.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}W.from=G;async function H(U,V,Q){if(U==null)return;let ne;s.is(U.execution)?ne=s.to(U.execution):h.is(U.execution)?ne=h.to(U.execution):m.is(U.execution)&&(ne=m.to(U._id,Q));const ce=i.to(U.definition);let Z;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?Z=U.source.scope:Z=await V.resolveWorkspaceFolder(c.URI.revive(U.source.scope)):Z=R.TaskScope.Workspace),!ce||!Z)return;const oe=new R.Task(ce,Z,U.name,U.source.label,ne,U.problemMatchers);return U.isBackground!==void 0&&(oe.isBackground=U.isBackground),U.group!==void 0&&(oe.group=R.TaskGroup.from(U.group._id),oe.group&&U.group.isDefault&&(oe.group=new R.TaskGroup(oe.group.id,oe.group.label),U.group.isDefault&&(oe.group.isDefault=U.group.isDefault))),U.presentationOptions&&(oe.presentationOptions=p.to(U.presentationOptions)),U._id&&(oe._id=U._id),U.detail&&(oe.detail=U.detail),oe}W.to=H})(g=e.TaskDTO||(e.TaskDTO={}));var I;(function(W){function B(H){return H}W.from=B;function G(H){if(!!H)return Object.assign(Object.create(null),H)}W.to=G})(I=e.TaskFilterDTO||(e.TaskFilterDTO={}));class F{constructor(B,G,H){this._id=G,this._task=H,S.set(this,void 0),et(this,S,B,"f")}get task(){return this._task}terminate(){Fe(this,S,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}S=new WeakMap;var L;(function(W){function B(G){return{id:G._id,task:void 0}}W.from=B})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let w=class{constructor(B,G,H,U,V,Q,ne,ce){this._onDidExecuteTask=new E.Emitter,this._onDidTerminateTask=new E.Emitter,this._onDidTaskProcessStarted=new E.Emitter,this._onDidTaskProcessEnded=new E.Emitter,this._proxy=B.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=U,this._configurationService=V,this._terminalService=Q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ne,this._deprecationService=ce,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,G,H){if(!H)return new R.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:G,provider:H,extension:B}),this._proxy.$registerTaskProvider(U,G),new R.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(B,G){this._proxy.$registerTaskSystem(B,G)}fetchTasks(B){return this._proxy.$fetchTasks(I.from(B)).then(async G=>{const H=[];for(let U of G){const V=await g.to(U,this._workspaceProvider,this._providedCustomExecutions2);V&&H.push(V)}return H})}get taskExecutions(){const B=[];return this._taskExecutions.forEach(G=>B.push(G)),B}terminateTask(B){if(!(B instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,G,H){const U=this._providedCustomExecutions2.get(B.id);if(U){if(this._activeCustomExecutions2.get(B.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(B.id,U),this._terminalService.attachPtyToTerminal(G,await U.callback(H))}this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const G=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:G})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const G=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:G,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const G=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:G,exitCode:B.exitCode})}$provideTasks(B,G){const H=this._handlers.get(B);if(!H)return Promise.reject(new Error("no handler found"));const U=[],V=(0,M.asPromise)(()=>H.provider.provideTasks(t.CancellationToken.None)).then(Q=>this.provideTasksInternal(G,U,H,Q));return new Promise(Q=>{V.then(ne=>{Promise.all(U).then(()=>{Q(ne)})})})}async $resolveTask(B,G){const H=this._handlers.get(B);if(!H)return Promise.reject(new Error("no handler found"));if(G.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${H.type}].`);const U=await g.to(G,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const V=await H.provider.resolveTask(U,t.CancellationToken.None);if(!V)return;this.checkDeprecation(V,H);const Q=g.from(V,H.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(Q.execution)&&await this.addCustomExecution(Q,V,!0),await this.resolveTaskInternal(Q)}nextHandle(){return this._handleCounter++}async addCustomExecution(B,G,H){const U=await this._proxy.$createTaskId(B);!H&&!this._providedCustomExecutions2.has(U)&&this._notProvidedCustomExecutions.add(U),this._providedCustomExecutions2.set(U,G.execution)}async getTaskExecution(B,G){if(typeof B=="string"){const V=this._taskExecutionPromises.get(B);if(!V)throw new Error("Unexpected: The specified task is missing an execution");return V}let H=this._taskExecutionPromises.get(B.id);if(H)return H;const U=new Promise(async(V,Q)=>{const ne=G||await g.to(B.task,this._workspaceProvider,this._providedCustomExecutions2);ne?V(new F(this,B.id,ne)):Q("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(B.id,U),U.then(V=>(this._taskExecutions.set(B.id,V),V),V=>Promise.reject(V))}checkDeprecation(B,G){B._deprecated&&this._deprecationService.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));let H=this._notProvidedCustomExecutions.values(),U=H.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=H.next()}};w=$e([Ve(0,n.IExtHostRpcService),Ve(1,f.IExtHostInitDataService),Ve(2,C.IExtHostWorkspace),Ve(3,y.IExtHostDocumentsAndEditors),Ve(4,P.IExtHostConfiguration),Ve(5,b.IExtHostTerminalService),Ve(6,D.ILogService),Ve(7,_.IExtHostApiDeprecationService)],w),e.ExtHostTaskBase=w;let x=class extends w{constructor(B,G,H,U,V,Q,ne,ce){super(B,G,H,U,V,Q,ne,ce);this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(B,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const H=g.from(G,B);if(H===void 0)throw new Error("Task is not valid");if(m.is(H.execution))await this.addCustomExecution(H,G,!1);else throw new d.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),G);return this._proxy.$executeTask(H).catch(V=>{throw new Error(V)}),U}provideTasksInternal(B,G,H,U){const V=[];if(U)for(let Q of U){this.checkDeprecation(Q,H),(!Q.definition||!B[Q.definition.type])&&this._logService.warn(`The task [${Q.source}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`);const ne=g.from(Q,H.extension);ne&&m.is(ne.execution)?(V.push(ne),G.push(this.addCustomExecution(ne,Q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:V,extension:H.extension}}async resolveTaskInternal(B){if(m.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,G){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,G,H){}};x=$e([Ve(0,n.IExtHostRpcService),Ve(1,f.IExtHostInitDataService),Ve(2,C.IExtHostWorkspace),Ve(3,y.IExtHostDocumentsAndEditors),Ve(4,P.IExtHostConfiguration),Ve(5,b.IExtHostTerminalService),Ve(6,D.ILogService),Ve(7,_.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")}),define(be[217],Ee([0,1,13,51,27,77,20,11,17,24,9,10,2,111,134,84,47,92,216,41]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o,l,v,D,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(k,T,g,I){this.configurationService=k,this.workspaceContextService=T,this.editorGroupsService=g,this.pathService=I}text(k,T,g={}){k=this.getContentPattern(k,g);const I=this.configurationService.getValue(),F=T&&T.some(w=>!this.configurationService.getValue({resource:w}).search.useRipgrep);return{...this.commonQuery(T?.map(v.toWorkspaceFolder),g),type:2,contentPattern:k,previewOptions:g.previewOptions,maxFileSize:g.maxFileSize,usePCRE2:I.search.usePCRE2||F||!1,beforeContext:g.beforeContext,afterContext:g.afterContext,userDisabledExcludesAndIgnoreFiles:g.disregardExcludeSettings&&g.disregardIgnoreFiles}}getContentPattern(k,T){const g=this.configurationService.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const I={...k,wordSeparators:g.editor.wordSeparators};return this.isCaseSensitive(k,T)&&(I.isCaseSensitive=!0),this.isMultiline(k)&&(I.isMultiline=!0),I}file(k,T={}){return{...this.commonQuery(k,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}handleIncludeExclude(k,T){return k?(k=Array.isArray(k)?k.map(s):s(k),T?this.parseSearchPaths(k):{pattern:i(...Array.isArray(k)?k:[k])}):{}}commonQuery(k=[],T={}){const g=this.handleIncludeExclude(T.includePattern,T.expandPatterns),I=this.handleIncludeExclude(T.excludePattern,T.expandPatterns),F=k.length>1,L=(g.searchPaths&&g.searchPaths.length?g.searchPaths.map(W=>this.getFolderQueryForSearchPath(W,T,I)):k.map(W=>this.getFolderQueryForRoot(W,T,I,F))).filter(W=>!!W),w={_reason:T._reason,folderQueries:L,usingSearchPaths:!!(g.searchPaths&&g.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:I.pattern,includePattern:g.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const B=c.coalesce(c.flatten(this.editorGroupsService.groups.map(H=>H.editors.map(U=>U.resource)))).filter(H=>(0,a.pathIncludedInQuery)(w,H.fsPath)),G=this.commonQueryFromFileList(B);return{...w,...G}}const x=T.extraFileResources&&T.extraFileResources.filter(W=>(0,a.pathIncludedInQuery)(w,W.fsPath));return w.extraFileResources=x&&x.length?x:void 0,w}commonQueryFromFileList(k){const T=[],g=new R.ResourceMap,I={};let F=!1;return k.forEach(L=>{if(L.scheme===C.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(L)){const x=this.workspaceContextService.getWorkspaceFolder(L)?.uri??L.with({path:y.dirname(L.fsPath)});let W=g.get(x);W||(F=!0,W={folder:x,includePattern:{}},T.push(W),g.set(x,W));const B=y.relative(x.fsPath,L.fsPath);(0,b.assertIsDefined)(W.includePattern)[B.replace(/\\/g,"/")]=!0}else L.fsPath&&(F=!0,I[L.fsPath]=!0)}),{folderQueries:T,includePattern:I,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(k,T){if(T.isSmartCase){if(k.isRegExp){if(t.containsUppercaseCharacter(k.pattern,!0))return!0}else if(t.containsUppercaseCharacter(k.pattern))return!0}return!!k.isCaseSensitive}isMultiline(k){return k.isMultiline||k.isRegExp&&(0,f.isMultilineRegexSource)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const T=G=>y.isAbsolute(G)||/^\.\.?([\/\\]|$)/.test(G),I=(Array.isArray(k)?k:p(k)).map(G=>{const H=this.pathService.resolvedUserHome;return H?(0,A.untildify)(G,H.scheme===C.Schemas.file?H.fsPath:H.path):G}),F=M.groupBy(I,G=>T(G)?"searchPaths":"exprSegments"),L=(F.exprSegments||[]).map(G=>t.rtrim(G,"/")).map(G=>t.rtrim(G,"\\")).map(G=>(G[0]==="."&&(G="*"+G),r(G))),w={},x=this.expandSearchPathPatterns(F.searchPaths||[]);x&&x.length&&(w.searchPaths=x);const W=c.flatten(L),B=i(...W);return B&&(w.pattern=B),w}getExcludesForFolder(k,T){return T.disregardExcludeSettings?void 0:(0,a.getExcludes)(k,!T.disregardSearchExcludeSettings)}expandSearchPathPatterns(k){if(!k||!k.length)return[];const T=c.flatten(k.map(I=>{let{pathPortion:F,globPortion:L}=S(I);L&&(L=u(L));const w=this.expandOneSearchPath(F);return c.flatten(w.map(x=>this.resolveOneSearchPathPattern(x,L)))})),g=new Map;return T.forEach(I=>{const F=I.searchPath.toString(),L=g.get(F);L?I.pattern&&(L.pattern=L.pattern||{},L.pattern[I.pattern]=!0):g.set(F,{searchPath:I.searchPath,pattern:I.pattern?i(I.pattern):void 0})}),Array.from(g.values())}expandOneSearchPath(k){if(y.isAbsolute(k)){const T=this.workspaceContextService.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==C.Schemas.file?[{searchPath:T[0].uri.with({path:k})}]:[{searchPath:n.URI.file(y.normalize(k))}]}if(this.workspaceContextService.getWorkbenchState()===2){const T=this.workspaceContextService.getWorkspace().folders[0].uri;if(k=s(k),k.startsWith("../")||k===".."){const I=y.posix.resolve(T.path,k);return[{searchPath:T.with({path:I})}]}const g=u(k);return[{searchPath:T,pattern:g}]}else{if(k==="./"||k===".\\")return[];{const T=k.replace(/^\.[\/\\]/,""),I=this.workspaceContextService.getWorkspace().folders.map(F=>{const L=T.match(new RegExp(`^${t.escapeRegExpCharacters(F.name)}(?:/(.*)|$)`));return L?{match:L,folder:F}:null}).filter(b.isDefined);if(I.length)return I.map(F=>{const L=F.match[1];return{searchPath:F.folder.uri,pattern:L&&u(L)}});{const F=k.match(/\.[\/\\](.+)[\/\\]?/),L=F?F[1]:k,w=o.localize(0,null,L);throw new Error(w)}}}}resolveOneSearchPathPattern(k,T){const g=k.pattern&&T?`${k.pattern}/${T}`:k.pattern||T,I=[{searchPath:k.searchPath,pattern:g}];return g&&!g.endsWith("**")&&I.push({searchPath:k.searchPath,pattern:g+"/**"}),I}getFolderQueryForSearchPath(k,T,g){const I=this.getFolderQueryForRoot((0,v.toWorkspaceFolder)(k.searchPath),T,g,!1);return I?{...I,includePattern:k.pattern}:null}getFolderQueryForRoot(k,T,g,I){let F;const L=n.URI.isUri(k)?k:k.uri;if(g.searchPaths){const G=g.searchPaths.filter(H=>(0,P.isEqual)(H.searchPath,L))[0];if(G&&!G.pattern)return null;G&&(F=G.pattern)}const w=this.configurationService.getValue({resource:L}),W={...this.getExcludesForFolder(w,T)||{},...F||{}},B=n.URI.isUri(k)?(0,P.basename)(k):k.name;return{folder:L,folderName:I?B:void 0,excludePattern:Object.keys(W).length>0?W:void 0,fileEncoding:w.files&&w.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!w.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!w.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!w.search.followSymlinks}}};d=$e([Ve(0,l.IConfigurationService),Ve(1,v.IWorkspaceContextService),Ve(2,D.IEditorGroupsService),Ve(3,_.IPathService)],d),e.QueryBuilder=d;function S(m){const k=m.match(/[\*\{\}\(\)\[\]\?]/);if(k){const T=k.index,g=m.substr(0,T).match(/[/|\\][^/\\]*$/);if(g){let I=m.substr(0,g.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:m.substr((g.index||0)+1)}}}return{pathPortion:m}}function i(...m){return m.length?m.reduce((k,T)=>(k[T]=!0,k),Object.create(null)):void 0}function p(m){return E.splitGlobAware(m,",").map(k=>k.trim()).filter(k=>!!k.length)}function r(m){return[`**/${m}/**`,`**/${m}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function s(m){return m.replace(/\\/g,"/")}function u(m){return s(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(m,k){m=c.distinct(m,I=>I.toString());const T=[],g=k.getWorkspace();return m&&m.forEach(I=>{let F;if(k.getWorkbenchState()===2)F=(0,P.relativePath)(g.folders[0].uri,I),F&&F!=="."&&(F="./"+F);else{const L=k.getWorkspaceFolder(I);if(L){const w=L.name;if(g.folders.filter(W=>W.name===w).length===1){const W=(0,P.relativePath)(L.uri,I);W===""?F=`./${L.name}`:F=`./${L.name}/${W}`}else F=I.fsPath}}F&&T.push(F)}),T}e.resolveResourcesForSearchIncludes=h}),define(be[218],Ee([0,1,24,2,21,16,4,217,41,47]),function(re,e,c,M,E,A,R,C,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function b(l,v){const D=v.activationEvents;if(!D)return Promise.resolve(void 0);const _=[],a=[];for(const s of D)if(/^workspaceContains:/.test(s)){const u=s.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||l.forceUsingSearch?a.push(u):_.push(u)}if(_.length===0&&a.length===0)return Promise.resolve(void 0);let d;const S=new Promise((s,u)=>{d=s}),i=s=>d({activationEvent:s}),p=Promise.all(_.map(s=>n(l,s,i))).then(()=>{}),r=f(l,v.identifier,a,i);return Promise.all([p,r]).then(()=>{d(void 0)}),S}e.checkActivateWorkspaceContainsExtension=b;async function n(l,v,D){for(const _ of l.folders)if(await l.exists(c.joinPath(M.URI.revive(_),v))){D(`workspaceContains:${v}`);return}}async function f(l,v,D,_){if(D.length===0)return Promise.resolve(void 0);const a=new E.CancellationTokenSource,d=l.checkExists(l.folders,D,a.token),S=setTimeout(async()=>{a.cancel(),_(`workspaceContainsTimeout:${D.join(",")}`)},t);let i=!1;try{i=await d}catch(p){A.isPromiseCanceledError(p)||A.onUnexpectedError(p)}a.dispose(),clearTimeout(S),i&&_(`workspaceContains:${D.join(",")}`)}function o(l,v,D,_){const a=l.get(R.IInstantiationService),d=l.get(y.ISearchService),i=a.createInstance(C.QueryBuilder).file(v.map(p=>(0,P.toWorkspaceFolder)(M.URI.revive(p))),{_reason:"checkExists",includePattern:D,exists:!0});return d.fileSearch(i,_).then(p=>!!p.limitHit,p=>A.isPromiseCanceledError(p)?!1:Promise.reject(p))}e.checkGlobFileExists=o});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Fe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(be[33],Ee([0,1,125,17,74,24,14,6,20,2,15,5,32,179,72,31,30,177,16,26,22,153,7,85,4,29,73,12,61,64,40,3,218,68,155]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o,l,v,D,_,a,d,S,i,p,r,s,u,h,m,k,T,g,I,F,L){"use strict";var w,x,W;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let B=class Wi extends C.Disposable{constructor(V,Q,ne,ce,Z,oe,ve,Ae,Se,Ne){super();this._onDidChangeRemoteConnectionData=this._register(new g.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Q,this._extHostContext=ne,this._initData=ve,this._extHostWorkspace=ce,this._extHostConfiguration=Z,this._logService=oe,this._extHostTunnelService=Se,this._extHostTerminalService=Ne,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(b.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(b.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(b.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._registry=new D.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new F.ExtHostSecretState(this._extHostContext),this._storagePath=Ae,this._instaService=V.createChild(new m.ServiceCollection([o.IExtHostStorage,this._storage],[F.IExtHostSecretState,this._secretState]));const We=new Set;this._initData.hostExtensions.forEach(je=>We.add(a.ExtensionIdentifier.toKey(je))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(je,qe,$)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(je,_.transformErrorForSerialization(qe),$)},actualActivateExtension:async(je,qe)=>{if(We.has(a.ExtensionIdentifier.toKey(je)))return await this._mainThreadExtensionsProxy.$activateExtension(je,qe),new f.HostExtension;const $=this._registry.getExtensionDescription(je);return this._activateExtension($,qe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),E.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(V){_.onUnexpectedError(V)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let V=[];try{V=this._registry.getAllExtensionDescriptions().map(Z=>Z.identifier).filter(Z=>this.isActivated(Z)).map(Z=>this._deactivate(Z))}catch(Q){}await Promise.all(V)}isActivated(V){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(V):!1}_activateByEvent(V,Q){return this._activator.activateByEvent(V,Q)}_activateById(V,Q){return this._activator.activateById(V,Q)}activateByIdWithErrors(V,Q){return this._activateById(V,Q).then(()=>{const ne=this._activator.getActivatedExtension(V);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(V=>this._registry)}getExtensionExports(V){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(V).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const V=y.TernarySearchTree.forPaths(),Q=this._registry.getAllExtensionDescriptions().map(ne=>{if(!!this._getEntryPoint(ne))return this._hostUtils.realpath(ne.extensionLocation.fsPath).then(ce=>V.set(P.URI.file(ce).fsPath,ne))});this._extensionPathIndex=Promise.all(Q).then(()=>V)}return this._extensionPathIndex}_deactivate(V){let Q=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(V))return Q;const ne=this._activator.getActivatedExtension(V);if(!ne)return Q;try{typeof ne.module.deactivate=="function"&&(Q=Promise.resolve(ne.module.deactivate()).then(void 0,ce=>(this._logService.error(ce),Promise.resolve(void 0))))}catch(ce){this._logService.error(ce)}try{(0,C.dispose)(ne.subscriptions)}catch(ce){this._logService.error(ce)}return Q}async _activateExtension(V,Q){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier),this._doActivateExtension(V,Q).then(ne=>{const ce=ne.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(V.identifier,ce.codeLoadingTime,ce.activateCallTime,ce.activateResolvedTime,Q),this._logExtensionActivationTimes(V,Q,"success",ce),ne},ne=>{throw this._logExtensionActivationTimes(V,Q,"failure"),ne})}_logExtensionActivationTimes(V,Q,ne,ce){const Z=G(V,Q);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Z,...ce||{},outcome:ne})}_doActivateExtension(V,Q){const ne=G(V,Q);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ne);const ce=this._getEntryPoint(V);if(!ce)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${V.identifier.value}, startup: ${Q.startup}, activationEvent: '${Q.activationEvent}'${V.identifier.value!==Q.extensionId.value?`, root cause: ${Q.extensionId.value}`:""}`),this._logService.flush();const Z=new f.ExtensionActivationTimesBuilder(Q.startup);return Promise.all([this._loadCommonJSModule(V.identifier,(0,A.joinPath)(V.extensionLocation,ce),Z),this._loadExtensionContext(V)]).then(oe=>(E.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),Wi._callActivate(this._logService,V.identifier,oe[0],oe[1],Z))).then(oe=>(E.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),oe))}_loadExtensionContext(V){const Q=new S.ExtensionGlobalMemento(V,this._storage),ne=new S.ExtensionMemento(V.identifier.value,!1,this._storage),ce=new L.ExtensionSecrets(V,this._secretState),Z=V.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,oe=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([Q.whenReady,ne.whenReady,this._storagePath.whenReady]).then(()=>{const ve=this;let Ae;return Object.freeze({globalState:Q,workspaceState:ne,secrets:ce,subscriptions:[],get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(Se){return M.join(V.extensionLocation.fsPath,Se)},get storagePath(){return ve._storagePath.workspaceValue(V)?.fsPath},get globalStoragePath(){return ve._storagePath.globalValue(V).fsPath},get logPath(){return M.join(ve._initData.logsLocation.fsPath,V.identifier.value)},get logUri(){return P.URI.joinPath(ve._initData.logsLocation,V.identifier.value)},get storageUri(){return ve._storagePath.workspaceValue(V)},get globalStorageUri(){return ve._storagePath.globalValue(V)},get extensionMode(){return Z},get extension(){return Ae===void 0&&(Ae=new H(ve,V.identifier,V,oe)),Ae},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(V),ve.extensionRuntime},get environmentVariableCollection(){return ve._extHostTerminalService.getEnvironmentVariableCollection(V)}})})}static _callActivate(V,Q,ne,ce,Z){return ne=ne||{activate:void 0,deactivate:void 0},this._callActivateOptional(V,Q,ne,ce,Z).then(oe=>new f.ActivatedExtension(!1,null,Z.build(),ne,oe,ce.subscriptions))}static _callActivateOptional(V,Q,ne,ce,Z){if(typeof ne.activate=="function")try{Z.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${Q.value}`);const oe=typeof global=="object"?global:self,ve=ne.activate.apply(oe,[ce]);return Z.activateCallStop(),Z.activateResolveStart(),Promise.resolve(ve).then(Ae=>(Z.activateResolveStop(),Ae))}catch(oe){return Promise.reject(oe)}else return Promise.resolve(ne)}_activateOneStartupFinished(V,Q){this._activateById(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:Q}).then(void 0,ne=>{this._logService.error(ne)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(E.getMarks());for(const V of this._registry.getAllExtensionDescriptions())if(V.activationEvents)for(const Q of V.activationEvents)Q==="onStartupFinished"&&this._activateOneStartupFinished(V,Q)}_handleEagerExtensions(){const V=this._activateByEvent("*",!0).then(void 0,Z=>{this._logService.error(Z)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Z=>this._handleWorkspaceContainsEagerExtensions(Z.added)));const Q=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ne=this._handleWorkspaceContainsEagerExtensions(Q),ce=Promise.all([V,ne]).then(()=>{});return Promise.race([ce,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ce}_handleWorkspaceContainsEagerExtensions(V){return V.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Q=>this._handleWorkspaceContainsEagerExtension(V,Q))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(V,Q){if(this.isActivated(Q.identifier))return;const ne=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ce={folders:V.map(oe=>oe.uri),forceUsingSearch:ne,exists:oe=>this._hostUtils.exists(oe.fsPath),checkExists:(oe,ve,Ae)=>this._mainThreadWorkspaceProxy.$checkExists(oe,ve,Ae)},Z=await(0,I.checkActivateWorkspaceContainsExtension)(ce,Q);if(!!Z)return this._activateById(Q.identifier,{startup:!0,extensionId:Q.identifier,activationEvent:Z.activationEvent}).then(void 0,oe=>this._logService.error(oe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(V){throw console.error(V),V}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:Q}=this._initData.environment;if(!V||!Q)throw new Error(c.localize(0,null));const ne=await this._loadCommonJSModule(null,Q,new f.ExtensionActivationTimesBuilder(!1));if(!ne||typeof ne.run!="function")throw new Error(c.localize(1,null,Q.toString()));return new Promise((ce,Z)=>{const oe=(Se,Ne)=>{Se?Z(Se):ce(typeof Ne=="number"&&Ne>0?1:0)},ve=(0,A.originalFSPath)(Q),Ae=ne.run(ve,oe);Ae&&Ae.then&&Ae.then(()=>{ce(0)}).catch(Se=>{Z(Se.toString())})})}async $extensionTestsExit(V){this._logService.info(`extension host terminating: test runner requested exit with code ${V}`),this._logService.info(`exiting with code ${V}`),this._logService.flush(),this._hostUtils.exit(V)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(V,Q){return this._resolvers[V]=Q,(0,C.toDisposable)(()=>{delete this._resolvers[V]})}async _activateAndGetResolver(V){const Q=V.indexOf("+");if(Q===-1)throw new Error("Not an authority that can be resolved!");const ne=V.substr(0,Q);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this._resolvers[ne]}}async $resolveAuthority(V,Q){const{authorityPrefix:ne,resolver:ce}=await this._activateAndGetResolver(V);if(!ce)return{type:"error",error:{code:p.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ne}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(ce)),E.mark(`code/extHost/willResolveAuthority/${ne}`);const Z=await ce.resolve(V,{resolveAttempt:Q});E.mark(`code/extHost/didResolveAuthorityOK/${ne}`);const oe={authority:V,host:Z.host,port:Z.port,connectionToken:Z.connectionToken},ve={extensionHostEnv:Z.extensionHostEnv,isTrusted:Z.isTrusted};return{type:"ok",value:{authority:oe,options:ve,tunnelInformation:{environmentTunnels:Z.environmentTunnels}}}}catch(Z){if(E.mark(`code/extHost/didResolveAuthorityError/${ne}`),Z instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:Z._code,message:Z._message,detail:Z._detail}};throw Z}}async $getCanonicalURI(V,Q){const{authorityPrefix:ne,resolver:ce}=await this._activateAndGetResolver(V);if(!ce)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ne}`);const Z=P.URI.revive(Q);if(typeof ce.getCanonicalURI=="undefined")return Z;const oe=await(0,R.asPromise)(()=>ce.getCanonicalURI(Z));return oe||Z}$startExtensionHost(V){return this._registry.keepOnly(V),this._startExtensionHost()}$activateByEvent(V,Q){return Q===1?this._activateByEvent(V,!1):this._readyToRunExtensions.wait().then(ne=>this._activateByEvent(V,!1))}async $activate(V,Q){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(V)?(await this._activateById(V,Q),!0):!1}async $deltaExtensions(V,Q){V.forEach(ce=>ce.extensionLocation=P.URI.revive(ce.extensionLocation));const ne=await this.getExtensionPathIndex();return await Promise.all(Q.map(async ce=>{const Z=this._registry.getExtensionDescription(ce);if(!Z)return;const oe=await this._hostUtils.realpath(Z.extensionLocation.fsPath);ne.delete(P.URI.file(oe).fsPath)})),await Promise.all(V.map(async ce=>{const Z=await this._hostUtils.realpath(ce.extensionLocation.fsPath);ne.set(P.URI.file(Z).fsPath,ce)})),this._registry.deltaExtensions(V,Q),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){let Q=d.VSBuffer.alloc(V),ne=Math.random()%256;for(let ce=0;ce<V;ce++)Q.writeUInt8(ne,ce);return Q}async $updateRemoteConnectionData(V){this._remoteConnectionData=V,this._onDidChangeRemoteConnectionData.fire()}};B=$e([Ve(0,r.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,h.IExtHostRpcService),Ve(3,l.IExtHostWorkspace),Ve(4,n.IExtHostConfiguration),Ve(5,t.ILogService),Ve(6,s.IExtHostInitDataService),Ve(7,u.IExtensionStoragePaths),Ve(8,k.IExtHostTunnelService),Ve(9,T.IExtHostTerminalService)],B),e.AbstractExtHostExtensionService=B;function G(U,V){return{id:U.identifier.value,name:U.name,extensionVersion:U.version,publisherDisplayName:U.publisher,activationEvents:U.activationEvents?U.activationEvents.join(","):null,isBuiltin:U.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class H{constructor(V,Q,ne,ce){w.set(this,void 0),x.set(this,void 0),W.set(this,void 0),et(this,w,V,"f"),et(this,x,Q,"f"),et(this,W,ne.identifier,"f"),this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=M.normalize((0,A.originalFSPath)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=ce}get isActive(){return Fe(this,w,"f").isActivated(Fe(this,W,"f"))}get exports(){if(this.packageJSON.api!=="none")return Fe(this,w,"f").getExtensionExports(Fe(this,W,"f"))}activate(){return Fe(this,w,"f").activateByIdWithErrors(Fe(this,W,"f"),{startup:!1,extensionId:Fe(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=H,w=new WeakMap,x=new WeakMap,W=new WeakMap}),define(be[100],Ee([0,1,17,2,3,14,5,7,163,31,33,49,168,32,164,12,4,10,91,70]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o,l,v,D,_,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let d=class{constructor(m,k,T,g,I,F){this._workspaceService=k,this._extensionService=T,this._editorsService=g,this._configurationService=I,this._editorTabs=F,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new E.Emitter,this._onDidTerminateDebugSession=new E.Emitter,this._onDidChangeActiveDebugSession=new E.Emitter,this._onDidReceiveDebugSessionCustomEvent=new E.Emitter,this._debugServiceProxy=m.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new E.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(L=>{L.onDidChange(w=>{this.registerAllDebugTypes(L)}),this.registerAllDebugTypes(L)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(m,k){const T=m;if(typeof T.sourceReference=="number"&&T.sourceReference>0){let g=`debug:${encodeURIComponent(T.path||"")}`,I="?";return k&&(g+=`${I}session=${encodeURIComponent(k.id)}`,I="&"),g+=`${I}ref=${T.sourceReference}`,M.URI.parse(g)}else{if(T.path)return M.URI.file(T.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const k=[];for(const T of m.getAllExtensionDescriptions())if(T.contributes){const g=T.contributes.debuggers;if(g&&g.length>0)for(const I of g)(0,o.isDebuggerMainContribution)(I)&&k.push(I.type)}this._debugServiceProxy.$registerDebugTypes(k)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const m=[];return this._breakpoints.forEach(k=>m.push(k)),m}addBreakpoints(m){this.startBreakpoints();const k=m.filter(I=>{const F=I.id;return this._breakpoints.has(F)?!1:(this._breakpoints.set(F,I),!0)});this.fireBreakpointChanges(k,[],[]);const T=[],g=new Map;for(const I of k)if(I instanceof C.SourceBreakpoint){let F=g.get(I.location.uri.toString());F||(F={type:"sourceMulti",uri:I.location.uri,lines:[]},g.set(I.location.uri.toString(),F),T.push(F)),F.lines.push({id:I.id,enabled:I.enabled,condition:I.condition,hitCondition:I.hitCondition,logMessage:I.logMessage,line:I.location.range.start.line,character:I.location.range.start.character})}else I instanceof C.FunctionBreakpoint&&T.push({type:"function",id:I.id,enabled:I.enabled,hitCondition:I.hitCondition,logMessage:I.logMessage,condition:I.condition,functionName:I.functionName});return this._debugServiceProxy.$registerBreakpoints(T)}removeBreakpoints(m){this.startBreakpoints();const k=m.filter(F=>this._breakpoints.delete(F.id));this.fireBreakpointChanges([],k,[]);const T=k.filter(F=>F instanceof C.SourceBreakpoint).map(F=>F.id),g=k.filter(F=>F instanceof C.FunctionBreakpoint).map(F=>F.id),I=k.filter(F=>F instanceof C.DataBreakpoint).map(F=>F.id);return this._debugServiceProxy.$unregisterBreakpoints(T,g,I)}startDebugging(m,k,T){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,k,{parentSessionID:T.parentSession?T.parentSession.id:void 0,lifecycleManagedByParent:T.lifecycleManagedByParent,repl:T.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:T.noDebug,compact:T.compact,debugUI:T.debugUI,suppressSaveBeforeStart:T.suppressSaveBeforeStart})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,k,T){if(!k)return new C.Disposable(()=>{});const g=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:g,provider:k}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,T,!!k.provideDebugConfigurations,!!k.resolveDebugConfiguration,!!k.resolveDebugConfigurationWithSubstitutedVariables,g),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(I=>I.provider!==k),this._debugServiceProxy.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(m,k,T){if(!T)return new C.Disposable(()=>{});if(!this.definesDebugType(m,k))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${k}' debugger.`);if(this.getAdapterDescriptorFactoryByType(k))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:k,handle:g,factory:T}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(k,g),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(I=>I.factory!==T),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(m,k){if(!k)return new C.Disposable(()=>{});const T=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:T,factory:k}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(g=>g.factory!==k)})}async $runInTerminal(m,k){return Promise.resolve(void 0)}async $substituteVariables(m,k){if(!this._variableResolver){const[I,F]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(I||[],this._editorsService,F)}let T;const g=await this.getFolder(m);return g&&(T={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(T,k)}createDebugAdapter(m,k){if(m.type==="implementation")return new s(m.implementation)}createSignService(){}async $startDASession(m,k){const T=this,g=await this.getSession(k);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(g.type),g).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const F=this.convertToDto(I),L=this.createDebugAdapter(F,g);if(!L)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const w=L;return this._debugAdapters.set(m,w),this.getDebugAdapterTrackers(g).then(x=>(x&&this._debugAdaptersTrackers.set(m,x),w.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const B=W,G={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const H=await this._signService.sign(B.arguments.value);G.body={signature:H},w.sendResponse(G)}else throw new Error("no signer")}catch(H){G.success=!1,G.message=H.message,w.sendResponse(G)}}else x&&x.onDidSendMessage&&x.onDidSendMessage(W),W=(0,o.convertToVSCPaths)(W,!0),T._debugServiceProxy.$acceptDAMessage(m,W)}),w.onError(W=>{x&&x.onError&&x.onError(W),this._debugServiceProxy.$acceptDAError(m,W.name,W.message,W.stack)}),w.onExit(W=>{x&&x.onExit&&x.onExit((0,D.withNullAsUndefined)(W),void 0),this._debugServiceProxy.$acceptDAExit(m,(0,D.withNullAsUndefined)(W),void 0)}),x&&x.onWillStartSession&&x.onWillStartSession(),w.startSession()))})}$sendDAMessage(m,k){k=(0,o.convertToDAPaths)(k,!1);const T=this._debugAdaptersTrackers.get(m);T&&T.onWillReceiveMessage&&T.onWillReceiveMessage(k);const g=this._debugAdapters.get(m);g&&g.sendMessage(k)}$stopDASession(m){const k=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),k&&k.onWillStopSession&&k.onWillStopSession();const T=this._debugAdapters.get(m);return this._debugAdapters.delete(m),T?T.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const k=[],T=[],g=[];if(m.added)for(const I of m.added){const F=I.id;if(F&&!this._breakpoints.has(F)){let L;if(I.type==="function")L=new C.FunctionBreakpoint(I.functionName,I.enabled,I.condition,I.hitCondition,I.logMessage);else if(I.type==="data")L=new C.DataBreakpoint(I.label,I.dataId,I.canPersist,I.enabled,I.hitCondition,I.condition,I.logMessage);else{const w=M.URI.revive(I.uri);L=new C.SourceBreakpoint(new C.Location(w,new C.Position(I.line,I.character)),I.enabled,I.condition,I.hitCondition,I.logMessage)}L._id=F,this._breakpoints.set(F,L),k.push(L)}}if(m.removed)for(const I of m.removed){const F=this._breakpoints.get(I);F&&(this._breakpoints.delete(I),T.push(F))}if(m.changed){for(const I of m.changed)if(I.id){const F=this._breakpoints.get(I.id);if(F){if(F instanceof C.FunctionBreakpoint&&I.type==="function"){const L=F;L.enabled=I.enabled,L.condition=I.condition,L.hitCondition=I.hitCondition,L.logMessage=I.logMessage,L.functionName=I.functionName}else if(F instanceof C.SourceBreakpoint&&I.type==="source"){const L=F;L.enabled=I.enabled,L.condition=I.condition,L.hitCondition=I.hitCondition,L.logMessage=I.logMessage,L.location=new C.Location(M.URI.revive(I.uri),new C.Position(I.line,I.character))}g.push(F)}}}this.fireBreakpointChanges(k,T,g)}$provideDebugConfigurations(m,k,T){return(0,A.asPromise)(async()=>{const g=this.getConfigProviderByHandle(m);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const I=await this.getFolder(k);return g.provideDebugConfigurations(I,T)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(m,k,T,g){return(0,A.asPromise)(async()=>{const I=this.getConfigProviderByHandle(m);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.getFolder(k);return I.resolveDebugConfiguration(F,T,g)})}$resolveDebugConfigurationWithSubstitutedVariables(m,k,T,g){return(0,A.asPromise)(async()=>{const I=this.getConfigProviderByHandle(m);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.getFolder(k);return I.resolveDebugConfigurationWithSubstitutedVariables(F,T,g)})}async $provideDebugAdapter(m,k){const T=this.getAdapterDescriptorFactoryByHandle(m);if(!T)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.getSession(k);return this.getAdapterDescriptor(T,g).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.convertToDto(I)})}async $acceptDebugSessionStarted(m){const k=await this.getSession(m);this._onDidStartDebugSession.fire(k)}async $acceptDebugSessionTerminated(m){const k=await this.getSession(m);k&&(this._onDidTerminateDebugSession.fire(k),this._debugSessions.delete(k.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(m,k){const T=await this.getSession(m);T&&T._acceptNameChanged(k)}async $acceptDebugSessionCustomEvent(m,k){const g={session:await this.getSession(m),event:k.event,body:k.body};this._onDidReceiveDebugSessionCustomEvent.fire(g)}convertToDto(m){if(m instanceof C.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof C.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const k=this._adapterFactories.filter(T=>T.type===m);if(k.length>0)return k[0].factory}getAdapterDescriptorFactoryByHandle(m){const k=this._adapterFactories.filter(T=>T.handle===m);if(k.length>0)return k[0].factory}getConfigProviderByHandle(m){const k=this._configProviders.filter(T=>T.handle===m);if(k.length>0)return k[0].provider}definesDebugType(m,k){if(m.contributes){const T=m.contributes.debuggers;if(T&&T.length>0){for(const g of T)if(g.label&&g.type&&g.type===k)return!0}}return!1}getDebugAdapterTrackers(m){const T=m.configuration.type,g=this._trackerFactories.filter(I=>I.type===T||I.type==="*").map(I=>(0,A.asPromise)(()=>I.factory.createDebugAdapterTracker(m)).then(F=>F,F=>null));return Promise.race([Promise.all(g).then(I=>{const F=I.filter(L=>!!L);if(F.length>0)return new r(F)}),new Promise((I,F)=>{const L=setTimeout(()=>{clearTimeout(L),F(new Error("timeout"))},1e3)})]).catch(I=>{})}async getAdapterDescriptor(m,k){const T=k.configuration.debugServer;if(typeof T=="number")return Promise.resolve(new C.DebugAdapterServer(T));if(m){const I=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>m.createDebugAdapterDescriptor(k,this.daExecutableFromPackage(k,I))).then(F=>{if(F)return F})}const g=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(k,g))}daExecutableFromPackage(m,k){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(m,k,T){(m.length>0||k.length>0||T.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:k,changed:T}))}async getSession(m){if(m)if(typeof m=="string"){const k=this._debugSessions.get(m);if(k)return k}else{let k=this._debugSessions.get(m.id);if(!k){const T=await this.getFolder(m.folderUri),g=m.parent?this._debugSessions.get(m.parent):void 0;k=new S(this._debugServiceProxy,m.id,m.type,m.name,T,m.configuration,g),this._debugSessions.set(k.id,k),this._debugServiceProxy.$sessionCached(k.id)}return k}throw new Error("cannot find session")}getFolder(m){if(m){const k=M.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(k)}return Promise.resolve(void 0)}};d=$e([Ve(0,l.IExtHostRpcService),Ve(1,P.IExtHostWorkspace),Ve(2,t.IExtHostExtensionService),Ve(3,b.IExtHostDocumentsAndEditors),Ve(4,f.IExtHostConfiguration),Ve(5,a.IExtHostEditorTabs)],d),e.ExtHostDebugServiceBase=d;class S{constructor(m,k,T,g,I,F,L){this._debugServiceProxy=m,this._id=k,this._type=T,this._name=g,this._workspaceFolder=I,this._configuration=F,this._parentSession=L}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(m){this._name=m,this._debugServiceProxy.$setDebugSessionName(this._id,m)}get parentSession(){return this._parentSession}_acceptNameChanged(m){this._name=m}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(m,k){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,m,k)}getDebugProtocolBreakpoint(m){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,m.id)}}e.ExtHostDebugSession=S;class i{constructor(m){this.value=Object.freeze({append(k){m.$appendDebugConsole(k)},appendLine(k){this.append(k+`
`)}})}}e.ExtHostDebugConsole=i;class p extends n.AbstractVariableResolverService{constructor(m,k,T,g,I){function F(){if(k){const L=k.activeEditor();if(L)return L.document.uri;const w=g.tabs.filter(x=>x.isActive);if(w.length>0){const x=w[0].resource;return x&&(x.primary||x.secondary)?x.primary??x.secondary:w[0].resource}}}super({getFolderUri:L=>{const w=m.filter(x=>x.name===L);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>m.length,getConfigurationValue:(L,w)=>T.getConfiguration(void 0,L).get(w),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{const L=F();if(L)return c.normalize(L.fsPath)},getWorkspaceFolderPathForFile:()=>{if(I){const L=F();if(L){const w=I.getWorkspaceFolder(L);if(w)return c.normalize(w.uri.fsPath)}}},getSelectedText:()=>{if(k){const L=k.activeEditor();if(L&&!L.selection.isEmpty)return L.document.getText(L.selection)}},getLineNumber:()=>{if(k){const L=k.activeEditor();if(L)return String(L.selection.end.line+1)}}},void 0,Promise.resolve(_.env))}}e.ExtHostVariableResolverService=p;class r{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(k=>k.onWillReceiveMessage?k.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(k=>k.onDidSendMessage?k.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(k=>k.onError?k.onError(m):void 0)}onExit(m,k){this.trackers.forEach(T=>T.onExit?T.onExit(m,k):void 0)}}class s extends y.AbstractDebugAdapter{constructor(m){super();this.implementation=m,m.onDidSendMessage(k=>{this.acceptMessage(k)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends d{constructor(m,k,T,g,I,F){super(m,k,T,g,I,F)}createVariableResolver(m,k,T){return new p(m,k,T,this._editorTabs)}};u=$e([Ve(0,l.IExtHostRpcService),Ve(1,P.IExtHostWorkspace),Ve(2,t.IExtHostExtensionService),Ve(3,b.IExtHostDocumentsAndEditors),Ve(4,f.IExtHostConfiguration),Ve(5,a.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(be[219],Ee([0,1,74,2,5,32,30,26,12,29,4,33,91,15]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(a,d,S,i,p,r,s){this._apiFactory=a,this._extensionRegistry=d,this._instaService=S,this._extHostConfiguration=i,this._extHostExtensionService=p,this._initData=r,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),c.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new l(this._apiFactory,d,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(D,d,this._initData.environment.appUriScheme))}register(a){if(Array.isArray(a.nodeModuleName))for(let d of a.nodeModuleName)this._factories.set(d,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(d=>a.alternativeModuleName(d))}};o=$e([Ve(2,t.IInstantiationService),Ve(3,A.IExtHostConfiguration),Ve(4,b.IExtHostExtensionService),Ve(5,P.IExtHostInitDataService),Ve(6,f.ILogService)],o),e.RequireInterceptor=o;class l{constructor(a,d,S,i,p){this._apiFactory=a,this._extensionPaths=d,this._extensionRegistry=S,this._configProvider=i,this._logService=p,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(a,d){const S=this._extensionPaths.findSubstr(d.fsPath);if(S){let i=this._extApiImpl.get(C.ExtensionIdentifier.toKey(S.identifier));return i||(i=this._apiFactory(S,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(S.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((p,r)=>i+=`	${r} -> ${p.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d.fsPath}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(a,d){this.nodeModuleName="keytar";const{environment:S}=d,i=a.getProxy(E.MainContext.MainThreadKeytar);if(S.appRoot){let p=S.appRoot.fsPath;n.platform==="win32"&&(p=p.replace(/\\/g,"/")),p[p.length-1]==="/"&&(p=p.substr(0,p.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${p}/node_modules.asar/keytar`),this.alternativeNames.add(`${p}/node_modules/keytar`)}this._impl={getPassword:(p,r)=>i.$getPassword(p,r),setPassword:(p,r,s)=>i.$setPassword(p,r,s),deletePassword:(p,r)=>i.$deletePassword(p,r),findPassword:p=>i.$findPassword(p),findCredentials(p){return i.$findCredentials(p)}}}load(a,d){return this._impl}alternativeModuleName(a){const d=a.length;if(d<=7||!this.alternativeNames)return;const S=d-7;if((a.charAt(S)==="/"||a.charAt(S)==="\\")&&a.endsWith("keytar")&&(a=a.replace(/\\/g,"/"),this.alternativeNames.has(a)))return"keytar"}};v=$e([Ve(0,y.IExtHostRpcService),Ve(1,P.IExtHostInitDataService)],v);let D=class{constructor(a,d,S){this._extensionPaths=a,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=S.getProxy(E.MainContext.MainThreadTelemetry);const i=S.getProxy(E.MainContext.MainThreadWindow);this._impl=(p,r)=>{const s=M.URI.parse(p);return r?this.callOriginal(p,r):s.scheme==="http"||s.scheme==="https"?i.$openUri(s,p,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?i.$openUri(s,p,{}):this.callOriginal(p,r)}}load(a,d,S){const i=this._extensionPaths.findSubstr(d.fsPath);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=S(a),this._impl}callOriginal(a,d){return this.sendNoForwardTelemetry(),this._original(a,d)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};D=$e([Ve(2,y.IExtHostRpcService)],D)}),define(be[220],Ee([0,1,14,16,74,6,2,5,213,15,57,61,29,144,12,65,33,40]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o,l,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(d,S,i,p){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new y.RPCProtocol(d,null,p),S=_._transform(S,this._rpcProtocol);const r=new b.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...S}),r.set(o.IExtHostRpcService,new o.ExtHostRpcService(this._rpcProtocol)),r.set(l.IURITransformerService,new l.URITransformerService(p)),r.set(v.IHostUtils,i);const s=new f.InstantiationService(r,!0),u=s.invokeFunction(T=>T.get(D.IExtHostTerminalService));this._disposables.add(u),this._logService=s.invokeFunction(T=>T.get(P.ILogService)),E.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",S),this._extensionService=s.invokeFunction(T=>T.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const h=new WeakMap;this._extensionService.getExtensionPathIndex().then(T=>{Error.prepareStackTrace=(g,I)=>{let F="",L,w;for(const x of I)F+=`
	at ${x.toString()}`,w=x.getFileName(),!L&&w&&(L=T.findSubstr(w));return h.set(g,L),`${g.name||"Error"}: ${g.message||""}${F}`}});const m=this._rpcProtocol.getProxy(C.MainContext.MainThreadExtensionService),k=this._rpcProtocol.getProxy(C.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(T=>{const g=M.transformErrorForSerialization(T),I=h.get(T);I?m.$onExtensionRuntimeError(I.identifier,g):k.$onUnexpectedError(g)})}terminate(d){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${d}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const S=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,c.timeout)(4e3),S]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(d,S){d.extensions.forEach(p=>p.extensionLocation=R.URI.revive(S.transformIncomingURIs(p.extensionLocation))),d.environment.appRoot=R.URI.revive(S.transformIncomingURIs(d.environment.appRoot));const i=d.environment.extensionDevelopmentLocationURI;return i&&(d.environment.extensionDevelopmentLocationURI=i.map(p=>R.URI.revive(S.transformIncomingURIs(p)))),d.environment.extensionTestsLocationURI=R.URI.revive(S.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=R.URI.revive(S.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=R.URI.revive(S.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=R.URI.revive(S.transformIncomingURIs(d.logsLocation)),d.logFile=R.URI.revive(S.transformIncomingURIs(d.logFile)),d.workspace=S.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=_}),define(be[221],Ee([0,1,17,21,56,27,24,194,41]),function(re,e,c,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(n,f,o){this.config=n,this.provider=f,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&A.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&A.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const f=this.config.folderQueries||[];return new Promise((o,l)=>{const v=D=>{this.resultCount++,n(D)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(D=>{const _=D.toString(),a=c.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,a)||this.matchFile(v,{base:D,basename:a})}),Promise.all(f.map(D=>this.searchInFolder(D,v))).then(D=>{o({limitHit:this.isLimitHit,stats:D[0]||void 0})},D=>{l(new Error((0,E.toErrorMessage)(D)))})})}async searchInFolder(n,f){const o=new M.CancellationTokenSource,l=this.getSearchOptionsForFolder(n),v=this.initDirectoryTree(),D=new y.QueryGlobTester(this.config,n),_=!D.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(o),a=C.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},l,o.token),S=a.elapsed(),i=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(p=>{const r=c.posix.relative(n.folder.path,p.path);if(_){const s=c.basename(p.path);this.matchFile(f,{base:n.folder,relativePath:r,basename:s});return}this.addDirectoryEntries(v,n.folder,r,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,D,f),{providerTime:S,postProcessTime:i.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(n){const f=(0,y.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),o=(0,y.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:o,includes:f,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},f,o,l){if(o===this.filePattern){const D=c.basename(this.filePattern);this.matchFile(l,{base:f,relativePath:this.filePattern,basename:D})}function v(D){const _=c.basename(D),a=c.dirname(D);let d=n[a];d||(d=n[a]=[],v(a)),d.push({base:f,relativePath:D,basename:_})}v(o)}matchDirectoryTree({rootEntries:n,pathToEntries:f},o,l){const v=this,D=this.filePattern;function _(a){const d=A.hasSiblingFn(()=>a.map(S=>S.basename));for(let S=0,i=a.length;S<i;S++){const p=a[S],{relativePath:r,basename:s}=p;if(o.matchesExcludesSync(r,s,D!==s?d:void 0))continue;const u=f[r];if(u)_(u);else{if(r===D)continue;v.matchFile(l,p)}if(v.isLimitHit)break}}_(n)}matchFile(n,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(f))}}class t{constructor(){this.sessions=new Map}fileSearch(n,f,o,l){const v=this.getSessionTokenSource(n.cacheKey),D=new P(n,f,v&&v.token);let _=0;const a=d=>{_+=d.length,o(d.map(S=>this.rawMatchToSearchItem(S)))};return this.doSearch(D,t.BATCH_SIZE,a,l).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:d.stats}}))}clearCache(n){const f=this.getSessionTokenSource(n);f&&f.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:R.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,f,o,l){l.onCancellationRequested(()=>{n.cancel()});const v=_=>{_&&(D.push(_),f>0&&D.length>=f&&(o(D),D=[]))};let D=[];return n.search(v).then(_=>(D.length&&o(D),_),_=>(D.length&&o(D),Promise.reject(_)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(be[222],Ee([0,1,13,21,56,27,11,17,24,10,2,41]),function(re,e,c,M,E,A,R,C,y,P,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(a,d,S,i){this.query=a,this.provider=d,this.fileUtils=S,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,d){const S=this.query.folderQueries||[],i=new M.CancellationTokenSource;return d.onCancellationRequested(()=>i.cancel()),new Promise((p,r)=>{this.collector=new o(a);let s=!1;const u=(h,m)=>{if(!s&&!this.isLimitHit){const k=this.resultSize(h);v(h)&&typeof this.query.maxResults=="number"&&this.resultCount+k>this.query.maxResults&&(this.isLimitHit=!0,s=!0,i.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const T=this.resultSize(h);this.resultCount+=T,(T>0||!v(h))&&this.collector.add(h,m)}};Promise.all(S.map((h,m)=>this.searchInFolder(h,k=>u(k,m),i.token))).then(h=>{i.dispose(),this.collector.flush();const m=h.some(k=>!!k&&!!k.limitHit);p({limitHit:this.isLimitHit||m,messages:(0,c.flatten)(h.map(k=>k?.message?(0,P.isArray)(k.message)?k.message:[k.message]:[])),stats:{type:this.processType}})},h=>{i.dispose();const m=(0,E.toErrorMessage)(h);r(new Error(m))})})}resultSize(a){return v(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,d){const S=Array.isArray(a.ranges)?a.ranges:[a.ranges],i=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:S.slice(0,d),preview:{matches:i.slice(0,d),text:a.preview.text},uri:a.uri}}async searchInFolder(a,d,S){const i=new b.QueryGlobTester(this.query,a),p=[],r={report:h=>{if(!this.validateProviderResult(h))return;const m=a.folder.scheme===R.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(h.uri))):void 0,k=y.relativePath(a.folder,h.uri);if(k){const T=i.includedInQuery(k,C.basename(k),m);(0,P.isPromise)(T)?p.push(T.then(g=>{g&&d(h)})):T&&d(h)}}},s=this.getSearchOptionsForFolder(a),u=await this.provider.provideTextSearchResults(f(this.query.contentPattern),s,r,S);return p.length&&await Promise.all(p),u}validateProviderResult(a){if(v(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const d=(0,b.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),S=(0,b.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),i={folder:t.URI.from(a.folder),excludes:S,includes:d,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function f(_){return{isCaseSensitive:_.isCaseSensitive||!1,isRegExp:_.isRegExp||!1,isWordMatch:_.isWordMatch||!1,isMultiline:_.isMultiline||!1,pattern:_.pattern}}class o{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new D(512,d=>this.sendItems(d))}add(a,d){this._currentFileMatch&&(this._currentFolderIdx!==d||!y.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=d,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(l(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=o;function l(_){return v(_)?{preview:{matches:(0,c.mapArrayOrNot)(_.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:_.preview.text},ranges:(0,c.mapArrayOrNot)(_.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:_.text,lineNumber:_.lineNumber}}function v(_){return!!_.preview}e.extensionResultIsMatch=v;class D{constructor(a,d){this.maxBatchSize=a,this.cb=d,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,d){!a||this.addItemToBatch(a,d)}addItems(a,d){!a||this.addItemsToBatch(a,d)}addItemToBatch(a,d){this.batch.push(a),this.batchSize+=d,this.onUpdate()}addItemsToBatch(a,d){this.batch=this.batch.concat(a),this.batchSize+=d,this.onUpdate()}onUpdate(){this.totalNumberCompleted<D.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},D.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=D,D.TIMEOUT=4e3,D.START_BATCH_AFTER_COUNT=50}),define(be[101],Ee([0,1,6,5,4,221,12,65,15,2,222]),function(re,e,c,M,E,A,R,C,y,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,E.createDecorator)("IExtHostSearch");let b=class{constructor(l,v,D){this.extHostRpc=l,this._uriTransformer=v,this._logService=D,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}registerTextSearchProvider(l,v){if(this._textSearchUsedSchemes.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this._textSearchUsedSchemes.add(l);const D=this._handlePool++;return this._textSearchProvider.set(D,v),this._proxy.$registerTextSearchProvider(D,this._transformScheme(l)),(0,c.toDisposable)(()=>{this._textSearchUsedSchemes.delete(l),this._textSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}registerFileSearchProvider(l,v){if(this._fileSearchUsedSchemes.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this._fileSearchUsedSchemes.add(l);const D=this._handlePool++;return this._fileSearchProvider.set(D,v),this._proxy.$registerFileSearchProvider(D,this._transformScheme(l)),(0,c.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(l),this._fileSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}$provideFileSearchResults(l,v,D,_){const a=n(D),d=this._fileSearchProvider.get(l);if(d)return this._fileSearchManager.fileSearch(a,d,S=>{this._proxy.$handleFileMatch(l,v,S.map(i=>i.resource))},_);throw new Error("unknown provider: "+l)}$clearCache(l){return this._fileSearchManager.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,v,D,_){const a=this._textSearchProvider.get(l);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const d=n(D);return this.createTextSearchManager(d,a).search(i=>this._proxy.$handleTextMatch(l,v,i),_)}$enableExtensionHostSearch(){}createTextSearchManager(l,v){return new t.TextSearchManager(l,v,{readdir:D=>Promise.resolve([]),toCanonicalName:D=>D},"textSearchProvider")}};b=$e([Ve(0,R.IExtHostRpcService),Ve(1,C.IURITransformerService),Ve(2,y.ILogService)],b),e.ExtHostSearch=b;function n(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(f),extraFileResources:o.extraFileResources&&o.extraFileResources.map(l=>P.URI.revive(l))}}e.reviveQuery=n;function f(o){return{...o,folder:P.URI.revive(o.folder)}}}),define(be[223],Ee([0,1,21,16,3,35,2,117,79,113,55,60,5,184,183,39,185,32,186,187,188,170,189,49,33,190,171,193,195,196,96,173,201,202,203,72,40,205,174,8,7,208,50,97,31,30,51,160,192,86,95,99,100,101,15,65,12,29,197,157,64,69,181,206,156,73,71,211,209,210,182,37,204,207,68,70,87,199,98,200,11,146,198,154,191]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o,l,v,D,_,a,d,S,i,p,r,s,u,h,m,k,T,g,I,F,L,w,x,W,B,G,H,U,V,Q,ne,ce,Z,oe,ve,Ae,Se,Ne,We,je,qe,$,K,ee,ae,q,se,he,Re,Be,ze,Qe,it,ke,Ze,j,J,me,He,Ye,st,ot,Et,mt,Dt,Pt,It,Xe,St,Te,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ce(te){const le=te.get(ee.IExtHostInitDataService),ge=te.get(me.IExtHostFileSystemInfo),fe=te.get(it.IExtHostConsumerFileSystem),Pe=te.get(r.IExtHostExtensionService),xe=te.get(ne.IExtHostWorkspace),Oe=te.get(Et.IExtHostTelemetry),Ke=te.get(D.IExtHostConfiguration),tt=te.get($.IURITransformerService),Le=te.get(K.IExtHostRpcService),de=te.get(w.IExtHostStorage),pe=te.get(Qe.IExtensionStoragePaths),Y=te.get(qe.ILogService),z=te.get(se.IExtHostTunnelService),we=te.get(he.IExtHostApiDeprecationService),Ie=te.get(Q.IExtHostWindow),Je=te.get(st.IExtHostSecretState),Ue=te.get(ot.IExtHostEditorTabs);Le.set(n.ExtHostContext.ExtHostFileSystemInfo,ge),Le.set(n.ExtHostContext.ExtHostLogService,Y),Le.set(n.ExtHostContext.ExtHostWorkspace,xe),Le.set(n.ExtHostContext.ExtHostConfiguration,Ke),Le.set(n.ExtHostContext.ExtHostExtensionService,Pe),Le.set(n.ExtHostContext.ExtHostStorage,de),Le.set(n.ExtHostContext.ExtHostTunnelService,z),Le.set(n.ExtHostContext.ExtHostWindow,Ie),Le.set(n.ExtHostContext.ExtHostSecretState,Je),Le.set(n.ExtHostContext.ExtHostTelemetry,Oe),Le.set(n.ExtHostContext.ExtHostEditorTabs,Ue);const dt=Le.set(n.ExtHostContext.ExtHostDecorations,te.get(Se.IExtHostDecorations)),gt=Le.set(n.ExtHostContext.ExtHostDocumentsAndEditors,te.get(p.IExtHostDocumentsAndEditors)),lt=Le.set(n.ExtHostContext.ExtHostCommands,te.get(l.IExtHostCommands)),ft=Le.set(n.ExtHostContext.ExtHostTerminalService,te.get(x.IExtHostTerminalService)),ut=Le.set(n.ExtHostContext.ExtHostDebugService,te.get(We.IExtHostDebugService)),pt=Le.set(n.ExtHostContext.ExtHostSearch,te.get(je.IExtHostSearch)),bt=Le.set(n.ExtHostContext.ExtHostTask,te.get(Ne.IExtHostTask)),Ut=Le.set(n.ExtHostContext.ExtHostOutputService,te.get(T.IExtHostOutputService)),Vt=Le.set(n.ExtHostContext.ExtHostUrls,new U.ExtHostUrls(Le)),yt=Le.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(Le,gt)),$t=Le.set(n.ExtHostContext.ExtHostDocumentContentProviders,new d.ExtHostDocumentContentProvider(Le,gt,Y)),ei=Le.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new S.ExtHostDocumentSaveParticipant(Y,yt,Le.getProxy(n.MainContext.MainThreadBulkEdits))),vt=Le.set(n.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(Le,lt,gt,yt,pe)),Qt=Le.set(n.ExtHostContext.ExtHostNotebookDocuments,new Te.ExtHostNotebookDocuments(Y,vt)),jt=Le.set(n.ExtHostContext.ExtHostNotebookEditors,new St.ExtHostNotebookEditors(Y,Le,vt)),ti=Le.set(n.ExtHostContext.ExtHostNotebookKernels,new mt.ExtHostNotebookKernels(Le,le,vt,lt,Y)),ii=Le.set(n.ExtHostContext.ExtHostNotebookRenderers,new Pt.ExtHostNotebookRenderers(Le,vt)),Tt=Le.set(n.ExtHostContext.ExtHostEditors,new W.ExtHostEditors(Le,gt)),Yt=Le.set(n.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(Le.getProxy(n.MainContext.MainThreadTreeViews),lt,Y)),wi=Le.set(n.ExtHostContext.ExtHostEditorInsets,new oe.ExtHostEditorInsets(Le.getProxy(n.MainContext.MainThreadEditorInsets),Tt,le)),Wt=Le.set(n.ExtHostContext.ExtHostDiagnostics,new _.ExtHostDiagnostics(Le,Y,ge)),Ht=Le.set(n.ExtHostContext.ExtHostLanguages,new m.ExtHostLanguages(Le,yt,lt.converter,tt)),ht=Le.set(n.ExtHostContext.ExtHostLanguageFeatures,new h.ExtHostLanguageFeatures(Le,tt,yt,lt,Wt,Y,we)),ni=Le.set(n.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(Le,ht)),Ot=Le.set(n.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Le,Y,gt)),Nt=Le.set(n.ExtHostContext.ExtHostQuickOpen,(0,I.createExtHostQuickOpen)(Le,xe,lt)),Jt=Le.set(n.ExtHostContext.ExtHostSCM,new F.ExtHostSCM(Le,lt,Y)),bi=Le.set(n.ExtHostContext.ExtHostComments,(0,v.createExtHostComments)(Le,lt,yt)),hi=Le.set(n.ExtHostContext.ExtHostProgress,new g.ExtHostProgress(Le.getProxy(n.MainContext.MainThreadProgress))),Ei=Le.set(n.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(Le)),fi=Le.set(n.ExtHostContext.ExtHostTheming,new q.ExtHostTheming(Le)),ri=Le.set(n.ExtHostContext.ExtHostAuthentication,new Re.ExtHostAuthentication(Le)),si=Le.set(n.ExtHostContext.ExtHostTimeline,new Be.ExtHostTimeline(Le,lt)),qt=Le.set(n.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(Le,{remote:le.remote},xe,Y,we)),oi=Le.set(n.ExtHostContext.ExtHostWebviewPanels,new j.ExtHostWebviewPanels(Le,qt,xe)),_i=Le.set(n.ExtHostContext.ExtHostCustomEditors,new Ze.ExtHostCustomEditors(Le,yt,pe,qt,oi)),yi=Le.set(n.ExtHostContext.ExtHostWebviewViews,new ke.ExtHostWebviewViews(Le,qt)),Gt=Le.set(n.ExtHostContext.ExtHostTesting,new He.ExtHostTesting(Le,lt)),Xt=Le.set(n.ExtHostContext.ExtHostUriOpeners,new Ye.ExtHostUriOpeners(Le));Le.set(n.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(Le,vt,gt,lt));const Si=(0,Z.values)(n.ExtHostContext);Le.assertRegistered(Si);const Di=new J.ExtHostBulkEdits(Le,gt),ai=new o.ExtHostClipboard(Le),li=new k.ExtHostMessageService(Le,Y),zt=new a.ExtHostDialogs(Le),Mt=new L.ExtHostStatusBar(Le,lt.converter);return f.ExtHostApiCommands.register(lt),function(Me,Rt,Kt){const wt=function(){let X=!Me.isUnderDevelopment;function ue(De){X||(Y.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function De(rt){if(Array.isArray(rt))rt.forEach(De);else if(typeof rt=="string")ue(rt);else{const _t=rt;typeof _t.scheme=="undefined"&&ue(rt),!Me.enableProposedApi&&typeof _t.exclusive=="boolean"&&(0,ce.throwProposedApiError)(Me)}return rt}}(),Ci={getSession(X,ue,De){return De?.forceNewSession&&(0,ce.checkProposedApiEnabled)(Me),ri.getSession(Me,X,ue,De)},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(X,ue,De,rt){return ri.registerAuthenticationProvider(X,ue,De,rt)}},ki={registerCommand(X,ue,De){return lt.registerCommand(!0,X,ue,De)},registerTextEditorCommand(X,ue,De){return lt.registerCommand(!0,X,(...rt)=>{const _t=Tt.getActiveTextEditor();if(!_t){Y.warn("Cannot execute "+X+" because there is no active text editor.");return}return _t.edit(kt=>{ue.apply(De,[_t,kt,...rt])}).then(kt=>{kt||Y.warn("Edits from command "+X+" were not applied.")},kt=>{Y.warn("An error occurred while running command "+X,kt)})})},registerDiffInformationCommand:(X,ue,De)=>((0,ce.checkProposedApiEnabled)(Me),lt.registerCommand(!0,X,async(...rt)=>{const _t=gt.activeEditor(!0);if(!_t){Y.warn("Cannot execute "+X+" because there is no active text editor.");return}const kt=await Tt.getDiffInformation(_t.id);ue.apply(De,[kt,...rt])})),executeCommand(X,...ue){return lt.executeCommand(X,...ue)},getCommands(X=!1){return lt.getCommands(X)}},mi={get machineId(){return le.telemetryInfo.machineId},get sessionId(){return le.telemetryInfo.sessionId},get language(){return le.environment.appLanguage},get appName(){return le.environment.appName},get appRoot(){return le.environment.appRoot?.fsPath??""},get appHost(){return le.environment.appHost},get uriScheme(){return le.environment.appUriScheme},get clipboard(){return ai.value},get shell(){return ft.getDefaultShell(!1)},get isTelemetryEnabled(){return Oe.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Oe.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(le.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,ue){return Ie.openUri(X,{allowTunneling:!!le.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===le.environment.appUriScheme)return Vt.createAppUri(X);try{return await Ie.asExternalUri(X,{allowTunneling:!!le.remote.authority})}catch(ue){if((0,Xe.matchesScheme)(X,It.Schemas.http)||(0,Xe.matchesScheme)(X,It.Schemas.https))return X;throw ue}},get remoteName(){return(0,Ae.getRemoteName)(le.remote.authority)},get remoteAuthority(){return(0,ce.checkProposedApiEnabled)(Me),le.remote.authority},get uiKind(){return le.uiKind}};le.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=le.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Ii={createTestController(X,ue){return Gt.createTestController(X,ue)},createTestObserver(){return(0,ce.checkProposedApiEnabled)(Me),Gt.createTestObserver()},runTests(X){return(0,ce.checkProposedApiEnabled)(Me),Gt.runTests(X)},get onDidChangeTestResults(){return(0,ce.checkProposedApiEnabled)(Me),Gt.onResultsChanged},get testResults(){return(0,ce.checkProposedApiEnabled)(Me),Gt.results}},Pi={getExtension(X){const ue=Rt.getExtensionDescription(X);if(ue)return new r.Extension(Pe,Me.identifier,ue,gi)},get all(){return Rt.getAllExtensionDescriptions().map(X=>new r.Extension(Pe,Me.identifier,X,gi))},get onDidChange(){return Rt.onDidChange}},ui={createDiagnosticCollection(X){return Wt.createDiagnosticCollection(Me.identifier,X)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:X=>Wt.getDiagnostics(X),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(X,ue){return Ht.changeLanguage(X.uri,ue)},match(X,ue){return(0,t.score)(G.LanguageSelector.from(X),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(X,ue,De){return ht.registerCodeActionProvider(Me,wt(X),ue,De)},registerCodeLensProvider(X,ue){return ht.registerCodeLensProvider(Me,wt(X),ue)},registerDefinitionProvider(X,ue){return ht.registerDefinitionProvider(Me,wt(X),ue)},registerDeclarationProvider(X,ue){return ht.registerDeclarationProvider(Me,wt(X),ue)},registerImplementationProvider(X,ue){return ht.registerImplementationProvider(Me,wt(X),ue)},registerTypeDefinitionProvider(X,ue){return ht.registerTypeDefinitionProvider(Me,wt(X),ue)},registerHoverProvider(X,ue){return ht.registerHoverProvider(Me,wt(X),ue,Me.identifier)},registerEvaluatableExpressionProvider(X,ue){return ht.registerEvaluatableExpressionProvider(Me,wt(X),ue,Me.identifier)},registerInlineValuesProvider(X,ue){return ht.registerInlineValuesProvider(Me,wt(X),ue,Me.identifier)},registerDocumentHighlightProvider(X,ue){return ht.registerDocumentHighlightProvider(Me,wt(X),ue)},registerLinkedEditingRangeProvider(X,ue){return ht.registerLinkedEditingRangeProvider(Me,wt(X),ue)},registerReferenceProvider(X,ue){return ht.registerReferenceProvider(Me,wt(X),ue)},registerRenameProvider(X,ue){return ht.registerRenameProvider(Me,wt(X),ue)},registerDocumentSymbolProvider(X,ue,De){return ht.registerDocumentSymbolProvider(Me,wt(X),ue,De)},registerWorkspaceSymbolProvider(X){return ht.registerWorkspaceSymbolProvider(Me,X)},registerDocumentFormattingEditProvider(X,ue){return ht.registerDocumentFormattingEditProvider(Me,wt(X),ue)},registerDocumentRangeFormattingEditProvider(X,ue){return ht.registerDocumentRangeFormattingEditProvider(Me,wt(X),ue)},registerOnTypeFormattingEditProvider(X,ue,De,...rt){return ht.registerOnTypeFormattingEditProvider(Me,wt(X),ue,[De].concat(rt))},registerDocumentSemanticTokensProvider(X,ue,De){return ht.registerDocumentSemanticTokensProvider(Me,wt(X),ue,De)},registerDocumentRangeSemanticTokensProvider(X,ue,De){return ht.registerDocumentRangeSemanticTokensProvider(Me,wt(X),ue,De)},registerSignatureHelpProvider(X,ue,De,...rt){return typeof De=="object"?ht.registerSignatureHelpProvider(Me,wt(X),ue,De):ht.registerSignatureHelpProvider(Me,wt(X),ue,typeof De=="undefined"?[]:[De,...rt])},registerCompletionItemProvider(X,ue,...De){return ht.registerCompletionItemProvider(Me,wt(X),ue,De)},registerInlineCompletionItemProvider(X,ue){return(0,ce.checkProposedApiEnabled)(Me),ht.registerInlineCompletionsProvider(Me,wt(X),ue)},registerDocumentLinkProvider(X,ue){return ht.registerDocumentLinkProvider(Me,wt(X),ue)},registerColorProvider(X,ue){return ht.registerColorProvider(Me,wt(X),ue)},registerFoldingRangeProvider(X,ue){return ht.registerFoldingRangeProvider(Me,wt(X),ue)},registerSelectionRangeProvider(X,ue){return ht.registerSelectionRangeProvider(Me,X,ue)},registerCallHierarchyProvider(X,ue){return ht.registerCallHierarchyProvider(Me,X,ue)},registerTypeHierarchyProvider(X,ue){return ht.registerTypeHierarchyProvider(Me,X,ue)},setLanguageConfiguration:(X,ue)=>ht.setLanguageConfiguration(Me,X,ue),getTokenInformationAtPosition(X,ue){return(0,ce.checkProposedApiEnabled)(Me),Ht.tokenAtPosition(X,ue)},registerInlayHintsProvider(X,ue){return(0,ce.checkProposedApiEnabled)(Me),ht.registerInlayHintsProvider(Me,X,ue)},createLanguageStatusItem(X,ue){return(0,ce.checkProposedApiEnabled)(Me),Ht.createLanguageStatusItem(Me,X,ue)}},Ti={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(X,ue,De){const rt=await(R.URI.isUri(X)?Promise.resolve(pi.openTextDocument(X)):Promise.resolve(X));return Tt.showTextDocument(rt,ue,De)},createTextEditorDecorationType(X){return Tt.createTextEditorDecorationType(Me,X)},onDidChangeActiveTextEditor(X,ue,De){return Tt.onDidChangeActiveTextEditor(X,ue,De)},onDidChangeVisibleTextEditors(X,ue,De){return Tt.onDidChangeVisibleTextEditors(X,ue,De)},onDidChangeTextEditorSelection(X,ue,De){return Tt.onDidChangeTextEditorSelection(X,ue,De)},onDidChangeTextEditorOptions(X,ue,De){return Tt.onDidChangeTextEditorOptions(X,ue,De)},onDidChangeTextEditorVisibleRanges(X,ue,De){return Tt.onDidChangeTextEditorVisibleRanges(X,ue,De)},onDidChangeTextEditorViewColumn(X,ue,De){return Tt.onDidChangeTextEditorViewColumn(X,ue,De)},onDidCloseTerminal(X,ue,De){return ft.onDidCloseTerminal(X,ue,De)},onDidOpenTerminal(X,ue,De){return ft.onDidOpenTerminal(X,ue,De)},onDidChangeActiveTerminal(X,ue,De){return ft.onDidChangeActiveTerminal(X,ue,De)},onDidChangeTerminalDimensions(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),ft.onDidChangeTerminalDimensions(X,ue,De)},onDidChangeTerminalState(X,ue,De){return ft.onDidChangeTerminalState(X,ue,De)},onDidWriteTerminalData(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),ft.onDidWriteTerminalData(X,ue,De)},get state(){return Ie.state},onDidChangeWindowState(X,ue,De){return Ie.onDidChangeWindowState(X,ue,De)},showInformationMessage(X,...ue){return li.showMessage(Me,A.default.Info,X,ue[0],ue.slice(1))},showWarningMessage(X,...ue){return li.showMessage(Me,A.default.Warning,X,ue[0],ue.slice(1))},showErrorMessage(X,...ue){return li.showMessage(Me,A.default.Error,X,ue[0],ue.slice(1))},showQuickPick(X,ue,De){return Nt.showQuickPick(X,!!Me.enableProposedApi,ue,De)},showWorkspaceFolderPick(X){return Nt.showWorkspaceFolderPick(X)},showInputBox(X,ue){return Nt.showInput(X,ue)},showOpenDialog(X){return zt.showOpenDialog(X)},showSaveDialog(X){return zt.showSaveDialog(X)},createStatusBarItem(X,ue,De){let rt,_t,kt;return typeof X=="string"?(rt=X,_t=ue,kt=De):(_t=X,kt=ue),Mt.createStatusBarEntry(Me,rt,_t,kt)},setStatusBarMessage(X,ue){return Mt.setStatusBarMessage(X,ue)},withScmProgress(X){return we.report("window.withScmProgress",Me,"Use 'withProgress' instead."),hi.withProgress(Me,{location:H.ProgressLocation.SourceControl},(ue,De)=>X({report(rt){}}))},withProgress(X,ue){return hi.withProgress(Me,X,ue)},createOutputChannel(X){return Ut.createOutputChannel(X,Me)},createWebviewPanel(X,ue,De,rt){return oi.createWebviewPanel(Me,X,ue,De,rt)},createWebviewTextEditorInset(X,ue,De,rt){return(0,ce.checkProposedApiEnabled)(Me),wi.createWebviewEditorInset(X,ue,De,rt,Me)},createTerminal(X,ue,De){return typeof X=="object"?("location"in X&&(0,ce.checkProposedApiEnabled)(Me),"pty"in X?ft.createExtensionTerminal(X):ft.createTerminalFromOptions(X)):ft.createTerminal(X,ue,De)},registerTerminalLinkProvider(X){return ft.registerLinkProvider(X)},registerTerminalProfileProvider(X,ue){return ft.registerProfileProvider(Me,X,ue)},registerTreeDataProvider(X,ue){return Yt.registerTreeDataProvider(X,ue,Me)},createTreeView(X,ue){return Yt.createTreeView(X,ue,Me)},registerWebviewPanelSerializer:(X,ue)=>oi.registerWebviewPanelSerializer(Me,X,ue),registerCustomEditorProvider:(X,ue,De={})=>_i.registerCustomEditorProvider(Me,X,ue,De),registerFileDecorationProvider(X){return dt.registerFileDecorationProvider(X,Me.identifier)},registerUriHandler(X){return Vt.registerUriHandler(Me.identifier,X)},createQuickPick(){return Nt.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return Nt.createInputBox(Me.identifier)},get activeColorTheme(){return fi.activeColorTheme},onDidChangeActiveColorTheme(X,ue,De){return fi.onDidChangeActiveColorTheme(X,ue,De)},registerWebviewViewProvider(X,ue,De){return yi.registerWebviewViewProvider(Me,X,ue,De?.webviewOptions)},get activeNotebookEditor(){return(0,ce.checkProposedApiEnabled)(Me),vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),vt.onDidChangeActiveNotebookEditor(X,ue,De)},get visibleNotebookEditors(){return(0,ce.checkProposedApiEnabled)(Me),vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ce.checkProposedApiEnabled)(Me),vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),jt.onDidChangeNotebookEditorSelection(X,ue,De)},onDidChangeNotebookEditorVisibleRanges(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),jt.onDidChangeNotebookEditorVisibleRanges(X,ue,De)},showNotebookDocument(X,ue){return(0,ce.checkProposedApiEnabled)(Me),vt.showNotebookDocument(X,ue)},registerExternalUriOpener(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),Xt.registerExternalUriOpener(Me.identifier,X,ue,De)},get tabs(){return(0,ce.checkProposedApiEnabled)(Me),Ue.tabs},get activeTab(){return(0,ce.checkProposedApiEnabled)(Me),Ue.activeTab},get onDidChangeTabs(){return(0,ce.checkProposedApiEnabled)(Me),Ue.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ce.checkProposedApiEnabled)(Me),Ue.onDidChangeActiveTab},getInlineCompletionItemController(X){return(0,ce.checkProposedApiEnabled)(Me),h.InlineCompletionController.get(X)}},pi={get rootPath(){return we.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),xe.getPath()},set rootPath(X){throw M.readonly()},getWorkspaceFolder(X){return xe.getWorkspaceFolder(X)},get workspaceFolders(){return xe.getWorkspaceFolders()},get name(){return xe.name},set name(X){throw M.readonly()},get workspaceFile(){return xe.workspaceFile},set workspaceFile(X){throw M.readonly()},updateWorkspaceFolders:(X,ue,...De)=>xe.updateWorkspaceFolders(Me,X,ue||0,...De),onDidChangeWorkspaceFolders:function(X,ue,De){return xe.onDidChangeWorkspace(X,ue,De)},asRelativePath:(X,ue)=>xe.getRelativePath(X,ue),findFiles:(X,ue,De,rt)=>xe.findFiles(G.GlobPattern.from(X),G.GlobPattern.from(ue),De,Me.identifier,rt),findTextInFiles:(X,ue,De,rt)=>{let _t,kt;return typeof ue=="object"?(_t=ue,kt=De):(_t={},kt=ue,rt=De),xe.findTextInFiles(X,_t||{},kt,Me.identifier,rt)},saveAll:X=>xe.saveAll(X),applyEdit(X){return Di.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,ue,De,rt)=>Ot.createFileSystemWatcher(G.GlobPattern.from(X),ue,De,rt),get textDocuments(){return yt.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw M.readonly()},openTextDocument(X){let ue;const De=X;if(typeof X=="string")ue=Promise.resolve(R.URI.file(X));else if(R.URI.isUri(X))ue=Promise.resolve(X);else if(!De||typeof De=="object")ue=yt.createDocumentData(De);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(rt=>yt.ensureDocumentData(rt).then(_t=>_t.document))},onDidOpenTextDocument:(X,ue,De)=>yt.onDidAddDocument(X,ue,De),onDidCloseTextDocument:(X,ue,De)=>yt.onDidRemoveDocument(X,ue,De),onDidChangeTextDocument:(X,ue,De)=>yt.onDidChangeDocument(X,ue,De),onDidSaveTextDocument:(X,ue,De)=>yt.onDidSaveDocument(X,ue,De),onWillSaveTextDocument:(X,ue,De)=>ei.getOnWillSaveTextDocumentEvent(Me)(X,ue,De),get notebookDocuments(){return vt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,ue){let De;if(R.URI.isUri(X))De=X,await vt.openNotebookDocument(X);else if(typeof X=="string")De=R.URI.revive(await vt.createNotebookDocument({viewType:X,content:ue}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(De).apiNotebook},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(X,ue,De,rt){return vt.registerNotebookSerializer(Me,X,ue,De,Me.enableProposedApi?rt:void 0)},registerNotebookContentProvider:(X,ue,De,rt)=>((0,ce.checkProposedApiEnabled)(Me),vt.registerNotebookContentProvider(Me,X,ue,De,Me.enableProposedApi?rt:void 0)),onDidChangeConfiguration:(X,ue,De)=>Kt.onDidChangeConfiguration(X,ue,De),getConfiguration(X,ue){return ue=arguments.length===1?void 0:ue,Kt.getConfiguration(X,ue,Me)},registerTextDocumentContentProvider(X,ue){return $t.registerTextDocumentContentProvider(X,ue)},registerTaskProvider:(X,ue)=>(we.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),bt.registerTaskProvider(Me,X,ue)),registerFileSystemProvider(X,ue,De){return ni.registerFileSystemProvider(Me.identifier,X,ue,De)},get fs(){return fe.value},registerFileSearchProvider:(X,ue)=>((0,ce.checkProposedApiEnabled)(Me),pt.registerFileSearchProvider(X,ue)),registerTextSearchProvider:(X,ue)=>((0,ce.checkProposedApiEnabled)(Me),pt.registerTextSearchProvider(X,ue)),registerRemoteAuthorityResolver:(X,ue)=>((0,ce.checkProposedApiEnabled)(Me),Pe.registerRemoteAuthorityResolver(X,ue)),registerResourceLabelFormatter:X=>((0,ce.checkProposedApiEnabled)(Me),Ei.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,ue,De)=>Ot.onDidCreateFile(X,ue,De),onDidDeleteFiles:(X,ue,De)=>Ot.onDidDeleteFile(X,ue,De),onDidRenameFiles:(X,ue,De)=>Ot.onDidRenameFile(X,ue,De),onWillCreateFiles:(X,ue,De)=>Ot.getOnWillCreateFileEvent(Me)(X,ue,De),onWillDeleteFiles:(X,ue,De)=>Ot.getOnWillDeleteFileEvent(Me)(X,ue,De),onWillRenameFiles:(X,ue,De)=>Ot.getOnWillRenameFileEvent(Me)(X,ue,De),openTunnel:X=>((0,ce.checkProposedApiEnabled)(Me),z.openTunnel(Me,X).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,ce.checkProposedApiEnabled)(Me),z.getTunnels()},onDidChangeTunnels:(X,ue,De)=>((0,ce.checkProposedApiEnabled)(Me),z.onDidChangeTunnels(X,ue,De)),registerPortAttributesProvider:(X,ue)=>((0,ce.checkProposedApiEnabled)(Me),z.registerPortsAttributesProvider(X,ue)),registerTimelineProvider:(X,ue)=>((0,ce.checkProposedApiEnabled)(Me),si.registerTimelineProvider(X,ue,Me.identifier,lt.converter)),get isTrusted(){return xe.trusted},requestWorkspaceTrust:X=>((0,ce.checkProposedApiEnabled)(Me),xe.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,ue,De)=>xe.onDidGrantWorkspaceTrust(X,ue,De)},Ai={get inputBox(){return we.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Me)},createSourceControl(X,ue,De){return Jt.createSourceControl(Me,X,ue,De)}},Ri={createCommentController(X,ue){return bi.createCommentController(Me,X,ue)}},Fi={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(X,ue,De){return ut.onDidStartDebugSession(X,ue,De)},onDidTerminateDebugSession(X,ue,De){return ut.onDidTerminateDebugSession(X,ue,De)},onDidChangeActiveDebugSession(X,ue,De){return ut.onDidChangeActiveDebugSession(X,ue,De)},onDidReceiveDebugSessionCustomEvent(X,ue,De){return ut.onDidReceiveDebugSessionCustomEvent(X,ue,De)},onDidChangeBreakpoints(X,ue,De){return ut.onDidChangeBreakpoints(X,ue,De)},registerDebugConfigurationProvider(X,ue,De){return ut.registerDebugConfigurationProvider(X,ue,De||H.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,ue){return ut.registerDebugAdapterDescriptorFactory(Me,X,ue)},registerDebugAdapterTrackerFactory(X,ue){return ut.registerDebugAdapterTrackerFactory(X,ue)},startDebugging(X,ue,De){return!De||typeof De=="object"&&"configuration"in De?ut.startDebugging(X,ue,{parentSession:De}):ut.startDebugging(X,ue,De||{})},stopDebugging(X){return ut.stopDebugging(X)},addBreakpoints(X){return ut.addBreakpoints(X)},removeBreakpoints(X){return ut.removeBreakpoints(X)},asDebugSourceUri(X,ue){return ut.asDebugSourceUri(X,ue)}},Mi={registerTaskProvider:(X,ue)=>bt.registerTaskProvider(Me,X,ue),fetchTasks:X=>bt.fetchTasks(X),executeTask:X=>bt.executeTask(Me,X),get taskExecutions(){return bt.taskExecutions},onDidStartTask:(X,ue,De)=>bt.onDidStartTask(X,ue,De),onDidEndTask:(X,ue,De)=>bt.onDidEndTask(X,ue,De),onDidStartTaskProcess:(X,ue,De)=>bt.onDidStartTaskProcess(X,ue,De),onDidEndTaskProcess:(X,ue,De)=>bt.onDidEndTaskProcess(X,ue,De)},Li={createNotebookController(X,ue,De,rt,_t){return ti.createNotebookController(Me,X,ue,De,rt,Me.enableProposedApi?_t:void 0)},registerNotebookCellStatusBarItemProvider:(X,ue)=>vt.registerNotebookCellStatusBarItemProvider(Me,X,ue),get onDidSaveNotebookDocument(){return(0,ce.checkProposedApiEnabled)(Me),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return(0,ce.checkProposedApiEnabled)(Me),jt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return ii.createRendererMessaging(Me,X)},onDidChangeNotebookDocumentMetadata(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),Qt.onDidChangeNotebookDocumentMetadata(X,ue,De)},onDidChangeNotebookCells(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),vt.onDidChangeNotebookCells(X,ue,De)},onDidChangeNotebookCellExecutionState(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),vt.onDidChangeNotebookCellExecutionState(X,ue,De)},onDidChangeCellOutputs(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),vt.onDidChangeCellOutputs(X,ue,De)},onDidChangeCellMetadata(X,ue,De){return(0,ce.checkProposedApiEnabled)(Me),vt.onDidChangeCellMetadata(X,ue,De)},createConcatTextDocument(X,ue){return(0,ce.checkProposedApiEnabled)(Me),new ze.ExtHostNotebookConcatDocument(vt,yt,X,ue)}};return{version:le.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:mi,extensions:Pi,languages:ui,notebooks:Li,scm:Ai,tasks:Mi,tests:Ii,window:Ti,workspace:pi,Breakpoint:H.Breakpoint,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:H.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:E.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestions,Hover:H.Hover,IndentAction:P.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:n.UIKind,Uri:R.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,InlayHint:H.InlayHint,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:Dt.TextSearchCompleteMessageType,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ce}),define(be[224],Ee([0,1,57,96,31,95,32,39,49,40,99,100,101,72,64,69,97,71,37,68,87,70]),function(re,e,c,M,E,A,R,C,y,P,t,b,n,f,o,l,v,D,_,a,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(l.IExtHostApiDeprecationService,l.ExtHostApiDeprecationService),(0,c.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,c.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration),(0,c.registerSingleton)(D.IExtHostConsumerFileSystem,D.ExtHostConsumerFileSystem),(0,c.registerSingleton)(b.IExtHostDebugService,b.WorkerExtHostDebugService),(0,c.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,c.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,c.registerSingleton)(_.IExtHostFileSystemInfo,_.ExtHostFileSystemInfo),(0,c.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,c.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,c.registerSingleton)(f.IExtHostStorage,f.ExtHostStorage),(0,c.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,c.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,c.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,c.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,c.registerSingleton)(E.IExtHostWorkspace,E.ExtHostWorkspace),(0,c.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,c.registerSingleton)(d.IExtHostTelemetry,d.ExtHostTelemetry),(0,c.registerSingleton)(S.IExtHostEditorTabs,S.ExtHostEditorTabs)}),define(be[225],Ee([0,1,223,33,219,7,14,5,11]),function(re,e,c,M,E,A,R,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var P;(function(o){const l=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(D,..._)=>{_.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const a=_.slice(0,-1).join(","),d=_.pop().toString();return`(function anonymous(${a}) {${d}
})`}});function v(...D){return l?self.eval(l.createScript("",...D)):new Function(...D)}o.create=v})(P||(P={}));class t extends E.RequireInterceptor{_installInterceptor(){}getModule(l,v){for(let D of this._alternatives){let _=D(l);if(_){l=_;break}}if(this._factories.has(l))return this._factories.get(l).load(l,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class b extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const l=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);f(l,this._initData.environment.isExtensionDevelopmentDebug);const v=this._instaService.invokeFunction(c.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,v,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(l){return l.browser}async _loadCommonJSModule(l,v,D){v=v.with({path:n(v.path,".js")}),l&&performance.mark(`code/extHost/willFetchExtensionCode/${l.value}`);const _=await fetch(y.FileAccess.asBrowserUri(v).toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l.value}`),_.status!==200)throw new Error(_.statusText);const a=await _.text(),d=`${v.toString(!0)}#vscode-extension`,S=`${a}
//# sourceURL=${d}`;let i;try{i=P.create(b._ttpExtensionScripts?.createScript("module")??"module",b._ttpExtensionScripts?.createScript("exports")??"exports",b._ttpExtensionScripts?.createScript("require")??"require",b._ttpExtensionScripts?.createScript(S)??S)}catch(u){throw console.error(l?`Loading code for extension ${l.value} failed: ${u.message}`:`Loading code failed: ${u.message}`),console.error(`${v.toString(!0)}${typeof u.line=="number"?` line ${u.line}`:""}${typeof u.column=="number"?` column ${u.column}`:""}`),console.error(u),u}const p={},r={exports:p},s=u=>{const h=this._fakeModules.getModule(u,v);if(h===void 0)throw new Error(`Cannot load module '${u}'`);return h};try{return D.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l.value}`),i(r,p,s),r.exports!==p?r.exports:p}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l.value}`),D.codeLoadingStop()}}async $setRemoteEnvironment(l){}async _waitForDebuggerAttachment(l=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+l;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=b,b._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:o=>o});function n(o,l){return o.endsWith(l)?o:o+l}function f(o,l){v("info","log"),v("log","log"),v("warn","warn"),v("error","error");function v(a,d){const S=console[a];console[a]=function(){o.$logExtensionHostMessage({type:"__$console",severity:d,arguments:_(arguments)}),l&&S.apply(console,arguments)}}const D=1e5;function _(a){const d=[],S=[];if(a.length)for(let i=0;i<a.length;i++){if(typeof a[i]=="undefined")a[i]="undefined";else if(a[i]instanceof Error){const p=a[i];p.stack?a[i]=p.stack:a[i]=p.toString()}S.push(a[i])}try{const i=JSON.stringify(S,function(p,r){if(r&&typeof r=="object"){if(d.indexOf(r)!==-1)return"[Circular]";d.push(r)}return r});return i.length>D?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(be[226],Ee([0,1,57,15,33,73,225,212]),function(re,e,c,M,E,A,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(E.IExtHostExtensionService,R.ExtHostExtensionService),(0,c.registerSingleton)(M.ILogService,C.ExtHostLogService),(0,c.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths)}),define(be[236],Ee([0,1,22,3,178,220,214,17,74,11,2,224,226]),function(re,e,c,M,E,A,R,C,y,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const f=fetch.bind(self);if(self.fetch=function(a,d){return a instanceof Request||/^file:/i.test(String(a))&&(a=P.FileAccess.asBrowserUri(t.URI.parse(String(a))).toString(!0)),f(a,d)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,d,S,i,p){return/^file:/i.test(d.toString())&&(d=P.FileAccess.asBrowserUri(t.URI.parse(d.toString())).toString(!0)),super.open(a,d,S??!0,i,p)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const a=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:S=>S}),d=self.Worker;Worker=function(S,i){/^file:/i.test(S.toString())&&(S=P.FileAccess.asBrowserUri(t.URI.parse(S.toString())).toString(!0));const r=`(${function(m){function k(F){return typeof F=="string"||F instanceof URL?String(F).replace(/^file:\/\//i,"vscode-file://vscode-app"):F}const T=fetch.bind(self);self.fetch=function(F,L){return F instanceof Request?T(F,L):T(k(F),L)},self.XMLHttpRequest=class extends XMLHttpRequest{open(F,L,w,x,W){return super.open(F,k(L),w??!0,x,W)}};const g=importScripts.bind(self);self.importScripts=(...F)=>{g(...F.map(k))};const I=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:F=>F}):void 0;g(I?I.createScriptURL(m):m)}.toString()}('${S}'))`;i=i||{},i.name=i.name||C.basename(S.toString());const s=new Blob([r],{type:"application/javascript"}),u=URL.createObjectURL(s);return new d(a?a.createScriptURL(u):u,i)}}else self.Worker=class extends R.NestedWorker{constructor(a,d){super(n,a,{name:C.basename(a.toString()),...d})}};const o=new class{exit(a){b()}async exists(a){return!0}async realpath(a){return a}};class l{constructor(){const d=new MessageChannel,S=new M.Emitter;let i=!1;n(d.port2,[d.port2]),d.port1.onmessage=p=>{const{data:r}=p;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const s=c.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,E.isMessageOfType)(s,2)){i=!0,D("received terminate message from renderer");return}S.fire(s)},this.protocol={onMessage:S.event,send:p=>{if(!i){const r=p.buffer.buffer.slice(p.buffer.byteOffset,p.buffer.byteOffset+p.buffer.byteLength);d.port1.postMessage(r,[r])}}}}}function v(a){return new Promise(d=>{const S=a.onMessage(i=>{S.dispose();const p=JSON.parse(i.toString());a.send((0,E.createMessageOfType)(0)),d({protocol:a,initData:p})});a.send((0,E.createMessageOfType)(1))})}let D=a=>b();function _(){const a=new l;y.mark("code/extHost/willConnectToRenderer"),v(a.protocol).then(d=>{y.mark("code/extHost/didWaitForInitData");const S=new A.ExtensionHostMain(d.protocol,d.initData,o,null);D=i=>S.terminate(i)})}e.create=_})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
